#include "header.hpp"

#include "ppaaa03.amplitude.set.hpp"
#include "ppaaa23.amplitude.doublevirtual.hpp"

void ppaaa03_amplitude_initialization(munich * MUC){
  static Logger logger("ppaaa03_amplitude_initialization");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (MUC->osi->switch_OL){
#ifdef OPENLOOPS
    MUC->asi = new ppaaa03_amplitude_OpenLoops_set();
#endif
  }
  else if (MUC->osi->switch_RCL){
#ifdef RECOLA
    MUC->asi = new ppaaa03_amplitude_Recola_set();
#endif
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}




#ifdef OPENLOOPS

ppaaa03_amplitude_OpenLoops_set::ppaaa03_amplitude_OpenLoops_set(){
  Logger logger("ppaaa03_amplitude_OpenLoops_set::ppaaa03_amplitude_OpenLoops_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  logger << LOG_INFO << "constructor called..." << endl;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

ppaaa03_amplitude_OpenLoops_set::~ppaaa03_amplitude_OpenLoops_set(){
  Logger logger("ppaaa03_amplitude_OpenLoops_set::~ppaaa03_amplitude_OpenLoops_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  logger << LOG_INFO << "destructor called..." << endl;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppaaa03_amplitude_OpenLoops_set::calculate_H2_QCD_2loop(){
  static Logger logger("ppaaa03_amplitude_OpenLoops_set::calculate_H2_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  ppaaa23_calculate_H2(osi);
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppaaa03_amplitude_OpenLoops_set::calculate_H1gg_QCD_2loop(){
  static Logger logger("ppaaa03_amplitude_OpenLoops_set::calculate_H1gg_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  //  ggaaa33_calculate_H1(osi);
  logger << LOG_FATAL << "Amplitudes have not been implemented yet." << endl;
  exit(1);
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

#endif



#ifdef RECOLA

ppaaa03_amplitude_Recola_set::ppaaa03_amplitude_Recola_set(){
  Logger logger("ppaaa03_amplitude_Recola_set::ppaaa03_amplitude_Recola_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  logger << LOG_INFO << "constructor called..." << endl;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

ppaaa03_amplitude_Recola_set::~ppaaa03_amplitude_Recola_set(){
  Logger logger("ppaaa03_amplitude_Recola_set::~ppaaa03_amplitude_Recola_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  logger << LOG_INFO << "destructor called..." << endl;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppaaa03_amplitude_Recola_set::calculate_H2_QCD_2loop(){
  static Logger logger("ppaaa03_amplitude_Recola_set::calculate_H2_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  ppaaa23_calculate_H2(osi);
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppaaa03_amplitude_Recola_set::calculate_H1gg_QCD_2loop(){
  static Logger logger("ppaaa03_amplitude_Recola_set::calculate_H1gg_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  //  ggaaa33_calculate_H1(osi);
  logger << LOG_FATAL << "Amplitudes have not been implemented yet." << endl;
  exit(1);
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

#endif
