#include "header.hpp"

#include "pph21.amplitude.set.hpp"

void pph21_amplitude_initialization(munich * MUC){
  static Logger logger("pph21_amplitude_initialization");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (MUC->osi->switch_OL){
#ifdef OPENLOOPS
    MUC->asi = new pph21_amplitude_OpenLoops_set();
#endif
  }
  else if (MUC->osi->switch_RCL){
#ifdef RECOLA
    MUC->asi = new pph21_amplitude_Recola_set();
#endif
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


pph21_amplitude_set::pph21_amplitude_set(){
  Logger logger("pph21_amplitude_set::pph21_amplitude_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "constructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

pph21_amplitude_set::~pph21_amplitude_set(){
  Logger logger("pph21_amplitude_set::~pph21_amplitude_set ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "destructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void pph21_amplitude_set::initialization_H2_QCD_2loop(){
  static Logger logger("pph21_amplitude_set::initialization_H2_QCD_2loop");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  osi->QT_A0 = osi->VA_b_ME2;
  double LQ = 2.0*log( osi->msi->M_H / osi->msi->M_t ); 

  osi->QT_H1_delta_QCD = (C_A*pi2 + 11)/2.0 ;
  osi->QT_H2_delta_QCD = 11399.0/144 + 19.0/8*LQ + 133.0*pi2/8 + 13.0/16*pi4 - 55.0/2*zeta3 + osi->N_f*(-1189.0/144 + 2.0*LQ/3 - 5.0*pi2/12); // formula from HNNLO (/Need/setup.f)

  osi->QT_H0_doublespinflip = 0.;
  osi->QT_H0_DG = 0.;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
