#ifndef pplla03_AMPLITUDE_SET_HPP
#define pplla03_AMPLITUDE_SET_HPP

using namespace std;

void pplla03_amplitude_initialization(munich * MUC);

class pplla03_amplitude_set : virtual public amplitude_set {
private:

public:
  pplla03_amplitude_set();
  virtual ~pplla03_amplitude_set();

  virtual void initialization_H2_QCD_2loop();
  virtual void finalization_H2_QCD_2loop();
  void calculate_H2_QCD_2loop();
  //  double_complex alpha0_Z(double e_q);
  //  double_complex beta0_Z(double e_q);
  //  double_complex alpha0_W(double u, double v, double e_q, double e_qprime);
  //  double_complex beta0_W(double u, double v, double e_q, double e_qprime);
  void calculate_helicity_amplitude_perm(int d, int e, int a, int b, int c, double e_q, vector<double_complex> & Aplus_0, vector<double_complex> & Aplus_1, vector<double_complex> & Aplus_2_VR, vector<double_complex> & Aplus_2_VL, vector<double_complex> & Aplus_2_P, int order);
  void calculate_helicity_amplitude_perm_FSR(int d, int e, int a, int b, int c, vector<double_complex> & Aplus_0, vector<double_complex> & Aplus_1, vector<double_complex> & Aplus_2, int order);
  double_complex alpha_1_1();
  double_complex alpha_1_2();
  double_complex alpha_1_3();
  double_complex beta_1_1();
  double_complex beta_1_2();
  double_complex beta_1_3();
  double_complex gamma_1_1();
  double_complex gamma_1_2();
  double_complex gamma_1_3();
  void Omega_1_ZP(double e_q);
  void Omega_1_W(double e_q, double e_qprime);

  double_complex alpha_2_1();
  double_complex alpha_2_2();
  double_complex alpha_2_3();
  double_complex alpha_2_4();
  double_complex beta_2_1();
  double_complex beta_2_2();
  double_complex beta_2_3();
  double_complex beta_2_4();
  double_complex gamma_2_1();
  double_complex gamma_2_2();
  double_complex gamma_2_3();
  double_complex gamma_2_4();
  void Omega_2_ZP(double e_q);
  void Omega_2_W(double e_q, double e_qprime);

  int no_process_class;
  int parton_identity;
  int parton_type;
  vector<fourvector> p_amp;
  vector<vector<double_complex > > za;
  vector<vector<double_complex > > zb;
  vector<vector<double> > s_inv;

  double I3_q;
  double e_q;
  double e_f;
  double I3_f;


  double delta_I1;
  double beta0;

  // QCD 2-loop amplitudes
  double F1;
  double F2_coefficient_1;
  double F2_coefficient_LR;
  double_complex F2;

  // QCD I-operator
  double K;
  double delta_qT;
  double D2a;
  double g1a;
  double delta_I2_coefficient_1;
  double delta_I2_coefficient_LR;
  double delta_I2;

  // amplitude coefficients
  // 56132, resonant piece
  vector<double_complex> Aplus56132_0;
  vector<double_complex> Aplus56132_1;
  vector<double_complex> Aplus56132_2_VR;
  vector<double_complex> Aplus56132_2_VL;
  vector<double_complex> Aplus56132_2_P;
  // 56132 DY like piece
  vector<double_complex> Aplus56132_0_FSR;
  vector<double_complex> Aplus56132_1_FSR;
  vector<double_complex> Aplus56132_2_FSR;
  // 65231, resonant piece
  vector<double_complex> Aplus65231_0;
  vector<double_complex> Aplus65231_1;
  vector<double_complex> Aplus65231_2_VR;
  vector<double_complex> Aplus65231_2_VL;
  vector<double_complex> Aplus65231_2_P;
  // 65231, DY like piece
  vector<double_complex> Aplus65231_0_FSR;
  vector<double_complex> Aplus65231_1_FSR;
  vector<double_complex> Aplus65231_2_FSR;
  // 56231, resonant piece
  vector<double_complex> Aplus56231_0;
  vector<double_complex> Aplus56231_1;
  vector<double_complex> Aplus56231_2_VR;
  vector<double_complex> Aplus56231_2_VL;
  vector<double_complex> Aplus56231_2_P;
  // 56231, DY like piece
  vector<double_complex> Aplus56231_0_FSR;
  vector<double_complex> Aplus56231_1_FSR;
  vector<double_complex> Aplus56231_2_FSR;
  // 65132, resonant piece
  vector<double_complex> Aplus65132_0;
  vector<double_complex> Aplus65132_1;
  vector<double_complex> Aplus65132_2_VR;
  vector<double_complex> Aplus65132_2_VL;
  vector<double_complex> Aplus65132_2_P;
  // 65132, DY like piece
  vector<double_complex> Aplus65132_0_FSR;
  vector<double_complex> Aplus65132_1_FSR;
  vector<double_complex> Aplus65132_2_FSR;

  vector<double_complex> Aplus56132_0_tot;
  vector<double_complex> Aplus65132_0_tot;
  vector<double_complex> Aplus56231_0_tot;
  vector<double_complex> Aplus65231_0_tot;

  vector<double_complex> Aplus56132_1_tot;
  vector<double_complex> Aplus65132_1_tot;
  vector<double_complex> Aplus56231_1_tot;
  vector<double_complex> Aplus65231_1_tot;

  vector<double_complex> Aplus56132_2_tot;
  vector<double_complex> Aplus65132_2_tot;
  vector<double_complex> Aplus56231_2_tot;
  vector<double_complex> Aplus65231_2_tot;


  double_complex LZ_q1q2;
  double_complex LZ_f5f6;
  double_complex RZ_q1q2;
  double_complex RZ_f5f6;

  double LP_q1q2;
  double LP_f5f6;
  double RP_q1q2;
  double RP_f5f6;

  double_complex LW_q1q2;
  double_complex LW_f5f6;

  // for every PSP:

  // propagator denominators
  //  double q2;
  double s34;
  double_complex DZ;
  double_complex DP;
  double_complex DW;

  // propagator denominators (FSR)
  double s12;
  double_complex DZ_FSR;
  double_complex DP_FSR;
  double_complex DW_FSR;

  double LR;
  int order;

  // kinematic variables, GPLs, etc.
  double dN_f;

  double u;
  double v;

  double * GHPLs1;
  double * GHPLs2;
  double * GHPLs3;
  double * GHPLs4;
  double * HPLs1;
  double * HPLs2;
  double * HPLs3;
  double * HPLs4;
  //  double HPLs1[2], HPLs2[2 * 2], HPLs3[2 * 2 * 2], HPLs4[2 * 2 * 2 * 2];
  //  double GHPLs1[4], GHPLs2[4 * 4], GHPLs3[4 * 4 * 4], GHPLs4[4 * 4 * 4 * 4];

  double_complex alpha_1;
  double_complex beta_1;
  double_complex gamma_1;
  
  double_complex alpha_2_ZR;
  double_complex beta_2_ZR;
  double_complex gamma_2_ZR;
  double_complex alpha_2_ZL;
  double_complex beta_2_ZL;
  double_complex gamma_2_ZL;
  double_complex alpha_2_P;
  double_complex beta_2_P;
  double_complex gamma_2_P;

  double_complex alpha_2_W;
  double_complex beta_2_W;
  double_complex gamma_2_W;

};


#ifdef OPENLOOPS
class pplla03_amplitude_OpenLoops_set : virtual public amplitude_OpenLoops_set, virtual public pplla03_amplitude_set {
private:

public:
  pplla03_amplitude_OpenLoops_set(){}
  virtual ~pplla03_amplitude_OpenLoops_set(){}

};
#endif


#ifdef RECOLA
class pplla03_amplitude_Recola_set : virtual public amplitude_Recola_set, virtual public pplla03_amplitude_set {
private:

public:
  pplla03_amplitude_Recola_set(){}
  virtual ~pplla03_amplitude_Recola_set(){}

};
#endif

#endif
