//  classes/...
#include "fourvector.hpp"
#include "contribution.set.hpp"
#include "user.defined.hpp"
#include "inputparameter.set.hpp"
#include "model.set.hpp"
#include "inputline.hpp"
#include "qTsubtraction.basic.hpp"
#include "runresumption.set.hpp"
#include "logger.hpp"
#include "topwidth.hpp"

//  routines/...
#include "routines.hpp"

//  phasespace/...
#include "phasespace.hpp"
#include "random.number.generator.hpp"
#include "multichannel.set.hpp"
#include "importancesampling.set.hpp"
#include "phasespace.set.hpp"
#include "randomvariable.hpp"
#include "randommanager.hpp"

// event/...
#include "particle.hpp"
#include "particle.history.hpp"
#include "define.particle.set.hpp"
#include "fiducialcut.hpp"
#include "event.set.hpp"

//  dipolesubtraction/...
#include "dipolesubtraction.hpp"
#include "dipole.set.hpp"
#include "ioperator.set.hpp"
#include "collinear.set.hpp"

//  qTsubtraction/...
#include "qTsubtraction.hpp"
#include "multicollinear.set.hpp"
#include "correlationoperator.set.hpp"

//  observable/...
#include "xdistribution.hpp"
#include "dddistribution.hpp"
#include "observable.set.hpp"

//  amplitude/...
#include "amplitude.set.hpp"
#include "amplitude.OpenLoops.set.hpp"
#include "amplitude.Recola.set.hpp"

// summary/...
#include "summary.distribution.hpp"
#include "summary.subprocess.hpp"
#include "summary.contribution.hpp"
#include "summary.list.hpp"
#include "summary.order.hpp"
#include "summary.generic.hpp"

//  munich/...
#include "munich.hpp"

#include "const.cxx"

using namespace mathconst;
using namespace physconst;

#define setdr right << setw(25) << setprecision(16) << showpoint
#define setdl left << setw(25) << setprecision(16) << showpoint
#define setsr right << setw(15) << setprecision(8) << showpoint
#define setsl left << setw(15) << setprecision(8) << showpoint
#define defaultfloat left << setw(23) << setprecision(15) << showpoint

