namespace mathconst
{
  const double pi = 4. * atan(1.);
  const double pi_48 = pi / 48.;
  const double f2pi = 2. * pi;
  const double f4pi = 4. * pi;
  const double pi2 = pow(pi, 2);
  const double pi2_2 = pi2 / 2.;
  const double pi2_3 = pi2 / 3.;
  const double pi2_6 = pi2 / 6.;
  const double pi2_9 = pi2 / 9.;
  const double pi2_12 = pi2 / 12.;
  const double pi2_18 = pi2 / 18.;
  const double pi2_24 = pi2 / 24.;
  const double pi2_48 = pi2 / 48.;
  const double pi2_72 = pi2 / 72.;
  const double pi2_144 = pi2 / 144.;
  const double pi4 = pow(pi, 4);
  const double pi4_90 = pi4 / 90.;
  const double pi4_180 = pi4 / 180.;
  const double pi4_288 = pi4 / 288.;
  const double pi4_480 = pi4 / 480.;
  const double sqrt2 = sqrt(2.);
  const double invpi = 1. / pi;
  const double inv2pi = 1. / (2. * pi);
  const double inv3pi = 1. / (3. * pi);
  const double inv4pi = 1. / (4. * pi);
  const double inv6pi = 1. / (6. * pi);
  const double inv12pi = 1. / (12. * pi);
  const double invpi2 = 1. / pi2;
  const double Eulergamma = 0.5772156649015328606065121;
  const double b0_Eulergamma = 2 * exp(-Eulergamma);
  const double zeta2 = pi2_6;
  const double zeta3 = 1.20205690315959429;
  const double zeta4 = pi4_90;
  const double PolyGamma_21 = -2 * zeta3;
  const double_complex ri(0, 1.);

  const double empty_double = -1.e100;
  const int empty_int = -32000;
  const double_complex empty_double_complex = double_complex(-1.e100, -1.e100);
  const string empty_string = "empty";
};

namespace physconst
{
  using namespace mathconst;
  const fourvector nullvector(0., 0., 0., 0.);

  // colour algebra
  const double infinity = 1.e99;
  const int N_c = 3;
  const double dN_c = (double)N_c;
  const double C_F = (dN_c * dN_c - 1.) / (2 * dN_c); // 4. / 3.;
  const double C_A = dN_c; // 3.;
  const double T_R = 1. / 2.;
};
