#ifndef ppbbx20_PHASESPACE_SET_HPP
#define ppbbx20_PHASESPACE_SET_HPP

using namespace std;

class ppbbx20_phasespace_set : public phasespace_set {
private:

public:
  ppbbx20_phasespace_set(){}
  ~ppbbx20_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_200_gg_bbx(int x_a);
  void ac_psp_200_gg_bbx(int x_a, int channel);
  void ag_psp_200_gg_bbx(int x_a, int zero);
  void ax_psp_200_ddx_bbx(int x_a);
  void ac_psp_200_ddx_bbx(int x_a, int channel);
  void ag_psp_200_ddx_bbx(int x_a, int zero);
  void ax_psp_200_uux_bbx(int x_a);
  void ac_psp_200_uux_bbx(int x_a, int channel);
  void ag_psp_200_uux_bbx(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_300_gg_bbxg(int x_a);
  void ac_psp_300_gg_bbxg(int x_a, int channel);
  void ag_psp_300_gg_bbxg(int x_a, int zero);
  void ax_psp_300_gd_bbxd(int x_a);
  void ac_psp_300_gd_bbxd(int x_a, int channel);
  void ag_psp_300_gd_bbxd(int x_a, int zero);
  void ax_psp_300_gu_bbxu(int x_a);
  void ac_psp_300_gu_bbxu(int x_a, int channel);
  void ag_psp_300_gu_bbxu(int x_a, int zero);
  void ax_psp_300_gdx_bbxdx(int x_a);
  void ac_psp_300_gdx_bbxdx(int x_a, int channel);
  void ag_psp_300_gdx_bbxdx(int x_a, int zero);
  void ax_psp_300_gux_bbxux(int x_a);
  void ac_psp_300_gux_bbxux(int x_a, int channel);
  void ag_psp_300_gux_bbxux(int x_a, int zero);
  void ax_psp_300_ddx_bbxg(int x_a);
  void ac_psp_300_ddx_bbxg(int x_a, int channel);
  void ag_psp_300_ddx_bbxg(int x_a, int zero);
  void ax_psp_300_uux_bbxg(int x_a);
  void ac_psp_300_uux_bbxg(int x_a, int channel);
  void ag_psp_300_uux_bbxg(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_400_gg_bbxgg(int x_a);
  void ac_psp_400_gg_bbxgg(int x_a, int channel);
  void ag_psp_400_gg_bbxgg(int x_a, int zero);
  void ax_psp_400_gg_bbxddx(int x_a);
  void ac_psp_400_gg_bbxddx(int x_a, int channel);
  void ag_psp_400_gg_bbxddx(int x_a, int zero);
  void ax_psp_400_gg_bbxuux(int x_a);
  void ac_psp_400_gg_bbxuux(int x_a, int channel);
  void ag_psp_400_gg_bbxuux(int x_a, int zero);
  void ax_psp_400_gd_bbxgd(int x_a);
  void ac_psp_400_gd_bbxgd(int x_a, int channel);
  void ag_psp_400_gd_bbxgd(int x_a, int zero);
  void ax_psp_400_gu_bbxgu(int x_a);
  void ac_psp_400_gu_bbxgu(int x_a, int channel);
  void ag_psp_400_gu_bbxgu(int x_a, int zero);
  void ax_psp_400_gdx_bbxgdx(int x_a);
  void ac_psp_400_gdx_bbxgdx(int x_a, int channel);
  void ag_psp_400_gdx_bbxgdx(int x_a, int zero);
  void ax_psp_400_gux_bbxgux(int x_a);
  void ac_psp_400_gux_bbxgux(int x_a, int channel);
  void ag_psp_400_gux_bbxgux(int x_a, int zero);
  void ax_psp_400_dd_bbxdd(int x_a);
  void ac_psp_400_dd_bbxdd(int x_a, int channel);
  void ag_psp_400_dd_bbxdd(int x_a, int zero);
  void ax_psp_400_du_bbxdu(int x_a);
  void ac_psp_400_du_bbxdu(int x_a, int channel);
  void ag_psp_400_du_bbxdu(int x_a, int zero);
  void ax_psp_400_ds_bbxds(int x_a);
  void ac_psp_400_ds_bbxds(int x_a, int channel);
  void ag_psp_400_ds_bbxds(int x_a, int zero);
  void ax_psp_400_dc_bbxdc(int x_a);
  void ac_psp_400_dc_bbxdc(int x_a, int channel);
  void ag_psp_400_dc_bbxdc(int x_a, int zero);
  void ax_psp_400_ddx_bbxgg(int x_a);
  void ac_psp_400_ddx_bbxgg(int x_a, int channel);
  void ag_psp_400_ddx_bbxgg(int x_a, int zero);
  void ax_psp_400_ddx_bbxddx(int x_a);
  void ac_psp_400_ddx_bbxddx(int x_a, int channel);
  void ag_psp_400_ddx_bbxddx(int x_a, int zero);
  void ax_psp_400_ddx_bbxuux(int x_a);
  void ac_psp_400_ddx_bbxuux(int x_a, int channel);
  void ag_psp_400_ddx_bbxuux(int x_a, int zero);
  void ax_psp_400_ddx_bbxssx(int x_a);
  void ac_psp_400_ddx_bbxssx(int x_a, int channel);
  void ag_psp_400_ddx_bbxssx(int x_a, int zero);
  void ax_psp_400_ddx_bbxccx(int x_a);
  void ac_psp_400_ddx_bbxccx(int x_a, int channel);
  void ag_psp_400_ddx_bbxccx(int x_a, int zero);
  void ax_psp_400_dux_bbxdux(int x_a);
  void ac_psp_400_dux_bbxdux(int x_a, int channel);
  void ag_psp_400_dux_bbxdux(int x_a, int zero);
  void ax_psp_400_dsx_bbxdsx(int x_a);
  void ac_psp_400_dsx_bbxdsx(int x_a, int channel);
  void ag_psp_400_dsx_bbxdsx(int x_a, int zero);
  void ax_psp_400_dcx_bbxdcx(int x_a);
  void ac_psp_400_dcx_bbxdcx(int x_a, int channel);
  void ag_psp_400_dcx_bbxdcx(int x_a, int zero);
  void ax_psp_400_uu_bbxuu(int x_a);
  void ac_psp_400_uu_bbxuu(int x_a, int channel);
  void ag_psp_400_uu_bbxuu(int x_a, int zero);
  void ax_psp_400_uc_bbxuc(int x_a);
  void ac_psp_400_uc_bbxuc(int x_a, int channel);
  void ag_psp_400_uc_bbxuc(int x_a, int zero);
  void ax_psp_400_udx_bbxudx(int x_a);
  void ac_psp_400_udx_bbxudx(int x_a, int channel);
  void ag_psp_400_udx_bbxudx(int x_a, int zero);
  void ax_psp_400_uux_bbxgg(int x_a);
  void ac_psp_400_uux_bbxgg(int x_a, int channel);
  void ag_psp_400_uux_bbxgg(int x_a, int zero);
  void ax_psp_400_uux_bbxddx(int x_a);
  void ac_psp_400_uux_bbxddx(int x_a, int channel);
  void ag_psp_400_uux_bbxddx(int x_a, int zero);
  void ax_psp_400_uux_bbxuux(int x_a);
  void ac_psp_400_uux_bbxuux(int x_a, int channel);
  void ag_psp_400_uux_bbxuux(int x_a, int zero);
  void ax_psp_400_uux_bbxssx(int x_a);
  void ac_psp_400_uux_bbxssx(int x_a, int channel);
  void ag_psp_400_uux_bbxssx(int x_a, int zero);
  void ax_psp_400_uux_bbxccx(int x_a);
  void ac_psp_400_uux_bbxccx(int x_a, int channel);
  void ag_psp_400_uux_bbxccx(int x_a, int zero);
  void ax_psp_400_usx_bbxusx(int x_a);
  void ac_psp_400_usx_bbxusx(int x_a, int channel);
  void ag_psp_400_usx_bbxusx(int x_a, int zero);
  void ax_psp_400_ucx_bbxucx(int x_a);
  void ac_psp_400_ucx_bbxucx(int x_a, int channel);
  void ag_psp_400_ucx_bbxucx(int x_a, int zero);
  void ax_psp_400_dxdx_bbxdxdx(int x_a);
  void ac_psp_400_dxdx_bbxdxdx(int x_a, int channel);
  void ag_psp_400_dxdx_bbxdxdx(int x_a, int zero);
  void ax_psp_400_dxux_bbxdxux(int x_a);
  void ac_psp_400_dxux_bbxdxux(int x_a, int channel);
  void ag_psp_400_dxux_bbxdxux(int x_a, int zero);
  void ax_psp_400_dxsx_bbxdxsx(int x_a);
  void ac_psp_400_dxsx_bbxdxsx(int x_a, int channel);
  void ag_psp_400_dxsx_bbxdxsx(int x_a, int zero);
  void ax_psp_400_dxcx_bbxdxcx(int x_a);
  void ac_psp_400_dxcx_bbxdxcx(int x_a, int channel);
  void ag_psp_400_dxcx_bbxdxcx(int x_a, int zero);
  void ax_psp_400_uxux_bbxuxux(int x_a);
  void ac_psp_400_uxux_bbxuxux(int x_a, int channel);
  void ag_psp_400_uxux_bbxuxux(int x_a, int zero);
  void ax_psp_400_uxcx_bbxuxcx(int x_a);
  void ac_psp_400_uxcx_bbxuxcx(int x_a, int channel);
  void ag_psp_400_uxcx_bbxuxcx(int x_a, int zero);

};
#endif
