#ifndef ppeex02_PHASESPACE_SET_HPP
#define ppeex02_PHASESPACE_SET_HPP

using namespace std;

class ppeex02_phasespace_set : public phasespace_set {
private:

public:
  ppeex02_phasespace_set(){}
  ~ppeex02_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_020_ddx_emep(int x_a);
  void ac_psp_020_ddx_emep(int x_a, int channel);
  void ag_psp_020_ddx_emep(int x_a, int zero);
  void ax_psp_020_uux_emep(int x_a);
  void ac_psp_020_uux_emep(int x_a, int channel);
  void ag_psp_020_uux_emep(int x_a, int zero);
  void ax_psp_020_bbx_emep(int x_a);
  void ac_psp_020_bbx_emep(int x_a, int channel);
  void ag_psp_020_bbx_emep(int x_a, int zero);
  void ax_psp_020_aa_emep(int x_a);
  void ac_psp_020_aa_emep(int x_a, int channel);
  void ag_psp_020_aa_emep(int x_a, int zero);
  void ax_psp_220_gg_emep(int x_a);
  void ac_psp_220_gg_emep(int x_a, int channel);
  void ag_psp_220_gg_emep(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_120_gd_emepd(int x_a);
  void ac_psp_120_gd_emepd(int x_a, int channel);
  void ag_psp_120_gd_emepd(int x_a, int zero);
  void ax_psp_120_gu_emepu(int x_a);
  void ac_psp_120_gu_emepu(int x_a, int channel);
  void ag_psp_120_gu_emepu(int x_a, int zero);
  void ax_psp_120_gb_emepb(int x_a);
  void ac_psp_120_gb_emepb(int x_a, int channel);
  void ag_psp_120_gb_emepb(int x_a, int zero);
  void ax_psp_120_gdx_emepdx(int x_a);
  void ac_psp_120_gdx_emepdx(int x_a, int channel);
  void ag_psp_120_gdx_emepdx(int x_a, int zero);
  void ax_psp_120_gux_emepux(int x_a);
  void ac_psp_120_gux_emepux(int x_a, int channel);
  void ag_psp_120_gux_emepux(int x_a, int zero);
  void ax_psp_120_gbx_emepbx(int x_a);
  void ac_psp_120_gbx_emepbx(int x_a, int channel);
  void ag_psp_120_gbx_emepbx(int x_a, int zero);
  void ax_psp_120_ddx_emepg(int x_a);
  void ac_psp_120_ddx_emepg(int x_a, int channel);
  void ag_psp_120_ddx_emepg(int x_a, int zero);
  void ax_psp_030_da_emepd(int x_a);
  void ac_psp_030_da_emepd(int x_a, int channel);
  void ag_psp_030_da_emepd(int x_a, int zero);
  void ax_psp_120_uux_emepg(int x_a);
  void ac_psp_120_uux_emepg(int x_a, int channel);
  void ag_psp_120_uux_emepg(int x_a, int zero);
  void ax_psp_030_ua_emepu(int x_a);
  void ac_psp_030_ua_emepu(int x_a, int channel);
  void ag_psp_030_ua_emepu(int x_a, int zero);
  void ax_psp_120_bbx_emepg(int x_a);
  void ac_psp_120_bbx_emepg(int x_a, int channel);
  void ag_psp_120_bbx_emepg(int x_a, int zero);
  void ax_psp_030_ba_emepb(int x_a);
  void ac_psp_030_ba_emepb(int x_a, int channel);
  void ag_psp_030_ba_emepb(int x_a, int zero);
  void ax_psp_030_dxa_emepdx(int x_a);
  void ac_psp_030_dxa_emepdx(int x_a, int channel);
  void ag_psp_030_dxa_emepdx(int x_a, int zero);
  void ax_psp_030_uxa_emepux(int x_a);
  void ac_psp_030_uxa_emepux(int x_a, int channel);
  void ag_psp_030_uxa_emepux(int x_a, int zero);
  void ax_psp_030_bxa_emepbx(int x_a);
  void ac_psp_030_bxa_emepbx(int x_a, int channel);
  void ag_psp_030_bxa_emepbx(int x_a, int zero);
  void ax_psp_030_ddx_emepa(int x_a);
  void ac_psp_030_ddx_emepa(int x_a, int channel);
  void ag_psp_030_ddx_emepa(int x_a, int zero);
  void ax_psp_030_uux_emepa(int x_a);
  void ac_psp_030_uux_emepa(int x_a, int channel);
  void ag_psp_030_uux_emepa(int x_a, int zero);
  void ax_psp_030_bbx_emepa(int x_a);
  void ac_psp_030_bbx_emepa(int x_a, int channel);
  void ag_psp_030_bbx_emepa(int x_a, int zero);
  void ax_psp_030_aa_emepa(int x_a);
  void ac_psp_030_aa_emepa(int x_a, int channel);
  void ag_psp_030_aa_emepa(int x_a, int zero);
  void ax_psp_320_gg_emepg(int x_a);
  void ac_psp_320_gg_emepg(int x_a, int channel);
  void ag_psp_320_gg_emepg(int x_a, int zero);
  void ax_psp_320_gd_emepd(int x_a);
  void ac_psp_320_gd_emepd(int x_a, int channel);
  void ag_psp_320_gd_emepd(int x_a, int zero);
  void ax_psp_320_gu_emepu(int x_a);
  void ac_psp_320_gu_emepu(int x_a, int channel);
  void ag_psp_320_gu_emepu(int x_a, int zero);
  void ax_psp_320_gb_emepb(int x_a);
  void ac_psp_320_gb_emepb(int x_a, int channel);
  void ag_psp_320_gb_emepb(int x_a, int zero);
  void ax_psp_320_gdx_emepdx(int x_a);
  void ac_psp_320_gdx_emepdx(int x_a, int channel);
  void ag_psp_320_gdx_emepdx(int x_a, int zero);
  void ax_psp_320_gux_emepux(int x_a);
  void ac_psp_320_gux_emepux(int x_a, int channel);
  void ag_psp_320_gux_emepux(int x_a, int zero);
  void ax_psp_320_gbx_emepbx(int x_a);
  void ac_psp_320_gbx_emepbx(int x_a, int channel);
  void ag_psp_320_gbx_emepbx(int x_a, int zero);
  void ax_psp_320_ddx_emepg(int x_a);
  void ac_psp_320_ddx_emepg(int x_a, int channel);
  void ag_psp_320_ddx_emepg(int x_a, int zero);
  void ax_psp_320_uux_emepg(int x_a);
  void ac_psp_320_uux_emepg(int x_a, int channel);
  void ag_psp_320_uux_emepg(int x_a, int zero);
  void ax_psp_320_bbx_emepg(int x_a);
  void ac_psp_320_bbx_emepg(int x_a, int channel);
  void ag_psp_320_bbx_emepg(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_220_gg_emepddx(int x_a);
  void ac_psp_220_gg_emepddx(int x_a, int channel);
  void ag_psp_220_gg_emepddx(int x_a, int zero);
  void ax_psp_220_gg_emepuux(int x_a);
  void ac_psp_220_gg_emepuux(int x_a, int channel);
  void ag_psp_220_gg_emepuux(int x_a, int zero);
  void ax_psp_220_gg_emepbbx(int x_a);
  void ac_psp_220_gg_emepbbx(int x_a, int channel);
  void ag_psp_220_gg_emepbbx(int x_a, int zero);
  void ax_psp_220_gd_emepgd(int x_a);
  void ac_psp_220_gd_emepgd(int x_a, int channel);
  void ag_psp_220_gd_emepgd(int x_a, int zero);
  void ax_psp_220_gu_emepgu(int x_a);
  void ac_psp_220_gu_emepgu(int x_a, int channel);
  void ag_psp_220_gu_emepgu(int x_a, int zero);
  void ax_psp_220_gb_emepgb(int x_a);
  void ac_psp_220_gb_emepgb(int x_a, int channel);
  void ag_psp_220_gb_emepgb(int x_a, int zero);
  void ax_psp_220_gdx_emepgdx(int x_a);
  void ac_psp_220_gdx_emepgdx(int x_a, int channel);
  void ag_psp_220_gdx_emepgdx(int x_a, int zero);
  void ax_psp_220_gux_emepgux(int x_a);
  void ac_psp_220_gux_emepgux(int x_a, int channel);
  void ag_psp_220_gux_emepgux(int x_a, int zero);
  void ax_psp_220_gbx_emepgbx(int x_a);
  void ac_psp_220_gbx_emepgbx(int x_a, int channel);
  void ag_psp_220_gbx_emepgbx(int x_a, int zero);
  void ax_psp_220_dd_emepdd(int x_a);
  void ac_psp_220_dd_emepdd(int x_a, int channel);
  void ag_psp_220_dd_emepdd(int x_a, int zero);
  void ax_psp_220_du_emepdu(int x_a);
  void ac_psp_220_du_emepdu(int x_a, int channel);
  void ag_psp_220_du_emepdu(int x_a, int zero);
  void ax_psp_220_ds_emepds(int x_a);
  void ac_psp_220_ds_emepds(int x_a, int channel);
  void ag_psp_220_ds_emepds(int x_a, int zero);
  void ax_psp_220_dc_emepdc(int x_a);
  void ac_psp_220_dc_emepdc(int x_a, int channel);
  void ag_psp_220_dc_emepdc(int x_a, int zero);
  void ax_psp_220_db_emepdb(int x_a);
  void ac_psp_220_db_emepdb(int x_a, int channel);
  void ag_psp_220_db_emepdb(int x_a, int zero);
  void ax_psp_220_ddx_emepgg(int x_a);
  void ac_psp_220_ddx_emepgg(int x_a, int channel);
  void ag_psp_220_ddx_emepgg(int x_a, int zero);
  void ax_psp_220_ddx_emepddx(int x_a);
  void ac_psp_220_ddx_emepddx(int x_a, int channel);
  void ag_psp_220_ddx_emepddx(int x_a, int zero);
  void ax_psp_220_ddx_emepuux(int x_a);
  void ac_psp_220_ddx_emepuux(int x_a, int channel);
  void ag_psp_220_ddx_emepuux(int x_a, int zero);
  void ax_psp_220_ddx_emepssx(int x_a);
  void ac_psp_220_ddx_emepssx(int x_a, int channel);
  void ag_psp_220_ddx_emepssx(int x_a, int zero);
  void ax_psp_220_ddx_emepccx(int x_a);
  void ac_psp_220_ddx_emepccx(int x_a, int channel);
  void ag_psp_220_ddx_emepccx(int x_a, int zero);
  void ax_psp_220_ddx_emepbbx(int x_a);
  void ac_psp_220_ddx_emepbbx(int x_a, int channel);
  void ag_psp_220_ddx_emepbbx(int x_a, int zero);
  void ax_psp_220_dux_emepdux(int x_a);
  void ac_psp_220_dux_emepdux(int x_a, int channel);
  void ag_psp_220_dux_emepdux(int x_a, int zero);
  void ax_psp_220_dsx_emepdsx(int x_a);
  void ac_psp_220_dsx_emepdsx(int x_a, int channel);
  void ag_psp_220_dsx_emepdsx(int x_a, int zero);
  void ax_psp_220_dcx_emepdcx(int x_a);
  void ac_psp_220_dcx_emepdcx(int x_a, int channel);
  void ag_psp_220_dcx_emepdcx(int x_a, int zero);
  void ax_psp_220_dbx_emepdbx(int x_a);
  void ac_psp_220_dbx_emepdbx(int x_a, int channel);
  void ag_psp_220_dbx_emepdbx(int x_a, int zero);
  void ax_psp_220_uu_emepuu(int x_a);
  void ac_psp_220_uu_emepuu(int x_a, int channel);
  void ag_psp_220_uu_emepuu(int x_a, int zero);
  void ax_psp_220_uc_emepuc(int x_a);
  void ac_psp_220_uc_emepuc(int x_a, int channel);
  void ag_psp_220_uc_emepuc(int x_a, int zero);
  void ax_psp_220_ub_emepub(int x_a);
  void ac_psp_220_ub_emepub(int x_a, int channel);
  void ag_psp_220_ub_emepub(int x_a, int zero);
  void ax_psp_220_udx_emepudx(int x_a);
  void ac_psp_220_udx_emepudx(int x_a, int channel);
  void ag_psp_220_udx_emepudx(int x_a, int zero);
  void ax_psp_220_uux_emepgg(int x_a);
  void ac_psp_220_uux_emepgg(int x_a, int channel);
  void ag_psp_220_uux_emepgg(int x_a, int zero);
  void ax_psp_220_uux_emepddx(int x_a);
  void ac_psp_220_uux_emepddx(int x_a, int channel);
  void ag_psp_220_uux_emepddx(int x_a, int zero);
  void ax_psp_220_uux_emepuux(int x_a);
  void ac_psp_220_uux_emepuux(int x_a, int channel);
  void ag_psp_220_uux_emepuux(int x_a, int zero);
  void ax_psp_220_uux_emepssx(int x_a);
  void ac_psp_220_uux_emepssx(int x_a, int channel);
  void ag_psp_220_uux_emepssx(int x_a, int zero);
  void ax_psp_220_uux_emepccx(int x_a);
  void ac_psp_220_uux_emepccx(int x_a, int channel);
  void ag_psp_220_uux_emepccx(int x_a, int zero);
  void ax_psp_220_uux_emepbbx(int x_a);
  void ac_psp_220_uux_emepbbx(int x_a, int channel);
  void ag_psp_220_uux_emepbbx(int x_a, int zero);
  void ax_psp_220_usx_emepusx(int x_a);
  void ac_psp_220_usx_emepusx(int x_a, int channel);
  void ag_psp_220_usx_emepusx(int x_a, int zero);
  void ax_psp_220_ucx_emepucx(int x_a);
  void ac_psp_220_ucx_emepucx(int x_a, int channel);
  void ag_psp_220_ucx_emepucx(int x_a, int zero);
  void ax_psp_220_ubx_emepubx(int x_a);
  void ac_psp_220_ubx_emepubx(int x_a, int channel);
  void ag_psp_220_ubx_emepubx(int x_a, int zero);
  void ax_psp_220_bb_emepbb(int x_a);
  void ac_psp_220_bb_emepbb(int x_a, int channel);
  void ag_psp_220_bb_emepbb(int x_a, int zero);
  void ax_psp_220_bdx_emepbdx(int x_a);
  void ac_psp_220_bdx_emepbdx(int x_a, int channel);
  void ag_psp_220_bdx_emepbdx(int x_a, int zero);
  void ax_psp_220_bux_emepbux(int x_a);
  void ac_psp_220_bux_emepbux(int x_a, int channel);
  void ag_psp_220_bux_emepbux(int x_a, int zero);
  void ax_psp_220_bbx_emepgg(int x_a);
  void ac_psp_220_bbx_emepgg(int x_a, int channel);
  void ag_psp_220_bbx_emepgg(int x_a, int zero);
  void ax_psp_220_bbx_emepddx(int x_a);
  void ac_psp_220_bbx_emepddx(int x_a, int channel);
  void ag_psp_220_bbx_emepddx(int x_a, int zero);
  void ax_psp_220_bbx_emepuux(int x_a);
  void ac_psp_220_bbx_emepuux(int x_a, int channel);
  void ag_psp_220_bbx_emepuux(int x_a, int zero);
  void ax_psp_220_bbx_emepbbx(int x_a);
  void ac_psp_220_bbx_emepbbx(int x_a, int channel);
  void ag_psp_220_bbx_emepbbx(int x_a, int zero);
  void ax_psp_220_dxdx_emepdxdx(int x_a);
  void ac_psp_220_dxdx_emepdxdx(int x_a, int channel);
  void ag_psp_220_dxdx_emepdxdx(int x_a, int zero);
  void ax_psp_220_dxux_emepdxux(int x_a);
  void ac_psp_220_dxux_emepdxux(int x_a, int channel);
  void ag_psp_220_dxux_emepdxux(int x_a, int zero);
  void ax_psp_220_dxsx_emepdxsx(int x_a);
  void ac_psp_220_dxsx_emepdxsx(int x_a, int channel);
  void ag_psp_220_dxsx_emepdxsx(int x_a, int zero);
  void ax_psp_220_dxcx_emepdxcx(int x_a);
  void ac_psp_220_dxcx_emepdxcx(int x_a, int channel);
  void ag_psp_220_dxcx_emepdxcx(int x_a, int zero);
  void ax_psp_220_dxbx_emepdxbx(int x_a);
  void ac_psp_220_dxbx_emepdxbx(int x_a, int channel);
  void ag_psp_220_dxbx_emepdxbx(int x_a, int zero);
  void ax_psp_220_uxux_emepuxux(int x_a);
  void ac_psp_220_uxux_emepuxux(int x_a, int channel);
  void ag_psp_220_uxux_emepuxux(int x_a, int zero);
  void ax_psp_220_uxcx_emepuxcx(int x_a);
  void ac_psp_220_uxcx_emepuxcx(int x_a, int channel);
  void ag_psp_220_uxcx_emepuxcx(int x_a, int zero);
  void ax_psp_220_uxbx_emepuxbx(int x_a);
  void ac_psp_220_uxbx_emepuxbx(int x_a, int channel);
  void ag_psp_220_uxbx_emepuxbx(int x_a, int zero);
  void ax_psp_220_bxbx_emepbxbx(int x_a);
  void ac_psp_220_bxbx_emepbxbx(int x_a, int channel);
  void ag_psp_220_bxbx_emepbxbx(int x_a, int zero);

};
#endif
