#ifndef ppexne02_PHASESPACE_SET_HPP
#define ppexne02_PHASESPACE_SET_HPP

using namespace std;

class ppexne02_phasespace_set : public phasespace_set {
private:

public:
  ppexne02_phasespace_set(){}
  ~ppexne02_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_020_udx_epve(int x_a);
  void ac_psp_020_udx_epve(int x_a, int channel);
  void ag_psp_020_udx_epve(int x_a, int zero);
  void ax_psp_020_usx_epve(int x_a);
  void ac_psp_020_usx_epve(int x_a, int channel);
  void ag_psp_020_usx_epve(int x_a, int zero);
  void ax_psp_020_ubx_epve(int x_a);
  void ac_psp_020_ubx_epve(int x_a, int channel);
  void ag_psp_020_ubx_epve(int x_a, int zero);
  void ax_psp_020_cdx_epve(int x_a);
  void ac_psp_020_cdx_epve(int x_a, int channel);
  void ag_psp_020_cdx_epve(int x_a, int zero);
  void ax_psp_020_csx_epve(int x_a);
  void ac_psp_020_csx_epve(int x_a, int channel);
  void ag_psp_020_csx_epve(int x_a, int zero);
  void ax_psp_020_cbx_epve(int x_a);
  void ac_psp_020_cbx_epve(int x_a, int channel);
  void ag_psp_020_cbx_epve(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_120_gu_epved(int x_a);
  void ac_psp_120_gu_epved(int x_a, int channel);
  void ag_psp_120_gu_epved(int x_a, int zero);
  void ax_psp_120_gu_epves(int x_a);
  void ac_psp_120_gu_epves(int x_a, int channel);
  void ag_psp_120_gu_epves(int x_a, int zero);
  void ax_psp_120_gu_epveb(int x_a);
  void ac_psp_120_gu_epveb(int x_a, int channel);
  void ag_psp_120_gu_epveb(int x_a, int zero);
  void ax_psp_120_gc_epved(int x_a);
  void ac_psp_120_gc_epved(int x_a, int channel);
  void ag_psp_120_gc_epved(int x_a, int zero);
  void ax_psp_120_gc_epves(int x_a);
  void ac_psp_120_gc_epves(int x_a, int channel);
  void ag_psp_120_gc_epves(int x_a, int zero);
  void ax_psp_120_gc_epveb(int x_a);
  void ac_psp_120_gc_epveb(int x_a, int channel);
  void ag_psp_120_gc_epveb(int x_a, int zero);
  void ax_psp_120_gdx_epveux(int x_a);
  void ac_psp_120_gdx_epveux(int x_a, int channel);
  void ag_psp_120_gdx_epveux(int x_a, int zero);
  void ax_psp_120_gdx_epvecx(int x_a);
  void ac_psp_120_gdx_epvecx(int x_a, int channel);
  void ag_psp_120_gdx_epvecx(int x_a, int zero);
  void ax_psp_120_gsx_epveux(int x_a);
  void ac_psp_120_gsx_epveux(int x_a, int channel);
  void ag_psp_120_gsx_epveux(int x_a, int zero);
  void ax_psp_120_gsx_epvecx(int x_a);
  void ac_psp_120_gsx_epvecx(int x_a, int channel);
  void ag_psp_120_gsx_epvecx(int x_a, int zero);
  void ax_psp_120_gbx_epveux(int x_a);
  void ac_psp_120_gbx_epveux(int x_a, int channel);
  void ag_psp_120_gbx_epveux(int x_a, int zero);
  void ax_psp_120_gbx_epvecx(int x_a);
  void ac_psp_120_gbx_epvecx(int x_a, int channel);
  void ag_psp_120_gbx_epvecx(int x_a, int zero);
  void ax_psp_120_udx_epveg(int x_a);
  void ac_psp_120_udx_epveg(int x_a, int channel);
  void ag_psp_120_udx_epveg(int x_a, int zero);
  void ax_psp_120_usx_epveg(int x_a);
  void ac_psp_120_usx_epveg(int x_a, int channel);
  void ag_psp_120_usx_epveg(int x_a, int zero);
  void ax_psp_120_ubx_epveg(int x_a);
  void ac_psp_120_ubx_epveg(int x_a, int channel);
  void ag_psp_120_ubx_epveg(int x_a, int zero);
  void ax_psp_030_ua_epved(int x_a);
  void ac_psp_030_ua_epved(int x_a, int channel);
  void ag_psp_030_ua_epved(int x_a, int zero);
  void ax_psp_030_ua_epves(int x_a);
  void ac_psp_030_ua_epves(int x_a, int channel);
  void ag_psp_030_ua_epves(int x_a, int zero);
  void ax_psp_030_ua_epveb(int x_a);
  void ac_psp_030_ua_epveb(int x_a, int channel);
  void ag_psp_030_ua_epveb(int x_a, int zero);
  void ax_psp_120_cdx_epveg(int x_a);
  void ac_psp_120_cdx_epveg(int x_a, int channel);
  void ag_psp_120_cdx_epveg(int x_a, int zero);
  void ax_psp_120_csx_epveg(int x_a);
  void ac_psp_120_csx_epveg(int x_a, int channel);
  void ag_psp_120_csx_epveg(int x_a, int zero);
  void ax_psp_120_cbx_epveg(int x_a);
  void ac_psp_120_cbx_epveg(int x_a, int channel);
  void ag_psp_120_cbx_epveg(int x_a, int zero);
  void ax_psp_030_ca_epved(int x_a);
  void ac_psp_030_ca_epved(int x_a, int channel);
  void ag_psp_030_ca_epved(int x_a, int zero);
  void ax_psp_030_ca_epves(int x_a);
  void ac_psp_030_ca_epves(int x_a, int channel);
  void ag_psp_030_ca_epves(int x_a, int zero);
  void ax_psp_030_ca_epveb(int x_a);
  void ac_psp_030_ca_epveb(int x_a, int channel);
  void ag_psp_030_ca_epveb(int x_a, int zero);
  void ax_psp_030_dxa_epveux(int x_a);
  void ac_psp_030_dxa_epveux(int x_a, int channel);
  void ag_psp_030_dxa_epveux(int x_a, int zero);
  void ax_psp_030_dxa_epvecx(int x_a);
  void ac_psp_030_dxa_epvecx(int x_a, int channel);
  void ag_psp_030_dxa_epvecx(int x_a, int zero);
  void ax_psp_030_sxa_epveux(int x_a);
  void ac_psp_030_sxa_epveux(int x_a, int channel);
  void ag_psp_030_sxa_epveux(int x_a, int zero);
  void ax_psp_030_sxa_epvecx(int x_a);
  void ac_psp_030_sxa_epvecx(int x_a, int channel);
  void ag_psp_030_sxa_epvecx(int x_a, int zero);
  void ax_psp_030_bxa_epveux(int x_a);
  void ac_psp_030_bxa_epveux(int x_a, int channel);
  void ag_psp_030_bxa_epveux(int x_a, int zero);
  void ax_psp_030_bxa_epvecx(int x_a);
  void ac_psp_030_bxa_epvecx(int x_a, int channel);
  void ag_psp_030_bxa_epvecx(int x_a, int zero);
  void ax_psp_030_udx_epvea(int x_a);
  void ac_psp_030_udx_epvea(int x_a, int channel);
  void ag_psp_030_udx_epvea(int x_a, int zero);
  void ax_psp_030_usx_epvea(int x_a);
  void ac_psp_030_usx_epvea(int x_a, int channel);
  void ag_psp_030_usx_epvea(int x_a, int zero);
  void ax_psp_030_ubx_epvea(int x_a);
  void ac_psp_030_ubx_epvea(int x_a, int channel);
  void ag_psp_030_ubx_epvea(int x_a, int zero);
  void ax_psp_030_cdx_epvea(int x_a);
  void ac_psp_030_cdx_epvea(int x_a, int channel);
  void ag_psp_030_cdx_epvea(int x_a, int zero);
  void ax_psp_030_csx_epvea(int x_a);
  void ac_psp_030_csx_epvea(int x_a, int channel);
  void ag_psp_030_csx_epvea(int x_a, int zero);
  void ax_psp_030_cbx_epvea(int x_a);
  void ac_psp_030_cbx_epvea(int x_a, int channel);
  void ag_psp_030_cbx_epvea(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_220_gg_epvedux(int x_a);
  void ac_psp_220_gg_epvedux(int x_a, int channel);
  void ag_psp_220_gg_epvedux(int x_a, int zero);
  void ax_psp_220_gg_epvedcx(int x_a);
  void ac_psp_220_gg_epvedcx(int x_a, int channel);
  void ag_psp_220_gg_epvedcx(int x_a, int zero);
  void ax_psp_220_gg_epvesux(int x_a);
  void ac_psp_220_gg_epvesux(int x_a, int channel);
  void ag_psp_220_gg_epvesux(int x_a, int zero);
  void ax_psp_220_gg_epvescx(int x_a);
  void ac_psp_220_gg_epvescx(int x_a, int channel);
  void ag_psp_220_gg_epvescx(int x_a, int zero);
  void ax_psp_220_gg_epvebux(int x_a);
  void ac_psp_220_gg_epvebux(int x_a, int channel);
  void ag_psp_220_gg_epvebux(int x_a, int zero);
  void ax_psp_220_gg_epvebcx(int x_a);
  void ac_psp_220_gg_epvebcx(int x_a, int channel);
  void ag_psp_220_gg_epvebcx(int x_a, int zero);
  void ax_psp_220_gu_epvegd(int x_a);
  void ac_psp_220_gu_epvegd(int x_a, int channel);
  void ag_psp_220_gu_epvegd(int x_a, int zero);
  void ax_psp_220_gu_epvegs(int x_a);
  void ac_psp_220_gu_epvegs(int x_a, int channel);
  void ag_psp_220_gu_epvegs(int x_a, int zero);
  void ax_psp_220_gu_epvegb(int x_a);
  void ac_psp_220_gu_epvegb(int x_a, int channel);
  void ag_psp_220_gu_epvegb(int x_a, int zero);
  void ax_psp_220_gc_epvegd(int x_a);
  void ac_psp_220_gc_epvegd(int x_a, int channel);
  void ag_psp_220_gc_epvegd(int x_a, int zero);
  void ax_psp_220_gc_epvegs(int x_a);
  void ac_psp_220_gc_epvegs(int x_a, int channel);
  void ag_psp_220_gc_epvegs(int x_a, int zero);
  void ax_psp_220_gc_epvegb(int x_a);
  void ac_psp_220_gc_epvegb(int x_a, int channel);
  void ag_psp_220_gc_epvegb(int x_a, int zero);
  void ax_psp_220_gdx_epvegux(int x_a);
  void ac_psp_220_gdx_epvegux(int x_a, int channel);
  void ag_psp_220_gdx_epvegux(int x_a, int zero);
  void ax_psp_220_gdx_epvegcx(int x_a);
  void ac_psp_220_gdx_epvegcx(int x_a, int channel);
  void ag_psp_220_gdx_epvegcx(int x_a, int zero);
  void ax_psp_220_gsx_epvegux(int x_a);
  void ac_psp_220_gsx_epvegux(int x_a, int channel);
  void ag_psp_220_gsx_epvegux(int x_a, int zero);
  void ax_psp_220_gsx_epvegcx(int x_a);
  void ac_psp_220_gsx_epvegcx(int x_a, int channel);
  void ag_psp_220_gsx_epvegcx(int x_a, int zero);
  void ax_psp_220_gbx_epvegux(int x_a);
  void ac_psp_220_gbx_epvegux(int x_a, int channel);
  void ag_psp_220_gbx_epvegux(int x_a, int zero);
  void ax_psp_220_gbx_epvegcx(int x_a);
  void ac_psp_220_gbx_epvegcx(int x_a, int channel);
  void ag_psp_220_gbx_epvegcx(int x_a, int zero);
  void ax_psp_220_du_epvedd(int x_a);
  void ac_psp_220_du_epvedd(int x_a, int channel);
  void ag_psp_220_du_epvedd(int x_a, int zero);
  void ax_psp_220_du_epveds(int x_a);
  void ac_psp_220_du_epveds(int x_a, int channel);
  void ag_psp_220_du_epveds(int x_a, int zero);
  void ax_psp_220_du_epvedb(int x_a);
  void ac_psp_220_du_epvedb(int x_a, int channel);
  void ag_psp_220_du_epvedb(int x_a, int zero);
  void ax_psp_220_dc_epvedd(int x_a);
  void ac_psp_220_dc_epvedd(int x_a, int channel);
  void ag_psp_220_dc_epvedd(int x_a, int zero);
  void ax_psp_220_dc_epveds(int x_a);
  void ac_psp_220_dc_epveds(int x_a, int channel);
  void ag_psp_220_dc_epveds(int x_a, int zero);
  void ax_psp_220_dc_epvedb(int x_a);
  void ac_psp_220_dc_epvedb(int x_a, int channel);
  void ag_psp_220_dc_epvedb(int x_a, int zero);
  void ax_psp_220_ddx_epvedux(int x_a);
  void ac_psp_220_ddx_epvedux(int x_a, int channel);
  void ag_psp_220_ddx_epvedux(int x_a, int zero);
  void ax_psp_220_ddx_epvedcx(int x_a);
  void ac_psp_220_ddx_epvedcx(int x_a, int channel);
  void ag_psp_220_ddx_epvedcx(int x_a, int zero);
  void ax_psp_220_ddx_epvesux(int x_a);
  void ac_psp_220_ddx_epvesux(int x_a, int channel);
  void ag_psp_220_ddx_epvesux(int x_a, int zero);
  void ax_psp_220_ddx_epvescx(int x_a);
  void ac_psp_220_ddx_epvescx(int x_a, int channel);
  void ag_psp_220_ddx_epvescx(int x_a, int zero);
  void ax_psp_220_ddx_epvebux(int x_a);
  void ac_psp_220_ddx_epvebux(int x_a, int channel);
  void ag_psp_220_ddx_epvebux(int x_a, int zero);
  void ax_psp_220_ddx_epvebcx(int x_a);
  void ac_psp_220_ddx_epvebcx(int x_a, int channel);
  void ag_psp_220_ddx_epvebcx(int x_a, int zero);
  void ax_psp_220_dsx_epvedux(int x_a);
  void ac_psp_220_dsx_epvedux(int x_a, int channel);
  void ag_psp_220_dsx_epvedux(int x_a, int zero);
  void ax_psp_220_dsx_epvedcx(int x_a);
  void ac_psp_220_dsx_epvedcx(int x_a, int channel);
  void ag_psp_220_dsx_epvedcx(int x_a, int zero);
  void ax_psp_220_dbx_epvedux(int x_a);
  void ac_psp_220_dbx_epvedux(int x_a, int channel);
  void ag_psp_220_dbx_epvedux(int x_a, int zero);
  void ax_psp_220_dbx_epvedcx(int x_a);
  void ac_psp_220_dbx_epvedcx(int x_a, int channel);
  void ag_psp_220_dbx_epvedcx(int x_a, int zero);
  void ax_psp_220_uu_epvedu(int x_a);
  void ac_psp_220_uu_epvedu(int x_a, int channel);
  void ag_psp_220_uu_epvedu(int x_a, int zero);
  void ax_psp_220_uu_epveus(int x_a);
  void ac_psp_220_uu_epveus(int x_a, int channel);
  void ag_psp_220_uu_epveus(int x_a, int zero);
  void ax_psp_220_uu_epveub(int x_a);
  void ac_psp_220_uu_epveub(int x_a, int channel);
  void ag_psp_220_uu_epveub(int x_a, int zero);
  void ax_psp_220_us_epveds(int x_a);
  void ac_psp_220_us_epveds(int x_a, int channel);
  void ag_psp_220_us_epveds(int x_a, int zero);
  void ax_psp_220_us_epvess(int x_a);
  void ac_psp_220_us_epvess(int x_a, int channel);
  void ag_psp_220_us_epvess(int x_a, int zero);
  void ax_psp_220_us_epvesb(int x_a);
  void ac_psp_220_us_epvesb(int x_a, int channel);
  void ag_psp_220_us_epvesb(int x_a, int zero);
  void ax_psp_220_uc_epvedu(int x_a);
  void ac_psp_220_uc_epvedu(int x_a, int channel);
  void ag_psp_220_uc_epvedu(int x_a, int zero);
  void ax_psp_220_uc_epvedc(int x_a);
  void ac_psp_220_uc_epvedc(int x_a, int channel);
  void ag_psp_220_uc_epvedc(int x_a, int zero);
  void ax_psp_220_uc_epveus(int x_a);
  void ac_psp_220_uc_epveus(int x_a, int channel);
  void ag_psp_220_uc_epveus(int x_a, int zero);
  void ax_psp_220_uc_epveub(int x_a);
  void ac_psp_220_uc_epveub(int x_a, int channel);
  void ag_psp_220_uc_epveub(int x_a, int zero);
  void ax_psp_220_uc_epvesc(int x_a);
  void ac_psp_220_uc_epvesc(int x_a, int channel);
  void ag_psp_220_uc_epvesc(int x_a, int zero);
  void ax_psp_220_uc_epvecb(int x_a);
  void ac_psp_220_uc_epvecb(int x_a, int channel);
  void ag_psp_220_uc_epvecb(int x_a, int zero);
  void ax_psp_220_ub_epvedb(int x_a);
  void ac_psp_220_ub_epvedb(int x_a, int channel);
  void ag_psp_220_ub_epvedb(int x_a, int zero);
  void ax_psp_220_ub_epvesb(int x_a);
  void ac_psp_220_ub_epvesb(int x_a, int channel);
  void ag_psp_220_ub_epvesb(int x_a, int zero);
  void ax_psp_220_ub_epvebb(int x_a);
  void ac_psp_220_ub_epvebb(int x_a, int channel);
  void ag_psp_220_ub_epvebb(int x_a, int zero);
  void ax_psp_220_udx_epvegg(int x_a);
  void ac_psp_220_udx_epvegg(int x_a, int channel);
  void ag_psp_220_udx_epvegg(int x_a, int zero);
  void ax_psp_220_udx_epveddx(int x_a);
  void ac_psp_220_udx_epveddx(int x_a, int channel);
  void ag_psp_220_udx_epveddx(int x_a, int zero);
  void ax_psp_220_udx_epveuux(int x_a);
  void ac_psp_220_udx_epveuux(int x_a, int channel);
  void ag_psp_220_udx_epveuux(int x_a, int zero);
  void ax_psp_220_udx_epveucx(int x_a);
  void ac_psp_220_udx_epveucx(int x_a, int channel);
  void ag_psp_220_udx_epveucx(int x_a, int zero);
  void ax_psp_220_udx_epvesdx(int x_a);
  void ac_psp_220_udx_epvesdx(int x_a, int channel);
  void ag_psp_220_udx_epvesdx(int x_a, int zero);
  void ax_psp_220_udx_epvessx(int x_a);
  void ac_psp_220_udx_epvessx(int x_a, int channel);
  void ag_psp_220_udx_epvessx(int x_a, int zero);
  void ax_psp_220_udx_epveccx(int x_a);
  void ac_psp_220_udx_epveccx(int x_a, int channel);
  void ag_psp_220_udx_epveccx(int x_a, int zero);
  void ax_psp_220_udx_epvebdx(int x_a);
  void ac_psp_220_udx_epvebdx(int x_a, int channel);
  void ag_psp_220_udx_epvebdx(int x_a, int zero);
  void ax_psp_220_udx_epvebbx(int x_a);
  void ac_psp_220_udx_epvebbx(int x_a, int channel);
  void ag_psp_220_udx_epvebbx(int x_a, int zero);
  void ax_psp_220_uux_epvedux(int x_a);
  void ac_psp_220_uux_epvedux(int x_a, int channel);
  void ag_psp_220_uux_epvedux(int x_a, int zero);
  void ax_psp_220_uux_epvedcx(int x_a);
  void ac_psp_220_uux_epvedcx(int x_a, int channel);
  void ag_psp_220_uux_epvedcx(int x_a, int zero);
  void ax_psp_220_uux_epvesux(int x_a);
  void ac_psp_220_uux_epvesux(int x_a, int channel);
  void ag_psp_220_uux_epvesux(int x_a, int zero);
  void ax_psp_220_uux_epvescx(int x_a);
  void ac_psp_220_uux_epvescx(int x_a, int channel);
  void ag_psp_220_uux_epvescx(int x_a, int zero);
  void ax_psp_220_uux_epvebux(int x_a);
  void ac_psp_220_uux_epvebux(int x_a, int channel);
  void ag_psp_220_uux_epvebux(int x_a, int zero);
  void ax_psp_220_uux_epvebcx(int x_a);
  void ac_psp_220_uux_epvebcx(int x_a, int channel);
  void ag_psp_220_uux_epvebcx(int x_a, int zero);
  void ax_psp_220_usx_epvegg(int x_a);
  void ac_psp_220_usx_epvegg(int x_a, int channel);
  void ag_psp_220_usx_epvegg(int x_a, int zero);
  void ax_psp_220_usx_epveddx(int x_a);
  void ac_psp_220_usx_epveddx(int x_a, int channel);
  void ag_psp_220_usx_epveddx(int x_a, int zero);
  void ax_psp_220_usx_epvedsx(int x_a);
  void ac_psp_220_usx_epvedsx(int x_a, int channel);
  void ag_psp_220_usx_epvedsx(int x_a, int zero);
  void ax_psp_220_usx_epveuux(int x_a);
  void ac_psp_220_usx_epveuux(int x_a, int channel);
  void ag_psp_220_usx_epveuux(int x_a, int zero);
  void ax_psp_220_usx_epveucx(int x_a);
  void ac_psp_220_usx_epveucx(int x_a, int channel);
  void ag_psp_220_usx_epveucx(int x_a, int zero);
  void ax_psp_220_usx_epvessx(int x_a);
  void ac_psp_220_usx_epvessx(int x_a, int channel);
  void ag_psp_220_usx_epvessx(int x_a, int zero);
  void ax_psp_220_usx_epveccx(int x_a);
  void ac_psp_220_usx_epveccx(int x_a, int channel);
  void ag_psp_220_usx_epveccx(int x_a, int zero);
  void ax_psp_220_usx_epvebsx(int x_a);
  void ac_psp_220_usx_epvebsx(int x_a, int channel);
  void ag_psp_220_usx_epvebsx(int x_a, int zero);
  void ax_psp_220_usx_epvebbx(int x_a);
  void ac_psp_220_usx_epvebbx(int x_a, int channel);
  void ag_psp_220_usx_epvebbx(int x_a, int zero);
  void ax_psp_220_ucx_epvedcx(int x_a);
  void ac_psp_220_ucx_epvedcx(int x_a, int channel);
  void ag_psp_220_ucx_epvedcx(int x_a, int zero);
  void ax_psp_220_ucx_epvescx(int x_a);
  void ac_psp_220_ucx_epvescx(int x_a, int channel);
  void ag_psp_220_ucx_epvescx(int x_a, int zero);
  void ax_psp_220_ucx_epvebcx(int x_a);
  void ac_psp_220_ucx_epvebcx(int x_a, int channel);
  void ag_psp_220_ucx_epvebcx(int x_a, int zero);
  void ax_psp_220_ubx_epvegg(int x_a);
  void ac_psp_220_ubx_epvegg(int x_a, int channel);
  void ag_psp_220_ubx_epvegg(int x_a, int zero);
  void ax_psp_220_ubx_epveddx(int x_a);
  void ac_psp_220_ubx_epveddx(int x_a, int channel);
  void ag_psp_220_ubx_epveddx(int x_a, int zero);
  void ax_psp_220_ubx_epvedbx(int x_a);
  void ac_psp_220_ubx_epvedbx(int x_a, int channel);
  void ag_psp_220_ubx_epvedbx(int x_a, int zero);
  void ax_psp_220_ubx_epveuux(int x_a);
  void ac_psp_220_ubx_epveuux(int x_a, int channel);
  void ag_psp_220_ubx_epveuux(int x_a, int zero);
  void ax_psp_220_ubx_epveucx(int x_a);
  void ac_psp_220_ubx_epveucx(int x_a, int channel);
  void ag_psp_220_ubx_epveucx(int x_a, int zero);
  void ax_psp_220_ubx_epvessx(int x_a);
  void ac_psp_220_ubx_epvessx(int x_a, int channel);
  void ag_psp_220_ubx_epvessx(int x_a, int zero);
  void ax_psp_220_ubx_epvesbx(int x_a);
  void ac_psp_220_ubx_epvesbx(int x_a, int channel);
  void ag_psp_220_ubx_epvesbx(int x_a, int zero);
  void ax_psp_220_ubx_epveccx(int x_a);
  void ac_psp_220_ubx_epveccx(int x_a, int channel);
  void ag_psp_220_ubx_epveccx(int x_a, int zero);
  void ax_psp_220_ubx_epvebbx(int x_a);
  void ac_psp_220_ubx_epvebbx(int x_a, int channel);
  void ag_psp_220_ubx_epvebbx(int x_a, int zero);
  void ax_psp_220_sc_epveds(int x_a);
  void ac_psp_220_sc_epveds(int x_a, int channel);
  void ag_psp_220_sc_epveds(int x_a, int zero);
  void ax_psp_220_sc_epvess(int x_a);
  void ac_psp_220_sc_epvess(int x_a, int channel);
  void ag_psp_220_sc_epvess(int x_a, int zero);
  void ax_psp_220_sc_epvesb(int x_a);
  void ac_psp_220_sc_epvesb(int x_a, int channel);
  void ag_psp_220_sc_epvesb(int x_a, int zero);
  void ax_psp_220_sdx_epvesux(int x_a);
  void ac_psp_220_sdx_epvesux(int x_a, int channel);
  void ag_psp_220_sdx_epvesux(int x_a, int zero);
  void ax_psp_220_sdx_epvescx(int x_a);
  void ac_psp_220_sdx_epvescx(int x_a, int channel);
  void ag_psp_220_sdx_epvescx(int x_a, int zero);
  void ax_psp_220_ssx_epvedux(int x_a);
  void ac_psp_220_ssx_epvedux(int x_a, int channel);
  void ag_psp_220_ssx_epvedux(int x_a, int zero);
  void ax_psp_220_ssx_epvedcx(int x_a);
  void ac_psp_220_ssx_epvedcx(int x_a, int channel);
  void ag_psp_220_ssx_epvedcx(int x_a, int zero);
  void ax_psp_220_ssx_epvesux(int x_a);
  void ac_psp_220_ssx_epvesux(int x_a, int channel);
  void ag_psp_220_ssx_epvesux(int x_a, int zero);
  void ax_psp_220_ssx_epvescx(int x_a);
  void ac_psp_220_ssx_epvescx(int x_a, int channel);
  void ag_psp_220_ssx_epvescx(int x_a, int zero);
  void ax_psp_220_ssx_epvebux(int x_a);
  void ac_psp_220_ssx_epvebux(int x_a, int channel);
  void ag_psp_220_ssx_epvebux(int x_a, int zero);
  void ax_psp_220_ssx_epvebcx(int x_a);
  void ac_psp_220_ssx_epvebcx(int x_a, int channel);
  void ag_psp_220_ssx_epvebcx(int x_a, int zero);
  void ax_psp_220_sbx_epvesux(int x_a);
  void ac_psp_220_sbx_epvesux(int x_a, int channel);
  void ag_psp_220_sbx_epvesux(int x_a, int zero);
  void ax_psp_220_sbx_epvescx(int x_a);
  void ac_psp_220_sbx_epvescx(int x_a, int channel);
  void ag_psp_220_sbx_epvescx(int x_a, int zero);
  void ax_psp_220_cc_epvedc(int x_a);
  void ac_psp_220_cc_epvedc(int x_a, int channel);
  void ag_psp_220_cc_epvedc(int x_a, int zero);
  void ax_psp_220_cc_epvesc(int x_a);
  void ac_psp_220_cc_epvesc(int x_a, int channel);
  void ag_psp_220_cc_epvesc(int x_a, int zero);
  void ax_psp_220_cc_epvecb(int x_a);
  void ac_psp_220_cc_epvecb(int x_a, int channel);
  void ag_psp_220_cc_epvecb(int x_a, int zero);
  void ax_psp_220_cb_epvedb(int x_a);
  void ac_psp_220_cb_epvedb(int x_a, int channel);
  void ag_psp_220_cb_epvedb(int x_a, int zero);
  void ax_psp_220_cb_epvesb(int x_a);
  void ac_psp_220_cb_epvesb(int x_a, int channel);
  void ag_psp_220_cb_epvesb(int x_a, int zero);
  void ax_psp_220_cb_epvebb(int x_a);
  void ac_psp_220_cb_epvebb(int x_a, int channel);
  void ag_psp_220_cb_epvebb(int x_a, int zero);
  void ax_psp_220_cdx_epvegg(int x_a);
  void ac_psp_220_cdx_epvegg(int x_a, int channel);
  void ag_psp_220_cdx_epvegg(int x_a, int zero);
  void ax_psp_220_cdx_epveddx(int x_a);
  void ac_psp_220_cdx_epveddx(int x_a, int channel);
  void ag_psp_220_cdx_epveddx(int x_a, int zero);
  void ax_psp_220_cdx_epveuux(int x_a);
  void ac_psp_220_cdx_epveuux(int x_a, int channel);
  void ag_psp_220_cdx_epveuux(int x_a, int zero);
  void ax_psp_220_cdx_epvesdx(int x_a);
  void ac_psp_220_cdx_epvesdx(int x_a, int channel);
  void ag_psp_220_cdx_epvesdx(int x_a, int zero);
  void ax_psp_220_cdx_epvessx(int x_a);
  void ac_psp_220_cdx_epvessx(int x_a, int channel);
  void ag_psp_220_cdx_epvessx(int x_a, int zero);
  void ax_psp_220_cdx_epvecux(int x_a);
  void ac_psp_220_cdx_epvecux(int x_a, int channel);
  void ag_psp_220_cdx_epvecux(int x_a, int zero);
  void ax_psp_220_cdx_epveccx(int x_a);
  void ac_psp_220_cdx_epveccx(int x_a, int channel);
  void ag_psp_220_cdx_epveccx(int x_a, int zero);
  void ax_psp_220_cdx_epvebdx(int x_a);
  void ac_psp_220_cdx_epvebdx(int x_a, int channel);
  void ag_psp_220_cdx_epvebdx(int x_a, int zero);
  void ax_psp_220_cdx_epvebbx(int x_a);
  void ac_psp_220_cdx_epvebbx(int x_a, int channel);
  void ag_psp_220_cdx_epvebbx(int x_a, int zero);
  void ax_psp_220_cux_epvedux(int x_a);
  void ac_psp_220_cux_epvedux(int x_a, int channel);
  void ag_psp_220_cux_epvedux(int x_a, int zero);
  void ax_psp_220_cux_epvesux(int x_a);
  void ac_psp_220_cux_epvesux(int x_a, int channel);
  void ag_psp_220_cux_epvesux(int x_a, int zero);
  void ax_psp_220_cux_epvebux(int x_a);
  void ac_psp_220_cux_epvebux(int x_a, int channel);
  void ag_psp_220_cux_epvebux(int x_a, int zero);
  void ax_psp_220_csx_epvegg(int x_a);
  void ac_psp_220_csx_epvegg(int x_a, int channel);
  void ag_psp_220_csx_epvegg(int x_a, int zero);
  void ax_psp_220_csx_epveddx(int x_a);
  void ac_psp_220_csx_epveddx(int x_a, int channel);
  void ag_psp_220_csx_epveddx(int x_a, int zero);
  void ax_psp_220_csx_epvedsx(int x_a);
  void ac_psp_220_csx_epvedsx(int x_a, int channel);
  void ag_psp_220_csx_epvedsx(int x_a, int zero);
  void ax_psp_220_csx_epveuux(int x_a);
  void ac_psp_220_csx_epveuux(int x_a, int channel);
  void ag_psp_220_csx_epveuux(int x_a, int zero);
  void ax_psp_220_csx_epvessx(int x_a);
  void ac_psp_220_csx_epvessx(int x_a, int channel);
  void ag_psp_220_csx_epvessx(int x_a, int zero);
  void ax_psp_220_csx_epvecux(int x_a);
  void ac_psp_220_csx_epvecux(int x_a, int channel);
  void ag_psp_220_csx_epvecux(int x_a, int zero);
  void ax_psp_220_csx_epveccx(int x_a);
  void ac_psp_220_csx_epveccx(int x_a, int channel);
  void ag_psp_220_csx_epveccx(int x_a, int zero);
  void ax_psp_220_csx_epvebsx(int x_a);
  void ac_psp_220_csx_epvebsx(int x_a, int channel);
  void ag_psp_220_csx_epvebsx(int x_a, int zero);
  void ax_psp_220_csx_epvebbx(int x_a);
  void ac_psp_220_csx_epvebbx(int x_a, int channel);
  void ag_psp_220_csx_epvebbx(int x_a, int zero);
  void ax_psp_220_ccx_epvedux(int x_a);
  void ac_psp_220_ccx_epvedux(int x_a, int channel);
  void ag_psp_220_ccx_epvedux(int x_a, int zero);
  void ax_psp_220_ccx_epvedcx(int x_a);
  void ac_psp_220_ccx_epvedcx(int x_a, int channel);
  void ag_psp_220_ccx_epvedcx(int x_a, int zero);
  void ax_psp_220_ccx_epvesux(int x_a);
  void ac_psp_220_ccx_epvesux(int x_a, int channel);
  void ag_psp_220_ccx_epvesux(int x_a, int zero);
  void ax_psp_220_ccx_epvescx(int x_a);
  void ac_psp_220_ccx_epvescx(int x_a, int channel);
  void ag_psp_220_ccx_epvescx(int x_a, int zero);
  void ax_psp_220_ccx_epvebux(int x_a);
  void ac_psp_220_ccx_epvebux(int x_a, int channel);
  void ag_psp_220_ccx_epvebux(int x_a, int zero);
  void ax_psp_220_ccx_epvebcx(int x_a);
  void ac_psp_220_ccx_epvebcx(int x_a, int channel);
  void ag_psp_220_ccx_epvebcx(int x_a, int zero);
  void ax_psp_220_cbx_epvegg(int x_a);
  void ac_psp_220_cbx_epvegg(int x_a, int channel);
  void ag_psp_220_cbx_epvegg(int x_a, int zero);
  void ax_psp_220_cbx_epveddx(int x_a);
  void ac_psp_220_cbx_epveddx(int x_a, int channel);
  void ag_psp_220_cbx_epveddx(int x_a, int zero);
  void ax_psp_220_cbx_epvedbx(int x_a);
  void ac_psp_220_cbx_epvedbx(int x_a, int channel);
  void ag_psp_220_cbx_epvedbx(int x_a, int zero);
  void ax_psp_220_cbx_epveuux(int x_a);
  void ac_psp_220_cbx_epveuux(int x_a, int channel);
  void ag_psp_220_cbx_epveuux(int x_a, int zero);
  void ax_psp_220_cbx_epvessx(int x_a);
  void ac_psp_220_cbx_epvessx(int x_a, int channel);
  void ag_psp_220_cbx_epvessx(int x_a, int zero);
  void ax_psp_220_cbx_epvesbx(int x_a);
  void ac_psp_220_cbx_epvesbx(int x_a, int channel);
  void ag_psp_220_cbx_epvesbx(int x_a, int zero);
  void ax_psp_220_cbx_epvecux(int x_a);
  void ac_psp_220_cbx_epvecux(int x_a, int channel);
  void ag_psp_220_cbx_epvecux(int x_a, int zero);
  void ax_psp_220_cbx_epveccx(int x_a);
  void ac_psp_220_cbx_epveccx(int x_a, int channel);
  void ag_psp_220_cbx_epveccx(int x_a, int zero);
  void ax_psp_220_cbx_epvebbx(int x_a);
  void ac_psp_220_cbx_epvebbx(int x_a, int channel);
  void ag_psp_220_cbx_epvebbx(int x_a, int zero);
  void ax_psp_220_bdx_epvebux(int x_a);
  void ac_psp_220_bdx_epvebux(int x_a, int channel);
  void ag_psp_220_bdx_epvebux(int x_a, int zero);
  void ax_psp_220_bdx_epvebcx(int x_a);
  void ac_psp_220_bdx_epvebcx(int x_a, int channel);
  void ag_psp_220_bdx_epvebcx(int x_a, int zero);
  void ax_psp_220_bsx_epvebux(int x_a);
  void ac_psp_220_bsx_epvebux(int x_a, int channel);
  void ag_psp_220_bsx_epvebux(int x_a, int zero);
  void ax_psp_220_bsx_epvebcx(int x_a);
  void ac_psp_220_bsx_epvebcx(int x_a, int channel);
  void ag_psp_220_bsx_epvebcx(int x_a, int zero);
  void ax_psp_220_bbx_epvedux(int x_a);
  void ac_psp_220_bbx_epvedux(int x_a, int channel);
  void ag_psp_220_bbx_epvedux(int x_a, int zero);
  void ax_psp_220_bbx_epvedcx(int x_a);
  void ac_psp_220_bbx_epvedcx(int x_a, int channel);
  void ag_psp_220_bbx_epvedcx(int x_a, int zero);
  void ax_psp_220_bbx_epvesux(int x_a);
  void ac_psp_220_bbx_epvesux(int x_a, int channel);
  void ag_psp_220_bbx_epvesux(int x_a, int zero);
  void ax_psp_220_bbx_epvescx(int x_a);
  void ac_psp_220_bbx_epvescx(int x_a, int channel);
  void ag_psp_220_bbx_epvescx(int x_a, int zero);
  void ax_psp_220_bbx_epvebux(int x_a);
  void ac_psp_220_bbx_epvebux(int x_a, int channel);
  void ag_psp_220_bbx_epvebux(int x_a, int zero);
  void ax_psp_220_bbx_epvebcx(int x_a);
  void ac_psp_220_bbx_epvebcx(int x_a, int channel);
  void ag_psp_220_bbx_epvebcx(int x_a, int zero);
  void ax_psp_220_dxdx_epvedxux(int x_a);
  void ac_psp_220_dxdx_epvedxux(int x_a, int channel);
  void ag_psp_220_dxdx_epvedxux(int x_a, int zero);
  void ax_psp_220_dxdx_epvedxcx(int x_a);
  void ac_psp_220_dxdx_epvedxcx(int x_a, int channel);
  void ag_psp_220_dxdx_epvedxcx(int x_a, int zero);
  void ax_psp_220_dxux_epveuxux(int x_a);
  void ac_psp_220_dxux_epveuxux(int x_a, int channel);
  void ag_psp_220_dxux_epveuxux(int x_a, int zero);
  void ax_psp_220_dxux_epveuxcx(int x_a);
  void ac_psp_220_dxux_epveuxcx(int x_a, int channel);
  void ag_psp_220_dxux_epveuxcx(int x_a, int zero);
  void ax_psp_220_dxsx_epvedxux(int x_a);
  void ac_psp_220_dxsx_epvedxux(int x_a, int channel);
  void ag_psp_220_dxsx_epvedxux(int x_a, int zero);
  void ax_psp_220_dxsx_epvedxcx(int x_a);
  void ac_psp_220_dxsx_epvedxcx(int x_a, int channel);
  void ag_psp_220_dxsx_epvedxcx(int x_a, int zero);
  void ax_psp_220_dxsx_epveuxsx(int x_a);
  void ac_psp_220_dxsx_epveuxsx(int x_a, int channel);
  void ag_psp_220_dxsx_epveuxsx(int x_a, int zero);
  void ax_psp_220_dxsx_epvesxcx(int x_a);
  void ac_psp_220_dxsx_epvesxcx(int x_a, int channel);
  void ag_psp_220_dxsx_epvesxcx(int x_a, int zero);
  void ax_psp_220_dxcx_epveuxcx(int x_a);
  void ac_psp_220_dxcx_epveuxcx(int x_a, int channel);
  void ag_psp_220_dxcx_epveuxcx(int x_a, int zero);
  void ax_psp_220_dxcx_epvecxcx(int x_a);
  void ac_psp_220_dxcx_epvecxcx(int x_a, int channel);
  void ag_psp_220_dxcx_epvecxcx(int x_a, int zero);
  void ax_psp_220_dxbx_epvedxux(int x_a);
  void ac_psp_220_dxbx_epvedxux(int x_a, int channel);
  void ag_psp_220_dxbx_epvedxux(int x_a, int zero);
  void ax_psp_220_dxbx_epvedxcx(int x_a);
  void ac_psp_220_dxbx_epvedxcx(int x_a, int channel);
  void ag_psp_220_dxbx_epvedxcx(int x_a, int zero);
  void ax_psp_220_dxbx_epveuxbx(int x_a);
  void ac_psp_220_dxbx_epveuxbx(int x_a, int channel);
  void ag_psp_220_dxbx_epveuxbx(int x_a, int zero);
  void ax_psp_220_dxbx_epvecxbx(int x_a);
  void ac_psp_220_dxbx_epvecxbx(int x_a, int channel);
  void ag_psp_220_dxbx_epvecxbx(int x_a, int zero);
  void ax_psp_220_uxsx_epveuxux(int x_a);
  void ac_psp_220_uxsx_epveuxux(int x_a, int channel);
  void ag_psp_220_uxsx_epveuxux(int x_a, int zero);
  void ax_psp_220_uxsx_epveuxcx(int x_a);
  void ac_psp_220_uxsx_epveuxcx(int x_a, int channel);
  void ag_psp_220_uxsx_epveuxcx(int x_a, int zero);
  void ax_psp_220_uxbx_epveuxux(int x_a);
  void ac_psp_220_uxbx_epveuxux(int x_a, int channel);
  void ag_psp_220_uxbx_epveuxux(int x_a, int zero);
  void ax_psp_220_uxbx_epveuxcx(int x_a);
  void ac_psp_220_uxbx_epveuxcx(int x_a, int channel);
  void ag_psp_220_uxbx_epveuxcx(int x_a, int zero);
  void ax_psp_220_sxsx_epveuxsx(int x_a);
  void ac_psp_220_sxsx_epveuxsx(int x_a, int channel);
  void ag_psp_220_sxsx_epveuxsx(int x_a, int zero);
  void ax_psp_220_sxsx_epvesxcx(int x_a);
  void ac_psp_220_sxsx_epvesxcx(int x_a, int channel);
  void ag_psp_220_sxsx_epvesxcx(int x_a, int zero);
  void ax_psp_220_sxcx_epveuxcx(int x_a);
  void ac_psp_220_sxcx_epveuxcx(int x_a, int channel);
  void ag_psp_220_sxcx_epveuxcx(int x_a, int zero);
  void ax_psp_220_sxcx_epvecxcx(int x_a);
  void ac_psp_220_sxcx_epvecxcx(int x_a, int channel);
  void ag_psp_220_sxcx_epvecxcx(int x_a, int zero);
  void ax_psp_220_sxbx_epveuxsx(int x_a);
  void ac_psp_220_sxbx_epveuxsx(int x_a, int channel);
  void ag_psp_220_sxbx_epveuxsx(int x_a, int zero);
  void ax_psp_220_sxbx_epveuxbx(int x_a);
  void ac_psp_220_sxbx_epveuxbx(int x_a, int channel);
  void ag_psp_220_sxbx_epveuxbx(int x_a, int zero);
  void ax_psp_220_sxbx_epvesxcx(int x_a);
  void ac_psp_220_sxbx_epvesxcx(int x_a, int channel);
  void ag_psp_220_sxbx_epvesxcx(int x_a, int zero);
  void ax_psp_220_sxbx_epvecxbx(int x_a);
  void ac_psp_220_sxbx_epvecxbx(int x_a, int channel);
  void ag_psp_220_sxbx_epvecxbx(int x_a, int zero);
  void ax_psp_220_cxbx_epveuxcx(int x_a);
  void ac_psp_220_cxbx_epveuxcx(int x_a, int channel);
  void ag_psp_220_cxbx_epveuxcx(int x_a, int zero);
  void ax_psp_220_cxbx_epvecxcx(int x_a);
  void ac_psp_220_cxbx_epvecxcx(int x_a, int channel);
  void ag_psp_220_cxbx_epvecxcx(int x_a, int zero);
  void ax_psp_220_bxbx_epveuxbx(int x_a);
  void ac_psp_220_bxbx_epveuxbx(int x_a, int channel);
  void ag_psp_220_bxbx_epveuxbx(int x_a, int zero);
  void ax_psp_220_bxbx_epvecxbx(int x_a);
  void ac_psp_220_bxbx_epvecxbx(int x_a, int channel);
  void ag_psp_220_bxbx_epvecxbx(int x_a, int zero);

};
#endif
