#ifndef ppnenexa03_PHASESPACE_SET_HPP
#define ppnenexa03_PHASESPACE_SET_HPP

using namespace std;

class ppnenexa03_phasespace_set : public phasespace_set {
private:

public:
  ppnenexa03_phasespace_set(){}
  ~ppnenexa03_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_030_ddx_vevexa(int x_a);
  void ac_psp_030_ddx_vevexa(int x_a, int channel);
  void ag_psp_030_ddx_vevexa(int x_a, int zero);
  void ax_psp_030_uux_vevexa(int x_a);
  void ac_psp_030_uux_vevexa(int x_a, int channel);
  void ag_psp_030_uux_vevexa(int x_a, int zero);
  void ax_psp_030_bbx_vevexa(int x_a);
  void ac_psp_030_bbx_vevexa(int x_a, int channel);
  void ag_psp_030_bbx_vevexa(int x_a, int zero);
  void ax_psp_230_gg_vevexa(int x_a);
  void ac_psp_230_gg_vevexa(int x_a, int channel);
  void ag_psp_230_gg_vevexa(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_130_gd_vevexad(int x_a);
  void ac_psp_130_gd_vevexad(int x_a, int channel);
  void ag_psp_130_gd_vevexad(int x_a, int zero);
  void ax_psp_130_gu_vevexau(int x_a);
  void ac_psp_130_gu_vevexau(int x_a, int channel);
  void ag_psp_130_gu_vevexau(int x_a, int zero);
  void ax_psp_130_gb_vevexab(int x_a);
  void ac_psp_130_gb_vevexab(int x_a, int channel);
  void ag_psp_130_gb_vevexab(int x_a, int zero);
  void ax_psp_130_gdx_vevexadx(int x_a);
  void ac_psp_130_gdx_vevexadx(int x_a, int channel);
  void ag_psp_130_gdx_vevexadx(int x_a, int zero);
  void ax_psp_130_gux_vevexaux(int x_a);
  void ac_psp_130_gux_vevexaux(int x_a, int channel);
  void ag_psp_130_gux_vevexaux(int x_a, int zero);
  void ax_psp_130_gbx_vevexabx(int x_a);
  void ac_psp_130_gbx_vevexabx(int x_a, int channel);
  void ag_psp_130_gbx_vevexabx(int x_a, int zero);
  void ax_psp_130_ddx_vevexag(int x_a);
  void ac_psp_130_ddx_vevexag(int x_a, int channel);
  void ag_psp_130_ddx_vevexag(int x_a, int zero);
  void ax_psp_040_da_vevexad(int x_a);
  void ac_psp_040_da_vevexad(int x_a, int channel);
  void ag_psp_040_da_vevexad(int x_a, int zero);
  void ax_psp_130_uux_vevexag(int x_a);
  void ac_psp_130_uux_vevexag(int x_a, int channel);
  void ag_psp_130_uux_vevexag(int x_a, int zero);
  void ax_psp_040_ua_vevexau(int x_a);
  void ac_psp_040_ua_vevexau(int x_a, int channel);
  void ag_psp_040_ua_vevexau(int x_a, int zero);
  void ax_psp_130_bbx_vevexag(int x_a);
  void ac_psp_130_bbx_vevexag(int x_a, int channel);
  void ag_psp_130_bbx_vevexag(int x_a, int zero);
  void ax_psp_040_ba_vevexab(int x_a);
  void ac_psp_040_ba_vevexab(int x_a, int channel);
  void ag_psp_040_ba_vevexab(int x_a, int zero);
  void ax_psp_040_dxa_vevexadx(int x_a);
  void ac_psp_040_dxa_vevexadx(int x_a, int channel);
  void ag_psp_040_dxa_vevexadx(int x_a, int zero);
  void ax_psp_040_uxa_vevexaux(int x_a);
  void ac_psp_040_uxa_vevexaux(int x_a, int channel);
  void ag_psp_040_uxa_vevexaux(int x_a, int zero);
  void ax_psp_040_bxa_vevexabx(int x_a);
  void ac_psp_040_bxa_vevexabx(int x_a, int channel);
  void ag_psp_040_bxa_vevexabx(int x_a, int zero);
  void ax_psp_040_ddx_vevexaa(int x_a);
  void ac_psp_040_ddx_vevexaa(int x_a, int channel);
  void ag_psp_040_ddx_vevexaa(int x_a, int zero);
  void ax_psp_040_uux_vevexaa(int x_a);
  void ac_psp_040_uux_vevexaa(int x_a, int channel);
  void ag_psp_040_uux_vevexaa(int x_a, int zero);
  void ax_psp_040_bbx_vevexaa(int x_a);
  void ac_psp_040_bbx_vevexaa(int x_a, int channel);
  void ag_psp_040_bbx_vevexaa(int x_a, int zero);
  void ax_psp_330_gg_vevexag(int x_a);
  void ac_psp_330_gg_vevexag(int x_a, int channel);
  void ag_psp_330_gg_vevexag(int x_a, int zero);
  void ax_psp_330_gd_vevexad(int x_a);
  void ac_psp_330_gd_vevexad(int x_a, int channel);
  void ag_psp_330_gd_vevexad(int x_a, int zero);
  void ax_psp_330_gu_vevexau(int x_a);
  void ac_psp_330_gu_vevexau(int x_a, int channel);
  void ag_psp_330_gu_vevexau(int x_a, int zero);
  void ax_psp_330_gb_vevexab(int x_a);
  void ac_psp_330_gb_vevexab(int x_a, int channel);
  void ag_psp_330_gb_vevexab(int x_a, int zero);
  void ax_psp_330_gdx_vevexadx(int x_a);
  void ac_psp_330_gdx_vevexadx(int x_a, int channel);
  void ag_psp_330_gdx_vevexadx(int x_a, int zero);
  void ax_psp_330_gux_vevexaux(int x_a);
  void ac_psp_330_gux_vevexaux(int x_a, int channel);
  void ag_psp_330_gux_vevexaux(int x_a, int zero);
  void ax_psp_330_gbx_vevexabx(int x_a);
  void ac_psp_330_gbx_vevexabx(int x_a, int channel);
  void ag_psp_330_gbx_vevexabx(int x_a, int zero);
  void ax_psp_330_ddx_vevexag(int x_a);
  void ac_psp_330_ddx_vevexag(int x_a, int channel);
  void ag_psp_330_ddx_vevexag(int x_a, int zero);
  void ax_psp_330_uux_vevexag(int x_a);
  void ac_psp_330_uux_vevexag(int x_a, int channel);
  void ag_psp_330_uux_vevexag(int x_a, int zero);
  void ax_psp_330_bbx_vevexag(int x_a);
  void ac_psp_330_bbx_vevexag(int x_a, int channel);
  void ag_psp_330_bbx_vevexag(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_230_gg_vevexaddx(int x_a);
  void ac_psp_230_gg_vevexaddx(int x_a, int channel);
  void ag_psp_230_gg_vevexaddx(int x_a, int zero);
  void ax_psp_230_gg_vevexauux(int x_a);
  void ac_psp_230_gg_vevexauux(int x_a, int channel);
  void ag_psp_230_gg_vevexauux(int x_a, int zero);
  void ax_psp_230_gg_vevexabbx(int x_a);
  void ac_psp_230_gg_vevexabbx(int x_a, int channel);
  void ag_psp_230_gg_vevexabbx(int x_a, int zero);
  void ax_psp_230_gd_vevexagd(int x_a);
  void ac_psp_230_gd_vevexagd(int x_a, int channel);
  void ag_psp_230_gd_vevexagd(int x_a, int zero);
  void ax_psp_230_gu_vevexagu(int x_a);
  void ac_psp_230_gu_vevexagu(int x_a, int channel);
  void ag_psp_230_gu_vevexagu(int x_a, int zero);
  void ax_psp_230_gb_vevexagb(int x_a);
  void ac_psp_230_gb_vevexagb(int x_a, int channel);
  void ag_psp_230_gb_vevexagb(int x_a, int zero);
  void ax_psp_230_gdx_vevexagdx(int x_a);
  void ac_psp_230_gdx_vevexagdx(int x_a, int channel);
  void ag_psp_230_gdx_vevexagdx(int x_a, int zero);
  void ax_psp_230_gux_vevexagux(int x_a);
  void ac_psp_230_gux_vevexagux(int x_a, int channel);
  void ag_psp_230_gux_vevexagux(int x_a, int zero);
  void ax_psp_230_gbx_vevexagbx(int x_a);
  void ac_psp_230_gbx_vevexagbx(int x_a, int channel);
  void ag_psp_230_gbx_vevexagbx(int x_a, int zero);
  void ax_psp_230_dd_vevexadd(int x_a);
  void ac_psp_230_dd_vevexadd(int x_a, int channel);
  void ag_psp_230_dd_vevexadd(int x_a, int zero);
  void ax_psp_230_du_vevexadu(int x_a);
  void ac_psp_230_du_vevexadu(int x_a, int channel);
  void ag_psp_230_du_vevexadu(int x_a, int zero);
  void ax_psp_230_ds_vevexads(int x_a);
  void ac_psp_230_ds_vevexads(int x_a, int channel);
  void ag_psp_230_ds_vevexads(int x_a, int zero);
  void ax_psp_230_dc_vevexadc(int x_a);
  void ac_psp_230_dc_vevexadc(int x_a, int channel);
  void ag_psp_230_dc_vevexadc(int x_a, int zero);
  void ax_psp_230_db_vevexadb(int x_a);
  void ac_psp_230_db_vevexadb(int x_a, int channel);
  void ag_psp_230_db_vevexadb(int x_a, int zero);
  void ax_psp_230_ddx_vevexagg(int x_a);
  void ac_psp_230_ddx_vevexagg(int x_a, int channel);
  void ag_psp_230_ddx_vevexagg(int x_a, int zero);
  void ax_psp_230_ddx_vevexaddx(int x_a);
  void ac_psp_230_ddx_vevexaddx(int x_a, int channel);
  void ag_psp_230_ddx_vevexaddx(int x_a, int zero);
  void ax_psp_230_ddx_vevexauux(int x_a);
  void ac_psp_230_ddx_vevexauux(int x_a, int channel);
  void ag_psp_230_ddx_vevexauux(int x_a, int zero);
  void ax_psp_230_ddx_vevexassx(int x_a);
  void ac_psp_230_ddx_vevexassx(int x_a, int channel);
  void ag_psp_230_ddx_vevexassx(int x_a, int zero);
  void ax_psp_230_ddx_vevexaccx(int x_a);
  void ac_psp_230_ddx_vevexaccx(int x_a, int channel);
  void ag_psp_230_ddx_vevexaccx(int x_a, int zero);
  void ax_psp_230_ddx_vevexabbx(int x_a);
  void ac_psp_230_ddx_vevexabbx(int x_a, int channel);
  void ag_psp_230_ddx_vevexabbx(int x_a, int zero);
  void ax_psp_230_dux_vevexadux(int x_a);
  void ac_psp_230_dux_vevexadux(int x_a, int channel);
  void ag_psp_230_dux_vevexadux(int x_a, int zero);
  void ax_psp_230_dsx_vevexadsx(int x_a);
  void ac_psp_230_dsx_vevexadsx(int x_a, int channel);
  void ag_psp_230_dsx_vevexadsx(int x_a, int zero);
  void ax_psp_230_dcx_vevexadcx(int x_a);
  void ac_psp_230_dcx_vevexadcx(int x_a, int channel);
  void ag_psp_230_dcx_vevexadcx(int x_a, int zero);
  void ax_psp_230_dbx_vevexadbx(int x_a);
  void ac_psp_230_dbx_vevexadbx(int x_a, int channel);
  void ag_psp_230_dbx_vevexadbx(int x_a, int zero);
  void ax_psp_230_uu_vevexauu(int x_a);
  void ac_psp_230_uu_vevexauu(int x_a, int channel);
  void ag_psp_230_uu_vevexauu(int x_a, int zero);
  void ax_psp_230_uc_vevexauc(int x_a);
  void ac_psp_230_uc_vevexauc(int x_a, int channel);
  void ag_psp_230_uc_vevexauc(int x_a, int zero);
  void ax_psp_230_ub_vevexaub(int x_a);
  void ac_psp_230_ub_vevexaub(int x_a, int channel);
  void ag_psp_230_ub_vevexaub(int x_a, int zero);
  void ax_psp_230_udx_vevexaudx(int x_a);
  void ac_psp_230_udx_vevexaudx(int x_a, int channel);
  void ag_psp_230_udx_vevexaudx(int x_a, int zero);
  void ax_psp_230_uux_vevexagg(int x_a);
  void ac_psp_230_uux_vevexagg(int x_a, int channel);
  void ag_psp_230_uux_vevexagg(int x_a, int zero);
  void ax_psp_230_uux_vevexaddx(int x_a);
  void ac_psp_230_uux_vevexaddx(int x_a, int channel);
  void ag_psp_230_uux_vevexaddx(int x_a, int zero);
  void ax_psp_230_uux_vevexauux(int x_a);
  void ac_psp_230_uux_vevexauux(int x_a, int channel);
  void ag_psp_230_uux_vevexauux(int x_a, int zero);
  void ax_psp_230_uux_vevexassx(int x_a);
  void ac_psp_230_uux_vevexassx(int x_a, int channel);
  void ag_psp_230_uux_vevexassx(int x_a, int zero);
  void ax_psp_230_uux_vevexaccx(int x_a);
  void ac_psp_230_uux_vevexaccx(int x_a, int channel);
  void ag_psp_230_uux_vevexaccx(int x_a, int zero);
  void ax_psp_230_uux_vevexabbx(int x_a);
  void ac_psp_230_uux_vevexabbx(int x_a, int channel);
  void ag_psp_230_uux_vevexabbx(int x_a, int zero);
  void ax_psp_230_usx_vevexausx(int x_a);
  void ac_psp_230_usx_vevexausx(int x_a, int channel);
  void ag_psp_230_usx_vevexausx(int x_a, int zero);
  void ax_psp_230_ucx_vevexaucx(int x_a);
  void ac_psp_230_ucx_vevexaucx(int x_a, int channel);
  void ag_psp_230_ucx_vevexaucx(int x_a, int zero);
  void ax_psp_230_ubx_vevexaubx(int x_a);
  void ac_psp_230_ubx_vevexaubx(int x_a, int channel);
  void ag_psp_230_ubx_vevexaubx(int x_a, int zero);
  void ax_psp_230_bb_vevexabb(int x_a);
  void ac_psp_230_bb_vevexabb(int x_a, int channel);
  void ag_psp_230_bb_vevexabb(int x_a, int zero);
  void ax_psp_230_bdx_vevexabdx(int x_a);
  void ac_psp_230_bdx_vevexabdx(int x_a, int channel);
  void ag_psp_230_bdx_vevexabdx(int x_a, int zero);
  void ax_psp_230_bux_vevexabux(int x_a);
  void ac_psp_230_bux_vevexabux(int x_a, int channel);
  void ag_psp_230_bux_vevexabux(int x_a, int zero);
  void ax_psp_230_bbx_vevexagg(int x_a);
  void ac_psp_230_bbx_vevexagg(int x_a, int channel);
  void ag_psp_230_bbx_vevexagg(int x_a, int zero);
  void ax_psp_230_bbx_vevexaddx(int x_a);
  void ac_psp_230_bbx_vevexaddx(int x_a, int channel);
  void ag_psp_230_bbx_vevexaddx(int x_a, int zero);
  void ax_psp_230_bbx_vevexauux(int x_a);
  void ac_psp_230_bbx_vevexauux(int x_a, int channel);
  void ag_psp_230_bbx_vevexauux(int x_a, int zero);
  void ax_psp_230_bbx_vevexabbx(int x_a);
  void ac_psp_230_bbx_vevexabbx(int x_a, int channel);
  void ag_psp_230_bbx_vevexabbx(int x_a, int zero);
  void ax_psp_230_dxdx_vevexadxdx(int x_a);
  void ac_psp_230_dxdx_vevexadxdx(int x_a, int channel);
  void ag_psp_230_dxdx_vevexadxdx(int x_a, int zero);
  void ax_psp_230_dxux_vevexadxux(int x_a);
  void ac_psp_230_dxux_vevexadxux(int x_a, int channel);
  void ag_psp_230_dxux_vevexadxux(int x_a, int zero);
  void ax_psp_230_dxsx_vevexadxsx(int x_a);
  void ac_psp_230_dxsx_vevexadxsx(int x_a, int channel);
  void ag_psp_230_dxsx_vevexadxsx(int x_a, int zero);
  void ax_psp_230_dxcx_vevexadxcx(int x_a);
  void ac_psp_230_dxcx_vevexadxcx(int x_a, int channel);
  void ag_psp_230_dxcx_vevexadxcx(int x_a, int zero);
  void ax_psp_230_dxbx_vevexadxbx(int x_a);
  void ac_psp_230_dxbx_vevexadxbx(int x_a, int channel);
  void ag_psp_230_dxbx_vevexadxbx(int x_a, int zero);
  void ax_psp_230_uxux_vevexauxux(int x_a);
  void ac_psp_230_uxux_vevexauxux(int x_a, int channel);
  void ag_psp_230_uxux_vevexauxux(int x_a, int zero);
  void ax_psp_230_uxcx_vevexauxcx(int x_a);
  void ac_psp_230_uxcx_vevexauxcx(int x_a, int channel);
  void ag_psp_230_uxcx_vevexauxcx(int x_a, int zero);
  void ax_psp_230_uxbx_vevexauxbx(int x_a);
  void ac_psp_230_uxbx_vevexauxbx(int x_a, int channel);
  void ag_psp_230_uxbx_vevexauxbx(int x_a, int zero);
  void ax_psp_230_bxbx_vevexabxbx(int x_a);
  void ac_psp_230_bxbx_vevexabxbx(int x_a, int channel);
  void ag_psp_230_bxbx_vevexabxbx(int x_a, int zero);

};
#endif
