#ifndef ppwxw02_PHASESPACE_SET_HPP
#define ppwxw02_PHASESPACE_SET_HPP

using namespace std;

class ppwxw02_phasespace_set : public phasespace_set {
private:

public:
  ppwxw02_phasespace_set(){}
  ~ppwxw02_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_020_ddx_wpwm(int x_a);
  void ac_psp_020_ddx_wpwm(int x_a, int channel);
  void ag_psp_020_ddx_wpwm(int x_a, int zero);
  void ax_psp_020_uux_wpwm(int x_a);
  void ac_psp_020_uux_wpwm(int x_a, int channel);
  void ag_psp_020_uux_wpwm(int x_a, int zero);
  void ax_psp_020_bbx_wpwm(int x_a);
  void ac_psp_020_bbx_wpwm(int x_a, int channel);
  void ag_psp_020_bbx_wpwm(int x_a, int zero);
  void ax_psp_020_aa_wpwm(int x_a);
  void ac_psp_020_aa_wpwm(int x_a, int channel);
  void ag_psp_020_aa_wpwm(int x_a, int zero);
  void ax_psp_220_gg_wpwm(int x_a);
  void ac_psp_220_gg_wpwm(int x_a, int channel);
  void ag_psp_220_gg_wpwm(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_120_gd_wpwmd(int x_a);
  void ac_psp_120_gd_wpwmd(int x_a, int channel);
  void ag_psp_120_gd_wpwmd(int x_a, int zero);
  void ax_psp_120_gu_wpwmu(int x_a);
  void ac_psp_120_gu_wpwmu(int x_a, int channel);
  void ag_psp_120_gu_wpwmu(int x_a, int zero);
  void ax_psp_120_gb_wpwmb(int x_a);
  void ac_psp_120_gb_wpwmb(int x_a, int channel);
  void ag_psp_120_gb_wpwmb(int x_a, int zero);
  void ax_psp_120_gdx_wpwmdx(int x_a);
  void ac_psp_120_gdx_wpwmdx(int x_a, int channel);
  void ag_psp_120_gdx_wpwmdx(int x_a, int zero);
  void ax_psp_120_gux_wpwmux(int x_a);
  void ac_psp_120_gux_wpwmux(int x_a, int channel);
  void ag_psp_120_gux_wpwmux(int x_a, int zero);
  void ax_psp_120_gbx_wpwmbx(int x_a);
  void ac_psp_120_gbx_wpwmbx(int x_a, int channel);
  void ag_psp_120_gbx_wpwmbx(int x_a, int zero);
  void ax_psp_120_ddx_wpwmg(int x_a);
  void ac_psp_120_ddx_wpwmg(int x_a, int channel);
  void ag_psp_120_ddx_wpwmg(int x_a, int zero);
  void ax_psp_030_da_wpwmd(int x_a);
  void ac_psp_030_da_wpwmd(int x_a, int channel);
  void ag_psp_030_da_wpwmd(int x_a, int zero);
  void ax_psp_120_uux_wpwmg(int x_a);
  void ac_psp_120_uux_wpwmg(int x_a, int channel);
  void ag_psp_120_uux_wpwmg(int x_a, int zero);
  void ax_psp_030_ua_wpwmu(int x_a);
  void ac_psp_030_ua_wpwmu(int x_a, int channel);
  void ag_psp_030_ua_wpwmu(int x_a, int zero);
  void ax_psp_120_bbx_wpwmg(int x_a);
  void ac_psp_120_bbx_wpwmg(int x_a, int channel);
  void ag_psp_120_bbx_wpwmg(int x_a, int zero);
  void ax_psp_030_ba_wpwmb(int x_a);
  void ac_psp_030_ba_wpwmb(int x_a, int channel);
  void ag_psp_030_ba_wpwmb(int x_a, int zero);
  void ax_psp_030_dxa_wpwmdx(int x_a);
  void ac_psp_030_dxa_wpwmdx(int x_a, int channel);
  void ag_psp_030_dxa_wpwmdx(int x_a, int zero);
  void ax_psp_030_uxa_wpwmux(int x_a);
  void ac_psp_030_uxa_wpwmux(int x_a, int channel);
  void ag_psp_030_uxa_wpwmux(int x_a, int zero);
  void ax_psp_030_bxa_wpwmbx(int x_a);
  void ac_psp_030_bxa_wpwmbx(int x_a, int channel);
  void ag_psp_030_bxa_wpwmbx(int x_a, int zero);
  void ax_psp_030_ddx_wpwma(int x_a);
  void ac_psp_030_ddx_wpwma(int x_a, int channel);
  void ag_psp_030_ddx_wpwma(int x_a, int zero);
  void ax_psp_030_uux_wpwma(int x_a);
  void ac_psp_030_uux_wpwma(int x_a, int channel);
  void ag_psp_030_uux_wpwma(int x_a, int zero);
  void ax_psp_030_bbx_wpwma(int x_a);
  void ac_psp_030_bbx_wpwma(int x_a, int channel);
  void ag_psp_030_bbx_wpwma(int x_a, int zero);
  void ax_psp_030_aa_wpwma(int x_a);
  void ac_psp_030_aa_wpwma(int x_a, int channel);
  void ag_psp_030_aa_wpwma(int x_a, int zero);
  void ax_psp_320_gg_wpwmg(int x_a);
  void ac_psp_320_gg_wpwmg(int x_a, int channel);
  void ag_psp_320_gg_wpwmg(int x_a, int zero);
  void ax_psp_320_gd_wpwmd(int x_a);
  void ac_psp_320_gd_wpwmd(int x_a, int channel);
  void ag_psp_320_gd_wpwmd(int x_a, int zero);
  void ax_psp_320_gu_wpwmu(int x_a);
  void ac_psp_320_gu_wpwmu(int x_a, int channel);
  void ag_psp_320_gu_wpwmu(int x_a, int zero);
  void ax_psp_320_gb_wpwmb(int x_a);
  void ac_psp_320_gb_wpwmb(int x_a, int channel);
  void ag_psp_320_gb_wpwmb(int x_a, int zero);
  void ax_psp_320_gdx_wpwmdx(int x_a);
  void ac_psp_320_gdx_wpwmdx(int x_a, int channel);
  void ag_psp_320_gdx_wpwmdx(int x_a, int zero);
  void ax_psp_320_gux_wpwmux(int x_a);
  void ac_psp_320_gux_wpwmux(int x_a, int channel);
  void ag_psp_320_gux_wpwmux(int x_a, int zero);
  void ax_psp_320_gbx_wpwmbx(int x_a);
  void ac_psp_320_gbx_wpwmbx(int x_a, int channel);
  void ag_psp_320_gbx_wpwmbx(int x_a, int zero);
  void ax_psp_320_ddx_wpwmg(int x_a);
  void ac_psp_320_ddx_wpwmg(int x_a, int channel);
  void ag_psp_320_ddx_wpwmg(int x_a, int zero);
  void ax_psp_320_uux_wpwmg(int x_a);
  void ac_psp_320_uux_wpwmg(int x_a, int channel);
  void ag_psp_320_uux_wpwmg(int x_a, int zero);
  void ax_psp_320_bbx_wpwmg(int x_a);
  void ac_psp_320_bbx_wpwmg(int x_a, int channel);
  void ag_psp_320_bbx_wpwmg(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_220_gg_wpwmddx(int x_a);
  void ac_psp_220_gg_wpwmddx(int x_a, int channel);
  void ag_psp_220_gg_wpwmddx(int x_a, int zero);
  void ax_psp_220_gg_wpwmuux(int x_a);
  void ac_psp_220_gg_wpwmuux(int x_a, int channel);
  void ag_psp_220_gg_wpwmuux(int x_a, int zero);
  void ax_psp_220_gg_wpwmbbx(int x_a);
  void ac_psp_220_gg_wpwmbbx(int x_a, int channel);
  void ag_psp_220_gg_wpwmbbx(int x_a, int zero);
  void ax_psp_220_gd_wpwmgd(int x_a);
  void ac_psp_220_gd_wpwmgd(int x_a, int channel);
  void ag_psp_220_gd_wpwmgd(int x_a, int zero);
  void ax_psp_220_gu_wpwmgu(int x_a);
  void ac_psp_220_gu_wpwmgu(int x_a, int channel);
  void ag_psp_220_gu_wpwmgu(int x_a, int zero);
  void ax_psp_220_gb_wpwmgb(int x_a);
  void ac_psp_220_gb_wpwmgb(int x_a, int channel);
  void ag_psp_220_gb_wpwmgb(int x_a, int zero);
  void ax_psp_220_gdx_wpwmgdx(int x_a);
  void ac_psp_220_gdx_wpwmgdx(int x_a, int channel);
  void ag_psp_220_gdx_wpwmgdx(int x_a, int zero);
  void ax_psp_220_gux_wpwmgux(int x_a);
  void ac_psp_220_gux_wpwmgux(int x_a, int channel);
  void ag_psp_220_gux_wpwmgux(int x_a, int zero);
  void ax_psp_220_gbx_wpwmgbx(int x_a);
  void ac_psp_220_gbx_wpwmgbx(int x_a, int channel);
  void ag_psp_220_gbx_wpwmgbx(int x_a, int zero);
  void ax_psp_220_dd_wpwmdd(int x_a);
  void ac_psp_220_dd_wpwmdd(int x_a, int channel);
  void ag_psp_220_dd_wpwmdd(int x_a, int zero);
  void ax_psp_220_du_wpwmdu(int x_a);
  void ac_psp_220_du_wpwmdu(int x_a, int channel);
  void ag_psp_220_du_wpwmdu(int x_a, int zero);
  void ax_psp_220_ds_wpwmds(int x_a);
  void ac_psp_220_ds_wpwmds(int x_a, int channel);
  void ag_psp_220_ds_wpwmds(int x_a, int zero);
  void ax_psp_220_dc_wpwmdc(int x_a);
  void ac_psp_220_dc_wpwmdc(int x_a, int channel);
  void ag_psp_220_dc_wpwmdc(int x_a, int zero);
  void ax_psp_220_dc_wpwmus(int x_a);
  void ac_psp_220_dc_wpwmus(int x_a, int channel);
  void ag_psp_220_dc_wpwmus(int x_a, int zero);
  void ax_psp_220_db_wpwmdb(int x_a);
  void ac_psp_220_db_wpwmdb(int x_a, int channel);
  void ag_psp_220_db_wpwmdb(int x_a, int zero);
  void ax_psp_220_ddx_wpwmgg(int x_a);
  void ac_psp_220_ddx_wpwmgg(int x_a, int channel);
  void ag_psp_220_ddx_wpwmgg(int x_a, int zero);
  void ax_psp_220_ddx_wpwmddx(int x_a);
  void ac_psp_220_ddx_wpwmddx(int x_a, int channel);
  void ag_psp_220_ddx_wpwmddx(int x_a, int zero);
  void ax_psp_220_ddx_wpwmuux(int x_a);
  void ac_psp_220_ddx_wpwmuux(int x_a, int channel);
  void ag_psp_220_ddx_wpwmuux(int x_a, int zero);
  void ax_psp_220_ddx_wpwmssx(int x_a);
  void ac_psp_220_ddx_wpwmssx(int x_a, int channel);
  void ag_psp_220_ddx_wpwmssx(int x_a, int zero);
  void ax_psp_220_ddx_wpwmccx(int x_a);
  void ac_psp_220_ddx_wpwmccx(int x_a, int channel);
  void ag_psp_220_ddx_wpwmccx(int x_a, int zero);
  void ax_psp_220_ddx_wpwmbbx(int x_a);
  void ac_psp_220_ddx_wpwmbbx(int x_a, int channel);
  void ag_psp_220_ddx_wpwmbbx(int x_a, int zero);
  void ax_psp_220_dux_wpwmdux(int x_a);
  void ac_psp_220_dux_wpwmdux(int x_a, int channel);
  void ag_psp_220_dux_wpwmdux(int x_a, int zero);
  void ax_psp_220_dux_wpwmscx(int x_a);
  void ac_psp_220_dux_wpwmscx(int x_a, int channel);
  void ag_psp_220_dux_wpwmscx(int x_a, int zero);
  void ax_psp_220_dsx_wpwmdsx(int x_a);
  void ac_psp_220_dsx_wpwmdsx(int x_a, int channel);
  void ag_psp_220_dsx_wpwmdsx(int x_a, int zero);
  void ax_psp_220_dsx_wpwmucx(int x_a);
  void ac_psp_220_dsx_wpwmucx(int x_a, int channel);
  void ag_psp_220_dsx_wpwmucx(int x_a, int zero);
  void ax_psp_220_dcx_wpwmdcx(int x_a);
  void ac_psp_220_dcx_wpwmdcx(int x_a, int channel);
  void ag_psp_220_dcx_wpwmdcx(int x_a, int zero);
  void ax_psp_220_dbx_wpwmdbx(int x_a);
  void ac_psp_220_dbx_wpwmdbx(int x_a, int channel);
  void ag_psp_220_dbx_wpwmdbx(int x_a, int zero);
  void ax_psp_220_uu_wpwmuu(int x_a);
  void ac_psp_220_uu_wpwmuu(int x_a, int channel);
  void ag_psp_220_uu_wpwmuu(int x_a, int zero);
  void ax_psp_220_uc_wpwmuc(int x_a);
  void ac_psp_220_uc_wpwmuc(int x_a, int channel);
  void ag_psp_220_uc_wpwmuc(int x_a, int zero);
  void ax_psp_220_ub_wpwmub(int x_a);
  void ac_psp_220_ub_wpwmub(int x_a, int channel);
  void ag_psp_220_ub_wpwmub(int x_a, int zero);
  void ax_psp_220_udx_wpwmudx(int x_a);
  void ac_psp_220_udx_wpwmudx(int x_a, int channel);
  void ag_psp_220_udx_wpwmudx(int x_a, int zero);
  void ax_psp_220_udx_wpwmcsx(int x_a);
  void ac_psp_220_udx_wpwmcsx(int x_a, int channel);
  void ag_psp_220_udx_wpwmcsx(int x_a, int zero);
  void ax_psp_220_uux_wpwmgg(int x_a);
  void ac_psp_220_uux_wpwmgg(int x_a, int channel);
  void ag_psp_220_uux_wpwmgg(int x_a, int zero);
  void ax_psp_220_uux_wpwmddx(int x_a);
  void ac_psp_220_uux_wpwmddx(int x_a, int channel);
  void ag_psp_220_uux_wpwmddx(int x_a, int zero);
  void ax_psp_220_uux_wpwmuux(int x_a);
  void ac_psp_220_uux_wpwmuux(int x_a, int channel);
  void ag_psp_220_uux_wpwmuux(int x_a, int zero);
  void ax_psp_220_uux_wpwmssx(int x_a);
  void ac_psp_220_uux_wpwmssx(int x_a, int channel);
  void ag_psp_220_uux_wpwmssx(int x_a, int zero);
  void ax_psp_220_uux_wpwmccx(int x_a);
  void ac_psp_220_uux_wpwmccx(int x_a, int channel);
  void ag_psp_220_uux_wpwmccx(int x_a, int zero);
  void ax_psp_220_uux_wpwmbbx(int x_a);
  void ac_psp_220_uux_wpwmbbx(int x_a, int channel);
  void ag_psp_220_uux_wpwmbbx(int x_a, int zero);
  void ax_psp_220_usx_wpwmusx(int x_a);
  void ac_psp_220_usx_wpwmusx(int x_a, int channel);
  void ag_psp_220_usx_wpwmusx(int x_a, int zero);
  void ax_psp_220_ucx_wpwmdsx(int x_a);
  void ac_psp_220_ucx_wpwmdsx(int x_a, int channel);
  void ag_psp_220_ucx_wpwmdsx(int x_a, int zero);
  void ax_psp_220_ucx_wpwmucx(int x_a);
  void ac_psp_220_ucx_wpwmucx(int x_a, int channel);
  void ag_psp_220_ucx_wpwmucx(int x_a, int zero);
  void ax_psp_220_ubx_wpwmubx(int x_a);
  void ac_psp_220_ubx_wpwmubx(int x_a, int channel);
  void ag_psp_220_ubx_wpwmubx(int x_a, int zero);
  void ax_psp_220_bb_wpwmbb(int x_a);
  void ac_psp_220_bb_wpwmbb(int x_a, int channel);
  void ag_psp_220_bb_wpwmbb(int x_a, int zero);
  void ax_psp_220_bdx_wpwmbdx(int x_a);
  void ac_psp_220_bdx_wpwmbdx(int x_a, int channel);
  void ag_psp_220_bdx_wpwmbdx(int x_a, int zero);
  void ax_psp_220_bux_wpwmbux(int x_a);
  void ac_psp_220_bux_wpwmbux(int x_a, int channel);
  void ag_psp_220_bux_wpwmbux(int x_a, int zero);
  void ax_psp_220_bbx_wpwmgg(int x_a);
  void ac_psp_220_bbx_wpwmgg(int x_a, int channel);
  void ag_psp_220_bbx_wpwmgg(int x_a, int zero);
  void ax_psp_220_bbx_wpwmddx(int x_a);
  void ac_psp_220_bbx_wpwmddx(int x_a, int channel);
  void ag_psp_220_bbx_wpwmddx(int x_a, int zero);
  void ax_psp_220_bbx_wpwmuux(int x_a);
  void ac_psp_220_bbx_wpwmuux(int x_a, int channel);
  void ag_psp_220_bbx_wpwmuux(int x_a, int zero);
  void ax_psp_220_bbx_wpwmbbx(int x_a);
  void ac_psp_220_bbx_wpwmbbx(int x_a, int channel);
  void ag_psp_220_bbx_wpwmbbx(int x_a, int zero);
  void ax_psp_220_dxdx_wpwmdxdx(int x_a);
  void ac_psp_220_dxdx_wpwmdxdx(int x_a, int channel);
  void ag_psp_220_dxdx_wpwmdxdx(int x_a, int zero);
  void ax_psp_220_dxux_wpwmdxux(int x_a);
  void ac_psp_220_dxux_wpwmdxux(int x_a, int channel);
  void ag_psp_220_dxux_wpwmdxux(int x_a, int zero);
  void ax_psp_220_dxsx_wpwmdxsx(int x_a);
  void ac_psp_220_dxsx_wpwmdxsx(int x_a, int channel);
  void ag_psp_220_dxsx_wpwmdxsx(int x_a, int zero);
  void ax_psp_220_dxcx_wpwmdxcx(int x_a);
  void ac_psp_220_dxcx_wpwmdxcx(int x_a, int channel);
  void ag_psp_220_dxcx_wpwmdxcx(int x_a, int zero);
  void ax_psp_220_dxcx_wpwmuxsx(int x_a);
  void ac_psp_220_dxcx_wpwmuxsx(int x_a, int channel);
  void ag_psp_220_dxcx_wpwmuxsx(int x_a, int zero);
  void ax_psp_220_dxbx_wpwmdxbx(int x_a);
  void ac_psp_220_dxbx_wpwmdxbx(int x_a, int channel);
  void ag_psp_220_dxbx_wpwmdxbx(int x_a, int zero);
  void ax_psp_220_uxux_wpwmuxux(int x_a);
  void ac_psp_220_uxux_wpwmuxux(int x_a, int channel);
  void ag_psp_220_uxux_wpwmuxux(int x_a, int zero);
  void ax_psp_220_uxcx_wpwmuxcx(int x_a);
  void ac_psp_220_uxcx_wpwmuxcx(int x_a, int channel);
  void ag_psp_220_uxcx_wpwmuxcx(int x_a, int zero);
  void ax_psp_220_uxbx_wpwmuxbx(int x_a);
  void ac_psp_220_uxbx_wpwmuxbx(int x_a, int channel);
  void ag_psp_220_uxbx_wpwmuxbx(int x_a, int zero);
  void ax_psp_220_bxbx_wpwmbxbx(int x_a);
  void ac_psp_220_bxbx_wpwmbxbx(int x_a, int channel);
  void ag_psp_220_bxbx_wpwmbxbx(int x_a, int zero);

};
#endif
