#ifndef ppz01_PHASESPACE_SET_HPP
#define ppz01_PHASESPACE_SET_HPP

using namespace std;

class ppz01_phasespace_set : public phasespace_set {
private:

public:
  ppz01_phasespace_set(){}
  ~ppz01_phasespace_set();

  void optimize_minv_born();
  int determination_MCchannels_born(int x_a);
  void ac_tau_psp_born(int x_a, vector<int> & tau_MC_map);
  void ax_psp_born(int x_a);
  void ac_psp_born(int x_a, int channel);
  void ag_psp_born(int x_a, int zero);
  void ax_psp_010_ddx_z(int x_a);
  void ac_psp_010_ddx_z(int x_a, int channel);
  void ag_psp_010_ddx_z(int x_a, int zero);
  void ax_psp_010_uux_z(int x_a);
  void ac_psp_010_uux_z(int x_a, int channel);
  void ag_psp_010_uux_z(int x_a, int zero);
  void ax_psp_010_bbx_z(int x_a);
  void ac_psp_010_bbx_z(int x_a, int channel);
  void ag_psp_010_bbx_z(int x_a, int zero);
  void ax_psp_210_gg_z(int x_a);
  void ac_psp_210_gg_z(int x_a, int channel);
  void ag_psp_210_gg_z(int x_a, int zero);

  void optimize_minv_real();
  int determination_MCchannels_real(int x_a);
  void ac_tau_psp_real(int x_a, vector<int> & tau_MC_map);
  void ax_psp_real(int x_a);
  void ac_psp_real(int x_a, int channel);
  void ag_psp_real(int x_a, int zero);
  void ax_psp_110_gd_zd(int x_a);
  void ac_psp_110_gd_zd(int x_a, int channel);
  void ag_psp_110_gd_zd(int x_a, int zero);
  void ax_psp_110_gu_zu(int x_a);
  void ac_psp_110_gu_zu(int x_a, int channel);
  void ag_psp_110_gu_zu(int x_a, int zero);
  void ax_psp_110_gb_zb(int x_a);
  void ac_psp_110_gb_zb(int x_a, int channel);
  void ag_psp_110_gb_zb(int x_a, int zero);
  void ax_psp_110_gdx_zdx(int x_a);
  void ac_psp_110_gdx_zdx(int x_a, int channel);
  void ag_psp_110_gdx_zdx(int x_a, int zero);
  void ax_psp_110_gux_zux(int x_a);
  void ac_psp_110_gux_zux(int x_a, int channel);
  void ag_psp_110_gux_zux(int x_a, int zero);
  void ax_psp_110_gbx_zbx(int x_a);
  void ac_psp_110_gbx_zbx(int x_a, int channel);
  void ag_psp_110_gbx_zbx(int x_a, int zero);
  void ax_psp_110_ddx_zg(int x_a);
  void ac_psp_110_ddx_zg(int x_a, int channel);
  void ag_psp_110_ddx_zg(int x_a, int zero);
  void ax_psp_020_da_zd(int x_a);
  void ac_psp_020_da_zd(int x_a, int channel);
  void ag_psp_020_da_zd(int x_a, int zero);
  void ax_psp_110_uux_zg(int x_a);
  void ac_psp_110_uux_zg(int x_a, int channel);
  void ag_psp_110_uux_zg(int x_a, int zero);
  void ax_psp_020_ua_zu(int x_a);
  void ac_psp_020_ua_zu(int x_a, int channel);
  void ag_psp_020_ua_zu(int x_a, int zero);
  void ax_psp_110_bbx_zg(int x_a);
  void ac_psp_110_bbx_zg(int x_a, int channel);
  void ag_psp_110_bbx_zg(int x_a, int zero);
  void ax_psp_020_ba_zb(int x_a);
  void ac_psp_020_ba_zb(int x_a, int channel);
  void ag_psp_020_ba_zb(int x_a, int zero);
  void ax_psp_020_dxa_zdx(int x_a);
  void ac_psp_020_dxa_zdx(int x_a, int channel);
  void ag_psp_020_dxa_zdx(int x_a, int zero);
  void ax_psp_020_uxa_zux(int x_a);
  void ac_psp_020_uxa_zux(int x_a, int channel);
  void ag_psp_020_uxa_zux(int x_a, int zero);
  void ax_psp_020_bxa_zbx(int x_a);
  void ac_psp_020_bxa_zbx(int x_a, int channel);
  void ag_psp_020_bxa_zbx(int x_a, int zero);
  void ax_psp_020_ddx_za(int x_a);
  void ac_psp_020_ddx_za(int x_a, int channel);
  void ag_psp_020_ddx_za(int x_a, int zero);
  void ax_psp_020_uux_za(int x_a);
  void ac_psp_020_uux_za(int x_a, int channel);
  void ag_psp_020_uux_za(int x_a, int zero);
  void ax_psp_020_bbx_za(int x_a);
  void ac_psp_020_bbx_za(int x_a, int channel);
  void ag_psp_020_bbx_za(int x_a, int zero);
  void ax_psp_310_gg_zg(int x_a);
  void ac_psp_310_gg_zg(int x_a, int channel);
  void ag_psp_310_gg_zg(int x_a, int zero);
  void ax_psp_310_gd_zd(int x_a);
  void ac_psp_310_gd_zd(int x_a, int channel);
  void ag_psp_310_gd_zd(int x_a, int zero);
  void ax_psp_310_gu_zu(int x_a);
  void ac_psp_310_gu_zu(int x_a, int channel);
  void ag_psp_310_gu_zu(int x_a, int zero);
  void ax_psp_310_gb_zb(int x_a);
  void ac_psp_310_gb_zb(int x_a, int channel);
  void ag_psp_310_gb_zb(int x_a, int zero);
  void ax_psp_310_gdx_zdx(int x_a);
  void ac_psp_310_gdx_zdx(int x_a, int channel);
  void ag_psp_310_gdx_zdx(int x_a, int zero);
  void ax_psp_310_gux_zux(int x_a);
  void ac_psp_310_gux_zux(int x_a, int channel);
  void ag_psp_310_gux_zux(int x_a, int zero);
  void ax_psp_310_gbx_zbx(int x_a);
  void ac_psp_310_gbx_zbx(int x_a, int channel);
  void ag_psp_310_gbx_zbx(int x_a, int zero);
  void ax_psp_310_ddx_zg(int x_a);
  void ac_psp_310_ddx_zg(int x_a, int channel);
  void ag_psp_310_ddx_zg(int x_a, int zero);
  void ax_psp_310_uux_zg(int x_a);
  void ac_psp_310_uux_zg(int x_a, int channel);
  void ag_psp_310_uux_zg(int x_a, int zero);
  void ax_psp_310_bbx_zg(int x_a);
  void ac_psp_310_bbx_zg(int x_a, int channel);
  void ag_psp_310_bbx_zg(int x_a, int zero);

  void optimize_minv_doublereal();
  int determination_MCchannels_doublereal(int x_a);
  void ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map);
  void ax_psp_doublereal(int x_a);
  void ac_psp_doublereal(int x_a, int channel);
  void ag_psp_doublereal(int x_a, int zero);
  void ax_psp_210_gg_zddx(int x_a);
  void ac_psp_210_gg_zddx(int x_a, int channel);
  void ag_psp_210_gg_zddx(int x_a, int zero);
  void ax_psp_210_gg_zuux(int x_a);
  void ac_psp_210_gg_zuux(int x_a, int channel);
  void ag_psp_210_gg_zuux(int x_a, int zero);
  void ax_psp_210_gg_zbbx(int x_a);
  void ac_psp_210_gg_zbbx(int x_a, int channel);
  void ag_psp_210_gg_zbbx(int x_a, int zero);
  void ax_psp_210_gd_zgd(int x_a);
  void ac_psp_210_gd_zgd(int x_a, int channel);
  void ag_psp_210_gd_zgd(int x_a, int zero);
  void ax_psp_210_gu_zgu(int x_a);
  void ac_psp_210_gu_zgu(int x_a, int channel);
  void ag_psp_210_gu_zgu(int x_a, int zero);
  void ax_psp_210_gb_zgb(int x_a);
  void ac_psp_210_gb_zgb(int x_a, int channel);
  void ag_psp_210_gb_zgb(int x_a, int zero);
  void ax_psp_210_gdx_zgdx(int x_a);
  void ac_psp_210_gdx_zgdx(int x_a, int channel);
  void ag_psp_210_gdx_zgdx(int x_a, int zero);
  void ax_psp_210_gux_zgux(int x_a);
  void ac_psp_210_gux_zgux(int x_a, int channel);
  void ag_psp_210_gux_zgux(int x_a, int zero);
  void ax_psp_210_gbx_zgbx(int x_a);
  void ac_psp_210_gbx_zgbx(int x_a, int channel);
  void ag_psp_210_gbx_zgbx(int x_a, int zero);
  void ax_psp_210_dd_zdd(int x_a);
  void ac_psp_210_dd_zdd(int x_a, int channel);
  void ag_psp_210_dd_zdd(int x_a, int zero);
  void ax_psp_210_du_zdu(int x_a);
  void ac_psp_210_du_zdu(int x_a, int channel);
  void ag_psp_210_du_zdu(int x_a, int zero);
  void ax_psp_210_ds_zds(int x_a);
  void ac_psp_210_ds_zds(int x_a, int channel);
  void ag_psp_210_ds_zds(int x_a, int zero);
  void ax_psp_210_dc_zdc(int x_a);
  void ac_psp_210_dc_zdc(int x_a, int channel);
  void ag_psp_210_dc_zdc(int x_a, int zero);
  void ax_psp_210_db_zdb(int x_a);
  void ac_psp_210_db_zdb(int x_a, int channel);
  void ag_psp_210_db_zdb(int x_a, int zero);
  void ax_psp_210_ddx_zgg(int x_a);
  void ac_psp_210_ddx_zgg(int x_a, int channel);
  void ag_psp_210_ddx_zgg(int x_a, int zero);
  void ax_psp_210_ddx_zddx(int x_a);
  void ac_psp_210_ddx_zddx(int x_a, int channel);
  void ag_psp_210_ddx_zddx(int x_a, int zero);
  void ax_psp_210_ddx_zuux(int x_a);
  void ac_psp_210_ddx_zuux(int x_a, int channel);
  void ag_psp_210_ddx_zuux(int x_a, int zero);
  void ax_psp_210_ddx_zssx(int x_a);
  void ac_psp_210_ddx_zssx(int x_a, int channel);
  void ag_psp_210_ddx_zssx(int x_a, int zero);
  void ax_psp_210_ddx_zccx(int x_a);
  void ac_psp_210_ddx_zccx(int x_a, int channel);
  void ag_psp_210_ddx_zccx(int x_a, int zero);
  void ax_psp_210_ddx_zbbx(int x_a);
  void ac_psp_210_ddx_zbbx(int x_a, int channel);
  void ag_psp_210_ddx_zbbx(int x_a, int zero);
  void ax_psp_210_dux_zdux(int x_a);
  void ac_psp_210_dux_zdux(int x_a, int channel);
  void ag_psp_210_dux_zdux(int x_a, int zero);
  void ax_psp_210_dsx_zdsx(int x_a);
  void ac_psp_210_dsx_zdsx(int x_a, int channel);
  void ag_psp_210_dsx_zdsx(int x_a, int zero);
  void ax_psp_210_dcx_zdcx(int x_a);
  void ac_psp_210_dcx_zdcx(int x_a, int channel);
  void ag_psp_210_dcx_zdcx(int x_a, int zero);
  void ax_psp_210_dbx_zdbx(int x_a);
  void ac_psp_210_dbx_zdbx(int x_a, int channel);
  void ag_psp_210_dbx_zdbx(int x_a, int zero);
  void ax_psp_210_uu_zuu(int x_a);
  void ac_psp_210_uu_zuu(int x_a, int channel);
  void ag_psp_210_uu_zuu(int x_a, int zero);
  void ax_psp_210_uc_zuc(int x_a);
  void ac_psp_210_uc_zuc(int x_a, int channel);
  void ag_psp_210_uc_zuc(int x_a, int zero);
  void ax_psp_210_ub_zub(int x_a);
  void ac_psp_210_ub_zub(int x_a, int channel);
  void ag_psp_210_ub_zub(int x_a, int zero);
  void ax_psp_210_udx_zudx(int x_a);
  void ac_psp_210_udx_zudx(int x_a, int channel);
  void ag_psp_210_udx_zudx(int x_a, int zero);
  void ax_psp_210_uux_zgg(int x_a);
  void ac_psp_210_uux_zgg(int x_a, int channel);
  void ag_psp_210_uux_zgg(int x_a, int zero);
  void ax_psp_210_uux_zddx(int x_a);
  void ac_psp_210_uux_zddx(int x_a, int channel);
  void ag_psp_210_uux_zddx(int x_a, int zero);
  void ax_psp_210_uux_zuux(int x_a);
  void ac_psp_210_uux_zuux(int x_a, int channel);
  void ag_psp_210_uux_zuux(int x_a, int zero);
  void ax_psp_210_uux_zssx(int x_a);
  void ac_psp_210_uux_zssx(int x_a, int channel);
  void ag_psp_210_uux_zssx(int x_a, int zero);
  void ax_psp_210_uux_zccx(int x_a);
  void ac_psp_210_uux_zccx(int x_a, int channel);
  void ag_psp_210_uux_zccx(int x_a, int zero);
  void ax_psp_210_uux_zbbx(int x_a);
  void ac_psp_210_uux_zbbx(int x_a, int channel);
  void ag_psp_210_uux_zbbx(int x_a, int zero);
  void ax_psp_210_usx_zusx(int x_a);
  void ac_psp_210_usx_zusx(int x_a, int channel);
  void ag_psp_210_usx_zusx(int x_a, int zero);
  void ax_psp_210_ucx_zucx(int x_a);
  void ac_psp_210_ucx_zucx(int x_a, int channel);
  void ag_psp_210_ucx_zucx(int x_a, int zero);
  void ax_psp_210_ubx_zubx(int x_a);
  void ac_psp_210_ubx_zubx(int x_a, int channel);
  void ag_psp_210_ubx_zubx(int x_a, int zero);
  void ax_psp_210_bb_zbb(int x_a);
  void ac_psp_210_bb_zbb(int x_a, int channel);
  void ag_psp_210_bb_zbb(int x_a, int zero);
  void ax_psp_210_bdx_zbdx(int x_a);
  void ac_psp_210_bdx_zbdx(int x_a, int channel);
  void ag_psp_210_bdx_zbdx(int x_a, int zero);
  void ax_psp_210_bux_zbux(int x_a);
  void ac_psp_210_bux_zbux(int x_a, int channel);
  void ag_psp_210_bux_zbux(int x_a, int zero);
  void ax_psp_210_bbx_zgg(int x_a);
  void ac_psp_210_bbx_zgg(int x_a, int channel);
  void ag_psp_210_bbx_zgg(int x_a, int zero);
  void ax_psp_210_bbx_zddx(int x_a);
  void ac_psp_210_bbx_zddx(int x_a, int channel);
  void ag_psp_210_bbx_zddx(int x_a, int zero);
  void ax_psp_210_bbx_zuux(int x_a);
  void ac_psp_210_bbx_zuux(int x_a, int channel);
  void ag_psp_210_bbx_zuux(int x_a, int zero);
  void ax_psp_210_bbx_zbbx(int x_a);
  void ac_psp_210_bbx_zbbx(int x_a, int channel);
  void ag_psp_210_bbx_zbbx(int x_a, int zero);
  void ax_psp_210_dxdx_zdxdx(int x_a);
  void ac_psp_210_dxdx_zdxdx(int x_a, int channel);
  void ag_psp_210_dxdx_zdxdx(int x_a, int zero);
  void ax_psp_210_dxux_zdxux(int x_a);
  void ac_psp_210_dxux_zdxux(int x_a, int channel);
  void ag_psp_210_dxux_zdxux(int x_a, int zero);
  void ax_psp_210_dxsx_zdxsx(int x_a);
  void ac_psp_210_dxsx_zdxsx(int x_a, int channel);
  void ag_psp_210_dxsx_zdxsx(int x_a, int zero);
  void ax_psp_210_dxcx_zdxcx(int x_a);
  void ac_psp_210_dxcx_zdxcx(int x_a, int channel);
  void ag_psp_210_dxcx_zdxcx(int x_a, int zero);
  void ax_psp_210_dxbx_zdxbx(int x_a);
  void ac_psp_210_dxbx_zdxbx(int x_a, int channel);
  void ag_psp_210_dxbx_zdxbx(int x_a, int zero);
  void ax_psp_210_uxux_zuxux(int x_a);
  void ac_psp_210_uxux_zuxux(int x_a, int channel);
  void ag_psp_210_uxux_zuxux(int x_a, int zero);
  void ax_psp_210_uxcx_zuxcx(int x_a);
  void ac_psp_210_uxcx_zuxcx(int x_a, int channel);
  void ag_psp_210_uxcx_zuxcx(int x_a, int zero);
  void ax_psp_210_uxbx_zuxbx(int x_a);
  void ac_psp_210_uxbx_zuxbx(int x_a, int channel);
  void ag_psp_210_uxbx_zuxbx(int x_a, int zero);
  void ax_psp_210_bxbx_zbxbx(int x_a);
  void ac_psp_210_bxbx_zbxbx(int x_a, int channel);
  void ag_psp_210_bxbx_zbxbx(int x_a, int zero);

};
#endif
