#ifndef RANDOMVARIABLE_H
#define RANDOMVARIABLE_H

#include <iostream>
#include <fstream>
#include <string>
#include <vector>

#include "logger.hpp"
#include "randommanager.hpp"
#include "importancesampling.set.hpp"

class randommanager;

class randomvariable {
public:
  randomvariable();
  randomvariable(importancesampling_input input, string name, randommanager * _manager);
  
  void psp_IS_optimization(double & psp_weight, double & psp_weight2);
  void step_IS_optimization(int events, bool enforce_step, int i_step);
  void result_IS_optimization(int i_step_mode, bool enforce_step, int i_step);

  double get_random();
  void get_g_IS(double r, double & g_IS);

  void proceeding_out(std::ofstream & out_proceeding);
  void proceeding_in(int & proc, vector<string> & readin);
  bool check_proceeding_in(int & int_end, int & proc, vector<string> & readin);

  void proceeding_group_by_type_out(ofstream & out_proceeding);
  void proceeding_group_by_type_in(int & proc, vector<string> & readin, bool switch_combination);

  void save_weights(std::ofstream & out_weights);
  void readin_weights(vector<string> & readin);

  friend std::ostream & operator << ( std::ostream &, const randomvariable & IS);

  bool used;
  bool imp_sampling;
  importancesampling_set IS_PS;
  randommanager * manager;
  int number;

 private:
  void get_random(double &x, double &g_IS, vector<double> &s);

};

#endif
