#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

ppaaa03_phasespace_set::~ppaaa03_phasespace_set(){
  static Logger logger("ppaaa03_phasespace_set::~ppaaa03_phasespace_set");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;


  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::optimize_minv_born(){
  static Logger logger("ppaaa03_phasespace_set::optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppaaa03_phasespace_set::determination_MCchannels_born(int x_a){
  static Logger logger("ppaaa03_phasespace_set::determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 6;}
    else if (csi->no_process_parton[x_a] == 3){n_channel = 6;}
    else if (csi->no_process_parton[x_a] == 4){n_channel = 6;}
    else if (csi->no_process_parton[x_a] == 5){n_channel = 6;}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){n_channel = 0;}
    else if (csi->no_process_parton[x_a] == 1){n_channel = 36;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ac_tau_psp_born(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppaaa03_phasespace_set::ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 3){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 4){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 5){tau_MC_map = vector<int> {  0};}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){
      tau_MC_map.push_back(0);
      tau_MC_map.push_back(-36);
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ax_psp_born(int x_a){
  static Logger logger("ppaaa03_phasespace_set::ax_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 3){ax_psp_030_ddx_aaa(x_a);}
    else if (csi->no_process_parton[x_a] == 4){ax_psp_030_uux_aaa(x_a);}
    else if (csi->no_process_parton[x_a] == 5){ax_psp_030_bbx_aaa(x_a);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){ax_psp_230_gg_aaa(x_a);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ac_psp_born(int x_a, int channel){
  static Logger logger("ppaaa03_phasespace_set::ac_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 3){ac_psp_030_ddx_aaa(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 4){ac_psp_030_uux_aaa(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 5){ac_psp_030_bbx_aaa(x_a, channel);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){ac_psp_230_gg_aaa(x_a, channel);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ag_psp_born(int x_a, int zero){
  static Logger logger("ppaaa03_phasespace_set::ag_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 3){ag_psp_030_ddx_aaa(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 4){ag_psp_030_uux_aaa(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 5){ag_psp_030_bbx_aaa(x_a, zero);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 1){ag_psp_230_gg_aaa(x_a, zero);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::optimize_minv_real(){
  static Logger logger("ppaaa03_phasespace_set::optimize_minv_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.real.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppaaa03_phasespace_set::determination_MCchannels_real(int x_a){
  static Logger logger("ppaaa03_phasespace_set::determination_MCchannels_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] ==  0){n_channel = 42;}
    else if (csi->no_process_parton[x_a] ==  2){n_channel = 24;}
    else if (csi->no_process_parton[x_a] ==  3){n_channel = 24;}
    else if (csi->no_process_parton[x_a] ==  4){n_channel = 24;}
    else if (csi->no_process_parton[x_a] ==  5){n_channel = 24;}
    else if (csi->no_process_parton[x_a] ==  6){n_channel = 24;}
    else if (csi->no_process_parton[x_a] ==  7){n_channel = 24;}
    else if (csi->no_process_parton[x_a] ==  9){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 11){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 13){n_channel = 24;}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] ==  0){n_channel = 42;}
    else if (csi->no_process_parton[x_a] == 10){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 12){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 14){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 15){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 16){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 17){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 21){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 22){n_channel = 24;}
    else if (csi->no_process_parton[x_a] == 23){n_channel = 24;}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 3 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] ==  0){n_channel = 0;}
    else if (csi->no_process_parton[x_a] ==  1){n_channel = 288;}
    else if (csi->no_process_parton[x_a] ==  7){n_channel = 102;}
    else if (csi->no_process_parton[x_a] ==  8){n_channel = 102;}
    else if (csi->no_process_parton[x_a] ==  9){n_channel = 102;}
    else if (csi->no_process_parton[x_a] == 10){n_channel = 102;}
    else if (csi->no_process_parton[x_a] == 11){n_channel = 102;}
    else if (csi->no_process_parton[x_a] == 12){n_channel = 102;}
    else if (csi->no_process_parton[x_a] == 13){n_channel = 102;}
    else if (csi->no_process_parton[x_a] == 15){n_channel = 102;}
    else if (csi->no_process_parton[x_a] == 17){n_channel = 102;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ac_tau_psp_real(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppaaa03_phasespace_set::ac_tau_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  2){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  3){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  4){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  5){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  6){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  7){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  9){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 11){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 13){tau_MC_map = vector<int> {  0};}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 10){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 12){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 14){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 15){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 16){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 17){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 21){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 22){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 23){tau_MC_map = vector<int> {  0};}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 3 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){
      tau_MC_map.push_back(0);
      tau_MC_map.push_back(-36);
    }
    else if (csi->no_process_parton[x_a] ==  7){
      tau_MC_map.push_back(0);
    }
    else if (csi->no_process_parton[x_a] ==  8){
      tau_MC_map.push_back(0);
    }
    else if (csi->no_process_parton[x_a] ==  9){
      tau_MC_map.push_back(0);
    }
    else if (csi->no_process_parton[x_a] == 10){
      tau_MC_map.push_back(0);
    }
    else if (csi->no_process_parton[x_a] == 11){
      tau_MC_map.push_back(0);
    }
    else if (csi->no_process_parton[x_a] == 12){
      tau_MC_map.push_back(0);
    }
    else if (csi->no_process_parton[x_a] == 13){
      tau_MC_map.push_back(0);
    }
    else if (csi->no_process_parton[x_a] == 15){
      tau_MC_map.push_back(0);
    }
    else if (csi->no_process_parton[x_a] == 17){
      tau_MC_map.push_back(0);
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ax_psp_real(int x_a){
  static Logger logger("ppaaa03_phasespace_set::ax_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  2){ax_psp_130_gd_aaad(x_a);}
    else if (csi->no_process_parton[x_a] ==  3){ax_psp_130_gu_aaau(x_a);}
    else if (csi->no_process_parton[x_a] ==  4){ax_psp_130_gb_aaab(x_a);}
    else if (csi->no_process_parton[x_a] ==  5){ax_psp_130_gdx_aaadx(x_a);}
    else if (csi->no_process_parton[x_a] ==  6){ax_psp_130_gux_aaaux(x_a);}
    else if (csi->no_process_parton[x_a] ==  7){ax_psp_130_gbx_aaabx(x_a);}
    else if (csi->no_process_parton[x_a] ==  9){ax_psp_130_ddx_aaag(x_a);}
    else if (csi->no_process_parton[x_a] == 11){ax_psp_130_uux_aaag(x_a);}
    else if (csi->no_process_parton[x_a] == 13){ax_psp_130_bbx_aaag(x_a);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 10){ax_psp_040_da_aaad(x_a);}
    else if (csi->no_process_parton[x_a] == 12){ax_psp_040_ua_aaau(x_a);}
    else if (csi->no_process_parton[x_a] == 14){ax_psp_040_ba_aaab(x_a);}
    else if (csi->no_process_parton[x_a] == 15){ax_psp_040_dxa_aaadx(x_a);}
    else if (csi->no_process_parton[x_a] == 16){ax_psp_040_uxa_aaaux(x_a);}
    else if (csi->no_process_parton[x_a] == 17){ax_psp_040_bxa_aaabx(x_a);}
    else if (csi->no_process_parton[x_a] == 21){ax_psp_040_ddx_aaaa(x_a);}
    else if (csi->no_process_parton[x_a] == 22){ax_psp_040_uux_aaaa(x_a);}
    else if (csi->no_process_parton[x_a] == 23){ax_psp_040_bbx_aaaa(x_a);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 3 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){ax_psp_330_gg_aaag(x_a);}
    else if (csi->no_process_parton[x_a] ==  7){ax_psp_330_gd_aaad(x_a);}
    else if (csi->no_process_parton[x_a] ==  8){ax_psp_330_gu_aaau(x_a);}
    else if (csi->no_process_parton[x_a] ==  9){ax_psp_330_gb_aaab(x_a);}
    else if (csi->no_process_parton[x_a] == 10){ax_psp_330_gdx_aaadx(x_a);}
    else if (csi->no_process_parton[x_a] == 11){ax_psp_330_gux_aaaux(x_a);}
    else if (csi->no_process_parton[x_a] == 12){ax_psp_330_gbx_aaabx(x_a);}
    else if (csi->no_process_parton[x_a] == 13){ax_psp_330_ddx_aaag(x_a);}
    else if (csi->no_process_parton[x_a] == 15){ax_psp_330_uux_aaag(x_a);}
    else if (csi->no_process_parton[x_a] == 17){ax_psp_330_bbx_aaag(x_a);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ac_psp_real(int x_a, int channel){
  static Logger logger("ppaaa03_phasespace_set::ac_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  2){ac_psp_130_gd_aaad(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  3){ac_psp_130_gu_aaau(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  4){ac_psp_130_gb_aaab(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  5){ac_psp_130_gdx_aaadx(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  6){ac_psp_130_gux_aaaux(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  7){ac_psp_130_gbx_aaabx(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  9){ac_psp_130_ddx_aaag(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 11){ac_psp_130_uux_aaag(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 13){ac_psp_130_bbx_aaag(x_a, channel);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 10){ac_psp_040_da_aaad(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 12){ac_psp_040_ua_aaau(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 14){ac_psp_040_ba_aaab(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 15){ac_psp_040_dxa_aaadx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 16){ac_psp_040_uxa_aaaux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 17){ac_psp_040_bxa_aaabx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 21){ac_psp_040_ddx_aaaa(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 22){ac_psp_040_uux_aaaa(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 23){ac_psp_040_bbx_aaaa(x_a, channel);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 3 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){ac_psp_330_gg_aaag(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  7){ac_psp_330_gd_aaad(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  8){ac_psp_330_gu_aaau(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  9){ac_psp_330_gb_aaab(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 10){ac_psp_330_gdx_aaadx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 11){ac_psp_330_gux_aaaux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 12){ac_psp_330_gbx_aaabx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 13){ac_psp_330_ddx_aaag(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 15){ac_psp_330_uux_aaag(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 17){ac_psp_330_bbx_aaag(x_a, channel);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ag_psp_real(int x_a, int zero){
  static Logger logger("ppaaa03_phasespace_set::ag_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 1 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  2){ag_psp_130_gd_aaad(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  3){ag_psp_130_gu_aaau(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  4){ag_psp_130_gb_aaab(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  5){ag_psp_130_gdx_aaadx(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  6){ag_psp_130_gux_aaaux(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  7){ag_psp_130_gbx_aaabx(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  9){ag_psp_130_ddx_aaag(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 11){ag_psp_130_uux_aaag(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 13){ag_psp_130_bbx_aaag(x_a, zero);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 0 && csi->phasespace_order_alpha_e[x_a] == 4 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] == 10){ag_psp_040_da_aaad(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 12){ag_psp_040_ua_aaau(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 14){ag_psp_040_ba_aaab(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 15){ag_psp_040_dxa_aaadx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 16){ag_psp_040_uxa_aaaux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 17){ag_psp_040_bxa_aaabx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 21){ag_psp_040_ddx_aaaa(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 22){ag_psp_040_uux_aaaa(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 23){ag_psp_040_bbx_aaaa(x_a, zero);}
  }
  else if (csi->phasespace_order_alpha_s[x_a] == 3 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  1){ag_psp_330_gg_aaag(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  7){ag_psp_330_gd_aaad(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  8){ag_psp_330_gu_aaau(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  9){ag_psp_330_gb_aaab(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 10){ag_psp_330_gdx_aaadx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 11){ag_psp_330_gux_aaaux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 12){ag_psp_330_gbx_aaabx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 13){ag_psp_330_ddx_aaag(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 15){ag_psp_330_uux_aaag(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 17){ag_psp_330_bbx_aaag(x_a, zero);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::optimize_minv_doublereal(){
  static Logger logger("ppaaa03_phasespace_set::optimize_minv_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

#include "specify.optimize.phasespace.minv.doublereal.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

int ppaaa03_phasespace_set::determination_MCchannels_doublereal(int x_a){
  static Logger logger("ppaaa03_phasespace_set::determination_MCchannels_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int n_channel = 0;
  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] ==  0){n_channel = 534;}
    else if (csi->no_process_parton[x_a] ==  2){n_channel = 144;}
    else if (csi->no_process_parton[x_a] ==  3){n_channel = 144;}
    else if (csi->no_process_parton[x_a] ==  4){n_channel = 144;}
    else if (csi->no_process_parton[x_a] ==  5){n_channel = 144;}
    else if (csi->no_process_parton[x_a] ==  6){n_channel = 144;}
    else if (csi->no_process_parton[x_a] ==  7){n_channel = 144;}
    else if (csi->no_process_parton[x_a] ==  8){n_channel = 144;}
    else if (csi->no_process_parton[x_a] ==  9){n_channel = 144;}
    else if (csi->no_process_parton[x_a] == 10){n_channel = 144;}
    else if (csi->no_process_parton[x_a] == 15){n_channel = 240;}
    else if (csi->no_process_parton[x_a] == 16){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 17){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 18){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 20){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 21){n_channel = 144;}
    else if (csi->no_process_parton[x_a] == 22){n_channel = 240;}
    else if (csi->no_process_parton[x_a] == 23){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 24){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 25){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 26){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 27){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 29){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 31){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 32){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 34){n_channel = 240;}
    else if (csi->no_process_parton[x_a] == 35){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 36){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 37){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 39){n_channel = 144;}
    else if (csi->no_process_parton[x_a] == 40){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 41){n_channel = 240;}
    else if (csi->no_process_parton[x_a] == 42){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 43){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 44){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 45){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 47){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 48){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 50){n_channel = 240;}
    else if (csi->no_process_parton[x_a] == 51){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 52){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 53){n_channel = 144;}
    else if (csi->no_process_parton[x_a] == 54){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 55){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 56){n_channel = 240;}
    else if (csi->no_process_parton[x_a] == 58){n_channel = 240;}
    else if (csi->no_process_parton[x_a] == 59){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 60){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 61){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 63){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 65){n_channel = 240;}
    else if (csi->no_process_parton[x_a] == 66){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 67){n_channel = 120;}
    else if (csi->no_process_parton[x_a] == 69){n_channel = 240;}
  }
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ac_tau_psp_doublereal(int x_a, vector<int> & tau_MC_map){
  static Logger logger("ppaaa03_phasespace_set::ac_tau_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if      (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  2){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  3){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  4){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  5){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  6){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  7){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  8){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] ==  9){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 10){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 15){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 16){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 17){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 18){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 20){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 21){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 22){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 23){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 24){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 25){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 26){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 27){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 29){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 31){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 32){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 34){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 35){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 36){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 37){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 39){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 40){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 41){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 42){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 43){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 44){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 45){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 47){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 48){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 50){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 51){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 52){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 53){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 54){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 55){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 56){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 58){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 59){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 60){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 61){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 63){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 65){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 66){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 67){tau_MC_map = vector<int> {  0};}
    else if (csi->no_process_parton[x_a] == 69){tau_MC_map = vector<int> {  0};}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ax_psp_doublereal(int x_a){
  static Logger logger("ppaaa03_phasespace_set::ax_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  2){ax_psp_230_gg_aaaddx(x_a);}
    else if (csi->no_process_parton[x_a] ==  3){ax_psp_230_gg_aaauux(x_a);}
    else if (csi->no_process_parton[x_a] ==  4){ax_psp_230_gg_aaabbx(x_a);}
    else if (csi->no_process_parton[x_a] ==  5){ax_psp_230_gd_aaagd(x_a);}
    else if (csi->no_process_parton[x_a] ==  6){ax_psp_230_gu_aaagu(x_a);}
    else if (csi->no_process_parton[x_a] ==  7){ax_psp_230_gb_aaagb(x_a);}
    else if (csi->no_process_parton[x_a] ==  8){ax_psp_230_gdx_aaagdx(x_a);}
    else if (csi->no_process_parton[x_a] ==  9){ax_psp_230_gux_aaagux(x_a);}
    else if (csi->no_process_parton[x_a] == 10){ax_psp_230_gbx_aaagbx(x_a);}
    else if (csi->no_process_parton[x_a] == 15){ax_psp_230_dd_aaadd(x_a);}
    else if (csi->no_process_parton[x_a] == 16){ax_psp_230_du_aaadu(x_a);}
    else if (csi->no_process_parton[x_a] == 17){ax_psp_230_ds_aaads(x_a);}
    else if (csi->no_process_parton[x_a] == 18){ax_psp_230_dc_aaadc(x_a);}
    else if (csi->no_process_parton[x_a] == 20){ax_psp_230_db_aaadb(x_a);}
    else if (csi->no_process_parton[x_a] == 21){ax_psp_230_ddx_aaagg(x_a);}
    else if (csi->no_process_parton[x_a] == 22){ax_psp_230_ddx_aaaddx(x_a);}
    else if (csi->no_process_parton[x_a] == 23){ax_psp_230_ddx_aaauux(x_a);}
    else if (csi->no_process_parton[x_a] == 24){ax_psp_230_ddx_aaassx(x_a);}
    else if (csi->no_process_parton[x_a] == 25){ax_psp_230_ddx_aaaccx(x_a);}
    else if (csi->no_process_parton[x_a] == 26){ax_psp_230_ddx_aaabbx(x_a);}
    else if (csi->no_process_parton[x_a] == 27){ax_psp_230_dux_aaadux(x_a);}
    else if (csi->no_process_parton[x_a] == 29){ax_psp_230_dsx_aaadsx(x_a);}
    else if (csi->no_process_parton[x_a] == 31){ax_psp_230_dcx_aaadcx(x_a);}
    else if (csi->no_process_parton[x_a] == 32){ax_psp_230_dbx_aaadbx(x_a);}
    else if (csi->no_process_parton[x_a] == 34){ax_psp_230_uu_aaauu(x_a);}
    else if (csi->no_process_parton[x_a] == 35){ax_psp_230_uc_aaauc(x_a);}
    else if (csi->no_process_parton[x_a] == 36){ax_psp_230_ub_aaaub(x_a);}
    else if (csi->no_process_parton[x_a] == 37){ax_psp_230_udx_aaaudx(x_a);}
    else if (csi->no_process_parton[x_a] == 39){ax_psp_230_uux_aaagg(x_a);}
    else if (csi->no_process_parton[x_a] == 40){ax_psp_230_uux_aaaddx(x_a);}
    else if (csi->no_process_parton[x_a] == 41){ax_psp_230_uux_aaauux(x_a);}
    else if (csi->no_process_parton[x_a] == 42){ax_psp_230_uux_aaassx(x_a);}
    else if (csi->no_process_parton[x_a] == 43){ax_psp_230_uux_aaaccx(x_a);}
    else if (csi->no_process_parton[x_a] == 44){ax_psp_230_uux_aaabbx(x_a);}
    else if (csi->no_process_parton[x_a] == 45){ax_psp_230_usx_aaausx(x_a);}
    else if (csi->no_process_parton[x_a] == 47){ax_psp_230_ucx_aaaucx(x_a);}
    else if (csi->no_process_parton[x_a] == 48){ax_psp_230_ubx_aaaubx(x_a);}
    else if (csi->no_process_parton[x_a] == 50){ax_psp_230_bb_aaabb(x_a);}
    else if (csi->no_process_parton[x_a] == 51){ax_psp_230_bdx_aaabdx(x_a);}
    else if (csi->no_process_parton[x_a] == 52){ax_psp_230_bux_aaabux(x_a);}
    else if (csi->no_process_parton[x_a] == 53){ax_psp_230_bbx_aaagg(x_a);}
    else if (csi->no_process_parton[x_a] == 54){ax_psp_230_bbx_aaaddx(x_a);}
    else if (csi->no_process_parton[x_a] == 55){ax_psp_230_bbx_aaauux(x_a);}
    else if (csi->no_process_parton[x_a] == 56){ax_psp_230_bbx_aaabbx(x_a);}
    else if (csi->no_process_parton[x_a] == 58){ax_psp_230_dxdx_aaadxdx(x_a);}
    else if (csi->no_process_parton[x_a] == 59){ax_psp_230_dxux_aaadxux(x_a);}
    else if (csi->no_process_parton[x_a] == 60){ax_psp_230_dxsx_aaadxsx(x_a);}
    else if (csi->no_process_parton[x_a] == 61){ax_psp_230_dxcx_aaadxcx(x_a);}
    else if (csi->no_process_parton[x_a] == 63){ax_psp_230_dxbx_aaadxbx(x_a);}
    else if (csi->no_process_parton[x_a] == 65){ax_psp_230_uxux_aaauxux(x_a);}
    else if (csi->no_process_parton[x_a] == 66){ax_psp_230_uxcx_aaauxcx(x_a);}
    else if (csi->no_process_parton[x_a] == 67){ax_psp_230_uxbx_aaauxbx(x_a);}
    else if (csi->no_process_parton[x_a] == 69){ax_psp_230_bxbx_aaabxbx(x_a);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ac_psp_doublereal(int x_a, int channel){
  static Logger logger("ppaaa03_phasespace_set::ac_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  2){ac_psp_230_gg_aaaddx(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  3){ac_psp_230_gg_aaauux(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  4){ac_psp_230_gg_aaabbx(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  5){ac_psp_230_gd_aaagd(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  6){ac_psp_230_gu_aaagu(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  7){ac_psp_230_gb_aaagb(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  8){ac_psp_230_gdx_aaagdx(x_a, channel);}
    else if (csi->no_process_parton[x_a] ==  9){ac_psp_230_gux_aaagux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 10){ac_psp_230_gbx_aaagbx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 15){ac_psp_230_dd_aaadd(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 16){ac_psp_230_du_aaadu(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 17){ac_psp_230_ds_aaads(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 18){ac_psp_230_dc_aaadc(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 20){ac_psp_230_db_aaadb(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 21){ac_psp_230_ddx_aaagg(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 22){ac_psp_230_ddx_aaaddx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 23){ac_psp_230_ddx_aaauux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 24){ac_psp_230_ddx_aaassx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 25){ac_psp_230_ddx_aaaccx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 26){ac_psp_230_ddx_aaabbx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 27){ac_psp_230_dux_aaadux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 29){ac_psp_230_dsx_aaadsx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 31){ac_psp_230_dcx_aaadcx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 32){ac_psp_230_dbx_aaadbx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 34){ac_psp_230_uu_aaauu(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 35){ac_psp_230_uc_aaauc(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 36){ac_psp_230_ub_aaaub(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 37){ac_psp_230_udx_aaaudx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 39){ac_psp_230_uux_aaagg(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 40){ac_psp_230_uux_aaaddx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 41){ac_psp_230_uux_aaauux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 42){ac_psp_230_uux_aaassx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 43){ac_psp_230_uux_aaaccx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 44){ac_psp_230_uux_aaabbx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 45){ac_psp_230_usx_aaausx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 47){ac_psp_230_ucx_aaaucx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 48){ac_psp_230_ubx_aaaubx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 50){ac_psp_230_bb_aaabb(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 51){ac_psp_230_bdx_aaabdx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 52){ac_psp_230_bux_aaabux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 53){ac_psp_230_bbx_aaagg(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 54){ac_psp_230_bbx_aaaddx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 55){ac_psp_230_bbx_aaauux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 56){ac_psp_230_bbx_aaabbx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 58){ac_psp_230_dxdx_aaadxdx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 59){ac_psp_230_dxux_aaadxux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 60){ac_psp_230_dxsx_aaadxsx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 61){ac_psp_230_dxcx_aaadxcx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 63){ac_psp_230_dxbx_aaadxbx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 65){ac_psp_230_uxux_aaauxux(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 66){ac_psp_230_uxcx_aaauxcx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 67){ac_psp_230_uxbx_aaauxbx(x_a, channel);}
    else if (csi->no_process_parton[x_a] == 69){ac_psp_230_bxbx_aaabxbx(x_a, channel);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

void ppaaa03_phasespace_set::ag_psp_doublereal(int x_a, int zero){
  static Logger logger("ppaaa03_phasespace_set::ag_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (csi->phasespace_order_alpha_s[x_a] == 2 && csi->phasespace_order_alpha_e[x_a] == 3 && csi->phasespace_order_interference[x_a] == 0){
    if (csi->no_process_parton[x_a] == 0){}
    else if (csi->no_process_parton[x_a] ==  2){ag_psp_230_gg_aaaddx(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  3){ag_psp_230_gg_aaauux(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  4){ag_psp_230_gg_aaabbx(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  5){ag_psp_230_gd_aaagd(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  6){ag_psp_230_gu_aaagu(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  7){ag_psp_230_gb_aaagb(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  8){ag_psp_230_gdx_aaagdx(x_a, zero);}
    else if (csi->no_process_parton[x_a] ==  9){ag_psp_230_gux_aaagux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 10){ag_psp_230_gbx_aaagbx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 15){ag_psp_230_dd_aaadd(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 16){ag_psp_230_du_aaadu(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 17){ag_psp_230_ds_aaads(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 18){ag_psp_230_dc_aaadc(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 20){ag_psp_230_db_aaadb(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 21){ag_psp_230_ddx_aaagg(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 22){ag_psp_230_ddx_aaaddx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 23){ag_psp_230_ddx_aaauux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 24){ag_psp_230_ddx_aaassx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 25){ag_psp_230_ddx_aaaccx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 26){ag_psp_230_ddx_aaabbx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 27){ag_psp_230_dux_aaadux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 29){ag_psp_230_dsx_aaadsx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 31){ag_psp_230_dcx_aaadcx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 32){ag_psp_230_dbx_aaadbx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 34){ag_psp_230_uu_aaauu(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 35){ag_psp_230_uc_aaauc(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 36){ag_psp_230_ub_aaaub(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 37){ag_psp_230_udx_aaaudx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 39){ag_psp_230_uux_aaagg(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 40){ag_psp_230_uux_aaaddx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 41){ag_psp_230_uux_aaauux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 42){ag_psp_230_uux_aaassx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 43){ag_psp_230_uux_aaaccx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 44){ag_psp_230_uux_aaabbx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 45){ag_psp_230_usx_aaausx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 47){ag_psp_230_ucx_aaaucx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 48){ag_psp_230_ubx_aaaubx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 50){ag_psp_230_bb_aaabb(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 51){ag_psp_230_bdx_aaabdx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 52){ag_psp_230_bux_aaabux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 53){ag_psp_230_bbx_aaagg(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 54){ag_psp_230_bbx_aaaddx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 55){ag_psp_230_bbx_aaauux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 56){ag_psp_230_bbx_aaabbx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 58){ag_psp_230_dxdx_aaadxdx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 59){ag_psp_230_dxux_aaadxux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 60){ag_psp_230_dxsx_aaadxsx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 61){ag_psp_230_dxcx_aaadxcx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 63){ag_psp_230_dxbx_aaadxbx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 65){ag_psp_230_uxux_aaauxux(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 66){ag_psp_230_uxcx_aaauxcx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 67){ag_psp_230_uxbx_aaauxbx(x_a, zero);}
    else if (csi->no_process_parton[x_a] == 69){ag_psp_230_bxbx_aaabxbx(x_a, zero);}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
