#include "header.hpp"

void amplitude_set::calculate_ME2_VA_QEW(){
  Logger logger("amplitude_set::calculate_ME2_VA_QEW");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_FATAL << "Basic amplitude_set function must be overwritten." << endline; exit(1);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void amplitude_set::calculate_ME2_ioperator_VA_QEW(){
  Logger logger("amplitude_set::calculate_ME2_ioperator_VA_QEW");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_FATAL << "Basic amplitude_set function must be overwritten." << endline; exit(1);

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void amplitude_set::calculate_ME2check_VA_QEW(){
  static Logger logger("amplitude_set::calculate_ME2check_VA_QEW");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (osi->switch_output_comparison && process_id != -1){
    esi->phasespacepoint();
    if (esi->p_parton[0][0].x0() == 0.){generate_testpoint();}
    if (esi->p_parton[0][0].x0() != 0.){
      ofstream out_comparison;
      out_comparison.open(osi->filename_comparison.c_str(), ofstream::out | ofstream::app);

      esi->perform_event_selection();
      osi->set_testpoint_scale_complete();
      vector<int> cut_ps_acc_all(csi->n_ps, 0);
      swap(esi->cut_ps, cut_ps_acc_all);

      osi->VA_delta_flag = 1;
      osi->VA_b_ME2 = 0.;
      osi->VA_V_ME2 = 0.;
      osi->VA_X_ME2 = 0.;
      osi->VA_I_ME2 = 0.;
      osi->VA_X_ME2_CV.resize(osi->n_scales_CV, 0.);
      if (osi->switch_output_comparison == 2){set_testpoint_alpha_S(osi->var_alpha_S_reference);}
      osi->VA_DeltaUV = 0.;
      osi->VA_DeltaIR1 = 0.;
      osi->VA_DeltaIR2 = 0.;
      logger << LOG_DEBUG << "osi->VA_DeltaUV  = " << osi->VA_DeltaUV << endline_flush;
      logger << LOG_DEBUG << "osi->VA_DeltaIR1 = " << osi->VA_DeltaIR1 << endline_flush;
      logger << LOG_DEBUG << "osi->VA_DeltaIR2 = " << osi->VA_DeltaIR2 << endline_flush;
      ///    ol_setparameter_double(OL_mu_ren, osi->var_mu_ren);
      ///    if (osi->user->double_value[osi->user->double_map["mu_reg"]] == 0.){ol_setparameter_double(OL_mu_reg, osi->var_mu_ren);}
      ///    else {ol_setparameter_double(OL_mu_reg, osi->user->double_value[osi->user->double_map["mu_reg"]]);}
      //      logger << LOG_DEBUG_VERBOSE << "before switch_OL" << endline_flush;
      /*
      // not yet treated correctly  (mu_reg treatment needs to be improved anyway) !!!
      double temp_mu_reg = 0.;
      if (osi->user->double_value[osi->user->double_map["mu_reg"]] == 0.){
	temp_mu_reg = osi->var_mu_ren;
      }
      else {
	temp_mu_reg = osi->user->double_value[osi->user->double_map["mu_reg"]];
      }
      */
      
      set_mu_reg();
      set_mu_and_delta_VA();
      output_parameter("testpoint");
      calculate_ME2_VA_QEW();

      out_comparison << output_amplitude_VA_QEW();

      osi->set_testpoint_x_pdf();
      if (osi->switch_TSV){
	//	osi->calculate_pdf_LHAPDF_TSV();
	osi->calculate_pdf_LHAPDF_list_TSV();
	out_comparison << osi->output_testpoint_VA_integrand_TSV() << endline;
	out_comparison << endline;
	out_comparison << osi->output_testpoint_integrand() << endline;
	out_comparison << endline;
      }

      swap(esi->cut_ps, cut_ps_acc_all);
      out_comparison << osi->output_testpoint_kinematics() << endline;
      out_comparison << osi->output_scales() << endline;
      out_comparison.close();
    }
    else {
      output_parameter("testpoint");
    }

    osi->switch_output_comparison = 0;
  }
  else {
    output_parameter("testpoint");
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


string amplitude_set::output_amplitude_VA_QEW(){
  static Logger logger("amplitude_set::output_amplitude_VA_QEW");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream out_comparison;

  double coefficient_B = 0.;
  double coefficient_VF = 0.;
  double coefficient_V1 = 0.;
  double coefficient_V2 = 0.;
  
  coefficient_B = osi->VA_b_ME2;
  coefficient_VF = osi->VA_V_ME2 + osi->VA_X_ME2;

  /*
    out_comparison << "Settings: " << endl << endline;
    out_comparison << setw(12) << "  mu_reg" << " = " << setprecision(15) << setw(23) << temp_mu_reg << "  ( = mu_ren by default)" << endline;
    out_comparison << setw(12) << "  mu_ren" << " = " << setprecision(15) << setw(23) << osi->var_mu_ren << "  " << "alpha_S(mu_ren) = " << osi->alpha_S << endline;
    out_comparison << setw(12) << "  mu_fact" << " = " << setprecision(15) << setw(23) << osi->var_mu_fact << endline;
    out_comparison << endline;
  */
  //  out_comparison << "Matrix elements (µreg = " << mu_reg << ", µR = " << osi->var_mu_ren << ", " << "alpha_S(µR) = " << setprecision(15) << osi->var_alpha_S_reference << "): " << endl << endline;
  out_comparison << "Matrix elements (µreg = " << mu_reg << ", µR = " << osi->scale_ren << ", " << "alpha_S(µR) = " << setprecision(15) << osi->alpha_S << "): " << endline << endline;
  out_comparison << osi->output_testpoint_VA_result() << endline;
  double OL_I_ME2 = osi->VA_I_ME2;
  //      if (osi->switch_VI != 2){
  {
    osi->VA_I_ME2 = 0.;
    set_testpoint_alpha_S(osi->var_alpha_S_reference); // Recola: !!! from QCD case: check if needed here as well !!!
    calculate_ME2_ioperator_VA_QEW();
    //	set_testpoint_rescale_I_ME2(); // Recola: !!! from QCD case: check if needed here as well !!!
    out_comparison << osi->output_testpoint_VA_ioperator() << endline;
    osi->VA_I_ME2 = OL_I_ME2;
  }
  /* // not needed, thus output switched off
     osi->VA_V_ME2 = osi->VA_V_ME2 / osi->VA_b_ME2;
     osi->VA_X_ME2 = osi->VA_X_ME2 / osi->VA_b_ME2;
     osi->VA_I_ME2 = osi->VA_I_ME2 / osi->VA_b_ME2;
     //    osi->VA_b_ME2 = osi->VA_b_ME2;
     out_comparison << "Relative results (corrections devided by ME2_born, ME2_born divided by coupling constants): " << endl << endline;
     osi->output_testpoint_VA_result(out_comparison);
     out_comparison << endline;
  */
  /*
    out_comparison << "Particle momenta: " << endl << endline;
    osi->output_momenta(out_comparison);
  */
      
  string s_Delta;
  double i_Delta;

  out_comparison << "Numerical check of (UV and IR) finiteness: " << endl << endline;

  if (allowed_Delta_IRneqUV){
    s_Delta = "Delta_UV";
    for (int i = 0; i < 3; i++){
      i_Delta = (double(i) - 1.) * 1.;
      osi->VA_DeltaUV = i_Delta;
      set_mu_and_delta_VA();
      calculate_ME2_VA_QEW();
      // use SK I-operator (needed for external photons by now) !!!
      ///  calculate_ME2_ioperator_VA_QEW();
      out_comparison << osi->output_testpoint_VA_Delta(i, i_Delta, s_Delta) << endline;
    }
    osi->VA_DeltaUV = 0.;
    out_comparison << endline;

    s_Delta = "Delta_IR_1";
    for (int i = 0; i < 3; i++){
      i_Delta = (double(i) - 1.) * 1.;
      osi->VA_DeltaIR1 = i_Delta;
      set_mu_and_delta_VA();
      calculate_ME2_VA_QEW();
      // use SK I-operator (needed for external photons by now) !!!
      ///  calculate_ME2_ioperator_VA_QEW();
      out_comparison << osi->output_testpoint_VA_Delta(i, i_Delta, s_Delta) << endline;
    }
    coefficient_V1 = osi->VA_V_ME2 + osi->VA_X_ME2 - coefficient_VF;
    osi->VA_DeltaIR1 = 0.;
    out_comparison << endline;
  }

  s_Delta = "Delta_IR_2";
  for (int i = 0; i < 3; i++){
    i_Delta = (double(i) - 1.) * 1.;
    osi->VA_DeltaIR2 = i_Delta;
    set_mu_and_delta_VA();
    calculate_ME2_VA_QEW();
    // use SK I-operator (needed for external photons by now) !!!
    ///  calculate_ME2_ioperator_VA_QEW();
    out_comparison << osi->output_testpoint_VA_Delta(i, i_Delta, s_Delta) << endline;
  }
  coefficient_V2 = osi->VA_V_ME2 + osi->VA_X_ME2 - coefficient_VF;

  osi->VA_DeltaIR2 = 0.;
  out_comparison << endline;
  s_Delta = "Delta_UV = Delta_IR_1";
  for (int i = 0; i < 3; i++){
    i_Delta = (double(i) - 1.) * 1.;
    osi->VA_DeltaUV = i_Delta;
    osi->VA_DeltaIR1 = i_Delta;
    set_mu_and_delta_VA();
    calculate_ME2_VA_QEW();
    // use SK I-operator (needed for external photons by now) !!!
    ///  calculate_ME2_ioperator_VA_QEW();
    out_comparison << osi->output_testpoint_VA_Delta(i, i_Delta, s_Delta) << endline;
  }
  if (allowed_Delta_IRneqUV){
    coefficient_V1 = osi->VA_V_ME2 + osi->VA_X_ME2 - coefficient_VF;
  }
  osi->VA_DeltaUV = 0.;
  osi->VA_DeltaIR1 = 0.;
  out_comparison << endline;
  set_mu_and_delta_VA();
  calculate_ME2_VA_QEW();
  // in order to reset Delta-dependent SK I-operator settings !!!
  ///  calculate_ME2_ioperator_VA_QEW();
  osi->VA_delta_flag = 0;

  out_comparison << endline;
  out_comparison << endline;
  out_comparison << "Coefficients:" << endline;
  out_comparison << endline;
  out_comparison << right << setw(5) << "B" << " = " << setprecision(15) << setw(23) << left << coefficient_B << endline;
  out_comparison << right << setw(5) << "VF" << " = " << setprecision(15) << setw(23) << left << coefficient_VF << endline;
  out_comparison << right << setw(5) << "V1" << " = " << setprecision(15) << setw(23) << left << coefficient_V1 << endline;
  out_comparison << right << setw(5) << "V2" << " = " << setprecision(15) << setw(23) << left << coefficient_V2 << endline;
  out_comparison << endline;
  out_comparison << endline;

  out_comparison << "#" << right
		 << setprecision(6) << setw(11) << "lam"
		 << setprecision(15) << setw(23) << "B"
		 << setprecision(15) << setw(23) << "VF"
		 << setprecision(15) << setw(23) << "V1"
		 << setprecision(15) << setw(23) << "V2"
		 << setprecision(15) << setw(23) << "VF/(B*alpha)"
		 << setprecision(15) << setw(23) << "V1/(B*alpha)"
		 << setprecision(15) << setw(23) << "V2/(B*alpha)"
		 << endline;

  // hard-coded alpha value ???
  out_comparison << right
		 << setprecision(7) << setw(12) << msi->alpha_e / 0.0075552541674291547
		 << setprecision(15) << setw(23) << coefficient_B
		 << setprecision(15) << setw(23) << coefficient_VF
		 << setprecision(15) << setw(23) << coefficient_V1
		 << setprecision(15) << setw(23) << coefficient_V2
		 << setprecision(15) << setw(23) << coefficient_VF / coefficient_B / msi->alpha_e
		 << setprecision(15) << setw(23) << coefficient_V1 / coefficient_B / msi->alpha_e
		 << setprecision(15) << setw(23) << coefficient_V2 / coefficient_B / msi->alpha_e
		 << endline;

  // Check if needed for QEW corrections !!!
  if (osi->switch_output_comparison == 2){set_testpoint_alpha_S(osi->alpha_S);}

  logger << LOG_DEBUG_VERBOSE << "finished - return (string):" << endl << out_comparison.str() << endline_flush;
  return out_comparison.str();
}
