#include "header.hpp"

void munich::integration_VA_QEW(){
  static Logger logger("munich::integration_VA_QEW");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  initialization_integration();
  asi->calculate_ME2check_VA_QEW();
  initialization_integration_check();
  
  while (osi->int_end == 0){
    rsi.perform_iteration_step();
    if (osi->int_end == 1){break;}
    psi->calculate_IS();
    if (!psi->identical_psp){
      psi->ac_psp(0, psi->MC_phasespace.channel);
      esi->determine_p_parton();
      if (munich_isnan(esi->p_parton)){errorhandling_c_psp(); continue;}
    }
    esi->perform_event_selection();
    if (esi->cut_ps[0] == -1){psi->handling_cut_psp(); continue;}
    if (osi->switch_console_output_tau_0){psi->output_check_tau_0();}
    if (!psi->identical_psp){psi->ag_psp(0, 0);}
    psi->calculate_g_tot();
    if (munich_isinfnan(psi->g_tot)){errorhandling_gtot(); continue;}
    osi->determine_scale_complete();
    if (!psi->identical_psp){
      asi->calculate_ME2_VA_QEW();
      if (munich_isnan(osi->VA_V_ME2) || munich_isnan(osi->VA_X_ME2) || munich_isnan(osi->VA_I_ME2)){errorhandling_me2(); continue;}
    }
    if (csi->type_contribution == "VA"){
      // Introduce a flag in asi that is set by the one-loop provider !!!
      if (osi->switch_OL && osi->VA_V_ME2 == 0. && osi->switch_VI != 2){errorhandling_OL(); continue;} // maybe better error output in case of RVA contribution !!!
      if (osi->switch_RCL && osi->VA_X_ME2 == 0. && osi->switch_VI != 2){errorhandling_OL(); continue;} // maybe better error output in case of RVA contribution !!!
    }
    if (osi->switch_moment){osi->moments();}
    if (osi->switch_CV){osi->calculate_pdf_LHAPDF_CV();}
    if (osi->switch_TSV){osi->calculate_pdf_LHAPDF_list_TSV();}
    osi->determine_integrand_VA();
    if (psi->i_gen <= esi->switch_output_check_selection){osi->output_check_selection_psp();}
    if (osi->switch_TSV){osi->determine_psp_weight_TSV();}
    osi->determine_psp_weight();
    if (osi->switch_output_maxevent){osi->output_integrand_maximum_VA();}
    if (osi->switch_distribution){osi->determine_distribution_complete();}
    if (osi->switch_optimization_modifier){osi->calculate_optimization_modifier();}
    psi->psp_optimization_complete(osi->integrand, osi->this_psp_weight, osi->this_psp_weight2, osi->optimization_modifier);
    psi->i_acc++; psi->i_acc_step++;
    if (csi->n_particle == 1){psi->identical_psp = true;}
    osi->determine_runtime();
  }
  osi->output_finalization_integration();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
