#include "header.hpp"

bool observable_set::check_proceeding_in(vector<string> & readin){
  Logger logger("check_proceeding_in");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (proceeding_check_size > readin.size()){
    int_end = 2;
    logger << LOG_DEBUG << "proceeding_check_size = " << setw(8) << proceeding_check_size << "  > " << setw(8) << readin.size() << " = readin.size()  @ proceeding_counter = " << setw(3) << ++proceeding_counter << "   int_end = 2" << endline_flush;
  }
  else {
    logger << LOG_DEBUG << "proceeding_check_size = " << setw(8) << proceeding_check_size << " <= " << setw(8) << readin.size() << " = readin.size()" << endline_flush;
  }

  bool check_size = true;
  if (int_end == 2){check_size = false;}
  
  logger << LOG_DEBUG_VERBOSE << "finished - return " << check_size << endline_flush;
  return check_size;
}


void observable_set::perform_proceeding_in(){
  Logger logger("observable_set::perform_proceeding_in");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  ifstream in_proceeding(filename_proceeding.c_str());
  char LineBuffer[128];
  vector<string> readin;
  while (in_proceeding.getline(LineBuffer, 128)) {
    readin.push_back(LineBuffer);
  }
  in_proceeding.close();
  for (int i = readin.size() - 1; i >=0; i--){
    if (readin[i][0] == '#'){
      logger << LOG_DEBUG << readin[i] << endline_flush;
      readin.erase(readin.begin() + i);
    }
  }
  logger << LOG_DEBUG << "proceeding_in size: " << readin.size() << endline_flush;

  logger << LOG_DEBUG << "Start checking expected content of proceeding_in" << endline_flush;

  proceeding_counter = 0;
  proceeding_check_size = 0;

  psi->rng.check_proceeding_in(int_end, proceeding_check_size, readin);

  //  proceeding_check_size += 3 + 1 + 5 + 2;
  proceeding_check_size += 3 + 7 + 5 + 2;
  if (!check_proceeding_in(readin)){return;}

  logger << LOG_DEBUG << "# standard end: proceeding_check_size = " << proceeding_check_size << endline_flush;
  logger << LOG_DEBUG << "# switch_CV = " << switch_CV << " (before) = " << proceeding_check_size << endline_flush;
  if (switch_CV){
    proceeding_check_size += 2 * output_n_qTcut * n_scales_CV;
    if (!check_proceeding_in(readin)){return;}
    logger << LOG_DEBUG << "# CV end: proceeding_check_size = " << proceeding_check_size << endline_flush;
  }

  logger << LOG_DEBUG << "# switch_moment = " << switch_moment << " (before) = " << proceeding_check_size << endline_flush;
  if (switch_moment){
    for (int i_m = 0; i_m < n_moments; i_m++){
      proceeding_check_size += 2;
      if (!check_proceeding_in(readin)){return;}
      if (switch_CV){
	proceeding_check_size += 2 * n_qTcut * n_scales_CV;
	if (!check_proceeding_in(readin)){return;}
      }
    }
    logger << LOG_DEBUG << "# n_moments end: proceeding_check_size = " << proceeding_check_size << endline_flush;
  }
  logger << LOG_DEBUG << "# switch_distribution = " << switch_distribution << " (before) = " << proceeding_check_size << endline_flush;
  if (switch_distribution){
    int dist_numbers = 3;
    if (switch_CV){dist_numbers += 2 * n_scales_CV;}
    for (int i_d = 0; i_d < dat.size(); i_d++){
      proceeding_check_size += dist_numbers * dat[i_d].n_bins;
      if (!check_proceeding_in(readin)){return;}
    }
    for (int i_ddd = 0; i_ddd < dddat.size(); i_ddd++){
      proceeding_check_size += dist_numbers * dddat[i_ddd].n_bins;
      if (!check_proceeding_in(readin)){return;}
    }
    logger << LOG_DEBUG << "# distribution end: proceeding_check_size = " << proceeding_check_size << endline_flush;
  }

  logger << LOG_DEBUG << "# switch_TSV = " << switch_TSV << " (before) = " << proceeding_check_size << endline_flush;
  if (switch_TSV){
    for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
      proceeding_check_size += 2 * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
      if (!check_proceeding_in(readin)){return;}
      if (active_qTcut){
	proceeding_check_size += 2 * n_qTcut * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
	if (!check_proceeding_in(readin)){return;}
      }
    }
    for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
      if (!switch_moment_TSV[i_s]){continue;}
       proceeding_check_size += 2 * n_moments * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
      if (!check_proceeding_in(readin)){return;}
    }
    int next_no_qTcut = 0;
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      if (next_no_qTcut == no_qTcut_distribution.size()){continue;}
      if (i_q != no_qTcut_distribution[next_no_qTcut]){continue;}
      for (int i_d = 0; i_d < dat.size(); i_d++){
	for (int i_b = 0; i_b < dat[i_d].n_bins; i_b++){
	  proceeding_check_size += 1;
	  if (!check_proceeding_in(readin)){return;}
	  for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
	    proceeding_check_size += 2 * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
	    if (!check_proceeding_in(readin)){return;}
	    //	    if (proceeding_check_size > readin.size()){int_end = 2; logger << LOG_DEBUG << "int_end = 2   proceeding_check_size = " << proceeding_check_size << " > " << readin.size() << " = readin.size()  @ counter = " << counter << endline_flush; return;}
	    //	    else {logger << LOG_DEBUG << "proceeding_check_size = " << proceeding_check_size << " <= " << readin.size() << " = readin.size()" << endline_flush;}
	  }
	}
      }
      for (int i_d = 0; i_d < dddat.size(); i_d++){
	// not needed here !!!	int i_ddd = dat.size() + i_d;
	for (int i_b = 0; i_b < dddat[i_d].n_bins; i_b++){
	  proceeding_check_size += 1;
	  if (!check_proceeding_in(readin)){return;}
	  for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
	    proceeding_check_size += 2 * n_scale_ren_TSV[i_s] * n_scale_fact_TSV[i_s];
	    if (!check_proceeding_in(readin)){return;}
	  }
	}
      }
      next_no_qTcut++;
    }
    logger << LOG_DEBUG << "# TSV size end: proceeding_check_size = " << proceeding_check_size << endline_flush;
  }

  logger << LOG_DEBUG << "# before temp_psi_MC_opt_end   readin[" << proceeding_check_size - 1 << "] = " << readin[proceeding_check_size - 1] << endline_flush;

  proceeding_check_size += 1;
  if (!check_proceeding_in(readin)){return;}

  int temp_psi_end_optimization = atoi(readin[proceeding_check_size - 1].c_str());
  logger << LOG_DEBUG << "# temp_psi_end_optimization = " << temp_psi_end_optimization << endline_flush;

  
  if (temp_psi_end_optimization != 2){
    logger << LOG_DEBUG << "# MC_phasespace   readin[" << proceeding_check_size - 1 << "] = " << readin[proceeding_check_size - 1] << endline_flush;
    logger << LOG_DEBUG << "# MC_phasespace   proceeding_check_size (before) = " << proceeding_check_size << endline_flush;
    if (psi->MC_phasespace.active_optimization != -1){
      proceeding_check_size += 1;
      if (!check_proceeding_in(readin)){return;}
      int temp_psi_MC_phasespace_end_optimization = atoi(readin[proceeding_check_size - 1].c_str());
      logger << LOG_DEBUG << "# MC_phasespace   temp_psi_MC_phasespace_end_optimization = " << temp_psi_MC_phasespace_end_optimization << endline_flush;
      logger << LOG_DEBUG << "# MC_phasespace   readin[" << proceeding_check_size - 1 << "] = " << readin[proceeding_check_size - 1] << endline_flush;
      proceeding_check_size += psi->MC_phasespace.n_channel;
      if (!check_proceeding_in(readin)){return;}
      if (temp_psi_MC_phasespace_end_optimization == 0){
	proceeding_check_size += 1;
	if (!check_proceeding_in(readin)){return;}
	int temp_n_opt_steps = atoi(readin[proceeding_check_size - 1].c_str());
	logger << LOG_DEBUG << "# MC_phasespace   temp_n_opt_steps = " << temp_n_opt_steps << endline_flush;
	proceeding_check_size += 2;
	if (!check_proceeding_in(readin)){return;}
	proceeding_check_size += 3 * psi->MC_phasespace.n_channel;
	if (!check_proceeding_in(readin)){return;}
	//      if (proceeding_check_size != readin.size()){
	if (psi->MC_phasespace.switch_validation_optimization){
	  proceeding_check_size += 2;
	  if (!check_proceeding_in(readin)){return;}
	  proceeding_check_size += temp_n_opt_steps; // -> diff_w
	  if (!check_proceeding_in(readin)){return;}
	  proceeding_check_size += temp_n_opt_steps * psi->MC_phasespace.n_channel; // -> alpha_it
	  logger << LOG_DEBUG << "temp_n_opt_steps = " << temp_n_opt_steps << endline_flush;
	  logger << LOG_DEBUG << "psi->MC_phasespace.n_channel = " << psi->MC_phasespace.n_channel << endline_flush;
	  if (!check_proceeding_in(readin)){return;}
	}
      }
    }
    logger << LOG_DEBUG << "# MC_phasespace   finished   readin[" << proceeding_check_size - 1 << "] = " << readin[proceeding_check_size - 1] << endline_flush;
    logger << LOG_DEBUG << "# MC_phasespace end: proceeding_check_size = " << proceeding_check_size << endline_flush;

    
    logger << LOG_DEBUG << "# MC_tau   proceeding_check_size (before) = " << proceeding_check_size << endline_flush;
    if (psi->MC_tau.active_optimization != -1){
      proceeding_check_size += 1;
      if (!check_proceeding_in(readin)){return;}
      int temp_psi_MC_tau_end_optimization = atoi(readin[proceeding_check_size - 1].c_str());
      logger << LOG_DEBUG << "# MC_tau   temp_psi_MC_tau_end_optimization = " << temp_psi_MC_tau_end_optimization << endline_flush;
      proceeding_check_size += psi->MC_tau.n_channel;
      if (!check_proceeding_in(readin)){return;}
      if (temp_psi_MC_tau_end_optimization == 0){
	proceeding_check_size += 1;
	proceeding_check_size += 2;
	if (!check_proceeding_in(readin)){return;}
	int temp_n_opt_steps = atoi(readin[proceeding_check_size - 1].c_str());
	logger << LOG_DEBUG << "# MC_tau   temp_n_opt_steps = " << temp_n_opt_steps << endline_flush;
	proceeding_check_size += 3 * psi->MC_tau.n_channel;
	if (!check_proceeding_in(readin)){return;}
	if (psi->MC_tau.switch_validation_optimization){
	  proceeding_check_size += 2;
	  if (!check_proceeding_in(readin)){return;}
	  proceeding_check_size += temp_n_opt_steps; // -> diff_w
	  if (!check_proceeding_in(readin)){return;}
	  proceeding_check_size += temp_n_opt_steps * psi->MC_tau.n_channel; // -> alpha_it
	  logger << LOG_DEBUG << "psi->MC_tau.n_channel = " << psi->MC_tau.n_channel << endline_flush;
	  if (!check_proceeding_in(readin)){return;}
	}
      }
    }
    logger << LOG_DEBUG << "# MC_tau   finished   readin[" << proceeding_check_size - 1 << "] = " << readin[proceeding_check_size - 1] << endline_flush;
    logger << LOG_DEBUG << "# MC_tau end: proceeding_check_size = " << proceeding_check_size << endline_flush;

    
    if (csi->class_contribution_CS_real){
      for (int i_a = 1; i_a < psi->MC_x_dipole.size(); i_a++){
	logger << LOG_DEBUG << "# MC_x_dipole[" << i_a << "]   proceeding_check_size (before) = " << proceeding_check_size << endline_flush;
	if (psi->MC_x_dipole[i_a].active_optimization != -1){
	  proceeding_check_size += 1;
	  if (!check_proceeding_in(readin)){return;}
	  int temp_psi_MC_x_dipole_i_a_end_optimization = atoi(readin[proceeding_check_size - 1].c_str());
	  logger << LOG_DEBUG << "# temp_psi_MC_x_dipole[" << i_a << "]   end_optimization = " << temp_psi_MC_x_dipole_i_a_end_optimization << endline_flush;
	  proceeding_check_size += psi->MC_x_dipole[i_a].n_channel;
	  if (!check_proceeding_in(readin)){return;}
	  if (temp_psi_MC_x_dipole_i_a_end_optimization == 0){
	    proceeding_check_size += 1;
	    proceeding_check_size += 2;
	    if (!check_proceeding_in(readin)){return;}
	    int temp_n_opt_steps = atoi(readin[proceeding_check_size - 1].c_str());
	    logger << LOG_DEBUG << "# temp_psi_MC_x_dipole[" << i_a << "]   temp_n_opt_steps = " << temp_n_opt_steps << endline_flush;
	    proceeding_check_size += 3 * psi->MC_x_dipole[i_a].n_channel;
	    if (!check_proceeding_in(readin)){return;}
	    if (psi->MC_x_dipole[i_a].switch_validation_optimization){
	      proceeding_check_size += 2;
	      if (!check_proceeding_in(readin)){return;}
	      proceeding_check_size += temp_n_opt_steps; // -> diff_w
	      if (!check_proceeding_in(readin)){return;}
	      proceeding_check_size += temp_n_opt_steps * psi->MC_x_dipole[i_a].n_channel; // -> alpha_it
	      if (!check_proceeding_in(readin)){return;}
	    }
	  }
	}
      }
      logger << LOG_DEBUG << "# MC_x_dipole   finished   readin[" << proceeding_check_size - 1 << "] = " << readin[proceeding_check_size - 1] << endline_flush;
      logger << LOG_DEBUG << "# MC_x_dipole end: proceeding_check_size = " << proceeding_check_size << endline_flush;
    }


    // Add  switch_validation_optimization  distinction for IS variables !!!
  
    logger << LOG_DEBUG << "# IS_tau   proceeding_check_size (before) = " << proceeding_check_size << endline_flush;
    proceeding_check_size += 1;
    if (!check_proceeding_in(readin)){return;}
    int temp_psi_tau_opt_end = atoi(readin[proceeding_check_size - 1].c_str());
    logger << LOG_DEBUG << "# temp_psi_tau_opt_end = " << temp_psi_tau_opt_end << endline_flush;
    if (temp_psi_tau_opt_end != -1){
      proceeding_check_size += psi->IS_tau.n_gridsize;
      if (!check_proceeding_in(readin)){return;}
    }
    if (temp_psi_tau_opt_end == 0){
      proceeding_check_size += 2 + 4 * psi->IS_tau.n_gridsize;
      if (!check_proceeding_in(readin)){return;}
    }
    logger << LOG_DEBUG << "# tau_opt end: proceeding_check_size = " << proceeding_check_size << endline_flush;

    
    logger << LOG_DEBUG << "# IS_x1x2   proceeding_check_size (before) = " << proceeding_check_size << endline_flush;
    proceeding_check_size += 1;
    if (!check_proceeding_in(readin)){return;}
    int temp_psi_x1x2_opt_end = atoi(readin[proceeding_check_size - 1].c_str());
    logger << LOG_DEBUG << "# temp_psi_x1x2_opt_end = " << temp_psi_x1x2_opt_end << endline_flush;
    if (temp_psi_x1x2_opt_end != -1){
      proceeding_check_size += psi->IS_x1x2.n_gridsize;
      if (!check_proceeding_in(readin)){return;}
    }
    if (temp_psi_x1x2_opt_end == 0){
      proceeding_check_size += 2 + 4 * psi->IS_x1x2.n_gridsize;
      if (!check_proceeding_in(readin)){return;}
    }
    logger << LOG_DEBUG << "# x1x2_opt end: proceeding_check_size = " << proceeding_check_size << endline_flush;


    if (csi->class_contribution_collinear){
      logger << LOG_DEBUG << "# IS_z1z2   proceeding_check_size (before) = " << proceeding_check_size << endline_flush;
      for (int i_z = 1; i_z < 3; i_z++){
	proceeding_check_size += 1;
	if (!check_proceeding_in(readin)){return;}
	int temp_psi_z1z2_opt_end = atoi(readin[proceeding_check_size - 1].c_str());
	logger << LOG_DEBUG << "# temp_psi_z1z2_opt_end = " << temp_psi_z1z2_opt_end << endline_flush;
	if (temp_psi_z1z2_opt_end != -1){
	  proceeding_check_size += psi->input_IS_z1z2.n_gridsize;
	  if (!check_proceeding_in(readin)){return;}
	  if (temp_psi_z1z2_opt_end == 0){
	    proceeding_check_size += 2 + 4 * psi->input_IS_z1z2.n_gridsize;
	    if (!check_proceeding_in(readin)){return;}
	  }
	}
	logger << LOG_DEBUG << "# TSV z1z2_opt end: proceeding_check_size = " << proceeding_check_size << endline_flush;
      }
    }

    
    if (csi->class_contribution_QT_powercorrection){
      logger << LOG_DEBUG << "# IS_qTres   proceeding_check_size (before) = " << proceeding_check_size << endline_flush;
      proceeding_check_size += 1;
      if (!check_proceeding_in(readin)){return;}
      int temp_psi_qTres_opt_end = atoi(readin[proceeding_check_size - 1].c_str());
      logger << LOG_DEBUG << "# temp_psi_qTres_opt_end = " << temp_psi_qTres_opt_end << endline_flush;
      if (temp_psi_qTres_opt_end != -1){
	proceeding_check_size += psi->IS_qTres.n_gridsize;
	if (!check_proceeding_in(readin)){return;}
      }
      if (temp_psi_qTres_opt_end == 0){
	proceeding_check_size += 2 + 4 * psi->IS_qTres.n_gridsize;
	if (!check_proceeding_in(readin)){return;}
      }
      logger << LOG_DEBUG << "# qTres_opt end: proceeding_check_size = " << proceeding_check_size << endline_flush;
    }

    
    if (switch_resummation){
      logger << LOG_DEBUG << "# IS_qTres   proceeding_check_size (before) = " << proceeding_check_size << endline_flush;
      proceeding_check_size += 1;
      if (!check_proceeding_in(readin)){return;}
      int temp_psi_qTres_opt_end = atoi(readin[proceeding_check_size - 1].c_str());
      logger << LOG_DEBUG << "# temp_psi_qTres_opt_end = " << temp_psi_qTres_opt_end << endline_flush;
      if (temp_psi_qTres_opt_end != -1){
	proceeding_check_size += psi->IS_qTres.n_gridsize;
	if (!check_proceeding_in(readin)){return;}
      }
      if (temp_psi_qTres_opt_end == 0){
	proceeding_check_size += 2 + 4 * psi->IS_qTres.n_gridsize;
	if (!check_proceeding_in(readin)){return;}
      }
      logger << LOG_DEBUG << "# qTres_opt end: proceeding_check_size = " << proceeding_check_size << endline_flush;
    }

    
    logger << LOG_DEBUG << "before psi->random_manager.proceeding_in" << endline_flush;

    proceeding_check_size += 1;
    if (!check_proceeding_in(readin)){return;}
    int temp_psi_randommanager_end_optimization = atoi(readin[proceeding_check_size - 1].c_str());
    if (temp_psi_randommanager_end_optimization != 2){
      logger << LOG_DEBUG << "# temp_psi_randommanager_end_optimization = " << temp_psi_randommanager_end_optimization << endline_flush;
      psi->random_manager.check_proceeding_in(int_end, proceeding_check_size, readin);
      logger << LOG_DEBUG << "# random_manager end: proceeding_check_size = " << proceeding_check_size << endline_flush;
      logger << LOG_DEBUG << "after psi->random_manager.proceeding_in" << endline_flush;
    }
  }

  
  // Create  check_proceeding_in  functions for multichannel_set and importancesampling_set !!!

  logger << LOG_INFO << "Checking expected content of proceeding_in succesfully finished:" << endl;
  logger << LOG_INFO << "proceeding_check_size = " << proceeding_check_size << " ? " << readin.size() << " = readin.size()" << endl;



  int proc = 0;
  psi->rng.proceeding_in(proc, readin);
  h = atoi(readin[proc++].c_str());
  min = atoi(readin[proc++].c_str());
  sec = atoi(readin[proc++].c_str());
  sec_import = sec + 60 * min + 3600 * h;
  logger << LOG_DEBUG << "Imported runtime: " << h << " h " << min << " min " << sec << " sec   ->   sec_import = " << sec_import << endline_flush;
  psi->i_step = atoi(readin[proc++].c_str());
  int temp_n_repetition = atoi(readin[proc++].c_str());
  int temp_n_events_max = atol(readin[proc++].c_str());
  int temp_switch_enforce_step_efficiency = atoi(readin[proc++].c_str());
  int temp_enforce_step_efficiency = atoi(readin[proc++].c_str());
  int temp_switch_enforce_step_time = atoi(readin[proc++].c_str());
  int temp_enforce_step_time = atoi(readin[proc++].c_str());
  logger << LOG_DEBUG << "Imported steps: i_step = " << psi->i_step << "  out of  " << temp_n_repetition << "  steps" << endline_flush;
  logger << LOG_DEBUG << "Setup of previous run:" << endline_flush;
  logger << LOG_DEBUG << "switch_enforce_step_efficiency = " << temp_switch_enforce_step_efficiency << "   enforce_step_efficiency = " << temp_enforce_step_efficiency << endline_flush;
  logger << LOG_DEBUG << "switch_enforce_step_time = " << temp_switch_enforce_step_time << "   enforce_step_time = " << temp_enforce_step_time << endline_flush;
  // Reset  i_step somehow if temp_n_repetition = psi_i_step  in order to allow continuation of runs with more events !!!
  
  psi->i_gen = atol(readin[proc++].c_str());
  psi->i_acc = atol(readin[proc++].c_str());
  psi->i_rej = atol(readin[proc++].c_str());
  psi->i_tec = atoi(readin[proc++].c_str());
  psi->i_nan = atoi(readin[proc++].c_str());
  logger << LOG_DEBUG << "Imported events: i_gen = " << psi->i_gen << "   i_acc = " << psi->i_acc << "   i_rej = " << psi->i_rej << "   i_tec = " << psi->i_tec << "   i_nan = " << psi->i_nan << endline_flush;

  ///  psi->last_step_mode = *psi->i_step_mode;

  full_sum_weight = hexastr2double(readin[proc]);
  full_sum_weight2 = hexastr2double(readin[proc + 1]);
  proc += 2;
  logger << LOG_DEBUG << "# standard end: proc = " << proc << endline_flush;
  if (switch_CV){
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      for (int i_s = 0; i_s < n_scales_CV; i_s++){
	full_sum_weight_CV[i_q][i_s] = hexastr2double(readin[proc++]);
	full_sum_weight2_CV[i_q][i_s] = hexastr2double(readin[proc++]);
      }
    }
    logger << LOG_DEBUG << "# CV end: proc = " << proc << endline_flush;
  }

  if (switch_moment){
    for (int i_m = 0; i_m < n_moments; i_m++){
      full_sum_moment[i_m] = hexastr2double(readin[proc++]);
      full_sum_moment2[i_m] = hexastr2double(readin[proc++]);
      if (switch_CV){
	for (int i_q = 0; i_q < output_n_qTcut; i_q++){
	  for (int i_s = 0; i_s < n_scales_CV; i_s++){
	    full_sum_moment_CV[i_m][i_q][i_s] = hexastr2double(readin[proc++]);
	    full_sum_moment2_CV[i_m][i_q][i_s] = hexastr2double(readin[proc++]);
	  }
	}
      }
    }
    logger << LOG_DEBUG << "# n_moments end: proc = " << proc << endline_flush;
  }

  if (switch_distribution){
    for (int i_d = 0; i_d < dat.size(); i_d++){
      for (int i_b = 0; i_b < dat[i_d].n_bins; i_b++){
	bin_counts[i_d][i_b] = atoi(readin[proc++].c_str());
	bin_weight[i_d][i_b] = hexastr2double(readin[proc++]);
	bin_weight2[i_d][i_b] = hexastr2double(readin[proc++]);
	if (switch_CV){
	  for (int i_s = 0; i_s < n_scales_CV; i_s++){
	    bin_weight_CV[i_s][i_d][i_b] = hexastr2double(readin[proc++]);
	    bin_weight2_CV[i_s][i_d][i_b] = hexastr2double(readin[proc++]);
	  }
	}
      }
    }
    for (int i_ddd = 0; i_ddd < dddat.size(); i_ddd++){
      for (int i_b = 0; i_b < dddat[i_ddd].n_bins; i_b++){
	bin_counts[dat.size() + i_ddd][i_b] = atoi(readin[proc++].c_str());
	bin_weight[dat.size() + i_ddd][i_b] = hexastr2double(readin[proc++]);
	bin_weight2[dat.size() + i_ddd][i_b] = hexastr2double(readin[proc++]);
	if (switch_CV){
	  for (int i_s = 0; i_s < n_scales_CV; i_s++){
	    bin_weight_CV[i_s][dat.size() + i_ddd][i_b] = hexastr2double(readin[proc++]);
	    bin_weight2_CV[i_s][dat.size() + i_ddd][i_b] = hexastr2double(readin[proc++]);
	  }
	}
      }
    }
    logger << LOG_DEBUG << "# distribution end: proc = " << proc << endline_flush;
  }

  if (switch_TSV){
    logger << LOG_DEBUG << "# TSV input started" << endline_flush;
    logger << LOG_DEBUG << "# TSV size start: proc = " << proc << endline_flush;
    for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
      for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	  fullsum_weight_TSV[i_s][i_r][i_f] = hexastr2double(readin[proc++]);
	  fullsum_weight2_TSV[i_s][i_r][i_f] = hexastr2double(readin[proc++]);
	}
      }
      if (active_qTcut){
	for (int i_q = 0; i_q < output_n_qTcut; i_q++){
	  for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	    for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	      fullsum_weight_qTcut_TSV[i_s][i_q][i_r][i_f] = hexastr2double(readin[proc++]);
	      fullsum_weight2_qTcut_TSV[i_s][i_q][i_r][i_f] = hexastr2double(readin[proc++]);
	    }
	  }
	}
      }
    }
    for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
      if (!switch_moment_TSV[i_s]){continue;}
      for (int i_m = 0; i_m < n_moments; i_m++){
	for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	    fullsum_moment_TSV[i_s][i_m][i_r][i_f] = hexastr2double(readin[proc++]);
	    fullsum_moment2_TSV[i_s][i_m][i_r][i_f] = hexastr2double(readin[proc++]);
	  }
	}
      }
    }
    logger << LOG_DEBUG_VERBOSE << "no_qTcut_distribution.size() = " << no_qTcut_distribution.size() << endline_flush;
    for (int x_q = 0; x_q < no_qTcut_distribution.size(); x_q++){
      logger << LOG_DEBUG_VERBOSE << "no_qTcut_distribution[" << x_q << "] = " << no_qTcut_distribution[x_q] << "   selection_qTcut_distribution[" << x_q << "] = " << no_qTcut_distribution[x_q] << endline_flush;
    }
    int next_no_qTcut = 0;
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      if (next_no_qTcut == no_qTcut_distribution.size()){continue;}
      if (i_q != no_qTcut_distribution[next_no_qTcut]){continue;}
      logger << LOG_DEBUG_VERBOSE << "next_no_qTcut = " << next_no_qTcut << "   " << no_qTcut_distribution.size() << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "no_qTcut_distribution[" << next_no_qTcut << "] = " << no_qTcut_distribution[next_no_qTcut] << endline_flush;
      logger << LOG_DEBUG_VERBOSE << "readin at i_q = " << i_q << "   proc = " << proc << endline_flush;
      for (int i_d = 0; i_d < dat.size(); i_d++){
	for (int i_b = 0; i_b < dat[i_d].n_bins; i_b++){
	  bin_count_TSV[i_q][i_d][i_b] = atoi(readin[proc++].c_str());
	  for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
	    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][i_b] = hexastr2double(readin[proc++]);
		bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][i_b] = hexastr2double(readin[proc++]);
	      }
	    }
	  }
	}
      }
      for (int i_d = 0; i_d < dddat.size(); i_d++){
	int i_ddd = dat.size() + i_d;
	for (int i_b = 0; i_b < dddat[i_d].n_bins; i_b++){
	  bin_count_TSV[i_q][i_ddd][i_b] = atoi(readin[proc++].c_str());
	  for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
	    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		bin_weight_TSV[i_s][i_q][i_r][i_f][i_ddd][i_b] = hexastr2double(readin[proc++]);
		bin_weight2_TSV[i_s][i_q][i_r][i_f][i_ddd][i_b] = hexastr2double(readin[proc++]);
	      }
	    }
	  }
	}
      }
      logger << LOG_DEBUG << "Before: next_no_qTcut = " << next_no_qTcut << "   i_q = " << i_q << "   no_qTcut_distribution[" << next_no_qTcut << "] = "<< no_qTcut_distribution[next_no_qTcut] << endline_flush;
      next_no_qTcut++;
    }
    logger << LOG_DEBUG << "# TSV size end: proc = " << proc << endline_flush;
    logger << LOG_DEBUG << "# TSV input finished" << endline_flush;
  }


  psi->end_optimization = atoi(readin[proc++].c_str());
  if (psi->end_optimization != 2){
    psi->MC_phasespace.proceeding_in(proc, readin);
    logger << LOG_DEBUG << "# MC_phasespace end: proc = " << proc << endline_flush;
    psi->MC_tau.proceeding_in(proc, readin);
    logger << LOG_DEBUG << "# MC_tau end: proc = " << proc << endline_flush;
    if (csi->class_contribution_CS_real){for (int i_a = 1; i_a < psi->MC_x_dipole.size(); i_a++){psi->MC_x_dipole[i_a].proceeding_in(proc, readin);}}
    logger << LOG_DEBUG << "# MC_x_dipole end: proc = " << proc << endline_flush;
    psi->IS_tau.proceeding_in(proc, readin);
    logger << LOG_DEBUG << "# tau_opt end: proc = " << proc << endline_flush;
    psi->IS_x1x2.proceeding_in(proc, readin);
    logger << LOG_DEBUG << "# x1x2_opt end: proc = " << proc << endline_flush;
    if (csi->class_contribution_collinear){for (int i_z = 1; i_z < 3; i_z++){psi->IS_z1z2[i_z].proceeding_in(proc, readin);}}
    logger << LOG_DEBUG << "# TSV z1z2_opt end: proc = " << proc << endline_flush;
    if (csi->class_contribution_QT_powercorrection){psi->IS_qTres.proceeding_in(proc, readin);}
    if (switch_resummation){psi->IS_qTres.proceeding_in(proc, readin);}
    logger << LOG_DEBUG << "# TSV qTres_opt end: proc = " << proc << endline_flush;
    psi->random_manager.end_optimization = atoi(readin[proc++].c_str());
    if (psi->random_manager.end_optimization != 2){psi->random_manager.proceeding_in(proc, readin);}
    logger << LOG_DEBUG << "# random_manager end: proc = " << proc << endline_flush;
  }
  
  for (int j = 0; j < psi->tau_MC_tau_gamma[0].size(); j++){logger << LOG_DEBUG_VERBOSE << "tau_MC_tau_gamma[0][" << j << "]" << " = " << setprecision(20) << setw(28) << psi->tau_MC_tau_gamma[0][j] << "   " << double2hexastr(psi->tau_MC_tau_gamma[0][j]) << endline_flush;}

  // if (psi->i_step == temp_n_repetition){
  logger << LOG_DEBUG << "Integration has already finished, but might be continued with increased event numbers..." << endline_flush;
  bool switch_continue = false;
  if (psi->switch_step_mode_grid){psi->i_step_mode = & psi->i_gen_step;}
  else {psi->i_step_mode = & psi->i_acc_step;}
    
  if (psi->n_events_max > temp_n_events_max){switch_continue = true;}
  if (*psi->i_step_mode < psi->n_events_max && psi->switch_step_mode_grid == 0 && switch_enforce_step_efficiency && enforce_step_efficiency > temp_enforce_step_efficiency){switch_continue = true;}
  if (*psi->i_step_mode < psi->n_events_max && temp_switch_enforce_step_efficiency > switch_enforce_step_efficiency){switch_continue = true;}
  if (*psi->i_step_mode < psi->n_events_max && switch_enforce_step_time && enforce_step_time > temp_enforce_step_time){switch_continue = true;}
  if (*psi->i_step_mode < psi->n_events_max && temp_switch_enforce_step_time > switch_enforce_step_time){switch_continue = true;}
    
  if (switch_continue){
    logger << LOG_INFO << "Already finished integration is continued after increasing number of requested events." << endline_flush;
    if (psi->switch_step_mode_grid == 0){
      psi->i_step = psi->i_acc / psi->n_step;
      psi->i_acc_step = psi->i_acc % psi->n_step;
      //	psi->i_gen_step = psi->i_gen / psi->i_acc * psi->i_acc_step;
      psi->i_gen_step = psi->i_gen - (psi->i_step * psi->n_step * psi->i_gen / psi->i_acc);
    }
    else if (psi->switch_step_mode_grid == 1){
      psi->i_step = psi->i_gen / psi->n_step;
      psi->i_gen_step = psi->i_gen % psi->n_step;
      psi->i_acc_step = psi->i_acc / psi->i_gen * psi->i_gen_step;
    }
  }
  // }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::perform_proceeding_out(){
  Logger logger("observable_set::perform_proceeding_out");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "filename_proceeding = " << filename_proceeding << endline_flush;
  ofstream out_proceeding;
  out_proceeding.open(filename_proceeding.c_str(), ofstream::out | ofstream::trunc);
  out_proceeding << "# random number generator (3)" << endline;
  psi->rng.proceeding_out(out_proceeding);
  out_proceeding << "# runtime: h (1) - min (1) - sec (1)" << endline;
  out_proceeding << h << endline;
  out_proceeding << min << endline;
  out_proceeding << sec << endline;
  out_proceeding << "# integration: i_step (1) - n_repetition (1) - n_events_max (1)" << endline;
  out_proceeding << psi->i_step << endline;
  out_proceeding << psi->n_repetition << endline;
  out_proceeding << psi->n_events_max << endline;
  out_proceeding << "# integration: switch_enforce_step_efficiency (1) -  enforce_step_efficiency(1)" << endline;
  out_proceeding << switch_enforce_step_efficiency << endline;
  out_proceeding << enforce_step_efficiency << endline;
  out_proceeding << "# integration: switch_enforce_step_time (1) - enforce_step_time (1)" << endline;
  out_proceeding << switch_enforce_step_time << endline;
  out_proceeding << enforce_step_time << endline;
  out_proceeding << "# events: i_gen (1) - i_acc (1) - i_rej (1) - i_tec (1) - i_nan (1)" << endline;
  out_proceeding << psi->i_gen << endline;
  out_proceeding << psi->i_acc << endline;
  out_proceeding << psi->i_rej << endline;
  out_proceeding << psi->i_tec << endline;
  out_proceeding << psi->i_nan << endline;
  out_proceeding << "# cross section: full_sum_weight - full_sum_weight2 (1 x 2)" << endline;
  out_proceeding << double2hexastr(full_sum_weight) << endline;
  out_proceeding << double2hexastr(full_sum_weight2) << endline;

  if (switch_CV){
    out_proceeding << "# cross section CV: full_sum_weight - full_sum_weight2 (" << n_qTcut << " x " << n_scales_CV << " x 2)" << endline;
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      for (int i_s = 0; i_s < n_scales_CV; i_s++){
	out_proceeding << double2hexastr(full_sum_weight_CV[i_q][i_s]) << endline;
	out_proceeding << double2hexastr(full_sum_weight2_CV[i_q][i_s]) << endline;
      }
    }
  }

  if (switch_moment){
    out_proceeding << "# moments: full_sum_moment - full_sum_moment2 (" << n_moments << " x 2)" << endline;
    for (int i_m = 0; i_m < n_moments; i_m++){
      out_proceeding << double2hexastr(full_sum_moment[i_m]) << endline;
      out_proceeding << double2hexastr(full_sum_moment2[i_m]) << endline;
    }
    if (switch_CV){
      out_proceeding << "# cross section CV: full_sum_moment - full_sum_moment2 (" << n_moments << " x "  << n_qTcut << " x " << n_scales_CV << " x 2)" << endline;
      for (int i_m = 0; i_m < n_moments; i_m++){
	for (int i_q = 0; i_q < n_qTcut; i_q++){
	  for (int i_s = 0; i_s < n_scales_CV; i_s++){
	    out_proceeding << double2hexastr(full_sum_moment_CV[i_m][i_q][i_s]) << endline;
	    out_proceeding << double2hexastr(full_sum_moment2_CV[i_m][i_q][i_s]) << endline;
	  }
	}
      }
    }
  }

  if (switch_distribution){
    // Could be merged by using 'extended_dat' !!!
    for (int i_d = 0; i_d < dat.size(); i_d++){
      out_proceeding << "# distribution CV: bin_counts - bin_weight - bin_weight2 (" << dat[i_d].n_bins << " x 3 + " << n_scales_CV << " x " << dat[i_d].n_bins << " x 2)" << endline;
      for (int i_b = 0; i_b < dat[i_d].n_bins; i_b++){
	out_proceeding << setprecision(18) << bin_counts[i_d][i_b] << endline;
	out_proceeding << double2hexastr(bin_weight[i_d][i_b]) << endline;
	out_proceeding << double2hexastr(bin_weight2[i_d][i_b]) << endline;
	if (switch_CV){
	  for (int i_s = 0; i_s < n_scales_CV; i_s++){
	    out_proceeding << double2hexastr(bin_weight_CV[i_s][i_d][i_b]) << endline;
	    out_proceeding << double2hexastr(bin_weight2_CV[i_s][i_d][i_b]) << endline;
	  }
	}
      }
    }
    for (int i_ddd = 0; i_ddd < dddat.size(); i_ddd++){
      out_proceeding << "# dddistribution CV: bin_counts - bin_weight - bin_weight2 (" << dddat[i_ddd].n_bins << " x 3 + " << n_scales_CV << " x " << dddat[i_ddd].n_bins << " x 2)" << endline;
      for (int i_b = 0; i_b < dddat[i_ddd].n_bins; i_b++){
	out_proceeding << setprecision(18) << bin_counts[dat.size() + i_ddd][i_b] << endline;
	out_proceeding << double2hexastr(bin_weight[dat.size() + i_ddd][i_b]) << endline;
	out_proceeding << double2hexastr(bin_weight2[dat.size() + i_ddd][i_b]) << endline;
	if (switch_CV){
	  for (int i_s = 0; i_s < n_scales_CV; i_s++){
	    out_proceeding << double2hexastr(bin_weight_CV[i_s][dat.size() + i_ddd][i_b]) << endline;
	    out_proceeding << double2hexastr(bin_weight2_CV[i_s][dat.size() + i_ddd][i_b]) << endline;
	  }
	}
      }
    }
  }

  if (switch_TSV){
    out_proceeding << "# TSV output" << endline;
    for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
      out_proceeding << "# cross section TSV (" << name_set_TSV[i_s] << "): fullsum_weight_TSV - fullsum_weight2_TSV (" << n_scale_fact_TSV[i_s] << " x " << n_scale_ren_TSV[i_s] << " x 2)" << endline;
      for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	  out_proceeding << double2hexastr(fullsum_weight_TSV[i_s][i_r][i_f]) << endline;
	  out_proceeding << double2hexastr(fullsum_weight2_TSV[i_s][i_r][i_f]) << endline;
	}
      }
      if (active_qTcut){
      out_proceeding << "# cross section qTcut TSV (" << name_set_TSV[i_s] << "): fullsum_weight_TSV - fullsum_weight2_TSV (" << n_qTcut << " x " << n_scale_fact_TSV[i_s] << " x " << n_scale_ren_TSV[i_s] << " x 2)" << endline;
	for (int i_q = 0; i_q < n_qTcut; i_q++){
	  for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	    for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	      out_proceeding << double2hexastr(fullsum_weight_qTcut_TSV[i_s][i_q][i_r][i_f]) << endline;
	      out_proceeding << double2hexastr(fullsum_weight2_qTcut_TSV[i_s][i_q][i_r][i_f]) << endline;
	    }
	  }
	}
      }
    }
    for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
      if (!switch_moment_TSV[i_s]){continue;}
      out_proceeding << "# moments TSV (" << name_set_TSV[i_s] << "): fullsum_weight_TSV - fullsum_weight2_TSV (" << n_moments << " x " << n_scale_fact_TSV[i_s] << " x " << n_scale_ren_TSV[i_s] << " x 2)" << endline;
      for (int i_m = 0; i_m < n_moments; i_m++){
	for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
	    out_proceeding << double2hexastr(fullsum_moment_TSV[i_s][i_m][i_r][i_f]) << endline;
	    out_proceeding << double2hexastr(fullsum_moment2_TSV[i_s][i_m][i_r][i_f]) << endline;
	  }
	}
      }
    }
    int next_no_qTcut = 0;
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      if (next_no_qTcut == no_qTcut_distribution.size()){continue;}
      if (i_q != no_qTcut_distribution[next_no_qTcut]){continue;}
      if (active_qTcut == 0){out_proceeding << "#   no qTcut" << endline;}
      else {out_proceeding << "#   qTcut[" << setw(3) << i_q << "] = " << setw(15) << setprecision(8) << value_qTcut[i_q] << endline;}
      for (int i_d = 0; i_d < dat.size(); i_d++){
	out_proceeding << "#" << char(9) << dat[i_d].xdistribution_name << endline;
	for (int i_b = 0; i_b < dat[i_d].n_bins; i_b++){
	  out_proceeding << bin_count_TSV[i_q][i_d][i_b] << endline;
	  for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
	    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		out_proceeding << double2hexastr(bin_weight_TSV[i_s][i_q][i_r][i_f][i_d][i_b]) << endline;
		out_proceeding << double2hexastr(bin_weight2_TSV[i_s][i_q][i_r][i_f][i_d][i_b]) << endline;
	      }
	    }
	  }
	}
      }
      for (int i_d = 0; i_d < dddat.size(); i_d++){
	int i_ddd = dat.size() + i_d;
	out_proceeding << "#" << char(9) << dddat[i_d].name << endline;
	for (int i_b = 0; i_b < dddat[i_d].n_bins; i_b++){
	  out_proceeding << bin_count_TSV[i_q][i_ddd][i_b] << endline;
	  for (int i_s = 0; i_s < n_extended_set_TSV; i_s++){
	    for (int i_r = 0; i_r < n_scale_ren_TSV[i_s]; i_r++){
	      for (int i_f = 0; i_f < n_scale_fact_TSV[i_s]; i_f++){
		out_proceeding << double2hexastr(bin_weight_TSV[i_s][i_q][i_r][i_f][i_ddd][i_b]) << endline;
		out_proceeding << double2hexastr(bin_weight2_TSV[i_s][i_q][i_r][i_f][i_ddd][i_b]) << endline;
	      }
	    }
	  }
	}
      }
      next_no_qTcut++;
    }
  }

  // One could avoid all the following output for the case of a completely finalized optimization phase (like in all standard non-grid runs) !!!
  // Introduce a general switch like e.g. 'opt_end', and the following is only written if that switch is 0 (or the other way round) !!!
  out_proceeding << "# end_optimization output" << endline;
  out_proceeding << psi->end_optimization << endline;
  if (psi->end_optimization != 2){
    psi->MC_phasespace.proceeding_out(out_proceeding);
    psi->MC_tau.proceeding_out(out_proceeding);
    if (csi->class_contribution_CS_real){for (int i_a = 1; i_a < psi->MC_x_dipole.size(); i_a++){psi->MC_x_dipole[i_a].proceeding_out(out_proceeding);}}
    psi->IS_tau.proceeding_out(out_proceeding);
    psi->IS_x1x2.proceeding_out(out_proceeding);
    if (csi->class_contribution_collinear){for (int i_z = 1; i_z < 3; i_z++){psi->IS_z1z2[i_z].proceeding_out(out_proceeding);}}
    if (csi->class_contribution_QT_powercorrection){psi->IS_qTres.proceeding_out(out_proceeding);}
    if (switch_resummation){psi->IS_qTres.proceeding_out(out_proceeding);}
    out_proceeding << "# random_manager" << endline;
    out_proceeding << psi->random_manager.end_optimization << endline;
    if (psi->random_manager.end_optimization != 2){psi->random_manager.proceeding_out(out_proceeding);}
  }

  out_proceeding.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::perform_proceeding_check(){
  Logger logger("observable_set::perform_proceeding_check");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  double Xsection_delta = sqrt((full_sum_weight2 - pow(full_sum_weight, 2) / psi->i_gen)) / (psi->i_gen - 1);
  double Xsection = full_sum_weight / psi->i_gen;
  double weights2_NLO_LO = abs(Xsection_delta / sigma_normalization);

  logger << LOG_DEBUG << "Xsection_delta = " << Xsection_delta << endline_flush;
  logger << LOG_DEBUG << "Xsection = " << Xsection << endline_flush;
  logger << LOG_DEBUG << "weights2_NLO_LO = " << weights2_NLO_LO << endline_flush;
  logger << LOG_DEBUG << "sigma_LO = " << sigma_normalization << endline_flush;
  logger << LOG_DEBUG << "n_events_max = " << psi->n_events_max << endline_flush;
  logger << LOG_DEBUG << "n_step = " << psi->n_step << endline_flush;
  logger << LOG_DEBUG << "psi->i_acc = " << psi->i_acc << endline_flush;
  logger << LOG_DEBUG << "sigma_LO_deviation = " << sigma_normalization_deviation << endline_flush;
  logger << LOG_DEBUG << "switch_output_proceeding = " << switch_output_proceeding << endline_flush;
  /*
  logger << LOG_INFO << "(psi->i_acc >= n_events_max) = " << (psi->i_acc >= psi->n_events_max) << endline;
  logger << LOG_DEBUG << "(psi->i_acc >= n_events_max - n_step) = " << (psi->i_acc >= psi->n_events_max - psi->n_step) << endline_flush;
  logger << LOG_DEBUG << "(psi->i_acc >= n_events_min && weights2_NLO_LO < sigma_LO_deviation) = " << (psi->i_acc >= psi->n_events_min && weights2_NLO_LO < sigma_normalization_deviation) << endline_flush;
  if (((psi->i_acc >= psi->n_events_max) && switch_output_proceeding == 1) ||
      ((psi->i_acc >= psi->n_events_max - psi->n_step) && switch_output_proceeding == 2) ||
      ((psi->i_acc >= psi->n_events_min) && (weights2_NLO_LO < sigma_normalization_deviation) && (psi->switch_n_events_opt != 2)) ||
      ((psi->i_step >= psi->n_repetition) && switch_output_proceeding == 1) ||
      ((psi->i_step >= psi->n_repetition - 1) && switch_output_proceeding == 2)){int_end = 1;}
  logger << LOG_DEBUG << "int_end = " << int_end << endline_flush;
  */
  if (psi->i_acc >= psi->n_events_max && switch_output_proceeding == 1){
    logger << LOG_INFO << "(psi->i_acc >= n_events_max) = " << (psi->i_acc >= psi->n_events_max) << endline;
    logger << LOG_INFO << "switch_output_proceeding = " << switch_output_proceeding << endline;
    int_end = 1;
    logger << LOG_INFO << "int_end = " << int_end << endline_flush;
  }
  else if ((psi->i_acc >= psi->n_events_max - psi->n_step) && switch_output_proceeding == 2){
    logger << LOG_INFO << "(psi->i_acc >= n_events_max - psi->n_step) = " << (psi->i_acc >= psi->n_events_max - psi->n_step) << endline;
    logger << LOG_INFO << "switch_output_proceeding = " << switch_output_proceeding << endline;
    int_end = 1;
    logger << LOG_INFO << "int_end = " << int_end << endline_flush;
  }
  else if ((psi->i_acc >= psi->n_events_min) && (weights2_NLO_LO < sigma_normalization_deviation) && (psi->switch_n_events_opt != 2)){
    logger << LOG_INFO << "(psi->i_acc >= psi->n_events_min) = " << (psi->i_acc >= psi->n_events_min) << endline_flush;
    logger << LOG_INFO << "(weights2_NLO_LO < sigma_normalization_deviation) = " << (weights2_NLO_LO < sigma_normalization_deviation) << endline_flush;
    logger << LOG_INFO << "(psi->switch_n_events_opt != 2) = " << (psi->switch_n_events_opt != 2) << endline_flush;
    int_end = 1;
    logger << LOG_INFO << "int_end = " << int_end << endline_flush;
  }
  else if (psi->i_step >= psi->n_repetition && switch_output_proceeding == 1){
    logger << LOG_INFO << " = " << endline_flush;
    logger << LOG_INFO << " = " << endline_flush;
    int_end = 1;
    logger << LOG_INFO << "int_end = " << int_end << endline_flush;
  }
  else if ((psi->i_step >= psi->n_repetition - 1) && switch_output_proceeding == 2){
    logger << LOG_INFO << " = " << endline_flush;
    logger << LOG_INFO << " = " << endline_flush;
    int_end = 1;
    logger << LOG_INFO << "int_end = " << int_end << endline_flush;
  }
    
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
