#include "header.hpp"

void observable_set::determine_CX_QCD(int n_emission){
  Logger logger("observable_set::determine_CX_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int temp_n_emission = n_emission;
  if (csi->switch_VTX){temp_n_emission = 0;}
  
  logger << LOG_DEBUG << "multicollinear determination" << endline_flush;
  logger.newLine(LOG_DEBUG);

  //  vector<string> pa_name(csi->type_parton[0].size(), "");
  vector<string> pa_name(3, "");
  if (csi->type_parton[0][1] >= -10 && csi->type_parton[0][1] <= 10){pa_name[1] = "a";}
  if (csi->type_parton[0][2] >= -10 && csi->type_parton[0][2] <= 10){pa_name[2] = "b";}
  //  for (int i_p = 3; i_p < pa_name.size(); i_p++){if (csi->type_parton[0][i_p] >= -10 && csi->type_parton[0][i_p] <= 10){pa_name[i_p] = char(105 + i_p - 3);}}
  //  for (int i_p = 3; i_p < pa_name.size(); i_p++){if (csi->type_parton[0][i_p] >= -10 && csi->type_parton[0][i_p] =< 10){pa_name[i_p] = alphabet[i_p - 3];}}
  //  new labels: omit colourless particles in counting
  //  for (int i_p = 3; i_p < pa_name.size(); i_p++){if (csi->type_parton[0][i_p] >= -10 && csi->type_parton[0][i_p] =< 10){pa_name[i_p] = alphabet[count++];}}

  logger << LOG_DEBUG_VERBOSE << "csi->no_process_parton[0] = " << csi->no_process_parton[0] << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "csi->type_parton[0].size() = " << csi->type_parton[0].size() << endline_flush;
  logger << LOG_DEBUG_VERBOSE << "csi->combination_pdf.size() = " << csi->combination_pdf.size() << endline_flush;

  multicollinear_set start_multicollinear(csi->no_process_parton[0], csi->type_parton[0], csi->combination_pdf);
  multicollinear.resize(1);
  multicollinear[0].push_back(start_multicollinear);
  logger << LOG_DEBUG << "multicollinear[" << setw(2) << 0 << "][" << 0 << "]" << endl << endl << output_ncollinear(multicollinear[0][0]) << endline_flush;

  for (int i_e = 1; i_e < temp_n_emission + 1; i_e++){
    //    logger << LOG_DEBUG_VERBOSE << "i_e = " << i_e << endline_flush;
    //    logger << LOG_DEBUG_VERBOSE << "multicollinear[i_e - 1 = " << i_e - 1 << "].size() = " << multicollinear[i_e - 1].size() << endline_flush;
    multicollinear.push_back(vector<multicollinear_set> (0));
    for (int i_c = 0; i_c < multicollinear[i_e - 1].size(); i_c++){
      //      logger << LOG_DEBUG_VERBOSE << "i_c = " << i_c << endline_flush;
      //      logger << LOG_DEBUG_VERBOSE << "multicollinear.size() = " << multicollinear.size() << endline_flush;
      //      logger << LOG_DEBUG_VERBOSE << "multicollinear[i_e = " << i_e << "].size() = " << multicollinear[i_e].size() << endline_flush;
      int x_c = 0;
      for (int temp_no_emitter = 1; temp_no_emitter < 3; temp_no_emitter++){
	logger << LOG_DEBUG << "temp_no_emitter = " << temp_no_emitter << endline_flush;
	if (pa_name[temp_no_emitter] == ""){continue;}
	if (temp_no_emitter < multicollinear[i_e - 1][i_c].no_emitter[i_e - 1]){continue;}
	for (int i_t = 0; i_t < 2; i_t++){
	  //	  logger << LOG_DEBUG_VERBOSE << "i_t = " << i_t << endline_flush;

	  x_c = multicollinear[i_e].size();
	  multicollinear[i_e].push_back(multicollinear[i_e - 1][i_c]);
	  multicollinear[i_e][x_c].no_emitter.push_back(temp_no_emitter);
	  multicollinear[i_e][x_c].in_collinear.push_back(vector<int> (3, 0));
	  multicollinear[i_e][x_c].in_collinear[i_e][temp_no_emitter] = 1;
	  multicollinear[i_e][x_c].charge_factor.push_back(1.);
	  multicollinear[i_e][x_c].type_correction.push_back(1);
	  multicollinear[i_e][x_c].previous_splitting.push_back(i_c);

	  multicollinear[i_e][x_c].n_emission[0]++;
	  multicollinear[i_e][x_c].n_emission[temp_no_emitter]++;
	  multicollinear[i_e][x_c].emission[temp_no_emitter] = 1;

	  multicollinear[i_e][x_c].n_emission_leg_type[0][0]++;
	  multicollinear[i_e][x_c].n_emission_leg_type[temp_no_emitter][0]++;

	  multicollinear[i_e][x_c].n_emission_leg_type[0][1]++;
	  multicollinear[i_e][x_c].n_emission_leg_type[temp_no_emitter][1]++;

	  logger << LOG_DEBUG_VERBOSE << "x_c = " << x_c << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "temp_no_emitter = " << temp_no_emitter << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "multicollinear.size() = " <<multicollinear.size()  << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "multicollinear[" << i_e << "].size() = " << multicollinear[i_e].size()  << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "multicollinear[" << i_e << "][" << x_c << "].pdf.size() = " << multicollinear[i_e][x_c].pdf.size()  << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "multicollinear[" << i_e << "][" << x_c << "].pdf[0].size() = " << multicollinear[i_e][x_c].pdf[0].size()  << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "multicollinear[" << i_e << "][" << x_c << "].pdf[0][" << temp_no_emitter << "] = " << multicollinear[i_e][x_c].pdf[0][temp_no_emitter] << endline_flush;
	  if (multicollinear[i_e][x_c].pdf[0][temp_no_emitter] == 0){
	    //	    logger << LOG_DEBUG_VERBOSE << "   i_t = " << i_t << endline_flush;
	    if (i_t == 0){
	      multicollinear[i_e][x_c].type_splitting.push_back(0); // hard process with g from g -> g g splitting
	      multicollinear[i_e][x_c].type_splitting_leg[temp_no_emitter].push_back(1); // hard process with g from g -> g g splitting
	      multicollinear[i_e][x_c].in_collinear[i_e][0] = 1;
	      multicollinear[i_e][x_c].name.insert(1, "_" + pa_name[temp_no_emitter] + "^{gg}");
	      //	      multicollinear[i_e][x_c].name = multicollinear[i_e][x_c].name + "_" + pa_name[temp_no_emitter] + "^{gg}";
	      for (int i_x = 0; i_x < multicollinear[i_e][x_c].pdf.size(); i_x++){multicollinear[i_e][x_c].all_name[i_x] = multicollinear[i_e][x_c].all_name[i_x] + "_" + pa_name[temp_no_emitter] + "^{gg}";}
	    }
	    else {
	      multicollinear[i_e][x_c].type_splitting.push_back(2); // hard process with g from q -> g q splitting
	      multicollinear[i_e][x_c].type_splitting_leg[temp_no_emitter].push_back(3); // hard process with g from q -> g q splitting
	      multicollinear[i_e][x_c].in_collinear[i_e][0] = 0;
	      multicollinear[i_e][x_c].name.insert(1, "_" + pa_name[temp_no_emitter] + "^{qg}");
	      //	      multicollinear[i_e][x_c].name = multicollinear[i_e][x_c].name + "_" + pa_name[temp_no_emitter] + "^{qg}";
	      for (int i_x = 0; i_x < multicollinear[i_e][x_c].pdf.size(); i_x++){multicollinear[i_e][x_c].all_name[i_x] = multicollinear[i_e][x_c].all_name[i_x] + "_" + pa_name[temp_no_emitter] + "^{qg}";}
	      for (int i_x = 0; i_x < multicollinear[i_e][x_c].pdf.size(); i_x++){multicollinear[i_e][x_c].pdf[i_x][temp_no_emitter] = 10;}
	    }
	    logger << LOG_DEBUG << "multicollinear[" << setw(2) << i_e << "][" << x_c << "]" << endl << endl << output_ncollinear(multicollinear[i_e][x_c]) << endline_flush;
	    logger << LOG_DEBUG_VERBOSE << "   i_t = " << i_t << endline_flush;
	  }
	  else if (multicollinear[i_e][x_c].pdf[0][temp_no_emitter] != 0){
	    if (i_t == 0){
	      multicollinear[i_e][x_c].type_splitting.push_back(3); // hard process with q from g -> q qx splitting
	      multicollinear[i_e][x_c].type_splitting_leg[temp_no_emitter].push_back(4); // hard process with q from g -> q qx splitting
	      multicollinear[i_e][x_c].in_collinear[i_e][0] = 0;
	      multicollinear[i_e][x_c].name.insert(1, "_" + pa_name[temp_no_emitter] + "^{g" + csi->name_particle[multicollinear[i_e][x_c].pdf[0][temp_no_emitter]] + "}");
	      //	      multicollinear[i_e][x_c].name = multicollinear[i_e][x_c].name + "_" + pa_name[temp_no_emitter] + "^{g" + csi->name_particle[multicollinear[i_e][x_c].pdf[0][temp_no_emitter]] + "}";
	      for (int i_x = 0; i_x < multicollinear[i_e][x_c].pdf.size(); i_x++){multicollinear[i_e][x_c].all_name[i_x] = multicollinear[i_e][x_c].all_name[i_x] + "_" + pa_name[temp_no_emitter] + "^{g" + csi->name_particle[multicollinear[i_e][x_c].pdf[i_x][temp_no_emitter]] + "}";}
	      for (int i_x = 0; i_x < multicollinear[i_e][x_c].pdf.size(); i_x++){multicollinear[i_e][x_c].pdf[i_x][temp_no_emitter] = 0;}
	    }
	    else {
	      multicollinear[i_e][x_c].type_splitting.push_back(1); // hard process with q from q -> q g splitting
	      multicollinear[i_e][x_c].type_splitting_leg[temp_no_emitter].push_back(2); // hard process with q from q -> q g splitting
	      multicollinear[i_e][x_c].in_collinear[i_e][0] = 1;
	      multicollinear[i_e][x_c].name.insert(1, "_" + pa_name[temp_no_emitter] + "^{" + csi->name_particle[multicollinear[i_e][x_c].pdf[0][temp_no_emitter]] + csi->name_particle[multicollinear[i_e][x_c].pdf[0][temp_no_emitter]] + "}");
	      //	      multicollinear[i_e][x_c].name = multicollinear[i_e][x_c].name + "_" + pa_name[temp_no_emitter] + "^{" + csi->name_particle[multicollinear[i_e][x_c].pdf[0][temp_no_emitter]] + csi->name_particle[multicollinear[i_e][x_c].pdf[0][temp_no_emitter]] + "}";
	      for (int i_x = 0; i_x < multicollinear[i_e][x_c].pdf.size(); i_x++){multicollinear[i_e][x_c].all_name[i_x] = multicollinear[i_e][x_c].all_name[i_x] + "_" + pa_name[temp_no_emitter] + "^{" + csi->name_particle[multicollinear[i_e][x_c].pdf[i_x][temp_no_emitter]] + csi->name_particle[multicollinear[i_e][x_c].pdf[i_x][temp_no_emitter]] + "}";}
	    }
	    logger << LOG_DEBUG << "multicollinear[" << setw(2) << i_e << "][" << x_c << "]" << endl << endl << output_ncollinear(multicollinear[i_e][x_c]) << endline_flush;
	  }
	}

	if (i_e < 2){continue;}

	// non-singlet contribution
	if (temp_no_emitter != multicollinear[i_e - 1][i_c].no_emitter[i_e - 1]){continue;}
	if (multicollinear[i_e - 1][i_c].type_splitting[i_e - 1] != 3){continue;}

	x_c = multicollinear[i_e].size();
	logger << LOG_DEBUG_VERBOSE << "x_c = " << x_c << endline_flush;
	multicollinear[i_e].push_back(multicollinear[i_e - 1][i_c]);
	multicollinear[i_e][x_c].no_emitter.push_back(temp_no_emitter);
	multicollinear[i_e][x_c].in_collinear.push_back(vector<int> (3, 0));
	multicollinear[i_e][x_c].in_collinear[i_e][temp_no_emitter] = 1;
	multicollinear[i_e][x_c].previous_splitting.push_back(i_c);
	multicollinear[i_e][x_c].charge_factor.push_back(1.);

	multicollinear[i_e][x_c].n_emission_leg_type[0][0]++;
	multicollinear[i_e][x_c].n_emission_leg_type[temp_no_emitter][0]++;

	multicollinear[i_e][x_c].type_correction.push_back(1);
	multicollinear[i_e][x_c].n_emission_leg_type[0][1]++;
	multicollinear[i_e][x_c].n_emission_leg_type[temp_no_emitter][1]++;
	
	multicollinear[i_e][x_c].n_emission[0]++;
	multicollinear[i_e][x_c].n_emission[temp_no_emitter]++;
	multicollinear[i_e][x_c].emission[temp_no_emitter] = 1;

	multicollinear[i_e][x_c].type_splitting.push_back(4); // selected(a-q) splitting
	multicollinear[i_e][x_c].type_splitting_leg[temp_no_emitter].push_back(5); // selected(a-q) splitting
	multicollinear[i_e][x_c].in_collinear[i_e][0] = 0;
	multicollinear[i_e][x_c].name.insert(1, "_" + pa_name[temp_no_emitter] + "^{" + csi->name_particle[-multicollinear[i_e - 2][multicollinear[i_e - 1][i_c].previous_splitting[i_e - 2]].pdf[0][temp_no_emitter]] + "g}");
	//	multicollinear[i_e][x_c].name = multicollinear[i_e][x_c].name + "_" + pa_name[temp_no_emitter] + "^{" + csi->name_particle[-multicollinear[i_e - 2][multicollinear[i_e - 1][i_c].previous_splitting[i_e - 2]].pdf[0][temp_no_emitter]] + "g}";
	for (int i_x = 0; i_x < multicollinear[i_e][x_c].pdf.size(); i_x++){multicollinear[i_e][x_c].all_name[i_x] = multicollinear[i_e][x_c].all_name[i_x] + "_" + pa_name[temp_no_emitter] + "^{" + csi->name_particle[-multicollinear[i_e - 2][multicollinear[i_e - 1][i_c].previous_splitting[i_e - 2]].pdf[i_x][temp_no_emitter]] + "g}";}
	for (int i_x = 0; i_x < multicollinear[i_e][x_c].pdf.size(); i_x++){multicollinear[i_e][x_c].pdf[i_x][temp_no_emitter] = -multicollinear[i_e - 2][multicollinear[i_e - 1][i_c].previous_splitting[i_e - 2]].pdf[i_x][temp_no_emitter];}
	// END non-singlet contribution
	logger << LOG_DEBUG << "multicollinear[" << right << setw(2) << i_e << "][" << x_c << "] (non-singlet)" << endl << endl << output_ncollinear(multicollinear[i_e][x_c]) << endline_flush;
      }
    }

    if (i_e < 2){continue;}

    // sort out splitting sequence leading to identical pdf's:
    logger << LOG_DEBUG << "sort out splitting sequence leading to identical pdf's:" << endline_flush;
    for (int i_c = 0; i_c < multicollinear[i_e].size(); i_c++){
      // hard process with q from  g -> q (qx) -> q (g) [42] is understood as part of  g -> g (g) -> q (qx) [14]
      if (multicollinear[i_e][i_c].type_splitting[i_e] == 0 && multicollinear[i_e][i_c].type_splitting[i_e - 1] == 3){
	for (int j_c = 0; j_c < multicollinear[i_e].size(); j_c++){
	  if (j_c == i_c){continue;}
	  if (multicollinear[i_e][j_c].type_splitting[i_e] == 3 &&
	      multicollinear[i_e][j_c].type_splitting[i_e - 1] == 1 &&
	      multicollinear[i_e][i_c].no_emitter[i_e] == multicollinear[i_e][j_c].no_emitter[i_e] &&
	      multicollinear[i_e][i_c].no_emitter[i_e - 1] == multicollinear[i_e][j_c].no_emitter[i_e - 1]){
	    logger << LOG_DEBUG << "multicollinear[" << right << setw(2) << i_e << "][" << setw(2) << j_c << "] = " << left << setw(25) << multicollinear[i_e][j_c].name << " assigned to  " << setw(25) << multicollinear[i_e][i_c].name << "  due to splitting sequences with identical pdf's (14)" << endline_flush;
	    multicollinear[i_e].erase(multicollinear[i_e].begin() + j_c);
	    break;
	  }
	}
      }
      // hard process with q from  g from Q -> g (Q) -> g (g) [31] is understood as part of  Q -> Q (g) -> g (Q) [23]
      else if (multicollinear[i_e][i_c].type_splitting[i_e] == 1 && multicollinear[i_e][i_c].type_splitting[i_e - 1] == 2){
	for (int j_c = 0; j_c < multicollinear[i_e].size(); j_c++){
	  if (j_c == i_c){continue;}
	  if (multicollinear[i_e][j_c].type_splitting[i_e] == 2 &&
		   multicollinear[i_e][j_c].type_splitting[i_e - 1] == 0 &&
		   multicollinear[i_e][i_c].no_emitter[i_e] == multicollinear[i_e][j_c].no_emitter[i_e] &&
		   multicollinear[i_e][i_c].no_emitter[i_e - 1] == multicollinear[i_e][j_c].no_emitter[i_e - 1]){
	    logger << LOG_DEBUG << "multicollinear[" << right << setw(2) << i_e << "][" << setw(2) << j_c << "] = " << left << setw(25) << multicollinear[i_e][j_c].name << " assigned to  " << setw(25) << multicollinear[i_e][i_c].name << "  due to splitting sequences with identical pdf's (23)" << endline_flush;
	    multicollinear[i_e].erase(multicollinear[i_e].begin() + j_c);
	    break;
	  }
	}
      }
      // hard process with g from g -> Q (Qx) -> g (Q) [43] is understood as part of  g -> g (g) -> g (g) [11]
      else if (multicollinear[i_e][i_c].type_splitting[i_e] == 0 && multicollinear[i_e][i_c].type_splitting[i_e - 1] == 0){
	for (int j_c = 0; j_c < multicollinear[i_e].size(); j_c++){
	  if (j_c == i_c){continue;}
	  if (multicollinear[i_e][j_c].type_splitting[i_e] == 3 &&
		   multicollinear[i_e][j_c].type_splitting[i_e - 1] == 2 &&
		   multicollinear[i_e][i_c].no_emitter[i_e] == multicollinear[i_e][j_c].no_emitter[i_e] &&
		   multicollinear[i_e][i_c].no_emitter[i_e - 1] == multicollinear[i_e][j_c].no_emitter[i_e - 1]){
	    logger << LOG_DEBUG << "multicollinear[" << right << setw(2) << i_e << "][" << setw(2) << j_c << "] = " << left << setw(25) << multicollinear[i_e][j_c].name << " assigned to  " << setw(25) << multicollinear[i_e][i_c].name << "  due to splitting sequences with identical pdf's (11)" << endline_flush;
	    multicollinear[i_e].erase(multicollinear[i_e].begin() + j_c);
	    break;
	  }
	}
      }
    }
    logger.newLine(LOG_DEBUG);
  }

  logger << LOG_DEBUG << "Final multicollinear, after removal of obsolete contributions:" << endline_flush;
  logger.newLine(LOG_DEBUG);
  for (int i_e = 0; i_e < multicollinear.size(); i_e++){
    for (int i_c = 0; i_c < multicollinear[i_e].size(); i_c++){
      logger << LOG_DEBUG << "multicollinear[" << setw(2) << i_e << "][" << i_c << "]" << endl << endl << output_ncollinear(multicollinear[i_e][i_c]) << endline_flush;
    }
  }
  logger.newLine(LOG_DEBUG);

  determine_CX_ncollinear_QCD(n_emission);

  perform_selection_content_pdf_list();
  // Order changed: output of determine_initial_channel used for removal !!!
  //  remove_empty_ncollinear();
  determine_initial_channel();
  remove_empty_ncollinear();

  //  output_CX_ncollinear_QCD();
  logger << LOG_DEBUG << "Final ncollinear, after removal PDF selection:" << endline_flush;
  for (int i_c = 0; i_c < ncollinear.size(); i_c++){
    logger << LOG_INFO << "ncollinear " << setw(2) << i_c << ":   " << endl << endl << output_ncollinear(ncollinear[i_c]) << endl;
  }
  logger.newLine(LOG_DEBUG);

  logger << LOG_DEBUG << "list_combination_pdf.size() = " << list_combination_pdf.size() << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::determine_CX_ncollinear_QCD(int n_emission){
  Logger logger("observable_set::determine_CX_ncollinear_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  //  vector<string> pa_name(csi->type_parton[0].size(), "");
  vector<string> pa_name(3, "");
  if (csi->type_parton[0][1] >= -10 && csi->type_parton[0][1] <= 10){pa_name[1] = "a";}
  if (csi->type_parton[0][2] >= -10 && csi->type_parton[0][2] <= 10){pa_name[2] = "b";}
  //  for (int i_p = 3; i_p < pa_name.size(); i_p++){if (csi->type_parton[0][i_p] >= -10 && csi->type_parton[0][i_p] <= 10){pa_name[i_p] = char(105 + i_p - 3);}}

  for (int i_e = 0; i_e < multicollinear.size(); i_e += n_emission){
    for (int i_c = 0; i_c < multicollinear[i_e].size(); i_c++){
      ncollinear.push_back(multicollinear[i_e][i_c]);
    }
  }

  for (int i_c = 0; i_c < ncollinear.size(); i_c++){
    // determine more general name
    stringstream temp;
    temp << "C";
    for (int i_e = 1; i_e < 3; i_e++){
      if (ncollinear[i_c].n_emission[i_e] == 0){continue;}
	//      if (ncollinear[i_c].n_emission[i_e] > 0){
      temp << "_" << pa_name[i_e];
      if (ncollinear[i_c].n_emission[i_e] > 1){temp << ncollinear[i_c].n_emission[i_e];}
      temp << "^{";
      temp << csi->name_particle[ncollinear[i_c].type_parton[i_e]] << csi->name_particle[ncollinear[i_c].pdf[0][i_e]];
      temp << "}";
	//      }
    }

    // determine more general all_name
    for (int i_a = 0; i_a < ncollinear[i_c].pdf.size(); i_a++){
      stringstream temp_all;
      temp_all << "C";
      for (int i_e = 1; i_e < 3; i_e++){
	if (ncollinear[i_c].n_emission[i_e] == 0){continue;}
	//      if (ncollinear[i_c].n_emission[i_e] > 0){
	temp_all << "_" << pa_name[i_e];
	if (ncollinear[i_c].n_emission[i_e] > 1){temp_all << ncollinear[i_c].n_emission[i_e];}
	temp_all << "^{";
	temp_all << csi->name_particle[ncollinear[0].pdf[i_a][i_e]] << csi->name_particle[ncollinear[i_c].pdf[i_a][i_e]];
	temp_all << "}";
	//      }
      }
      ncollinear[i_c].all_name[i_a] = temp_all.str();
    }

    // determine leg emission:
    if (ncollinear[i_c].n_emission_leg_type[1][0] > 0 && ncollinear[i_c].n_emission_leg_type[2][0] > 0){ncollinear[i_c].leg_emission = 0;}
    else if (ncollinear[i_c].n_emission_leg_type[1][0] > 0 && ncollinear[i_c].n_emission_leg_type[2][0] == 0){ncollinear[i_c].leg_emission = 1;}
    else if (ncollinear[i_c].n_emission_leg_type[2][0] > 0 && ncollinear[i_c].n_emission_leg_type[1][0] == 0){ncollinear[i_c].leg_emission = 2;}
    else {ncollinear[i_c].leg_emission = -1;}

    // determine numbers of ncollinear entries with corresponding endpoint pdf's:
    for (int i_e = 1; i_e < 3; i_e++){
      int j_e = i_e % 2 + 1;
      //      logger << LOG_DEBUG << "i_e = " << i_e << "   j_e = " << j_e << endline_flush;
      if (ncollinear[i_c].n_emission_leg_type[i_e][0] == 0){continue;}
      for (int j_c = 0; j_c < ncollinear.size(); j_c++){
	//	if (i_c == j_c){continue;}
	/*
	logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << i_c << "].no_endpoint[" << i_e << "] = " << ncollinear[i_c].no_endpoint[i_e] << endline_flush;
	logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << j_c << "].no_endpoint[" << i_e << "] = " << ncollinear[j_c].no_endpoint[i_e] << endline_flush;
	logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << i_c << "].no_endpoint[" << j_e << "] = " << ncollinear[i_c].no_endpoint[j_e] << endline_flush;
	logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << j_c << "].no_endpoint[" << j_e << "] = " << ncollinear[j_c].no_endpoint[j_e] << endline_flush;
	*/
	/*
	logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << i_c << "].n_emission_leg_type[" << i_e << "][0] = " << ncollinear[i_c].n_emission_leg_type[i_e][0] << endline_flush;
	logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << j_c << "].n_emission_leg_type[" << i_e << "][0] = " << ncollinear[j_c].n_emission_leg_type[i_e][0] << endline_flush;
	logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << i_c << "].n_emission_leg_type[" << j_e << "][0] = " << ncollinear[i_c].n_emission_leg_type[j_e][0] << endline_flush;
	logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << j_c << "].n_emission_leg_type[" << j_e << "][0] = " << ncollinear[j_c].n_emission_leg_type[j_e][0] << endline_flush;
	*/
	if (ncollinear[i_c].pdf == ncollinear[j_c].pdf){
	  /*
	  if (ncollinear[i_c].n_emission_leg_type[i_e][0] > 0 && ncollinear[j_c].n_emission_leg_type[i_e][0] == 0 &&
	      (ncollinear[i_c].n_emission_leg_type[j_e][0] > 0 && ncollinear[j_c].n_emission_leg_type[j_e][0] > 0) ||
	      (ncollinear[i_c].n_emission_leg_type[j_e][0] == 0 && ncollinear[j_c].n_emission_leg_type[j_e][0] == 0)){
	    ncollinear[i_c].no_endpoint[i_e] = j_c;
	    logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << i_c << "].no_endpoint[" << i_e << "] = " << ncollinear[i_c].no_endpoint[i_e] << endline_flush;
	  }

	  if (ncollinear[j_c].n_emission_leg_type[i_e][0] == 0 && ncollinear[j_c].n_emission_leg_type[j_e][0] == 0){
	    ncollinear[i_c].no_endpoint[0] = j_c;
	    logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << i_c << "].no_endpoint[0] = " << ncollinear[i_c].no_endpoint[0] << endline_flush;
	  }
	  */
	  logger << LOG_DEBUG_VERBOSE << "ncollinear[" << right << setw(2) << i_c << "].emission[" << i_e << "] = " << ncollinear[i_c].emission[i_e] << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "ncollinear[" << right << setw(2) << i_c << "].emission[" << j_e << "] = " << ncollinear[i_c].emission[j_e] << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "ncollinear[" << right << setw(2) << j_c << "].emission[" << i_e << "] = " << ncollinear[j_c].emission[i_e] << endline_flush;
	  logger << LOG_DEBUG_VERBOSE << "ncollinear[" << right << setw(2) << j_c << "].emission[" << j_e << "] = " << ncollinear[j_c].emission[j_e] << endline_flush;
	  if (ncollinear[i_c].emission[i_e] == ncollinear[j_c].emission[i_e] &&
	      ncollinear[i_c].emission[j_e] == ncollinear[j_c].emission[j_e]){
	    if (ncollinear[i_c].emission[i_e] == 0 && ncollinear[i_c].emission[j_e] == 0){ncollinear[i_c].no_endpoint[0] = j_c;}
	    if (ncollinear[i_c].emission[i_e] == 1 && ncollinear[i_c].emission[j_e] == 0){ncollinear[i_c].no_endpoint[j_e] = j_c;}
	    if (ncollinear[i_c].emission[i_e] == 1 && ncollinear[i_c].emission[j_e] == 1){ncollinear[i_c].no_endpoint[3] = j_c;}
	  }
	  if (ncollinear[i_c].emission[i_e] == 1 && ncollinear[j_c].emission[i_e] == 0){
	    if (ncollinear[i_c].emission[j_e] == 0 && ncollinear[j_c].emission[j_e] == 0){ncollinear[i_c].no_endpoint[0] = j_c;}
	    if (ncollinear[i_c].emission[j_e] == 1 && ncollinear[j_c].emission[j_e] == 1){ncollinear[i_c].no_endpoint[i_e] = j_c;}
	  }
	  if (ncollinear[i_c].emission[i_e] == 1 && ncollinear[j_c].emission[i_e] == 0 &&
	      ncollinear[i_c].emission[j_e] == 1 && ncollinear[j_c].emission[j_e] == 0){
	    ncollinear[i_c].no_endpoint[0] = j_c;
	  }

	  //	  if (ncollinear[j_c].emission[i_e] == 0 && ncollinear[j_c].emission[j_e] == 0){ncollinear[i_c].no_endpoint[0] = j_c;}
	  //	  if (ncollinear[i_c].emission[i_e] == 1 && ncollinear[j_c].emission[i_e] == 1 && ncollinear[j_c].emission[j_e] == 0){ncollinear[i_c].no_endpoint[j_e] = j_c;}
	  //	  if (ncollinear[j_c].emission[i_e] == 0 && ncollinear[j_c].emission[j_e] == 0){ncollinear[i_c].no_endpoint[0] = j_c;}
	  //	  if (ncollinear[j_c].emission[i_e] == 0 && ncollinear[j_c].emission[j_e] == 0){ncollinear[i_c].no_endpoint[0] = j_c;}



	  /*
	  if (ncollinear[i_c].n_emission_leg_type[i_e][0] > 0 && ncollinear[j_c].n_emission_leg_type[i_e][0] == 0 &&
	      (ncollinear[i_c].n_emission_leg_type[j_e][0] > 0 && ncollinear[j_c].n_emission_leg_type[j_e][0] > 0) ||
	      (ncollinear[i_c].n_emission_leg_type[j_e][0] == 0 && ncollinear[j_c].n_emission_leg_type[j_e][0] == 0)){
	    ncollinear[i_c].no_endpoint[i_e] = j_c;
	    logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << i_c << "].no_endpoint[" << i_e << "] = " << ncollinear[i_c].no_endpoint[i_e] << endline_flush;
	  }
	  if (ncollinear[i_c].n_emission_leg_type[i_e][0] > 0 && ncollinear[j_c].n_emission_leg_type[i_e][0] == 0 &&
	      ncollinear[i_c].n_emission_leg_type[j_e][0] > 0 && ncollinear[j_c].n_emission_leg_type[j_e][0] == 0){
	    ncollinear[i_c].no_endpoint[0] = j_c;
	    logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << i_c << "].no_endpoint[0] = " << ncollinear[i_c].no_endpoint[0] << endline_flush;
	  }
	  */
	}
      }
    }

    // determine type_splitting_full (for each leg):
    // 14 -  0   +   0 - 14
    // 34 -  0   +   0 - 34
    // 54 -  0   +   0 - 54
    // 22 -  0   +   0 - 22
    //  2 -  2
    //  2 -  4   +   4 -  2
    //  4 -  4

    for (int i_e = 1; i_e < 3; i_e++){
      if (ncollinear[i_c].n_emission[i_e] == 0){continue;}
      for (int i_s = 0; i_s < ncollinear[i_c].type_splitting_leg[i_e].size(); i_s++){
	ncollinear[i_c].type_splitting_full[i_e] += pow(10., i_s) * (ncollinear[i_c].type_splitting_leg[i_e][i_s]);
      }
    }


    // determine order_emission
    if (ncollinear[i_c].leg_emission == 0){
      if (ncollinear[i_c].type_splitting_full[2] < ncollinear[i_c].type_splitting_full[1]){
	ncollinear[i_c].x_a = 2;
	ncollinear[i_c].x_b = 1;
      }
      else {
	ncollinear[i_c].x_a = 1;
	ncollinear[i_c].x_b = 2;
      }
    }
    else if (ncollinear[i_c].leg_emission > 0){
      ncollinear[i_c].x_a = ncollinear[i_c].leg_emission;
      ncollinear[i_c].x_b = ncollinear[i_c].x_a % 2 + 1;
    }



    logger << LOG_DEBUG << "ncollinear[" << right << setw(2) << i_c << "].name =    old: " << left << setw(20) << ncollinear[i_c].name << "    new: " << setw(20) << temp.str() << endline_flush;
    ncollinear[i_c].name = temp.str();

    logger << LOG_DEBUG << left << setw(20) << ncollinear[i_c].name <<    "type_splitting_full[1] = " << setw(2) << ncollinear[i_c].type_splitting_full[1] << "   type_splitting_full[2] = " << setw(2) << ncollinear[i_c].type_splitting_full[2];
    logger.newLine(LOG_DEBUG);

    //      logger << LOG_DEBUG << "new name:   ncollinear[" << setw(2) << i_c << "].name = " << ncollinear[i_c].name << endline_flush;
  }




  /*
  for (int i_a = 0; i_a < (*CA_collinear).size(); i_a++){
    for (int i_z = 0; i_z < 3; i_z++){
      if ((*CA_collinear)[i_a][0].in_collinear()[i_z] == 1){CA_dipole_splitting[(*CA_collinear)[i_a][0].type()][i_z] = 1;}
    }
  }

  logger << LOG_DEBUG << "CA_dipole_splitting:" << endline_flush;
  for (int i_z = 0; i_z < 3; i_z++){
    stringstream temp_ss;
    temp_ss << "i_z = " << i_z << ":   ";
    for (int i_t = 0; i_t < 4; i_t++){temp_ss << CA_dipole_splitting[i_t][i_z] << "   ";}
    logger << LOG_DEBUG << temp_ss.str() << endline_flush;
  }
  logger.newLine(LOG_DEBUG);
  logger << LOG_DEBUG << "new collinear dipoles determined " << endl << endline_flush;
  */
  
  determine_QT_list_combination_pdf();
  determine_QT_Q2f_QCD();

  logger << LOG_INFO << "(output_list_combination_pdf)" << endline << output_list_combination_pdf() << endline_flush;

  //  output_CX_ncollinear_QCD();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::determine_QT_Q2f_QCD(){
  Logger logger("observable_set::determine_QT_Q2f_QCD");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // Set dummy charge factors here in QCD case and resize QT_Q2f here in order to be use the same routines as in the QEW case !!!
  QT_Q2f.resize(ncollinear.size());
  for (int i_l = 0; i_l < list_combination_pdf.size(); i_l++){
    QT_Q2f[i_l].resize(list_combination_pdf[i_l].size());
    for (int i_i = 0; i_i < list_combination_pdf[i_l].size(); i_i++){
      QT_Q2f[i_l][i_i].resize(list_combination_pdf[i_l][i_i].size(), 1.);
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


