#include "header.hpp"

void observable_set::initialization_QT_coefficients_QCD_1(){
  Logger logger("observable_set::initialization_QT_coefficients_QCD_1");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // The coll_..._contribution vectors are only used internally, so one could think of re-using a single version instead of QCD, QEW and MIX ones. 
  
  coll_tH1F_contribution_QCD.resize(list_combination_pdf.size());
  coll_tH1_contribution_QCD.resize(list_combination_pdf.size());
  coll_tH1_only_H1_delta_contribution_QCD.resize(list_combination_pdf.size());
  
  coll_tH1F_QCD.resize(list_combination_pdf.size(), 0.);
  coll_tH1_QCD.resize(list_combination_pdf.size(), 0.);
  coll_tH1_only_H1_delta_QCD.resize(list_combination_pdf.size(), 0.);

  value_tH1F_QCD.resize(value_mu_fact.size());
  value_sig11_QCD.resize(value_mu_fact.size());
  value_sig12_QCD.resize(value_mu_fact.size());
  value_tH1_QCD.resize(value_mu_fact.size());
  value_tH1_only_H1_delta_QCD.resize(value_mu_fact.size());
  value_H1full_QCD.resize(value_mu_ren.size(), vector<vector<vector<double> > > (value_mu_fact.size()));

  coll_tH1F_QCD_pdf.resize(value_mu_fact.size());
  coll_tH1_QCD_pdf.resize(value_mu_fact.size());
  coll_tH1_only_H1_delta_QCD_pdf.resize(value_mu_fact.size());
  
  for (int i_vf = 0; i_vf < value_mu_fact.size(); i_vf++){
    value_tH1F_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);
    value_sig11_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);
    value_sig12_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);
    value_tH1_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);
    value_tH1_only_H1_delta_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);

    coll_tH1F_QCD_pdf[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (list_combination_pdf.size(), 0.));
    coll_tH1_QCD_pdf[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (list_combination_pdf.size(), 0.));
    coll_tH1_only_H1_delta_QCD_pdf[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (list_combination_pdf.size(), 0.));

    for (int i_vr = 0; i_vr < value_mu_ren.size(); i_vr++){
      value_H1full_QCD[i_vr][i_vf].resize(value_mu_ren[i_vr].size(), vector<double> (value_mu_fact[i_vf].size(), 0.));
    }
  }

  if (switch_distribution){
    value_tH1F_QCD_D.resize(value_mu_fact.size());
    value_sig11_QCD_D.resize(value_mu_fact.size());
    value_sig12_QCD_D.resize(value_mu_fact.size());
    value_tH1_QCD_D.resize(value_mu_fact.size());
    value_tH1_only_H1_delta_QCD_D.resize(value_mu_fact.size());
    value_H1full_QCD_D.resize(value_mu_ren.size(), vector<vector<vector<vector<double> > > > (value_mu_fact.size()));    

    coll_tH1F_QCD_pdf_D.resize(value_mu_fact.size());
    coll_tH1_QCD_pdf_D.resize(value_mu_fact.size());
    coll_tH1_only_H1_delta_QCD_pdf_D.resize(value_mu_fact.size());

    for (int i_vf = 0; i_vf < value_mu_fact.size(); i_vf++){
      value_tH1F_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));
      value_sig11_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));
      value_sig12_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));
      value_tH1_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));
      value_tH1_only_H1_delta_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));

      coll_tH1F_QCD_pdf_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
      coll_tH1_QCD_pdf_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
      coll_tH1_only_H1_delta_QCD_pdf_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));

      for (int i_vr = 0; i_vr < value_mu_ren.size(); i_vr++){
	value_H1full_QCD_D[i_vr][i_vf].resize(value_mu_ren[i_vr].size(), vector<vector<double> > (value_mu_fact[i_vf].size(), vector<double> (3, 0.)));
	
      }
    }
  }
  
  if (switch_TSV){
    value_tH1F_QCD_TSV.resize(max_dyn_fact + 1);
    value_sig11_QCD_TSV.resize(max_dyn_fact + 1);
    value_sig12_QCD_TSV.resize(max_dyn_fact + 1);
    value_tH1_QCD_TSV.resize(max_dyn_fact + 1);
    value_tH1_only_H1_delta_QCD_TSV.resize(max_dyn_fact + 1);
    value_H1full_QCD_TSV.resize(max_dyn_ren + 1, vector<vector<vector<vector<double> > > > (max_dyn_fact + 1));

    coll_tH1F_QCD_pdf_TSV.resize(max_dyn_fact + 1);
    coll_tH1_QCD_pdf_TSV.resize(max_dyn_fact + 1);
    coll_tH1_only_H1_delta_QCD_pdf_TSV.resize(max_dyn_fact + 1);
    
    for (int i_vf = 0; i_vf < max_dyn_fact + 1; i_vf++){
      value_tH1F_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));
      value_sig11_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));
      value_sig12_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));
      value_tH1_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));
      value_tH1_only_H1_delta_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));

      coll_tH1F_QCD_pdf_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
      coll_tH1_QCD_pdf_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
      coll_tH1_only_H1_delta_QCD_pdf_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
    }

    for (int i_vr = 0; i_vr < max_dyn_ren + 1; i_vr++){
      for (int i_vf = 0; i_vf < max_dyn_fact + 1; i_vf++){
	value_H1full_QCD_TSV[i_vr][i_vf].resize(n_scale_dyn_ren[i_vr], vector<vector<double> > (n_scale_dyn_fact[i_vf], vector<double> (3, 0.)));
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void observable_set::initialization_QT_coefficients_QCD_2(){
  Logger logger("observable_set::initialization_QT_coefficients_QCD_2");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // The coll_..._contribution vectors are only used internally, so one could think of re-using a single version instead of QCD, QEW and MIX ones. 
  
  coll_tgaga_contribution_QCD.resize(list_combination_pdf.size());
  coll_tcga_contribution_QCD.resize(list_combination_pdf.size());
  coll_tgamma2_contribution_QCD.resize(list_combination_pdf.size());
  coll_tH2_contribution_QCD.resize(list_combination_pdf.size());

  coll_tgaga_QCD.resize(list_combination_pdf.size(), 0.);
  coll_tcga_QCD.resize(list_combination_pdf.size(), 0.);
  coll_tgamma2_QCD.resize(list_combination_pdf.size(), 0.);
  coll_tH2_QCD.resize(list_combination_pdf.size(), 0.);

  value_tgaga_QCD.resize(value_mu_fact.size());
  value_tcga_QCD.resize(value_mu_fact.size());
  value_tgamma2_QCD.resize(value_mu_fact.size());
  //  value_sig12_QCD.resize(value_mu_fact.size());
  value_sig23_QCD.resize(value_mu_fact.size());
  value_sig24_QCD.resize(value_mu_fact.size());
  value_tH2_QCD.resize(value_mu_fact.size());

  value_sig21_QCD.resize(value_mu_ren.size(), vector<vector<vector<double> > > (value_mu_fact.size()));
  value_sig22_QCD.resize(value_mu_ren.size(), vector<vector<vector<double> > > (value_mu_fact.size()));
  value_H2full_QCD.resize(value_mu_ren.size(), vector<vector<vector<double> > > (value_mu_fact.size()));

  coll_tgaga_QCD_pdf.resize(value_mu_fact.size());
  coll_tcga_QCD_pdf.resize(value_mu_fact.size());
  coll_tgamma2_QCD_pdf.resize(value_mu_fact.size());
  coll_tH2_QCD_pdf.resize(value_mu_fact.size());

  for (int i_vf = 0; i_vf < value_mu_fact.size(); i_vf++){
    value_tgaga_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);
    value_tcga_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);
    value_tgamma2_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);
    value_tH2_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);

    coll_tgaga_QCD_pdf[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (list_combination_pdf.size(), 0.));
    coll_tcga_QCD_pdf[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (list_combination_pdf.size(), 0.));
    coll_tgamma2_QCD_pdf[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (list_combination_pdf.size(), 0.));
    coll_tH2_QCD_pdf[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (list_combination_pdf.size(), 0.));

    //    value_sig12_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);
    value_sig23_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);
    value_sig24_QCD[i_vf].resize(value_mu_fact[i_vf].size(), 0.);

    for (int i_vr = 0; i_vr < value_mu_ren.size(); i_vr++){
      value_sig21_QCD[i_vr][i_vf].resize(value_mu_ren[i_vr].size(), vector<double> (value_mu_fact[i_vf].size(), 0.));
      value_sig22_QCD[i_vr][i_vf].resize(value_mu_ren[i_vr].size(), vector<double> (value_mu_fact[i_vf].size(), 0.));
      value_H2full_QCD[i_vr][i_vf].resize(value_mu_ren[i_vr].size(), vector<double> (value_mu_fact[i_vf].size(), 0.));
    }
  }

  if (switch_distribution){
    coll_tgaga_QCD_pdf_D.resize(value_mu_fact.size());
    coll_tcga_QCD_pdf_D.resize(value_mu_fact.size());
    coll_tgamma2_QCD_pdf_D.resize(value_mu_fact.size());
    coll_tH2_QCD_pdf_D.resize(value_mu_fact.size());

    value_tgaga_QCD_D.resize(value_mu_fact.size());
    value_tcga_QCD_D.resize(value_mu_fact.size());
    value_tgamma2_QCD_D.resize(value_mu_fact.size());
    value_tH2_QCD_D.resize(value_mu_fact.size());

    //    value_sig12_QCD_D.resize(value_mu_fact.size());
    value_sig23_QCD_D.resize(value_mu_fact.size());
    value_sig24_QCD_D.resize(value_mu_fact.size());

    value_sig21_QCD_D.resize(value_mu_ren.size(), vector<vector<vector<vector<double> > > > (value_mu_fact.size()));
    value_sig22_QCD_D.resize(value_mu_ren.size(), vector<vector<vector<vector<double> > > > (value_mu_fact.size()));
    value_H2full_QCD_D.resize(value_mu_ren.size(), vector<vector<vector<vector<double> > > > (value_mu_fact.size()));
    
    for (int i_vf = 0; i_vf < value_mu_fact.size(); i_vf++){
      value_tgaga_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));
      value_tcga_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));
      value_tgamma2_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));
      value_tH2_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));

      coll_tgaga_QCD_pdf_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
      coll_tcga_QCD_pdf_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
      coll_tgamma2_QCD_pdf_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
      coll_tH2_QCD_pdf_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));

      //      value_sig12_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));
      value_sig23_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));
      value_sig24_QCD_D[i_vf].resize(value_mu_fact[i_vf].size(), vector<double> (3, 0.));

      for (int i_vr = 0; i_vr < value_mu_ren.size(); i_vr++){
	value_sig21_QCD_D[i_vr][i_vf].resize(value_mu_ren[i_vr].size(), vector<vector<double> > (value_mu_fact[i_vf].size(), vector<double> (3, 0.)));
	value_sig22_QCD_D[i_vr][i_vf].resize(value_mu_ren[i_vr].size(), vector<vector<double> > (value_mu_fact[i_vf].size(), vector<double> (3, 0.)));
	value_H2full_QCD_D[i_vr][i_vf].resize(value_mu_ren[i_vr].size(), vector<vector<double> > (value_mu_fact[i_vf].size(), vector<double> (3, 0.)));

      }
    }
  }
  
  if (switch_TSV){
    value_tgaga_QCD_TSV.resize(max_dyn_fact + 1);
    value_tcga_QCD_TSV.resize(max_dyn_fact + 1);
    value_tgamma2_QCD_TSV.resize(max_dyn_fact + 1);
    value_tH2_QCD_TSV.resize(max_dyn_fact + 1);

    coll_tgaga_QCD_pdf_TSV.resize(max_dyn_fact + 1);
    coll_tcga_QCD_pdf_TSV.resize(max_dyn_fact + 1);
    coll_tgamma2_QCD_pdf_TSV.resize(max_dyn_fact + 1);
    coll_tH2_QCD_pdf_TSV.resize(max_dyn_fact + 1);

    //    value_sig12_QCD_TSV.resize(max_dyn_fact + 1);
    value_sig23_QCD_TSV.resize(max_dyn_fact + 1);
    value_sig24_QCD_TSV.resize(max_dyn_fact + 1);

    value_sig21_QCD_TSV.resize(max_dyn_ren + 1, vector<vector<vector<vector<double> > > > (max_dyn_fact + 1));
    value_sig22_QCD_TSV.resize(max_dyn_ren + 1, vector<vector<vector<vector<double> > > > (max_dyn_fact + 1));
    value_H2full_QCD_TSV.resize(max_dyn_ren + 1, vector<vector<vector<vector<double> > > > (max_dyn_fact + 1));

    for (int i_vf = 0; i_vf < max_dyn_fact + 1; i_vf++){
      value_tgaga_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));
      value_tcga_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));
      value_tgamma2_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));
      value_tH2_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));

      //      value_sig12_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));
      value_sig23_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));
      value_sig24_QCD_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<double> (3, 0.));

      coll_tgaga_QCD_pdf_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
      coll_tcga_QCD_pdf_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
      coll_tgamma2_QCD_pdf_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
      coll_tH2_QCD_pdf_TSV[i_vf].resize(n_scale_dyn_fact[i_vf], vector<vector<double> > (3, vector<double> (list_combination_pdf.size(), 0.)));
    }

    for (int i_vr = 0; i_vr < max_dyn_ren + 1; i_vr++){
      for (int i_vf = 0; i_vf < max_dyn_fact + 1; i_vf++){
	value_sig21_QCD_TSV[i_vr][i_vf].resize(n_scale_dyn_ren[i_vr], vector<vector<double> > (n_scale_dyn_fact[i_vf], vector<double> (3, 0.)));
	value_sig22_QCD_TSV[i_vr][i_vf].resize(n_scale_dyn_ren[i_vr], vector<vector<double> > (n_scale_dyn_fact[i_vf], vector<double> (3, 0.)));
	value_H2full_QCD_TSV[i_vr][i_vf].resize(n_scale_dyn_ren[i_vr], vector<vector<double> > (n_scale_dyn_fact[i_vf], vector<double> (3, 0.)));
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


#define x_e ncollinear[i_c].x_a
#define y_e ncollinear[i_c].x_b
#define no_zx ncollinear[ncollinear[i_c].no_endpoint[y_e]].no_pdf
#define no_xx ncollinear[ncollinear[i_c].no_endpoint[0]].no_pdf

void observable_set::initialization_splitting_QCD_1(){
  static Logger logger("observable_set::initialization_splitting_QCD_1");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  //  type_splitting_full (leg-wise):
  //  x_e - y_e   ---   ---
  //    1 -   0 +   0 -   1   // hard process with g from g -> g (g)  -> g (g)  splitting
  //    2 -   0 +   0 -   2   // hard process with q from q -> q (g)  -> q (g)  splitting
  //    3 -   0 +   0 -   3   // hard process with g from q -> q (g)  -> g (Q)  splitting
  //    4 -   0 +   0 -   4   // hard process with q from g -> g (g)  -> q (qx) splitting

  nc_splitting_QCD_1.resize(ncollinear.size(), 0);
  for (int i_c = 1; i_c < ncollinear.size(); i_c++){
    //    if ((csi->type_contribution == "CT" || csi->type_contribution == "VT" || csi->type_contribution == "L2CT" || csi->type_contribution == "L2VT") && csi->type_correction == "QCD"){
    if (csi->class_contribution_collinear && csi->class_contribution_order == 1 && csi->type_correction == "QCD"){
      if (ncollinear[i_c].type_splitting_full[x_e] == 0 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_1[i_c] = 0;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 1 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_1[i_c] = 1;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 2 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_1[i_c] = 2;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 3 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_1[i_c] = 3;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 4 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_1[i_c] = 4;}
    }
    //    if ((csi->type_contribution == "CT2" || csi->type_contribution == "VT2") && csi->type_correction == "QCD"){
    if (csi->class_contribution_collinear && csi->class_contribution_order == 2 && csi->type_correction == "QCD"){
      if (ncollinear[i_c].type_splitting_full[x_e] == 0 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_1[i_c] = 0;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 11 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_1[i_c] = 1;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 22 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_1[i_c] = 2;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 23 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_1[i_c] = 3;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 14 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_1[i_c] = 4;}
    }
  }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

#undef no_zx
#undef no_xx
#undef x_e
#undef y_e


#define x_e ncollinear[i_c].x_a
#define y_e ncollinear[i_c].x_b
#define no_zz ncollinear[ncollinear[i_c].no_endpoint[3]].no_pdf
#define no_xz ncollinear[ncollinear[i_c].no_endpoint[x_e]].no_pdf
#define no_zx ncollinear[ncollinear[i_c].no_endpoint[y_e]].no_pdf
#define no_xx ncollinear[ncollinear[i_c].no_endpoint[0]].no_pdf

void observable_set::initialization_splitting_QCD_2(){
  static Logger logger("observable_set::initialization_splitting_QCD_2");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  //  type_splitting_full (leg-wise):
  //  x_e - y_e     ---  ---
  //   14 -   0 +   0 -  14   // hard process with q from g -> g (g)  -> q (qx) splitting (-> 4  in sig11 calculation)
  // ( 42 -   0 +   0 -  42   // hard process with q from g -> q (q)  -> q (g)  splitting (part of  14 -  0   +   0 - 14))
  //   11 -   0 +   0 -  11   // hard process with g from g -> g (g)  -> g (g)  splitting (-> 1  in sig11 calculation)
  // ( 43 -   0 +   0 -  43   // hard process with g from g -> q (qx) -> g (Q)  splitting (part of  11 -  0   +   0 - 11))
  //   23 -   0 +   0 -  23   // hard process with g from q -> q (g)  -> g (Q)  splitting (-> 3  in sig11 calculation)
  // ( 31 -   0 +   0 -  31   // hard process with g from q -> g (q)  -> g (g)  splitting (part of  23 -  0   +   0 - 23))
  //   22 -   0 +   0 -  22   // hard process with q from q -> q (g)  -> q (g)  splitting (-> 2  in sig11 calculation)
  //   34 -   0 +   0 -  34   // hard process with q from q -> g (q)  -> q (qx) splitting (----  no equivalent)
  //   54 -   0 +   0 -  54   // hard process with q from qx -> ...   -> q      splitting (non-singlet)    (----  no equivalent)
  //    2 -   2               // hard process with (leg 1) q from q -> q (g)  splitting and (leg 2) q from q -> q (g)  splitting
  //    2 -   4 +   4 -   2   // hard process with (leg 1) q from q -> q (g)  splitting and (leg 2) g from q -> g (q)  splitting
  //    4 -   4               // hard process with (leg 1) g from q -> g (q)  splitting and (leg 2) g from q -> g (q)  splitting
  //    1 -   1               // hard process with (leg 1) g from g -> g (g)  splitting and (leg 2) g from g -> g (g)  splitting
  //    1 -   3 +   3 -   1   // hard process with (leg 1) g from g -> g (g)  splitting and (leg 2) g from q -> g (q)  splitting
  //    3 -   3               // hard process with (leg 1) g from q -> g (q)  splitting and (leg 2) g from q -> g (q)  splitting

  nc_splitting_QCD_2.resize(ncollinear.size(), 0);
  for (int i_c = 1; i_c < ncollinear.size(); i_c++){
    //    if ((csi->type_contribution == "CT2" || csi->type_contribution == "VT2") && csi->type_correction == "QCD"){
    if (csi->class_contribution_collinear && csi->class_contribution_order == 2 && csi->type_correction == "QCD"){
      if (ncollinear[i_c].type_splitting_full[x_e] == 0 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_2[i_c] = 0;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 11 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_2[i_c] = 11;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 23 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_2[i_c] = 23;}
      else if (ncollinear[i_c].leg_emission == 0 && ncollinear[i_c].type_splitting_full[x_e] == 1 && ncollinear[i_c].type_splitting_full[y_e] == 1){nc_splitting_QCD_2[i_c] = 101;}
      else if (ncollinear[i_c].leg_emission == 0 && ncollinear[i_c].type_splitting_full[x_e] == 3 && ncollinear[i_c].type_splitting_full[y_e] == 3){nc_splitting_QCD_2[i_c] = 303;}
      else if (ncollinear[i_c].leg_emission == 0 && ncollinear[i_c].type_splitting_full[x_e] == 1 && ncollinear[i_c].type_splitting_full[y_e] == 3){nc_splitting_QCD_2[i_c] = 103;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 14 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_2[i_c] = 14;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 34 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_2[i_c] = 34;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 22 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_2[i_c] = 22;}
      else if (ncollinear[i_c].type_splitting_full[x_e] == 54 && ncollinear[i_c].type_splitting_full[y_e] == 0){nc_splitting_QCD_2[i_c] = 54;}
      else if (ncollinear[i_c].leg_emission == 0 && ncollinear[i_c].type_splitting_full[x_e] == 2 && ncollinear[i_c].type_splitting_full[y_e] == 2){nc_splitting_QCD_2[i_c] = 202;}
      else if (ncollinear[i_c].leg_emission == 0 && ncollinear[i_c].type_splitting_full[x_e] == 4 && ncollinear[i_c].type_splitting_full[y_e] == 4){nc_splitting_QCD_2[i_c] = 404;}
      else if (ncollinear[i_c].leg_emission == 0 && ncollinear[i_c].type_splitting_full[x_e] == 2 && ncollinear[i_c].type_splitting_full[y_e] == 4){nc_splitting_QCD_2[i_c] = 204;}
    } 
  }
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

#undef no_zz
#undef no_xz
#undef no_zx
#undef no_xx
#undef x_e
#undef y_e


