#include "header.hpp"

string double2hexastr(double d){
  char buffer[25] = { 0 };
  ::snprintf(buffer, 25, "%A", d); // TODO Check for errors
  //  ::snprintf(buffer, 21, "%A", d); // TODO Check for errors
  return buffer;
  /*
  stringstream temp;
  temp << setprecision(15) << setw(23) << d;
  return temp.str();
  */
}


double hexastr2double(const string & s){
  double d = 0.0;
  ::sscanf(s.c_str(), "%lA", &d); // TODO Check for errors
  return d;
}


char * stch(string temp_s){
  char * temp_ch = new char[temp_s.size() + 1];
  //  char temp_ch[temp_s.size() + 1];
  std::copy(temp_s.begin(), temp_s.end(), temp_ch);
  temp_ch[temp_s.size()] = '\0';
  //  cout << "stch: " << temp_s << "   " << temp_ch << endline_flush;
  return temp_ch;
}


char stchar(string & temp_s){
  // assigning value to string s 
  // declaring character array : p 
  char p[temp_s.length()]; 
  for (int i = 0; i < sizeof(p); i++) { 
    p[i] = temp_s[i]; 
  }
  return *p;
}


vector<int> get_vector_from_array_int(int * temp_array, int size_array){
  //  cout << "sizeof(temp_array) = " << sizeof(temp_array) << endline_flush;
  //  cout << "sizeof(int) = " << sizeof(int) << endline_flush;
  //  cout << "size_array = " << size_array << endline_flush;
  vector<int> temp_vector(temp_array, temp_array + size_array);
  //  cout << "temp_vector.size() = " << temp_vector.size() << endline_flush;
  return temp_vector;
}



string time_hms_from_double(double & time){
  stringstream time_ss;
  long long temp_d = (long long)(time / 24 / 3600);
  long long temp_h = (long long)(time / 3600) - temp_d * 24;
  long long temp_min = (long long)(time / 60) - temp_d * 24 * 60 - temp_h * 60;
  long long temp_sec = (long long)(time) - temp_d * 24 * 3600 - temp_h * 3600 - temp_min * 60;
  time_ss << setw(4) << temp_d << " d " << setw(2) << temp_h << " h " << setw(2) << temp_min << " m " << setw(2) << temp_sec << " s";
  return time_ss.str();
}



double max_subset_from_binary(vector<double> & xbsqrtsmin_opt, int b){
  vector<int> temp = vectorbinary_from_binary(b);
  vector<int> xbcomb(0);
  vector<vector<int> > xcomb(0);
  vector<vector<int> > ycomb(0);
  for (int i = 4; i < b / 2; i += 4){
    vector<int> temp_part = vectorbinary_from_binary(i);
    int temp_counter = 0;
    for (int j = 0; j < temp_part.size(); j++){
      for (int k = 0; k < temp.size(); k++){
	if (temp_part[j] == temp[k]){
	  temp_counter++;
	  break;
	}
      }
    }
    if (temp_counter < temp_part.size()){continue;}
    vector<int> temp_part2 = vectorbinary_from_binary(b - i);
    xcomb.push_back(temp_part);
    ycomb.push_back(temp_part2);
    xbcomb.push_back(i);
  }
  for (int i = 0; i < xbcomb.size(); i++){
    double temp = xbsqrtsmin_opt[accumulate(xcomb[i].begin(), xcomb[i].end(), 0)] + xbsqrtsmin_opt[accumulate(ycomb[i].begin(), ycomb[i].end(), 0)];
    //    cout << "temp = " << setw(25) << temp << "   xbsqrtsmin_opt[" << setw(3) << b << "] = " << setw(25) << xbsqrtsmin_opt[b] << endline_flush;
    if (xbsqrtsmin_opt[b] < temp){xbsqrtsmin_opt[b] = temp;}
  }
  //  cout << "max_subset_from_binary end" << endline_flush;
  return xbsqrtsmin_opt[b];
}

vector<int> vectorint_from_binary(int b){
  vector<int> temp;
  int counter = 1;
  while (b != 0){
    if ((b % 2) == 1){temp.push_back(counter);}
    counter++;
    b = b / 2;
  }
  return temp;
}

vector<int> vectorbinary_from_binary(int b){
  vector<int> temp;
  int counter = 0;
  while (b != 0){
    if ((b % 2) == 1){temp.push_back(intpow(2, counter));}
    counter++;
    b = b / 2;
  }
  return temp;
}


