#include "header.hpp"

////////////////////
//  constructors  //
////////////////////
summary_generic::summary_generic(){
  Logger logger("summary_generic::summary_generic ()");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "constructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

summary_generic::summary_generic(munich * xmunich){
  Logger logger("summary_generic::summary_generic (xmunich)");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "constructor called..." << endline_flush;

  logger << LOG_DEBUG << "xmunich: order = " << xmunich->order << endline_flush;
  logger << LOG_DEBUG << "xmunich: infilename = " << xmunich->infilename << endline_flush;
  logger << LOG_DEBUG << "xmunich: infilename_scaleband = " << xmunich->infilename_scaleband << endline_flush;

  csi = xmunich->csi;
  isi = xmunich->isi;
  osi = xmunich->osi;

  order = xmunich->order;
  infilename = xmunich->infilename;
  infilename_scaleband = xmunich->infilename_scaleband;

  logger << LOG_DEBUG << "order = " << order << endline_flush;
  logger << LOG_DEBUG << "infilename = " << infilename << endline_flush;
  logger << LOG_DEBUG << "infilename_scaleband = " << infilename_scaleband << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}

summary_generic::~summary_generic(){
  Logger logger("summary_generic::~summary_generic");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "destructor called..." << endline_flush;

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_generic::get_summary(){
  Logger logger("summary_generic::get_summary");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  logger << LOG_DEBUG << "csi->type_perturbative_order = " << csi->type_perturbative_order << endline_flush;
  logger << LOG_DEBUG << "csi->type_contribution = " << csi->type_contribution << endline_flush;
  logger << LOG_DEBUG << "csi->type_correction = " << csi->type_correction << endline_flush;
  
  // default values:
  run_min_n_step = 10;
  run_factor_max = 2;
  run_min_n_event = 50000;
  run_max_time_per_job = 2 * 60 * 60;
  run_min_number_of_jobs_for_one_channel = 3;
  average_factor = 0;
  switch_generate_rundirectories = 0;
  no_qTcut_runtime_estimate = 0;
  deviation_tolerance_factor = 5.;

  switch_extrapolation_result = 2;
  switch_extrapolation_distribution = 2;

  min_qTcut_extrapolation = 0.05;
  max_qTcut_extrapolation = 0.5;
  error_extrapolation_range_chi2 = 4.;

  min_max_value_extrapolation_range = 0.25;
  min_n_qTcut_extrapolation_range = 10;

  max_min_value_extrapolation_range = 0.01;

  min_value_extrapolation_range = 0.;
  
  switch_output_plot = 1;
  switch_output_qTcut = 1;
  switch_output_result = 2;
  switch_output_overview = 3;
  // 0 - none
  // 1 - order
  // 2 - order + list
  // 3 - order + list + contribution
  // 4 - order + list + contribution + subprocess


  switch_output_subprocess = 0;
  // 0 - none
  // 1 - overview
  // 2 - overview + plot
  // 3 - overview + plot + result
  switch_output_contribution = 0;
  switch_output_list = 0;
  switch_output_order = 1;

  switch_output_only_reference_scale = 0;
  switch_output_script = 1;

  switch_output_complete = 1;
  switch_output_ren = 1;
  switch_output_fact = 1;
  switch_output_equal = 1;
  switch_output_antipodal = 1;

  switch_output_table_order = 0;
  switch_output_table_Kfactor = 0;
  switch_output_table_crosssection_Kfactor = 0;
  switch_output_table_IS_splitting = 0;
  switch_output_table_crosssection_Kfactor_combination_NNLOQCD_NLOEW = 0;
  switch_output_table_order_cumulative_ggLO = 0;
  switch_output_table_order_cumulative_ggNLO = 0;
  switch_output_table_crosssection_Kfactor_ggNLO = 0;

  if (!osi->switch_moment){osi->n_moments = 1;}

  infix_name_moment.resize(osi->n_moments);
  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    stringstream temp_ss;
    if (i_m == 0){}
    else {temp_ss << ".moment_" << i_m;}
    infix_name_moment[i_m] = temp_ss.str();
  }
  x_m = 0;

  // readin from specified input file:
  readin_combination_infile();

  system_execute(logger, "mkdir " + final_resultdirectory);

  for (int i_l = 0; i_l < list_contribution_file.size(); i_l++){logger << LOG_DEBUG << "list_contribution_file[" << i_l << "] = " << list_contribution_file[i_l] << endline_flush;}

  resultdirectory.resize(list_contribution_file.size());
  osi->initialization_result();
  // shifted to initialization_scaleset_CV():  osi->initialization_CV();

  if (osi->switch_TSV){initialization_scaleset_TSV();}
  // Check if "if (osi->switch_CV){" can cause trouble here !!!
  initialization_scaleset_CV();

  subgroup.push_back(csi->process_class); // ???

  // Initialization of xlist from 'list_contribution_file':
  initialization_summary_list();


  // qTcut information must come from the individual list -> investigate in initialization_summary_list !!!

  for (int i_o = 0; i_o < yorder.size(); i_o++){
    yorder[i_o]->active_qTcut = 0;
    yorder[i_o]->output_n_qTcut = 1;
    yorder[i_o]->selection_n_qTcut = 1;
    for (int i_c = 0; i_c < yorder[i_o]->combination.size(); i_c++){
      for (int i_l = 0; i_l < yorder[i_o]->contribution_file.size(); i_l++){
	int x_l = mapping_contribution_file[yorder[i_o]->contribution_file[i_l]];
	if (xlist[x_l]->active_qTcut){
	  yorder[i_o]->active_qTcut = xlist[x_l]->active_qTcut;
	  yorder[i_o]->output_n_qTcut = xlist[x_l]->output_n_qTcut;
	  yorder[i_o]->selection_n_qTcut = xlist[x_l]->selection_n_qTcut;
	}
      }
    }
  }

  
  for (int i_l = 0; i_l < xlist.size(); i_l++){
    logger << LOG_DEBUG << "xlist[" << i_l << "]->resultdirectory = " << xlist[i_l]->resultdirectory << "   active_qTcut = " << xlist[i_l]->active_qTcut << "   output_n_qTcut = " << setw(3) << xlist[i_l]->output_n_qTcut << "   selection_n_qTcut = " << xlist[i_l]->selection_n_qTcut << endline_flush;
    logger << LOG_DEBUG << "list   " << "   active_qTcut = " << xlist[i_l]->active_qTcut << "   output_n_qTcut = " << setw(3) << xlist[i_l]->output_n_qTcut << "   selection_n_qTcut = " << xlist[i_l]->selection_n_qTcut << endline_flush;
    for (int i_c = 0; i_c < xlist[i_l]->xcontribution.size(); i_c++){
      logger << LOG_DEBUG << "i_c = " << i_c << "   active_qTcut = " << xlist[i_l]->xcontribution[i_c]->active_qTcut << "   output_n_qTcut = " << setw(3) << xlist[i_l]->xcontribution[i_c]->output_n_qTcut << "   selection_n_qTcut = " << xlist[i_l]->xcontribution[i_c]->selection_n_qTcut << endline_flush;
    }
  }


  for (int i_o = 0; i_o < yorder.size(); i_o++){
    logger << LOG_DEBUG << "yorder[" << i_o << "].resultdirectory = " << setw(16) << yorder[i_o]->resultdirectory << "   active_qTcut = " << yorder[i_o]->active_qTcut << "   output_n_qTcut = " << setw(3) << yorder[i_o]->output_n_qTcut << "   selection_n_qTcut = " << yorder[i_o]->selection_n_qTcut << endline_flush;
  }
  

  if (order == "result"){

    // create result output directories
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!switch_output_scaleset[i_s]){continue;}
      system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s]);
      if (switch_output_complete){system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + "complete");}
      if (switch_output_ren){system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + "ren");}
      if (switch_output_fact){system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + "fact");}
      if (switch_output_equal){system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + "equal");}
      if (switch_output_antipodal){system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + "antipodal");}
      if (switch_output_7point){system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + "7-point");}
      if (switch_output_9point){system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + "9-point");}
    
      for (int i_v = 0; i_v < name_scale_variation_TSV.size(); i_v++){
	//      system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + name_scale_variation_TSV[i_v]);
	if (name_scale_variation_TSV[i_v] == "complete" && !switch_output_complete){continue;}
	if (name_scale_variation_TSV[i_v] == "ren" && !switch_output_ren){continue;}
	if (name_scale_variation_TSV[i_v] == "fact" && !switch_output_fact){continue;}
	if (name_scale_variation_TSV[i_v] == "equal" && !switch_output_equal){continue;}
	if (name_scale_variation_TSV[i_v] == "antipodal" && !switch_output_antipodal){continue;}
	if (name_scale_variation_TSV[i_v] == "7-point" && !switch_output_7point){continue;}
	if (name_scale_variation_TSV[i_v] == "9-point" && !switch_output_9point){continue;}
	// only if filled ???
	for (int i_l = 0; i_l < xlist.size(); i_l++){
	  if (switch_output_overview > 1 || switch_output_result > 1 || switch_output_plot > 1 || switch_output_qTcut > 1){
	    system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + name_scale_variation_TSV[i_v] + "/" + xlist[i_l]->resultdirectory);
	    // only if filled ???
	    if (switch_output_overview > 3 || switch_output_result > 3 || switch_output_plot > 3 || switch_output_qTcut > 3){
	      for (int i_c = 1; i_c < xlist[i_l]->xcontribution.size(); i_c++){
		system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + name_scale_variation_TSV[i_v] + "/" + xlist[i_l]->resultdirectory + "/" + xlist[i_l]->xcontribution[i_c]->infix_contribution);
	      }
	    }
	  }
	}
      }
    }
    logger << LOG_INFO << "Directories created." << endline_flush;
    //    exit(0);



    for (int i_l = 0; i_l < xlist.size(); i_l++){
      for (int i_c = 1; i_c < xlist[i_l]->xcontribution.size(); i_c++){xlist[i_l]->xcontribution[i_c]->readin_contribution_remove_run();}
    }

    for (int i_l = 0; i_l < list_contribution_file.size(); i_l++){
      logger << LOG_DEBUG_VERBOSE << "collect_contribution:   list_contribution_file[" << i_l << "] = " << list_contribution_file[i_l] << endline_flush;

      if (osi->switch_CV){xlist[i_l]->collect_contribution_result_CV();}
      if (osi->switch_TSV){xlist[i_l]->collect_contribution_result_TSV();}
    }

    for (int i_l = 0; i_l < list_contribution_file.size(); i_l++){
      logger << LOG_DEBUG_VERBOSE << "readin_runtime:   list_contribution_file[" << i_l << "] = " << list_contribution_file[i_l] << endline_flush;
      for (int i_c = 1; i_c < xlist[i_l]->xcontribution.size(); i_c++){xlist[i_l]->xcontribution[i_c]->readin_runtime_contribution();}
      xlist[i_l]->calculate_runtime();
    }

    for (int i_l = 0; i_l < xlist.size(); i_l++){
      for (int i_c = 1; i_c < xlist[i_l]->xcontribution.size(); i_c++){
	for (int i_p = 1; i_p < xlist[i_l]->xcontribution[i_c]->xsubprocess.size(); i_p++){
	  if (osi->switch_CV){
	    vector<vector<vector<double> > > ().swap(xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->result_run_CV);
	    vector<vector<vector<double> > > ().swap(xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->deviation_run_CV);
	  }
	  if (osi->switch_TSV){
	    vector<vector<vector<vector<vector<vector<vector<double> > > > > > > ().swap(xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->result_group_run_TSV);
	    vector<vector<vector<vector<vector<vector<vector<double> > > > > > > ().swap(xlist[i_l]->xcontribution[i_c]->xsubprocess[i_p]->deviation_group_run_TSV);
	  }
	}
      }
    }

    for (int i_o = 0; i_o < yorder.size(); i_o++){
      for (int i_l = 0; i_l < yorder[i_o]->contribution_file.size(); i_l++){
	int x_l = mapping_contribution_file[yorder[i_o]->contribution_file[i_l]];
	yorder[i_o]->xlist.push_back(xlist[x_l]);
      }
    }

    if (osi->switch_CV){collect_order_result_CV();} // partially contains runtime evaluation !!!
    if (osi->switch_TSV){collect_order_result_TSV();}

    determination_runtime_result();

    // add scaleband output for cross sections ???

  }



  if (order == "distribution"){
    // create result output directories for single-scale results
    scalename_TSV.resize(osi->n_extended_set_TSV);
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      scalename_TSV[i_s].resize(osi->n_scale_ren_TSV[i_s], vector<string> (osi->n_scale_fact_TSV[i_s]));
      if (osi->switch_distribution_TSV[i_s] != 0){
	system_execute(logger, "mkdir " + final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s]);
	for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	  for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	    stringstream scalepart;
	    scalepart << "scale." << i_r << "." << i_f;
	    scalename_TSV[i_s][i_r][i_f] = final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + scalepart.str();
	    system_execute(logger, "mkdir " + scalename_TSV[i_s][i_r][i_f]);
	    logger << LOG_DEBUG_VERBOSE << "mkdir " << scalename_TSV[i_s][i_r][i_f] << endline_flush;
	  }
	}
      }
    }
    
    initialization_distribution();

    if (osi->switch_CV){for (int i_l = 0; i_l < list_contribution_file.size(); i_l++){xlist[i_l]->collect_contribution_distribution_CV();}}
    if (osi->switch_TSV){for (int i_l = 0; i_l < list_contribution_file.size(); i_l++){xlist[i_l]->collect_contribution_distribution_TSV();}}

    for (int i_o = 0; i_o < yorder.size(); i_o++){
      logger << LOG_DEBUG << "yorder[i_o = " << i_o << "].contribution_file.size() = " << yorder[i_o]->contribution_file.size() << endline_flush;
      for (int i_l = 0; i_l < yorder[i_o]->contribution_file.size(); i_l++){
	int x_l = mapping_contribution_file[yorder[i_o]->contribution_file[i_l]];
	yorder[i_o]->xlist.push_back(xlist[x_l]);
      }
    }
    if (osi->switch_CV){collect_order_distribution_CV();}
    if (osi->switch_TSV){collect_order_distribution_TSV();}

    //    logger << LOG_INFO << "infilename_scaleband = " << infilename_scaleband << endline_flush;

    logger << LOG_DEBUG << "clear xlist since not needed any longer !!!" << endline_flush;
    for (int i_l = 0; i_l < xlist.size(); i_l++){delete xlist[i_l];}
    xlist.clear();
    logger << LOG_DEBUG << "clear xlist done." << endline_flush;

    if (infilename_scaleband != ""){
      logger << LOG_INFO << "Determination of scaleband (defined in  " << infilename_scaleband << " ) is started - final_resultdirectory = " << final_resultdirectory << " ." << endline_flush;
      determine_scaleband();
    }

    // add runtime estimate based on a selected distribution / a number of selected distributions !!!

  }
  if (order == "scaleband"){
    initialization_distribution();

    if (infilename_scaleband != ""){
      logger << LOG_INFO << "Determination of scaleband (defined in  " << infilename_scaleband << " ) is started - final_resultdirectory = " << final_resultdirectory << " ." << endline_flush;
      determine_scaleband();
    }
  }

  if (order == "processcombination"){
    initialization_distribution();

    if (infilename_scaleband != ""){
      logger << LOG_INFO << "Determination of process_combination (defined in  " << infilename_scaleband << " ) is started - final_resultdirectory = " << final_resultdirectory << " ." << endline_flush;
      determine_process_combination();
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_generic::output_filename_TSV(string & filename_begin, string & filename_end){
  Logger logger("summary_generic::output_filename_TSV");
  logger << LOG_DEBUG_VERBOSE  << "called" << endline_flush;

  filename_complete = filename_begin + "/complete/" + filename_end;
  filename_ren = filename_begin + "/ren/" + filename_end;
  filename_fact = filename_begin + "/fact/" + filename_end;
  filename_equal = filename_begin + "/equal/" + filename_end;
  filename_antipodal = filename_begin + "/antipodal/" + filename_end;

  logger << LOG_DEBUG_VERBOSE  << "finished" << endline_flush;
}


bool summary_generic::output_selection_scale_check_TSV(string selection, int i_s, int i_r, int i_f){
  Logger logger("summary_generic::output_result_overview_scale_check_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  if (selection == "complete"){return true;}
  else if (selection == "ren"){if (i_f == osi->no_central_scale_fact_TSV[i_s]){return true;} else {return false;}}
  else if (selection == "fact"){if (i_r == osi->no_central_scale_ren_TSV[i_s]){return true;} else {return false;}}
  else if (selection == "equal"){if (i_r == i_f){return true;} else {return false;}}
  else if (selection == "antipodal"){if (i_r == osi->n_scale_fact_TSV[i_s] - i_f - 1){return true;} else {return false;}}
  else if (selection == "7-point"){if (!(i_r == 0 && i_f == 2) && !(i_r == 2 && i_f == 0)){return true;}else {return false;}}
  else if (selection == "9-point"){return true;}
  else {return false;}
  
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_generic::collect_order_result_TSV(){
  Logger logger("summary_generic::collect_order_result_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  system_execute(logger, "mkdir " + final_resultdirectory);

  for (int i_o = 0; i_o < yorder.size(); i_o++){yorder[i_o]->collect_result_TSV(subgroup);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_generic::collect_order_result_CV(){
  Logger logger("summary_generic::collect_order_result_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  for (int i_o = 0; i_o < yorder.size(); i_o++){yorder[i_o]->collect_result_CV(subgroup);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_generic::collect_order_distribution_TSV(){
  Logger logger("summary_generic::collect_order_distribution_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // Avoid attempt to re-create result directories for each order:
  int temp_selection_n_qTcut = 1;
  for (int i_o = 0; i_o < yorder.size(); i_o++){
    if (temp_selection_n_qTcut < yorder[i_o]->selection_n_qTcut){temp_selection_n_qTcut = yorder[i_o]->selection_n_qTcut;}
  }
   
  for (int x_q = 0; x_q < temp_selection_n_qTcut; x_q++){
    stringstream qTcut_ss;
    qTcut_ss << "qTcut-" << osi->value_qTcut_distribution[x_q];
    string subdirectory = "/" + qTcut_ss.str();
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!switch_output_scaleset[i_s]){continue;}
      if (!osi->switch_distribution_TSV[i_s]){continue;}
      for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	  string directory_distribution_plot = scalename_TSV[i_s][i_r][i_f] + "/" + qTcut_ss.str();
	  logger << LOG_DEBUG << "   mkdir " << directory_distribution_plot << endline_flush;
	  system_execute(logger, "mkdir " + directory_distribution_plot);
	}
      }
    }
  }

  for (int i_o = 0; i_o < yorder.size(); i_o++){yorder[i_o]->collect_distribution_TSV();}

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_generic::collect_order_distribution_CV(){
  Logger logger("summary_generic::collect_order_distribution_CV");
  logger << LOG_DEBUG_VERBOSE  << "called" << endline_flush;

  for (int i_o = 0; i_o < yorder.size(); i_o++){yorder[i_o]->collect_distribution_CV();}

  // old asymmetry implementation deactivated for now !!!

  /*
  for (int i_o = 0; i_o < yorder.size(); i_o++){
    yorder[i_o]->distribution_result_CV.resize(subgroup.size(), vector<vector<vector<double> > > (osi->extended_distribution.size()));
    yorder[i_o]->distribution_deviation_CV.resize(subgroup.size(), vector<vector<vector<double> > > (osi->extended_distribution.size()));
    for (int i_g = 0; i_g < subgroup.size(); i_g++){
      for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
	if (!switch_output_distribution[i_d]){continue;}
	yorder[i_o]->distribution_result_CV[i_g][i_d].resize(osi->extended_distribution[i_d].n_bins, vector<double> (osi->n_scales_CV, 0.));
	yorder[i_o]->distribution_deviation_CV[i_g][i_d].resize(osi->extended_distribution[i_d].n_bins, vector<double> (osi->n_scales_CV, 0.));
      }
    }

    for (int i_g = 0; i_g < subgroup.size(); i_g++){
      for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
	if (!switch_output_distribution[i_d]){continue;}
	for (int i_b = 0; i_b < osi->extended_distribution[i_d].n_bins; i_b++){
	  for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	    double dev = 0.;
	    for (int i_l = 0; i_l < yorder[i_o]->contribution_file.size(); i_l++){
	      int x_l = mapping_contribution_file[yorder[i_o]->contribution_file[i_l]];
	      yorder[i_o]->distribution_result_CV[i_g][i_d][i_b][i_s] += xlist[x_l]->xcontribution[0]->distribution_result_CV[i_g][i_d][i_b][i_s];
	      dev += pow(xlist[x_l]->xcontribution[0]->distribution_deviation_CV[i_g][i_d][i_b][i_s], 2);
	    }
	    yorder[i_o]->distribution_deviation_CV[i_g][i_d][i_b][i_s] = sqrt(dev);
	    stringstream temp_res;
	    temp_res << setw(23) << setprecision(15) << yorder[i_o]->distribution_result_CV[i_g][i_d][i_b][i_s];
	    stringstream temp_dev;
	    temp_dev << setw(23) << setprecision(15) << yorder[i_o]->distribution_deviation_CV[i_g][i_d][i_b][i_s];
	    logger << LOG_DEBUG_VERBOSE << "XXX   result_CV[" << i_o << "][" << i_g << "][" << i_d << "][" << i_b << "][" << i_s << "] = " << temp_res.str() << " +- " << temp_dev.str() << endline_flush;
	  }
	}
      }
    }
  */
  for (int i_o = 0; i_o < 0; i_o++){
    exit(1);
    // to switch off this loop...
    //  for (int i_o = 0; i_o < yorder.size(); i_o++){

    if (switch_output_overview > 0){yorder[i_o]->output_distribution_overview_CV();}

    for (int i_g = 0; i_g < subgroup.size(); i_g++){
      for (int i_d = 0; i_d < osi->extended_distribution.size(); i_d++){
	if (!switch_output_distribution[i_d]){continue;}
	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  if ((osi->extended_distribution[i_d].xdistribution_name).substr(0, 4) == "asym"){
	  /*
	  double result_fw, result_bw, deviation_fw, deviation_bw;
	  ofstream out_asymfile;
	  string filename_asym = final_resultdirectory + "/CV/" + osi->directory_name_scale_CV[i_s] + "/" + osi->extended_distribution[i_d].xdistribution_name + "." + infix_order_contribution[0] + ".dat";
	  logger << LOG_DEBUG_VERBOSE << "filename_asym = " << filename_asym << endline_flush;
	  out_asymfile.open(filename_asym.c_str(), ofstream::out | ofstream::trunc);
	  if (osi->extended_distribution[i_d].xdistribution_type == "asym1" || osi->extended_distribution[i_d].xdistribution_type == "asym2"){
	    ofstream out_plotfile;
	    string filename_plot = final_resultdirectory + "/CV/" + osi->directory_name_scale_CV[i_s] + "/plot." + osi->extended_distribution[i_d].xdistribution_name + "." + infix_order_contributiony[0] + ".dat";
	    logger << LOG_DEBUG_VERBOSE << "filename_plot = " << filename_plot << endline_flush;
	    out_plotfile.open(filename_plot.c_str(), ofstream::out | ofstream::trunc);
	    // too slow // checksum << setw(16) << "interval" << " " << setw(16) << "backward cs." << setw(16) << "forward cs." << setw(16) << "cross section" << endline;
	    for (int i_b = 0; i_b < n_bin_distribution[i_d]; i_b++){
	      if (osi->extended_distribution[i_d].xdistribution_type == "asym1"){
		result_fw = yorder[i_o]->distribution_result_CV[i_g][i_d][n_bin_distribution[i_d] + i_b][i_s] * osi->fakeasymfactor[i_d];
		result_bw = yorder[i_o]->distribution_result_CV[i_g][i_d][i_b][i_s] * osi->fakeasymfactor[i_d];
		deviation_fw = yorder[i_o]->distribution_deviation_CV[i_g][i_d][n_bin_distribution[i_d] + i_b][i_s] * osi->fakeasymfactor[i_d];
		deviation_bw = yorder[i_o]->distribution_deviation_CV[i_g][i_d][i_b][i_s] * osi->fakeasymfactor[i_d];
	      }
	      else if (osi->extended_distribution[i_d].xdistribution_type == "asym2"){
		result_fw = yorder[i_o]->distribution_result_CV[i_g][i_d][2 * i_b + 1][i_s] * osi->fakeasymfactor[i_d];
		result_bw = yorder[i_o]->distribution_result_CV[i_g][i_d][2 * i_b + 0][i_s] * osi->fakeasymfactor[i_d];
		deviation_fw = yorder[i_o]->distribution_deviation_CV[i_g][i_d][2 * i_b + 1][i_s] * osi->fakeasymfactor[i_d];
		deviation_bw = yorder[i_o]->distribution_deviation_CV[i_g][i_d][2 * i_b + 0][i_s] * osi->fakeasymfactor[i_d];
	      }
	      out_asymfile << setw(25) << "backw. cross section: " << "   [" << setw(5) << setprecision(4) << bin_edge[i_d][i_b] << ";" << setw(5) << setprecision(4) << bin_edge[i_d][i_b + 1] << "]   " << setw(16) << setprecision(8) << result_bw * osi->extended_distribution[i_d].step << setw(16) << setprecision(8) << deviation_bw * osi->extended_distribution[i_d].step << endline;
	      out_asymfile << setw(25) << "forw. cross section: " << "   [" << setw(5) << setprecision(4) << bin_edge[i_d][i_b] << ";" << setw(5) << setprecision(4) << bin_edge[i_d][i_b + 1] << "]   " << setw(16) << setprecision(8) << result_fw * osi->extended_distribution[i_d].step << setw(16) << setprecision(8) << deviation_fw * osi->extended_distribution[i_d].step << endline;
	      out_asymfile << setw(25) << "forw.-backw. asymmetry: " << "   [" << setw(5) << setprecision(4) << bin_edge[i_d][i_b] << ";" << setw(5) << setprecision(4) << bin_edge[i_d][i_b + 1] << "]   " << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2) << endline;
	      out_plotfile << setw(5) << setprecision(4) << bin_edge[i_d][i_b] << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2) << endline;
	      double sum_result_fw = 0., sum_result_bw = 0.;
	      for (int c = i_b; c < n_bin_distribution[i_d]; c++){
		if (osi->extended_distribution[i_d].xdistribution_type == "asym1"){
		  sum_result_fw += yorder[i_o]->distribution_result_CV[i_g][i_d][n_bin_distribution[i_d] + c][i_s] * osi->fakeasymfactor[i_d];
		  sum_result_bw += yorder[i_o]->distribution_result_CV[i_g][i_d][c][i_s] * osi->fakeasymfactor[i_d];
		}
		else if (osi->extended_distribution[i_d].xdistribution_type == "asym2"){
		  sum_result_fw += yorder[i_o]->distribution_result_CV[i_g][i_d][2 * c + 1][i_s] * osi->fakeasymfactor[i_d];
		  sum_result_bw += yorder[i_o]->distribution_result_CV[i_g][i_d][2 * c + 0][i_s] * osi->fakeasymfactor[i_d];
		}
	      }
	    }
	    out_plotfile << setw(5) << setprecision(4) << osi->extended_distribution[i_d].end << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2) << endline;
	    out_asymfile.close();
	    out_plotfile.close();
	  }
	  else {
	    result_fw = yorder[i_o]->distribution_result_CV[i_g][i_d][1][i_s] * osi->fakeasymfactor[i_d];
	    result_bw = yorder[i_o]->distribution_result_CV[i_g][i_d][0][i_s] * osi->fakeasymfactor[i_d];
	    deviation_fw = yorder[i_o]->distribution_deviation_CV[i_g][i_d][1][i_s] * osi->fakeasymfactor[i_d];
	    deviation_bw = yorder[i_o]->distribution_deviation_CV[i_g][i_d][0][i_s] * osi->fakeasymfactor[i_d];
	    out_asymfile << setw(25) << "backw. cross section: " << setw(16) << setprecision(8) << result_bw << setw(16) << setprecision(8) << deviation_bw << endline;
	    out_asymfile << setw(25) << "forw. cross section: " << setw(16) << setprecision(8) << result_fw << setw(16) << setprecision(8) << deviation_fw << endline;
	    out_asymfile << setw(25) << "forw.-backw. asymmetry: " << setw(16) << setprecision(8) << (result_fw - result_bw) / (result_fw + result_bw) << setw(16) << 2. * (deviation_fw * result_bw + deviation_bw * result_fw) / pow(result_bw + result_fw, 2) << endline;
	    out_asymfile.close();
	  }
	  */
	  }
	  else {
	    ofstream out_plotfile;
	    string filename_plot = final_resultdirectory + "/CV/" + osi->directory_name_scale_CV[i_s] + "/plot." + osi->extended_distribution[i_d].xdistribution_name + ".." + yorder[i_o]->resultdirectory + ".dat";
	    logger << LOG_DEBUG_VERBOSE << "filename_plot = " << filename_plot << endline_flush;
	    out_plotfile.open(filename_plot.c_str(), ofstream::out | ofstream::trunc);
	    for (int i_b = 0; i_b < yorder[i_o]->distribution_result_CV[i_g][i_d].size(); i_b++){

	      out_plotfile << setw(10) << osi->extended_distribution[i_d].bin_edge[i_b] << setw(16) << setprecision(8) << osi->unit_factor_distribution * yorder[i_o]->distribution_result_CV[i_g][i_d][i_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b] << setw(16) << setprecision(8) << osi->unit_factor_distribution * yorder[i_o]->distribution_deviation_CV[i_g][i_d][i_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b] << endline;
	      // norm ->	    out_plotfile << setw(10) << osi->extended_distribution[i_d].bin_edge[i_b] << setw(16) << setprecision(8) << osi->unit_factor_distribution * yorder[i_o]->distribution_result_CV[i_g][i_d][i_b][i_s] << setw(16) << setprecision(8) << osi->unit_factor_distribution * yorder[i_o]->distribution_deviation_CV[i_g][i_d][i_b][i_s] << endline;
	      double sum_result = 0.;
	      for (int j_b = i_b; j_b < osi->extended_distribution[i_d].n_bins; j_b++){sum_result += yorder[i_o]->distribution_result_CV[i_g][i_d][j_b][i_s];}
	      //	      for (int j_b = i_b; j_b < osi->extended_distribution[i_d].n_bins; j_b++){sum_result += yorder[i_o]->distribution_result_CV[i_g][i_d][j_b][i_s] / osi->extended_distribution[i_d].bin_width[i_b];}
	    }
	    out_plotfile << setw(10) << osi->extended_distribution[i_d].bin_edge[osi->extended_distribution[i_d].n_bins] << setw(16) << setprecision(8) << osi->unit_factor_distribution * yorder[i_o]->distribution_result_CV[i_g][i_d][yorder[i_o]->distribution_result_CV[i_g][i_d].size() - 1][i_s] / osi->extended_distribution[i_d].bin_width[osi->extended_distribution[i_d].n_bins - 1] << setw(16) << setprecision(8) << osi->unit_factor_distribution * yorder[i_o]->distribution_deviation_CV[i_g][i_d][yorder[i_o]->distribution_deviation_CV[i_g][i_d].size() - 1][i_s] / osi->extended_distribution[i_d].bin_width[osi->extended_distribution[i_d].n_bins - 1] << endline; // endpoint
	    // norm ->	    out_plotfile << setw(10) << osi->extended_distribution[i_d].bin_edge[osi->extended_distribution[i_d].n_bins] << setw(16) << setprecision(8) << osi->unit_factor_distribution * yorder[i_o]->distribution_result_CV[i_g][i_d][yorder[i_o]->distribution_result_CV[i_g][i_d].size() - 1][i_s] << setw(16) << setprecision(8) << osi->unit_factor_distribution * yorder[i_o]->distribution_deviation_CV[i_g][i_d][yorder[i_o]->distribution_deviation_CV[i_g][i_d].size() - 1][i_s] << endline; // endpoint

	    out_plotfile.close();
	  }
	}
      }
    }
  }

  logger << LOG_DEBUG_VERBOSE  << "finished" << endline_flush;
}



