#include "header.hpp"

void summary_order::output_result_overview_TSV(){
  Logger logger("summary_order::output_result_overview_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 15 + 15 + 15 + 25 + 15 + 15 + 4 + 15;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  int start_i_m = 0; // temporary !!!
  //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
  for (int i_m = start_i_m; i_m < 1; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}
      system_execute(logger, "mkdir " + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s]);

      stringstream name_ss;
      name_ss << "dXS +- err (list)";

      stringstream header_ss;
      header_ss << left;
      header_ss << setw(15) << "qTcut";
      header_ss << setw(5) << "mu_R/" << setw(10) << osi->name_extended_set_TSV[i_s];
      header_ss << setw(5) << "mu_F/" << setw(10) << osi->name_extended_set_TSV[i_s];
      header_ss << setw(25) << "list";
      header_ss << setw(15) << "";
      header_ss << right;
      header_ss << setw(34) << name_ss.str();

      if (ygeneric->switch_output_complete){output_result_overview_selection_TSV("complete", i_m, i_s, header_ss, temp_ss_separation_one, temp_ss_separation_two);}
      if (ygeneric->switch_output_ren){output_result_overview_selection_TSV("ren", i_m, i_s, header_ss, temp_ss_separation_one, temp_ss_separation_two);}
      if (ygeneric->switch_output_fact){output_result_overview_selection_TSV("fact", i_m, i_s, header_ss, temp_ss_separation_one, temp_ss_separation_two);}
      if (ygeneric->switch_output_equal){output_result_overview_selection_TSV("equal", i_m, i_s, header_ss, temp_ss_separation_one, temp_ss_separation_two);}
      if (ygeneric->switch_output_antipodal){output_result_overview_selection_TSV("antipodal", i_m, i_s, header_ss, temp_ss_separation_one, temp_ss_separation_two);}
      if (ygeneric->switch_output_7point){output_result_overview_selection_TSV("7-point", i_m, i_s, header_ss, temp_ss_separation_one, temp_ss_separation_two);}
      if (ygeneric->switch_output_9point){output_result_overview_selection_TSV("9-point", i_m, i_s, header_ss, temp_ss_separation_one, temp_ss_separation_two);}
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_overview_selection_TSV(string selection, int i_m, int i_s, stringstream & header_ss, stringstream & temp_ss_separation_one, stringstream & temp_ss_separation_two){
  Logger logger("summary_order::output_result_overview_selection_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  //  int temp_size_result;
  //  int temp_size_deviation;

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/overview" + ygeneric->infix_name_moment[i_m] + "." + resultdirectory + ".dat";
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << header_ss.str() << endline;
  outfile_selection << endline;
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      int temp_size_result_0 = int(log10(abs(osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f])));
      int temp_size_result = int(log10(abs(osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f])));
      for (int i_l = 0; i_l < xlist.size(); i_l++){
	int temp_size_result_l = int(log10(abs(osi->unit_factor_result * xlist[i_l]->result_TSV[i_m][0][i_s][i_r][i_f])));
	if (temp_size_result_l > temp_size_result){temp_size_result = temp_size_result_l;}
      }
      int temp_size_deviation = int(log10(abs(osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f])));
      if (osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}

      stringstream temp_ss;
      temp_ss << left << noshowpoint;
      if (active_qTcut){temp_ss << setw(15) << "extrapolation";}
      else {temp_ss << setw(15) << "independent";}
      temp_ss << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
      temp_ss << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
      temp_ss << setw(25) << resultdirectory;
      temp_ss << left << setw(15) << "";
      temp_ss << showpoint;
      temp_ss << right << setw(15) << setprecision(10 + temp_size_result_0 - temp_size_result) << showpoint;
      temp_ss << osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f];
      temp_ss << " +- ";
      temp_ss << right << setw(15) << setprecision(10 + temp_size_deviation - temp_size_deviation - (temp_size_result - temp_size_deviation + 1));
      temp_ss << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f];
      outfile_selection << temp_ss.str() << endline;
      //      outfile_selection << format_output_result_overview_order_TSV(i_m, i_s, i_r, i_f, temp_size_result, temp_size_deviation) << endline;
      outfile_selection << temp_ss_separation_one.str() << endline;
      //      for (int i_l = 0; i_l < xlist.size(); i_l++){outfile_selection << format_output_result_overview_list_TSV(i_l, i_m, i_s, i_r, i_f, temp_size_result, temp_size_deviation) << endline;}
      for (int i_l = 0; i_l < xlist.size(); i_l++){
	int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_result * xlist[i_l]->result_TSV[i_m][0][i_s][i_r][i_f])));
	int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_result * xlist[i_l]->deviation_TSV[i_m][0][i_s][i_r][i_f])));
	if (osi->unit_factor_result * xlist[i_l]->deviation_TSV[i_m][0][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
	if (xlist[i_l]->result_TSV[i_m][0][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
	if (xlist[i_l]->deviation_TSV[i_m][0][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
	int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
	int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
	if (xlist[i_l]->result_TSV[i_m][0][i_s][i_r][i_f] == 0.){setw_result = 1;setw_deviation = 1;}
	else if (abs(osi->unit_factor_result * xlist[i_l]->result_TSV[i_m][0][i_s][i_r][i_f]) < 1.){setw_result--;}

	stringstream temp_l_ss;
	temp_l_ss << left;
	if (xlist[i_l]->active_qTcut){temp_l_ss << setw(15) << "extrapolation";}
	else {temp_l_ss << setw(15) << "independent";}
	temp_l_ss << noshowpoint;
	temp_l_ss << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
	temp_l_ss << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
	temp_l_ss << setw(25) << xlist[i_l]->xcontribution[0]->infix_order_contribution;
	if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){temp_l_ss << left << setw(5) << xlist[i_l]->channel_selection;}
	else {temp_l_ss << left << setw(5) << "";}
	if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){temp_l_ss << left << setw(10) << xlist[i_l]->extra_selection;}
	else {temp_l_ss << left << setw(10) << "";}
	temp_l_ss << showpoint;
	temp_l_ss << right << setw(15) << setprecision(setw_result) << showpoint;
	temp_l_ss << osi->unit_factor_result * xlist[i_l]->result_TSV[i_m][0][i_s][i_r][i_f];
	temp_l_ss << " +- ";
	temp_l_ss << right << setw(15) << setprecision(setw_deviation);
	temp_l_ss << osi->unit_factor_result * xlist[i_l]->deviation_TSV[i_m][0][i_s][i_r][i_f];
	outfile_selection << temp_l_ss.str() << endline;
      }
      outfile_selection << endline;
    }
  }
  //  outfile_selection << endline;
  outfile_selection << temp_ss_separation_two.str() << endl << endline;
  if (active_qTcut){
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      outfile_selection << header_ss.str() << endline;
      outfile_selection << endline;
      for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	  if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	  //	  outfile_selection << format_output_result_overview_order_qTcut_TSV(i_m, i_q, i_s, i_r, i_f, temp_size_result, temp_size_deviation) << endline;
	  int temp_size_result_0 = int(log10(abs(osi->unit_factor_result * result_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f])));
	  int temp_size_result = int(log10(abs(osi->unit_factor_result * result_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f])));
	  for (int i_l = 0; i_l < xlist.size(); i_l++){
	    int temp_size_result_l = int(log10(abs(osi->unit_factor_result * xlist[i_l]->xcontribution[0]->result_TSV[i_m][0][i_q][i_s][i_r][i_f])));
	    if (temp_size_result_l > temp_size_result){temp_size_result = temp_size_result_l;}
	  }
	  int temp_size_deviation = int(log10(abs(osi->unit_factor_result * deviation_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f])));
	  if (osi->unit_factor_result * deviation_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f] >= 1.){temp_size_deviation++;}

	  stringstream temp_ss;
	  temp_ss << left;
	  temp_ss << noshowpoint;
	  temp_ss << setw(15) << osi->value_qTcut[i_q];
	  temp_ss << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
	  temp_ss << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
	  temp_ss << setw(25) << resultdirectory;
	  temp_ss << left << setw(15) << "";
	  temp_ss << showpoint;
	  temp_ss << right << setw(15) << setprecision(10 + temp_size_result_0 - temp_size_result) << showpoint;
	  temp_ss << osi->unit_factor_result * result_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f];
	  temp_ss << " +- ";
	  temp_ss << right << setw(15) << setprecision(10 + temp_size_deviation - temp_size_deviation - (temp_size_result - temp_size_deviation + 1));
	  temp_ss << osi->unit_factor_result * deviation_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f];
	  outfile_selection << temp_ss.str() << endline;
	  outfile_selection << temp_ss_separation_one.str() << endline;
	  for (int i_l = 0; i_l < xlist.size(); i_l++){
	    //	    outfile_selection << format_output_result_overview_list_qTcut_TSV(i_l, i_m, i_q, i_s, i_r, i_f, temp_size_result, temp_size_deviation) << endline;
	    int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_result * xlist[i_l]->xcontribution[0]->result_TSV[i_m][0][i_q][i_s][i_r][i_f])));
	    int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_result * xlist[i_l]->xcontribution[0]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f])));
	    if (osi->unit_factor_result * xlist[i_l]->xcontribution[0]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f] >= 1.){temp_size_deviation_subprocess++;}
	    if (xlist[i_l]->xcontribution[0]->result_TSV[i_m][0][i_q][i_s][i_r][i_f] == 0){temp_size_result_subprocess = 0;}
	    if (xlist[i_l]->xcontribution[0]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f] == 0){temp_size_deviation_subprocess = 0;}
	    int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
	    int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
	    if (xlist[i_l]->xcontribution[0]->result_TSV[i_m][0][i_q][i_s][i_r][i_f] == 0.){setw_result = 1; setw_deviation = 1;}
	    else if (abs(osi->unit_factor_result * xlist[i_l]->xcontribution[0]->result_TSV[i_m][0][i_q][i_s][i_r][i_f]) < 1.){setw_result--;}

	    stringstream temp_l_ss;
	    temp_l_ss << noshowpoint;
	    temp_l_ss << left << setw(15) << osi->value_qTcut[i_q];
	    temp_l_ss << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
	    temp_l_ss << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
	    temp_l_ss << setw(25) << xlist[i_l]->xcontribution[0]->infix_order_contribution;
	    if (xlist[i_l]->channel_selection != "" && xlist[i_l]->channel_selection != "---"){temp_l_ss << left << setw(5) << xlist[i_l]->channel_selection;}
	    else {temp_l_ss << left << setw(5) << "";}
	    if (xlist[i_l]->extra_selection != "" && xlist[i_l]->extra_selection != "---"){temp_l_ss << left << setw(10) << xlist[i_l]->extra_selection;}
	    else {temp_l_ss << left << setw(10) << "";}
	    temp_l_ss << showpoint;
	    temp_l_ss << right << setw(15) << setprecision(setw_result) << showpoint;
	    temp_l_ss << osi->unit_factor_result * xlist[i_l]->xcontribution[0]->result_TSV[i_m][0][i_q][i_s][i_r][i_f];
	    temp_l_ss << " +- ";
	    temp_l_ss << right << setw(15) << setprecision(setw_deviation);
	    temp_l_ss << osi->unit_factor_result * xlist[i_l]->xcontribution[0]->deviation_TSV[i_m][0][i_q][i_s][i_r][i_f];
	    outfile_selection << temp_l_ss.str() << endline;
	  }
	  outfile_selection << endline;
	}
      }
      outfile_selection << temp_ss_separation_two.str() << endline << endline;
    }
  }
  outfile_selection.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_TSV(){
  Logger logger("summary_order::output_result_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;
  
  int start_i_m = 0; // temporary !!!
  //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
  for (int i_m = start_i_m; i_m < 1; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      if (i_m > 0 && !osi->switch_moment_TSV[i_s]){continue;}

      system_execute(logger, "mkdir " + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s]);

      stringstream header_ss;
      header_ss << noshowpoint << left << setw(15) << "qTcut" << setw(5) << "mu_R/" << setw(10) << osi->name_extended_set_TSV[i_s] << setw(5) << "mu_F/" << setw(10) << osi->name_extended_set_TSV[i_s]	<< "XS +- err (" << resultdirectory << ")";

      if (ygeneric->switch_output_complete){output_result_selection_TSV("complete", i_m, i_s, header_ss);}
      if (ygeneric->switch_output_ren){output_result_selection_TSV("ren", i_m, i_s, header_ss);}
      if (ygeneric->switch_output_fact){output_result_selection_TSV("fact", i_m, i_s, header_ss);}
      if (ygeneric->switch_output_equal){output_result_selection_TSV("equal", i_m, i_s, header_ss);}
      if (ygeneric->switch_output_antipodal){output_result_selection_TSV("antipodal", i_m, i_s, header_ss);}
      if (ygeneric->switch_output_7point){output_result_selection_TSV("7-point", i_m, i_s, header_ss);}
      if (ygeneric->switch_output_9point){output_result_selection_TSV("9-point", i_m, i_s, header_ss);}
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_selection_TSV(string selection, int i_m, int i_s, stringstream & header_ss){
  Logger logger("summary_order::output_result_selection_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/result" + ygeneric->infix_name_moment[i_m] + "." + resultdirectory + ".dat";
  ofstream outfile_selection;
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << header_ss.str() << endl << endline;
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      stringstream temp_ss;
      temp_ss << left ;
      if (active_qTcut){temp_ss << setw(15) << "extrapolation";}
      else {temp_ss << setw(15) << "independent";}
      temp_ss << left << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
      temp_ss << left << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
      temp_ss << left << showpoint;
      temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f];
      temp_ss << " +- ";
      temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f];

      outfile_selection << temp_ss.str() << endline;
    }
  }
  if (active_qTcut){
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      outfile_selection << endline;
      for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	  if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	  stringstream temp_ss;
	  temp_ss << noshowpoint << left << setw(15) << osi->value_qTcut[i_q];
	  temp_ss << left << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
	  temp_ss << left << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
	  temp_ss << left << showpoint;
	  temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * result_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f];
	  temp_ss << " +- ";
	  temp_ss << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f];
	  outfile_selection << temp_ss.str() << endline;
	}
      }
    }
  }
  outfile_selection.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_moment_TSV(string label){
  Logger logger("summary_order::output_result_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  // More general implementation of moments still missing !!!

  for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
    if (!ygeneric->switch_output_scaleset[i_s]){continue;}
    if (!osi->switch_moment_TSV[i_s]){continue;}
    system_execute(logger, "mkdir " + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s]);

    stringstream header_ss;
    header_ss << noshowpoint << left;
    if (osi->n_moments == 12){header_ss << setw(25) << "moment";}
    else {header_ss << setw(25) << "qTcut";}
    header_ss << setw(5) << "mu_R/" << setw(10) << osi->name_extended_set_TSV[i_s];
    header_ss << setw(5) << "mu_F/" << setw(10) << osi->name_extended_set_TSV[i_s];
    header_ss << setw(10) << "exponent" << label << "   (" << resultdirectory << ")";
    //		<< "XS +- err (" << resultdirectory << ")";
    if (ygeneric->switch_output_complete){output_moment_selection_TSV("complete", i_s, header_ss, label);}
    if (ygeneric->switch_output_ren){output_moment_selection_TSV("ren", i_s, header_ss, label);}
    if (ygeneric->switch_output_fact){output_moment_selection_TSV("fact", i_s, header_ss, label);}
    if (ygeneric->switch_output_equal){output_moment_selection_TSV("equal", i_s, header_ss, label);}
    if (ygeneric->switch_output_antipodal){output_moment_selection_TSV("antipodal", i_s, header_ss, label);}
    if (ygeneric->switch_output_7point){output_moment_selection_TSV("7-point", i_s, header_ss, label);}
    if (ygeneric->switch_output_9point){output_moment_selection_TSV("9-point", i_s, header_ss, label);}
	
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_moment_selection_TSV(string selection, int i_s, stringstream & header_ss, string label){
  Logger logger("summary_order::output_moment_selection_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/result" + "_" + label + "." + resultdirectory + ".dat";
  ofstream outfile_selection;
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << header_ss.str() << endl << endline;
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      int start_i_m = 1; // temporary !!!
      for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
	//  for (int i_m = start_i_m; i_m < 1; i_m++){
	stringstream temp_ss;
	temp_ss << left ;
	if (osi->n_moments == 12){
	  if      (i_m == 1){temp_ss << setw(25) << "<pT_jet_1>";}
	  else if (i_m == 2){temp_ss << setw(25) << "<pT_jet_2>";}
	  else if (i_m == 3){temp_ss << setw(25) << "<pT_jet_3>";}
	  else if (i_m == 4){temp_ss << setw(25) << "<pT_bjet_1>";}
	  else if (i_m == 5){temp_ss << setw(25) << "<pT_bjet_2>";}
	  else if (i_m == 6){temp_ss << setw(25) << "<pT_ljet_1>";}
	  else if (i_m == 7){temp_ss << setw(25) << "<pT_ljet_2>";}
	  else if (i_m == 8){temp_ss << setw(25) << "<pT_jet_1/pT_bjet_1>";}
	  else if (i_m == 9){temp_ss << setw(25) << "<pT_jet_1/pT_bjet_2>";}
	  else if (i_m == 10){temp_ss << setw(25) << "<pT_ljet_1/pT_bjet_1>";}
	  else if (i_m == 11){temp_ss << setw(25) << "<pT_ljet_1/pT_bjet_2>";}
	}
	else {
	  if (active_qTcut){temp_ss << setw(25) << "extrapolation";}
	  else {temp_ss << setw(25) << "independent";}
	}
	//		 temp_ss << setw(15) << "0"
	temp_ss << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r] << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
	temp_ss << setw(10) << i_m << showpoint << setprecision(8) << setw(15) << result_TSV[i_m][0][i_s][i_r][i_f];
	//		  << " +- "
	//		  << setprecision(8) << setw(15) << deviation_TSV[i_m][0][i_s][i_r][i_f];

	outfile_selection << temp_ss.str() << endline;
      }
      outfile_selection << endline;
    }
  }
  if (active_qTcut){
    for (int i_q = 0; i_q < output_n_qTcut; i_q++){
      outfile_selection << endline;
      for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
	for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	  if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	  stringstream temp_ss;
	  int start_i_m = 1; // temporary !!!
	  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
	    //  for (int i_m = start_i_m; i_m < 1; i_m++){
	    temp_ss << noshowpoint << left << setw(15) << osi->value_qTcut[i_q];
	    temp_ss << setw(15) << setprecision(8) << osi->relative_scale_ren_TSV[i_s][i_r];
	    temp_ss << setw(15) << setprecision(8) << osi->relative_scale_fact_TSV[i_s][i_f];
	    temp_ss << showpoint << setprecision(8) << setw(15) << result_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f];
	    //		      << " +- "
	    //		      << setprecision(8) << setw(15) << deviation_qTcut_TSV[i_m][0][i_q][i_s][i_r][i_f];
	    outfile_selection << temp_ss.str() << endline;
	  }
	  outfile_selection << endline;
	}
      }
    }
  }
  outfile_selection.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_TSV(){
  Logger logger("summary_order::output_result_plot_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  //  write out only the (if qTcut-dependent extrapolated) results:

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < 1; i_m++){
    //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      system_execute(logger, "mkdir " + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s]);

      if (ygeneric->switch_output_complete){output_result_plot_selection_TSV("complete", i_m, i_s);}
      if (ygeneric->switch_output_ren){output_result_plot_selection_TSV("ren", i_m, i_s);}
      if (ygeneric->switch_output_fact){output_result_plot_selection_TSV("fact", i_m, i_s);}
      if (ygeneric->switch_output_equal){output_result_plot_selection_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_antipodal){output_result_plot_selection_TSV("antipodal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_result_plot_selection_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_result_plot_selection_TSV("9-point", i_m, i_s);}

      if (ygeneric->switch_output_equal){output_result_plot_band_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_result_plot_band_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_result_plot_band_TSV("9-point", i_m, i_s);}
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_selection_TSV(string selection, int i_m, int i_s){
  Logger logger("summary_order::output_result_plot_selection_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/plot" + ygeneric->infix_name_moment[i_m] + "." + resultdirectory + ".dat";
  logger << LOG_DEBUG_VERBOSE << "filename_selection  = " << filename_selection  << endline_flush;
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  for (int i = 0; i < 3; i++){
    if (i == 0){outfile_selection << left << setw(15) << "#";}
    else if (i == 1){outfile_selection << left << setw(15) << "0";}
    else if (i == 2){outfile_selection << noshowpoint << setw(15) << osi->value_qTcut[osi->n_qTcut - 1];}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	if (i == 0){
	  stringstream temp_ss;
	  temp_ss << "mu_R = " << left << setprecision(2) << setw(4) << showpoint << osi->relative_scale_ren_TSV[i_s][i_r] << " -- ";
	  temp_ss << "mu_F = " << left << setprecision(2) << setw(4) << showpoint << osi->relative_scale_fact_TSV[i_s][i_f] << "    ";
	  outfile_selection << setw(30) << temp_ss.str();
	}
      	else if (i == 1){outfile_selection << showpoint << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f] << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f];}
	else if (i == 2){outfile_selection << showpoint << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f] << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f];}
      }
    }
    outfile_selection << endline;
  }
  outfile_selection.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_band_TSV(string selection, int i_m, int i_s){
  Logger logger("summary_order::output_result_plot_band_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename_band;
  ofstream outfile_band;
  filename_band = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/band" + ygeneric->infix_name_moment[i_m] + "." + resultdirectory + ".dat";
  logger << LOG_DEBUG_VERBOSE << "filename_band = " << filename_band << endline_flush;
  outfile_band.open(filename_band.c_str(), ofstream::out | ofstream::trunc);
  double result_min_band = +numeric_limits<double>::infinity();
  double result_max_band = -numeric_limits<double>::infinity();
  double x_r_min_band = 0;
  double x_r_max_band = 0;
  double x_f_min_band = 0;
  double x_f_max_band = 0;
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      if (result_TSV[i_m][0][i_s][i_r][i_f] < result_min_band){
	result_min_band = result_TSV[i_m][0][i_s][i_r][i_f];
	x_r_min_band = i_r;
	x_f_min_band = i_f;
      }
      if (result_TSV[i_m][0][i_s][i_r][i_f] > result_max_band){
	result_max_band = result_TSV[i_m][0][i_s][i_r][i_f];
	x_r_max_band = i_r;
	x_f_max_band = i_f;
      }
    }
  }
  string temp_s_min = "minimum (" + selection + ")";
  string temp_s_max = "maximum (" + selection + ")";
  outfile_band << left << setw(15) << "#" << noshowpoint << setw(30) << "central scale" << setw(30) << temp_s_min << setw(30) << temp_s_max << endline;
  outfile_band << left << setw(15) << "#" << noshowpoint;
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_ren_TSV[i_s][osi->no_central_scale_ren_TSV[i_s]] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_fact_TSV[i_s][osi->no_central_scale_fact_TSV[i_s]] << "    ";
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_ren_TSV[i_s][x_r_min_band] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_fact_TSV[i_s][x_f_min_band] << "    ";
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_ren_TSV[i_s][x_r_max_band] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_fact_TSV[i_s][x_f_max_band] << "    ";
  outfile_band << endline;

  for (int i = 0; i < 2; i++){
    if (i == 0){outfile_band << left << setw(15) << "0";}
    else {outfile_band << left << noshowpoint << setw(15) << osi->value_qTcut[osi->n_qTcut - 1];}
    outfile_band << showpoint << left;
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]];
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]];
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][x_r_min_band][x_f_min_band];
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][x_r_min_band][x_f_min_band];
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][x_r_max_band][x_f_max_band];
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][x_r_max_band][x_f_max_band];
    outfile_band << endline;
  }
  outfile_band.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_extrapolated_TSV(){
  Logger logger("summary_order::output_result_plot_extrapolated_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  //  write out only the lowest qTcut value for qTcut-independent and qTcut-dependent results:

  int x_q = 0;
  stringstream minrcut;
  minrcut << "rcut" << osi->value_qTcut[x_q];

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < 1; i_m++){
    //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      system_execute(logger, "mkdir " + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s]);

      if (ygeneric->switch_output_complete){output_result_plot_extrapolated_selection_TSV("complete", i_m, i_s);}
      if (ygeneric->switch_output_ren){output_result_plot_extrapolated_selection_TSV("ren", i_m, i_s);}
      if (ygeneric->switch_output_fact){output_result_plot_extrapolated_selection_TSV("fact", i_m, i_s);}
      if (ygeneric->switch_output_equal){output_result_plot_extrapolated_selection_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_antipodal){output_result_plot_extrapolated_selection_TSV("antipodal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_result_plot_extrapolated_selection_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_result_plot_extrapolated_selection_TSV("9-point", i_m, i_s);}

      if (ygeneric->switch_output_equal){output_result_plot_extrapolated_band_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_result_plot_extrapolated_band_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_result_plot_extrapolated_band_TSV("9-point", i_m, i_s);}
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_extrapolated_selection_TSV(string selection, int i_m, int i_s){
  Logger logger("summary_order::output_result_plot_extrapolated_selection_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/plot" + ygeneric->infix_name_moment[i_m] + ".extrapolated." + resultdirectory + ".dat";
  logger << LOG_DEBUG_VERBOSE << "filename_selection  = " << filename_selection  << endline_flush;
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  for (int i = 0; i < 2; i++){
    if (i == 0){outfile_selection << left << setw(15) << "#";}
    else if (i == 1){outfile_selection << left << setw(15) << "0";}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	if (i == 0){
	  stringstream temp_ss;
	  temp_ss << "mu_R = " << left << setprecision(2) << setw(4) << showpoint << osi->relative_scale_ren_TSV[i_s][i_r] << " -- ";
	  temp_ss << "mu_F = " << left << setprecision(2) << setw(4) << showpoint << osi->relative_scale_fact_TSV[i_s][i_f] << "    ";
	  outfile_selection << setw(30) << temp_ss.str();
	}
	else if (i == 1){outfile_selection << left << showpoint << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][i_r][i_f] << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][i_r][i_f];}
      }
    }
    outfile_selection << endline;
  }
  outfile_selection.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_extrapolated_band_TSV(string selection, int i_m, int i_s){
  Logger logger("summary_order::output_result_plot_extrapolated_band_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename_band;
  ofstream outfile_band;
  filename_band = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/band" + ygeneric->infix_name_moment[i_m] + ".extrapolated." + resultdirectory + ".dat";
  logger << LOG_DEBUG_VERBOSE << "filename_band = " << filename_band << endline_flush;
  outfile_band.open(filename_band.c_str(), ofstream::out | ofstream::trunc);
  double result_min_band = +numeric_limits<double>::infinity();
  double result_max_band = -numeric_limits<double>::infinity();
  double x_r_min_band = 0;
  double x_r_max_band = 0;
  double x_f_min_band = 0;
  double x_f_max_band = 0;
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      if (result_TSV[i_m][0][i_s][i_r][i_f] < result_min_band){
	result_min_band = result_TSV[i_m][0][i_s][i_r][i_f];
	x_r_min_band = i_r;
	x_f_min_band = i_f;
      }
      if (result_TSV[i_m][0][i_s][i_r][i_f] > result_max_band){
	result_max_band = result_TSV[i_m][0][i_s][i_r][i_f];
	x_r_max_band = i_r;
	x_f_max_band = i_f;
      }
    }
  }

  string temp_s_min = "minimum (" + selection + ")";
  string temp_s_max = "maximum (" + selection + ")";
  outfile_band << left << setw(15) << "#" << noshowpoint << setw(30) << "central scale" << setw(30) << temp_s_min << setw(30) << temp_s_max << endline;
  outfile_band << left << setw(15) << "#" << noshowpoint;
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_ren_TSV[i_s][osi->no_central_scale_ren_TSV[i_s]] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_fact_TSV[i_s][osi->no_central_scale_fact_TSV[i_s]] << "    ";
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_ren_TSV[i_s][x_r_min_band] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_fact_TSV[i_s][x_f_min_band] << "    ";
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_ren_TSV[i_s][x_r_max_band] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << showpoint << osi->relative_scale_fact_TSV[i_s][x_f_max_band] << "    ";
  outfile_band << endline;

  outfile_band << noshowpoint << setw(15) << osi->value_qTcut[0];
  outfile_band << left << showpoint;
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]];
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]];
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][x_r_min_band][x_f_min_band];
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][x_r_min_band][x_f_min_band];
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][x_r_max_band][x_f_max_band];
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][x_r_max_band][x_f_max_band];
  outfile_band << endline;
  outfile_band.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_minqTcut_TSV(){
  Logger logger("summary_order::output_result_plot_minqTcut_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  //  write out only the lowest qTcut value for qTcut-independent and qTcut-dependent results:

  if (!active_qTcut){return;}
  int x_q = 0;
  for (int i_q = 0; i_q < osi->n_qTcut; i_q++){if (abs(ygeneric->max_min_value_extrapolation_range - osi->value_qTcut[i_q]) / (ygeneric->max_min_value_extrapolation_range + osi->value_qTcut[i_q]) < 1.e-12){x_q = i_q; break;}}
  logger << LOG_INFO << "ygeneric->max_min_value_extrapolation_range = " << ygeneric->max_min_value_extrapolation_range << endline_flush;
  logger << LOG_INFO << "x_q = " << x_q << endline_flush;
  
  stringstream minqTcut;
  minqTcut << "rcut" << ygeneric->max_min_value_extrapolation_range;
  //  minqTcut << "rcut" << osi->value_qTcut[x_q];

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < 1; i_m++){
    //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      system_execute(logger, "mkdir " + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s]);

      if (ygeneric->switch_output_complete){output_result_plot_minqTcut_selection_TSV("complete", i_m, i_s, x_q, minqTcut);}
      if (ygeneric->switch_output_ren){output_result_plot_minqTcut_selection_TSV("ren", i_m, i_s, x_q, minqTcut);}
      if (ygeneric->switch_output_fact){output_result_plot_minqTcut_selection_TSV("fact", i_m, i_s, x_q, minqTcut);}
      if (ygeneric->switch_output_equal){output_result_plot_minqTcut_selection_TSV("equal", i_m, i_s, x_q, minqTcut);}
      if (ygeneric->switch_output_antipodal){output_result_plot_minqTcut_selection_TSV("antipodal", i_m, i_s, x_q, minqTcut);}
      if (ygeneric->switch_output_7point){output_result_plot_minqTcut_selection_TSV("7-point", i_m, i_s, x_q, minqTcut);}
      if (ygeneric->switch_output_9point){output_result_plot_minqTcut_selection_TSV("9-point", i_m, i_s, x_q, minqTcut);}

      if (ygeneric->switch_output_equal){output_result_plot_minqTcut_band_TSV("equal", i_m, i_s, x_q, minqTcut);}
      if (ygeneric->switch_output_7point){output_result_plot_minqTcut_band_TSV("7-point", i_m, i_s, x_q, minqTcut);}
      if (ygeneric->switch_output_9point){output_result_plot_minqTcut_band_TSV("9-point", i_m, i_s, x_q, minqTcut);}
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_minqTcut_selection_TSV(string selection, int i_m, int i_s, int x_q, stringstream & minqTcut){
  Logger logger("summary_order::output_result_plot_minqTcut_selection_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/plot" + ygeneric->infix_name_moment[i_m] + "." + minqTcut.str() + "." + resultdirectory + ".dat";
  logger << LOG_DEBUG_VERBOSE << "filename_selection  = " << filename_selection  << endline_flush;
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  for (int i = 0; i < 2; i++){
    if (i == 0){outfile_selection << left << setw(15) << "#";}
    else if (i == 1){outfile_selection << left << setw(15) <<osi->value_qTcut[x_q];}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      	if (i == 0){
	  stringstream temp_ss;
	  temp_ss << "mu_R = " << left << setprecision(2) << setw(4) << showpoint << osi->relative_scale_ren_TSV[i_s][i_r] << " -- ";
	  temp_ss << "mu_F = " << left << setprecision(2) << setw(4) << showpoint << osi->relative_scale_fact_TSV[i_s][i_f] << "    ";
	  outfile_selection << setw(30) << temp_ss.str();
	}
	else if (i == 1){outfile_selection << left << showpoint << setprecision(8) << setw(15) << osi->unit_factor_result * result_qTcut_TSV[i_m][0][x_q][i_s][i_r][i_f] << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_qTcut_TSV[i_m][0][x_q][i_s][i_r][i_f];}
      }
    }
    outfile_selection << endline;
  }
  outfile_selection.close();
 
  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_minqTcut_band_TSV(string selection, int i_m, int i_s, int x_q, stringstream & minqTcut){
  Logger logger("summary_order::output_result_plot_minqTcut_band_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename_band;
  ofstream outfile_band;
  filename_band = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/band" + ygeneric->infix_name_moment[i_m] + "." + minqTcut.str() + "." + resultdirectory + ".dat";
  logger << LOG_DEBUG_VERBOSE << "filename_band = " << filename_band << endline_flush;
  outfile_band.open(filename_band.c_str(), ofstream::out | ofstream::trunc);
  double result_min_band = +numeric_limits<double>::infinity();
  double result_max_band = -numeric_limits<double>::infinity();
  double x_r_min_band = 0;
  double x_r_max_band = 0;
  double x_f_min_band = 0;
  double x_f_max_band = 0;
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      if (result_TSV[i_m][0][i_s][i_r][i_f] < result_min_band){
	result_min_band = result_qTcut_TSV[i_m][0][x_q][i_s][i_r][i_f];
	x_r_min_band = i_r;
	x_f_min_band = i_f;
      }
      if (result_TSV[i_m][0][i_s][i_r][i_f] > result_max_band){
	result_max_band = result_qTcut_TSV[i_m][0][x_q][i_s][i_r][i_f];
	x_r_max_band = i_r;
	x_f_max_band = i_f;
      }
    }
  }

  string temp_s_min = "minimum (" + selection + ")";
  string temp_s_max = "maximum (" + selection + ")";
  outfile_band << left << setw(15) << "#" << noshowpoint << setw(30) << "central scale" << setw(30) << temp_s_min << setw(30) << temp_s_max << endline;
  outfile_band << left << setw(15) << "#" << showpoint;
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << osi->relative_scale_ren_TSV[i_s][osi->no_central_scale_ren_TSV[i_s]] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << osi->relative_scale_fact_TSV[i_s][osi->no_central_scale_fact_TSV[i_s]] << "    ";
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << osi->relative_scale_ren_TSV[i_s][x_r_min_band] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << osi->relative_scale_fact_TSV[i_s][x_f_min_band] << "    ";
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << osi->relative_scale_ren_TSV[i_s][x_r_max_band] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << osi->relative_scale_fact_TSV[i_s][x_f_max_band] << "    ";
  outfile_band << endline;

  outfile_band << noshowpoint << setw(15) << osi->value_qTcut[0];
  outfile_band << left << showpoint;
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_qTcut_TSV[i_m][0][x_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]];
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_qTcut_TSV[i_m][0][x_q][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]];
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_qTcut_TSV[i_m][0][x_q][i_s][x_r_min_band][x_f_min_band];
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_qTcut_TSV[i_m][0][x_q][i_s][x_r_min_band][x_f_min_band];
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_qTcut_TSV[i_m][0][x_q][i_s][x_r_max_band][x_f_max_band];
  outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_qTcut_TSV[i_m][0][x_q][i_s][x_r_max_band][x_f_max_band];
  outfile_band << endline;
  outfile_band.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_qTcut_TSV(){
  Logger logger("summary_order::output_result_plot_qTcut_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < 1; i_m++){
    //  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    for (int i_s = 0; i_s < osi->n_extended_set_TSV; i_s++){
      if (!ygeneric->switch_output_scaleset[i_s]){continue;}
      system_execute(logger, "mkdir " + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s]);

      if (ygeneric->switch_output_complete){output_result_plot_qTcut_selection_TSV("complete", i_m, i_s);}
      if (ygeneric->switch_output_ren){output_result_plot_qTcut_selection_TSV("ren", i_m, i_s);}
      if (ygeneric->switch_output_fact){output_result_plot_qTcut_selection_TSV("fact", i_m, i_s);}
      if (ygeneric->switch_output_equal){output_result_plot_qTcut_selection_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_antipodal){output_result_plot_qTcut_selection_TSV("antipodal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_result_plot_qTcut_selection_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_result_plot_qTcut_selection_TSV("9-point", i_m, i_s);}

      if (ygeneric->switch_output_equal){output_result_plot_qTcut_band_TSV("equal", i_m, i_s);}
      if (ygeneric->switch_output_7point){output_result_plot_qTcut_band_TSV("7-point", i_m, i_s);}
      if (ygeneric->switch_output_9point){output_result_plot_qTcut_band_TSV("9-point", i_m, i_s);}
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_qTcut_selection_TSV(string selection, int i_m, int i_s){
  Logger logger("summary_order::output_result_plot_qTcut_selection_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename_selection;
  ofstream outfile_selection;
  filename_selection = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/plot.qTcut" + ygeneric->infix_name_moment[i_m] + "." + resultdirectory + ".dat";
  logger << LOG_DEBUG_VERBOSE << "filename_selection  = " << filename_selection  << endline_flush;
  outfile_selection.open(filename_selection.c_str(), ofstream::out | ofstream::trunc);
  outfile_selection << left << setw(15) << "#";
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      outfile_selection << "mu_R = " << left << setprecision(2) << setw(4) << showpoint << osi->relative_scale_ren_TSV[i_s][i_r] << " -- ";
      outfile_selection	<< "mu_F = " << left << setprecision(2) << setw(4) << showpoint << osi->relative_scale_fact_TSV[i_s][i_f] << "    ";
    }
  }
  outfile_selection << endline;
  for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
    outfile_selection << left << noshowpoint << setw(15) << osi->value_qTcut[i_q];
    int x_q = 0;
    if (active_qTcut){x_q = i_q;}
    for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
      for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
	if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
	outfile_selection << left << showpoint << setprecision(8) << setw(15) << osi->unit_factor_result * result_qTcut_TSV[i_m][0][x_q][i_s][i_r][i_f];
	outfile_selection << left << showpoint << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_qTcut_TSV[i_m][0][x_q][i_s][i_r][i_f];
      }
    }
    outfile_selection << endline;
  }
  outfile_selection.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_qTcut_band_TSV(string selection, int i_m, int i_s){
  Logger logger("summary_order::output_result_plot_qTcut_band_TSV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename_band;
  ofstream outfile_band;
  filename_band = "" + ygeneric->final_resultdirectory + "/" + osi->name_extended_set_TSV[i_s] + "/" + selection + "/band.qTcut" + ygeneric->infix_name_moment[i_m] + "." + resultdirectory + ".dat";
  logger << LOG_DEBUG_VERBOSE << "filename_band = " << filename_band << endline_flush;
  outfile_band.open(filename_band.c_str(), ofstream::out | ofstream::trunc);
  double result_min_band = +numeric_limits<double>::infinity();
  double result_max_band = -numeric_limits<double>::infinity();
  double x_r_min_band = 0;
  double x_r_max_band = 0;
  double x_f_min_band = 0;
  double x_f_max_band = 0;
  for (int i_r = 0; i_r < osi->n_scale_ren_TSV[i_s]; i_r++){
    for (int i_f = 0; i_f < osi->n_scale_fact_TSV[i_s]; i_f++){
      if (!ygeneric->output_selection_scale_check_TSV(selection, i_s, i_r, i_f)){continue;}
      if (result_TSV[i_m][0][i_s][i_r][i_f] < result_min_band){
	result_min_band = result_TSV[i_m][0][i_s][i_r][i_f];
	x_r_min_band = i_r;
	x_f_min_band = i_f;
      }
      if (result_TSV[i_m][0][i_s][i_r][i_f] > result_max_band){
	result_max_band = result_TSV[i_m][0][i_s][i_r][i_f];
	x_r_max_band = i_r;
	x_f_max_band = i_f;
      }
    }
  }

  string temp_s_min = "minimum (" + selection + ")";
  string temp_s_max = "maximum (" + selection + ")";
  outfile_band << left << setw(15) << "#" << noshowpoint << setw(30) << "central scale" << setw(30) << temp_s_min << setw(30) << temp_s_max << endline;
  outfile_band << left << setw(15) << "#" << showpoint;
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << osi->relative_scale_ren_TSV[i_s][osi->no_central_scale_ren_TSV[i_s]] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << osi->relative_scale_fact_TSV[i_s][osi->no_central_scale_fact_TSV[i_s]] << "    ";
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << osi->relative_scale_ren_TSV[i_s][x_r_min_band] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << osi->relative_scale_fact_TSV[i_s][x_f_min_band] << "    ";
  outfile_band << "mu_R = " << setprecision(2) << setw(4) << osi->relative_scale_ren_TSV[i_s][x_r_max_band] << " -- ";
  outfile_band << "mu_F = " << setprecision(2) << setw(4) << osi->relative_scale_fact_TSV[i_s][x_f_max_band] << "    ";
  outfile_band << endline;

  for (int i = 0; i < 2; i++){
    if (i == 0){outfile_band << left << setw(15) << "0";}
    else {outfile_band << left << noshowpoint << setw(15) << osi->value_qTcut[osi->n_qTcut - 1];}
    outfile_band << left << showpoint;
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]];
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][osi->no_central_scale_ren_TSV[i_s]][osi->no_central_scale_fact_TSV[i_s]];
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][x_r_min_band][x_f_min_band];
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][x_r_min_band][x_f_min_band];
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * result_TSV[i_m][0][i_s][x_r_max_band][x_f_max_band];
    outfile_band << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_TSV[i_m][0][i_s][x_r_max_band][x_f_max_band];
    outfile_band << endline;
  }
  outfile_band.close();

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}





void summary_order::output_result_overview_CV(){
  Logger logger("summary_order::output_result_overview_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename;
  ofstream outfile;
  stringstream temp_ss_separation_one;
  stringstream temp_ss_separation_two;
  int counter_separation = 0 + 15 + 15 + 15 + 25 + 15 + 4 + 15;
  for (int i_x = 0; i_x < counter_separation; i_x++){
    temp_ss_separation_one << "-";
    temp_ss_separation_two << "=";
  }

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    system_execute(logger, "mkdir " + ygeneric->final_resultdirectory + "/CV");

    filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/overview" + ygeneric->infix_name_moment[i_m] + "." + resultdirectory + ".dat";
    outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

    stringstream name_ss;
    name_ss << "dXS +- err (list)";

    stringstream header_ss;
    header_ss << left
	      << setw(15) << "qTcut"
	      << setw(5) << "mu_R/" << setw(10) << "CV"
	      << setw(5) << "mu_F/" << setw(10) << "CV"
	      << setw(25) << "list"
	      << right
	      << setw(34) << name_ss.str();
    outfile << header_ss.str() << endline;
    outfile << endline;

    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      int temp_size_result_0 = int(log10(abs(osi->unit_factor_result * result_CV[i_m][0][i_s])));
      int temp_size_result = int(log10(abs(osi->unit_factor_result * result_CV[i_m][0][i_s])));
      for (int i_l = 0; i_l < xlist.size(); i_l++){
	int temp_size_result_l = int(log10(abs(osi->unit_factor_result * xlist[i_l]->result_CV[i_m][0][i_s])));
	if (temp_size_result_l > temp_size_result){temp_size_result = temp_size_result_l;}
      }
      int temp_size_deviation = int(log10(abs(osi->unit_factor_result * deviation_CV[i_m][0][i_s])));
      if (osi->unit_factor_result * deviation_CV[i_m][0][i_s] >= 1.){temp_size_deviation++;}
      int setw_result = 9 + temp_size_result_0 - temp_size_result;
      int setw_deviation = 9 + temp_size_deviation - temp_size_result - 1;
      if (result_CV[i_m][0][i_s] == 0.){setw_result = 1; setw_deviation = 1;}
      else if (abs(osi->unit_factor_result * result_CV[i_m][0][i_s]) < 1.){setw_result--;}

      stringstream temp_ss;
      temp_ss << left << noshowpoint;
      if (active_qTcut){temp_ss << setw(15) << "extrapolation";}
      else {temp_ss << setw(15) << "independent";}
      temp_ss << setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
	      << setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s]
 	      << setw(25) << resultdirectory
	      << showpoint
	      << right << setw(15) << setprecision(setw_result) << showpoint
	      << osi->unit_factor_result * result_CV[i_m][0][i_s]
	      << " +- "
	      << right << setw(15) << setprecision(setw_deviation)
	      << osi->unit_factor_result * deviation_CV[i_m][0][i_s];
      outfile << temp_ss.str() << endline;

      outfile << temp_ss_separation_one.str() << endline;

      for (int i_l = 0; i_l < xlist.size(); i_l++){
	int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_result * xlist[i_l]->result_CV[i_m][0][i_s])));
	int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_result * xlist[i_l]->deviation_CV[i_m][0][i_s])));
	if (osi->unit_factor_result * xlist[i_l]->deviation_CV[i_m][0][i_s] >= 1.){temp_size_deviation_subprocess++;}
	if (xlist[i_l]->result_CV[i_m][0][i_s] == 0){temp_size_result_subprocess = 0;}
	if (xlist[i_l]->deviation_CV[i_m][0][i_s] == 0){temp_size_deviation_subprocess = 0;}
	int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
	int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);
	if (xlist[i_l]->result_CV[i_m][0][i_s] == 0.){setw_result = 1; setw_deviation = 1;}
	else if (abs(osi->unit_factor_result * xlist[i_l]->result_CV[i_m][0][i_s]) < 1.){setw_result--;}

	stringstream temp_ss;
	temp_ss << left;
	if (xlist[i_l]->active_qTcut){temp_ss << setw(15) << "extrapolation";}
	else {temp_ss << setw(15) << "independent";}
	temp_ss << noshowpoint
		<< setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
		<< setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s]
		<< setw(25) << xlist[i_l]->xcontribution[0]->infix_order_contribution
		<< showpoint
		<< right << setw(15) << setprecision(setw_result)
		<< osi->unit_factor_result * xlist[i_l]->result_CV[i_m][0][i_s]
		<< " +- "
		<< right << setw(15) << setprecision(setw_deviation)
		<< osi->unit_factor_result * xlist[i_l]->deviation_CV[i_m][0][i_s];
	outfile << temp_ss.str() << endline;
      }
      outfile << endline;
    }

    outfile << temp_ss_separation_two.str() << endl << endline;

    if (active_qTcut){
      for (int i_q = 0; i_q < output_n_qTcut; i_q++){
	outfile << header_ss.str() << endline;
	outfile << endline;

	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  int temp_size_result_0 = int(log10(abs(osi->unit_factor_result * result_qTcut_CV[i_m][0][i_q][i_s])));
	  int temp_size_result = int(log10(abs(osi->unit_factor_result * result_qTcut_CV[i_m][0][i_q][i_s])));
	  for (int i_l = 0; i_l < xlist.size(); i_l++){
	    int temp_size_result_l = int(log10(abs(osi->unit_factor_result * xlist[i_l]->xcontribution[0]->result_CV[i_m][0][i_q][i_s])));
	    if (temp_size_result_l > temp_size_result){temp_size_result = temp_size_result_l;}
	  }
	  int temp_size_deviation = int(log10(abs(osi->unit_factor_result * deviation_qTcut_CV[i_m][0][i_q][i_s])));
	  if (osi->unit_factor_result * deviation_qTcut_CV[i_m][0][i_q][i_s] >= 1.){temp_size_deviation++;}


	  stringstream temp_ss;
	  temp_ss << left
		  << noshowpoint
		  << setw(15) << osi->value_qTcut[i_q]
		  << setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
		  << setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s]
 		  << setw(25) << resultdirectory
		  << showpoint
		  << right << setw(15) << setprecision(10 + temp_size_result_0 - temp_size_result) << showpoint
   		  << osi->unit_factor_result * result_qTcut_CV[i_m][0][i_q][i_s]
		  << " +- "
		  << right << setw(15) << setprecision(10 + temp_size_deviation - temp_size_deviation - (temp_size_result - temp_size_deviation + 1))
		  << osi->unit_factor_result * deviation_qTcut_CV[i_m][0][i_q][i_s];

	  outfile << temp_ss.str() << endline;

	  outfile << temp_ss_separation_one.str() << endline;

	  for (int i_l = 0; i_l < xlist.size(); i_l++){
	    int temp_size_result_subprocess = int(log10(abs(osi->unit_factor_result * xlist[i_l]->xcontribution[0]->result_CV[i_m][0][i_q][i_s])));
	    //	    if (temp_size_result_subprocess < -3){temp_size_result_subprocess -= 5;}
	    int temp_size_deviation_subprocess = int(log10(abs(osi->unit_factor_result * xlist[i_l]->xcontribution[0]->deviation_CV[i_m][0][i_q][i_s])));
	    if (osi->unit_factor_result * xlist[i_l]->xcontribution[0]->deviation_CV[i_m][0][i_q][i_s] >= 1.){temp_size_deviation_subprocess++;}
	    //	    if (temp_size_deviation_subprocess < -3){temp_size_deviation_subprocess -= 5;}
	    if (xlist[i_l]->xcontribution[0]->result_CV[i_m][0][i_q][i_s] == 0){temp_size_result_subprocess = 0;}
	    if (xlist[i_l]->xcontribution[0]->deviation_CV[i_m][0][i_q][i_s] == 0){temp_size_deviation_subprocess = 0;}

	    int setw_result = 9 + temp_size_result_subprocess - temp_size_result;
	    int setw_deviation = 9 + temp_size_deviation_subprocess - temp_size_deviation - (temp_size_result - temp_size_deviation + 1);

	    stringstream temp_l_ss;
	    temp_l_ss << left
		      << noshowpoint
		      << setw(15) << osi->value_qTcut[i_q]
		      << setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
		      << setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s]
		      << setw(25) << xlist[i_l]->xcontribution[0]->infix_order_contribution
		      << showpoint
		      << right << setw(15) << setprecision(setw_result) << showpoint
		      << osi->unit_factor_result * xlist[i_l]->xcontribution[0]->result_CV[i_m][0][i_q][i_s]
		      << " +- "
		      << right << setw(15) << setprecision(setw_deviation)
		      << osi->unit_factor_result * xlist[i_l]->xcontribution[0]->deviation_CV[i_m][0][i_q][i_s];

	    outfile << temp_l_ss.str() << endline;
	  }
	  outfile << endline;
	}
    	outfile << temp_ss_separation_two.str() << endl << endline;
      }
    }
    outfile.close();
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_CV(){
  Logger logger("summary_order::output_result_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename;
  ofstream outfile;

  int start_i_m = 0; // temporary !!!
  for (int i_m = start_i_m; i_m < osi->n_moments; i_m++){
    system_execute(logger, "mkdir " + ygeneric->final_resultdirectory + "/CV");

    filename = "" + ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/result" + ygeneric->infix_name_moment[i_m] + "." + resultdirectory + ".dat";
    outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

    stringstream header_ss;
    header_ss << noshowpoint << left
	      << setw(15) << "qTcut"
	      << setw(5) << "mu_R/" << setw(10) << "CV"
	      << setw(5) << "mu_F/" << setw(10) << "CV"
	      << "XS +- err (" << resultdirectory << ")";

    outfile << header_ss.str() << endl << endline;

    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      stringstream temp_ss;
      temp_ss << left;
      if (active_qTcut){temp_ss << setw(15) << "extrapolation";}
      else {temp_ss << setw(15) << "independent";}
      //	      << setw(15) << "0"
      temp_ss << setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
	      << setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s]
	      << showpoint
	      << setprecision(8) << setw(15) << osi->unit_factor_result * result_CV[i_m][0][i_s]
	      << " +- "
	      << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_CV[i_m][0][i_s];

      outfile << temp_ss.str() << endline;
    }

    if (active_qTcut){
      for (int i_q = 0; i_q < output_n_qTcut; i_q++){
	outfile << endline;
	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  stringstream temp_ss;
	  temp_ss << noshowpoint
		  << left
		  << setw(15) << osi->value_qTcut[i_q]
		  << setw(15) << setprecision(8) << osi->rel_scale_factor_ren_CV[i_s]
		  << setw(15) << setprecision(8) << osi->rel_scale_factor_fact_CV[i_s]
		  << showpoint
		  << setprecision(8) << setw(15) << osi->unit_factor_result * result_qTcut_CV[i_m][0][i_q][i_s]
		  << " +- "
		  << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_qTcut_CV[i_m][0][i_q][i_s];

	  outfile << temp_ss.str() << endline;
	}
      }
      outfile.close();
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_CV(){
  Logger logger("summary_order::output_result_plot_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  string filename;

  vector<double> rel_scale_CV(osi->n_scales_CV);
  vector<double> scale_CV(osi->n_scales_CV);
  if (osi->n_scales_CV != 0 && osi->n_qTcut != 0){
    for (int s = 0; s < osi->n_scales_CV; s++){
      if (osi->n_scales_CV > 1){rel_scale_CV[s] = pow(10., log10(double(osi->variation_factor_CV)) * double(2. * s / (osi->n_scales_CV - 1) - 1));}
      else {rel_scale_CV[s] = 1;}
      scale_CV[s] = rel_scale_CV[s] * osi->scale_ren;
    }
  }

  for (int i_m = 0; i_m < osi->n_moments; i_m++){
    ////////////////////////////////////
    //  output of usual CV variation  //
    ////////////////////////////////////
    ofstream outfile;
    filename = ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/plot" + ygeneric->infix_name_moment[i_m] + ".CV." + resultdirectory + ".dat";
    logger << LOG_DEBUG_VERBOSE << "FILENAME:   " << filename << endline_flush;
    outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);
    int i_q = 0;
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      // rel_scale_CV does not containt reasonable scale information !!!
      outfile << setw(15) << setprecision(8) << rel_scale_CV[i_s]
	      << setprecision(8) << setw(15) << osi->unit_factor_result * result_qTcut_CV[i_m][0][i_q][i_s]
	      << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_qTcut_CV[i_m][0][i_q][i_s] << endline;
    }
    outfile.close();

    //////////////////////////////////////////////////////////////////
    //  output of extrapolated (or qTcut-independent) CV variation  //
    //////////////////////////////////////////////////////////////////
    filename = ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/plot" + ygeneric->infix_name_moment[i_m] + ".CV.extrapolated." + resultdirectory + ".dat";
    logger << LOG_DEBUG_VERBOSE << "FILENAME:   " << filename << endline_flush;
    outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      // rel_scale_CV does not containt reasonable scale information !!!
      outfile << setw(15) << setprecision(8) << rel_scale_CV[i_s]
	      << setprecision(8) << setw(15) << osi->unit_factor_result * result_CV[i_m][0][i_s]
	      << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_CV[i_m][0][i_s]
	      << endline;
      if (i_m == osi->n_moments){
	logger << LOG_DEBUG_VERBOSE << setw(15) << setprecision(8) << rel_scale_CV[i_s] << setprecision(8) << setw(15) << "result_CV[" << i_m << "][0][" << i_s << "] = " << result_CV[i_m][0][i_s] << setprecision(8) << setw(15) << deviation_CV[i_m][0][i_s] << endline_flush;
      }
    }
    outfile.close();

    ///////////////////////////////////////////////////////////////////////////
    //  output of extrapolated (or qTcut-independent) result in plot format  //
    ///////////////////////////////////////////////////////////////////////////
    filename = ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/plot" + ygeneric->infix_name_moment[i_m] + "." + resultdirectory + ".dat";
    logger << LOG_DEBUG_VERBOSE << "xfilename i_m = " << i_m << "   " << filename << endline_flush;
    outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);
    outfile << showpoint << left
	    << setw(15) << "# qTcut";
    for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
      stringstream temp_ss;
      temp_ss << "mu_R = " << left << setprecision(2) << setw(4) << showpoint << osi->rel_scale_factor_ren_CV[i_s] << " -- "
	      << "mu_F = " << left << setprecision(2) << setw(4) << showpoint << osi->rel_scale_factor_fact_CV[i_s] << "    ";
      outfile << setw(30) << temp_ss.str() << left;
    }
    outfile << endline;

    for (int i = 0; i < 2; i++){
      if (i == 0){
	outfile << setw(15) << "0";
      }
      else {
	outfile << noshowpoint << setw(15) << osi->value_qTcut[osi->n_qTcut - 1];
      }
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	outfile << left << showpoint
		<< setprecision(8) << setw(15) << osi->unit_factor_result * result_CV[i_m][0][i_s]
		<< setprecision(8) << setw(15) << osi->unit_factor_result * deviation_CV[i_m][0][i_s];
      }
      outfile << endline;
    }
    outfile.close();
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}


void summary_order::output_result_plot_qTcut_CV(){
  Logger logger("summary_order::output_result_plot_qTcut_CV");
  logger << LOG_DEBUG_VERBOSE << "called" << endline_flush;

  ofstream outfile;
  string filename;

  if (osi->n_qTcut > 1){
    for (int i_m = 0; i_m < osi->n_moments; i_m++){
      filename = ygeneric->final_resultdirectory + "/CV/" + ygeneric->name_variation_CV + "/plot" + ygeneric->infix_name_moment[i_m] + ".qTcut." + resultdirectory + ".dat";      outfile.open(filename.c_str(), ofstream::out | ofstream::trunc);

      outfile << left << showpoint << setw(15) << "# qTcut";
      for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	stringstream temp_ss;
	temp_ss << "mu_R = " << left << setprecision(2) << setw(4) << showpoint << osi->rel_scale_factor_ren_CV[i_s] << " -- "
		<< "mu_F = " << left << setprecision(2) << setw(4) << showpoint << osi->rel_scale_factor_fact_CV[i_s] << "    ";
	outfile << setw(30) << temp_ss.str() << left;
      }
      outfile << endline;

      if (result_qTcut_CV[i_m][0][0][0] == result_qTcut_CV[i_m][0][osi->n_qTcut - 1][0]){
	outfile << setw(15) << "0.";
	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  outfile << left << showpoint  
		  << setprecision(8) << setw(15) << osi->unit_factor_result * result_qTcut_CV[i_m][0][0][i_s]
		  << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_qTcut_CV[i_m][0][0][i_s];
	}
	outfile << endline;
      }

      for (int i_q = 0; i_q < osi->n_qTcut; i_q++){
	outfile << noshowpoint << setw(15) << osi->value_qTcut[i_q];
	for (int i_s = 0; i_s < osi->n_scales_CV; i_s++){
	  outfile << left << showpoint
		  << setprecision(8) << setw(15) << osi->unit_factor_result * result_qTcut_CV[i_m][0][i_q][i_s]
		  << setprecision(8) << setw(15) << osi->unit_factor_result * deviation_qTcut_CV[i_m][0][i_q][i_s];
	}
	outfile << endline;
      }
      outfile.close();
      logger << LOG_DEBUG_VERBOSE << filename << " closed." << endline_flush;
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endline_flush;
}
