#include "header.hpp"

#include "ppaa02.phasespace.set.hpp"

void ppaa02_phasespace_set::ax_psp_220_gg_aa(int x_a){
  static Logger logger("ppaa02_phasespace_set::ax_psp_220_gg_aa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(0);
  needed_v_smin[x_a].resize(0);

  v_smax[x_a].resize(0);
  needed_v_smax[x_a].resize(0);

  g_p[x_a].resize(0);
  needed_g_p[x_a].resize(0);

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(4);
  needed_g_t[x_a].resize(4);
  needed_g_t[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_8");
  needed_g_t[x_a][1] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__4_8");
  needed_g_t[x_a][2] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_4");
  needed_g_t[x_a][3] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__8_4");

  g_d[x_a].resize(1);
  needed_g_d[x_a].resize(1);
  needed_g_d[x_a][0] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");

  c_p[x_a].resize(6);
  c_f[x_a].resize(6);
  c_t[x_a].resize(6);
  c_d[x_a].resize(6);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  1}; //   1
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  2}; //   1
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  3}; //   1
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_020_gg_aa
//  channel    0: 11(1, 2, 4, 8;   0)
//  channel    1: 11(1, 2, 4, 8;  36)
//  channel    2: 11(1, 2, 8, 4;   0)
//  channel    3: 11(1, 2, 8, 4;  36)
//  channel    4: 2v(1, 2, 4, 8;   0)
//  channel    5: 2v(1, 2, 4, 8;  36)
