#include "header.hpp"

#include "ppaa02.phasespace.set.hpp"

void ppaa02_phasespace_set::ax_psp_320_gg_aag(int x_a){
  static Logger logger("ppaa02_phasespace_set::ax_psp_320_gg_aag");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  int needed_v_smin_0[] = {  20,   21,   22,   23,   32,   33,   34,   35,   42,   43,   44,   45,    6,    7,    8,    9,   16,   17,   18,   19}; //  20
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 20);
  int needed_v_smin_1[] = {  24,   25,   36,   37,   38,   39,   46,   47,   10,   11,   12,   13,   14,   15}; //  14
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 14);
  int needed_v_smin_2[] = {  26,   27,   28,   29,   30,   31,   40,   41,    0,    1,    2,    3,    4,    5}; //  14
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 14);

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  int needed_v_smax_0[] = {  20,   21,   22,   23,   32,   33,   34,   35,   42,   43,   44,   45,    6,    7,    8,    9,   16,   17,   18,   19}; //  20
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 20);
  int needed_v_smax_1[] = {  24,   25,   36,   37,   38,   39,   46,   47,   10,   11,   12,   13,   14,   15}; //  14
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 14);
  int needed_v_smax_2[] = {  26,   27,   28,   29,   30,   31,   40,   41,    0,    1,    2,    3,    4,    5}; //  14
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 14);

  g_p[x_a].resize(6);
  needed_g_p[x_a].resize(6);
  needed_g_p[x_a][0] = {  20,   21,   32,   33,   42,   43}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  22,   23,   34,   35,   44,   45}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin0_smax0");
  needed_g_p[x_a][2] = {  24,   36,   37,   46}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {  25,   38,   39,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin1_smax1");
  needed_g_p[x_a][4] = {  26,   28,   29,   40}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][5] = {  27,   30,   31,   41}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin2_smax2");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   6,    7,    8,    9,   16,   17,   18,   19}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][2] = {  10,   11,   12,   13,   14,   15}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(24);
  needed_g_t[x_a].resize(24);
  needed_g_t[x_a][0] = {   0,    1,    4,   40}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_24");
  needed_g_t[x_a][1] = {   0,    1,    2}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_8");
  needed_g_t[x_a][2] = {   2,    3,    5,   41}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__4_24");
  needed_g_t[x_a][3] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_5__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_5__16_8");
  needed_g_t[x_a][4] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_16");
  needed_g_t[x_a][5] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_5__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_5__8_16");
  needed_g_t[x_a][6] = {   6,    7,    8,   16,   17,   18,   42,   43,   44}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_12");
  needed_g_t[x_a][7] = {   6,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_4");
  needed_g_t[x_a][8] = {   7,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_17__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_17__8_4");
  needed_g_t[x_a][9] = {   9,   19,   45}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__16_12");
  needed_g_t[x_a][10] = {  10,   11,   14,   46}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_20");
  needed_g_t[x_a][11] = {  10,   11,   12}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_4");
  needed_g_t[x_a][12] = {  12,   13,   15,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__8_20");
  needed_g_t[x_a][13] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_9__16_4");
  needed_g_t[x_a][14] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_16");
  needed_g_t[x_a][15] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_9__4_16");
  needed_g_t[x_a][16] = {  16,   18}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_8");
  needed_g_t[x_a][17] = {  17,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_17__4_8");
  needed_g_t[x_a][18] = {  20,   21,   22}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_12");
  needed_g_t[x_a][19] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__16_12");
  needed_g_t[x_a][20] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_20");
  needed_g_t[x_a][21] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__8_20");
  needed_g_t[x_a][22] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_24");
  needed_g_t[x_a][23] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__4_24");

  g_d[x_a].resize(6);
  needed_g_d[x_a].resize(6);
  needed_g_d[x_a][0] = {  20,   21,   22,   23,   32,   33,   34,   35,   42,   43,   44,   45}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  24,   25,   36,   37,   38,   39,   46,   47}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][2] = {  26,   27,   28,   29,   30,   31,   40,   41}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  28,   29,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][4] = {  32,   33,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {  36,   37,   38,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");

  c_p[x_a].resize(48);
  c_f[x_a].resize(48);
  c_t[x_a].resize(48);
  c_d[x_a].resize(48);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  2,   1}; //   2
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   4}; //   2
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  2,   5}; //   2
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  1}; //   1
  c_t[x_a][6] = {  6,   7}; //   2
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  1}; //   1
  c_t[x_a][7] = {  6,   8}; //   2
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  1}; //   1
  c_t[x_a][8] = {  6,   7}; //   2
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  9,   8}; //   2
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = {  2}; //   1
  c_t[x_a][10] = { 10,  11}; //   2
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {  2}; //   1
  c_t[x_a][11] = { 10,  11}; //   2
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {}; //   0
  c_f[x_a][12] = {  2}; //   1
  c_t[x_a][12] = { 12,  11}; //   2
  c_d[x_a][12] = {}; //   0

  c_p[x_a][13] = {}; //   0
  c_f[x_a][13] = {  2}; //   1
  c_t[x_a][13] = { 12,  13}; //   2
  c_d[x_a][13] = {}; //   0

  c_p[x_a][14] = {}; //   0
  c_f[x_a][14] = {  2}; //   1
  c_t[x_a][14] = { 10,  14}; //   2
  c_d[x_a][14] = {}; //   0

  c_p[x_a][15] = {}; //   0
  c_f[x_a][15] = {  2}; //   1
  c_t[x_a][15] = { 12,  15}; //   2
  c_d[x_a][15] = {}; //   0

  c_p[x_a][16] = {}; //   0
  c_f[x_a][16] = {  1}; //   1
  c_t[x_a][16] = {  6,  16}; //   2
  c_d[x_a][16] = {}; //   0

  c_p[x_a][17] = {}; //   0
  c_f[x_a][17] = {  1}; //   1
  c_t[x_a][17] = {  6,  17}; //   2
  c_d[x_a][17] = {}; //   0

  c_p[x_a][18] = {}; //   0
  c_f[x_a][18] = {  1}; //   1
  c_t[x_a][18] = {  6,  16}; //   2
  c_d[x_a][18] = {}; //   0

  c_p[x_a][19] = {}; //   0
  c_f[x_a][19] = {  1}; //   1
  c_t[x_a][19] = {  9,  17}; //   2
  c_d[x_a][19] = {}; //   0

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = { 18}; //   1
  c_d[x_a][20] = {  0}; //   1

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = { 18}; //   1
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = {  1}; //   1
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = { 18}; //   1
  c_d[x_a][22] = {  0}; //   1

  c_p[x_a][23] = {  1}; //   1
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 19}; //   1
  c_d[x_a][23] = {  0}; //   1

  c_p[x_a][24] = {  2}; //   1
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = { 20}; //   1
  c_d[x_a][24] = {  1}; //   1

  c_p[x_a][25] = {  3}; //   1
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = { 21}; //   1
  c_d[x_a][25] = {  1}; //   1

  c_p[x_a][26] = {  4}; //   1
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = { 22}; //   1
  c_d[x_a][26] = {  2}; //   1

  c_p[x_a][27] = {  5}; //   1
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 23}; //   1
  c_d[x_a][27] = {  2}; //   1

  c_p[x_a][28] = {  4}; //   1
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = {  3,   2}; //   2

  c_p[x_a][29] = {  4}; //   1
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = {  3,   2}; //   2

  c_p[x_a][30] = {  5}; //   1
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = {  3,   2}; //   2

  c_p[x_a][31] = {  5}; //   1
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = {  3,   2}; //   2

  c_p[x_a][32] = {  0}; //   1
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = {  4,   0}; //   2

  c_p[x_a][33] = {  0}; //   1
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = {  4,   0}; //   2

  c_p[x_a][34] = {  1}; //   1
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = {  4,   0}; //   2

  c_p[x_a][35] = {  1}; //   1
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = {  4,   0}; //   2

  c_p[x_a][36] = {  2}; //   1
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = {  5,   1}; //   2

  c_p[x_a][37] = {  2}; //   1
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = {  5,   1}; //   2

  c_p[x_a][38] = {  3}; //   1
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = {  5,   1}; //   2

  c_p[x_a][39] = {  3}; //   1
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = {  5,   1}; //   2

  c_p[x_a][40] = {  4}; //   1
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  0}; //   1
  c_d[x_a][40] = {  2}; //   1

  c_p[x_a][41] = {  5}; //   1
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  2}; //   1
  c_d[x_a][41] = {  2}; //   1

  c_p[x_a][42] = {  0}; //   1
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  6}; //   1
  c_d[x_a][42] = {  0}; //   1

  c_p[x_a][43] = {  0}; //   1
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  6}; //   1
  c_d[x_a][43] = {  0}; //   1

  c_p[x_a][44] = {  1}; //   1
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  6}; //   1
  c_d[x_a][44] = {  0}; //   1

  c_p[x_a][45] = {  1}; //   1
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  9}; //   1
  c_d[x_a][45] = {  0}; //   1

  c_p[x_a][46] = {  2}; //   1
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 10}; //   1
  c_d[x_a][46] = {  1}; //   1

  c_p[x_a][47] = {  3}; //   1
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = { 12}; //   1
  c_d[x_a][47] = {  1}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_120_gg_aag
//  channel    0: 111(1, 2, 4, 8, 16;   0,   0)
//  channel    1: 111(1, 2, 4, 8, 16;   0,   0)
//  channel    2: 111(1, 2, 4, 8, 16;  36,   0)
//  channel    3: 111(1, 2, 4, 8, 16;  36,  36)
//  channel    4: 111(1, 2, 4, 16, 8;   0,   0)
//  channel    5: 111(1, 2, 4, 16, 8;  36,  36)
//  channel    6: 111(1, 2, 16, 4, 8;   0,   0)
//  channel    7: 111(1, 2, 16, 4, 8;   0,  36)
//  channel    8: 111(1, 2, 16, 4, 8;   0,   0)
//  channel    9: 111(1, 2, 16, 4, 8;  36,  36)
//  channel   10: 111(1, 2, 8, 4, 16;   0,   0)
//  channel   11: 111(1, 2, 8, 4, 16;   0,   0)
//  channel   12: 111(1, 2, 8, 4, 16;  36,   0)
//  channel   13: 111(1, 2, 8, 4, 16;  36,  36)
//  channel   14: 111(1, 2, 8, 16, 4;   0,   0)
//  channel   15: 111(1, 2, 8, 16, 4;  36,  36)
//  channel   16: 111(1, 2, 16, 8, 4;   0,   0)
//  channel   17: 111(1, 2, 16, 8, 4;   0,  36)
//  channel   18: 111(1, 2, 16, 8, 4;   0,   0)
//  channel   19: 111(1, 2, 16, 8, 4;  36,  36)
//  channel   20: 2v1(1, 2, 4, 8, 16;   0,   0)
//  channel   21: 2v1(1, 2, 4, 8, 16;   0,   0)
//  channel   22: 2v1(1, 2, 4, 8, 16;  36,   0)
//  channel   23: 2v1(1, 2, 4, 8, 16;  36,  36)
//  channel   24: 2v1(1, 2, 4, 16, 8;   0,   0)
//  channel   25: 2v1(1, 2, 4, 16, 8;  36,  36)
//  channel   26: 2v1(1, 2, 8, 16, 4;   0,   0)
//  channel   27: 2v1(1, 2, 8, 16, 4;  36,  36)
//  channel   28: 3yv(1, 2, 4, 8, 16;   0,   0)
//  channel   29: 3yv(1, 2, 4, 8, 16;   0,   0)
//  channel   30: 3yv(1, 2, 4, 8, 16;  36,   0)
//  channel   31: 3yv(1, 2, 4, 8, 16;  36,  36)
//  channel   32: 3yv(1, 2, 16, 4, 8;   0,   0)
//  channel   33: 3yv(1, 2, 16, 4, 8;   0,   0)
//  channel   34: 3yv(1, 2, 16, 4, 8;  36,   0)
//  channel   35: 3yv(1, 2, 16, 4, 8;  36,  36)
//  channel   36: 3yv(1, 2, 8, 4, 16;   0,   0)
//  channel   37: 3yv(1, 2, 8, 4, 16;   0,   0)
//  channel   38: 3yv(1, 2, 8, 4, 16;  36,   0)
//  channel   39: 3yv(1, 2, 8, 4, 16;  36,  36)
//  channel   40: 12v(1, 2, 4, 8, 16;   0,   0)
//  channel   41: 12v(1, 2, 4, 8, 16;  36,  36)
//  channel   42: 12v(1, 2, 16, 4, 8;   0,   0)
//  channel   43: 12v(1, 2, 16, 4, 8;   0,   0)
//  channel   44: 12v(1, 2, 16, 4, 8;  36,   0)
//  channel   45: 12v(1, 2, 16, 4, 8;  36,  36)
//  channel   46: 12v(1, 2, 8, 4, 16;   0,   0)
//  channel   47: 12v(1, 2, 8, 4, 16;  36,  36)
