#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

void ppaaa03_phasespace_set::ac_psp_130_gux_aaaux(int x_a, int channel){
  static Logger logger("ppaaa03_phasespace_set::ac_psp_130_gux_aaaux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][36];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_propagator(x_a,   0,  36, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  1] = smin_opt[x_a][48];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_propagator(x_a,   0,  48, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  2] = smin_opt[x_a][40];
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][  4], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][52]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][  5], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  6], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  8], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 8));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][  9] = smin_opt[x_a][12];
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_timelikeinvariant(x_a,  12, v_smin[x_a][  9], v_smax[x_a][  6], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  28, v_smin[x_a][ 10], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 1));
    }
    else if (c_f[x_a][channel][i_f] ==   2){
      v_smin[x_a][ 11] = smin_opt[x_a][20];
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_timelikeinvariant(x_a,  20, v_smin[x_a][ 11], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 2));
    }
    else if (c_f[x_a][channel][i_f] ==   3){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  28, v_smin[x_a][ 12], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 3));
    }
    else if (c_f[x_a][channel][i_f] ==   4){
      v_smin[x_a][ 13] = smin_opt[x_a][24];
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_timelikeinvariant(x_a,  24, v_smin[x_a][ 13], v_smax[x_a][  9], random_manager.get_random(x_a, 1, 4));
    }
    else if (c_f[x_a][channel][i_f] ==   5){
      v_smin[x_a][ 14] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][28]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  28, v_smin[x_a][ 14], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 5));
    }
    else if (c_f[x_a][channel][i_f] ==   6){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][  6], v_smax[x_a][  3], random_manager.get_random(x_a, 1, 6));
    }
    else if (c_f[x_a][channel][i_f] ==   7){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][52]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][  5], v_smax[x_a][  4], random_manager.get_random(x_a, 1, 7));
    }
    else if (c_f[x_a][channel][i_f] ==   8){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][  4], v_smax[x_a][  4], random_manager.get_random(x_a, 1, 8));
    }
    else if (c_f[x_a][channel][i_f] ==   9){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 1, 9));
    }
    else if (c_f[x_a][channel][i_f] ==  10){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][  8], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 10));
    }
    else if (c_f[x_a][channel][i_f] ==  11){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 11));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  32,  28, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,   0,  28,   2,  33,  16,  12, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel(x_a,   0,  12,  33,  18,   4,   8, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel_opt(x_a,   0,  28,   2,  33,   8,  20, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel(x_a,   0,  20,  33,  10,   4,  16, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel(x_a,   0,  20,  33,  10,  16,   4, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel(x_a,   0,  12,  33,  18,   8,   4, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
    else if (c_t[x_a][channel][i_t] ==   7){
      c_tchannel_opt(x_a,   0,  28,   2,  33,   4,  24, random_manager.get_random(x_a, 2, 7), random_manager.get_random(x_a, 3, 7));
    }
    else if (c_t[x_a][channel][i_t] ==   8){
      c_tchannel(x_a,   0,  24,  33,   6,   8,  16, random_manager.get_random(x_a, 2, 8), random_manager.get_random(x_a, 3, 8));
    }
    else if (c_t[x_a][channel][i_t] ==   9){
      c_tchannel(x_a,   0,  24,  33,   6,  16,   8, random_manager.get_random(x_a, 2, 9), random_manager.get_random(x_a, 3, 9));
    }
    else if (c_t[x_a][channel][i_t] ==  10){
      c_tchannel_opt(x_a,   0,  60,   2,   1,  16,  44, random_manager.get_random(x_a, 2, 10), random_manager.get_random(x_a, 3, 10));
    }
    else if (c_t[x_a][channel][i_t] ==  11){
      c_tchannel_opt(x_a,   0,  44,   1,  18,  36,   8, random_manager.get_random(x_a, 2, 11), random_manager.get_random(x_a, 3, 11));
    }
    else if (c_t[x_a][channel][i_t] ==  12){
      c_tchannel_opt(x_a,   0,  60,   2,   1,   8,  52, random_manager.get_random(x_a, 2, 12), random_manager.get_random(x_a, 3, 12));
    }
    else if (c_t[x_a][channel][i_t] ==  13){
      c_tchannel_opt(x_a,   0,  52,   1,  10,  36,  16, random_manager.get_random(x_a, 2, 13), random_manager.get_random(x_a, 3, 13));
    }
    else if (c_t[x_a][channel][i_t] ==  14){
      c_tchannel_opt(x_a,   0,  52,   1,  10,  48,   4, random_manager.get_random(x_a, 2, 14), random_manager.get_random(x_a, 3, 14));
    }
    else if (c_t[x_a][channel][i_t] ==  15){
      c_tchannel_opt(x_a,   0,  44,   1,  18,  40,   4, random_manager.get_random(x_a, 2, 15), random_manager.get_random(x_a, 3, 15));
    }
    else if (c_t[x_a][channel][i_t] ==  16){
      c_tchannel_opt(x_a,   0,  60,   2,   1,   4,  56, random_manager.get_random(x_a, 2, 16), random_manager.get_random(x_a, 3, 16));
    }
    else if (c_t[x_a][channel][i_t] ==  17){
      c_tchannel_opt(x_a,   0,  56,   1,   6,  40,  16, random_manager.get_random(x_a, 2, 17), random_manager.get_random(x_a, 3, 17));
    }
    else if (c_t[x_a][channel][i_t] ==  18){
      c_tchannel_opt(x_a,   0,  56,   1,   6,  48,   8, random_manager.get_random(x_a, 2, 18), random_manager.get_random(x_a, 3, 18));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  36,   4,  32, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  48,  16,  32, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  40,   8,  32, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a,  44,   4,  40, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  52,   4,  48, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a,  52,  16,  36, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a,  44,   8,  36, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a,  56,   8,  48, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
    else if (c_d[x_a][channel][i_d] ==   8){
      c_decay(x_a,  56,  16,  40, random_manager.get_random(x_a, 4, 8), random_manager.get_random(x_a, 5, 8));
    }
    else if (c_d[x_a][channel][i_d] ==   9){
      c_decay(x_a,  60,   4,  56, random_manager.get_random(x_a, 4, 9), random_manager.get_random(x_a, 5, 9));
    }
    else if (c_d[x_a][channel][i_d] ==  10){
      c_decay(x_a,  60,  16,  44, random_manager.get_random(x_a, 4, 10), random_manager.get_random(x_a, 5, 10));
    }
    else if (c_d[x_a][channel][i_d] ==  11){
      c_decay(x_a,  60,   8,  52, random_manager.get_random(x_a, 4, 11), random_manager.get_random(x_a, 5, 11));
    }
  }


  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
void ppaaa03_phasespace_set::ac_psp_330_gux_aaaux(int x_a, int channel){
  static Logger logger("ppaaa03_phasespace_set::ac_psp_330_gux_aaaux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,  36,  12, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  1] = smin_opt[x_a][20];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  1] = smin_opt[x_a][20];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_propagator(x_a,  36,  20, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  2] = smin_opt[x_a][24];
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_propagator(x_a,   0,  24, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  2] = smin_opt[x_a][24];
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_propagator(x_a,  36,  24, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][28]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][28]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,  36,  28, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  4], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 8));
    }
    else if (c_p[x_a][channel][i_p] ==   9){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,  36,  28, v_smin[x_a][  4], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 9));
    }
    else if (c_p[x_a][channel][i_p] ==  10){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  5], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 10));
    }
    else if (c_p[x_a][channel][i_p] ==  11){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_propagator(x_a,  36,  28, v_smin[x_a][  5], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 11));
    }
    else if (c_p[x_a][channel][i_p] ==  12){
      v_smin[x_a][  6] = smin_opt[x_a][40];
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_propagator(x_a,   0,  40, v_smin[x_a][  6], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 12));
    }
    else if (c_p[x_a][channel][i_p] ==  13){
      v_smin[x_a][  7] = smin_opt[x_a][48];
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_propagator(x_a,   0,  48, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 13));
    }
    else if (c_p[x_a][channel][i_p] ==  14){
      v_smin[x_a][  8] = smin_opt[x_a][36];
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_propagator(x_a,   0,  36, v_smin[x_a][  8], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 14));
    }
    else if (c_p[x_a][channel][i_p] ==  15){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  9], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 15));
    }
    else if (c_p[x_a][channel][i_p] ==  16){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][ 10], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 16));
    }
    else if (c_p[x_a][channel][i_p] ==  17){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][ 11], v_smax[x_a][  8], random_manager.get_random(x_a, 0, 17));
    }
    else if (c_p[x_a][channel][i_p] ==  18){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][ 12], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 18));
    }
    else if (c_p[x_a][channel][i_p] ==  19){
      v_smin[x_a][ 13] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][52]);
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][ 13], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 19));
    }
    else if (c_p[x_a][channel][i_p] ==  20){
      v_smin[x_a][ 14] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][ 14], v_smax[x_a][  8], random_manager.get_random(x_a, 0, 20));
    }
    else if (c_p[x_a][channel][i_p] ==  21){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 21));
    }
    else if (c_p[x_a][channel][i_p] ==  22){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_propagator(x_a,  36,  12, v_smin[x_a][  0], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 22));
    }
    else if (c_p[x_a][channel][i_p] ==  23){
      v_smin[x_a][  1] = smin_opt[x_a][20];
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][40], 2);
      c_propagator(x_a,   0,  20, v_smin[x_a][  1], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 23));
    }
    else if (c_p[x_a][channel][i_p] ==  24){
      v_smin[x_a][  1] = smin_opt[x_a][20];
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][40], 2);
      c_propagator(x_a,  36,  20, v_smin[x_a][  1], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 24));
    }
    else if (c_p[x_a][channel][i_p] ==  25){
      v_smin[x_a][  2] = smin_opt[x_a][24];
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][36], 2);
      c_propagator(x_a,   0,  24, v_smin[x_a][  2], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 25));
    }
    else if (c_p[x_a][channel][i_p] ==  26){
      v_smin[x_a][  2] = smin_opt[x_a][24];
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][36], 2);
      c_propagator(x_a,  36,  24, v_smin[x_a][  2], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 26));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][  2] = smin_opt[x_a][24];
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2);
      c_timelikeinvariant(x_a,  24, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][ 15] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][56]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][ 15], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 1));
    }
    else if (c_f[x_a][channel][i_f] ==   2){
      v_smin[x_a][  6] = smin_opt[x_a][40];
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][20], 2);
      c_timelikeinvariant(x_a,  40, v_smin[x_a][  6], v_smax[x_a][  4], random_manager.get_random(x_a, 1, 2));
    }
    else if (c_f[x_a][channel][i_f] ==   3){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][56]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][ 10], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 3));
    }
    else if (c_f[x_a][channel][i_f] ==   4){
      v_smin[x_a][  7] = smin_opt[x_a][48];
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_timelikeinvariant(x_a,  48, v_smin[x_a][  7], v_smax[x_a][  5], random_manager.get_random(x_a, 1, 4));
    }
    else if (c_f[x_a][channel][i_f] ==   5){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][4], 2);
      c_timelikeinvariant(x_a,  56, v_smin[x_a][  9], v_smax[x_a][  7], random_manager.get_random(x_a, 1, 5));
    }
    else if (c_f[x_a][channel][i_f] ==   6){
      v_smin[x_a][  0] = smin_opt[x_a][12];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_timelikeinvariant(x_a,  12, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 1, 6));
    }
    else if (c_f[x_a][channel][i_f] ==   7){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][ 16], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 7));
    }
    else if (c_f[x_a][channel][i_f] ==   8){
      v_smin[x_a][  8] = smin_opt[x_a][36];
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][24], 2);
      c_timelikeinvariant(x_a,  36, v_smin[x_a][  8], v_smax[x_a][  6], random_manager.get_random(x_a, 1, 8));
    }
    else if (c_f[x_a][channel][i_f] ==   9){
      v_smin[x_a][ 14] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][44]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][ 14], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 9));
    }
    else if (c_f[x_a][channel][i_f] ==  10){
      v_smin[x_a][  1] = smin_opt[x_a][20];
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2);
      c_timelikeinvariant(x_a,  20, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 1, 10));
    }
    else if (c_f[x_a][channel][i_f] ==  11){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][52]);
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][ 17], v_smax[x_a][  9], random_manager.get_random(x_a, 1, 11));
    }
    else if (c_f[x_a][channel][i_f] ==  12){
      v_smin[x_a][ 13] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][36], 2), smin_opt[x_a][52]);
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][ 13], v_smax[x_a][  9], random_manager.get_random(x_a, 1, 12));
    }
    else if (c_f[x_a][channel][i_f] ==  13){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][8], 2);
      c_timelikeinvariant(x_a,  52, v_smin[x_a][ 12], v_smax[x_a][  9], random_manager.get_random(x_a, 1, 13));
    }
    else if (c_f[x_a][channel][i_f] ==  14){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][40], 2), smin_opt[x_a][44]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2);
      c_timelikeinvariant(x_a,  44, v_smin[x_a][ 11], v_smax[x_a][  8], random_manager.get_random(x_a, 1, 14));
    }
    else if (c_f[x_a][channel][i_f] ==  15){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  28, v_smin[x_a][  4], v_smax[x_a][  3], random_manager.get_random(x_a, 1, 15));
    }
    else if (c_f[x_a][channel][i_f] ==  16){
      v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  28, v_smin[x_a][  5], v_smax[x_a][  3], random_manager.get_random(x_a, 1, 16));
    }
    else if (c_f[x_a][channel][i_f] ==  17){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][28]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2);
      c_timelikeinvariant(x_a,  28, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 1, 17));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0,  60,   1,   2,   4,  56, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,   0,  56,   2,   5,  32,  24, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel(x_a,   0,  24,   5,  34,   8,  16, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel_opt(x_a,  36,  60,   1,   2,   4,  56, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel(x_a,  36,  24,   5,  34,   8,  16, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel_opt(x_a,   0,  56,   2,   5,  16,  40, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel(x_a,   0,  40,   5,  18,   8,  32, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
    else if (c_t[x_a][channel][i_t] ==   7){
      c_tchannel(x_a,   0,  40,   5,  18,  32,   8, random_manager.get_random(x_a, 2, 7), random_manager.get_random(x_a, 3, 7));
    }
    else if (c_t[x_a][channel][i_t] ==   8){
      c_tchannel(x_a,   0,  24,   5,  34,  16,   8, random_manager.get_random(x_a, 2, 8), random_manager.get_random(x_a, 3, 8));
    }
    else if (c_t[x_a][channel][i_t] ==   9){
      c_tchannel(x_a,  36,  24,   5,  34,  16,   8, random_manager.get_random(x_a, 2, 9), random_manager.get_random(x_a, 3, 9));
    }
    else if (c_t[x_a][channel][i_t] ==  10){
      c_tchannel_opt(x_a,   0,  56,   2,   5,   8,  48, random_manager.get_random(x_a, 2, 10), random_manager.get_random(x_a, 3, 10));
    }
    else if (c_t[x_a][channel][i_t] ==  11){
      c_tchannel(x_a,   0,  48,   5,  10,  16,  32, random_manager.get_random(x_a, 2, 11), random_manager.get_random(x_a, 3, 11));
    }
    else if (c_t[x_a][channel][i_t] ==  12){
      c_tchannel(x_a,   0,  48,   5,  10,  32,  16, random_manager.get_random(x_a, 2, 12), random_manager.get_random(x_a, 3, 12));
    }
    else if (c_t[x_a][channel][i_t] ==  13){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  16,  44, random_manager.get_random(x_a, 2, 13), random_manager.get_random(x_a, 3, 13));
    }
    else if (c_t[x_a][channel][i_t] ==  14){
      c_tchannel_opt(x_a,   0,  44,   2,  17,  32,  12, random_manager.get_random(x_a, 2, 14), random_manager.get_random(x_a, 3, 14));
    }
    else if (c_t[x_a][channel][i_t] ==  15){
      c_tchannel(x_a,   0,  12,  17,  34,   4,   8, random_manager.get_random(x_a, 2, 15), random_manager.get_random(x_a, 3, 15));
    }
    else if (c_t[x_a][channel][i_t] ==  16){
      c_tchannel_opt(x_a,  36,  60,   1,   2,  16,  44, random_manager.get_random(x_a, 2, 16), random_manager.get_random(x_a, 3, 16));
    }
    else if (c_t[x_a][channel][i_t] ==  17){
      c_tchannel(x_a,  36,  12,  17,  34,   4,   8, random_manager.get_random(x_a, 2, 17), random_manager.get_random(x_a, 3, 17));
    }
    else if (c_t[x_a][channel][i_t] ==  18){
      c_tchannel_opt(x_a,   0,  44,   2,  17,   8,  36, random_manager.get_random(x_a, 2, 18), random_manager.get_random(x_a, 3, 18));
    }
    else if (c_t[x_a][channel][i_t] ==  19){
      c_tchannel(x_a,   0,  36,  17,  10,   4,  32, random_manager.get_random(x_a, 2, 19), random_manager.get_random(x_a, 3, 19));
    }
    else if (c_t[x_a][channel][i_t] ==  20){
      c_tchannel(x_a,   0,  36,  17,  10,  32,   4, random_manager.get_random(x_a, 2, 20), random_manager.get_random(x_a, 3, 20));
    }
    else if (c_t[x_a][channel][i_t] ==  21){
      c_tchannel_opt(x_a,   0,  60,   1,   2,   8,  52, random_manager.get_random(x_a, 2, 21), random_manager.get_random(x_a, 3, 21));
    }
    else if (c_t[x_a][channel][i_t] ==  22){
      c_tchannel_opt(x_a,   0,  52,   2,   9,  32,  20, random_manager.get_random(x_a, 2, 22), random_manager.get_random(x_a, 3, 22));
    }
    else if (c_t[x_a][channel][i_t] ==  23){
      c_tchannel(x_a,   0,  20,   9,  34,   4,  16, random_manager.get_random(x_a, 2, 23), random_manager.get_random(x_a, 3, 23));
    }
    else if (c_t[x_a][channel][i_t] ==  24){
      c_tchannel_opt(x_a,  36,  60,   1,   2,   8,  52, random_manager.get_random(x_a, 2, 24), random_manager.get_random(x_a, 3, 24));
    }
    else if (c_t[x_a][channel][i_t] ==  25){
      c_tchannel(x_a,  36,  20,   9,  34,   4,  16, random_manager.get_random(x_a, 2, 25), random_manager.get_random(x_a, 3, 25));
    }
    else if (c_t[x_a][channel][i_t] ==  26){
      c_tchannel_opt(x_a,   0,  52,   2,   9,  16,  36, random_manager.get_random(x_a, 2, 26), random_manager.get_random(x_a, 3, 26));
    }
    else if (c_t[x_a][channel][i_t] ==  27){
      c_tchannel(x_a,   0,  36,   9,  18,   4,  32, random_manager.get_random(x_a, 2, 27), random_manager.get_random(x_a, 3, 27));
    }
    else if (c_t[x_a][channel][i_t] ==  28){
      c_tchannel(x_a,   0,  36,   9,  18,  32,   4, random_manager.get_random(x_a, 2, 28), random_manager.get_random(x_a, 3, 28));
    }
    else if (c_t[x_a][channel][i_t] ==  29){
      c_tchannel(x_a,   0,  20,   9,  34,  16,   4, random_manager.get_random(x_a, 2, 29), random_manager.get_random(x_a, 3, 29));
    }
    else if (c_t[x_a][channel][i_t] ==  30){
      c_tchannel(x_a,  36,  20,   9,  34,  16,   4, random_manager.get_random(x_a, 2, 30), random_manager.get_random(x_a, 3, 30));
    }
    else if (c_t[x_a][channel][i_t] ==  31){
      c_tchannel_opt(x_a,   0,  52,   2,   9,   4,  48, random_manager.get_random(x_a, 2, 31), random_manager.get_random(x_a, 3, 31));
    }
    else if (c_t[x_a][channel][i_t] ==  32){
      c_tchannel(x_a,   0,  48,   9,   6,  16,  32, random_manager.get_random(x_a, 2, 32), random_manager.get_random(x_a, 3, 32));
    }
    else if (c_t[x_a][channel][i_t] ==  33){
      c_tchannel(x_a,   0,  48,   9,   6,  32,  16, random_manager.get_random(x_a, 2, 33), random_manager.get_random(x_a, 3, 33));
    }
    else if (c_t[x_a][channel][i_t] ==  34){
      c_tchannel(x_a,   0,  12,  17,  34,   8,   4, random_manager.get_random(x_a, 2, 34), random_manager.get_random(x_a, 3, 34));
    }
    else if (c_t[x_a][channel][i_t] ==  35){
      c_tchannel(x_a,  36,  12,  17,  34,   8,   4, random_manager.get_random(x_a, 2, 35), random_manager.get_random(x_a, 3, 35));
    }
    else if (c_t[x_a][channel][i_t] ==  36){
      c_tchannel_opt(x_a,   0,  44,   2,  17,   4,  40, random_manager.get_random(x_a, 2, 36), random_manager.get_random(x_a, 3, 36));
    }
    else if (c_t[x_a][channel][i_t] ==  37){
      c_tchannel(x_a,   0,  40,  17,   6,   8,  32, random_manager.get_random(x_a, 2, 37), random_manager.get_random(x_a, 3, 37));
    }
    else if (c_t[x_a][channel][i_t] ==  38){
      c_tchannel(x_a,   0,  40,  17,   6,  32,   8, random_manager.get_random(x_a, 2, 38), random_manager.get_random(x_a, 3, 38));
    }
    else if (c_t[x_a][channel][i_t] ==  39){
      c_tchannel_opt(x_a,   0,  60,   2,   1,  32,  28, random_manager.get_random(x_a, 2, 39), random_manager.get_random(x_a, 3, 39));
    }
    else if (c_t[x_a][channel][i_t] ==  40){
      c_tchannel_opt(x_a,   0,  28,   1,  34,  12,  16, random_manager.get_random(x_a, 2, 40), random_manager.get_random(x_a, 3, 40));
    }
    else if (c_t[x_a][channel][i_t] ==  41){
      c_tchannel_opt(x_a,  36,  28,   1,  34,  12,  16, random_manager.get_random(x_a, 2, 41), random_manager.get_random(x_a, 3, 41));
    }
    else if (c_t[x_a][channel][i_t] ==  42){
      c_tchannel_opt(x_a,   0,  60,   2,   1,  16,  44, random_manager.get_random(x_a, 2, 42), random_manager.get_random(x_a, 3, 42));
    }
    else if (c_t[x_a][channel][i_t] ==  43){
      c_tchannel_opt(x_a,   0,  44,   1,  18,  12,  32, random_manager.get_random(x_a, 2, 43), random_manager.get_random(x_a, 3, 43));
    }
    else if (c_t[x_a][channel][i_t] ==  44){
      c_tchannel_opt(x_a,   0,  28,   1,  34,  20,   8, random_manager.get_random(x_a, 2, 44), random_manager.get_random(x_a, 3, 44));
    }
    else if (c_t[x_a][channel][i_t] ==  45){
      c_tchannel_opt(x_a,  36,  28,   1,  34,  20,   8, random_manager.get_random(x_a, 2, 45), random_manager.get_random(x_a, 3, 45));
    }
    else if (c_t[x_a][channel][i_t] ==  46){
      c_tchannel_opt(x_a,   0,  60,   2,   1,   8,  52, random_manager.get_random(x_a, 2, 46), random_manager.get_random(x_a, 3, 46));
    }
    else if (c_t[x_a][channel][i_t] ==  47){
      c_tchannel_opt(x_a,   0,  52,   1,  10,  20,  32, random_manager.get_random(x_a, 2, 47), random_manager.get_random(x_a, 3, 47));
    }
    else if (c_t[x_a][channel][i_t] ==  48){
      c_tchannel_opt(x_a,   0,  28,   1,  34,  24,   4, random_manager.get_random(x_a, 2, 48), random_manager.get_random(x_a, 3, 48));
    }
    else if (c_t[x_a][channel][i_t] ==  49){
      c_tchannel_opt(x_a,  36,  28,   1,  34,  24,   4, random_manager.get_random(x_a, 2, 49), random_manager.get_random(x_a, 3, 49));
    }
    else if (c_t[x_a][channel][i_t] ==  50){
      c_tchannel_opt(x_a,   0,  60,   2,   1,   4,  56, random_manager.get_random(x_a, 2, 50), random_manager.get_random(x_a, 3, 50));
    }
    else if (c_t[x_a][channel][i_t] ==  51){
      c_tchannel_opt(x_a,   0,  56,   1,   6,  24,  32, random_manager.get_random(x_a, 2, 51), random_manager.get_random(x_a, 3, 51));
    }
    else if (c_t[x_a][channel][i_t] ==  52){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  32,  28, random_manager.get_random(x_a, 2, 52), random_manager.get_random(x_a, 3, 52));
    }
    else if (c_t[x_a][channel][i_t] ==  53){
      c_tchannel_opt(x_a,   0,  56,   2,   5,  48,   8, random_manager.get_random(x_a, 2, 53), random_manager.get_random(x_a, 3, 53));
    }
    else if (c_t[x_a][channel][i_t] ==  54){
      c_tchannel_opt(x_a,   0,  56,   2,   5,  40,  16, random_manager.get_random(x_a, 2, 54), random_manager.get_random(x_a, 3, 54));
    }
    else if (c_t[x_a][channel][i_t] ==  55){
      c_tchannel_opt(x_a,   0,  44,   2,  17,  40,   4, random_manager.get_random(x_a, 2, 55), random_manager.get_random(x_a, 3, 55));
    }
    else if (c_t[x_a][channel][i_t] ==  56){
      c_tchannel_opt(x_a,   0,  52,   2,   9,  48,   4, random_manager.get_random(x_a, 2, 56), random_manager.get_random(x_a, 3, 56));
    }
    else if (c_t[x_a][channel][i_t] ==  57){
      c_tchannel_opt(x_a,   0,  52,   2,   9,  36,  16, random_manager.get_random(x_a, 2, 57), random_manager.get_random(x_a, 3, 57));
    }
    else if (c_t[x_a][channel][i_t] ==  58){
      c_tchannel_opt(x_a,   0,  44,   2,  17,  36,   8, random_manager.get_random(x_a, 2, 58), random_manager.get_random(x_a, 3, 58));
    }
    else if (c_t[x_a][channel][i_t] ==  59){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  12,  48, random_manager.get_random(x_a, 2, 59), random_manager.get_random(x_a, 3, 59));
    }
    else if (c_t[x_a][channel][i_t] ==  60){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  20,  40, random_manager.get_random(x_a, 2, 60), random_manager.get_random(x_a, 3, 60));
    }
    else if (c_t[x_a][channel][i_t] ==  61){
      c_tchannel_opt(x_a,   0,  60,   1,   2,  24,  36, random_manager.get_random(x_a, 2, 61), random_manager.get_random(x_a, 3, 61));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a,  12,   4,   8, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a,  20,   4,  16, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  24,   8,  16, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a,  28,   4,  24, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  28,  16,  12, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a,  28,   8,  20, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a,  60,  32,  28, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a,  40,   8,  32, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
    else if (c_d[x_a][channel][i_d] ==   8){
      c_decay(x_a,  48,  16,  32, random_manager.get_random(x_a, 4, 8), random_manager.get_random(x_a, 5, 8));
    }
    else if (c_d[x_a][channel][i_d] ==   9){
      c_decay(x_a,  36,   4,  32, random_manager.get_random(x_a, 4, 9), random_manager.get_random(x_a, 5, 9));
    }
    else if (c_d[x_a][channel][i_d] ==  10){
      c_decay(x_a,  56,   8,  48, random_manager.get_random(x_a, 4, 10), random_manager.get_random(x_a, 5, 10));
    }
    else if (c_d[x_a][channel][i_d] ==  11){
      c_decay(x_a,  56,  16,  40, random_manager.get_random(x_a, 4, 11), random_manager.get_random(x_a, 5, 11));
    }
    else if (c_d[x_a][channel][i_d] ==  12){
      c_decay(x_a,  44,   4,  40, random_manager.get_random(x_a, 4, 12), random_manager.get_random(x_a, 5, 12));
    }
    else if (c_d[x_a][channel][i_d] ==  13){
      c_decay(x_a,  52,   4,  48, random_manager.get_random(x_a, 4, 13), random_manager.get_random(x_a, 5, 13));
    }
    else if (c_d[x_a][channel][i_d] ==  14){
      c_decay(x_a,  52,  16,  36, random_manager.get_random(x_a, 4, 14), random_manager.get_random(x_a, 5, 14));
    }
    else if (c_d[x_a][channel][i_d] ==  15){
      c_decay(x_a,  44,   8,  36, random_manager.get_random(x_a, 4, 15), random_manager.get_random(x_a, 5, 15));
    }
  }

  /*
  if      (channel ==    0){ac_channel_1111(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==    1){ac_channel_1111(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,  36, psi);}
  else if (channel ==    2){ac_channel_1111(r, 1, 2, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==    3){ac_channel_1111(r, 1, 2, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==    4){ac_channel_1111(r, 1, 2, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==    5){ac_channel_1111(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==    6){ac_channel_1111(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,  36, psi);}
  else if (channel ==    7){ac_channel_1111(r, 1, 2, 4, 16, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==    8){ac_channel_1111(r, 1, 2, 4, 16, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==    9){ac_channel_1111(r, 1, 2, 4, 32, 16, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   10){ac_channel_1111(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   11){ac_channel_1111(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,  36, psi);}
  else if (channel ==   12){ac_channel_1111(r, 1, 2, 16, 4, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   13){ac_channel_1111(r, 1, 2, 16, 4, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   14){ac_channel_1111(r, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   15){ac_channel_1111(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   16){ac_channel_1111(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,  36, psi);}
  else if (channel ==   17){ac_channel_1111(r, 1, 2, 8, 4, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   18){ac_channel_1111(r, 1, 2, 8, 4, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   19){ac_channel_1111(r, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   20){ac_channel_1111(r, 1, 2, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   21){ac_channel_1111(r, 1, 2, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,  36, psi);}
  else if (channel ==   22){ac_channel_1111(r, 1, 2, 8, 16, 32, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   23){ac_channel_1111(r, 1, 2, 8, 16, 32, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   24){ac_channel_1111(r, 1, 2, 8, 32, 16, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   25){ac_channel_1111(r, 1, 2, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   26){ac_channel_1111(r, 1, 2, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,  36, psi);}
  else if (channel ==   27){ac_channel_1111(r, 1, 2, 16, 8, 32, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   28){ac_channel_1111(r, 1, 2, 16, 8, 32, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   29){ac_channel_1111(r, 1, 2, 16, 32, 8, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   30){ac_channel_2v11(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   31){ac_channel_2v11(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,  36, psi);}
  else if (channel ==   32){ac_channel_2v11(r, 1, 2, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   33){ac_channel_2v11(r, 1, 2, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   34){ac_channel_2v11(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   35){ac_channel_2v11(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,  36, psi);}
  else if (channel ==   36){ac_channel_2v11(r, 1, 2, 4, 16, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   37){ac_channel_2v11(r, 1, 2, 4, 16, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   38){ac_channel_2v11(r, 1, 2, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   39){ac_channel_2v11(r, 1, 2, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,  36, psi);}
  else if (channel ==   40){ac_channel_2v11(r, 1, 2, 8, 16, 32, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   41){ac_channel_2v11(r, 1, 2, 8, 16, 32, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   42){ac_channel_3yv1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   43){ac_channel_3yv1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   44){ac_channel_3yv1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   45){ac_channel_3yv1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36,   0, psi);}
  else if (channel ==   46){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   47){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   48){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   49){ac_channel_3yv1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36,   0, psi);}
  else if (channel ==   50){ac_channel_3yv1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   51){ac_channel_3yv1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   52){ac_channel_3yv1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   53){ac_channel_3yv1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36,   0, psi);}
  else if (channel ==   54){ac_channel_4yyv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   55){ac_channel_4yyv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   56){ac_channel_4yyv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   57){ac_channel_4yyv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   58){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   59){ac_channel_4yyv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   60){ac_channel_12v1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   61){ac_channel_12v1(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36,   0, psi);}
  else if (channel ==   62){ac_channel_12v1(r, 1, 2, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   63){ac_channel_12v1(r, 1, 2, 4, 16, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   64){ac_channel_12v1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   65){ac_channel_12v1(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36,   0, psi);}
  else if (channel ==   66){ac_channel_12v1(r, 1, 2, 16, 4, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   67){ac_channel_12v1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   68){ac_channel_12v1(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,  36,   0, psi);}
  else if (channel ==   69){ac_channel_12v1(r, 1, 2, 8, 4, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   70){ac_channel_12v1(r, 1, 2, 8, 16, 32, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   71){ac_channel_12v1(r, 1, 2, 16, 8, 32, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   72){ac_channel_13yv(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   73){ac_channel_13yv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   74){ac_channel_13yv(r, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   75){ac_channel_13yv(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   76){ac_channel_13yv(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   77){ac_channel_13yv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   78){ac_channel_13yv(r, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   79){ac_channel_13yv(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   80){ac_channel_13yv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   81){ac_channel_13yv(r, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  36,   0,   0, psi);}
  else if (channel ==   82){ac_channel_13yv(r, 1, 2, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   83){ac_channel_13yv(r, 1, 2, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   84){ac_channel_112v(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   85){ac_channel_112v(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==   86){ac_channel_112v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   87){ac_channel_112v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==   88){ac_channel_112v(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   89){ac_channel_112v(r, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==   90){ac_channel_112v(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   91){ac_channel_112v(r, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==   92){ac_channel_112v(r, 1, 2, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   93){ac_channel_112v(r, 1, 2, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==   94){ac_channel_112v(r, 1, 2, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   95){ac_channel_112v(r, 1, 2, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==   96){ac_channel_2v2v(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   97){ac_channel_2v2v(r, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==   98){ac_channel_2v2v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==   99){ac_channel_2v2v(r, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  else if (channel ==  100){ac_channel_2v2v(r, 1, 2, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  else if (channel ==  101){ac_channel_2v2v(r, 1, 2, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  36,   0, psi);}
  */

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
