#include "header.hpp"

#include "ppaaa03.phasespace.set.hpp"

void ppaaa03_phasespace_set::ax_psp_230_dcx_aaadcx(int x_a){
  static Logger logger("ppaaa03_phasespace_set::ax_psp_230_dcx_aaadcx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(58);
  needed_v_smin[x_a].resize(58);
  needed_v_smin[x_a][  0] = {  24,   25,   32,   33,   40,   41,   46,   48,   62,   64,   80,   82,   96,   97,  102,  103,  110,  111,  116,  117,   16,   20,   92,   93}; //  24
  needed_v_smin[x_a][  1] = {  26,   29,   31,   34,   36,   39,   44,   50,   54,   60,   72,   78,   98,  101,  104,  107,  109,  112,  115,  118,    0,   12,   91,   94}; //  24
  needed_v_smin[x_a][  2] = {  27,   28,   30,   35,   37,   38,   42,   52,   56,   58,   74,   76,   99,  100,  105,  106,  108,  113,  114,  119,    4,    8,   90,   95}; //  24
  needed_v_smin[x_a][  3] = {  30,   38,   58,  108,    8,   76}; //   6
  needed_v_smin[x_a][  4] = {  31,   39,   60,  109,   12,   78}; //   6
  needed_v_smin[x_a][  5] = {  32,   40,   62,  110,   16,   80}; //   6
  needed_v_smin[x_a][  6] = {  33,   41,   64,  111,   20,   82}; //   6
  needed_v_smin[x_a][  7] = {  34,   36,   54,  112,    0,   72}; //   6
  needed_v_smin[x_a][  8] = {  35,   37,   56,  113,    4,   74}; //   6
  needed_v_smin[x_a][  9] = {  36,   37}; //   2
  needed_v_smin[x_a][ 10] = {  38,   41}; //   2
  needed_v_smin[x_a][ 11] = {  39,   40}; //   2
  needed_v_smin[x_a][ 12] = {  43,   45,   59,   61,   70,   71,   77,   79,   88,   89,   94,   95,   98,   99,  106,  107,  112,  113,  118,  119,   10,   14,   26,   27}; //  24
  needed_v_smin[x_a][ 13] = {  47,   53,   57,   63,   66,   69,   75,   81,   84,   87,   90,   93,   97,  100,  102,  105,  108,  111,  114,  117,    6,   18,   25,   28}; //  24
  needed_v_smin[x_a][ 14] = {  49,   51,   55,   65,   67,   68,   73,   83,   85,   86,   91,   92,   96,  101,  103,  104,  109,  110,  115,  116,    2,   22,   24,   29}; //  24
  needed_v_smin[x_a][ 15] = {  55,   68,   86,  104,   49}; //   5
  needed_v_smin[x_a][ 16] = {  57,   69,   87,  105,   47}; //   5
  needed_v_smin[x_a][ 17] = {  59,   70,   88,  106,   45}; //   5
  needed_v_smin[x_a][ 18] = {  61,   71,   89,  107,   43}; //   5
  needed_v_smin[x_a][ 19] = {  63,   66,   84,  102,   53}; //   5
  needed_v_smin[x_a][ 20] = {  65,   67,   85,  103,   51}; //   5
  needed_v_smin[x_a][ 21] = {  66,   67,   19,   23,   51,   53,   63,   65}; //   8
  needed_v_smin[x_a][ 22] = {  68,   71,    3,   15,   43,   49,   55,   61}; //   8
  needed_v_smin[x_a][ 23] = {  69,   70,    7,   11,   45,   47,   57,   59}; //   8
  needed_v_smin[x_a][ 24] = {   0,    4,   34,   35,   54,   56,   72,   74}; //   8
  needed_v_smin[x_a][ 25] = {   1,    5,    9,   13,   17,   21}; //   6
  needed_v_smin[x_a][ 26] = {   1,   21}; //   2
  needed_v_smin[x_a][ 27] = {   1,    2,   42,   73}; //   4
  needed_v_smin[x_a][ 28] = {   2,   22,   73,   83}; //   4
  needed_v_smin[x_a][ 29] = {   3,   15}; //   2
  needed_v_smin[x_a][ 30] = {   3,   15}; //   2
  needed_v_smin[x_a][ 31] = {   5,   17}; //   2
  needed_v_smin[x_a][ 32] = {   5,    6,   44,   75}; //   4
  needed_v_smin[x_a][ 33] = {   6,   18,   75,   81}; //   4
  needed_v_smin[x_a][ 34] = {   7,   11}; //   2
  needed_v_smin[x_a][ 35] = {   7,   11}; //   2
  needed_v_smin[x_a][ 36] = {   8,   20,   30,   33,   58,   64,   76,   82}; //   8
  needed_v_smin[x_a][ 37] = {   9,   13}; //   2
  needed_v_smin[x_a][ 38] = {   9,   10,   46,   77}; //   4
  needed_v_smin[x_a][ 39] = {  10,   14,   77,   79}; //   4
  needed_v_smin[x_a][ 40] = {  12,   16,   31,   32,   60,   62,   78,   80}; //   8
  needed_v_smin[x_a][ 41] = {  13,   14,   48,   79}; //   4
  needed_v_smin[x_a][ 42] = {  17,   18,   50,   81}; //   4
  needed_v_smin[x_a][ 43] = {  19,   23}; //   2
  needed_v_smin[x_a][ 44] = {  19,   23}; //   2
  needed_v_smin[x_a][ 45] = {  21,   22,   52,   83}; //   4
  needed_v_smin[x_a][ 46] = {  24,   92,   96,  116}; //   4
  needed_v_smin[x_a][ 47] = {  25,   93,   97,  117}; //   4
  needed_v_smin[x_a][ 48] = {  26,   94,   98,  118}; //   4
  needed_v_smin[x_a][ 49] = {  27,   95,   99,  119}; //   4
  needed_v_smin[x_a][ 50] = {  28,   90,  100,  114}; //   4
  needed_v_smin[x_a][ 51] = {  29,   91,  101,  115}; //   4
  needed_v_smin[x_a][ 52] = {  42,   52}; //   2
  needed_v_smin[x_a][ 53] = {  44,   50}; //   2
  needed_v_smin[x_a][ 54] = {  46,   48}; //   2
  needed_v_smin[x_a][ 55] = {  84,   85}; //   2
  needed_v_smin[x_a][ 56] = {  86,   89}; //   2
  needed_v_smin[x_a][ 57] = {  87,   88}; //   2

  v_smax[x_a].resize(42);
  needed_v_smax[x_a].resize(42);
  needed_v_smax[x_a][  0] = {  24,   25,   32,   33,   40,   41,   46,   48,   62,   64,   80,   82,   16,   20}; //  14
  needed_v_smax[x_a][  1] = {  26,   29,   31,   34,   36,   39,   44,   50,   54,   60,   72,   78,    0,   12}; //  14
  needed_v_smax[x_a][  2] = {  27,   28,   30,   35,   37,   38,   42,   52,   56,   58,   74,   76,    4,    8}; //  14
  needed_v_smax[x_a][  3] = {  30,   33,   38,   41,   58,   64,    8,   20,   76,   82}; //  10
  needed_v_smax[x_a][  4] = {  31,   32,   39,   40,   60,   62,   12,   16,   78,   80}; //  10
  needed_v_smax[x_a][  5] = {  34,   35,   36,   37,   54,   56,    0,    4,   72,   74}; //  10
  needed_v_smax[x_a][  6] = {  36,   37,   38,   39,   40,   41}; //   6
  needed_v_smax[x_a][  7] = {  43,   45,   59,   61,   70,   71,   77,   79,   88,   89,   94,   95,   98,   99,  106,  107,  112,  113,  118,  119,   10,   14}; //  22
  needed_v_smax[x_a][  8] = {  47,   53,   57,   63,   66,   69,   75,   81,   84,   87,   90,   93,   97,  100,  102,  105,  108,  111,  114,  117,    6,   18}; //  22
  needed_v_smax[x_a][  9] = {  49,   51,   55,   65,   67,   68,   73,   83,   85,   86,   91,   92,   96,  101,  103,  104,  109,  110,  115,  116,    2,   22}; //  22
  needed_v_smax[x_a][ 10] = {  55,   61,   68,   71,   86,   89,  104,  107,    3,   15,   43,   49}; //  12
  needed_v_smax[x_a][ 11] = {  57,   59,   69,   70,   87,   88,  105,  106,    7,   11,   45,   47}; //  12
  needed_v_smax[x_a][ 12] = {  63,   65,   66,   67,   84,   85,  102,  103,   19,   23,   51,   53}; //  12
  needed_v_smax[x_a][ 13] = {  66,   67,   68,   69,   70,   71,    3,    7,   11,   15,   19,   23,   43,   45,   47,   49,   51,   53,   55,   57,   59,   61,   63,   65}; //  24
  needed_v_smax[x_a][ 14] = {  96,  110,  116,   92}; //   4
  needed_v_smax[x_a][ 15] = {  97,  111,  117,   93}; //   4
  needed_v_smax[x_a][ 16] = {  98,  112,  118,   94}; //   4
  needed_v_smax[x_a][ 17] = {  99,  113,  119,   95}; //   4
  needed_v_smax[x_a][ 18] = { 100,  108,  114,   90}; //   4
  needed_v_smax[x_a][ 19] = { 101,  109,  115,   91}; //   4
  needed_v_smax[x_a][ 20] = { 102,  103}; //   2
  needed_v_smax[x_a][ 21] = { 104,  107}; //   2
  needed_v_smax[x_a][ 22] = { 105,  106}; //   2
  needed_v_smax[x_a][ 23] = { 108,  111}; //   2
  needed_v_smax[x_a][ 24] = { 109,  110}; //   2
  needed_v_smax[x_a][ 25] = { 112,  113}; //   2
  needed_v_smax[x_a][ 26] = {   0,    1,    2,    4,    5,    6,   28,   29,   34,   35,   42,   44,   54,   56,   72,   73,   74,   75,   84,   85,   90,   91,  100,  101,  114,  115}; //  26
  needed_v_smax[x_a][ 27] = {   1,    5,    9,   13,   17,   21}; //   6
  needed_v_smax[x_a][ 28] = {   1,    2,   21,   22,   42,   52,   73,   83}; //   8
  needed_v_smax[x_a][ 29] = {   3,   15}; //   2
  needed_v_smax[x_a][ 30] = {   5,    6,   17,   18,   44,   50,   75,   81}; //   8
  needed_v_smax[x_a][ 31] = {   7,   11}; //   2
  needed_v_smax[x_a][ 32] = {   8,    9,   10,   20,   21,   22,   24,   27,   30,   33,   46,   52,   58,   64,   76,   77,   82,   83,   86,   89,   92,   95,   96,   99,  116,  119}; //  26
  needed_v_smax[x_a][ 33] = {   9,   10,   13,   14,   46,   48,   77,   79}; //   8
  needed_v_smax[x_a][ 34] = {  12,   13,   14,   16,   17,   18,   25,   26,   31,   32,   48,   50,   60,   62,   78,   79,   80,   81,   87,   88,   93,   94,   97,   98,  117,  118}; //  26
  needed_v_smax[x_a][ 35] = {  19,   23}; //   2
  needed_v_smax[x_a][ 36] = {  24}; //   1
  needed_v_smax[x_a][ 37] = {  25}; //   1
  needed_v_smax[x_a][ 38] = {  26}; //   1
  needed_v_smax[x_a][ 39] = {  27}; //   1
  needed_v_smax[x_a][ 40] = {  28}; //   1
  needed_v_smax[x_a][ 41] = {  29}; //   1

  g_p[x_a].resize(39);
  needed_g_p[x_a].resize(39);
  needed_g_p[x_a][0] = {  24,   25,   32,   33,   40,   41,   46,   48,   62,   64,   80,   82}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  26,   29,   31,   34,   36,   39,   44,   50,   54,   60,   72,   78}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {  27,   28,   30,   35,   37,   38,   42,   52,   56,   58,   74,   76}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {  30,   38,   58}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  31,   39,   60}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {  32,   40,   62}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {  33,   41,   64}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax3");
  needed_g_p[x_a][7] = {  34,   36,   54}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][8] = {  35,   37,   56}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax5");
  needed_g_p[x_a][9] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax6");
  needed_g_p[x_a][10] = {  38,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax6");
  needed_g_p[x_a][11] = {  39,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax6");
  needed_g_p[x_a][12] = {  43,   45,   59,   61,   70,   71,   77,   79,   88,   89,   94,   95,   98,   99,  106,  107,  112,  113,  118,  119}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax7");
  needed_g_p[x_a][13] = {  47,   53,   57,   63,   66,   69,   75,   81,   84,   87,   90,   93,   97,  100,  102,  105,  108,  111,  114,  117}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax8");
  needed_g_p[x_a][14] = {  49,   51,   55,   65,   67,   68,   73,   83,   85,   86,   91,   92,   96,  101,  103,  104,  109,  110,  115,  116}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax9");
  needed_g_p[x_a][15] = {  55,   68,   86,  104}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax10");
  needed_g_p[x_a][16] = {  57,   69,   87,  105}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax11");
  needed_g_p[x_a][17] = {  59,   70,   88,  106}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax11");
  needed_g_p[x_a][18] = {  61,   71,   89,  107}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax10");
  needed_g_p[x_a][19] = {  63,   66,   84,  102}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax12");
  needed_g_p[x_a][20] = {  65,   67,   85,  103}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax12");
  needed_g_p[x_a][21] = {  66,   67}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax13");
  needed_g_p[x_a][22] = {  68,   71}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax13");
  needed_g_p[x_a][23] = {  69,   70}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax13");
  needed_g_p[x_a][24] = {  96,  110,  116}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax14");
  needed_g_p[x_a][25] = {  97,  111,  117}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax15");
  needed_g_p[x_a][26] = {  98,  112,  118}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax16");
  needed_g_p[x_a][27] = {  99,  113,  119}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax17");
  needed_g_p[x_a][28] = { 100,  108,  114}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax18");
  needed_g_p[x_a][29] = { 101,  109,  115}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax19");
  needed_g_p[x_a][30] = { 102,  103}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax20");
  needed_g_p[x_a][31] = { 104,  107}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax21");
  needed_g_p[x_a][32] = { 105,  106}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax22");
  needed_g_p[x_a][33] = { 108}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax23");
  needed_g_p[x_a][34] = { 109}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax24");
  needed_g_p[x_a][35] = { 110}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax24");
  needed_g_p[x_a][36] = { 111}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax23");
  needed_g_p[x_a][37] = { 112}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax25");
  needed_g_p[x_a][38] = { 113}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax25");

  g_f[x_a].resize(67);
  needed_g_f[x_a].resize(67);
  needed_g_f[x_a][0] = {   0,   12}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   0,   72}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][2] = {   0,    4,   34,   35,   54,   56,   72,   74}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax26");
  needed_g_f[x_a][3] = {   1,    5,    9,   13,   17,   21}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax27");
  needed_g_f[x_a][4] = {   1,   21}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax28");
  needed_g_f[x_a][5] = {   1,    2,   42,   73}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax26");
  needed_g_f[x_a][6] = {   2,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax9");
  needed_g_f[x_a][7] = {   2,   22,   73,   83}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax28");
  needed_g_f[x_a][8] = {   3,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax29");
  needed_g_f[x_a][9] = {   3,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax10");
  needed_g_f[x_a][10] = {   3,   15,   43,   49,   55,   61}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax13");
  needed_g_f[x_a][11] = {   4,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][12] = {   4,   74}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax5");
  needed_g_f[x_a][13] = {   5,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax30");
  needed_g_f[x_a][14] = {   5,    6,   44,   75}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin32_smax26");
  needed_g_f[x_a][15] = {   6,   18}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax8");
  needed_g_f[x_a][16] = {   6,   18,   75,   81}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin33_smax30");
  needed_g_f[x_a][17] = {   7,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin34_smax31");
  needed_g_f[x_a][18] = {   7,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin35_smax11");
  needed_g_f[x_a][19] = {   7,   11,   45,   47,   57,   59}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax13");
  needed_g_f[x_a][20] = {   8,   76}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][21] = {   8,   20,   30,   33,   58,   64,   76,   82}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin36_smax32");
  needed_g_f[x_a][22] = {   9,   13}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin37_smax33");
  needed_g_f[x_a][23] = {   9,   10,   46,   77}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin38_smax32");
  needed_g_f[x_a][24] = {  10,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax7");
  needed_g_f[x_a][25] = {  10,   14,   77,   79}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin39_smax33");
  needed_g_f[x_a][26] = {  12,   78}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][27] = {  12,   16,   31,   32,   60,   62,   78,   80}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin40_smax34");
  needed_g_f[x_a][28] = {  13,   14,   48,   79}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin41_smax34");
  needed_g_f[x_a][29] = {  16,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][30] = {  16,   80}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][31] = {  17,   18,   50,   81}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin42_smax34");
  needed_g_f[x_a][32] = {  19,   23}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin43_smax35");
  needed_g_f[x_a][33] = {  19,   23}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin44_smax12");
  needed_g_f[x_a][34] = {  19,   23,   51,   53,   63,   65}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax13");
  needed_g_f[x_a][35] = {  20,   82}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax3");
  needed_g_f[x_a][36] = {  21,   22,   52,   83}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin45_smax32");
  needed_g_f[x_a][37] = {  24}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax36");
  needed_g_f[x_a][38] = {  24,   92,   96,  116}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin46_smax32");
  needed_g_f[x_a][39] = {  25}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax37");
  needed_g_f[x_a][40] = {  25,   93,   97,  117}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin47_smax34");
  needed_g_f[x_a][41] = {  26}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax38");
  needed_g_f[x_a][42] = {  26,   94,   98,  118}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin48_smax34");
  needed_g_f[x_a][43] = {  27}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax39");
  needed_g_f[x_a][44] = {  27,   95,   99,  119}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin49_smax32");
  needed_g_f[x_a][45] = {  28}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax40");
  needed_g_f[x_a][46] = {  28,   90,  100,  114}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin50_smax26");
  needed_g_f[x_a][47] = {  29}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax41");
  needed_g_f[x_a][48] = {  29,   91,  101,  115}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin51_smax26");
  needed_g_f[x_a][49] = {  42,   52}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin52_smax28");
  needed_g_f[x_a][50] = {  43}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax10");
  needed_g_f[x_a][51] = {  44,   50}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin53_smax30");
  needed_g_f[x_a][52] = {  45}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax11");
  needed_g_f[x_a][53] = {  46,   48}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin54_smax33");
  needed_g_f[x_a][54] = {  47}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax11");
  needed_g_f[x_a][55] = {  49}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax10");
  needed_g_f[x_a][56] = {  51}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax12");
  needed_g_f[x_a][57] = {  53}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax12");
  needed_g_f[x_a][58] = {  84,   85}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin55_smax26");
  needed_g_f[x_a][59] = {  86,   89}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin56_smax32");
  needed_g_f[x_a][60] = {  87,   88}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin57_smax34");
  needed_g_f[x_a][61] = {  90}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax18");
  needed_g_f[x_a][62] = {  91}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax19");
  needed_g_f[x_a][63] = {  92}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax14");
  needed_g_f[x_a][64] = {  93}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax15");
  needed_g_f[x_a][65] = {  94}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax16");
  needed_g_f[x_a][66] = {  95}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax17");

  g_t[x_a].resize(101);
  needed_g_t[x_a].resize(101);
  needed_g_t[x_a][0] = {   0,    1,    2,    4,    5,    6,   42,   44,   54,   56,   72,   73,   74,   75,   84,   85,   90,   91,  114,  115}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_120");
  needed_g_t[x_a][1] = {   0,    4,   54,   56,   72,   74}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__64_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__64_56");
  needed_g_t[x_a][2] = {   0,   72}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_66__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_66__8_48");
  needed_g_t[x_a][3] = {   0,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][4] = {   1,    2,   42,   73}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_104");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__8_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__8_96");
  needed_g_t[x_a][6] = {   1,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][7] = {   2,   73}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__32_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__32_72");
  needed_g_t[x_a][8] = {   2,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_37__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_37__8_64");
  needed_g_t[x_a][9] = {   3,    7,   11,   15,   19,   23,   43,   45,   47,   49,   51,   53,   55,   57,   59,   61,   63,   65,   66,   67,   68,   69,   70,   71}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][10] = {   3,   15,   43,   49,   55,   61}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][11] = {   3,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][12] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_97__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_97__8_4");
  needed_g_t[x_a][13] = {   4,   74}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_66__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_66__16_40");
  needed_g_t[x_a][14] = {   4,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_21__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_21__32_8");
  needed_g_t[x_a][15] = {   5,    6,   44,   75}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_112");
  needed_g_t[x_a][16] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_96");
  needed_g_t[x_a][17] = {   5,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_21__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_21__64_32");
  needed_g_t[x_a][18] = {   6,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__32_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__32_80");
  needed_g_t[x_a][19] = {   6,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_37__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_37__16_64");
  needed_g_t[x_a][20] = {   7,   11,   45,   47,   57,   59}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_84");
  needed_g_t[x_a][21] = {   7,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__64_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__64_20");
  needed_g_t[x_a][22] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_97__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_97__16_4");
  needed_g_t[x_a][23] = {   8,    9,   10,   20,   21,   22,   46,   52,   58,   64,   76,   77,   82,   83,   86,   89,   92,   95,  116,  119}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][24] = {   8,   20,   58,   64,   76,   82}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][25] = {   8,   76}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_66__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_66__4_40");
  needed_g_t[x_a][26] = {   9,   10,   46,   77}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_100");
  needed_g_t[x_a][27] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__4_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__4_96");
  needed_g_t[x_a][28] = {  10,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_68");
  needed_g_t[x_a][29] = {  10,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_49__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_49__4_64");
  needed_g_t[x_a][30] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_97__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_97__4_16");
  needed_g_t[x_a][31] = {  12,   13,   14,   16,   17,   18,   48,   50,   60,   62,   78,   79,   80,   81,   87,   88,   93,   94,  117,  118}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_116");
  needed_g_t[x_a][32] = {  12,   16,   60,   62,   78,   80}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__64_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__64_52");
  needed_g_t[x_a][33] = {  12,   78}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_66__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_66__4_48");
  needed_g_t[x_a][34] = {  13,   14,   48,   79}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_100");
  needed_g_t[x_a][35] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__4_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__4_96");
  needed_g_t[x_a][36] = {  14,   79}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__32_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__32_68");
  needed_g_t[x_a][37] = {  14,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_41__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_41__4_64");
  needed_g_t[x_a][38] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_97__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_97__4_8");
  needed_g_t[x_a][39] = {  16,   80}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_66__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_66__16_36");
  needed_g_t[x_a][40] = {  16,   20}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_25__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_25__32_4");
  needed_g_t[x_a][41] = {  17,   18,   50,   81}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_112");
  needed_g_t[x_a][42] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__16_96");
  needed_g_t[x_a][43] = {  17,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_25__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_25__64_32");
  needed_g_t[x_a][44] = {  18,   81}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__32_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__32_80");
  needed_g_t[x_a][45] = {  18,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_41__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_41__16_64");
  needed_g_t[x_a][46] = {  19,   23,   51,   53,   63,   65}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_88");
  needed_g_t[x_a][47] = {  19,   23}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__64_24");
  needed_g_t[x_a][48] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_97__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_97__16_8");
  needed_g_t[x_a][49] = {  20,   82}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_66__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_66__8_36");
  needed_g_t[x_a][50] = {  21,   22,   52,   83}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_104");
  needed_g_t[x_a][51] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__8_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__8_96");
  needed_g_t[x_a][52] = {  22,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_72");
  needed_g_t[x_a][53] = {  22,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_49__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_49__8_64");
  needed_g_t[x_a][54] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_97__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_97__8_16");
  needed_g_t[x_a][55] = {  24,   27,   30,   33,   96,   99}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][56] = {  24,   96}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__36_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__36_72");
  needed_g_t[x_a][57] = {  25,   26,   31,   32,   97,   98}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][58] = {  25,   97}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__36_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__36_80");
  needed_g_t[x_a][59] = {  26,   98}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_68");
  needed_g_t[x_a][60] = {  27,   99}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__40_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__40_68");
  needed_g_t[x_a][61] = {  28,   29,   34,   35,  100,  101}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][62] = {  28,  100}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__40_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__40_80");
  needed_g_t[x_a][63] = {  29,  101}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_72");
  needed_g_t[x_a][64] = {  30,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__64_44");
  needed_g_t[x_a][65] = {  31,   32}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__64_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__64_52");
  needed_g_t[x_a][66] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__64_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__64_56");
  needed_g_t[x_a][67] = {  36,   37,   38,   39,   40,   41}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][68] = {  42}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_5__64_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_5__64_40");
  needed_g_t[x_a][69] = {  43}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_33__8_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_33__8_68");
  needed_g_t[x_a][70] = {  44}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_5__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_5__64_48");
  needed_g_t[x_a][71] = {  45}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_33__16_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_33__16_68");
  needed_g_t[x_a][72] = {  46}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_17__64_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_17__64_36");
  needed_g_t[x_a][73] = {  47}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_33__4_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_33__4_80");
  needed_g_t[x_a][74] = {  48}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_9__64_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_9__64_36");
  needed_g_t[x_a][75] = {  49}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_33__4_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_33__4_72");
  needed_g_t[x_a][76] = {  50}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_9__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_9__64_48");
  needed_g_t[x_a][77] = {  51}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_33__16_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_33__16_72");
  needed_g_t[x_a][78] = {  52}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_17__64_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_17__64_40");
  needed_g_t[x_a][79] = {  53}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_33__8_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_33__8_80");
  needed_g_t[x_a][80] = {  84,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__5_2__32_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__5_2__32_88");
  needed_g_t[x_a][81] = {  86,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__32_76");
  needed_g_t[x_a][82] = {  87,   88}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__9_2__32_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__9_2__32_84");
  needed_g_t[x_a][83] = {  90,  114}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__80_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__80_40");
  needed_g_t[x_a][84] = {  90}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_82__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_82__8_32");
  needed_g_t[x_a][85] = {  91,  115}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__72_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__72_48");
  needed_g_t[x_a][86] = {  91}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_74__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_74__16_32");
  needed_g_t[x_a][87] = {  92,  116}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__72_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__72_36");
  needed_g_t[x_a][88] = {  92}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_74__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_74__4_32");
  needed_g_t[x_a][89] = {  93,  117}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__80_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__80_36");
  needed_g_t[x_a][90] = {  93}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_82__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_82__4_32");
  needed_g_t[x_a][91] = {  94,  118}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__68_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__68_48");
  needed_g_t[x_a][92] = {  94}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_70__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_70__16_32");
  needed_g_t[x_a][93] = {  95,  119}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__68_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__68_40");
  needed_g_t[x_a][94] = {  95}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_70__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_70__8_32");
  needed_g_t[x_a][95] = { 102,  103}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_88");
  needed_g_t[x_a][96] = { 104,  107}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][97] = { 105,  106}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_84");
  needed_g_t[x_a][98] = { 108,  111}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");
  needed_g_t[x_a][99] = { 109,  110}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__72_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__72_52");
  needed_g_t[x_a][100] = { 112,  113}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__68_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__68_56");

  g_d[x_a].resize(24);
  needed_g_d[x_a].resize(24);
  needed_g_d[x_a][0] = {  24,   25,   32,   33,   40,   41,   46,   48,   62,   64,   80,   82,   96,   97,  102,  103,  110,  111,  116,  117}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][1] = {  26,   29,   31,   34,   36,   39,   44,   50,   54,   60,   72,   78,   98,  101,  104,  107,  109,  112,  115,  118}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {  27,   28,   30,   35,   37,   38,   42,   52,   56,   58,   74,   76,   99,  100,  105,  106,  108,  113,  114,  119}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {  30,   38,   58,  108}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][4] = {  31,   39,   60,  109}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][5] = {  32,   40,   62,  110}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][6] = {  33,   41,   64,  111}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][7] = {  34,   36,   54,  112}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][8] = {  35,   37,   56,  113}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][9] = {  36,   37}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][10] = {  38,   41}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][11] = {  39,   40}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][12] = {  43,   45,   59,   61,   70,   71,   77,   79,   88,   89,   94,   95,   98,   99,  106,  107,  112,  113,  118,  119}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][13] = {  47,   53,   57,   63,   66,   69,   75,   81,   84,   87,   90,   93,   97,  100,  102,  105,  108,  111,  114,  117}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][14] = {  49,   51,   55,   65,   67,   68,   73,   83,   85,   86,   91,   92,   96,  101,  103,  104,  109,  110,  115,  116}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][15] = {  55,   68,   86,  104}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__4_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__4_72");
  needed_g_d[x_a][16] = {  57,   69,   87,  105}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__4_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__4_80");
  needed_g_d[x_a][17] = {  59,   70,   88,  106}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__16_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__16_68");
  needed_g_d[x_a][18] = {  61,   71,   89,  107}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__8_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__8_68");
  needed_g_d[x_a][19] = {  63,   66,   84,  102}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__8_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__8_80");
  needed_g_d[x_a][20] = {  65,   67,   85,  103}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__16_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__16_72");
  needed_g_d[x_a][21] = {  66,   67}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__4_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__4_88");
  needed_g_d[x_a][22] = {  68,   71}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][23] = {  69,   70}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__8_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__8_84");

  c_p[x_a].resize(120);
  c_f[x_a].resize(120);
  c_t[x_a].resize(120);
  c_d[x_a].resize(120);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  3,   4,   5}; //   3
  c_t[x_a][1] = {  0,   4,   5,   6}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  6,   7,   5}; //   3
  c_t[x_a][2] = {  0,   4,   7,   8}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  8,   9,  10}; //   3
  c_t[x_a][3] = {  9,  10,  11,  12}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = { 11,  12,   2}; //   3
  c_t[x_a][4] = {  0,   1,  13,  14}; //   4
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  3,  13,  14}; //   3
  c_t[x_a][5] = {  0,  15,  16,  17}; //   4
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = { 15,  16,  14}; //   3
  c_t[x_a][6] = {  0,  15,  18,  19}; //   4
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = { 17,  18,  19}; //   3
  c_t[x_a][7] = {  9,  20,  21,  22}; //   4
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = { 11,  20,  21}; //   3
  c_t[x_a][8] = { 23,  24,  25,  14}; //   4
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = {  3,  22,  23}; //   3
  c_t[x_a][9] = { 23,  26,  27,  17}; //   4
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = { 24,  25,  23}; //   3
  c_t[x_a][10] = { 23,  26,  28,  29}; //   4
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = { 17,  18,  19}; //   3
  c_t[x_a][11] = {  9,  20,  21,  30}; //   4
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {}; //   0
  c_f[x_a][12] = {  0,  26,  27}; //   3
  c_t[x_a][12] = { 31,  32,  33,   3}; //   4
  c_d[x_a][12] = {}; //   0

  c_p[x_a][13] = {}; //   0
  c_f[x_a][13] = {  3,  22,  28}; //   3
  c_t[x_a][13] = { 31,  34,  35,   6}; //   4
  c_d[x_a][13] = {}; //   0

  c_p[x_a][14] = {}; //   0
  c_f[x_a][14] = { 24,  25,  28}; //   3
  c_t[x_a][14] = { 31,  34,  36,  37}; //   4
  c_d[x_a][14] = {}; //   0

  c_p[x_a][15] = {}; //   0
  c_f[x_a][15] = {  8,   9,  10}; //   3
  c_t[x_a][15] = {  9,  10,  11,  38}; //   4
  c_d[x_a][15] = {}; //   0

  c_p[x_a][16] = {}; //   0
  c_f[x_a][16] = { 29,  30,  27}; //   3
  c_t[x_a][16] = { 31,  32,  39,  40}; //   4
  c_d[x_a][16] = {}; //   0

  c_p[x_a][17] = {}; //   0
  c_f[x_a][17] = {  3,  13,  31}; //   3
  c_t[x_a][17] = { 31,  41,  42,  43}; //   4
  c_d[x_a][17] = {}; //   0

  c_p[x_a][18] = {}; //   0
  c_f[x_a][18] = { 15,  16,  31}; //   3
  c_t[x_a][18] = { 31,  41,  44,  45}; //   4
  c_d[x_a][18] = {}; //   0

  c_p[x_a][19] = {}; //   0
  c_f[x_a][19] = { 32,  33,  34}; //   3
  c_t[x_a][19] = {  9,  46,  47,  48}; //   4
  c_d[x_a][19] = {}; //   0

  c_p[x_a][20] = {}; //   0
  c_f[x_a][20] = { 29,  35,  21}; //   3
  c_t[x_a][20] = { 23,  24,  49,  40}; //   4
  c_d[x_a][20] = {}; //   0

  c_p[x_a][21] = {}; //   0
  c_f[x_a][21] = {  3,   4,  36}; //   3
  c_t[x_a][21] = { 23,  50,  51,  43}; //   4
  c_d[x_a][21] = {}; //   0

  c_p[x_a][22] = {}; //   0
  c_f[x_a][22] = {  6,   7,  36}; //   3
  c_t[x_a][22] = { 23,  50,  52,  53}; //   4
  c_d[x_a][22] = {}; //   0

  c_p[x_a][23] = {}; //   0
  c_f[x_a][23] = { 32,  33,  34}; //   3
  c_t[x_a][23] = {  9,  46,  47,  54}; //   4
  c_d[x_a][23] = {}; //   0

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = { 37,  38}; //   2
  c_t[x_a][24] = { 55,  56,   8}; //   3
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  0}; //   1
  c_f[x_a][25] = { 39,  40}; //   2
  c_t[x_a][25] = { 57,  58,  19}; //   3
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  1}; //   1
  c_f[x_a][26] = { 41,  42}; //   2
  c_t[x_a][26] = { 57,  59,  29}; //   3
  c_d[x_a][26] = {  1}; //   1

  c_p[x_a][27] = {  2}; //   1
  c_f[x_a][27] = { 43,  44}; //   2
  c_t[x_a][27] = { 55,  60,  37}; //   3
  c_d[x_a][27] = {  2}; //   1

  c_p[x_a][28] = {  2}; //   1
  c_f[x_a][28] = { 45,  46}; //   2
  c_t[x_a][28] = { 61,  62,  45}; //   3
  c_d[x_a][28] = {  2}; //   1

  c_p[x_a][29] = {  1}; //   1
  c_f[x_a][29] = { 47,  48}; //   2
  c_t[x_a][29] = { 61,  63,  53}; //   3
  c_d[x_a][29] = {  1}; //   1

  c_p[x_a][30] = {  2,   3}; //   2
  c_f[x_a][30] = { 21}; //   1
  c_t[x_a][30] = { 55,  64}; //   2
  c_d[x_a][30] = {  3,   2}; //   2

  c_p[x_a][31] = {  1,   4}; //   2
  c_f[x_a][31] = { 27}; //   1
  c_t[x_a][31] = { 57,  65}; //   2
  c_d[x_a][31] = {  4,   1}; //   2

  c_p[x_a][32] = {  0,   5}; //   2
  c_f[x_a][32] = { 27}; //   1
  c_t[x_a][32] = { 57,  65}; //   2
  c_d[x_a][32] = {  5,   0}; //   2

  c_p[x_a][33] = {  0,   6}; //   2
  c_f[x_a][33] = { 21}; //   1
  c_t[x_a][33] = { 55,  64}; //   2
  c_d[x_a][33] = {  6,   0}; //   2

  c_p[x_a][34] = {  1,   7}; //   2
  c_f[x_a][34] = {  2}; //   1
  c_t[x_a][34] = { 61,  66}; //   2
  c_d[x_a][34] = {  7,   1}; //   2

  c_p[x_a][35] = {  2,   8}; //   2
  c_f[x_a][35] = {  2}; //   1
  c_t[x_a][35] = { 61,  66}; //   2
  c_d[x_a][35] = {  8,   2}; //   2

  c_p[x_a][36] = {  1,   7,   9}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = { 67}; //   1
  c_d[x_a][36] = {  9,   7,   1}; //   3

  c_p[x_a][37] = {  2,   8,   9}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = { 67}; //   1
  c_d[x_a][37] = {  9,   8,   2}; //   3

  c_p[x_a][38] = {  2,   3,  10}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 67}; //   1
  c_d[x_a][38] = { 10,   3,   2}; //   3

  c_p[x_a][39] = {  1,   4,  11}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 67}; //   1
  c_d[x_a][39] = { 11,   4,   1}; //   3

  c_p[x_a][40] = {  0,   5,  11}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = { 67}; //   1
  c_d[x_a][40] = { 11,   5,   0}; //   3

  c_p[x_a][41] = {  0,   6,  10}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = { 67}; //   1
  c_d[x_a][41] = { 10,   6,   0}; //   3

  c_p[x_a][42] = {  2}; //   1
  c_f[x_a][42] = { 49,   5}; //   2
  c_t[x_a][42] = {  0,   4,  68}; //   3
  c_d[x_a][42] = {  2}; //   1

  c_p[x_a][43] = { 12}; //   1
  c_f[x_a][43] = { 50,  10}; //   2
  c_t[x_a][43] = {  9,  10,  69}; //   3
  c_d[x_a][43] = { 12}; //   1

  c_p[x_a][44] = {  1}; //   1
  c_f[x_a][44] = { 51,  14}; //   2
  c_t[x_a][44] = {  0,  15,  70}; //   3
  c_d[x_a][44] = {  1}; //   1

  c_p[x_a][45] = { 12}; //   1
  c_f[x_a][45] = { 52,  19}; //   2
  c_t[x_a][45] = {  9,  20,  71}; //   3
  c_d[x_a][45] = { 12}; //   1

  c_p[x_a][46] = {  0}; //   1
  c_f[x_a][46] = { 53,  23}; //   2
  c_t[x_a][46] = { 23,  26,  72}; //   3
  c_d[x_a][46] = {  0}; //   1

  c_p[x_a][47] = { 13}; //   1
  c_f[x_a][47] = { 54,  19}; //   2
  c_t[x_a][47] = {  9,  20,  73}; //   3
  c_d[x_a][47] = { 13}; //   1

  c_p[x_a][48] = {  0}; //   1
  c_f[x_a][48] = { 53,  28}; //   2
  c_t[x_a][48] = { 31,  34,  74}; //   3
  c_d[x_a][48] = {  0}; //   1

  c_p[x_a][49] = { 14}; //   1
  c_f[x_a][49] = { 55,  10}; //   2
  c_t[x_a][49] = {  9,  10,  75}; //   3
  c_d[x_a][49] = { 14}; //   1

  c_p[x_a][50] = {  1}; //   1
  c_f[x_a][50] = { 51,  31}; //   2
  c_t[x_a][50] = { 31,  41,  76}; //   3
  c_d[x_a][50] = {  1}; //   1

  c_p[x_a][51] = { 14}; //   1
  c_f[x_a][51] = { 56,  34}; //   2
  c_t[x_a][51] = {  9,  46,  77}; //   3
  c_d[x_a][51] = { 14}; //   1

  c_p[x_a][52] = {  2}; //   1
  c_f[x_a][52] = { 49,  36}; //   2
  c_t[x_a][52] = { 23,  50,  78}; //   3
  c_d[x_a][52] = {  2}; //   1

  c_p[x_a][53] = { 13}; //   1
  c_f[x_a][53] = { 57,  34}; //   2
  c_t[x_a][53] = {  9,  46,  79}; //   3
  c_d[x_a][53] = { 13}; //   1

  c_p[x_a][54] = {  1,   7}; //   2
  c_f[x_a][54] = {  2}; //   1
  c_t[x_a][54] = {  0,   1}; //   2
  c_d[x_a][54] = {  7,   1}; //   2

  c_p[x_a][55] = { 14,  15}; //   2
  c_f[x_a][55] = { 10}; //   1
  c_t[x_a][55] = {  9,  10}; //   2
  c_d[x_a][55] = { 15,  14}; //   2

  c_p[x_a][56] = {  2,   8}; //   2
  c_f[x_a][56] = {  2}; //   1
  c_t[x_a][56] = {  0,   1}; //   2
  c_d[x_a][56] = {  8,   2}; //   2

  c_p[x_a][57] = { 13,  16}; //   2
  c_f[x_a][57] = { 19}; //   1
  c_t[x_a][57] = {  9,  20}; //   2
  c_d[x_a][57] = { 16,  13}; //   2

  c_p[x_a][58] = {  2,   3}; //   2
  c_f[x_a][58] = { 21}; //   1
  c_t[x_a][58] = { 23,  24}; //   2
  c_d[x_a][58] = {  3,   2}; //   2

  c_p[x_a][59] = { 12,  17}; //   2
  c_f[x_a][59] = { 19}; //   1
  c_t[x_a][59] = {  9,  20}; //   2
  c_d[x_a][59] = { 17,  12}; //   2

  c_p[x_a][60] = {  1,   4}; //   2
  c_f[x_a][60] = { 27}; //   1
  c_t[x_a][60] = { 31,  32}; //   2
  c_d[x_a][60] = {  4,   1}; //   2

  c_p[x_a][61] = { 12,  18}; //   2
  c_f[x_a][61] = { 10}; //   1
  c_t[x_a][61] = {  9,  10}; //   2
  c_d[x_a][61] = { 18,  12}; //   2

  c_p[x_a][62] = {  0,   5}; //   2
  c_f[x_a][62] = { 27}; //   1
  c_t[x_a][62] = { 31,  32}; //   2
  c_d[x_a][62] = {  5,   0}; //   2

  c_p[x_a][63] = { 13,  19}; //   2
  c_f[x_a][63] = { 34}; //   1
  c_t[x_a][63] = {  9,  46}; //   2
  c_d[x_a][63] = { 19,  13}; //   2

  c_p[x_a][64] = {  0,   6}; //   2
  c_f[x_a][64] = { 21}; //   1
  c_t[x_a][64] = { 23,  24}; //   2
  c_d[x_a][64] = {  6,   0}; //   2

  c_p[x_a][65] = { 14,  20}; //   2
  c_f[x_a][65] = { 34}; //   1
  c_t[x_a][65] = {  9,  46}; //   2
  c_d[x_a][65] = { 20,  14}; //   2

  c_p[x_a][66] = { 13,  19,  21}; //   3
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  9}; //   1
  c_d[x_a][66] = { 21,  19,  13}; //   3

  c_p[x_a][67] = { 14,  20,  21}; //   3
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  9}; //   1
  c_d[x_a][67] = { 21,  20,  14}; //   3

  c_p[x_a][68] = { 14,  15,  22}; //   3
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  9}; //   1
  c_d[x_a][68] = { 22,  15,  14}; //   3

  c_p[x_a][69] = { 13,  16,  23}; //   3
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  9}; //   1
  c_d[x_a][69] = { 23,  16,  13}; //   3

  c_p[x_a][70] = { 12,  17,  23}; //   3
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  9}; //   1
  c_d[x_a][70] = { 23,  17,  12}; //   3

  c_p[x_a][71] = { 12,  18,  22}; //   3
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {  9}; //   1
  c_d[x_a][71] = { 22,  18,  12}; //   3

  c_p[x_a][72] = {  1}; //   1
  c_f[x_a][72] = {  1,   2}; //   2
  c_t[x_a][72] = {  0,   1,   2}; //   3
  c_d[x_a][72] = {  1}; //   1

  c_p[x_a][73] = { 14}; //   1
  c_f[x_a][73] = {  7,   5}; //   2
  c_t[x_a][73] = {  0,   4,   7}; //   3
  c_d[x_a][73] = { 14}; //   1

  c_p[x_a][74] = {  2}; //   1
  c_f[x_a][74] = { 12,   2}; //   2
  c_t[x_a][74] = {  0,   1,  13}; //   3
  c_d[x_a][74] = {  2}; //   1

  c_p[x_a][75] = { 13}; //   1
  c_f[x_a][75] = { 16,  14}; //   2
  c_t[x_a][75] = {  0,  15,  18}; //   3
  c_d[x_a][75] = { 13}; //   1

  c_p[x_a][76] = {  2}; //   1
  c_f[x_a][76] = { 20,  21}; //   2
  c_t[x_a][76] = { 23,  24,  25}; //   3
  c_d[x_a][76] = {  2}; //   1

  c_p[x_a][77] = { 12}; //   1
  c_f[x_a][77] = { 25,  23}; //   2
  c_t[x_a][77] = { 23,  26,  28}; //   3
  c_d[x_a][77] = { 12}; //   1

  c_p[x_a][78] = {  1}; //   1
  c_f[x_a][78] = { 26,  27}; //   2
  c_t[x_a][78] = { 31,  32,  33}; //   3
  c_d[x_a][78] = {  1}; //   1

  c_p[x_a][79] = { 12}; //   1
  c_f[x_a][79] = { 25,  28}; //   2
  c_t[x_a][79] = { 31,  34,  36}; //   3
  c_d[x_a][79] = { 12}; //   1

  c_p[x_a][80] = {  0}; //   1
  c_f[x_a][80] = { 30,  27}; //   2
  c_t[x_a][80] = { 31,  32,  39}; //   3
  c_d[x_a][80] = {  0}; //   1

  c_p[x_a][81] = { 13}; //   1
  c_f[x_a][81] = { 16,  31}; //   2
  c_t[x_a][81] = { 31,  41,  44}; //   3
  c_d[x_a][81] = { 13}; //   1

  c_p[x_a][82] = {  0}; //   1
  c_f[x_a][82] = { 35,  21}; //   2
  c_t[x_a][82] = { 23,  24,  49}; //   3
  c_d[x_a][82] = {  0}; //   1

  c_p[x_a][83] = { 14}; //   1
  c_f[x_a][83] = {  7,  36}; //   2
  c_t[x_a][83] = { 23,  50,  52}; //   3
  c_d[x_a][83] = { 14}; //   1

  c_p[x_a][84] = { 13,  19}; //   2
  c_f[x_a][84] = { 58}; //   1
  c_t[x_a][84] = {  0,  80}; //   2
  c_d[x_a][84] = { 19,  13}; //   2

  c_p[x_a][85] = { 14,  20}; //   2
  c_f[x_a][85] = { 58}; //   1
  c_t[x_a][85] = {  0,  80}; //   2
  c_d[x_a][85] = { 20,  14}; //   2

  c_p[x_a][86] = { 14,  15}; //   2
  c_f[x_a][86] = { 59}; //   1
  c_t[x_a][86] = { 23,  81}; //   2
  c_d[x_a][86] = { 15,  14}; //   2

  c_p[x_a][87] = { 13,  16}; //   2
  c_f[x_a][87] = { 60}; //   1
  c_t[x_a][87] = { 31,  82}; //   2
  c_d[x_a][87] = { 16,  13}; //   2

  c_p[x_a][88] = { 12,  17}; //   2
  c_f[x_a][88] = { 60}; //   1
  c_t[x_a][88] = { 31,  82}; //   2
  c_d[x_a][88] = { 17,  12}; //   2

  c_p[x_a][89] = { 12,  18}; //   2
  c_f[x_a][89] = { 59}; //   1
  c_t[x_a][89] = { 23,  81}; //   2
  c_d[x_a][89] = { 18,  12}; //   2

  c_p[x_a][90] = { 13}; //   1
  c_f[x_a][90] = { 61,  46}; //   2
  c_t[x_a][90] = {  0,  83,  84}; //   3
  c_d[x_a][90] = { 13}; //   1

  c_p[x_a][91] = { 14}; //   1
  c_f[x_a][91] = { 62,  48}; //   2
  c_t[x_a][91] = {  0,  85,  86}; //   3
  c_d[x_a][91] = { 14}; //   1

  c_p[x_a][92] = { 14}; //   1
  c_f[x_a][92] = { 63,  38}; //   2
  c_t[x_a][92] = { 23,  87,  88}; //   3
  c_d[x_a][92] = { 14}; //   1

  c_p[x_a][93] = { 13}; //   1
  c_f[x_a][93] = { 64,  40}; //   2
  c_t[x_a][93] = { 31,  89,  90}; //   3
  c_d[x_a][93] = { 13}; //   1

  c_p[x_a][94] = { 12}; //   1
  c_f[x_a][94] = { 65,  42}; //   2
  c_t[x_a][94] = { 31,  91,  92}; //   3
  c_d[x_a][94] = { 12}; //   1

  c_p[x_a][95] = { 12}; //   1
  c_f[x_a][95] = { 66,  44}; //   2
  c_t[x_a][95] = { 23,  93,  94}; //   3
  c_d[x_a][95] = { 12}; //   1

  c_p[x_a][96] = { 14,  24}; //   2
  c_f[x_a][96] = { 38}; //   1
  c_t[x_a][96] = { 55,  56}; //   2
  c_d[x_a][96] = {  0,  14}; //   2

  c_p[x_a][97] = { 13,  25}; //   2
  c_f[x_a][97] = { 40}; //   1
  c_t[x_a][97] = { 57,  58}; //   2
  c_d[x_a][97] = {  0,  13}; //   2

  c_p[x_a][98] = { 12,  26}; //   2
  c_f[x_a][98] = { 42}; //   1
  c_t[x_a][98] = { 57,  59}; //   2
  c_d[x_a][98] = {  1,  12}; //   2

  c_p[x_a][99] = { 12,  27}; //   2
  c_f[x_a][99] = { 44}; //   1
  c_t[x_a][99] = { 55,  60}; //   2
  c_d[x_a][99] = {  2,  12}; //   2

  c_p[x_a][100] = { 13,  28}; //   2
  c_f[x_a][100] = { 46}; //   1
  c_t[x_a][100] = { 61,  62}; //   2
  c_d[x_a][100] = {  2,  13}; //   2

  c_p[x_a][101] = { 14,  29}; //   2
  c_f[x_a][101] = { 48}; //   1
  c_t[x_a][101] = { 61,  63}; //   2
  c_d[x_a][101] = {  1,  14}; //   2

  c_p[x_a][102] = { 13,  19,  30}; //   3
  c_f[x_a][102] = {}; //   0
  c_t[x_a][102] = { 95}; //   1
  c_d[x_a][102] = {  0,  19,  13}; //   3

  c_p[x_a][103] = { 14,  20,  30}; //   3
  c_f[x_a][103] = {}; //   0
  c_t[x_a][103] = { 95}; //   1
  c_d[x_a][103] = {  0,  20,  14}; //   3

  c_p[x_a][104] = { 14,  15,  31}; //   3
  c_f[x_a][104] = {}; //   0
  c_t[x_a][104] = { 96}; //   1
  c_d[x_a][104] = {  1,  15,  14}; //   3

  c_p[x_a][105] = { 13,  16,  32}; //   3
  c_f[x_a][105] = {}; //   0
  c_t[x_a][105] = { 97}; //   1
  c_d[x_a][105] = {  2,  16,  13}; //   3

  c_p[x_a][106] = { 12,  17,  32}; //   3
  c_f[x_a][106] = {}; //   0
  c_t[x_a][106] = { 97}; //   1
  c_d[x_a][106] = {  2,  17,  12}; //   3

  c_p[x_a][107] = { 12,  18,  31}; //   3
  c_f[x_a][107] = {}; //   0
  c_t[x_a][107] = { 96}; //   1
  c_d[x_a][107] = {  1,  18,  12}; //   3

  c_p[x_a][108] = { 13,  28,  33}; //   3
  c_f[x_a][108] = {}; //   0
  c_t[x_a][108] = { 98}; //   1
  c_d[x_a][108] = {  3,   2,  13}; //   3

  c_p[x_a][109] = { 14,  29,  34}; //   3
  c_f[x_a][109] = {}; //   0
  c_t[x_a][109] = { 99}; //   1
  c_d[x_a][109] = {  4,   1,  14}; //   3

  c_p[x_a][110] = { 14,  24,  35}; //   3
  c_f[x_a][110] = {}; //   0
  c_t[x_a][110] = { 99}; //   1
  c_d[x_a][110] = {  5,   0,  14}; //   3

  c_p[x_a][111] = { 13,  25,  36}; //   3
  c_f[x_a][111] = {}; //   0
  c_t[x_a][111] = { 98}; //   1
  c_d[x_a][111] = {  6,   0,  13}; //   3

  c_p[x_a][112] = { 12,  26,  37}; //   3
  c_f[x_a][112] = {}; //   0
  c_t[x_a][112] = {100}; //   1
  c_d[x_a][112] = {  7,   1,  12}; //   3

  c_p[x_a][113] = { 12,  27,  38}; //   3
  c_f[x_a][113] = {}; //   0
  c_t[x_a][113] = {100}; //   1
  c_d[x_a][113] = {  8,   2,  12}; //   3

  c_p[x_a][114] = { 13,  28}; //   2
  c_f[x_a][114] = { 46}; //   1
  c_t[x_a][114] = {  0,  83}; //   2
  c_d[x_a][114] = {  2,  13}; //   2

  c_p[x_a][115] = { 14,  29}; //   2
  c_f[x_a][115] = { 48}; //   1
  c_t[x_a][115] = {  0,  85}; //   2
  c_d[x_a][115] = {  1,  14}; //   2

  c_p[x_a][116] = { 14,  24}; //   2
  c_f[x_a][116] = { 38}; //   1
  c_t[x_a][116] = { 23,  87}; //   2
  c_d[x_a][116] = {  0,  14}; //   2

  c_p[x_a][117] = { 13,  25}; //   2
  c_f[x_a][117] = { 40}; //   1
  c_t[x_a][117] = { 31,  89}; //   2
  c_d[x_a][117] = {  0,  13}; //   2

  c_p[x_a][118] = { 12,  26}; //   2
  c_f[x_a][118] = { 42}; //   1
  c_t[x_a][118] = { 31,  91}; //   2
  c_d[x_a][118] = {  1,  12}; //   2

  c_p[x_a][119] = { 12,  27}; //   2
  c_f[x_a][119] = { 44}; //   1
  c_t[x_a][119] = { 23,  93}; //   2
  c_d[x_a][119] = {  2,  12}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

// channel    0: 11111(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel    1: 11111(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
// channel    2: 11111(1, 2, 4, 32, 64, 8, 16;   0,   0,   0,   0)
// channel    3: 11111(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
// channel    4: 11111(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
// channel    5: 11111(1, 2, 4, 16, 32, 64, 8;   0,   0,   0,   0)
// channel    6: 11111(1, 2, 4, 32, 64, 16, 8;   0,   0,   0,   0)
// channel    7: 11111(1, 2, 32, 64, 4, 16, 8;   0,   0,   0,   0)
// channel    8: 11111(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel    9: 11111(1, 2, 16, 4, 32, 64, 8;   0,   0,   0,   0)
// channel   10: 11111(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   11: 11111(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
// channel   12: 11111(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
// channel   13: 11111(1, 2, 8, 4, 32, 64, 16;   0,   0,   0,   0)
// channel   14: 11111(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
// channel   15: 11111(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
// channel   16: 11111(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
// channel   17: 11111(1, 2, 8, 16, 32, 64, 4;   0,   0,   0,   0)
// channel   18: 11111(1, 2, 8, 32, 64, 16, 4;   0,   0,   0,   0)
// channel   19: 11111(1, 2, 32, 64, 8, 16, 4;   0,   0,   0,   0)
// channel   20: 11111(1, 2, 16, 8, 4, 32, 64;   0,   0,   0,   0)
// channel   21: 11111(1, 2, 16, 8, 32, 64, 4;   0,   0,   0,   0)
// channel   22: 11111(1, 2, 16, 32, 64, 8, 4;   0,   0,   0,   0)
// channel   23: 11111(1, 2, 32, 64, 16, 8, 4;   0,   0,   0,   0)
// channel   24: 2v111(1, 2, 4, 32, 64, 8, 16;   0,   0,   0,   0)
// channel   25: 2v111(1, 2, 4, 32, 64, 16, 8;   0,   0,   0,   0)
// channel   26: 2v111(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
// channel   27: 2v111(1, 2, 8, 32, 64, 4, 16;   0,   0,   0,   0)
// channel   28: 2v111(1, 2, 8, 32, 64, 16, 4;   0,   0,   0,   0)
// channel   29: 2v111(1, 2, 16, 32, 64, 8, 4;   0,   0,   0,   0)
// channel   30: 3yv11(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
// channel   31: 3yv11(1, 2, 4, 16, 32, 64, 8;   0,   0,   0,   0)
// channel   32: 3yv11(1, 2, 16, 4, 32, 64, 8;   0,   0,   0,   0)
// channel   33: 3yv11(1, 2, 8, 4, 32, 64, 16;   0,   0,   0,   0)
// channel   34: 3yv11(1, 2, 8, 16, 32, 64, 4;   0,   0,   0,   0)
// channel   35: 3yv11(1, 2, 16, 8, 32, 64, 4;   0,   0,   0,   0)
// channel   36: 4yyv1(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel   37: 4yyv1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
// channel   38: 4yyv1(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel   39: 4yyv1(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
// channel   40: 4yyv1(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
// channel   41: 4yyv1(1, 2, 16, 8, 4, 32, 64;   0,   0,   0,   0)
// channel   42: 12v11(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
// channel   43: 12v11(1, 2, 32, 4, 64, 8, 16;   0,   0,   0,   0)
// channel   44: 12v11(1, 2, 4, 16, 32, 64, 8;   0,   0,   0,   0)
// channel   45: 12v11(1, 2, 32, 4, 64, 16, 8;   0,   0,   0,   0)
// channel   46: 12v11(1, 2, 16, 4, 32, 64, 8;   0,   0,   0,   0)
// channel   47: 12v11(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
// channel   48: 12v11(1, 2, 8, 4, 32, 64, 16;   0,   0,   0,   0)
// channel   49: 12v11(1, 2, 32, 8, 64, 4, 16;   0,   0,   0,   0)
// channel   50: 12v11(1, 2, 8, 16, 32, 64, 4;   0,   0,   0,   0)
// channel   51: 12v11(1, 2, 32, 8, 64, 16, 4;   0,   0,   0,   0)
// channel   52: 12v11(1, 2, 16, 8, 32, 64, 4;   0,   0,   0,   0)
// channel   53: 12v11(1, 2, 32, 16, 64, 8, 4;   0,   0,   0,   0)
// channel   54: 13yv1(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel   55: 13yv1(1, 2, 32, 4, 8, 64, 16;   0,   0,   0,   0)
// channel   56: 13yv1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
// channel   57: 13yv1(1, 2, 32, 4, 16, 64, 8;   0,   0,   0,   0)
// channel   58: 13yv1(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel   59: 13yv1(1, 2, 32, 16, 4, 64, 8;   0,   0,   0,   0)
// channel   60: 13yv1(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
// channel   61: 13yv1(1, 2, 32, 8, 4, 64, 16;   0,   0,   0,   0)
// channel   62: 13yv1(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
// channel   63: 13yv1(1, 2, 32, 8, 16, 64, 4;   0,   0,   0,   0)
// channel   64: 13yv1(1, 2, 16, 8, 4, 32, 64;   0,   0,   0,   0)
// channel   65: 13yv1(1, 2, 32, 16, 8, 64, 4;   0,   0,   0,   0)
// channel   66: 14yyv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
// channel   67: 14yyv(1, 2, 32, 4, 16, 8, 64;   0,   0,   0,   0)
// channel   68: 14yyv(1, 2, 32, 16, 4, 8, 64;   0,   0,   0,   0)
// channel   69: 14yyv(1, 2, 32, 8, 4, 16, 64;   0,   0,   0,   0)
// channel   70: 14yyv(1, 2, 32, 8, 16, 4, 64;   0,   0,   0,   0)
// channel   71: 14yyv(1, 2, 32, 16, 8, 4, 64;   0,   0,   0,   0)
// channel   72: 112v1(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
// channel   73: 112v1(1, 2, 4, 32, 8, 64, 16;   0,   0,   0,   0)
// channel   74: 112v1(1, 2, 4, 16, 8, 32, 64;   0,   0,   0,   0)
// channel   75: 112v1(1, 2, 4, 32, 16, 64, 8;   0,   0,   0,   0)
// channel   76: 112v1(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
// channel   77: 112v1(1, 2, 16, 32, 4, 64, 8;   0,   0,   0,   0)
// channel   78: 112v1(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
// channel   79: 112v1(1, 2, 8, 32, 4, 64, 16;   0,   0,   0,   0)
// channel   80: 112v1(1, 2, 8, 16, 4, 32, 64;   0,   0,   0,   0)
// channel   81: 112v1(1, 2, 8, 32, 16, 64, 4;   0,   0,   0,   0)
// channel   82: 112v1(1, 2, 16, 8, 4, 32, 64;   0,   0,   0,   0)
// channel   83: 112v1(1, 2, 16, 32, 8, 64, 4;   0,   0,   0,   0)
// channel   84: 113yv(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,   0)
// channel   85: 113yv(1, 2, 4, 32, 16, 8, 64;   0,   0,   0,   0)
// channel   86: 113yv(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
// channel   87: 113yv(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
// channel   88: 113yv(1, 2, 8, 32, 16, 4, 64;   0,   0,   0,   0)
// channel   89: 113yv(1, 2, 16, 32, 8, 4, 64;   0,   0,   0,   0)
// channel   90: 1112v(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
// channel   91: 1112v(1, 2, 4, 16, 32, 8, 64;   0,   0,   0,   0)
// channel   92: 1112v(1, 2, 16, 4, 32, 8, 64;   0,   0,   0,   0)
// channel   93: 1112v(1, 2, 8, 4, 32, 16, 64;   0,   0,   0,   0)
// channel   94: 1112v(1, 2, 8, 16, 32, 4, 64;   0,   0,   0,   0)
// channel   95: 1112v(1, 2, 16, 8, 32, 4, 64;   0,   0,   0,   0)
// channel   96: 2v2v1(1, 2, 4, 32, 8, 64, 16;   0,   0,   0,   0)
// channel   97: 2v2v1(1, 2, 4, 32, 16, 64, 8;   0,   0,   0,   0)
// channel   98: 2v2v1(1, 2, 16, 32, 4, 64, 8;   0,   0,   0,   0)
// channel   99: 2v2v1(1, 2, 8, 32, 4, 64, 16;   0,   0,   0,   0)
// channel  100: 2v2v1(1, 2, 8, 32, 16, 64, 4;   0,   0,   0,   0)
// channel  101: 2v2v1(1, 2, 16, 32, 8, 64, 4;   0,   0,   0,   0)
// channel  102: 2v3yv(1, 2, 4, 32, 8, 16, 64;   0,   0,   0,   0)
// channel  103: 2v3yv(1, 2, 4, 32, 16, 8, 64;   0,   0,   0,   0)
// channel  104: 2v3yv(1, 2, 16, 32, 4, 8, 64;   0,   0,   0,   0)
// channel  105: 2v3yv(1, 2, 8, 32, 4, 16, 64;   0,   0,   0,   0)
// channel  106: 2v3yv(1, 2, 8, 32, 16, 4, 64;   0,   0,   0,   0)
// channel  107: 2v3yv(1, 2, 16, 32, 8, 4, 64;   0,   0,   0,   0)
// channel  108: 3yv2v(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
// channel  109: 3yv2v(1, 2, 4, 16, 32, 8, 64;   0,   0,   0,   0)
// channel  110: 3yv2v(1, 2, 16, 4, 32, 8, 64;   0,   0,   0,   0)
// channel  111: 3yv2v(1, 2, 8, 4, 32, 16, 64;   0,   0,   0,   0)
// channel  112: 3yv2v(1, 2, 8, 16, 32, 4, 64;   0,   0,   0,   0)
// channel  113: 3yv2v(1, 2, 16, 8, 32, 4, 64;   0,   0,   0,   0)
// channel  114: 12v2v(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
// channel  115: 12v2v(1, 2, 4, 16, 32, 8, 64;   0,   0,   0,   0)
// channel  116: 12v2v(1, 2, 16, 4, 32, 8, 64;   0,   0,   0,   0)
// channel  117: 12v2v(1, 2, 8, 4, 32, 16, 64;   0,   0,   0,   0)
// channel  118: 12v2v(1, 2, 8, 16, 32, 4, 64;   0,   0,   0,   0)
// channel  119: 12v2v(1, 2, 16, 8, 32, 4, 64;   0,   0,   0,   0)
