#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_101(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[30];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[9];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[20];
z[6] = v[2];
z[7] = iW[3];
z[8] = iW[21];
z[9] = iW[22];
z[10] = iW[15];
z[11] = v[0];
z[12] = (T(1) / T(2)) * z[9];
z[13] = z[8] + z[12];
z[14] = z[3] * z[10];
z[13] = z[13] * z[14];
z[12] = -z[10] + z[12];
z[13] = z[8] + z[12] + z[13];
z[15] = (T(277) / T(18)) * z[3];
z[13] = z[13] * z[15];
z[16] = z[6] * z[9];
z[17] = z[7] * z[11];
z[13] = T(241) / T(36) + z[13] + (T(277) / T(12)) * z[16] + z[17];
z[13] = z[1] * z[13];
z[17] = (T(1) / T(2)) * z[2];
z[18] = (T(277) / T(18)) * z[9];
z[19] = z[7] * z[8];
z[20] = z[11] * z[19];
z[13] = (T(1) / T(2)) * z[5] + (T(-277) / T(9)) * z[7] + (T(277) / T(36)) * z[8] + z[13] + -z[17] + z[18] + (T(-277) / T(12)) * z[20];
z[13] = z[1] * z[13];
z[21] = z[8] + z[9];
z[22] = z[14] * z[21];
z[23] = 1 + z[16];
z[23] = z[7] * z[23];
z[22] = z[8] + -z[9] + z[20] + z[22] + z[23];
z[23] = (T(1) / T(2)) * z[1];
z[22] = z[22] * z[23];
z[24] = z[10] * z[21];
z[25] = z[7] * z[9];
z[22] = z[19] + z[22] + (T(1) / T(2)) * z[24] + z[25];
z[22] = z[1] * z[22];
z[26] = (T(1) / T(2)) * z[4];
z[27] = -prod_pow(z[1], 2) * z[25] * z[26];
z[22] = z[22] + z[27];
z[27] = (T(277) / T(18)) * z[4];
z[22] = z[22] * z[27];
z[13] = z[13] + (T(-277) / T(18)) * z[19] + z[22];
z[13] = z[13] * z[26];
z[22] = -z[2] + (T(277) / T(18)) * z[8];
z[28] = (T(277) / T(9)) * z[10] + z[18] + -z[22];
z[14] = z[8] * z[14];
z[28] = z[5] + (T(-277) / T(36)) * z[14] + (T(1) / T(2)) * z[28];
z[29] = (T(1) / T(2)) * z[3];
z[28] = z[28] * z[29];
z[12] = z[12] + (T(1) / T(2)) * z[14];
z[12] = z[3] * z[12];
z[14] = T(259) / T(3) + 277 * z[16];
z[12] = (T(277) / T(3)) * z[12] + (T(1) / T(2)) * z[14];
z[12] = z[3] * z[12];
z[12] = z[6] + (T(1) / T(2)) * z[11] + (T(1) / T(6)) * z[12];
z[12] = z[12] * z[23];
z[14] = (T(-1) / T(4)) * z[2] + -z[7];
z[14] = z[11] * z[14];
z[23] = (T(-1) / T(4)) * z[5] + z[7];
z[23] = z[6] * z[23];
z[12] = T(-253) / T(24) + z[12] + z[14] + z[23] + z[28];
z[12] = z[1] * z[12];
z[14] = z[6] * z[19];
z[19] = z[5] + (T(277) / T(9)) * z[14];
z[23] = (T(277) / T(18)) * z[7];
z[28] = -z[2] + -z[19] + (T(277) / T(9)) * z[20] + z[23];
z[12] = z[12] + z[13] + (T(1) / T(4)) * z[28];
z[12] = z[4] * z[12];
z[13] = (T(-313) / T(9)) * z[7] + -z[19] + (T(277) / T(18)) * z[20] + z[22];
z[13] = z[6] * z[13];
z[15] = z[15] * z[16];
z[15] = z[6] + z[15];
z[15] = z[1] * z[15];
z[16] = z[5] * z[6];
z[18] = z[5] + z[18];
z[18] = z[3] * z[18];
z[15] = T(-259) / T(18) + z[15] + -z[16] + z[18];
z[15] = z[3] * z[15];
z[15] = 3 * z[6] + z[11] + z[15];
z[15] = z[1] * z[15];
z[18] = (T(313) / T(18)) * z[7];
z[19] = z[18] + -z[22];
z[19] = z[11] * z[19];
z[20] = -z[2] * z[3];
z[13] = T(-66053) / T(324) + z[13] + z[15] + z[19] + z[20];
z[15] = z[24] + z[25];
z[15] = z[15] * z[27];
z[19] = -z[7] + -z[21];
z[20] = z[2] + -z[5];
z[20] = z[3] * z[20];
z[20] = T(-277) / T(9) + z[20];
z[20] = z[1] * z[20];
z[15] = z[15] + (T(277) / T(18)) * z[19] + z[20];
z[15] = z[15] * z[26];
z[19] = -z[5] + -z[22] + -z[23];
z[19] = z[6] * z[19];
z[17] = z[5] + z[17];
z[17] = z[3] * z[17];
z[20] = z[3] * z[5];
z[21] = T(-259) / T(36) + -z[20];
z[21] = z[3] * z[21];
z[21] = (T(295) / T(18)) * z[6] + z[21];
z[21] = z[1] * z[21];
z[15] = z[15] + z[17] + (T(1) / T(2)) * z[19] + z[21];
z[15] = z[4] * z[15];
z[14] = z[5] + (T(277) / T(18)) * z[14] + z[18];
z[14] = z[6] * z[14];
z[14] = T(-277) / T(18) + z[14];
z[14] = z[6] * z[14];
z[16] = -z[16] + z[20];
z[16] = z[3] * z[16];
z[14] = z[14] + z[16];
z[16] = 1 + -z[20];
z[16] = z[3] * z[16];
z[16] = (T(259) / T(18)) * z[6] + z[16];
z[16] = z[16] * z[29];
z[17] = prod_pow(z[6], 2);
z[16] = z[16] + -z[17];
z[16] = z[1] * z[16];
z[14] = (T(1) / T(2)) * z[14] + z[15] + z[16];
z[14] = z[0] * z[14];
z[12] = z[12] + (T(1) / T(4)) * z[13] + (T(1) / T(2)) * z[14];
return (T(1) / T(2)) * z[12];
}



template double eval_coef_2q3y_2l_pmmpp_12345_101(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_101(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
