#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_106(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[32];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[3];
z[6] = iW[22];
z[7] = iW[15];
z[8] = v[0];
z[9] = iW[4];
z[10] = iW[23];
z[11] = iW[24];
z[12] = v[1];
z[13] = (T(1) / T(6)) * z[10];
z[14] = -7 * z[7] + (T(277) / T(3)) * z[9];
z[13] = z[13] * z[14];
z[15] = z[6] * z[7];
z[16] = z[13] + z[15];
z[17] = z[3] * z[16];
z[18] = -z[0] + z[6];
z[17] = (T(19) / T(6)) * z[7] + z[17] + -z[18];
z[17] = z[1] * z[17];
z[19] = z[10] * z[14];
z[20] = (T(1) / T(3)) * z[19];
z[17] = 3 * z[15] + z[17] + -z[20];
z[17] = z[3] * z[17];
z[21] = (T(19) / T(6)) * z[0];
z[17] = -z[6] + (T(-7) / T(6)) * z[7] + z[17] + -z[21];
z[17] = z[1] * z[17];
z[22] = z[0] * z[7];
z[21] = -z[6] + z[21];
z[23] = z[5] * z[21];
z[17] = z[17] + z[22] + z[23];
z[23] = z[3] * z[15];
z[24] = z[1] * z[23];
z[24] = z[15] + z[24];
z[24] = z[1] * z[24];
z[15] = z[0] * z[15];
z[25] = z[0] * z[6];
z[26] = z[5] * z[25];
z[15] = z[15] + z[24] + z[26];
z[24] = (T(1) / T(2)) * z[2];
z[15] = z[15] * z[24];
z[26] = (T(1) / T(12)) * z[10];
z[14] = z[14] * z[26];
z[23] = z[0] * z[23];
z[26] = (T(3) / T(2)) * z[23];
z[15] = z[14] + z[15] + (T(1) / T(2)) * z[17] + z[25] + z[26];
z[15] = z[15] * z[24];
z[17] = -z[20] + z[22] + (T(1) / T(2)) * z[25] + z[26];
z[20] = (T(1) / T(2)) * z[3];
z[17] = z[17] * z[20];
z[24] = -z[0] + z[11];
z[25] = (T(277) / T(9)) * z[9];
z[26] = -z[24] + z[25];
z[26] = -z[6] + (T(35) / T(6)) * z[7] + (T(1) / T(2)) * z[26];
z[16] = z[16] * z[20];
z[20] = (T(32) / T(3)) * z[10];
z[16] = z[16] + z[20] + (T(1) / T(2)) * z[26];
z[16] = z[3] * z[16];
z[26] = z[4] * z[10];
z[26] = (T(64) / T(9)) * z[26];
z[18] = z[4] * z[18];
z[18] = T(277) / T(18) + z[18];
z[18] = (T(1) / T(2)) * z[18] + z[26];
z[18] = z[3] * z[18];
z[27] = z[4] * z[6];
z[28] = T(4) / T(3) + (T(3) / T(4)) * z[27];
z[28] = z[4] * z[28];
z[29] = prod_pow(z[4], 3);
z[30] = z[5] * z[6] * z[29];
z[18] = z[18] + z[28] + (T(1) / T(4)) * z[30];
z[18] = z[1] * z[18];
z[28] = (T(1) / T(4)) * z[4];
z[30] = (T(19) / T(3)) * z[0] + -z[6] + -z[11];
z[28] = z[28] * z[30];
z[30] = (T(13) / T(12)) * z[5] + (T(19) / T(12)) * z[7];
z[30] = z[4] * z[30];
z[16] = T(4) / T(3) + z[16] + z[18] + z[28] + z[30];
z[16] = z[1] * z[16];
z[18] = T(-13) / T(3) + -z[27];
z[18] = z[5] * z[18];
z[18] = -z[6] + z[18] + -z[25];
z[25] = z[0] * z[4];
z[28] = T(-13) / T(3) + (T(1) / T(2)) * z[25];
z[28] = z[7] * z[28];
z[18] = (T(1) / T(2)) * z[18] + z[28];
z[28] = z[12] * z[14];
z[15] = z[15] + z[16] + z[17] + (T(1) / T(2)) * z[18] + -z[20] + z[28];
z[15] = z[2] * z[15];
z[16] = -1 + z[27];
z[16] = z[4] * z[16];
z[16] = (T(-13) / T(6)) * z[8] + z[16];
z[16] = z[5] * z[16];
z[17] = prod_pow(z[4], 2);
z[18] = -z[16] * z[17];
z[27] = T(217) / T(18) + -z[27];
z[27] = z[4] * z[27];
z[27] = (T(277) / T(18)) * z[8] + z[27];
z[27] = z[4] * z[27];
z[18] = z[18] + z[27];
z[27] = (T(32) / T(9)) * z[10];
z[28] = z[27] * z[29];
z[29] = (T(1) / T(4)) * z[3];
z[30] = z[4] * z[29];
z[31] = T(-277) / T(18) + z[25];
z[31] = z[30] * z[31];
z[18] = (T(1) / T(4)) * z[18] + z[28] + z[31];
z[18] = z[1] * z[18];
z[21] = z[11] + -z[21];
z[21] = z[4] * z[21];
z[21] = T(7) / T(6) + z[21];
z[21] = z[16] + (T(1) / T(2)) * z[21];
z[21] = z[4] * z[21];
z[17] = -z[17] * z[27];
z[24] = z[24] * z[30];
z[17] = z[17] + z[18] + (T(1) / T(2)) * z[21] + z[24];
z[17] = z[1] * z[17];
z[14] = -z[3] * z[14];
z[18] = (T(277) / T(18)) * z[9];
z[21] = (T(-13) / T(2)) * z[7] + -z[11] + -z[18];
z[19] = z[12] * z[19];
z[14] = z[14] + (T(1) / T(24)) * z[19] + -z[20] + (T(1) / T(4)) * z[21];
z[14] = z[12] * z[14];
z[19] = z[8] * z[9];
z[19] = 665 + 277 * z[19];
z[21] = 17 + (T(19) / T(3)) * z[25];
z[21] = z[4] * z[7] * z[21];
z[16] = -z[16] + (T(1) / T(18)) * z[19] + (T(1) / T(2)) * z[21];
z[13] = z[13] + z[22] + z[23];
z[13] = z[13] * z[29];
z[19] = T(15) / T(2) + z[25];
z[19] = z[7] * z[19];
z[18] = z[18] + z[19];
z[13] = z[13] + (T(1) / T(4)) * z[18] + z[20];
z[13] = z[3] * z[13];
return z[13] + z[14] + z[15] + (T(1) / T(4)) * z[16] + z[17] + z[26];
}



template double eval_coef_2q3y_2l_pmmpp_12345_106(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_106(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
