#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_109(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[31];
z[0] = iW[1];
z[1] = v[0];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[3];
z[5] = iW[21];
z[6] = iW[15];
z[7] = v[3];
z[8] = iW[18];
z[9] = v[1];
z[10] = z[5] * z[8];
z[11] = prod_pow(z[5], 2);
z[10] = z[10] + z[11];
z[12] = z[3] * z[10];
z[13] = z[2] * z[5];
z[14] = 1 + z[13];
z[15] = z[2] * z[14];
z[16] = (T(19) / T(6)) * z[3];
z[17] = -z[15] + -z[16];
z[17] = z[4] * z[17];
z[18] = z[2] * z[11];
z[19] = z[5] + z[18];
z[20] = -z[2] * z[19];
z[17] = T(13) / T(12) + z[17] + z[20];
z[17] = z[4] * z[17];
z[17] = z[12] + z[17] + z[19];
z[19] = (T(1) / T(2)) * z[1];
z[17] = z[17] * z[19];
z[20] = (T(3) / T(2)) * z[5] + z[18];
z[21] = (T(1) / T(2)) * z[2];
z[22] = -z[20] * z[21];
z[23] = (T(1) / T(2)) * z[3];
z[24] = z[10] * z[23];
z[24] = (T(-7) / T(4)) * z[5] + z[8] + -z[18] + z[24];
z[24] = z[3] * z[24];
z[25] = prod_pow(z[2], 2);
z[14] = z[14] * z[25];
z[26] = z[2] * z[16];
z[14] = z[14] + z[26];
z[14] = z[4] * z[14];
z[26] = z[2] * z[20];
z[27] = T(-13) / T(6) + z[26];
z[27] = z[2] * z[27];
z[14] = (T(11) / T(3)) * z[3] + z[14] + z[27];
z[14] = z[4] * z[14];
z[14] = (T(1) / T(2)) * z[14] + z[17] + z[22] + z[24];
z[14] = z[1] * z[14];
z[11] = z[11] * z[21];
z[11] = z[5] + z[11];
z[11] = z[2] * z[11];
z[17] = z[8] * z[21];
z[17] = z[11] + -z[17];
z[22] = T(1) / T(4) + z[17];
z[22] = z[3] * z[22];
z[24] = T(25) / T(6) + z[13];
z[24] = z[24] * z[25];
z[27] = z[2] * z[3];
z[24] = z[24] + -z[27];
z[27] = (T(1) / T(4)) * z[4];
z[24] = z[24] * z[27];
z[28] = z[7] + -z[15];
z[14] = z[14] + z[22] + z[24] + (T(1) / T(4)) * z[28];
z[14] = z[1] * z[14];
z[22] = prod_pow(z[7], 2);
z[24] = (T(7) / T(2)) * z[5] + z[18];
z[24] = z[2] * z[24];
z[24] = T(5) / T(2) + z[24];
z[24] = z[2] * z[24];
z[24] = z[7] + z[24];
z[24] = z[2] * z[24];
z[24] = -z[22] + z[24];
z[28] = z[3] * z[17];
z[29] = (T(-11) / T(4)) * z[5] + -z[18];
z[29] = z[2] * z[29];
z[29] = T(-1) / T(2) + z[29];
z[29] = z[2] * z[29];
z[28] = (T(-25) / T(24)) * z[7] + z[28] + z[29];
z[28] = z[3] * z[28];
z[24] = (T(1) / T(2)) * z[24] + z[28];
z[24] = z[3] * z[24];
z[28] = T(1) / T(2) + z[13];
z[28] = z[25] * z[28];
z[29] = z[5] * z[25];
z[30] = -z[23] * z[29];
z[28] = z[28] + z[30];
z[28] = z[3] * z[28];
z[15] = -z[7] + -z[15];
z[15] = z[2] * z[15];
z[15] = z[15] + (T(-19) / T(6)) * z[22];
z[15] = z[15] * z[21];
z[15] = z[15] + z[28];
z[15] = z[3] * z[15];
z[28] = prod_pow(z[7], 3);
z[30] = -z[21] * z[28];
z[15] = z[15] + z[30];
z[15] = z[6] * z[15];
z[15] = (T(1) / T(2)) * z[15] + z[24] + (T(1) / T(4)) * z[28];
z[15] = z[6] * z[15];
z[24] = z[2] + -z[3];
z[24] = z[19] * z[24];
z[23] = z[2] + -z[23];
z[23] = z[3] * z[23];
z[23] = z[23] + z[24] + (T(-1) / T(2)) * z[25];
z[23] = z[0] * z[19] * z[23];
z[24] = z[2] * z[7];
z[28] = z[22] + z[24];
z[17] = T(-25) / T(24) + -z[17];
z[17] = z[3] * z[17];
z[30] = 3 * z[5] + z[18];
z[30] = z[2] * z[30];
z[30] = T(31) / T(12) + z[30];
z[30] = z[2] * z[30];
z[30] = -z[7] + z[30];
z[17] = z[17] + (T(1) / T(2)) * z[30];
z[17] = z[3] * z[17];
z[14] = z[14] + z[15] + z[17] + z[23] + (T(1) / T(4)) * z[28];
z[14] = z[0] * z[14];
z[15] = T(23) / T(8) + z[11];
z[15] = z[3] * z[15];
z[17] = -z[2] + -z[7];
z[14] = z[14] + z[15] + (T(1) / T(4)) * z[17];
z[12] = -z[8] + -z[12] + 3 * z[20];
z[15] = T(-11) / T(3) + -z[13];
z[15] = z[2] * z[15];
z[15] = (T(-19) / T(12)) * z[3] + z[15];
z[15] = z[4] * z[15];
z[15] = T(-19) / T(6) + z[15] + -z[26];
z[15] = z[4] * z[15];
z[17] = prod_pow(z[4], 2);
z[10] = -z[10] + (T(19) / T(6)) * z[17];
z[10] = z[10] * z[19];
z[10] = z[10] + (T(1) / T(2)) * z[12] + z[15];
z[10] = z[10] * z[19];
z[12] = T(19) / T(6) + z[13];
z[13] = z[12] * z[25] * z[27];
z[15] = (T(1) / T(8)) * z[3];
z[18] = (T(5) / T(2)) * z[5] + z[18];
z[18] = z[2] * z[18];
z[19] = T(4) / T(3) + (T(1) / T(4)) * z[18];
z[19] = z[2] * z[19];
z[13] = z[13] + z[15] + z[19];
z[13] = z[4] * z[13];
z[19] = -1 + -z[11];
z[10] = z[10] + z[13] + (T(1) / T(2)) * z[19];
z[10] = z[1] * z[10];
z[13] = (T(-19) / T(6)) * z[7] + z[29];
z[13] = z[13] * z[15];
z[15] = (T(2) / T(3)) * z[7] + (T(-1) / T(8)) * z[29];
z[15] = z[2] * z[15];
z[13] = z[13] + z[15] + (T(-19) / T(48)) * z[22];
z[13] = z[3] * z[13];
z[15] = z[2] * z[22];
z[13] = z[13] + (T(3) / T(8)) * z[15];
z[13] = z[6] * z[13];
z[15] = T(1) / T(4) + -z[11];
z[15] = z[3] * z[15];
z[18] = T(1) / T(2) + z[18];
z[18] = z[2] * z[18];
z[18] = (T(31) / T(6)) * z[7] + z[18];
z[15] = z[15] + (T(1) / T(2)) * z[18];
z[15] = z[3] * z[15];
z[15] = z[15] + (T(-1) / T(2)) * z[22];
z[13] = z[13] + (T(1) / T(2)) * z[15];
z[13] = z[6] * z[13];
z[10] = z[10] + z[13] + (T(1) / T(2)) * z[14];
z[10] = z[0] * z[10];
z[12] = -z[4] * z[12] * z[21];
z[11] = T(-17) / T(8) + -z[11] + z[12];
z[11] = z[4] * z[11];
z[12] = z[1] * z[17];
z[11] = z[11] + (T(19) / T(12)) * z[12];
z[11] = z[1] * z[11];
z[12] = (T(-13) / T(2)) * z[2] + (T(19) / T(2)) * z[3] + 19 * z[7];
z[12] = z[3] * z[12];
z[12] = (T(1) / T(3)) * z[12] + -3 * z[24];
z[12] = z[6] * z[12];
z[12] = (T(-25) / T(3)) * z[3] + z[7] + z[12];
z[12] = z[6] * z[12];
z[13] = z[2] + -z[16];
z[13] = prod_pow(z[6], 2) * z[9] * z[13];
z[12] = z[12] + z[13];
z[11] = z[11] + (T(1) / T(4)) * z[12];
return z[10] + (T(1) / T(2)) * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_109(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_109(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
