#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_118(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[28];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[16];
z[3] = v[2];
z[4] = v[3];
z[5] = v[4];
z[6] = iW[3];
z[7] = v[1];
z[8] = iW[2];
z[9] = iW[5];
z[10] = v[0];
z[11] = iW[15];
z[12] = (T(1) / T(2)) * z[8];
z[13] = -z[6] + z[12];
z[14] = prod_pow(z[6], 2);
z[15] = z[3] * z[14];
z[16] = 3 * z[13] + 5 * z[15];
z[16] = (T(1) / T(2)) * z[16];
z[17] = (T(16) / T(3)) * z[6] + -z[8];
z[18] = z[5] * z[6];
z[17] = z[17] * z[18];
z[19] = z[16] + -z[17];
z[19] = z[5] * z[19];
z[20] = z[3] * z[6];
z[21] = 1 + z[20];
z[19] = z[19] + -z[21];
z[19] = z[5] * z[19];
z[22] = (T(5) / T(3)) * z[15];
z[13] = z[13] + z[22];
z[13] = (T(1) / T(2)) * z[13];
z[23] = (T(1) / T(4)) * z[8];
z[24] = (T(4) / T(3)) * z[6] + -z[23];
z[25] = z[18] * z[24];
z[25] = -z[13] + z[25];
z[25] = z[5] * z[25];
z[21] = (T(1) / T(2)) * z[21];
z[25] = z[21] + z[25];
z[25] = prod_pow(z[5], 2) * z[1] * z[25];
z[19] = z[19] + z[25];
z[19] = z[1] * z[19];
z[25] = (T(3) / T(2)) * z[8];
z[26] = 8 * z[6];
z[27] = -z[25] + z[26];
z[18] = z[18] * z[27];
z[16] = -z[16] + z[18];
z[16] = z[5] * z[16];
z[18] = z[6] * z[7] * z[24];
z[13] = z[13] + -z[17] + z[18];
z[13] = z[7] * z[13];
z[13] = z[13] + z[16] + z[19] + z[21];
z[13] = z[10] * z[13];
z[16] = (T(-3) / T(4)) * z[8] + (T(29) / T(12)) * z[15] + z[26];
z[16] = z[5] * z[16];
z[12] = -z[4] * z[12];
z[17] = -41 * z[6] + (T(-17) / T(2)) * z[15];
z[17] = z[3] * z[17];
z[12] = 2 + z[12] + z[16] + (T(1) / T(6)) * z[17];
z[12] = z[5] * z[12];
z[16] = (T(1) / T(2)) * z[5];
z[17] = (T(-35) / T(3)) * z[6] + z[8];
z[17] = z[16] * z[17];
z[18] = z[4] * z[8];
z[19] = -5 + z[18];
z[17] = z[17] + (T(1) / T(2)) * z[19] + (T(29) / T(3)) * z[20];
z[17] = z[16] * z[17];
z[19] = (T(1) / T(4)) * z[3];
z[21] = 1 + (T(-23) / T(3)) * z[20];
z[21] = z[19] * z[21];
z[17] = -z[4] + z[17] + z[21];
z[17] = z[5] * z[17];
z[21] = z[3] + z[4];
z[24] = z[3] * z[21];
z[17] = z[17] + (T(3) / T(4)) * z[24];
z[17] = z[1] * z[17];
z[24] = 7 + (T(25) / T(3)) * z[20];
z[24] = z[3] * z[24];
z[24] = 5 * z[4] + z[24];
z[12] = z[12] + z[17] + (T(1) / T(4)) * z[24];
z[12] = z[5] * z[12];
z[17] = z[19] * z[21];
z[12] = z[12] + z[17];
z[12] = z[1] * z[12];
z[17] = -13 * z[6] + (T(-29) / T(2)) * z[15] + z[25];
z[17] = z[5] * z[17];
z[18] = -1 + z[18];
z[19] = -5 * z[6] + 17 * z[15];
z[19] = z[3] * z[19];
z[17] = z[17] + (T(1) / T(2)) * z[18] + (T(1) / T(3)) * z[19];
z[17] = z[16] * z[17];
z[18] = (T(1) / T(2)) * z[3];
z[14] = z[14] * z[18];
z[19] = z[6] + -z[14];
z[19] = z[3] * z[19];
z[19] = -1 + (T(17) / T(3)) * z[19];
z[21] = (T(2) / T(3)) * z[6] + (T(29) / T(4)) * z[15] + -z[23];
z[21] = z[5] * z[21];
z[23] = 3 * z[6] + (T(-29) / T(3)) * z[15];
z[23] = z[7] * z[23];
z[19] = (T(1) / T(2)) * z[19] + z[21] + (T(1) / T(4)) * z[23];
z[19] = z[7] * z[19];
z[21] = (T(1) / T(4)) * z[4];
z[23] = -2 + (T(-1) / T(6)) * z[20];
z[23] = z[3] * z[23];
z[12] = z[12] + z[13] + z[17] + z[19] + -z[21] + z[23];
z[12] = z[2] * z[10] * z[12];
z[13] = T(11) / T(3) + (T(1) / T(2)) * z[20];
z[13] = z[5] * z[13];
z[13] = (T(19) / T(6)) * z[4] + z[13];
z[13] = z[13] * z[16];
z[17] = prod_pow(z[3], 2);
z[19] = prod_pow(z[4], 2);
z[23] = (T(-13) / T(6)) * z[17] + -z[19];
z[24] = (T(1) / T(2)) * z[4];
z[25] = (T(8) / T(3)) * z[3] + (T(-19) / T(12)) * z[5] + -z[24];
z[25] = z[5] * z[25];
z[23] = (T(1) / T(2)) * z[23] + z[25];
z[23] = z[1] * z[5] * z[23];
z[13] = z[13] + z[23];
z[13] = z[1] * z[13];
z[23] = z[4] + z[5];
z[25] = z[7] + -z[23];
z[12] = z[12] + z[13] + (T(19) / T(12)) * z[25];
z[12] = z[9] * z[12];
z[13] = (T(-89) / T(9)) * z[6] + z[15];
z[13] = z[13] * z[18];
z[13] = T(49) / T(9) + z[13];
z[13] = z[13] * z[18];
z[14] = (T(49) / T(9)) * z[6] + -z[14];
z[14] = z[14] * z[18];
z[14] = T(-20) / T(9) + z[14];
z[14] = z[5] * z[14];
z[25] = (T(-20) / T(9)) * z[6] + (T(1) / T(4)) * z[15];
z[25] = z[3] * z[7] * z[25];
z[13] = z[13] + z[14] + z[25];
z[13] = z[7] * z[13];
z[14] = z[3] + -z[4];
z[14] = z[14] * z[17];
z[17] = 3 * z[3] + -z[23];
z[17] = z[16] * z[17];
z[23] = (T(-3) / T(2)) * z[3] + z[4];
z[23] = z[3] * z[23];
z[17] = z[17] + z[23];
z[17] = z[5] * z[17];
z[14] = (T(1) / T(2)) * z[14] + z[17];
z[17] = (T(1) / T(2)) * z[1];
z[14] = z[14] * z[17];
z[23] = T(-89) / T(18) + z[20];
z[25] = -z[3] * z[23];
z[25] = -z[4] + z[25];
z[25] = z[18] * z[25];
z[26] = z[3] + -z[16];
z[23] = z[23] * z[26];
z[23] = z[23] + z[24];
z[23] = z[5] * z[23];
z[13] = z[13] + z[14] + z[23] + z[25];
z[13] = z[0] * z[13];
z[14] = (T(5) / T(2)) * z[6] + z[15];
z[14] = z[14] * z[18];
z[14] = 1 + z[14];
z[14] = z[3] * z[14];
z[13] = z[13] + z[14] + z[21];
z[13] = z[2] * z[13];
z[14] = z[4] * z[11];
z[20] = T(-1) / T(3) + -z[14] + -z[20];
z[16] = z[16] * z[20];
z[19] = z[11] * z[19];
z[20] = z[4] + -z[19];
z[20] = z[1] * z[18] * z[20];
z[14] = T(-3) / T(2) + z[14];
z[14] = z[3] * z[14];
z[14] = z[4] + z[14] + z[16] + (T(-1) / T(2)) * z[19] + z[20];
z[14] = z[14] * z[17];
z[16] = (T(-13) / T(3)) * z[6] + -z[11];
z[16] = -z[15] + (T(1) / T(2)) * z[16];
z[16] = z[16] * z[18];
z[17] = (T(23) / T(9)) * z[6] + -z[11];
z[17] = (T(1) / T(2)) * z[17] + z[22];
z[17] = z[7] * z[17];
z[18] = z[11] * z[24];
z[15] = (T(-8) / T(9)) * z[6] + (T(1) / T(4)) * z[11] + (T(-5) / T(6)) * z[15];
z[15] = z[5] * z[15];
return T(1) / T(3) + z[12] + z[13] + z[14] + z[15] + z[16] + (T(1) / T(2)) * z[17] + z[18];
}



template double eval_coef_2q3y_2l_pmmpp_12345_118(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_118(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
