#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_122(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[32];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[5];
z[3] = iW[18];
z[4] = v[1];
z[5] = v[2];
z[6] = v[4];
z[7] = v[3];
z[8] = iW[1];
z[9] = iW[2];
z[10] = v[0];
z[11] = (T(1) / T(2)) * z[6];
z[12] = prod_pow(z[8], 2);
z[13] = z[11] * z[12];
z[14] = 2 * z[8];
z[15] = z[13] + -z[14];
z[15] = z[6] * z[15];
z[16] = 3 + z[15];
z[16] = z[6] * z[16];
z[16] = -2 * z[4] + z[16];
z[16] = z[6] * z[16];
z[17] = prod_pow(z[4], 2);
z[18] = (T(1) / T(2)) * z[17];
z[16] = z[16] + z[18];
z[19] = z[1] * z[16];
z[12] = z[6] * z[12];
z[20] = 3 * z[8];
z[21] = z[12] + -z[20];
z[21] = z[6] * z[21];
z[21] = 3 + z[21];
z[21] = z[6] * z[21];
z[21] = -z[4] + z[21];
z[16] = z[9] * z[16];
z[16] = z[16] + z[19] + (T(5) / T(4)) * z[21];
z[16] = z[9] * z[16];
z[19] = z[19] + z[21];
z[19] = z[1] * z[19];
z[22] = prod_pow(z[9], 2) * z[7] * z[21];
z[16] = z[16] + z[19] + (T(3) / T(4)) * z[22];
z[16] = z[10] * z[16];
z[19] = z[6] * z[9];
z[21] = z[19] * z[21];
z[22] = -z[8] + z[13];
z[22] = z[6] * z[22];
z[22] = T(1) / T(2) + z[22];
z[19] = -z[19] * z[22];
z[23] = (T(1) / T(2)) * z[8] + -z[12];
z[23] = z[6] * z[23];
z[24] = T(1) / T(2) + z[23];
z[19] = z[19] + (T(-1) / T(2)) * z[24];
z[19] = z[7] * z[19];
z[25] = 3 * z[12];
z[26] = 11 * z[8] + -z[25];
z[26] = z[6] * z[26];
z[26] = -13 + z[26];
z[26] = z[6] * z[26];
z[26] = 5 * z[4] + z[26];
z[19] = 3 * z[19] + -z[21] + (T(1) / T(2)) * z[26];
z[19] = z[9] * z[19];
z[19] = z[19] + (T(-5) / T(2)) * z[24];
z[19] = z[7] * z[19];
z[24] = 5 * z[8] + -z[12];
z[24] = z[6] * z[24];
z[24] = -9 + z[24];
z[24] = z[6] * z[24];
z[24] = 7 * z[4] + z[24];
z[24] = z[6] * z[24];
z[24] = -2 * z[17] + z[24];
z[24] = z[1] * z[24];
z[26] = (T(11) / T(2)) * z[4];
z[27] = (T(9) / T(2)) * z[8] + -z[12];
z[27] = z[6] * z[27];
z[27] = T(-15) / T(2) + z[27];
z[27] = z[6] * z[27];
z[27] = z[26] + z[27];
z[27] = z[6] * z[27];
z[28] = (T(3) / T(2)) * z[17];
z[27] = z[27] + -z[28];
z[27] = z[9] * z[27];
z[29] = 4 * z[4];
z[30] = 6 * z[8] + -z[12];
z[30] = z[6] * z[30];
z[30] = -9 + z[30];
z[30] = z[6] * z[30];
z[16] = z[16] + z[19] + z[24] + z[27] + z[29] + z[30];
z[16] = z[10] * z[16];
z[19] = z[0] * z[4];
z[24] = z[0] + z[8];
z[24] = z[6] * z[24];
z[24] = 5 + z[19] + z[24];
z[24] = z[11] * z[24];
z[27] = -z[4] + z[11];
z[27] = z[6] * z[27];
z[18] = z[18] + z[27];
z[18] = z[1] * z[18];
z[27] = -3 + -z[19];
z[27] = z[4] * z[27];
z[18] = 3 * z[18] + z[24] + z[27];
z[18] = z[1] * z[18];
z[24] = -z[0] * z[17];
z[27] = z[6] * z[19];
z[24] = z[24] + z[27];
z[27] = (T(1) / T(2)) * z[1];
z[24] = z[24] * z[27];
z[30] = -z[0] * z[11];
z[24] = z[19] + z[24] + z[30];
z[24] = z[1] * z[24];
z[24] = (T(-1) / T(2)) * z[0] + z[24];
z[24] = z[5] * z[24];
z[30] = z[7] + z[11];
z[31] = -z[0] + z[12];
z[30] = z[30] * z[31];
z[18] = T(3) / T(2) + z[18] + 2 * z[19] + z[24] + z[30];
z[18] = z[5] * z[18];
z[20] = z[0] + z[20] + -z[25];
z[11] = z[11] * z[20];
z[20] = -z[0] + (T(5) / T(2)) * z[12];
z[20] = z[7] * z[20];
z[11] = T(9) / T(4) + z[11] + z[19] + (T(1) / T(2)) * z[20];
z[11] = z[7] * z[11];
z[20] = 3 * z[4];
z[24] = z[6] * z[8];
z[25] = -3 + z[24];
z[25] = z[6] * z[25];
z[25] = z[20] + z[25];
z[25] = z[6] * z[25];
z[25] = -z[17] + z[25];
z[25] = z[1] * z[25];
z[30] = z[8] + z[12];
z[30] = z[6] * z[30];
z[30] = -5 + z[30];
z[30] = z[6] * z[30];
z[20] = z[20] + (T(3) / T(2)) * z[25] + z[30];
z[20] = z[1] * z[20];
z[25] = 2 * z[12];
z[30] = -z[8] + z[25];
z[30] = z[6] * z[30];
z[20] = -1 + z[20] + z[30];
z[20] = z[10] * z[20];
z[14] = z[14] + -z[31];
z[14] = z[6] * z[14];
z[30] = T(15) / T(2) + -z[19];
z[14] = z[14] + (T(1) / T(2)) * z[30];
z[14] = z[6] * z[14];
z[24] = 7 + -z[24];
z[24] = z[6] * z[24];
z[24] = -11 * z[4] + z[24];
z[24] = z[6] * z[24];
z[17] = 5 * z[17] + z[24];
z[17] = z[17] * z[27];
z[24] = T(-19) / T(2) + -z[19];
z[24] = z[4] * z[24];
z[11] = z[11] + z[14] + z[17] + z[18] + z[20] + (T(1) / T(2)) * z[24];
z[11] = z[5] * z[11];
z[12] = -z[8] + z[12];
z[14] = prod_pow(z[6], 2);
z[17] = z[12] * z[14];
z[14] = z[9] * z[14];
z[18] = z[14] * z[22];
z[17] = (T(1) / T(4)) * z[17] + z[18];
z[17] = z[9] * z[17];
z[12] = z[12] * z[14];
z[12] = (T(1) / T(2)) * z[12] + z[23];
z[12] = z[9] * z[12];
z[12] = z[12] + z[13];
z[12] = z[7] * z[12];
z[13] = z[0] + (T(5) / T(2)) * z[8];
z[13] = (T(1) / T(2)) * z[13] + -z[25];
z[13] = z[6] * z[13];
z[12] = T(5) / T(4) + (T(3) / T(2)) * z[12] + z[13] + z[17];
z[12] = z[7] * z[12];
z[13] = z[0] * z[6];
z[13] = T(11) / T(2) + z[13] + -z[19];
z[13] = z[6] * z[13];
z[13] = z[13] + z[21] + -z[26];
z[12] = z[12] + (T(1) / T(2)) * z[13];
z[12] = z[7] * z[12];
z[13] = 4 + z[15];
z[13] = z[6] * z[13];
z[13] = z[13] + -z[29];
z[13] = z[6] * z[13];
z[11] = z[11] + z[12] + z[13] + z[16] + z[28];
return z[2] * z[3] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_122(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_122(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
