#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_123(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[33];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[5];
z[3] = v[0];
z[4] = v[4];
z[5] = iW[17];
z[6] = v[2];
z[7] = iW[21];
z[8] = iW[7];
z[9] = iW[15];
z[10] = v[3];
z[11] = iW[18];
z[12] = v[1];
z[13] = prod_pow(z[5], 2);
z[14] = z[6] * z[13];
z[15] = (T(1) / T(2)) * z[5] + -z[14];
z[16] = (T(1) / T(2)) * z[4];
z[17] = z[15] * z[16];
z[18] = z[6] * z[11];
z[19] = 1 + 3 * z[18];
z[20] = z[6] * z[7];
z[21] = (T(1) / T(4)) * z[20];
z[22] = z[6] * z[8];
z[23] = (T(1) / T(4)) * z[13];
z[24] = -z[4] * z[10] * z[23];
z[17] = z[17] + (T(-1) / T(2)) * z[19] + z[21] + 2 * z[22] + z[24];
z[17] = z[10] * z[17];
z[24] = prod_pow(z[6], 2);
z[23] = -z[23] * z[24];
z[25] = z[5] * z[6];
z[26] = -1 + z[25];
z[27] = z[1] * z[6];
z[28] = z[26] * z[27];
z[29] = z[4] * z[8];
z[23] = -1 + -z[22] + z[23] + (T(-1) / T(4)) * z[28] + z[29];
z[23] = z[4] * z[23];
z[28] = -z[5] + (T(1) / T(2)) * z[14];
z[16] = z[16] * z[28];
z[28] = z[21] + z[22];
z[30] = T(1) / T(4) + -z[16] + (T(3) / T(4)) * z[18] + -z[25] + -z[28];
z[30] = z[10] * z[30];
z[15] = z[6] * z[15];
z[15] = T(-1) / T(2) + z[15];
z[15] = (T(1) / T(2)) * z[15] + -z[16] + z[22];
z[15] = z[4] * z[15];
z[16] = z[7] * z[24];
z[31] = (T(1) / T(4)) * z[16];
z[25] = T(1) / T(4) + -2 * z[25];
z[25] = z[6] * z[25];
z[15] = z[15] + z[25] + z[30] + z[31];
z[15] = z[10] * z[15];
z[25] = z[1] * z[24];
z[30] = z[25] * z[26];
z[13] = (T(1) / T(2)) * z[13];
z[13] = -z[13] * z[24];
z[13] = -1 + z[13];
z[13] = z[6] * z[13];
z[13] = z[13] + (T(-3) / T(2)) * z[30];
z[13] = z[1] * z[13];
z[32] = (T(5) / T(2)) * z[5] + -z[14];
z[32] = z[6] * z[32];
z[13] = 1 + z[13] + z[32];
z[13] = (T(1) / T(2)) * z[13] + -z[29];
z[13] = z[4] * z[13];
z[14] = -2 * z[5] + (T(-1) / T(4)) * z[14];
z[14] = z[6] * z[14];
z[14] = T(1) / T(2) + z[14];
z[14] = z[6] * z[14];
z[13] = z[13] + z[14] + (T(-7) / T(4)) * z[30];
z[13] = z[4] * z[13];
z[14] = -z[24] * z[26];
z[13] = z[13] + z[14] + z[15];
z[13] = z[0] * z[13];
z[13] = z[6] + z[13] + z[17] + z[23];
z[13] = z[0] * z[13];
z[14] = z[1] * z[16];
z[14] = z[14] + z[27];
z[15] = z[1] * z[4];
z[14] = 1 + (T(1) / T(2)) * z[14] + z[15] + (T(-3) / T(2)) * z[18];
z[17] = -1 + (T(3) / T(4)) * z[27];
z[17] = z[15] * z[17];
z[18] = -5 + 7 * z[27];
z[17] = z[17] + (T(1) / T(4)) * z[18];
z[17] = z[4] * z[17];
z[18] = z[19] + -z[20];
z[23] = (T(1) / T(4)) * z[10];
z[18] = z[18] * z[23];
z[17] = (T(5) / T(4)) * z[6] + z[17] + z[18] + z[31];
z[17] = z[0] * z[17];
z[14] = (T(1) / T(2)) * z[14] + z[17];
z[14] = z[0] * z[14];
z[17] = (T(1) / T(2)) * z[7];
z[18] = -z[11] + z[17];
z[18] = z[10] * z[18];
z[18] = T(1) / T(2) + z[18] + (T(31) / T(9)) * z[27];
z[23] = -z[6] + (T(1) / T(2)) * z[25];
z[17] = z[17] * z[23];
z[23] = prod_pow(z[1], 2);
z[24] = z[4] * z[23];
z[25] = (T(-11) / T(9)) * z[1] + (T(3) / T(4)) * z[24];
z[25] = z[4] * z[25];
z[17] = z[17] + (T(1) / T(2)) * z[18] + z[25];
z[17] = z[0] * z[17];
z[18] = z[0] * z[24];
z[18] = z[18] + -z[23];
z[18] = z[3] * z[18];
z[25] = -2 + (T(53) / T(36)) * z[27];
z[25] = z[1] * z[25];
z[17] = z[17] + (T(53) / T(36)) * z[18] + (T(-277) / T(36)) * z[24] + z[25];
z[17] = z[0] * z[17];
z[17] = z[17] + (T(125) / T(18)) * z[23];
z[17] = z[3] * z[17];
z[18] = 1 + (T(1) / T(2)) * z[15];
z[18] = z[0] * z[4] * z[18];
z[15] = z[15] + z[18];
z[15] = z[0] * z[15];
z[18] = -prod_pow(z[4], 2) * z[0] * z[23];
z[18] = z[18] + 2 * z[24];
z[18] = z[0] * z[18];
z[18] = z[18] + -z[23];
z[18] = z[3] * z[18];
z[15] = (T(-3) / T(2)) * z[1] + z[15] + z[18];
z[15] = z[3] * z[15];
z[18] = z[4] + -z[6];
z[18] = prod_pow(z[0], 2) * z[4] * z[18];
z[18] = -1 + z[18];
z[15] = z[15] + (T(1) / T(2)) * z[18];
z[15] = z[2] * z[15];
z[18] = -31 + -107 * z[27];
z[18] = z[1] * z[18];
z[14] = z[14] + z[15] + z[17] + (T(1) / T(18)) * z[18];
z[14] = z[3] * z[14];
z[15] = (T(1) / T(4)) * z[19];
z[17] = z[15] + -z[22];
z[18] = 3 * z[17];
z[19] = -z[18] + (T(1) / T(2)) * z[20];
z[19] = z[10] * z[19];
z[16] = z[4] + z[6] + z[16];
z[16] = (T(1) / T(4)) * z[16];
z[19] = -z[16] + z[19];
z[19] = z[10] * z[19];
z[15] = z[15] + -z[28];
z[15] = z[10] * z[15];
z[15] = z[15] + z[16];
z[15] = prod_pow(z[10], 2) * z[0] * z[15];
z[15] = z[15] + z[19];
z[15] = z[0] * z[15];
z[16] = z[18] + -z[21];
z[16] = z[10] * z[16];
z[18] = -z[12] * z[17];
z[15] = z[15] + z[16] + z[18];
z[15] = z[9] * z[15];
return z[13] + z[14] + z[15] + z[17];
}



template double eval_coef_2q3y_2l_pmmpp_12345_123(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_123(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
