#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_124(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[32];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[3];
z[6] = iW[19];
z[7] = v[1];
z[8] = iW[5];
z[9] = v[0];
z[10] = iW[17];
z[11] = iW[12];
z[12] = iW[15];
z[13] = z[2] * z[10];
z[14] = z[8] * z[9];
z[15] = (T(1) / T(2)) * z[4];
z[16] = z[8] * z[15];
z[16] = T(13) / T(3) + -z[13] + -z[14] + z[16];
z[16] = z[4] * z[16];
z[17] = (T(1) / T(2)) * z[13];
z[18] = T(-13) / T(3) + -z[17];
z[18] = z[2] * z[18];
z[16] = z[16] + z[18];
z[16] = z[4] * z[16];
z[18] = z[4] * z[8];
z[17] = -1 + -z[17] + z[18];
z[17] = z[4] * z[17];
z[19] = z[2] * z[12];
z[18] = z[18] + -z[19];
z[20] = (T(1) / T(2)) * z[3];
z[18] = z[18] * z[20];
z[17] = z[17] + z[18];
z[17] = z[3] * z[17];
z[16] = z[16] + z[17];
z[17] = (T(1) / T(2)) * z[9];
z[18] = (T(1) / T(2)) * z[14];
z[21] = T(-5) / T(3) + z[18];
z[21] = z[17] * z[21];
z[22] = T(-5) / T(2) + 4 * z[13];
z[22] = z[2] * z[22];
z[21] = -z[15] + z[21] + (T(1) / T(3)) * z[22];
z[22] = prod_pow(z[4], 3);
z[21] = z[21] * z[22];
z[23] = -z[2] + z[15];
z[23] = z[4] * z[23];
z[24] = prod_pow(z[2], 2);
z[23] = z[23] + (T(1) / T(2)) * z[24];
z[22] = z[6] * z[22];
z[25] = z[22] * z[23];
z[21] = z[21] + z[25];
z[21] = z[5] * z[21];
z[25] = prod_pow(z[10], 2);
z[26] = z[2] * z[25];
z[26] = -41 * z[10] + 19 * z[26];
z[26] = z[2] * z[26];
z[26] = 23 + z[26];
z[26] = -z[14] + (T(1) / T(6)) * z[26];
z[26] = z[15] * z[26];
z[27] = -3 + (T(17) / T(4)) * z[13];
z[27] = z[2] * z[27];
z[26] = (T(-7) / T(12)) * z[9] + z[26] + z[27];
z[27] = prod_pow(z[4], 2);
z[26] = z[26] * z[27];
z[28] = z[6] * z[27];
z[29] = z[23] * z[28];
z[21] = z[21] + z[26] + (T(5) / T(2)) * z[29];
z[21] = z[5] * z[21];
z[26] = -2 * z[2] + z[4];
z[26] = z[4] * z[26];
z[26] = z[24] + z[26];
z[26] = z[4] * z[26];
z[29] = z[20] * z[23];
z[26] = z[26] + z[29];
z[26] = z[6] * z[26];
z[29] = (T(1) / T(2)) * z[2];
z[25] = z[25] * z[29];
z[25] = -z[10] + z[25];
z[25] = z[2] * z[25];
z[25] = T(1) / T(2) + z[25];
z[25] = z[4] * z[25];
z[30] = (T(1) / T(4)) * z[13];
z[31] = T(-1) / T(3) + z[30];
z[31] = z[2] * z[31];
z[25] = (T(1) / T(6)) * z[25] + z[31];
z[25] = z[4] * z[25];
z[24] = (T(1) / T(4)) * z[24] + z[25];
z[24] = z[4] * z[24];
z[23] = z[3] * z[23];
z[23] = (T(1) / T(6)) * z[23] + z[24];
z[23] = z[11] * z[23];
z[16] = (T(1) / T(2)) * z[16] + z[21] + 19 * z[23] + z[26];
z[16] = z[1] * z[16];
z[21] = -55 + 73 * z[13];
z[21] = z[14] + (T(1) / T(6)) * z[21];
z[21] = z[4] * z[21];
z[21] = (T(5) / T(3)) * z[9] + z[21] + z[29];
z[21] = z[4] * z[21];
z[23] = -z[2] + z[4];
z[24] = z[23] * z[28];
z[21] = z[21] + (T(-7) / T(2)) * z[24];
z[24] = (T(3) / T(2)) * z[14];
z[25] = T(13) / T(3) + -z[24];
z[17] = z[17] * z[25];
z[17] = z[4] + z[17];
z[17] = z[17] * z[27];
z[25] = -z[22] * z[23];
z[17] = z[17] + z[25];
z[17] = z[5] * z[17];
z[17] = z[17] + (T(1) / T(2)) * z[21];
z[17] = z[5] * z[17];
z[21] = z[8] + z[12];
z[25] = -z[10] + -z[21];
z[15] = z[15] * z[25];
z[25] = -z[12] * z[20];
z[15] = T(1) / T(2) + z[15] + z[19] + z[25];
z[15] = z[15] * z[20];
z[20] = z[8] + z[10];
z[20] = z[4] * z[20];
z[20] = z[14] + -z[20];
z[20] = T(-5) / T(3) + (T(1) / T(4)) * z[20] + -z[30];
z[20] = z[4] * z[20];
z[25] = z[3] * z[23];
z[25] = (T(1) / T(4)) * z[25];
z[26] = -z[4] * z[23];
z[26] = -z[25] + z[26];
z[26] = z[6] * z[26];
z[13] = T(-1) / T(2) + z[13];
z[13] = z[4] * z[13];
z[13] = (T(5) / T(4)) * z[2] + z[13];
z[13] = z[4] * z[13];
z[13] = z[13] + -z[25];
z[27] = (T(19) / T(3)) * z[11];
z[13] = z[13] * z[27];
z[25] = z[0] * z[25];
z[13] = (T(-4) / T(3)) * z[2] + z[13] + z[15] + z[16] + z[17] + z[20] + z[25] + z[26];
z[13] = z[1] * z[13];
z[15] = 1 + -z[18];
z[15] = z[9] * z[15];
z[15] = z[15] + -z[29];
z[15] = z[7] * z[15];
z[16] = T(-11) / T(3) + z[24];
z[16] = z[9] * z[16];
z[16] = (T(13) / T(6)) * z[2] + -z[4] + z[16];
z[16] = z[4] * z[16];
z[15] = z[15] + z[16] + z[22];
z[15] = z[5] * z[15];
z[16] = z[2] + -z[9] + z[28];
z[17] = T(4) / T(9) + z[18];
z[17] = z[4] * z[17];
z[18] = T(20) / T(9) + -z[18];
z[18] = z[7] * z[18];
z[15] = (T(1) / T(2)) * z[15] + (T(1) / T(4)) * z[16] + z[17] + z[18];
z[15] = z[5] * z[15];
z[16] = z[4] + -z[7];
z[16] = z[16] * z[21];
z[14] = T(-199) / T(9) + z[14] + z[16] + -z[19];
z[16] = (T(1) / T(2)) * z[8] + z[12];
z[16] = z[3] * z[16];
z[17] = z[4] * z[27];
z[14] = (T(1) / T(2)) * z[14] + z[16] + z[17];
z[16] = (T(-71) / T(9)) * z[2] + z[4] + -z[28];
z[16] = z[5] * z[7] * z[16];
z[16] = (T(1) / T(4)) * z[16] + (T(-20) / T(9)) * z[23];
z[16] = z[0] * z[16];
return z[13] + (T(1) / T(2)) * z[14] + z[15] + z[16];
}



template double eval_coef_2q3y_2l_pmmpp_12345_124(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_124(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
