#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_126(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[35];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[5];
z[3] = v[0];
z[4] = v[4];
z[5] = iW[17];
z[6] = v[2];
z[7] = iW[19];
z[8] = iW[4];
z[9] = iW[15];
z[10] = v[3];
z[11] = iW[18];
z[12] = v[1];
z[13] = prod_pow(z[5], 2);
z[14] = z[6] * z[13];
z[15] = -z[5] + z[14];
z[16] = (T(1) / T(2)) * z[4];
z[17] = z[15] * z[16];
z[18] = z[2] * z[3];
z[19] = (T(3) / T(2)) * z[5] + z[14];
z[19] = z[6] * z[19];
z[17] = T(1) / T(2) + z[17] + -z[18] + z[19];
z[17] = z[4] * z[17];
z[19] = z[5] * z[6];
z[15] = z[4] * z[15];
z[20] = -z[5] * z[10];
z[15] = 1 + z[15] + z[19] + z[20];
z[20] = (T(1) / T(2)) * z[10];
z[15] = z[15] * z[20];
z[21] = (T(1) / T(2)) * z[3];
z[22] = -1 + (T(5) / T(2)) * z[19];
z[22] = z[6] * z[22];
z[15] = z[15] + z[17] + z[21] + z[22];
z[15] = z[15] * z[20];
z[17] = prod_pow(z[3], 3);
z[22] = z[2] * z[17];
z[23] = prod_pow(z[3], 2);
z[24] = (T(5) / T(2)) * z[5] + -z[7];
z[24] = z[6] * z[24];
z[24] = T(-7) / T(2) + z[24];
z[24] = z[6] * z[24];
z[24] = (T(-7) / T(2)) * z[3] + z[24];
z[24] = z[6] * z[24];
z[24] = z[22] + (T(-7) / T(2)) * z[23] + z[24];
z[25] = z[4] * z[7];
z[25] = -1 + z[25];
z[26] = z[6] * z[7];
z[27] = -z[25] + 3 * z[26];
z[28] = -z[16] * z[27];
z[29] = 1 + (T(3) / T(2)) * z[26];
z[29] = z[6] * z[29];
z[21] = z[21] + z[28] + z[29];
z[21] = z[4] * z[21];
z[21] = z[21] + (T(1) / T(2)) * z[24];
z[21] = z[4] * z[21];
z[21] = (T(-23) / T(9)) * z[17] + z[21];
z[21] = z[1] * z[21];
z[24] = (T(1) / T(2)) * z[6];
z[28] = 5 * z[5] + 9 * z[7] + z[14];
z[28] = z[6] * z[28];
z[28] = 5 + z[28];
z[28] = z[24] * z[28];
z[27] = z[4] * z[27];
z[27] = 3 * z[3] + (T(-3) / T(2)) * z[27] + z[28];
z[27] = z[16] * z[27];
z[28] = 3 * z[5] + -z[7];
z[29] = (T(1) / T(4)) * z[6];
z[28] = z[28] * z[29];
z[28] = -1 + z[28];
z[28] = z[6] * z[28];
z[28] = -z[3] + z[28];
z[30] = 3 * z[6];
z[31] = z[28] * z[30];
z[21] = z[21] + (T(37) / T(18)) * z[23] + z[27] + z[31];
z[21] = z[4] * z[21];
z[27] = z[6] * z[23];
z[31] = -z[17] + -z[27];
z[21] = z[21] + (T(101) / T(36)) * z[31];
z[21] = z[1] * z[21];
z[31] = 3 * z[7];
z[32] = -z[5] + -z[31];
z[32] = z[14] + (T(1) / T(2)) * z[32];
z[32] = z[6] * z[32];
z[33] = z[7] * z[16];
z[32] = -z[18] + z[32] + z[33];
z[32] = z[16] * z[32];
z[31] = 13 * z[5] + z[14] + z[31];
z[31] = z[6] * z[31];
z[31] = -3 + z[31];
z[29] = z[29] * z[31];
z[31] = z[2] * z[23];
z[29] = z[3] + z[29] + (T(-1) / T(2)) * z[31] + z[32];
z[29] = z[4] * z[29];
z[32] = z[6] * z[9];
z[34] = -z[5] + -z[9];
z[34] = z[10] * z[34];
z[34] = -3 * z[19] + z[32] + z[34];
z[34] = z[10] * z[34];
z[19] = -1 + z[19];
z[30] = -z[19] * z[30];
z[30] = z[30] + z[34];
z[20] = z[20] * z[30];
z[19] = -z[19] * z[24];
z[19] = z[3] + z[19];
z[19] = z[6] * z[19];
z[19] = z[19] + z[20];
z[19] = z[10] * z[19];
z[19] = z[19] + (T(-55) / T(9)) * z[27];
z[19] = z[8] * z[19];
z[20] = z[6] * z[28];
z[17] = -z[17] + z[27];
z[27] = z[11] * z[17];
z[15] = z[15] + (T(1) / T(2)) * z[19] + z[20] + z[21] + (T(32) / T(9)) * z[23] + (T(1) / T(4)) * z[27] + z[29];
z[15] = z[0] * z[15];
z[19] = T(-1) / T(2) + -z[26] + z[33];
z[19] = z[4] * z[19];
z[20] = z[5] + -z[7];
z[20] = z[20] * z[24];
z[20] = -1 + z[20];
z[20] = z[6] * z[20];
z[20] = -z[3] + -z[19] + z[20] + -z[31];
z[20] = z[4] * z[20];
z[21] = 1 + z[26];
z[21] = z[6] * z[21];
z[21] = z[3] + z[21];
z[21] = (T(1) / T(2)) * z[21];
z[19] = -z[19] + -z[21];
z[19] = z[4] * z[19];
z[19] = z[19] + -z[22] + (T(295) / T(36)) * z[23];
z[19] = z[4] * z[19];
z[17] = (T(-23) / T(9)) * z[17] + z[19];
z[17] = z[1] * z[17];
z[17] = z[17] + z[20] + (T(-2) / T(3)) * z[23];
z[17] = z[1] * z[17];
z[19] = z[13] * z[24];
z[19] = z[5] + z[7] + z[19];
z[19] = z[6] * z[19];
z[19] = z[19] + -z[33];
z[19] = z[4] * z[19];
z[13] = z[10] * z[13] * z[16];
z[14] = z[4] * z[14];
z[13] = z[13] + z[14];
z[13] = z[10] * z[13];
z[13] = z[13] + z[19] + -z[21];
z[14] = -z[3] * z[24];
z[14] = z[14] + (T(-55) / T(9)) * z[23];
z[16] = -1 + z[32];
z[19] = (T(3) / T(4)) * z[16];
z[20] = z[9] * z[10];
z[21] = -z[19] + z[20];
z[21] = z[10] * z[21];
z[24] = -z[3] + z[6];
z[21] = z[21] + (T(-1) / T(2)) * z[24];
z[21] = z[10] * z[21];
z[14] = (T(1) / T(2)) * z[14] + z[21];
z[14] = z[8] * z[14];
z[13] = (T(1) / T(2)) * z[13] + z[14] + z[15] + z[17];
z[13] = z[0] * z[13];
z[14] = z[9] * z[12];
z[15] = z[14] + z[19] + (T(-3) / T(2)) * z[20];
z[15] = z[10] * z[15];
z[14] = -z[14] + -z[16];
z[14] = z[12] * z[14];
z[14] = z[14] + z[24];
z[14] = (T(1) / T(4)) * z[14] + z[15];
z[14] = z[8] * z[14];
z[15] = z[3] * z[6];
z[15] = (T(107) / T(18)) * z[15] + (T(1) / T(2)) * z[22] + (T(-58) / T(9)) * z[23];
z[15] = z[1] * z[15];
z[16] = -z[25] + z[26];
z[16] = z[4] * z[16];
z[15] = (T(133) / T(36)) * z[3] + z[15] + (T(1) / T(4)) * z[16] + z[31];
z[15] = z[1] * z[15];
return z[13] + z[14] + z[15] + (T(1) / T(2)) * z[18];
}



template double eval_coef_2q3y_2l_pmmpp_12345_126(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_126(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
