#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_127(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[41];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[5];
z[3] = iW[18];
z[4] = v[0];
z[5] = v[3];
z[6] = v[4];
z[7] = iW[3];
z[8] = v[2];
z[9] = iW[12];
z[10] = iW[17];
z[11] = iW[4];
z[12] = v[1];
z[13] = z[5] + z[8];
z[14] = prod_pow(z[0], 2);
z[15] = z[5] * z[14];
z[16] = -z[0] + z[15];
z[13] = z[11] * z[13] * z[16];
z[16] = (T(1) / T(2)) * z[6];
z[17] = z[14] * z[16];
z[18] = -z[0] + z[17];
z[19] = z[6] * z[18];
z[20] = T(1) / T(2) + z[19];
z[21] = -z[7] * z[20];
z[22] = z[8] * z[14];
z[13] = (T(1) / T(2)) * z[13] + (T(3) / T(2)) * z[15] + z[21] + z[22];
z[21] = z[6] * z[14];
z[23] = -z[0] + z[21];
z[24] = -z[15] + z[23];
z[25] = (T(1) / T(2)) * z[5];
z[26] = -z[24] * z[25];
z[27] = 3 * z[0];
z[28] = z[21] + -z[27];
z[28] = z[6] * z[28];
z[28] = 3 + z[28];
z[28] = z[6] * z[28];
z[28] = -z[12] + z[28];
z[29] = (T(1) / T(2)) * z[7];
z[30] = z[28] * z[29];
z[26] = -z[20] + z[26] + z[30];
z[30] = (T(1) / T(4)) * z[5];
z[31] = -z[23] * z[30];
z[31] = -z[20] + z[31];
z[31] = z[5] * z[31];
z[28] = (T(-1) / T(4)) * z[28] + z[31];
z[28] = z[1] * z[28];
z[26] = (T(1) / T(2)) * z[26] + z[28];
z[26] = z[1] * z[26];
z[13] = (T(1) / T(2)) * z[13] + z[26];
z[13] = z[2] * z[3] * z[13];
z[26] = 3 * z[21];
z[28] = z[0] + -z[26];
z[28] = z[25] * z[28];
z[31] = (T(1) / T(2)) * z[8];
z[32] = (T(3) / T(2)) * z[5] + z[6] + z[31];
z[32] = z[14] * z[32];
z[33] = (T(1) / T(2)) * z[0];
z[32] = z[32] + -z[33];
z[32] = z[8] * z[32];
z[22] = z[6] * z[22];
z[34] = z[0] * z[6];
z[35] = z[22] + -3 * z[34];
z[36] = z[7] * z[8];
z[35] = z[35] * z[36];
z[37] = z[0] + (T(-5) / T(4)) * z[21];
z[37] = z[6] * z[37];
z[28] = z[28] + z[32] + (T(1) / T(4)) * z[35] + z[37];
z[32] = prod_pow(z[10], 2) * z[9];
z[28] = z[28] * z[32];
z[13] = z[13] + z[28];
z[13] = z[4] * z[13];
z[28] = -z[0] + (T(5) / T(2)) * z[21];
z[28] = z[16] * z[28];
z[35] = -2 * z[15] + (T(1) / T(4)) * z[21];
z[35] = z[5] * z[35];
z[37] = 3 * z[5] + z[8];
z[38] = (T(-3) / T(2)) * z[6] + -z[37];
z[38] = z[14] * z[38];
z[38] = z[0] + z[38];
z[38] = z[8] * z[38];
z[28] = z[28] + z[35] + z[38];
z[28] = z[8] * z[28];
z[35] = -9 * z[0] + 7 * z[21];
z[35] = z[6] * z[35];
z[38] = -z[0] + 2 * z[21];
z[38] = z[5] * z[38];
z[35] = (T(1) / T(4)) * z[35] + z[38];
z[35] = z[5] * z[35];
z[38] = z[17] + z[27];
z[38] = z[6] * z[38];
z[38] = -z[22] + z[38];
z[38] = prod_pow(z[8], 2) * z[29] * z[38];
z[28] = z[28] + z[35] + z[38];
z[28] = z[28] * z[32];
z[35] = 5 * z[0];
z[38] = z[12] * z[35];
z[39] = 11 * z[34] + -z[38];
z[39] = z[5] * z[39];
z[38] = 7 * z[34] + -z[38];
z[38] = z[8] * z[38];
z[38] = z[38] + z[39];
z[38] = z[7] * z[38];
z[39] = prod_pow(z[6], 2);
z[40] = z[14] * z[39];
z[39] = z[1] * z[15] * z[39];
z[38] = z[38] + z[39] + -5 * z[40];
z[39] = (T(1) / T(2)) * z[1];
z[38] = z[38] * z[39];
z[40] = -z[7] * z[40];
z[38] = z[21] + z[38] + z[40];
z[38] = z[2] * z[38];
z[40] = z[5] * z[21];
z[34] = -z[34] + z[40];
z[34] = z[34] * z[39];
z[33] = -z[21] + z[33] + z[34];
z[33] = z[33] * z[39];
z[34] = -z[3] + -z[11];
z[30] = z[30] * z[34];
z[30] = -1 + z[30];
z[30] = z[14] * z[30];
z[34] = (T(3) / T(2)) * z[21];
z[39] = z[0] + -z[34];
z[29] = z[29] * z[39];
z[13] = z[13] + z[28] + z[29] + z[30] + z[33] + (T(1) / T(2)) * z[38];
z[13] = z[4] * z[13];
z[28] = z[16] * z[23];
z[17] = -z[0] + -z[17];
z[17] = z[8] * z[17];
z[17] = 1 + z[17] + z[28];
z[17] = z[17] * z[36];
z[28] = z[21] + -z[35];
z[28] = z[16] * z[28];
z[29] = z[0] + z[15];
z[30] = -z[21] + -z[29];
z[30] = z[5] * z[30];
z[29] = -z[29] + -z[34];
z[29] = z[8] * z[29];
z[17] = 3 + z[17] + z[28] + z[29] + z[30];
z[23] = z[23] * z[25];
z[20] = z[20] + z[23];
z[20] = z[1] * z[5] * z[20];
z[17] = (T(1) / T(2)) * z[17] + z[20];
z[17] = z[2] * z[17];
z[20] = -z[26] + z[35];
z[16] = z[16] * z[20];
z[20] = -z[5] * z[24];
z[16] = z[16] + z[20];
z[16] = z[5] * z[16];
z[15] = 3 * z[15] + z[18];
z[15] = z[5] * z[15];
z[18] = z[6] + z[37];
z[14] = z[14] * z[18];
z[14] = -z[0] + z[14];
z[14] = z[8] * z[14];
z[18] = -z[0] + -z[21];
z[18] = z[6] * z[18];
z[14] = z[14] + z[15] + z[18];
z[14] = z[8] * z[14];
z[14] = z[14] + z[16];
z[14] = z[14] * z[31];
z[15] = z[19] + z[23];
z[15] = -prod_pow(z[5], 2) * z[15];
z[16] = -z[21] + -z[27];
z[16] = z[6] * z[16];
z[16] = z[16] + z[22];
z[18] = (T(1) / T(4)) * z[7];
z[16] = prod_pow(z[8], 3) * z[16] * z[18];
z[14] = z[14] + z[15] + z[16];
z[14] = z[14] * z[32];
z[13] = z[13] + z[14] + z[17];
return z[4] * z[13];
}



template double eval_coef_2q3y_2l_pmmpp_12345_127(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_127(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
