#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_128(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[36];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[3];
z[3] = iW[16];
z[4] = iW[18];
z[5] = v[0];
z[6] = v[4];
z[7] = v[3];
z[8] = iW[12];
z[9] = iW[15];
z[10] = v[2];
z[11] = iW[4];
z[12] = v[1];
z[13] = prod_pow(z[1], 2);
z[14] = z[7] * z[13];
z[15] = -z[1] + (T(7) / T(2)) * z[2];
z[16] = prod_pow(z[2], 2);
z[17] = z[10] * z[16];
z[14] = (T(-1) / T(4)) * z[14] + (T(-1) / T(2)) * z[15] + (T(23) / T(9)) * z[17];
z[18] = z[1] * z[15];
z[19] = (T(155) / T(18)) * z[16] + -z[18];
z[20] = z[1] * z[2];
z[21] = 5 * z[16] + -z[20];
z[22] = (T(1) / T(2)) * z[1];
z[23] = z[21] * z[22];
z[24] = -z[6] * z[23];
z[24] = z[19] + z[24];
z[25] = (T(1) / T(2)) * z[6];
z[24] = z[24] * z[25];
z[24] = -z[14] + z[24];
z[24] = z[6] * z[24];
z[26] = (T(1) / T(2)) * z[7];
z[27] = z[1] * z[26];
z[28] = z[2] * z[10];
z[27] = T(1) / T(2) + -z[27] + z[28];
z[29] = (T(1) / T(2)) * z[27];
z[24] = z[24] + z[29];
z[24] = z[0] * z[24];
z[18] = (T(155) / T(6)) * z[16] + -3 * z[18];
z[18] = (T(1) / T(2)) * z[18];
z[30] = z[1] * z[6];
z[31] = z[21] * z[30];
z[31] = -z[18] + z[31];
z[31] = z[6] * z[31];
z[13] = z[13] * z[26];
z[15] = -z[13] + -z[15] + (T(46) / T(9)) * z[17] + z[24] + z[31];
z[15] = z[6] * z[15];
z[15] = z[15] + -z[29];
z[15] = z[0] * z[15];
z[23] = -z[12] * z[23];
z[19] = -z[19] + z[23];
z[19] = z[12] * z[19];
z[23] = z[1] * z[12];
z[23] = z[23] + (T(-3) / T(2)) * z[30];
z[21] = z[21] * z[23];
z[18] = z[18] + z[21];
z[18] = z[6] * z[18];
z[14] = -z[14] + z[15] + z[18] + (T(1) / T(2)) * z[19];
z[14] = z[4] * z[5] * z[14];
z[15] = z[2] + z[17];
z[15] = z[10] * z[15];
z[15] = T(1) / T(2) + z[15];
z[15] = z[0] * z[15];
z[14] = z[14] + (T(1) / T(2)) * z[15];
z[14] = z[5] * z[14];
z[15] = 1 + z[28];
z[14] = z[14] + (T(1) / T(4)) * z[15];
z[14] = z[3] * z[14];
z[18] = z[1] + -7 * z[2];
z[18] = z[18] * z[22];
z[18] = -z[16] + z[18];
z[18] = z[6] * z[18];
z[13] = (T(-3) / T(2)) * z[1] + (T(73) / T(9)) * z[2] + z[13] + z[18];
z[13] = z[6] * z[13];
z[18] = z[7] + z[10];
z[19] = -z[11] * z[18];
z[13] = z[13] + (T(1) / T(2)) * z[19];
z[19] = prod_pow(z[10], 2);
z[21] = z[16] * z[19];
z[21] = -1 + z[21];
z[21] = z[21] * z[25];
z[23] = (T(1) / T(2)) * z[10];
z[24] = 1 + 3 * z[28];
z[24] = z[23] * z[24];
z[24] = -z[7] + z[21] + z[24];
z[24] = z[6] * z[24];
z[29] = -z[10] + z[26];
z[29] = z[7] * z[29];
z[30] = (T(3) / T(2)) * z[19];
z[29] = z[29] + -z[30];
z[24] = z[24] + -z[29];
z[24] = z[6] * z[24];
z[31] = z[7] + 3 * z[10];
z[31] = z[26] * z[31];
z[31] = z[19] + z[31];
z[26] = z[26] * z[31];
z[24] = z[24] + z[26];
z[26] = z[8] * z[9];
z[24] = z[24] * z[26];
z[31] = z[6] * z[15];
z[32] = z[18] + (T(-101) / T(9)) * z[31];
z[24] = z[24] + (T(1) / T(4)) * z[32];
z[24] = z[4] * z[24];
z[13] = (T(1) / T(2)) * z[13] + z[24];
z[13] = z[0] * z[13];
z[24] = z[7] * z[10];
z[24] = z[19] + z[24];
z[32] = -z[2] + (T(1) / T(2)) * z[17];
z[32] = z[10] * z[32];
z[32] = T(-3) / T(2) + z[32];
z[32] = z[6] * z[32];
z[33] = 1 + -z[28];
z[33] = z[10] * z[33];
z[33] = 2 * z[7] + -z[32] + z[33];
z[33] = z[6] * z[33];
z[33] = (T(-1) / T(2)) * z[24] + z[33];
z[33] = z[26] * z[33];
z[34] = -1 + (T(101) / T(18)) * z[28];
z[33] = z[33] + (T(1) / T(2)) * z[34];
z[33] = z[4] * z[33];
z[34] = 3 * z[2];
z[35] = z[1] + z[34];
z[35] = (T(-55) / T(9)) * z[17] + (T(1) / T(2)) * z[35];
z[34] = (T(-1) / T(4)) * z[1] + z[34];
z[34] = z[1] * z[34];
z[34] = (T(277) / T(36)) * z[16] + z[34];
z[34] = z[6] * z[34];
z[13] = z[13] + z[33] + z[34] + (T(1) / T(2)) * z[35];
z[13] = z[0] * z[13];
z[16] = (T(-259) / T(9)) * z[16] + -5 * z[20];
z[20] = (T(-1) / T(4)) * z[18] + -z[31];
z[20] = z[4] * z[20] * z[26];
z[13] = z[13] + (T(1) / T(4)) * z[16] + z[20];
z[13] = z[5] * z[13];
z[16] = z[1] + -z[17];
z[16] = z[16] * z[25];
z[16] = z[16] + -z[27];
z[16] = z[6] * z[16];
z[20] = -z[2] * z[19];
z[20] = z[7] + z[20];
z[20] = z[20] * z[25];
z[25] = z[7] + -z[23];
z[25] = z[7] * z[25];
z[20] = z[20] + z[25] + -z[30];
z[20] = z[6] * z[20];
z[25] = z[7] * z[29];
z[20] = z[20] + z[25];
z[20] = z[6] * z[20];
z[27] = prod_pow(z[7], 2);
z[24] = z[24] * z[27];
z[20] = z[20] + (T(-3) / T(4)) * z[24];
z[20] = z[20] * z[26];
z[24] = -z[6] + (T(-3) / T(2)) * z[7];
z[18] = z[18] * z[24];
z[18] = (T(1) / T(2)) * z[18] + z[20];
z[18] = z[4] * z[18];
z[16] = z[16] + z[18];
z[16] = z[0] * z[16];
z[18] = z[19] + -z[27];
z[19] = T(-1) / T(2) + 2 * z[28];
z[19] = z[10] * z[19];
z[19] = (T(-5) / T(2)) * z[7] + z[19] + z[21];
z[19] = z[6] * z[19];
z[18] = (T(5) / T(2)) * z[18] + z[19];
z[18] = z[6] * z[18];
z[18] = z[18] + -z[25];
z[18] = z[18] * z[26];
z[19] = z[1] * z[7];
z[20] = T(1) / T(2) + -z[19];
z[20] = z[7] * z[20];
z[19] = 1 + z[19];
z[21] = -z[6] * z[19];
z[20] = (T(3) / T(2)) * z[10] + z[20] + z[21];
z[18] = z[18] + (T(1) / T(2)) * z[20];
z[18] = z[4] * z[18];
z[20] = -z[1] + -z[2];
z[20] = z[6] * z[20];
z[16] = z[16] + z[18] + z[20];
z[16] = z[0] * z[16];
z[18] = 2 + -z[28];
z[18] = z[10] * z[18];
z[15] = -z[12] * z[15];
z[15] = 3 * z[7] + z[15] + z[18] + -z[32];
z[15] = z[6] * z[15];
z[18] = -z[10] * z[12];
z[18] = z[18] + -z[30];
z[20] = -z[12] + z[23];
z[20] = z[7] + (T(1) / T(2)) * z[20];
z[20] = z[7] * z[20];
z[15] = z[15] + (T(1) / T(2)) * z[18] + z[20];
z[15] = z[15] * z[26];
z[15] = z[15] + (T(1) / T(2)) * z[19];
z[15] = z[4] * z[15];
z[13] = 2 * z[2] + z[13] + z[14] + z[15] + z[16] + (T(107) / T(18)) * z[17] + z[22];
return z[5] * z[13];
}



template double eval_coef_2q3y_2l_pmmpp_12345_128(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_128(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
