#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_132(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[43];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[3];
z[5] = iW[3];
z[6] = v[2];
z[7] = iW[22];
z[8] = v[4];
z[9] = iW[4];
z[10] = iW[15];
z[11] = iW[19];
z[12] = v[1];
z[13] = z[5] + z[11];
z[14] = prod_pow(z[7], 2);
z[13] = z[13] * z[14];
z[15] = z[8] * z[13];
z[16] = (T(3) / T(4)) * z[15];
z[17] = z[5] * z[7];
z[18] = 3 * z[14] + -z[17];
z[19] = z[7] * z[11];
z[18] = z[16] + (T(1) / T(2)) * z[18] + -z[19];
z[18] = z[8] * z[18];
z[20] = -5 * z[7] + z[11];
z[18] = z[18] + (T(1) / T(4)) * z[20];
z[18] = z[8] * z[18];
z[20] = -z[2] + z[11];
z[21] = (T(1) / T(2)) * z[10];
z[22] = z[20] * z[21];
z[23] = prod_pow(z[2], 2);
z[22] = z[22] + z[23];
z[24] = z[4] * z[21] * z[22];
z[25] = z[10] * z[20];
z[26] = z[24] + z[25];
z[27] = (T(1) / T(2)) * z[9];
z[28] = z[7] + z[27];
z[29] = z[7] * z[28];
z[30] = (T(1) / T(2)) * z[23] + -z[29];
z[31] = z[26] + z[30];
z[31] = z[4] * z[31];
z[32] = z[8] * z[14];
z[31] = (T(-3) / T(4)) * z[2] + -z[7] + (T(-1) / T(4)) * z[9] + z[31] + -z[32];
z[31] = z[4] * z[31];
z[33] = -z[14] + (T(1) / T(4)) * z[19];
z[34] = (T(-1) / T(4)) * z[15] + z[33];
z[34] = z[8] * z[34];
z[35] = (T(1) / T(2)) * z[4];
z[36] = -z[29] * z[35];
z[34] = (T(-1) / T(4)) * z[7] + z[34] + z[36];
z[34] = z[6] * z[34];
z[36] = (T(1) / T(2)) * z[5];
z[37] = -z[2] + z[36];
z[38] = -z[3] * z[37];
z[38] = -1 + z[38];
z[38] = z[2] * z[38];
z[39] = z[4] * z[23];
z[38] = z[38] + z[39];
z[40] = (T(1) / T(2)) * z[3];
z[38] = z[38] * z[40];
z[18] = T(-1) / T(4) + z[18] + z[31] + z[34] + z[38];
z[18] = z[6] * z[18];
z[16] = -z[16] + z[17] + (T(5) / T(4)) * z[19];
z[16] = z[8] * z[16];
z[31] = (T(1) / T(4)) * z[5];
z[16] = z[7] + z[16] + -z[31];
z[16] = z[8] * z[16];
z[16] = T(-1) / T(2) + z[16];
z[16] = z[8] * z[16];
z[23] = -z[23] + -z[29];
z[34] = 2 * z[2] + (T(-3) / T(2)) * z[11];
z[34] = z[10] * z[34];
z[23] = (T(1) / T(2)) * z[23] + -z[24] + z[34];
z[23] = z[4] * z[23];
z[24] = 7 * z[2];
z[34] = -3 * z[7] + -z[9] + z[24];
z[23] = -z[11] + z[23] + (T(1) / T(4)) * z[34];
z[23] = z[4] * z[23];
z[34] = (T(1) / T(2)) * z[11];
z[38] = -z[7] + z[34];
z[41] = 2 * z[32] + z[38];
z[41] = z[8] * z[41];
z[23] = T(-5) / T(4) + z[23] + z[41];
z[23] = z[4] * z[23];
z[41] = 3 * z[2];
z[27] = -z[27] + -z[39] + z[41];
z[27] = z[4] * z[27];
z[27] = T(-3) / T(2) + z[27];
z[42] = -z[5] + z[24];
z[39] = -z[39] + (T(1) / T(4)) * z[42];
z[39] = z[3] * z[39];
z[27] = (T(1) / T(2)) * z[27] + z[39];
z[27] = z[3] * z[27];
z[16] = z[16] + z[18] + z[23] + z[27];
z[16] = z[6] * z[16];
z[18] = (T(1) / T(2)) * z[8];
z[13] = z[13] * z[18];
z[23] = z[13] + -z[14];
z[27] = -z[17] + -z[19] + z[23];
z[27] = z[8] * z[27];
z[27] = z[27] + z[36] + -z[38];
z[27] = z[8] * z[27];
z[27] = 1 + z[27];
z[27] = prod_pow(z[8], 2) * z[27];
z[36] = -z[7] + -z[11];
z[36] = z[32] + (T(1) / T(2)) * z[36];
z[36] = z[8] * z[36];
z[39] = z[4] * z[10];
z[42] = 1 + z[39];
z[34] = -z[2] + z[34];
z[34] = z[34] * z[42];
z[34] = z[21] + z[34];
z[34] = z[4] * z[34];
z[34] = 1 + z[34] + z[36];
z[34] = z[34] * z[35];
z[14] = -z[14] * z[18];
z[14] = z[7] + (T(1) / T(4)) * z[11] + z[14];
z[14] = z[8] * z[14];
z[14] = T(-1) / T(2) + z[14];
z[14] = z[8] * z[14];
z[14] = z[14] + z[34];
z[14] = z[4] * z[14];
z[34] = z[2] * z[4];
z[36] = (T(1) / T(2)) * z[1] + z[2];
z[36] = z[34] * z[36];
z[24] = -z[1] + -z[24];
z[24] = (T(1) / T(2)) * z[24] + z[36];
z[24] = z[24] * z[35];
z[36] = -z[8] * z[31];
z[24] = 1 + z[24] + z[36];
z[24] = z[3] * z[24];
z[34] = 1 + -z[34];
z[34] = z[4] * z[34];
z[34] = -z[8] + z[34];
z[24] = z[24] + (T(1) / T(2)) * z[34];
z[24] = z[3] * z[24];
z[14] = z[14] + z[16] + z[24] + (T(1) / T(2)) * z[27];
z[14] = z[0] * z[14];
z[16] = z[22] * z[39];
z[22] = (T(5) / T(2)) * z[11] + -z[41];
z[22] = z[10] * z[22];
z[22] = z[16] + z[22] + z[30];
z[22] = z[4] * z[22];
z[24] = -z[2] + (T(3) / T(4)) * z[11];
z[22] = z[22] + z[24] + (T(-1) / T(2)) * z[28] + -z[32];
z[22] = z[4] * z[22];
z[27] = -z[13] + (T(1) / T(2)) * z[17] + z[33];
z[27] = z[8] * z[27];
z[16] = -z[16] + (T(-3) / T(2)) * z[25] + -z[29];
z[16] = z[16] * z[35];
z[30] = z[37] * z[40];
z[33] = -z[2] * z[30];
z[16] = z[16] + z[27] + z[33];
z[16] = z[6] * z[16];
z[27] = -7 * z[17] + -3 * z[19];
z[15] = z[15] + (T(1) / T(4)) * z[27];
z[15] = z[8] * z[15];
z[27] = z[5] + -z[7];
z[15] = z[15] + (T(1) / T(2)) * z[27];
z[15] = z[8] * z[15];
z[15] = z[15] + z[16] + z[22] + -z[30];
z[15] = z[6] * z[15];
z[16] = (T(5) / T(4)) * z[17] + (T(1) / T(2)) * z[19] + -z[23];
z[16] = z[8] * z[16];
z[16] = (T(-3) / T(4)) * z[5] + -z[7] + z[16];
z[16] = z[8] * z[16];
z[16] = T(-1) / T(4) + z[16];
z[16] = z[8] * z[16];
z[19] = 5 * z[2] + -3 * z[11];
z[19] = z[19] * z[21];
z[19] = z[19] + -z[29];
z[19] = z[4] * z[19];
z[19] = (T(3) / T(2)) * z[2] + -z[11] + z[19] + -z[21] + -z[28];
z[19] = z[4] * z[19];
z[21] = z[32] + z[38];
z[21] = z[8] * z[21];
z[19] = -1 + z[19] + z[21];
z[19] = z[19] * z[35];
z[21] = z[3] + z[8];
z[21] = z[5] * z[21];
z[22] = z[2] + -z[9];
z[22] = z[4] * z[22];
z[21] = 1 + z[21] + z[22];
z[21] = z[3] * z[21];
z[14] = z[14] + z[15] + z[16] + z[19] + (T(1) / T(4)) * z[21];
z[14] = z[0] * z[14];
z[15] = -z[12] * z[25];
z[15] = z[15] + z[20];
z[16] = z[24] * z[39];
z[15] = (T(1) / T(4)) * z[15] + z[16];
z[15] = z[4] * z[15];
z[13] = z[13] + -z[17];
z[13] = -z[13] * z[18];
z[16] = -z[4] * z[26];
z[13] = z[13] + z[16];
z[13] = z[6] * z[13];
z[16] = (T(-3) / T(2)) * z[17] + z[23];
z[16] = z[8] * z[16];
z[16] = z[5] + z[7] + z[16];
z[16] = z[16] * z[18];
z[17] = -z[3] * z[31];
return z[13] + z[14] + z[15] + z[16] + z[17];
}



template double eval_coef_2q3y_2l_pmmpp_12345_132(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_132(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
