#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_133(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[37];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[2];
z[5] = iW[22];
z[6] = v[4];
z[7] = iW[15];
z[8] = v[3];
z[9] = iW[16];
z[10] = iW[17];
z[11] = iW[18];
z[12] = z[4] * z[8];
z[13] = prod_pow(z[4], 2);
z[14] = z[12] + z[13];
z[15] = z[9] * z[14];
z[16] = z[7] * z[14];
z[16] = z[15] + z[16];
z[17] = prod_pow(z[8], 3);
z[16] = z[16] * z[17];
z[18] = z[4] + z[8];
z[19] = z[8] * z[18];
z[19] = -z[13] + z[19];
z[20] = (T(1) / T(2)) * z[6];
z[21] = (T(1) / T(2)) * z[8];
z[22] = z[4] + z[21];
z[23] = -z[20] + z[22];
z[23] = z[6] * z[23];
z[19] = (T(1) / T(2)) * z[19] + z[23];
z[19] = z[6] * z[19];
z[23] = -3 * z[4] + -z[8];
z[23] = z[21] * z[23];
z[23] = -z[13] + z[23];
z[23] = z[8] * z[23];
z[19] = z[19] + z[23];
z[19] = z[6] * z[19];
z[23] = prod_pow(z[8], 2);
z[24] = z[14] * z[23];
z[16] = (T(-1) / T(4)) * z[16] + z[19] + (T(-1) / T(2)) * z[24];
z[16] = z[5] * z[16];
z[19] = z[8] * z[22];
z[24] = (T(1) / T(2)) * z[13];
z[25] = z[19] + z[24];
z[25] = z[10] * z[25];
z[26] = -z[15] + (T(-1) / T(2)) * z[25];
z[26] = z[23] * z[26];
z[27] = (T(5) / T(2)) * z[6];
z[28] = -z[4] + z[21];
z[29] = z[27] + z[28];
z[29] = z[6] * z[29];
z[19] = (T(-3) / T(2)) * z[13] + -5 * z[19] + z[29];
z[19] = z[19] * z[20];
z[29] = prod_pow(z[6], 2);
z[30] = (T(1) / T(2)) * z[1];
z[31] = z[29] * z[30];
z[20] = -z[4] + z[20];
z[32] = -z[6] * z[20];
z[24] = -z[24] + z[32];
z[24] = z[24] * z[31];
z[12] = -z[12] + (T(-3) / T(4)) * z[13];
z[12] = z[8] * z[12];
z[32] = (T(1) / T(2)) * z[7];
z[17] = z[17] * z[32];
z[33] = -z[17] * z[22];
z[12] = z[12] + z[16] + z[19] + z[24] + z[26] + z[33];
z[12] = z[5] * z[12];
z[16] = -z[4] + z[6];
z[16] = z[16] * z[31];
z[19] = -z[8] * z[25];
z[24] = z[8] * z[9];
z[25] = (T(3) / T(2)) * z[24];
z[14] = -z[14] * z[25];
z[26] = z[4] * z[21];
z[33] = -z[6] + (T(-3) / T(2)) * z[18];
z[33] = z[6] * z[33];
z[14] = z[14] + z[16] + -z[17] + z[19] + z[26] + z[33];
z[17] = (T(1) / T(4)) * z[11];
z[17] = -z[17] * z[23];
z[19] = z[4] + -z[8];
z[19] = z[2] * z[19] * z[21];
z[26] = z[9] * z[13];
z[33] = (T(1) / T(4)) * z[26];
z[34] = z[1] * z[13];
z[35] = (T(1) / T(4)) * z[34];
z[17] = (T(-1) / T(4)) * z[4] + z[8] + z[17] + z[19] + -z[33] + z[35];
z[17] = z[2] * z[17];
z[19] = z[4] * z[9];
z[36] = z[1] * z[4];
z[21] = z[11] * z[21];
z[21] = T(-5) / T(2) + (T(1) / T(2)) * z[19] + z[21] + z[36];
z[33] = z[28] + z[33] + z[35];
z[33] = z[2] * z[33];
z[21] = (T(1) / T(2)) * z[21] + z[33];
z[21] = z[2] * z[21];
z[21] = (T(1) / T(4)) * z[1] + z[21];
z[21] = z[3] * z[21];
z[33] = z[8] * z[11];
z[35] = z[4] + z[6];
z[36] = z[1] * z[35];
z[36] = -1 + -z[19] + z[33] + z[36];
z[17] = z[17] + z[21] + (T(1) / T(4)) * z[36];
z[17] = z[3] * z[17];
z[15] = -z[15] + -z[20] + -z[31];
z[15] = (T(1) / T(2)) * z[15] + z[17];
z[15] = z[3] * z[15];
z[12] = z[12] + (T(1) / T(2)) * z[14] + z[15];
z[12] = z[0] * z[12];
z[14] = z[23] * z[32];
z[15] = (T(1) / T(2)) * z[9];
z[17] = -z[15] * z[23];
z[17] = -z[14] + z[17];
z[20] = -z[13] + z[23];
z[17] = z[17] * z[20];
z[21] = z[18] * z[23];
z[32] = z[6] + -z[18];
z[29] = z[29] * z[32];
z[17] = z[17] + -z[21] + z[29];
z[17] = z[5] * z[17];
z[27] = z[18] + -z[27];
z[27] = z[6] * z[27];
z[20] = -z[20] * z[25];
z[25] = -z[4] + (T(-3) / T(2)) * z[8];
z[25] = z[8] * z[25];
z[23] = z[4] * z[7] * z[23];
z[16] = z[16] + z[17] + z[20] + z[23] + z[25] + z[27];
z[16] = z[5] * z[16];
z[17] = z[18] * z[24];
z[16] = z[6] + z[14] + z[16] + -z[17] + -z[31];
z[13] = z[13] * z[30];
z[13] = z[13] + (T(1) / T(2)) * z[26] + z[28];
z[13] = z[2] * z[13];
z[18] = z[4] * z[30];
z[13] = -1 + z[13] + z[18] + (T(3) / T(4)) * z[19] + (T(1) / T(4)) * z[33];
z[13] = z[2] * z[13];
z[18] = -z[1] + z[9];
z[13] = z[13] + (T(1) / T(4)) * z[18];
z[13] = z[3] * z[13];
z[18] = z[30] * z[35];
z[20] = -z[26] + z[34];
z[23] = (T(1) / T(2)) * z[2];
z[20] = z[20] * z[23];
z[22] = -z[9] * z[22];
z[18] = z[18] + z[20] + z[22];
z[13] = z[13] + (T(1) / T(2)) * z[18];
z[13] = z[3] * z[13];
z[12] = z[12] + z[13] + (T(1) / T(2)) * z[16];
z[12] = z[0] * z[12];
z[13] = z[7] + z[9];
z[13] = z[5] * z[13] * z[21];
z[13] = (T(1) / T(2)) * z[13] + z[14] + z[17];
z[13] = z[5] * z[13];
z[14] = z[26] + z[34];
z[14] = z[14] * z[23];
z[14] = z[14] + z[19];
z[14] = z[2] * z[14];
z[14] = z[14] + z[15];
z[14] = z[3] * z[14];
z[13] = z[13] + z[14];
return z[12] + (T(1) / T(2)) * z[13];
}



template double eval_coef_2q3y_2l_pmmpp_12345_133(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_133(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
