#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_137(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[53];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[15];
z[6] = iW[3];
z[7] = iW[22];
z[8] = v[1];
z[9] = v[0];
z[10] = iW[4];
z[11] = (T(1) / T(6)) * z[5];
z[12] = (T(19) / T(3)) * z[6];
z[13] = -z[7] + z[11] + -z[12];
z[14] = (T(1) / T(2)) * z[6];
z[13] = z[13] * z[14];
z[15] = prod_pow(z[5], 2);
z[16] = (T(1) / T(2)) * z[15];
z[17] = 3 * z[7];
z[18] = z[5] + z[17];
z[18] = z[7] * z[18];
z[13] = z[13] + z[16] + z[18];
z[18] = z[6] * z[7];
z[19] = prod_pow(z[7], 2);
z[20] = z[18] + -z[19];
z[21] = (T(1) / T(4)) * z[6];
z[21] = z[20] * z[21];
z[22] = z[8] * z[21];
z[23] = z[5] * z[7];
z[23] = z[16] + z[23];
z[23] = z[7] * z[23];
z[24] = z[3] * z[23];
z[25] = z[1] * z[3];
z[26] = T(-25) / T(6) + z[25];
z[26] = z[1] * z[26];
z[27] = (T(7) / T(6)) * z[5];
z[28] = -z[26] + -z[27];
z[29] = (T(1) / T(8)) * z[1];
z[28] = z[28] * z[29];
z[13] = (T(1) / T(4)) * z[13] + -z[22] + z[24] + z[28];
z[13] = z[0] * z[13];
z[11] = z[7] + z[11];
z[11] = z[11] * z[14];
z[28] = z[16] + z[24];
z[30] = (T(3) / T(2)) * z[5];
z[31] = -z[7] + z[30];
z[32] = z[7] * z[31];
z[32] = z[28] + z[32];
z[32] = z[25] * z[32];
z[33] = z[5] + -z[7];
z[33] = z[7] * z[33];
z[11] = z[11] + z[16] + z[32] + z[33];
z[11] = (T(1) / T(4)) * z[11] + z[24];
z[11] = z[1] * z[11];
z[16] = (T(1) / T(2)) * z[5];
z[32] = -z[16] * z[18];
z[33] = z[1] * z[24];
z[32] = z[23] + z[32] + z[33];
z[32] = z[1] * z[32];
z[16] = z[7] + -z[16];
z[16] = z[7] * z[16];
z[16] = z[16] + -z[18];
z[16] = z[6] * z[16];
z[16] = z[16] + z[23];
z[16] = z[0] * z[16];
z[16] = z[16] + z[32];
z[16] = z[2] * z[16];
z[11] = z[11] + z[13] + (T(1) / T(4)) * z[16] + z[21];
z[11] = z[2] * z[11];
z[13] = (T(3) / T(2)) * z[24];
z[16] = z[7] + z[30];
z[23] = z[7] * z[16];
z[23] = z[13] + (T(3) / T(8)) * z[15] + z[23];
z[23] = z[3] * z[23];
z[32] = T(-25) / T(2) + 3 * z[25];
z[32] = z[1] * z[32];
z[33] = (T(13) / T(3)) * z[5] + z[32];
z[33] = z[29] * z[33];
z[34] = (T(2) / T(3)) * z[6];
z[35] = -z[5] * z[34];
z[33] = (T(1) / T(8)) * z[15] + z[33] + z[35];
z[33] = z[4] * z[33];
z[35] = prod_pow(z[6], 2);
z[36] = z[19] + (T(-19) / T(12)) * z[35];
z[37] = (T(1) / T(2)) * z[8];
z[36] = z[36] * z[37];
z[38] = (T(1) / T(4)) * z[1];
z[39] = (T(1) / T(4)) * z[5] + z[7];
z[40] = (T(1) / T(3)) * z[6] + z[39];
z[23] = z[23] + z[33] + z[36] + z[38] + (T(1) / T(2)) * z[40];
z[23] = z[0] * z[23];
z[33] = (T(3) / T(2)) * z[7];
z[31] = z[31] * z[33];
z[36] = z[5] * z[10];
z[13] = z[13] + (T(1) / T(6)) * z[15] + z[31] + z[36];
z[13] = z[3] * z[13];
z[31] = z[5] + z[10];
z[31] = z[7] * z[31];
z[31] = (T(13) / T(12)) * z[15] + z[31] + -z[36];
z[31] = z[3] * z[31];
z[40] = (T(-5) / T(3)) * z[5] + z[7] + z[31];
z[40] = z[3] * z[40];
z[25] = T(-35) / T(6) + (T(1) / T(2)) * z[25] + z[40];
z[40] = (T(1) / T(2)) * z[1];
z[25] = z[25] * z[40];
z[41] = (T(19) / T(3)) * z[5] + (T(-13) / T(2)) * z[6] + -z[7];
z[13] = z[13] + z[25] + (T(1) / T(4)) * z[41];
z[13] = z[1] * z[13];
z[25] = (T(7) / T(12)) * z[15];
z[36] = z[25] + -z[36];
z[41] = (T(13) / T(3)) * z[6];
z[42] = (T(1) / T(2)) * z[7];
z[43] = z[41] + z[42];
z[43] = z[14] * z[43];
z[13] = z[13] + -z[19] + (T(1) / T(2)) * z[36] + z[43];
z[43] = (T(19) / T(24)) * z[15] + z[19];
z[44] = (T(1) / T(2)) * z[3];
z[45] = z[43] * z[44];
z[46] = (T(2) / T(3)) * z[5];
z[45] = (T(-15) / T(16)) * z[6] + -z[29] + z[45] + -z[46];
z[45] = z[1] * z[45];
z[25] = -z[19] + -z[25];
z[47] = (T(1) / T(8)) * z[7];
z[46] = (T(-13) / T(12)) * z[6] + -z[46] + z[47];
z[46] = z[6] * z[46];
z[25] = (T(1) / T(4)) * z[25] + z[45] + z[46];
z[25] = z[1] * z[25];
z[20] = z[6] * z[20];
z[45] = (T(1) / T(2)) * z[4];
z[46] = z[20] * z[45];
z[18] = -z[18] + (T(3) / T(2)) * z[19] + -z[46];
z[48] = prod_pow(z[1], 2);
z[18] = z[18] * z[45] * z[48];
z[18] = z[18] + z[21] + z[25];
z[18] = z[4] * z[18];
z[11] = z[11] + (T(1) / T(2)) * z[13] + z[18] + z[22] + z[23];
z[11] = z[2] * z[11];
z[13] = z[6] * z[9];
z[18] = 2 * z[13];
z[22] = z[3] * z[5];
z[23] = T(41) / T(8) + -z[18] + 2 * z[22];
z[25] = -z[3] + (T(1) / T(2)) * z[9];
z[25] = z[25] * z[38];
z[23] = (T(1) / T(3)) * z[23] + z[25];
z[23] = z[1] * z[23];
z[25] = (T(35) / T(12)) * z[15] + z[19];
z[25] = z[25] * z[44];
z[49] = (T(4) / T(3)) * z[6];
z[50] = z[9] * z[35];
z[51] = (T(13) / T(12)) * z[50];
z[23] = (T(-21) / T(16)) * z[5] + z[23] + z[25] + -z[49] + z[51];
z[23] = z[1] * z[23];
z[25] = z[6] + (T(-7) / T(4)) * z[7];
z[14] = z[14] * z[25];
z[25] = -z[6] + z[50];
z[25] = z[1] + (T(11) / T(3)) * z[5] + (T(-13) / T(6)) * z[25] + z[42];
z[25] = z[25] * z[38];
z[14] = z[14] + z[25] + z[43];
z[14] = z[1] * z[14];
z[25] = -z[6] + z[33];
z[25] = z[6] * z[25];
z[25] = -z[19] + z[25];
z[33] = z[1] * z[25];
z[33] = -3 * z[20] + z[33];
z[33] = z[1] * z[33];
z[43] = z[4] * z[20];
z[52] = z[43] * z[48];
z[33] = z[33] + z[52];
z[33] = z[4] * z[33];
z[14] = z[14] + z[21] + (T(1) / T(4)) * z[33];
z[14] = z[4] * z[14];
z[21] = (T(-13) / T(3)) * z[15] + -z[19];
z[33] = z[47] + -z[49];
z[33] = z[6] * z[33];
z[14] = z[14] + (T(1) / T(4)) * z[21] + z[23] + z[33];
z[14] = z[4] * z[14];
z[21] = -z[39] * z[42];
z[21] = z[21] + (T(-1) / T(4)) * z[24] + -z[36];
z[21] = z[3] * z[21];
z[23] = (T(-1) / T(2)) * z[19] + (T(13) / T(6)) * z[35] + z[36] + z[46];
z[23] = z[23] * z[37];
z[32] = (T(-25) / T(6)) * z[5] + -z[32];
z[32] = z[1] * z[32];
z[32] = z[15] + z[32];
z[32] = z[4] * z[32];
z[33] = z[3] * z[15];
z[32] = (T(1) / T(8)) * z[32] + (T(1) / T(4)) * z[33] + -z[34] + -z[40];
z[32] = z[4] * z[32];
z[17] = 7 * z[5] + z[17];
z[17] = z[7] * z[17];
z[17] = (T(3) / T(2)) * z[15] + z[17];
z[17] = (T(1) / T(4)) * z[17] + z[24];
z[17] = z[3] * z[17];
z[34] = 5 * z[5] + 7 * z[7];
z[17] = z[17] + (T(1) / T(8)) * z[34];
z[17] = z[3] * z[17];
z[34] = (T(7) / T(12)) * z[6];
z[39] = z[3] * z[19];
z[39] = z[7] + z[34] + z[39];
z[39] = z[8] * z[39];
z[17] = T(-1) / T(48) + z[17] + z[32] + (T(1) / T(4)) * z[39];
z[17] = z[0] * z[17];
z[16] = (T(1) / T(2)) * z[16] + z[31];
z[16] = z[3] * z[16];
z[16] = T(-41) / T(12) + z[16];
z[22] = 1 + z[22];
z[22] = z[3] * z[22];
z[22] = z[9] + z[22];
z[22] = z[22] * z[29];
z[13] = (T(-2) / T(3)) * z[13] + z[22];
z[16] = -z[13] + (T(1) / T(2)) * z[16];
z[16] = z[1] * z[16];
z[22] = (T(-23) / T(6)) * z[6] + z[10] + z[30] + -z[42];
z[11] = z[11] + z[14] + z[16] + z[17] + z[21] + (T(1) / T(4)) * z[22] + z[23] + (T(-13) / T(24)) * z[50];
z[11] = z[2] * z[11];
z[14] = z[25] + (T(-1) / T(2)) * z[48];
z[14] = z[14] * z[40];
z[16] = z[1] * z[46];
z[14] = z[14] + z[16] + -z[20];
z[14] = z[4] * z[14];
z[16] = (T(13) / T(3)) * z[50];
z[17] = z[3] + -z[9];
z[17] = z[1] * z[17];
z[17] = T(-13) / T(6) + z[17];
z[17] = z[1] * z[17];
z[17] = 3 * z[5] + z[7] + -z[16] + z[17] + z[41];
z[17] = z[17] * z[38];
z[19] = (T(17) / T(4)) * z[15] + z[19];
z[20] = z[6] + (T(-3) / T(4)) * z[7];
z[20] = z[6] * z[20];
z[14] = z[14] + z[17] + (T(1) / T(2)) * z[19] + z[20];
z[14] = z[14] * z[45];
z[12] = 13 * z[5] + -z[12] + 15 * z[33];
z[12] = (T(1) / T(4)) * z[12] + z[16];
z[16] = T(17) / T(4) + -z[18];
z[17] = z[9] * z[38];
z[16] = (T(1) / T(3)) * z[16] + z[17];
z[16] = z[1] * z[16];
z[12] = (T(1) / T(4)) * z[12] + z[14] + z[16];
z[12] = z[4] * z[12];
z[14] = (T(-13) / T(4)) * z[15] + -z[35] + z[43];
z[14] = z[14] * z[45];
z[16] = -z[3] + z[37];
z[16] = z[16] * z[36];
z[17] = z[10] + -z[27] + -z[34];
z[14] = z[14] + z[16] + (T(1) / T(2)) * z[17] + -z[51];
z[14] = z[14] * z[37];
z[16] = -z[5] + z[10];
z[16] = z[7] * z[16];
z[16] = z[16] + -z[24] + z[36];
z[16] = z[3] * z[16];
z[16] = (T(13) / T(6)) * z[5] + z[16];
z[16] = z[3] * z[16];
z[16] = T(11) / T(4) + z[16];
z[17] = (T(5) / T(2)) * z[5] + z[7];
z[17] = z[7] * z[17];
z[17] = z[17] + z[28];
z[17] = z[17] * z[44];
z[17] = (T(3) / T(4)) * z[5] + z[7] + z[17];
z[17] = z[3] * z[17];
z[17] = T(1) / T(2) + z[17];
z[17] = z[3] * z[17];
z[18] = z[5] + z[26];
z[18] = z[1] * z[18];
z[15] = (T(19) / T(6)) * z[15] + z[18];
z[15] = z[15] * z[45];
z[18] = -z[5] + z[33];
z[15] = z[1] + z[15] + (T(1) / T(2)) * z[18];
z[15] = z[4] * z[15];
z[18] = z[5] + z[33];
z[18] = z[3] * z[18];
z[18] = T(7) / T(6) + z[18];
z[15] = z[15] + (T(1) / T(2)) * z[18];
z[15] = z[15] * z[45];
z[15] = z[15] + z[17];
z[15] = z[0] * z[15];
return z[11] + z[12] + -z[13] + z[14] + (T(1) / T(2)) * z[15] + (T(1) / T(4)) * z[16];
}



template double eval_coef_2q3y_2l_pmmpp_12345_137(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_137(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
