#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_142(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[41];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[3];
z[5] = iW[3];
z[6] = v[2];
z[7] = iW[22];
z[8] = v[4];
z[9] = iW[4];
z[10] = iW[15];
z[11] = iW[19];
z[12] = v[1];
z[13] = prod_pow(z[7], 2);
z[14] = 2 * z[13];
z[15] = z[6] * z[14];
z[16] = 3 * z[7];
z[17] = (T(1) / T(2)) * z[11];
z[18] = -z[15] + -z[16] + z[17];
z[18] = z[6] * z[18];
z[19] = 5 * z[7];
z[20] = z[17] + z[19];
z[21] = z[8] * z[13];
z[22] = z[6] * z[13];
z[20] = (T(1) / T(2)) * z[20] + -z[21] + 4 * z[22];
z[20] = z[8] * z[20];
z[18] = -1 + z[18] + z[20];
z[18] = z[8] * z[18];
z[20] = prod_pow(z[9], 2);
z[22] = prod_pow(z[2], 2);
z[23] = (T(259) / T(36)) * z[20] + -3 * z[22];
z[24] = (T(1) / T(2)) * z[6];
z[23] = z[23] * z[24];
z[25] = (T(1) / T(2)) * z[1] + z[2];
z[25] = z[2] * z[3] * z[25];
z[26] = 3 * z[2];
z[23] = (T(-1) / T(4)) * z[1] + (T(-277) / T(72)) * z[9] + z[23] + (T(-1) / T(2)) * z[25] + -z[26];
z[23] = z[3] * z[23];
z[27] = z[6] * z[22];
z[28] = (T(-1) / T(2)) * z[9] + z[26] + z[27];
z[28] = z[6] * z[28];
z[28] = 1 + z[28];
z[23] = z[23] + (T(1) / T(2)) * z[28];
z[23] = z[3] * z[23];
z[28] = z[7] * z[9];
z[29] = z[13] + (T(1) / T(4)) * z[28];
z[30] = z[6] * z[29];
z[30] = (T(1) / T(4)) * z[9] + z[30];
z[31] = (T(-3) / T(4)) * z[2] + -2 * z[7] + -z[30];
z[31] = z[6] * z[31];
z[31] = T(-7) / T(4) + z[31];
z[31] = z[6] * z[31];
z[18] = z[18] + z[23] + z[31];
z[18] = z[0] * z[18];
z[23] = z[11] + -z[19];
z[15] = -z[15] + z[21] + (T(1) / T(4)) * z[23];
z[15] = z[8] * z[15];
z[23] = prod_pow(z[6], 2);
z[31] = -z[2] + z[11];
z[32] = z[10] * z[31];
z[33] = z[23] * z[32];
z[34] = -z[2] + (T(3) / T(4)) * z[11];
z[30] = -z[7] + -z[30] + z[34];
z[30] = z[6] * z[30];
z[35] = z[2] + -z[9];
z[35] = -z[25] + (T(1) / T(2)) * z[35];
z[36] = (T(1) / T(2)) * z[3];
z[35] = z[35] * z[36];
z[15] = T(-3) / T(4) + z[15] + z[18] + z[30] + (T(-3) / T(4)) * z[33] + z[35];
z[15] = z[0] * z[15];
z[18] = (T(1) / T(2)) * z[22];
z[28] = z[14] + -z[18] + (T(1) / T(2)) * z[28];
z[28] = z[6] * z[28];
z[30] = z[2] + -z[7];
z[30] = -z[9] + 7 * z[30];
z[30] = -z[11] + -z[28] + (T(1) / T(4)) * z[30];
z[30] = z[6] * z[30];
z[35] = -z[11] + -z[16];
z[21] = z[21] + (T(1) / T(4)) * z[35];
z[21] = z[8] * z[21];
z[35] = z[2] + z[27];
z[25] = z[25] + (T(-1) / T(2)) * z[35];
z[25] = z[3] * z[25];
z[21] = T(1) / T(2) + z[21] + z[25] + z[30] + z[33];
z[21] = z[0] * z[21];
z[25] = T(1) / T(4) + (T(1) / T(4)) * z[33];
z[22] = z[22] * z[24];
z[30] = (T(5) / T(2)) * z[11] + -z[22] + -z[26];
z[30] = z[6] * z[30];
z[30] = -z[25] + z[30];
z[30] = z[10] * z[30];
z[19] = -z[9] + -z[19] + z[26];
z[19] = -z[11] + (T(1) / T(2)) * z[19];
z[19] = (T(1) / T(2)) * z[19] + z[21] + -z[28] + z[30];
z[19] = z[0] * z[19];
z[21] = z[24] * z[32];
z[28] = 5 * z[2];
z[30] = -3 * z[11] + z[28];
z[30] = z[21] + z[27] + (T(1) / T(4)) * z[30];
z[30] = z[10] * z[30];
z[33] = 2 * z[2] + (T(-3) / T(2)) * z[11] + z[22];
z[33] = z[6] * z[33];
z[25] = z[25] + z[33];
z[25] = z[10] * z[25];
z[18] = -z[18] + -z[29];
z[18] = z[6] * z[18];
z[33] = -z[2] + z[17];
z[18] = z[18] + z[25] + (T(1) / T(2)) * z[33];
z[18] = z[0] * z[18];
z[18] = z[18] + -z[29] + z[30];
z[18] = z[0] * z[18];
z[17] = z[17] + -z[21] + -z[35];
z[17] = prod_pow(z[0], 2) * z[4] * z[10] * z[17];
z[17] = (T(1) / T(2)) * z[17] + z[18];
z[17] = z[4] * z[17];
z[18] = (T(1) / T(4)) * z[6];
z[21] = -z[18] * z[32];
z[21] = z[21] + -z[22] + z[34];
z[21] = z[10] * z[21];
z[17] = z[17] + z[19] + z[21];
z[17] = z[4] * z[17];
z[19] = -z[6] + (T(-1) / T(4)) * z[12];
z[19] = z[10] * z[19] * z[31];
z[15] = z[15] + z[17] + z[19] + (T(1) / T(4)) * z[31];
z[15] = z[4] * z[15];
z[17] = 3 * z[5] + z[11];
z[17] = z[13] * z[17];
z[19] = z[17] * z[18];
z[21] = z[5] * z[7];
z[25] = 2 * z[21];
z[29] = z[7] * z[11];
z[30] = 3 * z[13] + -z[19] + -z[25] + -z[29];
z[30] = z[6] * z[30];
z[31] = (T(5) / T(4)) * z[5];
z[30] = z[16] + z[30] + -z[31];
z[30] = z[6] * z[30];
z[32] = z[6] * z[17];
z[33] = (T(3) / T(4)) * z[32];
z[34] = 4 * z[21] + (T(5) / T(4)) * z[29] + z[33];
z[34] = z[6] * z[34];
z[13] = z[13] + z[25];
z[17] = z[8] * z[17];
z[25] = -z[13] + (T(1) / T(4)) * z[17];
z[37] = (T(1) / T(2)) * z[29];
z[33] = z[25] + -z[33] + -z[37];
z[33] = z[8] * z[33];
z[33] = z[7] + (T(-1) / T(4)) * z[11] + z[31] + z[33] + z[34];
z[33] = z[8] * z[33];
z[30] = 1 + z[30] + z[33];
z[30] = z[8] * z[30];
z[14] = -z[14] + (T(1) / T(4)) * z[29];
z[33] = z[6] * z[14];
z[34] = -15 * z[7] + z[11];
z[33] = z[33] + (T(1) / T(4)) * z[34];
z[33] = z[6] * z[33];
z[33] = -2 + z[33];
z[33] = z[6] * z[33];
z[30] = z[30] + z[33];
z[30] = z[8] * z[30];
z[33] = (T(1) / T(2)) * z[5];
z[34] = -z[2] + z[33];
z[38] = z[2] * z[6];
z[39] = -z[34] * z[38];
z[40] = 9 * z[2] + -z[5] + (T(259) / T(18)) * z[9];
z[39] = z[39] + (T(1) / T(2)) * z[40];
z[39] = z[6] * z[39];
z[33] = z[8] * z[33];
z[39] = T(-133) / T(36) + -z[33] + z[39];
z[22] = -z[5] * z[22];
z[31] = z[2] + -z[31];
z[31] = z[2] * z[31];
z[22] = z[22] + z[31];
z[22] = z[6] * z[22];
z[26] = (T(223) / T(36)) * z[5] + (T(277) / T(36)) * z[9] + z[26];
z[22] = z[22] + (T(1) / T(2)) * z[26];
z[22] = z[3] * z[22];
z[22] = z[22] + (T(1) / T(2)) * z[39];
z[22] = z[3] * z[22];
z[26] = T(-3) / T(2) + -z[38];
z[24] = z[24] * z[26];
z[26] = -1 + -z[33];
z[26] = z[8] * z[26];
z[22] = z[22] + z[24] + z[26];
z[22] = z[3] * z[22];
z[24] = z[6] * z[7];
z[24] = 1 + z[24];
z[23] = z[23] * z[24];
z[22] = z[22] + (T(-1) / T(4)) * z[23] + z[30];
z[22] = z[0] * z[22];
z[13] = 2 * z[13] + (T(-1) / T(2)) * z[17] + z[32] + z[37];
z[13] = z[8] * z[13];
z[17] = -7 * z[21] + -z[29];
z[17] = (T(3) / T(2)) * z[17] + -z[32];
z[17] = z[6] * z[17];
z[17] = -5 * z[5] + (T(-9) / T(2)) * z[7] + z[17];
z[13] = z[13] + (T(1) / T(2)) * z[17];
z[13] = z[8] * z[13];
z[14] = z[14] + (T(5) / T(4)) * z[21];
z[14] = z[6] * z[14];
z[16] = (T(5) / T(2)) * z[5] + -z[16];
z[14] = z[14] + (T(1) / T(2)) * z[16];
z[14] = z[6] * z[14];
z[13] = T(-3) / T(4) + z[13] + z[14];
z[13] = z[8] * z[13];
z[14] = (T(259) / T(72)) * z[20];
z[16] = z[2] + (T(-7) / T(4)) * z[5];
z[16] = z[2] * z[16];
z[17] = -z[5] * z[27];
z[16] = -z[14] + z[16] + z[17];
z[16] = z[6] * z[16];
z[17] = (T(13) / T(3)) * z[5] + (T(337) / T(18)) * z[9] + z[28];
z[14] = z[3] * z[14];
z[14] = z[14] + z[16] + (T(1) / T(4)) * z[17];
z[14] = z[3] * z[14];
z[16] = -1 + -z[38];
z[16] = z[6] * z[16] * z[34];
z[16] = 1 + z[16];
z[17] = z[5] * z[8];
z[14] = z[14] + (T(1) / T(2)) * z[16] + z[17];
z[14] = z[3] * z[14];
z[16] = z[18] * z[24];
z[13] = z[13] + z[14] + z[16] + z[22];
z[13] = z[0] * z[13];
z[14] = -z[19] + z[25];
z[14] = z[8] * z[14];
z[16] = z[6] * z[21];
z[16] = z[5] + z[7] + z[16];
z[14] = z[14] + (T(5) / T(4)) * z[16];
z[14] = z[8] * z[14];
z[16] = -z[6] * z[35];
z[16] = T(-25) / T(12) + z[16];
z[16] = z[5] * z[16] * z[36];
return z[13] + z[14] + z[15] + z[16];
}



template double eval_coef_2q3y_2l_pmmpp_12345_142(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_142(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
