#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_143(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[43];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[2];
z[5] = iW[22];
z[6] = v[4];
z[7] = iW[15];
z[8] = v[3];
z[9] = iW[16];
z[10] = iW[17];
z[11] = iW[18];
z[12] = prod_pow(z[4], 2);
z[13] = (T(1) / T(2)) * z[12];
z[14] = prod_pow(z[0], 2);
z[15] = z[3] * z[14];
z[16] = z[13] * z[15];
z[17] = z[0] * z[12];
z[16] = z[16] + z[17];
z[16] = z[3] * z[16];
z[16] = z[13] + z[16];
z[16] = z[2] * z[3] * z[16];
z[17] = z[4] * z[14];
z[18] = z[3] * z[17];
z[19] = 3 * z[0] + -z[17];
z[19] = z[4] * z[19];
z[19] = z[18] + z[19];
z[20] = (T(1) / T(2)) * z[3];
z[19] = z[19] * z[20];
z[21] = z[0] * z[4];
z[22] = 1 + (T(-1) / T(2)) * z[21];
z[22] = z[4] * z[22];
z[19] = z[19] + z[22];
z[19] = z[3] * z[19];
z[19] = z[16] + z[19];
z[19] = z[2] * z[19];
z[22] = (T(3) / T(2)) * z[4];
z[22] = z[14] * z[22];
z[23] = z[0] + z[22];
z[24] = -z[4] + -z[8];
z[24] = z[23] * z[24];
z[25] = (T(1) / T(2)) * z[0];
z[26] = z[17] + z[25];
z[27] = -z[3] * z[26];
z[24] = z[24] + z[27];
z[24] = z[8] * z[24];
z[27] = -z[0] + z[17];
z[20] = -z[20] * z[27];
z[28] = z[0] + z[17];
z[29] = z[4] * z[28];
z[20] = T(1) / T(2) + z[20] + -z[29];
z[20] = z[3] * z[20];
z[19] = z[19] + z[20] + z[24];
z[19] = z[9] * z[19];
z[20] = (T(1) / T(2)) * z[4];
z[24] = z[14] * z[20];
z[30] = z[0] + z[24];
z[30] = z[4] * z[30];
z[31] = z[8] * z[14];
z[32] = -z[27] + -z[31];
z[33] = (T(1) / T(2)) * z[8];
z[32] = z[32] * z[33];
z[32] = z[30] + z[32];
z[32] = z[8] * z[32];
z[34] = z[13] * z[28];
z[32] = z[32] + z[34];
z[32] = z[5] * z[32];
z[35] = z[17] + (T(1) / T(2)) * z[31];
z[35] = z[8] * z[35];
z[36] = -z[13] * z[14];
z[32] = z[32] + -z[35] + z[36];
z[32] = z[8] * z[10] * z[32];
z[35] = T(1) / T(2) + z[21] + -z[35];
z[36] = prod_pow(z[8], 2);
z[35] = z[35] * z[36];
z[37] = z[12] * z[14];
z[38] = z[8] * z[28];
z[38] = -1 + z[37] + z[38];
z[38] = z[8] * z[38];
z[39] = 1 + z[21];
z[40] = z[4] * z[39];
z[38] = z[38] + -z[40];
z[40] = (T(1) / T(2)) * z[36];
z[41] = -z[5] * z[38] * z[40];
z[35] = z[35] + z[41];
z[35] = z[5] * z[35];
z[41] = -z[0] + z[31];
z[40] = -z[40] * z[41];
z[35] = z[35] + z[40];
z[35] = z[7] * z[35];
z[19] = z[19] + z[32] + z[35];
z[32] = z[6] * z[14];
z[35] = z[8] * z[32];
z[40] = 3 * z[17];
z[42] = -z[6] * z[40];
z[29] = z[29] + -z[35] + z[42];
z[29] = z[29] * z[33];
z[33] = -z[23] + z[32];
z[33] = z[6] * z[33];
z[33] = z[21] + z[33];
z[33] = z[6] * z[33];
z[29] = z[29] + z[33] + z[34];
z[29] = z[8] * z[29];
z[33] = -2 * z[17] + -z[25];
z[33] = z[4] * z[33];
z[25] = z[17] + -z[25];
z[25] = z[6] * z[25];
z[25] = T(1) / T(2) + z[25] + z[33];
z[25] = z[6] * z[25];
z[12] = z[12] * z[28];
z[12] = z[12] + z[25];
z[12] = z[6] * z[12];
z[25] = 2 * z[0];
z[33] = -z[22] + -z[25];
z[33] = z[4] * z[33];
z[34] = (T(1) / T(2)) * z[32];
z[42] = z[23] + -z[34];
z[42] = z[6] * z[42];
z[33] = T(-1) / T(2) + z[33] + z[42];
z[33] = z[6] * z[33];
z[30] = T(1) / T(2) + z[30];
z[30] = z[4] * z[30];
z[30] = z[30] + z[33];
z[30] = prod_pow(z[6], 2) * z[1] * z[30];
z[33] = z[9] * z[36] * z[38];
z[12] = z[12] + z[29] + z[30] + (T(-1) / T(4)) * z[33];
z[12] = z[5] * z[12];
z[29] = 1 + (T(3) / T(2)) * z[21];
z[29] = z[20] * z[29];
z[30] = (T(-3) / T(4)) * z[0] + -z[17];
z[30] = z[8] * z[30];
z[30] = T(1) / T(2) + z[30] + -z[37];
z[30] = z[8] * z[30];
z[29] = z[29] + z[30];
z[29] = z[9] * z[29];
z[23] = z[20] * z[23];
z[30] = -z[0] + z[32];
z[22] = -z[22] + -z[30];
z[22] = z[6] * z[22];
z[22] = z[22] + z[23] + z[29] + -z[35];
z[22] = z[8] * z[22];
z[23] = (T(-7) / T(4)) * z[17] + -z[25] + z[32];
z[23] = z[6] * z[23];
z[25] = (T(9) / T(2)) * z[0] + z[17];
z[25] = z[20] * z[25];
z[23] = 1 + z[23] + z[25];
z[23] = z[6] * z[23];
z[25] = z[20] * z[27];
z[25] = -1 + z[25];
z[29] = z[20] * z[25];
z[23] = z[23] + z[29];
z[23] = z[1] * z[23];
z[29] = -z[0] + -5 * z[17];
z[29] = (T(1) / T(2)) * z[29] + z[32];
z[29] = z[6] * z[29];
z[32] = (T(3) / T(2)) * z[0] + z[17];
z[32] = z[4] * z[32];
z[23] = T(-1) / T(2) + z[23] + z[29] + z[32];
z[23] = z[6] * z[23];
z[13] = z[13] * z[26];
z[12] = z[12] + z[13] + z[22] + z[23];
z[12] = z[5] * z[12];
z[13] = z[15] + z[24];
z[13] = z[3] * z[13];
z[13] = z[13] + z[25];
z[22] = (T(1) / T(4)) * z[17];
z[23] = z[0] + z[22] + -z[34];
z[23] = z[6] * z[23];
z[13] = (T(1) / T(2)) * z[13] + z[23];
z[13] = z[6] * z[13];
z[23] = z[20] * z[39];
z[24] = 7 * z[0];
z[25] = z[17] + z[24];
z[25] = z[20] * z[25];
z[25] = 3 * z[18] + z[25];
z[25] = z[3] * z[25];
z[23] = z[23] + z[25];
z[23] = z[3] * z[23];
z[16] = 3 * z[16] + z[23];
z[16] = z[2] * z[16];
z[23] = (T(-19) / T(3)) * z[0] + (T(-223) / T(18)) * z[15] + z[17];
z[23] = z[3] * z[23];
z[23] = T(13) / T(6) + z[21] + z[23];
z[23] = z[3] * z[23];
z[13] = z[13] + (T(1) / T(2)) * z[16] + (T(1) / T(4)) * z[23];
z[13] = z[1] * z[13];
z[16] = prod_pow(z[3], 2);
z[14] = z[14] * z[16];
z[23] = z[15] + z[28];
z[25] = z[2] * z[16];
z[23] = z[23] * z[25];
z[23] = 2 * z[14] + z[23];
z[23] = z[2] * z[23];
z[28] = z[16] * z[31];
z[29] = -prod_pow(z[2], 2) * z[28];
z[23] = z[23] + z[26] + z[29] + -z[34];
z[23] = z[8] * z[23];
z[29] = z[15] + -z[41];
z[29] = z[25] * z[29];
z[14] = (T(-259) / T(9)) * z[14] + z[29];
z[14] = z[8] * z[14];
z[27] = -z[15] + z[27];
z[27] = z[16] * z[27];
z[27] = z[27] + z[28];
z[27] = z[8] * z[27];
z[28] = -z[16] * z[21];
z[27] = z[27] + z[28];
z[27] = z[11] * z[27];
z[28] = 337 * z[0] + -259 * z[17];
z[28] = 67 * z[15] + (T(1) / T(8)) * z[28];
z[28] = z[16] * z[28];
z[14] = (T(1) / T(4)) * z[14] + (T(259) / T(72)) * z[27] + (T(1) / T(9)) * z[28];
z[14] = z[11] * z[14];
z[24] = -9 * z[15] + -z[24] + -z[40];
z[16] = z[16] * z[24];
z[18] = -z[18] + -z[21];
z[18] = z[18] * z[25];
z[16] = (T(1) / T(4)) * z[16] + 2 * z[18];
z[16] = z[2] * z[16];
z[18] = z[20] * z[26];
z[15] = (T(1) / T(4)) * z[0] + (T(223) / T(72)) * z[15] + z[17];
z[15] = z[3] * z[15];
z[17] = z[22] + -z[30];
z[17] = z[6] * z[17];
return z[12] + z[13] + z[14] + z[15] + z[16] + z[17] + z[18] + (T(1) / T(2)) * z[19] + z[23];
}



template double eval_coef_2q3y_2l_pmmpp_12345_143(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_143(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
