#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_145(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[40];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[15];
z[3] = v[2];
z[4] = v[4];
z[5] = iW[3];
z[6] = iW[21];
z[7] = v[1];
z[8] = iW[12];
z[9] = v[0];
z[10] = iW[7];
z[11] = v[3];
z[12] = prod_pow(z[11], 2);
z[13] = prod_pow(z[1], 2);
z[14] = z[12] * z[13];
z[15] = z[2] * z[14];
z[16] = z[11] * z[13];
z[17] = z[9] * z[16];
z[18] = -z[1] + z[16];
z[19] = z[11] * z[18];
z[19] = -3 * z[17] + z[19];
z[20] = (T(1) / T(2)) * z[6];
z[19] = z[19] * z[20];
z[21] = (T(1) / T(2)) * z[0];
z[22] = -z[1] + z[21];
z[23] = z[9] * z[13];
z[15] = (T(5) / T(4)) * z[15] + z[16] + z[19] + (T(-5) / T(2)) * z[22] + (T(15) / T(4)) * z[23];
z[15] = z[6] * z[15];
z[19] = (T(1) / T(2)) * z[2];
z[24] = z[14] * z[19];
z[25] = (T(1) / T(2)) * z[11];
z[25] = z[13] * z[25];
z[26] = (T(3) / T(2)) * z[23];
z[22] = -z[22] + z[24] + z[25] + z[26];
z[22] = z[6] * z[22];
z[27] = z[0] + z[1];
z[28] = z[2] * z[27];
z[29] = z[13] + z[28];
z[30] = (T(1) / T(2)) * z[9];
z[31] = z[13] * z[30];
z[21] = z[1] + z[21] + z[31];
z[21] = z[5] * z[21];
z[29] = z[21] + (T(1) / T(4)) * z[29];
z[29] = z[5] * z[29];
z[31] = z[16] + z[27];
z[32] = prod_pow(z[2], 2) * z[31];
z[29] = z[29] + (T(-1) / T(4)) * z[32];
z[32] = -z[2] * z[31];
z[32] = -z[13] + z[32];
z[21] = -z[21] + (T(1) / T(2)) * z[32];
z[21] = z[6] * z[21];
z[21] = z[21] + -z[29];
z[21] = z[3] * z[21];
z[24] = (T(-7) / T(2)) * z[16] + -z[24] + -3 * z[27];
z[24] = z[2] * z[24];
z[27] = 5 * z[1];
z[32] = (T(-7) / T(2)) * z[0] + -z[26] + -z[27];
z[32] = z[5] * z[32];
z[24] = -3 * z[13] + z[24] + z[32];
z[21] = z[21] + z[22] + (T(1) / T(2)) * z[24];
z[21] = z[6] * z[21];
z[21] = z[21] + -z[29];
z[21] = z[3] * z[21];
z[22] = z[0] * z[1];
z[24] = -z[8] * z[16];
z[24] = -5 * z[13] + -z[22] + z[24];
z[25] = -z[1] + z[25];
z[29] = z[11] * z[25];
z[29] = T(1) / T(2) + z[29];
z[29] = z[2] * z[29];
z[31] = z[29] + (T(-5) / T(2)) * z[31];
z[31] = z[2] * z[31];
z[24] = (T(1) / T(2)) * z[24] + z[31];
z[31] = (T(1) / T(2)) * z[13];
z[32] = z[4] * z[13];
z[33] = z[8] * z[32];
z[33] = -z[28] + -z[31] + (T(-3) / T(2)) * z[33];
z[33] = z[4] * z[33];
z[34] = (T(-25) / T(3)) * z[0] + -9 * z[1];
z[26] = -z[26] + z[33] + (T(1) / T(2)) * z[34];
z[33] = -z[1] + z[32];
z[30] = -z[30] * z[33];
z[34] = z[0] * z[7];
z[35] = z[8] * z[13];
z[36] = prod_pow(z[4], 2) * z[35];
z[36] = (T(-19) / T(12)) * z[0] + -z[1] + (T(-1) / T(4)) * z[36];
z[36] = z[4] * z[36];
z[30] = 1 + z[30] + (T(4) / T(3)) * z[34] + z[36];
z[30] = z[5] * z[30];
z[26] = (T(1) / T(2)) * z[26] + z[30];
z[26] = z[5] * z[26];
z[30] = z[0] + (T(-7) / T(6)) * z[1] + (T(19) / T(6)) * z[16];
z[30] = z[2] * z[30];
z[30] = z[22] + z[30];
z[30] = (T(-4) / T(3)) * z[13] + (T(1) / T(4)) * z[30];
z[30] = z[2] * z[30];
z[30] = z[30] + (T(-3) / T(4)) * z[35];
z[30] = z[4] * z[30];
z[36] = (T(3) / T(2)) * z[10];
z[29] = -z[29] * z[36];
z[15] = z[15] + z[21] + (T(1) / T(2)) * z[24] + z[26] + z[29] + z[30];
z[15] = z[3] * z[15];
z[21] = (T(5) / T(2)) * z[1];
z[24] = z[16] + -z[21];
z[24] = z[8] * z[24];
z[24] = z[22] + z[24] + -z[31];
z[26] = (T(19) / T(3)) * z[1];
z[29] = z[0] + z[26];
z[29] = z[19] * z[29];
z[29] = (T(11) / T(3)) * z[13] + -z[22] + z[29];
z[19] = z[19] * z[29];
z[19] = z[19] + z[35];
z[19] = z[4] * z[19];
z[29] = (T(3) / T(4)) * z[16];
z[30] = z[1] * z[11];
z[31] = T(-19) / T(2) + 11 * z[30];
z[31] = z[2] * z[31];
z[31] = -z[0] + (T(-125) / T(24)) * z[1] + z[29] + (T(1) / T(6)) * z[31];
z[31] = z[2] * z[31];
z[19] = z[19] + (T(1) / T(2)) * z[24] + z[31];
z[19] = z[4] * z[19];
z[24] = (T(1) / T(2)) * z[4];
z[31] = z[24] * z[35];
z[37] = -z[1] * z[8];
z[28] = (T(-23) / T(12)) * z[13] + (T(-13) / T(24)) * z[28] + z[31] + z[37];
z[28] = z[4] * z[28];
z[31] = -5 * z[0] + -z[1];
z[28] = z[28] + (T(5) / T(12)) * z[31];
z[28] = z[4] * z[28];
z[31] = z[13] * z[24];
z[37] = -z[1] + z[31];
z[37] = z[4] * z[37];
z[37] = T(1) / T(2) + z[37];
z[37] = z[9] * z[37];
z[26] = -z[26] + z[31];
z[26] = z[4] * z[26];
z[26] = T(67) / T(6) + z[26];
z[26] = z[24] * z[26];
z[26] = (T(-8) / T(3)) * z[7] + z[26] + -z[37];
z[26] = z[5] * z[26];
z[38] = (T(3) / T(4)) * z[9];
z[39] = -z[33] * z[38];
z[26] = T(7) / T(3) + z[26] + z[28] + (T(17) / T(8)) * z[34] + z[39];
z[26] = z[5] * z[26];
z[28] = -z[8] * z[30];
z[27] = (T(-17) / T(2)) * z[0] + -z[16] + z[27] + z[28];
z[28] = -1 + z[30];
z[30] = -1 + (T(1) / T(2)) * z[30];
z[34] = z[11] * z[30];
z[34] = (T(1) / T(2)) * z[7] + z[34];
z[34] = z[2] * z[34];
z[34] = (T(-3) / T(2)) * z[28] + z[34];
z[34] = z[2] * z[34];
z[27] = (T(1) / T(2)) * z[27] + z[34];
z[18] = -z[18] + z[23];
z[12] = z[6] * z[12] * z[18];
z[18] = 3 * z[16] + -z[21];
z[18] = z[11] * z[18];
z[17] = z[12] + (T(-13) / T(2)) * z[17] + z[18];
z[17] = z[17] * z[20];
z[18] = (T(1) / T(2)) * z[28];
z[20] = -z[4] * z[16];
z[20] = z[18] + z[20];
z[20] = z[20] * z[36];
z[15] = z[15] + z[17] + z[19] + z[20] + 2 * z[23] + z[26] + (T(1) / T(2)) * z[27];
z[15] = z[3] * z[15];
z[13] = -z[13] + -z[22];
z[17] = -z[8] * z[25];
z[19] = (T(19) / T(6)) * z[2];
z[20] = z[0] * z[19];
z[20] = z[20] + z[22];
z[20] = z[2] * z[20];
z[20] = z[20] + -z[35];
z[20] = z[20] * z[24];
z[19] = (T(-19) / T(3)) * z[0] + (T(1) / T(2)) * z[1] + z[19];
z[19] = z[2] * z[19];
z[13] = (T(1) / T(2)) * z[13] + z[17] + z[19] + z[20];
z[13] = z[13] * z[24];
z[17] = z[25] + z[31];
z[17] = z[4] * z[17];
z[17] = z[17] + -z[18];
z[17] = z[17] * z[36];
z[18] = z[8] * z[30];
z[19] = -z[7] + z[11];
z[19] = z[2] * z[19];
z[20] = -17 + (T(19) / T(3)) * z[19];
z[20] = z[2] * z[20];
z[13] = (T(17) / T(8)) * z[0] + z[1] + z[13] + z[17] + (T(1) / T(2)) * z[18] + (T(1) / T(8)) * z[20] + -z[29];
z[13] = z[4] * z[13];
z[14] = -1 + z[14];
z[14] = 3 * z[14] + z[19];
z[16] = -z[16] + z[33];
z[16] = z[16] * z[38];
z[17] = -3 * z[1] + z[32];
z[17] = z[4] * z[17];
z[17] = 3 + z[17];
z[17] = z[4] * z[17];
z[17] = -z[7] + z[17];
z[17] = (T(17) / T(4)) * z[17] + -z[37];
z[18] = z[1] + (T(-1) / T(3)) * z[32];
z[18] = z[4] * z[18];
z[18] = -1 + z[18];
z[18] = z[4] * z[18];
z[18] = (T(1) / T(3)) * z[7] + z[18];
z[18] = z[5] * z[9] * z[18];
z[17] = (T(1) / T(2)) * z[17] + 4 * z[18];
z[17] = z[5] * z[17];
return (T(3) / T(4)) * z[12] + z[13] + (T(1) / T(4)) * z[14] + z[15] + z[16] + z[17];
}



template double eval_coef_2q3y_2l_pmmpp_12345_145(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_145(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
