#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_149(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[35];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[3];
z[4] = v[4];
z[5] = iW[3];
z[6] = v[1];
z[7] = iW[21];
z[8] = iW[15];
z[9] = iW[17];
z[10] = iW[5];
z[11] = v[0];
z[12] = iW[7];
z[13] = iW[18];
z[14] = (T(1) / T(2)) * z[3];
z[15] = prod_pow(z[9], 2);
z[16] = -z[14] * z[15];
z[17] = (T(1) / T(2)) * z[9];
z[18] = z[4] * z[17];
z[19] = (T(5) / T(2)) * z[5];
z[20] = -z[10] + z[19];
z[21] = -z[9] + -z[20];
z[21] = z[18] * z[21];
z[22] = (T(5) / T(4)) * z[9];
z[23] = prod_pow(z[5], 2);
z[24] = z[11] * z[23];
z[25] = (T(53) / T(18)) * z[24];
z[26] = (T(1) / T(4)) * z[8];
z[16] = (T(-49) / T(9)) * z[5] + (T(-1) / T(2)) * z[10] + z[16] + z[21] + -z[22] + z[25] + z[26];
z[16] = z[4] * z[16];
z[21] = z[9] * z[20];
z[21] = z[21] + (T(3) / T(2)) * z[23];
z[27] = (T(1) / T(2)) * z[4];
z[21] = z[21] * z[27];
z[19] = z[10] + z[19] + z[21] + z[22];
z[19] = z[4] * z[19];
z[21] = 2 * z[12];
z[22] = z[21] + -z[26];
z[28] = z[17] + -z[22];
z[28] = z[3] * z[28];
z[29] = z[5] * z[11];
z[30] = -5 + 23 * z[29];
z[19] = z[19] + z[28] + (T(5) / T(36)) * z[30];
z[19] = z[4] * z[19];
z[28] = z[7] * z[11];
z[30] = -z[7] + z[8] + -5 * z[13];
z[30] = z[3] * z[30];
z[30] = 5 + 3 * z[28] + z[30];
z[30] = z[14] * z[30];
z[30] = -z[11] + z[30];
z[19] = z[19] + (T(1) / T(2)) * z[30];
z[19] = z[1] * z[19];
z[30] = (T(1) / T(4)) * z[0];
z[31] = (T(1) / T(4)) * z[7];
z[32] = (T(-3) / T(4)) * z[8] + -z[9] + z[12] + (T(5) / T(4)) * z[13] + z[30] + z[31];
z[32] = z[3] * z[32];
z[33] = -3 + -z[29];
z[16] = z[16] + z[19] + z[32] + (T(1) / T(4)) * z[33];
z[16] = z[1] * z[16];
z[19] = -z[12] + (T(3) / T(4)) * z[13];
z[19] = z[8] * z[19];
z[32] = -z[7] * z[26];
z[32] = z[19] + z[32];
z[32] = z[3] * z[32];
z[32] = -z[9] + z[26] + -z[31] + z[32];
z[32] = z[3] * z[32];
z[33] = -z[5] * z[9];
z[33] = -3 * z[23] + z[33];
z[33] = z[4] * z[33];
z[20] = -z[17] + -z[20] + (T(1) / T(4)) * z[33];
z[20] = z[4] * z[9] * z[20];
z[15] = z[3] * z[15];
z[15] = (T(1) / T(4)) * z[15];
z[20] = (T(-9) / T(4)) * z[9] + -z[10] + -z[15] + z[20];
z[20] = z[4] * z[20];
z[28] = T(31) / T(9) + (T(-3) / T(2)) * z[28] + (T(1) / T(2)) * z[29];
z[20] = z[20] + (T(1) / T(2)) * z[28] + z[32];
z[20] = z[1] * z[20];
z[28] = z[3] * z[8];
z[21] = (T(-3) / T(2)) * z[13] + z[21];
z[21] = z[21] * z[28];
z[32] = (T(1) / T(2)) * z[8];
z[33] = z[5] + z[32];
z[34] = -z[7] + z[33];
z[18] = -z[10] * z[18];
z[18] = z[18] + z[20] + z[21] + (T(1) / T(2)) * z[34];
z[18] = z[1] * z[18];
z[20] = (T(1) / T(2)) * z[7];
z[21] = z[5] + z[8];
z[21] = z[0] * z[20] * z[21];
z[28] = 1 + z[28] + z[29];
z[28] = z[7] * z[28];
z[29] = z[9] * z[10];
z[34] = -z[4] * z[29];
z[28] = (T(1) / T(2)) * z[28] + z[34];
z[28] = z[1] * z[28];
z[33] = z[7] * z[33];
z[28] = z[28] + z[33];
z[28] = z[1] * z[28];
z[21] = z[21] + z[28];
z[21] = z[2] * z[21];
z[21] = z[21] + (T(53) / T(18)) * z[23] + z[29];
z[28] = z[6] * z[23];
z[28] = (T(223) / T(18)) * z[5] + -z[9] + (T(-107) / T(9)) * z[28] + z[32];
z[28] = (T(1) / T(2)) * z[28] + z[31];
z[28] = z[0] * z[28];
z[18] = z[18] + z[19] + (T(1) / T(2)) * z[21] + z[28];
z[18] = z[2] * z[18];
z[19] = (T(-205) / T(18)) * z[5] + z[9] + z[32];
z[19] = z[0] * z[19];
z[19] = z[19] + (T(-491) / T(18)) * z[23] + -z[29];
z[19] = z[19] * z[27];
z[21] = z[10] * z[17];
z[21] = z[21] + (T(116) / T(9)) * z[23];
z[21] = z[6] * z[21];
z[27] = -z[12] + z[32];
z[28] = (T(-31) / T(9)) * z[5] + -z[9];
z[28] = z[6] * z[28];
z[28] = T(71) / T(18) + z[28];
z[28] = z[0] * z[28];
z[16] = (T(-331) / T(36)) * z[5] + (T(3) / T(2)) * z[10] + z[16] + z[18] + z[19] + z[21] + -z[25] + z[27] + (T(1) / T(2)) * z[28];
z[16] = z[2] * z[16];
z[18] = z[0] * z[4];
z[18] = -1 + z[18];
z[18] = z[18] * z[26];
z[19] = z[5] * z[10];
z[21] = -7 * z[19] + (T(599) / T(18)) * z[23];
z[28] = z[10] * z[24];
z[29] = 3 * z[28];
z[21] = (T(1) / T(2)) * z[21] + -z[29];
z[21] = z[11] * z[21];
z[31] = 2 * z[10];
z[15] = (T(-20) / T(9)) * z[0] + (T(-37) / T(6)) * z[5] + z[12] + -z[15] + z[18] + z[21] + -z[31];
z[15] = z[4] * z[15];
z[17] = z[17] + z[27] + -z[30];
z[17] = z[3] * z[17];
z[18] = (T(-1) / T(2)) * z[19] + (T(-85) / T(9)) * z[23] + z[29];
z[18] = z[11] * z[18];
z[18] = (T(277) / T(36)) * z[5] + (T(1) / T(4)) * z[9] + z[18] + -z[22];
z[18] = z[4] * z[18];
z[21] = (T(25) / T(36)) * z[5] + -z[10] + -z[25];
z[21] = z[11] * z[21];
z[17] = T(13) / T(4) + z[17] + z[18] + z[21];
z[17] = z[4] * z[17];
z[18] = (T(53) / T(36)) * z[24];
z[21] = (T(-133) / T(36)) * z[5] + z[18] + z[31];
z[21] = z[11] * z[21];
z[22] = z[19] + (T(1) / T(2)) * z[23];
z[22] = (T(3) / T(2)) * z[22] + -z[28];
z[22] = z[11] * z[22];
z[22] = (T(-7) / T(4)) * z[5] + z[12] + z[22];
z[22] = z[4] * z[22];
z[24] = z[3] * z[12];
z[21] = T(-37) / T(36) + z[21] + z[22] + z[24];
z[21] = z[4] * z[21];
z[21] = (T(1) / T(4)) * z[11] + z[21];
z[21] = z[4] * z[21];
z[22] = z[3] + -z[11];
z[20] = -z[13] + z[20];
z[22] = z[20] * z[22];
z[22] = T(1) / T(2) + z[22];
z[22] = z[3] * z[22];
z[24] = (T(1) / T(2)) * z[11];
z[22] = z[22] + -z[24];
z[14] = z[14] * z[22];
z[14] = z[14] + z[21];
z[14] = z[1] * z[14];
z[20] = -z[20] + z[32];
z[20] = z[3] * z[20];
z[20] = T(-1) / T(2) + z[20];
z[20] = z[3] * z[20];
z[20] = z[20] + -z[24];
z[14] = z[14] + z[17] + (T(1) / T(2)) * z[20];
z[14] = z[1] * z[14];
z[17] = 5 * z[19] + (T(-143) / T(9)) * z[23];
z[17] = (T(1) / T(2)) * z[17] + z[28];
z[17] = z[11] * z[17];
z[19] = (T(1) / T(9)) * z[5] + z[10];
z[17] = z[17] + 2 * z[19] + z[26];
z[17] = z[6] * z[17];
z[18] = 3 * z[5] + -z[10] + z[18];
z[18] = z[11] * z[18];
z[19] = -z[3] * z[32];
return -1 + z[14] + z[15] + z[16] + z[17] + z[18] + z[19];
}



template double eval_coef_2q3y_2l_pmmpp_12345_149(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_149(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
