#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_151(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[36];
z[0] = iW[0];
z[1] = iW[3];
z[2] = v[1];
z[3] = v[2];
z[4] = iW[19];
z[5] = v[4];
z[6] = iW[17];
z[7] = v[3];
z[8] = iW[1];
z[9] = iW[5];
z[10] = v[0];
z[11] = iW[4];
z[12] = iW[15];
z[13] = iW[18];
z[14] = -z[7] + z[10];
z[15] = z[7] * z[13];
z[16] = -1 + z[15];
z[17] = (T(1) / T(2)) * z[10];
z[14] = z[14] * z[16] * z[17];
z[16] = (T(1) / T(2)) * z[4];
z[18] = -z[6] + z[16];
z[19] = (T(1) / T(2)) * z[13];
z[20] = -z[18] + z[19];
z[20] = z[7] * z[20];
z[20] = T(-101) / T(18) + z[20];
z[20] = z[3] * z[20];
z[19] = -z[6] + z[19];
z[19] = z[7] * z[19];
z[19] = T(247) / T(18) + z[19];
z[19] = z[7] * z[19];
z[15] = T(-101) / T(9) + -z[15];
z[15] = z[10] * z[15];
z[15] = z[15] + z[19] + z[20];
z[15] = z[3] * z[15];
z[14] = z[14] + z[15];
z[15] = prod_pow(z[6], 2);
z[19] = (T(1) / T(2)) * z[3];
z[20] = z[15] * z[19];
z[21] = 2 * z[4] + (T(-7) / T(4)) * z[6] + z[20];
z[21] = z[3] * z[21];
z[22] = z[9] * z[10];
z[23] = z[6] * z[7];
z[24] = z[9] * z[23];
z[25] = -z[6] + z[24];
z[26] = (T(-1) / T(4)) * z[4] + -z[25];
z[26] = z[7] * z[26];
z[27] = z[6] + -z[9] + -z[24];
z[27] = -z[4] + (T(1) / T(2)) * z[27];
z[28] = z[5] * z[27];
z[21] = T(-19) / T(18) + z[21] + -z[22] + z[26] + z[28];
z[21] = z[5] * z[21];
z[26] = -z[4] + 3 * z[6];
z[28] = z[7] * z[15];
z[28] = z[26] + (T(1) / T(4)) * z[28];
z[28] = z[3] * z[28];
z[18] = z[7] * z[18];
z[18] = T(139) / T(36) + z[18] + z[28];
z[18] = z[3] * z[18];
z[25] = z[9] + -z[25];
z[25] = z[7] * z[25];
z[25] = T(-137) / T(18) + z[25];
z[25] = z[7] * z[25];
z[25] = (T(229) / T(18)) * z[10] + z[25];
z[18] = z[18] + z[21] + (T(1) / T(2)) * z[25];
z[18] = z[5] * z[18];
z[21] = (T(1) / T(4)) * z[3];
z[25] = z[15] * z[21];
z[28] = (T(5) / T(2)) * z[4];
z[25] = -z[6] + z[25] + z[28];
z[25] = z[3] * z[25];
z[29] = z[4] * z[5];
z[30] = T(13) / T(2) + -z[22];
z[25] = z[25] + (T(-5) / T(4)) * z[29] + (T(1) / T(2)) * z[30];
z[25] = z[5] * z[25];
z[28] = 7 * z[6] + -z[28];
z[28] = z[3] * z[28];
z[28] = T(-19) / T(2) + z[28];
z[28] = z[19] * z[28];
z[25] = (T(46) / T(9)) * z[10] + z[25] + z[28];
z[25] = z[5] * z[25];
z[28] = z[3] * z[10];
z[30] = prod_pow(z[10], 2);
z[31] = -193 * z[28] + -101 * z[30];
z[25] = z[25] + (T(1) / T(36)) * z[31];
z[25] = z[5] * z[25];
z[31] = T(-7) / T(2) + z[22];
z[31] = z[10] * z[31];
z[32] = -z[4] + (T(5) / T(2)) * z[6];
z[33] = z[3] * z[32];
z[33] = T(-7) / T(2) + z[33];
z[33] = z[3] * z[33];
z[31] = z[31] + z[33];
z[33] = z[3] * z[4];
z[34] = (T(1) / T(2)) * z[29];
z[35] = T(1) / T(2) + z[33] + -z[34];
z[35] = z[5] * z[35];
z[31] = (T(1) / T(2)) * z[31] + z[35];
z[31] = z[5] * z[31];
z[31] = (T(-23) / T(9)) * z[30] + z[31];
z[31] = prod_pow(z[5], 2) * z[1] * z[31];
z[25] = z[25] + z[31];
z[25] = z[1] * z[25];
z[14] = (T(1) / T(2)) * z[14] + z[18] + z[25];
z[14] = z[8] * z[14];
z[18] = z[24] + (T(-1) / T(2)) * z[26];
z[18] = z[7] * z[18];
z[18] = T(5) / T(6) + z[18] + z[22];
z[24] = (T(1) / T(2)) * z[7];
z[15] = z[15] * z[24];
z[15] = z[15] + z[32];
z[15] = z[3] * z[15];
z[20] = z[20] + -z[27];
z[20] = z[5] * z[20];
z[15] = z[15] + (T(1) / T(2)) * z[18] + z[20];
z[15] = z[5] * z[15];
z[18] = T(-349) / T(18) + -z[22];
z[20] = (T(-7) / T(4)) * z[4] + 2 * z[6];
z[20] = z[3] * z[20];
z[18] = (T(1) / T(2)) * z[18] + z[20] + (T(7) / T(4)) * z[29];
z[18] = z[5] * z[18];
z[20] = -z[28] + z[30];
z[25] = -1 + z[29];
z[27] = z[25] + -z[33];
z[27] = z[5] * z[27];
z[28] = T(94) / T(9) + (T(-3) / T(2)) * z[22];
z[28] = z[10] * z[28];
z[27] = z[27] + z[28];
z[27] = z[5] * z[27];
z[20] = (T(46) / T(9)) * z[20] + z[27];
z[20] = z[1] * z[20];
z[27] = (T(223) / T(2)) * z[3] + -95 * z[10];
z[18] = z[18] + z[20] + (T(1) / T(18)) * z[27];
z[18] = z[5] * z[18];
z[20] = (T(-23) / T(9)) * z[10] + -z[21];
z[20] = z[3] * z[20];
z[18] = z[18] + z[20] + (T(101) / T(36)) * z[30];
z[18] = z[1] * z[18];
z[20] = z[6] + z[12];
z[27] = -z[7] * z[20];
z[27] = T(119) / T(9) + z[27];
z[27] = z[24] * z[27];
z[28] = -z[3] + z[10];
z[28] = z[13] * z[28];
z[26] = z[12] + -z[13] + z[26];
z[26] = z[7] * z[26];
z[26] = T(-179) / T(9) + z[26] + z[28];
z[26] = z[19] * z[26];
z[28] = z[13] * z[24];
z[28] = T(-119) / T(9) + z[28];
z[28] = z[10] * z[28];
z[26] = z[26] + z[27] + z[28];
z[14] = z[14] + z[15] + z[18] + (T(1) / T(2)) * z[26];
z[14] = z[8] * z[14];
z[15] = z[0] * z[3];
z[18] = T(329) / T(18) + (T(107) / T(9)) * z[15] + 5 * z[22] + -z[34];
z[26] = (T(1) / T(2)) * z[5];
z[18] = z[18] * z[26];
z[27] = -z[3] + 2 * z[10];
z[27] = z[3] * z[27];
z[27] = z[27] + -z[30];
z[28] = 3 * z[22];
z[29] = T(-563) / T(18) + z[28];
z[29] = z[10] * z[29];
z[25] = -z[5] * z[25];
z[25] = (T(509) / T(18)) * z[3] + z[25] + z[29];
z[25] = z[25] * z[26];
z[25] = z[25] + (T(23) / T(9)) * z[27];
z[25] = z[1] * z[25];
z[27] = 52 + (T(-107) / T(2)) * z[15];
z[27] = z[3] * z[27];
z[17] = z[17] + (T(1) / T(3)) * z[27];
z[17] = (T(1) / T(3)) * z[17] + z[18] + z[25];
z[17] = z[1] * z[17];
z[18] = z[4] * z[19];
z[18] = T(71) / T(9) + z[18];
z[18] = z[0] * z[18];
z[16] = -z[16] + z[18];
z[16] = z[3] * z[16];
z[18] = T(125) / T(9) + -z[22];
z[18] = z[10] * z[18];
z[15] = -223 + 107 * z[15];
z[15] = z[3] * z[15];
z[15] = (T(1) / T(9)) * z[15] + z[18];
z[15] = z[1] * z[15];
z[15] = T(-97) / T(18) + z[15] + z[16] + -z[28] + -z[34];
z[15] = z[1] * z[15];
z[16] = -z[0] + z[9];
z[18] = z[16] * z[23];
z[25] = 3 * z[9];
z[15] = z[0] + (T(-1) / T(2)) * z[12] + z[15] + z[18] + -z[25];
z[18] = (T(1) / T(2)) * z[2];
z[15] = z[15] * z[18];
z[27] = z[3] * z[12];
z[28] = z[7] * z[12];
z[29] = -1 + -3 * z[28];
z[18] = z[12] * z[18];
z[18] = z[18] + z[27] + (T(1) / T(2)) * z[29];
z[18] = z[2] * z[18];
z[27] = T(101) / T(9) + z[27] + -5 * z[28];
z[27] = z[19] * z[27];
z[29] = 1 + (T(3) / T(2)) * z[28];
z[29] = z[7] * z[29];
z[18] = (T(-55) / T(9)) * z[10] + z[18] + z[27] + z[29];
z[27] = T(55) / T(9) + -z[28];
z[27] = z[19] * z[27];
z[28] = (T(-1) / T(4)) * z[6] + z[12];
z[28] = z[7] * z[28];
z[28] = T(-23) / T(9) + z[28];
z[28] = z[7] * z[28];
z[27] = (T(-55) / T(18)) * z[10] + z[27] + z[28];
z[27] = z[3] * z[27];
z[28] = -z[6] + z[12];
z[24] = z[24] * z[28];
z[24] = T(-55) / T(9) + z[24];
z[24] = z[3] * z[7] * z[24];
z[20] = prod_pow(z[7], 3) * z[20];
z[24] = (T(-1) / T(2)) * z[20] + z[24];
z[19] = z[8] * z[19] * z[24];
z[19] = z[19] + (T(-1) / T(4)) * z[20] + z[27];
z[19] = z[8] * z[19];
z[18] = (T(1) / T(2)) * z[18] + z[19];
z[18] = z[11] * z[18];
z[19] = (T(1) / T(2)) * z[6];
z[20] = -z[16] + z[19];
z[20] = z[20] * z[23];
z[19] = (T(71) / T(9)) * z[0] + z[19] + z[20] + z[25];
z[19] = z[19] * z[26];
z[20] = (T(1) / T(2)) * z[23];
z[16] = -z[16] * z[20];
z[20] = -z[0] + z[12];
z[16] = z[9] + z[16] + (T(1) / T(2)) * z[20];
z[16] = z[7] * z[16];
z[20] = (T(-133) / T(9)) * z[0] + -z[12];
z[20] = z[20] * z[21];
return T(7) / T(9) + z[14] + z[15] + z[16] + z[17] + z[18] + z[19] + z[20] + (T(1) / T(2)) * z[22];
}



template double eval_coef_2q3y_2l_pmmpp_12345_151(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_151(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
