#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_153(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[37];
z[0] = iW[0];
z[1] = iW[3];
z[2] = v[1];
z[3] = v[2];
z[4] = iW[16];
z[5] = v[4];
z[6] = iW[12];
z[7] = v[3];
z[8] = iW[1];
z[9] = iW[2];
z[10] = v[0];
z[11] = iW[18];
z[12] = iW[4];
z[13] = iW[15];
z[14] = (T(55) / T(9)) * z[1];
z[15] = (T(1) / T(2)) * z[9];
z[16] = z[14] + -z[15];
z[16] = z[1] * z[16];
z[17] = prod_pow(z[9], 2);
z[18] = (T(1) / T(2)) * z[17];
z[16] = z[16] + z[18];
z[19] = z[10] * z[16];
z[20] = z[1] * z[3];
z[21] = 1 + z[20];
z[14] = -z[14] * z[21];
z[14] = z[9] + z[14] + z[19];
z[14] = z[10] * z[14];
z[22] = T(-101) / T(18) + z[20];
z[22] = z[1] * z[22];
z[22] = z[15] + z[22];
z[23] = -z[10] * z[22];
z[21] = (T(-193) / T(18)) * z[21] + z[23];
z[21] = z[10] * z[21];
z[23] = z[3] * z[6];
z[24] = T(229) / T(18) + 3 * z[23];
z[24] = z[3] * z[24];
z[21] = z[21] + z[24];
z[24] = (T(1) / T(4)) * z[9];
z[25] = -z[6] + z[24];
z[26] = z[7] * z[25];
z[26] = T(14) / T(9) + (T(1) / T(2)) * z[23] + z[26];
z[26] = z[7] * z[26];
z[21] = (T(1) / T(2)) * z[21] + z[26];
z[21] = z[8] * z[21];
z[26] = 3 + (T(223) / T(18)) * z[20] + 5 * z[23];
z[27] = (T(1) / T(2)) * z[10];
z[28] = -z[17] * z[27];
z[29] = z[7] * z[15];
z[30] = z[6] * z[29];
z[28] = 2 * z[6] + (T(-7) / T(4)) * z[9] + z[28] + -z[30];
z[28] = z[7] * z[28];
z[14] = z[14] + z[21] + (T(1) / T(2)) * z[26] + z[28];
z[14] = z[8] * z[14];
z[21] = -z[6] + z[15];
z[26] = z[7] * z[9];
z[28] = -z[21] * z[26];
z[31] = -z[6] + z[9];
z[32] = z[10] * z[17];
z[28] = z[28] + 3 * z[31] + z[32];
z[28] = z[7] * z[28];
z[31] = -1 + z[23];
z[32] = z[20] * z[31];
z[33] = 5 * z[9];
z[34] = (T(301) / T(9)) * z[1] + -z[33];
z[19] = -z[19] + (T(1) / T(2)) * z[34];
z[19] = z[10] * z[19];
z[19] = T(-227) / T(18) + z[19] + -z[23] + z[28] + 3 * z[32];
z[28] = (T(1) / T(2)) * z[8];
z[19] = z[19] * z[28];
z[32] = z[1] * z[33];
z[32] = -z[17] + z[32];
z[34] = z[1] * z[10];
z[35] = (T(3) / T(4)) * z[34];
z[35] = z[32] * z[35];
z[36] = (T(85) / T(9)) * z[1] + 7 * z[9];
z[36] = z[1] * z[36];
z[17] = -z[17] + -z[35] + z[36];
z[17] = z[10] * z[17];
z[25] = z[25] * z[26];
z[26] = T(-143) / T(18) + 2 * z[23];
z[26] = z[1] * z[26];
z[17] = z[6] + (T(-19) / T(4)) * z[9] + z[17] + z[19] + z[25] + z[26];
z[17] = z[8] * z[17];
z[19] = (T(1) / T(4)) * z[34];
z[19] = z[19] * z[32];
z[25] = 3 * z[9];
z[26] = (T(1) / T(2)) * z[1];
z[32] = -z[25] + -z[26];
z[32] = z[1] * z[32];
z[32] = z[18] + z[19] + z[32];
z[32] = z[10] * z[32];
z[34] = -1 + z[20];
z[31] = z[1] * z[31] * z[34];
z[31] = -z[6] + (T(9) / T(2)) * z[9] + z[31];
z[21] = -z[21] * z[29];
z[21] = z[21] + (T(1) / T(2)) * z[31] + z[32];
z[21] = prod_pow(z[8], 2) * z[5] * z[21];
z[17] = z[17] + z[21];
z[17] = z[5] * z[17];
z[21] = (T(-313) / T(18)) * z[1] + -z[33];
z[21] = z[1] * z[21];
z[18] = z[18] + z[21] + z[35];
z[18] = z[10] * z[18];
z[21] = (T(1) / T(2)) * z[7];
z[29] = z[6] * z[21];
z[29] = 2 + (T(107) / T(18)) * z[20] + z[29];
z[29] = z[0] * z[29];
z[31] = 385 + 491 * z[20];
z[31] = z[1] * z[31];
z[14] = z[6] + z[14] + z[17] + z[18] + z[25] + z[29] + z[30] + (T(1) / T(36)) * z[31];
z[14] = z[5] * z[14];
z[17] = z[3] * z[10];
z[18] = prod_pow(z[3], 2);
z[17] = z[17] + -z[18];
z[25] = -z[3] * z[7];
z[25] = -z[18] + z[25];
z[29] = z[7] * z[8];
z[25] = z[25] * z[29];
z[30] = z[3] + -z[10];
z[30] = z[7] * z[30];
z[25] = -z[17] + z[25] + z[30];
z[25] = z[12] * z[25];
z[30] = z[1] * z[18];
z[25] = (T(101) / T(9)) * z[3] + z[25] + -z[30];
z[31] = (T(1) / T(2)) * z[3];
z[32] = z[3] * z[4];
z[33] = T(37) / T(9) + (T(5) / T(2)) * z[32];
z[33] = z[31] * z[33];
z[34] = -1 + z[32];
z[35] = z[30] * z[34];
z[33] = z[33] + z[35];
z[33] = z[1] * z[33];
z[22] = z[22] * z[27];
z[35] = T(-3) / T(2) + z[32];
z[22] = z[22] + z[33] + (T(1) / T(2)) * z[35];
z[22] = z[10] * z[22];
z[15] = z[10] * z[15];
z[33] = T(-55) / T(9) + -z[15] + z[23];
z[33] = z[7] * z[33];
z[23] = T(-211) / T(18) + z[23];
z[23] = z[3] * z[23];
z[35] = T(101) / T(9) + z[15];
z[35] = z[10] * z[35];
z[23] = z[23] + z[33] + z[35];
z[23] = z[7] * z[23];
z[33] = z[30] + z[31];
z[33] = z[1] * z[33] * z[34];
z[33] = T(-55) / T(9) + z[33];
z[33] = z[10] * z[33];
z[33] = (T(211) / T(18)) * z[3] + z[33];
z[33] = z[10] * z[33];
z[23] = (T(-101) / T(18)) * z[18] + z[23] + z[33];
z[23] = z[23] * z[28];
z[28] = z[3] + z[7];
z[33] = -z[6] + (T(1) / T(2)) * z[13];
z[33] = -z[28] * z[33];
z[33] = T(55) / T(9) + -z[15] + z[33];
z[33] = z[21] * z[33];
z[22] = z[22] + z[23] + (T(1) / T(4)) * z[25] + z[33];
z[22] = z[8] * z[22];
z[23] = z[3] * z[13];
z[25] = T(-119) / T(9) + z[23];
z[33] = z[9] * z[10];
z[34] = -z[25] + z[33];
z[34] = z[7] * z[34];
z[35] = T(229) / T(9) + -z[23];
z[35] = z[3] * z[35];
z[33] = T(-211) / T(9) + -z[33];
z[33] = z[10] * z[33];
z[33] = z[33] + z[34] + z[35];
z[34] = (T(1) / T(4)) * z[7];
z[33] = z[33] * z[34];
z[35] = -z[3] + z[27];
z[35] = z[10] * z[35];
z[18] = (T(1) / T(2)) * z[18] + z[35];
z[18] = (T(55) / T(9)) * z[18] + z[33];
z[18] = z[18] * z[29];
z[15] = -z[15] + z[25];
z[15] = z[15] * z[21];
z[23] = T(-29) / T(3) + (T(1) / T(2)) * z[23];
z[23] = z[3] * z[23];
z[15] = (T(55) / T(9)) * z[10] + z[15] + z[23];
z[15] = z[7] * z[15];
z[15] = z[15] + (T(55) / T(18)) * z[17] + z[18];
z[15] = z[8] * z[15];
z[17] = -z[25] * z[28];
z[15] = z[15] + (T(1) / T(4)) * z[17];
z[15] = z[11] * z[15];
z[17] = T(277) / T(9) + 5 * z[32];
z[17] = z[17] * z[31];
z[18] = T(-55) / T(9) + z[32];
z[18] = z[18] * z[30];
z[17] = z[17] + z[18];
z[17] = z[17] * z[26];
z[16] = -z[16] * z[27];
z[18] = T(-9) / T(4) + (T(55) / T(9)) * z[20];
z[18] = z[1] * z[18];
z[16] = z[16] + z[18] + z[24];
z[16] = z[10] * z[16];
z[18] = -13 + (T(-473) / T(9)) * z[20];
z[18] = z[18] * z[26];
z[18] = -z[9] + z[18];
z[20] = (T(76) / T(9)) * z[1] + z[9];
z[20] = z[1] * z[20];
z[19] = -z[19] + z[20];
z[19] = z[10] * z[19];
z[18] = (T(1) / T(2)) * z[18] + z[19];
z[18] = z[2] * z[18];
z[19] = 2 + (T(1) / T(4)) * z[32];
z[19] = z[3] * z[19];
z[19] = z[19] + (T(107) / T(18)) * z[30];
z[19] = z[1] * z[19];
z[20] = 1 + z[32];
z[19] = z[19] + (T(1) / T(2)) * z[20];
z[19] = z[2] * z[19];
z[20] = z[2] * z[4];
z[20] = -3 + z[20];
z[20] = z[20] * z[34];
z[23] = (T(-9) / T(2)) * z[3] + (T(-107) / T(9)) * z[30];
z[19] = z[19] + z[20] + (T(1) / T(2)) * z[23];
z[19] = z[0] * z[19];
z[20] = z[4] + z[13];
z[20] = z[9] + (T(1) / T(2)) * z[20];
z[20] = z[20] * z[21];
z[21] = z[4] + (T(1) / T(4)) * z[13];
z[21] = z[3] * z[21];
return T(7) / T(4) + z[14] + z[15] + z[16] + z[17] + z[18] + z[19] + z[20] + z[21] + z[22];
}



template double eval_coef_2q3y_2l_pmmpp_12345_153(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_153(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
