#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_159(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[63];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[1];
z[4] = v[2];
z[5] = iW[22];
z[6] = iW[15];
z[7] = iW[19];
z[8] = v[3];
z[9] = v[4];
z[10] = iW[1];
z[11] = iW[2];
z[12] = v[0];
z[13] = iW[4];
z[14] = -z[1] + z[7];
z[15] = (T(1) / T(2)) * z[5];
z[16] = z[14] * z[15];
z[17] = prod_pow(z[5], 2);
z[18] = z[3] * z[17];
z[19] = 3 * z[1];
z[20] = z[7] + z[19];
z[21] = z[18] * z[20];
z[22] = prod_pow(z[2], 2);
z[23] = z[4] * z[22];
z[24] = -z[19] * z[23];
z[25] = prod_pow(z[13], 2);
z[26] = (T(259) / T(36)) * z[25];
z[27] = z[1] * z[2];
z[24] = z[16] + (T(1) / T(2)) * z[21] + z[22] + z[24] + z[26] + (T(-11) / T(2)) * z[27];
z[28] = (T(1) / T(2)) * z[4];
z[24] = z[24] * z[28];
z[29] = (T(1) / T(2)) * z[22];
z[30] = z[17] + -z[29];
z[30] = z[8] * z[30];
z[14] = z[5] * z[14];
z[14] = z[14] + z[21];
z[31] = (T(1) / T(4)) * z[9];
z[14] = z[14] * z[31];
z[32] = (T(1) / T(2)) * z[1];
z[33] = z[5] + -z[32];
z[33] = z[3] * z[33];
z[33] = T(3) / T(4) + z[33];
z[33] = z[5] * z[33];
z[14] = (T(5) / T(6)) * z[1] + z[2] + (T(-337) / T(72)) * z[13] + z[14] + z[24] + z[30] + z[33];
z[14] = z[4] * z[14];
z[24] = (T(1) / T(4)) * z[13];
z[30] = -z[5] + (T(259) / T(18)) * z[13];
z[30] = z[24] * z[30];
z[33] = -z[2] + z[7];
z[34] = (T(1) / T(2)) * z[6];
z[35] = z[33] * z[34];
z[35] = z[22] + z[35];
z[36] = z[8] * z[34];
z[37] = -z[35] * z[36];
z[38] = (T(3) / T(2)) * z[7];
z[39] = 2 * z[2] + -z[38];
z[39] = z[6] * z[39];
z[29] = -z[17] + -z[29] + z[30] + z[37] + z[39];
z[29] = z[8] * z[29];
z[30] = 3 * z[7];
z[37] = 7 * z[2];
z[39] = -z[30] + z[37];
z[40] = (T(259) / T(36)) * z[13];
z[39] = -z[5] + (T(1) / T(2)) * z[39] + z[40];
z[29] = z[29] + (T(1) / T(2)) * z[39];
z[29] = z[8] * z[29];
z[20] = z[17] * z[20];
z[39] = z[9] * z[20];
z[41] = (T(1) / T(4)) * z[39];
z[42] = (T(1) / T(2)) * z[7];
z[43] = 3 * z[5];
z[44] = z[42] + -z[43];
z[44] = z[5] * z[44];
z[44] = -z[41] + z[44];
z[44] = z[9] * z[44];
z[45] = z[8] * z[17];
z[44] = (T(-1) / T(4)) * z[7] + z[44] + -3 * z[45];
z[44] = z[9] * z[44];
z[46] = z[6] * z[8];
z[47] = z[35] * z[46];
z[33] = z[6] * z[33];
z[48] = z[22] + (T(3) / T(2)) * z[33] + z[47];
z[48] = z[8] * z[48];
z[48] = -z[2] + z[48];
z[48] = z[28] * z[48];
z[29] = T(-1) / T(2) + z[29] + z[44] + z[48];
z[29] = z[4] * z[29];
z[44] = (T(-3) / T(2)) * z[2] + z[7];
z[44] = z[34] * z[44];
z[44] = -z[22] + z[44];
z[44] = z[8] * z[44];
z[48] = (T(67) / T(9)) * z[13];
z[49] = (T(5) / T(2)) * z[2] + z[7];
z[44] = (T(1) / T(4)) * z[6] + z[44] + -z[48] + (T(1) / T(2)) * z[49];
z[44] = z[8] * z[44];
z[44] = T(-58) / T(9) + z[44];
z[44] = z[8] * z[44];
z[49] = z[1] + z[7];
z[50] = 4 * z[5] + (T(-5) / T(4)) * z[49];
z[50] = z[5] * z[50];
z[50] = (T(1) / T(2)) * z[39] + z[50];
z[50] = z[9] * z[50];
z[51] = 2 * z[45];
z[52] = (T(7) / T(2)) * z[5];
z[50] = z[7] + z[50] + z[51] + -z[52];
z[50] = z[9] * z[50];
z[53] = -z[7] + -z[43];
z[53] = z[8] * z[53];
z[53] = T(-3) / T(2) + z[53];
z[50] = z[50] + (T(1) / T(2)) * z[53];
z[50] = z[9] * z[50];
z[29] = z[29] + z[44] + z[50];
z[29] = z[4] * z[29];
z[44] = 3 * z[22];
z[23] = z[1] * z[23];
z[50] = -z[23] + (T(-7) / T(2)) * z[27] + z[44];
z[50] = z[4] * z[50];
z[53] = z[8] * z[22];
z[54] = -z[1] + 3 * z[2];
z[50] = z[50] + -3 * z[53] + (T(5) / T(2)) * z[54];
z[50] = z[4] * z[50];
z[54] = (T(1) / T(2)) * z[2];
z[55] = z[11] * z[54];
z[55] = z[22] + z[55];
z[56] = z[8] * z[55];
z[57] = 9 * z[2];
z[58] = -z[11] + -z[57];
z[58] = z[56] + (T(1) / T(2)) * z[58];
z[58] = z[8] * z[58];
z[59] = z[1] * z[9];
z[50] = T(385) / T(36) + z[50] + z[58] + (T(223) / T(36)) * z[59];
z[50] = z[12] * z[50];
z[58] = 13 * z[2];
z[60] = (T(3) / T(2)) * z[11] + -3 * z[56] + z[58];
z[60] = z[8] * z[60];
z[60] = T(-439) / T(18) + z[60];
z[60] = z[8] * z[60];
z[61] = (T(1) / T(2)) * z[11];
z[61] = -z[8] * z[61];
z[61] = T(-89) / T(9) + (T(-1) / T(2)) * z[59] + z[61];
z[61] = z[9] * z[61];
z[50] = z[50] + z[60] + z[61];
z[60] = z[1] * z[54];
z[61] = -z[22] + z[60];
z[62] = -z[4] * z[61];
z[32] = -z[32] + z[37] + -5 * z[53] + z[62];
z[32] = z[28] * z[32];
z[48] = z[48] + (T(7) / T(2)) * z[53] + -z[57];
z[48] = z[8] * z[48];
z[53] = -z[1] * z[31];
z[32] = T(367) / T(36) + z[32] + z[48] + z[53];
z[32] = z[4] * z[32];
z[32] = z[32] + (T(1) / T(2)) * z[50];
z[32] = z[12] * z[32];
z[48] = 5 * z[1];
z[30] = z[30] + z[48];
z[30] = -z[5] + (T(1) / T(4)) * z[30];
z[30] = z[5] * z[30];
z[30] = z[30] + -z[41];
z[30] = z[9] * z[30];
z[41] = -z[1] + z[52];
z[50] = z[41] + -z[42];
z[30] = z[30] + (T(1) / T(2)) * z[50];
z[30] = z[9] * z[30];
z[30] = T(-3) / T(4) + z[30];
z[30] = z[9] * z[30];
z[50] = z[8] * z[11];
z[50] = T(169) / T(18) + z[50];
z[50] = z[8] * z[50];
z[30] = z[30] + (T(1) / T(4)) * z[50];
z[30] = z[9] * z[30];
z[37] = -z[11] + -z[37];
z[37] = (T(1) / T(2)) * z[37] + z[56];
z[37] = z[8] * z[37];
z[37] = T(439) / T(72) + z[37];
z[37] = prod_pow(z[8], 2) * z[37];
z[29] = z[29] + z[30] + z[32] + z[37];
z[29] = z[10] * z[29];
z[30] = -z[7] + z[54];
z[30] = z[30] * z[34];
z[15] = z[13] * z[15];
z[30] = -z[15] + -2 * z[17] + (T(3) / T(2)) * z[22] + z[30];
z[30] = z[8] * z[30];
z[30] = (T(-15) / T(4)) * z[2] + -z[5] + (T(95) / T(8)) * z[13] + z[30] + z[34];
z[30] = z[8] * z[30];
z[32] = -z[38] + z[41];
z[37] = (T(3) / T(4)) * z[39];
z[38] = 5 * z[5];
z[39] = 2 * z[1] + z[7] + -z[38];
z[39] = z[5] * z[39];
z[39] = -z[37] + z[39];
z[39] = z[9] * z[39];
z[32] = (T(1) / T(2)) * z[32] + z[39] + -4 * z[45];
z[32] = z[9] * z[32];
z[39] = z[2] * z[6];
z[41] = (T(-259) / T(18)) * z[25] + (T(3) / T(2)) * z[39] + -z[44];
z[41] = z[8] * z[41];
z[40] = (T(13) / T(2)) * z[2] + -z[40] + z[41] + -z[49];
z[36] = 1 + z[36];
z[35] = z[35] * z[36];
z[35] = z[35] + -z[60];
z[35] = z[4] * z[35];
z[35] = z[35] + (T(1) / T(2)) * z[40];
z[35] = z[4] * z[35];
z[30] = T(499) / T(72) + z[30] + z[32] + z[35];
z[30] = z[4] * z[30];
z[23] = (T(5) / T(2)) * z[22] + (T(-3) / T(2)) * z[23] + -4 * z[27];
z[23] = z[4] * z[23];
z[26] = -2 * z[22] + z[26];
z[26] = z[8] * z[26];
z[32] = (T(115) / T(18)) * z[1] + 21 * z[2] + (T(241) / T(18)) * z[13];
z[23] = z[23] + z[26] + (T(1) / T(4)) * z[32];
z[23] = z[4] * z[23];
z[26] = -z[13] + -z[58];
z[26] = (T(1) / T(4)) * z[26] + z[56];
z[26] = z[8] * z[26];
z[32] = (T(-223) / T(18)) * z[1] + z[13];
z[32] = z[12] * z[32];
z[23] = T(79) / T(9) + z[23] + z[26] + (T(1) / T(4)) * z[32] + (T(4) / T(3)) * z[59];
z[23] = z[12] * z[23];
z[26] = 2 * z[5];
z[32] = (T(-5) / T(2)) * z[1] + -z[7];
z[32] = z[26] + (T(3) / T(2)) * z[32];
z[32] = z[5] * z[32];
z[32] = z[32] + z[37];
z[32] = z[9] * z[32];
z[19] = z[19] + z[42];
z[19] = (T(1) / T(2)) * z[19] + z[32] + -z[43];
z[19] = z[9] * z[19];
z[32] = T(11) / T(3) + z[46];
z[19] = z[19] + (T(1) / T(4)) * z[32];
z[19] = z[9] * z[19];
z[32] = 4 * z[2] + (T(1) / T(4)) * z[11] + (T(-3) / T(2)) * z[56];
z[32] = z[8] * z[32];
z[32] = T(-445) / T(72) + z[32];
z[32] = z[8] * z[32];
z[19] = z[19] + z[23] + z[29] + z[30] + z[32];
z[19] = z[10] * z[19];
z[23] = z[1] * z[22];
z[20] = (T(-1) / T(2)) * z[20] + -z[23];
z[20] = z[3] * z[20];
z[16] = -z[16] + z[20] + z[33] + z[47] + -z[61];
z[16] = z[16] * z[28];
z[17] = -z[17] + z[22] + (T(3) / T(4)) * z[39];
z[17] = z[8] * z[17];
z[20] = -z[22] + -z[27];
z[22] = (T(-1) / T(4)) * z[1] + -z[26];
z[22] = z[5] * z[22];
z[20] = (T(1) / T(2)) * z[20] + z[22];
z[20] = z[3] * z[20];
z[22] = -z[2] + -z[43];
z[16] = z[16] + z[17] + z[20] + (T(1) / T(4)) * z[22];
z[16] = z[4] * z[16];
z[17] = z[2] + (T(-9) / T(4)) * z[5] + -z[18] + z[34] + -z[51];
z[17] = z[8] * z[17];
z[18] = (T(-13) / T(12)) * z[1] + -z[2] + -z[5];
z[18] = z[3] * z[18];
z[18] = T(1) / T(12) + z[18];
z[16] = z[16] + z[17] + (T(1) / T(2)) * z[18];
z[16] = z[4] * z[16];
z[17] = T(-13) / T(6) + z[46];
z[17] = z[17] * z[31];
z[18] = (T(-3) / T(2)) * z[5] + -z[45];
z[18] = z[8] * z[18];
z[18] = T(-1) / T(2) + z[18];
z[18] = z[8] * z[18];
z[16] = z[16] + z[17] + z[18];
z[16] = z[0] * z[16];
z[17] = z[7] + z[48];
z[17] = -z[5] + (T(3) / T(4)) * z[17];
z[17] = z[5] * z[17];
z[17] = z[17] + (T(1) / T(4)) * z[21] + -z[37];
z[17] = z[9] * z[17];
z[18] = z[1] * z[3];
z[20] = 1 + -z[18];
z[20] = z[20] * z[38];
z[20] = (T(-49) / T(6)) * z[1] + z[20];
z[17] = z[17] + (T(1) / T(4)) * z[20];
z[17] = z[9] * z[17];
z[20] = (T(-259) / T(3)) * z[4] + (T(259) / T(6)) * z[12];
z[20] = z[20] * z[25];
z[20] = -13 * z[1] + (T(337) / T(6)) * z[13] + z[20];
z[20] = z[12] * z[20];
z[18] = 7 + (T(25) / T(2)) * z[18] + z[20];
z[15] = -z[15] + z[55];
z[15] = z[8] * z[15];
z[15] = -z[2] + (T(1) / T(2)) * z[15] + -z[24];
z[15] = z[8] * z[15];
return z[14] + z[15] + z[16] + z[17] + (T(1) / T(12)) * z[18] + z[19];
}



template double eval_coef_2q3y_2l_pmmpp_12345_159(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_159(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
