#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_16(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[23];
z[0] = iW[1];
z[1] = iW[7];
z[2] = iW[15];
z[3] = iW[18];
z[4] = iW[23];
z[5] = v[0];
z[6] = v[4];
z[7] = v[2];
z[8] = v[3];
z[9] = v[1];
z[10] = prod_pow(z[0], 2);
z[11] = z[6] * z[10];
z[12] = 3 * z[0];
z[13] = z[11] + -z[12];
z[14] = z[6] * z[13];
z[15] = (T(1) / T(2)) * z[6];
z[16] = z[10] * z[15];
z[17] = -z[12] + z[16];
z[18] = (T(1) / T(2)) * z[7];
z[19] = z[17] * z[18];
z[20] = -z[0] + z[11];
z[21] = z[7] * z[10];
z[21] = -5 * z[20] + 3 * z[21];
z[21] = z[8] * z[21];
z[19] = T(-5) / T(2) + -z[14] + z[19] + (T(1) / T(4)) * z[21];
z[19] = z[8] * z[19];
z[21] = -7 * z[0] + z[11];
z[21] = z[15] * z[21];
z[22] = (T(5) / T(2)) * z[6] + -z[7];
z[22] = z[10] * z[22];
z[12] = -z[12] + z[22];
z[12] = z[8] * z[12];
z[22] = z[0] * z[7];
z[20] = -z[5] * z[20];
z[12] = 3 + z[12] + z[20] + z[21] + z[22];
z[12] = z[5] * z[12];
z[14] = -7 + -z[14];
z[14] = z[6] * z[14];
z[20] = z[0] * z[6];
z[21] = -3 + z[20];
z[22] = -z[7] * z[21];
z[14] = 5 * z[9] + z[14] + z[22];
z[12] = (T(1) / T(2)) * z[12] + (T(1) / T(4)) * z[14] + z[19];
z[12] = z[5] * z[12];
z[14] = z[15] * z[21];
z[14] = z[9] + z[14];
z[14] = z[7] * z[14];
z[19] = prod_pow(z[9], 2);
z[20] = T(5) / T(2) + -z[20];
z[20] = z[6] * z[20];
z[20] = (T(-5) / T(2)) * z[9] + z[20];
z[20] = z[6] * z[20];
z[14] = z[14] + z[19] + z[20];
z[13] = z[13] * z[15];
z[15] = z[0] + -z[16];
z[15] = z[7] * z[15];
z[13] = 1 + z[13] + z[15];
z[15] = z[6] + -z[7];
z[10] = z[10] * z[15];
z[10] = -z[0] + z[10];
z[10] = z[8] * z[10];
z[10] = z[10] + 3 * z[13];
z[10] = z[8] * z[10];
z[13] = -z[6] * z[17];
z[13] = -3 + z[13];
z[13] = z[13] * z[18];
z[11] = -2 * z[0] + (T(1) / T(4)) * z[11];
z[11] = z[6] * z[11];
z[11] = 3 + z[11];
z[11] = z[6] * z[11];
z[10] = (T(-3) / T(2)) * z[9] + (T(1) / T(2)) * z[10] + z[11] + z[13];
z[10] = z[8] * z[10];
z[10] = z[10] + z[12] + (T(1) / T(2)) * z[14];
return prod_pow(z[5], 2) * z[1] * z[2] * z[3] * z[4] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_16(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_16(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
