#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_160(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[53];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[2];
z[4] = v[4];
z[5] = iW[22];
z[6] = v[1];
z[7] = iW[15];
z[8] = v[3];
z[9] = iW[16];
z[10] = iW[1];
z[11] = v[0];
z[12] = iW[17];
z[13] = iW[18];
z[14] = z[7] + z[9];
z[15] = prod_pow(z[5], 2);
z[16] = z[14] * z[15];
z[17] = (T(1) / T(2)) * z[8];
z[18] = z[16] * z[17];
z[19] = prod_pow(z[2], 2);
z[20] = 2 * z[19];
z[21] = z[5] * z[7];
z[22] = prod_pow(z[13], 2);
z[23] = (T(1) / T(2)) * z[12];
z[24] = -z[9] + z[23];
z[25] = 2 * z[5] + z[24];
z[25] = z[5] * z[25];
z[25] = -z[18] + -z[20] + (T(-5) / T(4)) * z[21] + (T(-259) / T(18)) * z[22] + z[25];
z[25] = z[8] * z[25];
z[26] = z[4] * z[15];
z[27] = 5 * z[26];
z[28] = 13 * z[2];
z[29] = z[12] + z[28];
z[14] = 5 * z[5] + (T(1373) / T(36)) * z[13] + -z[14] + z[27] + (T(1) / T(2)) * z[29];
z[14] = (T(1) / T(2)) * z[14] + z[25];
z[14] = z[8] * z[14];
z[16] = z[8] * z[16];
z[25] = z[16] + z[21];
z[29] = 3 * z[9];
z[30] = -z[5] + z[29];
z[31] = (T(1) / T(2)) * z[5];
z[32] = -z[30] * z[31];
z[33] = (T(259) / T(36)) * z[22];
z[25] = z[19] + (T(-3) / T(4)) * z[25] + z[32] + -z[33];
z[25] = z[8] * z[25];
z[32] = z[1] * z[2];
z[34] = z[2] * z[9];
z[35] = z[32] + -z[34];
z[36] = 3 * z[19];
z[37] = z[1] * z[36];
z[38] = z[9] * z[19];
z[37] = z[37] + z[38];
z[39] = z[11] * z[37];
z[40] = -z[5] * z[9];
z[40] = -z[18] + z[35] + (T(3) / T(2)) * z[39] + z[40];
z[41] = (T(1) / T(2)) * z[3];
z[40] = z[40] * z[41];
z[42] = (T(1) / T(4)) * z[34];
z[43] = -z[19] + z[42];
z[43] = (T(19) / T(4)) * z[32] + 5 * z[43];
z[43] = z[11] * z[43];
z[44] = (T(1) / T(2)) * z[1];
z[25] = (T(-3) / T(4)) * z[2] + -z[9] + (T(259) / T(72)) * z[13] + z[25] + z[31] + z[40] + z[43] + z[44];
z[25] = z[3] * z[25];
z[40] = z[1] * z[4];
z[43] = 3 * z[26];
z[45] = -z[5] + z[43];
z[45] = z[4] * z[45];
z[45] = 1 + z[45];
z[45] = z[40] * z[45];
z[46] = (T(3) / T(2)) * z[5] + z[27];
z[46] = z[4] * z[46];
z[45] = T(-355) / T(36) + z[45] + z[46];
z[46] = 4 * z[19] + z[33];
z[46] = z[8] * z[46];
z[47] = (T(-115) / T(36)) * z[1] + (T(-33) / T(2)) * z[2] + z[9] + (T(-277) / T(36)) * z[13];
z[47] = z[46] + (T(1) / T(2)) * z[47];
z[47] = z[11] * z[47];
z[14] = z[14] + z[25] + (T(1) / T(2)) * z[45] + z[47];
z[14] = z[3] * z[14];
z[25] = (T(1) / T(4)) * z[16];
z[22] = (T(259) / T(72)) * z[22];
z[45] = z[12] + -z[29];
z[45] = z[5] + (T(1) / T(4)) * z[45];
z[45] = z[5] * z[45];
z[45] = (T(-1) / T(2)) * z[21] + z[22] + -z[25] + z[45];
z[45] = z[8] * z[45];
z[24] = 3 * z[5] + (T(-259) / T(36)) * z[13] + z[24] + z[43];
z[24] = (T(1) / T(2)) * z[24] + z[45];
z[24] = z[8] * z[24];
z[32] = (T(9) / T(4)) * z[32] + -z[36] + z[42];
z[32] = z[11] * z[32];
z[36] = 3 * z[2];
z[42] = (T(1) / T(2)) * z[9] + z[36];
z[45] = -z[42] + z[44];
z[47] = z[8] * z[20];
z[32] = z[32] + (T(1) / T(2)) * z[45] + z[47];
z[32] = z[11] * z[32];
z[35] = z[35] + z[39];
z[35] = z[11] * z[35];
z[39] = -z[5] * z[29];
z[39] = -z[16] + z[39];
z[39] = z[17] * z[39];
z[35] = -z[9] + (T(1) / T(2)) * z[35] + z[39];
z[35] = z[35] * z[41];
z[39] = z[26] + z[31];
z[41] = prod_pow(z[4], 2);
z[45] = z[1] * z[41];
z[47] = 3 * z[4] + z[45];
z[39] = z[39] * z[47];
z[39] = 1 + z[39];
z[24] = z[24] + z[32] + z[35] + (T(1) / T(2)) * z[39];
z[24] = z[3] * z[24];
z[32] = z[19] + z[33];
z[33] = (T(1) / T(4)) * z[5];
z[35] = z[12] * z[33];
z[39] = (T(1) / T(4)) * z[21] + z[35];
z[47] = z[32] + -z[39];
z[47] = z[8] * z[47];
z[48] = (T(1) / T(2)) * z[7];
z[49] = (T(-7) / T(2)) * z[2] + -z[12] + (T(-259) / T(9)) * z[13] + -z[48];
z[47] = -z[26] + z[47] + (T(1) / T(2)) * z[49];
z[47] = z[8] * z[47];
z[49] = -z[5] + -z[12];
z[27] = -z[27] + (T(1) / T(2)) * z[49];
z[27] = z[4] * z[27];
z[27] = T(277) / T(18) + z[27];
z[27] = (T(1) / T(2)) * z[27] + z[47];
z[27] = z[8] * z[27];
z[47] = 15 * z[2] + (T(527) / T(18)) * z[13];
z[46] = -z[46] + (T(1) / T(2)) * z[47];
z[46] = z[8] * z[46];
z[47] = z[8] * z[19];
z[47] = -2 * z[2] + z[44] + z[47];
z[47] = z[11] * z[47];
z[49] = T(-313) / T(9) + z[40];
z[46] = z[46] + 3 * z[47] + (T(1) / T(4)) * z[49];
z[46] = z[11] * z[46];
z[47] = -z[15] * z[41];
z[47] = T(1) / T(2) + z[47];
z[47] = z[4] * z[47];
z[33] = -z[26] + z[33];
z[33] = z[4] * z[33];
z[33] = T(1) / T(4) + z[33];
z[33] = z[33] * z[45];
z[24] = z[24] + z[27] + z[33] + z[46] + (T(5) / T(2)) * z[47];
z[24] = z[3] * z[24];
z[27] = (T(1) / T(2)) * z[4];
z[33] = -z[5] + z[26];
z[46] = z[4] * z[33];
z[47] = T(-223) / T(36) + z[46];
z[47] = z[27] * z[47];
z[49] = -z[2] + (T(259) / T(18)) * z[13];
z[49] = z[13] * z[49];
z[50] = -z[19] + (T(1) / T(4)) * z[49];
z[51] = z[8] * z[50];
z[52] = (T(-253) / T(24)) * z[13] + z[36] + z[51];
z[52] = z[8] * z[52];
z[52] = T(187) / T(36) + z[52];
z[52] = z[8] * z[52];
z[47] = z[47] + z[52];
z[47] = z[8] * z[47];
z[20] = -z[20] + (T(1) / T(2)) * z[49];
z[49] = z[8] * z[20];
z[28] = (T(259) / T(6)) * z[13] + -z[28];
z[28] = (T(1) / T(2)) * z[28] + -z[49];
z[28] = z[8] * z[28];
z[28] = T(-187) / T(18) + z[28];
z[28] = z[8] * z[28];
z[52] = 7 * z[2] + (T(-265) / T(12)) * z[13];
z[51] = z[51] + (T(1) / T(2)) * z[52];
z[51] = z[8] * z[51];
z[52] = 187 + (T(-223) / T(2)) * z[40];
z[51] = z[51] + (T(1) / T(36)) * z[52];
z[51] = z[11] * z[51];
z[45] = (T(223) / T(18)) * z[4] + z[45];
z[28] = z[28] + (T(1) / T(2)) * z[45] + z[51];
z[28] = z[11] * z[28];
z[45] = T(-1) / T(2) + z[46];
z[41] = z[41] * z[45];
z[51] = prod_pow(z[4], 4) * z[33] * z[44];
z[24] = z[24] + z[28] + z[41] + z[47] + z[51];
z[24] = z[10] * z[24];
z[20] = -z[20] + -z[39];
z[20] = z[8] * z[20];
z[23] = -9 * z[2] + -z[7] + (T(539) / T(18)) * z[13] + -z[23];
z[20] = z[20] + (T(1) / T(2)) * z[23];
z[20] = z[8] * z[20];
z[23] = -z[33] + -z[48];
z[23] = z[4] * z[23];
z[23] = T(-211) / T(36) + z[23];
z[20] = z[20] + (T(1) / T(2)) * z[23];
z[20] = z[8] * z[20];
z[23] = 5 * z[2] + (T(-557) / T(36)) * z[13] + z[49];
z[23] = z[8] * z[23];
z[28] = z[1] * z[11];
z[39] = -1 + -5 * z[40];
z[23] = z[23] + (T(223) / T(72)) * z[28] + (T(5) / T(12)) * z[39];
z[23] = z[11] * z[23];
z[39] = T(2) / T(3) + -z[46];
z[39] = z[4] * z[39];
z[33] = prod_pow(z[4], 3) * z[1] * z[33];
z[14] = z[14] + z[20] + z[23] + z[24] + (T(-3) / T(2)) * z[33] + 2 * z[39];
z[14] = z[10] * z[14];
z[20] = z[3] * z[37];
z[23] = z[5] * z[6];
z[24] = T(-1) / T(2) + z[23];
z[33] = z[5] * z[24];
z[37] = (T(11) / T(2)) * z[2] + -z[33];
z[37] = z[37] * z[44];
z[15] = (T(1) / T(2)) * z[15] + -z[19] + (T(3) / T(4)) * z[20] + z[22] + (T(7) / T(4)) * z[34] + z[37];
z[15] = z[3] * z[15];
z[22] = T(-1) / T(2) + -z[23];
z[22] = z[5] * z[22];
z[37] = -z[4] * z[33];
z[37] = T(-19) / T(6) + z[37];
z[37] = z[1] * z[37];
z[22] = (T(5) / T(2)) * z[9] + (T(-337) / T(36)) * z[13] + z[22] + z[26] + -z[36] + z[37];
z[26] = z[8] * z[32];
z[15] = z[15] + (T(1) / T(2)) * z[22] + z[26];
z[15] = z[3] * z[15];
z[22] = z[4] * z[38];
z[20] = z[20] + -z[22];
z[22] = -z[5] + -z[9];
z[22] = z[22] * z[31];
z[26] = (T(3) / T(2)) * z[4];
z[32] = z[19] * z[26];
z[32] = (T(-3) / T(2)) * z[2] + z[32] + z[33];
z[32] = z[32] * z[44];
z[20] = (T(-1) / T(4)) * z[20] + z[22] + -z[25] + z[32] + -z[34];
z[20] = z[3] * z[20];
z[16] = (T(3) / T(2)) * z[16];
z[22] = (T(3) / T(2)) * z[21];
z[25] = -z[5] + -z[29];
z[25] = z[5] * z[25];
z[25] = -z[16] + -z[22] + z[25];
z[25] = z[17] * z[25];
z[19] = z[19] + (T(3) / T(4)) * z[34];
z[19] = z[4] * z[19];
z[29] = z[2] * z[27];
z[24] = z[24] + z[29];
z[24] = z[24] * z[44];
z[19] = (T(-3) / T(2)) * z[9] + z[19] + z[20] + z[24] + z[25] + z[33];
z[19] = z[3] * z[19];
z[20] = z[2] + z[9];
z[20] = z[20] * z[26];
z[24] = (T(13) / T(12)) * z[6];
z[25] = z[1] * z[24];
z[20] = T(-1) / T(12) + z[20] + z[23] + z[25];
z[25] = -z[5] * z[30];
z[16] = -z[16] + -3 * z[21] + z[25];
z[16] = z[16] * z[17];
z[21] = T(3) / T(2) + z[23];
z[21] = z[21] * z[31];
z[16] = -z[9] + z[16] + z[21] + -z[48];
z[16] = z[8] * z[16];
z[16] = z[16] + z[19] + (T(1) / T(2)) * z[20];
z[16] = z[3] * z[16];
z[19] = z[5] + -z[9];
z[19] = z[5] * z[19];
z[18] = -z[18] + z[19] + -z[22];
z[17] = z[17] * z[18];
z[17] = z[5] + (T(-1) / T(4)) * z[9] + z[17] + -z[48];
z[17] = z[8] * z[17];
z[18] = -z[7] + z[9];
z[18] = z[18] * z[27];
z[18] = 1 + z[18];
z[17] = z[17] + (T(1) / T(2)) * z[18];
z[17] = z[8] * z[17];
z[16] = (T(13) / T(24)) * z[4] + z[16] + z[17];
z[16] = z[0] * z[16];
z[17] = -3 + -z[23];
z[17] = z[5] * z[17];
z[17] = z[17] + z[43];
z[17] = z[4] * z[17];
z[17] = T(13) / T(12) + z[17] + z[23];
z[17] = z[4] * z[17];
z[17] = z[17] + -z[24];
z[17] = z[17] * z[44];
z[18] = z[35] + z[50];
z[18] = z[8] * z[18];
z[19] = (T(-319) / T(36)) * z[13] + z[42];
z[18] = z[18] + (T(1) / T(2)) * z[19];
z[18] = z[8] * z[18];
return z[14] + z[15] + z[16] + z[17] + z[18] + (T(19) / T(12)) * z[28] + z[45];
}



template double eval_coef_2q3y_2l_pmmpp_12345_160(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_160(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
