#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_162(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[59];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[1];
z[4] = v[2];
z[5] = iW[22];
z[6] = v[3];
z[7] = v[4];
z[8] = iW[1];
z[9] = v[0];
z[10] = iW[4];
z[11] = iW[17];
z[12] = iW[18];
z[13] = z[5] + (T(1) / T(2)) * z[11];
z[14] = -z[2] + (T(7) / T(2)) * z[12];
z[15] = z[13] + -z[14];
z[16] = prod_pow(z[5], 2);
z[17] = (T(1) / T(2)) * z[16];
z[18] = prod_pow(z[5], 3);
z[19] = z[7] * z[18];
z[20] = z[17] + -z[19];
z[20] = z[7] * z[20];
z[21] = prod_pow(z[12], 2);
z[22] = 3 * z[21];
z[23] = prod_pow(z[2], 2);
z[24] = z[22] + -z[23];
z[25] = z[6] * z[24];
z[15] = (T(1) / T(2)) * z[15] + z[20] + (T(1) / T(4)) * z[25];
z[15] = z[6] * z[15];
z[20] = 2 * z[19];
z[25] = z[17] + -z[20];
z[25] = z[7] * z[25];
z[13] = (T(1) / T(2)) * z[13] + z[25];
z[13] = z[7] * z[13];
z[13] = T(3) / T(2) + z[13] + z[15];
z[13] = z[6] * z[13];
z[15] = (T(3) / T(2)) * z[21];
z[25] = prod_pow(z[11], 2);
z[26] = z[15] + -z[25];
z[27] = z[10] + z[11];
z[28] = z[5] + (T(1) / T(4)) * z[27];
z[28] = z[5] * z[28];
z[29] = (T(1) / T(4)) * z[25];
z[30] = z[28] + -z[29];
z[31] = (T(1) / T(2)) * z[5];
z[32] = z[6] * z[30] * z[31];
z[26] = (T(3) / T(2)) * z[19] + (T(1) / T(4)) * z[26] + z[28] + z[32];
z[26] = z[6] * z[26];
z[28] = 3 * z[7];
z[32] = z[18] * z[28];
z[33] = 3 * z[16];
z[29] = -z[29] + z[32] + z[33];
z[29] = z[7] * z[29];
z[32] = z[11] + (T(-1) / T(2)) * z[12];
z[32] = z[5] + (T(1) / T(2)) * z[32];
z[29] = z[29] + 3 * z[32];
z[26] = z[26] + (T(1) / T(2)) * z[29];
z[26] = z[6] * z[26];
z[29] = (T(1) / T(2)) * z[1];
z[32] = z[5] + z[29];
z[34] = z[16] * z[32];
z[35] = z[7] * z[34];
z[36] = z[5] * z[32];
z[36] = (T(1) / T(2)) * z[35] + z[36];
z[36] = z[7] * z[36];
z[37] = 3 * z[5];
z[38] = z[11] + z[37];
z[36] = z[36] + (T(1) / T(2)) * z[38];
z[36] = z[7] * z[36];
z[26] = z[26] + z[36];
z[26] = z[4] * z[26];
z[36] = z[1] + z[5];
z[38] = -z[31] * z[36];
z[38] = -z[35] + z[38];
z[38] = z[7] * z[38];
z[39] = -z[1] + z[5];
z[40] = (T(1) / T(2)) * z[39];
z[38] = z[38] + -z[40];
z[38] = z[7] * z[38];
z[38] = 1 + z[38];
z[38] = z[7] * z[38];
z[13] = z[13] + z[26] + z[38];
z[13] = z[4] * z[13];
z[21] = (T(3) / T(4)) * z[21];
z[26] = z[21] + -z[23];
z[26] = z[6] * z[26];
z[38] = 3 * z[2];
z[41] = (T(7) / T(4)) * z[12] + -z[26] + -z[38];
z[41] = z[6] * z[41];
z[42] = (T(1) / T(2)) * z[4];
z[43] = z[6] * z[23];
z[44] = z[2] + -z[43];
z[44] = z[42] * z[44];
z[41] = T(-3) / T(8) + z[41] + z[44];
z[41] = z[4] * z[41];
z[44] = z[1] * z[2];
z[45] = 5 * z[44];
z[46] = z[1] * z[4] * z[23];
z[47] = 3 * z[23] + -z[45] + -z[46];
z[48] = (T(1) / T(4)) * z[4];
z[47] = z[47] * z[48];
z[43] = -z[1] + z[38] + (T(-3) / T(4)) * z[43] + z[47];
z[43] = z[4] * z[43];
z[47] = (T(1) / T(2)) * z[2] + z[12];
z[47] = z[2] * z[47];
z[21] = z[21] + z[47];
z[47] = z[6] * z[21];
z[49] = (T(11) / T(2)) * z[12];
z[50] = -9 * z[2] + -z[49];
z[50] = z[47] + (T(1) / T(2)) * z[50];
z[50] = z[6] * z[50];
z[51] = z[1] * z[28];
z[50] = 5 + z[50] + -z[51];
z[43] = z[43] + (T(1) / T(2)) * z[50];
z[43] = z[9] * z[43];
z[50] = (T(1) / T(2)) * z[7];
z[52] = z[1] * z[7];
z[52] = T(19) / T(4) + z[52];
z[52] = z[50] * z[52];
z[53] = (T(13) / T(2)) * z[12];
z[54] = 7 * z[2] + z[53];
z[54] = -z[47] + (T(1) / T(2)) * z[54];
z[54] = z[6] * z[54];
z[54] = T(-9) / T(2) + z[54];
z[54] = z[6] * z[54];
z[41] = z[41] + z[43] + z[52] + z[54];
z[41] = z[9] * z[41];
z[43] = (T(3) / T(2)) * z[16];
z[52] = z[19] + -z[43];
z[54] = prod_pow(z[7], 2);
z[55] = (T(1) / T(2)) * z[54];
z[52] = z[52] * z[55];
z[52] = -1 + z[52];
z[52] = z[7] * z[52];
z[56] = z[2] + (T(3) / T(2)) * z[12];
z[57] = z[47] + (T(-5) / T(2)) * z[56];
z[58] = (T(1) / T(2)) * z[6];
z[57] = z[57] * z[58];
z[57] = 2 + z[57];
z[57] = z[6] * z[57];
z[52] = z[52] + z[57];
z[52] = z[6] * z[52];
z[57] = -z[16] + z[35];
z[57] = z[7] * z[57];
z[57] = -z[29] + z[57];
z[57] = z[7] * z[57];
z[57] = -1 + z[57];
z[55] = z[55] * z[57];
z[13] = z[13] + z[41] + z[52] + z[55];
z[13] = z[8] * z[13];
z[28] = z[28] * z[34];
z[37] = z[1] + z[37];
z[41] = z[31] * z[37];
z[41] = z[28] + z[41];
z[41] = z[7] * z[41];
z[41] = z[31] + z[41];
z[41] = z[7] * z[41];
z[41] = T(-5) / T(4) + z[41];
z[52] = 7 * z[5] + (T(5) / T(2)) * z[27];
z[52] = z[31] * z[52];
z[52] = -z[24] + (T(-1) / T(2)) * z[25] + z[52];
z[55] = z[5] * z[6];
z[30] = z[30] * z[55];
z[20] = z[20] + z[30] + (T(1) / T(2)) * z[52];
z[20] = z[6] * z[20];
z[17] = z[17] + z[19];
z[17] = z[7] * z[17];
z[30] = 5 * z[5] + z[10] + (T(5) / T(2)) * z[11] + (T(21) / T(2)) * z[12] + -z[38];
z[17] = 5 * z[17] + (T(1) / T(2)) * z[30];
z[17] = (T(1) / T(2)) * z[17] + z[20];
z[17] = z[6] * z[17];
z[20] = -z[22] + -z[23];
z[20] = z[6] * z[20];
z[20] = z[20] + z[56];
z[20] = z[20] * z[48];
z[17] = z[17] + z[20] + (T(1) / T(2)) * z[41];
z[17] = z[4] * z[17];
z[20] = (T(1) / T(2)) * z[23] + -z[44];
z[20] = 5 * z[20] + (T(-3) / T(2)) * z[46];
z[20] = z[20] * z[42];
z[22] = 13 * z[2] + (T(-5) / T(2)) * z[12];
z[22] = -5 * z[1] + (T(1) / T(2)) * z[22];
z[20] = z[20] + (T(1) / T(2)) * z[22] + z[26];
z[20] = z[4] * z[20];
z[22] = -5 * z[2] + -z[49];
z[22] = (T(1) / T(2)) * z[22] + z[47];
z[22] = z[6] * z[22];
z[26] = z[1] * z[9];
z[30] = 1 + -z[51];
z[20] = z[20] + z[22] + (T(3) / T(2)) * z[26] + (T(1) / T(2)) * z[30];
z[20] = z[9] * z[20];
z[22] = z[38] + z[53];
z[22] = (T(1) / T(2)) * z[22] + -z[47];
z[22] = z[6] * z[22];
z[30] = (T(5) / T(4)) * z[16] + -z[19];
z[30] = z[30] * z[54];
z[22] = T(-3) / T(2) + z[22] + z[30];
z[22] = z[6] * z[22];
z[30] = z[5] * z[37];
z[28] = -z[28] + z[30];
z[28] = z[7] * z[28];
z[28] = z[28] + z[32];
z[28] = z[28] * z[50];
z[28] = 1 + z[28];
z[28] = z[7] * z[28];
z[13] = z[13] + z[17] + z[20] + z[22] + z[28];
z[13] = z[8] * z[13];
z[17] = -z[31] * z[39];
z[20] = -z[4] * z[34];
z[18] = z[6] * z[18];
z[17] = z[17] + -z[18] + z[20] + -z[35];
z[17] = z[4] * z[17];
z[20] = z[5] * z[36];
z[20] = z[20] + -z[35];
z[20] = z[7] * z[20];
z[17] = -z[1] + z[17] + z[20];
z[20] = -z[23] * z[29];
z[20] = z[20] + z[34];
z[20] = z[20] * z[42];
z[20] = z[16] + z[18] + z[20] + (T(-1) / T(4)) * z[23];
z[20] = z[4] * z[20];
z[22] = z[18] + z[43];
z[22] = z[6] * z[22];
z[22] = z[22] + z[29];
z[20] = z[20] + (T(1) / T(2)) * z[22];
z[20] = z[0] * z[4] * z[20];
z[17] = (T(1) / T(2)) * z[17] + z[20];
z[17] = z[3] * z[17];
z[15] = z[15] + z[23] + -z[45] + -3 * z[46];
z[15] = z[15] * z[48];
z[20] = z[24] + -z[33];
z[20] = -z[18] + (T(1) / T(2)) * z[20];
z[20] = z[20] * z[58];
z[14] = z[5] + z[14];
z[14] = -z[1] + (T(-1) / T(4)) * z[14] + z[15] + z[20];
z[14] = z[4] * z[14];
z[15] = z[5] * z[27];
z[20] = z[15] + -z[25];
z[20] = z[20] * z[55];
z[15] = (T(3) / T(4)) * z[15] + (T(1) / T(4)) * z[20] + z[21];
z[15] = z[6] * z[15];
z[19] = -z[16] + z[19];
z[19] = z[7] * z[19];
z[20] = -z[2] + z[10] + -z[49];
z[15] = z[15] + z[19] + (T(1) / T(2)) * z[20];
z[15] = z[15] * z[58];
z[19] = 2 * z[16] + z[18];
z[19] = z[6] * z[19];
z[19] = z[5] + z[19];
z[19] = z[6] * z[19];
z[20] = z[23] + z[33];
z[20] = z[18] + (T(1) / T(2)) * z[20];
z[20] = z[6] * z[20];
z[21] = -z[2] + z[5];
z[20] = z[20] + (T(1) / T(2)) * z[21];
z[20] = z[20] * z[42];
z[19] = T(-1) / T(4) + z[19] + z[20];
z[19] = z[4] * z[19];
z[16] = (T(5) / T(2)) * z[16] + z[18];
z[16] = z[6] * z[16];
z[18] = (T(3) / T(2)) * z[5];
z[16] = z[16] + z[18];
z[16] = prod_pow(z[6], 2) * z[16];
z[16] = z[16] + z[50];
z[16] = (T(1) / T(2)) * z[16] + z[19];
z[16] = z[0] * z[16];
z[18] = -z[1] + -z[18];
z[18] = z[5] * z[18];
z[18] = z[18] + (T(3) / T(2)) * z[35];
z[18] = z[7] * z[18];
z[18] = z[18] + -z[40];
z[18] = z[7] * z[18];
return z[13] + z[14] + z[15] + z[16] + z[17] + z[18] + z[26];
}



template double eval_coef_2q3y_2l_pmmpp_12345_162(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_162(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
