#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_163(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[57];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[1];
z[4] = v[2];
z[5] = iW[22];
z[6] = v[3];
z[7] = iW[1];
z[8] = iW[2];
z[9] = v[0];
z[10] = v[4];
z[11] = iW[4];
z[12] = iW[17];
z[13] = iW[18];
z[14] = prod_pow(z[12], 2);
z[15] = z[11] + z[12];
z[16] = -7 * z[5] + (T(-5) / T(2)) * z[15];
z[16] = z[5] * z[16];
z[16] = z[14] + z[16];
z[17] = prod_pow(z[2], 2);
z[18] = 5 * z[17];
z[19] = prod_pow(z[5], 3);
z[20] = z[10] * z[19];
z[21] = 4 * z[20];
z[22] = prod_pow(z[2], 3);
z[23] = z[4] * z[22];
z[16] = (T(1) / T(2)) * z[16] + -z[18] + -z[21] + -z[23];
z[16] = z[4] * z[16];
z[24] = 2 * z[2];
z[25] = z[8] + z[13];
z[26] = (T(1) / T(2)) * z[25];
z[27] = z[24] + z[26];
z[27] = z[2] * z[27];
z[28] = prod_pow(z[8], 2);
z[29] = (T(1) / T(2)) * z[28];
z[27] = z[27] + -z[29];
z[30] = z[2] * z[6];
z[27] = z[27] * z[30];
z[31] = 13 * z[2] + (T(7) / T(2)) * z[25];
z[31] = z[2] * z[31];
z[31] = -z[29] + z[31];
z[32] = 2 * z[5];
z[33] = (T(1) / T(2)) * z[15];
z[34] = z[32] + z[33];
z[34] = z[5] * z[34];
z[34] = (T(-1) / T(2)) * z[14] + z[34];
z[35] = -z[5] * z[34];
z[35] = 2 * z[22] + z[35];
z[35] = z[4] * z[35];
z[31] = -z[27] + (T(1) / T(2)) * z[31] + z[35];
z[31] = z[6] * z[31];
z[35] = 3 * z[8];
z[36] = -z[13] + -z[35];
z[36] = -15 * z[2] + (T(1) / T(2)) * z[36];
z[16] = z[16] + z[31] + (T(1) / T(2)) * z[36];
z[16] = z[6] * z[16];
z[31] = prod_pow(z[5], 2);
z[36] = -z[20] + (T(-1) / T(2)) * z[31];
z[36] = z[10] * z[36];
z[37] = z[4] * z[17];
z[38] = z[11] + z[13];
z[36] = (T(7) / T(2)) * z[2] + (T(-5) / T(2)) * z[5] + (T(-5) / T(4)) * z[12] + 5 * z[36] + (T(3) / T(2)) * z[37] + z[38];
z[36] = z[4] * z[36];
z[39] = (T(5) / T(2)) * z[31];
z[40] = 2 * z[20];
z[41] = -z[39] + z[40];
z[42] = prod_pow(z[10], 2);
z[41] = z[41] * z[42];
z[16] = T(-3) / T(4) + z[16] + z[36] + z[41];
z[16] = z[6] * z[16];
z[36] = 2 * z[19];
z[41] = z[1] * z[31];
z[41] = z[36] + z[41];
z[41] = z[10] * z[41];
z[43] = z[1] * z[5];
z[41] = z[31] + z[41] + z[43];
z[41] = z[10] * z[41];
z[41] = -z[1] + z[5] + z[41];
z[41] = z[10] * z[41];
z[44] = (T(1) / T(2)) * z[1];
z[45] = z[31] * z[44];
z[45] = z[19] + z[45];
z[46] = z[10] * z[45];
z[47] = 2 * z[31];
z[48] = -z[43] + -z[46] + -z[47];
z[48] = z[10] * z[48];
z[49] = 3 * z[5];
z[48] = -z[12] + z[48] + -z[49];
z[48] = z[4] * z[48];
z[41] = -2 + z[41] + z[48];
z[41] = z[4] * z[10] * z[41];
z[40] = -z[31] + z[40];
z[40] = z[10] * z[40];
z[48] = 3 * z[20];
z[34] = -z[34] + -z[48];
z[34] = z[4] * z[34];
z[24] = -z[5] + -z[24] + -z[33] + z[34] + z[40];
z[24] = z[4] * z[24];
z[33] = z[2] + (T(1) / T(4)) * z[25];
z[33] = z[2] * z[33];
z[34] = (T(1) / T(4)) * z[28];
z[33] = z[33] + -z[34];
z[30] = z[30] * z[33];
z[30] = z[30] + z[34];
z[40] = -4 * z[2] + -z[25];
z[40] = z[2] * z[40];
z[40] = -z[23] + z[30] + z[40];
z[40] = z[6] * z[40];
z[50] = (T(1) / T(4)) * z[14];
z[51] = -z[5] + (T(-1) / T(4)) * z[15];
z[51] = z[5] * z[51];
z[51] = z[50] + z[51];
z[51] = z[4] * z[5] * z[51];
z[52] = (T(5) / T(2)) * z[17];
z[51] = z[51] + z[52];
z[51] = z[4] * z[51];
z[53] = z[10] * z[34];
z[40] = (T(13) / T(2)) * z[2] + z[8] + (T(3) / T(4)) * z[13] + z[40] + z[51] + -z[53];
z[40] = z[6] * z[40];
z[51] = z[8] * z[10];
z[24] = -2 + z[24] + z[40] + -z[51];
z[24] = z[6] * z[24];
z[40] = 3 * z[31];
z[48] = -z[40] + -z[48] + z[50];
z[48] = z[10] * z[48];
z[50] = z[5] + (T(1) / T(2)) * z[12];
z[48] = z[48] + -3 * z[50];
z[48] = z[4] * z[48];
z[21] = z[21] + -z[31];
z[21] = z[10] * z[21];
z[21] = z[21] + -z[50];
z[21] = z[10] * z[21];
z[21] = T(-3) / T(2) + z[21] + z[48];
z[21] = z[4] * z[21];
z[48] = (T(3) / T(2)) * z[31];
z[50] = -z[20] + z[48];
z[50] = z[42] * z[50];
z[50] = T(5) / T(4) + z[50];
z[50] = z[10] * z[50];
z[21] = z[21] + z[24] + z[50];
z[21] = z[6] * z[21];
z[24] = -z[31] + z[46];
z[50] = -z[10] * z[24];
z[50] = z[44] + z[50];
z[50] = z[10] * z[50];
z[50] = 1 + z[50];
z[42] = z[42] * z[50];
z[21] = z[21] + z[41] + z[42];
z[21] = z[7] * z[21];
z[41] = 3 * z[10];
z[41] = z[41] * z[45];
z[42] = -z[40] + -z[43];
z[42] = -z[41] + (T(1) / T(2)) * z[42];
z[42] = z[10] * z[42];
z[50] = (T(1) / T(2)) * z[5];
z[42] = z[42] + -z[50];
z[42] = z[10] * z[42];
z[54] = z[2] * z[4];
z[42] = T(-1) / T(2) + z[42] + (T(-1) / T(2)) * z[54];
z[42] = z[4] * z[42];
z[41] = -z[40] + z[41];
z[55] = z[41] + -z[43];
z[55] = z[10] * z[55];
z[55] = -z[5] + -z[44] + z[55];
z[55] = z[10] * z[55];
z[55] = -1 + z[55];
z[55] = z[10] * z[55];
z[16] = z[16] + z[21] + z[42] + z[55];
z[16] = z[7] * z[16];
z[21] = -z[2] + z[44];
z[42] = z[17] * z[21];
z[42] = z[42] + -z[45];
z[42] = z[0] * z[3] * z[42];
z[55] = 3 * z[17];
z[56] = z[21] * z[55];
z[42] = z[42] + z[56];
z[42] = z[4] * z[42];
z[45] = z[3] * z[45];
z[47] = (T(-1) / T(2)) * z[17] + -z[47];
z[47] = z[3] * z[47];
z[56] = z[2] + -z[5];
z[47] = z[47] + (T(1) / T(2)) * z[56];
z[47] = z[0] * z[47];
z[56] = (T(5) / T(2)) * z[1] + -6 * z[2];
z[56] = z[2] * z[56];
z[42] = z[42] + z[45] + z[47] + z[56];
z[42] = z[4] * z[42];
z[45] = z[31] + -z[43];
z[45] = (T(1) / T(2)) * z[45] + z[46];
z[45] = z[3] * z[45];
z[46] = (T(5) / T(2)) * z[2];
z[42] = z[1] + -z[38] + z[42] + z[45] + -z[46] + z[50];
z[42] = z[4] * z[42];
z[45] = -z[19] + z[22];
z[47] = z[4] * z[45];
z[50] = z[3] * z[19];
z[47] = z[17] + -4 * z[31] + z[47] + -z[50];
z[47] = z[0] * z[47];
z[45] = -z[45] + z[47];
z[45] = z[4] * z[45];
z[47] = -z[4] * z[36];
z[19] = -z[6] * z[19];
z[19] = z[19] + -z[39] + z[47];
z[19] = z[0] * z[19];
z[15] = z[5] * z[15];
z[14] = z[14] + -z[15];
z[14] = z[5] * z[14];
z[33] = z[2] * z[33];
z[14] = (T(1) / T(4)) * z[14] + z[19] + z[33];
z[14] = z[6] * z[14];
z[19] = 5 * z[2];
z[25] = -z[19] + (T(-3) / T(2)) * z[25];
z[25] = z[2] * z[25];
z[33] = -z[0] * z[49];
z[15] = (T(-3) / T(2)) * z[15] + z[25] + z[33];
z[14] = z[14] + (T(1) / T(2)) * z[15] + z[45];
z[14] = z[6] * z[14];
z[15] = -z[17] + -z[31];
z[25] = -z[22] + -z[36];
z[25] = z[3] * z[25];
z[15] = (T(3) / T(2)) * z[15] + z[25];
z[15] = z[0] * z[15];
z[15] = z[15] + z[22];
z[15] = z[4] * z[15];
z[18] = z[18] + z[40];
z[22] = -z[17] + -z[48];
z[22] = z[3] * z[22];
z[22] = -z[2] + z[22] + -z[32];
z[22] = z[0] * z[22];
z[15] = z[15] + (T(1) / T(2)) * z[18] + z[22] + z[50];
z[15] = z[4] * z[15];
z[18] = -z[20] + z[31];
z[18] = z[10] * z[18];
z[14] = (T(3) / T(2)) * z[2] + z[14] + z[15] + z[18] + (T(-1) / T(2)) * z[38];
z[14] = z[6] * z[14];
z[15] = -4 * z[23] + z[27];
z[18] = 3 * z[2];
z[20] = z[18] + z[26];
z[18] = z[18] * z[20];
z[18] = -z[15] + z[18] + -z[29];
z[18] = z[6] * z[18];
z[22] = z[10] * z[28];
z[22] = z[13] + z[22] + -z[35];
z[17] = -11 * z[17] + -2 * z[23];
z[17] = z[4] * z[17];
z[17] = -16 * z[2] + z[17] + z[18] + (T(1) / T(2)) * z[22];
z[17] = z[6] * z[17];
z[18] = 11 * z[2] + 3 * z[37] + z[38];
z[18] = z[4] * z[18];
z[17] = T(9) / T(2) + z[17] + z[18] + 2 * z[51];
z[17] = z[6] * z[17];
z[18] = z[1] * z[10];
z[22] = -3 + -z[18];
z[22] = z[10] * z[22];
z[25] = -1 + -z[54];
z[25] = z[4] * z[25];
z[17] = z[17] + z[22] + z[25];
z[17] = z[7] * z[17];
z[22] = z[21] * z[37];
z[21] = z[19] * z[21];
z[21] = z[21] + z[22];
z[21] = z[4] * z[21];
z[25] = z[1] + -z[19];
z[21] = z[21] + 2 * z[25];
z[21] = z[4] * z[21];
z[19] = -z[19] + -z[26];
z[19] = z[2] * z[19];
z[19] = z[19] + -3 * z[23] + z[30];
z[19] = z[6] * z[19];
z[25] = z[23] + z[55];
z[25] = z[4] * z[25];
z[19] = 9 * z[2] + (T(1) / T(2)) * z[8] + -z[13] + z[19] + 3 * z[25] + -z[53];
z[19] = z[6] * z[19];
z[25] = (T(3) / T(2)) * z[1] + -z[8];
z[26] = z[10] * z[25];
z[19] = T(-3) / T(2) + z[19] + z[21] + z[26];
z[19] = z[7] * z[19];
z[21] = z[6] * z[34];
z[19] = z[11] + z[19] + z[21] + -z[25];
z[19] = z[9] * z[19];
z[20] = -z[20] * z[46];
z[15] = z[15] + z[20];
z[15] = z[6] * z[15];
z[20] = z[23] + z[52];
z[20] = z[4] * z[20];
z[21] = (T(-3) / T(2)) * z[8] + -z[11] + -3 * z[13];
z[15] = 10 * z[2] + z[15] + 5 * z[20] + (T(1) / T(2)) * z[21];
z[15] = z[6] * z[15];
z[20] = 5 * z[1] + (T(-21) / T(2)) * z[2];
z[20] = z[2] * z[20];
z[20] = z[20] + 3 * z[22];
z[20] = z[4] * z[20];
z[20] = (T(7) / T(2)) * z[1] + (T(-25) / T(2)) * z[2] + z[20] + -z[38];
z[20] = z[4] * z[20];
z[18] = 1 + z[18];
z[15] = z[15] + z[17] + 2 * z[18] + z[19] + z[20];
z[15] = z[7] * z[15];
z[15] = -z[1] + z[11] + z[15];
z[15] = z[9] * z[15];
z[17] = -z[41] + 2 * z[43];
z[17] = z[10] * z[17];
z[17] = z[5] + z[17] + -z[44];
z[17] = z[10] * z[17];
z[18] = z[24] + -z[43];
z[18] = z[10] * z[18];
z[18] = z[18] + z[44];
z[18] = z[3] * z[18];
return 1 + z[14] + z[15] + z[16] + z[17] + z[18] + z[42];
}



template double eval_coef_2q3y_2l_pmmpp_12345_163(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_163(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
