#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_164(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[57];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[5];
z[3] = v[0];
z[4] = v[4];
z[5] = iW[18];
z[6] = v[3];
z[7] = iW[3];
z[8] = iW[16];
z[9] = v[2];
z[10] = iW[19];
z[11] = iW[17];
z[12] = iW[4];
z[13] = iW[15];
z[14] = iW[12];
z[15] = v[1];
z[16] = (T(1) / T(3)) * z[11];
z[17] = prod_pow(z[11], 2);
z[18] = z[6] * z[17];
z[19] = (T(1) / T(2)) * z[10];
z[20] = -z[16] + (T(1) / T(6)) * z[18] + z[19];
z[21] = (T(1) / T(2)) * z[6];
z[22] = z[12] * z[21];
z[20] = z[20] * z[22];
z[20] = (T(1) / T(3)) * z[14] + z[20];
z[23] = z[4] * z[14];
z[24] = prod_pow(z[4], 2);
z[25] = z[14] * z[24];
z[26] = z[4] + -z[25];
z[26] = z[11] * z[26];
z[26] = 1 + -2 * z[23] + z[26];
z[26] = z[16] * z[26];
z[26] = (T(1) / T(24)) * z[18] + -z[19] + -z[20] + z[26];
z[26] = z[9] * z[26];
z[27] = (T(3) / T(4)) * z[10];
z[28] = z[4] * z[11];
z[29] = 1 + z[28];
z[29] = z[11] * z[29];
z[29] = (T(1) / T(12)) * z[18] + z[27] + (T(2) / T(3)) * z[29];
z[29] = z[6] * z[29];
z[30] = z[11] * z[24];
z[25] = (T(-11) / T(8)) * z[4] + z[25] + (T(5) / T(4)) * z[30];
z[16] = z[16] * z[25];
z[25] = z[11] + (T(-1) / T(3)) * z[18];
z[25] = z[6] * z[25];
z[25] = T(-5) / T(6) + z[25];
z[22] = z[22] * z[25];
z[25] = z[4] * z[10];
z[31] = 3 * z[25];
z[32] = -1 + z[31];
z[32] = (T(1) / T(2)) * z[32];
z[16] = z[16] + z[22] + (T(1) / T(3)) * z[23] + z[26] + z[29] + z[32];
z[16] = z[9] * z[16];
z[22] = z[3] * z[5];
z[26] = -1 + (T(-103) / T(36)) * z[22];
z[26] = z[3] * z[26];
z[29] = T(23) / T(12) + -z[31];
z[29] = z[4] * z[29];
z[26] = z[26] + z[29] + (T(-5) / T(3)) * z[30];
z[29] = prod_pow(z[3], 2);
z[33] = prod_pow(z[5], 2) * z[29];
z[34] = (T(3) / T(2)) * z[25];
z[35] = -3 * z[4] + (T(5) / T(6)) * z[30];
z[35] = z[11] * z[35];
z[35] = T(1) / T(4) + z[33] + -z[34] + (T(1) / T(2)) * z[35];
z[36] = (T(1) / T(8)) * z[18];
z[37] = T(5) / T(4) + z[28];
z[37] = z[11] * z[37];
z[37] = z[36] + z[37];
z[38] = (T(1) / T(3)) * z[6];
z[37] = z[37] * z[38];
z[35] = (T(1) / T(2)) * z[35] + z[37];
z[35] = z[6] * z[35];
z[37] = prod_pow(z[13], 2);
z[39] = z[17] + (T(1) / T(2)) * z[37];
z[40] = (T(1) / T(4)) * z[6];
z[39] = z[39] * z[40];
z[39] = -z[11] + z[39];
z[39] = z[6] * z[39];
z[39] = T(5) / T(8) + z[39];
z[39] = z[6] * z[39];
z[39] = z[3] + z[39];
z[39] = z[6] * z[39];
z[41] = (T(7) / T(8)) * z[29] + -z[39];
z[42] = z[12] * z[29];
z[43] = z[6] * z[42];
z[41] = (T(1) / T(3)) * z[41] + (T(3) / T(8)) * z[43];
z[41] = z[12] * z[41];
z[16] = z[16] + (T(1) / T(2)) * z[26] + z[35] + z[41];
z[16] = z[9] * z[16];
z[22] = 1 + z[22];
z[26] = prod_pow(z[1], 2);
z[35] = (T(5) / T(12)) * z[26];
z[22] = z[22] * z[35];
z[41] = (T(-5) / T(4)) * z[1] + z[5];
z[41] = z[5] * z[41];
z[22] = z[22] + z[41];
z[22] = z[22] * z[29];
z[41] = z[5] * z[26] * z[29];
z[43] = -z[13] + -5 * z[41];
z[43] = z[11] + (T(1) / T(2)) * z[43];
z[43] = z[6] * z[43];
z[22] = T(-1) / T(4) + z[22] + (T(-1) / T(4)) * z[28] + (T(1) / T(6)) * z[43];
z[22] = z[6] * z[22];
z[43] = 5 * z[1] + z[2];
z[43] = -z[5] + (T(1) / T(6)) * z[43];
z[43] = z[5] * z[43];
z[44] = z[2] * z[8];
z[43] = z[43] + (T(-5) / T(6)) * z[44];
z[44] = -z[35] + z[43];
z[44] = z[3] * z[44];
z[45] = 3 * z[1] + (T(-175) / T(18)) * z[5];
z[44] = z[44] + (T(1) / T(2)) * z[45];
z[44] = z[3] * z[44];
z[44] = T(1) / T(4) + z[44];
z[44] = z[3] * z[44];
z[45] = prod_pow(z[2], 2);
z[46] = (T(-1) / T(6)) * z[26] + -z[45];
z[46] = z[29] * z[46];
z[47] = (T(1) / T(2)) * z[25];
z[46] = T(-1) / T(4) + z[46] + z[47];
z[46] = z[4] * z[46];
z[22] = z[22] + (T(-5) / T(12)) * z[30] + z[44] + z[46];
z[22] = z[21] * z[22];
z[44] = z[1] * z[2];
z[46] = z[26] + z[44];
z[48] = z[2] * z[3];
z[46] = z[46] * z[48];
z[49] = (T(5) / T(12)) * z[46];
z[50] = -z[35] + -z[45] + z[49];
z[50] = z[29] * z[50];
z[50] = T(-7) / T(12) + z[25] + z[50];
z[50] = z[4] * z[50];
z[26] = (T(1) / T(2)) * z[26] + z[44];
z[51] = z[3] * z[26];
z[51] = (T(1) / T(4)) * z[1] + -z[2] + z[51];
z[51] = z[3] * z[51];
z[51] = T(7) / T(4) + z[51];
z[52] = (T(1) / T(3)) * z[3];
z[51] = z[51] * z[52];
z[50] = z[50] + z[51];
z[51] = (T(1) / T(2)) * z[4];
z[50] = z[50] * z[51];
z[53] = (T(1) / T(2)) * z[2];
z[54] = (T(-2) / T(3)) * z[1] + (T(115) / T(72)) * z[5] + (T(5) / T(12)) * z[8] + -z[53];
z[54] = z[3] * z[54];
z[54] = T(25) / T(18) + z[54];
z[54] = z[29] * z[54];
z[55] = z[6] * z[29];
z[56] = prod_pow(z[3], 3);
z[55] = -z[55] + (T(-1) / T(3)) * z[56];
z[55] = z[12] * z[55];
z[16] = z[16] + z[22] + z[50] + z[54] + (T(5) / T(8)) * z[55];
z[16] = z[0] * z[16];
z[22] = 1 + (T(5) / T(6)) * z[28];
z[22] = z[11] * z[22];
z[18] = z[10] + (T(1) / T(2)) * z[18] + z[22];
z[18] = z[6] * z[18];
z[22] = -z[17] + z[37];
z[22] = z[22] * z[38];
z[22] = z[11] + z[22];
z[22] = z[6] * z[22];
z[22] = -1 + z[22];
z[22] = z[6] * z[22];
z[22] = (T(-1) / T(6)) * z[3] + z[22] + (T(-3) / T(4)) * z[42];
z[22] = z[12] * z[22];
z[18] = T(-19) / T(12) + z[18] + z[22] + (T(7) / T(6)) * z[28] + z[31] + -z[33];
z[22] = T(3) / T(8) + (T(-2) / T(3)) * z[23] + (T(5) / T(24)) * z[28];
z[22] = z[11] * z[22];
z[20] = -z[20] + z[22] + -z[27] + z[36];
z[20] = z[9] * z[20];
z[18] = (T(1) / T(2)) * z[18] + z[20];
z[18] = z[9] * z[18];
z[17] = z[17] + (T(-1) / T(3)) * z[37];
z[17] = z[6] * z[17];
z[20] = 1 + (T(5) / T(3)) * z[28];
z[20] = z[11] * z[20];
z[17] = z[17] + z[20] + (T(5) / T(3)) * z[41];
z[17] = z[17] * z[40];
z[20] = z[29] * z[43];
z[17] = z[17] + z[20] + (T(1) / T(6)) * z[28] + -z[47];
z[17] = z[6] * z[17];
z[20] = z[35] + z[44] + (T(-5) / T(6)) * z[46];
z[20] = z[20] * z[29];
z[20] = T(11) / T(12) + z[20] + -z[34];
z[20] = z[4] * z[20];
z[22] = -z[26] * z[52];
z[22] = (T(1) / T(6)) * z[1] + -z[2] + (T(103) / T(36)) * z[5] + (T(3) / T(2)) * z[8] + z[22];
z[22] = z[3] * z[22];
z[22] = T(-19) / T(12) + z[22];
z[22] = z[3] * z[22];
z[17] = z[17] + z[20] + z[22];
z[20] = (T(11) / T(8)) * z[29] + -z[39];
z[22] = z[12] * z[56];
z[20] = (T(1) / T(3)) * z[20] + (T(3) / T(8)) * z[22];
z[20] = z[12] * z[20];
z[16] = z[16] + (T(1) / T(2)) * z[17] + z[18] + z[20];
z[16] = z[0] * z[16];
z[17] = T(-7) / T(3) + z[31];
z[17] = z[17] * z[24];
z[18] = (T(1) / T(3)) * z[29];
z[20] = z[3] * z[8];
z[22] = T(77) / T(6) + -z[20];
z[22] = z[18] * z[22];
z[22] = -z[17] + z[22];
z[23] = (T(1) / T(2)) * z[3];
z[26] = 1 + z[31];
z[26] = z[4] * z[26];
z[26] = z[23] + z[26] + (T(-7) / T(6)) * z[30];
z[27] = -z[4] + (T(-1) / T(4)) * z[30];
z[27] = z[11] * z[27];
z[27] = z[27] + -z[47];
z[27] = z[9] * z[27];
z[26] = (T(1) / T(2)) * z[26] + z[27];
z[26] = z[9] * z[26];
z[22] = (T(1) / T(2)) * z[22] + z[26];
z[26] = (T(1) / T(2)) * z[9];
z[22] = z[22] * z[26];
z[27] = z[3] * z[45];
z[31] = -z[2] + (T(17) / T(4)) * z[27];
z[31] = z[31] * z[52];
z[31] = T(1) / T(2) + z[31];
z[31] = z[3] * z[31];
z[33] = -1 + z[25];
z[35] = z[33] * z[51];
z[31] = z[31] + z[35];
z[31] = z[31] * z[51];
z[35] = 2 * z[48];
z[36] = T(1) / T(24) + z[35];
z[36] = z[18] * z[36];
z[31] = z[31] + z[36];
z[31] = z[4] * z[31];
z[22] = z[22] + z[31] + (T(-109) / T(72)) * z[56];
z[22] = z[0] * z[22];
z[31] = -1 + (T(5) / T(2)) * z[20];
z[31] = z[31] * z[52];
z[28] = -z[25] + (T(-1) / T(3)) * z[28];
z[28] = z[26] * z[28];
z[36] = T(-1) / T(3) + z[25];
z[36] = z[4] * z[36];
z[28] = z[28] + z[31] + z[36];
z[28] = z[9] * z[28];
z[31] = T(1) / T(4) + -z[35];
z[31] = z[18] * z[31];
z[35] = 3 * z[2] + (T(-17) / T(6)) * z[27];
z[35] = z[29] * z[35];
z[33] = z[4] * z[33];
z[35] = -z[33] + z[35];
z[35] = z[35] * z[51];
z[22] = z[22] + z[28] + z[31] + z[35];
z[22] = z[0] * z[22];
z[28] = T(-61) / T(12) + z[48];
z[28] = z[18] * z[28];
z[31] = z[3] + z[33];
z[35] = -z[31] * z[51];
z[28] = z[28] + z[35];
z[28] = z[4] * z[28];
z[28] = z[28] + (T(-25) / T(36)) * z[56];
z[28] = z[28] * z[51];
z[35] = z[10] * z[24];
z[30] = (T(-1) / T(3)) * z[30] + (T(1) / T(4)) * z[35];
z[30] = z[9] * z[30];
z[36] = z[8] * z[56];
z[17] = (T(-1) / T(4)) * z[17] + z[30] + z[36];
z[17] = z[9] * z[17];
z[30] = -1 + z[34];
z[30] = z[4] * z[30];
z[34] = (T(7) / T(6)) * z[3] + z[30];
z[34] = z[4] * z[34];
z[34] = (T(121) / T(36)) * z[29] + z[34];
z[34] = z[34] * z[51];
z[17] = z[17] + z[34] + -z[56];
z[17] = z[9] * z[17];
z[17] = z[17] + z[28];
z[17] = z[0] * z[17];
z[28] = T(-1) / T(2) + z[25];
z[34] = -z[4] * z[28];
z[34] = -z[23] + z[34];
z[34] = z[4] * z[34];
z[38] = z[19] * z[24];
z[39] = T(1) / T(2) + 5 * z[20];
z[39] = z[3] * z[39];
z[38] = z[38] + z[39];
z[38] = z[9] * z[38];
z[34] = (T(-151) / T(36)) * z[29] + z[34] + z[38];
z[34] = z[26] * z[34];
z[38] = T(47) / T(24) + -z[48];
z[38] = z[18] * z[38];
z[31] = z[4] * z[31];
z[38] = (T(1) / T(4)) * z[31] + z[38];
z[38] = z[4] * z[38];
z[17] = z[17] + z[34] + z[38] + (T(25) / T(72)) * z[56];
z[17] = z[0] * z[17];
z[34] = z[8] * z[9];
z[34] = -1 + z[34];
z[34] = z[29] * z[34];
z[38] = prod_pow(z[4], 3);
z[39] = z[19] * z[38];
z[34] = z[34] + z[39];
z[34] = z[9] * z[34];
z[28] = -z[24] * z[28];
z[28] = z[28] + (T(67) / T(36)) * z[29];
z[28] = z[4] * z[28];
z[28] = z[28] + z[34] + (T(1) / T(2)) * z[56];
z[28] = z[9] * z[28];
z[32] = -z[32] * z[38];
z[34] = z[36] + z[39];
z[34] = z[9] * z[34];
z[32] = z[32] + z[34] + -z[56];
z[32] = z[9] * z[32];
z[30] = z[23] + z[30];
z[30] = z[24] * z[30];
z[30] = z[30] + -z[56];
z[30] = z[4] * z[30];
z[30] = z[30] + z[32];
z[30] = z[9] * z[30];
z[31] = -z[29] + z[31];
z[31] = z[4] * z[31];
z[31] = z[31] + (T(-67) / T(18)) * z[56];
z[32] = (T(1) / T(2)) * z[31];
z[24] = -z[24] * z[32];
z[24] = z[24] + z[30];
z[24] = z[0] * z[24];
z[30] = z[31] * z[51];
z[24] = (T(1) / T(2)) * z[24] + z[28] + z[30];
z[24] = z[0] * z[24];
z[28] = -z[3] + z[35];
z[28] = z[4] * z[28];
z[28] = z[28] + (T(-67) / T(9)) * z[29];
z[29] = z[9] * z[20];
z[30] = (T(67) / T(36)) * z[3] + z[29];
z[30] = z[9] * z[30];
z[28] = (T(1) / T(2)) * z[28] + z[30];
z[28] = z[9] * z[28];
z[28] = z[28] + -z[32];
z[24] = z[24] + (T(1) / T(2)) * z[28];
z[24] = z[7] * z[24];
z[28] = T(7) / T(6) + z[48];
z[18] = z[18] * z[28];
z[28] = (T(-13) / T(18)) * z[3] + 3 * z[29];
z[28] = z[9] * z[28];
z[18] = z[18] + z[28];
z[17] = z[17] + (T(1) / T(2)) * z[18] + z[24];
z[17] = z[7] * z[17];
z[18] = (T(11) / T(3)) * z[20] + -z[25];
z[18] = z[9] * z[18];
z[18] = z[18] + z[33];
z[20] = -4 * z[2] + (T(17) / T(8)) * z[27];
z[20] = z[20] * z[52];
z[20] = T(7) / T(8) + z[20];
z[20] = z[3] * z[20];
z[17] = z[17] + (T(1) / T(4)) * z[18] + z[20] + z[22];
z[17] = z[7] * z[17];
z[18] = prod_pow(z[6], 2) * z[37];
z[20] = T(-1) / T(2) + z[18];
z[20] = z[6] * z[20];
z[20] = z[20] + -z[23];
z[22] = z[6] * z[37];
z[24] = z[15] * z[37];
z[27] = -z[22] + (T(1) / T(4)) * z[24];
z[28] = (T(1) / T(3)) * z[15];
z[27] = z[27] * z[28];
z[18] = T(-1) / T(6) + z[18];
z[18] = (T(1) / T(2)) * z[18] + z[27];
z[27] = -z[15] * z[18];
z[20] = (T(1) / T(3)) * z[20] + z[27];
z[20] = z[12] * z[20];
z[27] = -z[1] + z[2];
z[27] = z[2] * z[27];
z[27] = z[27] + z[49];
z[23] = z[23] * z[27];
z[23] = (T(1) / T(3)) * z[8] + z[23] + -z[53];
z[23] = z[3] * z[23];
z[21] = -z[21] * z[37];
z[21] = (T(-1) / T(3)) * z[13] + z[21] + (T(1) / T(6)) * z[24];
z[24] = (T(1) / T(4)) * z[15];
z[21] = z[21] * z[24];
z[18] = -z[12] * z[18];
z[18] = z[18] + -z[19];
z[18] = z[18] * z[26];
z[19] = z[13] + z[22];
z[19] = z[6] * z[19];
return T(-5) / T(24) + z[16] + z[17] + z[18] + (T(1) / T(8)) * z[19] + (T(1) / T(2)) * z[20] + z[21] + z[23] + (T(1) / T(4)) * z[25];
}



template double eval_coef_2q3y_2l_pmmpp_12345_164(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_164(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
