#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_170(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[74];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[3];
z[5] = iW[3];
z[6] = iW[22];
z[7] = v[2];
z[8] = v[4];
z[9] = iW[5];
z[10] = iW[4];
z[11] = iW[15];
z[12] = iW[18];
z[13] = iW[23];
z[14] = iW[17];
z[15] = iW[19];
z[16] = v[1];
z[17] = (T(1) / T(2)) * z[7];
z[18] = prod_pow(z[0], 2);
z[19] = z[17] * z[18];
z[20] = z[0] + -z[19];
z[20] = z[7] * z[20];
z[21] = (T(1) / T(2)) * z[4];
z[22] = z[18] * z[21];
z[23] = z[7] * z[18];
z[24] = 2 * z[23];
z[25] = (T(-1) / T(2)) * z[0] + -z[22] + -z[24];
z[25] = z[4] * z[25];
z[20] = T(1) / T(2) + z[20] + z[25];
z[20] = z[4] * z[20];
z[25] = 2 * z[0];
z[26] = 3 * z[23];
z[27] = -z[25] + -z[26];
z[27] = z[7] * z[27];
z[28] = (T(3) / T(2)) * z[23];
z[29] = z[4] * z[18];
z[30] = z[28] + z[29];
z[30] = z[8] * z[30];
z[31] = (T(-3) / T(2)) * z[0] + -z[24];
z[31] = z[4] * z[31];
z[27] = z[27] + z[30] + z[31];
z[27] = z[8] * z[27];
z[30] = z[25] + z[28];
z[30] = z[7] * z[30];
z[30] = T(1) / T(2) + z[30];
z[30] = z[7] * z[30];
z[20] = z[20] + z[27] + z[30];
z[20] = z[8] * z[20];
z[27] = z[0] + z[23];
z[30] = prod_pow(z[7], 2);
z[31] = z[27] * z[30];
z[32] = (T(3) / T(2)) * z[31];
z[33] = z[21] * z[27];
z[34] = z[7] * z[27];
z[35] = z[33] + 2 * z[34];
z[35] = z[4] * z[35];
z[35] = z[32] + z[35];
z[35] = z[4] * z[35];
z[20] = z[20] + z[35];
z[20] = z[8] * z[20];
z[33] = z[33] + z[34];
z[33] = z[4] * z[33];
z[35] = (T(1) / T(2)) * z[30];
z[36] = z[27] * z[35];
z[33] = z[33] + z[36];
z[37] = prod_pow(z[4], 2);
z[33] = z[33] * z[37];
z[38] = (T(1) / T(2)) * z[8];
z[39] = z[18] * z[38];
z[40] = -z[0] + z[39];
z[41] = -z[28] + z[40];
z[41] = z[38] * z[41];
z[42] = z[0] + (T(3) / T(4)) * z[23];
z[42] = z[7] * z[42];
z[41] = T(1) / T(4) + z[41] + z[42];
z[41] = z[8] * z[41];
z[42] = z[0] + z[19];
z[42] = z[7] * z[42];
z[42] = T(1) / T(2) + z[42];
z[43] = z[17] * z[42];
z[41] = z[41] + -z[43];
z[43] = prod_pow(z[8], 3);
z[44] = z[5] * z[43];
z[45] = -z[15] * z[43];
z[45] = -z[44] + z[45];
z[45] = z[41] * z[45];
z[20] = z[20] + z[33] + z[45];
z[20] = z[6] * z[20];
z[45] = 9 * z[23];
z[46] = z[8] * z[18];
z[47] = (T(-29) / T(3)) * z[0] + (T(-5) / T(3)) * z[29] + -z[45] + (T(13) / T(3)) * z[46];
z[48] = (T(1) / T(4)) * z[8];
z[47] = z[47] * z[48];
z[49] = 5 * z[0];
z[50] = -z[19] + z[49];
z[50] = z[17] * z[50];
z[51] = (T(1) / T(4)) * z[0] + -z[24];
z[51] = (T(-19) / T(4)) * z[29] + 5 * z[51];
z[52] = (T(1) / T(3)) * z[4];
z[51] = z[51] * z[52];
z[47] = T(4) / T(3) + z[47] + z[50] + z[51];
z[47] = z[8] * z[47];
z[50] = 8 * z[0];
z[51] = (T(41) / T(4)) * z[23] + z[50];
z[53] = (T(1) / T(3)) * z[7];
z[51] = z[51] * z[53];
z[28] = z[0] + z[28];
z[54] = (T(1) / T(4)) * z[29];
z[55] = z[28] + z[54];
z[55] = z[4] * z[55];
z[51] = T(-1) / T(2) + z[51] + z[55];
z[51] = z[4] * z[51];
z[55] = (T(1) / T(6)) * z[7];
z[56] = 17 * z[23];
z[57] = 11 * z[0] + z[56];
z[57] = z[55] * z[57];
z[57] = -1 + z[57];
z[57] = z[17] * z[57];
z[47] = z[47] + z[51] + z[57];
z[47] = z[8] * z[47];
z[41] = z[41] * z[44];
z[44] = (T(5) / T(3)) * z[0];
z[51] = (T(1) / T(3)) * z[46];
z[57] = z[23] + z[44] + -z[51];
z[48] = z[48] * z[57];
z[44] = -z[19] + -z[44];
z[44] = z[17] * z[44];
z[44] = T(-1) / T(3) + z[44] + z[48];
z[44] = z[8] * z[44];
z[48] = z[23] + z[49];
z[48] = z[7] * z[48];
z[48] = 1 + (T(1) / T(4)) * z[48];
z[48] = z[48] * z[53];
z[44] = z[44] + z[48];
z[48] = prod_pow(z[8], 2);
z[44] = z[44] * z[48];
z[44] = z[41] + z[44];
z[44] = z[5] * z[44];
z[53] = (T(19) / T(2)) * z[23] + z[50];
z[53] = z[7] * z[53];
z[57] = 11 * z[23];
z[58] = (T(19) / T(2)) * z[0] + z[57];
z[58] = z[21] * z[58];
z[53] = z[53] + z[58];
z[53] = z[4] * z[53];
z[58] = 4 * z[23];
z[59] = (T(13) / T(4)) * z[0] + z[58];
z[59] = z[30] * z[59];
z[53] = z[53] + z[59];
z[53] = z[52] * z[53];
z[59] = -z[0] + z[46];
z[60] = -z[26] + z[59];
z[60] = z[38] * z[60];
z[28] = z[7] * z[28];
z[28] = z[28] + z[60];
z[28] = z[8] * z[28];
z[28] = z[28] + -z[36];
z[36] = (T(1) / T(2)) * z[48];
z[28] = z[15] * z[28] * z[36];
z[20] = z[20] + z[28] + z[44] + z[47] + z[53];
z[20] = z[6] * z[20];
z[28] = 10 * z[23];
z[44] = (T(19) / T(4)) * z[0] + -z[28] + (T(-13) / T(4)) * z[29] + (T(7) / T(4)) * z[46];
z[44] = z[8] * z[44];
z[47] = (T(-1) / T(4)) * z[23] + z[49];
z[47] = z[7] * z[47];
z[48] = 7 * z[23];
z[53] = (T(13) / T(2)) * z[0] + (T(-7) / T(4)) * z[29] + -z[48];
z[53] = z[4] * z[53];
z[44] = T(-13) / T(2) + z[44] + z[47] + z[53];
z[47] = (T(1) / T(3)) * z[8];
z[44] = z[44] * z[47];
z[53] = 3 * z[46];
z[45] = z[45] + z[49] + -z[53];
z[45] = z[38] * z[45];
z[60] = (T(9) / T(2)) * z[23];
z[61] = -z[49] + -z[60];
z[61] = z[7] * z[61];
z[45] = -1 + z[45] + z[61];
z[45] = z[8] * z[45];
z[61] = z[26] + z[49];
z[62] = z[17] * z[61];
z[62] = 1 + z[62];
z[63] = z[7] * z[62];
z[45] = z[45] + z[63];
z[45] = z[36] * z[45];
z[41] = -z[41] + z[45];
z[41] = z[5] * z[41];
z[45] = z[0] + (T(13) / T(3)) * z[23];
z[45] = z[17] * z[45];
z[45] = T(-5) / T(3) + z[45];
z[63] = z[7] * z[45];
z[64] = (T(-17) / T(3)) * z[0] + z[26];
z[64] = z[51] + (T(1) / T(2)) * z[64];
z[64] = z[8] * z[64];
z[58] = (T(7) / T(3)) * z[0] + -z[58];
z[58] = z[7] * z[58];
z[58] = T(5) / T(2) + z[58] + z[64];
z[58] = z[8] * z[58];
z[58] = z[58] + z[63];
z[58] = z[8] * z[58];
z[41] = z[41] + z[58];
z[41] = z[5] * z[41];
z[58] = (T(7) / T(2)) * z[0];
z[63] = 19 * z[23];
z[64] = -z[58] + z[63];
z[64] = z[22] + (T(1) / T(3)) * z[64];
z[64] = z[4] * z[64];
z[65] = z[18] * z[30];
z[64] = z[64] + (T(25) / T(2)) * z[65];
z[64] = z[21] * z[64];
z[66] = (T(7) / T(4)) * z[0] + z[28];
z[66] = z[30] * z[66];
z[20] = z[20] + z[41] + z[44] + z[64] + (T(1) / T(3)) * z[66];
z[20] = z[6] * z[20];
z[33] = z[6] * z[33];
z[41] = z[4] * z[27];
z[34] = 10 * z[34] + (T(11) / T(2)) * z[41];
z[34] = z[34] * z[52];
z[32] = z[32] + z[34];
z[32] = z[4] * z[32];
z[32] = z[32] + (T(1) / T(3)) * z[33];
z[32] = z[6] * z[32];
z[34] = z[27] * z[52];
z[44] = z[0] * z[7];
z[64] = 1 + z[44];
z[66] = -z[34] + z[64];
z[66] = z[4] * z[66];
z[67] = z[7] + z[16];
z[66] = z[66] + -z[67];
z[66] = z[4] * z[66];
z[68] = z[7] * z[16];
z[69] = prod_pow(z[16], 2);
z[70] = z[68] + z[69];
z[66] = z[66] + (T(1) / T(3)) * z[70];
z[66] = z[11] * z[66];
z[70] = z[3] * z[18];
z[63] = 253 * z[0] + -z[29] + z[63] + 91 * z[70];
z[63] = z[3] * z[63];
z[63] = (T(35) / T(2)) * z[41] + (T(1) / T(24)) * z[63] + -4 * z[64];
z[63] = z[3] * z[63];
z[64] = z[4] * z[23];
z[71] = z[0] * z[3];
z[71] = -z[44] + z[64] + z[71];
z[72] = prod_pow(z[3], 2);
z[71] = z[10] * z[71] * z[72];
z[73] = (T(11) / T(9)) * z[0] + z[26];
z[73] = z[17] * z[73];
z[41] = T(-8) / T(9) + (T(19) / T(9)) * z[41] + z[73];
z[41] = z[4] * z[41];
z[32] = z[32] + z[41] + (T(1) / T(9)) * z[63] + (T(-4) / T(3)) * z[66] + (T(4) / T(9)) * z[67] + (T(55) / T(216)) * z[71];
z[32] = z[10] * z[32];
z[41] = -7 + -z[44];
z[41] = z[41] * z[55];
z[53] = -z[53] + z[61];
z[53] = z[38] * z[53];
z[53] = -1 + (T(1) / T(6)) * z[44] + z[53];
z[53] = z[8] * z[53];
z[41] = z[41] + z[53];
z[51] = z[9] * z[51];
z[53] = z[0] * z[9];
z[53] = (T(5) / T(8)) * z[18] + -z[51] + (T(2) / T(3)) * z[53];
z[53] = z[8] * z[53];
z[55] = (T(1) / T(3)) * z[9];
z[53] = (T(-5) / T(8)) * z[0] + z[53] + -z[55];
z[53] = z[3] * z[53];
z[57] = -23 * z[0] + z[46] + z[57];
z[38] = z[38] * z[57];
z[38] = 11 + z[38] + (T(17) / T(2)) * z[44];
z[38] = (T(1) / T(12)) * z[38] + z[53];
z[38] = z[3] * z[38];
z[38] = z[38] + (T(1) / T(2)) * z[41];
z[38] = z[3] * z[38];
z[19] = z[19] + -z[40];
z[19] = z[8] * z[19];
z[19] = T(-1) / T(2) + z[19];
z[19] = z[8] * z[19];
z[19] = -z[17] + z[19];
z[19] = z[8] * z[19];
z[40] = z[8] * z[40];
z[41] = T(1) / T(2) + z[40];
z[41] = z[3] * z[41];
z[41] = -z[7] + z[41];
z[53] = 1 + (T(13) / T(3)) * z[44];
z[40] = z[40] + (T(1) / T(2)) * z[53];
z[40] = z[8] * z[40];
z[40] = z[40] + (T(13) / T(6)) * z[41];
z[40] = z[3] * z[40];
z[19] = z[19] + (T(13) / T(12)) * z[30] + z[40];
z[19] = z[3] * z[19];
z[40] = -z[27] + z[39];
z[40] = z[8] * z[40];
z[40] = z[40] + z[42];
z[40] = z[40] * z[43];
z[19] = z[19] + z[40];
z[19] = z[5] * z[19];
z[40] = (T(5) / T(2)) * z[0];
z[41] = -z[26] + -z[40] + (T(3) / T(2)) * z[46];
z[41] = z[8] * z[41];
z[41] = z[41] + z[62];
z[36] = z[36] * z[41];
z[19] = (T(1) / T(2)) * z[19] + z[36] + z[38];
z[19] = z[5] * z[19];
z[36] = z[9] * z[46];
z[36] = (T(19) / T(8)) * z[18] + z[36];
z[36] = z[36] * z[47];
z[36] = (T(-5) / T(4)) * z[0] + (T(13) / T(24)) * z[23] + z[36] + -z[55] + (T(-77) / T(72)) * z[70];
z[36] = z[3] * z[36];
z[38] = 5 + (T(-1) / T(3)) * z[65];
z[41] = z[0] + (T(-11) / T(4)) * z[46] + z[60];
z[41] = z[8] * z[41];
z[38] = (T(1) / T(4)) * z[38] + z[41];
z[36] = z[36] + (T(1) / T(2)) * z[38];
z[36] = z[3] * z[36];
z[38] = -8 * z[23] + z[58];
z[38] = (T(1) / T(3)) * z[38] + z[39];
z[38] = z[8] * z[38];
z[38] = z[38] + z[45];
z[38] = z[8] * z[38];
z[19] = z[19] + z[36] + z[38];
z[19] = z[5] * z[19];
z[36] = z[17] * z[27];
z[34] = z[34] + z[36];
z[34] = z[4] * z[34];
z[31] = (T(1) / T(6)) * z[31] + z[34];
z[31] = z[4] * z[31];
z[31] = z[31] + (T(1) / T(6)) * z[33];
z[31] = z[6] * z[31];
z[34] = -z[17] * z[29];
z[34] = z[34] + -z[65];
z[34] = z[4] * z[34];
z[36] = prod_pow(z[7], 3) * z[18];
z[34] = z[34] + (T(-1) / T(2)) * z[36];
z[34] = z[4] * z[34];
z[33] = -z[33] + z[34];
z[33] = z[14] * z[33];
z[34] = z[24] + z[54];
z[34] = z[4] * z[34];
z[34] = z[34] + (T(11) / T(4)) * z[65];
z[34] = z[4] * z[34];
z[34] = z[34] + z[36];
z[31] = z[31] + (T(1) / T(6)) * z[33] + (T(1) / T(3)) * z[34];
z[31] = z[14] * z[31];
z[33] = 9 * z[0] + (T(5) / T(3)) * z[23];
z[33] = (T(-19) / T(3)) * z[29] + (T(1) / T(2)) * z[33];
z[34] = z[3] * z[29];
z[36] = -7 * z[0] + (T(23) / T(2)) * z[29];
z[36] = z[4] * z[36];
z[36] = -7 * z[34] + z[36];
z[36] = z[12] * z[36];
z[38] = -z[3] * z[23];
z[38] = z[38] + -z[44];
z[38] = z[5] * z[38];
z[33] = (T(1) / T(2)) * z[33] + (T(1) / T(12)) * z[36] + (T(5) / T(3)) * z[38] + 4 * z[70];
z[33] = z[33] * z[72];
z[24] = -z[24] + z[29];
z[24] = z[4] * z[24];
z[24] = z[24] + z[65];
z[24] = z[3] * z[24];
z[25] = z[25] * z[30];
z[36] = z[27] + -z[29];
z[36] = z[4] * z[36];
z[36] = z[36] + -2 * z[44];
z[36] = z[4] * z[36];
z[24] = z[24] + z[25] + z[36];
z[24] = z[3] * z[24];
z[24] = z[24] + z[30];
z[24] = z[2] * z[24];
z[25] = -z[0] + z[29];
z[36] = 35 * z[25] + -z[56];
z[36] = z[4] * z[36];
z[28] = z[28] + (T(-41) / T(4)) * z[29];
z[28] = z[3] * z[28];
z[28] = z[28] + (T(1) / T(4)) * z[36] + 13 * z[44];
z[36] = (T(1) / T(3)) * z[3];
z[28] = z[28] * z[36];
z[38] = -z[35] * z[70];
z[30] = -z[0] * z[30];
z[30] = z[30] + z[38];
z[30] = z[3] * z[30];
z[30] = z[30] + -z[35];
z[30] = z[5] * z[30];
z[24] = z[7] + z[24] + z[28] + (T(5) / T(6)) * z[30];
z[24] = z[3] * z[24];
z[28] = z[25] + -z[70];
z[28] = z[28] * z[37] * z[72];
z[30] = z[12] * z[28];
z[24] = z[24] + (T(-3) / T(8)) * z[30];
z[24] = z[2] * z[24];
z[24] = z[24] + z[33];
z[24] = z[2] * z[24];
z[30] = -z[23] + (T(-5) / T(12)) * z[29] + z[40] + (T(-7) / T(6)) * z[46];
z[30] = z[30] * z[47];
z[33] = 3 * z[18] + z[51];
z[33] = z[3] * z[33];
z[33] = (T(37) / T(36)) * z[0] + z[26] + (T(11) / T(72)) * z[29] + z[33] + (T(-5) / T(36)) * z[46];
z[33] = z[3] * z[33];
z[35] = -49 * z[29] + -z[48] + -z[49] + -29 * z[70];
z[35] = z[3] * z[35];
z[22] = -z[0] + z[22] + z[23];
z[22] = z[4] * z[22];
z[22] = T(1) / T(2) + z[22] + (T(1) / T(6)) * z[35] + -z[44];
z[22] = z[22] * z[36];
z[35] = z[18] * z[52];
z[35] = -z[0] + (T(1) / T(3)) * z[23] + z[35];
z[35] = z[21] * z[35];
z[35] = T(1) / T(2) + z[35] + (T(-1) / T(3)) * z[44];
z[35] = z[4] * z[35];
z[36] = z[7] + -z[16];
z[22] = z[22] + z[35] + (T(1) / T(6)) * z[36];
z[25] = -z[23] + -z[25];
z[25] = z[4] * z[25];
z[25] = z[25] + z[34] + z[44];
z[25] = z[12] * z[25] * z[72];
z[22] = (T(1) / T(3)) * z[22] + z[25];
z[22] = z[12] * z[22];
z[25] = z[0] * z[4];
z[25] = 1 + (T(-1) / T(3)) * z[25];
z[25] = z[4] * z[25];
z[25] = -z[16] + z[25];
z[25] = z[4] * z[25];
z[25] = z[25] + (T(1) / T(3)) * z[69];
z[35] = z[44] + (T(-1) / T(4)) * z[64];
z[35] = z[35] * z[52];
z[17] = -z[17] + z[35];
z[17] = z[4] * z[17];
z[17] = z[17] + (T(1) / T(3)) * z[68];
z[17] = z[4] * z[17];
z[35] = (T(1) / T(12)) * z[69];
z[36] = -z[7] * z[35];
z[17] = z[17] + z[36];
z[17] = z[12] * z[17];
z[17] = z[17] + (T(1) / T(4)) * z[25];
z[17] = z[11] * z[17];
z[18] = z[18] * z[37];
z[25] = 1 + (T(-1) / T(3)) * z[18];
z[21] = z[21] * z[25];
z[25] = (T(1) / T(3)) * z[16];
z[21] = z[21] + -z[25];
z[36] = -z[0] + z[54];
z[36] = z[36] * z[52];
z[36] = T(1) / T(2) + z[36];
z[36] = z[4] * z[36];
z[25] = -z[25] + z[36];
z[25] = z[4] * z[25];
z[25] = z[25] + z[35];
z[25] = z[12] * z[25];
z[17] = z[17] + (T(1) / T(2)) * z[21] + z[25];
z[17] = z[11] * z[17];
z[21] = z[27] + z[29];
z[21] = z[4] * z[21];
z[25] = 2 * z[29] + z[59];
z[25] = z[8] * z[25];
z[21] = -2 + z[21] + z[25] + -z[44];
z[21] = z[21] * z[47];
z[25] = -1 + (T(-2) / T(3)) * z[44];
z[27] = z[0] + (T(2) / T(3)) * z[23];
z[27] = z[4] * z[27];
z[25] = 2 * z[25] + z[27];
z[25] = z[4] * z[25];
z[21] = (T(2) / T(3)) * z[7] + z[16] + z[21] + z[25] + -z[66];
z[21] = z[13] * z[21];
z[25] = z[2] * z[28];
z[27] = -z[0] + (T(3) / T(2)) * z[29];
z[27] = z[4] * z[27];
z[27] = z[27] + -z[34];
z[27] = z[27] * z[72];
z[27] = (T(-1) / T(2)) * z[25] + z[27];
z[27] = z[2] * z[27];
z[18] = -z[18] + z[34];
z[18] = z[18] * z[72];
z[18] = z[18] + z[25];
z[18] = z[1] * z[18];
z[25] = -z[29] + z[70];
z[25] = z[25] * z[72];
z[18] = (T(1) / T(4)) * z[18] + z[25] + (T(1) / T(2)) * z[27];
z[18] = z[1] * z[18];
z[23] = (T(115) / T(4)) * z[23] + (T(11) / T(8)) * z[29] + z[50];
z[23] = z[4] * z[23];
z[25] = (T(5) / T(36)) * z[0] + z[26];
z[25] = z[7] * z[25];
return T(-7) / T(8) + (T(1) / T(6)) * z[17] + (T(1) / T(2)) * z[18] + z[19] + z[20] + (T(4) / T(3)) * z[21] + (T(1) / T(4)) * z[22] + (T(1) / T(9)) * z[23] + z[24] + z[25] + z[30] + z[31] + z[32] + z[33];
}



template double eval_coef_2q3y_2l_pmmpp_12345_170(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_170(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
