#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_33(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[18];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[15];
z[3] = iW[17];
z[4] = iW[18];
z[5] = v[0];
z[6] = v[4];
z[7] = v[2];
z[8] = v[3];
z[9] = v[1];
z[10] = z[1] * z[9];
z[11] = -z[0] + z[1];
z[12] = z[5] * z[11];
z[12] = z[10] + z[12];
z[13] = (T(1) / T(2)) * z[7];
z[14] = prod_pow(z[0], 2);
z[15] = -z[8] * z[14];
z[15] = z[1] + z[15];
z[15] = z[13] * z[15];
z[16] = z[0] * z[8];
z[12] = T(3) / T(2) + (T(-1) / T(2)) * z[12] + z[15] + -z[16];
z[12] = z[5] * z[12];
z[10] = -1 + z[10];
z[10] = z[7] * z[10];
z[10] = -z[8] + z[9] + z[10];
z[10] = (T(1) / T(2)) * z[10] + z[12];
z[10] = z[5] * z[10];
z[12] = z[0] * z[1];
z[13] = -z[12] * z[13];
z[15] = z[12] + -z[14];
z[15] = z[5] * z[15];
z[17] = T(-5) / T(2) + z[16];
z[17] = z[0] * z[17];
z[13] = z[1] + z[13] + z[15] + z[17];
z[13] = z[5] * z[13];
z[11] = -z[7] * z[11];
z[11] = -1 + z[11] + z[16];
z[11] = (T(1) / T(2)) * z[11] + z[13];
z[11] = z[5] * z[11];
z[13] = -z[1] * z[5];
z[13] = 1 + z[13];
z[13] = z[13] * z[14];
z[12] = -z[12] + z[13];
z[13] = (T(1) / T(2)) * z[6];
z[12] = prod_pow(z[5], 2) * z[12] * z[13];
z[11] = z[11] + z[12];
z[11] = z[6] * z[11];
z[10] = z[10] + z[11];
return z[2] * z[3] * z[4] * z[10] * z[13];
}



template double eval_coef_2q3y_2l_pmmpp_12345_33(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_33(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
