#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_48(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[27];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[8];
z[3] = iW[15];
z[4] = iW[21];
z[5] = iW[22];
z[6] = v[0];
z[7] = v[4];
z[8] = v[2];
z[9] = v[3];
z[10] = v[1];
z[11] = prod_pow(z[7], 3);
z[12] = z[1] * z[11];
z[13] = prod_pow(z[7], 2);
z[14] = z[12] + (T(5) / T(2)) * z[13];
z[15] = (T(1) / T(2)) * z[1];
z[16] = z[13] * z[15];
z[17] = z[1] * z[7];
z[18] = T(-5) / T(4) + -z[17];
z[18] = z[8] * z[18];
z[18] = z[16] + z[18];
z[18] = z[8] * z[18];
z[19] = prod_pow(z[9], 2);
z[20] = 3 * z[7];
z[21] = -z[8] + z[20];
z[22] = -z[9] + -z[21];
z[22] = z[0] * z[19] * z[22];
z[23] = 3 * z[9];
z[24] = 5 * z[7] + -z[8] + z[23];
z[24] = z[9] * z[24];
z[14] = (T(1) / T(2)) * z[14] + z[18] + (T(1) / T(4)) * z[22] + (T(3) / T(4)) * z[24];
z[14] = z[0] * z[14];
z[18] = z[1] * z[8];
z[22] = (T(1) / T(2)) * z[18];
z[24] = z[1] * z[10];
z[24] = T(7) / T(4) + z[17] + -z[22] + (T(-1) / T(4)) * z[24];
z[24] = z[10] * z[24];
z[25] = z[1] * z[13];
z[26] = -z[7] + -z[25];
z[26] = z[8] * z[26];
z[12] = z[12] + z[13] + z[26];
z[26] = -z[8] + z[9];
z[26] = z[7] + (T(1) / T(4)) * z[26];
z[26] = z[9] * z[26];
z[12] = (T(1) / T(2)) * z[12] + z[26];
z[12] = z[0] * z[12];
z[26] = T(1) / T(2) + z[17];
z[26] = z[8] * z[26];
z[12] = (T(-5) / T(4)) * z[7] + -z[9] + z[12] + -z[25] + (T(3) / T(2)) * z[26];
z[12] = z[0] * z[12];
z[16] = z[0] * z[16];
z[16] = z[16] + -z[17];
z[16] = z[0] * z[16];
z[15] = z[15] + z[16];
z[15] = z[6] * z[15];
z[16] = T(3) / T(2) + z[17];
z[15] = z[15] + z[16];
z[12] = z[12] + (T(1) / T(2)) * z[15] + -z[18];
z[12] = z[6] * z[12];
z[15] = (T(1) / T(2)) * z[8];
z[26] = 1 + (T(5) / T(2)) * z[18];
z[26] = z[15] * z[26];
z[12] = (T(-15) / T(4)) * z[9] + z[12] + z[14] + -z[20] + z[24] + (T(-5) / T(4)) * z[25] + z[26];
z[12] = z[6] * z[12];
z[14] = T(-9) / T(2) + -z[17] + -z[18];
z[14] = z[14] * z[15];
z[14] = z[14] + z[20] + z[25];
z[14] = z[8] * z[14];
z[16] = (T(-3) / T(2)) * z[16] + z[18];
z[16] = z[8] * z[16];
z[20] = (T(1) / T(2)) * z[10];
z[24] = 1 + z[18];
z[24] = z[20] * z[24];
z[16] = (T(-1) / T(4)) * z[7] + (T(-5) / T(2)) * z[9] + z[16] + z[24];
z[16] = z[10] * z[16];
z[24] = -z[7] + z[8];
z[25] = z[8] * z[24];
z[25] = -z[13] + z[25];
z[25] = z[8] * z[25];
z[25] = z[11] + z[25];
z[15] = -z[7] + z[15];
z[15] = z[8] * z[15];
z[15] = (T(1) / T(2)) * z[13] + z[15];
z[26] = -z[7] + -z[8];
z[26] = -z[9] + (T(3) / T(4)) * z[26];
z[26] = z[9] * z[26];
z[26] = (T(5) / T(2)) * z[15] + z[26];
z[26] = z[9] * z[26];
z[25] = (T(1) / T(2)) * z[25] + z[26];
z[25] = z[0] * z[25];
z[26] = (T(1) / T(2)) * z[7] + z[8];
z[23] = z[23] + (T(5) / T(2)) * z[26];
z[23] = z[9] * z[23];
z[12] = z[12] + (T(-3) / T(4)) * z[13] + z[14] + z[16] + z[23] + z[25];
z[12] = z[6] * z[12];
z[14] = z[8] * z[21];
z[14] = -3 * z[13] + z[14];
z[14] = z[8] * z[14];
z[16] = z[19] * z[24];
z[11] = z[11] + z[14] + z[16];
z[11] = z[0] * z[11];
z[14] = 3 * z[8];
z[16] = (T(1) / T(2)) * z[9];
z[19] = z[7] + -z[14] + -z[16];
z[19] = z[9] * z[19];
z[11] = z[11] + -z[15] + z[19];
z[11] = z[11] * z[16];
z[15] = 1 + z[17] + -z[18];
z[15] = z[8] * z[15];
z[15] = -z[7] + z[15];
z[15] = z[8] * z[15];
z[17] = -1 + -z[22];
z[17] = z[8] * z[17];
z[16] = -z[16] + z[17];
z[16] = z[10] * z[16];
z[14] = z[9] + z[14];
z[14] = z[9] * z[14];
z[14] = z[14] + z[15] + z[16];
z[14] = z[14] * z[20];
z[15] = -2 * z[7] + z[8];
z[15] = z[8] * z[15];
z[13] = z[13] + z[15];
z[13] = z[8] * z[13];
z[11] = z[11] + z[12] + z[13] + z[14];
return z[2] * z[3] * z[4] * z[5] * z[6] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_48(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_48(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
