#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_53(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[23];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[12];
z[3] = iW[15];
z[4] = iW[17];
z[5] = v[0];
z[6] = v[2];
z[7] = v[4];
z[8] = v[3];
z[9] = iW[16];
z[10] = prod_pow(z[5], 2);
z[11] = (T(1) / T(2)) * z[10];
z[12] = z[5] + -z[8];
z[13] = z[11] * z[12];
z[14] = z[5] * z[7];
z[15] = z[1] * z[5];
z[16] = T(-1) / T(2) + z[15];
z[16] = z[14] * z[16];
z[17] = T(7) / T(2) + -z[15];
z[17] = z[5] * z[17];
z[17] = (T(-3) / T(2)) * z[8] + z[17];
z[17] = z[5] * z[17];
z[16] = z[16] + z[17];
z[16] = z[7] * z[16];
z[17] = (T(1) / T(2)) * z[7];
z[18] = -z[15] * z[17];
z[19] = T(-3) / T(2) + z[15];
z[19] = z[5] * z[19];
z[18] = z[18] + z[19];
z[18] = z[7] * z[18];
z[18] = z[11] + z[18];
z[18] = z[6] * z[18];
z[16] = -z[13] + z[16] + z[18];
z[16] = z[6] * z[16];
z[18] = z[5] * z[8];
z[20] = prod_pow(z[8], 2);
z[18] = z[18] + -z[20];
z[21] = z[11] * z[18];
z[16] = z[16] + z[21];
z[18] = z[10] * z[18];
z[21] = -1 + z[15];
z[21] = z[14] * z[21];
z[12] = -z[5] * z[12];
z[12] = z[12] + -z[21];
z[22] = z[6] * z[7];
z[12] = z[12] * z[22];
z[12] = z[12] + z[18];
z[18] = (T(3) / T(4)) * z[5] + -z[8];
z[18] = z[5] * z[18];
z[18] = z[18] + (T(1) / T(4)) * z[20];
z[18] = z[5] * z[18];
z[19] = (T(1) / T(2)) * z[8] + z[19];
z[14] = z[14] * z[19];
z[14] = (T(1) / T(2)) * z[14] + z[18];
z[14] = z[7] * z[14];
z[12] = (T(1) / T(4)) * z[12] + z[14];
z[12] = z[0] * z[6] * z[12];
z[12] = z[12] + (T(1) / T(2)) * z[16];
z[12] = z[0] * z[12];
z[14] = z[15] * z[22];
z[11] = z[11] + z[14] + -z[21];
z[11] = z[6] * z[11];
z[11] = z[11] + -z[13];
z[11] = (T(1) / T(2)) * z[11] + z[12];
z[11] = z[2] * z[3] * z[4] * z[11];
z[12] = z[7] * z[15];
z[13] = z[5] + z[12];
z[13] = z[0] * z[13] * z[17];
z[12] = -z[12] + z[13];
z[12] = z[0] * z[12];
z[13] = z[0] * z[7];
z[13] = -1 + z[13];
z[10] = z[1] * z[10] * z[13];
z[13] = z[6] * z[15];
z[10] = z[10] + (T(3) / T(2)) * z[13];
z[10] = z[9] * z[10];
z[10] = z[10] + z[12] + (T(-295) / T(36)) * z[15];
return (T(1) / T(2)) * z[10] + z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_53(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_53(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
