#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_54(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[26];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[3];
z[3] = iW[5];
z[4] = iW[15];
z[5] = iW[19];
z[6] = v[0];
z[7] = v[4];
z[8] = v[3];
z[9] = v[2];
z[10] = v[1];
z[11] = prod_pow(z[8], 2);
z[12] = z[8] * z[10];
z[12] = -z[11] + z[12];
z[13] = z[2] * z[10];
z[14] = z[2] * z[6];
z[15] = z[13] + z[14];
z[16] = T(169) / T(18) + 3 * z[15];
z[16] = z[6] * z[16];
z[17] = -133 * z[8] + 223 * z[10];
z[16] = z[16] + (T(1) / T(18)) * z[17];
z[16] = z[6] * z[16];
z[12] = 3 * z[12] + z[16];
z[16] = (T(1) / T(2)) * z[6];
z[12] = z[12] * z[16];
z[15] = -89 + (T(205) / T(4)) * z[15];
z[15] = z[6] * z[15];
z[17] = -1 + z[14];
z[18] = -z[13] + -z[17];
z[18] = z[9] * z[18];
z[19] = -z[8] + z[10];
z[15] = z[15] + (T(241) / T(4)) * z[18] + (T(-187) / T(4)) * z[19];
z[15] = z[6] * z[9] * z[15];
z[18] = z[8] * z[16];
z[11] = -z[11] + z[18];
z[18] = prod_pow(z[6], 2);
z[11] = z[11] * z[18];
z[20] = z[9] * z[18];
z[21] = z[6] + -z[8];
z[22] = z[9] + z[21];
z[22] = z[20] * z[22];
z[11] = z[11] + (T(1) / T(2)) * z[22];
z[11] = z[0] * z[11];
z[22] = -1 + (T(1) / T(2)) * z[14];
z[23] = (T(-1) / T(2)) * z[13] + -z[22];
z[23] = z[6] * z[23];
z[23] = (T(1) / T(2)) * z[19] + z[23];
z[24] = prod_pow(z[6], 3);
z[25] = z[1] * z[24];
z[23] = z[23] * z[25];
z[11] = z[11] + z[12] + (T(1) / T(9)) * z[15] + z[23];
z[12] = -3 + z[14];
z[12] = z[12] * z[16];
z[12] = z[8] + z[12];
z[15] = z[6] * z[22];
z[15] = (T(1) / T(2)) * z[8] + z[15];
z[16] = -z[0] * z[15];
z[16] = z[16] + (T(-1) / T(2)) * z[17];
z[16] = z[7] * z[16];
z[16] = z[12] + z[16];
z[22] = z[1] * z[18];
z[16] = z[16] * z[22];
z[15] = z[15] * z[25];
z[12] = z[12] * z[18];
z[12] = z[12] + -z[15];
z[12] = z[0] * z[12];
z[23] = (T(1) / T(2)) * z[2];
z[23] = -z[23] * z[24];
z[12] = z[12] + z[16] + z[23];
z[12] = z[0] * z[12];
z[16] = z[1] * z[17];
z[16] = -z[2] + z[16];
z[16] = z[16] * z[18];
z[12] = z[12] + z[16];
z[12] = z[7] * z[12];
z[16] = z[13] + -z[14];
z[23] = T(331) / T(36) + z[16];
z[23] = z[6] * z[23];
z[13] = -1 + z[13];
z[13] = 295 * z[13] + 367 * z[14];
z[13] = z[9] * z[13];
z[13] = (T(1) / T(36)) * z[13] + (T(295) / T(36)) * z[19] + z[23];
z[13] = z[6] * z[13];
z[16] = -z[6] * z[16];
z[16] = z[16] + z[19];
z[16] = z[16] * z[22];
z[12] = z[12] + z[13] + (T(1) / T(2)) * z[16];
z[13] = T(7) / T(4) + -z[14];
z[13] = z[6] * z[13];
z[14] = z[9] * z[17];
z[13] = (T(-5) / T(4)) * z[8] + z[13] + z[14];
z[13] = z[13] * z[18];
z[14] = z[20] + -z[24];
z[14] = z[0] * z[14] * z[21];
z[13] = z[13] + (T(1) / T(4)) * z[14] + z[15];
z[13] = z[0] * z[13];
z[12] = (T(1) / T(2)) * z[12] + z[13];
z[12] = z[7] * z[12];
z[11] = (T(1) / T(2)) * z[11] + z[12];
return z[3] * z[4] * z[5] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_54(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_54(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
