#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_57(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[17];
z[0] = iW[0];
z[1] = iW[3];
z[2] = v[1];
z[3] = v[2];
z[4] = v[4];
z[5] = iW[1];
z[6] = v[0];
z[7] = (T(1) / T(2)) * z[4];
z[8] = prod_pow(z[5], 2);
z[9] = -z[7] * z[8];
z[9] = z[0] + z[9];
z[9] = z[3] * z[9];
z[10] = z[0] * z[4];
z[11] = z[0] * z[2];
z[8] = z[4] * z[8];
z[12] = (T(-3) / T(2)) * z[5] + z[8];
z[12] = z[4] * z[12];
z[9] = -1 + z[9] + -z[10] + (T(-3) / T(4)) * z[11] + z[12];
z[9] = z[3] * z[9];
z[12] = -z[0] + -z[5];
z[12] = z[7] * z[12];
z[13] = z[0] * z[3];
z[11] = -1 + -z[11] + z[12] + (T(1) / T(2)) * z[13];
z[11] = z[3] * z[11];
z[12] = z[4] * z[5];
z[12] = -5 + z[12];
z[12] = z[7] * z[12];
z[11] = 2 * z[2] + z[11] + z[12];
z[11] = z[3] * z[11];
z[12] = z[2] + -z[4];
z[14] = -z[2] * z[13];
z[12] = 3 * z[12] + z[14];
z[12] = prod_pow(z[3], 2) * z[12];
z[14] = 3 * z[3];
z[7] = -z[5] * z[7];
z[7] = 1 + z[7];
z[7] = z[4] * z[7];
z[7] = (T(-1) / T(2)) * z[2] + z[7];
z[7] = z[7] * z[14];
z[14] = -3 * z[5] + z[8];
z[14] = z[4] * z[14];
z[15] = 3 + z[14];
z[15] = z[4] * z[15];
z[15] = -z[2] + z[15];
z[16] = z[6] * z[15];
z[7] = z[7] + (T(-1) / T(2)) * z[16];
z[7] = z[6] * z[7];
z[7] = z[7] + (T(1) / T(2)) * z[12];
z[7] = z[1] * z[7];
z[8] = (T(1) / T(2)) * z[5] + -z[8];
z[8] = z[4] * z[8];
z[8] = T(1) / T(2) + z[8];
z[8] = z[3] * z[8];
z[8] = z[8] + z[15];
z[8] = z[6] * z[8];
z[7] = z[7] + z[8] + z[11];
z[7] = z[1] * z[7];
z[8] = T(-7) / T(2) + -z[14];
z[8] = z[4] * z[8];
z[8] = (T(3) / T(2)) * z[2] + z[8];
z[7] = z[7] + (T(1) / T(2)) * z[8] + z[9];
z[7] = z[1] * z[7];
z[8] = z[10] + -z[13];
z[8] = T(-67) / T(12) + -3 * z[8];
return z[7] + (T(1) / T(4)) * z[8];
}



template double eval_coef_2q3y_2l_pmmpp_12345_57(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_57(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
