#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_59(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[26];
z[0] = iW[1];
z[1] = iW[4];
z[2] = iW[7];
z[3] = iW[15];
z[4] = iW[18];
z[5] = v[0];
z[6] = v[2];
z[7] = v[3];
z[8] = v[4];
z[9] = v[1];
z[10] = (T(1) / T(2)) * z[0];
z[11] = prod_pow(z[7], 2);
z[12] = z[10] * z[11];
z[12] = -z[7] + z[12];
z[13] = z[0] * z[12];
z[13] = T(1) / T(2) + z[13];
z[14] = z[6] * z[13];
z[12] = (T(1) / T(2)) * z[9] + z[12] + z[14];
z[12] = z[1] * z[12];
z[15] = prod_pow(z[0], 2) * z[8];
z[16] = z[0] * z[7];
z[17] = -1 + (T(1) / T(2)) * z[16];
z[17] = z[0] * z[17];
z[17] = z[15] + z[17];
z[17] = z[5] * z[17];
z[12] = z[12] + z[17];
z[17] = -1 + z[16];
z[17] = z[6] * z[17];
z[18] = z[0] * z[11];
z[19] = (T(133) / T(18)) * z[7] + (T(13) / T(9)) * z[17] + -2 * z[18];
z[19] = z[0] * z[19];
z[20] = 35 + -37 * z[16];
z[20] = z[0] * z[20];
z[20] = 7 * z[15] + z[20];
z[20] = z[8] * z[20];
z[12] = T(-97) / T(18) + (T(13) / T(9)) * z[12] + z[19] + (T(1) / T(9)) * z[20];
z[12] = z[5] * z[12];
z[19] = (T(-131) / T(18)) * z[7] + (T(7) / T(9)) * z[17] + 4 * z[18];
z[19] = z[0] * z[19];
z[20] = 3 + (T(-23) / T(6)) * z[16];
z[20] = z[0] * z[20];
z[15] = (T(1) / T(3)) * z[15] + z[20];
z[20] = (T(1) / T(2)) * z[8];
z[15] = z[15] * z[20];
z[15] = T(59) / T(18) + z[15] + z[19];
z[15] = z[8] * z[15];
z[19] = (T(1) / T(3)) * z[0];
z[21] = prod_pow(z[7], 3);
z[22] = z[19] * z[21];
z[22] = -z[11] + z[22];
z[23] = z[0] * z[22];
z[24] = (T(1) / T(3)) * z[9];
z[25] = -z[7] + z[24];
z[23] = z[23] + -z[25];
z[23] = z[6] * z[23];
z[25] = z[9] * z[25];
z[22] = -z[22] + -z[23] + z[25];
z[22] = z[1] * z[22];
z[10] = z[10] * z[21];
z[10] = z[10] + (T(-25) / T(9)) * z[11];
z[10] = z[0] * z[10];
z[10] = (T(73) / T(18)) * z[7] + z[10];
z[10] = (T(-8) / T(9)) * z[9] + (T(1) / T(2)) * z[10];
z[25] = 2 * z[7] + -z[18];
z[25] = z[0] * z[25];
z[25] = -1 + z[25];
z[25] = z[6] * z[25];
z[10] = 7 * z[10] + z[12] + z[15] + (T(23) / T(6)) * z[22] + (T(8) / T(3)) * z[25];
z[10] = z[5] * z[10];
z[12] = z[0] * z[21];
z[15] = 155 * z[11] + -61 * z[12];
z[15] = z[0] * z[15];
z[15] = -127 * z[7] + z[15];
z[15] = 11 * z[9] + (T(1) / T(3)) * z[15];
z[14] = (T(-41) / T(3)) * z[14] + (T(1) / T(2)) * z[15];
z[15] = z[17] * z[19];
z[17] = (T(-11) / T(3)) * z[7] + (T(5) / T(2)) * z[18];
z[17] = z[0] * z[17];
z[15] = T(7) / T(6) + z[15] + z[17];
z[16] = 1 + (T(-5) / T(4)) * z[16];
z[16] = z[8] * z[16] * z[19];
z[15] = (T(1) / T(2)) * z[15] + z[16];
z[15] = z[8] * z[15];
z[14] = (T(1) / T(6)) * z[14] + z[15];
z[14] = z[8] * z[14];
z[15] = (T(1) / T(4)) * z[0];
z[16] = prod_pow(z[7], 4);
z[15] = z[15] * z[16];
z[15] = z[15] + -z[21];
z[17] = z[15] * z[19];
z[18] = -z[7] + (T(1) / T(4)) * z[9];
z[18] = z[18] * z[24];
z[18] = (T(1) / T(2)) * z[11] + z[18];
z[17] = z[17] + z[18];
z[17] = z[6] * z[17];
z[18] = z[9] * z[18];
z[15] = (T(1) / T(3)) * z[15] + z[17] + z[18];
z[17] = z[1] * z[15];
z[16] = z[0] * z[16];
z[18] = (T(-17) / T(2)) * z[16] + 67 * z[21];
z[18] = z[0] * z[18];
z[19] = 133 * z[7] + (T(-83) / T(2)) * z[9];
z[19] = z[9] * z[19];
z[18] = z[18] + z[19];
z[18] = -25 * z[11] + (T(1) / T(6)) * z[18];
z[10] = z[10] + z[14] + (T(17) / T(3)) * z[17] + (T(1) / T(3)) * z[18] + 4 * z[23];
z[10] = z[5] * z[10];
z[14] = (T(13) / T(12)) * z[16] + -5 * z[21];
z[14] = z[0] * z[14];
z[16] = (T(-19) / T(3)) * z[7] + (T(7) / T(4)) * z[9];
z[16] = z[9] * z[16];
z[14] = (T(17) / T(2)) * z[11] + z[14] + z[16] + z[23];
z[16] = (T(-1) / T(2)) * z[6] + z[20];
z[13] = z[13] * z[16];
z[11] = (T(-1) / T(4)) * z[11] + (T(-1) / T(9)) * z[12];
z[11] = z[0] * z[11];
z[11] = (T(5) / T(6)) * z[7] + (T(-17) / T(36)) * z[9] + z[11] + z[13];
z[11] = z[8] * z[11];
z[11] = z[11] + (T(1) / T(3)) * z[14];
z[11] = z[8] * z[11];
z[10] = z[10] + z[11] + (T(-13) / T(3)) * z[15];
z[11] = z[3] * z[4] * z[5];
return prod_pow(z[11], 2) * z[2] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_59(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_59(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
