#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_60(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[28];
z[0] = iW[1];
z[1] = iW[4];
z[2] = iW[15];
z[3] = iW[18];
z[4] = iW[23];
z[5] = v[0];
z[6] = v[2];
z[7] = v[3];
z[8] = v[4];
z[9] = v[1];
z[10] = (T(1) / T(3)) * z[1];
z[11] = z[1] * z[6];
z[12] = 13 * z[11];
z[13] = T(61) / T(2) + -z[12];
z[13] = z[10] * z[13];
z[14] = prod_pow(z[1], 2);
z[15] = z[7] * z[14];
z[16] = (T(13) / T(2)) * z[15];
z[13] = z[13] + -z[16];
z[13] = z[7] * z[13];
z[17] = z[1] * z[7];
z[18] = (T(1) / T(2)) * z[11];
z[19] = -2 + z[18];
z[19] = z[17] * z[19];
z[19] = z[11] + z[19];
z[19] = -17 + (T(13) / T(3)) * z[19];
z[19] = z[7] * z[19];
z[19] = (T(-7) / T(3)) * z[8] + z[19];
z[19] = z[0] * z[19];
z[20] = 49 + -z[12];
z[13] = z[13] + z[19] + (T(1) / T(3)) * z[20];
z[19] = (T(1) / T(3)) * z[0];
z[13] = z[13] * z[19];
z[20] = (T(1) / T(2)) * z[1];
z[21] = -1 + (T(13) / T(9)) * z[11];
z[21] = z[20] * z[21];
z[22] = 1 + (T(1) / T(2)) * z[17];
z[22] = z[0] * z[22];
z[22] = (T(1) / T(2)) * z[15] + z[22];
z[22] = z[0] * z[22];
z[22] = (T(-1) / T(2)) * z[14] + z[22];
z[22] = z[5] * z[22];
z[23] = (T(13) / T(3)) * z[15];
z[24] = z[9] * z[14];
z[25] = (T(13) / T(6)) * z[24];
z[13] = z[13] + z[21] + (T(13) / T(9)) * z[22] + z[23] + -z[25];
z[13] = z[5] * z[13];
z[21] = T(-181) / T(9) + z[12];
z[21] = z[1] * z[21];
z[21] = z[21] + z[23];
z[21] = z[7] * z[21];
z[22] = T(-557) / T(4) + 76 * z[11];
z[21] = (T(1) / T(2)) * z[21] + (T(1) / T(9)) * z[22];
z[21] = z[7] * z[21];
z[22] = 13 * z[17];
z[23] = 1 + -z[18];
z[23] = z[22] * z[23];
z[23] = 25 + (T(-38) / T(3)) * z[11] + z[23];
z[23] = z[7] * z[23];
z[23] = (T(-7) / T(3)) * z[6] + (T(29) / T(4)) * z[8] + z[23];
z[23] = z[7] * z[23];
z[26] = prod_pow(z[8], 2);
z[23] = z[23] + (T(1) / T(2)) * z[26];
z[19] = z[19] * z[23];
z[19] = (T(7) / T(9)) * z[6] + -2 * z[8] + z[19] + z[21];
z[19] = z[0] * z[19];
z[21] = 13 * z[7];
z[14] = z[14] * z[21];
z[21] = T(-25) / T(3) + z[12];
z[10] = z[10] * z[21];
z[10] = z[10] + z[14] + (T(-13) / T(3)) * z[24];
z[10] = z[9] * z[10];
z[21] = T(64) / T(9) + (T(-13) / T(2)) * z[11];
z[21] = z[1] * z[21];
z[16] = -z[16] + z[21];
z[16] = z[7] * z[16];
z[21] = T(257) / T(4) + -38 * z[11];
z[10] = (T(1) / T(2)) * z[10] + z[13] + z[16] + z[19] + (T(1) / T(9)) * z[21];
z[10] = z[5] * z[10];
z[13] = 26 * z[11];
z[16] = T(179) / T(6) + -z[13];
z[16] = z[1] * z[16];
z[16] = (T(-13) / T(6)) * z[15] + z[16];
z[16] = z[7] * z[16];
z[19] = 37 * z[11];
z[16] = T(529) / T(12) + z[16] + -z[19];
z[16] = z[7] * z[16];
z[21] = (T(-59) / T(3)) * z[6] + 25 * z[8];
z[16] = z[16] + (T(1) / T(2)) * z[21];
z[16] = z[7] * z[16];
z[21] = z[6] * z[8];
z[16] = z[16] + (T(-1) / T(2)) * z[21] + z[26];
z[23] = z[21] + (T(-5) / T(2)) * z[26];
z[18] = T(-2) / T(3) + z[18];
z[18] = z[18] * z[22];
z[22] = -49 + z[19];
z[18] = z[18] + (T(1) / T(3)) * z[22];
z[22] = (T(1) / T(3)) * z[7];
z[18] = z[18] * z[22];
z[24] = 5 * z[8];
z[27] = (T(59) / T(18)) * z[6] + -z[24];
z[18] = z[18] + (T(1) / T(2)) * z[27];
z[18] = z[7] * z[18];
z[18] = z[18] + (T(1) / T(6)) * z[23];
z[18] = z[0] * z[7] * z[18];
z[16] = (T(1) / T(3)) * z[16] + z[18];
z[16] = z[0] * z[16];
z[18] = T(-23) / T(3) + z[12];
z[18] = z[18] * z[20];
z[18] = (T(26) / T(3)) * z[15] + z[18] + -z[25];
z[18] = z[9] * z[18];
z[13] = T(121) / T(6) + -z[13];
z[13] = z[1] * z[13];
z[13] = z[13] + -z[14];
z[13] = z[7] * z[13];
z[14] = T(137) / T(4) + -z[19];
z[13] = z[13] + (T(1) / T(3)) * z[14] + z[18];
z[14] = (T(1) / T(3)) * z[9];
z[13] = z[13] * z[14];
z[18] = T(-25) / T(2) + z[12];
z[18] = z[1] * z[18];
z[15] = (T(26) / T(9)) * z[15] + z[18];
z[15] = z[7] * z[15];
z[18] = T(-235) / T(6) + z[19];
z[15] = z[15] + (T(1) / T(3)) * z[18];
z[15] = z[7] * z[15];
z[18] = (T(59) / T(12)) * z[6] + -z[24];
z[10] = z[10] + z[13] + z[15] + z[16] + (T(1) / T(3)) * z[18];
z[10] = z[5] * z[10];
z[13] = z[21] + -z[26];
z[15] = (T(1) / T(6)) * z[17];
z[16] = 65 * z[11];
z[18] = -59 + z[16];
z[18] = z[15] * z[18];
z[19] = 8 * z[11];
z[20] = -7 + z[19];
z[18] = z[18] + 2 * z[20];
z[18] = z[18] * z[22];
z[20] = (T(31) / T(3)) * z[6] + -9 * z[8];
z[18] = z[18] + (T(1) / T(4)) * z[20];
z[18] = z[7] * z[18];
z[18] = (T(1) / T(2)) * z[13] + z[18];
z[18] = z[7] * z[18];
z[13] = (T(1) / T(4)) * z[13];
z[20] = -4 + (T(-13) / T(6)) * z[17];
z[21] = -1 + z[11];
z[20] = z[7] * z[20] * z[21];
z[21] = -z[6] + z[8];
z[20] = z[20] + (T(31) / T(12)) * z[21];
z[20] = z[20] * z[22];
z[20] = -z[13] + z[20];
z[20] = prod_pow(z[7], 2) * z[0] * z[20];
z[18] = z[18] + z[20];
z[18] = z[0] * z[18];
z[20] = 41 + -z[16];
z[15] = z[15] * z[20];
z[20] = 1 + -2 * z[11];
z[12] = -7 + z[12];
z[12] = z[1] * z[9] * z[12];
z[12] = (T(1) / T(6)) * z[12] + z[15] + 2 * z[20];
z[12] = z[9] * z[12];
z[15] = -47 + z[16];
z[15] = z[15] * z[17];
z[19] = -5 + z[19];
z[15] = (T(1) / T(3)) * z[15] + 2 * z[19];
z[15] = z[7] * z[15];
z[19] = 31 * z[6];
z[20] = -19 * z[8] + z[19];
z[12] = z[12] + z[15] + (T(1) / T(12)) * z[20];
z[12] = z[12] * z[14];
z[14] = 53 + -z[16];
z[14] = z[14] * z[17];
z[11] = 3 + -4 * z[11];
z[11] = 2 * z[11] + (T(1) / T(9)) * z[14];
z[11] = z[7] * z[11];
z[14] = 23 * z[8] + -z[19];
z[11] = z[11] + (T(1) / T(12)) * z[14];
z[11] = z[7] * z[11];
z[10] = z[10] + z[11] + z[12] + -z[13] + z[18];
z[11] = z[2] * z[5];
return prod_pow(z[11], 2) * z[3] * z[4] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_60(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_60(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
