#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_62(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[24];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[17];
z[3] = v[1];
z[4] = v[2];
z[5] = v[3];
z[6] = v[4];
z[7] = iW[1];
z[8] = v[0];
z[9] = prod_pow(z[7], 2);
z[10] = z[6] * z[9];
z[11] = -5 * z[7] + z[10];
z[11] = z[6] * z[11];
z[12] = 7 + z[11];
z[12] = z[6] * z[12];
z[13] = 3 * z[3];
z[12] = z[12] + -z[13];
z[14] = (T(1) / T(2)) * z[7];
z[15] = z[10] + z[14];
z[15] = z[6] * z[15];
z[16] = z[6] * z[7];
z[17] = -7 + (T(5) / T(2)) * z[16];
z[17] = z[6] * z[17];
z[17] = (T(9) / T(2)) * z[3] + z[17];
z[17] = z[1] * z[17];
z[15] = T(-9) / T(2) + z[15] + z[17];
z[15] = z[4] * z[15];
z[15] = -z[12] + z[15];
z[17] = (T(1) / T(2)) * z[6];
z[18] = z[9] * z[17];
z[19] = 2 * z[7] + -z[18];
z[19] = z[6] * z[19];
z[20] = (T(1) / T(2)) * z[4];
z[21] = -z[7] + z[10];
z[21] = z[20] * z[21];
z[19] = -2 + z[19] + z[21];
z[19] = z[5] * z[19];
z[21] = (T(1) / T(4)) * z[6];
z[22] = z[9] * z[21];
z[23] = -z[7] + z[22];
z[23] = z[6] * z[23];
z[12] = z[1] * z[12];
z[12] = T(3) / T(4) + (T(1) / T(4)) * z[12] + z[23];
z[12] = z[8] * z[12];
z[12] = z[12] + (T(1) / T(2)) * z[15] + z[19];
z[12] = z[8] * z[12];
z[14] = z[0] + z[14];
z[10] = -z[10] + 3 * z[14];
z[10] = z[6] * z[10];
z[14] = -3 * z[0] + z[7] + z[18];
z[14] = z[4] * z[14];
z[15] = z[0] * z[3];
z[10] = 7 + z[10] + z[14] + (T(3) / T(2)) * z[15];
z[10] = z[4] * z[10];
z[11] = 5 + z[11];
z[11] = z[6] * z[11];
z[11] = z[11] + -z[13];
z[10] = z[10] + (T(1) / T(2)) * z[11];
z[11] = (T(3) / T(4)) * z[0] + -z[7];
z[14] = z[11] + z[22];
z[14] = z[6] * z[14];
z[18] = (T(1) / T(4)) * z[4] + -z[17];
z[9] = z[9] * z[18];
z[9] = z[9] + -z[11];
z[9] = z[4] * z[9];
z[9] = T(3) / T(2) + z[9] + z[14];
z[9] = z[5] * z[9];
z[9] = z[9] + (T(1) / T(2)) * z[10];
z[9] = z[5] * z[9];
z[10] = z[0] + z[7];
z[10] = z[10] * z[17];
z[10] = T(3) / T(2) + z[10] + z[15];
z[11] = -9 * z[3] + 7 * z[6];
z[11] = z[1] * z[11];
z[14] = z[1] * z[15];
z[14] = -z[0] + z[14];
z[14] = z[4] * z[14];
z[10] = 3 * z[10] + (T(1) / T(2)) * z[11] + (T(3) / T(2)) * z[14];
z[10] = z[10] * z[20];
z[11] = 11 + -3 * z[16];
z[11] = z[11] * z[21];
z[10] = z[10] + z[11] + -z[13];
z[10] = z[4] * z[10];
z[9] = z[9] + z[10] + z[12];
return prod_pow(z[2], 2) * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_12345_62(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_62(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
