#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_64(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[40];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[15];
z[3] = iW[21];
z[4] = iW[22];
z[5] = v[2];
z[6] = v[3];
z[7] = v[4];
z[8] = iW[3];
z[9] = v[1];
z[10] = v[0];
z[11] = z[0] * z[1];
z[12] = z[6] * z[11];
z[13] = (T(3) / T(4)) * z[12];
z[14] = prod_pow(z[1], 2);
z[15] = z[10] * z[14];
z[16] = -z[0] + z[1];
z[16] = z[13] + -z[15] + (T(7) / T(4)) * z[16];
z[16] = z[6] * z[16];
z[17] = (T(1) / T(2)) * z[1];
z[18] = z[0] + z[17];
z[19] = (T(3) / T(2)) * z[12] + -z[15] + -z[18];
z[19] = z[7] * z[19];
z[20] = 3 * z[1] + z[15];
z[21] = (T(1) / T(4)) * z[10];
z[22] = z[20] * z[21];
z[23] = z[0] * z[9];
z[16] = T(-9) / T(4) + z[16] + z[19] + z[22] + z[23];
z[16] = z[7] * z[16];
z[19] = (T(1) / T(2)) * z[10];
z[22] = z[14] * z[19];
z[24] = z[1] + z[22];
z[25] = 3 * z[10];
z[24] = z[24] * z[25];
z[24] = T(-539) / T(54) + -3 * z[23] + z[24];
z[26] = (T(-1) / T(2)) * z[11] + z[14];
z[26] = z[6] * z[26];
z[26] = z[0] + z[1] + (T(-3) / T(2)) * z[15] + z[26];
z[27] = 3 * z[6];
z[26] = z[26] * z[27];
z[24] = (T(1) / T(2)) * z[24] + z[26];
z[26] = (T(1) / T(2)) * z[6];
z[24] = z[24] * z[26];
z[28] = z[1] * z[10];
z[29] = T(-125) / T(27) + (T(-9) / T(8)) * z[28];
z[29] = z[10] * z[29];
z[16] = (T(215) / T(216)) * z[9] + (T(3) / T(2)) * z[16] + z[24] + z[29];
z[16] = z[7] * z[16];
z[24] = (T(1) / T(4)) * z[15];
z[13] = -z[13] + z[18] + z[24];
z[13] = z[7] * z[13];
z[29] = -1 + z[23];
z[30] = 5 * z[28] + -7 * z[29];
z[24] = z[0] + (T(-1) / T(4)) * z[1] + (T(-3) / T(8)) * z[12] + z[24];
z[24] = z[6] * z[24];
z[13] = z[13] + z[24] + (T(1) / T(8)) * z[30];
z[24] = 3 * z[7];
z[13] = z[13] * z[24];
z[30] = 3 * z[0];
z[31] = -z[1] + z[12] + -z[30];
z[31] = z[26] * z[31];
z[31] = 1 + (T(3) / T(2)) * z[23] + z[31];
z[32] = z[11] * z[26];
z[18] = -z[18] + z[32];
z[18] = z[7] * z[18];
z[18] = z[18] + (T(1) / T(2)) * z[31];
z[18] = z[5] * z[18];
z[31] = -z[1] + z[15];
z[32] = -z[6] * z[14];
z[32] = z[31] + z[32];
z[33] = (T(3) / T(4)) * z[6];
z[32] = z[32] * z[33];
z[34] = (T(3) / T(2)) * z[28];
z[32] = T(37) / T(27) + z[32] + z[34];
z[32] = z[6] * z[32];
z[35] = (T(-229) / T(2)) * z[9] + 7 * z[10];
z[32] = z[32] + (T(1) / T(54)) * z[35];
z[13] = z[13] + (T(3) / T(2)) * z[18] + (T(1) / T(2)) * z[32];
z[13] = z[5] * z[13];
z[18] = z[11] + -z[14];
z[32] = -z[6] * z[18];
z[35] = z[1] + z[15];
z[30] = z[30] + z[32] + -z[35];
z[30] = z[26] * z[30];
z[32] = 1 + z[23];
z[30] = z[28] + z[30] + (T(-3) / T(2)) * z[32];
z[30] = z[27] * z[30];
z[36] = prod_pow(z[9], 2);
z[37] = z[0] * z[36];
z[38] = T(257) / T(27) + -3 * z[28];
z[38] = z[10] * z[38];
z[38] = (T(-95) / T(27)) * z[9] + 3 * z[37] + z[38];
z[30] = z[30] + (T(1) / T(2)) * z[38];
z[38] = (T(1) / T(4)) * z[6];
z[30] = z[30] * z[38];
z[39] = (T(15) / T(8)) * z[9] + (T(-22) / T(27)) * z[10];
z[39] = z[10] * z[39];
z[13] = z[13] + z[16] + z[30] + (T(169) / T(108)) * z[36] + z[39];
z[13] = z[5] * z[13];
z[11] = z[11] + (T(-3) / T(2)) * z[14];
z[11] = z[6] * z[11];
z[11] = -z[0] + z[11] + (T(7) / T(2)) * z[15] + z[17];
z[11] = z[11] * z[33];
z[14] = z[10] * z[20];
z[11] = T(-22) / T(27) + z[11] + (T(-3) / T(2)) * z[14];
z[11] = z[6] * z[11];
z[14] = (T(1) / T(2)) * z[0] + -z[1] + (T(-1) / T(4)) * z[12] + z[22];
z[14] = z[14] * z[26];
z[12] = -z[12] + z[15];
z[12] = z[7] * z[12];
z[16] = -z[1] + (T(-1) / T(8)) * z[15];
z[16] = z[10] * z[16];
z[12] = (T(1) / T(4)) * z[12] + z[14] + z[16];
z[12] = z[12] * z[24];
z[14] = T(287) / T(27) + (T(3) / T(4)) * z[28];
z[14] = z[10] * z[14];
z[14] = (T(169) / T(54)) * z[9] + z[14];
z[11] = z[11] + z[12] + (T(1) / T(2)) * z[14];
z[11] = z[7] * z[11];
z[12] = -15 * z[1] + -z[15];
z[12] = z[10] * z[12];
z[12] = -9 + z[12] + z[23];
z[14] = z[18] * z[26];
z[14] = -z[0] + (T(7) / T(2)) * z[1] + z[14] + z[15];
z[14] = z[6] * z[14];
z[12] = (T(1) / T(2)) * z[12] + z[14];
z[12] = z[12] * z[27];
z[14] = 9 * z[28];
z[16] = T(715) / T(54) + z[14];
z[16] = z[10] * z[16];
z[12] = (T(581) / T(54)) * z[9] + z[12] + z[16];
z[12] = z[12] * z[26];
z[16] = -3 * z[9] + (T(419) / T(108)) * z[10];
z[16] = z[10] * z[16];
z[12] = z[12] + z[16] + (T(-169) / T(54)) * z[36];
z[11] = z[11] + (T(1) / T(2)) * z[12];
z[11] = z[7] * z[11];
z[12] = z[9] * z[10];
z[16] = z[12] + z[36];
z[17] = z[28] + (T(-1) / T(2)) * z[29];
z[17] = z[7] * z[17];
z[18] = (T(-5) / T(2)) * z[9] + (T(-7) / T(2)) * z[10] + z[37];
z[17] = z[17] + (T(1) / T(2)) * z[18];
z[17] = z[7] * z[17];
z[18] = -z[9] + -z[37];
z[20] = z[7] * z[32];
z[18] = (T(1) / T(2)) * z[18] + z[20];
z[20] = (T(1) / T(2)) * z[5];
z[18] = z[18] * z[20];
z[17] = (T(3) / T(4)) * z[16] + z[17] + z[18];
z[17] = z[17] * z[20];
z[18] = z[19] * z[31];
z[18] = -1 + z[18];
z[18] = z[7] * z[18];
z[20] = 1 + -7 * z[28];
z[20] = z[10] * z[20];
z[18] = z[9] + (T(1) / T(2)) * z[18] + (T(1) / T(8)) * z[20];
z[18] = z[7] * z[18];
z[20] = (T(1) / T(2)) * z[9] + z[10];
z[20] = z[10] * z[20];
z[18] = z[18] + z[20] + (T(-1) / T(2)) * z[36];
z[18] = z[7] * z[18];
z[20] = z[10] * z[16];
z[17] = z[17] + z[18] + (T(-3) / T(8)) * z[20];
z[17] = z[5] * z[17];
z[18] = -1 + z[28];
z[18] = z[18] * z[19];
z[18] = -z[9] + z[18];
z[18] = z[18] * z[25];
z[15] = 5 * z[1] + -z[15];
z[15] = z[15] * z[19];
z[20] = -z[7] * z[35];
z[15] = 3 + z[15] + z[20];
z[15] = z[7] * z[10] * z[15];
z[15] = z[15] + z[18];
z[15] = z[7] * z[15];
z[18] = -z[9] + -z[25];
z[18] = z[18] * z[19];
z[18] = z[18] + z[36];
z[18] = z[10] * z[18];
z[15] = z[15] + z[18];
z[15] = z[7] * z[15];
z[16] = prod_pow(z[10], 2) * z[16];
z[15] = z[15] + (T(1) / T(2)) * z[16];
z[15] = (T(1) / T(4)) * z[15] + z[17];
z[15] = z[8] * z[15];
z[16] = T(-95) / T(27) + z[34];
z[16] = z[16] * z[21];
z[17] = z[1] * z[6];
z[14] = T(-67) / T(27) + -z[14];
z[14] = (T(1) / T(2)) * z[14] + 3 * z[17];
z[14] = z[14] * z[38];
z[14] = (T(-44) / T(27)) * z[9] + z[14] + z[16];
z[14] = z[6] * z[14];
z[16] = (T(257) / T(8)) * z[9] + (T(22) / T(3)) * z[10];
z[16] = z[10] * z[16];
z[16] = z[16] + (T(257) / T(24)) * z[36];
z[14] = z[14] + (T(1) / T(9)) * z[16];
z[14] = z[6] * z[14];
z[12] = (T(-419) / T(2)) * z[12] + -169 * z[36];
z[12] = z[10] * z[12];
z[11] = z[11] + (T(1) / T(108)) * z[12] + z[13] + z[14] + 3 * z[15];
return z[2] * z[3] * z[4] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_64(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_64(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
