#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_65(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[24];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[16];
z[3] = v[2];
z[4] = v[4];
z[5] = iW[19];
z[6] = v[1];
z[7] = v[3];
z[8] = iW[1];
z[9] = iW[2];
z[10] = v[0];
z[11] = iW[17];
z[12] = prod_pow(z[4], 2) * z[8];
z[13] = -z[2] + (T(1) / T(2)) * z[9];
z[13] = z[12] * z[13];
z[14] = z[2] * z[3];
z[15] = -1 + z[14];
z[16] = z[2] + -z[9];
z[16] = z[4] * z[16];
z[13] = z[13] + z[15] + z[16];
z[13] = z[10] * z[13];
z[16] = z[3] * z[15];
z[17] = z[4] * z[5];
z[18] = -1 + z[17];
z[19] = z[4] * z[18];
z[20] = -z[16] + -z[19];
z[21] = z[5] + (T(1) / T(2)) * z[11];
z[21] = z[3] * z[21];
z[22] = T(1) / T(2) + z[21];
z[23] = z[17] + -z[22];
z[12] = z[12] * z[23];
z[23] = z[2] * z[4];
z[15] = z[15] + -z[23];
z[23] = (T(3) / T(2)) * z[0];
z[15] = prod_pow(z[3], 2) * z[15] * z[23];
z[12] = z[12] + z[13] + z[15] + (T(5) / T(2)) * z[20];
z[12] = z[1] * z[12];
z[13] = -z[17] + z[21];
z[13] = -z[8] * z[13];
z[15] = -z[5] + -z[11];
z[13] = z[13] + (T(1) / T(2)) * z[15] + -z[23];
z[13] = z[7] * z[13];
z[12] = z[12] + z[13];
z[13] = (T(3) / T(4)) * z[0];
z[15] = -z[13] * z[18];
z[17] = z[3] + -z[19];
z[17] = z[13] * z[17];
z[18] = (T(1) / T(4)) * z[9];
z[19] = z[10] * z[18];
z[17] = -1 + z[17] + z[19];
z[17] = z[1] * z[17];
z[15] = z[15] + z[17];
z[15] = z[6] * z[15];
z[17] = z[5] + -z[18];
z[17] = z[4] * z[17];
z[17] = z[17] + -z[22];
z[17] = z[8] * z[17];
z[18] = z[9] + -z[11];
z[18] = -3 * z[5] + (T(1) / T(2)) * z[18];
z[17] = z[17] + (T(1) / T(2)) * z[18];
z[17] = z[4] * z[17];
z[18] = -z[4] * z[14];
z[16] = z[16] + z[18];
z[13] = z[13] * z[16];
return T(313) / T(36) + (T(1) / T(2)) * z[12] + z[13] + -z[14] + z[15] + z[17];
}



template double eval_coef_2q3y_2l_pmmpp_12345_65(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_65(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
