#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_68(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[36];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[15];
z[3] = iW[22];
z[4] = iW[23];
z[5] = iW[24];
z[6] = v[0];
z[7] = v[4];
z[8] = v[2];
z[9] = iW[4];
z[10] = v[3];
z[11] = v[1];
z[12] = (T(1) / T(3)) * z[0];
z[13] = z[1] * z[7];
z[14] = T(-113) / T(3) + (T(-19) / T(4)) * z[13];
z[14] = z[7] * z[14];
z[14] = (T(277) / T(4)) * z[10] + z[14];
z[14] = z[12] * z[14];
z[15] = T(-329) / T(6) + z[13];
z[14] = z[14] + (T(1) / T(2)) * z[15];
z[14] = z[0] * z[14];
z[15] = T(41) / T(6) + z[13];
z[15] = z[12] * z[15];
z[15] = (T(-1) / T(2)) * z[1] + z[15];
z[16] = z[0] * z[8];
z[15] = z[15] * z[16];
z[17] = 13 * z[1];
z[18] = 13 * z[13];
z[19] = T(-277) / T(3) + -z[18];
z[19] = z[0] * z[19];
z[19] = z[17] + z[19];
z[20] = z[0] * z[6];
z[19] = z[19] * z[20];
z[21] = (T(13) / T(12)) * z[1];
z[14] = z[14] + (T(13) / T(2)) * z[15] + (T(1) / T(12)) * z[19] + z[21];
z[14] = z[6] * z[14];
z[15] = prod_pow(z[10], 2);
z[19] = T(-25) / T(3) + (T(13) / T(4)) * z[13];
z[19] = z[7] * z[19];
z[19] = (T(329) / T(3)) * z[10] + z[19];
z[19] = z[7] * z[19];
z[19] = (T(-277) / T(4)) * z[15] + z[19];
z[19] = z[0] * z[19];
z[22] = 29 * z[13];
z[23] = T(-1369) / T(6) + -z[22];
z[23] = z[7] * z[23];
z[23] = (T(635) / T(3)) * z[10] + z[23];
z[19] = z[19] + (T(1) / T(2)) * z[23];
z[19] = z[0] * z[19];
z[23] = z[1] * z[11];
z[24] = (T(13) / T(4)) * z[23];
z[22] = -1 + z[22];
z[19] = z[19] + (T(1) / T(2)) * z[22] + -z[24];
z[22] = (T(1) / T(2)) * z[7];
z[25] = T(83) / T(9) + (T(1) / T(2)) * z[13];
z[25] = z[22] * z[25];
z[25] = (T(-239) / T(9)) * z[10] + z[25];
z[25] = z[0] * z[25];
z[26] = T(293) / T(3) + (T(7) / T(4)) * z[13];
z[25] = z[25] + (T(1) / T(3)) * z[26];
z[25] = z[0] * z[25];
z[18] = T(-235) / T(3) + -z[18];
z[18] = z[12] * z[18];
z[18] = z[17] + z[18];
z[18] = z[16] * z[18];
z[18] = (T(-13) / T(6)) * z[1] + (T(1) / T(8)) * z[18] + z[25];
z[18] = z[8] * z[18];
z[14] = (T(1) / T(2)) * z[14] + z[18] + (T(1) / T(6)) * z[19];
z[14] = z[6] * z[14];
z[18] = 11 * z[13];
z[19] = (T(13) / T(3)) * z[13];
z[25] = 11 + z[19];
z[25] = z[7] * z[25];
z[25] = (T(1057) / T(9)) * z[10] + z[25];
z[25] = z[0] * z[25];
z[25] = T(-1411) / T(9) + -z[18] + z[25];
z[25] = z[0] * z[25];
z[17] = -7 * z[0] + -z[17];
z[17] = z[8] * z[12] * z[17];
z[17] = (T(65) / T(3)) * z[1] + z[17] + z[25];
z[17] = z[8] * z[17];
z[25] = 4 * z[13];
z[26] = T(-19) / T(4) + -z[25];
z[26] = z[7] * z[26];
z[26] = (T(-151) / T(3)) * z[10] + z[26];
z[26] = z[7] * z[26];
z[26] = (T(1951) / T(24)) * z[15] + z[26];
z[26] = z[12] * z[26];
z[27] = T(775) / T(36) + z[25];
z[27] = z[7] * z[27];
z[26] = (T(-3223) / T(72)) * z[10] + z[26] + z[27];
z[26] = z[0] * z[26];
z[27] = (T(13) / T(24)) * z[23];
z[17] = T(365) / T(24) + (T(1) / T(8)) * z[17] + -z[25] + z[26] + z[27];
z[17] = z[8] * z[17];
z[26] = (T(1) / T(3)) * z[7];
z[18] = T(-383) / T(12) + -z[18];
z[18] = z[7] * z[18];
z[18] = (T(1847) / T(12)) * z[10] + z[18];
z[18] = z[18] * z[26];
z[18] = (T(-1) / T(4)) * z[15] + z[18];
z[28] = 1 + (T(19) / T(12)) * z[13];
z[28] = z[7] * z[28];
z[28] = (T(107) / T(9)) * z[10] + z[28];
z[28] = z[22] * z[28];
z[28] = (T(-140) / T(9)) * z[15] + z[28];
z[28] = z[7] * z[28];
z[29] = prod_pow(z[10], 3);
z[28] = z[28] + (T(277) / T(72)) * z[29];
z[28] = z[0] * z[28];
z[18] = (T(1) / T(2)) * z[18] + z[28];
z[18] = z[0] * z[18];
z[28] = 5 * z[13];
z[24] = T(767) / T(12) + -z[24] + z[28];
z[30] = (T(1) / T(6)) * z[11];
z[24] = z[24] * z[30];
z[31] = 3 * z[13];
z[32] = T(-733) / T(18) + z[31];
z[32] = z[7] * z[32];
z[32] = (T(-115) / T(2)) * z[10] + z[32];
z[14] = z[14] + z[17] + z[18] + z[24] + (T(1) / T(4)) * z[32];
z[14] = z[6] * z[14];
z[17] = 19 * z[13];
z[18] = 121 + z[17];
z[18] = z[18] * z[22];
z[18] = (T(421) / T(3)) * z[10] + z[18];
z[18] = z[7] * z[18];
z[18] = (T(-421) / T(6)) * z[15] + z[18];
z[18] = z[7] * z[18];
z[24] = 25 * z[10];
z[32] = -13 * z[7] + -z[24];
z[32] = z[7] * z[32];
z[32] = (T(-289) / T(3)) * z[15] + z[32];
z[32] = z[7] * z[32];
z[32] = (T(295) / T(3)) * z[29] + z[32];
z[32] = z[0] * z[22] * z[32];
z[18] = z[18] + (T(-313) / T(6)) * z[29] + z[32];
z[18] = z[12] * z[18];
z[32] = T(517) / T(9) + z[17];
z[32] = z[7] * z[32];
z[33] = -7 + z[17];
z[34] = z[11] * z[33];
z[32] = (T(-397) / T(9)) * z[10] + z[32] + (T(-1) / T(3)) * z[34];
z[34] = (T(1) / T(2)) * z[11];
z[32] = z[32] * z[34];
z[35] = T(-431) / T(9) + (T(-19) / T(2)) * z[13];
z[35] = z[7] * z[35];
z[35] = (T(-313) / T(18)) * z[10] + z[35];
z[35] = z[7] * z[35];
z[18] = (T(689) / T(18)) * z[15] + z[18] + z[32] + z[35];
z[32] = -101 + (T(-13) / T(2)) * z[13];
z[32] = z[26] * z[32];
z[32] = (T(-257) / T(2)) * z[10] + z[32];
z[32] = z[22] * z[32];
z[35] = (T(11) / T(2)) * z[7] + (T(29) / T(3)) * z[10];
z[35] = z[7] * z[35];
z[35] = (T(97) / T(2)) * z[15] + z[35];
z[35] = z[22] * z[35];
z[35] = (T(-143) / T(9)) * z[29] + z[35];
z[35] = z[0] * z[35];
z[32] = (T(161) / T(9)) * z[15] + z[32] + z[35];
z[32] = z[0] * z[32];
z[35] = T(-421) / T(3) + (T(-65) / T(2)) * z[13] + 13 * z[23];
z[35] = z[30] * z[35];
z[19] = T(193) / T(4) + z[19];
z[19] = z[7] * z[19];
z[19] = (T(173) / T(9)) * z[10] + z[19] + z[32] + z[35];
z[32] = -9 * z[7] + (T(-41) / T(3)) * z[10];
z[32] = z[7] * z[32];
z[32] = (T(-287) / T(3)) * z[15] + z[32];
z[32] = z[0] * z[32];
z[35] = 21 + (T(-19) / T(3)) * z[13];
z[35] = z[7] * z[35];
z[32] = 223 * z[10] + z[32] + z[35];
z[32] = z[0] * z[32];
z[23] = (T(13) / T(3)) * z[23];
z[28] = -79 + z[28];
z[28] = z[23] + (T(5) / T(3)) * z[28] + z[32];
z[32] = (T(7) / T(8)) * z[7] + z[10];
z[32] = z[12] * z[32];
z[35] = 3 + (T(13) / T(6)) * z[13];
z[32] = z[32] + (T(1) / T(4)) * z[35];
z[32] = z[0] * z[32];
z[21] = -z[21] + z[32];
z[21] = z[8] * z[21];
z[21] = z[21] + (T(1) / T(8)) * z[28];
z[21] = z[8] * z[21];
z[19] = (T(1) / T(2)) * z[19] + z[21];
z[19] = z[8] * z[19];
z[14] = z[14] + (T(1) / T(4)) * z[18] + z[19];
z[14] = z[6] * z[14];
z[18] = z[7] * z[10];
z[19] = z[15] + 3 * z[18];
z[19] = z[19] * z[22];
z[19] = z[19] + -z[29];
z[19] = z[0] * z[19];
z[21] = -23 * z[7] + (T(-67) / T(3)) * z[10];
z[21] = z[7] * z[21];
z[19] = (T(11) / T(3)) * z[15] + z[19] + (T(1) / T(4)) * z[21];
z[19] = z[7] * z[19];
z[19] = z[19] + z[29];
z[19] = z[0] * z[19];
z[21] = 125 + z[17];
z[21] = z[21] * z[22];
z[21] = -z[10] + z[21];
z[21] = z[7] * z[21];
z[21] = (T(-31) / T(2)) * z[15] + z[21];
z[28] = z[33] * z[34];
z[17] = T(-49) / T(2) + -z[17];
z[17] = z[7] * z[17];
z[17] = 13 * z[10] + z[17] + z[28];
z[17] = z[17] * z[30];
z[17] = z[17] + z[19] + (T(1) / T(6)) * z[21];
z[19] = (T(21) / T(2)) * z[7] + (T(37) / T(3)) * z[10];
z[19] = z[7] * z[19];
z[19] = (T(-13) / T(6)) * z[15] + z[19];
z[21] = -z[15] + (T(-3) / T(2)) * z[18];
z[21] = z[7] * z[21];
z[21] = z[21] + (T(1) / T(2)) * z[29];
z[21] = z[0] * z[21];
z[19] = (T(1) / T(2)) * z[19] + z[21];
z[21] = (T(1) / T(2)) * z[0];
z[19] = z[19] * z[21];
z[18] = z[15] + z[18];
z[18] = z[0] * z[18];
z[24] = -19 * z[7] + -z[24];
z[18] = z[18] + (T(1) / T(6)) * z[24];
z[18] = z[0] * z[18];
z[13] = 4 + (T(13) / T(8)) * z[13];
z[13] = (T(1) / T(3)) * z[13] + (T(1) / T(4)) * z[18] + -z[27];
z[13] = z[8] * z[13];
z[18] = T(5) / T(3) + z[31];
z[18] = 5 * z[18] + -z[23];
z[18] = z[11] * z[18];
z[23] = T(-107) / T(8) + -z[25];
z[23] = z[7] * z[23];
z[23] = (T(-5) / T(8)) * z[10] + z[23];
z[13] = z[13] + (T(1) / T(8)) * z[18] + z[19] + (T(1) / T(3)) * z[23];
z[13] = z[8] * z[13];
z[13] = z[13] + (T(1) / T(2)) * z[17];
z[13] = z[8] * z[13];
z[17] = prod_pow(z[7], 2);
z[18] = -z[10] * z[17];
z[18] = z[18] + z[29];
z[17] = z[17] * z[18] * z[21];
z[18] = (T(25) / T(6)) * z[7] + 3 * z[10];
z[18] = z[7] * z[18];
z[18] = (T(-31) / T(6)) * z[15] + z[18];
z[18] = z[18] * z[22];
z[18] = z[18] + -z[29];
z[18] = z[7] * z[18];
z[17] = z[17] + z[18];
z[17] = z[0] * z[17];
z[18] = 25 * z[7];
z[19] = (T(13) / T(2)) * z[10] + -z[18];
z[19] = z[7] * z[19];
z[19] = (T(43) / T(2)) * z[15] + z[19];
z[19] = z[19] * z[26];
z[19] = z[19] + z[29];
z[22] = z[10] * z[34];
z[22] = -z[15] + z[22];
z[18] = -31 * z[10] + z[18];
z[18] = z[7] * z[18];
z[18] = (T(1) / T(12)) * z[18] + z[22];
z[18] = z[11] * z[18];
z[17] = z[17] + z[18] + (T(1) / T(2)) * z[19];
z[13] = z[13] + z[14] + (T(1) / T(2)) * z[17];
z[13] = z[6] * z[13];
z[14] = z[0] * z[29];
z[14] = z[14] + -z[15];
z[17] = z[0] * z[14];
z[18] = -z[10] + z[11];
z[17] = z[17] + z[18];
z[19] = z[15] * z[21];
z[19] = -z[10] + z[19];
z[19] = z[0] * z[19];
z[19] = T(1) / T(2) + z[19];
z[19] = z[8] * z[19];
z[17] = (T(1) / T(2)) * z[17] + z[19];
z[17] = z[8] * z[17];
z[19] = z[21] * z[29];
z[17] = z[17] + z[19] + z[22];
z[17] = z[8] * z[17];
z[12] = z[10] * z[12];
z[19] = 1 + -z[12];
z[19] = z[8] * z[19] * z[21];
z[19] = z[12] + z[19] + (T(-1) / T(6)) * z[20];
z[19] = z[6] * z[19];
z[20] = z[0] * z[15];
z[22] = z[18] + -z[20];
z[12] = T(-1) / T(2) + z[12];
z[12] = z[12] * z[16];
z[23] = (T(-5) / T(2)) * z[10] + z[20];
z[23] = z[0] * z[23];
z[23] = T(1) / T(2) + z[23];
z[12] = z[12] + (T(1) / T(3)) * z[23];
z[12] = z[8] * z[12];
z[12] = z[12] + z[19] + (T(1) / T(6)) * z[22];
z[12] = z[6] * z[12];
z[19] = (T(5) / T(3)) * z[10] + -z[20];
z[19] = z[19] * z[21];
z[20] = -z[0] * z[10];
z[20] = 1 + z[20];
z[16] = z[16] * z[20];
z[16] = T(-1) / T(3) + (T(1) / T(6)) * z[16] + z[19];
z[16] = z[8] * z[16];
z[14] = -z[14] * z[21];
z[14] = z[14] + -z[18];
z[14] = (T(1) / T(3)) * z[14] + z[16];
z[14] = z[8] * z[14];
z[16] = z[10] * z[11];
z[15] = z[15] + -z[16];
z[12] = z[12] + z[14] + (T(1) / T(6)) * z[15];
z[12] = z[6] * z[12];
z[12] = z[12] + (T(1) / T(3)) * z[17];
z[12] = prod_pow(z[6], 2) * z[9] * z[12];
z[12] = (T(277) / T(12)) * z[12] + z[13];
return z[2] * z[3] * z[4] * z[5] * z[12];
}



template double eval_coef_2q3y_2l_pmmpp_12345_68(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_68(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
