#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_69(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[25];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[2];
z[5] = v[4];
z[6] = iW[15];
z[7] = v[3];
z[8] = iW[20];
z[9] = iW[24];
z[10] = v[1];
z[11] = z[4] * z[8];
z[12] = -1 + z[11];
z[13] = z[4] * z[12];
z[14] = z[1] * z[3];
z[15] = T(-19) / T(6) + -z[14];
z[15] = z[3] * z[15];
z[16] = (T(-19) / T(6)) * z[6] + -z[8];
z[16] = z[7] * z[16];
z[16] = T(-13) / T(6) + z[16];
z[16] = z[7] * z[16];
z[13] = z[13] + z[15] + z[16];
z[15] = (T(1) / T(4)) * z[0];
z[13] = z[13] * z[15];
z[16] = z[6] * z[8];
z[17] = prod_pow(z[8], 2);
z[16] = (T(19) / T(3)) * z[16] + -z[17];
z[18] = (T(1) / T(8)) * z[7];
z[18] = z[16] * z[18];
z[19] = (T(4) / T(3)) * z[6] + (T(3) / T(4)) * z[8] + -z[18];
z[19] = z[7] * z[19];
z[17] = z[4] * z[17];
z[20] = (T(-31) / T(3)) * z[8] + z[17];
z[21] = z[4] * z[20];
z[22] = -9 + -z[21];
z[13] = z[13] + z[19] + (T(1) / T(8)) * z[22];
z[13] = z[0] * z[13];
z[19] = -z[7] * z[8];
z[19] = -z[12] + z[19];
z[19] = z[15] * z[19];
z[18] = (T(-2) / T(3)) * z[8] + (T(1) / T(8)) * z[17] + -z[18] + z[19];
z[18] = z[0] * z[18];
z[19] = (T(1) / T(8)) * z[16];
z[15] = -z[9] * z[15];
z[15] = z[15] + z[18] + z[19];
z[15] = z[5] * z[15];
z[18] = (T(1) / T(2)) * z[7];
z[16] = z[16] * z[18];
z[22] = z[0] * z[4];
z[22] = 1 + z[22];
z[22] = z[9] * z[22];
z[16] = (T(-13) / T(12)) * z[6] + -z[8] + z[16] + z[22];
z[19] = -z[10] * z[19];
z[13] = z[13] + z[15] + (T(1) / T(2)) * z[16] + z[19];
z[13] = z[5] * z[13];
z[15] = z[2] * z[4];
z[16] = (T(25) / T(3)) * z[8] + -z[17];
z[16] = z[4] * z[16];
z[16] = T(-19) / T(3) + z[16];
z[17] = prod_pow(z[4], 2);
z[19] = z[2] * z[17];
z[22] = z[4] + z[19];
z[23] = z[6] * z[22];
z[16] = -z[15] + (T(1) / T(2)) * z[16] + z[23];
z[23] = T(3) / T(2) + -z[15];
z[23] = z[6] * z[23];
z[23] = (T(-1) / T(4)) * z[20] + z[23];
z[23] = z[7] * z[23];
z[16] = (T(1) / T(2)) * z[16] + z[23];
z[16] = z[7] * z[16];
z[23] = -1 + z[15];
z[24] = z[7] * z[23];
z[24] = -z[22] + z[24];
z[24] = z[6] * z[24];
z[12] = z[12] + z[15] + z[24];
z[12] = z[12] * z[18];
z[18] = -z[2] * z[3];
z[18] = z[18] + z[23];
z[18] = z[3] * z[18];
z[18] = -z[18] + z[19];
z[19] = -1 + (T(1) / T(2)) * z[11];
z[19] = z[4] * z[19];
z[12] = z[12] + (T(-1) / T(2)) * z[18] + z[19];
z[12] = z[7] * z[12];
z[18] = z[1] * z[22];
z[19] = T(1) / T(2) + z[15] + (T(-1) / T(2)) * z[18];
z[19] = z[3] * z[19];
z[19] = z[19] + (T(-1) / T(2)) * z[22];
z[19] = z[3] * z[19];
z[12] = z[12] + z[19];
z[12] = z[0] * z[12];
z[14] = T(-7) / T(6) + z[14] + -z[18];
z[14] = z[3] * z[14];
z[11] = 3 + -z[11];
z[11] = z[4] * z[11];
z[11] = (T(1) / T(2)) * z[11] + z[14];
z[11] = (T(1) / T(2)) * z[11] + z[12] + z[16];
z[11] = z[0] * z[11];
z[12] = -3 + z[15];
z[12] = z[6] * z[12];
z[12] = z[12] + z[20];
z[12] = z[7] * z[12];
z[14] = T(31) / T(3) + z[21];
z[15] = z[6] + -z[9] + (T(-1) / T(2)) * z[20];
z[15] = z[10] * z[15];
z[12] = z[12] + (T(1) / T(2)) * z[14] + z[15];
z[14] = (T(1) / T(2)) * z[17];
z[14] = -z[0] * z[14];
z[14] = -z[4] + z[14];
z[14] = z[9] * z[14];
z[11] = z[11] + (T(1) / T(2)) * z[12] + z[14];
return (T(1) / T(2)) * z[11] + z[13];
}



template double eval_coef_2q3y_2l_pmmpp_12345_69(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_69(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
