#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_70(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[24];
z[0] = iW[1];
z[1] = v[0];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[3];
z[5] = iW[19];
z[6] = iW[17];
z[7] = v[3];
z[8] = iW[16];
z[9] = (T(1) / T(2)) * z[3];
z[10] = -z[2] + -z[3];
z[10] = z[9] * z[10];
z[11] = prod_pow(z[2], 2);
z[12] = -z[2] + z[3];
z[13] = (T(1) / T(2)) * z[12];
z[14] = -z[7] * z[13];
z[10] = z[10] + z[11] + z[14];
z[10] = z[7] * z[10];
z[14] = (T(1) / T(2)) * z[11];
z[15] = -z[2] * z[3];
z[15] = z[14] + z[15];
z[15] = z[3] * z[15];
z[16] = prod_pow(z[2], 3);
z[10] = z[10] + z[15] + (T(1) / T(2)) * z[16];
z[10] = z[6] * z[10];
z[15] = (T(1) / T(2)) * z[1];
z[15] = z[12] * z[15];
z[17] = -z[2] + z[9];
z[17] = z[3] * z[17];
z[14] = z[14] + z[17];
z[17] = -z[14] + -z[15];
z[17] = z[0] * z[1] * z[17];
z[18] = 3 * z[2];
z[19] = -z[3] + z[18];
z[20] = z[3] * z[19];
z[20] = -3 * z[11] + z[20];
z[20] = z[3] * z[20];
z[20] = z[16] + z[20];
z[21] = (T(1) / T(2)) * z[5];
z[21] = z[20] * z[21];
z[22] = z[3] + (T(1) / T(2)) * z[7];
z[22] = z[12] * z[22];
z[23] = prod_pow(z[1], 2);
z[10] = z[10] + z[17] + z[21] + z[22] + (T(1) / T(2)) * z[23];
z[10] = z[0] * z[10];
z[17] = z[5] * z[14];
z[10] = z[1] + z[10] + -z[13] + z[17];
z[10] = z[0] * z[10];
z[13] = -5 * z[2] + 3 * z[3];
z[13] = z[9] * z[13];
z[13] = z[11] + z[13];
z[13] = z[3] * z[13];
z[22] = -z[3] * z[11];
z[16] = z[16] + z[22];
z[9] = z[6] * z[9] * z[16];
z[9] = z[9] + z[13];
z[13] = 4 * z[2];
z[16] = (T(13) / T(8)) * z[3] + -z[13];
z[16] = z[3] * z[16];
z[13] = (T(-5) / T(2)) * z[3] + z[13];
z[13] = z[1] * z[13];
z[13] = (T(19) / T(8)) * z[11] + z[13] + z[16];
z[13] = z[1] * z[13];
z[16] = z[3] * z[5];
z[20] = z[16] * z[20];
z[9] = (T(1) / T(2)) * z[9] + (T(1) / T(3)) * z[13] + (T(3) / T(4)) * z[20];
z[9] = z[0] * z[9];
z[13] = z[14] + z[21];
z[20] = prod_pow(z[3], 2);
z[13] = z[13] * z[20];
z[21] = (T(13) / T(6)) * z[1];
z[22] = -z[3] * z[21];
z[22] = -z[20] + z[22];
z[15] = z[15] * z[22];
z[13] = z[13] + z[15];
z[13] = z[0] * z[13];
z[15] = z[12] * z[21];
z[21] = (T(-19) / T(6)) * z[2] + z[3];
z[21] = z[3] * z[21];
z[11] = (T(13) / T(6)) * z[11] + z[15] + z[21];
z[11] = z[1] * z[11];
z[15] = -z[12] * z[20];
z[11] = z[11] + z[15];
z[15] = z[17] * z[20];
z[11] = (T(1) / T(2)) * z[11] + z[13] + z[15];
z[11] = z[4] * z[11];
z[13] = -z[1] * z[2] * z[8];
z[13] = z[13] + (T(1) / T(2)) * z[19];
z[13] = z[1] * z[13];
z[15] = -z[3] * z[12];
z[13] = z[13] + z[15];
z[14] = z[14] * z[16];
z[9] = z[9] + z[11] + (T(1) / T(2)) * z[13] + z[14];
z[9] = z[0] * z[9];
z[11] = z[12] * z[16];
z[12] = -z[8] * z[18];
z[12] = 1 + z[12];
z[12] = z[1] * z[12];
z[11] = -z[3] + z[11] + z[12];
z[9] = z[9] + (T(1) / T(4)) * z[11];
z[9] = z[4] * z[9];
return z[9] + (T(1) / T(2)) * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_12345_70(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_70(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
