#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_73(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[23];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[18];
z[3] = v[0];
z[4] = v[3];
z[5] = v[4];
z[6] = iW[4];
z[7] = v[2];
z[8] = v[1];
z[9] = prod_pow(z[5], 2);
z[10] = -z[5] * z[7];
z[10] = z[9] + z[10];
z[11] = prod_pow(z[1], 2);
z[12] = z[5] * z[11];
z[12] = z[1] + z[12];
z[13] = (T(1) / T(2)) * z[5];
z[14] = z[12] * z[13];
z[15] = z[6] * z[7];
z[14] = z[14] + -z[15];
z[16] = (T(1) / T(2)) * z[4];
z[14] = z[14] * z[16];
z[17] = z[1] * z[5];
z[18] = T(1) / T(8) + z[17];
z[19] = z[5] * z[18];
z[14] = (T(-9) / T(8)) * z[7] + z[14] + z[19];
z[14] = z[4] * z[14];
z[19] = -z[11] * z[13];
z[19] = -z[1] + z[19];
z[19] = z[5] * z[19];
z[19] = T(1) / T(2) + z[19];
z[19] = z[16] * z[19];
z[20] = T(1) / T(4) + -z[17];
z[20] = z[5] * z[20];
z[19] = z[19] + z[20];
z[19] = z[3] * z[19];
z[10] = (T(5) / T(8)) * z[10] + z[14] + (T(1) / T(2)) * z[19];
z[10] = z[3] * z[10];
z[14] = T(1) / T(2) + -z[17];
z[14] = z[13] * z[14];
z[19] = (T(3) / T(4)) * z[7];
z[20] = prod_pow(z[6], 2);
z[21] = -z[19] * z[20];
z[21] = z[6] + z[21];
z[21] = z[7] * z[21];
z[22] = prod_pow(z[17], 2);
z[21] = z[21] + (T(-1) / T(4)) * z[22];
z[16] = z[16] * z[21];
z[21] = 1 + (T(-3) / T(4)) * z[15];
z[21] = z[7] * z[21];
z[14] = z[14] + z[16] + z[21];
z[14] = z[4] * z[14];
z[16] = z[5] + (T(-1) / T(2)) * z[7];
z[16] = z[7] * z[16];
z[9] = (T(-1) / T(2)) * z[9] + z[16];
z[9] = (T(3) / T(4)) * z[9] + z[14];
z[9] = z[4] * z[9];
z[9] = z[9] + z[10];
z[9] = z[0] * z[9];
z[10] = z[7] * z[20];
z[14] = -11 * z[6] + 9 * z[10];
z[14] = z[7] * z[14];
z[14] = 1 + z[14] + z[17];
z[16] = (T(1) / T(4)) * z[4];
z[14] = z[14] * z[16];
z[21] = T(-7) / T(2) + 3 * z[15];
z[21] = z[7] * z[21];
z[13] = z[13] + z[14] + z[21];
z[13] = z[4] * z[13];
z[14] = -z[5] + z[7];
z[14] = z[14] * z[19];
z[13] = z[13] + z[14];
z[14] = 3 * z[7];
z[19] = z[14] * z[20];
z[12] = z[6] + z[12];
z[21] = -z[12] + -z[19];
z[21] = z[4] * z[21];
z[17] = -3 + (T(-7) / T(2)) * z[15] + (T(-11) / T(2)) * z[17] + z[21];
z[17] = z[4] * z[17];
z[17] = (T(-11) / T(2)) * z[5] + z[17];
z[12] = z[12] * z[16];
z[12] = z[12] + z[18];
z[12] = z[3] * z[12];
z[12] = z[12] + (T(1) / T(4)) * z[17];
z[12] = z[3] * z[12];
z[9] = z[9] + z[12] + (T(1) / T(2)) * z[13];
z[9] = z[0] * z[9];
z[12] = 3 * z[1] + -z[6];
z[12] = (T(1) / T(4)) * z[12] + z[19];
z[12] = z[4] * z[12];
z[13] = (T(3) / T(2)) * z[8];
z[17] = (T(1) / T(2)) * z[6] + -z[10];
z[17] = z[13] * z[17];
z[11] = -z[11] + -3 * z[20];
z[11] = z[11] * z[16];
z[16] = z[8] * z[20];
z[11] = -z[1] + (T(-5) / T(4)) * z[6] + z[11] + (T(3) / T(4)) * z[16];
z[11] = z[3] * z[11];
z[16] = 3 + 11 * z[15];
z[11] = z[11] + z[12] + (T(1) / T(4)) * z[16] + z[17];
z[11] = z[3] * z[11];
z[12] = 1 + -z[15];
z[12] = z[12] * z[14];
z[14] = -z[6] + z[10];
z[13] = z[7] * z[13] * z[14];
z[10] = 5 * z[6] + (T(-9) / T(2)) * z[10];
z[10] = z[7] * z[10];
z[10] = T(-1) / T(2) + z[10];
z[10] = z[4] * z[10];
z[10] = z[10] + z[12] + z[13];
z[10] = (T(1) / T(2)) * z[10] + z[11];
z[9] = z[9] + (T(1) / T(2)) * z[10];
return z[2] * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_12345_73(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_73(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
