#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_74(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[41];
z[0] = iW[1];
z[1] = iW[4];
z[2] = iW[17];
z[3] = iW[18];
z[4] = v[0];
z[5] = v[2];
z[6] = v[3];
z[7] = v[4];
z[8] = v[1];
z[9] = prod_pow(z[0], 2);
z[10] = z[7] * z[9];
z[11] = (T(3) / T(2)) * z[0] + -z[10];
z[12] = (T(1) / T(2)) * z[1];
z[13] = z[11] + z[12];
z[13] = z[6] * z[13];
z[14] = z[1] * z[8];
z[15] = 5 * z[10];
z[16] = (T(19) / T(2)) * z[0] + -z[15];
z[16] = z[7] * z[16];
z[13] = T(-7) / T(2) + z[13] + -z[14] + z[16];
z[16] = (T(1) / T(2)) * z[6];
z[13] = z[13] * z[16];
z[17] = prod_pow(z[8], 2);
z[18] = (T(1) / T(4)) * z[1];
z[19] = z[17] * z[18];
z[20] = (T(1) / T(4)) * z[7];
z[21] = z[9] * z[20];
z[21] = z[0] + z[21];
z[21] = z[7] * z[21];
z[21] = T(-17) / T(8) + z[21];
z[21] = z[7] * z[21];
z[13] = (T(5) / T(8)) * z[8] + z[13] + z[19] + z[21];
z[13] = z[6] * z[13];
z[21] = z[0] * z[1];
z[22] = z[9] + z[21];
z[22] = z[16] * z[22];
z[23] = 3 * z[0];
z[22] = -z[1] + (T(5) / T(2)) * z[10] + z[22] + z[23];
z[22] = z[6] * z[22];
z[24] = (T(1) / T(2)) * z[7];
z[25] = (T(45) / T(2)) * z[0] + -11 * z[10];
z[25] = z[24] * z[25];
z[22] = -7 + (T(1) / T(2)) * z[14] + z[22] + z[25];
z[22] = z[16] * z[22];
z[25] = 7 * z[10];
z[26] = (T(23) / T(2)) * z[0] + -z[25];
z[26] = z[24] * z[26];
z[27] = z[6] * z[9];
z[28] = (T(11) / T(2)) * z[0] + z[10] + -z[27];
z[28] = z[16] * z[28];
z[26] = -3 + z[26] + z[28];
z[28] = (T(1) / T(2)) * z[5];
z[26] = z[26] * z[28];
z[29] = 3 * z[7];
z[29] = z[9] * z[29];
z[30] = (T(1) / T(2)) * z[0] + -z[29];
z[30] = z[7] * z[30];
z[31] = T(-13) / T(2) + -z[30];
z[31] = z[20] * z[31];
z[22] = z[8] + z[22] + z[26] + z[31];
z[22] = z[5] * z[22];
z[26] = z[9] * z[16];
z[31] = (T(7) / T(2)) * z[0];
z[32] = z[10] + z[26] + -z[31];
z[32] = z[16] * z[32];
z[33] = -25 * z[0] + 13 * z[10];
z[33] = z[20] * z[33];
z[32] = 3 + z[32] + z[33];
z[32] = z[5] * z[32];
z[33] = z[9] * z[24];
z[34] = z[0] + z[33];
z[34] = z[7] * z[34];
z[35] = T(7) / T(2) + -z[34];
z[35] = z[24] * z[35];
z[36] = -z[0] + z[33];
z[36] = z[7] * z[36];
z[36] = T(1) / T(2) + z[36];
z[37] = (T(3) / T(4)) * z[10];
z[38] = -z[0] + z[37];
z[39] = z[6] * z[38];
z[39] = 7 * z[36] + z[39];
z[39] = z[6] * z[39];
z[32] = -z[8] + z[32] + z[35] + z[39];
z[35] = -z[0] + z[10];
z[39] = (T(1) / T(8)) * z[6];
z[40] = -z[35] * z[39];
z[36] = -z[36] + z[40];
z[36] = z[4] * z[36];
z[32] = (T(1) / T(2)) * z[32] + z[36];
z[32] = z[4] * z[32];
z[13] = z[13] + z[22] + z[32];
z[22] = prod_pow(z[3], 2);
z[13] = z[4] * z[13] * z[22];
z[32] = z[18] * z[27];
z[32] = (T(1) / T(2)) * z[9] + -z[21] + z[32];
z[32] = z[6] * z[32];
z[36] = -z[0] + z[12] + -z[37];
z[32] = z[32] + (T(5) / T(2)) * z[36];
z[32] = z[6] * z[32];
z[25] = -9 * z[0] + z[25];
z[25] = z[24] * z[25];
z[25] = 5 + -z[14] + z[25];
z[25] = (T(1) / T(2)) * z[25] + z[32];
z[25] = z[6] * z[25];
z[26] = (T(-5) / T(2)) * z[0] + z[26] + -z[29];
z[26] = z[16] * z[26];
z[15] = z[15] + -z[23];
z[15] = z[15] * z[20];
z[15] = 1 + z[15] + z[26];
z[15] = z[15] * z[28];
z[26] = 5 * z[9];
z[32] = -prod_pow(z[7], 2) * z[26];
z[32] = 9 + z[32];
z[32] = z[20] * z[32];
z[32] = -z[8] + z[32];
z[15] = z[15] + z[25] + (T(1) / T(2)) * z[32];
z[15] = z[5] * z[15];
z[25] = -z[0] + (T(5) / T(4)) * z[10];
z[25] = z[7] * z[25];
z[25] = T(-1) / T(2) + (T(3) / T(4)) * z[14] + z[25];
z[26] = z[21] + -z[26];
z[26] = z[26] * z[39];
z[26] = z[0] + (T(-3) / T(4)) * z[1] + (T(-9) / T(4)) * z[10] + z[26];
z[26] = z[6] * z[26];
z[25] = (T(3) / T(2)) * z[25] + z[26];
z[25] = z[6] * z[25];
z[12] = -z[12] * z[17];
z[26] = (T(-1) / T(8)) * z[0] + -z[10];
z[26] = z[7] * z[26];
z[26] = T(5) / T(4) + z[26];
z[26] = z[7] * z[26];
z[12] = (T(3) / T(8)) * z[8] + z[12] + z[25] + z[26];
z[12] = z[6] * z[12];
z[12] = z[12] + z[15];
z[12] = z[5] * z[12];
z[15] = (T(7) / T(4)) * z[10] + -z[23];
z[15] = z[7] * z[15];
z[18] = -z[18] + z[38];
z[18] = z[16] * z[18];
z[15] = 1 + (T(1) / T(4)) * z[14] + z[15] + z[18];
z[15] = z[6] * z[15];
z[18] = -5 * z[0] + -z[33];
z[18] = z[18] * z[20];
z[18] = 2 + z[18];
z[18] = z[7] * z[18];
z[17] = z[1] * z[17];
z[15] = (T(-1) / T(2)) * z[8] + z[15] + (T(-1) / T(8)) * z[17] + z[18];
z[17] = prod_pow(z[6], 2);
z[15] = z[15] * z[17];
z[12] = z[12] + z[15];
z[12] = z[12] * z[22];
z[12] = z[12] + z[13];
z[12] = z[4] * z[12];
z[13] = -2 * z[0] + -z[33];
z[13] = z[7] * z[13];
z[15] = z[1] * z[27];
z[18] = -z[15] + z[21];
z[18] = z[18] * z[39];
z[18] = -z[0] + (T(3) / T(8)) * z[1] + (T(3) / T(2)) * z[10] + z[18];
z[18] = z[6] * z[18];
z[13] = 2 + z[13] + (T(-5) / T(8)) * z[14] + z[18];
z[13] = z[6] * z[13];
z[18] = -z[0] + z[29];
z[18] = z[18] * z[20];
z[18] = 1 + z[18];
z[18] = z[18] * z[24];
z[13] = -z[8] + z[13] + z[18] + z[19];
z[13] = z[6] * z[13];
z[18] = -z[9] + z[21];
z[15] = -z[15] + 3 * z[18];
z[15] = z[15] * z[16];
z[16] = (T(3) / T(2)) * z[1];
z[15] = z[15] + -z[16] + z[23] + z[33];
z[15] = z[6] * z[15];
z[18] = -3 + z[14] + z[30];
z[15] = z[15] + (T(1) / T(2)) * z[18];
z[15] = z[6] * z[15];
z[18] = (T(3) / T(4)) * z[7];
z[23] = z[0] * z[7];
z[24] = -1 + z[23];
z[18] = z[18] * z[24];
z[10] = z[6] * z[10];
z[10] = z[10] + -z[23];
z[10] = z[5] * z[10];
z[10] = (T(3) / T(4)) * z[10] + z[15] + z[18];
z[10] = z[10] * z[28];
z[10] = z[10] + z[13];
z[10] = z[5] * z[10];
z[9] = z[9] + (T(-1) / T(2)) * z[21];
z[9] = z[6] * z[9];
z[9] = z[9] + z[16] + z[29] + -z[31];
z[13] = (T(1) / T(4)) * z[6];
z[9] = z[9] * z[13];
z[15] = -z[0] + -z[29];
z[15] = z[15] * z[20];
z[9] = 1 + z[9] + (T(-3) / T(8)) * z[14] + z[15];
z[9] = z[6] * z[9];
z[14] = -1 + z[34];
z[14] = z[7] * z[14];
z[14] = (T(-3) / T(4)) * z[8] + z[14] + z[19];
z[9] = z[9] + (T(1) / T(2)) * z[14];
z[9] = z[9] * z[17];
z[9] = z[9] + z[10];
z[9] = z[5] * z[9];
z[10] = -z[13] * z[35];
z[11] = z[7] * z[11];
z[10] = T(-1) / T(2) + z[10] + z[11];
z[10] = z[6] * z[10];
z[11] = T(-5) / T(4) + z[23];
z[11] = z[7] * z[11];
z[10] = (T(1) / T(4)) * z[8] + z[10] + z[11];
z[10] = prod_pow(z[6], 3) * z[10];
z[9] = z[9] + (T(1) / T(2)) * z[10];
z[9] = z[9] * z[22];
z[9] = z[9] + z[12];
return prod_pow(z[2], 2) * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_12345_74(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_74(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
