#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_76(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[29];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[4];
z[3] = iW[15];
z[4] = v[2];
z[5] = v[3];
z[6] = v[4];
z[7] = iW[3];
z[8] = v[1];
z[9] = iW[2];
z[10] = v[0];
z[11] = (T(1) / T(2)) * z[6];
z[12] = prod_pow(z[1], 2);
z[13] = -z[11] * z[12];
z[13] = z[1] + z[13];
z[13] = z[6] * z[13];
z[14] = z[6] * z[12];
z[15] = 3 * z[1];
z[16] = -z[14] + z[15];
z[16] = z[6] * z[16];
z[16] = -3 + z[16];
z[16] = z[6] * z[16];
z[16] = z[8] + z[16];
z[17] = (T(1) / T(2)) * z[7];
z[16] = z[16] * z[17];
z[13] = T(-1) / T(2) + z[13] + z[16];
z[13] = z[10] * z[13];
z[16] = z[5] + z[6];
z[16] = z[12] * z[16];
z[16] = -z[15] + z[16];
z[16] = z[6] * z[16];
z[18] = z[1] * z[5];
z[19] = -1 + (T(1) / T(2)) * z[18];
z[16] = z[16] + -3 * z[19];
z[16] = z[6] * z[16];
z[20] = 3 * z[8];
z[21] = z[1] * z[6];
z[21] = -3 + z[21];
z[22] = -z[6] * z[21];
z[22] = -z[20] + z[22];
z[22] = z[6] * z[22];
z[23] = prod_pow(z[8], 2);
z[22] = z[22] + z[23];
z[17] = z[17] * z[22];
z[22] = (T(1) / T(2)) * z[5];
z[13] = -z[8] + z[13] + z[16] + z[17] + z[22];
z[13] = z[10] * z[13];
z[16] = z[5] * z[12];
z[17] = z[15] + -z[16];
z[17] = z[17] * z[22];
z[24] = -z[1] + z[16];
z[25] = -z[11] * z[24];
z[17] = -1 + z[17] + z[25];
z[17] = z[6] * z[17];
z[25] = z[5] * z[19];
z[26] = (T(1) / T(2)) * z[8];
z[25] = z[25] + z[26];
z[17] = z[17] + z[25];
z[17] = z[6] * z[17];
z[13] = z[13] + z[17];
z[13] = z[9] * z[13];
z[17] = -1 + z[18];
z[17] = z[11] * z[17];
z[27] = T(-3) / T(2) + z[18];
z[27] = z[5] * z[27];
z[17] = z[17] + z[26] + z[27];
z[17] = z[6] * z[17];
z[27] = z[5] * z[25];
z[17] = z[17] + z[27];
z[17] = z[0] * z[17];
z[12] = z[12] * z[22];
z[12] = -z[12] + z[15];
z[12] = z[5] * z[12];
z[12] = -5 + z[12];
z[12] = z[5] * z[12];
z[27] = z[14] * z[22];
z[28] = -3 + z[18];
z[27] = z[27] + z[28];
z[27] = z[6] * z[27];
z[12] = (T(7) / T(2)) * z[8] + z[12] + z[13] + z[17] + z[27];
z[13] = -z[14] + -z[15];
z[13] = z[6] * z[13];
z[14] = -z[1] * z[11];
z[14] = 1 + z[14];
z[14] = z[6] * z[14];
z[14] = z[14] + -z[26];
z[14] = z[7] * z[14];
z[15] = z[2] * z[25];
z[17] = -z[1] + (T(1) / T(4)) * z[16];
z[17] = z[5] * z[17];
z[13] = T(5) / T(4) + (T(1) / T(4)) * z[13] + z[14] + (T(-1) / T(2)) * z[15] + z[17];
z[13] = z[10] * z[13];
z[14] = -z[6] * z[8];
z[14] = z[14] + z[23];
z[14] = z[0] * z[14];
z[14] = -z[6] + z[8] + z[14];
z[14] = z[7] * z[14];
z[15] = -z[5] * z[28];
z[15] = z[15] + -z[20];
z[15] = z[5] * z[15];
z[15] = z[15] + z[23];
z[15] = z[0] * z[15];
z[17] = z[5] * z[24];
z[17] = -1 + z[17];
z[17] = z[5] * z[17];
z[15] = z[8] + z[15] + z[17];
z[15] = z[2] * z[15];
z[16] = z[1] + z[16];
z[16] = z[5] * z[16];
z[14] = z[14] + z[15] + z[16] + z[21];
z[15] = T(-5) / T(2) + z[18];
z[15] = z[15] * z[22];
z[15] = z[8] + z[15];
z[16] = -z[11] * z[19];
z[16] = -z[15] + z[16];
z[16] = z[0] * z[16];
z[14] = (T(1) / T(4)) * z[14] + z[16];
z[14] = z[4] * z[14];
z[11] = z[8] + -z[11];
z[11] = z[6] * z[11];
z[11] = z[11] + (T(-1) / T(2)) * z[23];
z[11] = z[7] * z[11];
z[15] = z[5] * z[15];
z[15] = z[15] + (T(-1) / T(4)) * z[23];
z[15] = z[2] * z[15];
z[11] = z[11] + (T(1) / T(2)) * z[12] + z[13] + z[14] + z[15];
return z[3] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_76(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_76(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
