#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_84(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[25];
z[0] = iW[0];
z[1] = iW[3];
z[2] = iW[16];
z[3] = v[1];
z[4] = v[2];
z[5] = v[4];
z[6] = v[3];
z[7] = iW[1];
z[8] = v[0];
z[9] = 3 * z[1];
z[10] = z[3] + -z[5];
z[10] = z[9] * z[10];
z[11] = z[5] * z[7];
z[12] = z[0] * z[5];
z[13] = z[0] * z[3];
z[10] = -3 + z[10] + -z[11] + -z[12] + -3 * z[13];
z[10] = z[1] * z[10];
z[14] = prod_pow(z[7], 2);
z[15] = z[5] * z[14];
z[10] = 3 * z[0] + z[10] + -z[15];
z[10] = z[1] * z[10];
z[16] = prod_pow(z[1], 2);
z[17] = -z[1] * z[13];
z[17] = z[0] + z[17];
z[17] = z[4] * z[16] * z[17];
z[10] = z[10] + -z[14] + z[17];
z[10] = z[4] * z[10];
z[17] = z[6] * z[14];
z[10] = -z[10] + z[17];
z[17] = 2 * z[7];
z[18] = z[15] + -z[17];
z[18] = z[5] * z[18];
z[12] = (T(3) / T(2)) * z[12];
z[19] = (T(1) / T(2)) * z[5];
z[20] = z[7] * z[19];
z[21] = -4 + z[20];
z[21] = z[5] * z[21];
z[21] = (T(7) / T(2)) * z[3] + z[21];
z[21] = z[1] * z[21];
z[21] = T(-7) / T(2) + -z[12] + (T(-3) / T(2)) * z[13] + z[18] + z[21];
z[21] = z[1] * z[21];
z[14] = z[14] * z[19];
z[22] = -z[7] + z[14];
z[20] = 1 + -z[20];
z[20] = z[5] * z[20];
z[20] = (T(-1) / T(2)) * z[3] + z[20];
z[9] = z[9] * z[20];
z[20] = (T(-1) / T(2)) * z[7] + -z[15];
z[20] = z[5] * z[20];
z[9] = T(3) / T(2) + z[9] + z[20];
z[9] = z[1] * z[9];
z[9] = z[9] + -z[15];
z[20] = z[1] * z[8];
z[9] = z[9] * z[20];
z[9] = (T(3) / T(2)) * z[0] + z[9] + (T(-1) / T(2)) * z[10] + z[21] + z[22];
z[9] = z[4] * z[9];
z[10] = -3 * z[7] + z[15];
z[10] = z[5] * z[10];
z[10] = 3 + z[10];
z[10] = z[5] * z[10];
z[10] = -z[3] + z[10];
z[21] = (T(1) / T(2)) * z[1];
z[21] = z[10] * z[21];
z[22] = z[5] * z[22];
z[21] = T(1) / T(2) + z[21] + z[22];
z[16] = -z[8] * z[16] * z[21];
z[23] = (T(5) / T(2)) * z[3];
z[24] = (T(-9) / T(2)) * z[7] + z[15];
z[24] = z[5] * z[24];
z[24] = 6 + z[24];
z[24] = z[5] * z[24];
z[24] = -z[23] + z[24];
z[24] = z[1] * z[24];
z[11] = 1 + -z[11];
z[11] = (T(5) / T(2)) * z[11] + z[24];
z[11] = z[1] * z[11];
z[11] = z[11] + -z[15] + z[16];
z[11] = z[8] * z[11];
z[15] = -z[7] + z[15];
z[16] = z[15] * z[19];
z[14] = -z[14] + z[17];
z[14] = z[5] * z[14];
z[14] = -4 + z[14];
z[14] = z[5] * z[14];
z[14] = z[14] + z[23];
z[14] = z[1] * z[14];
z[15] = (T(1) / T(2)) * z[0] + z[15];
z[15] = z[6] * z[15];
z[9] = -3 + z[9] + z[11] + -z[12] + (T(-1) / T(2)) * z[13] + z[14] + z[15] + z[16];
z[9] = z[4] * z[9];
z[11] = -z[20] * z[21];
z[12] = z[1] * z[10];
z[11] = 1 + z[11] + z[12] + z[18];
z[11] = z[8] * z[11];
z[12] = -z[0] * z[19];
z[12] = -1 + z[12] + -z[22];
z[12] = z[6] * z[12];
z[9] = z[9] + (T(-1) / T(2)) * z[10] + z[11] + z[12];
return z[2] * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_12345_84(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_84(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
