#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_90(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[39];
z[0] = iW[1];
z[1] = iW[2];
z[2] = iW[3];
z[3] = iW[15];
z[4] = iW[19];
z[5] = v[0];
z[6] = v[4];
z[7] = v[3];
z[8] = iW[4];
z[9] = v[2];
z[10] = v[1];
z[11] = 3 * z[1];
z[12] = prod_pow(z[1], 2);
z[13] = z[6] * z[12];
z[14] = z[11] + -z[13];
z[14] = z[6] * z[14];
z[15] = 3 * z[6];
z[16] = z[12] * z[15];
z[17] = 5 * z[1];
z[18] = z[16] + -z[17];
z[18] = z[6] * z[18];
z[18] = -9 + z[18];
z[19] = (T(1) / T(2)) * z[6];
z[18] = z[18] * z[19];
z[20] = prod_pow(z[9], 2) * z[8];
z[18] = (T(11) / T(2)) * z[9] + z[18] + -z[20];
z[18] = z[0] * z[18];
z[14] = 9 + z[14] + z[18];
z[14] = z[0] * z[14];
z[18] = z[12] * z[19];
z[21] = -z[1] + z[13];
z[22] = z[6] * z[21];
z[23] = z[8] * z[9];
z[24] = -3 + -z[22] + z[23];
z[24] = z[0] * z[24];
z[24] = z[8] + z[13] + z[24];
z[25] = (T(1) / T(2)) * z[0];
z[24] = z[7] * z[24] * z[25];
z[14] = (T(-5) / T(2)) * z[1] + z[8] + z[14] + -z[18] + z[24];
z[24] = (T(1) / T(2)) * z[7];
z[14] = z[14] * z[24];
z[26] = -37 + 5 * z[22] + -z[23];
z[27] = (T(-3) / T(2)) * z[8] + z[17] + -z[18];
z[27] = z[10] * z[27];
z[26] = (T(1) / T(2)) * z[26] + z[27];
z[27] = z[1] + z[13];
z[28] = -z[19] * z[27];
z[29] = z[13] + -z[17];
z[30] = (T(1) / T(4)) * z[10];
z[29] = z[29] * z[30];
z[28] = 5 + z[28] + z[29];
z[28] = z[10] * z[28];
z[29] = 7 * z[1] + z[13];
z[29] = z[6] * z[29];
z[31] = -11 + z[29];
z[31] = z[6] * z[31];
z[31] = -9 * z[9] + z[31];
z[28] = z[28] + (T(1) / T(4)) * z[31];
z[28] = z[2] * z[28];
z[31] = 3 * z[9];
z[32] = z[20] + -z[31];
z[33] = (T(-1) / T(2)) * z[1] + -z[13];
z[33] = z[6] * z[33];
z[33] = T(11) / T(2) + z[33];
z[33] = z[6] * z[33];
z[32] = (T(1) / T(2)) * z[32] + z[33];
z[32] = z[0] * z[32];
z[14] = z[14] + (T(1) / T(2)) * z[26] + z[28] + z[32];
z[26] = (T(1) / T(2)) * z[10];
z[28] = z[12] * z[26];
z[32] = -11 * z[1] + z[13];
z[32] = z[19] * z[32];
z[32] = -5 + -z[23] + z[32];
z[33] = z[1] + (T(-3) / T(4)) * z[13];
z[33] = z[6] * z[33];
z[33] = T(7) / T(4) + z[33];
z[33] = z[6] * z[33];
z[33] = -z[9] + z[33];
z[33] = z[0] * z[33];
z[32] = (T(1) / T(2)) * z[32] + z[33];
z[32] = z[0] * z[32];
z[33] = -z[1] + (T(3) / T(2)) * z[13];
z[33] = z[6] * z[33];
z[33] = T(1) / T(2) + z[33];
z[33] = z[25] * z[33];
z[33] = -z[13] + z[33];
z[33] = z[0] * z[33];
z[33] = (T(1) / T(4)) * z[12] + z[33];
z[33] = z[7] * z[33];
z[34] = -z[8] + z[17];
z[32] = z[13] + -z[28] + z[32] + z[33] + (T(1) / T(2)) * z[34];
z[33] = -z[16] + -z[17];
z[21] = z[19] * z[21];
z[21] = -1 + z[21];
z[34] = z[0] * z[6];
z[21] = z[21] * z[34];
z[35] = z[1] * z[15];
z[21] = 1 + z[21] + z[35];
z[21] = z[0] * z[21];
z[35] = prod_pow(z[6], 2);
z[36] = z[12] * z[35];
z[37] = z[25] * z[36];
z[37] = -z[13] + z[37];
z[37] = z[0] * z[37];
z[37] = (T(1) / T(2)) * z[12] + z[37];
z[37] = z[5] * z[37];
z[38] = z[10] * z[12];
z[21] = z[21] + (T(1) / T(2)) * z[33] + z[37] + z[38];
z[21] = z[2] * z[21];
z[16] = z[1] + -z[16];
z[16] = z[16] * z[34];
z[16] = 5 * z[13] + z[16];
z[16] = z[16] * z[25];
z[12] = -z[12] + z[16] + z[21];
z[12] = z[5] * z[12];
z[16] = -z[17] + z[28];
z[16] = z[16] * z[30];
z[17] = (T(1) / T(4)) * z[0];
z[21] = z[6] * z[27];
z[25] = -5 + z[21];
z[25] = z[6] * z[25];
z[25] = -z[9] + z[25];
z[25] = z[17] * z[25];
z[13] = z[1] + (T(-3) / T(8)) * z[13];
z[13] = z[6] * z[13];
z[13] = T(13) / T(8) + z[13] + z[16] + z[25];
z[13] = z[2] * z[13];
z[12] = (T(1) / T(4)) * z[12] + z[13] + (T(1) / T(2)) * z[32];
z[12] = z[5] * z[12];
z[12] = z[12] + (T(1) / T(2)) * z[14];
z[12] = z[5] * z[12];
z[13] = -13 + z[22] + 7 * z[23];
z[14] = z[1] + -z[18];
z[14] = z[14] * z[19];
z[14] = 1 + z[14];
z[14] = z[14] * z[19];
z[14] = -z[9] + z[14] + (T(3) / T(8)) * z[20];
z[14] = z[0] * z[14];
z[13] = (T(1) / T(8)) * z[13] + z[14];
z[13] = z[0] * z[13];
z[14] = 1 + -z[23];
z[14] = z[0] * z[14];
z[14] = -z[8] + z[14];
z[14] = z[7] * z[14] * z[17];
z[13] = (T(1) / T(2)) * z[8] + z[13] + z[14];
z[13] = z[7] * z[13];
z[14] = -7 + z[36];
z[14] = z[6] * z[14];
z[14] = 7 * z[9] + z[14] + -3 * z[20];
z[14] = z[14] * z[17];
z[16] = -z[8] * z[30];
z[13] = T(33) / T(8) + z[13] + z[14] + z[16] + (T(-1) / T(4)) * z[21] + -z[23];
z[13] = z[7] * z[13];
z[11] = -z[11] + -z[18];
z[11] = z[6] * z[11];
z[11] = 5 + z[11];
z[11] = z[6] * z[11];
z[14] = -31 + 3 * z[23] + z[29];
z[14] = z[14] * z[26];
z[16] = z[9] + (T(1) / T(2)) * z[20];
z[11] = z[11] + z[14] + 3 * z[16];
z[14] = z[1] * z[35];
z[16] = z[1] * z[6];
z[16] = T(9) / T(4) + -z[16];
z[16] = z[10] * z[16];
z[14] = z[14] + z[16] + -z[31];
z[14] = z[2] * z[14] * z[26];
z[11] = (T(1) / T(4)) * z[11] + z[12] + z[13] + z[14];
z[11] = z[5] * z[11];
z[12] = 5 * z[9] + -z[15];
z[13] = -z[10] + z[12];
z[13] = z[13] * z[26];
z[12] = (T(1) / T(4)) * z[12];
z[14] = z[10] + -z[12] + -z[24];
z[14] = z[7] * z[14];
z[12] = -prod_pow(z[10], 2) * z[2] * z[12];
z[12] = z[12] + z[13] + z[14];
z[11] = z[11] + (T(1) / T(2)) * z[12];
return prod_pow(z[3], 2) * z[4] * z[5] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_12345_90(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_90(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
