#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_12345_97(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[30];
z[0] = iW[1];
z[1] = iW[4];
z[2] = iW[15];
z[3] = v[2];
z[4] = v[3];
z[5] = iW[7];
z[6] = v[0];
z[7] = iW[18];
z[8] = v[4];
z[9] = v[1];
z[10] = prod_pow(z[0], 2);
z[11] = z[4] * z[10];
z[12] = -z[0] + z[11];
z[13] = prod_pow(z[4], 2);
z[14] = -z[12] * z[13];
z[15] = (T(1) / T(2)) * z[13];
z[16] = z[6] * z[10];
z[17] = z[15] * z[16];
z[14] = z[14] + z[17];
z[14] = z[6] * z[14];
z[17] = z[4] * z[6];
z[18] = -z[12] * z[17];
z[19] = (T(1) / T(2)) * z[4];
z[20] = z[10] * z[19];
z[21] = -z[0] + z[20];
z[22] = z[4] * z[21];
z[22] = T(1) / T(2) + z[22];
z[23] = z[3] * z[22];
z[24] = -2 * z[0] + z[11];
z[24] = z[4] * z[24];
z[24] = 1 + z[24];
z[24] = z[4] * z[24];
z[18] = z[18] + z[23] + z[24];
z[18] = z[3] * z[18];
z[23] = z[13] * z[22];
z[14] = z[14] + z[18] + z[23];
z[14] = z[7] * z[14];
z[18] = (T(13) / T(2)) * z[3];
z[12] = z[12] * z[18];
z[18] = (T(1) / T(2)) * z[0];
z[23] = 2 * z[11] + -z[18];
z[23] = z[6] * z[23];
z[24] = 11 * z[11];
z[25] = (T(29) / T(2)) * z[0] + -z[24];
z[25] = z[4] * z[25];
z[23] = T(-7) / T(2) + -z[12] + 13 * z[23] + z[25];
z[23] = z[3] * z[23];
z[25] = prod_pow(z[3], 2) * z[2] * z[22];
z[26] = (T(1) / T(3)) * z[4];
z[27] = (T(31) / T(6)) * z[0] + -4 * z[11];
z[27] = z[4] * z[27];
z[27] = T(-7) / T(6) + z[27];
z[27] = z[26] * z[27];
z[17] = z[10] * z[17];
z[11] = (T(-23) / T(9)) * z[0] + (T(7) / T(2)) * z[11];
z[11] = z[4] * z[11];
z[11] = z[11] + (T(-13) / T(6)) * z[17];
z[11] = z[6] * z[11];
z[11] = z[11] + (T(13) / T(9)) * z[14] + (T(1) / T(9)) * z[23] + (T(-5) / T(3)) * z[25] + z[27];
z[11] = z[7] * z[11];
z[14] = z[0] * z[19];
z[14] = -1 + z[14];
z[14] = z[4] * z[14];
z[19] = (T(1) / T(2)) * z[9];
z[14] = z[14] + z[19];
z[23] = (T(1) / T(3)) * z[3];
z[22] = z[22] * z[23];
z[22] = (T(1) / T(2)) * z[14] + z[22];
z[22] = z[3] * z[22];
z[27] = z[0] * z[4];
z[28] = 1 + (T(-1) / T(3)) * z[27];
z[28] = z[13] * z[28];
z[10] = z[10] * z[26];
z[26] = z[0] + -z[10];
z[26] = z[4] * z[26];
z[26] = -1 + z[26];
z[26] = z[4] * z[26];
z[29] = (T(1) / T(3)) * z[9];
z[26] = z[26] + z[29];
z[26] = z[3] * z[26];
z[29] = -z[4] + z[29];
z[29] = z[9] * z[29];
z[26] = (T(1) / T(2)) * z[26] + z[28] + z[29];
z[26] = z[3] * z[26];
z[13] = z[13] + z[29];
z[13] = z[9] * z[13];
z[28] = prod_pow(z[4], 3);
z[13] = z[13] + (T(-1) / T(3)) * z[28];
z[13] = (T(1) / T(2)) * z[13] + z[26];
z[13] = z[2] * z[13];
z[19] = -z[4] + z[19];
z[19] = z[9] * z[19];
z[15] = z[15] + z[19];
z[13] = (T(1) / T(2)) * z[13] + (T(1) / T(6)) * z[15] + z[22];
z[13] = z[2] * z[13];
z[19] = -1 + z[27];
z[22] = z[0] * z[6];
z[12] = z[12] + 8 * z[19] + (T(13) / T(2)) * z[22];
z[12] = z[12] * z[23];
z[22] = -z[4] + z[9];
z[23] = (T(13) / T(3)) * z[6] + -z[22];
z[12] = z[12] + (T(1) / T(2)) * z[23];
z[12] = (T(1) / T(3)) * z[12] + z[13];
z[12] = z[1] * z[12];
z[13] = (T(1) / T(2)) * z[16] + -z[21];
z[13] = z[6] * z[13];
z[19] = (T(1) / T(2)) * z[19];
z[13] = z[13] + -z[19];
z[13] = z[6] * z[13];
z[17] = -z[17] + -z[19];
z[17] = z[3] * z[17];
z[13] = z[13] + z[17] + z[25];
z[13] = z[5] * z[13];
z[17] = -z[18] + z[24];
z[17] = z[4] * z[17];
z[19] = (T(1) / T(3)) * z[16] + -z[20];
z[19] = z[8] * z[19];
z[17] = -1 + (T(1) / T(9)) * z[17] + z[19];
z[14] = -z[3] * z[14];
z[19] = z[8] * z[22];
z[14] = z[14] + -z[15] + (T(1) / T(4)) * z[19];
z[14] = z[2] * z[14];
z[15] = -z[10] + z[18];
z[15] = z[4] * z[15];
z[15] = T(-1) / T(6) + z[15];
z[15] = z[3] * z[15];
z[15] = (T(-1) / T(6)) * z[8] + z[15];
z[14] = (T(1) / T(3)) * z[14] + (T(1) / T(2)) * z[15];
z[14] = z[2] * z[14];
z[15] = z[0] + (T(11) / T(2)) * z[16] + -z[24];
z[15] = z[6] * z[15];
z[10] = z[3] * z[10];
return z[10] + z[11] + z[12] + (T(5) / T(3)) * z[13] + z[14] + (T(1) / T(9)) * z[15] + (T(1) / T(2)) * z[17];
}



template double eval_coef_2q3y_2l_pmmpp_12345_97(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_12345_97(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
