#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_23(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[23];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[7];
z[3] = iW[15];
z[4] = iW[18];
z[5] = v[0];
z[6] = v[4];
z[7] = v[2];
z[8] = v[3];
z[9] = v[1];
z[10] = z[6] * z[7];
z[11] = prod_pow(z[6], 2);
z[12] = z[10] + -z[11];
z[13] = prod_pow(z[6], 3);
z[14] = -z[0] * z[13];
z[14] = -z[12] + z[14];
z[14] = z[0] * z[14];
z[14] = z[6] + z[7] + -z[9] + z[14];
z[15] = (T(1) / T(2)) * z[1];
z[14] = z[14] * z[15];
z[16] = (T(1) / T(2)) * z[0];
z[17] = -z[12] * z[16];
z[18] = 13 * z[6] + (T(-19) / T(2)) * z[7];
z[17] = z[17] + (T(1) / T(3)) * z[18];
z[17] = z[0] * z[17];
z[18] = z[0] * z[8];
z[19] = -2 * z[6] + z[7];
z[19] = z[0] * z[19];
z[19] = 2 + z[19];
z[19] = z[18] * z[19];
z[20] = -z[11] * z[16];
z[20] = z[6] + z[20];
z[20] = z[0] * z[20];
z[20] = T(-1) / T(2) + z[20];
z[20] = z[1] * z[20];
z[21] = z[0] * z[6];
z[21] = -1 + z[21];
z[21] = z[0] * z[21];
z[20] = z[20] + (T(8) / T(3)) * z[21];
z[20] = z[5] * z[20];
z[14] = T(-29) / T(6) + z[14] + z[17] + (T(8) / T(3)) * z[19] + z[20];
z[14] = z[5] * z[14];
z[17] = z[7] * z[11];
z[19] = -z[13] + -z[17];
z[19] = z[16] * z[19];
z[19] = z[11] + z[19];
z[19] = z[1] * z[19];
z[20] = -z[6] + z[7];
z[21] = z[15] * z[20];
z[21] = T(-8) / T(3) + z[21];
z[21] = z[9] * z[21];
z[14] = z[14] + z[19] + z[21];
z[13] = -z[13] + z[17];
z[19] = z[0] * z[13];
z[19] = -z[11] + (T(-1) / T(3)) * z[19];
z[19] = z[16] * z[19];
z[21] = z[0] * z[20];
z[22] = -1 + -z[21];
z[18] = z[18] * z[22];
z[18] = 16 + 8 * z[18] + (T(35) / T(2)) * z[21];
z[18] = z[8] * z[18];
z[14] = (T(1) / T(3)) * z[14] + (T(1) / T(9)) * z[18] + z[19] + (T(-11) / T(9)) * z[20];
z[14] = z[5] * z[14];
z[12] = z[8] * z[12];
z[12] = z[12] + z[13];
z[12] = z[12] * z[16];
z[13] = z[9] * z[10];
z[13] = z[13] + -z[17];
z[13] = z[13] * z[15];
z[10] = -z[10] + (T(1) / T(2)) * z[11] + z[12] + z[13];
z[10] = (T(1) / T(3)) * z[10] + z[14];
return z[2] * z[3] * z[4] * z[5] * z[10];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_23(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_23(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
