#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_24(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[19];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[9];
z[3] = iW[15];
z[4] = v[2];
z[5] = v[3];
z[6] = v[4];
z[7] = v[1];
z[8] = v[0];
z[9] = (T(1) / T(2)) * z[0];
z[9] = z[7] * z[9];
z[10] = z[0] * z[5];
z[9] = z[9] + -z[10];
z[11] = prod_pow(z[5], 2);
z[12] = z[5] * z[6];
z[12] = z[11] + z[12];
z[12] = z[1] * z[12];
z[13] = -1 + -z[10];
z[13] = z[5] * z[13];
z[12] = -z[6] + z[12] + z[13];
z[12] = z[1] * z[12];
z[12] = -z[9] + (T(1) / T(2)) * z[12];
z[12] = z[4] * z[12];
z[9] = T(1) / T(2) + -z[9];
z[9] = z[7] * z[9];
z[13] = 5 + z[10];
z[14] = z[0] * z[6];
z[14] = -z[13] + z[14];
z[15] = (T(1) / T(2)) * z[6];
z[14] = z[14] * z[15];
z[16] = (T(1) / T(2)) * z[10];
z[17] = -2 + -z[16];
z[17] = z[5] * z[17];
z[9] = z[9] + z[12] + z[14] + z[17];
z[12] = z[5] * z[8];
z[14] = z[11] + (T(-1) / T(3)) * z[12];
z[13] = z[5] * z[13];
z[13] = -z[8] + z[13];
z[16] = 2 + -z[16];
z[16] = z[6] * z[16];
z[13] = (T(1) / T(2)) * z[13] + z[16];
z[13] = z[6] * z[13];
z[16] = -z[11] + z[12];
z[17] = -z[5] + z[8];
z[17] = z[6] * z[17];
z[17] = z[16] + z[17];
z[18] = z[1] * z[6];
z[18] = (T(1) / T(6)) * z[18];
z[17] = z[17] * z[18];
z[13] = (T(1) / T(3)) * z[13] + (T(1) / T(2)) * z[14] + z[17];
z[13] = z[1] * z[13];
z[9] = (T(1) / T(3)) * z[9] + z[13];
z[9] = z[4] * z[9];
z[13] = (T(1) / T(2)) * z[7];
z[14] = -z[5] + (T(1) / T(3)) * z[7];
z[13] = z[13] * z[14];
z[14] = z[5] + -z[7];
z[17] = 1 + (T(1) / T(3)) * z[10];
z[14] = z[14] * z[17];
z[14] = z[6] + z[14];
z[14] = z[14] * z[15];
z[10] = -1 + z[10];
z[10] = prod_pow(z[6], 2) * z[10];
z[10] = z[10] + z[16];
z[10] = z[10] * z[18];
z[9] = z[9] + z[10] + (T(1) / T(3)) * z[11] + (T(-1) / T(6)) * z[12] + z[13] + z[14];
return z[2] * z[3] * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_24(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_24(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
