#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_27(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[22];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[3];
z[5] = v[1];
z[6] = v[0];
z[7] = prod_pow(z[6], 2);
z[8] = z[0] * z[2];
z[9] = (T(1) / T(3)) * z[8];
z[10] = -1 + z[9];
z[11] = z[2] * z[10];
z[11] = z[6] + z[11];
z[11] = z[2] * z[11];
z[11] = (T(-1) / T(3)) * z[7] + z[11];
z[12] = (T(1) / T(2)) * z[8];
z[13] = -1 + z[12];
z[13] = z[2] * z[13];
z[14] = (T(1) / T(2)) * z[6];
z[13] = z[13] + z[14];
z[15] = z[5] * z[13];
z[16] = (T(1) / T(3)) * z[2];
z[17] = 2 + -z[12];
z[17] = z[16] * z[17];
z[17] = -z[14] + z[17];
z[17] = z[3] * z[17];
z[11] = (T(1) / T(2)) * z[11] + (T(1) / T(3)) * z[15] + z[17];
z[11] = z[4] * z[11];
z[15] = (T(1) / T(2)) * z[2];
z[10] = z[10] * z[15];
z[17] = (T(1) / T(2)) * z[3];
z[18] = T(3) / T(2) + -z[9];
z[18] = z[17] * z[18];
z[19] = (T(1) / T(3)) * z[6];
z[20] = -1 + z[8];
z[21] = z[5] * z[20];
z[10] = z[10] + z[11] + z[18] + z[19] + (T(1) / T(4)) * z[21];
z[10] = z[4] * z[10];
z[11] = 2 * z[6];
z[18] = z[2] + -z[11];
z[18] = z[2] * z[18];
z[18] = z[7] + z[18];
z[14] = z[14] + -z[16];
z[14] = z[3] * z[14];
z[14] = z[14] + (T(1) / T(3)) * z[18];
z[14] = z[4] * z[14];
z[16] = 2 + z[12];
z[16] = z[2] * z[16];
z[11] = -z[11] + z[16];
z[16] = (T(1) / T(4)) * z[3];
z[9] = -3 + -z[9];
z[9] = z[9] * z[16];
z[9] = z[9] + (T(1) / T(3)) * z[11] + z[14];
z[9] = z[3] * z[9];
z[11] = z[2] * z[20];
z[14] = z[6] + -z[11];
z[14] = z[2] * z[14];
z[14] = -z[7] + z[14];
z[9] = z[9] + (T(1) / T(12)) * z[14];
z[9] = z[4] * z[9];
z[14] = -z[15] + z[16] + z[19];
z[14] = z[3] * z[14];
z[15] = (T(1) / T(4)) * z[2] + -z[19];
z[15] = z[2] * z[15];
z[14] = (T(1) / T(12)) * z[7] + z[14] + z[15];
z[14] = z[3] * z[14];
z[15] = z[2] + -z[3];
z[15] = z[6] * z[15];
z[7] = -z[7] + z[15];
z[7] = prod_pow(z[3], 2) * z[4] * z[7];
z[7] = (T(1) / T(6)) * z[7] + z[14];
z[7] = z[4] * z[7];
z[13] = z[2] * z[13];
z[14] = z[0] * z[3];
z[12] = T(1) / T(3) + -z[12] + (T(1) / T(6)) * z[14];
z[12] = z[12] * z[17];
z[15] = T(-1) / T(3) + (T(1) / T(4)) * z[8];
z[15] = z[2] * z[15];
z[12] = (T(1) / T(12)) * z[6] + z[12] + z[15];
z[12] = z[3] * z[12];
z[7] = z[7] + z[12] + (T(-1) / T(6)) * z[13];
z[7] = z[1] * z[7];
z[12] = -1 + 2 * z[8] + -z[14];
z[12] = z[3] * z[12];
z[11] = -z[11] + z[12];
z[7] = z[7] + z[9] + (T(1) / T(3)) * z[11];
z[7] = z[1] * z[7];
z[8] = -z[8] + z[14];
return z[7] + (T(1) / T(4)) * z[8] + z[10];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_27(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_27(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
