#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_28(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[23];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[15];
z[3] = iW[20];
z[4] = v[2];
z[5] = v[3];
z[6] = v[4];
z[7] = v[1];
z[8] = v[0];
z[9] = (T(1) / T(3)) * z[4];
z[10] = z[4] + -z[8];
z[9] = -z[9] * z[10];
z[11] = z[0] * z[4];
z[12] = -1 + z[11];
z[13] = z[5] * z[12];
z[14] = z[10] + -z[13];
z[14] = z[5] * z[14];
z[15] = z[4] * z[10];
z[16] = z[4] * z[5];
z[17] = z[15] + z[16];
z[18] = z[1] * z[5];
z[17] = z[17] * z[18];
z[9] = z[9] + z[14] + (T(1) / T(3)) * z[17];
z[9] = z[1] * z[9];
z[9] = z[9] + -z[10] + (T(5) / T(3)) * z[13];
z[13] = (T(1) / T(2)) * z[3];
z[9] = z[9] * z[13];
z[13] = -1 + (T(1) / T(2)) * z[11];
z[14] = z[0] * z[5];
z[17] = -z[13] + z[14];
z[17] = z[5] * z[17];
z[19] = prod_pow(z[8], 2);
z[20] = z[4] * z[8];
z[20] = -z[19] + z[20];
z[21] = (T(1) / T(2)) * z[4] + -z[8];
z[22] = (T(-1) / T(2)) * z[5] + -z[21];
z[22] = z[5] * z[22];
z[20] = (T(1) / T(2)) * z[20] + z[22];
z[20] = z[1] * z[20];
z[10] = 2 * z[10] + z[17] + z[20];
z[10] = z[1] * z[10];
z[10] = z[10] + (T(1) / T(2)) * z[12] + -z[14];
z[10] = z[3] * z[10];
z[17] = z[3] * z[6];
z[14] = -1 + z[14];
z[14] = z[1] * z[14] * z[17];
z[10] = z[10] + (T(1) / T(2)) * z[14];
z[10] = z[6] * z[10];
z[9] = z[9] + (T(1) / T(3)) * z[10];
z[9] = z[6] * z[9];
z[10] = z[4] * z[21];
z[10] = z[10] + (T(1) / T(2)) * z[19];
z[14] = z[12] * z[16];
z[14] = z[14] + -z[15];
z[14] = z[14] * z[18];
z[11] = T(1) / T(2) + (T(-1) / T(3)) * z[11];
z[11] = z[4] * z[11];
z[11] = (T(-1) / T(6)) * z[8] + z[11];
z[11] = z[5] * z[11];
z[10] = (T(1) / T(3)) * z[10] + z[11] + (T(1) / T(6)) * z[14];
z[10] = z[3] * z[10];
z[11] = -z[12] * z[17];
z[12] = z[4] * z[13];
z[12] = (T(1) / T(2)) * z[8] + z[12];
z[12] = z[3] * z[12];
z[11] = z[11] + z[12];
z[11] = z[7] * z[11];
z[9] = z[9] + z[10] + (T(1) / T(3)) * z[11];
return z[2] * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_28(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_28(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
