#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_29(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[25];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[15];
z[3] = v[0];
z[4] = v[4];
z[5] = v[2];
z[6] = v[3];
z[7] = v[1];
z[8] = (T(1) / T(3)) * z[5];
z[9] = prod_pow(z[1], 2);
z[10] = z[8] * z[9];
z[11] = (T(-3) / T(2)) * z[1] + -z[10];
z[11] = z[5] * z[11];
z[12] = z[1] + z[10];
z[13] = (T(1) / T(2)) * z[4];
z[14] = -z[12] * z[13];
z[15] = (T(1) / T(2)) * z[7];
z[16] = 2 * z[5] + z[13] + -z[15];
z[16] = z[9] * z[16];
z[16] = (T(7) / T(2)) * z[1] + z[16];
z[16] = z[7] * z[16];
z[17] = -z[3] + z[4] + (T(5) / T(3)) * z[5] + -z[7];
z[17] = z[9] * z[17];
z[17] = 3 * z[1] + z[17];
z[18] = (T(1) / T(2)) * z[3];
z[17] = z[17] * z[18];
z[11] = T(-4) / T(3) + z[11] + z[14] + (T(1) / T(3)) * z[16] + z[17];
z[11] = z[3] * z[11];
z[12] = z[4] * z[12];
z[14] = (T(1) / T(2)) * z[5];
z[16] = z[9] * z[14];
z[16] = 2 * z[1] + z[16];
z[17] = -z[5] * z[16];
z[17] = -2 + z[17];
z[19] = (T(-1) / T(6)) * z[3] + z[8] + z[13];
z[19] = z[9] * z[19];
z[20] = (T(1) / T(2)) * z[1];
z[19] = z[19] + z[20];
z[19] = z[3] * z[19];
z[17] = -z[12] + (T(1) / T(3)) * z[17] + z[19];
z[17] = z[3] * z[17];
z[19] = z[1] * z[5];
z[21] = (T(1) / T(2)) * z[19];
z[22] = 2 + z[21];
z[22] = z[5] * z[22];
z[22] = z[6] + z[22];
z[23] = z[1] * z[8];
z[24] = T(1) / T(4) + z[23];
z[24] = z[4] * z[24];
z[17] = z[17] + (T(1) / T(3)) * z[22] + z[24];
z[17] = z[3] * z[17];
z[9] = z[4] * z[9];
z[9] = z[9] + -z[20];
z[9] = z[3] * z[9];
z[9] = 1 + z[9] + z[19];
z[9] = (T(1) / T(3)) * z[9] + -z[12];
z[9] = z[9] * z[18];
z[12] = -1 + (T(-1) / T(4)) * z[19];
z[12] = z[5] * z[12];
z[12] = (T(-1) / T(4)) * z[6] + z[12];
z[18] = T(1) / T(2) + z[23];
z[18] = z[4] * z[18];
z[9] = z[9] + (T(1) / T(3)) * z[12] + z[18];
z[9] = z[3] * z[9];
z[12] = z[5] + z[6];
z[12] = z[8] * z[12];
z[18] = (T(1) / T(6)) * z[4] + (T(-1) / T(3)) * z[6] + -z[14];
z[18] = z[4] * z[18];
z[12] = z[12] + z[18];
z[9] = z[9] + (T(1) / T(2)) * z[12];
z[9] = z[3] * z[9];
z[12] = z[5] * z[6];
z[18] = -z[6] * z[13];
z[18] = z[12] + z[18];
z[18] = z[4] * z[18];
z[19] = (T(1) / T(2)) * z[6];
z[22] = -prod_pow(z[5], 2) * z[19];
z[18] = z[18] + z[22];
z[9] = z[9] + (T(1) / T(6)) * z[18];
z[9] = z[0] * z[9];
z[13] = z[6] + z[13] + -z[14];
z[13] = z[4] * z[13];
z[12] = -z[12] + z[13];
z[9] = z[9] + (T(1) / T(3)) * z[12] + z[17];
z[9] = z[0] * z[9];
z[8] = -z[8] * z[16];
z[10] = z[10] + z[20];
z[10] = z[10] * z[15];
z[8] = T(-1) / T(2) + z[8] + z[10];
z[8] = z[7] * z[8];
z[10] = T(5) / T(3) + z[21];
z[10] = z[5] * z[10];
z[10] = z[10] + z[19];
z[8] = (T(-1) / T(3)) * z[4] + z[8] + z[9] + (T(1) / T(2)) * z[10] + z[11];
return prod_pow(z[2], 2) * z[3] * z[8];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_29(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_29(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
