#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_41(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[19];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[5];
z[3] = iW[18];
z[4] = v[0];
z[5] = v[2];
z[6] = v[4];
z[7] = v[3];
z[8] = v[1];
z[9] = prod_pow(z[8], 2);
z[10] = (T(1) / T(3)) * z[9];
z[11] = z[0] * z[6];
z[12] = -1 + (T(1) / T(3)) * z[11];
z[12] = z[6] * z[12];
z[12] = z[8] + z[12];
z[12] = z[6] * z[12];
z[12] = -z[10] + z[12];
z[13] = 2 * z[1];
z[12] = z[12] * z[13];
z[13] = prod_pow(z[0], 2);
z[14] = z[6] * z[13];
z[15] = -7 * z[0] + 4 * z[14];
z[15] = z[6] * z[15];
z[15] = 2 + z[15];
z[15] = z[6] * z[15];
z[15] = z[8] + z[15];
z[12] = z[12] + (T(1) / T(3)) * z[15];
z[12] = z[1] * z[12];
z[15] = (T(-4) / T(3)) * z[0] + z[14];
z[15] = z[6] * z[15];
z[15] = T(1) / T(3) + z[15];
z[11] = 2 + -z[11];
z[11] = z[6] * z[11];
z[11] = -z[8] + z[11];
z[11] = z[1] * z[11];
z[11] = z[11] + -z[15];
z[11] = z[1] * z[11];
z[11] = z[11] + (T(5) / T(3)) * z[14];
z[11] = z[5] * z[11];
z[16] = z[0] + (T(-2) / T(3)) * z[14];
z[16] = z[6] * z[16];
z[16] = T(-1) / T(3) + z[16];
z[11] = (T(2) / T(3)) * z[11] + z[12] + (T(5) / T(3)) * z[16];
z[11] = z[5] * z[11];
z[12] = (T(1) / T(3)) * z[6];
z[16] = -4 * z[0] + z[14];
z[16] = z[12] * z[16];
z[16] = 2 + z[16];
z[16] = z[6] * z[16];
z[16] = (T(-4) / T(3)) * z[8] + z[16];
z[16] = z[6] * z[16];
z[10] = z[10] + z[16];
z[10] = prod_pow(z[1], 2) * z[10];
z[12] = z[12] * z[13];
z[12] = -z[0] + z[12];
z[12] = z[6] * z[12];
z[12] = 1 + z[12];
z[12] = z[6] * z[12];
z[12] = (T(-1) / T(3)) * z[8] + z[12];
z[12] = z[1] * z[12];
z[16] = -2 * z[0] + z[14];
z[16] = z[6] * z[16];
z[16] = 1 + z[16];
z[17] = (T(5) / T(9)) * z[16];
z[18] = -z[12] + z[17];
z[18] = z[1] * z[5] * z[18];
z[10] = z[10] + z[17] + z[18];
z[10] = z[4] * z[10];
z[17] = 2 * z[6];
z[12] = -z[12] * z[17];
z[10] = z[10] + z[11] + z[12];
z[10] = z[4] * z[10];
z[11] = prod_pow(z[6], 2);
z[12] = z[11] * z[13];
z[17] = -z[5] + z[17];
z[17] = z[13] * z[17];
z[18] = -z[5] * z[17];
z[12] = z[12] + z[18];
z[12] = z[7] * z[12];
z[17] = -z[0] + -z[17];
z[17] = z[5] * z[17];
z[18] = z[0] + z[14];
z[18] = z[6] * z[18];
z[17] = z[17] + z[18];
z[17] = z[5] * z[17];
z[13] = z[5] * z[13];
z[13] = z[0] + z[13] + -z[14];
z[13] = z[4] * z[6] * z[13];
z[12] = z[12] + 2 * z[13] + z[17];
z[12] = z[7] * z[12];
z[13] = z[6] + -2 * z[8];
z[13] = z[6] * z[13];
z[9] = z[9] + z[13];
z[9] = z[1] * z[9];
z[13] = z[6] + -z[8];
z[9] = z[9] + z[13];
z[9] = z[1] * z[9];
z[13] = -z[1] * z[13];
z[13] = -1 + z[13];
z[13] = z[1] * z[13];
z[13] = (T(-5) / T(3)) * z[0] + z[13] + -z[14];
z[13] = z[5] * z[13];
z[9] = z[9] + z[13];
z[13] = (T(-1) / T(9)) * z[0] + z[14];
z[13] = z[6] * z[13];
z[9] = (T(1) / T(3)) * z[9] + z[13];
z[9] = z[5] * z[9];
z[13] = -z[6] * z[15];
z[9] = z[9] + z[13];
z[9] = z[5] * z[9];
z[11] = z[11] * z[16];
z[9] = z[9] + z[10] + (T(1) / T(3)) * z[11] + (T(5) / T(9)) * z[12];
return z[2] * z[3] * z[9];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_41(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_41(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
