#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_45(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[33];
z[0] = iW[0];
z[1] = iW[1];
z[2] = iW[15];
z[3] = iW[23];
z[4] = v[2];
z[5] = v[3];
z[6] = v[4];
z[7] = iW[3];
z[8] = v[1];
z[9] = v[0];
z[10] = iW[4];
z[11] = (T(1) / T(2)) * z[5];
z[12] = prod_pow(z[1], 2);
z[13] = z[11] * z[12];
z[13] = -z[1] + z[13];
z[14] = (T(1) / T(2)) * z[7];
z[15] = z[13] + z[14];
z[16] = -z[5] * z[13];
z[16] = T(-1) / T(2) + z[16];
z[17] = (T(19) / T(3)) * z[10];
z[16] = z[16] * z[17];
z[16] = -z[15] + z[16];
z[16] = z[4] * z[16];
z[18] = z[1] * z[5];
z[19] = -2 + z[18];
z[19] = z[5] * z[19];
z[19] = z[8] + z[19];
z[20] = z[17] * z[19];
z[21] = z[7] * z[8];
z[22] = z[5] * z[12];
z[23] = -43 * z[1] + 38 * z[22];
z[23] = z[5] * z[23];
z[23] = -1 + z[23];
z[16] = z[16] + z[20] + 2 * z[21] + (T(1) / T(3)) * z[23];
z[16] = z[4] * z[16];
z[20] = (T(19) / T(6)) * z[10];
z[23] = z[5] + -z[8];
z[23] = z[20] * z[23];
z[24] = -1 + z[18];
z[25] = -z[17] * z[24];
z[25] = -z[1] + z[7] + (T(-19) / T(3)) * z[22] + z[25];
z[25] = z[4] * z[25];
z[26] = (T(1) / T(2)) * z[9];
z[17] = -z[7] + -z[17];
z[17] = z[17] * z[26];
z[17] = T(-8) / T(3) + z[17] + -z[21] + z[23] + z[25];
z[17] = z[9] * z[17];
z[23] = T(-19) / T(3) + -z[21];
z[23] = z[8] * z[23];
z[16] = (T(11) / T(3)) * z[5] + z[16] + z[17] + (T(1) / T(2)) * z[23];
z[17] = (T(1) / T(3)) * z[9];
z[16] = z[16] * z[17];
z[23] = z[9] * z[12] * z[14];
z[25] = z[1] * z[7];
z[26] = z[12] + -z[25];
z[26] = -z[23] + 2 * z[26];
z[26] = z[17] * z[26];
z[27] = z[12] + z[25];
z[28] = (T(1) / T(3)) * z[4];
z[29] = z[27] * z[28];
z[30] = 3 * z[1] + -z[7] + (T(-5) / T(3)) * z[22];
z[26] = z[26] + z[29] + (T(1) / T(2)) * z[30];
z[26] = z[9] * z[26];
z[14] = z[1] * z[14];
z[14] = -z[12] + z[14] + z[23];
z[14] = z[9] * z[14];
z[13] = z[13] + z[14];
z[14] = (T(1) / T(3)) * z[6];
z[13] = z[13] * z[14];
z[23] = (T(1) / T(3)) * z[5];
z[29] = z[12] * z[23];
z[29] = -z[1] + z[29];
z[29] = z[5] * z[29];
z[30] = 1 + z[29];
z[31] = -z[7] + z[22];
z[32] = 2 * z[1] + -z[31];
z[32] = z[28] * z[32];
z[13] = z[13] + z[26] + z[30] + z[32];
z[13] = z[6] * z[13];
z[26] = -z[4] * z[27];
z[12] = (T(-19) / T(6)) * z[12] + z[25];
z[12] = z[9] * z[12];
z[25] = 19 * z[22];
z[27] = (T(-53) / T(3)) * z[1] + 5 * z[7] + z[25];
z[12] = z[12] + z[26] + (T(1) / T(2)) * z[27];
z[12] = z[12] * z[17];
z[17] = (T(1) / T(2)) * z[21];
z[22] = (T(44) / T(3)) * z[1] + (T(-19) / T(2)) * z[22];
z[22] = z[5] * z[22];
z[22] = T(-20) / T(3) + z[22];
z[26] = (T(-1) / T(3)) * z[1] + z[31];
z[26] = z[4] * z[26];
z[12] = z[12] + z[17] + (T(1) / T(3)) * z[22] + z[26];
z[12] = z[9] * z[12];
z[22] = (T(1) / T(3)) * z[21];
z[26] = T(-1) / T(3) + -z[22] + -z[29];
z[15] = z[15] * z[28];
z[15] = z[15] + 2 * z[26];
z[15] = z[4] * z[15];
z[26] = -41 * z[1] + z[25];
z[26] = z[11] * z[26];
z[26] = 17 + z[26];
z[26] = z[23] * z[26];
z[26] = -2 * z[8] + z[26];
z[12] = z[12] + z[13] + z[15] + (T(1) / T(3)) * z[26];
z[12] = z[6] * z[12];
z[13] = z[5] * z[30];
z[13] = (T(-1) / T(3)) * z[8] + z[13];
z[13] = z[13] * z[20];
z[15] = -1 + z[22];
z[13] = z[13] + -z[15] + z[29];
z[13] = z[4] * z[13];
z[20] = 49 * z[1] + -z[25];
z[20] = z[5] * z[20];
z[20] = -38 + z[20];
z[20] = z[20] * z[23];
z[21] = T(5) / T(3) + z[21];
z[21] = z[8] * z[21];
z[20] = z[20] + z[21];
z[13] = z[13] + (T(1) / T(3)) * z[20];
z[13] = z[4] * z[13];
z[20] = (T(1) / T(2)) * z[18];
z[17] = -1 + z[17] + z[20];
z[17] = z[4] * z[17];
z[17] = z[17] + -z[19];
z[17] = z[4] * z[17];
z[11] = -z[4] + z[11];
z[11] = z[11] * z[24];
z[19] = z[6] * z[20];
z[11] = z[11] + z[19];
z[11] = z[6] * z[11];
z[11] = z[11] + z[17];
z[11] = z[11] * z[14];
z[14] = -1 + (T(1) / T(3)) * z[18];
z[14] = z[5] * z[14];
z[15] = -z[8] * z[15];
z[14] = z[14] + z[15];
z[14] = prod_pow(z[4], 2) * z[14];
z[11] = z[11] + (T(1) / T(2)) * z[14];
z[11] = z[0] * z[11];
z[11] = z[11] + z[12] + z[13] + z[16];
return z[2] * z[3] * z[11];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_45(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_45(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
