#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_46(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[25];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[15];
z[5] = iW[3];
z[6] = v[1];
z[7] = v[0];
z[8] = v[3];
z[9] = z[3] * z[7];
z[10] = prod_pow(z[3], 2);
z[11] = (T(1) / T(2)) * z[10];
z[12] = z[2] * z[3];
z[13] = -z[9] + z[11] + 2 * z[12];
z[13] = z[7] * z[13];
z[14] = prod_pow(z[2], 2);
z[15] = -z[3] * z[14];
z[13] = z[13] + z[15];
z[13] = z[5] * z[13];
z[15] = (T(1) / T(4)) * z[2];
z[16] = 2 * z[3];
z[17] = (T(1) / T(4)) * z[7] + -z[15] + z[16];
z[17] = z[7] * z[17];
z[15] = -z[3] + -z[15];
z[15] = z[2] * z[15];
z[13] = -z[11] + z[13] + z[15] + z[17];
z[13] = z[5] * z[13];
z[15] = (T(1) / T(2)) * z[2];
z[17] = -z[3] + z[15];
z[18] = z[5] * z[14] * z[17];
z[17] = z[2] * z[17];
z[11] = z[11] + z[17];
z[17] = -z[0] * z[2] * z[11];
z[19] = z[3] * z[15];
z[20] = z[10] + -z[19];
z[20] = z[2] * z[20];
z[21] = z[8] * z[12];
z[20] = z[20] + z[21];
z[20] = z[4] * z[20];
z[17] = (T(-5) / T(2)) * z[12] + z[17] + z[18] + z[20];
z[17] = z[4] * z[17];
z[16] = z[2] + -z[16];
z[16] = z[2] * z[16];
z[16] = z[10] + z[16];
z[16] = z[0] * z[16];
z[20] = z[2] + -z[3];
z[13] = z[13] + z[16] + (T(1) / T(2)) * z[17] + -z[20];
z[16] = (T(1) / T(6)) * z[5];
z[17] = -z[2] + z[7];
z[16] = z[10] * z[16] * z[17];
z[12] = -z[10] + z[12];
z[9] = (T(-1) / T(4)) * z[9] + z[12];
z[9] = (T(1) / T(3)) * z[9] + z[16];
z[9] = z[7] * z[9];
z[16] = (T(1) / T(3)) * z[10];
z[17] = z[16] + -z[19];
z[17] = z[15] * z[17];
z[9] = z[9] + z[17];
z[9] = z[5] * z[9];
z[17] = -z[2] * z[12];
z[19] = (T(1) / T(2)) * z[3];
z[21] = z[4] * z[8] * z[14] * z[19];
z[17] = z[17] + z[21];
z[21] = (T(1) / T(6)) * z[4];
z[17] = z[17] * z[21];
z[22] = (T(1) / T(3)) * z[2] + -z[3];
z[22] = z[2] * z[22];
z[10] = z[10] + z[22];
z[10] = z[2] * z[10];
z[22] = prod_pow(z[3], 3);
z[10] = z[10] + (T(-1) / T(3)) * z[22];
z[23] = (T(1) / T(4)) * z[0];
z[10] = z[10] * z[23];
z[24] = z[7] * z[20];
z[9] = z[9] + z[10] + (T(-1) / T(3)) * z[11] + z[17] + (T(1) / T(12)) * z[24];
z[9] = z[1] * z[9];
z[9] = z[9] + (T(1) / T(3)) * z[13];
z[9] = z[1] * z[9];
z[10] = z[3] + -z[6];
z[10] = (T(1) / T(3)) * z[10] + z[15];
z[10] = z[2] * z[10];
z[11] = (T(1) / T(6)) * z[14];
z[13] = -z[2] + z[6];
z[11] = z[0] * z[11] * z[13];
z[13] = (T(1) / T(2)) * z[6];
z[14] = -z[3] + z[13];
z[14] = (T(1) / T(6)) * z[7] + (T(1) / T(3)) * z[14] + -z[15];
z[14] = z[7] * z[14];
z[10] = z[10] + z[11] + z[14];
z[10] = z[5] * z[10];
z[11] = -z[2] + (T(1) / T(3)) * z[3] + z[13];
z[11] = z[0] * z[11];
z[11] = T(5) / T(3) + z[11];
z[11] = z[2] * z[11];
z[13] = (T(5) / T(3)) * z[3] + -z[6];
z[11] = z[11] + (T(1) / T(2)) * z[13];
z[10] = (T(-1) / T(3)) * z[7] + z[10] + (T(1) / T(2)) * z[11];
z[10] = z[5] * z[10];
z[11] = -z[6] + z[8];
z[11] = z[11] * z[19];
z[13] = z[0] * z[22];
z[11] = z[11] + -z[12] + (T(1) / T(2)) * z[13];
z[11] = z[11] * z[21];
z[12] = -z[16] + (T(1) / T(6)) * z[18];
z[12] = z[0] * z[12];
z[11] = (T(-1) / T(4)) * z[3] + z[11] + z[12];
z[11] = z[4] * z[11];
z[12] = -z[20] * z[23];
return z[9] + z[10] + z[11] + z[12];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_46(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_46(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
