#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_51(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[28];
z[0] = iW[1];
z[1] = iW[3];
z[2] = v[0];
z[3] = v[4];
z[4] = v[2];
z[5] = iW[4];
z[6] = v[3];
z[7] = iW[15];
z[8] = iW[23];
z[9] = iW[18];
z[10] = v[1];
z[11] = (T(1) / T(3)) * z[0];
z[12] = prod_pow(z[6], 3) * z[11];
z[13] = prod_pow(z[6], 2);
z[12] = z[12] + -z[13];
z[14] = z[0] * z[12];
z[14] = z[6] + z[14];
z[14] = z[4] * z[14];
z[15] = z[4] + z[10];
z[15] = -z[6] + (T(1) / T(3)) * z[15];
z[15] = z[10] * z[15];
z[12] = z[12] + z[14] + -z[15];
z[14] = (T(1) / T(2)) * z[0];
z[15] = z[13] * z[14];
z[16] = -z[6] + z[15];
z[17] = z[0] * z[16];
z[17] = T(1) / T(2) + z[17];
z[17] = z[4] * z[17];
z[18] = z[0] * z[6];
z[19] = -1 + z[18];
z[20] = (T(1) / T(2)) * z[3];
z[21] = z[19] * z[20];
z[13] = z[0] * z[13];
z[22] = -2 * z[6] + z[13];
z[23] = -z[10] + -z[22];
z[17] = z[17] + z[21] + -z[23];
z[21] = (T(1) / T(3)) * z[3];
z[17] = z[17] * z[21];
z[17] = (T(1) / T(2)) * z[12] + z[17];
z[17] = z[7] * z[17];
z[24] = -z[8] * z[12];
z[15] = z[6] + z[15];
z[11] = z[11] * z[15];
z[15] = prod_pow(z[0], 2);
z[25] = z[3] * z[15];
z[26] = z[6] * z[25];
z[11] = T(-1) / T(2) + z[11] + (T(1) / T(6)) * z[26];
z[11] = z[3] * z[11];
z[11] = (T(1) / T(2)) * z[10] + z[11] + z[16] + z[17] + z[24];
z[11] = z[7] * z[11];
z[16] = z[15] * z[20];
z[17] = z[4] * z[15];
z[20] = z[16] + -z[17];
z[20] = z[3] * z[20];
z[24] = z[0] * z[4];
z[26] = -z[3] * z[24];
z[26] = z[4] + z[26];
z[26] = z[1] * z[26];
z[20] = T(-1) / T(2) + z[20] + z[26];
z[20] = z[1] * z[20];
z[26] = -1 + -z[24];
z[26] = z[5] * z[19] * z[26];
z[14] = -z[14] + -z[16] + -z[17] + z[20] + z[26];
z[16] = 2 * z[0] + -z[25];
z[16] = z[3] * z[16];
z[16] = -1 + z[16] + z[24];
z[16] = z[1] * z[16];
z[16] = z[0] + z[16] + z[17] + -2 * z[25];
z[16] = z[1] * z[16];
z[20] = (T(1) / T(2)) * z[15];
z[26] = -z[0] + z[25];
z[26] = z[1] * z[26];
z[26] = z[20] + z[26];
z[26] = z[1] * z[26];
z[27] = z[0] * z[5];
z[27] = z[15] + z[27];
z[27] = z[5] * z[27];
z[15] = z[9] * z[15];
z[15] = (T(8) / T(3)) * z[15] + z[26] + (T(19) / T(6)) * z[27];
z[15] = z[2] * z[15];
z[15] = z[15] + z[16];
z[16] = z[0] * z[19];
z[16] = z[16] + z[17];
z[26] = z[9] * z[16];
z[27] = z[5] * z[24];
z[27] = -z[0] + z[27];
z[27] = z[19] * z[27];
z[17] = z[17] + z[27];
z[17] = z[5] * z[17];
z[15] = (T(1) / T(3)) * z[15] + (T(19) / T(18)) * z[17] + -z[20] + (T(-8) / T(9)) * z[26];
z[15] = z[2] * z[15];
z[14] = (T(1) / T(3)) * z[14] + z[15];
z[14] = z[2] * z[14];
z[15] = -z[19] * z[24];
z[17] = 1 + -2 * z[18];
z[17] = z[0] * z[17];
z[17] = z[17] + -z[25];
z[17] = z[3] * z[17];
z[13] = -z[6] + -z[13];
z[13] = z[0] * z[13];
z[13] = 2 + z[13] + z[15] + z[17];
z[13] = z[13] * z[21];
z[15] = z[0] * z[22];
z[15] = 1 + z[15];
z[15] = z[4] * z[15];
z[13] = z[13] + (T(-2) / T(3)) * z[15] + z[23];
z[13] = z[8] * z[13];
z[12] = -z[7] * z[12];
z[15] = -z[15] + z[23];
z[12] = z[12] + (T(1) / T(3)) * z[15];
z[12] = z[5] * z[12];
z[15] = T(-1) / T(3) + (T(-1) / T(2)) * z[24];
z[15] = z[15] * z[19];
z[16] = -z[16] + -z[25];
z[16] = z[3] * z[16];
return z[11] + z[12] + z[13] + z[14] + z[15] + (T(1) / T(6)) * z[16];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_51(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_51(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
