#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_53(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[35];
z[0] = iW[1];
z[1] = iW[3];
z[2] = iW[21];
z[3] = v[0];
z[4] = v[2];
z[5] = iW[22];
z[6] = v[4];
z[7] = iW[4];
z[8] = v[3];
z[9] = iW[18];
z[10] = z[1] * z[6];
z[11] = -1 + z[10];
z[12] = prod_pow(z[6], 3);
z[13] = -z[11] * z[12];
z[14] = prod_pow(z[8], 2);
z[15] = prod_pow(z[6], 2);
z[16] = -z[14] + z[15];
z[17] = (T(1) / T(2)) * z[8];
z[16] = z[16] * z[17];
z[13] = z[13] + z[16];
z[16] = z[6] + z[8];
z[18] = -z[16] * z[17];
z[19] = 1 + z[10];
z[20] = z[6] * z[19];
z[21] = -z[17] + -z[20];
z[22] = (T(1) / T(2)) * z[4];
z[21] = z[21] * z[22];
z[23] = z[1] * z[12];
z[18] = z[18] + z[21] + z[23];
z[18] = z[4] * z[18];
z[13] = (T(1) / T(2)) * z[13] + z[18];
z[13] = z[5] * z[13];
z[18] = z[7] * z[14];
z[21] = T(1) / T(2) + z[10];
z[21] = z[6] * z[21];
z[18] = z[18] + z[21];
z[23] = z[7] * z[8];
z[24] = T(1) / T(2) + z[23];
z[25] = -z[22] * z[24];
z[25] = -z[18] + z[25];
z[25] = z[4] * z[25];
z[26] = T(-1) / T(4) + z[10];
z[26] = z[15] * z[26];
z[27] = T(1) / T(2) + -z[23];
z[27] = z[8] * z[27];
z[27] = -z[6] + z[27];
z[27] = z[17] * z[27];
z[13] = z[13] + z[25] + z[26] + z[27];
z[13] = z[5] * z[13];
z[25] = -z[4] * z[24];
z[18] = -z[18] + z[25];
z[13] = z[13] + (T(1) / T(2)) * z[18];
z[18] = z[15] * z[19];
z[25] = (T(1) / T(3)) * z[8];
z[16] = -z[16] * z[25];
z[26] = (T(1) / T(2)) * z[10];
z[27] = 1 + z[26];
z[28] = -z[6] * z[27];
z[28] = -z[17] + z[28];
z[29] = (T(1) / T(3)) * z[4];
z[28] = z[28] * z[29];
z[16] = z[16] + (T(1) / T(2)) * z[18] + z[28];
z[16] = z[16] * z[22];
z[18] = (T(1) / T(4)) * z[1];
z[22] = prod_pow(z[6], 4);
z[28] = -z[18] * z[22];
z[14] = (T(-1) / T(4)) * z[14] + z[15];
z[14] = z[14] * z[25];
z[14] = z[14] + z[16] + z[28];
z[14] = z[4] * z[14];
z[16] = z[11] * z[22];
z[22] = z[8] * z[15];
z[22] = -z[12] + z[22];
z[22] = z[8] * z[22];
z[16] = z[16] + z[22];
z[14] = z[14] + (T(1) / T(12)) * z[16];
z[14] = z[5] * z[14];
z[12] = -z[12] * z[19];
z[16] = z[6] * z[8];
z[16] = z[15] + z[16];
z[19] = z[8] * z[16];
z[12] = z[12] + z[19];
z[19] = (T(1) / T(2)) * z[23] + z[27];
z[22] = z[19] * z[29];
z[27] = T(1) / T(2) + (T(1) / T(3)) * z[23];
z[27] = z[8] * z[27];
z[28] = T(1) / T(3) + z[10];
z[28] = z[6] * z[28];
z[28] = -z[22] + -z[27] + (T(1) / T(4)) * z[28];
z[28] = z[4] * z[28];
z[23] = -1 + -z[23];
z[23] = z[17] * z[23];
z[23] = z[6] + z[23];
z[23] = z[8] * z[23];
z[23] = z[15] + z[23];
z[23] = (T(1) / T(3)) * z[23] + z[28];
z[23] = z[4] * z[23];
z[12] = (T(1) / T(12)) * z[12] + z[14] + z[23];
z[12] = z[5] * z[12];
z[14] = (T(1) / T(2)) * z[2];
z[23] = z[9] + z[14];
z[23] = z[2] * z[23];
z[28] = prod_pow(z[9], 2);
z[23] = z[23] + (T(19) / T(6)) * z[28];
z[17] = -z[17] * z[23];
z[17] = z[2] + (T(19) / T(12)) * z[7] + (T(11) / T(3)) * z[9] + z[17];
z[17] = z[8] * z[17];
z[30] = prod_pow(z[7], 2);
z[28] = z[28] + z[30];
z[31] = prod_pow(z[2], 2);
z[32] = (T(-19) / T(3)) * z[28] + z[31];
z[32] = z[8] * z[32];
z[33] = z[7] + -z[9];
z[32] = -z[2] + z[32] + (T(-19) / T(3)) * z[33];
z[32] = z[4] * z[32];
z[33] = T(-5) / T(2) + -z[10];
z[17] = z[17] + (T(1) / T(4)) * z[32] + (T(1) / T(2)) * z[33];
z[23] = z[23] * z[25];
z[25] = (T(1) / T(2)) * z[1];
z[32] = -z[2] + (T(-19) / T(18)) * z[7] + (T(-19) / T(9)) * z[9] + z[23] + z[25];
z[33] = z[4] * z[31];
z[18] = z[18] * z[33];
z[34] = -z[1] + z[14];
z[34] = z[2] * z[34];
z[18] = z[18] + -z[34];
z[18] = z[18] * z[29];
z[18] = z[18] + (T(1) / T(2)) * z[32];
z[18] = z[3] * z[18];
z[17] = (T(1) / T(3)) * z[17] + z[18];
z[17] = z[3] * z[17];
z[18] = -z[4] * z[19];
z[18] = z[18] + (T(1) / T(4)) * z[20];
z[17] = z[17] + (T(1) / T(3)) * z[18];
z[17] = z[3] * z[17];
z[18] = (T(1) / T(3)) * z[21] + -z[27];
z[18] = (T(1) / T(2)) * z[18] + -z[22];
z[18] = z[4] * z[18];
z[12] = z[12] + (T(1) / T(12)) * z[16] + z[17] + z[18];
z[12] = z[0] * z[12];
z[16] = z[1] + (T(-31) / T(6)) * z[9];
z[14] = (T(-31) / T(18)) * z[7] + -z[14] + (T(1) / T(3)) * z[16] + z[23];
z[16] = z[25] * z[33];
z[16] = z[16] + (T(19) / T(12)) * z[28] + -z[34];
z[16] = z[16] * z[29];
z[17] = z[3] * z[30];
z[14] = (T(1) / T(2)) * z[14] + z[16] + (T(-19) / T(36)) * z[17];
z[14] = z[3] * z[14];
z[14] = z[14] + (T(-1) / T(6)) * z[24];
z[14] = z[3] * z[14];
z[12] = z[12] + (T(1) / T(3)) * z[13] + z[14];
z[12] = z[0] * z[12];
z[13] = z[10] * z[29];
z[14] = -z[1] * z[4];
z[11] = z[11] + z[14];
z[11] = z[5] * z[11] * z[15];
z[14] = T(1) / T(3) + -z[26];
z[14] = z[6] * z[14];
z[11] = (T(1) / T(6)) * z[11] + z[13] + z[14];
z[11] = z[5] * z[11];
z[13] = prod_pow(z[4], 2) * z[31];
z[13] = -1 + z[13];
z[13] = z[1] * z[3] * z[13];
z[10] = (T(1) / T(3)) * z[10] + z[11] + (T(1) / T(6)) * z[13];
return (T(1) / T(2)) * z[10] + z[12];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_53(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_53(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
