#include "FivePointAmplitudes_config.h"
#include "prod_pow.h"
#include <array>
#ifdef FivePointAmplitudes_QD_ENABLED
#include <qd/qd_real.h>
#endif

namespace FivePointAmplitudes {

template <typename T> T eval_coef_2q3y_2l_pmmpp_nf_12345_55(const std::array<T,5>& v, const std::array<T,26>& iW)
{
T z[38];
z[0] = iW[0];
z[1] = iW[1];
z[2] = v[2];
z[3] = v[4];
z[4] = iW[15];
z[5] = iW[3];
z[6] = v[0];
z[7] = iW[4];
z[8] = v[3];
z[9] = iW[7];
z[10] = iW[18];
z[11] = v[1];
z[12] = z[1] * z[5];
z[13] = prod_pow(z[1], 2);
z[14] = z[12] + z[13];
z[15] = z[8] * z[13];
z[16] = -z[1] + z[15];
z[17] = (T(1) / T(2)) * z[4];
z[18] = z[16] * z[17];
z[19] = -z[1] + z[5];
z[19] = z[0] * z[19];
z[18] = -z[14] + z[18] + -z[19];
z[20] = (T(1) / T(6)) * z[4];
z[18] = z[18] * z[20];
z[21] = (T(1) / T(4)) * z[13];
z[22] = (T(-1) / T(3)) * z[12] + -z[21];
z[22] = z[5] * z[22];
z[23] = -z[0] * z[21];
z[18] = z[18] + z[22] + z[23];
z[18] = z[3] * z[18];
z[22] = prod_pow(z[5], 2);
z[23] = (T(1) / T(2)) * z[13] + -z[22];
z[23] = z[0] * z[23];
z[19] = z[12] + z[19];
z[19] = z[17] * z[19];
z[19] = z[19] + z[23];
z[19] = z[2] * z[19];
z[23] = (T(1) / T(2)) * z[1];
z[24] = (T(1) / T(3)) * z[5];
z[25] = -z[23] + z[24];
z[25] = z[5] * z[25];
z[25] = -z[13] + z[25];
z[26] = (T(1) / T(2)) * z[8];
z[27] = z[13] * z[26];
z[27] = -z[1] + z[27];
z[28] = z[8] * z[27];
z[28] = T(1) / T(2) + z[28];
z[29] = (T(1) / T(3)) * z[4];
z[30] = z[9] * z[28] * z[29];
z[31] = (T(4) / T(9)) * z[7];
z[32] = -z[16] * z[31];
z[18] = z[18] + (T(1) / T(6)) * z[19] + (T(1) / T(2)) * z[25] + z[30] + z[32];
z[18] = z[2] * z[18];
z[19] = -z[0] * z[23];
z[25] = z[1] * z[4];
z[19] = z[13] + z[19] + z[25];
z[19] = z[19] * z[29];
z[25] = (T(1) / T(3)) * z[6];
z[22] = z[22] * z[25];
z[30] = -z[22] + z[24];
z[30] = z[13] * z[30];
z[32] = (T(1) / T(2)) * z[0];
z[33] = z[13] * z[32];
z[19] = z[19] + z[30] + z[33];
z[19] = z[3] * z[19];
z[30] = (T(1) / T(2)) * z[6];
z[34] = -z[5] * z[30];
z[34] = 1 + z[34];
z[34] = z[13] * z[34];
z[35] = z[1] * z[8];
z[35] = -1 + z[35];
z[36] = z[4] * z[35];
z[36] = (T(-5) / T(2)) * z[1] + z[36];
z[20] = z[20] * z[36];
z[36] = z[9] * z[15];
z[37] = -z[0] * z[24];
z[19] = (T(1) / T(2)) * z[19] + z[20] + z[34] + (T(1) / T(3)) * z[36] + z[37];
z[19] = z[3] * z[19];
z[20] = z[9] * z[35];
z[20] = (T(1) / T(6)) * z[20] + z[24];
z[34] = -z[15] + -z[23];
z[24] = z[23] + z[24];
z[24] = z[5] * z[24];
z[24] = (T(1) / T(3)) * z[13] + z[24];
z[24] = z[24] * z[30];
z[36] = -z[1] * z[6];
z[35] = -z[35] + z[36];
z[35] = z[31] * z[35];
z[18] = z[18] + z[19] + -z[20] + z[24] + (T(1) / T(2)) * z[34] + z[35];
z[18] = z[2] * z[18];
z[19] = -z[9] * z[27];
z[14] = -z[14] + z[19];
z[19] = z[13] * z[30];
z[22] = z[5] + -z[22];
z[22] = z[19] * z[22];
z[24] = prod_pow(z[4], 2);
z[27] = z[24] * z[32];
z[32] = -z[9] * z[13];
z[27] = z[27] + z[32] + -z[33];
z[27] = z[3] * z[27];
z[17] = -z[0] + z[17];
z[17] = z[17] * z[29];
z[14] = (T(1) / T(3)) * z[14] + z[17] + z[22] + (T(1) / T(6)) * z[27];
z[14] = z[3] * z[14];
z[17] = z[12] + z[21];
z[17] = z[5] * z[6] * z[17];
z[12] = (T(-5) / T(2)) * z[12] + -z[13] + z[17];
z[12] = z[12] * z[25];
z[17] = z[8] * z[29];
z[17] = -1 + z[17];
z[17] = z[4] * z[17];
z[17] = z[15] + z[17];
z[21] = z[11] * z[24];
z[12] = z[12] + z[14] + (T(1) / T(4)) * z[17] + z[20] + (T(-1) / T(12)) * z[21];
z[12] = z[3] * z[12];
z[14] = z[16] + -z[19];
z[14] = z[6] * z[14];
z[14] = z[14] + -z[28];
z[14] = prod_pow(z[8], 2) * z[14];
z[17] = (T(-1) / T(2)) * z[2] + -z[8];
z[17] = z[17] * z[28];
z[19] = z[6] * z[16] * z[26];
z[17] = z[17] + z[19];
z[17] = z[2] * z[17];
z[14] = (T(1) / T(2)) * z[14] + z[17];
z[14] = z[10] * z[14];
z[17] = (T(-113) / T(4)) * z[1] + 22 * z[15];
z[17] = z[8] * z[17];
z[19] = (T(1) / T(4)) * z[1] + -z[15];
z[19] = z[6] * z[19];
z[17] = T(25) / T(4) + z[17] + 19 * z[19];
z[19] = -z[4] * z[28];
z[16] = (T(19) / T(12)) * z[16] + z[19];
z[16] = z[2] * z[16];
z[16] = z[16] + (T(1) / T(3)) * z[17];
z[16] = z[2] * z[16];
z[17] = (T(41) / T(6)) * z[1] + -10 * z[15];
z[17] = z[8] * z[17];
z[19] = z[6] * z[15];
z[17] = z[17] + (T(19) / T(4)) * z[19];
z[17] = z[17] * z[25];
z[19] = (T(-22) / T(9)) * z[1] + (T(7) / T(4)) * z[15];
z[19] = z[8] * z[19];
z[19] = T(25) / T(36) + z[19];
z[19] = z[8] * z[19];
z[14] = (T(19) / T(9)) * z[14] + (T(1) / T(3)) * z[16] + z[17] + z[19];
z[14] = z[10] * z[14];
z[16] = -z[5] + -z[23];
z[16] = z[5] * z[16];
z[13] = (T(-19) / T(3)) * z[13] + z[16];
z[13] = z[13] * z[30];
z[16] = -8 * z[1] + (T(41) / T(2)) * z[15];
z[13] = z[5] + z[13] + (T(1) / T(3)) * z[16];
z[13] = z[13] * z[25];
z[15] = (T(41) / T(4)) * z[1] + -11 * z[15];
z[15] = z[8] * z[15];
z[16] = -z[6] * z[31];
return T(-1) / T(2) + z[12] + z[13] + z[14] + (T(1) / T(9)) * z[15] + z[16] + z[18];
}



template double eval_coef_2q3y_2l_pmmpp_nf_12345_55(const std::array<double,5>& v, const std::array<double,26>& iW);
#ifdef FivePointAmplitudes_QD_ENABLED 
template dd_real eval_coef_2q3y_2l_pmmpp_nf_12345_55(const std::array<dd_real,5>& v, const std::array<dd_real,26>& iW);
#endif

}
