#include "header.hpp"

#include "ppeeexex04.phasespace.set.hpp"

void ppeeexex04_phasespace_set::ax_psp_040_aa_ememepep(int x_a){
  static Logger logger("ppeeexex04_phasespace_set::ax_psp_040_aa_ememepep");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(18);
  needed_v_smin[x_a].resize(18);
  needed_v_smin[x_a][  0] = {  32,   33,   44,   45,   48,   49,   60,   61,   64,   65,   66,   67,    4,    5,   26,   27}; //  16
  needed_v_smin[x_a][  1] = {  32,   33,   66,   67,   26,   27,   60,   61}; //   8
  needed_v_smin[x_a][  2] = {  34,   35,   46,   47,   50,   51,   62,   63,   68,   69,   70,   71,    0,    1,   30,   31}; //  16
  needed_v_smin[x_a][  3] = {  34,   35,   70,   71,   30,   31,   62,   63}; //   8
  needed_v_smin[x_a][  4] = {  36,   37,   40,   41,   52,   53,   56,   57,   72,   73,   74,   75,   10,   11,   20,   21}; //  16
  needed_v_smin[x_a][  5] = {  36,   37,   72,   73,   20,   21,   56,   57}; //   8
  needed_v_smin[x_a][  6] = {  38,   39,   42,   43,   54,   55,   58,   59,   76,   77,   78,   79,   14,   15,   16,   17}; //  16
  needed_v_smin[x_a][  7] = {  38,   39,   76,   77,   16,   17,   58,   59}; //   8
  needed_v_smin[x_a][  8] = {  40,   41,   74,   75,   10,   11,   52,   53}; //   8
  needed_v_smin[x_a][  9] = {  42,   43,   78,   79,   14,   15,   54,   55}; //   8
  needed_v_smin[x_a][ 10] = {  44,   45,   64,   65,    4,    5,   48,   49}; //   8
  needed_v_smin[x_a][ 11] = {  46,   47,   68,   69,    0,    1,   50,   51}; //   8
  needed_v_smin[x_a][ 12] = {   2,    3,   12,   13,   18,   19,   28,   29}; //   8
  needed_v_smin[x_a][ 13] = {   2,    3,   18,   19}; //   4
  needed_v_smin[x_a][ 14] = {   6,    7,    8,    9,   22,   23,   24,   25}; //   8
  needed_v_smin[x_a][ 15] = {   6,    7,    8,    9}; //   4
  needed_v_smin[x_a][ 16] = {  12,   13,   28,   29}; //   4
  needed_v_smin[x_a][ 17] = {  22,   23,   24,   25}; //   4

  v_smax[x_a].resize(10);
  needed_v_smax[x_a].resize(10);
  needed_v_smax[x_a][  0] = {  32,   33,   44,   45,   48,   49,   60,   61,   64,   65,   66,   67,    4,    5,   26,   27}; //  16
  needed_v_smax[x_a][  1] = {  32,   33,   40,   41,   66,   67,   74,   75,    2,    3,   10,   11,   18,   19,   26,   27,   52,   53,   60,   61}; //  20
  needed_v_smax[x_a][  2] = {  34,   35,   46,   47,   50,   51,   62,   63,   68,   69,   70,   71,    0,    1,   30,   31}; //  16
  needed_v_smax[x_a][  3] = {  34,   35,   42,   43,   70,   71,   78,   79,   12,   13,   14,   15,   28,   29,   30,   31,   54,   55,   62,   63}; //  20
  needed_v_smax[x_a][  4] = {  36,   37,   40,   41,   52,   53,   56,   57,   72,   73,   74,   75,   10,   11,   20,   21}; //  16
  needed_v_smax[x_a][  5] = {  36,   37,   38,   39,   72,   73,   76,   77,   16,   17,   20,   21,   22,   23,   24,   25,   56,   57,   58,   59}; //  20
  needed_v_smax[x_a][  6] = {  38,   39,   42,   43,   54,   55,   58,   59,   76,   77,   78,   79,   14,   15,   16,   17}; //  16
  needed_v_smax[x_a][  7] = {  44,   45,   46,   47,   64,   65,   68,   69,    0,    1,    4,    5,    6,    7,    8,    9,   48,   49,   50,   51}; //  20
  needed_v_smax[x_a][  8] = {   2,    3,   12,   13,   18,   19,   28,   29}; //   8
  needed_v_smax[x_a][  9] = {   6,    7,    8,    9,   22,   23,   24,   25}; //   8

  g_p[x_a].resize(16);
  needed_g_p[x_a].resize(16);
  needed_g_p[x_a][0] = {  32,   44,   48,   60,   64,   66}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  32,   33,   66,   67}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {  33,   45,   49,   61,   65,   67}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][3] = {  34,   46,   50,   62,   68,   70}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {  34,   35,   70,   71}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {  35,   47,   51,   63,   69,   71}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][6] = {  36,   40,   52,   56,   72,   74}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][7] = {  36,   37,   72,   73}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][8] = {  37,   41,   53,   57,   73,   75}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][9] = {  38,   42,   54,   58,   76,   78}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][10] = {  38,   39,   76,   77}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][11] = {  39,   43,   55,   59,   77,   79}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax6");
  needed_g_p[x_a][12] = {  40,   41,   74,   75}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax1");
  needed_g_p[x_a][13] = {  42,   43,   78,   79}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax3");
  needed_g_p[x_a][14] = {  44,   45,   64,   65}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][15] = {  46,   47,   68,   69}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");

  g_f[x_a].resize(18);
  needed_g_f[x_a].resize(18);
  needed_g_f[x_a][0] = {   0,    1,   30,   31}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   0,    1,   50,   51}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax7");
  needed_g_f[x_a][2] = {   2,    3,   12,   13,   18,   19,   28,   29}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax8");
  needed_g_f[x_a][3] = {   2,    3,   18,   19}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax1");
  needed_g_f[x_a][4] = {   4,    5,   26,   27}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][5] = {   4,    5,   48,   49}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax7");
  needed_g_f[x_a][6] = {   6,    7,    8,    9,   22,   23,   24,   25}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax9");
  needed_g_f[x_a][7] = {   6,    7,    8,    9}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax7");
  needed_g_f[x_a][8] = {  10,   11,   20,   21}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][9] = {  10,   11,   52,   53}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax1");
  needed_g_f[x_a][10] = {  12,   13,   28,   29}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax3");
  needed_g_f[x_a][11] = {  14,   15,   16,   17}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax6");
  needed_g_f[x_a][12] = {  14,   15,   54,   55}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax3");
  needed_g_f[x_a][13] = {  16,   17,   58,   59}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][14] = {  20,   21,   56,   57}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][15] = {  22,   23,   24,   25}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax5");
  needed_g_f[x_a][16] = {  26,   27,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][17] = {  30,   31,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");

  g_t[x_a].resize(52);
  needed_g_t[x_a].resize(52);
  needed_g_t[x_a][0] = {   0,    1,    4,    5,    6,    7,    8,    9,   48,   49,   50,   51,   64,   65,   68,   69}; //  16
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,    1,   50,   51}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_40");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__32_8");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__5_18__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__5_18__32_8");
  needed_g_t[x_a][4] = {   2,    3,   10,   11,   18,   19,   26,   27,   52,   53,   60,   61,   66,   67,   74,   75}; //  16
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][5] = {   2,    3,   18,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__4_8");
  needed_g_t[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__33_18__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__33_18__4_8");
  needed_g_t[x_a][8] = {   4,    5,   48,   49}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__16_8");
  needed_g_t[x_a][10] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__5_34__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__5_34__16_8");
  needed_g_t[x_a][11] = {   6,    7,    8,    9}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][12] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_32");
  needed_g_t[x_a][13] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__5_10__16_32");
  needed_g_t[x_a][14] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__32_16");
  needed_g_t[x_a][15] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__5_10__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__5_10__32_16");
  needed_g_t[x_a][16] = {  10,   11,   52,   53}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_20");
  needed_g_t[x_a][17] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__4_16");
  needed_g_t[x_a][18] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__33_10__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__33_10__4_16");
  needed_g_t[x_a][19] = {  12,   13,   14,   15,   28,   29,   30,   31,   54,   55,   62,   63,   70,   71,   78,   79}; //  16
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][20] = {  12,   13,   28,   29}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][21] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__4_8");
  needed_g_t[x_a][22] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__17_34__4_8");
  needed_g_t[x_a][23] = {  14,   15,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][24] = {  14}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__4_32");
  needed_g_t[x_a][25] = {  15}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__17_10__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__17_10__4_32");
  needed_g_t[x_a][26] = {  16,   17,   20,   21,   22,   23,   24,   25,   56,   57,   58,   59,   72,   73,   76,   77}; //  16
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][27] = {  16,   17,   58,   59}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_36");
  needed_g_t[x_a][28] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__32_4");
  needed_g_t[x_a][29] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__9_18__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__9_18__32_4");
  needed_g_t[x_a][30] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__8_4");
  needed_g_t[x_a][31] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__33_18__8_4");
  needed_g_t[x_a][32] = {  20,   21,   56,   57}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][33] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__16_4");
  needed_g_t[x_a][34] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__9_34__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__9_34__16_4");
  needed_g_t[x_a][35] = {  22,   23,   24,   25}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][36] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__16_32");
  needed_g_t[x_a][37] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__9_6__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__9_6__16_32");
  needed_g_t[x_a][38] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__32_16");
  needed_g_t[x_a][39] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__9_6__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__9_6__32_16");
  needed_g_t[x_a][40] = {  26,   27,   60,   61}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__4_24");
  needed_g_t[x_a][41] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__8_16");
  needed_g_t[x_a][42] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__33_6__8_16");
  needed_g_t[x_a][43] = {  28}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__8_4");
  needed_g_t[x_a][44] = {  29}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__17_34__8_4");
  needed_g_t[x_a][45] = {  30,   31,   62,   63}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");
  needed_g_t[x_a][46] = {  30}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__8_32");
  needed_g_t[x_a][47] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__17_6__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__17_6__8_32");
  needed_g_t[x_a][48] = {  32,   33,   40,   41}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][49] = {  34,   35,   42,   43}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][50] = {  36,   37,   38,   39}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][51] = {  44,   45,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");

  g_d[x_a].resize(12);
  needed_g_d[x_a].resize(12);
  needed_g_d[x_a][0] = {  32,   33,   66,   67}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][1] = {  32,   33,   44,   45,   48,   49,   60,   61,   64,   65,   66,   67}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][2] = {  34,   35,   70,   71}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][3] = {  34,   35,   46,   47,   50,   51,   62,   63,   68,   69,   70,   71}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][4] = {  36,   37,   72,   73}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][5] = {  36,   37,   40,   41,   52,   53,   56,   57,   72,   73,   74,   75}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][6] = {  38,   39,   76,   77}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {  38,   39,   42,   43,   54,   55,   58,   59,   76,   77,   78,   79}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {  40,   41,   74,   75}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][9] = {  42,   43,   78,   79}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {  44,   45,   64,   65}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][11] = {  46,   47,   68,   69}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");

  c_p[x_a].resize(80);
  c_f[x_a].resize(80);
  c_t[x_a].resize(80);
  c_d[x_a].resize(80);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1}; //   2
  c_t[x_a][1] = {  0,   1,   3}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  4,   5,   6}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  2,   3}; //   2
  c_t[x_a][3] = {  4,   5,   7}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  4,   5}; //   2
  c_t[x_a][4] = {  0,   8,   9}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  4,   5}; //   2
  c_t[x_a][5] = {  0,   8,  10}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  6,   7}; //   2
  c_t[x_a][6] = {  0,  11,  12}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  6,   7}; //   2
  c_t[x_a][7] = {  0,  11,  13}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  6,   7}; //   2
  c_t[x_a][8] = {  0,  11,  14}; //   3
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = {  6,   7}; //   2
  c_t[x_a][9] = {  0,  11,  15}; //   3
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = {  8,   9}; //   2
  c_t[x_a][10] = {  4,  16,  17}; //   3
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {  8,   9}; //   2
  c_t[x_a][11] = {  4,  16,  18}; //   3
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {}; //   0
  c_f[x_a][12] = {  2,  10}; //   2
  c_t[x_a][12] = { 19,  20,  21}; //   3
  c_d[x_a][12] = {}; //   0

  c_p[x_a][13] = {}; //   0
  c_f[x_a][13] = {  2,  10}; //   2
  c_t[x_a][13] = { 19,  20,  22}; //   3
  c_d[x_a][13] = {}; //   0

  c_p[x_a][14] = {}; //   0
  c_f[x_a][14] = { 11,  12}; //   2
  c_t[x_a][14] = { 19,  23,  24}; //   3
  c_d[x_a][14] = {}; //   0

  c_p[x_a][15] = {}; //   0
  c_f[x_a][15] = { 11,  12}; //   2
  c_t[x_a][15] = { 19,  23,  25}; //   3
  c_d[x_a][15] = {}; //   0

  c_p[x_a][16] = {}; //   0
  c_f[x_a][16] = { 11,  13}; //   2
  c_t[x_a][16] = { 26,  27,  28}; //   3
  c_d[x_a][16] = {}; //   0

  c_p[x_a][17] = {}; //   0
  c_f[x_a][17] = { 11,  13}; //   2
  c_t[x_a][17] = { 26,  27,  29}; //   3
  c_d[x_a][17] = {}; //   0

  c_p[x_a][18] = {}; //   0
  c_f[x_a][18] = {  2,   3}; //   2
  c_t[x_a][18] = {  4,   5,  30}; //   3
  c_d[x_a][18] = {}; //   0

  c_p[x_a][19] = {}; //   0
  c_f[x_a][19] = {  2,   3}; //   2
  c_t[x_a][19] = {  4,   5,  31}; //   3
  c_d[x_a][19] = {}; //   0

  c_p[x_a][20] = {}; //   0
  c_f[x_a][20] = {  8,  14}; //   2
  c_t[x_a][20] = { 26,  32,  33}; //   3
  c_d[x_a][20] = {}; //   0

  c_p[x_a][21] = {}; //   0
  c_f[x_a][21] = {  8,  14}; //   2
  c_t[x_a][21] = { 26,  32,  34}; //   3
  c_d[x_a][21] = {}; //   0

  c_p[x_a][22] = {}; //   0
  c_f[x_a][22] = {  6,  15}; //   2
  c_t[x_a][22] = { 26,  35,  36}; //   3
  c_d[x_a][22] = {}; //   0

  c_p[x_a][23] = {}; //   0
  c_f[x_a][23] = {  6,  15}; //   2
  c_t[x_a][23] = { 26,  35,  37}; //   3
  c_d[x_a][23] = {}; //   0

  c_p[x_a][24] = {}; //   0
  c_f[x_a][24] = {  6,  15}; //   2
  c_t[x_a][24] = { 26,  35,  38}; //   3
  c_d[x_a][24] = {}; //   0

  c_p[x_a][25] = {}; //   0
  c_f[x_a][25] = {  6,  15}; //   2
  c_t[x_a][25] = { 26,  35,  39}; //   3
  c_d[x_a][25] = {}; //   0

  c_p[x_a][26] = {}; //   0
  c_f[x_a][26] = {  4,  16}; //   2
  c_t[x_a][26] = {  4,  40,  41}; //   3
  c_d[x_a][26] = {}; //   0

  c_p[x_a][27] = {}; //   0
  c_f[x_a][27] = {  4,  16}; //   2
  c_t[x_a][27] = {  4,  40,  42}; //   3
  c_d[x_a][27] = {}; //   0

  c_p[x_a][28] = {}; //   0
  c_f[x_a][28] = {  2,  10}; //   2
  c_t[x_a][28] = { 19,  20,  43}; //   3
  c_d[x_a][28] = {}; //   0

  c_p[x_a][29] = {}; //   0
  c_f[x_a][29] = {  2,  10}; //   2
  c_t[x_a][29] = { 19,  20,  44}; //   3
  c_d[x_a][29] = {}; //   0

  c_p[x_a][30] = {}; //   0
  c_f[x_a][30] = {  0,  17}; //   2
  c_t[x_a][30] = { 19,  45,  46}; //   3
  c_d[x_a][30] = {}; //   0

  c_p[x_a][31] = {}; //   0
  c_f[x_a][31] = {  0,  17}; //   2
  c_t[x_a][31] = { 19,  45,  47}; //   3
  c_d[x_a][31] = {}; //   0

  c_p[x_a][32] = {  0,   1}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = { 48}; //   1
  c_d[x_a][32] = {  0,   1}; //   2

  c_p[x_a][33] = {  2,   1}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = { 48}; //   1
  c_d[x_a][33] = {  0,   1}; //   2

  c_p[x_a][34] = {  3,   4}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = { 49}; //   1
  c_d[x_a][34] = {  2,   3}; //   2

  c_p[x_a][35] = {  5,   4}; //   2
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = { 49}; //   1
  c_d[x_a][35] = {  2,   3}; //   2

  c_p[x_a][36] = {  6,   7}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = { 50}; //   1
  c_d[x_a][36] = {  4,   5}; //   2

  c_p[x_a][37] = {  8,   7}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = { 50}; //   1
  c_d[x_a][37] = {  4,   5}; //   2

  c_p[x_a][38] = {  9,  10}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 50}; //   1
  c_d[x_a][38] = {  6,   7}; //   2

  c_p[x_a][39] = { 11,  10}; //   2
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = { 50}; //   1
  c_d[x_a][39] = {  6,   7}; //   2

  c_p[x_a][40] = {  6,  12}; //   2
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = { 48}; //   1
  c_d[x_a][40] = {  8,   5}; //   2

  c_p[x_a][41] = {  8,  12}; //   2
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = { 48}; //   1
  c_d[x_a][41] = {  8,   5}; //   2

  c_p[x_a][42] = {  9,  13}; //   2
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 49}; //   1
  c_d[x_a][42] = {  9,   7}; //   2

  c_p[x_a][43] = { 11,  13}; //   2
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 49}; //   1
  c_d[x_a][43] = {  9,   7}; //   2

  c_p[x_a][44] = {  0,  14}; //   2
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = { 51}; //   1
  c_d[x_a][44] = { 10,   1}; //   2

  c_p[x_a][45] = {  2,  14}; //   2
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = { 51}; //   1
  c_d[x_a][45] = { 10,   1}; //   2

  c_p[x_a][46] = {  3,  15}; //   2
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 51}; //   1
  c_d[x_a][46] = { 11,   3}; //   2

  c_p[x_a][47] = {  5,  15}; //   2
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = { 51}; //   1
  c_d[x_a][47] = { 11,   3}; //   2

  c_p[x_a][48] = {  0}; //   1
  c_f[x_a][48] = {  5}; //   1
  c_t[x_a][48] = {  0,   8}; //   2
  c_d[x_a][48] = {  1}; //   1

  c_p[x_a][49] = {  2}; //   1
  c_f[x_a][49] = {  5}; //   1
  c_t[x_a][49] = {  0,   8}; //   2
  c_d[x_a][49] = {  1}; //   1

  c_p[x_a][50] = {  3}; //   1
  c_f[x_a][50] = {  1}; //   1
  c_t[x_a][50] = {  0,   1}; //   2
  c_d[x_a][50] = {  3}; //   1

  c_p[x_a][51] = {  5}; //   1
  c_f[x_a][51] = {  1}; //   1
  c_t[x_a][51] = {  0,   1}; //   2
  c_d[x_a][51] = {  3}; //   1

  c_p[x_a][52] = {  6}; //   1
  c_f[x_a][52] = {  9}; //   1
  c_t[x_a][52] = {  4,  16}; //   2
  c_d[x_a][52] = {  5}; //   1

  c_p[x_a][53] = {  8}; //   1
  c_f[x_a][53] = {  9}; //   1
  c_t[x_a][53] = {  4,  16}; //   2
  c_d[x_a][53] = {  5}; //   1

  c_p[x_a][54] = {  9}; //   1
  c_f[x_a][54] = { 12}; //   1
  c_t[x_a][54] = { 19,  23}; //   2
  c_d[x_a][54] = {  7}; //   1

  c_p[x_a][55] = { 11}; //   1
  c_f[x_a][55] = { 12}; //   1
  c_t[x_a][55] = { 19,  23}; //   2
  c_d[x_a][55] = {  7}; //   1

  c_p[x_a][56] = {  6}; //   1
  c_f[x_a][56] = { 14}; //   1
  c_t[x_a][56] = { 26,  32}; //   2
  c_d[x_a][56] = {  5}; //   1

  c_p[x_a][57] = {  8}; //   1
  c_f[x_a][57] = { 14}; //   1
  c_t[x_a][57] = { 26,  32}; //   2
  c_d[x_a][57] = {  5}; //   1

  c_p[x_a][58] = {  9}; //   1
  c_f[x_a][58] = { 13}; //   1
  c_t[x_a][58] = { 26,  27}; //   2
  c_d[x_a][58] = {  7}; //   1

  c_p[x_a][59] = { 11}; //   1
  c_f[x_a][59] = { 13}; //   1
  c_t[x_a][59] = { 26,  27}; //   2
  c_d[x_a][59] = {  7}; //   1

  c_p[x_a][60] = {  0}; //   1
  c_f[x_a][60] = { 16}; //   1
  c_t[x_a][60] = {  4,  40}; //   2
  c_d[x_a][60] = {  1}; //   1

  c_p[x_a][61] = {  2}; //   1
  c_f[x_a][61] = { 16}; //   1
  c_t[x_a][61] = {  4,  40}; //   2
  c_d[x_a][61] = {  1}; //   1

  c_p[x_a][62] = {  3}; //   1
  c_f[x_a][62] = { 17}; //   1
  c_t[x_a][62] = { 19,  45}; //   2
  c_d[x_a][62] = {  3}; //   1

  c_p[x_a][63] = {  5}; //   1
  c_f[x_a][63] = { 17}; //   1
  c_t[x_a][63] = { 19,  45}; //   2
  c_d[x_a][63] = {  3}; //   1

  c_p[x_a][64] = {  0,  14}; //   2
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  0}; //   1
  c_d[x_a][64] = { 10,   1}; //   2

  c_p[x_a][65] = {  2,  14}; //   2
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  0}; //   1
  c_d[x_a][65] = { 10,   1}; //   2

  c_p[x_a][66] = {  0,   1}; //   2
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  4}; //   1
  c_d[x_a][66] = {  0,   1}; //   2

  c_p[x_a][67] = {  2,   1}; //   2
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  4}; //   1
  c_d[x_a][67] = {  0,   1}; //   2

  c_p[x_a][68] = {  3,  15}; //   2
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  0}; //   1
  c_d[x_a][68] = { 11,   3}; //   2

  c_p[x_a][69] = {  5,  15}; //   2
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  0}; //   1
  c_d[x_a][69] = { 11,   3}; //   2

  c_p[x_a][70] = {  3,   4}; //   2
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = { 19}; //   1
  c_d[x_a][70] = {  2,   3}; //   2

  c_p[x_a][71] = {  5,   4}; //   2
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = { 19}; //   1
  c_d[x_a][71] = {  2,   3}; //   2

  c_p[x_a][72] = {  6,   7}; //   2
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = { 26}; //   1
  c_d[x_a][72] = {  4,   5}; //   2

  c_p[x_a][73] = {  8,   7}; //   2
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = { 26}; //   1
  c_d[x_a][73] = {  4,   5}; //   2

  c_p[x_a][74] = {  6,  12}; //   2
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {  4}; //   1
  c_d[x_a][74] = {  8,   5}; //   2

  c_p[x_a][75] = {  8,  12}; //   2
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {  4}; //   1
  c_d[x_a][75] = {  8,   5}; //   2

  c_p[x_a][76] = {  9,  10}; //   2
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = { 26}; //   1
  c_d[x_a][76] = {  6,   7}; //   2

  c_p[x_a][77] = { 11,  10}; //   2
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = { 26}; //   1
  c_d[x_a][77] = {  6,   7}; //   2

  c_p[x_a][78] = {  9,  13}; //   2
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = { 19}; //   1
  c_d[x_a][78] = {  9,   7}; //   2

  c_p[x_a][79] = { 11,  13}; //   2
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = { 19}; //   1
  c_d[x_a][79] = {  9,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_040_aa_ememepep
//  channel    0: 1111(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel    1: 1111(1, 2, 4, 32, 8, 16;   0,   0,  23)
//  channel    2: 1111(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    3: 1111(1, 2, 32, 4, 8, 16;   0,   0,  23)
//  channel    4: 1111(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel    5: 1111(1, 2, 4, 16, 8, 32;   0,   0,  23)
//  channel    6: 1111(1, 2, 4, 16, 32, 8;   0,   0,   0)
//  channel    7: 1111(1, 2, 4, 16, 32, 8;   0,   0,  23)
//  channel    8: 1111(1, 2, 4, 32, 16, 8;   0,   0,   0)
//  channel    9: 1111(1, 2, 4, 32, 16, 8;   0,   0,  23)
//  channel   10: 1111(1, 2, 32, 4, 16, 8;   0,   0,   0)
//  channel   11: 1111(1, 2, 32, 4, 16, 8;   0,   0,  23)
//  channel   12: 1111(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   13: 1111(1, 2, 16, 4, 8, 32;   0,   0,  23)
//  channel   14: 1111(1, 2, 16, 4, 32, 8;   0,   0,   0)
//  channel   15: 1111(1, 2, 16, 4, 32, 8;   0,   0,  23)
//  channel   16: 1111(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel   17: 1111(1, 2, 8, 32, 4, 16;   0,   0,  23)
//  channel   18: 1111(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   19: 1111(1, 2, 32, 8, 4, 16;   0,   0,  23)
//  channel   20: 1111(1, 2, 8, 16, 4, 32;   0,   0,   0)
//  channel   21: 1111(1, 2, 8, 16, 4, 32;   0,   0,  23)
//  channel   22: 1111(1, 2, 8, 16, 32, 4;   0,   0,   0)
//  channel   23: 1111(1, 2, 8, 16, 32, 4;   0,   0,  23)
//  channel   24: 1111(1, 2, 8, 32, 16, 4;   0,   0,   0)
//  channel   25: 1111(1, 2, 8, 32, 16, 4;   0,   0,  23)
//  channel   26: 1111(1, 2, 32, 8, 16, 4;   0,   0,   0)
//  channel   27: 1111(1, 2, 32, 8, 16, 4;   0,   0,  23)
//  channel   28: 1111(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   29: 1111(1, 2, 16, 8, 4, 32;   0,   0,  23)
//  channel   30: 1111(1, 2, 16, 8, 32, 4;   0,   0,   0)
//  channel   31: 1111(1, 2, 16, 8, 32, 4;   0,   0,  23)
//  channel   32: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   33: 3yv1(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel   34: 3yv1(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel   35: 3yv1(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel   36: 3yv1(1, 2, 32, 4, 16, 8;   0,   0,   0)
//  channel   37: 3yv1(1, 2, 32, 4, 16, 8;  23,   0,   0)
//  channel   38: 3yv1(1, 2, 16, 4, 32, 8;   0,   0,   0)
//  channel   39: 3yv1(1, 2, 16, 4, 32, 8;  23,   0,   0)
//  channel   40: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   41: 3yv1(1, 2, 8, 4, 16, 32;  23,   0,   0)
//  channel   42: 3yv1(1, 2, 8, 4, 32, 16;   0,   0,   0)
//  channel   43: 3yv1(1, 2, 8, 4, 32, 16;  23,   0,   0)
//  channel   44: 3yv1(1, 2, 32, 8, 16, 4;   0,   0,   0)
//  channel   45: 3yv1(1, 2, 32, 8, 16, 4;  23,   0,   0)
//  channel   46: 3yv1(1, 2, 16, 8, 32, 4;   0,   0,   0)
//  channel   47: 3yv1(1, 2, 16, 8, 32, 4;  23,   0,   0)
//  channel   48: 12v1(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   49: 12v1(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel   50: 12v1(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel   51: 12v1(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel   52: 12v1(1, 2, 32, 4, 16, 8;   0,   0,   0)
//  channel   53: 12v1(1, 2, 32, 4, 16, 8;  23,   0,   0)
//  channel   54: 12v1(1, 2, 16, 4, 32, 8;   0,   0,   0)
//  channel   55: 12v1(1, 2, 16, 4, 32, 8;  23,   0,   0)
//  channel   56: 12v1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   57: 12v1(1, 2, 8, 4, 16, 32;  23,   0,   0)
//  channel   58: 12v1(1, 2, 8, 4, 32, 16;   0,   0,   0)
//  channel   59: 12v1(1, 2, 8, 4, 32, 16;  23,   0,   0)
//  channel   60: 12v1(1, 2, 32, 8, 16, 4;   0,   0,   0)
//  channel   61: 12v1(1, 2, 32, 8, 16, 4;  23,   0,   0)
//  channel   62: 12v1(1, 2, 16, 8, 32, 4;   0,   0,   0)
//  channel   63: 12v1(1, 2, 16, 8, 32, 4;  23,   0,   0)
//  channel   64: 13yv(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel   65: 13yv(1, 2, 4, 32, 8, 16;  23,   0,   0)
//  channel   66: 13yv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   67: 13yv(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel   68: 13yv(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel   69: 13yv(1, 2, 4, 16, 8, 32;  23,   0,   0)
//  channel   70: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   71: 13yv(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   72: 13yv(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel   73: 13yv(1, 2, 8, 32, 4, 16;  23,   0,   0)
//  channel   74: 13yv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   75: 13yv(1, 2, 32, 8, 4, 16;  23,   0,   0)
//  channel   76: 13yv(1, 2, 8, 16, 4, 32;   0,   0,   0)
//  channel   77: 13yv(1, 2, 8, 16, 4, 32;  23,   0,   0)
//  channel   78: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   79: 13yv(1, 2, 16, 8, 4, 32;  23,   0,   0)
