#include "header.hpp"

#include "ppeeexnex04.phasespace.set.hpp"

void ppeeexnex04_phasespace_set::ax_psp_240_dsx_ememepvexusx(int x_a){
  static Logger logger("ppeeexnex04_phasespace_set::ax_psp_240_dsx_ememepvexusx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(33);
  needed_v_smin[x_a].resize(33);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    8,    9,   12,   13,   14,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47,   48,   49,   52,   53,   56,   57,   60,   61}; //  30
  needed_v_smin[x_a][  1] = {   0,   12}; //   2
  needed_v_smin[x_a][  2] = {   0,    3,   12,   15}; //   4
  needed_v_smin[x_a][  3] = {   1,    2,   13,   14}; //   4
  needed_v_smin[x_a][  4] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  needed_v_smin[x_a][  5] = {   3,   10,   11,   15,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45,   50,   51,   54,   55,   58,   59,   62,   63}; //  26
  needed_v_smin[x_a][  6] = {   3,   15}; //   2
  needed_v_smin[x_a][  7] = {   4,    5,    6,   10,   11,   16,   17,   18,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45,   50,   51,   54,   55,   58,   59,   62,   63}; //  30
  needed_v_smin[x_a][  8] = {   4,   16}; //   2
  needed_v_smin[x_a][  9] = {   4,    7,   16,   19}; //   4
  needed_v_smin[x_a][ 10] = {   5,    6,   17,   18}; //   4
  needed_v_smin[x_a][ 11] = {   7,    8,    9,   19,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47,   48,   49,   52,   53,   56,   57,   60,   61}; //  26
  needed_v_smin[x_a][ 12] = {   7,   19}; //   2
  needed_v_smin[x_a][ 13] = {   8,    9,   20,   21}; //   4
  needed_v_smin[x_a][ 14] = {  10,   11,   22,   23}; //   4
  needed_v_smin[x_a][ 15] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  24
  needed_v_smin[x_a][ 16] = {  24,   25,   40,   41,   32,   33}; //   6
  needed_v_smin[x_a][ 17] = {  24,   25,   32,   33,   40,   41}; //   6
  needed_v_smin[x_a][ 18] = {  26,   27,   42,   43,   58,   59,   62,   63,   34,   35}; //  10
  needed_v_smin[x_a][ 19] = {  26,   27,   34,   35,   42,   43}; //   6
  needed_v_smin[x_a][ 20] = {  28,   29,   44,   45,   36,   37}; //   6
  needed_v_smin[x_a][ 21] = {  28,   29,   36,   37,   44,   45}; //   6
  needed_v_smin[x_a][ 22] = {  30,   31,   46,   47,   56,   57,   60,   61,   38,   39}; //  10
  needed_v_smin[x_a][ 23] = {  30,   31,   38,   39,   46,   47}; //   6
  needed_v_smin[x_a][ 24] = {  48,   49,   56,   57}; //   4
  needed_v_smin[x_a][ 25] = {  50,   51,   58,   59}; //   4
  needed_v_smin[x_a][ 26] = {  48,   49}; //   2
  needed_v_smin[x_a][ 27] = {  50,   51}; //   2
  needed_v_smin[x_a][ 28] = {  52,   53,   54,   55}; //   4
  needed_v_smin[x_a][ 29] = {  52,   53}; //   2
  needed_v_smin[x_a][ 30] = {  54,   55}; //   2
  needed_v_smin[x_a][ 31] = {  60,   61}; //   2
  needed_v_smin[x_a][ 32] = {  62,   63}; //   2

  v_smax[x_a].resize(37);
  needed_v_smax[x_a].resize(37);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    8,    9,   12,   13,   14,   20,   21,   24,   25,   32,   33,   40,   41,   48,   49,   52,   53,   56,   57,   60,   61}; //  24
  needed_v_smax[x_a][  1] = {   0,    3,   12,   15}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  needed_v_smax[x_a][  3] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  needed_v_smax[x_a][  4] = {   3,   10,   11,   15,   22,   23,   26,   27,   34,   35,   42,   43}; //  12
  needed_v_smax[x_a][  5] = {   4,    5,    6,   16,   17,   18,   28,   29,   36,   37,   44,   45,   50,   51,   54,   55,   58,   59,   62,   63}; //  20
  needed_v_smax[x_a][  6] = {   4,    7,   16,   19}; //   4
  needed_v_smax[x_a][  7] = {   7,   19,   30,   31,   38,   39,   46,   47}; //   8
  needed_v_smax[x_a][  8] = {   8,    9,   20,   21,   32,   33,   52,   53,   60,   61}; //  10
  needed_v_smax[x_a][  9] = {  10,   11,   22,   23,   34,   35}; //   6
  needed_v_smax[x_a][ 10] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  48
  needed_v_smax[x_a][ 11] = {  24,   25,   40,   41}; //   4
  needed_v_smax[x_a][ 12] = {  24,   25,   40,   41}; //   4
  needed_v_smax[x_a][ 13] = {  26,   27,   42,   43}; //   4
  needed_v_smax[x_a][ 14] = {  26,   27,   42,   43}; //   4
  needed_v_smax[x_a][ 15] = {  28,   29,   44,   45}; //   4
  needed_v_smax[x_a][ 16] = {  28,   29,   44,   45}; //   4
  needed_v_smax[x_a][ 17] = {  30,   31,   46,   47}; //   4
  needed_v_smax[x_a][ 18] = {  30,   31,   46,   47}; //   4
  needed_v_smax[x_a][ 19] = {  36,   37,   54,   55,   62,   63}; //   6
  needed_v_smax[x_a][ 20] = {  38,   39}; //   2
  needed_v_smax[x_a][ 21] = {  48,   49,   56,   57}; //   4
  needed_v_smax[x_a][ 22] = {  48,   49,   56,   57}; //   4
  needed_v_smax[x_a][ 23] = {  50,   51,   58,   59}; //   4
  needed_v_smax[x_a][ 24] = {  50,   51,   58,   59}; //   4
  needed_v_smax[x_a][ 25] = {  56,   57}; //   2
  needed_v_smax[x_a][ 26] = {  58,   59}; //   2
  needed_v_smax[x_a][ 27] = {  60,   61,   38,   39}; //   4
  needed_v_smax[x_a][ 28] = {  62,   63,   34,   35}; //   4
  needed_v_smax[x_a][ 29] = {  32,   33}; //   2
  needed_v_smax[x_a][ 30] = {  36,   37}; //   2
  needed_v_smax[x_a][ 31] = {  48,   49,   52,   53}; //   4
  needed_v_smax[x_a][ 32] = {  50,   51,   54,   55}; //   4
  needed_v_smax[x_a][ 33] = {  52,   53}; //   2
  needed_v_smax[x_a][ 34] = {  54,   55}; //   2
  needed_v_smax[x_a][ 35] = {  60,   61}; //   2
  needed_v_smax[x_a][ 36] = {  62,   63}; //   2

  g_p[x_a].resize(46);
  needed_g_p[x_a].resize(46);
  needed_g_p[x_a][0] = {   0,    2,    9,   12,   14,   21,   25,   33,   41,   49,   53,   57,   61}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    3,   12,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    8,   13,   20,   24,   32,   40,   48,   52,   56,   60}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][4] = {   1,    2,   13,   14}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][6] = {   3,   10,   11,   15,   22,   23,   26,   27,   34,   35,   42,   43}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax1");
  needed_g_p[x_a][8] = {   4,    6,   16,   18,   29,   37,   45,   51,   55,   59,   63}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax5");
  needed_g_p[x_a][9] = {   4,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4,    7,   16,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][11] = {   5,   17,   28,   36,   44,   50,   54,   58,   62}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][12] = {   5,    6,   17,   18}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax3");
  needed_g_p[x_a][13] = {   7,   19,   30,   31,   38,   39,   46,   47}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax7");
  needed_g_p[x_a][14] = {   7,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax6");
  needed_g_p[x_a][15] = {   8,    9,   20,   21,   32,   33,   52,   53,   60,   61}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax8");
  needed_g_p[x_a][16] = {   8,    9,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax2");
  needed_g_p[x_a][17] = {  10,   22,   34}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax9");
  needed_g_p[x_a][18] = {  10,   11,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin14_smax2");
  needed_g_p[x_a][19] = {  11,   23,   35}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax9");
  needed_g_p[x_a][20] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax10");
  needed_g_p[x_a][21] = {  24,   25,   40,   41}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax11");
  needed_g_p[x_a][22] = {  24,   25,   40,   41}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax12");
  needed_g_p[x_a][23] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax10");
  needed_g_p[x_a][24] = {  26,   27,   42,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax13");
  needed_g_p[x_a][25] = {  26,   42}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax14");
  needed_g_p[x_a][26] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax10");
  needed_g_p[x_a][27] = {  27,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax14");
  needed_g_p[x_a][28] = {  28,   29,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax15");
  needed_g_p[x_a][29] = {  28,   29,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax16");
  needed_g_p[x_a][30] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax10");
  needed_g_p[x_a][31] = {  30,   31,   46,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax17");
  needed_g_p[x_a][32] = {  30,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax18");
  needed_g_p[x_a][33] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax10");
  needed_g_p[x_a][34] = {  31,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax18");
  needed_g_p[x_a][35] = {  36,   37,   54,   55,   62,   63}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax19");
  needed_g_p[x_a][36] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax20");
  needed_g_p[x_a][37] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax20");
  needed_g_p[x_a][38] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax21");
  needed_g_p[x_a][39] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax22");
  needed_g_p[x_a][40] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax23");
  needed_g_p[x_a][41] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax24");
  needed_g_p[x_a][42] = {  56,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax25");
  needed_g_p[x_a][43] = {  58,   59}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax26");
  needed_g_p[x_a][44] = {  60,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax27");
  needed_g_p[x_a][45] = {  62,   63}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax28");

  g_f[x_a].resize(17);
  needed_g_f[x_a].resize(17);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax10");
  needed_g_f[x_a][1] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax29");
  needed_g_f[x_a][2] = {  32,   33,   40,   41}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax10");
  needed_g_f[x_a][3] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax28");
  needed_g_f[x_a][4] = {  34,   35,   42,   43}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax10");
  needed_g_f[x_a][5] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax30");
  needed_g_f[x_a][6] = {  36,   37,   44,   45}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax10");
  needed_g_f[x_a][7] = {  38,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax27");
  needed_g_f[x_a][8] = {  38,   39,   46,   47}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax10");
  needed_g_f[x_a][9] = {  48,   49}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax31");
  needed_g_f[x_a][10] = {  50,   51}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax32");
  needed_g_f[x_a][11] = {  52,   53}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax33");
  needed_g_f[x_a][12] = {  52,   53}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax31");
  needed_g_f[x_a][13] = {  54,   55}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax34");
  needed_g_f[x_a][14] = {  54,   55}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax32");
  needed_g_f[x_a][15] = {  60,   61}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax35");
  needed_g_f[x_a][16] = {  62,   63}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin32_smax36");

  g_t[x_a].resize(24);
  needed_g_t[x_a].resize(24);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  48
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {  32,   33,   40,   41}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__36_88");
  needed_g_t[x_a][3] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_37__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_37__64_24");
  needed_g_t[x_a][4] = {  34,   35,   42,   43}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__20_104");
  needed_g_t[x_a][5] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_21__64_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_21__64_40");
  needed_g_t[x_a][6] = {  36,   37,   44,   45}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__40_84");
  needed_g_t[x_a][7] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_41__64_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_41__64_20");
  needed_g_t[x_a][8] = {  38,   39,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__24_100");
  needed_g_t[x_a][9] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_25__64_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_25__64_36");
  needed_g_t[x_a][10] = {  48,   49,   52,   53}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_216");
  needed_g_t[x_a][11] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__152_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__152_64");
  needed_g_t[x_a][12] = {  50,   51,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_212");
  needed_g_t[x_a][13] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__148_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__148_64");
  needed_g_t[x_a][14] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__24_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__24_192");
  needed_g_t[x_a][15] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__37_26__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__37_26__64_128");
  needed_g_t[x_a][16] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_192");
  needed_g_t[x_a][17] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__41_22__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__41_22__64_128");
  needed_g_t[x_a][18] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__100_152");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__100_152");
  needed_g_t[x_a][19] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__104_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__104_148");
  needed_g_t[x_a][20] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__24_228");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__24_228");
  needed_g_t[x_a][21] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_26__100_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_26__100_128");
  needed_g_t[x_a][22] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_232");
  needed_g_t[x_a][23] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_22__104_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_22__104_128");

  g_d[x_a].resize(26);
  needed_g_d[x_a].resize(26);
  needed_g_d[x_a][0] = {   0,    3,   12,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    8,    9,   12,   13,   14,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47,   48,   49,   52,   53,   56,   57,   60,   61}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   1,    2,    5,    6,   13,   14,   17,   18}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   1,    2,   13,   14}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][6] = {   3,   10,   11,   15,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45,   50,   51,   54,   55,   58,   59,   62,   63}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][7] = {   4,    7,   16,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][8] = {   4,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][9] = {   4,    5,    6,   10,   11,   16,   17,   18,   22,   23,   26,   27,   28,   29,   34,   35,   36,   37,   42,   43,   44,   45,   50,   51,   54,   55,   58,   59,   62,   63}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][10] = {   5,    6,   17,   18}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][11] = {   7,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][12] = {   7,    8,    9,   19,   20,   21,   24,   25,   30,   31,   32,   33,   38,   39,   40,   41,   46,   47,   48,   49,   52,   53,   56,   57,   60,   61}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][13] = {   8,    9,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][14] = {  10,   11,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][15] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][16] = {  24,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][17] = {  24,   25,   40,   41}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][18] = {  26,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][19] = {  26,   27,   42,   43,   58,   59,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][20] = {  28,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][21] = {  28,   29,   44,   45}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][22] = {  30,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");
  needed_g_d[x_a][23] = {  30,   31,   46,   47,   56,   57,   60,   61}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][24] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_152__128_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_152__128_24");
  needed_g_d[x_a][25] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  3,   4,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   2}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  0,   5,   6}; //   3

  c_p[x_a][4] = {  8,   9,  10}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  7,   8,   9}; //   3

  c_p[x_a][5] = { 11,  12,   5}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  3,  10,   9}; //   3

  c_p[x_a][6] = {  8,  12,   5}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = {  3,  10,   9}; //   3

  c_p[x_a][7] = { 13,  14,  10}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = {  7,  11,  12}; //   3

  c_p[x_a][8] = {  3,  15,  16}; //   3
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  0,   1}; //   2
  c_d[x_a][8] = { 13,  12,   2}; //   3

  c_p[x_a][9] = {  0,  15,  16}; //   3
  c_f[x_a][9] = {  0}; //   1
  c_t[x_a][9] = {  0,   1}; //   2
  c_d[x_a][9] = { 13,  12,   2}; //   3

  c_p[x_a][10] = {  6,  17,  18}; //   3
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = { 14,   9,   6}; //   3

  c_p[x_a][11] = {  6,  19,  18}; //   3
  c_f[x_a][11] = {  0}; //   1
  c_t[x_a][11] = {  0,   1}; //   2
  c_d[x_a][11] = { 14,   9,   6}; //   3

  c_p[x_a][12] = {  0,   1,   2,  20}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 15,   0,   1,   2}; //   4

  c_p[x_a][13] = {  3,   4,   5,  20}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 15,   3,   4,   2}; //   4

  c_p[x_a][14] = {  0,   4,   5,  20}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 15,   3,   4,   2}; //   4

  c_p[x_a][15] = {  6,   7,   2,  20}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 15,   0,   5,   6}; //   4

  c_p[x_a][16] = {  8,   9,  10,  20}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 15,   7,   8,   9}; //   4

  c_p[x_a][17] = { 11,  12,   5,  20}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 15,   3,  10,   9}; //   4

  c_p[x_a][18] = {  8,  12,   5,  20}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 15,   3,  10,   9}; //   4

  c_p[x_a][19] = { 13,  14,  10,  20}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 15,   7,  11,  12}; //   4

  c_p[x_a][20] = {  3,  15,  16,  20}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = { 15,  13,  12,   2}; //   4

  c_p[x_a][21] = {  0,  15,  16,  20}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = { 15,  13,  12,   2}; //   4

  c_p[x_a][22] = {  6,  17,  18,  20}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = { 15,  14,   9,   6}; //   4

  c_p[x_a][23] = {  6,  19,  18,  20}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = { 15,  14,   9,   6}; //   4

  c_p[x_a][24] = {  3,  21,  22,  23}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = { 16,  12,  17,   2}; //   4

  c_p[x_a][25] = {  0,  21,  22,  23}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = { 16,  12,  17,   2}; //   4

  c_p[x_a][26] = {  6,  24,  25,  26}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = { 18,   9,  19,   6}; //   4

  c_p[x_a][27] = {  6,  24,  27,  26}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = { 18,   9,  19,   6}; //   4

  c_p[x_a][28] = { 11,  28,  29,  30}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = { 20,   6,  21,   9}; //   4

  c_p[x_a][29] = {  8,  28,  29,  30}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = { 20,   6,  21,   9}; //   4

  c_p[x_a][30] = { 13,  31,  32,  33}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = { 22,   2,  23,  12}; //   4

  c_p[x_a][31] = { 13,  31,  34,  33}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = { 22,   2,  23,  12}; //   4

  c_p[x_a][32] = {  3,  15}; //   2
  c_f[x_a][32] = {  1,   2}; //   2
  c_t[x_a][32] = {  0,   2,   3}; //   3
  c_d[x_a][32] = { 12,   2}; //   2

  c_p[x_a][33] = {  0,  15}; //   2
  c_f[x_a][33] = {  1,   2}; //   2
  c_t[x_a][33] = {  0,   2,   3}; //   3
  c_d[x_a][33] = { 12,   2}; //   2

  c_p[x_a][34] = {  6,  17}; //   2
  c_f[x_a][34] = {  3,   4}; //   2
  c_t[x_a][34] = {  0,   4,   5}; //   3
  c_d[x_a][34] = {  9,   6}; //   2

  c_p[x_a][35] = {  6,  19}; //   2
  c_f[x_a][35] = {  3,   4}; //   2
  c_t[x_a][35] = {  0,   4,   5}; //   3
  c_d[x_a][35] = {  9,   6}; //   2

  c_p[x_a][36] = { 11,  35}; //   2
  c_f[x_a][36] = {  5,   6}; //   2
  c_t[x_a][36] = {  0,   6,   7}; //   3
  c_d[x_a][36] = {  6,   9}; //   2

  c_p[x_a][37] = {  8,  35}; //   2
  c_f[x_a][37] = {  5,   6}; //   2
  c_t[x_a][37] = {  0,   6,   7}; //   3
  c_d[x_a][37] = {  6,   9}; //   2

  c_p[x_a][38] = { 13,  36}; //   2
  c_f[x_a][38] = {  7,   8}; //   2
  c_t[x_a][38] = {  0,   8,   9}; //   3
  c_d[x_a][38] = {  2,  12}; //   2

  c_p[x_a][39] = { 13,  37}; //   2
  c_f[x_a][39] = {  7,   8}; //   2
  c_t[x_a][39] = {  0,   8,   9}; //   3
  c_d[x_a][39] = {  2,  12}; //   2

  c_p[x_a][40] = {  3,  21,  22}; //   3
  c_f[x_a][40] = {  2}; //   1
  c_t[x_a][40] = {  0,   2}; //   2
  c_d[x_a][40] = { 12,  17,   2}; //   3

  c_p[x_a][41] = {  0,  21,  22}; //   3
  c_f[x_a][41] = {  2}; //   1
  c_t[x_a][41] = {  0,   2}; //   2
  c_d[x_a][41] = { 12,  17,   2}; //   3

  c_p[x_a][42] = {  6,  24,  25}; //   3
  c_f[x_a][42] = {  4}; //   1
  c_t[x_a][42] = {  0,   4}; //   2
  c_d[x_a][42] = {  9,  19,   6}; //   3

  c_p[x_a][43] = {  6,  24,  27}; //   3
  c_f[x_a][43] = {  4}; //   1
  c_t[x_a][43] = {  0,   4}; //   2
  c_d[x_a][43] = {  9,  19,   6}; //   3

  c_p[x_a][44] = { 11,  28,  29}; //   3
  c_f[x_a][44] = {  6}; //   1
  c_t[x_a][44] = {  0,   6}; //   2
  c_d[x_a][44] = {  6,  21,   9}; //   3

  c_p[x_a][45] = {  8,  28,  29}; //   3
  c_f[x_a][45] = {  6}; //   1
  c_t[x_a][45] = {  0,   6}; //   2
  c_d[x_a][45] = {  6,  21,   9}; //   3

  c_p[x_a][46] = { 13,  31,  32}; //   3
  c_f[x_a][46] = {  8}; //   1
  c_t[x_a][46] = {  0,   8}; //   2
  c_d[x_a][46] = {  2,  23,  12}; //   3

  c_p[x_a][47] = { 13,  31,  34}; //   3
  c_f[x_a][47] = {  8}; //   1
  c_t[x_a][47] = {  0,   8}; //   2
  c_d[x_a][47] = {  2,  23,  12}; //   3

  c_p[x_a][48] = {  3,  38,  39}; //   3
  c_f[x_a][48] = {  9}; //   1
  c_t[x_a][48] = { 10,  11}; //   2
  c_d[x_a][48] = { 12,  24,   2}; //   3

  c_p[x_a][49] = {  0,  38,  39}; //   3
  c_f[x_a][49] = {  9}; //   1
  c_t[x_a][49] = { 10,  11}; //   2
  c_d[x_a][49] = { 12,  24,   2}; //   3

  c_p[x_a][50] = { 11,  40,  41}; //   3
  c_f[x_a][50] = { 10}; //   1
  c_t[x_a][50] = { 12,  13}; //   2
  c_d[x_a][50] = {  6,  25,   9}; //   3

  c_p[x_a][51] = {  8,  40,  41}; //   3
  c_f[x_a][51] = { 10}; //   1
  c_t[x_a][51] = { 12,  13}; //   2
  c_d[x_a][51] = {  6,  25,   9}; //   3

  c_p[x_a][52] = {  3,  15}; //   2
  c_f[x_a][52] = { 11,  12}; //   2
  c_t[x_a][52] = { 10,  14,  15}; //   3
  c_d[x_a][52] = { 12,   2}; //   2

  c_p[x_a][53] = {  0,  15}; //   2
  c_f[x_a][53] = { 11,  12}; //   2
  c_t[x_a][53] = { 10,  14,  15}; //   3
  c_d[x_a][53] = { 12,   2}; //   2

  c_p[x_a][54] = { 11,  35}; //   2
  c_f[x_a][54] = { 13,  14}; //   2
  c_t[x_a][54] = { 12,  16,  17}; //   3
  c_d[x_a][54] = {  6,   9}; //   2

  c_p[x_a][55] = {  8,  35}; //   2
  c_f[x_a][55] = { 13,  14}; //   2
  c_t[x_a][55] = { 12,  16,  17}; //   3
  c_d[x_a][55] = {  6,   9}; //   2

  c_p[x_a][56] = {  3,  38,  39,  42}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = { 18}; //   1
  c_d[x_a][56] = { 23,  12,  24,   2}; //   4

  c_p[x_a][57] = {  0,  38,  39,  42}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = { 18}; //   1
  c_d[x_a][57] = { 23,  12,  24,   2}; //   4

  c_p[x_a][58] = { 11,  40,  41,  43}; //   4
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = { 19}; //   1
  c_d[x_a][58] = { 19,   6,  25,   9}; //   4

  c_p[x_a][59] = {  8,  40,  41,  43}; //   4
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = { 19}; //   1
  c_d[x_a][59] = { 19,   6,  25,   9}; //   4

  c_p[x_a][60] = {  3,  15,  44}; //   3
  c_f[x_a][60] = { 15}; //   1
  c_t[x_a][60] = { 20,  21}; //   2
  c_d[x_a][60] = { 23,  12,   2}; //   3

  c_p[x_a][61] = {  0,  15,  44}; //   3
  c_f[x_a][61] = { 15}; //   1
  c_t[x_a][61] = { 20,  21}; //   2
  c_d[x_a][61] = { 23,  12,   2}; //   3

  c_p[x_a][62] = { 11,  35,  45}; //   3
  c_f[x_a][62] = { 16}; //   1
  c_t[x_a][62] = { 22,  23}; //   2
  c_d[x_a][62] = { 19,   6,   9}; //   3

  c_p[x_a][63] = {  8,  35,  45}; //   3
  c_f[x_a][63] = { 16}; //   1
  c_t[x_a][63] = { 22,  23}; //   2
  c_d[x_a][63] = { 19,   6,   9}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_dsx_ememepvexusx
//  channel    0: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  23,   0,  24,   0,   0)
//  channel    1: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;   0,   0,  24,   0,   0)
//  channel    2: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;  23,   0,  24,   0,   0)
//  channel    3: 4yyv11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,  24,   0,   0)
//  channel    4: 4yyv11(1, 2, 8, 32, 4, 16, 64, 128;  23,   0,  24,   0,   0)
//  channel    5: 4yyv11(1, 2, 32, 8, 4, 16, 64, 128;   0,   0,  24,   0,   0)
//  channel    6: 4yyv11(1, 2, 32, 8, 4, 16, 64, 128;  23,   0,  24,   0,   0)
//  channel    7: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,  24,   0,   0)
//  channel    8: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   0,   0)
//  channel    9: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  23,  24,  24,   0,   0)
//  channel   10: 42vv11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,  24,   0,   0)
//  channel   11: 42vv11(1, 2, 4, 16, 8, 32, 64, 128;  24,  23,  24,   0,   0)
//  channel   12: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  23,   0,  24,   0,   0)
//  channel   13: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;   0,   0,  24,   0,   0)
//  channel   14: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;  23,   0,  24,   0,   0)
//  channel   15: 5yyyv1(1, 2, 64, 4, 16, 8, 32, 128;  24,   0,  24,   0,   0)
//  channel   16: 5yyyv1(1, 2, 64, 8, 32, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel   17: 5yyyv1(1, 2, 64, 32, 8, 4, 16, 128;   0,   0,  24,   0,   0)
//  channel   18: 5yyyv1(1, 2, 64, 32, 8, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel   19: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  24,   0,   0)
//  channel   20: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;   0,  24,  24,   0,   0)
//  channel   21: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  23,  24,  24,   0,   0)
//  channel   22: 5y2vv1(1, 2, 64, 4, 16, 8, 32, 128;  24,   0,  24,   0,   0)
//  channel   23: 5y2vv1(1, 2, 64, 4, 16, 8, 32, 128;  24,  23,  24,   0,   0)
//  channel   24: 52vyv1(1, 2, 4, 32, 64, 8, 16, 128;   0,   0,  24,   0,   0)
//  channel   25: 52vyv1(1, 2, 4, 32, 64, 8, 16, 128;  23,   0,  24,   0,   0)
//  channel   26: 52vyv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,   0,   0,   0)
//  channel   27: 52vyv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,  23,   0,   0)
//  channel   28: 52vyv1(1, 2, 8, 32, 64, 4, 16, 128;   0,   0,  24,   0,   0)
//  channel   29: 52vyv1(1, 2, 8, 32, 64, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel   30: 52vyv1(1, 2, 8, 16, 64, 4, 32, 128;  24,   0,   0,   0,   0)
//  channel   31: 52vyv1(1, 2, 8, 16, 64, 4, 32, 128;  24,   0,  23,   0,   0)
//  channel   32: 2v2v11(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,   0,   0)
//  channel   33: 2v2v11(1, 2, 4, 32, 8, 16, 64, 128;  23,  24,   0,   0,   0)
//  channel   34: 2v2v11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,   0,   0,   0)
//  channel   35: 2v2v11(1, 2, 4, 16, 8, 32, 64, 128;  24,  23,   0,   0,   0)
//  channel   36: 2v2v11(1, 2, 8, 32, 4, 16, 64, 128;   0,  24,   0,   0,   0)
//  channel   37: 2v2v11(1, 2, 8, 32, 4, 16, 64, 128;  23,  24,   0,   0,   0)
//  channel   38: 2v2v11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,   0,   0,   0)
//  channel   39: 2v2v11(1, 2, 8, 16, 4, 32, 64, 128;  24,  23,   0,   0,   0)
//  channel   40: 2v3yv1(1, 2, 4, 32, 64, 8, 16, 128;   0,   0,  24,   0,   0)
//  channel   41: 2v3yv1(1, 2, 4, 32, 64, 8, 16, 128;  23,   0,  24,   0,   0)
//  channel   42: 2v3yv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,   0,   0,   0)
//  channel   43: 2v3yv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,  23,   0,   0)
//  channel   44: 2v3yv1(1, 2, 8, 32, 64, 4, 16, 128;   0,   0,  24,   0,   0)
//  channel   45: 2v3yv1(1, 2, 8, 32, 64, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel   46: 2v3yv1(1, 2, 8, 16, 64, 4, 32, 128;  24,   0,   0,   0,   0)
//  channel   47: 2v3yv1(1, 2, 8, 16, 64, 4, 32, 128;  24,   0,  23,   0,   0)
//  channel   48: 2v13yv(1, 2, 4, 32, 64, 128, 8, 16;   0,   0,  24,   0,   0)
//  channel   49: 2v13yv(1, 2, 4, 32, 64, 128, 8, 16;  23,   0,  24,   0,   0)
//  channel   50: 2v13yv(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   51: 2v13yv(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   52: 2v112v(1, 2, 4, 32, 64, 128, 8, 16;   0,  24,   0,   0,   0)
//  channel   53: 2v112v(1, 2, 4, 32, 64, 128, 8, 16;  23,  24,   0,   0,   0)
//  channel   54: 2v112v(1, 2, 8, 32, 64, 128, 4, 16;   0,  24,   0,   0,   0)
//  channel   55: 2v112v(1, 2, 8, 32, 64, 128, 4, 16;  23,  24,   0,   0,   0)
//  channel   56: 3yv3yv(1, 2, 64, 4, 32, 128, 8, 16;   0,   0,  24,   0,   0)
//  channel   57: 3yv3yv(1, 2, 64, 4, 32, 128, 8, 16;  23,   0,  24,   0,   0)
//  channel   58: 3yv3yv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   59: 3yv3yv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   60: 3yv12v(1, 2, 64, 4, 32, 128, 8, 16;   0,  24,   0,   0,   0)
//  channel   61: 3yv12v(1, 2, 64, 4, 32, 128, 8, 16;  23,  24,   0,   0,   0)
//  channel   62: 3yv12v(1, 2, 64, 8, 32, 128, 4, 16;   0,  24,   0,   0,   0)
//  channel   63: 3yv12v(1, 2, 64, 8, 32, 128, 4, 16;  23,  24,   0,   0,   0)
