#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ag_psp_130_gb_emepab(int x_a, int zero){
  static Logger logger("ppeexa03_phasespace_set::ag_psp_130_gb_emepab");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (xbp_all[x_a][12] == nullvector){xbp_all[x_a][12] = xbp_all[x_a][4] + xbp_all[x_a][8];}
  if (xbs_all[x_a][12] == 0.){xbs_all[x_a][12] = xbp_all[x_a][12].m2();}
  if (xbs_all[x_a][12] < 0.){xbs_all[x_a][12] = 0.;}
  if (xbsqrts_all[x_a][12] == 0.){xbsqrts_all[x_a][12] = sqrt(xbs_all[x_a][12]);}
  if (xbp_all[x_a][18] == nullvector){xbp_all[x_a][18] = xbp_all[x_a][2] - xbp_all[x_a][16];}
  if (xbs_all[x_a][18] == 0.){xbs_all[x_a][18] = xbp_all[x_a][18].m2();}
  if (xbs_all[x_a][18] > 0.){xbs_all[x_a][18] = 0.;}
  if (xbp_all[x_a][20] == nullvector){xbp_all[x_a][20] = xbp_all[x_a][4] + xbp_all[x_a][16];}
  if (xbs_all[x_a][20] == 0.){xbs_all[x_a][20] = xbp_all[x_a][20].m2();}
  if (xbs_all[x_a][20] < 0.){xbs_all[x_a][20] = 0.;}
  if (xbsqrts_all[x_a][20] == 0.){xbsqrts_all[x_a][20] = sqrt(xbs_all[x_a][20]);}
  if (xbp_all[x_a][24] == nullvector){xbp_all[x_a][24] = xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][24] == 0.){xbs_all[x_a][24] = xbp_all[x_a][24].m2();}
  if (xbs_all[x_a][24] < 0.){xbs_all[x_a][24] = 0.;}
  if (xbsqrts_all[x_a][24] == 0.){xbsqrts_all[x_a][24] = sqrt(xbs_all[x_a][24]);}
  if (xbp_all[x_a][33] == nullvector){xbp_all[x_a][33] = xbp_all[x_a][1] - xbp_all[x_a][32];}
  if (xbs_all[x_a][33] == 0.){xbs_all[x_a][33] = xbp_all[x_a][33].m2();}
  if (xbs_all[x_a][33] > 0.){xbs_all[x_a][33] = 0.;}
  if (xbp_all[x_a][48] == nullvector){xbp_all[x_a][48] = xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][48] == 0.){xbs_all[x_a][48] = xbp_all[x_a][48].m2();}
  if (xbs_all[x_a][48] < 0.){xbs_all[x_a][48] = 0.;}
  if (xbsqrts_all[x_a][48] == 0.){xbsqrts_all[x_a][48] = sqrt(xbs_all[x_a][48]);}
  if (xbp_all[x_a][14] == nullvector){xbp_all[x_a][14] = xbp_all[x_a][2] - xbp_all[x_a][4] - xbp_all[x_a][8];}
  if (xbs_all[x_a][14] == 0.){xbs_all[x_a][14] = xbp_all[x_a][14].m2();}
  if (xbs_all[x_a][14] > 0.){xbs_all[x_a][14] = 0.;}
  if (xbp_all[x_a][28] == nullvector){xbp_all[x_a][28] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][28] == 0.){xbs_all[x_a][28] = xbp_all[x_a][28].m2();}
  if (xbs_all[x_a][28] < 0.){xbs_all[x_a][28] = 0.;}
  if (xbp_all[x_a][44] == nullvector){xbp_all[x_a][44] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][32];}
  if (xbs_all[x_a][44] == 0.){xbs_all[x_a][44] = xbp_all[x_a][44].m2();}
  if (xbs_all[x_a][44] < 0.){xbs_all[x_a][44] = 0.;}
  if (xbp_all[x_a][49] == nullvector){xbp_all[x_a][49] = xbp_all[x_a][1] - xbp_all[x_a][16] - xbp_all[x_a][32];}
  if (xbs_all[x_a][49] == 0.){xbs_all[x_a][49] = xbp_all[x_a][49].m2();}
  if (xbs_all[x_a][49] > 0.){xbs_all[x_a][49] = 0.;}
  if (xbp_all[x_a][60] == nullvector){xbp_all[x_a][60] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][60] == 0.){xbs_all[x_a][60] = xbp_all[x_a][60].m2();}
  if (xbs_all[x_a][60] < 0.){xbs_all[x_a][60] = 0.;}

  v_smin[x_a][  0] = smin_opt[x_a][12]; // 12 times
  v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]); // 4 times
  v_smin[x_a][  2] = smin_opt[x_a][24]; // 4 times
  v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][28]); // 4 times
  v_smin[x_a][  4] = smin_opt[x_a][20]; // 4 times
  v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]); // 4 times
  v_smin[x_a][  6] = smin_opt[x_a][48]; // 4 times
  v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]); // 4 times

  v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2); // 10 times
  v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2); // 4 times
  v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2); // 4 times
  v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2); // 12 times
  v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2); // 4 times
  v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2); // 2 times
  v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2); // 2 times
  v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2); // 2 times

  //  vector<double> g_p(13);
  {g_p[x_a][  0] = g_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 5 times
  {g_p[x_a][  1] = g_propagator(x_a,   0,  44, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 3 */} // 4 times
  {g_p[x_a][  2] = g_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 5 times
  {g_p[x_a][  3] = g_propagator(x_a,   0,  24, v_smin[x_a][  2], v_smax[x_a][  2]); /* npp 2 */} // 4 times
  {g_p[x_a][  4] = g_propagator(x_a,   0,  28, v_smin[x_a][  3], v_smax[x_a][  3]); /* npp 3 */} // 2 times
  {g_p[x_a][  5] = g_propagator(x_a,  23,  28, v_smin[x_a][  3], v_smax[x_a][  3]); /* npp 3 */} // 2 times
  {g_p[x_a][  6] = g_propagator(x_a,   0,  20, v_smin[x_a][  4], v_smax[x_a][  4]); /* npp 2 */} // 4 times
  {g_p[x_a][  7] = g_propagator(x_a,   0,  28, v_smin[x_a][  5], v_smax[x_a][  3]); /* npp 3 */} // 2 times
  {g_p[x_a][  8] = g_propagator(x_a,  23,  28, v_smin[x_a][  5], v_smax[x_a][  3]); /* npp 3 */} // 2 times
  {g_p[x_a][  9] = g_propagator(x_a,   0,  48, v_smin[x_a][  6], v_smax[x_a][  5]); /* npp 2 */} // 2 times
  {g_p[x_a][ 10] = g_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  6]); /* npp 2 */} // 1 times
  {g_p[x_a][ 11] = g_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  6]); /* npp 2 */} // 1 times
  {g_p[x_a][ 12] = g_propagator(x_a,   0,  48, v_smin[x_a][  6], v_smax[x_a][  7]); /* npp 2 */} // 2 times

  //  vector<double> g_f(1);
  {g_f[x_a][  0] = g_timelikeinvariant(v_smin[x_a][  7], v_smax[x_a][  3]); /* nfp 3 */} // 4 times

  //  vector<double> g_t(5);
  {g_t[x_a][  0] = g_tchannel_opt(x_a,   0,  60,   2,   1,  16,  44); /* ntp 0 */} // 2 times
  {g_t[x_a][  1] = g_tchannel_opt(x_a,   0,  60,   1,   2,  32,  28); /* ntp 0 */} // 8 times
  {g_t[x_a][  2] = g_tchannel_opt(x_a,   0,  28,   2,  33,  16,  12); /* ntp 1 */} // 2 times
  {g_t[x_a][  3] = g_tchannel_opt(x_a,   0,  28,   2,  33,  12,  16); /* ntp 1 */} // 2 times
  {g_t[x_a][  4] = g_tchannel_opt(x_a,   0,  60,   1,   2,  48,  12); /* ntp 0 */} // 2 times

  //  vector<double> g_d(10);
  {g_d[x_a][  0] = g_decay(x_a,  44,  32,  12); /* ndp 3 */} // 4 times
  {g_d[x_a][  1] = g_decay(x_a,  12,   4,   8); /* ndp 2 */} // 12 times
  {g_d[x_a][  2] = g_decay(x_a,  60,  32,  28); /* ndp 4 */} // 4 times
  {g_d[x_a][  3] = g_decay(x_a,  28,   4,  24); /* ndp 3 */} // 4 times
  {g_d[x_a][  4] = g_decay(x_a,  24,   8,  16); /* ndp 2 */} // 4 times
  {g_d[x_a][  5] = g_decay(x_a,  60,  16,  44); /* ndp 4 */} // 2 times
  {g_d[x_a][  6] = g_decay(x_a,  28,   8,  20); /* ndp 3 */} // 4 times
  {g_d[x_a][  7] = g_decay(x_a,  20,   4,  16); /* ndp 2 */} // 4 times
  {g_d[x_a][  8] = g_decay(x_a,  60,  12,  48); /* ndp 4 */} // 2 times
  {g_d[x_a][  9] = g_decay(x_a,  48,  16,  32); /* ndp 2 */} // 4 times

  if (switch_IS_mode_phasespace == 2 || switch_IS_mode_phasespace == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(6);
    inv_r[0].resize(13);
    inv_r[1].resize(1);
    inv_r[2].resize(5);
    inv_r[3].resize(5);
    inv_r[4].resize(10);
    inv_r[5].resize(10);

    {inv_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][0]);} // 5 times
    {inv_propagator(x_a,   0,  44, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][1]);} // 4 times
    {inv_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][2]);} // 5 times
    {inv_propagator(x_a,   0,  24, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[0][3]);} // 4 times
    {inv_propagator(x_a,   0,  28, v_smin[x_a][  3], v_smax[x_a][  3], inv_r[0][4]);} // 2 times
    {inv_propagator(x_a,  23,  28, v_smin[x_a][  3], v_smax[x_a][  3], inv_r[0][5]);} // 2 times
    {inv_propagator(x_a,   0,  20, v_smin[x_a][  4], v_smax[x_a][  4], inv_r[0][6]);} // 4 times
    {inv_propagator(x_a,   0,  28, v_smin[x_a][  5], v_smax[x_a][  3], inv_r[0][7]);} // 2 times
    {inv_propagator(x_a,  23,  28, v_smin[x_a][  5], v_smax[x_a][  3], inv_r[0][8]);} // 2 times
    {inv_propagator(x_a,   0,  48, v_smin[x_a][  6], v_smax[x_a][  5], inv_r[0][9]);} // 2 times
    {inv_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  6], inv_r[0][10]);} // 1 times
    {inv_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  6], inv_r[0][11]);} // 1 times
    {inv_propagator(x_a,   0,  48, v_smin[x_a][  6], v_smax[x_a][  7], inv_r[0][12]);} // 2 times

    {inv_timelikeinvariant(x_a,  28, v_smin[x_a][  7], v_smax[x_a][  3], inv_r[1][0]);} // 4 times

    {inv_tchannel_opt(x_a,   0,  60,   2,   1,  16,  44, inv_r[2][0], inv_r[3][0]);} // 2 times
    {inv_tchannel_opt(x_a,   0,  60,   1,   2,  32,  28, inv_r[2][1], inv_r[3][1]);} // 8 times
    {inv_tchannel_opt(x_a,   0,  28,   2,  33,  16,  12, inv_r[2][2], inv_r[3][2]);} // 2 times
    {inv_tchannel_opt(x_a,   0,  28,   2,  33,  12,  16, inv_r[2][3], inv_r[3][3]);} // 2 times
    {inv_tchannel_opt(x_a,   0,  60,   1,   2,  48,  12, inv_r[2][4], inv_r[3][4]);} // 2 times

    {inv_decay(x_a,  44,  32,  12, inv_r[4][0], inv_r[5][0]);} // 4 times
    {inv_decay(x_a,  12,   4,   8, inv_r[4][1], inv_r[5][1]);} // 12 times
    {inv_decay(x_a,  60,  32,  28, inv_r[4][2], inv_r[5][2]);} // 4 times
    {inv_decay(x_a,  28,   4,  24, inv_r[4][3], inv_r[5][3]);} // 4 times
    {inv_decay(x_a,  24,   8,  16, inv_r[4][4], inv_r[5][4]);} // 4 times
    {inv_decay(x_a,  60,  16,  44, inv_r[4][5], inv_r[5][5]);} // 2 times
    {inv_decay(x_a,  28,   8,  20, inv_r[4][6], inv_r[5][6]);} // 4 times
    {inv_decay(x_a,  20,   4,  16, inv_r[4][7], inv_r[5][7]);} // 4 times
    {inv_decay(x_a,  60,  12,  48, inv_r[4][8], inv_r[5][8]);} // 2 times
    {inv_decay(x_a,  48,  16,  32, inv_r[4][9], inv_r[5][9]);} // 4 times

    if (switch_IS_mode_phasespace == 2){
      vector<vector<double> > inv_channel_r(20, vector<double> (8));
      vector<double> g_IS(20, 1.);
      for (int i_c = 0; i_c < 20; i_c++){
        if (MC_phasespace.alpha[zero + i_c] == 0.){continue;}
        int ran = 0;
        for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){
          inv_channel_r[i_c][ran++] = inv_r[0][c_p[x_a][i_c][i_p]];
        }
        for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){
          inv_channel_r[i_c][ran++] = inv_r[1][c_f[x_a][i_c][i_f]];
        }
        for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t]];
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t] + 1];
        }
        for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d]];
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d] + 1];
        }
        for (int i_r = 0; i_r < 8; i_r++){
          random_psp[(zero + i_c) * no_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
          g_IS[i_c] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_IS[  0] * g_p[x_a][  0] * g_p[x_a][  1] * g_t[x_a][  0] * g_d[x_a][  0] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_IS[  1] * g_p[x_a][  2] * g_p[x_a][  1] * g_t[x_a][  0] * g_d[x_a][  0] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_IS[  2] * g_p[x_a][  3] * g_p[x_a][  4] * g_d[x_a][  2] * g_d[x_a][  3] * g_d[x_a][  4];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_IS[  3] * g_p[x_a][  3] * g_p[x_a][  5] * g_d[x_a][  2] * g_d[x_a][  3] * g_d[x_a][  4];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_IS[  4] * g_p[x_a][  0] * g_p[x_a][  1] * g_d[x_a][  5] * g_d[x_a][  0] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_IS[  5] * g_p[x_a][  2] * g_p[x_a][  1] * g_d[x_a][  5] * g_d[x_a][  0] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_IS[  6] * g_p[x_a][  6] * g_p[x_a][  7] * g_d[x_a][  2] * g_d[x_a][  6] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_IS[  7] * g_p[x_a][  6] * g_p[x_a][  8] * g_d[x_a][  2] * g_d[x_a][  6] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_IS[  8] * g_p[x_a][  9] * g_p[x_a][ 10] * g_d[x_a][  8] * g_d[x_a][  1] * g_d[x_a][  9];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_IS[  9] * g_p[x_a][  9] * g_p[x_a][ 11] * g_d[x_a][  8] * g_d[x_a][  1] * g_d[x_a][  9];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_IS[ 10] * g_p[x_a][  0] * g_f[x_a][  0] * g_t[x_a][  1] * g_t[x_a][  2] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_IS[ 11] * g_p[x_a][  2] * g_f[x_a][  0] * g_t[x_a][  1] * g_t[x_a][  2] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_IS[ 12] * g_p[x_a][  3] * g_p[x_a][  4] * g_t[x_a][  1] * g_d[x_a][  3] * g_d[x_a][  4];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_IS[ 13] * g_p[x_a][  3] * g_p[x_a][  5] * g_t[x_a][  1] * g_d[x_a][  3] * g_d[x_a][  4];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_IS[ 14] * g_p[x_a][  6] * g_p[x_a][  7] * g_t[x_a][  1] * g_d[x_a][  6] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_IS[ 15] * g_p[x_a][  6] * g_p[x_a][  8] * g_t[x_a][  1] * g_d[x_a][  6] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_IS[ 16] * g_p[x_a][  0] * g_f[x_a][  0] * g_t[x_a][  1] * g_t[x_a][  3] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_IS[ 17] * g_p[x_a][  2] * g_f[x_a][  0] * g_t[x_a][  1] * g_t[x_a][  3] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_IS[ 18] * g_p[x_a][  0] * g_p[x_a][ 12] * g_t[x_a][  4] * g_d[x_a][  9] * g_d[x_a][  1];}
      if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_IS[ 19] * g_p[x_a][  2] * g_p[x_a][ 12] * g_t[x_a][  4] * g_d[x_a][  9] * g_d[x_a][  1];}
    }
    else if (switch_IS_mode_phasespace == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(13, 1.);
      g_IS[1].resize(1, 1.);
      g_IS[2].resize(5, 1.);
      g_IS[3].resize(10, 1.);

      for (int i_t = 0; i_t < 6; i_t++){
        for (int i_i = 0; i_i < inv_r[i_t].size(); i_i++){
          random_psp[map_type_to_list_MC_IS[vector<int> {x_a, i_t, i_i}]]->get_g_IS(inv_r[i_t][i_i], g_IS_temp);
          int i_g = i_t;
          if (i_t > 2){i_g = i_t / 2 + 1;}
          g_IS[i_g][i_i] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  3] * g_IS[0][  3] * g_p[x_a][  4] * g_IS[0][  4] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  4] * g_IS[3][  4];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  3] * g_IS[0][  3] * g_p[x_a][  5] * g_IS[0][  5] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  4] * g_IS[3][  4];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  1] * g_IS[0][  1] * g_d[x_a][  5] * g_IS[3][  5] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][  7] * g_IS[0][  7] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  6] * g_IS[3][  6] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][  8] * g_IS[0][  8] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  6] * g_IS[3][  6] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_p[x_a][  9] * g_IS[0][  9] * g_p[x_a][ 10] * g_IS[0][ 10] * g_d[x_a][  8] * g_IS[3][  8] * g_d[x_a][  1] * g_IS[3][  1] * g_d[x_a][  9] * g_IS[3][  9];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_p[x_a][  9] * g_IS[0][  9] * g_p[x_a][ 11] * g_IS[0][ 11] * g_d[x_a][  8] * g_IS[3][  8] * g_d[x_a][  1] * g_IS[3][  1] * g_d[x_a][  9] * g_IS[3][  9];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_p[x_a][  0] * g_IS[0][  0] * g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  1] * g_IS[2][  1] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_p[x_a][  2] * g_IS[0][  2] * g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  1] * g_IS[2][  1] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_p[x_a][  3] * g_IS[0][  3] * g_p[x_a][  4] * g_IS[0][  4] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  4] * g_IS[3][  4];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_p[x_a][  3] * g_IS[0][  3] * g_p[x_a][  5] * g_IS[0][  5] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  4] * g_IS[3][  4];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][  7] * g_IS[0][  7] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  6] * g_IS[3][  6] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_p[x_a][  6] * g_IS[0][  6] * g_p[x_a][  8] * g_IS[0][  8] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  6] * g_IS[3][  6] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_p[x_a][  0] * g_IS[0][  0] * g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  1] * g_IS[2][  1] * g_t[x_a][  3] * g_IS[2][  3] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_p[x_a][  2] * g_IS[0][  2] * g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  1] * g_IS[2][  1] * g_t[x_a][  3] * g_IS[2][  3] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][ 12] * g_IS[0][ 12] * g_t[x_a][  4] * g_IS[2][  4] * g_d[x_a][  9] * g_IS[3][  9] * g_d[x_a][  1] * g_IS[3][  1];}
      if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][ 12] * g_IS[0][ 12] * g_t[x_a][  4] * g_IS[2][  4] * g_d[x_a][  9] * g_IS[3][  9] * g_d[x_a][  1] * g_IS[3][  1];}
    }
  }
  else {
    if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_p[x_a][  0] * g_p[x_a][  1] * g_t[x_a][  0] * g_d[x_a][  0] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  2] * g_p[x_a][  1] * g_t[x_a][  0] * g_d[x_a][  0] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  3] * g_p[x_a][  4] * g_d[x_a][  2] * g_d[x_a][  3] * g_d[x_a][  4];}
    if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  3] * g_p[x_a][  5] * g_d[x_a][  2] * g_d[x_a][  3] * g_d[x_a][  4];}
    if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_p[x_a][  0] * g_p[x_a][  1] * g_d[x_a][  5] * g_d[x_a][  0] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_p[x_a][  2] * g_p[x_a][  1] * g_d[x_a][  5] * g_d[x_a][  0] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_p[x_a][  6] * g_p[x_a][  7] * g_d[x_a][  2] * g_d[x_a][  6] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_p[x_a][  6] * g_p[x_a][  8] * g_d[x_a][  2] * g_d[x_a][  6] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_p[x_a][  9] * g_p[x_a][ 10] * g_d[x_a][  8] * g_d[x_a][  1] * g_d[x_a][  9];}
    if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_p[x_a][  9] * g_p[x_a][ 11] * g_d[x_a][  8] * g_d[x_a][  1] * g_d[x_a][  9];}
    if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_p[x_a][  0] * g_f[x_a][  0] * g_t[x_a][  1] * g_t[x_a][  2] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_p[x_a][  2] * g_f[x_a][  0] * g_t[x_a][  1] * g_t[x_a][  2] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_p[x_a][  3] * g_p[x_a][  4] * g_t[x_a][  1] * g_d[x_a][  3] * g_d[x_a][  4];}
    if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_p[x_a][  3] * g_p[x_a][  5] * g_t[x_a][  1] * g_d[x_a][  3] * g_d[x_a][  4];}
    if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_p[x_a][  6] * g_p[x_a][  7] * g_t[x_a][  1] * g_d[x_a][  6] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_p[x_a][  6] * g_p[x_a][  8] * g_t[x_a][  1] * g_d[x_a][  6] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_p[x_a][  0] * g_f[x_a][  0] * g_t[x_a][  1] * g_t[x_a][  3] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_p[x_a][  2] * g_f[x_a][  0] * g_t[x_a][  1] * g_t[x_a][  3] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_p[x_a][  0] * g_p[x_a][ 12] * g_t[x_a][  4] * g_d[x_a][  9] * g_d[x_a][  1];}
    if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_p[x_a][  2] * g_p[x_a][ 12] * g_t[x_a][  4] * g_d[x_a][  9] * g_d[x_a][  1];}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexa03_phasespace_set::ag_psp_330_gb_emepab(int x_a, int zero){
  static Logger logger("ppeexa03_phasespace_set::ag_psp_330_gb_emepab");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (xbp_all[x_a][12] == nullvector){xbp_all[x_a][12] = xbp_all[x_a][4] + xbp_all[x_a][8];}
  if (xbs_all[x_a][12] == 0.){xbs_all[x_a][12] = xbp_all[x_a][12].m2();}
  if (xbs_all[x_a][12] < 0.){xbs_all[x_a][12] = 0.;}
  if (xbsqrts_all[x_a][12] == 0.){xbsqrts_all[x_a][12] = sqrt(xbs_all[x_a][12]);}
  if (xbp_all[x_a][17] == nullvector){xbp_all[x_a][17] = xbp_all[x_a][1] - xbp_all[x_a][16];}
  if (xbs_all[x_a][17] == 0.){xbs_all[x_a][17] = xbp_all[x_a][17].m2();}
  if (xbs_all[x_a][17] > 0.){xbs_all[x_a][17] = 0.;}
  if (xbp_all[x_a][18] == nullvector){xbp_all[x_a][18] = xbp_all[x_a][2] - xbp_all[x_a][16];}
  if (xbs_all[x_a][18] == 0.){xbs_all[x_a][18] = xbp_all[x_a][18].m2();}
  if (xbs_all[x_a][18] > 0.){xbs_all[x_a][18] = 0.;}
  if (xbp_all[x_a][20] == nullvector){xbp_all[x_a][20] = xbp_all[x_a][4] + xbp_all[x_a][16];}
  if (xbs_all[x_a][20] == 0.){xbs_all[x_a][20] = xbp_all[x_a][20].m2();}
  if (xbs_all[x_a][20] < 0.){xbs_all[x_a][20] = 0.;}
  if (xbsqrts_all[x_a][20] == 0.){xbsqrts_all[x_a][20] = sqrt(xbs_all[x_a][20]);}
  if (xbp_all[x_a][24] == nullvector){xbp_all[x_a][24] = xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][24] == 0.){xbs_all[x_a][24] = xbp_all[x_a][24].m2();}
  if (xbs_all[x_a][24] < 0.){xbs_all[x_a][24] = 0.;}
  if (xbsqrts_all[x_a][24] == 0.){xbsqrts_all[x_a][24] = sqrt(xbs_all[x_a][24]);}
  if (xbp_all[x_a][34] == nullvector){xbp_all[x_a][34] = xbp_all[x_a][2] - xbp_all[x_a][32];}
  if (xbs_all[x_a][34] == 0.){xbs_all[x_a][34] = xbp_all[x_a][34].m2();}
  if (xbs_all[x_a][34] > 0.){xbs_all[x_a][34] = 0.;}
  if (xbp_all[x_a][48] == nullvector){xbp_all[x_a][48] = xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][48] == 0.){xbs_all[x_a][48] = xbp_all[x_a][48].m2();}
  if (xbs_all[x_a][48] < 0.){xbs_all[x_a][48] = 0.;}
  if (xbsqrts_all[x_a][48] == 0.){xbsqrts_all[x_a][48] = sqrt(xbs_all[x_a][48]);}
  if (xbp_all[x_a][13] == nullvector){xbp_all[x_a][13] = xbp_all[x_a][1] - xbp_all[x_a][4] - xbp_all[x_a][8];}
  if (xbs_all[x_a][13] == 0.){xbs_all[x_a][13] = xbp_all[x_a][13].m2();}
  if (xbs_all[x_a][13] > 0.){xbs_all[x_a][13] = 0.;}
  if (xbp_all[x_a][14] == nullvector){xbp_all[x_a][14] = xbp_all[x_a][2] - xbp_all[x_a][4] - xbp_all[x_a][8];}
  if (xbs_all[x_a][14] == 0.){xbs_all[x_a][14] = xbp_all[x_a][14].m2();}
  if (xbs_all[x_a][14] > 0.){xbs_all[x_a][14] = 0.;}
  if (xbp_all[x_a][28] == nullvector){xbp_all[x_a][28] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][28] == 0.){xbs_all[x_a][28] = xbp_all[x_a][28].m2();}
  if (xbs_all[x_a][28] < 0.){xbs_all[x_a][28] = 0.;}
  if (xbp_all[x_a][44] == nullvector){xbp_all[x_a][44] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][32];}
  if (xbs_all[x_a][44] == 0.){xbs_all[x_a][44] = xbp_all[x_a][44].m2();}
  if (xbs_all[x_a][44] < 0.){xbs_all[x_a][44] = 0.;}
  if (xbp_all[x_a][60] == nullvector){xbp_all[x_a][60] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][60] == 0.){xbs_all[x_a][60] = xbp_all[x_a][60].m2();}
  if (xbs_all[x_a][60] < 0.){xbs_all[x_a][60] = 0.;}

  v_smin[x_a][  0] = smin_opt[x_a][12]; // 20 times
  v_smin[x_a][  1] = smin_opt[x_a][24]; // 2 times
  v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][24], 2), smin_opt[x_a][28]); // 2 times
  v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]); // 8 times
  v_smin[x_a][  4] = smin_opt[x_a][20]; // 2 times
  v_smin[x_a][  5] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][20], 2), smin_opt[x_a][28]); // 2 times
  v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]); // 10 times
  v_smin[x_a][  7] = smin_opt[x_a][48]; // 2 times

  v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2); // 18 times
  v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][36], 2); // 2 times
  v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2); // 12 times
  v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][40], 2); // 2 times
  v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][16], 2); // 10 times
  v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2); // 2 times
  v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2); // 2 times

  //  vector<double> g_p(14);
  {g_p[x_a][  0] = g_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 9 times
  {g_p[x_a][  1] = g_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 9 times
  {g_p[x_a][  2] = g_propagator(x_a,   0,  24, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 2 */} // 2 times
  {g_p[x_a][  3] = g_propagator(x_a,   0,  28, v_smin[x_a][  2], v_smax[x_a][  2]); /* npp 3 */} // 1 times
  {g_p[x_a][  4] = g_propagator(x_a,  23,  28, v_smin[x_a][  2], v_smax[x_a][  2]); /* npp 3 */} // 1 times
  {g_p[x_a][  5] = g_propagator(x_a,   0,  28, v_smin[x_a][  3], v_smax[x_a][  2]); /* npp 3 */} // 2 times
  {g_p[x_a][  6] = g_propagator(x_a,  36,  28, v_smin[x_a][  3], v_smax[x_a][  2]); /* npp 3 */} // 2 times
  {g_p[x_a][  7] = g_propagator(x_a,   0,  20, v_smin[x_a][  4], v_smax[x_a][  3]); /* npp 2 */} // 2 times
  {g_p[x_a][  8] = g_propagator(x_a,   0,  28, v_smin[x_a][  5], v_smax[x_a][  2]); /* npp 3 */} // 1 times
  {g_p[x_a][  9] = g_propagator(x_a,  23,  28, v_smin[x_a][  5], v_smax[x_a][  2]); /* npp 3 */} // 1 times
  {g_p[x_a][ 10] = g_propagator(x_a,   0,  44, v_smin[x_a][  6], v_smax[x_a][  4]); /* npp 3 */} // 2 times
  {g_p[x_a][ 11] = g_propagator(x_a,   0,  48, v_smin[x_a][  7], v_smax[x_a][  5]); /* npp 2 */} // 2 times
  {g_p[x_a][ 12] = g_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  6]); /* npp 2 */} // 1 times
  {g_p[x_a][ 13] = g_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  6]); /* npp 2 */} // 1 times

  //  vector<double> g_f(2);
  {g_f[x_a][  0] = g_timelikeinvariant(v_smin[x_a][  3], v_smax[x_a][  2]); /* nfp 3 */} // 4 times
  {g_f[x_a][  1] = g_timelikeinvariant(v_smin[x_a][  6], v_smax[x_a][  4]); /* nfp 3 */} // 8 times

  //  vector<double> g_t(10);
  {g_t[x_a][  0] = g_tchannel_opt(x_a,   0,  60,   2,   1,  32,  28); /* ntp 0 */} // 12 times
  {g_t[x_a][  1] = g_tchannel_opt(x_a,   0,  28,   1,  34,  12,  16); /* ntp 1 */} // 2 times
  {g_t[x_a][  2] = g_tchannel_opt(x_a,  36,  28,   1,  34,  12,  16); /* ntp 1 */} // 2 times
  {g_t[x_a][  3] = g_tchannel_opt(x_a,   0,  60,   2,   1,  16,  44); /* ntp 0 */} // 2 times
  {g_t[x_a][  4] = g_tchannel_opt(x_a,   0,  44,   1,  18,  12,  32); /* ntp 1 */} // 2 times
  {g_t[x_a][  5] = g_tchannel_opt(x_a,   0,  60,   1,   2,  16,  44); /* ntp 0 */} // 6 times
  {g_t[x_a][  6] = g_tchannel_opt(x_a,   0,  44,   2,  17,  32,  12); /* ntp 1 */} // 4 times
  {g_t[x_a][  7] = g_tchannel_opt(x_a,  36,  60,   1,   2,  16,  44); /* ntp 0 */} // 2 times
  {g_t[x_a][  8] = g_tchannel_opt(x_a,   0,  44,   2,  17,  12,  32); /* ntp 1 */} // 2 times
  {g_t[x_a][  9] = g_tchannel_opt(x_a,   0,  60,   1,   2,  12,  48); /* ntp 0 */} // 2 times

  //  vector<double> g_d(8);
  {g_d[x_a][  0] = g_decay(x_a,  12,   4,   8); /* ndp 2 */} // 20 times
  {g_d[x_a][  1] = g_decay(x_a,  28,   4,  24); /* ndp 3 */} // 2 times
  {g_d[x_a][  2] = g_decay(x_a,  24,   8,  16); /* ndp 2 */} // 2 times
  {g_d[x_a][  3] = g_decay(x_a,  28,  16,  12); /* ndp 3 */} // 4 times
  {g_d[x_a][  4] = g_decay(x_a,  28,   8,  20); /* ndp 3 */} // 2 times
  {g_d[x_a][  5] = g_decay(x_a,  20,   4,  16); /* ndp 2 */} // 2 times
  {g_d[x_a][  6] = g_decay(x_a,  44,  32,  12); /* ndp 3 */} // 2 times
  {g_d[x_a][  7] = g_decay(x_a,  48,  16,  32); /* ndp 2 */} // 2 times

  if (switch_IS_mode_phasespace == 2 || switch_IS_mode_phasespace == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(6);
    inv_r[0].resize(14);
    inv_r[1].resize(2);
    inv_r[2].resize(10);
    inv_r[3].resize(10);
    inv_r[4].resize(8);
    inv_r[5].resize(8);

    {inv_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][0]);} // 9 times
    {inv_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][1]);} // 9 times
    {inv_propagator(x_a,   0,  24, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][2]);} // 2 times
    {inv_propagator(x_a,   0,  28, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[0][3]);} // 1 times
    {inv_propagator(x_a,  23,  28, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[0][4]);} // 1 times
    {inv_propagator(x_a,   0,  28, v_smin[x_a][  3], v_smax[x_a][  2], inv_r[0][5]);} // 2 times
    {inv_propagator(x_a,  36,  28, v_smin[x_a][  3], v_smax[x_a][  2], inv_r[0][6]);} // 2 times
    {inv_propagator(x_a,   0,  20, v_smin[x_a][  4], v_smax[x_a][  3], inv_r[0][7]);} // 2 times
    {inv_propagator(x_a,   0,  28, v_smin[x_a][  5], v_smax[x_a][  2], inv_r[0][8]);} // 1 times
    {inv_propagator(x_a,  23,  28, v_smin[x_a][  5], v_smax[x_a][  2], inv_r[0][9]);} // 1 times
    {inv_propagator(x_a,   0,  44, v_smin[x_a][  6], v_smax[x_a][  4], inv_r[0][10]);} // 2 times
    {inv_propagator(x_a,   0,  48, v_smin[x_a][  7], v_smax[x_a][  5], inv_r[0][11]);} // 2 times
    {inv_propagator(x_a,   0,  12, v_smin[x_a][  0], v_smax[x_a][  6], inv_r[0][12]);} // 1 times
    {inv_propagator(x_a,  23,  12, v_smin[x_a][  0], v_smax[x_a][  6], inv_r[0][13]);} // 1 times

    {inv_timelikeinvariant(x_a,  28, v_smin[x_a][  3], v_smax[x_a][  2], inv_r[1][0]);} // 4 times
    {inv_timelikeinvariant(x_a,  44, v_smin[x_a][  6], v_smax[x_a][  4], inv_r[1][1]);} // 8 times

    {inv_tchannel_opt(x_a,   0,  60,   2,   1,  32,  28, inv_r[2][0], inv_r[3][0]);} // 12 times
    {inv_tchannel_opt(x_a,   0,  28,   1,  34,  12,  16, inv_r[2][1], inv_r[3][1]);} // 2 times
    {inv_tchannel_opt(x_a,  36,  28,   1,  34,  12,  16, inv_r[2][2], inv_r[3][2]);} // 2 times
    {inv_tchannel_opt(x_a,   0,  60,   2,   1,  16,  44, inv_r[2][3], inv_r[3][3]);} // 2 times
    {inv_tchannel_opt(x_a,   0,  44,   1,  18,  12,  32, inv_r[2][4], inv_r[3][4]);} // 2 times
    {inv_tchannel_opt(x_a,   0,  60,   1,   2,  16,  44, inv_r[2][5], inv_r[3][5]);} // 6 times
    {inv_tchannel_opt(x_a,   0,  44,   2,  17,  32,  12, inv_r[2][6], inv_r[3][6]);} // 4 times
    {inv_tchannel_opt(x_a,  36,  60,   1,   2,  16,  44, inv_r[2][7], inv_r[3][7]);} // 2 times
    {inv_tchannel_opt(x_a,   0,  44,   2,  17,  12,  32, inv_r[2][8], inv_r[3][8]);} // 2 times
    {inv_tchannel_opt(x_a,   0,  60,   1,   2,  12,  48, inv_r[2][9], inv_r[3][9]);} // 2 times

    {inv_decay(x_a,  12,   4,   8, inv_r[4][0], inv_r[5][0]);} // 20 times
    {inv_decay(x_a,  28,   4,  24, inv_r[4][1], inv_r[5][1]);} // 2 times
    {inv_decay(x_a,  24,   8,  16, inv_r[4][2], inv_r[5][2]);} // 2 times
    {inv_decay(x_a,  28,  16,  12, inv_r[4][3], inv_r[5][3]);} // 4 times
    {inv_decay(x_a,  28,   8,  20, inv_r[4][4], inv_r[5][4]);} // 2 times
    {inv_decay(x_a,  20,   4,  16, inv_r[4][5], inv_r[5][5]);} // 2 times
    {inv_decay(x_a,  44,  32,  12, inv_r[4][6], inv_r[5][6]);} // 2 times
    {inv_decay(x_a,  48,  16,  32, inv_r[4][7], inv_r[5][7]);} // 2 times

    if (switch_IS_mode_phasespace == 2){
      vector<vector<double> > inv_channel_r(24, vector<double> (8));
      vector<double> g_IS(24, 1.);
      for (int i_c = 0; i_c < 24; i_c++){
        int ran = 0;
        if (MC_phasespace.alpha[zero + i_c] == 0.){continue;}
        for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){
          inv_channel_r[i_c][ran++] = inv_r[0][c_p[x_a][i_c][i_p]];
        }
        for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){
          inv_channel_r[i_c][ran++] = inv_r[1][c_f[x_a][i_c][i_f]];
        }
        for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t]];
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t] + 1];
        }
        for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d]];
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d] + 1];
        }
        for (int i_r = 0; i_r < 8; i_r++){
          random_psp[(zero + i_c) * no_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
          g_IS[i_c] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_IS[  0] * g_p[x_a][  0] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_IS[  1] * g_p[x_a][  0] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  2] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_IS[  2] * g_p[x_a][  1] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_IS[  3] * g_p[x_a][  1] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  2] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_IS[  4] * g_p[x_a][  0] * g_f[x_a][  1] * g_t[x_a][  3] * g_t[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_IS[  5] * g_p[x_a][  1] * g_f[x_a][  1] * g_t[x_a][  3] * g_t[x_a][  4] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_IS[  6] * g_p[x_a][  2] * g_p[x_a][  3] * g_t[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_IS[  7] * g_p[x_a][  2] * g_p[x_a][  4] * g_t[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_IS[  8] * g_p[x_a][  0] * g_p[x_a][  5] * g_t[x_a][  0] * g_d[x_a][  3] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_IS[  9] * g_p[x_a][  0] * g_p[x_a][  6] * g_t[x_a][  0] * g_d[x_a][  3] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_IS[ 10] * g_p[x_a][  1] * g_p[x_a][  5] * g_t[x_a][  0] * g_d[x_a][  3] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_IS[ 11] * g_p[x_a][  1] * g_p[x_a][  6] * g_t[x_a][  0] * g_d[x_a][  3] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_IS[ 12] * g_p[x_a][  7] * g_p[x_a][  8] * g_t[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  5];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_IS[ 13] * g_p[x_a][  7] * g_p[x_a][  9] * g_t[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  5];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_IS[ 14] * g_p[x_a][  0] * g_f[x_a][  1] * g_t[x_a][  5] * g_t[x_a][  6] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_IS[ 15] * g_p[x_a][  0] * g_f[x_a][  1] * g_t[x_a][  7] * g_t[x_a][  6] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_IS[ 16] * g_p[x_a][  1] * g_f[x_a][  1] * g_t[x_a][  5] * g_t[x_a][  6] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_IS[ 17] * g_p[x_a][  1] * g_f[x_a][  1] * g_t[x_a][  7] * g_t[x_a][  6] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_IS[ 18] * g_p[x_a][  0] * g_p[x_a][ 10] * g_t[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_IS[ 19] * g_p[x_a][  1] * g_p[x_a][ 10] * g_t[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_IS[ 20] * g_p[x_a][  0] * g_f[x_a][  1] * g_t[x_a][  5] * g_t[x_a][  8] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_IS[ 21] * g_p[x_a][  1] * g_f[x_a][  1] * g_t[x_a][  5] * g_t[x_a][  8] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_IS[ 22] * g_p[x_a][ 11] * g_p[x_a][ 12] * g_t[x_a][  9] * g_d[x_a][  0] * g_d[x_a][  7];}
      if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_IS[ 23] * g_p[x_a][ 11] * g_p[x_a][ 13] * g_t[x_a][  9] * g_d[x_a][  0] * g_d[x_a][  7];}
    }
    else if (switch_IS_mode_phasespace == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(14, 1.);
      g_IS[1].resize(2, 1.);
      g_IS[2].resize(10, 1.);
      g_IS[3].resize(8, 1.);

      for (int i_t = 0; i_t < 6; i_t++){
        for (int i_i = 0; i_i < inv_r[i_t].size(); i_i++){
          random_psp[map_type_to_list_MC_IS[vector<int> {x_a, i_t, i_i}]]->get_g_IS(inv_r[i_t][i_i], g_IS_temp);
          int i_g = i_t;
          if (i_t > 2){i_g = i_t / 2 + 1;}
          g_IS[i_g][i_i] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_p[x_a][  0] * g_IS[0][  0] * g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  0] * g_IS[0][  0] * g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  1] * g_IS[0][  1] * g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  1] * g_IS[0][  1] * g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_p[x_a][  0] * g_IS[0][  0] * g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  3] * g_IS[2][  3] * g_t[x_a][  4] * g_IS[2][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_p[x_a][  1] * g_IS[0][  1] * g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  3] * g_IS[2][  3] * g_t[x_a][  4] * g_IS[2][  4] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  3] * g_IS[0][  3] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  1] * g_IS[3][  1] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  4] * g_IS[0][  4] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  1] * g_IS[3][  1] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  5] * g_IS[0][  5] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  6] * g_IS[0][  6] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_p[x_a][  1] * g_IS[0][  1] * g_p[x_a][  5] * g_IS[0][  5] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_p[x_a][  1] * g_IS[0][  1] * g_p[x_a][  6] * g_IS[0][  6] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  3] * g_IS[3][  3] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_p[x_a][  7] * g_IS[0][  7] * g_p[x_a][  8] * g_IS[0][  8] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  5] * g_IS[3][  5];}
      if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_p[x_a][  7] * g_IS[0][  7] * g_p[x_a][  9] * g_IS[0][  9] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  4] * g_IS[3][  4] * g_d[x_a][  5] * g_IS[3][  5];}
      if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_p[x_a][  0] * g_IS[0][  0] * g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  5] * g_IS[2][  5] * g_t[x_a][  6] * g_IS[2][  6] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_p[x_a][  0] * g_IS[0][  0] * g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  7] * g_IS[2][  7] * g_t[x_a][  6] * g_IS[2][  6] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_p[x_a][  1] * g_IS[0][  1] * g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  5] * g_IS[2][  5] * g_t[x_a][  6] * g_IS[2][  6] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_p[x_a][  1] * g_IS[0][  1] * g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  7] * g_IS[2][  7] * g_t[x_a][  6] * g_IS[2][  6] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][ 10] * g_IS[0][ 10] * g_t[x_a][  5] * g_IS[2][  5] * g_d[x_a][  6] * g_IS[3][  6] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_p[x_a][  1] * g_IS[0][  1] * g_p[x_a][ 10] * g_IS[0][ 10] * g_t[x_a][  5] * g_IS[2][  5] * g_d[x_a][  6] * g_IS[3][  6] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_p[x_a][  0] * g_IS[0][  0] * g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  5] * g_IS[2][  5] * g_t[x_a][  8] * g_IS[2][  8] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_p[x_a][  1] * g_IS[0][  1] * g_f[x_a][  1] * g_IS[1][  1] * g_t[x_a][  5] * g_IS[2][  5] * g_t[x_a][  8] * g_IS[2][  8] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_p[x_a][ 11] * g_IS[0][ 11] * g_p[x_a][ 12] * g_IS[0][ 12] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  7] * g_IS[3][  7];}
      if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_p[x_a][ 11] * g_IS[0][ 11] * g_p[x_a][ 13] * g_IS[0][ 13] * g_t[x_a][  9] * g_IS[2][  9] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  7] * g_IS[3][  7];}
    }
  }
  else {
    if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_p[x_a][  0] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  0] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  2] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  1] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  1] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  2] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +   4] != 0.){MC_phasespace.g_channel[zero +   4] = g_p[x_a][  0] * g_f[x_a][  1] * g_t[x_a][  3] * g_t[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +   5] != 0.){MC_phasespace.g_channel[zero +   5] = g_p[x_a][  1] * g_f[x_a][  1] * g_t[x_a][  3] * g_t[x_a][  4] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +   6] != 0.){MC_phasespace.g_channel[zero +   6] = g_p[x_a][  2] * g_p[x_a][  3] * g_t[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   7] != 0.){MC_phasespace.g_channel[zero +   7] = g_p[x_a][  2] * g_p[x_a][  4] * g_t[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   8] != 0.){MC_phasespace.g_channel[zero +   8] = g_p[x_a][  0] * g_p[x_a][  5] * g_t[x_a][  0] * g_d[x_a][  3] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +   9] != 0.){MC_phasespace.g_channel[zero +   9] = g_p[x_a][  0] * g_p[x_a][  6] * g_t[x_a][  0] * g_d[x_a][  3] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  10] != 0.){MC_phasespace.g_channel[zero +  10] = g_p[x_a][  1] * g_p[x_a][  5] * g_t[x_a][  0] * g_d[x_a][  3] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  11] != 0.){MC_phasespace.g_channel[zero +  11] = g_p[x_a][  1] * g_p[x_a][  6] * g_t[x_a][  0] * g_d[x_a][  3] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  12] != 0.){MC_phasespace.g_channel[zero +  12] = g_p[x_a][  7] * g_p[x_a][  8] * g_t[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  5];}
    if (MC_phasespace.alpha[zero +  13] != 0.){MC_phasespace.g_channel[zero +  13] = g_p[x_a][  7] * g_p[x_a][  9] * g_t[x_a][  0] * g_d[x_a][  4] * g_d[x_a][  5];}
    if (MC_phasespace.alpha[zero +  14] != 0.){MC_phasespace.g_channel[zero +  14] = g_p[x_a][  0] * g_f[x_a][  1] * g_t[x_a][  5] * g_t[x_a][  6] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  15] != 0.){MC_phasespace.g_channel[zero +  15] = g_p[x_a][  0] * g_f[x_a][  1] * g_t[x_a][  7] * g_t[x_a][  6] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  16] != 0.){MC_phasespace.g_channel[zero +  16] = g_p[x_a][  1] * g_f[x_a][  1] * g_t[x_a][  5] * g_t[x_a][  6] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  17] != 0.){MC_phasespace.g_channel[zero +  17] = g_p[x_a][  1] * g_f[x_a][  1] * g_t[x_a][  7] * g_t[x_a][  6] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  18] != 0.){MC_phasespace.g_channel[zero +  18] = g_p[x_a][  0] * g_p[x_a][ 10] * g_t[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  19] != 0.){MC_phasespace.g_channel[zero +  19] = g_p[x_a][  1] * g_p[x_a][ 10] * g_t[x_a][  5] * g_d[x_a][  6] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  20] != 0.){MC_phasespace.g_channel[zero +  20] = g_p[x_a][  0] * g_f[x_a][  1] * g_t[x_a][  5] * g_t[x_a][  8] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  21] != 0.){MC_phasespace.g_channel[zero +  21] = g_p[x_a][  1] * g_f[x_a][  1] * g_t[x_a][  5] * g_t[x_a][  8] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +  22] != 0.){MC_phasespace.g_channel[zero +  22] = g_p[x_a][ 11] * g_p[x_a][ 12] * g_t[x_a][  9] * g_d[x_a][  0] * g_d[x_a][  7];}
    if (MC_phasespace.alpha[zero +  23] != 0.){MC_phasespace.g_channel[zero +  23] = g_p[x_a][ 11] * g_p[x_a][ 13] * g_t[x_a][  9] * g_d[x_a][  0] * g_d[x_a][  7];}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
