#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_230_ddx_emepaccx(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_230_ddx_emepaccx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(23);
  needed_v_smin[x_a].resize(23);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    8,    9,   10,   11,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   40,   41,   42,   43,   46,   47,   48,   49,   52,   53,   54,   55}; //  40
  needed_v_smin[x_a][  1] = {   0,    1,   10,   11,   20,   21,   24,   25}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,   24,   25}; //   4
  needed_v_smin[x_a][  3] = {   2,    3,    8,    9,   22,   23,   26,   27}; //   8
  needed_v_smin[x_a][  4] = {   2,    3,   26,   27}; //   4
  needed_v_smin[x_a][  5] = {   4,    5,    6,    7,   36,   37,   44,   45}; //   8
  needed_v_smin[x_a][  6] = {   4,    5,    6,    7,   36,   37,   44,   45}; //   8
  needed_v_smin[x_a][  7] = {   4,    5,   12,   13}; //   4
  needed_v_smin[x_a][  8] = {   6,    7,   14,   15}; //   4
  needed_v_smin[x_a][  9] = {   8,    9}; //   2
  needed_v_smin[x_a][ 10] = {  10,   11}; //   2
  needed_v_smin[x_a][ 11] = {  12,   13,   14,   15,   38,   39,   50,   51}; //   8
  needed_v_smin[x_a][ 12] = {  12,   13,   14,   15,   38,   39,   50,   51}; //   8
  needed_v_smin[x_a][ 13] = {  16,   17,   20,   21,   32,   33,   46,   47}; //   8
  needed_v_smin[x_a][ 14] = {  16,   17}; //   2
  needed_v_smin[x_a][ 15] = {  18,   19,   22,   23,   34,   35,   48,   49}; //   8
  needed_v_smin[x_a][ 16] = {  18,   19}; //   2
  needed_v_smin[x_a][ 17] = {  28,   29,   30,   31,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   50,   51,   52,   53,   54,   55}; //  20
  needed_v_smin[x_a][ 18] = {  32,   33,   46,   47}; //   4
  needed_v_smin[x_a][ 19] = {  34,   35,   48,   49}; //   4
  needed_v_smin[x_a][ 20] = {  28,   29,   30,   31,   52,   53,   54,   55}; //   8
  needed_v_smin[x_a][ 21] = {  40,   41}; //   2
  needed_v_smin[x_a][ 22] = {  42,   43}; //   2

  v_smax[x_a].resize(27);
  needed_v_smax[x_a].resize(27);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    8,    9,   10,   11,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   42,   43,   46,   47,   48,   49,   54,   55}; //  26
  needed_v_smax[x_a][  1] = {   0,    1,   10,   11,   20,   21,   24,   25}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,   24,   25,   26,   27,   28,   29,   30,   31,   52,   53,   54,   55}; //  16
  needed_v_smax[x_a][  3] = {   2,    3,    8,    9,   22,   23,   26,   27}; //   8
  needed_v_smax[x_a][  4] = {   4,    5,    6,    7,   36,   37}; //   6
  needed_v_smax[x_a][  5] = {   4,    5,    6,    7,   12,   13,   14,   15,   36,   37,   38,   39}; //  12
  needed_v_smax[x_a][  6] = {   4,    5,   10,   11,   12,   13,   18,   19}; //   8
  needed_v_smax[x_a][  7] = {   6,    7,    8,    9,   14,   15,   16,   17}; //   8
  needed_v_smax[x_a][  8] = {  12,   13,   14,   15,   38,   39}; //   6
  needed_v_smax[x_a][  9] = {  16,   17,   32,   33}; //   4
  needed_v_smax[x_a][ 10] = {  16,   17}; //   2
  needed_v_smax[x_a][ 11] = {  18,   19,   34,   35}; //   4
  needed_v_smax[x_a][ 12] = {  18,   19}; //   2
  needed_v_smax[x_a][ 13] = {  20,   21}; //   2
  needed_v_smax[x_a][ 14] = {  22,   23}; //   2
  needed_v_smax[x_a][ 15] = {  28,   29,   40,   41,   44,   45,   50,   51,   52,   53}; //  10
  needed_v_smax[x_a][ 16] = {  28,   29,   40,   41,   52,   53}; //   6
  needed_v_smax[x_a][ 17] = {  30,   31,   42,   43,   54,   55}; //   6
  needed_v_smax[x_a][ 18] = {  32,   33,   34,   35}; //   4
  needed_v_smax[x_a][ 19] = {  32,   33,   34,   35}; //   4
  needed_v_smax[x_a][ 20] = {  36,   37,   38,   39}; //   4
  needed_v_smax[x_a][ 21] = {  44,   45}; //   2
  needed_v_smax[x_a][ 22] = {  44,   45,   50,   51,   42,   43}; //   6
  needed_v_smax[x_a][ 23] = {  46,   47}; //   2
  needed_v_smax[x_a][ 24] = {  46,   47,   48,   49,   40,   41}; //   6
  needed_v_smax[x_a][ 25] = {  48,   49}; //   2
  needed_v_smax[x_a][ 26] = {  50,   51}; //   2

  g_p[x_a].resize(45);
  needed_g_p[x_a].resize(45);
  needed_g_p[x_a][0] = {   0,    2,    8,   10,   20,   22,   24,   26,   30,   42,   46,   48,   54}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   10,   11,   20,   21,   24,   25}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1,   24,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,    9,   11,   21,   23,   25,   27,   31,   43,   47,   49,   55}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][4] = {   2,    3,    8,    9,   22,   23,   26,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    3,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][6] = {   4,    5,    6,    7,   36,   37}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   4,    6,   36}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   4,    5,   12,   13}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {   5,    7,   37}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax5");
  needed_g_p[x_a][10] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][11] = {   8,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][12] = {  10,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax6");
  needed_g_p[x_a][13] = {  12,   13,   14,   15,   38,   39}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][14] = {  12,   14,   38}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax5");
  needed_g_p[x_a][15] = {  13,   15,   39}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax5");
  needed_g_p[x_a][16] = {  16,   17,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][17] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax10");
  needed_g_p[x_a][18] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][19] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax10");
  needed_g_p[x_a][20] = {  18,   19,   34,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax11");
  needed_g_p[x_a][21] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax12");
  needed_g_p[x_a][22] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax6");
  needed_g_p[x_a][23] = {  19}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax12");
  needed_g_p[x_a][24] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax13");
  needed_g_p[x_a][25] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax14");
  needed_g_p[x_a][26] = {  28,   29,   40,   41,   44,   45,   50,   51,   52,   53}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax15");
  needed_g_p[x_a][27] = {  28,   40,   52}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax16");
  needed_g_p[x_a][28] = {  29,   41,   53}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");
  needed_g_p[x_a][29] = {  30,   31,   42,   43,   54,   55}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax17");
  needed_g_p[x_a][30] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax18");
  needed_g_p[x_a][31] = {  32,   34}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax19");
  needed_g_p[x_a][32] = {  33,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax19");
  needed_g_p[x_a][33] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax18");
  needed_g_p[x_a][34] = {  36,   37,   38,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax20");
  needed_g_p[x_a][35] = {  44,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax21");
  needed_g_p[x_a][36] = {  44}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax22");
  needed_g_p[x_a][37] = {  45}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax22");
  needed_g_p[x_a][38] = {  46,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax23");
  needed_g_p[x_a][39] = {  46,   47}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax24");
  needed_g_p[x_a][40] = {  48,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax25");
  needed_g_p[x_a][41] = {  48,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax24");
  needed_g_p[x_a][42] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax26");
  needed_g_p[x_a][43] = {  50}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax22");
  needed_g_p[x_a][44] = {  51}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax22");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  28,   29,   30,   31,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax2");
  needed_g_f[x_a][1] = {  40,   41}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax24");
  needed_g_f[x_a][2] = {  42,   43}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax22");

  g_t[x_a].resize(12);
  needed_g_t[x_a].resize(12);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,   28,   29,   30,   31}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][1] = {  24,   25,   26,   27,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][2] = {  28,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][3] = {  30,   31}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][4] = {  32,   33,   34,   35,   40,   41}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][5] = {  36,   37,   38,   39,   42,   43}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][6] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__96_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__96_16");
  needed_g_t[x_a][7] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][8] = {  44,   45,   50,   51}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__96_28");
  needed_g_t[x_a][9] = {  46,   47,   48,   49}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");
  needed_g_t[x_a][10] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");
  needed_g_t[x_a][11] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");

  g_d[x_a].resize(24);
  needed_g_d[x_a].resize(24);
  needed_g_d[x_a][0] = {   0,    1,   24,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][1] = {   0,    1,   10,   11,   20,   21,   24,   25}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    8,    9,   10,   11,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   40,   41,   42,   43,   46,   47,   48,   49,   52,   53,   54,   55}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][3] = {   2,    3,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__64_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__64_44");
  needed_g_d[x_a][4] = {   2,    3,    8,    9,   22,   23,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][5] = {   4,    5,   10,   11,   12,   13,   18,   19}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][6] = {   4,    5,   12,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][7] = {   4,    5,    6,    7,   36,   37,   44,   45}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][8] = {   4,    5,    6,    7,   36,   37,   44,   45}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][9] = {   6,    7,    8,    9,   14,   15,   16,   17}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][10] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][11] = {   8,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][12] = {  10,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][13] = {  12,   13,   14,   15,   38,   39,   50,   51}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][14] = {  12,   13,   14,   15,   38,   39,   50,   51}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][15] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][16] = {  16,   17,   20,   21,   32,   33,   46,   47}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][17] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][18] = {  18,   19,   22,   23,   34,   35,   48,   49}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][19] = {  20,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][20] = {  22,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");
  needed_g_d[x_a][21] = {  28,   29,   30,   31,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   50,   51,   52,   53,   54,   55}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][22] = {  32,   33,   46,   47}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][23] = {  34,   35,   48,   49}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");

  c_p[x_a].resize(56);
  c_f[x_a].resize(56);
  c_t[x_a].resize(56);
  c_d[x_a].resize(56);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   1,   2}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  3,   4,   5}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  3,   4,   2}; //   3

  c_p[x_a][4] = {  6,   7,   8}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  5,   6,   7,   8}; //   4

  c_p[x_a][5] = {  6,   9,   8}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  5,   6,   7,   8}; //   4

  c_p[x_a][6] = {  6,   7,  10}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  9,  10,   7,   8}; //   4

  c_p[x_a][7] = {  6,   9,  10}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  9,  10,   7,   8}; //   4

  c_p[x_a][8] = {  0,   4,  11}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  9,  11,   4,   2}; //   4

  c_p[x_a][9] = {  3,   4,  11}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  9,  11,   4,   2}; //   4

  c_p[x_a][10] = {  0,   1,  12}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  5,  12,   1,   2}; //   4

  c_p[x_a][11] = {  3,   1,  12}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,  12,   1,   2}; //   4

  c_p[x_a][12] = { 13,  14,   8}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  5,   6,  13,  14}; //   4

  c_p[x_a][13] = { 13,  15,   8}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  5,   6,  13,  14}; //   4

  c_p[x_a][14] = { 13,  14,  10}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  9,  10,  13,  14}; //   4

  c_p[x_a][15] = { 13,  15,  10}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  9,  10,  13,  14}; //   4

  c_p[x_a][16] = { 16,  17,  18}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  9,  15,   2,  16}; //   4

  c_p[x_a][17] = { 16,  19,  18}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  9,  15,   2,  16}; //   4

  c_p[x_a][18] = { 20,  21,  22}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  5,  17,   2,  18}; //   4

  c_p[x_a][19] = { 20,  23,  22}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  5,  17,   2,  18}; //   4

  c_p[x_a][20] = {  0,   1,  24}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 19,  16,   1,   2}; //   4

  c_p[x_a][21] = {  3,   1,  24}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 19,  16,   1,   2}; //   4

  c_p[x_a][22] = {  0,   4,  25}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 20,  18,   4,   2}; //   4

  c_p[x_a][23] = {  3,   4,  25}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 20,  18,   4,   2}; //   4

  c_p[x_a][24] = {  0,   1,   2}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  1}; //   1
  c_d[x_a][24] = {  0,   1,   2}; //   3

  c_p[x_a][25] = {  3,   1,   2}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  1}; //   1
  c_d[x_a][25] = {  0,   1,   2}; //   3

  c_p[x_a][26] = {  0,   4,   5}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  1}; //   1
  c_d[x_a][26] = {  3,   4,   2}; //   3

  c_p[x_a][27] = {  3,   4,   5}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  1}; //   1
  c_d[x_a][27] = {  3,   4,   2}; //   3

  c_p[x_a][28] = { 26,  27}; //   2
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  0,   2}; //   2
  c_d[x_a][28] = {  2,  21}; //   2

  c_p[x_a][29] = { 26,  28}; //   2
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  0,   2}; //   2
  c_d[x_a][29] = {  2,  21}; //   2

  c_p[x_a][30] = {  0,  29}; //   2
  c_f[x_a][30] = {  0}; //   1
  c_t[x_a][30] = {  0,   3}; //   2
  c_d[x_a][30] = { 21,   2}; //   2

  c_p[x_a][31] = {  3,  29}; //   2
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  0,   3}; //   2
  c_d[x_a][31] = { 21,   2}; //   2

  c_p[x_a][32] = { 16,  30,  31}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  4}; //   1
  c_d[x_a][32] = {  2,  22,  16}; //   3

  c_p[x_a][33] = { 16,  30,  32}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  4}; //   1
  c_d[x_a][33] = {  2,  22,  16}; //   3

  c_p[x_a][34] = { 20,  33,  31}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  4}; //   1
  c_d[x_a][34] = {  2,  23,  18}; //   3

  c_p[x_a][35] = { 20,  33,  32}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  4}; //   1
  c_d[x_a][35] = {  2,  23,  18}; //   3

  c_p[x_a][36] = {  6,   7,  34}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  5}; //   1
  c_d[x_a][36] = { 21,   7,   8}; //   3

  c_p[x_a][37] = {  6,   9,  34}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  5}; //   1
  c_d[x_a][37] = { 21,   7,   8}; //   3

  c_p[x_a][38] = { 13,  14,  34}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  5}; //   1
  c_d[x_a][38] = { 21,  13,  14}; //   3

  c_p[x_a][39] = { 13,  15,  34}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  5}; //   1
  c_d[x_a][39] = { 21,  13,  14}; //   3

  c_p[x_a][40] = { 26,  27}; //   2
  c_f[x_a][40] = {  1}; //   1
  c_t[x_a][40] = {  4,   6}; //   2
  c_d[x_a][40] = {  2,  21}; //   2

  c_p[x_a][41] = { 26,  28}; //   2
  c_f[x_a][41] = {  1}; //   1
  c_t[x_a][41] = {  4,   6}; //   2
  c_d[x_a][41] = {  2,  21}; //   2

  c_p[x_a][42] = {  0,  29}; //   2
  c_f[x_a][42] = {  2}; //   1
  c_t[x_a][42] = {  5,   7}; //   2
  c_d[x_a][42] = { 21,   2}; //   2

  c_p[x_a][43] = {  3,  29}; //   2
  c_f[x_a][43] = {  2}; //   1
  c_t[x_a][43] = {  5,   7}; //   2
  c_d[x_a][43] = { 21,   2}; //   2

  c_p[x_a][44] = { 26,  35,  36}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  8}; //   1
  c_d[x_a][44] = {  7,   8,  21}; //   3

  c_p[x_a][45] = { 26,  35,  37}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  8}; //   1
  c_d[x_a][45] = {  7,   8,  21}; //   3

  c_p[x_a][46] = {  0,  38,  39}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  9}; //   1
  c_d[x_a][46] = { 22,  16,   2}; //   3

  c_p[x_a][47] = {  3,  38,  39}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  9}; //   1
  c_d[x_a][47] = { 22,  16,   2}; //   3

  c_p[x_a][48] = {  0,  40,  41}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  9}; //   1
  c_d[x_a][48] = { 23,  18,   2}; //   3

  c_p[x_a][49] = {  3,  40,  41}; //   3
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  9}; //   1
  c_d[x_a][49] = { 23,  18,   2}; //   3

  c_p[x_a][50] = { 26,  42,  43}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  8}; //   1
  c_d[x_a][50] = { 13,  14,  21}; //   3

  c_p[x_a][51] = { 26,  42,  44}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  8}; //   1
  c_d[x_a][51] = { 13,  14,  21}; //   3

  c_p[x_a][52] = { 26,  27}; //   2
  c_f[x_a][52] = {  0}; //   1
  c_t[x_a][52] = {  1,  10}; //   2
  c_d[x_a][52] = {  2,  21}; //   2

  c_p[x_a][53] = { 26,  28}; //   2
  c_f[x_a][53] = {  0}; //   1
  c_t[x_a][53] = {  1,  10}; //   2
  c_d[x_a][53] = {  2,  21}; //   2

  c_p[x_a][54] = {  0,  29}; //   2
  c_f[x_a][54] = {  0}; //   1
  c_t[x_a][54] = {  1,  11}; //   2
  c_d[x_a][54] = { 21,   2}; //   2

  c_p[x_a][55] = {  3,  29}; //   2
  c_f[x_a][55] = {  0}; //   1
  c_t[x_a][55] = {  1,  11}; //   2
  c_d[x_a][55] = { 21,   2}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_ddx_emepaccx
//  channel    0: 4yyv1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel    1: 4yyv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel    2: 4yyv1(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
//  channel    3: 4yyv1(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
//  channel    4: 5yyyv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel    5: 5yyyv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
//  channel    6: 5yyyv(1, 2, 64, 32, 4, 8, 16;   0,   0,   0,   0)
//  channel    7: 5yyyv(1, 2, 64, 32, 4, 8, 16;   0,  23,   0,   0)
//  channel    8: 5yyyv(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
//  channel    9: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel   10: 5yyyv(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
//  channel   11: 5yyyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel   12: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
//  channel   13: 5yyyv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
//  channel   14: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,   0,   0,   0)
//  channel   15: 5yyyv(1, 2, 64, 32, 8, 4, 16;   0,  23,   0,   0)
//  channel   16: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,   0,   0,   0)
//  channel   17: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
//  channel   18: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,   0,   0,   0)
//  channel   19: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   20: 52vyv(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
//  channel   21: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   22: 52vyv(1, 2, 16, 64, 32, 4, 8;   0,   0,   0,   0)
//  channel   23: 52vyv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   24: 14yyv(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
//  channel   25: 14yyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   26: 14yyv(1, 2, 16, 64, 32, 4, 8;   0,   0,   0,   0)
//  channel   27: 14yyv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   28: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,   0,   0,   0)
//  channel   29: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,  23,   0,   0)
//  channel   30: 2v2v1(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel   31: 2v2v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   32: 2v3yv(1, 2, 4, 8, 64, 16, 32;   0,   0,   0,   0)
//  channel   33: 2v3yv(1, 2, 4, 8, 64, 16, 32;   0,   0,  23,   0)
//  channel   34: 2v3yv(1, 2, 4, 8, 32, 16, 64;   0,   0,   0,   0)
//  channel   35: 2v3yv(1, 2, 4, 8, 32, 16, 64;   0,   0,  23,   0)
//  channel   36: 2v3yv(1, 2, 32, 64, 4, 8, 16;   0,   0,   0,   0)
//  channel   37: 2v3yv(1, 2, 32, 64, 4, 8, 16;   0,  23,   0,   0)
//  channel   38: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,   0,   0,   0)
//  channel   39: 2v3yv(1, 2, 32, 64, 8, 4, 16;   0,  23,   0,   0)
//  channel   40: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
//  channel   41: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel   42: 2v12v(1, 2, 32, 64, 16, 4, 8;   0,   0,   0,   0)
//  channel   43: 2v12v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
//  channel   44: 3yv2v(1, 2, 4, 8, 16, 32, 64;   0,   0,   0,   0)
//  channel   45: 3yv2v(1, 2, 4, 8, 16, 32, 64;   0,   0,  23,   0)
//  channel   46: 3yv2v(1, 2, 64, 16, 32, 4, 8;   0,   0,   0,   0)
//  channel   47: 3yv2v(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel   48: 3yv2v(1, 2, 32, 16, 64, 4, 8;   0,   0,   0,   0)
//  channel   49: 3yv2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel   50: 3yv2v(1, 2, 8, 4, 16, 32, 64;   0,   0,   0,   0)
//  channel   51: 3yv2v(1, 2, 8, 4, 16, 32, 64;   0,   0,  23,   0)
//  channel   52: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,   0,   0,   0)
//  channel   53: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,  23,   0,   0)
//  channel   54: 12v2v(1, 2, 16, 32, 64, 4, 8;   0,   0,   0,   0)
//  channel   55: 12v2v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
