#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_040_bbx_emepaa(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_040_bbx_emepaa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(15);
  needed_v_smin[x_a].resize(15);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,   24,   25,   26,   27,   36,   37,   38,   39}; //  12
  needed_v_smin[x_a][  1] = {   4,    5,   12,   13,   20,   21,   28,   29}; //   8
  needed_v_smin[x_a][  2] = {   4,    5,   28,   29}; //   4
  needed_v_smin[x_a][  3] = {   6,    7,   14,   15,   22,   23,   30,   31}; //   8
  needed_v_smin[x_a][  4] = {   6,    7,   30,   31}; //   4
  needed_v_smin[x_a][  5] = {   8,    9,   16,   17,   22,   23,   32,   33}; //   8
  needed_v_smin[x_a][  6] = {   8,    9,   32,   33}; //   4
  needed_v_smin[x_a][  7] = {  10,   11,   18,   19,   20,   21,   34,   35}; //   8
  needed_v_smin[x_a][  8] = {  10,   11,   34,   35}; //   4
  needed_v_smin[x_a][  9] = {  12,   13}; //   2
  needed_v_smin[x_a][ 10] = {  14,   15}; //   2
  needed_v_smin[x_a][ 11] = {  16,   17}; //   2
  needed_v_smin[x_a][ 12] = {  18,   19}; //   2
  needed_v_smin[x_a][ 13] = {   0,    1,   24,   25,   38,   39}; //   6
  needed_v_smin[x_a][ 14] = {   2,    3,   26,   27,   36,   37}; //   6

  v_smax[x_a].resize(11);
  needed_v_smax[x_a].resize(11);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,   24,   25,   26,   27,   36,   37,   38,   39}; //  12
  needed_v_smax[x_a][  1] = {   4,    5,   12,   13,   20,   21,   28,   29}; //   8
  needed_v_smax[x_a][  2] = {   4,    5,    8,    9,   28,   29,   32,   33,    0,    1,   24,   25,   38,   39}; //  14
  needed_v_smax[x_a][  3] = {   6,    7,   14,   15,   22,   23,   30,   31}; //   8
  needed_v_smax[x_a][  4] = {   6,    7,   10,   11,   30,   31,   34,   35,    2,    3,   26,   27,   36,   37}; //  14
  needed_v_smax[x_a][  5] = {   8,    9,   16,   17,   32,   33}; //   6
  needed_v_smax[x_a][  6] = {  10,   11,   18,   19,   34,   35}; //   6
  needed_v_smax[x_a][  7] = {  12,   13,   14,   15}; //   4
  needed_v_smax[x_a][  8] = {  16,   17,   18,   19}; //   4
  needed_v_smax[x_a][  9] = {  20,   21}; //   2
  needed_v_smax[x_a][ 10] = {  22,   23}; //   2

  g_p[x_a].resize(20);
  needed_g_p[x_a].resize(20);
  needed_g_p[x_a][0] = {   0,    2,   24,   26,   36,   38}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   1,    3,   25,   27,   37,   39}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   4,    5,   12,   13,   20,   21,   28,   29}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {   4,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   5,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   6,    7,   14,   15,   22,   23,   30,   31}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   6,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][7] = {   7,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][8] = {   8,    9,   16,   17,   32,   33}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][9] = {   8,   32}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax2");
  needed_g_p[x_a][10] = {   9,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][11] = {  10,   11,   18,   19,   34,   35}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][12] = {  10,   34}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax4");
  needed_g_p[x_a][13] = {  11,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax4");
  needed_g_p[x_a][14] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][15] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][16] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][17] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax8");
  needed_g_p[x_a][18] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax9");
  needed_g_p[x_a][19] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax10");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    1,   24,   25,   38,   39}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax2");
  needed_g_f[x_a][1] = {   2,    3,   26,   27,   36,   37}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax4");

  g_t[x_a].resize(10);
  needed_g_t[x_a].resize(10);
  needed_g_t[x_a][0] = {   0,    1,    4,    5,    8,    9}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   2,    3,    6,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][4] = {  24,   25,   28,   29,   32,   33,   38,   39}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][5] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][6] = {  26,   27,   30,   31,   34,   35,   36,   37}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][7] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][8] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][9] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");

  g_d[x_a].resize(17);
  needed_g_d[x_a].resize(17);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,   24,   25,   26,   27,   36,   37,   38,   39}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   4,    5,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {   4,    5,   12,   13,   20,   21,   28,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   6,    7,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][4] = {   6,    7,   14,   15,   22,   23,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][5] = {   8,    9,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][6] = {   8,    9,   16,   17,   22,   23,   32,   33}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][7] = {  10,   11,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][8] = {  10,   11,   18,   19,   20,   21,   34,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][9] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][10] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][11] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][12] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][13] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][14] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][15] = {  20,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][16] = {  22,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(40);
  c_f[x_a].resize(40);
  c_t[x_a].resize(40);
  c_d[x_a].resize(40);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  1}; //   1
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  2,   3}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  2,   3}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  1,   2}; //   2

  c_p[x_a][5] = {  2,   4}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  1,   2}; //   2

  c_p[x_a][6] = {  5,   6}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  2}; //   1
  c_d[x_a][6] = {  3,   4}; //   2

  c_p[x_a][7] = {  5,   7}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  2}; //   1
  c_d[x_a][7] = {  3,   4}; //   2

  c_p[x_a][8] = {  8,   9}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  5,   6}; //   2

  c_p[x_a][9] = {  8,  10}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  5,   6}; //   2

  c_p[x_a][10] = { 11,  12}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  2}; //   1
  c_d[x_a][10] = {  7,   8}; //   2

  c_p[x_a][11] = { 11,  13}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  2}; //   1
  c_d[x_a][11] = {  7,   8}; //   2

  c_p[x_a][12] = {  2,  14}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  9,  10,   2}; //   3

  c_p[x_a][13] = {  2,  14}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  9,  10,   2}; //   3

  c_p[x_a][14] = {  5,  15}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  9,  11,   4}; //   3

  c_p[x_a][15] = {  5,  15}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  9,  11,   4}; //   3

  c_p[x_a][16] = {  8,  16}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 12,  13,   6}; //   3

  c_p[x_a][17] = {  8,  16}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 12,  13,   6}; //   3

  c_p[x_a][18] = { 11,  17}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 12,  14,   8}; //   3

  c_p[x_a][19] = { 11,  17}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 12,  14,   8}; //   3

  c_p[x_a][20] = {  2,  18}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 15,   8,   2}; //   3

  c_p[x_a][21] = {  2,  18}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 15,   8,   2}; //   3

  c_p[x_a][22] = {  5,  19}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 16,   6,   4}; //   3

  c_p[x_a][23] = {  5,  19}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 16,   6,   4}; //   3

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = {  0}; //   1
  c_t[x_a][24] = {  4,   5}; //   2
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  1}; //   1
  c_f[x_a][25] = {  0}; //   1
  c_t[x_a][25] = {  4,   5}; //   2
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  0}; //   1
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  6,   7}; //   2
  c_d[x_a][26] = {  0}; //   1

  c_p[x_a][27] = {  1}; //   1
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  6,   7}; //   2
  c_d[x_a][27] = {  0}; //   1

  c_p[x_a][28] = {  2,   3}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  4}; //   1
  c_d[x_a][28] = {  1,   2}; //   2

  c_p[x_a][29] = {  2,   4}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  4}; //   1
  c_d[x_a][29] = {  1,   2}; //   2

  c_p[x_a][30] = {  5,   6}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  6}; //   1
  c_d[x_a][30] = {  3,   4}; //   2

  c_p[x_a][31] = {  5,   7}; //   2
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  6}; //   1
  c_d[x_a][31] = {  3,   4}; //   2

  c_p[x_a][32] = {  8,   9}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  4}; //   1
  c_d[x_a][32] = {  5,   6}; //   2

  c_p[x_a][33] = {  8,  10}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  4}; //   1
  c_d[x_a][33] = {  5,   6}; //   2

  c_p[x_a][34] = { 11,  12}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  6}; //   1
  c_d[x_a][34] = {  7,   8}; //   2

  c_p[x_a][35] = { 11,  13}; //   2
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  6}; //   1
  c_d[x_a][35] = {  7,   8}; //   2

  c_p[x_a][36] = {  0}; //   1
  c_f[x_a][36] = {  1}; //   1
  c_t[x_a][36] = {  6,   8}; //   2
  c_d[x_a][36] = {  0}; //   1

  c_p[x_a][37] = {  1}; //   1
  c_f[x_a][37] = {  1}; //   1
  c_t[x_a][37] = {  6,   8}; //   2
  c_d[x_a][37] = {  0}; //   1

  c_p[x_a][38] = {  0}; //   1
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  4,   9}; //   2
  c_d[x_a][38] = {  0}; //   1

  c_p[x_a][39] = {  1}; //   1
  c_f[x_a][39] = {  0}; //   1
  c_t[x_a][39] = {  4,   9}; //   2
  c_d[x_a][39] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_040_bbx_emepaa
//  channel    0: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    1: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    2: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel    3: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel    4: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    5: 3yv1(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel    6: 3yv1(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel    7: 3yv1(1, 2, 4, 8, 32, 16;   0,  23,   0)
//  channel    8: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel    9: 3yv1(1, 2, 8, 4, 16, 32;   0,  23,   0)
//  channel   10: 3yv1(1, 2, 8, 4, 32, 16;   0,   0,   0)
//  channel   11: 3yv1(1, 2, 8, 4, 32, 16;   0,  23,   0)
//  channel   12: 4yyv(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel   13: 4yyv(1, 2, 4, 32, 8, 16;   0,   0,  23)
//  channel   14: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel   15: 4yyv(1, 2, 4, 16, 8, 32;   0,   0,  23)
//  channel   16: 4yyv(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel   17: 4yyv(1, 2, 8, 32, 4, 16;   0,   0,  23)
//  channel   18: 4yyv(1, 2, 8, 16, 4, 32;   0,   0,   0)
//  channel   19: 4yyv(1, 2, 8, 16, 4, 32;   0,   0,  23)
//  channel   20: 42vv(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel   21: 42vv(1, 2, 4, 32, 8, 16;   0,   0,  23)
//  channel   22: 42vv(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel   23: 42vv(1, 2, 4, 16, 8, 32;   0,   0,  23)
//  channel   24: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   25: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel   26: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   27: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   28: 13yv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   29: 13yv(1, 2, 32, 4, 8, 16;   0,  23,   0)
//  channel   30: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   31: 13yv(1, 2, 16, 4, 8, 32;   0,  23,   0)
//  channel   32: 13yv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   33: 13yv(1, 2, 32, 8, 4, 16;   0,  23,   0)
//  channel   34: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   35: 13yv(1, 2, 16, 8, 4, 32;   0,  23,   0)
//  channel   36: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   37: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   38: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   39: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
