#include "header.hpp"

#include "ppeexa03.phasespace.set.hpp"

void ppeexa03_phasespace_set::ax_psp_330_gg_emepag(int x_a){
  static Logger logger("ppeexa03_phasespace_set::ax_psp_330_gg_emepag");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(8);
  needed_v_smin[x_a].resize(8);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  112,  113,  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,  129,  130,  131}; //  96
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 96);
  int needed_v_smin_1[] = {  12,   13,   14,   15,   16,   17,   36,   37,   38,   39,   40,   41,   88,   89,   90,   91,   92,   93}; //  18
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 18);
  int needed_v_smin_2[] = {  12,   13,   14,   15,   16,   17,   36,   37,   38,   39,   40,   41,   88,   89,   90,   91,   92,   93}; //  18
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 18);
  int needed_v_smin_3[] = {  18,   19,   20,   21,   42,   43,   44,   45,   46,   47,   48,   49,   94,   95,   96,   97,    8,    9,   10,   11,   80,   81,   82,   83,   84,   85,   86,   87,  112,  113,  114,  115}; //  32
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 32);
  int needed_v_smin_4[] = {  22,   23,   24,   25,   26,   27,   28,   29,   50,   51,   52,   53,   54,   55,   56,   57,   98,   99,  100,  101,  102,  103,  104,  105,    0,    1,    2,    3,    4,    5,    6,    7,   72,   73,   74,   75,   76,   77,   78,   79,  116,  117,  118,  119,  120,  121,  122,  123}; //  48
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 48);
  int needed_v_smin_5[] = {  30,   31,   32,   33,   34,   35,   58,   59,   60,   61,   62,   63,  106,  107,  108,  109,  110,  111}; //  18
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 18);
  int needed_v_smin_6[] = {  30,   31,   32,   33,   34,   35,   58,   59,   60,   61,   62,   63,  106,  107,  108,  109,  110,  111}; //  18
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 18);
  int needed_v_smin_7[] = {  64,   65,   66,   67,   68,   69,   70,   71,  124,  125,  126,  127,  128,  129,  130,  131}; //  16
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 16);

  v_smax[x_a].resize(8);
  needed_v_smax[x_a].resize(8);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  112,  113,  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,  128,  129,  130,  131}; //  84
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 84);
  int needed_v_smax_1[] = {  12,   13,   14,   15,   16,   17,   36,   37,   38,   39,   40,   41,   88,   89,   90,   91,   92,   93}; //  18
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 18);
  int needed_v_smax_2[] = {  12,   13,   14,   15,   16,   17,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   88,   89,   90,   91,   92,   93,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111,    0,    1,    2,    3,    4,    5,    6,    7,   72,   73,   74,   75,   76,   77,   78,   79,  116,  117,  118,  119,  120,  121,  122,  123}; //  84
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 84);
  int needed_v_smax_3[] = {  18,   19,   20,   21,   42,   43,   44,   45,   46,   47,   48,   49,   94,   95,   96,   97,    8,    9,   10,   11,   80,   81,   82,   83,   84,   85,   86,   87,  112,  113,  114,  115}; //  32
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 32);
  int needed_v_smax_4[] = {  30,   31,   32,   33,   34,   35,   58,   59,   60,   61,   62,   63,  106,  107,  108,  109,  110,  111}; //  18
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 18);
  int needed_v_smax_5[] = {  64,   65,   66,   67,   68,   69,   70,   71,  124,  125,  126,  127}; //  12
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 12);
  int needed_v_smax_6[] = {  64,   65,   66,   67,   68,   69,   70,   71,  124,  125,  126,  127}; //  12
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 12);
  int needed_v_smax_7[] = { 128,  129,  130,  131}; //   4
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 4);

  g_p[x_a].resize(18);
  needed_g_p[x_a].resize(18);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    8,    9,   18,   19,   22,   23,   24,   25,   42,   43,   44,   45,   50,   51,   52,   53,   72,   73,   74,   75,   80,   81,   82,   83,   94,   95,   98,   99,  100,  101,  112,  113,  116,  117,  118,  119,  128,  129}; //  42
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   4,    5,    6,    7,   10,   11,   20,   21,   26,   27,   28,   29,   46,   47,   48,   49,   54,   55,   56,   57,   76,   77,   78,   79,   84,   85,   86,   87,   96,   97,  102,  103,  104,  105,  114,  115,  120,  121,  122,  123,  130,  131}; //  42
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {  12,   13,   14,   15,   16,   17,   36,   37,   38,   39,   40,   41,   88,   89,   90,   91,   92,   93}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {  12,   13,   14,   36,   37,   38,   88,   89,   90}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {  15,   16,   17,   39,   40,   41,   91,   92,   93}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {  18,   20,   42,   43,   46,   47,   94,   96}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {  19,   21,   44,   45,   48,   49,   95,   97}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin3_smax3");
  needed_g_p[x_a][7] = {  22,   23,   26,   27,   50,   51,   54,   55,   98,   99,  102,  103}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][8] = {  24,   25,   28,   29,   52,   53,   56,   57,  100,  101,  104,  105}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin4_smax2");
  needed_g_p[x_a][9] = {  30,   31,   32,   33,   34,   35,   58,   59,   60,   61,   62,   63,  106,  107,  108,  109,  110,  111}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][10] = {  30,   31,   32,   58,   59,   60,  106,  107,  108}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax2");
  needed_g_p[x_a][11] = {  33,   34,   35,   61,   62,   63,  109,  110,  111}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][12] = {  64,   65,   66,   67,  124,  125}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][13] = {  64,   65,   68,   69,  124,  126}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][14] = {  66,   67,   70,   71,  125,  127}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][15] = {  68,   69,   70,   71,  126,  127}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin7_smax5");
  needed_g_p[x_a][16] = { 128,  130}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax7");
  needed_g_p[x_a][17] = { 129,  131}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin7_smax7");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,   72,   73,   74,   75,   76,   77,   78,   79,  116,  117,  118,  119,  120,  121,  122,  123}; //  24
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax2");
  needed_g_f[x_a][1] = {   8,    9,   10,   11,   80,   81,   82,   83,   84,   85,   86,   87,  112,  113,  114,  115}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");

  g_t[x_a].resize(24);
  needed_g_t[x_a].resize(24);
  needed_g_t[x_a][0] = {   0,    1,    2,    4,    5,    6,   12,   13,   15,   16,   22,   23,   24,   26,   27,   28,   30,   31,   33,   34}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0,    2,    4,    6}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   1,    3,    5,    7}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_34__12_16");
  needed_g_t[x_a][3] = {   3,    7,   14,   17,   25,   29,   32,   35}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__32_28");
  needed_g_t[x_a][4] = {   8,   10,   18,   20}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][5] = {   8,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][6] = {   9,   11,   19,   21}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__16_44");
  needed_g_t[x_a][7] = {   9,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_18__12_32");
  needed_g_t[x_a][8] = {  72,   73,   74,   76,   77,   78,   88,   89,   91,   92,   98,   99,  100,  102,  103,  104,  106,  107,  109,  110,  116,  117,  118,  120,  121,  122}; //  26
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][9] = {  72,   74,   76,   78}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][10] = {  73,   75,   77,   79}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_33__16_12");
  needed_g_t[x_a][11] = {  75,   79,   90,   93,  101,  105,  108,  111,  119,  123}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__32_28");
  needed_g_t[x_a][12] = {  80,   81,   84,   85,   94,   96,  112,  114}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][13] = {  80,   81,   82,   84,   85,   86}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][14] = {  82,   83,   86,   87,   95,   97,  113,  115}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__16_44");
  needed_g_t[x_a][15] = {  83,   87}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_17__32_12");
  needed_g_t[x_a][16] = { 112,  114}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][17] = { 113,  115}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_17__12_32");
  needed_g_t[x_a][18] = { 116,  118,  120,  122}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");
  needed_g_t[x_a][19] = { 117,  119,  121,  123}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_33__12_16");
  needed_g_t[x_a][20] = { 124,  125}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][21] = { 126,  127}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__12_48");
  needed_g_t[x_a][22] = { 128,  130}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");
  needed_g_t[x_a][23] = { 129,  131}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__48_12");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  112,  113,  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,  124,  125,  126,  127,  128,  129,  130,  131}; //  96
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  12,   13,   14,   15,   16,   17,   36,   37,   38,   39,   40,   41,   88,   89,   90,   91,   92,   93}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {  12,   13,   14,   15,   16,   17,   36,   37,   38,   39,   40,   41,   88,   89,   90,   91,   92,   93}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  18,   19,   20,   21,   42,   43,   44,   45,   46,   47,   48,   49,   94,   95,   96,   97}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][4] = {  22,   23,   24,   25,   26,   27,   28,   29,   50,   51,   52,   53,   54,   55,   56,   57,   98,   99,  100,  101,  102,  103,  104,  105}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {  30,   31,   32,   33,   34,   35,   58,   59,   60,   61,   62,   63,  106,  107,  108,  109,  110,  111}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][6] = {  30,   31,   32,   33,   34,   35,   58,   59,   60,   61,   62,   63,  106,  107,  108,  109,  110,  111}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][7] = {  36,   37,   38,   39,   40,   41,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {  42,   43,   44,   45,   46,   47,   48,   49}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {  64,   65,   66,   67,   68,   69,   70,   71}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][10] = {  64,   65,   66,   67,   68,   69,   70,   71,  124,  125,  126,  127,  128,  129,  130,  131}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(132);
  c_f[x_a].resize(132);
  c_t[x_a].resize(132);
  c_d[x_a].resize(132);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   2}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  3,   2}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  1}; //   1
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   2}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  1}; //   1
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  1}; //   1
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  3,   2}; //   2
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  1}; //   1
  c_t[x_a][8] = {  4,   5}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  6,   7}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  1}; //   1
  c_f[x_a][10] = {  1}; //   1
  c_t[x_a][10] = {  4,   5}; //   2
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  1}; //   1
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  6,   7}; //   2
  c_d[x_a][11] = {  0}; //   1

  c_p[x_a][12] = {  2,   3}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  1,   2}; //   2

  c_p[x_a][13] = {  2,   3}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  1,   2}; //   2

  c_p[x_a][14] = {  2,   3}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  3}; //   1
  c_d[x_a][14] = {  1,   2}; //   2

  c_p[x_a][15] = {  2,   4}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = {  1,   2}; //   2

  c_p[x_a][16] = {  2,   4}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = {  1,   2}; //   2

  c_p[x_a][17] = {  2,   4}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  3}; //   1
  c_d[x_a][17] = {  1,   2}; //   2

  c_p[x_a][18] = {  0,   5}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  4}; //   1
  c_d[x_a][18] = {  3,   0}; //   2

  c_p[x_a][19] = {  0,   6}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  6}; //   1
  c_d[x_a][19] = {  3,   0}; //   2

  c_p[x_a][20] = {  1,   5}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  4}; //   1
  c_d[x_a][20] = {  3,   0}; //   2

  c_p[x_a][21] = {  1,   6}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  6}; //   1
  c_d[x_a][21] = {  3,   0}; //   2

  c_p[x_a][22] = {  0,   7}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = {  4,   0}; //   2

  c_p[x_a][23] = {  0,   7}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = {  4,   0}; //   2

  c_p[x_a][24] = {  0,   8}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = {  4,   0}; //   2

  c_p[x_a][25] = {  0,   8}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  3}; //   1
  c_d[x_a][25] = {  4,   0}; //   2

  c_p[x_a][26] = {  1,   7}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = {  4,   0}; //   2

  c_p[x_a][27] = {  1,   7}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  4,   0}; //   2

  c_p[x_a][28] = {  1,   8}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = {  4,   0}; //   2

  c_p[x_a][29] = {  1,   8}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  3}; //   1
  c_d[x_a][29] = {  4,   0}; //   2

  c_p[x_a][30] = {  9,  10}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = {  5,   6}; //   2

  c_p[x_a][31] = {  9,  10}; //   2
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = {  5,   6}; //   2

  c_p[x_a][32] = {  9,  10}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  3}; //   1
  c_d[x_a][32] = {  5,   6}; //   2

  c_p[x_a][33] = {  9,  11}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  0}; //   1
  c_d[x_a][33] = {  5,   6}; //   2

  c_p[x_a][34] = {  9,  11}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  0}; //   1
  c_d[x_a][34] = {  5,   6}; //   2

  c_p[x_a][35] = {  9,  11}; //   2
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  3}; //   1
  c_d[x_a][35] = {  5,   6}; //   2

  c_p[x_a][36] = {  2,   3}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = {  7,   1,   2}; //   3

  c_p[x_a][37] = {  2,   3}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = {  7,   1,   2}; //   3

  c_p[x_a][38] = {  2,   3}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = {  7,   1,   2}; //   3

  c_p[x_a][39] = {  2,   4}; //   2
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = {  7,   1,   2}; //   3

  c_p[x_a][40] = {  2,   4}; //   2
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = {  7,   1,   2}; //   3

  c_p[x_a][41] = {  2,   4}; //   2
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = {  7,   1,   2}; //   3

  c_p[x_a][42] = {  0,   5}; //   2
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = {  8,   3,   0}; //   3

  c_p[x_a][43] = {  0,   5}; //   2
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {}; //   0
  c_d[x_a][43] = {  8,   3,   0}; //   3

  c_p[x_a][44] = {  0,   6}; //   2
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {}; //   0
  c_d[x_a][44] = {  8,   3,   0}; //   3

  c_p[x_a][45] = {  0,   6}; //   2
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {}; //   0
  c_d[x_a][45] = {  8,   3,   0}; //   3

  c_p[x_a][46] = {  1,   5}; //   2
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {}; //   0
  c_d[x_a][46] = {  8,   3,   0}; //   3

  c_p[x_a][47] = {  1,   5}; //   2
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {}; //   0
  c_d[x_a][47] = {  8,   3,   0}; //   3

  c_p[x_a][48] = {  1,   6}; //   2
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {}; //   0
  c_d[x_a][48] = {  8,   3,   0}; //   3

  c_p[x_a][49] = {  1,   6}; //   2
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {}; //   0
  c_d[x_a][49] = {  8,   3,   0}; //   3

  c_p[x_a][50] = {  0,   7}; //   2
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {}; //   0
  c_d[x_a][50] = {  7,   4,   0}; //   3

  c_p[x_a][51] = {  0,   7}; //   2
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {}; //   0
  c_d[x_a][51] = {  7,   4,   0}; //   3

  c_p[x_a][52] = {  0,   8}; //   2
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {}; //   0
  c_d[x_a][52] = {  7,   4,   0}; //   3

  c_p[x_a][53] = {  0,   8}; //   2
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {}; //   0
  c_d[x_a][53] = {  7,   4,   0}; //   3

  c_p[x_a][54] = {  1,   7}; //   2
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {}; //   0
  c_d[x_a][54] = {  7,   4,   0}; //   3

  c_p[x_a][55] = {  1,   7}; //   2
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {}; //   0
  c_d[x_a][55] = {  7,   4,   0}; //   3

  c_p[x_a][56] = {  1,   8}; //   2
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {}; //   0
  c_d[x_a][56] = {  7,   4,   0}; //   3

  c_p[x_a][57] = {  1,   8}; //   2
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {}; //   0
  c_d[x_a][57] = {  7,   4,   0}; //   3

  c_p[x_a][58] = {  9,  10}; //   2
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {}; //   0
  c_d[x_a][58] = {  7,   5,   6}; //   3

  c_p[x_a][59] = {  9,  10}; //   2
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {}; //   0
  c_d[x_a][59] = {  7,   5,   6}; //   3

  c_p[x_a][60] = {  9,  10}; //   2
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {}; //   0
  c_d[x_a][60] = {  7,   5,   6}; //   3

  c_p[x_a][61] = {  9,  11}; //   2
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {}; //   0
  c_d[x_a][61] = {  7,   5,   6}; //   3

  c_p[x_a][62] = {  9,  11}; //   2
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {}; //   0
  c_d[x_a][62] = {  7,   5,   6}; //   3

  c_p[x_a][63] = {  9,  11}; //   2
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {}; //   0
  c_d[x_a][63] = {  7,   5,   6}; //   3

  c_p[x_a][64] = { 12,  13}; //   2
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {}; //   0
  c_d[x_a][64] = {  9,   0,  10}; //   3

  c_p[x_a][65] = { 12,  13}; //   2
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {}; //   0
  c_d[x_a][65] = {  9,   0,  10}; //   3

  c_p[x_a][66] = { 12,  14}; //   2
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {}; //   0
  c_d[x_a][66] = {  9,   0,  10}; //   3

  c_p[x_a][67] = { 12,  14}; //   2
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {}; //   0
  c_d[x_a][67] = {  9,   0,  10}; //   3

  c_p[x_a][68] = { 15,  13}; //   2
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {}; //   0
  c_d[x_a][68] = {  9,   0,  10}; //   3

  c_p[x_a][69] = { 15,  13}; //   2
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {}; //   0
  c_d[x_a][69] = {  9,   0,  10}; //   3

  c_p[x_a][70] = { 15,  14}; //   2
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {}; //   0
  c_d[x_a][70] = {  9,   0,  10}; //   3

  c_p[x_a][71] = { 15,  14}; //   2
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {}; //   0
  c_d[x_a][71] = {  9,   0,  10}; //   3

  c_p[x_a][72] = {  0}; //   1
  c_f[x_a][72] = {  0}; //   1
  c_t[x_a][72] = {  8,   9}; //   2
  c_d[x_a][72] = {  0}; //   1

  c_p[x_a][73] = {  0}; //   1
  c_f[x_a][73] = {  0}; //   1
  c_t[x_a][73] = {  8,  10}; //   2
  c_d[x_a][73] = {  0}; //   1

  c_p[x_a][74] = {  0}; //   1
  c_f[x_a][74] = {  0}; //   1
  c_t[x_a][74] = {  8,   9}; //   2
  c_d[x_a][74] = {  0}; //   1

  c_p[x_a][75] = {  0}; //   1
  c_f[x_a][75] = {  0}; //   1
  c_t[x_a][75] = { 11,  10}; //   2
  c_d[x_a][75] = {  0}; //   1

  c_p[x_a][76] = {  1}; //   1
  c_f[x_a][76] = {  0}; //   1
  c_t[x_a][76] = {  8,   9}; //   2
  c_d[x_a][76] = {  0}; //   1

  c_p[x_a][77] = {  1}; //   1
  c_f[x_a][77] = {  0}; //   1
  c_t[x_a][77] = {  8,  10}; //   2
  c_d[x_a][77] = {  0}; //   1

  c_p[x_a][78] = {  1}; //   1
  c_f[x_a][78] = {  0}; //   1
  c_t[x_a][78] = {  8,   9}; //   2
  c_d[x_a][78] = {  0}; //   1

  c_p[x_a][79] = {  1}; //   1
  c_f[x_a][79] = {  0}; //   1
  c_t[x_a][79] = { 11,  10}; //   2
  c_d[x_a][79] = {  0}; //   1

  c_p[x_a][80] = {  0}; //   1
  c_f[x_a][80] = {  1}; //   1
  c_t[x_a][80] = { 12,  13}; //   2
  c_d[x_a][80] = {  0}; //   1

  c_p[x_a][81] = {  0}; //   1
  c_f[x_a][81] = {  1}; //   1
  c_t[x_a][81] = { 12,  13}; //   2
  c_d[x_a][81] = {  0}; //   1

  c_p[x_a][82] = {  0}; //   1
  c_f[x_a][82] = {  1}; //   1
  c_t[x_a][82] = { 14,  13}; //   2
  c_d[x_a][82] = {  0}; //   1

  c_p[x_a][83] = {  0}; //   1
  c_f[x_a][83] = {  1}; //   1
  c_t[x_a][83] = { 14,  15}; //   2
  c_d[x_a][83] = {  0}; //   1

  c_p[x_a][84] = {  1}; //   1
  c_f[x_a][84] = {  1}; //   1
  c_t[x_a][84] = { 12,  13}; //   2
  c_d[x_a][84] = {  0}; //   1

  c_p[x_a][85] = {  1}; //   1
  c_f[x_a][85] = {  1}; //   1
  c_t[x_a][85] = { 12,  13}; //   2
  c_d[x_a][85] = {  0}; //   1

  c_p[x_a][86] = {  1}; //   1
  c_f[x_a][86] = {  1}; //   1
  c_t[x_a][86] = { 14,  13}; //   2
  c_d[x_a][86] = {  0}; //   1

  c_p[x_a][87] = {  1}; //   1
  c_f[x_a][87] = {  1}; //   1
  c_t[x_a][87] = { 14,  15}; //   2
  c_d[x_a][87] = {  0}; //   1

  c_p[x_a][88] = {  2,   3}; //   2
  c_f[x_a][88] = {}; //   0
  c_t[x_a][88] = {  8}; //   1
  c_d[x_a][88] = {  1,   2}; //   2

  c_p[x_a][89] = {  2,   3}; //   2
  c_f[x_a][89] = {}; //   0
  c_t[x_a][89] = {  8}; //   1
  c_d[x_a][89] = {  1,   2}; //   2

  c_p[x_a][90] = {  2,   3}; //   2
  c_f[x_a][90] = {}; //   0
  c_t[x_a][90] = { 11}; //   1
  c_d[x_a][90] = {  1,   2}; //   2

  c_p[x_a][91] = {  2,   4}; //   2
  c_f[x_a][91] = {}; //   0
  c_t[x_a][91] = {  8}; //   1
  c_d[x_a][91] = {  1,   2}; //   2

  c_p[x_a][92] = {  2,   4}; //   2
  c_f[x_a][92] = {}; //   0
  c_t[x_a][92] = {  8}; //   1
  c_d[x_a][92] = {  1,   2}; //   2

  c_p[x_a][93] = {  2,   4}; //   2
  c_f[x_a][93] = {}; //   0
  c_t[x_a][93] = { 11}; //   1
  c_d[x_a][93] = {  1,   2}; //   2

  c_p[x_a][94] = {  0,   5}; //   2
  c_f[x_a][94] = {}; //   0
  c_t[x_a][94] = { 12}; //   1
  c_d[x_a][94] = {  3,   0}; //   2

  c_p[x_a][95] = {  0,   6}; //   2
  c_f[x_a][95] = {}; //   0
  c_t[x_a][95] = { 14}; //   1
  c_d[x_a][95] = {  3,   0}; //   2

  c_p[x_a][96] = {  1,   5}; //   2
  c_f[x_a][96] = {}; //   0
  c_t[x_a][96] = { 12}; //   1
  c_d[x_a][96] = {  3,   0}; //   2

  c_p[x_a][97] = {  1,   6}; //   2
  c_f[x_a][97] = {}; //   0
  c_t[x_a][97] = { 14}; //   1
  c_d[x_a][97] = {  3,   0}; //   2

  c_p[x_a][98] = {  0,   7}; //   2
  c_f[x_a][98] = {}; //   0
  c_t[x_a][98] = {  8}; //   1
  c_d[x_a][98] = {  4,   0}; //   2

  c_p[x_a][99] = {  0,   7}; //   2
  c_f[x_a][99] = {}; //   0
  c_t[x_a][99] = {  8}; //   1
  c_d[x_a][99] = {  4,   0}; //   2

  c_p[x_a][100] = {  0,   8}; //   2
  c_f[x_a][100] = {}; //   0
  c_t[x_a][100] = {  8}; //   1
  c_d[x_a][100] = {  4,   0}; //   2

  c_p[x_a][101] = {  0,   8}; //   2
  c_f[x_a][101] = {}; //   0
  c_t[x_a][101] = { 11}; //   1
  c_d[x_a][101] = {  4,   0}; //   2

  c_p[x_a][102] = {  1,   7}; //   2
  c_f[x_a][102] = {}; //   0
  c_t[x_a][102] = {  8}; //   1
  c_d[x_a][102] = {  4,   0}; //   2

  c_p[x_a][103] = {  1,   7}; //   2
  c_f[x_a][103] = {}; //   0
  c_t[x_a][103] = {  8}; //   1
  c_d[x_a][103] = {  4,   0}; //   2

  c_p[x_a][104] = {  1,   8}; //   2
  c_f[x_a][104] = {}; //   0
  c_t[x_a][104] = {  8}; //   1
  c_d[x_a][104] = {  4,   0}; //   2

  c_p[x_a][105] = {  1,   8}; //   2
  c_f[x_a][105] = {}; //   0
  c_t[x_a][105] = { 11}; //   1
  c_d[x_a][105] = {  4,   0}; //   2

  c_p[x_a][106] = {  9,  10}; //   2
  c_f[x_a][106] = {}; //   0
  c_t[x_a][106] = {  8}; //   1
  c_d[x_a][106] = {  5,   6}; //   2

  c_p[x_a][107] = {  9,  10}; //   2
  c_f[x_a][107] = {}; //   0
  c_t[x_a][107] = {  8}; //   1
  c_d[x_a][107] = {  5,   6}; //   2

  c_p[x_a][108] = {  9,  10}; //   2
  c_f[x_a][108] = {}; //   0
  c_t[x_a][108] = { 11}; //   1
  c_d[x_a][108] = {  5,   6}; //   2

  c_p[x_a][109] = {  9,  11}; //   2
  c_f[x_a][109] = {}; //   0
  c_t[x_a][109] = {  8}; //   1
  c_d[x_a][109] = {  5,   6}; //   2

  c_p[x_a][110] = {  9,  11}; //   2
  c_f[x_a][110] = {}; //   0
  c_t[x_a][110] = {  8}; //   1
  c_d[x_a][110] = {  5,   6}; //   2

  c_p[x_a][111] = {  9,  11}; //   2
  c_f[x_a][111] = {}; //   0
  c_t[x_a][111] = { 11}; //   1
  c_d[x_a][111] = {  5,   6}; //   2

  c_p[x_a][112] = {  0}; //   1
  c_f[x_a][112] = {  1}; //   1
  c_t[x_a][112] = { 12,  16}; //   2
  c_d[x_a][112] = {  0}; //   1

  c_p[x_a][113] = {  0}; //   1
  c_f[x_a][113] = {  1}; //   1
  c_t[x_a][113] = { 14,  17}; //   2
  c_d[x_a][113] = {  0}; //   1

  c_p[x_a][114] = {  1}; //   1
  c_f[x_a][114] = {  1}; //   1
  c_t[x_a][114] = { 12,  16}; //   2
  c_d[x_a][114] = {  0}; //   1

  c_p[x_a][115] = {  1}; //   1
  c_f[x_a][115] = {  1}; //   1
  c_t[x_a][115] = { 14,  17}; //   2
  c_d[x_a][115] = {  0}; //   1

  c_p[x_a][116] = {  0}; //   1
  c_f[x_a][116] = {  0}; //   1
  c_t[x_a][116] = {  8,  18}; //   2
  c_d[x_a][116] = {  0}; //   1

  c_p[x_a][117] = {  0}; //   1
  c_f[x_a][117] = {  0}; //   1
  c_t[x_a][117] = {  8,  19}; //   2
  c_d[x_a][117] = {  0}; //   1

  c_p[x_a][118] = {  0}; //   1
  c_f[x_a][118] = {  0}; //   1
  c_t[x_a][118] = {  8,  18}; //   2
  c_d[x_a][118] = {  0}; //   1

  c_p[x_a][119] = {  0}; //   1
  c_f[x_a][119] = {  0}; //   1
  c_t[x_a][119] = { 11,  19}; //   2
  c_d[x_a][119] = {  0}; //   1

  c_p[x_a][120] = {  1}; //   1
  c_f[x_a][120] = {  0}; //   1
  c_t[x_a][120] = {  8,  18}; //   2
  c_d[x_a][120] = {  0}; //   1

  c_p[x_a][121] = {  1}; //   1
  c_f[x_a][121] = {  0}; //   1
  c_t[x_a][121] = {  8,  19}; //   2
  c_d[x_a][121] = {  0}; //   1

  c_p[x_a][122] = {  1}; //   1
  c_f[x_a][122] = {  0}; //   1
  c_t[x_a][122] = {  8,  18}; //   2
  c_d[x_a][122] = {  0}; //   1

  c_p[x_a][123] = {  1}; //   1
  c_f[x_a][123] = {  0}; //   1
  c_t[x_a][123] = { 11,  19}; //   2
  c_d[x_a][123] = {  0}; //   1

  c_p[x_a][124] = { 12,  13}; //   2
  c_f[x_a][124] = {}; //   0
  c_t[x_a][124] = { 20}; //   1
  c_d[x_a][124] = {  0,  10}; //   2

  c_p[x_a][125] = { 12,  14}; //   2
  c_f[x_a][125] = {}; //   0
  c_t[x_a][125] = { 20}; //   1
  c_d[x_a][125] = {  0,  10}; //   2

  c_p[x_a][126] = { 15,  13}; //   2
  c_f[x_a][126] = {}; //   0
  c_t[x_a][126] = { 21}; //   1
  c_d[x_a][126] = {  0,  10}; //   2

  c_p[x_a][127] = { 15,  14}; //   2
  c_f[x_a][127] = {}; //   0
  c_t[x_a][127] = { 21}; //   1
  c_d[x_a][127] = {  0,  10}; //   2

  c_p[x_a][128] = {  0,  16}; //   2
  c_f[x_a][128] = {}; //   0
  c_t[x_a][128] = { 22}; //   1
  c_d[x_a][128] = { 10,   0}; //   2

  c_p[x_a][129] = {  0,  17}; //   2
  c_f[x_a][129] = {}; //   0
  c_t[x_a][129] = { 23}; //   1
  c_d[x_a][129] = { 10,   0}; //   2

  c_p[x_a][130] = {  1,  16}; //   2
  c_f[x_a][130] = {}; //   0
  c_t[x_a][130] = { 22}; //   1
  c_d[x_a][130] = { 10,   0}; //   2

  c_p[x_a][131] = {  1,  17}; //   2
  c_f[x_a][131] = {}; //   0
  c_t[x_a][131] = { 23}; //   1
  c_d[x_a][131] = { 10,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_130_gg_emepag
//  channel    0: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    1: 2v11(1, 2, 4, 8, 16, 32;   0,   0,  36)
//  channel    2: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    3: 2v11(1, 2, 4, 8, 16, 32;   0,  36,  36)
//  channel    4: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    5: 2v11(1, 2, 4, 8, 16, 32;  23,   0,  36)
//  channel    6: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    7: 2v11(1, 2, 4, 8, 16, 32;  23,  36,  36)
//  channel    8: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel    9: 2v11(1, 2, 4, 8, 32, 16;   0,  36,  36)
//  channel   10: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel   11: 2v11(1, 2, 4, 8, 32, 16;  23,  36,  36)
//  channel   12: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   13: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   14: 3yv1(1, 2, 4, 8, 16, 32;   0,   0,  36)
//  channel   15: 3yv1(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   16: 3yv1(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   17: 3yv1(1, 2, 4, 8, 16, 32;   0,  23,  36)
//  channel   18: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   19: 3yv1(1, 2, 32, 4, 8, 16;   0,  36,  36)
//  channel   20: 3yv1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel   21: 3yv1(1, 2, 32, 4, 8, 16;  23,  36,  36)
//  channel   22: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   23: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   24: 3yv1(1, 2, 16, 4, 8, 32;   0,  36,   0)
//  channel   25: 3yv1(1, 2, 16, 4, 8, 32;   0,  36,  36)
//  channel   26: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   27: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   28: 3yv1(1, 2, 16, 4, 8, 32;  23,  36,   0)
//  channel   29: 3yv1(1, 2, 16, 4, 8, 32;  23,  36,  36)
//  channel   30: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   31: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   32: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,  36)
//  channel   33: 3yv1(1, 2, 8, 4, 16, 32;   0,  23,   0)
//  channel   34: 3yv1(1, 2, 8, 4, 16, 32;   0,  23,   0)
//  channel   35: 3yv1(1, 2, 8, 4, 16, 32;   0,  23,  36)
//  channel   36: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   37: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   38: 4yyv(1, 2, 32, 4, 8, 16;   0,   0,  36)
//  channel   39: 4yyv(1, 2, 32, 4, 8, 16;   0,  23,   0)
//  channel   40: 4yyv(1, 2, 32, 4, 8, 16;   0,  23,   0)
//  channel   41: 4yyv(1, 2, 32, 4, 8, 16;   0,  23,  36)
//  channel   42: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   43: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   44: 4yyv(1, 2, 16, 32, 4, 8;   0,  36,   0)
//  channel   45: 4yyv(1, 2, 16, 32, 4, 8;   0,  36,  36)
//  channel   46: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   47: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   48: 4yyv(1, 2, 16, 32, 4, 8;  23,  36,   0)
//  channel   49: 4yyv(1, 2, 16, 32, 4, 8;  23,  36,  36)
//  channel   50: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   51: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   52: 4yyv(1, 2, 32, 16, 4, 8;   0,  36,   0)
//  channel   53: 4yyv(1, 2, 32, 16, 4, 8;   0,  36,  36)
//  channel   54: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   55: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   56: 4yyv(1, 2, 32, 16, 4, 8;  23,  36,   0)
//  channel   57: 4yyv(1, 2, 32, 16, 4, 8;  23,  36,  36)
//  channel   58: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   59: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   60: 4yyv(1, 2, 32, 8, 4, 16;   0,   0,  36)
//  channel   61: 4yyv(1, 2, 32, 8, 4, 16;   0,  23,   0)
//  channel   62: 4yyv(1, 2, 32, 8, 4, 16;   0,  23,   0)
//  channel   63: 4yyv(1, 2, 32, 8, 4, 16;   0,  23,  36)
//  channel   64: 42vv(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   65: 42vv(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   66: 42vv(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   67: 42vv(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   68: 42vv(1, 2, 4, 8, 16, 32;  36,   0,   0)
//  channel   69: 42vv(1, 2, 4, 8, 16, 32;  36,   0,  36)
//  channel   70: 42vv(1, 2, 4, 8, 16, 32;  36,  23,   0)
//  channel   71: 42vv(1, 2, 4, 8, 16, 32;  36,  23,  36)
//  channel   72: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   73: 12v1(1, 2, 32, 4, 8, 16;   0,   0,  36)
//  channel   74: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   75: 12v1(1, 2, 32, 4, 8, 16;   0,  36,  36)
//  channel   76: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel   77: 12v1(1, 2, 32, 4, 8, 16;  23,   0,  36)
//  channel   78: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel   79: 12v1(1, 2, 32, 4, 8, 16;  23,  36,  36)
//  channel   80: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   81: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   82: 12v1(1, 2, 16, 4, 8, 32;   0,  36,   0)
//  channel   83: 12v1(1, 2, 16, 4, 8, 32;   0,  36,  36)
//  channel   84: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   85: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   86: 12v1(1, 2, 16, 4, 8, 32;  23,  36,   0)
//  channel   87: 12v1(1, 2, 16, 4, 8, 32;  23,  36,  36)
//  channel   88: 13yv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   89: 13yv(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   90: 13yv(1, 2, 32, 4, 8, 16;   0,   0,  36)
//  channel   91: 13yv(1, 2, 32, 4, 8, 16;   0,  23,   0)
//  channel   92: 13yv(1, 2, 32, 4, 8, 16;   0,  23,   0)
//  channel   93: 13yv(1, 2, 32, 4, 8, 16;   0,  23,  36)
//  channel   94: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   95: 13yv(1, 2, 16, 32, 4, 8;   0,  36,  36)
//  channel   96: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   97: 13yv(1, 2, 16, 32, 4, 8;  23,  36,  36)
//  channel   98: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   99: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel  100: 13yv(1, 2, 32, 16, 4, 8;   0,  36,   0)
//  channel  101: 13yv(1, 2, 32, 16, 4, 8;   0,  36,  36)
//  channel  102: 13yv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel  103: 13yv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel  104: 13yv(1, 2, 32, 16, 4, 8;  23,  36,   0)
//  channel  105: 13yv(1, 2, 32, 16, 4, 8;  23,  36,  36)
//  channel  106: 13yv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel  107: 13yv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel  108: 13yv(1, 2, 32, 8, 4, 16;   0,   0,  36)
//  channel  109: 13yv(1, 2, 32, 8, 4, 16;   0,  23,   0)
//  channel  110: 13yv(1, 2, 32, 8, 4, 16;   0,  23,   0)
//  channel  111: 13yv(1, 2, 32, 8, 4, 16;   0,  23,  36)
//  channel  112: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel  113: 112v(1, 2, 16, 32, 4, 8;   0,  36,  36)
//  channel  114: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel  115: 112v(1, 2, 16, 32, 4, 8;  23,  36,  36)
//  channel  116: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel  117: 112v(1, 2, 32, 16, 4, 8;   0,   0,  36)
//  channel  118: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel  119: 112v(1, 2, 32, 16, 4, 8;   0,  36,  36)
//  channel  120: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel  121: 112v(1, 2, 32, 16, 4, 8;  23,   0,  36)
//  channel  122: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel  123: 112v(1, 2, 32, 16, 4, 8;  23,  36,  36)
//  channel  124: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel  125: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel  126: 2v2v(1, 2, 4, 8, 16, 32;  36,   0,  36)
//  channel  127: 2v2v(1, 2, 4, 8, 16, 32;  36,  23,  36)
//  channel  128: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel  129: 2v2v(1, 2, 16, 32, 4, 8;   0,  36,  36)
//  channel  130: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel  131: 2v2v(1, 2, 16, 32, 4, 8;  23,  36,  36)
