#include "header.hpp"

#include "ppeexexne04.phasespace.set.hpp"

void ppeexexne04_phasespace_set::ax_psp_240_uc_emepepvedc(int x_a){
  static Logger logger("ppeexexne04_phasespace_set::ax_psp_240_uc_emepepvedc");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(33);
  needed_v_smin[x_a].resize(33);
  needed_v_smin[x_a][  0] = {   0,   10,   11,   12,   22,   23,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   54,   55,   58,   59,   62,   63}; //  26
  needed_v_smin[x_a][  1] = {   0,   12}; //   2
  needed_v_smin[x_a][  2] = {   0,    1,   12,   13}; //   4
  needed_v_smin[x_a][  3] = {   1,    2,    3,    8,    9,   13,   14,   15,   20,   21,   24,   25,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  30
  needed_v_smin[x_a][  4] = {   1,   13}; //   2
  needed_v_smin[x_a][  5] = {   2,    3,   14,   15}; //   4
  needed_v_smin[x_a][  6] = {   2,    3,    6,    7,   14,   15,   18,   19}; //   8
  needed_v_smin[x_a][  7] = {   4,    8,    9,   16,   20,   21,   24,   25,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  26
  needed_v_smin[x_a][  8] = {   4,   16}; //   2
  needed_v_smin[x_a][  9] = {   4,    5,   16,   17}; //   4
  needed_v_smin[x_a][ 10] = {   5,    6,    7,   10,   11,   17,   18,   19,   22,   23,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   54,   55,   58,   59,   62,   63}; //  30
  needed_v_smin[x_a][ 11] = {   5,   17}; //   2
  needed_v_smin[x_a][ 12] = {   6,    7,   18,   19}; //   4
  needed_v_smin[x_a][ 13] = {   8,    9,   20,   21}; //   4
  needed_v_smin[x_a][ 14] = {  10,   11,   22,   23}; //   4
  needed_v_smin[x_a][ 15] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  24
  needed_v_smin[x_a][ 16] = {  24,   25,   40,   41,   56,   57,   60,   61,   32,   33}; //  10
  needed_v_smin[x_a][ 17] = {  24,   25,   32,   33,   40,   41}; //   6
  needed_v_smin[x_a][ 18] = {  26,   27,   42,   43,   58,   59,   62,   63,   34,   35}; //  10
  needed_v_smin[x_a][ 19] = {  26,   27,   34,   35,   42,   43}; //   6
  needed_v_smin[x_a][ 20] = {  28,   29,   44,   45,   36,   37}; //   6
  needed_v_smin[x_a][ 21] = {  28,   29,   36,   37,   44,   45}; //   6
  needed_v_smin[x_a][ 22] = {  30,   31,   46,   47,   38,   39}; //   6
  needed_v_smin[x_a][ 23] = {  30,   31,   38,   39,   46,   47}; //   6
  needed_v_smin[x_a][ 24] = {  48,   49,   56,   57}; //   4
  needed_v_smin[x_a][ 25] = {  50,   51,   58,   59}; //   4
  needed_v_smin[x_a][ 26] = {  48,   49}; //   2
  needed_v_smin[x_a][ 27] = {  50,   51}; //   2
  needed_v_smin[x_a][ 28] = {  52,   53,   54,   55}; //   4
  needed_v_smin[x_a][ 29] = {  52,   53}; //   2
  needed_v_smin[x_a][ 30] = {  54,   55}; //   2
  needed_v_smin[x_a][ 31] = {  60,   61}; //   2
  needed_v_smin[x_a][ 32] = {  62,   63}; //   2

  v_smax[x_a].resize(37);
  needed_v_smax[x_a].resize(37);
  needed_v_smax[x_a][  0] = {   0,   10,   11,   12,   22,   23,   26,   27,   34,   35,   42,   43}; //  12
  needed_v_smax[x_a][  1] = {   0,    1,   12,   13}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  24
  needed_v_smax[x_a][  3] = {   1,    2,    3,   13,   14,   15,   28,   29,   36,   37,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  20
  needed_v_smax[x_a][  4] = {   2,    3,    6,    7,   14,   15,   18,   19}; //   8
  needed_v_smax[x_a][  5] = {   4,    8,    9,   16,   20,   21,   24,   25,   32,   33,   40,   41}; //  12
  needed_v_smax[x_a][  6] = {   4,    5,   16,   17}; //   4
  needed_v_smax[x_a][  7] = {   5,    6,    7,   17,   18,   19,   30,   31,   38,   39,   46,   47,   50,   51,   54,   55,   58,   59,   62,   63}; //  20
  needed_v_smax[x_a][  8] = {   8,    9,   20,   21,   32,   33}; //   6
  needed_v_smax[x_a][  9] = {  10,   11,   22,   23,   34,   35}; //   6
  needed_v_smax[x_a][ 10] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  48
  needed_v_smax[x_a][ 11] = {  24,   25,   40,   41}; //   4
  needed_v_smax[x_a][ 12] = {  24,   25,   40,   41}; //   4
  needed_v_smax[x_a][ 13] = {  26,   27,   42,   43}; //   4
  needed_v_smax[x_a][ 14] = {  26,   27,   42,   43}; //   4
  needed_v_smax[x_a][ 15] = {  28,   29,   44,   45}; //   4
  needed_v_smax[x_a][ 16] = {  28,   29,   44,   45}; //   4
  needed_v_smax[x_a][ 17] = {  30,   31,   46,   47}; //   4
  needed_v_smax[x_a][ 18] = {  30,   31,   46,   47}; //   4
  needed_v_smax[x_a][ 19] = {  36,   37,   52,   53,   60,   61}; //   6
  needed_v_smax[x_a][ 20] = {  38,   39,   54,   55,   62,   63}; //   6
  needed_v_smax[x_a][ 21] = {  48,   49,   56,   57}; //   4
  needed_v_smax[x_a][ 22] = {  48,   49,   56,   57}; //   4
  needed_v_smax[x_a][ 23] = {  50,   51,   58,   59}; //   4
  needed_v_smax[x_a][ 24] = {  50,   51,   58,   59}; //   4
  needed_v_smax[x_a][ 25] = {  56,   57}; //   2
  needed_v_smax[x_a][ 26] = {  58,   59}; //   2
  needed_v_smax[x_a][ 27] = {  60,   61,   32,   33}; //   4
  needed_v_smax[x_a][ 28] = {  62,   63,   34,   35}; //   4
  needed_v_smax[x_a][ 29] = {  36,   37}; //   2
  needed_v_smax[x_a][ 30] = {  38,   39}; //   2
  needed_v_smax[x_a][ 31] = {  48,   49,   52,   53}; //   4
  needed_v_smax[x_a][ 32] = {  50,   51,   54,   55}; //   4
  needed_v_smax[x_a][ 33] = {  52,   53}; //   2
  needed_v_smax[x_a][ 34] = {  54,   55}; //   2
  needed_v_smax[x_a][ 35] = {  60,   61}; //   2
  needed_v_smax[x_a][ 36] = {  62,   63}; //   2

  g_p[x_a].resize(46);
  needed_g_p[x_a].resize(46);
  needed_g_p[x_a][0] = {   0,   10,   11,   12,   22,   23,   26,   27,   34,   35,   42,   43}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1,   12,   13}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   13,   15,   29,   37,   45,   49,   53,   57,   61}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][4] = {   1,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][5] = {   2,   14,   28,   36,   44,   48,   52,   56,   60}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {   2,    3,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   2,    3,    6,    7,   14,   15,   18,   19}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax2");
  needed_g_p[x_a][8] = {   4,    8,    9,   16,   20,   21,   24,   25,   32,   33,   40,   41}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax5");
  needed_g_p[x_a][9] = {   4,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   4,    5,   16,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax2");
  needed_g_p[x_a][11] = {   5,    7,   17,   19,   31,   39,   47,   51,   55,   59,   63}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax7");
  needed_g_p[x_a][12] = {   5,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax6");
  needed_g_p[x_a][13] = {   6,   18,   30,   38,   46,   50,   54,   58,   62}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][14] = {   6,    7,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax4");
  needed_g_p[x_a][15] = {   8,   20,   32}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax8");
  needed_g_p[x_a][16] = {   8,    9,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax2");
  needed_g_p[x_a][17] = {   9,   21,   33}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax8");
  needed_g_p[x_a][18] = {  10,   22,   34}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax9");
  needed_g_p[x_a][19] = {  10,   11,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin14_smax2");
  needed_g_p[x_a][20] = {  11,   23,   35}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax9");
  needed_g_p[x_a][21] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax10");
  needed_g_p[x_a][22] = {  24,   25,   40,   41}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax11");
  needed_g_p[x_a][23] = {  24,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax12");
  needed_g_p[x_a][24] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax10");
  needed_g_p[x_a][25] = {  25,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax12");
  needed_g_p[x_a][26] = {  26,   27,   42,   43}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax13");
  needed_g_p[x_a][27] = {  26,   42}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax14");
  needed_g_p[x_a][28] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax10");
  needed_g_p[x_a][29] = {  27,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax14");
  needed_g_p[x_a][30] = {  28,   29,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax15");
  needed_g_p[x_a][31] = {  28,   29,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax16");
  needed_g_p[x_a][32] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax10");
  needed_g_p[x_a][33] = {  30,   31,   46,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax17");
  needed_g_p[x_a][34] = {  30,   31,   46,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax18");
  needed_g_p[x_a][35] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax10");
  needed_g_p[x_a][36] = {  36,   37,   52,   53,   60,   61}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax19");
  needed_g_p[x_a][37] = {  38,   39,   54,   55,   62,   63}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax20");
  needed_g_p[x_a][38] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax21");
  needed_g_p[x_a][39] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax22");
  needed_g_p[x_a][40] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax23");
  needed_g_p[x_a][41] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax24");
  needed_g_p[x_a][42] = {  56,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax25");
  needed_g_p[x_a][43] = {  58,   59}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax26");
  needed_g_p[x_a][44] = {  60,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax27");
  needed_g_p[x_a][45] = {  62,   63}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax28");

  g_f[x_a].resize(17);
  needed_g_f[x_a].resize(17);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax10");
  needed_g_f[x_a][1] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax27");
  needed_g_f[x_a][2] = {  32,   33,   40,   41}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax10");
  needed_g_f[x_a][3] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax28");
  needed_g_f[x_a][4] = {  34,   35,   42,   43}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax10");
  needed_g_f[x_a][5] = {  36,   37}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax29");
  needed_g_f[x_a][6] = {  36,   37,   44,   45}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax10");
  needed_g_f[x_a][7] = {  38,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax30");
  needed_g_f[x_a][8] = {  38,   39,   46,   47}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax10");
  needed_g_f[x_a][9] = {  48,   49}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax31");
  needed_g_f[x_a][10] = {  50,   51}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax32");
  needed_g_f[x_a][11] = {  52,   53}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax33");
  needed_g_f[x_a][12] = {  52,   53}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin29_smax31");
  needed_g_f[x_a][13] = {  54,   55}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin28_smax34");
  needed_g_f[x_a][14] = {  54,   55}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin30_smax32");
  needed_g_f[x_a][15] = {  60,   61}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin31_smax35");
  needed_g_f[x_a][16] = {  62,   63}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin32_smax36");

  g_t[x_a].resize(24);
  needed_g_t[x_a].resize(24);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  48
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {  32,   33,   40,   41}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__12_112");
  needed_g_t[x_a][3] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_13__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_13__64_48");
  needed_g_t[x_a][4] = {  34,   35,   42,   43}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__20_104");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__20_104");
  needed_g_t[x_a][5] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_21__64_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_21__64_40");
  needed_g_t[x_a][6] = {  36,   37,   44,   45}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__48_76");
  needed_g_t[x_a][7] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_49__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_49__64_12");
  needed_g_t[x_a][8] = {  38,   39,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__40_84");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__40_84");
  needed_g_t[x_a][9] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_41__64_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_41__64_20");
  needed_g_t[x_a][10] = {  48,   49,   52,   53}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][11] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__140_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__140_64");
  needed_g_t[x_a][12] = {  50,   51,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_212");
  needed_g_t[x_a][13] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__148_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__148_64");
  needed_g_t[x_a][14] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][15] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__49_14__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__49_14__64_128");
  needed_g_t[x_a][16] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_192");
  needed_g_t[x_a][17] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__41_22__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__41_22__64_128");
  needed_g_t[x_a][18] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__112_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__112_140");
  needed_g_t[x_a][19] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__104_148");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__104_148");
  needed_g_t[x_a][20] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");
  needed_g_t[x_a][21] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_14__112_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_14__112_128");
  needed_g_t[x_a][22] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__20_232");
  needed_g_t[x_a][23] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_22__104_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_22__104_128");

  g_d[x_a].resize(26);
  needed_g_d[x_a].resize(26);
  needed_g_d[x_a][0] = {   0,    1,   12,   13}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][1] = {   0,   12}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][2] = {   0,   10,   11,   12,   22,   23,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   54,   55,   58,   59,   62,   63}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][3] = {   1,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][4] = {   1,    2,    3,    8,    9,   13,   14,   15,   20,   21,   24,   25,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][5] = {   2,    3,    6,    7,   14,   15,   18,   19}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   2,    3,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][7] = {   4,    5,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][8] = {   4,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][9] = {   4,    8,    9,   16,   20,   21,   24,   25,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][10] = {   5,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][11] = {   5,    6,    7,   10,   11,   17,   18,   19,   22,   23,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   54,   55,   58,   59,   62,   63}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][12] = {   6,    7,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][13] = {   8,    9,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][14] = {  10,   11,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");
  needed_g_d[x_a][15] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][16] = {  24,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][17] = {  24,   25,   40,   41,   56,   57,   60,   61}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][18] = {  26,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__20_104");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__20_104");
  needed_g_d[x_a][19] = {  26,   27,   42,   43,   58,   59,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_104__64_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_104__64_40");
  needed_g_d[x_a][20] = {  28,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][21] = {  28,   29,   44,   45}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][22] = {  30,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__40_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__40_84");
  needed_g_d[x_a][23] = {  30,   31,   46,   47}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][24] = {  48,   49,   56,   57}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][25] = {  50,   51,   58,   59}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   4,   2}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   3,   4}; //   3

  c_p[x_a][2] = {  5,   6,   7}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  5,   6,   4}; //   3

  c_p[x_a][3] = {  3,   6,   7}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  5,   6,   4}; //   3

  c_p[x_a][4] = {  8,   9,  10}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  7,   8,   9}; //   3

  c_p[x_a][5] = { 11,  12,  10}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  7,  10,  11}; //   3

  c_p[x_a][6] = { 13,  14,   7}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = {  5,  12,  11}; //   3

  c_p[x_a][7] = { 11,  14,   7}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = {  5,  12,  11}; //   3

  c_p[x_a][8] = {  8,  15,  16}; //   3
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  0,   1}; //   2
  c_d[x_a][8] = { 13,   4,   9}; //   3

  c_p[x_a][9] = {  8,  17,  16}; //   3
  c_f[x_a][9] = {  0}; //   1
  c_t[x_a][9] = {  0,   1}; //   2
  c_d[x_a][9] = { 13,   4,   9}; //   3

  c_p[x_a][10] = {  0,  18,  19}; //   3
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = { 14,  11,   2}; //   3

  c_p[x_a][11] = {  0,  20,  19}; //   3
  c_f[x_a][11] = {  0}; //   1
  c_t[x_a][11] = {  0,   1}; //   2
  c_d[x_a][11] = { 14,  11,   2}; //   3

  c_p[x_a][12] = {  0,   1,   2,  21}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 15,   0,   1,   2}; //   4

  c_p[x_a][13] = {  3,   4,   2,  21}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 15,   0,   3,   4}; //   4

  c_p[x_a][14] = {  5,   6,   7,  21}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 15,   5,   6,   4}; //   4

  c_p[x_a][15] = {  3,   6,   7,  21}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 15,   5,   6,   4}; //   4

  c_p[x_a][16] = {  8,   9,  10,  21}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 15,   7,   8,   9}; //   4

  c_p[x_a][17] = { 11,  12,  10,  21}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 15,   7,  10,  11}; //   4

  c_p[x_a][18] = { 13,  14,   7,  21}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 15,   5,  12,  11}; //   4

  c_p[x_a][19] = { 11,  14,   7,  21}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 15,   5,  12,  11}; //   4

  c_p[x_a][20] = {  8,  15,  16,  21}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = { 15,  13,   4,   9}; //   4

  c_p[x_a][21] = {  8,  17,  16,  21}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = { 15,  13,   4,   9}; //   4

  c_p[x_a][22] = {  0,  18,  19,  21}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = { 15,  14,  11,   2}; //   4

  c_p[x_a][23] = {  0,  20,  19,  21}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = { 15,  14,  11,   2}; //   4

  c_p[x_a][24] = {  8,  22,  23,  24}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = { 16,   4,  17,   9}; //   4

  c_p[x_a][25] = {  8,  22,  25,  24}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = { 16,   4,  17,   9}; //   4

  c_p[x_a][26] = {  0,  26,  27,  28}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = { 18,  11,  19,   2}; //   4

  c_p[x_a][27] = {  0,  26,  29,  28}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = { 18,  11,  19,   2}; //   4

  c_p[x_a][28] = {  5,  30,  31,  32}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = { 20,   9,  21,   4}; //   4

  c_p[x_a][29] = {  3,  30,  31,  32}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = { 20,   9,  21,   4}; //   4

  c_p[x_a][30] = { 13,  33,  34,  35}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = { 22,   2,  23,  11}; //   4

  c_p[x_a][31] = { 11,  33,  34,  35}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = { 22,   2,  23,  11}; //   4

  c_p[x_a][32] = {  8,  15}; //   2
  c_f[x_a][32] = {  1,   2}; //   2
  c_t[x_a][32] = {  0,   2,   3}; //   3
  c_d[x_a][32] = {  4,   9}; //   2

  c_p[x_a][33] = {  8,  17}; //   2
  c_f[x_a][33] = {  1,   2}; //   2
  c_t[x_a][33] = {  0,   2,   3}; //   3
  c_d[x_a][33] = {  4,   9}; //   2

  c_p[x_a][34] = {  0,  18}; //   2
  c_f[x_a][34] = {  3,   4}; //   2
  c_t[x_a][34] = {  0,   4,   5}; //   3
  c_d[x_a][34] = { 11,   2}; //   2

  c_p[x_a][35] = {  0,  20}; //   2
  c_f[x_a][35] = {  3,   4}; //   2
  c_t[x_a][35] = {  0,   4,   5}; //   3
  c_d[x_a][35] = { 11,   2}; //   2

  c_p[x_a][36] = {  5,  36}; //   2
  c_f[x_a][36] = {  5,   6}; //   2
  c_t[x_a][36] = {  0,   6,   7}; //   3
  c_d[x_a][36] = {  9,   4}; //   2

  c_p[x_a][37] = {  3,  36}; //   2
  c_f[x_a][37] = {  5,   6}; //   2
  c_t[x_a][37] = {  0,   6,   7}; //   3
  c_d[x_a][37] = {  9,   4}; //   2

  c_p[x_a][38] = { 13,  37}; //   2
  c_f[x_a][38] = {  7,   8}; //   2
  c_t[x_a][38] = {  0,   8,   9}; //   3
  c_d[x_a][38] = {  2,  11}; //   2

  c_p[x_a][39] = { 11,  37}; //   2
  c_f[x_a][39] = {  7,   8}; //   2
  c_t[x_a][39] = {  0,   8,   9}; //   3
  c_d[x_a][39] = {  2,  11}; //   2

  c_p[x_a][40] = {  8,  22,  23}; //   3
  c_f[x_a][40] = {  2}; //   1
  c_t[x_a][40] = {  0,   2}; //   2
  c_d[x_a][40] = {  4,  17,   9}; //   3

  c_p[x_a][41] = {  8,  22,  25}; //   3
  c_f[x_a][41] = {  2}; //   1
  c_t[x_a][41] = {  0,   2}; //   2
  c_d[x_a][41] = {  4,  17,   9}; //   3

  c_p[x_a][42] = {  0,  26,  27}; //   3
  c_f[x_a][42] = {  4}; //   1
  c_t[x_a][42] = {  0,   4}; //   2
  c_d[x_a][42] = { 11,  19,   2}; //   3

  c_p[x_a][43] = {  0,  26,  29}; //   3
  c_f[x_a][43] = {  4}; //   1
  c_t[x_a][43] = {  0,   4}; //   2
  c_d[x_a][43] = { 11,  19,   2}; //   3

  c_p[x_a][44] = {  5,  30,  31}; //   3
  c_f[x_a][44] = {  6}; //   1
  c_t[x_a][44] = {  0,   6}; //   2
  c_d[x_a][44] = {  9,  21,   4}; //   3

  c_p[x_a][45] = {  3,  30,  31}; //   3
  c_f[x_a][45] = {  6}; //   1
  c_t[x_a][45] = {  0,   6}; //   2
  c_d[x_a][45] = {  9,  21,   4}; //   3

  c_p[x_a][46] = { 13,  33,  34}; //   3
  c_f[x_a][46] = {  8}; //   1
  c_t[x_a][46] = {  0,   8}; //   2
  c_d[x_a][46] = {  2,  23,  11}; //   3

  c_p[x_a][47] = { 11,  33,  34}; //   3
  c_f[x_a][47] = {  8}; //   1
  c_t[x_a][47] = {  0,   8}; //   2
  c_d[x_a][47] = {  2,  23,  11}; //   3

  c_p[x_a][48] = {  5,  38,  39}; //   3
  c_f[x_a][48] = {  9}; //   1
  c_t[x_a][48] = { 10,  11}; //   2
  c_d[x_a][48] = {  9,  24,   4}; //   3

  c_p[x_a][49] = {  3,  38,  39}; //   3
  c_f[x_a][49] = {  9}; //   1
  c_t[x_a][49] = { 10,  11}; //   2
  c_d[x_a][49] = {  9,  24,   4}; //   3

  c_p[x_a][50] = { 13,  40,  41}; //   3
  c_f[x_a][50] = { 10}; //   1
  c_t[x_a][50] = { 12,  13}; //   2
  c_d[x_a][50] = {  2,  25,  11}; //   3

  c_p[x_a][51] = { 11,  40,  41}; //   3
  c_f[x_a][51] = { 10}; //   1
  c_t[x_a][51] = { 12,  13}; //   2
  c_d[x_a][51] = {  2,  25,  11}; //   3

  c_p[x_a][52] = {  5,  36}; //   2
  c_f[x_a][52] = { 11,  12}; //   2
  c_t[x_a][52] = { 10,  14,  15}; //   3
  c_d[x_a][52] = {  9,   4}; //   2

  c_p[x_a][53] = {  3,  36}; //   2
  c_f[x_a][53] = { 11,  12}; //   2
  c_t[x_a][53] = { 10,  14,  15}; //   3
  c_d[x_a][53] = {  9,   4}; //   2

  c_p[x_a][54] = { 13,  37}; //   2
  c_f[x_a][54] = { 13,  14}; //   2
  c_t[x_a][54] = { 12,  16,  17}; //   3
  c_d[x_a][54] = {  2,  11}; //   2

  c_p[x_a][55] = { 11,  37}; //   2
  c_f[x_a][55] = { 13,  14}; //   2
  c_t[x_a][55] = { 12,  16,  17}; //   3
  c_d[x_a][55] = {  2,  11}; //   2

  c_p[x_a][56] = {  5,  38,  39,  42}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = { 18}; //   1
  c_d[x_a][56] = { 17,   9,  24,   4}; //   4

  c_p[x_a][57] = {  3,  38,  39,  42}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = { 18}; //   1
  c_d[x_a][57] = { 17,   9,  24,   4}; //   4

  c_p[x_a][58] = { 13,  40,  41,  43}; //   4
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = { 19}; //   1
  c_d[x_a][58] = { 19,   2,  25,  11}; //   4

  c_p[x_a][59] = { 11,  40,  41,  43}; //   4
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = { 19}; //   1
  c_d[x_a][59] = { 19,   2,  25,  11}; //   4

  c_p[x_a][60] = {  5,  36,  44}; //   3
  c_f[x_a][60] = { 15}; //   1
  c_t[x_a][60] = { 20,  21}; //   2
  c_d[x_a][60] = { 17,   9,   4}; //   3

  c_p[x_a][61] = {  3,  36,  44}; //   3
  c_f[x_a][61] = { 15}; //   1
  c_t[x_a][61] = { 20,  21}; //   2
  c_d[x_a][61] = { 17,   9,   4}; //   3

  c_p[x_a][62] = { 13,  37,  45}; //   3
  c_f[x_a][62] = { 16}; //   1
  c_t[x_a][62] = { 22,  23}; //   2
  c_d[x_a][62] = { 19,   2,  11}; //   3

  c_p[x_a][63] = { 11,  37,  45}; //   3
  c_f[x_a][63] = { 16}; //   1
  c_t[x_a][63] = { 22,  23}; //   2
  c_d[x_a][63] = { 19,   2,  11}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_uc_emepepvedc
//  channel    0: 4yyv11(1, 2, 16, 4, 8, 32, 64, 128;  24,   0,  24,   0,   0)
//  channel    1: 4yyv11(1, 2, 16, 32, 4, 8, 64, 128;  23,   0,  24,   0,   0)
//  channel    2: 4yyv11(1, 2, 32, 16, 4, 8, 64, 128;   0,   0,  24,   0,   0)
//  channel    3: 4yyv11(1, 2, 32, 16, 4, 8, 64, 128;  23,   0,  24,   0,   0)
//  channel    4: 4yyv11(1, 2, 8, 4, 16, 32, 64, 128;  24,   0,  24,   0,   0)
//  channel    5: 4yyv11(1, 2, 8, 32, 4, 16, 64, 128;  23,   0,  24,   0,   0)
//  channel    6: 4yyv11(1, 2, 32, 8, 4, 16, 64, 128;   0,   0,  24,   0,   0)
//  channel    7: 4yyv11(1, 2, 32, 8, 4, 16, 64, 128;  23,   0,  24,   0,   0)
//  channel    8: 42vv11(1, 2, 4, 8, 16, 32, 64, 128;  24,   0,  24,   0,   0)
//  channel    9: 42vv11(1, 2, 4, 8, 16, 32, 64, 128;  24,  23,  24,   0,   0)
//  channel   10: 42vv11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,  24,   0,   0)
//  channel   11: 42vv11(1, 2, 4, 16, 8, 32, 64, 128;  24,  23,  24,   0,   0)
//  channel   12: 5yyyv1(1, 2, 64, 16, 4, 8, 32, 128;  24,   0,  24,   0,   0)
//  channel   13: 5yyyv1(1, 2, 64, 16, 32, 4, 8, 128;  23,   0,  24,   0,   0)
//  channel   14: 5yyyv1(1, 2, 64, 32, 16, 4, 8, 128;   0,   0,  24,   0,   0)
//  channel   15: 5yyyv1(1, 2, 64, 32, 16, 4, 8, 128;  23,   0,  24,   0,   0)
//  channel   16: 5yyyv1(1, 2, 64, 8, 4, 16, 32, 128;  24,   0,  24,   0,   0)
//  channel   17: 5yyyv1(1, 2, 64, 8, 32, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel   18: 5yyyv1(1, 2, 64, 32, 8, 4, 16, 128;   0,   0,  24,   0,   0)
//  channel   19: 5yyyv1(1, 2, 64, 32, 8, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel   20: 5y2vv1(1, 2, 64, 4, 8, 16, 32, 128;  24,   0,  24,   0,   0)
//  channel   21: 5y2vv1(1, 2, 64, 4, 8, 16, 32, 128;  24,  23,  24,   0,   0)
//  channel   22: 5y2vv1(1, 2, 64, 4, 16, 8, 32, 128;  24,   0,  24,   0,   0)
//  channel   23: 5y2vv1(1, 2, 64, 4, 16, 8, 32, 128;  24,  23,  24,   0,   0)
//  channel   24: 52vyv1(1, 2, 4, 8, 64, 16, 32, 128;  24,   0,   0,   0,   0)
//  channel   25: 52vyv1(1, 2, 4, 8, 64, 16, 32, 128;  24,   0,  23,   0,   0)
//  channel   26: 52vyv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,   0,   0,   0)
//  channel   27: 52vyv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,  23,   0,   0)
//  channel   28: 52vyv1(1, 2, 16, 32, 64, 4, 8, 128;   0,   0,  24,   0,   0)
//  channel   29: 52vyv1(1, 2, 16, 32, 64, 4, 8, 128;  23,   0,  24,   0,   0)
//  channel   30: 52vyv1(1, 2, 8, 32, 64, 4, 16, 128;   0,   0,  24,   0,   0)
//  channel   31: 52vyv1(1, 2, 8, 32, 64, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel   32: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  24,   0,   0,   0,   0)
//  channel   33: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  24,  23,   0,   0,   0)
//  channel   34: 2v2v11(1, 2, 4, 16, 8, 32, 64, 128;  24,   0,   0,   0,   0)
//  channel   35: 2v2v11(1, 2, 4, 16, 8, 32, 64, 128;  24,  23,   0,   0,   0)
//  channel   36: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;   0,  24,   0,   0,   0)
//  channel   37: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;  23,  24,   0,   0,   0)
//  channel   38: 2v2v11(1, 2, 8, 32, 4, 16, 64, 128;   0,  24,   0,   0,   0)
//  channel   39: 2v2v11(1, 2, 8, 32, 4, 16, 64, 128;  23,  24,   0,   0,   0)
//  channel   40: 2v3yv1(1, 2, 4, 8, 64, 16, 32, 128;  24,   0,   0,   0,   0)
//  channel   41: 2v3yv1(1, 2, 4, 8, 64, 16, 32, 128;  24,   0,  23,   0,   0)
//  channel   42: 2v3yv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,   0,   0,   0)
//  channel   43: 2v3yv1(1, 2, 4, 16, 64, 8, 32, 128;  24,   0,  23,   0,   0)
//  channel   44: 2v3yv1(1, 2, 16, 32, 64, 4, 8, 128;   0,   0,  24,   0,   0)
//  channel   45: 2v3yv1(1, 2, 16, 32, 64, 4, 8, 128;  23,   0,  24,   0,   0)
//  channel   46: 2v3yv1(1, 2, 8, 32, 64, 4, 16, 128;   0,   0,  24,   0,   0)
//  channel   47: 2v3yv1(1, 2, 8, 32, 64, 4, 16, 128;  23,   0,  24,   0,   0)
//  channel   48: 2v13yv(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  24,   0,   0)
//  channel   49: 2v13yv(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  24,   0,   0)
//  channel   50: 2v13yv(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   51: 2v13yv(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   52: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;   0,  24,   0,   0,   0)
//  channel   53: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;  23,  24,   0,   0,   0)
//  channel   54: 2v112v(1, 2, 8, 32, 64, 128, 4, 16;   0,  24,   0,   0,   0)
//  channel   55: 2v112v(1, 2, 8, 32, 64, 128, 4, 16;  23,  24,   0,   0,   0)
//  channel   56: 3yv3yv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  24,   0,   0)
//  channel   57: 3yv3yv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  24,   0,   0)
//  channel   58: 3yv3yv(1, 2, 64, 8, 32, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   59: 3yv3yv(1, 2, 64, 8, 32, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   60: 3yv12v(1, 2, 64, 16, 32, 128, 4, 8;   0,  24,   0,   0,   0)
//  channel   61: 3yv12v(1, 2, 64, 16, 32, 128, 4, 8;  23,  24,   0,   0,   0)
//  channel   62: 3yv12v(1, 2, 64, 8, 32, 128, 4, 16;   0,  24,   0,   0,   0)
//  channel   63: 3yv12v(1, 2, 64, 8, 32, 128, 4, 16;  23,  24,   0,   0,   0)
