#include "header.hpp"

#include "ppeexexne04.phasespace.set.hpp"

void ppeexexne04_phasespace_set::ax_psp_240_udx_emepepveccx(int x_a){
  static Logger logger("ppeexexne04_phasespace_set::ax_psp_240_udx_emepepveccx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(28);
  needed_v_smin[x_a].resize(28);
  needed_v_smin[x_a][  0] = {   0,    9,   10,   11,   12,   18,   19,   24,   25,   26,   27,   28,   38,   39,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   63}; //  26
  needed_v_smin[x_a][  1] = {   0,   28}; //   2
  needed_v_smin[x_a][  2] = {   0,    5,   28,   29}; //   4
  needed_v_smin[x_a][  3] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  needed_v_smin[x_a][  4] = {   1,    2,    3,    4,    5,    6,    7,   16,   17,   20,   21,   22,   23,   29,   30,   31,   36,   37,   40,   41,   42,   43,   44,   45,   52,   53,   54,   55,   56,   57}; //  30
  needed_v_smin[x_a][  5] = {   1,    2,   20,   21}; //   4
  needed_v_smin[x_a][  6] = {   1,    2,   20,   21}; //   4
  needed_v_smin[x_a][  7] = {   1,    2,    3,    4,    8,   16,   17,   20,   21,   22,   23,   32,   36,   37,   40,   41,   42,   43,   44,   45,   52,   53,   54,   55,   56,   57}; //  26
  needed_v_smin[x_a][  8] = {   3,    4,   22,   23}; //   4
  needed_v_smin[x_a][  9] = {   3,    4,   22,   23}; //   4
  needed_v_smin[x_a][ 10] = {   5,   29}; //   2
  needed_v_smin[x_a][ 11] = {   6,    7,   30,   31}; //   4
  needed_v_smin[x_a][ 12] = {   6,    7,   14,   15,   30,   31,   34,   35}; //   8
  needed_v_smin[x_a][ 13] = {   8,   32}; //   2
  needed_v_smin[x_a][ 14] = {   8,   13,   32,   33}; //   4
  needed_v_smin[x_a][ 15] = {   9,   10,   11,   12,   13,   14,   15,   18,   19,   24,   25,   26,   27,   33,   34,   35,   38,   39,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   63}; //  30
  needed_v_smin[x_a][ 16] = {   9,   10,   24,   25}; //   4
  needed_v_smin[x_a][ 17] = {   9,   10,   24,   25}; //   4
  needed_v_smin[x_a][ 18] = {  11,   12,   26,   27}; //   4
  needed_v_smin[x_a][ 19] = {  11,   12,   26,   27}; //   4
  needed_v_smin[x_a][ 20] = {  13,   33}; //   2
  needed_v_smin[x_a][ 21] = {  14,   15,   34,   35}; //   4
  needed_v_smin[x_a][ 22] = {  16,   17,   36,   37,   44,   45,   56,   57}; //   8
  needed_v_smin[x_a][ 23] = {  18,   19,   38,   39,   50,   51,   62,   63}; //   8
  needed_v_smin[x_a][ 24] = {  40,   41,   42,   43}; //   4
  needed_v_smin[x_a][ 25] = {  46,   47,   48,   49}; //   4
  needed_v_smin[x_a][ 26] = {  52,   53,   54,   55}; //   4
  needed_v_smin[x_a][ 27] = {  58,   59,   60,   61}; //   4

  v_smax[x_a].resize(48);
  needed_v_smax[x_a].resize(48);
  needed_v_smax[x_a][  0] = {   0,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51}; //  11
  needed_v_smax[x_a][  1] = {   0,    5}; //   2
  needed_v_smax[x_a][  2] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19}; //  12
  needed_v_smax[x_a][  3] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19}; //  12
  needed_v_smax[x_a][  4] = {   1,    2,    3,    4,    5,    6,    7,   54,   55,   56,   57}; //  11
  needed_v_smax[x_a][  5] = {   1,    2}; //   2
  needed_v_smax[x_a][  6] = {   1,    2,    3,    4}; //   4
  needed_v_smax[x_a][  7] = {   1,    2,    3,    4}; //   4
  needed_v_smax[x_a][  8] = {   3,    4}; //   2
  needed_v_smax[x_a][  9] = {   6,    7,   14,   15}; //   4
  needed_v_smax[x_a][ 10] = {   8,   16,   17,   20,   21,   22,   23,   42,   43,   44,   45}; //  11
  needed_v_smax[x_a][ 11] = {   8,   13}; //   2
  needed_v_smax[x_a][ 12] = {   9,   10,   11,   12,   13,   14,   15,   60,   61,   62,   63}; //  11
  needed_v_smax[x_a][ 13] = {   9,   10}; //   2
  needed_v_smax[x_a][ 14] = {   9,   10,   11,   12}; //   4
  needed_v_smax[x_a][ 15] = {   9,   10,   11,   12}; //   4
  needed_v_smax[x_a][ 16] = {  11,   12}; //   2
  needed_v_smax[x_a][ 17] = {  16,   17,   20,   21,   22,   23,   44,   45}; //   8
  needed_v_smax[x_a][ 18] = {  18,   19,   24,   25,   26,   27,   50,   51}; //   8
  needed_v_smax[x_a][ 19] = {  20,   21}; //   2
  needed_v_smax[x_a][ 20] = {  20,   21,   22,   23,   52,   53,   54,   55}; //   8
  needed_v_smax[x_a][ 21] = {  22,   23}; //   2
  needed_v_smax[x_a][ 22] = {  24,   25}; //   2
  needed_v_smax[x_a][ 23] = {  24,   25,   26,   27,   58,   59,   60,   61}; //   8
  needed_v_smax[x_a][ 24] = {  26,   27}; //   2
  needed_v_smax[x_a][ 25] = {  28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   46,   47,   52,   53,   58,   59}; //  20
  needed_v_smax[x_a][ 26] = {  28,   38,   39,   46,   47}; //   5
  needed_v_smax[x_a][ 27] = {  28,   29}; //   2
  needed_v_smax[x_a][ 28] = {  28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   44,   45,   50,   51,   56,   57,   62,   63}; //  20
  needed_v_smax[x_a][ 29] = {  29,   30,   31,   52,   53}; //   5
  needed_v_smax[x_a][ 30] = {  30,   31,   34,   35}; //   4
  needed_v_smax[x_a][ 31] = {  32,   36,   37,   40,   41}; //   5
  needed_v_smax[x_a][ 32] = {  32,   33}; //   2
  needed_v_smax[x_a][ 33] = {  33,   34,   35,   58,   59}; //   5
  needed_v_smax[x_a][ 34] = {  36,   37,   40,   41,   42,   43}; //   6
  needed_v_smax[x_a][ 35] = {  38,   39,   46,   47,   48,   49}; //   6
  needed_v_smax[x_a][ 36] = {  42,   43}; //   2
  needed_v_smax[x_a][ 37] = {  44,   45,   56,   57}; //   4
  needed_v_smax[x_a][ 38] = {  48,   49}; //   2
  needed_v_smax[x_a][ 39] = {  50,   51,   62,   63}; //   4
  needed_v_smax[x_a][ 40] = {  52,   53,   54,   55}; //   4
  needed_v_smax[x_a][ 41] = {  54,   55}; //   2
  needed_v_smax[x_a][ 42] = {  56,   57}; //   2
  needed_v_smax[x_a][ 43] = {  58,   59,   60,   61}; //   4
  needed_v_smax[x_a][ 44] = {  60,   61}; //   2
  needed_v_smax[x_a][ 45] = {  62,   63}; //   2
  needed_v_smax[x_a][ 46] = {  40,   41,   42,   43}; //   4
  needed_v_smax[x_a][ 47] = {  46,   47,   48,   49}; //   4

  g_p[x_a].resize(72);
  needed_g_p[x_a].resize(72);
  needed_g_p[x_a][0] = {   0,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,    6,   54,   56}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   1,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {   1,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][7] = {   1,    2,    3,    4}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax7");
  needed_g_p[x_a][8] = {   2,    4,    5,    7,   55,   57}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][9] = {   3,    4}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax8");
  needed_g_p[x_a][10] = {   3,    4}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax6");
  needed_g_p[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax1");
  needed_g_p[x_a][12] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][13] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax2");
  needed_g_p[x_a][14] = {   8,   16,   17,   20,   21,   22,   23,   42,   43,   44,   45}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax10");
  needed_g_p[x_a][15] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax11");
  needed_g_p[x_a][16] = {   8,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin14_smax2");
  needed_g_p[x_a][17] = {   9,   11,   14,   60,   62}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][18] = {   9,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax13");
  needed_g_p[x_a][19] = {   9,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax14");
  needed_g_p[x_a][20] = {   9,   10,   11,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax15");
  needed_g_p[x_a][21] = {  10,   12,   13,   15,   61,   63}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin15_smax12");
  needed_g_p[x_a][22] = {  11,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax16");
  needed_g_p[x_a][23] = {  11,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax14");
  needed_g_p[x_a][24] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax11");
  needed_g_p[x_a][25] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax9");
  needed_g_p[x_a][26] = {  16,   20,   22,   44}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax17");
  needed_g_p[x_a][27] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin22_smax2");
  needed_g_p[x_a][28] = {  17,   21,   23,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax17");
  needed_g_p[x_a][29] = {  18,   24,   26,   50}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax18");
  needed_g_p[x_a][30] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin23_smax2");
  needed_g_p[x_a][31] = {  19,   25,   27,   51}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin15_smax18");
  needed_g_p[x_a][32] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax19");
  needed_g_p[x_a][33] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax20");
  needed_g_p[x_a][34] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax21");
  needed_g_p[x_a][35] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax20");
  needed_g_p[x_a][36] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax22");
  needed_g_p[x_a][37] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax23");
  needed_g_p[x_a][38] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax24");
  needed_g_p[x_a][39] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax23");
  needed_g_p[x_a][40] = {  28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   46,   47,   52,   53,   58,   59}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax25");
  needed_g_p[x_a][41] = {  28,   38,   39,   46,   47}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax26");
  needed_g_p[x_a][42] = {  28}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax27");
  needed_g_p[x_a][43] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax28");
  needed_g_p[x_a][44] = {  29,   31,   53}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax29");
  needed_g_p[x_a][45] = {  29}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax27");
  needed_g_p[x_a][46] = {  30,   52}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax29");
  needed_g_p[x_a][47] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax30");
  needed_g_p[x_a][48] = {  30,   31,   34,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax28");
  needed_g_p[x_a][49] = {  32,   36,   37,   40,   41}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax31");
  needed_g_p[x_a][50] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax32");
  needed_g_p[x_a][51] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin14_smax28");
  needed_g_p[x_a][52] = {  33,   35,   59}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin15_smax33");
  needed_g_p[x_a][53] = {  33}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax32");
  needed_g_p[x_a][54] = {  34,   58}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax33");
  needed_g_p[x_a][55] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax30");
  needed_g_p[x_a][56] = {  36,   40,   42}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax34");
  needed_g_p[x_a][57] = {  36,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin22_smax28");
  needed_g_p[x_a][58] = {  37,   41,   43}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax34");
  needed_g_p[x_a][59] = {  38,   46,   48}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax35");
  needed_g_p[x_a][60] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin23_smax28");
  needed_g_p[x_a][61] = {  39,   47,   49}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin15_smax35");
  needed_g_p[x_a][62] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax36");
  needed_g_p[x_a][63] = {  44,   45,   56,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax37");
  needed_g_p[x_a][64] = {  48,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax38");
  needed_g_p[x_a][65] = {  50,   51,   62,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax39");
  needed_g_p[x_a][66] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax40");
  needed_g_p[x_a][67] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax41");
  needed_g_p[x_a][68] = {  56,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax42");
  needed_g_p[x_a][69] = {  58,   59,   60,   61}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax43");
  needed_g_p[x_a][70] = {  60,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax44");
  needed_g_p[x_a][71] = {  62,   63}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax45");

  g_f[x_a].resize(6);
  needed_g_f[x_a].resize(6);
  needed_g_f[x_a][0] = {  40,   41,   42,   43}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax46");
  needed_g_f[x_a][1] = {  44,   45,   56,   57}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax28");
  needed_g_f[x_a][2] = {  46,   47,   48,   49}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax47");
  needed_g_f[x_a][3] = {  50,   51,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax28");
  needed_g_f[x_a][4] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax20");
  needed_g_f[x_a][5] = {  58,   59,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax23");

  g_t[x_a].resize(20);
  needed_g_t[x_a].resize(20);
  needed_g_t[x_a][0] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19,   44,   45,   50,   51,   56,   57,   62,   63}; //  20
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][1] = {   1,    2,    3,    4,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][2] = {   9,   10,   11,   12,   58,   59,   60,   61}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_212");
  needed_g_t[x_a][3] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][4] = {  24,   25,   26,   27}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__40_212");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__40_212");
  needed_g_t[x_a][5] = {  28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  12
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][6] = {  40,   41,   42,   43}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][7] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__192_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__192_48");
  needed_g_t[x_a][8] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][9] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__48_12");
  needed_g_t[x_a][10] = {  46,   47,   48,   49}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__20_232");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__20_232");
  needed_g_t[x_a][11] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__192_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__192_40");
  needed_g_t[x_a][12] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_21__40_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_21__40_192");
  needed_g_t[x_a][13] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__40_20");
  needed_g_t[x_a][14] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__192_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__192_12");
  needed_g_t[x_a][15] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][16] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__12_48");
  needed_g_t[x_a][17] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__192_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__192_20");
  needed_g_t[x_a][18] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_41__20_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_41__20_192");
  needed_g_t[x_a][19] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__20_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__20_40");

  g_d[x_a].resize(24);
  needed_g_d[x_a].resize(24);
  needed_g_d[x_a][0] = {   0,    5,    6,    7,    8,   13,   14,   15,   16,   17,   18,   19,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][1] = {   0,    5,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][2] = {   0,   28}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][3] = {   0,    9,   10,   11,   12,   18,   19,   24,   25,   26,   27,   28,   38,   39,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   63}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][4] = {   1,    2,    3,    4,    8,   16,   17,   20,   21,   22,   23,   32,   36,   37,   40,   41,   42,   43,   44,   45,   52,   53,   54,   55,   56,   57}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][5] = {   1,    2,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__64_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__64_140");
  needed_g_d[x_a][6] = {   1,    2,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][7] = {   1,    2,    3,    4,    5,    6,    7,   16,   17,   20,   21,   22,   23,   29,   30,   31,   36,   37,   40,   41,   42,   43,   44,   45,   52,   53,   54,   55,   56,   57}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][8] = {   3,    4,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__128_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__128_76");
  needed_g_d[x_a][9] = {   3,    4,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][10] = {   5,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][11] = {   6,    7,   14,   15,   30,   31,   34,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][12] = {   6,    7,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][13] = {   8,   13,   32,   33}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][14] = {   8,   32}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][15] = {   9,   10,   24,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_212__64_148");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_212__64_148");
  needed_g_d[x_a][16] = {   9,   10,   24,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_148__128_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_148__128_20");
  needed_g_d[x_a][17] = {   9,   10,   11,   12,   13,   14,   15,   18,   19,   24,   25,   26,   27,   33,   34,   35,   38,   39,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   63}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][18] = {  11,   12,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_212__128_84");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_212__128_84");
  needed_g_d[x_a][19] = {  11,   12,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_84__64_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_84__64_20");
  needed_g_d[x_a][20] = {  13,   33}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__32_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__32_20");
  needed_g_d[x_a][21] = {  14,   15,   34,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][22] = {  16,   17,   36,   37}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][23] = {  18,   19,   38,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__20_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__20_40");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  4,   5,   6,   7}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  1}; //   1
  c_d[x_a][1] = {  4,   5,   6,   7}; //   4

  c_p[x_a][2] = {  8,   5,   6,   7}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  1}; //   1
  c_d[x_a][2] = {  4,   5,   6,   7}; //   4

  c_p[x_a][3] = {  4,   9,  10,   7}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  1}; //   1
  c_d[x_a][3] = {  4,   8,   9,   7}; //   4

  c_p[x_a][4] = {  8,   9,  10,   7}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  1}; //   1
  c_d[x_a][4] = {  4,   8,   9,   7}; //   4

  c_p[x_a][5] = {  8,  11,   2,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   1,  10,   7}; //   4

  c_p[x_a][6] = {  4,  12,  13,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  0,  11,  12,   7}; //   4

  c_p[x_a][7] = {  8,  12,  13,   3}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  0,  11,  12,   7}; //   4

  c_p[x_a][8] = { 14,  15,  16,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  0,  13,  14,   4}; //   4

  c_p[x_a][9] = { 17,  18,  19,  20}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  2}; //   1
  c_d[x_a][9] = {  3,  15,  16,  17}; //   4

  c_p[x_a][10] = { 21,  18,  19,  20}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  2}; //   1
  c_d[x_a][10] = {  3,  15,  16,  17}; //   4

  c_p[x_a][11] = { 17,  22,  23,  20}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  2}; //   1
  c_d[x_a][11] = {  3,  18,  19,  17}; //   4

  c_p[x_a][12] = { 21,  22,  23,  20}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  2}; //   1
  c_d[x_a][12] = {  3,  18,  19,  17}; //   4

  c_p[x_a][13] = { 21,  24,  16,   3}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = {  0,  13,  20,  17}; //   4

  c_p[x_a][14] = { 17,  25,  13,   3}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = {  0,  11,  21,  17}; //   4

  c_p[x_a][15] = { 21,  25,  13,   3}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = {  0,  11,  21,  17}; //   4

  c_p[x_a][16] = { 14,  26,  27,   3}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = {  0,  22,   7,   4}; //   4

  c_p[x_a][17] = { 14,  28,  27,   3}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = {  0,  22,   7,   4}; //   4

  c_p[x_a][18] = {  0,  29,  30,   3}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = {  0,  23,  17,   3}; //   4

  c_p[x_a][19] = {  0,  31,  30,   3}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = {  0,  23,  17,   3}; //   4

  c_p[x_a][20] = { 14,  26,  32,  33}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  3}; //   1
  c_d[x_a][20] = {  5,   6,   7,   4}; //   4

  c_p[x_a][21] = { 14,  28,  32,  33}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  3}; //   1
  c_d[x_a][21] = {  5,   6,   7,   4}; //   4

  c_p[x_a][22] = { 14,  26,  34,  35}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  3}; //   1
  c_d[x_a][22] = {  8,   9,   7,   4}; //   4

  c_p[x_a][23] = { 14,  28,  34,  35}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  3}; //   1
  c_d[x_a][23] = {  8,   9,   7,   4}; //   4

  c_p[x_a][24] = {  0,  29,  36,  37}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  4}; //   1
  c_d[x_a][24] = { 15,  16,  17,   3}; //   4

  c_p[x_a][25] = {  0,  31,  36,  37}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  4}; //   1
  c_d[x_a][25] = { 15,  16,  17,   3}; //   4

  c_p[x_a][26] = {  0,  29,  38,  39}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  4}; //   1
  c_d[x_a][26] = { 18,  19,  17,   3}; //   4

  c_p[x_a][27] = {  0,  31,  38,  39}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  4}; //   1
  c_d[x_a][27] = { 18,  19,  17,   3}; //   4

  c_p[x_a][28] = { 40,  41,  42,  43}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  5}; //   1
  c_d[x_a][28] = {  1,   2,   3,   0}; //   4

  c_p[x_a][29] = { 40,  44,  45,  43}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  5}; //   1
  c_d[x_a][29] = {  1,  10,   7,   0}; //   4

  c_p[x_a][30] = { 40,  46,  47,  48}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  5}; //   1
  c_d[x_a][30] = { 11,  12,   7,   0}; //   4

  c_p[x_a][31] = { 40,  44,  47,  48}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  5}; //   1
  c_d[x_a][31] = { 11,  12,   7,   0}; //   4

  c_p[x_a][32] = { 40,  49,  50,  51}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  5}; //   1
  c_d[x_a][32] = { 13,  14,   4,   0}; //   4

  c_p[x_a][33] = { 40,  52,  53,  51}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  5}; //   1
  c_d[x_a][33] = { 13,  20,  17,   0}; //   4

  c_p[x_a][34] = { 40,  54,  55,  48}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  5}; //   1
  c_d[x_a][34] = { 11,  21,  17,   0}; //   4

  c_p[x_a][35] = { 40,  52,  55,  48}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  5}; //   1
  c_d[x_a][35] = { 11,  21,  17,   0}; //   4

  c_p[x_a][36] = { 40,  49,  56,  57}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  5}; //   1
  c_d[x_a][36] = { 22,   7,   4,   0}; //   4

  c_p[x_a][37] = { 40,  49,  58,  57}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  5}; //   1
  c_d[x_a][37] = { 22,   7,   4,   0}; //   4

  c_p[x_a][38] = { 40,  41,  59,  60}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  5}; //   1
  c_d[x_a][38] = { 23,  17,   3,   0}; //   4

  c_p[x_a][39] = { 40,  41,  61,  60}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  5}; //   1
  c_d[x_a][39] = { 23,  17,   3,   0}; //   4

  c_p[x_a][40] = { 40,  49,  56}; //   3
  c_f[x_a][40] = {  0}; //   1
  c_t[x_a][40] = {  6,   7}; //   2
  c_d[x_a][40] = {  7,   4,   0}; //   3

  c_p[x_a][41] = { 40,  49,  58}; //   3
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  6,   7}; //   2
  c_d[x_a][41] = {  7,   4,   0}; //   3

  c_p[x_a][42] = { 14,  62,  56}; //   3
  c_f[x_a][42] = {  0}; //   1
  c_t[x_a][42] = {  6,   8}; //   2
  c_d[x_a][42] = {  7,   0,   4}; //   3

  c_p[x_a][43] = { 14,  62,  58}; //   3
  c_f[x_a][43] = {  0}; //   1
  c_t[x_a][43] = {  6,   8}; //   2
  c_d[x_a][43] = {  7,   0,   4}; //   3

  c_p[x_a][44] = { 14,  26,  63}; //   3
  c_f[x_a][44] = {  1}; //   1
  c_t[x_a][44] = {  0,   9}; //   2
  c_d[x_a][44] = {  0,   7,   4}; //   3

  c_p[x_a][45] = { 14,  28,  63}; //   3
  c_f[x_a][45] = {  1}; //   1
  c_t[x_a][45] = {  0,   9}; //   2
  c_d[x_a][45] = {  0,   7,   4}; //   3

  c_p[x_a][46] = { 40,  41,  59}; //   3
  c_f[x_a][46] = {  2}; //   1
  c_t[x_a][46] = { 10,  11}; //   2
  c_d[x_a][46] = { 17,   3,   0}; //   3

  c_p[x_a][47] = { 40,  41,  61}; //   3
  c_f[x_a][47] = {  2}; //   1
  c_t[x_a][47] = { 10,  11}; //   2
  c_d[x_a][47] = { 17,   3,   0}; //   3

  c_p[x_a][48] = {  0,  64,  59}; //   3
  c_f[x_a][48] = {  2}; //   1
  c_t[x_a][48] = { 10,  12}; //   2
  c_d[x_a][48] = { 17,   0,   3}; //   3

  c_p[x_a][49] = {  0,  64,  61}; //   3
  c_f[x_a][49] = {  2}; //   1
  c_t[x_a][49] = { 10,  12}; //   2
  c_d[x_a][49] = { 17,   0,   3}; //   3

  c_p[x_a][50] = {  0,  29,  65}; //   3
  c_f[x_a][50] = {  3}; //   1
  c_t[x_a][50] = {  0,  13}; //   2
  c_d[x_a][50] = {  0,  17,   3}; //   3

  c_p[x_a][51] = {  0,  31,  65}; //   3
  c_f[x_a][51] = {  3}; //   1
  c_t[x_a][51] = {  0,  13}; //   2
  c_d[x_a][51] = {  0,  17,   3}; //   3

  c_p[x_a][52] = { 40,  46,  66}; //   3
  c_f[x_a][52] = {  4}; //   1
  c_t[x_a][52] = {  1,  14}; //   2
  c_d[x_a][52] = {  4,   7,   0}; //   3

  c_p[x_a][53] = { 40,  44,  66}; //   3
  c_f[x_a][53] = {  4}; //   1
  c_t[x_a][53] = {  1,  14}; //   2
  c_d[x_a][53] = {  4,   7,   0}; //   3

  c_p[x_a][54] = {  4,  67,  66}; //   3
  c_f[x_a][54] = {  4}; //   1
  c_t[x_a][54] = {  1,  15}; //   2
  c_d[x_a][54] = {  4,   0,   7}; //   3

  c_p[x_a][55] = {  8,  67,  66}; //   3
  c_f[x_a][55] = {  4}; //   1
  c_t[x_a][55] = {  1,  15}; //   2
  c_d[x_a][55] = {  4,   0,   7}; //   3

  c_p[x_a][56] = {  4,  68,  63}; //   3
  c_f[x_a][56] = {  1}; //   1
  c_t[x_a][56] = {  0,  16}; //   2
  c_d[x_a][56] = {  0,   4,   7}; //   3

  c_p[x_a][57] = {  8,  68,  63}; //   3
  c_f[x_a][57] = {  1}; //   1
  c_t[x_a][57] = {  0,  16}; //   2
  c_d[x_a][57] = {  0,   4,   7}; //   3

  c_p[x_a][58] = { 40,  54,  69}; //   3
  c_f[x_a][58] = {  5}; //   1
  c_t[x_a][58] = {  2,  17}; //   2
  c_d[x_a][58] = {  3,  17,   0}; //   3

  c_p[x_a][59] = { 40,  52,  69}; //   3
  c_f[x_a][59] = {  5}; //   1
  c_t[x_a][59] = {  2,  17}; //   2
  c_d[x_a][59] = {  3,  17,   0}; //   3

  c_p[x_a][60] = { 17,  70,  69}; //   3
  c_f[x_a][60] = {  5}; //   1
  c_t[x_a][60] = {  2,  18}; //   2
  c_d[x_a][60] = {  3,   0,  17}; //   3

  c_p[x_a][61] = { 21,  70,  69}; //   3
  c_f[x_a][61] = {  5}; //   1
  c_t[x_a][61] = {  2,  18}; //   2
  c_d[x_a][61] = {  3,   0,  17}; //   3

  c_p[x_a][62] = { 17,  71,  65}; //   3
  c_f[x_a][62] = {  3}; //   1
  c_t[x_a][62] = {  0,  19}; //   2
  c_d[x_a][62] = {  0,   3,  17}; //   3

  c_p[x_a][63] = { 21,  71,  65}; //   3
  c_f[x_a][63] = {  3}; //   1
  c_t[x_a][63] = {  0,  19}; //   2
  c_d[x_a][63] = {  0,   3,  17}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_udx_emepepveccx
//  channel    0: 2v4yyv(1, 2, 64, 128, 16, 4, 8, 32;  24,   0,  24,   0,   0)
//  channel    1: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,   0,  24,   0)
//  channel    2: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,   0,  24,   0)
//  channel    3: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;   0,   0,   0,  24,   0)
//  channel    4: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;  23,   0,   0,  24,   0)
//  channel    5: 2v4yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
//  channel    6: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
//  channel    7: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
//  channel    8: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
//  channel    9: 2v4yyv(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,   0,  24,   0)
//  channel   10: 2v4yyv(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,   0,  24,   0)
//  channel   11: 2v4yyv(1, 2, 8, 32, 128, 64, 4, 16;   0,   0,   0,  24,   0)
//  channel   12: 2v4yyv(1, 2, 8, 32, 128, 64, 4, 16;  23,   0,   0,  24,   0)
//  channel   13: 2v4yyv(1, 2, 64, 128, 8, 32, 4, 16;  23,   0,  24,   0,   0)
//  channel   14: 2v4yyv(1, 2, 64, 128, 32, 8, 4, 16;   0,   0,  24,   0,   0)
//  channel   15: 2v4yyv(1, 2, 64, 128, 32, 8, 4, 16;  23,   0,  24,   0,   0)
//  channel   16: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
//  channel   17: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
//  channel   18: 2v42vv(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,  24,   0,   0)
//  channel   19: 2v42vv(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,  24,   0,   0)
//  channel   20: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
//  channel   21: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
//  channel   22: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  24,   0,   0,   0,   0)
//  channel   23: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  24,  23,   0,   0,   0)
//  channel   24: 4yyv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   25: 4yyv2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel   26: 4yyv2v(1, 2, 128, 64, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   27: 4yyv2v(1, 2, 128, 64, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel   28: 4yyv2v(1, 2, 16, 4, 8, 32, 64, 128;   0,  24,   0,  24,   0)
//  channel   29: 4yyv2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,  24,   0)
//  channel   30: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,   0,   0,  24,   0)
//  channel   31: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,  23,   0,  24,   0)
//  channel   32: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  24,   0,  24,   0)
//  channel   33: 4yyv2v(1, 2, 8, 32, 4, 16, 64, 128;   0,  23,   0,  24,   0)
//  channel   34: 4yyv2v(1, 2, 32, 8, 4, 16, 64, 128;   0,   0,   0,  24,   0)
//  channel   35: 4yyv2v(1, 2, 32, 8, 4, 16, 64, 128;   0,  23,   0,  24,   0)
//  channel   36: 42vv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,  24,   0)
//  channel   37: 42vv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,  23,  24,   0)
//  channel   38: 42vv2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,  24,   0)
//  channel   39: 42vv2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,  23,  24,   0)
//  channel   40: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,   0,   0)
//  channel   41: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,  23,   0,   0)
//  channel   42: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
//  channel   43: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,  23,   0,   0)
//  channel   44: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
//  channel   45: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
//  channel   46: 2v2v2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,   0,   0,   0)
//  channel   47: 2v2v2v(1, 2, 4, 16, 8, 32, 64, 128;   0,  24,  23,   0,   0)
//  channel   48: 2v2v2v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,   0,   0,   0)
//  channel   49: 2v2v2v(1, 2, 4, 16, 64, 128, 8, 32;  24,   0,  23,   0,   0)
//  channel   50: 2v2v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,   0,   0,   0,   0)
//  channel   51: 2v2v2v(1, 2, 64, 128, 4, 16, 8, 32;  24,  23,   0,   0,   0)
//  channel   52: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,   0,  24,   0,   0)
//  channel   53: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,  24,   0,   0)
//  channel   54: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  24,   0,   0)
//  channel   55: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  24,   0,   0)
//  channel   56: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
//  channel   57: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
//  channel   58: 2v2v2v(1, 2, 8, 32, 4, 16, 64, 128;   0,   0,  24,   0,   0)
//  channel   59: 2v2v2v(1, 2, 8, 32, 4, 16, 64, 128;   0,  23,  24,   0,   0)
//  channel   60: 2v2v2v(1, 2, 8, 32, 64, 128, 4, 16;   0,   0,  24,   0,   0)
//  channel   61: 2v2v2v(1, 2, 8, 32, 64, 128, 4, 16;  23,   0,  24,   0,   0)
//  channel   62: 2v2v2v(1, 2, 64, 128, 8, 32, 4, 16;   0,  24,   0,   0,   0)
//  channel   63: 2v2v2v(1, 2, 64, 128, 8, 32, 4, 16;  23,  24,   0,   0,   0)
