#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

void ppeexmxnm04_phasespace_set::ax_psp_240_dxdx_emepmupvmdxux(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::ax_psp_240_dxdx_emepmupvmdxux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(20);
  needed_v_smin[x_a].resize(20);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   20,   21,   22,   23,   24,   25,   26,   27,   28,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  needed_v_smin[x_a][  1] = {   0,    6,   16,   26}; //   4
  needed_v_smin[x_a][  2] = {   0,    6,   16,   26}; //   4
  needed_v_smin[x_a][  3] = {   1,    2,    7,    8,   17,   18,   27,   28}; //   8
  needed_v_smin[x_a][  4] = {   1,    2,    7,    8,   17,   18,   27,   28}; //   8
  needed_v_smin[x_a][  5] = {   3,    4,    5,    9,   10,   11,   12,   13,   14,   15,   19,   20,   21,   22,   23,   24,   25,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  needed_v_smin[x_a][  6] = {   3,    9,   19,   29}; //   4
  needed_v_smin[x_a][  7] = {   3,    9,   19,   29}; //   4
  needed_v_smin[x_a][  8] = {   4,    5,   10,   11,   20,   21,   30,   31}; //   8
  needed_v_smin[x_a][  9] = {   6,    7,    8,    9,   10,   11,   16,   17,   18,   19,   20,   21,    0,    1,    2,    3,    4,    5,   26,   27,   28,   29,   30,   31}; //  24
  needed_v_smin[x_a][ 10] = {  12,   13,   22,   23,   36,   37,   40,   41,   48,   49,   50,   51,   54,   55,   58,   59,   32,   33,   62,   63}; //  20
  needed_v_smin[x_a][ 11] = {  12,   13,   22,   23,   32,   33,   36,   37,   58,   59,   62,   63}; //  12
  needed_v_smin[x_a][ 12] = {  14,   15,   24,   25,   38,   39,   56,   57,   34,   35,   60,   61}; //  12
  needed_v_smin[x_a][ 13] = {  14,   15,   24,   25,   34,   35,   38,   39,   56,   57,   60,   61}; //  12
  needed_v_smin[x_a][ 14] = {  42,   43,   48,   49,   50,   51,   52,   53}; //   8
  needed_v_smin[x_a][ 15] = {  40,   41,   54,   55}; //   4
  needed_v_smin[x_a][ 16] = {  42,   43,   52,   53}; //   4
  needed_v_smin[x_a][ 17] = {  44,   45,   46,   47}; //   4
  needed_v_smin[x_a][ 18] = {  44,   45}; //   2
  needed_v_smin[x_a][ 19] = {  46,   47}; //   2

  v_smax[x_a].resize(23);
  needed_v_smax[x_a].resize(23);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,   14,   15,   16,   17,   18,   24,   25,   26,   27,   28,   34,   35,   38,   39,   42,   43,   46,   47,   50,   51,   54,   55,   58,   59,   62,   63}; //  32
  needed_v_smax[x_a][  1] = {   0,    6,   16,   26}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   16,   17,   18,   19,   20,   21,   26,   27,   28,   29,   30,   31}; //  24
  needed_v_smax[x_a][  3] = {   1,    2,    7,    8,   17,   18,   27,   28}; //   8
  needed_v_smax[x_a][  4] = {   3,    4,    5,    9,   10,   11,   12,   13,   19,   20,   21,   22,   23,   29,   30,   31,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  32
  needed_v_smax[x_a][  5] = {   3,    9,   19,   29}; //   4
  needed_v_smax[x_a][  6] = {   4,    5,   10,   11,   20,   21,   30,   31,   32,   33,   44,   45,   52,   53,   56,   57,   60,   61}; //  18
  needed_v_smax[x_a][  7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,    0,    1,    2,    3,    4,    5,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  needed_v_smax[x_a][  8] = {  12,   13,   22,   23,   36,   37,   40,   41,   48,   49}; //  10
  needed_v_smax[x_a][  9] = {  12,   13,   22,   23,   36,   37,   40,   41,   48,   49}; //  10
  needed_v_smax[x_a][ 10] = {  14,   15,   24,   25,   38,   39}; //   6
  needed_v_smax[x_a][ 11] = {  14,   15,   24,   25,   38,   39}; //   6
  needed_v_smax[x_a][ 12] = {  34,   35,   46,   47,   54,   55,   58,   59,   62,   63}; //  10
  needed_v_smax[x_a][ 13] = {  42,   43,   50,   51}; //   4
  needed_v_smax[x_a][ 14] = {  42,   43,   50,   51}; //   4
  needed_v_smax[x_a][ 15] = {  48,   49}; //   2
  needed_v_smax[x_a][ 16] = {  50,   51}; //   2
  needed_v_smax[x_a][ 17] = {  52,   53}; //   2
  needed_v_smax[x_a][ 18] = {  54,   55,   58,   59,   32,   33,   62,   63}; //   8
  needed_v_smax[x_a][ 19] = {  56,   57,   34,   35,   60,   61}; //   6
  needed_v_smax[x_a][ 20] = {  40,   41,   44,   45,   54,   55}; //   6
  needed_v_smax[x_a][ 21] = {  42,   43,   46,   47,   52,   53}; //   6
  needed_v_smax[x_a][ 22] = {  44,   45,   46,   47}; //   4

  g_p[x_a].resize(28);
  needed_g_p[x_a].resize(28);
  needed_g_p[x_a][0] = {   0,    2,    6,    8,   15,   16,   18,   25,   26,   28,   35,   39,   43,   47,   51,   55,   59,   63}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    6,   16,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    6,   16,   26}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    7,   14,   17,   24,   27,   34,   38,   42,   46,   50,   54,   58,   62}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][4] = {   1,    2,    7,    8,   17,   18,   27,   28}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   1,    2,    7,    8,   17,   18,   27,   28}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,    9,   10,   11,   12,   13,   19,   20,   21,   22,   23,   29,   30,   31,   32,   33,   36,   37,   40,   41,   44,   45,   48,   49,   52,   53,   56,   57,   60,   61}; //  32
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,    9,   19,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,    9,   19,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   10,   20,   30,   32,   44,   52,   56,   60}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][10] = {   4,    5,   10,   11,   20,   21,   30,   31}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][11] = {   5,   11,   21,   31,   33,   45,   53,   57,   61}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][12] = {   6,    7,    8,    9,   10,   11,   16,   17,   18,   19,   20,   21}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][13] = {  12,   13,   22,   23,   36,   37,   40,   41,   48,   49}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][14] = {  12,   22,   36,   40,   48}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax9");
  needed_g_p[x_a][15] = {  12,   13,   22,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][16] = {  13,   23,   37,   41,   49}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax9");
  needed_g_p[x_a][17] = {  14,   15,   24,   25,   38,   39}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][18] = {  14,   15,   24,   25,   38,   39}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax11");
  needed_g_p[x_a][19] = {  14,   15,   24,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax7");
  needed_g_p[x_a][20] = {  34,   35,   46,   47,   54,   55,   58,   59,   62,   63}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax12");
  needed_g_p[x_a][21] = {  42,   43,   50,   51}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax13");
  needed_g_p[x_a][22] = {  42,   43,   50,   51}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax14");
  needed_g_p[x_a][23] = {  48,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax15");
  needed_g_p[x_a][24] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax16");
  needed_g_p[x_a][25] = {  52,   53}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax17");
  needed_g_p[x_a][26] = {  54,   55,   58,   59}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax18");
  needed_g_p[x_a][27] = {  56,   57}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax19");

  g_f[x_a].resize(10);
  needed_g_f[x_a].resize(10);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5,   26,   27,   28,   29,   30,   31}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][1] = {  32,   33,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax18");
  needed_g_f[x_a][2] = {  32,   33,   36,   37,   58,   59,   62,   63}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax7");
  needed_g_f[x_a][3] = {  34,   35,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax19");
  needed_g_f[x_a][4] = {  34,   35,   38,   39,   56,   57,   60,   61}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax7");
  needed_g_f[x_a][5] = {  40,   41,   54,   55}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax20");
  needed_g_f[x_a][6] = {  42,   43,   52,   53}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax21");
  needed_g_f[x_a][7] = {  44,   45,   46,   47}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax22");
  needed_g_f[x_a][8] = {  44,   45}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax20");
  needed_g_f[x_a][9] = {  46,   47}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax21");

  g_t[x_a].resize(26);
  needed_g_t[x_a].resize(26);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   32,   33,   34,   35,   36,   37,   38,   39}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_188");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__128_60");
  needed_g_t[x_a][2] = {  16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   56,   57,   58,   59,   60,   61,   62,   63}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][3] = {  26,   27,   28,   29,   30,   31}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][4] = {  32,   33,   36,   37}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_176");
  needed_g_t[x_a][5] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__128_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__128_48");
  needed_g_t[x_a][6] = {  34,   35,   38,   39}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_140");
  needed_g_t[x_a][7] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_49__128_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_49__128_12");
  needed_g_t[x_a][8] = {  40,   41,   44,   45}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][9] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__176_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__176_64");
  needed_g_t[x_a][10] = {  42,   43,   46,   47}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][11] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__76_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__76_128");
  needed_g_t[x_a][12] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][13] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__13_50__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__13_50__64_128");
  needed_g_t[x_a][14] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][15] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__49_14__128_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__49_14__128_64");
  needed_g_t[x_a][16] = {  48,   49}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__76_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__76_176");
  needed_g_t[x_a][17] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__176_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__176_76");
  needed_g_t[x_a][18] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][19] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_50__76_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_50__76_128");
  needed_g_t[x_a][20] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");
  needed_g_t[x_a][21] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_14__176_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_14__176_64");
  needed_g_t[x_a][22] = {  56,   57,   60,   61}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_140");
  needed_g_t[x_a][23] = {  58,   59,   62,   63}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_176");
  needed_g_t[x_a][24] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_50__128_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_50__128_12");
  needed_g_t[x_a][25] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__128_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__128_48");

  g_d[x_a].resize(15);
  needed_g_d[x_a].resize(15);
  needed_g_d[x_a][0] = {   0,    6,   16,   26}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][1] = {   0,    6,   16,   26}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   0,    1,    2,    4,    5,    6,    7,    8,   10,   11,   12,   13,   14,   15,   16,   17,   18,   20,   21,   22,   23,   24,   25,   26,   27,   28,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][3] = {   1,    2,    7,    8,   17,   18,   27,   28}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   1,    2,    7,    8,   17,   18,   27,   28}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {   3,    9,   19,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    9,   19,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][7] = {   3,    4,    5,    9,   10,   11,   12,   13,   14,   15,   19,   20,   21,   22,   23,   24,   25,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][8] = {   4,    5,   10,   11,   20,   21,   30,   31}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][9] = {   6,    7,    8,    9,   10,   11,   16,   17,   18,   19,   20,   21}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][10] = {  12,   13,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][11] = {  12,   13,   22,   23,   36,   37,   40,   41,   48,   49,   50,   51,   54,   55,   58,   59}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][12] = {  14,   15,   24,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][13] = {  14,   15,   24,   25,   38,   39,   56,   57}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][14] = {  42,   43,   48,   49,   50,   51,   52,   53}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  3,   4,   5}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  3,   4,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  6,   9,  10}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  8,   2,   7}; //   3

  c_p[x_a][5] = {  6,  11,  10}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  8,   2,   7}; //   3

  c_p[x_a][6] = {  0,   1,   2,  12}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  9,   0,   1,   2}; //   4

  c_p[x_a][7] = {  3,   4,   5,  12}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  9,   3,   4,   2}; //   4

  c_p[x_a][8] = {  0,   4,   5,  12}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  9,   3,   4,   2}; //   4

  c_p[x_a][9] = {  6,   7,   8,  12}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  9,   5,   6,   7}; //   4

  c_p[x_a][10] = {  6,   9,  10,  12}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  9,   8,   2,   7}; //   4

  c_p[x_a][11] = {  6,  11,  10,  12}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  9,   8,   2,   7}; //   4

  c_p[x_a][12] = {  6,  13,  14,  15}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 10,   2,  11,   7}; //   4

  c_p[x_a][13] = {  6,  13,  16,  15}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 10,   2,  11,   7}; //   4

  c_p[x_a][14] = {  3,  17,  18,  19}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 12,   7,  13,   2}; //   4

  c_p[x_a][15] = {  0,  17,  18,  19}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 12,   7,  13,   2}; //   4

  c_p[x_a][16] = {  0,   1,   2,  12}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  2}; //   1
  c_d[x_a][16] = {  9,   0,   1,   2}; //   4

  c_p[x_a][17] = {  3,   4,   5,  12}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  2}; //   1
  c_d[x_a][17] = {  9,   3,   4,   2}; //   4

  c_p[x_a][18] = {  0,   4,   5,  12}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  2}; //   1
  c_d[x_a][18] = {  9,   3,   4,   2}; //   4

  c_p[x_a][19] = {  6,   7,   8,  12}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  2}; //   1
  c_d[x_a][19] = {  9,   5,   6,   7}; //   4

  c_p[x_a][20] = {  6,   9,  10,  12}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  2}; //   1
  c_d[x_a][20] = {  9,   8,   2,   7}; //   4

  c_p[x_a][21] = {  6,  11,  10,  12}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  2}; //   1
  c_d[x_a][21] = {  9,   8,   2,   7}; //   4

  c_p[x_a][22] = {  6,  13,  14,  15}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  2}; //   1
  c_d[x_a][22] = { 10,   2,  11,   7}; //   4

  c_p[x_a][23] = {  6,  13,  16,  15}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  2}; //   1
  c_d[x_a][23] = { 10,   2,  11,   7}; //   4

  c_p[x_a][24] = {  3,  17,  18,  19}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  2}; //   1
  c_d[x_a][24] = { 12,   7,  13,   2}; //   4

  c_p[x_a][25] = {  0,  17,  18,  19}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  2}; //   1
  c_d[x_a][25] = { 12,   7,  13,   2}; //   4

  c_p[x_a][26] = {  0,   1,   2}; //   3
  c_f[x_a][26] = {  0}; //   1
  c_t[x_a][26] = {  2,   3}; //   2
  c_d[x_a][26] = {  0,   1,   2}; //   3

  c_p[x_a][27] = {  3,   4,   5}; //   3
  c_f[x_a][27] = {  0}; //   1
  c_t[x_a][27] = {  2,   3}; //   2
  c_d[x_a][27] = {  3,   4,   2}; //   3

  c_p[x_a][28] = {  0,   4,   5}; //   3
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  2,   3}; //   2
  c_d[x_a][28] = {  3,   4,   2}; //   3

  c_p[x_a][29] = {  6,   7,   8}; //   3
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  2,   3}; //   2
  c_d[x_a][29] = {  5,   6,   7}; //   3

  c_p[x_a][30] = {  6,   9,  10}; //   3
  c_f[x_a][30] = {  0}; //   1
  c_t[x_a][30] = {  2,   3}; //   2
  c_d[x_a][30] = {  8,   2,   7}; //   3

  c_p[x_a][31] = {  6,  11,  10}; //   3
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  2,   3}; //   2
  c_d[x_a][31] = {  8,   2,   7}; //   3

  c_p[x_a][32] = {  6,   9}; //   2
  c_f[x_a][32] = {  1,   2}; //   2
  c_t[x_a][32] = {  0,   4,   5}; //   3
  c_d[x_a][32] = {  2,   7}; //   2

  c_p[x_a][33] = {  6,  11}; //   2
  c_f[x_a][33] = {  1,   2}; //   2
  c_t[x_a][33] = {  0,   4,   5}; //   3
  c_d[x_a][33] = {  2,   7}; //   2

  c_p[x_a][34] = {  3,  20}; //   2
  c_f[x_a][34] = {  3,   4}; //   2
  c_t[x_a][34] = {  0,   6,   7}; //   3
  c_d[x_a][34] = {  7,   2}; //   2

  c_p[x_a][35] = {  0,  20}; //   2
  c_f[x_a][35] = {  3,   4}; //   2
  c_t[x_a][35] = {  0,   6,   7}; //   3
  c_d[x_a][35] = {  7,   2}; //   2

  c_p[x_a][36] = {  6,  13,  14}; //   3
  c_f[x_a][36] = {  2}; //   1
  c_t[x_a][36] = {  0,   4}; //   2
  c_d[x_a][36] = {  2,  11,   7}; //   3

  c_p[x_a][37] = {  6,  13,  16}; //   3
  c_f[x_a][37] = {  2}; //   1
  c_t[x_a][37] = {  0,   4}; //   2
  c_d[x_a][37] = {  2,  11,   7}; //   3

  c_p[x_a][38] = {  3,  17,  18}; //   3
  c_f[x_a][38] = {  4}; //   1
  c_t[x_a][38] = {  0,   6}; //   2
  c_d[x_a][38] = {  7,  13,   2}; //   3

  c_p[x_a][39] = {  0,  17,  18}; //   3
  c_f[x_a][39] = {  4}; //   1
  c_t[x_a][39] = {  0,   6}; //   2
  c_d[x_a][39] = {  7,  13,   2}; //   3

  c_p[x_a][40] = {  6,  13,  14}; //   3
  c_f[x_a][40] = {  5}; //   1
  c_t[x_a][40] = {  8,   9}; //   2
  c_d[x_a][40] = {  2,  11,   7}; //   3

  c_p[x_a][41] = {  6,  13,  16}; //   3
  c_f[x_a][41] = {  5}; //   1
  c_t[x_a][41] = {  8,   9}; //   2
  c_d[x_a][41] = {  2,  11,   7}; //   3

  c_p[x_a][42] = {  3,  21,  22}; //   3
  c_f[x_a][42] = {  6}; //   1
  c_t[x_a][42] = { 10,  11}; //   2
  c_d[x_a][42] = {  7,  14,   2}; //   3

  c_p[x_a][43] = {  0,  21,  22}; //   3
  c_f[x_a][43] = {  6}; //   1
  c_t[x_a][43] = { 10,  11}; //   2
  c_d[x_a][43] = {  7,  14,   2}; //   3

  c_p[x_a][44] = {  6,   9}; //   2
  c_f[x_a][44] = {  7,   8}; //   2
  c_t[x_a][44] = {  8,  12,  13}; //   3
  c_d[x_a][44] = {  2,   7}; //   2

  c_p[x_a][45] = {  6,  11}; //   2
  c_f[x_a][45] = {  7,   8}; //   2
  c_t[x_a][45] = {  8,  12,  13}; //   3
  c_d[x_a][45] = {  2,   7}; //   2

  c_p[x_a][46] = {  3,  20}; //   2
  c_f[x_a][46] = {  7,   9}; //   2
  c_t[x_a][46] = { 10,  14,  15}; //   3
  c_d[x_a][46] = {  7,   2}; //   2

  c_p[x_a][47] = {  0,  20}; //   2
  c_f[x_a][47] = {  7,   9}; //   2
  c_t[x_a][47] = { 10,  14,  15}; //   3
  c_d[x_a][47] = {  7,   2}; //   2

  c_p[x_a][48] = {  6,  13,  14,  23}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = { 16}; //   1
  c_d[x_a][48] = { 14,   2,  11,   7}; //   4

  c_p[x_a][49] = {  6,  13,  16,  23}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = { 16}; //   1
  c_d[x_a][49] = { 14,   2,  11,   7}; //   4

  c_p[x_a][50] = {  3,  21,  22,  24}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = { 17}; //   1
  c_d[x_a][50] = { 11,   7,  14,   2}; //   4

  c_p[x_a][51] = {  0,  21,  22,  24}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = { 17}; //   1
  c_d[x_a][51] = { 11,   7,  14,   2}; //   4

  c_p[x_a][52] = {  6,   9,  25}; //   3
  c_f[x_a][52] = {  6}; //   1
  c_t[x_a][52] = { 18,  19}; //   2
  c_d[x_a][52] = { 14,   2,   7}; //   3

  c_p[x_a][53] = {  6,  11,  25}; //   3
  c_f[x_a][53] = {  6}; //   1
  c_t[x_a][53] = { 18,  19}; //   2
  c_d[x_a][53] = { 14,   2,   7}; //   3

  c_p[x_a][54] = {  3,  20,  26}; //   3
  c_f[x_a][54] = {  5}; //   1
  c_t[x_a][54] = { 20,  21}; //   2
  c_d[x_a][54] = { 11,   7,   2}; //   3

  c_p[x_a][55] = {  0,  20,  26}; //   3
  c_f[x_a][55] = {  5}; //   1
  c_t[x_a][55] = { 20,  21}; //   2
  c_d[x_a][55] = { 11,   7,   2}; //   3

  c_p[x_a][56] = {  6,   9,  27}; //   3
  c_f[x_a][56] = {  4}; //   1
  c_t[x_a][56] = {  2,  22}; //   2
  c_d[x_a][56] = { 13,   2,   7}; //   3

  c_p[x_a][57] = {  6,  11,  27}; //   3
  c_f[x_a][57] = {  4}; //   1
  c_t[x_a][57] = {  2,  22}; //   2
  c_d[x_a][57] = { 13,   2,   7}; //   3

  c_p[x_a][58] = {  3,  20,  26}; //   3
  c_f[x_a][58] = {  2}; //   1
  c_t[x_a][58] = {  2,  23}; //   2
  c_d[x_a][58] = { 11,   7,   2}; //   3

  c_p[x_a][59] = {  0,  20,  26}; //   3
  c_f[x_a][59] = {  2}; //   1
  c_t[x_a][59] = {  2,  23}; //   2
  c_d[x_a][59] = { 11,   7,   2}; //   3

  c_p[x_a][60] = {  6,   9}; //   2
  c_f[x_a][60] = {  3,   4}; //   2
  c_t[x_a][60] = {  2,  22,  24}; //   3
  c_d[x_a][60] = {  2,   7}; //   2

  c_p[x_a][61] = {  6,  11}; //   2
  c_f[x_a][61] = {  3,   4}; //   2
  c_t[x_a][61] = {  2,  22,  24}; //   3
  c_d[x_a][61] = {  2,   7}; //   2

  c_p[x_a][62] = {  3,  20}; //   2
  c_f[x_a][62] = {  1,   2}; //   2
  c_t[x_a][62] = {  2,  23,  25}; //   3
  c_d[x_a][62] = {  7,   2}; //   2

  c_p[x_a][63] = {  0,  20}; //   2
  c_f[x_a][63] = {  1,   2}; //   2
  c_t[x_a][63] = {  2,  23,  25}; //   3
  c_d[x_a][63] = {  7,   2}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_dxdx_emepmupvmdxux
//  channel    0: 4yyv11(1, 2, 16, 32, 4, 8, 128, 64;  23,   0,  24,   0,   0)
//  channel    1: 4yyv11(1, 2, 32, 16, 4, 8, 128, 64;   0,   0,  24,   0,   0)
//  channel    2: 4yyv11(1, 2, 32, 16, 4, 8, 128, 64;  23,   0,  24,   0,   0)
//  channel    3: 4yyv11(1, 2, 8, 4, 16, 32, 128, 64;  24,   0,  24,   0,   0)
//  channel    4: 42vv11(1, 2, 4, 8, 16, 32, 128, 64;  24,   0,  24,   0,   0)
//  channel    5: 42vv11(1, 2, 4, 8, 16, 32, 128, 64;  24,  23,  24,   0,   0)
//  channel    6: 5yyyv1(1, 2, 128, 16, 32, 4, 8, 64;  23,   0,  24,   0,   0)
//  channel    7: 5yyyv1(1, 2, 128, 32, 16, 4, 8, 64;   0,   0,  24,   0,   0)
//  channel    8: 5yyyv1(1, 2, 128, 32, 16, 4, 8, 64;  23,   0,  24,   0,   0)
//  channel    9: 5yyyv1(1, 2, 128, 8, 4, 16, 32, 64;  24,   0,  24,   0,   0)
//  channel   10: 5y2vv1(1, 2, 128, 4, 8, 16, 32, 64;  24,   0,  24,   0,   0)
//  channel   11: 5y2vv1(1, 2, 128, 4, 8, 16, 32, 64;  24,  23,  24,   0,   0)
//  channel   12: 52vyv1(1, 2, 4, 8, 128, 16, 32, 64;  24,   0,   0,   0,   0)
//  channel   13: 52vyv1(1, 2, 4, 8, 128, 16, 32, 64;  24,   0,  23,   0,   0)
//  channel   14: 52vyv1(1, 2, 16, 32, 128, 4, 8, 64;   0,   0,  24,   0,   0)
//  channel   15: 52vyv1(1, 2, 16, 32, 128, 4, 8, 64;  23,   0,  24,   0,   0)
//  channel   16: 15yyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
//  channel   17: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
//  channel   18: 15yyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
//  channel   19: 15yyyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
//  channel   20: 15y2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
//  channel   21: 15y2vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
//  channel   22: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
//  channel   23: 152vyv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
//  channel   24: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  24,   0,   0)
//  channel   25: 152vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  24,   0,   0)
//  channel   26: 114yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
//  channel   27: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
//  channel   28: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
//  channel   29: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
//  channel   30: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
//  channel   31: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
//  channel   32: 2v2v11(1, 2, 4, 8, 16, 32, 128, 64;  24,   0,   0,   0,   0)
//  channel   33: 2v2v11(1, 2, 4, 8, 16, 32, 128, 64;  24,  23,   0,   0,   0)
//  channel   34: 2v2v11(1, 2, 16, 32, 4, 8, 128, 64;   0,  24,   0,   0,   0)
//  channel   35: 2v2v11(1, 2, 16, 32, 4, 8, 128, 64;  23,  24,   0,   0,   0)
//  channel   36: 2v3yv1(1, 2, 4, 8, 128, 16, 32, 64;  24,   0,   0,   0,   0)
//  channel   37: 2v3yv1(1, 2, 4, 8, 128, 16, 32, 64;  24,   0,  23,   0,   0)
//  channel   38: 2v3yv1(1, 2, 16, 32, 128, 4, 8, 64;   0,   0,  24,   0,   0)
//  channel   39: 2v3yv1(1, 2, 16, 32, 128, 4, 8, 64;  23,   0,  24,   0,   0)
//  channel   40: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
//  channel   41: 2v13yv(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,  23,   0,   0)
//  channel   42: 2v13yv(1, 2, 16, 32, 128, 64, 4, 8;   0,   0,  24,   0,   0)
//  channel   43: 2v13yv(1, 2, 16, 32, 128, 64, 4, 8;  23,   0,  24,   0,   0)
//  channel   44: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
//  channel   45: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  24,  23,   0,   0,   0)
//  channel   46: 2v112v(1, 2, 16, 32, 128, 64, 4, 8;   0,  24,   0,   0,   0)
//  channel   47: 2v112v(1, 2, 16, 32, 128, 64, 4, 8;  23,  24,   0,   0,   0)
//  channel   48: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
//  channel   49: 3yv3yv(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,  23,   0,   0)
//  channel   50: 3yv3yv(1, 2, 128, 16, 32, 64, 4, 8;   0,   0,  24,   0,   0)
//  channel   51: 3yv3yv(1, 2, 128, 16, 32, 64, 4, 8;  23,   0,  24,   0,   0)
//  channel   52: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
//  channel   53: 3yv12v(1, 2, 64, 4, 8, 128, 16, 32;  24,  23,   0,   0,   0)
//  channel   54: 3yv12v(1, 2, 128, 16, 32, 64, 4, 8;   0,  24,   0,   0,   0)
//  channel   55: 3yv12v(1, 2, 128, 16, 32, 64, 4, 8;  23,  24,   0,   0,   0)
//  channel   56: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
//  channel   57: 13yv2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
//  channel   58: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
//  channel   59: 13yv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
//  channel   60: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
//  channel   61: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
//  channel   62: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
//  channel   63: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
