#include "header.hpp"

#include "ppeexmxnm04.phasespace.set.hpp"

void ppeexmxnm04_phasespace_set::ax_psp_240_udx_emepmupvmgg(int x_a){
  static Logger logger("ppeexmxnm04_phasespace_set::ax_psp_240_udx_emepmupvmgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(22);
  needed_v_smin[x_a].resize(22);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; // 100
  needed_v_smin[x_a][  1] = {   0,    1,   12,   13,   24,   25,   44,   66}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,   12,   13,   24,   25,   44,   66}; //   8
  needed_v_smin[x_a][  3] = {   2,    3,    4,    5,   14,   15,   16,   17,   26,   27,   28,   29,   45,   46,   67,   68}; //  16
  needed_v_smin[x_a][  4] = {   2,    3,    4,    5,   14,   15,   16,   17,   26,   27,   28,   29,   45,   46,   67,   68}; //  16
  needed_v_smin[x_a][  5] = {   6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; //  84
  needed_v_smin[x_a][  6] = {   6,    7,   18,   19,   30,   31,   47,   69}; //   8
  needed_v_smin[x_a][  7] = {   6,    7,   18,   19,   30,   31,   47,   69}; //   8
  needed_v_smin[x_a][  8] = {   8,    9,   10,   11,   20,   21,   22,   23,   32,   33,   34,   35,   48,   49,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,  100,  101,  106,  107}; //  28
  needed_v_smin[x_a][  9] = {  44,   45,   46,   47,   48,   49,   66,   67,   68,   69,   70,   71,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,   58,   59,   60,   61,   62,   63,   64,   65}; //  32
  needed_v_smin[x_a][ 10] = {   0,    2,    3,    6,    8,    9,   12,   14,   15,   18,   20,   21,   25,   28,   29,   31,   34,   35,   72,   73,   76,   77}; //  22
  needed_v_smin[x_a][ 11] = {   1,    4,    5,    7,   10,   11,   13,   16,   17,   19,   22,   23,   24,   26,   27,   30,   32,   33,   74,   75,   78,   79}; //  22
  needed_v_smin[x_a][ 12] = {  36,   37,   52,   53,   84,   85,   94,   95}; //   8
  needed_v_smin[x_a][ 13] = {  36,   37,   52,   53,   84,   85,   94,   95}; //   8
  needed_v_smin[x_a][ 14] = {  38,   39,   50,   51,   86,   87,   92,   93}; //   8
  needed_v_smin[x_a][ 15] = {  38,   39,   50,   51,   86,   87,   92,   93}; //   8
  needed_v_smin[x_a][ 16] = {  40,   41,   56,   57,   80,   81,   90,   91}; //   8
  needed_v_smin[x_a][ 17] = {  40,   41,   56,   57,   80,   81,   90,   91}; //   8
  needed_v_smin[x_a][ 18] = {  42,   43,   54,   55,   82,   83,   88,   89}; //   8
  needed_v_smin[x_a][ 19] = {  42,   43,   54,   55,   82,   83,   88,   89}; //   8
  needed_v_smin[x_a][ 20] = {  58,   59,   60,   61,   96,   97,   98,   99}; //   8
  needed_v_smin[x_a][ 21] = {  62,   63,   64,   65,  102,  103,  104,  105}; //   8

  v_smax[x_a].resize(29);
  needed_v_smax[x_a].resize(29);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   40,   41,   42,   43,   44,   45,   46,   54,   55,   56,   57,   62,   63,   64,   65,   76,   77,   78,   79,   84,   85,   86,   87,   92,   93,   94,   95,  104,  105,  106,  107}; //  49
  needed_v_smax[x_a][  1] = {   0,    1,   12,   13,   24,   25,   44}; //   7
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   44,   45,   46,   47,   48,   49,   72,   73,   74,   75,   76,   77,   78,   79}; //  50
  needed_v_smax[x_a][  3] = {   2,    3,    4,    5,   14,   15,   16,   17,   26,   27,   28,   29,   45,   46}; //  14
  needed_v_smax[x_a][  4] = {   6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   47,   48,   49,   50,   51,   52,   53,   58,   59,   60,   61,   72,   73,   74,   75,   80,   81,   82,   83,   88,   89,   90,   91,   98,   99,  100,  101}; //  49
  needed_v_smax[x_a][  5] = {   6,    7,   18,   19,   30,   31,   47}; //   7
  needed_v_smax[x_a][  6] = {   8,    9,   10,   11,   20,   21,   22,   23,   32,   33,   34,   35,   36,   37,   38,   39,   48,   49,   50,   51,   52,   53,   58,   59,   60,   61,   72,   73,   74,   75,   80,   81,   82,   83,   88,   89,   90,   91,  100,  101}; //  40
  needed_v_smax[x_a][  7] = {  40,   41,   42,   43,   54,   55,   56,   57,   62,   63,   64,   65,   76,   77,   78,   79,   84,   85,   86,   87,   92,   93,   94,   95,  106,  107}; //  26
  needed_v_smax[x_a][  8] = {  44,   45,   46,   47,   48,   49}; //   6
  needed_v_smax[x_a][  9] = {  66,   67,   68,   69,   70,   71,   96,   97,  102,  103}; //  10
  needed_v_smax[x_a][ 10] = {  66,   67,   68,  102,  103}; //   5
  needed_v_smax[x_a][ 11] = {  66}; //   1
  needed_v_smax[x_a][ 12] = {  66,   67,   68,   69,   70,   71,  100,  101,  106,  107}; //  10
  needed_v_smax[x_a][ 13] = {  67,   68}; //   2
  needed_v_smax[x_a][ 14] = {  69,   70,   71,   96,   97}; //   5
  needed_v_smax[x_a][ 15] = {  69}; //   1
  needed_v_smax[x_a][ 16] = {  70,   71,   96,   97,   98,   99}; //   6
  needed_v_smax[x_a][ 17] = {  98,   99}; //   2
  needed_v_smax[x_a][ 18] = { 100,  101,  106,  107,   58,   59,   60,   61,   62,   63,   64,   65}; //  12
  needed_v_smax[x_a][ 19] = { 102,  103,  104,  105}; //   4
  needed_v_smax[x_a][ 20] = { 104,  105}; //   2
  needed_v_smax[x_a][ 21] = {   0,    2,    3,    6,    8,    9,   12,   14,   15,   18,   20,   21,   25,   28,   29,   31,   34,   35,   36,   37,   40,   41,   52,   53,   56,   57,   72,   73,   76,   77,   80,   81,   84,   85,   90,   91,   94,   95}; //  38
  needed_v_smax[x_a][ 22] = {   1,    4,    5,    7,   10,   11,   13,   16,   17,   19,   22,   23,   24,   26,   27,   30,   32,   33,   38,   39,   42,   43,   50,   51,   54,   55,   74,   75,   78,   79,   82,   83,   86,   87,   88,   89,   92,   93}; //  38
  needed_v_smax[x_a][ 23] = {  36,   37,   52,   53,   84,   85,   94,   95}; //   8
  needed_v_smax[x_a][ 24] = {  38,   39,   50,   51,   86,   87,   92,   93}; //   8
  needed_v_smax[x_a][ 25] = {  40,   41,   56,   57,   80,   81,   90,   91}; //   8
  needed_v_smax[x_a][ 26] = {  42,   43,   54,   55,   82,   83,   88,   89}; //   8
  needed_v_smax[x_a][ 27] = {  58,   59,   60,   61,   96,   97,   98,   99}; //   8
  needed_v_smax[x_a][ 28] = {  62,   63,   64,   65,  102,  103,  104,  105}; //   8

  g_p[x_a].resize(31);
  needed_g_p[x_a].resize(31);
  needed_g_p[x_a][0] = {   0,    1,    3,    5,   12,   13,   15,   17,   24,   25,   27,   29,   41,   43,   44,   46,   55,   57,   63,   65,   77,   79,   85,   87,   93,   95,  105,  107}; //  28
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   12,   13,   24,   25,   44}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    1,   12,   13,   24,   25,   44}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   2,    4,   14,   16,   26,   28,   40,   42,   45,   54,   56,   62,   64,   76,   78,   84,   86,   92,   94,  104,  106}; //  21
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][4] = {   2,    3,    4,    5,   14,   15,   16,   17,   26,   27,   28,   29,   45,   46}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    3,    4,    5,   14,   15,   16,   17,   26,   27,   28,   29,   45,   46}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax2");
  needed_g_p[x_a][6] = {   6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   47,   48,   49,   50,   51,   52,   53,   58,   59,   60,   61,   72,   73,   74,   75,   80,   81,   82,   83,   88,   89,   90,   91,   98,   99,  100,  101}; //  49
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   6,    7,   18,   19,   30,   31,   47}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   6,    7,   18,   19,   30,   31,   47}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax2");
  needed_g_p[x_a][9] = {   8,   10,   20,   22,   32,   34,   36,   38,   48,   50,   52,   58,   60,   72,   74,   80,   82,   88,   90,  100}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][10] = {   8,    9,   10,   11,   20,   21,   22,   23,   32,   33,   34,   35,   48,   49}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax2");
  needed_g_p[x_a][11] = {   9,   11,   21,   23,   33,   35,   37,   39,   49,   51,   53,   59,   61,   73,   75,   81,   83,   89,   91,  101}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][12] = {  40,   41,   42,   43,   54,   55,   56,   57,   62,   63,   64,   65,   76,   77,   78,   79,   84,   85,   86,   87,   92,   93,   94,   95,  106,  107}; //  26
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {  44,   45,   46,   47,   48,   49}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax8");
  needed_g_p[x_a][14] = {  66,   67,   68,   69,   70,   71,   96,   97,  102,  103}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax9");
  needed_g_p[x_a][15] = {  66,   68,  103}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax10");
  needed_g_p[x_a][16] = {  66}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax11");
  needed_g_p[x_a][17] = {  66}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax12");
  needed_g_p[x_a][18] = {  67,  102}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax10");
  needed_g_p[x_a][19] = {  67,   68}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax13");
  needed_g_p[x_a][20] = {  67,   68}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin4_smax12");
  needed_g_p[x_a][21] = {  69,   70,   71,   96,   97}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax14");
  needed_g_p[x_a][22] = {  69}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax15");
  needed_g_p[x_a][23] = {  69}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax12");
  needed_g_p[x_a][24] = {  70,   96,   98}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax16");
  needed_g_p[x_a][25] = {  70,   71}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin8_smax12");
  needed_g_p[x_a][26] = {  71,   97,   99}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");
  needed_g_p[x_a][27] = {  98,   99}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax17");
  needed_g_p[x_a][28] = { 100,  101,  106,  107}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax18");
  needed_g_p[x_a][29] = { 102,  103,  104,  105}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax19");
  needed_g_p[x_a][30] = { 104,  105}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax20");

  g_f[x_a].resize(15);
  needed_g_f[x_a].resize(15);
  needed_g_f[x_a][0] = {   0,    2,    3,    6,    8,    9,   12,   14,   15,   18,   20,   21,   25,   28,   29,   31,   34,   35,   72,   73,   76,   77}; //  22
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax21");
  needed_g_f[x_a][1] = {   1,    4,    5,    7,   10,   11,   13,   16,   17,   19,   22,   23,   24,   26,   27,   30,   32,   33,   74,   75,   78,   79}; //  22
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax22");
  needed_g_f[x_a][2] = {  36,   37,   52,   53,   84,   85,   94,   95}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax23");
  needed_g_f[x_a][3] = {  36,   37,   52,   53,   84,   85,   94,   95}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax21");
  needed_g_f[x_a][4] = {  38,   39,   50,   51,   86,   87,   92,   93}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax24");
  needed_g_f[x_a][5] = {  38,   39,   50,   51,   86,   87,   92,   93}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax22");
  needed_g_f[x_a][6] = {  40,   41,   56,   57,   80,   81,   90,   91}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax25");
  needed_g_f[x_a][7] = {  40,   41,   56,   57,   80,   81,   90,   91}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax21");
  needed_g_f[x_a][8] = {  42,   43,   54,   55,   82,   83,   88,   89}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax26");
  needed_g_f[x_a][9] = {  42,   43,   54,   55,   82,   83,   88,   89}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax22");
  needed_g_f[x_a][10] = {  58,   59,   60,   61,   62,   63,   64,   65}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax18");
  needed_g_f[x_a][11] = {  58,   59,   60,   61,   96,   97,   98,   99}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax27");
  needed_g_f[x_a][12] = {  62,   63,   64,   65,  102,  103,  104,  105}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax28");
  needed_g_f[x_a][13] = {  72,   73,   74,   75,   76,   77,   78,   79}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax2");
  needed_g_f[x_a][14] = { 100,  101,  106,  107}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax12");

  g_t[x_a].resize(52);
  needed_g_t[x_a].resize(52);
  needed_g_t[x_a][0] = {   0,    2,    3,    6,    8,    9,   36,   37,   40,   41,   52,   53,   56,   57}; //  14
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    2,    3,    6,    8,    9}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {   1,    4,    5,    7,   10,   11,   38,   39,   42,   43,   50,   51,   54,   55}; //  14
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_188");
  needed_g_t[x_a][3] = {   1,    4,    5,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__128_60");
  needed_g_t[x_a][4] = {  12,   14,   15,   18,   20,   21,   25,   28,   29,   31,   34,   35,   72,   73,   76,   77,   80,   81,   84,   85,   90,   91,   94,   95}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__128_124");
  needed_g_t[x_a][5] = {  12,   14,   15,   18,   20,   21,   72,   73,   76,   77}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__64_60");
  needed_g_t[x_a][6] = {  13,   16,   17,   19,   22,   23,   24,   26,   27,   30,   32,   33,   74,   75,   78,   79,   82,   83,   86,   87,   88,   89,   92,   93}; //  24
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][7] = {  13,   16,   17,   19,   22,   23,   74,   75,   78,   79}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__128_60");
  needed_g_t[x_a][8] = {  24,   26,   27,   30,   32,   33}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][9] = {  25,   28,   29,   31,   34,   35}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__129_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__129_2__64_60");
  needed_g_t[x_a][10] = {  36,   37,   52,   53}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__12_112");
  needed_g_t[x_a][11] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_13__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_13__64_48");
  needed_g_t[x_a][12] = {  38,   39,   50,   51}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_176");
  needed_g_t[x_a][13] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__128_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__128_48");
  needed_g_t[x_a][14] = {  40,   41,   56,   57}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__48_76");
  needed_g_t[x_a][15] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_49__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_49__64_12");
  needed_g_t[x_a][16] = {  42,   43,   54,   55}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_140");
  needed_g_t[x_a][17] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_49__128_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_49__128_12");
  needed_g_t[x_a][18] = {  44,   45,   46,   47,   48,   49,  100,  101,  106,  107}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][19] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__48_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__48_128");
  needed_g_t[x_a][20] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_13__48_64");
  needed_g_t[x_a][21] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_49__12_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_49__12_128");
  needed_g_t[x_a][22] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_49__12_64");
  needed_g_t[x_a][23] = {  58,   59,   60,   61,   96,   97,   98,   99}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][24] = {  58,   59,   60,   61,   98,   99}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][25] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__13_50__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__13_50__64_128");
  needed_g_t[x_a][26] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__13_50__128_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__13_50__128_64");
  needed_g_t[x_a][27] = {  62,   63,   64,   65,  102,  103,  104,  105}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][28] = {  62,   63,   64,   65,  104,  105}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][29] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__49_14__64_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__49_14__64_128");
  needed_g_t[x_a][30] = {  64,   65}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__49_14__128_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__49_14__128_64");
  needed_g_t[x_a][31] = {  66,   67,   68,   69,   70,   71}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][32] = {  72,   73}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_66__12_48");
  needed_g_t[x_a][33] = {  74,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_130__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_130__12_48");
  needed_g_t[x_a][34] = {  76,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_66__48_12");
  needed_g_t[x_a][35] = {  78,   79}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_130__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_130__48_12");
  needed_g_t[x_a][36] = {  80,   81,   90,   91}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__48_76");
  needed_g_t[x_a][37] = {  80,   81}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_50__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_50__12_64");
  needed_g_t[x_a][38] = {  82,   83,   88,   89}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_140");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_140");
  needed_g_t[x_a][39] = {  82,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_50__12_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_50__12_128");
  needed_g_t[x_a][40] = {  84,   85,   94,   95}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__12_112");
  needed_g_t[x_a][41] = {  84,   85}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_14__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_14__48_64");
  needed_g_t[x_a][42] = {  86,   87,   92,   93}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_176");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_176");
  needed_g_t[x_a][43] = {  86,   87}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__48_128");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__48_128");
  needed_g_t[x_a][44] = {  88,   89}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_50__128_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_50__128_12");
  needed_g_t[x_a][45] = {  90,   91}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_50__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_50__64_12");
  needed_g_t[x_a][46] = {  92,   93}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__128_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__128_48");
  needed_g_t[x_a][47] = {  94,   95}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_14__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_14__64_48");
  needed_g_t[x_a][48] = {  96,   97}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__192_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__192_48");
  needed_g_t[x_a][49] = { 100,  101}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__48_12");
  needed_g_t[x_a][50] = { 102,  103}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__192_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__192_12");
  needed_g_t[x_a][51] = { 106,  107}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__12_48");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   0,    1,   12,   13,   24,   25,   44,   66}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][1] = {   0,    1,   12,   13,   24,   25,   44,   66}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; // 100
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][3] = {   2,    3,    4,    5,   14,   15,   16,   17,   26,   27,   28,   29,   45,   46,   67,   68}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2,    3,    4,    5,   14,   15,   16,   17,   26,   27,   28,   29,   45,   46,   67,   68}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {   6,    7,   18,   19,   30,   31,   47,   69}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   6,    7,   18,   19,   30,   31,   47,   69}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][7] = {   6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   22,   23,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; //  84
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][8] = {   8,    9,   10,   11,   20,   21,   22,   23,   32,   33,   34,   35,   48,   49,   70,   71}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][9] = {  44,   45,   46,   47,   48,   49,   66,   67,   68,   69,   70,   71,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");

  c_p[x_a].resize(108);
  c_f[x_a].resize(108);
  c_t[x_a].resize(108);
  c_d[x_a].resize(108);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   2}; //   3
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  3,   4,   5}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  0,   4,   5}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  3,   4,   2}; //   3

  c_p[x_a][4] = {  3,   4,   5}; //   3
  c_f[x_a][4] = {  1}; //   1
  c_t[x_a][4] = {  2,   3}; //   2
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   4,   5}; //   3
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  2,   3}; //   2
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  6,   7,   8}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = {  5,   6,   7}; //   3

  c_p[x_a][7] = {  6,   7,   8}; //   3
  c_f[x_a][7] = {  1}; //   1
  c_t[x_a][7] = {  2,   3}; //   2
  c_d[x_a][7] = {  5,   6,   7}; //   3

  c_p[x_a][8] = {  6,   9,  10}; //   3
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  0,   1}; //   2
  c_d[x_a][8] = {  8,   2,   7}; //   3

  c_p[x_a][9] = {  6,  11,  10}; //   3
  c_f[x_a][9] = {  0}; //   1
  c_t[x_a][9] = {  0,   1}; //   2
  c_d[x_a][9] = {  8,   2,   7}; //   3

  c_p[x_a][10] = {  6,   9,  10}; //   3
  c_f[x_a][10] = {  1}; //   1
  c_t[x_a][10] = {  2,   3}; //   2
  c_d[x_a][10] = {  8,   2,   7}; //   3

  c_p[x_a][11] = {  6,  11,  10}; //   3
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  2,   3}; //   2
  c_d[x_a][11] = {  8,   2,   7}; //   3

  c_p[x_a][12] = {  0,   1,   2}; //   3
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  4,   5}; //   2
  c_d[x_a][12] = {  0,   1,   2}; //   3

  c_p[x_a][13] = {  0,   1,   2}; //   3
  c_f[x_a][13] = {  1}; //   1
  c_t[x_a][13] = {  6,   7}; //   2
  c_d[x_a][13] = {  0,   1,   2}; //   3

  c_p[x_a][14] = {  3,   4,   5}; //   3
  c_f[x_a][14] = {  0}; //   1
  c_t[x_a][14] = {  4,   5}; //   2
  c_d[x_a][14] = {  3,   4,   2}; //   3

  c_p[x_a][15] = {  0,   4,   5}; //   3
  c_f[x_a][15] = {  0}; //   1
  c_t[x_a][15] = {  4,   5}; //   2
  c_d[x_a][15] = {  3,   4,   2}; //   3

  c_p[x_a][16] = {  3,   4,   5}; //   3
  c_f[x_a][16] = {  1}; //   1
  c_t[x_a][16] = {  6,   7}; //   2
  c_d[x_a][16] = {  3,   4,   2}; //   3

  c_p[x_a][17] = {  0,   4,   5}; //   3
  c_f[x_a][17] = {  1}; //   1
  c_t[x_a][17] = {  6,   7}; //   2
  c_d[x_a][17] = {  3,   4,   2}; //   3

  c_p[x_a][18] = {  6,   7,   8}; //   3
  c_f[x_a][18] = {  0}; //   1
  c_t[x_a][18] = {  4,   5}; //   2
  c_d[x_a][18] = {  5,   6,   7}; //   3

  c_p[x_a][19] = {  6,   7,   8}; //   3
  c_f[x_a][19] = {  1}; //   1
  c_t[x_a][19] = {  6,   7}; //   2
  c_d[x_a][19] = {  5,   6,   7}; //   3

  c_p[x_a][20] = {  6,   9,  10}; //   3
  c_f[x_a][20] = {  0}; //   1
  c_t[x_a][20] = {  4,   5}; //   2
  c_d[x_a][20] = {  8,   2,   7}; //   3

  c_p[x_a][21] = {  6,  11,  10}; //   3
  c_f[x_a][21] = {  0}; //   1
  c_t[x_a][21] = {  4,   5}; //   2
  c_d[x_a][21] = {  8,   2,   7}; //   3

  c_p[x_a][22] = {  6,   9,  10}; //   3
  c_f[x_a][22] = {  1}; //   1
  c_t[x_a][22] = {  6,   7}; //   2
  c_d[x_a][22] = {  8,   2,   7}; //   3

  c_p[x_a][23] = {  6,  11,  10}; //   3
  c_f[x_a][23] = {  1}; //   1
  c_t[x_a][23] = {  6,   7}; //   2
  c_d[x_a][23] = {  8,   2,   7}; //   3

  c_p[x_a][24] = {  0,   1,   2}; //   3
  c_f[x_a][24] = {  1}; //   1
  c_t[x_a][24] = {  6,   8}; //   2
  c_d[x_a][24] = {  0,   1,   2}; //   3

  c_p[x_a][25] = {  0,   1,   2}; //   3
  c_f[x_a][25] = {  0}; //   1
  c_t[x_a][25] = {  4,   9}; //   2
  c_d[x_a][25] = {  0,   1,   2}; //   3

  c_p[x_a][26] = {  3,   4,   5}; //   3
  c_f[x_a][26] = {  1}; //   1
  c_t[x_a][26] = {  6,   8}; //   2
  c_d[x_a][26] = {  3,   4,   2}; //   3

  c_p[x_a][27] = {  0,   4,   5}; //   3
  c_f[x_a][27] = {  1}; //   1
  c_t[x_a][27] = {  6,   8}; //   2
  c_d[x_a][27] = {  3,   4,   2}; //   3

  c_p[x_a][28] = {  3,   4,   5}; //   3
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  4,   9}; //   2
  c_d[x_a][28] = {  3,   4,   2}; //   3

  c_p[x_a][29] = {  0,   4,   5}; //   3
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  4,   9}; //   2
  c_d[x_a][29] = {  3,   4,   2}; //   3

  c_p[x_a][30] = {  6,   7,   8}; //   3
  c_f[x_a][30] = {  1}; //   1
  c_t[x_a][30] = {  6,   8}; //   2
  c_d[x_a][30] = {  5,   6,   7}; //   3

  c_p[x_a][31] = {  6,   7,   8}; //   3
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  4,   9}; //   2
  c_d[x_a][31] = {  5,   6,   7}; //   3

  c_p[x_a][32] = {  6,   9,  10}; //   3
  c_f[x_a][32] = {  1}; //   1
  c_t[x_a][32] = {  6,   8}; //   2
  c_d[x_a][32] = {  8,   2,   7}; //   3

  c_p[x_a][33] = {  6,  11,  10}; //   3
  c_f[x_a][33] = {  1}; //   1
  c_t[x_a][33] = {  6,   8}; //   2
  c_d[x_a][33] = {  8,   2,   7}; //   3

  c_p[x_a][34] = {  6,   9,  10}; //   3
  c_f[x_a][34] = {  0}; //   1
  c_t[x_a][34] = {  4,   9}; //   2
  c_d[x_a][34] = {  8,   2,   7}; //   3

  c_p[x_a][35] = {  6,  11,  10}; //   3
  c_f[x_a][35] = {  0}; //   1
  c_t[x_a][35] = {  4,   9}; //   2
  c_d[x_a][35] = {  8,   2,   7}; //   3

  c_p[x_a][36] = {  6,   9}; //   2
  c_f[x_a][36] = {  2,   3}; //   2
  c_t[x_a][36] = {  0,  10,  11}; //   3
  c_d[x_a][36] = {  2,   7}; //   2

  c_p[x_a][37] = {  6,  11}; //   2
  c_f[x_a][37] = {  2,   3}; //   2
  c_t[x_a][37] = {  0,  10,  11}; //   3
  c_d[x_a][37] = {  2,   7}; //   2

  c_p[x_a][38] = {  6,   9}; //   2
  c_f[x_a][38] = {  4,   5}; //   2
  c_t[x_a][38] = {  2,  12,  13}; //   3
  c_d[x_a][38] = {  2,   7}; //   2

  c_p[x_a][39] = {  6,  11}; //   2
  c_f[x_a][39] = {  4,   5}; //   2
  c_t[x_a][39] = {  2,  12,  13}; //   3
  c_d[x_a][39] = {  2,   7}; //   2

  c_p[x_a][40] = {  3,  12}; //   2
  c_f[x_a][40] = {  6,   7}; //   2
  c_t[x_a][40] = {  0,  14,  15}; //   3
  c_d[x_a][40] = {  7,   2}; //   2

  c_p[x_a][41] = {  0,  12}; //   2
  c_f[x_a][41] = {  6,   7}; //   2
  c_t[x_a][41] = {  0,  14,  15}; //   3
  c_d[x_a][41] = {  7,   2}; //   2

  c_p[x_a][42] = {  3,  12}; //   2
  c_f[x_a][42] = {  8,   9}; //   2
  c_t[x_a][42] = {  2,  16,  17}; //   3
  c_d[x_a][42] = {  7,   2}; //   2

  c_p[x_a][43] = {  0,  12}; //   2
  c_f[x_a][43] = {  8,   9}; //   2
  c_t[x_a][43] = {  2,  16,  17}; //   3
  c_d[x_a][43] = {  7,   2}; //   2

  c_p[x_a][44] = {  0,   1,   2,  13}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = { 18}; //   1
  c_d[x_a][44] = {  9,   0,   1,   2}; //   4

  c_p[x_a][45] = {  3,   4,   5,  13}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = { 18}; //   1
  c_d[x_a][45] = {  9,   3,   4,   2}; //   4

  c_p[x_a][46] = {  0,   4,   5,  13}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 18}; //   1
  c_d[x_a][46] = {  9,   3,   4,   2}; //   4

  c_p[x_a][47] = {  6,   7,   8,  13}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = { 18}; //   1
  c_d[x_a][47] = {  9,   5,   6,   7}; //   4

  c_p[x_a][48] = {  6,   9,  10,  13}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = { 18}; //   1
  c_d[x_a][48] = {  9,   8,   2,   7}; //   4

  c_p[x_a][49] = {  6,  11,  10,  13}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = { 18}; //   1
  c_d[x_a][49] = {  9,   8,   2,   7}; //   4

  c_p[x_a][50] = {  6,   9}; //   2
  c_f[x_a][50] = {  4,   5}; //   2
  c_t[x_a][50] = {  2,  12,  19}; //   3
  c_d[x_a][50] = {  2,   7}; //   2

  c_p[x_a][51] = {  6,  11}; //   2
  c_f[x_a][51] = {  4,   5}; //   2
  c_t[x_a][51] = {  2,  12,  19}; //   3
  c_d[x_a][51] = {  2,   7}; //   2

  c_p[x_a][52] = {  6,   9}; //   2
  c_f[x_a][52] = {  2,   3}; //   2
  c_t[x_a][52] = {  0,  10,  20}; //   3
  c_d[x_a][52] = {  2,   7}; //   2

  c_p[x_a][53] = {  6,  11}; //   2
  c_f[x_a][53] = {  2,   3}; //   2
  c_t[x_a][53] = {  0,  10,  20}; //   3
  c_d[x_a][53] = {  2,   7}; //   2

  c_p[x_a][54] = {  3,  12}; //   2
  c_f[x_a][54] = {  8,   9}; //   2
  c_t[x_a][54] = {  2,  16,  21}; //   3
  c_d[x_a][54] = {  7,   2}; //   2

  c_p[x_a][55] = {  0,  12}; //   2
  c_f[x_a][55] = {  8,   9}; //   2
  c_t[x_a][55] = {  2,  16,  21}; //   3
  c_d[x_a][55] = {  7,   2}; //   2

  c_p[x_a][56] = {  3,  12}; //   2
  c_f[x_a][56] = {  6,   7}; //   2
  c_t[x_a][56] = {  0,  14,  22}; //   3
  c_d[x_a][56] = {  7,   2}; //   2

  c_p[x_a][57] = {  0,  12}; //   2
  c_f[x_a][57] = {  6,   7}; //   2
  c_t[x_a][57] = {  0,  14,  22}; //   3
  c_d[x_a][57] = {  7,   2}; //   2

  c_p[x_a][58] = {  6,   9}; //   2
  c_f[x_a][58] = { 10,  11}; //   2
  c_t[x_a][58] = { 23,  24,  25}; //   3
  c_d[x_a][58] = {  2,   7}; //   2

  c_p[x_a][59] = {  6,  11}; //   2
  c_f[x_a][59] = { 10,  11}; //   2
  c_t[x_a][59] = { 23,  24,  25}; //   3
  c_d[x_a][59] = {  2,   7}; //   2

  c_p[x_a][60] = {  6,   9}; //   2
  c_f[x_a][60] = { 10,  11}; //   2
  c_t[x_a][60] = { 23,  24,  26}; //   3
  c_d[x_a][60] = {  2,   7}; //   2

  c_p[x_a][61] = {  6,  11}; //   2
  c_f[x_a][61] = { 10,  11}; //   2
  c_t[x_a][61] = { 23,  24,  26}; //   3
  c_d[x_a][61] = {  2,   7}; //   2

  c_p[x_a][62] = {  3,  12}; //   2
  c_f[x_a][62] = { 10,  12}; //   2
  c_t[x_a][62] = { 27,  28,  29}; //   3
  c_d[x_a][62] = {  7,   2}; //   2

  c_p[x_a][63] = {  0,  12}; //   2
  c_f[x_a][63] = { 10,  12}; //   2
  c_t[x_a][63] = { 27,  28,  29}; //   3
  c_d[x_a][63] = {  7,   2}; //   2

  c_p[x_a][64] = {  3,  12}; //   2
  c_f[x_a][64] = { 10,  12}; //   2
  c_t[x_a][64] = { 27,  28,  30}; //   3
  c_d[x_a][64] = {  7,   2}; //   2

  c_p[x_a][65] = {  0,  12}; //   2
  c_f[x_a][65] = { 10,  12}; //   2
  c_t[x_a][65] = { 27,  28,  30}; //   3
  c_d[x_a][65] = {  7,   2}; //   2

  c_p[x_a][66] = { 14,  15,  16,  17}; //   4
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = { 31}; //   1
  c_d[x_a][66] = {  0,   1,   2,   9}; //   4

  c_p[x_a][67] = { 14,  18,  19,  20}; //   4
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = { 31}; //   1
  c_d[x_a][67] = {  3,   4,   2,   9}; //   4

  c_p[x_a][68] = { 14,  15,  19,  20}; //   4
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = { 31}; //   1
  c_d[x_a][68] = {  3,   4,   2,   9}; //   4

  c_p[x_a][69] = { 14,  21,  22,  23}; //   4
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = { 31}; //   1
  c_d[x_a][69] = {  5,   6,   7,   9}; //   4

  c_p[x_a][70] = { 14,  21,  24,  25}; //   4
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = { 31}; //   1
  c_d[x_a][70] = {  8,   2,   7,   9}; //   4

  c_p[x_a][71] = { 14,  21,  26,  25}; //   4
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = { 31}; //   1
  c_d[x_a][71] = {  8,   2,   7,   9}; //   4

  c_p[x_a][72] = {  6,   9}; //   2
  c_f[x_a][72] = { 13,   0}; //   2
  c_t[x_a][72] = {  4,   5,  32}; //   3
  c_d[x_a][72] = {  2,   7}; //   2

  c_p[x_a][73] = {  6,  11}; //   2
  c_f[x_a][73] = { 13,   0}; //   2
  c_t[x_a][73] = {  4,   5,  32}; //   3
  c_d[x_a][73] = {  2,   7}; //   2

  c_p[x_a][74] = {  6,   9}; //   2
  c_f[x_a][74] = { 13,   1}; //   2
  c_t[x_a][74] = {  6,   7,  33}; //   3
  c_d[x_a][74] = {  2,   7}; //   2

  c_p[x_a][75] = {  6,  11}; //   2
  c_f[x_a][75] = { 13,   1}; //   2
  c_t[x_a][75] = {  6,   7,  33}; //   3
  c_d[x_a][75] = {  2,   7}; //   2

  c_p[x_a][76] = {  3,  12}; //   2
  c_f[x_a][76] = { 13,   0}; //   2
  c_t[x_a][76] = {  4,   5,  34}; //   3
  c_d[x_a][76] = {  7,   2}; //   2

  c_p[x_a][77] = {  0,  12}; //   2
  c_f[x_a][77] = { 13,   0}; //   2
  c_t[x_a][77] = {  4,   5,  34}; //   3
  c_d[x_a][77] = {  7,   2}; //   2

  c_p[x_a][78] = {  3,  12}; //   2
  c_f[x_a][78] = { 13,   1}; //   2
  c_t[x_a][78] = {  6,   7,  35}; //   3
  c_d[x_a][78] = {  7,   2}; //   2

  c_p[x_a][79] = {  0,  12}; //   2
  c_f[x_a][79] = { 13,   1}; //   2
  c_t[x_a][79] = {  6,   7,  35}; //   3
  c_d[x_a][79] = {  7,   2}; //   2

  c_p[x_a][80] = {  6,   9}; //   2
  c_f[x_a][80] = {  6,   7}; //   2
  c_t[x_a][80] = {  4,  36,  37}; //   3
  c_d[x_a][80] = {  2,   7}; //   2

  c_p[x_a][81] = {  6,  11}; //   2
  c_f[x_a][81] = {  6,   7}; //   2
  c_t[x_a][81] = {  4,  36,  37}; //   3
  c_d[x_a][81] = {  2,   7}; //   2

  c_p[x_a][82] = {  6,   9}; //   2
  c_f[x_a][82] = {  8,   9}; //   2
  c_t[x_a][82] = {  6,  38,  39}; //   3
  c_d[x_a][82] = {  2,   7}; //   2

  c_p[x_a][83] = {  6,  11}; //   2
  c_f[x_a][83] = {  8,   9}; //   2
  c_t[x_a][83] = {  6,  38,  39}; //   3
  c_d[x_a][83] = {  2,   7}; //   2

  c_p[x_a][84] = {  3,  12}; //   2
  c_f[x_a][84] = {  2,   3}; //   2
  c_t[x_a][84] = {  4,  40,  41}; //   3
  c_d[x_a][84] = {  7,   2}; //   2

  c_p[x_a][85] = {  0,  12}; //   2
  c_f[x_a][85] = {  2,   3}; //   2
  c_t[x_a][85] = {  4,  40,  41}; //   3
  c_d[x_a][85] = {  7,   2}; //   2

  c_p[x_a][86] = {  3,  12}; //   2
  c_f[x_a][86] = {  4,   5}; //   2
  c_t[x_a][86] = {  6,  42,  43}; //   3
  c_d[x_a][86] = {  7,   2}; //   2

  c_p[x_a][87] = {  0,  12}; //   2
  c_f[x_a][87] = {  4,   5}; //   2
  c_t[x_a][87] = {  6,  42,  43}; //   3
  c_d[x_a][87] = {  7,   2}; //   2

  c_p[x_a][88] = {  6,   9}; //   2
  c_f[x_a][88] = {  8,   9}; //   2
  c_t[x_a][88] = {  6,  38,  44}; //   3
  c_d[x_a][88] = {  2,   7}; //   2

  c_p[x_a][89] = {  6,  11}; //   2
  c_f[x_a][89] = {  8,   9}; //   2
  c_t[x_a][89] = {  6,  38,  44}; //   3
  c_d[x_a][89] = {  2,   7}; //   2

  c_p[x_a][90] = {  6,   9}; //   2
  c_f[x_a][90] = {  6,   7}; //   2
  c_t[x_a][90] = {  4,  36,  45}; //   3
  c_d[x_a][90] = {  2,   7}; //   2

  c_p[x_a][91] = {  6,  11}; //   2
  c_f[x_a][91] = {  6,   7}; //   2
  c_t[x_a][91] = {  4,  36,  45}; //   3
  c_d[x_a][91] = {  2,   7}; //   2

  c_p[x_a][92] = {  3,  12}; //   2
  c_f[x_a][92] = {  4,   5}; //   2
  c_t[x_a][92] = {  6,  42,  46}; //   3
  c_d[x_a][92] = {  7,   2}; //   2

  c_p[x_a][93] = {  0,  12}; //   2
  c_f[x_a][93] = {  4,   5}; //   2
  c_t[x_a][93] = {  6,  42,  46}; //   3
  c_d[x_a][93] = {  7,   2}; //   2

  c_p[x_a][94] = {  3,  12}; //   2
  c_f[x_a][94] = {  2,   3}; //   2
  c_t[x_a][94] = {  4,  40,  47}; //   3
  c_d[x_a][94] = {  7,   2}; //   2

  c_p[x_a][95] = {  0,  12}; //   2
  c_f[x_a][95] = {  2,   3}; //   2
  c_t[x_a][95] = {  4,  40,  47}; //   3
  c_d[x_a][95] = {  7,   2}; //   2

  c_p[x_a][96] = { 14,  21,  24}; //   3
  c_f[x_a][96] = { 11}; //   1
  c_t[x_a][96] = { 23,  48}; //   2
  c_d[x_a][96] = {  2,   7,   9}; //   3

  c_p[x_a][97] = { 14,  21,  26}; //   3
  c_f[x_a][97] = { 11}; //   1
  c_t[x_a][97] = { 23,  48}; //   2
  c_d[x_a][97] = {  2,   7,   9}; //   3

  c_p[x_a][98] = {  6,  27,  24}; //   3
  c_f[x_a][98] = { 11}; //   1
  c_t[x_a][98] = { 23,  24}; //   2
  c_d[x_a][98] = {  2,   9,   7}; //   3

  c_p[x_a][99] = {  6,  27,  26}; //   3
  c_f[x_a][99] = { 11}; //   1
  c_t[x_a][99] = { 23,  24}; //   2
  c_d[x_a][99] = {  2,   9,   7}; //   3

  c_p[x_a][100] = {  6,   9,  28}; //   3
  c_f[x_a][100] = { 14}; //   1
  c_t[x_a][100] = { 18,  49}; //   2
  c_d[x_a][100] = {  9,   2,   7}; //   3

  c_p[x_a][101] = {  6,  11,  28}; //   3
  c_f[x_a][101] = { 14}; //   1
  c_t[x_a][101] = { 18,  49}; //   2
  c_d[x_a][101] = {  9,   2,   7}; //   3

  c_p[x_a][102] = { 14,  18,  29}; //   3
  c_f[x_a][102] = { 12}; //   1
  c_t[x_a][102] = { 27,  50}; //   2
  c_d[x_a][102] = {  7,   2,   9}; //   3

  c_p[x_a][103] = { 14,  15,  29}; //   3
  c_f[x_a][103] = { 12}; //   1
  c_t[x_a][103] = { 27,  50}; //   2
  c_d[x_a][103] = {  7,   2,   9}; //   3

  c_p[x_a][104] = {  3,  30,  29}; //   3
  c_f[x_a][104] = { 12}; //   1
  c_t[x_a][104] = { 27,  28}; //   2
  c_d[x_a][104] = {  7,   9,   2}; //   3

  c_p[x_a][105] = {  0,  30,  29}; //   3
  c_f[x_a][105] = { 12}; //   1
  c_t[x_a][105] = { 27,  28}; //   2
  c_d[x_a][105] = {  7,   9,   2}; //   3

  c_p[x_a][106] = {  3,  12,  28}; //   3
  c_f[x_a][106] = { 14}; //   1
  c_t[x_a][106] = { 18,  51}; //   2
  c_d[x_a][106] = {  9,   7,   2}; //   3

  c_p[x_a][107] = {  0,  12,  28}; //   3
  c_f[x_a][107] = { 14}; //   1
  c_t[x_a][107] = { 18,  51}; //   2
  c_d[x_a][107] = {  9,   7,   2}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_udx_emepmupvmgg
//  channel    0: 4yyv11(1, 2, 16, 32, 4, 8, 64, 128;  23,   0,  24,   0,   0)
//  channel    1: 4yyv11(1, 2, 16, 32, 4, 8, 128, 64;  23,   0,  24,   0,   0)
//  channel    2: 4yyv11(1, 2, 32, 16, 4, 8, 64, 128;   0,   0,  24,   0,   0)
//  channel    3: 4yyv11(1, 2, 32, 16, 4, 8, 64, 128;  23,   0,  24,   0,   0)
//  channel    4: 4yyv11(1, 2, 32, 16, 4, 8, 128, 64;   0,   0,  24,   0,   0)
//  channel    5: 4yyv11(1, 2, 32, 16, 4, 8, 128, 64;  23,   0,  24,   0,   0)
//  channel    6: 4yyv11(1, 2, 8, 4, 16, 32, 64, 128;  24,   0,  24,   0,   0)
//  channel    7: 4yyv11(1, 2, 8, 4, 16, 32, 128, 64;  24,   0,  24,   0,   0)
//  channel    8: 42vv11(1, 2, 4, 8, 16, 32, 64, 128;  24,   0,  24,   0,   0)
//  channel    9: 42vv11(1, 2, 4, 8, 16, 32, 64, 128;  24,  23,  24,   0,   0)
//  channel   10: 42vv11(1, 2, 4, 8, 16, 32, 128, 64;  24,   0,  24,   0,   0)
//  channel   11: 42vv11(1, 2, 4, 8, 16, 32, 128, 64;  24,  23,  24,   0,   0)
//  channel   12: 14yyv1(1, 2, 128, 16, 32, 4, 8, 64;  23,   0,  24,   0,   0)
//  channel   13: 14yyv1(1, 2, 64, 16, 32, 4, 8, 128;  23,   0,  24,   0,   0)
//  channel   14: 14yyv1(1, 2, 128, 32, 16, 4, 8, 64;   0,   0,  24,   0,   0)
//  channel   15: 14yyv1(1, 2, 128, 32, 16, 4, 8, 64;  23,   0,  24,   0,   0)
//  channel   16: 14yyv1(1, 2, 64, 32, 16, 4, 8, 128;   0,   0,  24,   0,   0)
//  channel   17: 14yyv1(1, 2, 64, 32, 16, 4, 8, 128;  23,   0,  24,   0,   0)
//  channel   18: 14yyv1(1, 2, 128, 8, 4, 16, 32, 64;  24,   0,  24,   0,   0)
//  channel   19: 14yyv1(1, 2, 64, 8, 4, 16, 32, 128;  24,   0,  24,   0,   0)
//  channel   20: 142vv1(1, 2, 128, 4, 8, 16, 32, 64;  24,   0,  24,   0,   0)
//  channel   21: 142vv1(1, 2, 128, 4, 8, 16, 32, 64;  24,  23,  24,   0,   0)
//  channel   22: 142vv1(1, 2, 64, 4, 8, 16, 32, 128;  24,   0,  24,   0,   0)
//  channel   23: 142vv1(1, 2, 64, 4, 8, 16, 32, 128;  24,  23,  24,   0,   0)
//  channel   24: 114yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
//  channel   25: 114yyv(1, 2, 128, 64, 16, 32, 4, 8;  23,   0,  24,   0,   0)
//  channel   26: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
//  channel   27: 114yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
//  channel   28: 114yyv(1, 2, 128, 64, 32, 16, 4, 8;   0,   0,  24,   0,   0)
//  channel   29: 114yyv(1, 2, 128, 64, 32, 16, 4, 8;  23,   0,  24,   0,   0)
//  channel   30: 114yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
//  channel   31: 114yyv(1, 2, 128, 64, 8, 4, 16, 32;  24,   0,  24,   0,   0)
//  channel   32: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
//  channel   33: 1142vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
//  channel   34: 1142vv(1, 2, 128, 64, 4, 8, 16, 32;  24,   0,  24,   0,   0)
//  channel   35: 1142vv(1, 2, 128, 64, 4, 8, 16, 32;  24,  23,  24,   0,   0)
//  channel   36: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  24,   0,   0,   0,   0)
//  channel   37: 2v2v11(1, 2, 4, 8, 16, 32, 64, 128;  24,  23,   0,   0,   0)
//  channel   38: 2v2v11(1, 2, 4, 8, 16, 32, 128, 64;  24,   0,   0,   0,   0)
//  channel   39: 2v2v11(1, 2, 4, 8, 16, 32, 128, 64;  24,  23,   0,   0,   0)
//  channel   40: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;   0,  24,   0,   0,   0)
//  channel   41: 2v2v11(1, 2, 16, 32, 4, 8, 64, 128;  23,  24,   0,   0,   0)
//  channel   42: 2v2v11(1, 2, 16, 32, 4, 8, 128, 64;   0,  24,   0,   0,   0)
//  channel   43: 2v2v11(1, 2, 16, 32, 4, 8, 128, 64;  23,  24,   0,   0,   0)
//  channel   44: 2v4yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  24,   0,   0)
//  channel   45: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;   0,   0,  24,   0,   0)
//  channel   46: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  24,   0,   0)
//  channel   47: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  24,   0,  24,   0,   0)
//  channel   48: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,  24,   0,   0)
//  channel   49: 2v42vv(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,  24,   0,   0)
//  channel   50: 2v12v1(1, 2, 4, 8, 128, 16, 32, 64;  24,   0,   0,   0,   0)
//  channel   51: 2v12v1(1, 2, 4, 8, 128, 16, 32, 64;  24,  23,   0,   0,   0)
//  channel   52: 2v12v1(1, 2, 4, 8, 64, 16, 32, 128;  24,   0,   0,   0,   0)
//  channel   53: 2v12v1(1, 2, 4, 8, 64, 16, 32, 128;  24,  23,   0,   0,   0)
//  channel   54: 2v12v1(1, 2, 16, 32, 128, 4, 8, 64;   0,  24,   0,   0,   0)
//  channel   55: 2v12v1(1, 2, 16, 32, 128, 4, 8, 64;  23,  24,   0,   0,   0)
//  channel   56: 2v12v1(1, 2, 16, 32, 64, 4, 8, 128;   0,  24,   0,   0,   0)
//  channel   57: 2v12v1(1, 2, 16, 32, 64, 4, 8, 128;  23,  24,   0,   0,   0)
//  channel   58: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
//  channel   59: 2v112v(1, 2, 4, 8, 64, 128, 16, 32;  24,  23,   0,   0,   0)
//  channel   60: 2v112v(1, 2, 4, 8, 128, 64, 16, 32;  24,   0,   0,   0,   0)
//  channel   61: 2v112v(1, 2, 4, 8, 128, 64, 16, 32;  24,  23,   0,   0,   0)
//  channel   62: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;   0,  24,   0,   0,   0)
//  channel   63: 2v112v(1, 2, 16, 32, 64, 128, 4, 8;  23,  24,   0,   0,   0)
//  channel   64: 2v112v(1, 2, 16, 32, 128, 64, 4, 8;   0,  24,   0,   0,   0)
//  channel   65: 2v112v(1, 2, 16, 32, 128, 64, 4, 8;  23,  24,   0,   0,   0)
//  channel   66: 4yyv2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,  24,   0)
//  channel   67: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,   0,   0,  24,   0)
//  channel   68: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,  23,   0,  24,   0)
//  channel   69: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  24,   0,  24,   0)
//  channel   70: 42vv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,  24,   0)
//  channel   71: 42vv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,  23,  24,   0)
//  channel   72: 12v2v1(1, 2, 128, 4, 8, 16, 32, 64;  24,   0,   0,   0,   0)
//  channel   73: 12v2v1(1, 2, 128, 4, 8, 16, 32, 64;  24,  23,   0,   0,   0)
//  channel   74: 12v2v1(1, 2, 64, 4, 8, 16, 32, 128;  24,   0,   0,   0,   0)
//  channel   75: 12v2v1(1, 2, 64, 4, 8, 16, 32, 128;  24,  23,   0,   0,   0)
//  channel   76: 12v2v1(1, 2, 128, 16, 32, 4, 8, 64;   0,  24,   0,   0,   0)
//  channel   77: 12v2v1(1, 2, 128, 16, 32, 4, 8, 64;  23,  24,   0,   0,   0)
//  channel   78: 12v2v1(1, 2, 64, 16, 32, 4, 8, 128;   0,  24,   0,   0,   0)
//  channel   79: 12v2v1(1, 2, 64, 16, 32, 4, 8, 128;  23,  24,   0,   0,   0)
//  channel   80: 12v12v(1, 2, 128, 4, 8, 64, 16, 32;  24,   0,   0,   0,   0)
//  channel   81: 12v12v(1, 2, 128, 4, 8, 64, 16, 32;  24,  23,   0,   0,   0)
//  channel   82: 12v12v(1, 2, 64, 4, 8, 128, 16, 32;  24,   0,   0,   0,   0)
//  channel   83: 12v12v(1, 2, 64, 4, 8, 128, 16, 32;  24,  23,   0,   0,   0)
//  channel   84: 12v12v(1, 2, 128, 16, 32, 64, 4, 8;   0,  24,   0,   0,   0)
//  channel   85: 12v12v(1, 2, 128, 16, 32, 64, 4, 8;  23,  24,   0,   0,   0)
//  channel   86: 12v12v(1, 2, 64, 16, 32, 128, 4, 8;   0,  24,   0,   0,   0)
//  channel   87: 12v12v(1, 2, 64, 16, 32, 128, 4, 8;  23,  24,   0,   0,   0)
//  channel   88: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
//  channel   89: 112v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
//  channel   90: 112v2v(1, 2, 128, 64, 4, 8, 16, 32;  24,   0,   0,   0,   0)
//  channel   91: 112v2v(1, 2, 128, 64, 4, 8, 16, 32;  24,  23,   0,   0,   0)
//  channel   92: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
//  channel   93: 112v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
//  channel   94: 112v2v(1, 2, 128, 64, 16, 32, 4, 8;   0,  24,   0,   0,   0)
//  channel   95: 112v2v(1, 2, 128, 64, 16, 32, 4, 8;  23,  24,   0,   0,   0)
//  channel   96: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,   0,   0,   0)
//  channel   97: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  24,  23,   0,   0)
//  channel   98: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,   0,   0,   0)
//  channel   99: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  24,   0,  23,   0,   0)
//  channel  100: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,   0,   0,   0,   0)
//  channel  101: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  24,  23,   0,   0,   0)
//  channel  102: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,   0,  24,   0,   0)
//  channel  103: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,  24,   0,   0)
//  channel  104: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  24,   0,   0)
//  channel  105: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  24,   0,   0)
//  channel  106: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  24,   0,   0,   0)
//  channel  107: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  24,   0,   0,   0)
