#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_240_gg_emepvevex(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_240_gg_emepvevex");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(12);
  needed_v_smin[x_a].resize(12);
  int needed_v_smin_0[] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  23
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 23);
  int needed_v_smin_1[] = {   0,    1}; //   2
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 15);
  int needed_v_smin_3[] = {   2,    3}; //   2
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 2);
  int needed_v_smin_4[] = {   4}; //   1
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 1);
  int needed_v_smin_5[] = {   5,    6,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  21
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 21);
  int needed_v_smin_6[] = {   5}; //   1
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 1);
  int needed_v_smin_7[] = {   6}; //   1
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 1);
  int needed_v_smin_8[] = {   7,    8}; //   2
  needed_v_smin[x_a][  8] = get_vector_from_array_int(needed_v_smin_8, 2);
  int needed_v_smin_9[] = {   9,   10,   11,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  needed_v_smin[x_a][  9] = get_vector_from_array_int(needed_v_smin_9, 15);
  int needed_v_smin_10[] = {   9,   10}; //   2
  needed_v_smin[x_a][ 10] = get_vector_from_array_int(needed_v_smin_10, 2);
  int needed_v_smin_11[] = {  11}; //   1
  needed_v_smin[x_a][ 11] = get_vector_from_array_int(needed_v_smin_11, 1);

  v_smax[x_a].resize(12);
  needed_v_smax[x_a].resize(12);
  int needed_v_smax_0[] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30}; //  17
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 17);
  int needed_v_smax_1[] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 4);
  int needed_v_smax_2[] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33}; //  12
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 12);
  int needed_v_smax_3[] = {   4,    6}; //   2
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 2);
  int needed_v_smax_4[] = {   5,    6,   34,   35,   36,   37,   38,   39}; //   8
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 8);
  int needed_v_smax_5[] = {   5,   11}; //   2
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 2);
  int needed_v_smax_6[] = {   7,    8,    9,   10}; //   4
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 4);
  int needed_v_smax_7[] = {   9,   10,   11,   40,   41,   42}; //   6
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 6);
  int needed_v_smax_8[] = {  12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30}; //  13
  needed_v_smax[x_a][  8] = get_vector_from_array_int(needed_v_smax_8, 13);
  int needed_v_smax_9[] = {  19,   20,   21,   22,   23,   24,   31,   32,   33}; //   9
  needed_v_smax[x_a][  9] = get_vector_from_array_int(needed_v_smax_9, 9);
  int needed_v_smax_10[] = {  34,   35,   36,   37,   38,   39}; //   6
  needed_v_smax[x_a][ 10] = get_vector_from_array_int(needed_v_smax_10, 6);
  int needed_v_smax_11[] = {  40,   41,   42}; //   3
  needed_v_smax[x_a][ 11] = get_vector_from_array_int(needed_v_smax_11, 3);

  g_p[x_a].resize(18);
  needed_g_p[x_a].resize(18);
  needed_g_p[x_a][0] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax1");
  needed_g_p[x_a][4] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][5] = {   5,    6,   37,   38,   39}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax4");
  needed_g_p[x_a][6] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax3");
  needed_g_p[x_a][8] = {   7,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][9] = {   9,   10,   11,   40,   41,   42}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax7");
  needed_g_p[x_a][10] = {   9,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax6");
  needed_g_p[x_a][11] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax5");
  needed_g_p[x_a][12] = {  12,   13,   14,   25,   26,   27}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax8");
  needed_g_p[x_a][13] = {  15,   16,   17,   18,   28,   29,   30}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax8");
  needed_g_p[x_a][14] = {  19,   20,   21,   22,   23,   24,   31,   32,   33}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax9");
  needed_g_p[x_a][15] = {  34,   35,   36}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][16] = {  34,   35,   36,   37,   38,   39}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax10");
  needed_g_p[x_a][17] = {  40,   41,   42}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax11");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(12);
  needed_g_t[x_a].resize(12);
  needed_g_t[x_a][0] = {  25,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][1] = {  26,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__12_48");
  needed_g_t[x_a][2] = {  27,   30}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__12_48");
  needed_g_t[x_a][3] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__36_24");
  needed_g_t[x_a][4] = {  32}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__36_24");
  needed_g_t[x_a][5] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__36_24");
  needed_g_t[x_a][6] = {  34,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");
  needed_g_t[x_a][7] = {  35,   38}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__48_12");
  needed_g_t[x_a][8] = {  36,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__48_12");
  needed_g_t[x_a][9] = {  40}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");
  needed_g_t[x_a][10] = {  41}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__24_36");
  needed_g_t[x_a][11] = {  42}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__24_36");

  g_d[x_a].resize(18);
  needed_g_d[x_a].resize(18);
  needed_g_d[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  23
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][4] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   4,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {   5,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {   5,    6,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  21
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][10] = {   6}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   7,    8,    9,   10}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][12] = {   7,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][13] = {   9,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {   9,   10,   11,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][16] = {  12,   13,   14,   15,   16,   17,   18}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][17] = {  19,   20,   21,   22,   23,   24}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");

  c_p[x_a].resize(43);
  c_f[x_a].resize(43);
  c_t[x_a].resize(43);
  c_d[x_a].resize(43);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  2,   3}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   3,   4}; //   3

  c_p[x_a][3] = {  2,   3}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   3,   4}; //   3

  c_p[x_a][4] = {  2,   4}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  5,   6,   4}; //   3

  c_p[x_a][5] = {  5,   6}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  7,   8,   9}; //   3

  c_p[x_a][6] = {  5,   7}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  5,  10,   9}; //   3

  c_p[x_a][7] = {  0,   8}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 11,  12,   2}; //   3

  c_p[x_a][8] = {  0,   8}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 11,  12,   2}; //   3

  c_p[x_a][9] = {  9,  10}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 11,  13,  14}; //   3

  c_p[x_a][10] = {  9,  10}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 11,  13,  14}; //   3

  c_p[x_a][11] = {  9,  11}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  7,  15,  14}; //   3

  c_p[x_a][12] = {  0,  12}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 16,   9,   2}; //   3

  c_p[x_a][13] = {  0,  12}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 16,   9,   2}; //   3

  c_p[x_a][14] = {  0,  12}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 16,   9,   2}; //   3

  c_p[x_a][15] = {  0,  13}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 16,   9,   2}; //   3

  c_p[x_a][16] = {  0,  13}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 16,   9,   2}; //   3

  c_p[x_a][17] = {  0,  13}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 16,   9,   2}; //   3

  c_p[x_a][18] = {  0,  13}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 16,   9,   2}; //   3

  c_p[x_a][19] = {  2,  14}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 17,  14,   4}; //   3

  c_p[x_a][20] = {  2,  14}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 17,  14,   4}; //   3

  c_p[x_a][21] = {  2,  14}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 17,  14,   4}; //   3

  c_p[x_a][22] = {  2,  14}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 17,  14,   4}; //   3

  c_p[x_a][23] = {  2,  14}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 17,  14,   4}; //   3

  c_p[x_a][24] = {  2,  14}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 17,  14,   4}; //   3

  c_p[x_a][25] = {  0,  12}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  9,   2}; //   2

  c_p[x_a][26] = {  0,  12}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  1}; //   1
  c_d[x_a][26] = {  9,   2}; //   2

  c_p[x_a][27] = {  0,  12}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  2}; //   1
  c_d[x_a][27] = {  9,   2}; //   2

  c_p[x_a][28] = {  0,  13}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = {  9,   2}; //   2

  c_p[x_a][29] = {  0,  13}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  1}; //   1
  c_d[x_a][29] = {  9,   2}; //   2

  c_p[x_a][30] = {  0,  13}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  2}; //   1
  c_d[x_a][30] = {  9,   2}; //   2

  c_p[x_a][31] = {  2,  14}; //   2
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  3}; //   1
  c_d[x_a][31] = { 14,   4}; //   2

  c_p[x_a][32] = {  2,  14}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  4}; //   1
  c_d[x_a][32] = { 14,   4}; //   2

  c_p[x_a][33] = {  2,  14}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  5}; //   1
  c_d[x_a][33] = { 14,   4}; //   2

  c_p[x_a][34] = { 15,  16}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  6}; //   1
  c_d[x_a][34] = {  2,   9}; //   2

  c_p[x_a][35] = { 15,  16}; //   2
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  7}; //   1
  c_d[x_a][35] = {  2,   9}; //   2

  c_p[x_a][36] = { 15,  16}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  8}; //   1
  c_d[x_a][36] = {  2,   9}; //   2

  c_p[x_a][37] = {  5,  16}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  6}; //   1
  c_d[x_a][37] = {  2,   9}; //   2

  c_p[x_a][38] = {  5,  16}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  7}; //   1
  c_d[x_a][38] = {  2,   9}; //   2

  c_p[x_a][39] = {  5,  16}; //   2
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  8}; //   1
  c_d[x_a][39] = {  2,   9}; //   2

  c_p[x_a][40] = {  9,  17}; //   2
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  9}; //   1
  c_d[x_a][40] = {  4,  14}; //   2

  c_p[x_a][41] = {  9,  17}; //   2
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = { 10}; //   1
  c_d[x_a][41] = {  4,  14}; //   2

  c_p[x_a][42] = {  9,  17}; //   2
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = { 11}; //   1
  c_d[x_a][42] = {  4,  14}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_040_gg_emepvevex
//  channel    0: 4yyv(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    1: 4yyv(1, 2, 4, 8, 16, 32;  23,   0,  23)
//  channel    2: 4yyv(1, 2, 4, 32, 8, 16;  24,   0,   0)
//  channel    3: 4yyv(1, 2, 4, 32, 8, 16;  24,   0,  23)
//  channel    4: 4yyv(1, 2, 32, 4, 8, 16;  24,   0,  23)
//  channel    5: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,  23)
//  channel    6: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,  23)
//  channel    7: 4yyv(1, 2, 8, 4, 16, 32;  23,   0,   0)
//  channel    8: 4yyv(1, 2, 8, 4, 16, 32;  23,   0,  23)
//  channel    9: 4yyv(1, 2, 8, 16, 4, 32;  24,   0,   0)
//  channel   10: 4yyv(1, 2, 8, 16, 4, 32;  24,   0,  23)
//  channel   11: 4yyv(1, 2, 16, 8, 4, 32;  24,   0,  23)
//  channel   12: 42vv(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel   13: 42vv(1, 2, 4, 8, 16, 32;  23,   0,  35)
//  channel   14: 42vv(1, 2, 4, 8, 16, 32;  23,   0,  36)
//  channel   15: 42vv(1, 2, 4, 8, 16, 32;  23,  23,  25)
//  channel   16: 42vv(1, 2, 4, 8, 16, 32;  23,  23,   0)
//  channel   17: 42vv(1, 2, 4, 8, 16, 32;  23,  23,  35)
//  channel   18: 42vv(1, 2, 4, 8, 16, 32;  23,  23,  36)
//  channel   19: 42vv(1, 2, 4, 32, 8, 16;  24,  24,   0)
//  channel   20: 42vv(1, 2, 4, 32, 8, 16;  24,  24,  23)
//  channel   21: 42vv(1, 2, 4, 32, 8, 16;  24,  24,  25)
//  channel   22: 42vv(1, 2, 4, 32, 8, 16;  24,  24,   0)
//  channel   23: 42vv(1, 2, 4, 32, 8, 16;  24,  24,  35)
//  channel   24: 42vv(1, 2, 4, 32, 8, 16;  24,  24,  36)
//  channel   25: 2v2v(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel   26: 2v2v(1, 2, 4, 8, 16, 32;  23,   0,  35)
//  channel   27: 2v2v(1, 2, 4, 8, 16, 32;  23,   0,  36)
//  channel   28: 2v2v(1, 2, 4, 8, 16, 32;  23,  23,   0)
//  channel   29: 2v2v(1, 2, 4, 8, 16, 32;  23,  23,  35)
//  channel   30: 2v2v(1, 2, 4, 8, 16, 32;  23,  23,  36)
//  channel   31: 2v2v(1, 2, 4, 32, 8, 16;  24,  24,   0)
//  channel   32: 2v2v(1, 2, 4, 32, 8, 16;  24,  24,  36)
//  channel   33: 2v2v(1, 2, 4, 32, 8, 16;  24,  24,  35)
//  channel   34: 2v2v(1, 2, 16, 32, 4, 8;   0,  23,   0)
//  channel   35: 2v2v(1, 2, 16, 32, 4, 8;   0,  23,  35)
//  channel   36: 2v2v(1, 2, 16, 32, 4, 8;   0,  23,  36)
//  channel   37: 2v2v(1, 2, 16, 32, 4, 8;  23,  23,   0)
//  channel   38: 2v2v(1, 2, 16, 32, 4, 8;  23,  23,  35)
//  channel   39: 2v2v(1, 2, 16, 32, 4, 8;  23,  23,  36)
//  channel   40: 2v2v(1, 2, 8, 16, 4, 32;  24,  24,   0)
//  channel   41: 2v2v(1, 2, 8, 16, 4, 32;  24,  24,  35)
//  channel   42: 2v2v(1, 2, 8, 16, 4, 32;  24,  24,  36)
