#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_040_uux_emepvevex(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_040_uux_emepvevex");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(12);
  needed_v_smin[x_a].resize(12);
  needed_v_smin[x_a][  0] = {   0,    1,    7,    8,   14,   15,   16,   17}; //   8
  needed_v_smin[x_a][  1] = {   0,    1}; //   2
  needed_v_smin[x_a][  2] = {   2,    3,    4,   12,   13,   18}; //   6
  needed_v_smin[x_a][  3] = {   2,    3}; //   2
  needed_v_smin[x_a][  4] = {   4}; //   1
  needed_v_smin[x_a][  5] = {   5,    6,   14,   15,   16,   17}; //   6
  needed_v_smin[x_a][  6] = {   5}; //   1
  needed_v_smin[x_a][  7] = {   6}; //   1
  needed_v_smin[x_a][  8] = {   7,    8}; //   2
  needed_v_smin[x_a][  9] = {   9,   10,   11,   12,   13,   18}; //   6
  needed_v_smin[x_a][ 10] = {   9,   10}; //   2
  needed_v_smin[x_a][ 11] = {  11}; //   1

  v_smax[x_a].resize(12);
  needed_v_smax[x_a].resize(12);
  needed_v_smax[x_a][  0] = {   0,    1,    7,    8,   14,   15}; //   6
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  2] = {   2,    3,    4,   12,   13}; //   5
  needed_v_smax[x_a][  3] = {   4,    6}; //   2
  needed_v_smax[x_a][  4] = {   5,    6,   16,   17}; //   4
  needed_v_smax[x_a][  5] = {   5,   11}; //   2
  needed_v_smax[x_a][  6] = {   7,    8,    9,   10}; //   4
  needed_v_smax[x_a][  7] = {   9,   10,   11,   18}; //   4
  needed_v_smax[x_a][  8] = {  12,   13}; //   2
  needed_v_smax[x_a][  9] = {  14,   15}; //   2
  needed_v_smax[x_a][ 10] = {  16,   17}; //   2
  needed_v_smax[x_a][ 11] = {  18}; //   1

  g_p[x_a].resize(18);
  needed_g_p[x_a].resize(18);
  needed_g_p[x_a][0] = {   0,    1,    7,    8,   14,   15}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    3,    4,   12,   13}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax1");
  needed_g_p[x_a][4] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][5] = {   5,    6,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax4");
  needed_g_p[x_a][6] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax3");
  needed_g_p[x_a][8] = {   7,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][9] = {   9,   10,   11,   18}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax7");
  needed_g_p[x_a][10] = {   9,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax6");
  needed_g_p[x_a][11] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax5");
  needed_g_p[x_a][12] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax8");
  needed_g_p[x_a][13] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax9");
  needed_g_p[x_a][14] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax9");
  needed_g_p[x_a][15] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][16] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax10");
  needed_g_p[x_a][17] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax11");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(3);
  needed_g_t[x_a].resize(3);
  needed_g_t[x_a][0] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][1] = {  16,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");
  needed_g_t[x_a][2] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_36");

  g_d[x_a].resize(17);
  needed_g_d[x_a].resize(17);
  needed_g_d[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    7,    8,   14,   15,   16,   17}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][4] = {   2,    3,    4,   12,   13,   18}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   4,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {   5,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {   5,    6,   14,   15,   16,   17}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][10] = {   6}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   7,    8,    9,   10}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][12] = {   7,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][13] = {   9,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {   9,   10,   11,   12,   13,   18}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][16] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");

  c_p[x_a].resize(19);
  c_f[x_a].resize(19);
  c_t[x_a].resize(19);
  c_d[x_a].resize(19);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  2,   3}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   3,   4}; //   3

  c_p[x_a][3] = {  2,   3}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   3,   4}; //   3

  c_p[x_a][4] = {  2,   4}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  5,   6,   4}; //   3

  c_p[x_a][5] = {  5,   6}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  7,   8,   9}; //   3

  c_p[x_a][6] = {  5,   7}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  5,  10,   9}; //   3

  c_p[x_a][7] = {  0,   8}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 11,  12,   2}; //   3

  c_p[x_a][8] = {  0,   8}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 11,  12,   2}; //   3

  c_p[x_a][9] = {  9,  10}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 11,  13,  14}; //   3

  c_p[x_a][10] = {  9,  10}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 11,  13,  14}; //   3

  c_p[x_a][11] = {  9,  11}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  7,  15,  14}; //   3

  c_p[x_a][12] = {  2,  12}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 16,  14,   4}; //   3

  c_p[x_a][13] = {  2,  12}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 16,  14,   4}; //   3

  c_p[x_a][14] = {  0,  13}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = {  9,   2}; //   2

  c_p[x_a][15] = {  0,  14}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = {  9,   2}; //   2

  c_p[x_a][16] = { 15,  16}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  1}; //   1
  c_d[x_a][16] = {  2,   9}; //   2

  c_p[x_a][17] = {  5,  16}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  1}; //   1
  c_d[x_a][17] = {  2,   9}; //   2

  c_p[x_a][18] = {  9,  17}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  2}; //   1
  c_d[x_a][18] = {  4,  14}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_040_uux_emepvevex
//  channel    0: 4yyv(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    1: 4yyv(1, 2, 4, 8, 16, 32;  23,   0,  23)
//  channel    2: 4yyv(1, 2, 4, 32, 8, 16;  24,   0,   0)
//  channel    3: 4yyv(1, 2, 4, 32, 8, 16;  24,   0,  23)
//  channel    4: 4yyv(1, 2, 32, 4, 8, 16;  24,   0,  23)
//  channel    5: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,  23)
//  channel    6: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,  23)
//  channel    7: 4yyv(1, 2, 8, 4, 16, 32;  23,   0,   0)
//  channel    8: 4yyv(1, 2, 8, 4, 16, 32;  23,   0,  23)
//  channel    9: 4yyv(1, 2, 8, 16, 4, 32;  24,   0,   0)
//  channel   10: 4yyv(1, 2, 8, 16, 4, 32;  24,   0,  23)
//  channel   11: 4yyv(1, 2, 16, 8, 4, 32;  24,   0,  23)
//  channel   12: 42vv(1, 2, 4, 32, 8, 16;  24,  24,   0)
//  channel   13: 42vv(1, 2, 4, 32, 8, 16;  24,  24,  23)
//  channel   14: 2v2v(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel   15: 2v2v(1, 2, 4, 8, 16, 32;  23,  23,   0)
//  channel   16: 2v2v(1, 2, 16, 32, 4, 8;   0,  23,   0)
//  channel   17: 2v2v(1, 2, 16, 32, 4, 8;  23,  23,   0)
//  channel   18: 2v2v(1, 2, 8, 16, 4, 32;  24,  24,   0)
