#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_240_uux_emepvevexccx(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_240_uux_emepvevexccx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(40);
  needed_v_smin[x_a].resize(40);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,   14,   15,   16,   17,   28,   29,   30,   31,   33,   34,   35,   36,   38,   39,   41,   42,   43,   44,   45,   46,   47,   48,   52,   53,   54,   55,   58,   59,   65,   66,   67,   68,   69,   70,   75,   76,   77,   78,   80,   81,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98}; //  56
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   47,   48,   65,   66}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,   47,   48,   49,   50,   65,   66,   71,   72}; //  16
  needed_v_smin[x_a][  3] = {   0,    1,    4,    5,    8,   10,   12,   14,   15,   18,   19,   22,   24,   25}; //  14
  needed_v_smin[x_a][  4] = {   2,    3,    6,    7,    9,   11,   13,   16,   17,   20,   21,   23,   26,   27}; //  14
  needed_v_smin[x_a][  5] = {   4,    5,    6,    7,    8,    9,   24,   25,   26,   27,   32,   37,   40,   49,   50,   51,   63,   64,   71,   72,   73,   85,   86,   99,  100,  101}; //  26
  needed_v_smin[x_a][  6] = {   4,    5,    6,    7,   49,   50,   71,   72}; //   8
  needed_v_smin[x_a][  7] = {   8,    9,   51,   73}; //   4
  needed_v_smin[x_a][  8] = {   8,    9,   12,   13,   51,   57,   73,   79}; //   8
  needed_v_smin[x_a][  9] = {  10,   11,   12,   13,   28,   29,   30,   31,   33,   34,   35,   36,   38,   39,   41,   42,   43,   44,   45,   46,   52,   53,   54,   55,   56,   57,   67,   68,   69,   70,   74,   75,   76,   77,   78,   79,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98}; //  48
  needed_v_smin[x_a][ 10] = {  10,   11,   56,   74}; //   4
  needed_v_smin[x_a][ 11] = {  10,   11,   22,   23,   56,   62,   74,   84}; //   8
  needed_v_smin[x_a][ 12] = {  12,   13,   57,   79}; //   4
  needed_v_smin[x_a][ 13] = {  14,   15,   16,   17,   58,   59,   80,   81}; //   8
  needed_v_smin[x_a][ 14] = {  14,   15,   16,   17,   18,   19,   20,   21,   58,   59,   60,   61,   80,   81,   82,   83}; //  16
  needed_v_smin[x_a][ 15] = {  18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   32,   37,   40,   60,   61,   62,   63,   64,   82,   83,   84,   85,   86,   99,  100,  101}; //  26
  needed_v_smin[x_a][ 16] = {  18,   19,   20,   21,   60,   61,   82,   83}; //   8
  needed_v_smin[x_a][ 17] = {  22,   23,   62,   84}; //   4
  needed_v_smin[x_a][ 18] = {  24,   25,   26,   27,   63,   64,   85,   86,  101}; //   9
  needed_v_smin[x_a][ 19] = {  28,   29,   41,   42,   45,   46,   77,   78}; //   8
  needed_v_smin[x_a][ 20] = {  28,   29}; //   2
  needed_v_smin[x_a][ 21] = {  30,   31,   38,   39,   43,   44,   75,   76}; //   8
  needed_v_smin[x_a][ 22] = {  30,   31}; //   2
  needed_v_smin[x_a][ 23] = {  32,   40}; //   2
  needed_v_smin[x_a][ 24] = {  32}; //   1
  needed_v_smin[x_a][ 25] = {  33,   34,   38,   39,   54,   55,   69,   70}; //   8
  needed_v_smin[x_a][ 26] = {  33,   34}; //   2
  needed_v_smin[x_a][ 27] = {  35,   36,   41,   42,   52,   53,   67,   68}; //   8
  needed_v_smin[x_a][ 28] = {  35,   36}; //   2
  needed_v_smin[x_a][ 29] = {  37,   40}; //   2
  needed_v_smin[x_a][ 30] = {  37}; //   1
  needed_v_smin[x_a][ 31] = {  43,   44,   75,   76}; //   4
  needed_v_smin[x_a][ 32] = {  45,   46,   77,   78}; //   4
  needed_v_smin[x_a][ 33] = {  47,   48,   49,   50,   51,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   71,   72,   73,   74,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101}; //  43
  needed_v_smin[x_a][ 34] = {  52,   53,   67,   68}; //   4
  needed_v_smin[x_a][ 35] = {  54,   55,   69,   70}; //   4
  needed_v_smin[x_a][ 36] = {  87,   88,   89,   90}; //   4
  needed_v_smin[x_a][ 37] = {  91,   92,   97,   98}; //   4
  needed_v_smin[x_a][ 38] = {  93,   94,   95,   96}; //   4
  needed_v_smin[x_a][ 39] = {  99,  100}; //   2

  v_smax[x_a].resize(62);
  needed_v_smax[x_a].resize(62);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,   14,   15,   16,   17,   28,   29,   30,   31,   38,   39,   43,   44,   45,   46,   47,   48,   58,   59,   67,   68,   69,   70,   89,   90,   91,   92}; //  30
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,    4,    5,    6,    7,   47,   48,   49,   50}; //  12
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   47,   48,   49,   50,   51,   56,   57,   58,   59,   60,   61,   62,   63,   64}; //  42
  needed_v_smax[x_a][  3] = {   0,    1,    4,    5,    8,   10,   12,   14,   15,   18,   19,   22,   24,   25,   30,   31,   32,   35,   36}; //  19
  needed_v_smax[x_a][  4] = {   2,    3,    6,    7,    9,   11,   13,   16,   17,   20,   21,   23,   26,   27,   28,   29,   33,   34,   37}; //  19
  needed_v_smax[x_a][  5] = {   4,    5,    6,    7,    8,    9,   24,   25,   26,   27,   32,   40,   49,   50,   51,   63,   64}; //  17
  needed_v_smax[x_a][  6] = {   8,    9,   12,   13,   51,   57}; //   6
  needed_v_smax[x_a][  7] = {  10,   11,   12,   13,   33,   34,   35,   36,   41,   42,   52,   53,   54,   55,   56,   57,   75,   76,   77,   78,   95,   96,   97,   98}; //  24
  needed_v_smax[x_a][  8] = {  10,   11,   22,   23,   56,   62}; //   6
  needed_v_smax[x_a][  9] = {  14,   15,   16,   17,   18,   19,   20,   21,   58,   59,   60,   61}; //  12
  needed_v_smax[x_a][ 10] = {  18,   19,   20,   21,   22,   23,   37,   60,   61,   62,  100,  101}; //  12
  needed_v_smax[x_a][ 11] = {  24,   25,   26,   27,   40,   63,   64}; //   7
  needed_v_smax[x_a][ 12] = {  28,   29,   45,   46}; //   4
  needed_v_smax[x_a][ 13] = {  28,   29}; //   2
  needed_v_smax[x_a][ 14] = {  30,   31,   43,   44}; //   4
  needed_v_smax[x_a][ 15] = {  30,   31}; //   2
  needed_v_smax[x_a][ 16] = {  32}; //   1
  needed_v_smax[x_a][ 17] = {  32}; //   1
  needed_v_smax[x_a][ 18] = {  33,   34,   54,   55}; //   4
  needed_v_smax[x_a][ 19] = {  33,   34}; //   2
  needed_v_smax[x_a][ 20] = {  35,   36,   52,   53}; //   4
  needed_v_smax[x_a][ 21] = {  35,   36}; //   2
  needed_v_smax[x_a][ 22] = {  37}; //   1
  needed_v_smax[x_a][ 23] = {  37}; //   1
  needed_v_smax[x_a][ 24] = {  38,   39,   67,   68,   69,   70,   91,   92}; //   8
  needed_v_smax[x_a][ 25] = {  38,   39,   75,   76}; //   4
  needed_v_smax[x_a][ 26] = {  38,   39}; //   2
  needed_v_smax[x_a][ 27] = {  40}; //   1
  needed_v_smax[x_a][ 28] = {  40}; //   1
  needed_v_smax[x_a][ 29] = {  41,   42,   75,   76,   77,   78,   97,   98}; //   8
  needed_v_smax[x_a][ 30] = {  41,   42,   67,   68}; //   4
  needed_v_smax[x_a][ 31] = {  41,   42}; //   2
  needed_v_smax[x_a][ 32] = {  43,   44,   45,   46}; //   4
  needed_v_smax[x_a][ 33] = {  43,   44,   45,   46}; //   4
  needed_v_smax[x_a][ 34] = {  47,   48,   49,   50,   51,   56,   57,   58,   59,   60,   61,   62,   63,   64}; //  14
  needed_v_smax[x_a][ 35] = {  52,   53,   54,   55}; //   4
  needed_v_smax[x_a][ 36] = {  52,   53,   54,   55}; //   4
  needed_v_smax[x_a][ 37] = {  65,   66,   71,   72,   73,   74,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   93,   94,   99}; //  19
  needed_v_smax[x_a][ 38] = {  65,   66,   80,   81,   87,   88}; //   6
  needed_v_smax[x_a][ 39] = {  65,   66,   71,   72}; //   4
  needed_v_smax[x_a][ 40] = {  65,   66,   71,   72,   73,   74,   79,   80,   81,   82,   83,   84,   85,   86,   91,   92,   97,   98,  101}; //  19
  needed_v_smax[x_a][ 41] = {  67,   68,   69,   70,   93,   94,   95,   96}; //   8
  needed_v_smax[x_a][ 42] = {  69,   70}; //   2
  needed_v_smax[x_a][ 43] = {  71,   72,   73,   85,   86}; //   5
  needed_v_smax[x_a][ 44] = {  73,   79}; //   2
  needed_v_smax[x_a][ 45] = {  74,   79,   93,   94}; //   4
  needed_v_smax[x_a][ 46] = {  74,   84}; //   2
  needed_v_smax[x_a][ 47] = {  75,   76,   77,   78,   87,   88,   89,   90}; //   8
  needed_v_smax[x_a][ 48] = {  77,   78}; //   2
  needed_v_smax[x_a][ 49] = {  80,   81,   82,   83}; //   4
  needed_v_smax[x_a][ 50] = {  82,   83,   84,   99}; //   4
  needed_v_smax[x_a][ 51] = {  85,   86}; //   2
  needed_v_smax[x_a][ 52] = {  87,   88,   89,   90}; //   4
  needed_v_smax[x_a][ 53] = {  89,   90}; //   2
  needed_v_smax[x_a][ 54] = {  91,   92,   97,   98}; //   4
  needed_v_smax[x_a][ 55] = {  93,   94,   95,   96}; //   4
  needed_v_smax[x_a][ 56] = {  95,   96}; //   2
  needed_v_smax[x_a][ 57] = {  99,  100}; //   2
  needed_v_smax[x_a][ 58] = { 100}; //   1
  needed_v_smax[x_a][ 59] = { 101}; //   1
  needed_v_smax[x_a][ 60] = { 101}; //   1
  needed_v_smax[x_a][ 61] = {  99,  100}; //   2

  g_p[x_a].resize(100);
  needed_g_p[x_a].resize(100);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,   14,   15,   16,   17,   28,   29,   30,   31,   38,   39,   43,   44,   45,   46,   47,   48,   58,   59,   67,   68,   69,   70,   89,   90,   91,   92}; //  30
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   47,   48}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,    4,    6,   47,   49}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    4,    5,    8,   10,   12,   14,   15,   18,   19,   22,   24,   25}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,    5,    7,   48,   50}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   2,    3,    6,    7,    9,   11,   13,   16,   17,   20,   21,   23,   26,   27}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   4,    5,    6,    7,    8,    9,   24,   25,   26,   27,   32,   40,   49,   50,   51,   63,   64}; //  17
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax5");
  needed_g_p[x_a][7] = {   4,    5,    6,    7,   49,   50}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax1");
  needed_g_p[x_a][8] = {   8,    9,   51}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {   8,    9,   12,   13,   51,   57}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax2");
  needed_g_p[x_a][10] = {  10,   11,   12,   13,   34,   36,   42,   53,   55,   56,   57,   76,   78,   96,   98}; //  15
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax7");
  needed_g_p[x_a][11] = {  10,   11,   56}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][12] = {  10,   11,   22,   23,   56,   62}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][13] = {  12,   13,   57}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax6");
  needed_g_p[x_a][14] = {  14,   15,   16,   17,   58,   59}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][15] = {  14,   16,   18,   20,   58,   60}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax2");
  needed_g_p[x_a][16] = {  15,   17,   19,   21,   59,   61}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin14_smax2");
  needed_g_p[x_a][17] = {  18,   19,   20,   21,   22,   23,   37,   60,   61,   62,  100,  101}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax10");
  needed_g_p[x_a][18] = {  18,   19,   20,   21,   60,   61}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax9");
  needed_g_p[x_a][19] = {  22,   23,   62}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax8");
  needed_g_p[x_a][20] = {  24,   25,   26,   27,   40,   63,   64}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax11");
  needed_g_p[x_a][21] = {  24,   26,   63}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax2");
  needed_g_p[x_a][22] = {  25,   27,   64}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin18_smax2");
  needed_g_p[x_a][23] = {  28,   29,   45,   46}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax12");
  needed_g_p[x_a][24] = {  28}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax13");
  needed_g_p[x_a][25] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax4");
  needed_g_p[x_a][26] = {  29}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax13");
  needed_g_p[x_a][27] = {  30,   31,   43,   44}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax14");
  needed_g_p[x_a][28] = {  30}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax15");
  needed_g_p[x_a][29] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax3");
  needed_g_p[x_a][30] = {  31}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax15");
  needed_g_p[x_a][31] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax16");
  needed_g_p[x_a][32] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax17");
  needed_g_p[x_a][33] = {  32}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax3");
  needed_g_p[x_a][34] = {  33,   35,   41,   52,   54,   75,   77,   95,   97}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][35] = {  33,   34,   54,   55}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax18");
  needed_g_p[x_a][36] = {  33,   34}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax19");
  needed_g_p[x_a][37] = {  33,   34}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin26_smax4");
  needed_g_p[x_a][38] = {  35,   36,   52,   53}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin27_smax20");
  needed_g_p[x_a][39] = {  35,   36}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax21");
  needed_g_p[x_a][40] = {  35,   36}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin28_smax3");
  needed_g_p[x_a][41] = {  37}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax22");
  needed_g_p[x_a][42] = {  37}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax23");
  needed_g_p[x_a][43] = {  37}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin30_smax4");
  needed_g_p[x_a][44] = {  38,   67,   69,   91}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax24");
  needed_g_p[x_a][45] = {  38,   39,   75,   76}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax25");
  needed_g_p[x_a][46] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax26");
  needed_g_p[x_a][47] = {  39,   68,   70,   92}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax24");
  needed_g_p[x_a][48] = {  40}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax27");
  needed_g_p[x_a][49] = {  40}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin29_smax28");
  needed_g_p[x_a][50] = {  41,   42,   75,   76,   77,   78,   97,   98}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax29");
  needed_g_p[x_a][51] = {  41,   42,   67,   68}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin27_smax30");
  needed_g_p[x_a][52] = {  41,   42}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax31");
  needed_g_p[x_a][53] = {  43,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin31_smax32");
  needed_g_p[x_a][54] = {  43,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax33");
  needed_g_p[x_a][55] = {  44,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax33");
  needed_g_p[x_a][56] = {  45,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin32_smax32");
  needed_g_p[x_a][57] = {  47,   48,   49,   50,   51,   56,   57,   58,   59,   60,   61,   62,   63,   64}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax34");
  needed_g_p[x_a][58] = {  52,   53}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax35");
  needed_g_p[x_a][59] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax36");
  needed_g_p[x_a][60] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin35_smax35");
  needed_g_p[x_a][61] = {  65,   66,   71,   72,   73,   74,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   93,   94,   99}; //  19
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax37");
  needed_g_p[x_a][62] = {  65,   66,   80,   81,   87,   88}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax38");
  needed_g_p[x_a][63] = {  65,   66}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax39");
  needed_g_p[x_a][64] = {  65,   71}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax40");
  needed_g_p[x_a][65] = {  66,   72}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax40");
  needed_g_p[x_a][66] = {  67,   68}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin34_smax41");
  needed_g_p[x_a][67] = {  69,   70}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin25_smax42");
  needed_g_p[x_a][68] = {  69,   70}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin35_smax41");
  needed_g_p[x_a][69] = {  71,   72,   73,   85,   86}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax43");
  needed_g_p[x_a][70] = {  71,   72}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax39");
  needed_g_p[x_a][71] = {  73}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax44");
  needed_g_p[x_a][72] = {  73,   79}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax40");
  needed_g_p[x_a][73] = {  74,   79,   94}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax45");
  needed_g_p[x_a][74] = {  74}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax46");
  needed_g_p[x_a][75] = {  74,   84}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax40");
  needed_g_p[x_a][76] = {  75,   76}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin31_smax47");
  needed_g_p[x_a][77] = {  77,   78}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax48");
  needed_g_p[x_a][78] = {  77,   78}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin32_smax47");
  needed_g_p[x_a][79] = {  79}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax44");
  needed_g_p[x_a][80] = {  80,   81}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax49");
  needed_g_p[x_a][81] = {  80,   82}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax40");
  needed_g_p[x_a][82] = {  81,   83}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin14_smax40");
  needed_g_p[x_a][83] = {  82,   83,   84,   99}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax50");
  needed_g_p[x_a][84] = {  82,   83}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax49");
  needed_g_p[x_a][85] = {  84}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax46");
  needed_g_p[x_a][86] = {  85,   86}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin15_smax51");
  needed_g_p[x_a][87] = {  85}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax40");
  needed_g_p[x_a][88] = {  86}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin18_smax40");
  needed_g_p[x_a][89] = {  87,   89}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax52");
  needed_g_p[x_a][90] = {  88,   90}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax52");
  needed_g_p[x_a][91] = {  89,   90}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax53");
  needed_g_p[x_a][92] = {  91,   92,   97,   98}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax54");
  needed_g_p[x_a][93] = {  93}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax45");
  needed_g_p[x_a][94] = {  93,   94,   95,   96}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax55");
  needed_g_p[x_a][95] = {  95,   96}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax56");
  needed_g_p[x_a][96] = {  99,  100}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax57");
  needed_g_p[x_a][97] = { 100}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax58");
  needed_g_p[x_a][98] = { 101}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax59");
  needed_g_p[x_a][99] = { 101}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin33_smax60");

  g_f[x_a].resize(5);
  needed_g_f[x_a].resize(5);
  needed_g_f[x_a][0] = {  87,   88,   89,   90}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin36_smax47");
  needed_g_f[x_a][1] = {  91,   92,   97,   98}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin37_smax40");
  needed_g_f[x_a][2] = {  93,   94,   95,   96}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin38_smax41");
  needed_g_f[x_a][3] = {  99,  100}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin39_smax61");
  needed_g_f[x_a][4] = { 101}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax40");

  g_t[x_a].resize(16);
  needed_g_t[x_a].resize(16);
  needed_g_t[x_a][0] = {  43,   44,   45,   46,   87,   88,   89,   90}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][1] = {  47,   48,   49,   50,   51,   56,   57,   58,   59,   60,   61,   62,   63,   64,   91,   92,   97,   98,  101}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][2] = {  52,   53,   54,   55,   93,   94,   95,   96}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][3] = {  65,   66,   71,   72,   73,   74,   79,   80,   81,   82,   83,   84,   85,   86}; //  14
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][4] = {  67,   68,   69,   70}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][5] = {  75,   76,   77,   78}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");
  needed_g_t[x_a][6] = {  87,   88}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__192_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__192_48");
  needed_g_t[x_a][7] = {  89,   90}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][8] = {  91,   92}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__48_12");
  needed_g_t[x_a][9] = {  93,   94}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__192_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__192_12");
  needed_g_t[x_a][10] = {  95,   96}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][11] = {  97,   98}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__12_48");
  needed_g_t[x_a][12] = {  99,  100}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_228");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_228");
  needed_g_t[x_a][13] = {  99}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__192_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__192_36");
  needed_g_t[x_a][14] = { 100}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__36_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__36_192");
  needed_g_t[x_a][15] = { 101}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__36_24");

  g_d[x_a].resize(41);
  needed_g_d[x_a].resize(41);
  needed_g_d[x_a][0] = {   0,    1,    4,    5,    8,   10,   12,   14,   15,   18,   19,   22,   24,   25,   30,   31,   32,   35,   36}; //  19
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][1] = {   0,    1,    4,    5,    8,   10,   12,   14,   15,   18,   19,   22,   24,   25}; //  14
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,    6,    7,   47,   48,   49,   50,   65,   66,   71,   72}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,   47,   48,   65,   66}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][4] = {   0,    1,    2,    3,   14,   15,   16,   17,   28,   29,   30,   31,   33,   34,   35,   36,   38,   39,   41,   42,   43,   44,   45,   46,   47,   48,   52,   53,   54,   55,   58,   59,   65,   66,   67,   68,   69,   70,   75,   76,   77,   78,   80,   81,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98}; //  56
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][5] = {   2,    3,    6,    7,    9,   11,   13,   16,   17,   20,   21,   23,   26,   27,   28,   29,   33,   34,   37}; //  19
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][6] = {   2,    3,    6,    7,    9,   11,   13,   16,   17,   20,   21,   23,   26,   27}; //  14
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][7] = {   4,    5,    6,    7,   49,   50,   71,   72}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][8] = {   4,    5,    6,    7,    8,    9,   24,   25,   26,   27,   32,   37,   40,   49,   50,   51,   63,   64,   71,   72,   73,   85,   86,   99,  100,  101}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][9] = {   8,    9,   12,   13,   51,   57,   73,   79}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][10] = {   8,    9,   51,   73}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][11] = {  10,   11,   22,   23,   56,   62,   74,   84}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][12] = {  10,   11,   56,   74}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][13] = {  10,   11,   12,   13,   28,   29,   30,   31,   33,   34,   35,   36,   38,   39,   41,   42,   43,   44,   45,   46,   52,   53,   54,   55,   56,   57,   67,   68,   69,   70,   74,   75,   76,   77,   78,   79,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98}; //  48
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][14] = {  12,   13,   57,   79}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][15] = {  14,   15,   16,   17,   18,   19,   20,   21,   58,   59,   60,   61,   80,   81,   82,   83}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][16] = {  14,   15,   16,   17,   58,   59,   80,   81}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][17] = {  18,   19,   20,   21,   60,   61,   82,   83}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][18] = {  18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   32,   37,   40,   60,   61,   62,   63,   64,   82,   83,   84,   85,   86,   99,  100,  101}; //  26
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][19] = {  22,   23,   62,   84}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][20] = {  24,   25,   26,   27,   63,   64,   85,   86}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][21] = {  28,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][22] = {  28,   29,   41,   42,   45,   46,   77,   78}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][23] = {  30,   31}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][24] = {  30,   31,   38,   39,   43,   44,   75,   76}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][25] = {  32}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__36_152");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__36_152");
  needed_g_d[x_a][26] = {  32,   40}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_152__128_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_152__128_24");
  needed_g_d[x_a][27] = {  33,   34}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][28] = {  33,   34,   38,   39,   54,   55,   69,   70}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][29] = {  35,   36}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][30] = {  35,   36,   41,   42,   52,   53,   67,   68}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][31] = {  37}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");
  needed_g_d[x_a][32] = {  37,   40}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][33] = {  38,   39}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__76_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__76_176");
  needed_g_d[x_a][34] = {  40}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__100_152");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__100_152");
  needed_g_d[x_a][35] = {  41,   42}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__112_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__112_140");
  needed_g_d[x_a][36] = {  43,   44,   75,   76}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__64_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__64_176");
  needed_g_d[x_a][37] = {  45,   46,   77,   78}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__128_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__128_112");
  needed_g_d[x_a][38] = {  47,   48,   49,   50,   51,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   71,   72,   73,   74,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101}; //  43
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][39] = {  52,   53,   67,   68}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__64_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__64_140");
  needed_g_d[x_a][40] = {  54,   55,   69,   70}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__128_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__128_76");

  c_p[x_a].resize(102);
  c_f[x_a].resize(102);
  c_t[x_a].resize(102);
  c_d[x_a].resize(102);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][1] = {  0,   1,   4,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][2] = {  0,   1,   2,   5}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][3] = {  0,   1,   4,   5}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][4] = {  6,   7,   2,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   1,   2,   7,   8}; //   5

  c_p[x_a][5] = {  6,   7,   4,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   1,   2,   7,   8}; //   5

  c_p[x_a][6] = {  6,   7,   2,   5}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  5,   6,   2,   7,   8}; //   5

  c_p[x_a][7] = {  6,   7,   4,   5}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,   6,   2,   7,   8}; //   5

  c_p[x_a][8] = {  6,   8,   9,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   1,   9,  10,   8}; //   5

  c_p[x_a][9] = {  6,   8,   9,   5}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  5,   6,   9,  10,   8}; //   5

  c_p[x_a][10] = { 10,  11,  12,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,   1,  11,  12,  13}; //   5

  c_p[x_a][11] = { 10,  11,  12,   5}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   6,  11,  12,  13}; //   5

  c_p[x_a][12] = { 10,  13,   9,   3}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  0,   1,   9,  14,  13}; //   5

  c_p[x_a][13] = { 10,  13,   9,   5}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  5,   6,   9,  14,  13}; //   5

  c_p[x_a][14] = {  0,  14,  15,   3}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  0,   1,  15,  16,   4}; //   5

  c_p[x_a][15] = {  0,  14,  16,   3}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  0,   1,  15,  16,   4}; //   5

  c_p[x_a][16] = {  0,  14,  15,   5}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  5,   6,  15,  16,   4}; //   5

  c_p[x_a][17] = {  0,  14,  16,   5}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  5,   6,  15,  16,   4}; //   5

  c_p[x_a][18] = { 17,  18,  15,   3}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  0,   1,  15,  17,  18}; //   5

  c_p[x_a][19] = { 17,  18,  16,   3}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  0,   1,  15,  17,  18}; //   5

  c_p[x_a][20] = { 17,  18,  15,   5}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  5,   6,  15,  17,  18}; //   5

  c_p[x_a][21] = { 17,  18,  16,   5}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  5,   6,  15,  17,  18}; //   5

  c_p[x_a][22] = { 17,  19,  12,   3}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = {  0,   1,  11,  19,  18}; //   5

  c_p[x_a][23] = { 17,  19,  12,   5}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = {  5,   6,  11,  19,  18}; //   5

  c_p[x_a][24] = {  6,  20,  21,   3}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = {  0,   1,  20,  18,   8}; //   5

  c_p[x_a][25] = {  6,  20,  22,   3}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = {  0,   1,  20,  18,   8}; //   5

  c_p[x_a][26] = {  6,  20,  21,   5}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = {  5,   6,  20,  18,   8}; //   5

  c_p[x_a][27] = {  6,  20,  22,   5}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = {  5,   6,  20,  18,   8}; //   5

  c_p[x_a][28] = {  0,  23,  24,  25}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = {  5,  21,  13,  22,   4}; //   5

  c_p[x_a][29] = {  0,  23,  26,  25}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = {  5,  21,  13,  22,   4}; //   5

  c_p[x_a][30] = {  0,  27,  28,  29}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = {  0,  23,  13,  24,   4}; //   5

  c_p[x_a][31] = {  0,  27,  30,  29}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = {  0,  23,  13,  24,   4}; //   5

  c_p[x_a][32] = {  6,  31,  32,  33}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = {  0,  25,  18,  26,   8}; //   5

  c_p[x_a][33] = { 34,  35,  36,  37}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = {  5,  27,   4,  28,  13}; //   5

  c_p[x_a][34] = { 10,  35,  36,  37}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = {  5,  27,   4,  28,  13}; //   5

  c_p[x_a][35] = { 34,  38,  39,  40}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = {  0,  29,   4,  30,  13}; //   5

  c_p[x_a][36] = { 10,  38,  39,  40}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = {  0,  29,   4,  30,  13}; //   5

  c_p[x_a][37] = { 17,  41,  42,  43}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = {  5,  31,   8,  32,  18}; //   5

  c_p[x_a][38] = {  0,  44,  45,  46}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 33,  28,  24,  13,   4}; //   5

  c_p[x_a][39] = {  0,  47,  45,  46}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 33,  28,  24,  13,   4}; //   5

  c_p[x_a][40] = {  6,  20,  48,  49}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {}; //   0
  c_d[x_a][40] = { 34,  32,  26,  18,   8}; //   5

  c_p[x_a][41] = { 34,  50,  51,  52}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {}; //   0
  c_d[x_a][41] = { 35,  22,  30,   4,  13}; //   5

  c_p[x_a][42] = { 10,  50,  51,  52}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {}; //   0
  c_d[x_a][42] = { 35,  22,  30,   4,  13}; //   5

  c_p[x_a][43] = {  0,  27,  53,  54}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  0}; //   1
  c_d[x_a][43] = { 13,  36,  24,   4}; //   4

  c_p[x_a][44] = {  0,  27,  53,  55}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  0}; //   1
  c_d[x_a][44] = { 13,  36,  24,   4}; //   4

  c_p[x_a][45] = {  0,  23,  56,  54}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  0}; //   1
  c_d[x_a][45] = { 13,  37,  22,   4}; //   4

  c_p[x_a][46] = {  0,  23,  56,  55}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  0}; //   1
  c_d[x_a][46] = { 13,  37,  22,   4}; //   4

  c_p[x_a][47] = {  0,   1,   2,  57}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  1}; //   1
  c_d[x_a][47] = { 38,   2,   3,   4}; //   4

  c_p[x_a][48] = {  0,   1,   4,  57}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  1}; //   1
  c_d[x_a][48] = { 38,   2,   3,   4}; //   4

  c_p[x_a][49] = {  6,   7,   2,  57}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  1}; //   1
  c_d[x_a][49] = { 38,   2,   7,   8}; //   4

  c_p[x_a][50] = {  6,   7,   4,  57}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  1}; //   1
  c_d[x_a][50] = { 38,   2,   7,   8}; //   4

  c_p[x_a][51] = {  6,   8,   9,  57}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  1}; //   1
  c_d[x_a][51] = { 38,   9,  10,   8}; //   4

  c_p[x_a][52] = { 34,  38,  58,  59}; //   4
  c_f[x_a][52] = {}; //   0
  c_t[x_a][52] = {  2}; //   1
  c_d[x_a][52] = {  4,  39,  30,  13}; //   4

  c_p[x_a][53] = { 10,  38,  58,  59}; //   4
  c_f[x_a][53] = {}; //   0
  c_t[x_a][53] = {  2}; //   1
  c_d[x_a][53] = {  4,  39,  30,  13}; //   4

  c_p[x_a][54] = { 34,  35,  60,  59}; //   4
  c_f[x_a][54] = {}; //   0
  c_t[x_a][54] = {  2}; //   1
  c_d[x_a][54] = {  4,  40,  28,  13}; //   4

  c_p[x_a][55] = { 10,  35,  60,  59}; //   4
  c_f[x_a][55] = {}; //   0
  c_t[x_a][55] = {  2}; //   1
  c_d[x_a][55] = {  4,  40,  28,  13}; //   4

  c_p[x_a][56] = { 10,  11,  12,  57}; //   4
  c_f[x_a][56] = {}; //   0
  c_t[x_a][56] = {  1}; //   1
  c_d[x_a][56] = { 38,  11,  12,  13}; //   4

  c_p[x_a][57] = { 10,  13,   9,  57}; //   4
  c_f[x_a][57] = {}; //   0
  c_t[x_a][57] = {  1}; //   1
  c_d[x_a][57] = { 38,   9,  14,  13}; //   4

  c_p[x_a][58] = {  0,  14,  15,  57}; //   4
  c_f[x_a][58] = {}; //   0
  c_t[x_a][58] = {  1}; //   1
  c_d[x_a][58] = { 38,  15,  16,   4}; //   4

  c_p[x_a][59] = {  0,  14,  16,  57}; //   4
  c_f[x_a][59] = {}; //   0
  c_t[x_a][59] = {  1}; //   1
  c_d[x_a][59] = { 38,  15,  16,   4}; //   4

  c_p[x_a][60] = { 17,  18,  15,  57}; //   4
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = {  1}; //   1
  c_d[x_a][60] = { 38,  15,  17,  18}; //   4

  c_p[x_a][61] = { 17,  18,  16,  57}; //   4
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  1}; //   1
  c_d[x_a][61] = { 38,  15,  17,  18}; //   4

  c_p[x_a][62] = { 17,  19,  12,  57}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  1}; //   1
  c_d[x_a][62] = { 38,  11,  19,  18}; //   4

  c_p[x_a][63] = {  6,  20,  21,  57}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  1}; //   1
  c_d[x_a][63] = { 38,  20,  18,   8}; //   4

  c_p[x_a][64] = {  6,  20,  22,  57}; //   4
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  1}; //   1
  c_d[x_a][64] = { 38,  20,  18,   8}; //   4

  c_p[x_a][65] = { 61,  62,  63,  64}; //   4
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  3}; //   1
  c_d[x_a][65] = {  2,   3,   4,  38}; //   4

  c_p[x_a][66] = { 61,  62,  63,  65}; //   4
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  3}; //   1
  c_d[x_a][66] = {  2,   3,   4,  38}; //   4

  c_p[x_a][67] = {  0,  44,  51,  66}; //   4
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  4}; //   1
  c_d[x_a][67] = { 39,  30,  13,   4}; //   4

  c_p[x_a][68] = {  0,  47,  51,  66}; //   4
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  4}; //   1
  c_d[x_a][68] = { 39,  30,  13,   4}; //   4

  c_p[x_a][69] = {  0,  44,  67,  68}; //   4
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  4}; //   1
  c_d[x_a][69] = { 40,  28,  13,   4}; //   4

  c_p[x_a][70] = {  0,  47,  67,  68}; //   4
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  4}; //   1
  c_d[x_a][70] = { 40,  28,  13,   4}; //   4

  c_p[x_a][71] = { 61,  69,  70,  64}; //   4
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {  3}; //   1
  c_d[x_a][71] = {  2,   7,   8,  38}; //   4

  c_p[x_a][72] = { 61,  69,  70,  65}; //   4
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {  3}; //   1
  c_d[x_a][72] = {  2,   7,   8,  38}; //   4

  c_p[x_a][73] = { 61,  69,  71,  72}; //   4
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {  3}; //   1
  c_d[x_a][73] = {  9,  10,   8,  38}; //   4

  c_p[x_a][74] = { 61,  73,  74,  75}; //   4
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {  3}; //   1
  c_d[x_a][74] = { 11,  12,  13,  38}; //   4

  c_p[x_a][75] = { 34,  50,  45,  76}; //   4
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {  5}; //   1
  c_d[x_a][75] = { 36,  24,   4,  13}; //   4

  c_p[x_a][76] = { 10,  50,  45,  76}; //   4
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {  5}; //   1
  c_d[x_a][76] = { 36,  24,   4,  13}; //   4

  c_p[x_a][77] = { 34,  50,  77,  78}; //   4
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {  5}; //   1
  c_d[x_a][77] = { 37,  22,   4,  13}; //   4

  c_p[x_a][78] = { 10,  50,  77,  78}; //   4
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = {  5}; //   1
  c_d[x_a][78] = { 37,  22,   4,  13}; //   4

  c_p[x_a][79] = { 61,  73,  79,  72}; //   4
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = {  3}; //   1
  c_d[x_a][79] = {  9,  14,  13,  38}; //   4

  c_p[x_a][80] = { 61,  62,  80,  81}; //   4
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = {  3}; //   1
  c_d[x_a][80] = { 15,  16,   4,  38}; //   4

  c_p[x_a][81] = { 61,  62,  80,  82}; //   4
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = {  3}; //   1
  c_d[x_a][81] = { 15,  16,   4,  38}; //   4

  c_p[x_a][82] = { 61,  83,  84,  81}; //   4
  c_f[x_a][82] = {}; //   0
  c_t[x_a][82] = {  3}; //   1
  c_d[x_a][82] = { 15,  17,  18,  38}; //   4

  c_p[x_a][83] = { 61,  83,  84,  82}; //   4
  c_f[x_a][83] = {}; //   0
  c_t[x_a][83] = {  3}; //   1
  c_d[x_a][83] = { 15,  17,  18,  38}; //   4

  c_p[x_a][84] = { 61,  83,  85,  75}; //   4
  c_f[x_a][84] = {}; //   0
  c_t[x_a][84] = {  3}; //   1
  c_d[x_a][84] = { 11,  19,  18,  38}; //   4

  c_p[x_a][85] = { 61,  69,  86,  87}; //   4
  c_f[x_a][85] = {}; //   0
  c_t[x_a][85] = {  3}; //   1
  c_d[x_a][85] = { 20,  18,   8,  38}; //   4

  c_p[x_a][86] = { 61,  69,  86,  88}; //   4
  c_f[x_a][86] = {}; //   0
  c_t[x_a][86] = {  3}; //   1
  c_d[x_a][86] = { 20,  18,   8,  38}; //   4

  c_p[x_a][87] = { 61,  62,  89}; //   3
  c_f[x_a][87] = {  0}; //   1
  c_t[x_a][87] = {  0,   6}; //   2
  c_d[x_a][87] = { 13,   4,  38}; //   3

  c_p[x_a][88] = { 61,  62,  90}; //   3
  c_f[x_a][88] = {  0}; //   1
  c_t[x_a][88] = {  0,   6}; //   2
  c_d[x_a][88] = { 13,   4,  38}; //   3

  c_p[x_a][89] = {  0,  91,  89}; //   3
  c_f[x_a][89] = {  0}; //   1
  c_t[x_a][89] = {  0,   7}; //   2
  c_d[x_a][89] = { 13,  38,   4}; //   3

  c_p[x_a][90] = {  0,  91,  90}; //   3
  c_f[x_a][90] = {  0}; //   1
  c_t[x_a][90] = {  0,   7}; //   2
  c_d[x_a][90] = { 13,  38,   4}; //   3

  c_p[x_a][91] = {  0,  44,  92}; //   3
  c_f[x_a][91] = {  1}; //   1
  c_t[x_a][91] = {  1,   8}; //   2
  c_d[x_a][91] = { 38,  13,   4}; //   3

  c_p[x_a][92] = {  0,  47,  92}; //   3
  c_f[x_a][92] = {  1}; //   1
  c_t[x_a][92] = {  1,   8}; //   2
  c_d[x_a][92] = { 38,  13,   4}; //   3

  c_p[x_a][93] = { 61,  93,  94}; //   3
  c_f[x_a][93] = {  2}; //   1
  c_t[x_a][93] = {  2,   9}; //   2
  c_d[x_a][93] = {  4,  13,  38}; //   3

  c_p[x_a][94] = { 61,  73,  94}; //   3
  c_f[x_a][94] = {  2}; //   1
  c_t[x_a][94] = {  2,   9}; //   2
  c_d[x_a][94] = {  4,  13,  38}; //   3

  c_p[x_a][95] = { 34,  95,  94}; //   3
  c_f[x_a][95] = {  2}; //   1
  c_t[x_a][95] = {  2,  10}; //   2
  c_d[x_a][95] = {  4,  38,  13}; //   3

  c_p[x_a][96] = { 10,  95,  94}; //   3
  c_f[x_a][96] = {  2}; //   1
  c_t[x_a][96] = {  2,  10}; //   2
  c_d[x_a][96] = {  4,  38,  13}; //   3

  c_p[x_a][97] = { 34,  50,  92}; //   3
  c_f[x_a][97] = {  1}; //   1
  c_t[x_a][97] = {  1,  11}; //   2
  c_d[x_a][97] = { 38,   4,  13}; //   3

  c_p[x_a][98] = { 10,  50,  92}; //   3
  c_f[x_a][98] = {  1}; //   1
  c_t[x_a][98] = {  1,  11}; //   2
  c_d[x_a][98] = { 38,   4,  13}; //   3

  c_p[x_a][99] = { 61,  83,  96}; //   3
  c_f[x_a][99] = {  3}; //   1
  c_t[x_a][99] = { 12,  13}; //   2
  c_d[x_a][99] = {  8,  18,  38}; //   3

  c_p[x_a][100] = { 17,  97,  96}; //   3
  c_f[x_a][100] = {  3}; //   1
  c_t[x_a][100] = { 12,  14}; //   2
  c_d[x_a][100] = {  8,  38,  18}; //   3

  c_p[x_a][101] = { 17,  98,  99}; //   3
  c_f[x_a][101] = {  4}; //   1
  c_t[x_a][101] = {  1,  15}; //   2
  c_d[x_a][101] = { 38,   8,  18}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_uux_emepvevexccx
//  channel    0: 6yyyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel    1: 6yyyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   0,   0)
//  channel    2: 6yyyyv(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel    3: 6yyyyv(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,  23,   0,   0)
//  channel    4: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel    5: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel    6: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel    7: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel    8: 6yyyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel    9: 6yyyyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   10: 6yyyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   0,   0)
//  channel   11: 6yyyyv(1, 2, 128, 64, 16, 32, 4, 8;  23,   0,  23,   0,   0)
//  channel   12: 6yyyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   0,   0)
//  channel   13: 6yyyyv(1, 2, 128, 64, 32, 16, 4, 8;  23,   0,  23,   0,   0)
//  channel   14: 6yyyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   0,   0)
//  channel   15: 6yyyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   0,   0)
//  channel   16: 6yyyyv(1, 2, 128, 64, 8, 4, 16, 32;  23,   0,   0,   0,   0)
//  channel   17: 6yyyyv(1, 2, 128, 64, 8, 4, 16, 32;  23,   0,  23,   0,   0)
//  channel   18: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   19: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   20: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   21: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   22: 6yyyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   23: 6yyyyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   24: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   25: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   26: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   27: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   28: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  23,   0,   0,   0,   0)
//  channel   29: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  23,   0,  23,   0,   0)
//  channel   30: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   31: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,  23,   0,   0)
//  channel   32: 6y2vyv(1, 2, 64, 4, 32, 128, 8, 16;  24,   0,  24,   0,   0)
//  channel   33: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;   0,   0,  23,   0,   0)
//  channel   34: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;  23,   0,  23,   0,   0)
//  channel   35: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  23,   0,   0)
//  channel   36: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  23,   0,   0)
//  channel   37: 6y2vyv(1, 2, 128, 8, 16, 64, 4, 32;  24,   0,  24,   0,   0)
//  channel   38: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   39: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  23,  23,   0,   0,   0)
//  channel   40: 63yvyv(1, 2, 64, 4, 32, 128, 8, 16;  24,  24,   0,   0,   0)
//  channel   41: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;   0,  23,   0,   0,   0)
//  channel   42: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;  23,  23,   0,   0,   0)
//  channel   43: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   44: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,  23,   0)
//  channel   45: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  23,   0,   0,   0,   0)
//  channel   46: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  23,   0,   0,  23,   0)
//  channel   47: 2v4yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   48: 2v4yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   0,   0)
//  channel   49: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   50: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   51: 2v4yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   52: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,   0,  23,   0)
//  channel   53: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,   0,  23,   0)
//  channel   54: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;   0,   0,   0,  23,   0)
//  channel   55: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;  23,   0,   0,  23,   0)
//  channel   56: 2v4yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   0,   0)
//  channel   57: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   0,   0)
//  channel   58: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   0,   0)
//  channel   59: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   0,   0)
//  channel   60: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   61: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   62: 2v4yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   63: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   64: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   65: 4yyv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,   0,   0)
//  channel   66: 4yyv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,  23,   0)
//  channel   67: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   68: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   0,   0,   0)
//  channel   69: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   70: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  23,  23,   0,   0,   0)
//  channel   71: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,   0,   0)
//  channel   72: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,  23,   0)
//  channel   73: 4yyv2v(1, 2, 32, 4, 8, 16, 64, 128;   0,  24,   0,  23,   0)
//  channel   74: 4yyv2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,  23,   0)
//  channel   75: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   0,   0,   0)
//  channel   76: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   0,   0,   0)
//  channel   77: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;   0,  23,   0,   0,   0)
//  channel   78: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;  23,  23,   0,   0,   0)
//  channel   79: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,  23,   0,  23,   0)
//  channel   80: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  23,   0,   0,   0)
//  channel   81: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  23,   0,  23,   0)
//  channel   82: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,   0,   0)
//  channel   83: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,  23,   0)
//  channel   84: 4yyv2v(1, 2, 16, 8, 4, 32, 64, 128;   0,  24,   0,  23,   0)
//  channel   85: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   0,   0)
//  channel   86: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,  23,   0)
//  channel   87: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,   0,   0)
//  channel   88: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,  23,   0,   0)
//  channel   89: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   90: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,  23,   0,   0)
//  channel   91: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   92: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   0,   0,   0)
//  channel   93: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,   0,  23,   0,   0)
//  channel   94: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,  23,   0,   0)
//  channel   95: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  23,   0,   0)
//  channel   96: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  23,   0,   0)
//  channel   97: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   0,   0,   0)
//  channel   98: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   0,   0,   0)
//  channel   99: 2v2v2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,  24,   0,   0)
//  channel  100: 2v2v2v(1, 2, 8, 16, 64, 128, 4, 32;  24,   0,  24,   0,   0)
//  channel  101: 2v2v2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   0,   0)
