#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_050_aa_emepvevexa(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_050_aa_emepvevexa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(28);
  needed_v_smin[x_a].resize(28);
  needed_v_smin[x_a][  0] = {   6,    7,   13,   15,   21,   22,   37,   38,   49,   50,   55,   56,   61,   63,   65,   66,   68,   70,   71,   72,   74,   77,   78,   81}; //  24
  needed_v_smin[x_a][  1] = {   8,   14,   23,   28,   39,   41,   51,   57,   58,   60,   62,   67,   69,   73,   75,   79,   80,   83}; //  18
  needed_v_smin[x_a][  2] = {   9,   10,   17,   18,   25,   26,   33,   34,   45,   46,   52,   53,   61,   62,   65,   67,   68,   69,   71,   73,   74,   75,   78,   80}; //  24
  needed_v_smin[x_a][  3] = {  11,   19,   27,   29,   35,   40,   47,   54,   59,   63,   64,   66,   70,   72,   76,   77,   81,   82}; //  18
  needed_v_smin[x_a][  4] = {  12,   16,   20,   24,   28,   29,   30,   31,   32,   36,   40,   41,   42,   43,   44,   48,   58,   59,   60,   64,   76,   79,   82,   83,    2,    5,    8,   11,   54,   57}; //  30
  needed_v_smin[x_a][  5] = {  12,   20,   36,   48,   64,   76}; //   6
  needed_v_smin[x_a][  6] = {  13,   21,   37,   49,   65,   74,   71}; //   7
  needed_v_smin[x_a][  7] = {  14,   23,   39,   51,   67,   75,   73}; //   7
  needed_v_smin[x_a][  8] = {  15,   22,   38,   50,   66,   77,   72}; //   7
  needed_v_smin[x_a][  9] = {  16,   24,   32,   44,   60,   79}; //   6
  needed_v_smin[x_a][ 10] = {  17,   25,   33,   45,   61,   78,   68}; //   7
  needed_v_smin[x_a][ 11] = {  18,   26,   34,   46,   62,   80,   69}; //   7
  needed_v_smin[x_a][ 12] = {  19,   27,   35,   47,   63,   81,   70}; //   7
  needed_v_smin[x_a][ 13] = {  20,   22,   36,   38,   12,   15,   48,   50}; //   8
  needed_v_smin[x_a][ 14] = {  21,   23,   37,   39,   13,   14,   49,   51}; //   8
  needed_v_smin[x_a][ 15] = {  24,   26,   32,   34,   16,   18,   44,   46}; //   8
  needed_v_smin[x_a][ 16] = {  25,   27,   33,   35,   17,   19,   45,   47}; //   8
  needed_v_smin[x_a][ 17] = {  28,   41,    8,   57,   58,   83}; //   6
  needed_v_smin[x_a][ 18] = {  29,   40,   11,   54,   59,   82}; //   6
  needed_v_smin[x_a][ 19] = {   0,    1,    6,    7,   55,   56}; //   6
  needed_v_smin[x_a][ 20] = {   0,    1}; //   2
  needed_v_smin[x_a][ 21] = {   0,    1,    2,   30,   42}; //   5
  needed_v_smin[x_a][ 22] = {   2,    5,   30,   31,   42,   43}; //   6
  needed_v_smin[x_a][ 23] = {   3,    4,    9,   10,   52,   53}; //   6
  needed_v_smin[x_a][ 24] = {   3,    4}; //   2
  needed_v_smin[x_a][ 25] = {   3,    4,    5,   31,   43}; //   5
  needed_v_smin[x_a][ 26] = {   6,    7,   55,   56}; //   4
  needed_v_smin[x_a][ 27] = {   9,   10,   52,   53}; //   4

  v_smax[x_a].resize(34);
  needed_v_smax[x_a].resize(34);
  needed_v_smax[x_a][  0] = {   6,    7,   13,   15,   21,   22,   37,   38,   49,   50,   55,   56,   65,   66,   71,   72,   78,   81}; //  18
  needed_v_smax[x_a][  1] = {   8,   14,   23,   39,   51,   57,   67,   73,   79,   80,   83}; //  11
  needed_v_smax[x_a][  2] = {   9,   10,   17,   18,   25,   26,   33,   34,   45,   46,   52,   53,   61,   62,   68,   69,   74,   75}; //  18
  needed_v_smax[x_a][  3] = {  11,   19,   27,   35,   47,   54,   63,   70,   76,   77,   82}; //  11
  needed_v_smax[x_a][  4] = {  12,   16,   20,   24,   28,   29,   30,   31,   32,   36,   40,   41,   42,   43,   44,   48,   58,   59,   60,   64,    2,    5}; //  22
  needed_v_smax[x_a][  5] = {  12,   15,   20,   22,   36,   38,   48,   50,   64,   66}; //  10
  needed_v_smax[x_a][  6] = {  13,   14,   21,   23,   37,   39,   49,   51,   65,   67}; //  10
  needed_v_smax[x_a][  7] = {  16,   18,   24,   26,   32,   34,   44,   46,   60,   62}; //  10
  needed_v_smax[x_a][  8] = {  17,   19,   25,   27,   33,   35,   45,   47,   61,   63}; //  10
  needed_v_smax[x_a][  9] = {  20,   21,   22,   23,   28,   36,   37,   38,   39,   41,    3,    4,    5,    6,    7,    8,   12,   13,   14,   15,   31,   43,   48,   49,   50,   51,   55,   56,   57,   58,   83}; //  31
  needed_v_smax[x_a][ 10] = {  24,   25,   26,   27,   29,   32,   33,   34,   35,   40,    0,    1,    2,    9,   10,   11,   16,   17,   18,   19,   30,   42,   44,   45,   46,   47,   52,   53,   54,   59,   82}; //  31
  needed_v_smax[x_a][ 11] = {  28,   41,   58}; //   3
  needed_v_smax[x_a][ 12] = {  29,   40,   59}; //   3
  needed_v_smax[x_a][ 13] = {  60,   62}; //   2
  needed_v_smax[x_a][ 14] = {  61,   63}; //   2
  needed_v_smax[x_a][ 15] = {  64,   66}; //   2
  needed_v_smax[x_a][ 16] = {  65,   67}; //   2
  needed_v_smax[x_a][ 17] = {  68,   74}; //   2
  needed_v_smax[x_a][ 18] = {  69,   75}; //   2
  needed_v_smax[x_a][ 19] = {  70,   77}; //   2
  needed_v_smax[x_a][ 20] = {  71,   78}; //   2
  needed_v_smax[x_a][ 21] = {  72,   81}; //   2
  needed_v_smax[x_a][ 22] = {  73,   80}; //   2
  needed_v_smax[x_a][ 23] = {  74,   75,   71,   73}; //   4
  needed_v_smax[x_a][ 24] = {  76,   82,   11,   54}; //   4
  needed_v_smax[x_a][ 25] = {  76,   77,   72}; //   3
  needed_v_smax[x_a][ 26] = {  78,   81,   68,   70}; //   4
  needed_v_smax[x_a][ 27] = {  79,   83,    8,   57}; //   4
  needed_v_smax[x_a][ 28] = {  79,   80,   69}; //   3
  needed_v_smax[x_a][ 29] = {   0,    1}; //   2
  needed_v_smax[x_a][ 30] = {   0,    1,    2,    3,    4,    5,   30,   31,   42,   43}; //  10
  needed_v_smax[x_a][ 31] = {   3,    4}; //   2
  needed_v_smax[x_a][ 32] = {   6,    7,   55,   56}; //   4
  needed_v_smax[x_a][ 33] = {   9,   10,   52,   53}; //   4

  g_p[x_a].resize(41);
  needed_g_p[x_a].resize(41);
  needed_g_p[x_a][0] = {   6,    7,   13,   15,   21,   22,   37,   38,   49,   50,   55,   56,   65,   66,   71,   72,   78,   81}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   8,   14,   23,   39,   51,   57,   67,   73,   79,   80,   83}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   9,   10,   17,   18,   25,   26,   33,   34,   45,   46,   52,   53,   61,   62,   68,   69,   74,   75}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");
  needed_g_p[x_a][3] = {  11,   19,   27,   35,   47,   54,   63,   70,   76,   77,   82}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  12,   16,   20,   24,   28,   29,   30,   31,   32,   36,   40,   41,   42,   43,   44,   48,   58,   59,   60,   64}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][5] = {  12,   20,   36,   48,   64}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {  13,   21,   37,   49,   65}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax6");
  needed_g_p[x_a][7] = {  14,   23,   39,   51,   67}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax6");
  needed_g_p[x_a][8] = {  15,   22,   38,   50,   66}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax5");
  needed_g_p[x_a][9] = {  16,   24,   32,   44,   60}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][10] = {  17,   25,   33,   45,   61}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax8");
  needed_g_p[x_a][11] = {  18,   26,   34,   46,   62}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][12] = {  19,   27,   35,   47,   63}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax8");
  needed_g_p[x_a][13] = {  20,   22,   36,   38}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][14] = {  21,   23,   37,   39}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax9");
  needed_g_p[x_a][15] = {  24,   26,   32,   34}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax10");
  needed_g_p[x_a][16] = {  25,   27,   33,   35}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax10");
  needed_g_p[x_a][17] = {  28,   41,   58}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax11");
  needed_g_p[x_a][18] = {  28,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax9");
  needed_g_p[x_a][19] = {  29,   40,   59}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax12");
  needed_g_p[x_a][20] = {  29,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax10");
  needed_g_p[x_a][21] = {  60,   62}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax13");
  needed_g_p[x_a][22] = {  61,   63}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][23] = {  64,   66}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax15");
  needed_g_p[x_a][24] = {  65,   67}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax16");
  needed_g_p[x_a][25] = {  68,   74}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax17");
  needed_g_p[x_a][26] = {  69,   75}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax18");
  needed_g_p[x_a][27] = {  70,   77}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax19");
  needed_g_p[x_a][28] = {  71,   78}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax20");
  needed_g_p[x_a][29] = {  72,   81}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax21");
  needed_g_p[x_a][30] = {  73,   80}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax22");
  needed_g_p[x_a][31] = {  74}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax23");
  needed_g_p[x_a][32] = {  75}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin7_smax23");
  needed_g_p[x_a][33] = {  76,   82}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax24");
  needed_g_p[x_a][34] = {  76}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax25");
  needed_g_p[x_a][35] = {  77}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax25");
  needed_g_p[x_a][36] = {  78}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin10_smax26");
  needed_g_p[x_a][37] = {  79,   83}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax27");
  needed_g_p[x_a][38] = {  79}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax28");
  needed_g_p[x_a][39] = {  80}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax28");
  needed_g_p[x_a][40] = {  81}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin12_smax26");

  g_f[x_a].resize(26);
  needed_g_f[x_a].resize(26);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax29");
  needed_g_f[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax30");
  needed_g_f[x_a][2] = {   0,    1,    2,   30,   42}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax10");
  needed_g_f[x_a][3] = {   2,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][4] = {   2,    5,   30,   31,   42,   43}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax30");
  needed_g_f[x_a][5] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax31");
  needed_g_f[x_a][6] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax30");
  needed_g_f[x_a][7] = {   3,    4,    5,   31,   43}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax9");
  needed_g_f[x_a][8] = {   6,    7,   55,   56}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax32");
  needed_g_f[x_a][9] = {   6,    7,   55,   56}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax9");
  needed_g_f[x_a][10] = {   8,   57}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax27");
  needed_g_f[x_a][11] = {   8,   57,   58,   83}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax9");
  needed_g_f[x_a][12] = {   9,   10,   52,   53}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax33");
  needed_g_f[x_a][13] = {   9,   10,   52,   53}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax10");
  needed_g_f[x_a][14] = {  11,   54}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax24");
  needed_g_f[x_a][15] = {  11,   54,   59,   82}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax10");
  needed_g_f[x_a][16] = {  12,   15,   48,   50}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax9");
  needed_g_f[x_a][17] = {  13,   14,   49,   51}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax9");
  needed_g_f[x_a][18] = {  16,   18,   44,   46}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax10");
  needed_g_f[x_a][19] = {  17,   19,   45,   47}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax10");
  needed_g_f[x_a][20] = {  68}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax26");
  needed_g_f[x_a][21] = {  69}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax28");
  needed_g_f[x_a][22] = {  70}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax26");
  needed_g_f[x_a][23] = {  71}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax23");
  needed_g_f[x_a][24] = {  72}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax25");
  needed_g_f[x_a][25] = {  73}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax23");

  g_t[x_a].resize(54);
  needed_g_t[x_a].resize(54);
  needed_g_t[x_a][0] = {   0,    1,    2,   30,   32,   33,   34,   35,   40,   42,   44,   45,   46,   47,   52,   53,   54,   82}; //  18
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_120");
  needed_g_t[x_a][1] = {   0,    1,    2,   30,   42}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_112");
  needed_g_t[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__5_10__32_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__5_10__32_80");
  needed_g_t[x_a][3] = {   0,    6}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_37__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_37__64_16");
  needed_g_t[x_a][4] = {   1,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_37__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_37__16_64");
  needed_g_t[x_a][5] = {   2,   42}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__64_48");
  needed_g_t[x_a][6] = {   2,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__10_69__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__10_69__16_32");
  needed_g_t[x_a][7] = {   3,    4,    5,   31,   36,   37,   38,   39,   41,   43,   48,   49,   50,   51,   55,   56,   57,   83}; //  18
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_116");
  needed_g_t[x_a][8] = {   3,    4,    5,   31,   43}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_112");
  needed_g_t[x_a][9] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__9_6__16_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__9_6__16_96");
  needed_g_t[x_a][10] = {   3,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_25__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_25__64_32");
  needed_g_t[x_a][11] = {   4,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_25__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_25__32_64");
  needed_g_t[x_a][12] = {   5,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__64_48");
  needed_g_t[x_a][13] = {   5,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__6_73__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__6_73__32_16");
  needed_g_t[x_a][14] = {   6,    7,    8,   12,   13,   14,   15,   20,   21,   22,   23,   28,   58}; //  13
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][15] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_10__36_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_10__36_80");
  needed_g_t[x_a][16] = {   8,   58}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__68_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__68_48");
  needed_g_t[x_a][17] = {   9,   10,   11,   16,   17,   18,   19,   24,   25,   26,   27,   29,   59}; //  13
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][18] = {   9,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_6__24_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_6__24_96");
  needed_g_t[x_a][19] = {  11,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__72_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__72_48");
  needed_g_t[x_a][20] = {  12,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__64_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__64_52");
  needed_g_t[x_a][21] = {  13,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__10_1__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__10_1__16_100");
  needed_g_t[x_a][22] = {  16,   18}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__64_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__64_56");
  needed_g_t[x_a][23] = {  17,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__6_1__32_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__6_1__32_88");
  needed_g_t[x_a][24] = {  30}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_5__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_5__64_48");
  needed_g_t[x_a][25] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_9__64_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_9__64_48");
  needed_g_t[x_a][26] = {  44,   46}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__5_2__64_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__5_2__64_56");
  needed_g_t[x_a][27] = {  45,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__5_2__32_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__5_2__32_88");
  needed_g_t[x_a][28] = {  48,   50}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__9_2__64_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__9_2__64_52");
  needed_g_t[x_a][29] = {  49,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__9_2__16_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__9_2__16_100");
  needed_g_t[x_a][30] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_5__24_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_5__24_96");
  needed_g_t[x_a][31] = {  52}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__5_26__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__5_26__32_64");
  needed_g_t[x_a][32] = {  53}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_26__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_26__64_32");
  needed_g_t[x_a][33] = {  54,   82}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__72_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__72_48");
  needed_g_t[x_a][34] = {  54}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__5_74__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__5_74__32_16");
  needed_g_t[x_a][35] = {  55,   56}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_9__36_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_9__36_80");
  needed_g_t[x_a][36] = {  55}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__9_38__16_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__9_38__16_64");
  needed_g_t[x_a][37] = {  56}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_38__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_38__64_16");
  needed_g_t[x_a][38] = {  57,   83}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__68_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__68_48");
  needed_g_t[x_a][39] = {  57}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_24__9_70__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_24__9_70__16_32");
  needed_g_t[x_a][40] = {  60,   62,   69}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__68_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__68_56");
  needed_g_t[x_a][41] = {  61,   63,   68,   70}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_2__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_2__36_88");
  needed_g_t[x_a][42] = {  64,   66,   72}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__72_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__72_52");
  needed_g_t[x_a][43] = {  65,   67,   71,   73}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__1_2__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__1_2__24_100");
  needed_g_t[x_a][44] = {  68}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_37__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_37__24_64");
  needed_g_t[x_a][45] = {  69}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_69__24_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_69__24_32");
  needed_g_t[x_a][46] = {  70}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_37__72_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_37__72_16");
  needed_g_t[x_a][47] = {  71}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_25__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_25__36_64");
  needed_g_t[x_a][48] = {  72}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_73__36_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_73__36_16");
  needed_g_t[x_a][49] = {  73}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__68_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__68_32");
  needed_g_t[x_a][50] = {  74,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__24_100");
  needed_g_t[x_a][51] = {  76,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__72_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__72_52");
  needed_g_t[x_a][52] = {  78,   81}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_24__2_1__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_24__2_1__36_88");
  needed_g_t[x_a][53] = {  79,   80}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__68_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__68_56");

  g_d[x_a].resize(19);
  needed_g_d[x_a].resize(19);
  needed_g_d[x_a][0] = {   6,    7,   13,   15,   21,   22,   37,   38,   49,   50,   55,   56,   61,   63,   65,   66,   68,   70,   71,   72,   74,   77,   78,   81}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][1] = {   8,   14,   23,   28,   39,   41,   51,   57,   58,   60,   62,   67,   69,   73,   75,   79,   80,   83}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][2] = {   9,   10,   17,   18,   25,   26,   33,   34,   45,   46,   52,   53,   61,   62,   65,   67,   68,   69,   71,   73,   74,   75,   78,   80}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  11,   19,   27,   29,   35,   40,   47,   54,   59,   63,   64,   66,   70,   72,   76,   77,   81,   82}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][4] = {  12,   20,   36,   48,   64,   76}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][5] = {  12,   16,   20,   24,   28,   29,   30,   31,   32,   36,   40,   41,   42,   43,   44,   48,   58,   59,   60,   64,   76,   79,   82,   83}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][6] = {  13,   21,   37,   49,   65,   74}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][7] = {  14,   23,   39,   51,   67,   75}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__32_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__32_68");
  needed_g_d[x_a][8] = {  15,   22,   38,   50,   66,   77}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][9] = {  16,   24,   32,   44,   60,   79}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][10] = {  17,   25,   33,   45,   61,   78}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][11] = {  18,   26,   34,   46,   62,   80}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][12] = {  19,   27,   35,   47,   63,   81}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__16_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__16_72");
  needed_g_d[x_a][13] = {  20,   22,   36,   38}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__64_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__64_52");
  needed_g_d[x_a][14] = {  21,   23,   37,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__16_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__16_100");
  needed_g_d[x_a][15] = {  24,   26,   32,   34}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__64_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__64_56");
  needed_g_d[x_a][16] = {  25,   27,   33,   35}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__32_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__32_88");
  needed_g_d[x_a][17] = {  28,   41}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__68_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__68_48");
  needed_g_d[x_a][18] = {  29,   40}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__72_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__72_48");

  c_p[x_a].resize(84);
  c_f[x_a].resize(84);
  c_t[x_a].resize(84);
  c_d[x_a].resize(84);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1,   2}; //   3
  c_t[x_a][1] = {  0,   1,   2,   4}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  3,   4,   2}; //   3
  c_t[x_a][2] = {  0,   1,   5,   6}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  5,   6,   7}; //   3
  c_t[x_a][3] = {  7,   8,   9,  10}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  5,   6,   7}; //   3
  c_t[x_a][4] = {  7,   8,   9,  11}; //   4
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  3,   4,   7}; //   3
  c_t[x_a][5] = {  7,   8,  12,  13}; //   4
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  8,   9}; //   2
  c_t[x_a][6] = { 14,  15,   3}; //   3
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = {  8,   9}; //   2
  c_t[x_a][7] = { 14,  15,   4}; //   3
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  1}; //   1
  c_f[x_a][8] = { 10,  11}; //   2
  c_t[x_a][8] = { 14,  16,   6}; //   3
  c_d[x_a][8] = {  1}; //   1

  c_p[x_a][9] = {  2}; //   1
  c_f[x_a][9] = { 12,  13}; //   2
  c_t[x_a][9] = { 17,  18,  10}; //   3
  c_d[x_a][9] = {  2}; //   1

  c_p[x_a][10] = {  2}; //   1
  c_f[x_a][10] = { 12,  13}; //   2
  c_t[x_a][10] = { 17,  18,  11}; //   3
  c_d[x_a][10] = {  2}; //   1

  c_p[x_a][11] = {  3}; //   1
  c_f[x_a][11] = { 14,  15}; //   2
  c_t[x_a][11] = { 17,  19,  13}; //   3
  c_d[x_a][11] = {  3}; //   1

  c_p[x_a][12] = {  4,   5}; //   2
  c_f[x_a][12] = { 16}; //   1
  c_t[x_a][12] = { 14,  20}; //   2
  c_d[x_a][12] = {  4,   5}; //   2

  c_p[x_a][13] = {  0,   6}; //   2
  c_f[x_a][13] = { 17}; //   1
  c_t[x_a][13] = { 14,  21}; //   2
  c_d[x_a][13] = {  6,   0}; //   2

  c_p[x_a][14] = {  1,   7}; //   2
  c_f[x_a][14] = { 17}; //   1
  c_t[x_a][14] = { 14,  21}; //   2
  c_d[x_a][14] = {  7,   1}; //   2

  c_p[x_a][15] = {  0,   8}; //   2
  c_f[x_a][15] = { 16}; //   1
  c_t[x_a][15] = { 14,  20}; //   2
  c_d[x_a][15] = {  8,   0}; //   2

  c_p[x_a][16] = {  4,   9}; //   2
  c_f[x_a][16] = { 18}; //   1
  c_t[x_a][16] = { 17,  22}; //   2
  c_d[x_a][16] = {  9,   5}; //   2

  c_p[x_a][17] = {  2,  10}; //   2
  c_f[x_a][17] = { 19}; //   1
  c_t[x_a][17] = { 17,  23}; //   2
  c_d[x_a][17] = { 10,   2}; //   2

  c_p[x_a][18] = {  2,  11}; //   2
  c_f[x_a][18] = { 18}; //   1
  c_t[x_a][18] = { 17,  22}; //   2
  c_d[x_a][18] = { 11,   2}; //   2

  c_p[x_a][19] = {  3,  12}; //   2
  c_f[x_a][19] = { 19}; //   1
  c_t[x_a][19] = { 17,  23}; //   2
  c_d[x_a][19] = { 12,   3}; //   2

  c_p[x_a][20] = {  4,   5,  13}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = { 14}; //   1
  c_d[x_a][20] = { 13,   4,   5}; //   3

  c_p[x_a][21] = {  0,   6,  14}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = { 14}; //   1
  c_d[x_a][21] = { 14,   6,   0}; //   3

  c_p[x_a][22] = {  0,   8,  13}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = { 14}; //   1
  c_d[x_a][22] = { 13,   8,   0}; //   3

  c_p[x_a][23] = {  1,   7,  14}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 14}; //   1
  c_d[x_a][23] = { 14,   7,   1}; //   3

  c_p[x_a][24] = {  4,   9,  15}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = { 17}; //   1
  c_d[x_a][24] = { 15,   9,   5}; //   3

  c_p[x_a][25] = {  2,  10,  16}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = { 17}; //   1
  c_d[x_a][25] = { 16,  10,   2}; //   3

  c_p[x_a][26] = {  2,  11,  15}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = { 17}; //   1
  c_d[x_a][26] = { 15,  11,   2}; //   3

  c_p[x_a][27] = {  3,  12,  16}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 17}; //   1
  c_d[x_a][27] = { 16,  12,   3}; //   3

  c_p[x_a][28] = {  4,  17,  18}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 14}; //   1
  c_d[x_a][28] = { 17,   1,   5}; //   3

  c_p[x_a][29] = {  4,  19,  20}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = { 17}; //   1
  c_d[x_a][29] = { 18,   3,   5}; //   3

  c_p[x_a][30] = {  4}; //   1
  c_f[x_a][30] = {  4,   2}; //   2
  c_t[x_a][30] = {  0,   1,  24}; //   3
  c_d[x_a][30] = {  5}; //   1

  c_p[x_a][31] = {  4}; //   1
  c_f[x_a][31] = {  4,   7}; //   2
  c_t[x_a][31] = {  7,   8,  25}; //   3
  c_d[x_a][31] = {  5}; //   1

  c_p[x_a][32] = {  4,   9,  15}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  0}; //   1
  c_d[x_a][32] = { 15,   9,   5}; //   3

  c_p[x_a][33] = {  2,  10,  16}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  0}; //   1
  c_d[x_a][33] = { 16,  10,   2}; //   3

  c_p[x_a][34] = {  2,  11,  15}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  0}; //   1
  c_d[x_a][34] = { 15,  11,   2}; //   3

  c_p[x_a][35] = {  3,  12,  16}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  0}; //   1
  c_d[x_a][35] = { 16,  12,   3}; //   3

  c_p[x_a][36] = {  4,   5,  13}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  7}; //   1
  c_d[x_a][36] = { 13,   4,   5}; //   3

  c_p[x_a][37] = {  0,   6,  14}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  7}; //   1
  c_d[x_a][37] = { 14,   6,   0}; //   3

  c_p[x_a][38] = {  0,   8,  13}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  7}; //   1
  c_d[x_a][38] = { 13,   8,   0}; //   3

  c_p[x_a][39] = {  1,   7,  14}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  7}; //   1
  c_d[x_a][39] = { 14,   7,   1}; //   3

  c_p[x_a][40] = {  4,  19,  20}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  0}; //   1
  c_d[x_a][40] = { 18,   3,   5}; //   3

  c_p[x_a][41] = {  4,  17,  18}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  7}; //   1
  c_d[x_a][41] = { 17,   1,   5}; //   3

  c_p[x_a][42] = {  4}; //   1
  c_f[x_a][42] = {  4,   2}; //   2
  c_t[x_a][42] = {  0,   1,   5}; //   3
  c_d[x_a][42] = {  5}; //   1

  c_p[x_a][43] = {  4}; //   1
  c_f[x_a][43] = {  4,   7}; //   2
  c_t[x_a][43] = {  7,   8,  12}; //   3
  c_d[x_a][43] = {  5}; //   1

  c_p[x_a][44] = {  4,   9}; //   2
  c_f[x_a][44] = { 18}; //   1
  c_t[x_a][44] = {  0,  26}; //   2
  c_d[x_a][44] = {  9,   5}; //   2

  c_p[x_a][45] = {  2,  10}; //   2
  c_f[x_a][45] = { 19}; //   1
  c_t[x_a][45] = {  0,  27}; //   2
  c_d[x_a][45] = { 10,   2}; //   2

  c_p[x_a][46] = {  2,  11}; //   2
  c_f[x_a][46] = { 18}; //   1
  c_t[x_a][46] = {  0,  26}; //   2
  c_d[x_a][46] = { 11,   2}; //   2

  c_p[x_a][47] = {  3,  12}; //   2
  c_f[x_a][47] = { 19}; //   1
  c_t[x_a][47] = {  0,  27}; //   2
  c_d[x_a][47] = { 12,   3}; //   2

  c_p[x_a][48] = {  4,   5}; //   2
  c_f[x_a][48] = { 16}; //   1
  c_t[x_a][48] = {  7,  28}; //   2
  c_d[x_a][48] = {  4,   5}; //   2

  c_p[x_a][49] = {  0,   6}; //   2
  c_f[x_a][49] = { 17}; //   1
  c_t[x_a][49] = {  7,  29}; //   2
  c_d[x_a][49] = {  6,   0}; //   2

  c_p[x_a][50] = {  0,   8}; //   2
  c_f[x_a][50] = { 16}; //   1
  c_t[x_a][50] = {  7,  28}; //   2
  c_d[x_a][50] = {  8,   0}; //   2

  c_p[x_a][51] = {  1,   7}; //   2
  c_f[x_a][51] = { 17}; //   1
  c_t[x_a][51] = {  7,  29}; //   2
  c_d[x_a][51] = {  7,   1}; //   2

  c_p[x_a][52] = {  2}; //   1
  c_f[x_a][52] = { 12,  13}; //   2
  c_t[x_a][52] = {  0,  30,  31}; //   3
  c_d[x_a][52] = {  2}; //   1

  c_p[x_a][53] = {  2}; //   1
  c_f[x_a][53] = { 12,  13}; //   2
  c_t[x_a][53] = {  0,  30,  32}; //   3
  c_d[x_a][53] = {  2}; //   1

  c_p[x_a][54] = {  3}; //   1
  c_f[x_a][54] = { 14,  15}; //   2
  c_t[x_a][54] = {  0,  33,  34}; //   3
  c_d[x_a][54] = {  3}; //   1

  c_p[x_a][55] = {  0}; //   1
  c_f[x_a][55] = {  8,   9}; //   2
  c_t[x_a][55] = {  7,  35,  36}; //   3
  c_d[x_a][55] = {  0}; //   1

  c_p[x_a][56] = {  0}; //   1
  c_f[x_a][56] = {  8,   9}; //   2
  c_t[x_a][56] = {  7,  35,  37}; //   3
  c_d[x_a][56] = {  0}; //   1

  c_p[x_a][57] = {  1}; //   1
  c_f[x_a][57] = { 10,  11}; //   2
  c_t[x_a][57] = {  7,  38,  39}; //   3
  c_d[x_a][57] = {  1}; //   1

  c_p[x_a][58] = {  4,  17}; //   2
  c_f[x_a][58] = { 11}; //   1
  c_t[x_a][58] = { 14,  16}; //   2
  c_d[x_a][58] = {  1,   5}; //   2

  c_p[x_a][59] = {  4,  19}; //   2
  c_f[x_a][59] = { 15}; //   1
  c_t[x_a][59] = { 17,  19}; //   2
  c_d[x_a][59] = {  3,   5}; //   2

  c_p[x_a][60] = {  4,   9,  21}; //   3
  c_f[x_a][60] = {}; //   0
  c_t[x_a][60] = { 40}; //   1
  c_d[x_a][60] = {  1,   9,   5}; //   3

  c_p[x_a][61] = {  2,  10,  22}; //   3
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = { 41}; //   1
  c_d[x_a][61] = {  0,  10,   2}; //   3

  c_p[x_a][62] = {  2,  11,  21}; //   3
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = { 40}; //   1
  c_d[x_a][62] = {  1,  11,   2}; //   3

  c_p[x_a][63] = {  3,  12,  22}; //   3
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = { 41}; //   1
  c_d[x_a][63] = {  0,  12,   3}; //   3

  c_p[x_a][64] = {  4,   5,  23}; //   3
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = { 42}; //   1
  c_d[x_a][64] = {  3,   4,   5}; //   3

  c_p[x_a][65] = {  0,   6,  24}; //   3
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = { 43}; //   1
  c_d[x_a][65] = {  2,   6,   0}; //   3

  c_p[x_a][66] = {  0,   8,  23}; //   3
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = { 42}; //   1
  c_d[x_a][66] = {  3,   8,   0}; //   3

  c_p[x_a][67] = {  1,   7,  24}; //   3
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = { 43}; //   1
  c_d[x_a][67] = {  2,   7,   1}; //   3

  c_p[x_a][68] = {  2,  25}; //   2
  c_f[x_a][68] = { 20}; //   1
  c_t[x_a][68] = { 41,  44}; //   2
  c_d[x_a][68] = {  0,   2}; //   2

  c_p[x_a][69] = {  2,  26}; //   2
  c_f[x_a][69] = { 21}; //   1
  c_t[x_a][69] = { 40,  45}; //   2
  c_d[x_a][69] = {  1,   2}; //   2

  c_p[x_a][70] = {  3,  27}; //   2
  c_f[x_a][70] = { 22}; //   1
  c_t[x_a][70] = { 41,  46}; //   2
  c_d[x_a][70] = {  0,   3}; //   2

  c_p[x_a][71] = {  0,  28}; //   2
  c_f[x_a][71] = { 23}; //   1
  c_t[x_a][71] = { 43,  47}; //   2
  c_d[x_a][71] = {  2,   0}; //   2

  c_p[x_a][72] = {  0,  29}; //   2
  c_f[x_a][72] = { 24}; //   1
  c_t[x_a][72] = { 42,  48}; //   2
  c_d[x_a][72] = {  3,   0}; //   2

  c_p[x_a][73] = {  1,  30}; //   2
  c_f[x_a][73] = { 25}; //   1
  c_t[x_a][73] = { 43,  49}; //   2
  c_d[x_a][73] = {  2,   1}; //   2

  c_p[x_a][74] = {  2,  25,  31}; //   3
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = { 50}; //   1
  c_d[x_a][74] = {  6,   0,   2}; //   3

  c_p[x_a][75] = {  2,  26,  32}; //   3
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = { 50}; //   1
  c_d[x_a][75] = {  7,   1,   2}; //   3

  c_p[x_a][76] = {  3,  33,  34}; //   3
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = { 51}; //   1
  c_d[x_a][76] = {  4,   5,   3}; //   3

  c_p[x_a][77] = {  3,  27,  35}; //   3
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = { 51}; //   1
  c_d[x_a][77] = {  8,   0,   3}; //   3

  c_p[x_a][78] = {  0,  28,  36}; //   3
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = { 52}; //   1
  c_d[x_a][78] = { 10,   2,   0}; //   3

  c_p[x_a][79] = {  1,  37,  38}; //   3
  c_f[x_a][79] = {}; //   0
  c_t[x_a][79] = { 53}; //   1
  c_d[x_a][79] = {  9,   5,   1}; //   3

  c_p[x_a][80] = {  1,  30,  39}; //   3
  c_f[x_a][80] = {}; //   0
  c_t[x_a][80] = { 53}; //   1
  c_d[x_a][80] = { 11,   2,   1}; //   3

  c_p[x_a][81] = {  0,  29,  40}; //   3
  c_f[x_a][81] = {}; //   0
  c_t[x_a][81] = { 52}; //   1
  c_d[x_a][81] = { 12,   3,   0}; //   3

  c_p[x_a][82] = {  3,  33}; //   2
  c_f[x_a][82] = { 15}; //   1
  c_t[x_a][82] = {  0,  33}; //   2
  c_d[x_a][82] = {  5,   3}; //   2

  c_p[x_a][83] = {  1,  37}; //   2
  c_f[x_a][83] = { 11}; //   1
  c_t[x_a][83] = {  7,  38}; //   2
  c_d[x_a][83] = {  5,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_050_aa_emepvevexa
//  channel    0: 11111(1, 2, 4, 32, 16, 64, 8;   0,   0,  24,   0)
//  channel    1: 11111(1, 2, 4, 32, 64, 16, 8;   0,   0,  24,  24)
//  channel    2: 11111(1, 2, 4, 64, 32, 16, 8;   0,   0,   0,  24)
//  channel    3: 11111(1, 2, 8, 16, 32, 64, 4;   0,   0,  24,   0)
//  channel    4: 11111(1, 2, 8, 16, 64, 32, 4;   0,   0,  24,  24)
//  channel    5: 11111(1, 2, 8, 64, 16, 32, 4;   0,   0,   0,  24)
//  channel    6: 2v111(1, 2, 4, 32, 16, 64, 8;  24,   0,  24,   0)
//  channel    7: 2v111(1, 2, 4, 32, 64, 16, 8;  24,   0,  24,  24)
//  channel    8: 2v111(1, 2, 4, 64, 32, 16, 8;   0,   0,   0,  24)
//  channel    9: 2v111(1, 2, 8, 16, 32, 64, 4;  24,   0,  24,   0)
//  channel   10: 2v111(1, 2, 8, 16, 64, 32, 4;  24,   0,  24,  24)
//  channel   11: 2v111(1, 2, 8, 64, 16, 32, 4;   0,   0,   0,  24)
//  channel   12: 3yv11(1, 2, 4, 16, 32, 64, 8;  23,   0,   0,   0)
//  channel   13: 3yv11(1, 2, 64, 4, 32, 16, 8;  24,  24,   0,  24)
//  channel   14: 3yv11(1, 2, 32, 4, 64, 16, 8;   0,  24,   0,  24)
//  channel   15: 3yv11(1, 2, 16, 4, 32, 64, 8;  24,   0,   0,   0)
//  channel   16: 3yv11(1, 2, 8, 16, 32, 64, 4;  23,   0,   0,   0)
//  channel   17: 3yv11(1, 2, 64, 8, 16, 32, 4;  24,  24,   0,  24)
//  channel   18: 3yv11(1, 2, 32, 8, 16, 64, 4;  24,   0,   0,   0)
//  channel   19: 3yv11(1, 2, 16, 8, 64, 32, 4;   0,  24,   0,  24)
//  channel   20: 4yyv1(1, 2, 64, 4, 16, 32, 8;  23,   0,   0,   0)
//  channel   21: 4yyv1(1, 2, 16, 64, 4, 32, 8;  24,  24,   0,   0)
//  channel   22: 4yyv1(1, 2, 64, 16, 4, 32, 8;  24,   0,   0,   0)
//  channel   23: 4yyv1(1, 2, 16, 32, 4, 64, 8;   0,  24,   0,   0)
//  channel   24: 4yyv1(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,   0)
//  channel   25: 4yyv1(1, 2, 32, 64, 8, 16, 4;  24,  24,   0,   0)
//  channel   26: 4yyv1(1, 2, 64, 32, 8, 16, 4;  24,   0,   0,   0)
//  channel   27: 4yyv1(1, 2, 32, 16, 8, 64, 4;   0,  24,   0,   0)
//  channel   28: 42vv1(1, 2, 4, 64, 16, 32, 8;  23,   0,   0,   0)
//  channel   29: 42vv1(1, 2, 8, 64, 16, 32, 4;  23,   0,   0,   0)
//  channel   30: 12v11(1, 2, 4, 16, 32, 64, 8;  23,   0,   0,   0)
//  channel   31: 12v11(1, 2, 8, 16, 32, 64, 4;  23,   0,   0,   0)
//  channel   32: 14yyv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
//  channel   33: 14yyv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,   0)
//  channel   34: 14yyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
//  channel   35: 14yyv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,   0)
//  channel   36: 14yyv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
//  channel   37: 14yyv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,   0)
//  channel   38: 14yyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
//  channel   39: 14yyv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,   0)
//  channel   40: 142vv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel   41: 142vv(1, 2, 8, 4, 64, 16, 32;  23,   0,   0,   0)
//  channel   42: 112v1(1, 2, 4, 64, 16, 32, 8;  23,   0,   0,   0)
//  channel   43: 112v1(1, 2, 8, 64, 16, 32, 4;  23,   0,   0,   0)
//  channel   44: 113yv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
//  channel   45: 113yv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,  24)
//  channel   46: 113yv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
//  channel   47: 113yv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,  24)
//  channel   48: 113yv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
//  channel   49: 113yv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,  24)
//  channel   50: 113yv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
//  channel   51: 113yv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,  24)
//  channel   52: 1112v(1, 2, 4, 32, 64, 8, 16;  24,   0,  24,  24)
//  channel   53: 1112v(1, 2, 4, 64, 32, 8, 16;  24,   0,  24,   0)
//  channel   54: 1112v(1, 2, 4, 32, 16, 8, 64;   0,   0,   0,  24)
//  channel   55: 1112v(1, 2, 8, 16, 64, 4, 32;  24,   0,  24,  24)
//  channel   56: 1112v(1, 2, 8, 64, 16, 4, 32;  24,   0,  24,   0)
//  channel   57: 1112v(1, 2, 8, 16, 32, 4, 64;   0,   0,   0,  24)
//  channel   58: 2v2v1(1, 2, 4, 64, 16, 32, 8;  23,   0,   0,   0)
//  channel   59: 2v2v1(1, 2, 8, 64, 16, 32, 4;  23,   0,   0,   0)
//  channel   60: 2v3yv(1, 2, 4, 64, 8, 16, 32;  23,   0,   0,   0)
//  channel   61: 2v3yv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,  24)
//  channel   62: 2v3yv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
//  channel   63: 2v3yv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,  24)
//  channel   64: 2v3yv(1, 2, 8, 64, 4, 16, 32;  23,   0,   0,   0)
//  channel   65: 2v3yv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,  24)
//  channel   66: 2v3yv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
//  channel   67: 2v3yv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,  24)
//  channel   68: 2v12v(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,  24)
//  channel   69: 2v12v(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,  24)
//  channel   70: 2v12v(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,   0)
//  channel   71: 2v12v(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,  24)
//  channel   72: 2v12v(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,  24)
//  channel   73: 2v12v(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,   0)
//  channel   74: 3yv2v(1, 2, 64, 4, 32, 8, 16;  24,  24,  24,  24)
//  channel   75: 3yv2v(1, 2, 32, 4, 64, 8, 16;  24,   0,  24,  24)
//  channel   76: 3yv2v(1, 2, 4, 16, 32, 8, 64;   0,  23,   0,   0)
//  channel   77: 3yv2v(1, 2, 16, 4, 32, 8, 64;   0,  24,   0,   0)
//  channel   78: 3yv2v(1, 2, 64, 8, 16, 4, 32;  24,  24,  24,  24)
//  channel   79: 3yv2v(1, 2, 8, 16, 32, 4, 64;   0,  23,   0,   0)
//  channel   80: 3yv2v(1, 2, 32, 8, 16, 4, 64;   0,  24,   0,   0)
//  channel   81: 3yv2v(1, 2, 16, 8, 64, 4, 32;  24,   0,  24,  24)
//  channel   82: 12v2v(1, 2, 4, 16, 32, 8, 64;   0,  23,   0,   0)
//  channel   83: 12v2v(1, 2, 8, 16, 32, 4, 64;   0,  23,   0,   0)
