#include "header.hpp"

#include "ppeexnenex04.phasespace.set.hpp"

void ppeexnenex04_phasespace_set::ax_psp_140_gd_emepvevexd(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_140_gd_emepvevexd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(21);
  needed_v_smin[x_a].resize(21);
  needed_v_smin[x_a][  0] = {   0,    1,    7,    8,   14,   15,   17,   18,   19,   20,   26,   27,   33,   34,   35,   36,   38,   39,   40,   41}; //  20
  needed_v_smin[x_a][  1] = {   0,    1,   19,   20}; //   4
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   19,   20,   21,   22}; //   8
  needed_v_smin[x_a][  3] = {   2,    3,    4,   12,   13,   16,   21,   22,   23,   31,   32,   37,   42}; //  13
  needed_v_smin[x_a][  4] = {   2,    3,   21,   22}; //   4
  needed_v_smin[x_a][  5] = {   4,   23}; //   2
  needed_v_smin[x_a][  6] = {   4,    6,   23,   25}; //   4
  needed_v_smin[x_a][  7] = {   5,    6,   14,   15,   17,   18,   24,   25,   33,   34,   35,   36,   38,   39,   40,   41}; //  16
  needed_v_smin[x_a][  8] = {   5,   24}; //   2
  needed_v_smin[x_a][  9] = {   5,   11,   24,   30}; //   4
  needed_v_smin[x_a][ 10] = {   6,   25}; //   2
  needed_v_smin[x_a][ 11] = {   7,    8,   26,   27}; //   4
  needed_v_smin[x_a][ 12] = {   7,    8,    9,   10,   26,   27,   28,   29}; //   8
  needed_v_smin[x_a][ 13] = {   9,   10,   11,   12,   13,   16,   28,   29,   30,   31,   32,   37,   42}; //  13
  needed_v_smin[x_a][ 14] = {   9,   10,   28,   29}; //   4
  needed_v_smin[x_a][ 15] = {  11,   30}; //   2
  needed_v_smin[x_a][ 16] = {  12,   13,   31,   32,   42}; //   5
  needed_v_smin[x_a][ 17] = {  14,   15,   35,   36}; //   4
  needed_v_smin[x_a][ 18] = {  16,   37}; //   2
  needed_v_smin[x_a][ 19] = {  17,   18,   33,   34}; //   4
  needed_v_smin[x_a][ 20] = {  38,   39,   40,   41}; //   4

  v_smax[x_a].resize(22);
  needed_v_smax[x_a].resize(22);
  needed_v_smax[x_a][  0] = {   0,    1,    7,    8,   14,   15,   19,   20,   26,   27,   33,   34,   38,   39}; //  14
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   19,   20,   21,   22}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   38,   39,   40,   41,   42}; //  33
  needed_v_smax[x_a][  3] = {   2,    3,    4,   12,   13,   16,   21,   22,   23,   31,   32}; //  11
  needed_v_smax[x_a][  4] = {   4,    6,   23,   25}; //   4
  needed_v_smax[x_a][  5] = {   5,    6,   17,   18,   24,   25,   35,   36,   40,   41}; //  10
  needed_v_smax[x_a][  6] = {   5,   11,   24,   30}; //   4
  needed_v_smax[x_a][  7] = {   7,    8,    9,   10,   26,   27,   28,   29}; //   8
  needed_v_smax[x_a][  8] = {   9,   10,   11,   28,   29,   30,   37,   42}; //   8
  needed_v_smax[x_a][  9] = {  12,   13,   31,   32}; //   4
  needed_v_smax[x_a][ 10] = {  14,   15}; //   2
  needed_v_smax[x_a][ 11] = {  14,   15}; //   2
  needed_v_smax[x_a][ 12] = {  16}; //   1
  needed_v_smax[x_a][ 13] = {  16}; //   1
  needed_v_smax[x_a][ 14] = {  17,   18}; //   2
  needed_v_smax[x_a][ 15] = {  17,   18}; //   2
  needed_v_smax[x_a][ 16] = {  33,   34,   38,   39}; //   4
  needed_v_smax[x_a][ 17] = {  33,   34}; //   2
  needed_v_smax[x_a][ 18] = {  35,   36,   40,   41}; //   4
  needed_v_smax[x_a][ 19] = {  35,   36}; //   2
  needed_v_smax[x_a][ 20] = {  37,   42}; //   2
  needed_v_smax[x_a][ 21] = {  37}; //   1

  g_p[x_a].resize(36);
  needed_g_p[x_a].resize(36);
  needed_g_p[x_a][0] = {   0,    1,    7,    8,   14,   15,   19,   20,   26,   27,   33,   34,   38,   39}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   19,   20}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   19,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   20,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    4,   12,   13,   16,   21,   22,   23,   31,   32}; //  11
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    3,   21,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][6] = {   4,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   4,    6,   23,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][8] = {   5,    6,   18,   24,   25,   36,   41}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax5");
  needed_g_p[x_a][9] = {   5,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   5,   11,   24,   30}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][11] = {   6,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax4");
  needed_g_p[x_a][12] = {   7,    8,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][13] = {   7,    9,   26,   28}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax2");
  needed_g_p[x_a][14] = {   8,   10,   27,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax2");
  needed_g_p[x_a][15] = {   9,   10,   11,   28,   29,   30,   37,   42}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax8");
  needed_g_p[x_a][16] = {   9,   10,   28,   29}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][17] = {  11,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax6");
  needed_g_p[x_a][18] = {  12,   13,   31,   32}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax9");
  needed_g_p[x_a][19] = {  12,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax2");
  needed_g_p[x_a][20] = {  13,   32}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin16_smax2");
  needed_g_p[x_a][21] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax10");
  needed_g_p[x_a][22] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax11");
  needed_g_p[x_a][23] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax11");
  needed_g_p[x_a][24] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax12");
  needed_g_p[x_a][25] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax13");
  needed_g_p[x_a][26] = {  17,   35,   40}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][27] = {  17,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax14");
  needed_g_p[x_a][28] = {  17,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax15");
  needed_g_p[x_a][29] = {  33,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax16");
  needed_g_p[x_a][30] = {  33,   34}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax17");
  needed_g_p[x_a][31] = {  34,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax16");
  needed_g_p[x_a][32] = {  35,   36,   40,   41}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax18");
  needed_g_p[x_a][33] = {  35,   36}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax19");
  needed_g_p[x_a][34] = {  37,   42}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax20");
  needed_g_p[x_a][35] = {  37}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax21");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {  38,   39,   40,   41}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax2");
  needed_g_f[x_a][1] = {  42}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax2");

  g_t[x_a].resize(7);
  needed_g_t[x_a].resize(7);
  needed_g_t[x_a][0] = {  19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   38,   39,   40,   41,   42}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][1] = {  33,   34}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][2] = {  35,   36}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");
  needed_g_t[x_a][3] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__36_88");
  needed_g_t[x_a][4] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][5] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][6] = {  42}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_24");

  g_d[x_a].resize(24);
  needed_g_d[x_a].resize(24);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13}; //  14
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,   19,   20,   21,   22}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1,   19,   20}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][3] = {   0,    1,    7,    8,   14,   15,   17,   18,   19,   20,   26,   27,   33,   34,   35,   36,   38,   39,   40,   41}; //  20
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][4] = {   2,    3,   21,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][5] = {   2,    3,    4,   12,   13,   16,   21,   22,   23,   31,   32,   37,   42}; //  13
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][6] = {   4,    6,   23,   25}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][7] = {   4,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][8] = {   5,   11,   24,   30}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   5,   24}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][10] = {   5,    6,   14,   15,   17,   18,   24,   25,   33,   34,   35,   36,   38,   39,   40,   41}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][11] = {   6,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][12] = {   7,    8,    9,   10,   26,   27,   28,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][13] = {   7,    8,   26,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][14] = {   9,   10,   28,   29}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][15] = {   9,   10,   11,   12,   13,   16,   28,   29,   30,   31,   32,   37,   42}; //  13
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][16] = {  11,   30}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][17] = {  12,   13,   31,   32}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][18] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][19] = {  14,   15,   35,   36}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][20] = {  16}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][21] = {  16,   37}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][22] = {  17,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][23] = {  17,   18,   33,   34}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");

  c_p[x_a].resize(43);
  c_f[x_a].resize(43);
  c_t[x_a].resize(43);
  c_d[x_a].resize(43);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  4,   5,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   1,   4,   5}; //   4

  c_p[x_a][3] = {  4,   5,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   1,   4,   5}; //   4

  c_p[x_a][4] = {  4,   6,   7}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   6,   7,   5}; //   4

  c_p[x_a][5] = {  8,   9,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   8,   9,  10}; //   4

  c_p[x_a][6] = {  8,  11,   7}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   6,  11,  10}; //   4

  c_p[x_a][7] = {  0,  12,  13}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0,  12,  13,   3}; //   4

  c_p[x_a][8] = {  0,  12,  14}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,  12,  13,   3}; //   4

  c_p[x_a][9] = { 15,  16,  13}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,  12,  14,  15}; //   4

  c_p[x_a][10] = { 15,  16,  14}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,  12,  14,  15}; //   4

  c_p[x_a][11] = { 15,  17,  10}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0,   8,  16,  15}; //   4

  c_p[x_a][12] = {  4,  18,  19}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  0,  17,  15,   5}; //   4

  c_p[x_a][13] = {  4,  18,  20}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  0,  17,  15,   5}; //   4

  c_p[x_a][14] = {  0,  21,  22}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 18,  10,  19,   3}; //   4

  c_p[x_a][15] = {  0,  21,  23}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 18,  10,  19,   3}; //   4

  c_p[x_a][16] = {  4,  24,  25}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 20,  15,  21,   5}; //   4

  c_p[x_a][17] = { 26,  27,  28}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 22,   3,  23,  10}; //   4

  c_p[x_a][18] = {  8,  27,  28}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 22,   3,  23,  10}; //   4

  c_p[x_a][19] = {  0,   1,   2}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = {  1,   2,   3}; //   3

  c_p[x_a][20] = {  0,   1,   3}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = {  1,   2,   3}; //   3

  c_p[x_a][21] = {  4,   5,   2}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = {  1,   4,   5}; //   3

  c_p[x_a][22] = {  4,   5,   3}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = {  1,   4,   5}; //   3

  c_p[x_a][23] = {  4,   6,   7}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = {  6,   7,   5}; //   3

  c_p[x_a][24] = {  8,   9,  10}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = {  8,   9,  10}; //   3

  c_p[x_a][25] = {  8,  11,   7}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  6,  11,  10}; //   3

  c_p[x_a][26] = {  0,  12,  13}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = { 12,  13,   3}; //   3

  c_p[x_a][27] = {  0,  12,  14}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = { 12,  13,   3}; //   3

  c_p[x_a][28] = { 15,  16,  13}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  0}; //   1
  c_d[x_a][28] = { 12,  14,  15}; //   3

  c_p[x_a][29] = { 15,  16,  14}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  0}; //   1
  c_d[x_a][29] = { 12,  14,  15}; //   3

  c_p[x_a][30] = { 15,  17,  10}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = {  8,  16,  15}; //   3

  c_p[x_a][31] = {  4,  18,  19}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = { 17,  15,   5}; //   3

  c_p[x_a][32] = {  4,  18,  20}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  0}; //   1
  c_d[x_a][32] = { 17,  15,   5}; //   3

  c_p[x_a][33] = {  0,  29,  30}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  1}; //   1
  c_d[x_a][33] = { 23,  10,   3}; //   3

  c_p[x_a][34] = {  0,  31,  30}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  1}; //   1
  c_d[x_a][34] = { 23,  10,   3}; //   3

  c_p[x_a][35] = { 26,  32,  33}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  2}; //   1
  c_d[x_a][35] = { 19,   3,  10}; //   3

  c_p[x_a][36] = {  8,  32,  33}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  2}; //   1
  c_d[x_a][36] = { 19,   3,  10}; //   3

  c_p[x_a][37] = { 15,  34,  35}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  3}; //   1
  c_d[x_a][37] = { 21,   5,  15}; //   3

  c_p[x_a][38] = {  0,  29}; //   2
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  0,   4}; //   2
  c_d[x_a][38] = { 10,   3}; //   2

  c_p[x_a][39] = {  0,  31}; //   2
  c_f[x_a][39] = {  0}; //   1
  c_t[x_a][39] = {  0,   4}; //   2
  c_d[x_a][39] = { 10,   3}; //   2

  c_p[x_a][40] = { 26,  32}; //   2
  c_f[x_a][40] = {  0}; //   1
  c_t[x_a][40] = {  0,   5}; //   2
  c_d[x_a][40] = {  3,  10}; //   2

  c_p[x_a][41] = {  8,  32}; //   2
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  0,   5}; //   2
  c_d[x_a][41] = {  3,  10}; //   2

  c_p[x_a][42] = { 15,  34}; //   2
  c_f[x_a][42] = {  1}; //   1
  c_t[x_a][42] = {  0,   6}; //   2
  c_d[x_a][42] = {  5,  15}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_140_gd_emepvevexd
//  channel    0: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel    1: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
//  channel    2: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
//  channel    3: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
//  channel    4: 5yyyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   0)
//  channel    5: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   0)
//  channel    6: 5yyyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   0)
//  channel    7: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
//  channel    8: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
//  channel    9: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
//  channel   10: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
//  channel   11: 5yyyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   0)
//  channel   12: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   0)
//  channel   13: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   0)
//  channel   14: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel   15: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   0,  23,   0)
//  channel   16: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,   0,  24,   0)
//  channel   17: 52vyv(1, 2, 16, 32, 64, 4, 8;   0,   0,  23,   0)
//  channel   18: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   0,  23,   0)
//  channel   19: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel   20: 14yyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
//  channel   21: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
//  channel   22: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
//  channel   23: 14yyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   0)
//  channel   24: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   0)
//  channel   25: 14yyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   0)
//  channel   26: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
//  channel   27: 14yyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
//  channel   28: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
//  channel   29: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
//  channel   30: 14yyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   0)
//  channel   31: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   0)
//  channel   32: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   0)
//  channel   33: 3yv2v(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel   34: 3yv2v(1, 2, 64, 4, 8, 16, 32;  23,  23,   0,   0)
//  channel   35: 3yv2v(1, 2, 64, 16, 32, 4, 8;   0,  23,   0,   0)
//  channel   36: 3yv2v(1, 2, 64, 16, 32, 4, 8;  23,  23,   0,   0)
//  channel   37: 3yv2v(1, 2, 64, 8, 16, 4, 32;  24,  24,   0,   0)
//  channel   38: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel   39: 12v2v(1, 2, 64, 4, 8, 16, 32;  23,  23,   0,   0)
//  channel   40: 12v2v(1, 2, 64, 16, 32, 4, 8;   0,  23,   0,   0)
//  channel   41: 12v2v(1, 2, 64, 16, 32, 4, 8;  23,  23,   0,   0)
//  channel   42: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,   0,   0)

void ppeexnenex04_phasespace_set::ax_psp_340_gd_emepvevexd(int x_a){
  static Logger logger("ppeexnenex04_phasespace_set::ax_psp_340_gd_emepvevexd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(20);
  needed_v_smin[x_a].resize(20);
  int needed_v_smin_0[] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   50}; //  31
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 31);
  int needed_v_smin_1[] = {   0,    1}; //   2
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   0,    1,    2,    3}; //   4
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 15);
  int needed_v_smin_4[] = {   2,    3}; //   2
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 2);
  int needed_v_smin_5[] = {   4}; //   1
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 1);
  int needed_v_smin_6[] = {   4,    6}; //   2
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 2);
  int needed_v_smin_7[] = {   5,    6,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   50}; //  29
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 29);
  int needed_v_smin_8[] = {   5}; //   1
  needed_v_smin[x_a][  8] = get_vector_from_array_int(needed_v_smin_8, 1);
  int needed_v_smin_9[] = {   5,   11}; //   2
  needed_v_smin[x_a][  9] = get_vector_from_array_int(needed_v_smin_9, 2);
  int needed_v_smin_10[] = {   6}; //   1
  needed_v_smin[x_a][ 10] = get_vector_from_array_int(needed_v_smin_10, 1);
  int needed_v_smin_11[] = {   7,    8}; //   2
  needed_v_smin[x_a][ 11] = get_vector_from_array_int(needed_v_smin_11, 2);
  int needed_v_smin_12[] = {   7,    8,    9,   10}; //   4
  needed_v_smin[x_a][ 12] = get_vector_from_array_int(needed_v_smin_12, 4);
  int needed_v_smin_13[] = {   9,   10,   11,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  needed_v_smin[x_a][ 13] = get_vector_from_array_int(needed_v_smin_13, 15);
  int needed_v_smin_14[] = {   9,   10}; //   2
  needed_v_smin[x_a][ 14] = get_vector_from_array_int(needed_v_smin_14, 2);
  int needed_v_smin_15[] = {  11}; //   1
  needed_v_smin[x_a][ 15] = get_vector_from_array_int(needed_v_smin_15, 1);
  int needed_v_smin_16[] = {  12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  19
  needed_v_smin[x_a][ 16] = get_vector_from_array_int(needed_v_smin_16, 19);
  int needed_v_smin_17[] = {  19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  12
  needed_v_smin[x_a][ 17] = get_vector_from_array_int(needed_v_smin_17, 12);
  int needed_v_smin_18[] = {  43,   44,   47,   48}; //   4
  needed_v_smin[x_a][ 18] = get_vector_from_array_int(needed_v_smin_18, 4);
  int needed_v_smin_19[] = {  45,   46,   49,   50}; //   4
  needed_v_smin[x_a][ 19] = get_vector_from_array_int(needed_v_smin_19, 4);

  v_smax[x_a].resize(19);
  needed_v_smax[x_a].resize(19);
  int needed_v_smax_0[] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   43,   44,   47,   48}; //  21
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 21);
  int needed_v_smax_1[] = {   0,    1,    2,    3}; //   4
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 4);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42}; //  43
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 43);
  int needed_v_smax_3[] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33}; //  12
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 12);
  int needed_v_smax_4[] = {   4,    6}; //   2
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 2);
  int needed_v_smax_5[] = {   5,    6,   34,   35,   36,   37,   38,   39,   45,   46,   49,   50}; //  12
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 12);
  int needed_v_smax_6[] = {   5,   11}; //   2
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 2);
  int needed_v_smax_7[] = {   7,    8,    9,   10}; //   4
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 4);
  int needed_v_smax_8[] = {   9,   10,   11,   40,   41,   42}; //   6
  needed_v_smax[x_a][  8] = get_vector_from_array_int(needed_v_smax_8, 6);
  int needed_v_smax_9[] = {  12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   47,   48}; //  15
  needed_v_smax[x_a][  9] = get_vector_from_array_int(needed_v_smax_9, 15);
  int needed_v_smax_10[] = {  19,   20,   21,   22,   23,   24,   31,   32,   33}; //   9
  needed_v_smax[x_a][ 10] = get_vector_from_array_int(needed_v_smax_10, 9);
  int needed_v_smax_11[] = {  34,   35,   36,   37,   38,   39,   49,   50}; //   8
  needed_v_smax[x_a][ 11] = get_vector_from_array_int(needed_v_smax_11, 8);
  int needed_v_smax_12[] = {  40,   41,   42}; //   3
  needed_v_smax[x_a][ 12] = get_vector_from_array_int(needed_v_smax_12, 3);
  int needed_v_smax_13[] = {  43,   44}; //   2
  needed_v_smax[x_a][ 13] = get_vector_from_array_int(needed_v_smax_13, 2);
  int needed_v_smax_14[] = {  43,   44}; //   2
  needed_v_smax[x_a][ 14] = get_vector_from_array_int(needed_v_smax_14, 2);
  int needed_v_smax_15[] = {  45,   46}; //   2
  needed_v_smax[x_a][ 15] = get_vector_from_array_int(needed_v_smax_15, 2);
  int needed_v_smax_16[] = {  45,   46}; //   2
  needed_v_smax[x_a][ 16] = get_vector_from_array_int(needed_v_smax_16, 2);
  int needed_v_smax_17[] = {  47,   48}; //   2
  needed_v_smax[x_a][ 17] = get_vector_from_array_int(needed_v_smax_17, 2);
  int needed_v_smax_18[] = {  49,   50}; //   2
  needed_v_smax[x_a][ 18] = get_vector_from_array_int(needed_v_smax_18, 2);

  g_p[x_a].resize(38);
  needed_g_p[x_a].resize(38);
  needed_g_p[x_a][0] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   43,   44,   47,   48}; //  21
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax3");
  needed_g_p[x_a][5] = {   2,    3}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax1");
  needed_g_p[x_a][6] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {   4,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax2");
  needed_g_p[x_a][8] = {   5,    6,   37,   38,   39,   46,   50}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax5");
  needed_g_p[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][10] = {   5,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][11] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax4");
  needed_g_p[x_a][12] = {   7,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax7");
  needed_g_p[x_a][13] = {   7,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax2");
  needed_g_p[x_a][14] = {   8,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin12_smax2");
  needed_g_p[x_a][15] = {   9,   10,   11,   40,   41,   42}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax8");
  needed_g_p[x_a][16] = {   9,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax7");
  needed_g_p[x_a][17] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax6");
  needed_g_p[x_a][18] = {  12,   13,   14,   25,   26,   27,   47}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax9");
  needed_g_p[x_a][19] = {  12,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax2");
  needed_g_p[x_a][20] = {  13,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin16_smax2");
  needed_g_p[x_a][21] = {  14,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin16_smax2");
  needed_g_p[x_a][22] = {  15,   16,   17,   18,   28,   29,   30,   48}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax9");
  needed_g_p[x_a][23] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin16_smax2");
  needed_g_p[x_a][24] = {  19,   20,   21,   22,   23,   24,   31,   32,   33}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin13_smax10");
  needed_g_p[x_a][25] = {  19,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax2");
  needed_g_p[x_a][26] = {  20}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin17_smax2");
  needed_g_p[x_a][27] = {  21}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin17_smax2");
  needed_g_p[x_a][28] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin17_smax2");
  needed_g_p[x_a][29] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin17_smax2");
  needed_g_p[x_a][30] = {  34,   35,   36,   45,   49}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax5");
  needed_g_p[x_a][31] = {  34,   35,   36,   37,   38,   39,   49,   50}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax11");
  needed_g_p[x_a][32] = {  40,   41,   42}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin3_smax12");
  needed_g_p[x_a][33] = {  43,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax13");
  needed_g_p[x_a][34] = {  43}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax14");
  needed_g_p[x_a][35] = {  44}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax14");
  needed_g_p[x_a][36] = {  45,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax15");
  needed_g_p[x_a][37] = {  45,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");

  g_f[x_a].resize(4);
  needed_g_f[x_a].resize(4);
  needed_g_f[x_a][0] = {  25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax2");
  needed_g_f[x_a][1] = {  31,   32,   33,   40,   41,   42}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax2");
  needed_g_f[x_a][2] = {  47,   48}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax17");
  needed_g_f[x_a][3] = {  49,   50}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax18");

  g_t[x_a].resize(17);
  needed_g_t[x_a].resize(17);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42}; //  43
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  25,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {  26,   29}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_66__12_48");
  needed_g_t[x_a][3] = {  27,   30}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__12_48");
  needed_g_t[x_a][4] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__36_24");
  needed_g_t[x_a][5] = {  32}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__36_24");
  needed_g_t[x_a][6] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_66__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_66__36_24");
  needed_g_t[x_a][7] = {  34,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][8] = {  35,   38}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_66__48_12");
  needed_g_t[x_a][9] = {  36,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__48_12");
  needed_g_t[x_a][10] = {  40}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__24_36");
  needed_g_t[x_a][11] = {  41}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_66__24_36");
  needed_g_t[x_a][12] = {  42}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_66__24_36");
  needed_g_t[x_a][13] = {  43,   44,   47,   48}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][14] = {  45,   46,   49,   50}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][15] = {  47,   48}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_64");
  needed_g_t[x_a][16] = {  49,   50}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");

  g_d[x_a].resize(20);
  needed_g_d[x_a].resize(20);
  needed_g_d[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][2] = {   0,    1,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   50}; //  31
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][3] = {   2,    3}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][4] = {   2,    3,    4,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][5] = {   4,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][6] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][7] = {   5,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {   5,    6,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   50}; //  29
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][10] = {   6}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][11] = {   7,    8,    9,   10}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][12] = {   7,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][13] = {   9,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][14] = {   9,   10,   11,   19,   20,   21,   22,   23,   24,   31,   32,   33,   40,   41,   42}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][15] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][16] = {  12,   13,   14,   15,   16,   17,   18}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][17] = {  19,   20,   21,   22,   23,   24}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][18] = {  43,   44}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][19] = {  45,   46}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");

  c_p[x_a].resize(51);
  c_f[x_a].resize(51);
  c_t[x_a].resize(51);
  c_d[x_a].resize(51);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  4,   5,   2}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   3,   4}; //   3

  c_p[x_a][3] = {  4,   5,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   3,   4}; //   3

  c_p[x_a][4] = {  4,   6,   7}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  5,   6,   4}; //   3

  c_p[x_a][5] = {  8,   9,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  7,   8,   9}; //   3

  c_p[x_a][6] = {  8,  11,   7}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  5,  10,   9}; //   3

  c_p[x_a][7] = {  0,  12,  13}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 11,  12,   2}; //   3

  c_p[x_a][8] = {  0,  12,  14}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 11,  12,   2}; //   3

  c_p[x_a][9] = { 15,  16,  13}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 11,  13,  14}; //   3

  c_p[x_a][10] = { 15,  16,  14}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 11,  13,  14}; //   3

  c_p[x_a][11] = { 15,  17,  10}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  7,  15,  14}; //   3

  c_p[x_a][12] = {  0,  18,  19}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 16,   9,   2}; //   3

  c_p[x_a][13] = {  0,  18,  20}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 16,   9,   2}; //   3

  c_p[x_a][14] = {  0,  18,  21}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 16,   9,   2}; //   3

  c_p[x_a][15] = {  0,  22,  23}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 16,   9,   2}; //   3

  c_p[x_a][16] = {  0,  22,  19}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 16,   9,   2}; //   3

  c_p[x_a][17] = {  0,  22,  20}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 16,   9,   2}; //   3

  c_p[x_a][18] = {  0,  22,  21}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 16,   9,   2}; //   3

  c_p[x_a][19] = {  4,  24,  25}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 17,  14,   4}; //   3

  c_p[x_a][20] = {  4,  24,  26}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  0}; //   1
  c_d[x_a][20] = { 17,  14,   4}; //   3

  c_p[x_a][21] = {  4,  24,  27}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = { 17,  14,   4}; //   3

  c_p[x_a][22] = {  4,  24,  25}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  0}; //   1
  c_d[x_a][22] = { 17,  14,   4}; //   3

  c_p[x_a][23] = {  4,  24,  28}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = { 17,  14,   4}; //   3

  c_p[x_a][24] = {  4,  24,  29}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = { 17,  14,   4}; //   3

  c_p[x_a][25] = {  0,  18}; //   2
  c_f[x_a][25] = {  0}; //   1
  c_t[x_a][25] = {  0,   1}; //   2
  c_d[x_a][25] = {  9,   2}; //   2

  c_p[x_a][26] = {  0,  18}; //   2
  c_f[x_a][26] = {  0}; //   1
  c_t[x_a][26] = {  0,   2}; //   2
  c_d[x_a][26] = {  9,   2}; //   2

  c_p[x_a][27] = {  0,  18}; //   2
  c_f[x_a][27] = {  0}; //   1
  c_t[x_a][27] = {  0,   3}; //   2
  c_d[x_a][27] = {  9,   2}; //   2

  c_p[x_a][28] = {  0,  22}; //   2
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  0,   1}; //   2
  c_d[x_a][28] = {  9,   2}; //   2

  c_p[x_a][29] = {  0,  22}; //   2
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  0,   2}; //   2
  c_d[x_a][29] = {  9,   2}; //   2

  c_p[x_a][30] = {  0,  22}; //   2
  c_f[x_a][30] = {  0}; //   1
  c_t[x_a][30] = {  0,   3}; //   2
  c_d[x_a][30] = {  9,   2}; //   2

  c_p[x_a][31] = {  4,  24}; //   2
  c_f[x_a][31] = {  1}; //   1
  c_t[x_a][31] = {  0,   4}; //   2
  c_d[x_a][31] = { 14,   4}; //   2

  c_p[x_a][32] = {  4,  24}; //   2
  c_f[x_a][32] = {  1}; //   1
  c_t[x_a][32] = {  0,   5}; //   2
  c_d[x_a][32] = { 14,   4}; //   2

  c_p[x_a][33] = {  4,  24}; //   2
  c_f[x_a][33] = {  1}; //   1
  c_t[x_a][33] = {  0,   6}; //   2
  c_d[x_a][33] = { 14,   4}; //   2

  c_p[x_a][34] = { 30,  31}; //   2
  c_f[x_a][34] = {  0}; //   1
  c_t[x_a][34] = {  0,   7}; //   2
  c_d[x_a][34] = {  2,   9}; //   2

  c_p[x_a][35] = { 30,  31}; //   2
  c_f[x_a][35] = {  0}; //   1
  c_t[x_a][35] = {  0,   8}; //   2
  c_d[x_a][35] = {  2,   9}; //   2

  c_p[x_a][36] = { 30,  31}; //   2
  c_f[x_a][36] = {  0}; //   1
  c_t[x_a][36] = {  0,   9}; //   2
  c_d[x_a][36] = {  2,   9}; //   2

  c_p[x_a][37] = {  8,  31}; //   2
  c_f[x_a][37] = {  0}; //   1
  c_t[x_a][37] = {  0,   7}; //   2
  c_d[x_a][37] = {  2,   9}; //   2

  c_p[x_a][38] = {  8,  31}; //   2
  c_f[x_a][38] = {  0}; //   1
  c_t[x_a][38] = {  0,   8}; //   2
  c_d[x_a][38] = {  2,   9}; //   2

  c_p[x_a][39] = {  8,  31}; //   2
  c_f[x_a][39] = {  0}; //   1
  c_t[x_a][39] = {  0,   9}; //   2
  c_d[x_a][39] = {  2,   9}; //   2

  c_p[x_a][40] = { 15,  32}; //   2
  c_f[x_a][40] = {  1}; //   1
  c_t[x_a][40] = {  0,  10}; //   2
  c_d[x_a][40] = {  4,  14}; //   2

  c_p[x_a][41] = { 15,  32}; //   2
  c_f[x_a][41] = {  1}; //   1
  c_t[x_a][41] = {  0,  11}; //   2
  c_d[x_a][41] = {  4,  14}; //   2

  c_p[x_a][42] = { 15,  32}; //   2
  c_f[x_a][42] = {  1}; //   1
  c_t[x_a][42] = {  0,  12}; //   2
  c_d[x_a][42] = {  4,  14}; //   2

  c_p[x_a][43] = {  0,  33,  34}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = { 13}; //   1
  c_d[x_a][43] = {  9,  18,   2}; //   3

  c_p[x_a][44] = {  0,  33,  35}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = { 13}; //   1
  c_d[x_a][44] = {  9,  18,   2}; //   3

  c_p[x_a][45] = { 30,  36,  37}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = { 14}; //   1
  c_d[x_a][45] = {  2,  19,   9}; //   3

  c_p[x_a][46] = {  8,  36,  37}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 14}; //   1
  c_d[x_a][46] = {  2,  19,   9}; //   3

  c_p[x_a][47] = {  0,  18}; //   2
  c_f[x_a][47] = {  2}; //   1
  c_t[x_a][47] = { 13,  15}; //   2
  c_d[x_a][47] = {  9,   2}; //   2

  c_p[x_a][48] = {  0,  22}; //   2
  c_f[x_a][48] = {  2}; //   1
  c_t[x_a][48] = { 13,  15}; //   2
  c_d[x_a][48] = {  9,   2}; //   2

  c_p[x_a][49] = { 30,  31}; //   2
  c_f[x_a][49] = {  3}; //   1
  c_t[x_a][49] = { 14,  16}; //   2
  c_d[x_a][49] = {  2,   9}; //   2

  c_p[x_a][50] = {  8,  31}; //   2
  c_f[x_a][50] = {  3}; //   1
  c_t[x_a][50] = { 14,  16}; //   2
  c_d[x_a][50] = {  2,   9}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_140_gd_emepvevexd
//  channel    0: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel    1: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  23,   0)
//  channel    2: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,   0,   0)
//  channel    3: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,  23,   0)
//  channel    4: 4yyv1(1, 2, 32, 4, 8, 16, 64;  24,   0,  23,   0)
//  channel    5: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  23,   0)
//  channel    6: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  23,   0)
//  channel    7: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,   0,   0)
//  channel    8: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,  23,   0)
//  channel    9: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   0)
//  channel   10: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  23,   0)
//  channel   11: 4yyv1(1, 2, 16, 8, 4, 32, 64;  24,   0,  23,   0)
//  channel   12: 42vv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel   13: 42vv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  35,   0)
//  channel   14: 42vv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  36,   0)
//  channel   15: 42vv1(1, 2, 4, 8, 16, 32, 64;  23,  23,  25,   0)
//  channel   16: 42vv1(1, 2, 4, 8, 16, 32, 64;  23,  23,   0,   0)
//  channel   17: 42vv1(1, 2, 4, 8, 16, 32, 64;  23,  23,  35,   0)
//  channel   18: 42vv1(1, 2, 4, 8, 16, 32, 64;  23,  23,  36,   0)
//  channel   19: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   0)
//  channel   20: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  23,   0)
//  channel   21: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  25,   0)
//  channel   22: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   0)
//  channel   23: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  35,   0)
//  channel   24: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  36,   0)
//  channel   25: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel   26: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,  35)
//  channel   27: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,  36)
//  channel   28: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   0,   0)
//  channel   29: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   0,  35)
//  channel   30: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   0,  36)
//  channel   31: 2v2v1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   0)
//  channel   32: 2v2v1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,  36)
//  channel   33: 2v2v1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,  35)
//  channel   34: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,   0)
//  channel   35: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,  35)
//  channel   36: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,  36)
//  channel   37: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   0,   0)
//  channel   38: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   0,  35)
//  channel   39: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   0,  36)
//  channel   40: 2v2v1(1, 2, 8, 16, 4, 32, 64;  24,  24,   0,   0)
//  channel   41: 2v2v1(1, 2, 8, 16, 4, 32, 64;  24,  24,   0,  35)
//  channel   42: 2v2v1(1, 2, 8, 16, 4, 32, 64;  24,  24,   0,  36)
//  channel   43: 2v3yv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel   44: 2v3yv(1, 2, 4, 8, 64, 16, 32;  23,   0,  23,   0)
//  channel   45: 2v3yv(1, 2, 16, 32, 64, 4, 8;   0,   0,  23,   0)
//  channel   46: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   0,  23,   0)
//  channel   47: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel   48: 2v12v(1, 2, 4, 8, 64, 16, 32;  23,  23,   0,   0)
//  channel   49: 2v12v(1, 2, 16, 32, 64, 4, 8;   0,  23,   0,   0)
//  channel   50: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,  23,   0,   0)
