#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ac_psp_240_uux_emepvmvmxssx(int x_a, int channel){
  static Logger logger("ppeexnmnmx04_phasespace_set::ac_psp_240_uux_emepvmvmxssx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  for (int i_p = 0; i_p < c_p[x_a][channel].size(); i_p++){
    if (c_p[x_a][channel][i_p] ==   0){
      v_smin[x_a][  0] = smin_opt[x_a][48];
      v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][204], 2);
      c_propagator(x_a,  23,  48, v_smin[x_a][  0], v_smax[x_a][  0], random_manager.get_random(x_a, 0, 0));
    }
    else if (c_p[x_a][channel][i_p] ==   1){
      v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][196], 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  1], v_smax[x_a][  1], random_manager.get_random(x_a, 0, 1));
    }
    else if (c_p[x_a][channel][i_p] ==   2){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][192], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 2));
    }
    else if (c_p[x_a][channel][i_p] ==   3){
      v_smin[x_a][  3] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][60], 2), smin_opt[x_a][188]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0, 188, v_smin[x_a][  3], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 3));
    }
    else if (c_p[x_a][channel][i_p] ==   4){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][192], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  2], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 4));
    }
    else if (c_p[x_a][channel][i_p] ==   5){
      v_smin[x_a][  4] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][60], 2), smin_opt[x_a][124]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][128], 2);
      c_propagator(x_a,   0, 124, v_smin[x_a][  4], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 5));
    }
    else if (c_p[x_a][channel][i_p] ==   6){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][240], 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  5], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 6));
    }
    else if (c_p[x_a][channel][i_p] ==   7){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][  6] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][208], 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  6], v_smax[x_a][  6], random_manager.get_random(x_a, 0, 7));
    }
    else if (c_p[x_a][channel][i_p] ==   8){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][192], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  7], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 8));
    }
    else if (c_p[x_a][channel][i_p] ==   9){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][  7] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][224], 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  8], v_smax[x_a][  7], random_manager.get_random(x_a, 0, 9));
    }
    else if (c_p[x_a][channel][i_p] ==  10){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][28], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][192], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  9], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 10));
    }
    else if (c_p[x_a][channel][i_p] ==  11){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][  8] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][200], 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][ 10], v_smax[x_a][  8], random_manager.get_random(x_a, 0, 11));
    }
    else if (c_p[x_a][channel][i_p] ==  12){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][192], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 11], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 12));
    }
    else if (c_p[x_a][channel][i_p] ==  13){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][192], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][ 11], v_smax[x_a][  2], random_manager.get_random(x_a, 0, 13));
    }
    else if (c_p[x_a][channel][i_p] ==  14){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][  9] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][140], 2);
      c_propagator(x_a,   0, 112, v_smin[x_a][ 12], v_smax[x_a][  9], random_manager.get_random(x_a, 0, 14));
    }
    else if (c_p[x_a][channel][i_p] ==  15){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][112], sqrtsmin_opt[x_a][240]), 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  5], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 15));
    }
    else if (c_p[x_a][channel][i_p] ==  16){
      v_smin[x_a][ 13] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][112], 2), smin_opt[x_a][124]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][128], 2);
      c_propagator(x_a,   0, 124, v_smin[x_a][ 13], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 16));
    }
    else if (c_p[x_a][channel][i_p] ==  17){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 10] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][112], sqrtsmin_opt[x_a][240]), 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  5], v_smax[x_a][ 10], random_manager.get_random(x_a, 0, 17));
    }
    else if (c_p[x_a][channel][i_p] ==  18){
      v_smin[x_a][ 14] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][176]);
      v_smax[x_a][ 11] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][76], 2);
      c_propagator(x_a,   0, 176, v_smin[x_a][ 14], v_smax[x_a][ 11], random_manager.get_random(x_a, 0, 18));
    }
    else if (c_p[x_a][channel][i_p] ==  19){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][176], sqrtsmin_opt[x_a][240]), 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  5], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 19));
    }
    else if (c_p[x_a][channel][i_p] ==  20){
      v_smin[x_a][ 15] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][176], 2), smin_opt[x_a][188]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0, 188, v_smin[x_a][ 15], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 20));
    }
    else if (c_p[x_a][channel][i_p] ==  21){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 12] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][176], sqrtsmin_opt[x_a][240]), 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  5], v_smax[x_a][ 12], random_manager.get_random(x_a, 0, 21));
    }
    else if (c_p[x_a][channel][i_p] ==  22){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][  5] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][240], 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  5], v_smax[x_a][  5], random_manager.get_random(x_a, 0, 22));
    }
    else if (c_p[x_a][channel][i_p] ==  23){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 13] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][176], 2);
      c_propagator(x_a,   0,  76, v_smin[x_a][ 16], v_smax[x_a][ 13], random_manager.get_random(x_a, 0, 23));
    }
    else if (c_p[x_a][channel][i_p] ==  24){
      v_smin[x_a][  0] = smin_opt[x_a][48];
      v_smax[x_a][ 14] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][76], sqrtsmin_opt[x_a][204]), 2);
      c_propagator(x_a,  23,  48, v_smin[x_a][  0], v_smax[x_a][ 14], random_manager.get_random(x_a, 0, 24));
    }
    else if (c_p[x_a][channel][i_p] ==  25){
      v_smin[x_a][ 17] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][48] + xbsqrts_all[x_a][76], 2), smin_opt[x_a][124]);
      v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][128], 2);
      c_propagator(x_a,   0, 124, v_smin[x_a][ 17], v_smax[x_a][  4], random_manager.get_random(x_a, 0, 25));
    }
    else if (c_p[x_a][channel][i_p] ==  26){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][140]);
      v_smax[x_a][ 15] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][112], 2);
      c_propagator(x_a,   0, 140, v_smin[x_a][ 18], v_smax[x_a][ 15], random_manager.get_random(x_a, 0, 26));
    }
    else if (c_p[x_a][channel][i_p] ==  27){
      v_smin[x_a][  0] = smin_opt[x_a][48];
      v_smax[x_a][ 16] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][140], sqrtsmin_opt[x_a][204]), 2);
      c_propagator(x_a,  23,  48, v_smin[x_a][  0], v_smax[x_a][ 16], random_manager.get_random(x_a, 0, 27));
    }
    else if (c_p[x_a][channel][i_p] ==  28){
      v_smin[x_a][ 19] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][48] + xbsqrts_all[x_a][140], 2), smin_opt[x_a][188]);
      v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][64], 2);
      c_propagator(x_a,   0, 188, v_smin[x_a][ 19], v_smax[x_a][  3], random_manager.get_random(x_a, 0, 28));
    }
    else if (c_p[x_a][channel][i_p] ==  29){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][192] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][240]), 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  5], v_smax[x_a][ 17], random_manager.get_random(x_a, 0, 29));
    }
    else if (c_p[x_a][channel][i_p] ==  30){
      v_smin[x_a][ 14] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][176]);
      v_smax[x_a][ 18] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], sqrtsmin_opt[x_a][76]), 2);
      c_propagator(x_a,   0, 176, v_smin[x_a][ 14], v_smax[x_a][ 18], random_manager.get_random(x_a, 0, 30));
    }
    else if (c_p[x_a][channel][i_p] ==  31){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 19] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][176], 2);
      c_propagator(x_a,   0,  76, v_smin[x_a][ 16], v_smax[x_a][ 19], random_manager.get_random(x_a, 0, 31));
    }
    else if (c_p[x_a][channel][i_p] ==  32){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 17] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][192] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][240]), 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  5], v_smax[x_a][ 17], random_manager.get_random(x_a, 0, 32));
    }
    else if (c_p[x_a][channel][i_p] ==  33){
      v_smin[x_a][  0] = smin_opt[x_a][48];
      v_smax[x_a][ 20] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][192] + xbsqrts_all[x_a][12], sqrtsmin_opt[x_a][204]), 2);
      c_propagator(x_a,  23,  48, v_smin[x_a][  0], v_smax[x_a][ 20], random_manager.get_random(x_a, 0, 33));
    }
    else if (c_p[x_a][channel][i_p] ==  34){
      v_smin[x_a][ 18] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][140]);
      v_smax[x_a][ 21] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][112]), 2);
      c_propagator(x_a,   0, 140, v_smin[x_a][ 18], v_smax[x_a][ 21], random_manager.get_random(x_a, 0, 34));
    }
    else if (c_p[x_a][channel][i_p] ==  35){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 22] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][140], 2);
      c_propagator(x_a,   0, 112, v_smin[x_a][ 12], v_smax[x_a][ 22], random_manager.get_random(x_a, 0, 35));
    }
    else if (c_p[x_a][channel][i_p] ==  36){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][176], 2), smin_opt[x_a][240]);
      v_smax[x_a][ 23] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_propagator(x_a,   0, 240, v_smin[x_a][ 20], v_smax[x_a][ 23], random_manager.get_random(x_a, 0, 36));
    }
    else if (c_p[x_a][channel][i_p] ==  37){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 24] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][240], 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  5], v_smax[x_a][ 24], random_manager.get_random(x_a, 0, 37));
    }
    else if (c_p[x_a][channel][i_p] ==  38){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 24] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][240], 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  5], v_smax[x_a][ 24], random_manager.get_random(x_a, 0, 38));
    }
    else if (c_p[x_a][channel][i_p] ==  39){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][112], 2), smin_opt[x_a][240]);
      v_smax[x_a][ 23] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2);
      c_propagator(x_a,   0, 240, v_smin[x_a][ 21], v_smax[x_a][ 23], random_manager.get_random(x_a, 0, 39));
    }
    else if (c_p[x_a][channel][i_p] ==  40){
      v_smin[x_a][ 22] = smin_opt[x_a][192];
      v_smax[x_a][ 25] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][60], 2);
      c_propagator(x_a,   0, 192, v_smin[x_a][ 22], v_smax[x_a][ 25], random_manager.get_random(x_a, 0, 40));
    }
    else if (c_p[x_a][channel][i_p] ==  41){
      v_smin[x_a][ 23] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][140], 2), smin_opt[x_a][204]);
      v_smax[x_a][ 26] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,   0, 204, v_smin[x_a][ 23], v_smax[x_a][ 26], random_manager.get_random(x_a, 0, 41));
    }
    else if (c_p[x_a][channel][i_p] ==  42){
      v_smin[x_a][  0] = smin_opt[x_a][48];
      v_smax[x_a][ 27] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][204], 2);
      c_propagator(x_a,  23,  48, v_smin[x_a][  0], v_smax[x_a][ 27], random_manager.get_random(x_a, 0, 42));
    }
    else if (c_p[x_a][channel][i_p] ==  43){
      v_smin[x_a][ 24] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][76], 2), smin_opt[x_a][204]);
      v_smax[x_a][ 26] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2);
      c_propagator(x_a,   0, 204, v_smin[x_a][ 24], v_smax[x_a][ 26], random_manager.get_random(x_a, 0, 43));
    }
    else if (c_p[x_a][channel][i_p] ==  44){
      v_smin[x_a][ 22] = smin_opt[x_a][192];
      v_smax[x_a][ 28] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][60], 2);
      c_propagator(x_a,   0, 192, v_smin[x_a][ 22], v_smax[x_a][ 28], random_manager.get_random(x_a, 0, 44));
    }
    else if (c_p[x_a][channel][i_p] ==  45){
      v_smin[x_a][  0] = smin_opt[x_a][48];
      v_smax[x_a][ 29] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][12] + xbsqrts_all[x_a][192], sqrtsmin_opt[x_a][204]), 2);
      c_propagator(x_a,  23,  48, v_smin[x_a][  0], v_smax[x_a][ 29], random_manager.get_random(x_a, 0, 45));
    }
    else if (c_p[x_a][channel][i_p] ==  46){
      v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][56]);
      v_smax[x_a][ 30] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][192], sqrtsmin_opt[x_a][196]), 2);
      c_propagator(x_a,   0,  56, v_smin[x_a][  1], v_smax[x_a][ 30], random_manager.get_random(x_a, 0, 46));
    }
    else if (c_p[x_a][channel][i_p] ==  47){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][ 31] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][192], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][  2], v_smax[x_a][ 31], random_manager.get_random(x_a, 0, 47));
    }
    else if (c_p[x_a][channel][i_p] ==  48){
      v_smin[x_a][  2] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][56], 2), smin_opt[x_a][60]);
      v_smax[x_a][ 31] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][192], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  2], v_smax[x_a][ 31], random_manager.get_random(x_a, 0, 48));
    }
    else if (c_p[x_a][channel][i_p] ==  49){
      v_smin[x_a][ 23] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][140], 2), smin_opt[x_a][204]);
      v_smax[x_a][ 32] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_propagator(x_a,   0, 204, v_smin[x_a][ 23], v_smax[x_a][ 32], random_manager.get_random(x_a, 0, 49));
    }
    else if (c_p[x_a][channel][i_p] ==  50){
      v_smin[x_a][ 16] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][76]);
      v_smax[x_a][ 33] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][176]), 2);
      c_propagator(x_a,   0,  76, v_smin[x_a][ 16], v_smax[x_a][ 33], random_manager.get_random(x_a, 0, 50));
    }
    else if (c_p[x_a][channel][i_p] ==  51){
      v_smin[x_a][ 24] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][76], 2), smin_opt[x_a][204]);
      v_smax[x_a][ 32] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_propagator(x_a,   0, 204, v_smin[x_a][ 24], v_smax[x_a][ 32], random_manager.get_random(x_a, 0, 51));
    }
    else if (c_p[x_a][channel][i_p] ==  52){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 34] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][48] + xbsqrts_all[x_a][192], sqrtsmin_opt[x_a][240]), 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  5], v_smax[x_a][ 34], random_manager.get_random(x_a, 0, 52));
    }
    else if (c_p[x_a][channel][i_p] ==  53){
      v_smin[x_a][  6] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][44]);
      v_smax[x_a][ 35] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][192], sqrtsmin_opt[x_a][208]), 2);
      c_propagator(x_a,   0,  44, v_smin[x_a][  6], v_smax[x_a][ 35], random_manager.get_random(x_a, 0, 53));
    }
    else if (c_p[x_a][channel][i_p] ==  54){
      v_smin[x_a][  7] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][44], 2), smin_opt[x_a][60]);
      v_smax[x_a][ 31] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][192], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  7], v_smax[x_a][ 31], random_manager.get_random(x_a, 0, 54));
    }
    else if (c_p[x_a][channel][i_p] ==  55){
      v_smin[x_a][ 20] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][176], 2), smin_opt[x_a][240]);
      v_smax[x_a][ 36] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2);
      c_propagator(x_a,   0, 240, v_smin[x_a][ 20], v_smax[x_a][ 36], random_manager.get_random(x_a, 0, 55));
    }
    else if (c_p[x_a][channel][i_p] ==  56){
      v_smin[x_a][ 12] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][64] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][112]);
      v_smax[x_a][ 37] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][12], sqrtsmin_opt[x_a][140]), 2);
      c_propagator(x_a,   0, 112, v_smin[x_a][ 12], v_smax[x_a][ 37], random_manager.get_random(x_a, 0, 56));
    }
    else if (c_p[x_a][channel][i_p] ==  57){
      v_smin[x_a][ 21] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][128] + xbsqrts_all[x_a][112], 2), smin_opt[x_a][240]);
      v_smax[x_a][ 36] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2);
      c_propagator(x_a,   0, 240, v_smin[x_a][ 21], v_smax[x_a][ 36], random_manager.get_random(x_a, 0, 57));
    }
    else if (c_p[x_a][channel][i_p] ==  58){
      v_smin[x_a][  8] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]);
      v_smax[x_a][ 38] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][192], sqrtsmin_opt[x_a][224]), 2);
      c_propagator(x_a,   0,  28, v_smin[x_a][  8], v_smax[x_a][ 38], random_manager.get_random(x_a, 0, 58));
    }
    else if (c_p[x_a][channel][i_p] ==  59){
      v_smin[x_a][  9] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][32] + xbsqrts_all[x_a][28], 2), smin_opt[x_a][60]);
      v_smax[x_a][ 31] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][192], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][  9], v_smax[x_a][ 31], random_manager.get_random(x_a, 0, 59));
    }
    else if (c_p[x_a][channel][i_p] ==  60){
      v_smin[x_a][ 10] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][4] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][52]);
      v_smax[x_a][ 39] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][192], sqrtsmin_opt[x_a][200]), 2);
      c_propagator(x_a,   0,  52, v_smin[x_a][ 10], v_smax[x_a][ 39], random_manager.get_random(x_a, 0, 60));
    }
    else if (c_p[x_a][channel][i_p] ==  61){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][ 31] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][192], 2);
      c_propagator(x_a,   0,  60, v_smin[x_a][ 11], v_smax[x_a][ 31], random_manager.get_random(x_a, 0, 61));
    }
    else if (c_p[x_a][channel][i_p] ==  62){
      v_smin[x_a][ 11] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][8] + xbsqrts_all[x_a][52], 2), smin_opt[x_a][60]);
      v_smax[x_a][ 31] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][192], 2);
      c_propagator(x_a,  23,  60, v_smin[x_a][ 11], v_smax[x_a][ 31], random_manager.get_random(x_a, 0, 62));
    }
    else if (c_p[x_a][channel][i_p] ==  63){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 40] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(xbsqrts_all[x_a][48] + xbsqrts_all[x_a][192], sqrtsmin_opt[x_a][240]), 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  5], v_smax[x_a][ 40], random_manager.get_random(x_a, 0, 63));
    }
    else if (c_p[x_a][channel][i_p] ==  64){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 40] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(xbsqrts_all[x_a][48] + xbsqrts_all[x_a][192], sqrtsmin_opt[x_a][240]), 2);
      c_propagator(x_a,  23,  12, v_smin[x_a][  5], v_smax[x_a][ 40], random_manager.get_random(x_a, 0, 64));
    }
    else if (c_p[x_a][channel][i_p] ==  65){
      v_smin[x_a][ 22] = smin_opt[x_a][192];
      v_smax[x_a][ 41] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][12] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][60]), 2);
      c_propagator(x_a,   0, 192, v_smin[x_a][ 22], v_smax[x_a][ 41], random_manager.get_random(x_a, 0, 65));
    }
    else if (c_p[x_a][channel][i_p] ==  66){
      v_smin[x_a][ 22] = smin_opt[x_a][192];
      v_smax[x_a][ 42] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][48], sqrtsmin_opt[x_a][60]), 2);
      c_propagator(x_a,   0, 192, v_smin[x_a][ 22], v_smax[x_a][ 42], random_manager.get_random(x_a, 0, 66));
    }
    else if (c_p[x_a][channel][i_p] ==  67){
      v_smin[x_a][  5] = smin_opt[x_a][12];
      v_smax[x_a][ 34] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][48] + xbsqrts_all[x_a][192], sqrtsmin_opt[x_a][240]), 2);
      c_propagator(x_a,   0,  12, v_smin[x_a][  5], v_smax[x_a][ 34], random_manager.get_random(x_a, 0, 67));
    }
    else if (c_p[x_a][channel][i_p] ==  68){
      v_smin[x_a][  0] = smin_opt[x_a][48];
      v_smax[x_a][ 43] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][192], sqrtsmin_opt[x_a][204]), 2);
      c_propagator(x_a,  23,  48, v_smin[x_a][  0], v_smax[x_a][ 43], random_manager.get_random(x_a, 0, 68));
    }
    else if (c_p[x_a][channel][i_p] ==  69){
      v_smin[x_a][ 22] = smin_opt[x_a][192];
      v_smax[x_a][ 44] = pow(xbsqrts_all[x_a][0] - GSL_MAX_DBL(sqrtsmin_opt[x_a][48] + xbsqrts_all[x_a][12], sqrtsmin_opt[x_a][60]), 2);
      c_propagator(x_a,   0, 192, v_smin[x_a][ 22], v_smax[x_a][ 44], random_manager.get_random(x_a, 0, 69));
    }
  }

  for (int i_f = 0; i_f < c_f[x_a][channel].size(); i_f++){
    if (c_f[x_a][channel][i_f] ==   0){
      v_smin[x_a][ 25] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][48] + xbsqrts_all[x_a][192], 2), smin_opt[x_a][240]);
      v_smax[x_a][ 36] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2);
      c_timelikeinvariant(x_a, 240, v_smin[x_a][ 25], v_smax[x_a][ 36], random_manager.get_random(x_a, 1, 0));
    }
    else if (c_f[x_a][channel][i_f] ==   1){
      v_smin[x_a][ 26] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][48], 2), smin_opt[x_a][60]);
      v_smax[x_a][ 31] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][192], 2);
      c_timelikeinvariant(x_a,  60, v_smin[x_a][ 26], v_smax[x_a][ 31], random_manager.get_random(x_a, 1, 1));
    }
    else if (c_f[x_a][channel][i_f] ==   2){
      v_smin[x_a][ 27] = GSL_MAX_DBL(pow(xbsqrts_all[x_a][12] + xbsqrts_all[x_a][192], 2), smin_opt[x_a][204]);
      v_smax[x_a][ 32] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2);
      c_timelikeinvariant(x_a, 204, v_smin[x_a][ 27], v_smax[x_a][ 32], random_manager.get_random(x_a, 1, 2));
    }
  }

  for (int i_t = 0; i_t < c_t[x_a][channel].size(); i_t++){
    if      (c_t[x_a][channel][i_t] ==   0){
      c_tchannel_opt(x_a,   0, 252,   1,   2,  12, 240, random_manager.get_random(x_a, 2, 0), random_manager.get_random(x_a, 3, 0));
    }
    else if (c_t[x_a][channel][i_t] ==   1){
      c_tchannel_opt(x_a,   0, 252,   1,   2, 192,  60, random_manager.get_random(x_a, 2, 1), random_manager.get_random(x_a, 3, 1));
    }
    else if (c_t[x_a][channel][i_t] ==   2){
      c_tchannel_opt(x_a,   0, 252,   1,   2,  48, 204, random_manager.get_random(x_a, 2, 2), random_manager.get_random(x_a, 3, 2));
    }
    else if (c_t[x_a][channel][i_t] ==   3){
      c_tchannel_opt(x_a,   0, 252,   2,   1, 192,  60, random_manager.get_random(x_a, 2, 3), random_manager.get_random(x_a, 3, 3));
    }
    else if (c_t[x_a][channel][i_t] ==   4){
      c_tchannel_opt(x_a,   0, 252,   2,   1,  48, 204, random_manager.get_random(x_a, 2, 4), random_manager.get_random(x_a, 3, 4));
    }
    else if (c_t[x_a][channel][i_t] ==   5){
      c_tchannel_opt(x_a,   0, 252,   2,   1,  12, 240, random_manager.get_random(x_a, 2, 5), random_manager.get_random(x_a, 3, 5));
    }
    else if (c_t[x_a][channel][i_t] ==   6){
      c_tchannel_opt(x_a,   0, 240,   2,  13, 192,  48, random_manager.get_random(x_a, 2, 6), random_manager.get_random(x_a, 3, 6));
    }
    else if (c_t[x_a][channel][i_t] ==   7){
      c_tchannel_opt(x_a,   0, 240,   2,  13,  48, 192, random_manager.get_random(x_a, 2, 7), random_manager.get_random(x_a, 3, 7));
    }
    else if (c_t[x_a][channel][i_t] ==   8){
      c_tchannel_opt(x_a,   0,  60,   2, 193,  48,  12, random_manager.get_random(x_a, 2, 8), random_manager.get_random(x_a, 3, 8));
    }
    else if (c_t[x_a][channel][i_t] ==   9){
      c_tchannel_opt(x_a,   0, 204,   2,  49, 192,  12, random_manager.get_random(x_a, 2, 9), random_manager.get_random(x_a, 3, 9));
    }
    else if (c_t[x_a][channel][i_t] ==  10){
      c_tchannel_opt(x_a,   0, 204,   2,  49,  12, 192, random_manager.get_random(x_a, 2, 10), random_manager.get_random(x_a, 3, 10));
    }
    else if (c_t[x_a][channel][i_t] ==  11){
      c_tchannel_opt(x_a,   0,  60,   2, 193,  12,  48, random_manager.get_random(x_a, 2, 11), random_manager.get_random(x_a, 3, 11));
    }
  }

  for (int i_d = 0; i_d < c_d[x_a][channel].size(); i_d++){
    if      (c_d[x_a][channel][i_d] ==   0){
      c_decay(x_a, 252,  64, 188, random_manager.get_random(x_a, 4, 0), random_manager.get_random(x_a, 5, 0));
    }
    else if (c_d[x_a][channel][i_d] ==   1){
      c_decay(x_a, 188, 128,  60, random_manager.get_random(x_a, 4, 1), random_manager.get_random(x_a, 5, 1));
    }
    else if (c_d[x_a][channel][i_d] ==   2){
      c_decay(x_a,  60,   4,  56, random_manager.get_random(x_a, 4, 2), random_manager.get_random(x_a, 5, 2));
    }
    else if (c_d[x_a][channel][i_d] ==   3){
      c_decay(x_a,  56,   8,  48, random_manager.get_random(x_a, 4, 3), random_manager.get_random(x_a, 5, 3));
    }
    else if (c_d[x_a][channel][i_d] ==   4){
      c_decay(x_a,  48,  16,  32, random_manager.get_random(x_a, 4, 4), random_manager.get_random(x_a, 5, 4));
    }
    else if (c_d[x_a][channel][i_d] ==   5){
      c_decay(x_a, 252, 128, 124, random_manager.get_random(x_a, 4, 5), random_manager.get_random(x_a, 5, 5));
    }
    else if (c_d[x_a][channel][i_d] ==   6){
      c_decay(x_a, 124,  64,  60, random_manager.get_random(x_a, 4, 6), random_manager.get_random(x_a, 5, 6));
    }
    else if (c_d[x_a][channel][i_d] ==   7){
      c_decay(x_a,  60,  16,  44, random_manager.get_random(x_a, 4, 7), random_manager.get_random(x_a, 5, 7));
    }
    else if (c_d[x_a][channel][i_d] ==   8){
      c_decay(x_a,  44,  32,  12, random_manager.get_random(x_a, 4, 8), random_manager.get_random(x_a, 5, 8));
    }
    else if (c_d[x_a][channel][i_d] ==   9){
      c_decay(x_a,  12,   4,   8, random_manager.get_random(x_a, 4, 9), random_manager.get_random(x_a, 5, 9));
    }
    else if (c_d[x_a][channel][i_d] ==  10){
      c_decay(x_a,  60,  32,  28, random_manager.get_random(x_a, 4, 10), random_manager.get_random(x_a, 5, 10));
    }
    else if (c_d[x_a][channel][i_d] ==  11){
      c_decay(x_a,  28,  16,  12, random_manager.get_random(x_a, 4, 11), random_manager.get_random(x_a, 5, 11));
    }
    else if (c_d[x_a][channel][i_d] ==  12){
      c_decay(x_a,  60,   8,  52, random_manager.get_random(x_a, 4, 12), random_manager.get_random(x_a, 5, 12));
    }
    else if (c_d[x_a][channel][i_d] ==  13){
      c_decay(x_a,  52,   4,  48, random_manager.get_random(x_a, 4, 13), random_manager.get_random(x_a, 5, 13));
    }
    else if (c_d[x_a][channel][i_d] ==  14){
      c_decay(x_a, 124,  12, 112, random_manager.get_random(x_a, 4, 14), random_manager.get_random(x_a, 5, 14));
    }
    else if (c_d[x_a][channel][i_d] ==  15){
      c_decay(x_a, 112,  64,  48, random_manager.get_random(x_a, 4, 15), random_manager.get_random(x_a, 5, 15));
    }
    else if (c_d[x_a][channel][i_d] ==  16){
      c_decay(x_a, 188,  12, 176, random_manager.get_random(x_a, 4, 16), random_manager.get_random(x_a, 5, 16));
    }
    else if (c_d[x_a][channel][i_d] ==  17){
      c_decay(x_a, 176, 128,  48, random_manager.get_random(x_a, 4, 17), random_manager.get_random(x_a, 5, 17));
    }
    else if (c_d[x_a][channel][i_d] ==  18){
      c_decay(x_a, 124,  48,  76, random_manager.get_random(x_a, 4, 18), random_manager.get_random(x_a, 5, 18));
    }
    else if (c_d[x_a][channel][i_d] ==  19){
      c_decay(x_a,  76,  64,  12, random_manager.get_random(x_a, 4, 19), random_manager.get_random(x_a, 5, 19));
    }
    else if (c_d[x_a][channel][i_d] ==  20){
      c_decay(x_a, 188,  48, 140, random_manager.get_random(x_a, 4, 20), random_manager.get_random(x_a, 5, 20));
    }
    else if (c_d[x_a][channel][i_d] ==  21){
      c_decay(x_a, 140, 128,  12, random_manager.get_random(x_a, 4, 21), random_manager.get_random(x_a, 5, 21));
    }
    else if (c_d[x_a][channel][i_d] ==  22){
      c_decay(x_a, 252,  76, 176, random_manager.get_random(x_a, 4, 22), random_manager.get_random(x_a, 5, 22));
    }
    else if (c_d[x_a][channel][i_d] ==  23){
      c_decay(x_a, 252, 112, 140, random_manager.get_random(x_a, 4, 23), random_manager.get_random(x_a, 5, 23));
    }
    else if (c_d[x_a][channel][i_d] ==  24){
      c_decay(x_a, 240,  64, 176, random_manager.get_random(x_a, 4, 24), random_manager.get_random(x_a, 5, 24));
    }
    else if (c_d[x_a][channel][i_d] ==  25){
      c_decay(x_a, 240, 128, 112, random_manager.get_random(x_a, 4, 25), random_manager.get_random(x_a, 5, 25));
    }
    else if (c_d[x_a][channel][i_d] ==  26){
      c_decay(x_a, 192,  64, 128, random_manager.get_random(x_a, 4, 26), random_manager.get_random(x_a, 5, 26));
    }
    else if (c_d[x_a][channel][i_d] ==  27){
      c_decay(x_a, 204,  64, 140, random_manager.get_random(x_a, 4, 27), random_manager.get_random(x_a, 5, 27));
    }
    else if (c_d[x_a][channel][i_d] ==  28){
      c_decay(x_a, 204, 128,  76, random_manager.get_random(x_a, 4, 28), random_manager.get_random(x_a, 5, 28));
    }
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
