#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_240_ddx_emepvmvmxssx(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_240_ddx_emepvmvmxssx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(28);
  needed_v_smin[x_a].resize(28);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   36,   37,   38,   39,   40,   41,   42,   43,   45,   46,   47,   48,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  56
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   28,   29,   38,   39}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   28,   29,   38,   39}; //   8
  needed_v_smin[x_a][  3] = {   0,    1,    4,    6,    8,    9}; //   6
  needed_v_smin[x_a][  4] = {   2,    3,    5,    7,   10,   11}; //   6
  needed_v_smin[x_a][  5] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  needed_v_smin[x_a][  6] = {   4,    5,   34,   44}; //   4
  needed_v_smin[x_a][  7] = {   4,    5,   34,   44}; //   4
  needed_v_smin[x_a][  8] = {   6,    7,   35,   49}; //   4
  needed_v_smin[x_a][  9] = {   6,    7,   35,   49}; //   4
  needed_v_smin[x_a][ 10] = {   8,    9,   10,   11,   36,   37,   50,   51}; //   8
  needed_v_smin[x_a][ 11] = {   8,    9,   10,   11,   36,   37,   50,   51}; //   8
  needed_v_smin[x_a][ 12] = {  12,   13,   22,   23,   26,   27,   47,   48}; //   8
  needed_v_smin[x_a][ 13] = {  12,   13}; //   2
  needed_v_smin[x_a][ 14] = {  14,   15,   20,   21,   24,   25,   45,   46}; //   8
  needed_v_smin[x_a][ 15] = {  14,   15}; //   2
  needed_v_smin[x_a][ 16] = {  16,   17,   20,   21,   32,   33,   42,   43}; //   8
  needed_v_smin[x_a][ 17] = {  16,   17}; //   2
  needed_v_smin[x_a][ 18] = {  18,   19,   22,   23,   30,   31,   40,   41}; //   8
  needed_v_smin[x_a][ 19] = {  18,   19}; //   2
  needed_v_smin[x_a][ 20] = {  24,   25,   45,   46}; //   4
  needed_v_smin[x_a][ 21] = {  26,   27,   47,   48}; //   4
  needed_v_smin[x_a][ 22] = {  28,   29,   34,   35,   36,   37,   38,   39,   44,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  24
  needed_v_smin[x_a][ 23] = {  30,   31,   40,   41}; //   4
  needed_v_smin[x_a][ 24] = {  32,   33,   42,   43}; //   4
  needed_v_smin[x_a][ 25] = {  52,   53,   54,   55}; //   4
  needed_v_smin[x_a][ 26] = {  56,   57,   62,   63}; //   4
  needed_v_smin[x_a][ 27] = {  58,   59,   60,   61}; //   4

  v_smax[x_a].resize(45);
  needed_v_smax[x_a].resize(45);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   24,   25,   26,   27,   28,   29,   36,   37,   40,   41,   42,   43,   54,   55,   56,   57}; //  30
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   28,   29}; //   6
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   28,   29,   34,   35,   36,   37}; //  18
  needed_v_smax[x_a][  3] = {   0,    1,    4,    6,    8,    9,   14,   15,   18,   19}; //  10
  needed_v_smax[x_a][  4] = {   2,    3,    5,    7,   10,   11,   12,   13,   16,   17}; //  10
  needed_v_smax[x_a][  5] = {   4,    5,    6,    7,   16,   17,   18,   19,   22,   23,   30,   31,   32,   33,   34,   35,   45,   46,   47,   48,   60,   61,   62,   63}; //  24
  needed_v_smax[x_a][  6] = {   4,    5,   34}; //   3
  needed_v_smax[x_a][  7] = {   6,    7,   35}; //   3
  needed_v_smax[x_a][  8] = {   8,    9,   10,   11,   36,   37}; //   6
  needed_v_smax[x_a][  9] = {  12,   13,   26,   27}; //   4
  needed_v_smax[x_a][ 10] = {  12,   13}; //   2
  needed_v_smax[x_a][ 11] = {  14,   15,   24,   25}; //   4
  needed_v_smax[x_a][ 12] = {  14,   15}; //   2
  needed_v_smax[x_a][ 13] = {  16,   17,   32,   33}; //   4
  needed_v_smax[x_a][ 14] = {  16,   17}; //   2
  needed_v_smax[x_a][ 15] = {  18,   19,   30,   31}; //   4
  needed_v_smax[x_a][ 16] = {  18,   19}; //   2
  needed_v_smax[x_a][ 17] = {  20,   21,   40,   41,   42,   43,   56,   57}; //   8
  needed_v_smax[x_a][ 18] = {  20,   21,   45,   46}; //   4
  needed_v_smax[x_a][ 19] = {  20,   21}; //   2
  needed_v_smax[x_a][ 20] = {  22,   23,   45,   46,   47,   48,   62,   63}; //   8
  needed_v_smax[x_a][ 21] = {  22,   23,   40,   41}; //   4
  needed_v_smax[x_a][ 22] = {  22,   23}; //   2
  needed_v_smax[x_a][ 23] = {  24,   25,   26,   27}; //   4
  needed_v_smax[x_a][ 24] = {  24,   25,   26,   27}; //   4
  needed_v_smax[x_a][ 25] = {  28,   29,   34,   35,   36,   37}; //   6
  needed_v_smax[x_a][ 26] = {  30,   31,   32,   33}; //   4
  needed_v_smax[x_a][ 27] = {  30,   31,   32,   33}; //   4
  needed_v_smax[x_a][ 28] = {  38,   39,   44,   49,   50,   51,   52,   53,   58,   59}; //  10
  needed_v_smax[x_a][ 29] = {  38,   39,   50,   51,   52,   53}; //   6
  needed_v_smax[x_a][ 30] = {  38,   39}; //   2
  needed_v_smax[x_a][ 31] = {  38,   39,   44,   49,   50,   51,   56,   57,   62,   63}; //  10
  needed_v_smax[x_a][ 32] = {  40,   41,   42,   43,   58,   59,   60,   61}; //   8
  needed_v_smax[x_a][ 33] = {  42,   43}; //   2
  needed_v_smax[x_a][ 34] = {  44,   49,   58,   59}; //   4
  needed_v_smax[x_a][ 35] = {  44}; //   1
  needed_v_smax[x_a][ 36] = {  45,   46,   47,   48,   52,   53,   54,   55}; //   8
  needed_v_smax[x_a][ 37] = {  47,   48}; //   2
  needed_v_smax[x_a][ 38] = {  49}; //   1
  needed_v_smax[x_a][ 39] = {  50,   51}; //   2
  needed_v_smax[x_a][ 40] = {  52,   53,   54,   55}; //   4
  needed_v_smax[x_a][ 41] = {  54,   55}; //   2
  needed_v_smax[x_a][ 42] = {  56,   57,   62,   63}; //   4
  needed_v_smax[x_a][ 43] = {  58,   59,   60,   61}; //   4
  needed_v_smax[x_a][ 44] = {  60,   61}; //   2

  g_p[x_a].resize(70);
  needed_g_p[x_a].resize(70);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    8,    9,   10,   11,   12,   13,   14,   15,   20,   21,   24,   25,   26,   27,   28,   29,   36,   37,   40,   41,   42,   43,   54,   55,   56,   57}; //  30
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   28,   29}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   28}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    4,    6,    8,    9}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,    3,   29}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   2,    3,    5,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   4,    5,    6,    7,   17,   19,   23,   31,   33,   34,   35,   46,   48,   61,   63}; //  15
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax5");
  needed_g_p[x_a][7] = {   4,    5,   34}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax6");
  needed_g_p[x_a][8] = {   4,    5,   34}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][9] = {   6,    7,   35}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {   6,    7,   35}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][11] = {   8,    9,   10,   11,   36,   37}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax8");
  needed_g_p[x_a][12] = {   8,   10,   36}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax2");
  needed_g_p[x_a][13] = {   9,   11,   37}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][14] = {  12,   13,   26,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][15] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax10");
  needed_g_p[x_a][16] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax4");
  needed_g_p[x_a][17] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax10");
  needed_g_p[x_a][18] = {  14,   15,   24,   25}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax11");
  needed_g_p[x_a][19] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax12");
  needed_g_p[x_a][20] = {  14,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax3");
  needed_g_p[x_a][21] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax12");
  needed_g_p[x_a][22] = {  16,   18,   22,   30,   32,   45,   47,   60,   62}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][23] = {  16,   17,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax13");
  needed_g_p[x_a][24] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax14");
  needed_g_p[x_a][25] = {  16,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax4");
  needed_g_p[x_a][26] = {  18,   19,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax15");
  needed_g_p[x_a][27] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");
  needed_g_p[x_a][28] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax3");
  needed_g_p[x_a][29] = {  20,   40,   42,   56}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax17");
  needed_g_p[x_a][30] = {  20,   21,   45,   46}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax18");
  needed_g_p[x_a][31] = {  20,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax19");
  needed_g_p[x_a][32] = {  21,   41,   43,   57}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax17");
  needed_g_p[x_a][33] = {  22,   23,   45,   46,   47,   48,   62,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax20");
  needed_g_p[x_a][34] = {  22,   23,   40,   41}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax21");
  needed_g_p[x_a][35] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax22");
  needed_g_p[x_a][36] = {  24,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax23");
  needed_g_p[x_a][37] = {  24,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax24");
  needed_g_p[x_a][38] = {  25,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax24");
  needed_g_p[x_a][39] = {  26,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax23");
  needed_g_p[x_a][40] = {  28,   29,   34,   35,   36,   37}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax25");
  needed_g_p[x_a][41] = {  30,   31}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax26");
  needed_g_p[x_a][42] = {  30,   31,   32,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax27");
  needed_g_p[x_a][43] = {  32,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax26");
  needed_g_p[x_a][44] = {  38,   39,   44,   49,   50,   51,   52,   53,   58,   59}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax28");
  needed_g_p[x_a][45] = {  38,   39,   50,   51,   52,   53}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax29");
  needed_g_p[x_a][46] = {  38,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax30");
  needed_g_p[x_a][47] = {  38}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax31");
  needed_g_p[x_a][48] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax31");
  needed_g_p[x_a][49] = {  40,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax32");
  needed_g_p[x_a][50] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax33");
  needed_g_p[x_a][51] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax32");
  needed_g_p[x_a][52] = {  44,   49,   59}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax34");
  needed_g_p[x_a][53] = {  44}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax35");
  needed_g_p[x_a][54] = {  44}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax31");
  needed_g_p[x_a][55] = {  45,   46}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax36");
  needed_g_p[x_a][56] = {  47,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax37");
  needed_g_p[x_a][57] = {  47,   48}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin21_smax36");
  needed_g_p[x_a][58] = {  49}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax38");
  needed_g_p[x_a][59] = {  49}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax31");
  needed_g_p[x_a][60] = {  50,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax39");
  needed_g_p[x_a][61] = {  50}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax31");
  needed_g_p[x_a][62] = {  51}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax31");
  needed_g_p[x_a][63] = {  52,   54}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax40");
  needed_g_p[x_a][64] = {  53,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax40");
  needed_g_p[x_a][65] = {  54,   55}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax41");
  needed_g_p[x_a][66] = {  56,   57,   62,   63}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax42");
  needed_g_p[x_a][67] = {  58}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax34");
  needed_g_p[x_a][68] = {  58,   59,   60,   61}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax43");
  needed_g_p[x_a][69] = {  60,   61}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax44");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {  52,   53,   54,   55}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax36");
  needed_g_f[x_a][1] = {  56,   57,   62,   63}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax31");
  needed_g_f[x_a][2] = {  58,   59,   60,   61}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin27_smax32");

  g_t[x_a].resize(12);
  needed_g_t[x_a].resize(12);
  needed_g_t[x_a][0] = {  24,   25,   26,   27,   52,   53,   54,   55}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_240");
  needed_g_t[x_a][1] = {  28,   29,   34,   35,   36,   37,   56,   57,   62,   63}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][2] = {  30,   31,   32,   33,   58,   59,   60,   61}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_204");
  needed_g_t[x_a][3] = {  38,   39,   44,   49,   50,   51}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__192_60");
  needed_g_t[x_a][4] = {  40,   41,   42,   43}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_204");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_204");
  needed_g_t[x_a][5] = {  45,   46,   47,   48}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_240");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_240");
  needed_g_t[x_a][6] = {  52,   53}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__192_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__192_48");
  needed_g_t[x_a][7] = {  54,   55}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__48_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__48_192");
  needed_g_t[x_a][8] = {  56,   57}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__48_12");
  needed_g_t[x_a][9] = {  58,   59}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__192_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__192_12");
  needed_g_t[x_a][10] = {  60,   61}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_192");
  needed_g_t[x_a][11] = {  62,   63}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__12_48");

  g_d[x_a].resize(29);
  needed_g_d[x_a].resize(29);
  needed_g_d[x_a][0] = {   0,    1,    4,    6,    8,    9,   14,   15,   18,   19}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][1] = {   0,    1,    4,    6,    8,    9}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,   28,   29,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][3] = {   0,    1,    2,    3,   28,   29,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][4] = {   0,    1,    2,    3,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   36,   37,   38,   39,   40,   41,   42,   43,   45,   46,   47,   48,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  56
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][5] = {   2,    3,    5,    7,   10,   11,   12,   13,   16,   17}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][6] = {   2,    3,    5,    7,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][7] = {   4,    5,   34,   44}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {   4,    5,   34,   44}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][9] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   30,   31,   32,   33,   34,   35,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][10] = {   6,    7,   35,   49}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][11] = {   6,    7,   35,   49}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][12] = {   8,    9,   10,   11,   36,   37,   50,   51}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][13] = {   8,    9,   10,   11,   36,   37,   50,   51}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][14] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][15] = {  12,   13,   22,   23,   26,   27,   47,   48}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][16] = {  14,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__12_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__12_176");
  needed_g_d[x_a][17] = {  14,   15,   20,   21,   24,   25,   45,   46}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_176__128_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_176__128_48");
  needed_g_d[x_a][18] = {  16,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][19] = {  16,   17,   20,   21,   32,   33,   42,   43}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][20] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__48_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__48_140");
  needed_g_d[x_a][21] = {  18,   19,   22,   23,   30,   31,   40,   41}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_140__128_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_140__128_12");
  needed_g_d[x_a][22] = {  20,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__76_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__76_176");
  needed_g_d[x_a][23] = {  22,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__112_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__112_140");
  needed_g_d[x_a][24] = {  24,   25,   45,   46}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__64_176");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__64_176");
  needed_g_d[x_a][25] = {  26,   27,   47,   48}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_240__128_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_240__128_112");
  needed_g_d[x_a][26] = {  28,   29,   34,   35,   36,   37,   38,   39,   44,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][27] = {  30,   31,   40,   41}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__64_140");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__64_140");
  needed_g_d[x_a][28] = {  32,   33,   42,   43}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_204__128_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_204__128_76");

  c_p[x_a].resize(64);
  c_f[x_a].resize(64);
  c_t[x_a].resize(64);
  c_d[x_a].resize(64);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][1] = {  0,   1,   4,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3,   4}; //   5

  c_p[x_a][2] = {  0,   1,   2,   5}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][3] = {  0,   1,   4,   5}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  5,   6,   2,   3,   4}; //   5

  c_p[x_a][4] = {  6,   7,   8,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   1,   7,   8,   9}; //   5

  c_p[x_a][5] = {  6,   7,   8,   5}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  5,   6,   7,   8,   9}; //   5

  c_p[x_a][6] = {  6,   9,  10,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,   1,  10,  11,   9}; //   5

  c_p[x_a][7] = {  6,   9,  10,   5}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  5,   6,  10,  11,   9}; //   5

  c_p[x_a][8] = {  0,  11,  12,   3}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,   1,  12,  13,   4}; //   5

  c_p[x_a][9] = {  0,  11,  13,   3}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,   1,  12,  13,   4}; //   5

  c_p[x_a][10] = {  0,  11,  12,   5}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  5,   6,  12,  13,   4}; //   5

  c_p[x_a][11] = {  0,  11,  13,   5}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   6,  12,  13,   4}; //   5

  c_p[x_a][12] = {  0,  14,  15,  16}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  5,  14,   9,  15,   4}; //   5

  c_p[x_a][13] = {  0,  14,  17,  16}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  5,  14,   9,  15,   4}; //   5

  c_p[x_a][14] = {  0,  18,  19,  20}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  0,  16,   9,  17,   4}; //   5

  c_p[x_a][15] = {  0,  18,  21,  20}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  0,  16,   9,  17,   4}; //   5

  c_p[x_a][16] = { 22,  23,  24,  25}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  5,  18,   4,  19,   9}; //   5

  c_p[x_a][17] = {  6,  23,  24,  25}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  5,  18,   4,  19,   9}; //   5

  c_p[x_a][18] = { 22,  26,  27,  28}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  0,  20,   4,  21,   9}; //   5

  c_p[x_a][19] = {  6,  26,  27,  28}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  0,  20,   4,  21,   9}; //   5

  c_p[x_a][20] = {  0,  29,  30,  31}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 22,  19,  17,   9,   4}; //   5

  c_p[x_a][21] = {  0,  32,  30,  31}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 22,  19,  17,   9,   4}; //   5

  c_p[x_a][22] = { 22,  33,  34,  35}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 23,  15,  21,   4,   9}; //   5

  c_p[x_a][23] = {  6,  33,  34,  35}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 23,  15,  21,   4,   9}; //   5

  c_p[x_a][24] = {  0,  18,  36,  37}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = {  9,  24,  17,   4}; //   4

  c_p[x_a][25] = {  0,  18,  36,  38}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  9,  24,  17,   4}; //   4

  c_p[x_a][26] = {  0,  14,  39,  37}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  0}; //   1
  c_d[x_a][26] = {  9,  25,  15,   4}; //   4

  c_p[x_a][27] = {  0,  14,  39,  38}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = {  9,  25,  15,   4}; //   4

  c_p[x_a][28] = {  0,   1,   2,  40}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  1}; //   1
  c_d[x_a][28] = { 26,   2,   3,   4}; //   4

  c_p[x_a][29] = {  0,   1,   4,  40}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  1}; //   1
  c_d[x_a][29] = { 26,   2,   3,   4}; //   4

  c_p[x_a][30] = { 22,  26,  41,  42}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  2}; //   1
  c_d[x_a][30] = {  4,  27,  21,   9}; //   4

  c_p[x_a][31] = {  6,  26,  41,  42}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  2}; //   1
  c_d[x_a][31] = {  4,  27,  21,   9}; //   4

  c_p[x_a][32] = { 22,  23,  43,  42}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  2}; //   1
  c_d[x_a][32] = {  4,  28,  19,   9}; //   4

  c_p[x_a][33] = {  6,  23,  43,  42}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  2}; //   1
  c_d[x_a][33] = {  4,  28,  19,   9}; //   4

  c_p[x_a][34] = {  6,   7,   8,  40}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  1}; //   1
  c_d[x_a][34] = { 26,   7,   8,   9}; //   4

  c_p[x_a][35] = {  6,   9,  10,  40}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  1}; //   1
  c_d[x_a][35] = { 26,  10,  11,   9}; //   4

  c_p[x_a][36] = {  0,  11,  12,  40}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  1}; //   1
  c_d[x_a][36] = { 26,  12,  13,   4}; //   4

  c_p[x_a][37] = {  0,  11,  13,  40}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  1}; //   1
  c_d[x_a][37] = { 26,  12,  13,   4}; //   4

  c_p[x_a][38] = { 44,  45,  46,  47}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  3}; //   1
  c_d[x_a][38] = {  2,   3,   4,  26}; //   4

  c_p[x_a][39] = { 44,  45,  46,  48}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  3}; //   1
  c_d[x_a][39] = {  2,   3,   4,  26}; //   4

  c_p[x_a][40] = {  0,  29,  34,  49}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  4}; //   1
  c_d[x_a][40] = { 27,  21,   9,   4}; //   4

  c_p[x_a][41] = {  0,  32,  34,  49}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  4}; //   1
  c_d[x_a][41] = { 27,  21,   9,   4}; //   4

  c_p[x_a][42] = {  0,  29,  50,  51}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  4}; //   1
  c_d[x_a][42] = { 28,  19,   9,   4}; //   4

  c_p[x_a][43] = {  0,  32,  50,  51}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  4}; //   1
  c_d[x_a][43] = { 28,  19,   9,   4}; //   4

  c_p[x_a][44] = { 44,  52,  53,  54}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  3}; //   1
  c_d[x_a][44] = {  7,   8,   9,  26}; //   4

  c_p[x_a][45] = { 22,  33,  30,  55}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  5}; //   1
  c_d[x_a][45] = { 24,  17,   4,   9}; //   4

  c_p[x_a][46] = {  6,  33,  30,  55}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  5}; //   1
  c_d[x_a][46] = { 24,  17,   4,   9}; //   4

  c_p[x_a][47] = { 22,  33,  56,  57}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  5}; //   1
  c_d[x_a][47] = { 25,  15,   4,   9}; //   4

  c_p[x_a][48] = {  6,  33,  56,  57}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  5}; //   1
  c_d[x_a][48] = { 25,  15,   4,   9}; //   4

  c_p[x_a][49] = { 44,  52,  58,  59}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  3}; //   1
  c_d[x_a][49] = { 10,  11,   9,  26}; //   4

  c_p[x_a][50] = { 44,  45,  60,  61}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  3}; //   1
  c_d[x_a][50] = { 12,  13,   4,  26}; //   4

  c_p[x_a][51] = { 44,  45,  60,  62}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  3}; //   1
  c_d[x_a][51] = { 12,  13,   4,  26}; //   4

  c_p[x_a][52] = { 44,  45,  63}; //   3
  c_f[x_a][52] = {  0}; //   1
  c_t[x_a][52] = {  0,   6}; //   2
  c_d[x_a][52] = {  9,   4,  26}; //   3

  c_p[x_a][53] = { 44,  45,  64}; //   3
  c_f[x_a][53] = {  0}; //   1
  c_t[x_a][53] = {  0,   6}; //   2
  c_d[x_a][53] = {  9,   4,  26}; //   3

  c_p[x_a][54] = {  0,  65,  63}; //   3
  c_f[x_a][54] = {  0}; //   1
  c_t[x_a][54] = {  0,   7}; //   2
  c_d[x_a][54] = {  9,  26,   4}; //   3

  c_p[x_a][55] = {  0,  65,  64}; //   3
  c_f[x_a][55] = {  0}; //   1
  c_t[x_a][55] = {  0,   7}; //   2
  c_d[x_a][55] = {  9,  26,   4}; //   3

  c_p[x_a][56] = {  0,  29,  66}; //   3
  c_f[x_a][56] = {  1}; //   1
  c_t[x_a][56] = {  1,   8}; //   2
  c_d[x_a][56] = { 26,   9,   4}; //   3

  c_p[x_a][57] = {  0,  32,  66}; //   3
  c_f[x_a][57] = {  1}; //   1
  c_t[x_a][57] = {  1,   8}; //   2
  c_d[x_a][57] = { 26,   9,   4}; //   3

  c_p[x_a][58] = { 44,  67,  68}; //   3
  c_f[x_a][58] = {  2}; //   1
  c_t[x_a][58] = {  2,   9}; //   2
  c_d[x_a][58] = {  4,   9,  26}; //   3

  c_p[x_a][59] = { 44,  52,  68}; //   3
  c_f[x_a][59] = {  2}; //   1
  c_t[x_a][59] = {  2,   9}; //   2
  c_d[x_a][59] = {  4,   9,  26}; //   3

  c_p[x_a][60] = { 22,  69,  68}; //   3
  c_f[x_a][60] = {  2}; //   1
  c_t[x_a][60] = {  2,  10}; //   2
  c_d[x_a][60] = {  4,  26,   9}; //   3

  c_p[x_a][61] = {  6,  69,  68}; //   3
  c_f[x_a][61] = {  2}; //   1
  c_t[x_a][61] = {  2,  10}; //   2
  c_d[x_a][61] = {  4,  26,   9}; //   3

  c_p[x_a][62] = { 22,  33,  66}; //   3
  c_f[x_a][62] = {  1}; //   1
  c_t[x_a][62] = {  1,  11}; //   2
  c_d[x_a][62] = { 26,   4,   9}; //   3

  c_p[x_a][63] = {  6,  33,  66}; //   3
  c_f[x_a][63] = {  1}; //   1
  c_t[x_a][63] = {  1,  11}; //   2
  c_d[x_a][63] = { 26,   4,   9}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_ddx_emepvmvmxssx
//  channel    0: 6yyyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel    1: 6yyyyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   0,   0)
//  channel    2: 6yyyyv(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel    3: 6yyyyv(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,  23,   0,   0)
//  channel    4: 6yyyyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   0,   0)
//  channel    5: 6yyyyv(1, 2, 128, 64, 16, 32, 4, 8;  23,   0,  23,   0,   0)
//  channel    6: 6yyyyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   0,   0)
//  channel    7: 6yyyyv(1, 2, 128, 64, 32, 16, 4, 8;  23,   0,  23,   0,   0)
//  channel    8: 6yyyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   0,   0)
//  channel    9: 6yyyyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   0,   0)
//  channel   10: 6yyyyv(1, 2, 128, 64, 8, 4, 16, 32;  23,   0,   0,   0,   0)
//  channel   11: 6yyyyv(1, 2, 128, 64, 8, 4, 16, 32;  23,   0,  23,   0,   0)
//  channel   12: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  23,   0,   0,   0,   0)
//  channel   13: 6y2vyv(1, 2, 128, 4, 8, 64, 16, 32;  23,   0,  23,   0,   0)
//  channel   14: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   15: 6y2vyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,  23,   0,   0)
//  channel   16: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;   0,   0,  23,   0,   0)
//  channel   17: 6y2vyv(1, 2, 128, 16, 32, 64, 4, 8;  23,   0,  23,   0,   0)
//  channel   18: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;   0,   0,  23,   0,   0)
//  channel   19: 6y2vyv(1, 2, 64, 16, 32, 128, 4, 8;  23,   0,  23,   0,   0)
//  channel   20: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   21: 63yvyv(1, 2, 64, 4, 8, 128, 16, 32;  23,  23,   0,   0,   0)
//  channel   22: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;   0,  23,   0,   0,   0)
//  channel   23: 63yvyv(1, 2, 64, 16, 32, 128, 4, 8;  23,  23,   0,   0,   0)
//  channel   24: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   25: 2v4yyv(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,  23,   0)
//  channel   26: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  23,   0,   0,   0,   0)
//  channel   27: 2v4yyv(1, 2, 4, 8, 128, 64, 16, 32;  23,   0,   0,  23,   0)
//  channel   28: 2v4yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   29: 2v4yyv(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,  23,   0,   0)
//  channel   30: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,   0,  23,   0)
//  channel   31: 2v4yyv(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,   0,  23,   0)
//  channel   32: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;   0,   0,   0,  23,   0)
//  channel   33: 2v4yyv(1, 2, 16, 32, 128, 64, 4, 8;  23,   0,   0,  23,   0)
//  channel   34: 2v4yyv(1, 2, 64, 128, 16, 32, 4, 8;  23,   0,  23,   0,   0)
//  channel   35: 2v4yyv(1, 2, 64, 128, 32, 16, 4, 8;  23,   0,  23,   0,   0)
//  channel   36: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,   0,   0,   0)
//  channel   37: 2v4yyv(1, 2, 64, 128, 8, 4, 16, 32;  23,   0,  23,   0,   0)
//  channel   38: 4yyv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,   0,   0)
//  channel   39: 4yyv2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,  23,   0)
//  channel   40: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   41: 4yyv2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   0,   0,   0)
//  channel   42: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   43: 4yyv2v(1, 2, 128, 64, 4, 8, 16, 32;  23,  23,   0,   0,   0)
//  channel   44: 4yyv2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,   0,  23,   0)
//  channel   45: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   0,   0,   0)
//  channel   46: 4yyv2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   0,   0,   0)
//  channel   47: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;   0,  23,   0,   0,   0)
//  channel   48: 4yyv2v(1, 2, 128, 64, 16, 32, 4, 8;  23,  23,   0,   0,   0)
//  channel   49: 4yyv2v(1, 2, 32, 16, 4, 8, 64, 128;   0,  23,   0,  23,   0)
//  channel   50: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  23,   0,   0,   0)
//  channel   51: 4yyv2v(1, 2, 8, 4, 16, 32, 64, 128;   0,  23,   0,  23,   0)
//  channel   52: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,   0,   0,   0)
//  channel   53: 2v2v2v(1, 2, 4, 8, 16, 32, 64, 128;   0,  23,  23,   0,   0)
//  channel   54: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,   0,   0,   0)
//  channel   55: 2v2v2v(1, 2, 4, 8, 64, 128, 16, 32;  23,   0,  23,   0,   0)
//  channel   56: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,   0,   0,   0,   0)
//  channel   57: 2v2v2v(1, 2, 64, 128, 4, 8, 16, 32;  23,  23,   0,   0,   0)
//  channel   58: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,   0,  23,   0,   0)
//  channel   59: 2v2v2v(1, 2, 16, 32, 4, 8, 64, 128;   0,  23,  23,   0,   0)
//  channel   60: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;   0,   0,  23,   0,   0)
//  channel   61: 2v2v2v(1, 2, 16, 32, 64, 128, 4, 8;  23,   0,  23,   0,   0)
//  channel   62: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;   0,  23,   0,   0,   0)
//  channel   63: 2v2v2v(1, 2, 64, 128, 16, 32, 4, 8;  23,  23,   0,   0,   0)
