#include "header.hpp"

#include "ppeexnmnmx04.phasespace.set.hpp"

void ppeexnmnmx04_phasespace_set::ax_psp_050_uxa_emepvmvmxux(int x_a){
  static Logger logger("ppeexnmnmx04_phasespace_set::ax_psp_050_uxa_emepvmvmxux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(27);
  needed_v_smin[x_a].resize(27);
  needed_v_smin[x_a][  0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   16,   17,   18,   19,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  40
  needed_v_smin[x_a][  1] = {   8,    9,   10,   11,   24,   25,   44,   45}; //   8
  needed_v_smin[x_a][  2] = {  12,   13,   18,   19,   30,   31,   36,   37,   34,   35}; //  10
  needed_v_smin[x_a][  3] = {  12,   13,   18,   19,    2,    3,   30,   31,   34,   35,   36,   37}; //  12
  needed_v_smin[x_a][  4] = {  14,   15,   20,   21,   24,   25,   26,   27,   40,   41,   42,   43,   44,   45,   46,   47}; //  16
  needed_v_smin[x_a][  5] = {  14,   20}; //   2
  needed_v_smin[x_a][  6] = {  14,   20}; //   2
  needed_v_smin[x_a][  7] = {  15,   21}; //   2
  needed_v_smin[x_a][  8] = {  15,   21}; //   2
  needed_v_smin[x_a][  9] = {  16,   17,   22,   23,   28,   29,   38,   39,   32,   33}; //  10
  needed_v_smin[x_a][ 10] = {  16,   17,   22,   23,    0,    1,   28,   29,   32,   33,   38,   39}; //  12
  needed_v_smin[x_a][ 11] = {  26,   27,   46,   47}; //   4
  needed_v_smin[x_a][ 12] = {   0}; //   1
  needed_v_smin[x_a][ 13] = {   0}; //   1
  needed_v_smin[x_a][ 14] = {   1}; //   1
  needed_v_smin[x_a][ 15] = {   1}; //   1
  needed_v_smin[x_a][ 16] = {   2}; //   1
  needed_v_smin[x_a][ 17] = {   2}; //   1
  needed_v_smin[x_a][ 18] = {   3}; //   1
  needed_v_smin[x_a][ 19] = {   3}; //   1
  needed_v_smin[x_a][ 20] = {   4,    5}; //   2
  needed_v_smin[x_a][ 21] = {   4,    5}; //   2
  needed_v_smin[x_a][ 22] = {   6,    7}; //   2
  needed_v_smin[x_a][ 23] = {   6,    7}; //   2
  needed_v_smin[x_a][ 24] = {   8,    9}; //   2
  needed_v_smin[x_a][ 25] = {  10,   11}; //   2
  needed_v_smin[x_a][ 26] = {  40,   41,   42,   43}; //   4

  v_smax[x_a].resize(21);
  needed_v_smax[x_a].resize(21);
  needed_v_smax[x_a][  0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   16,   17,   18,   19,   22,   23,   24,   25,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   44,   45}; //  34
  needed_v_smax[x_a][  1] = {   8,    9,   10,   11,   24,   25,   44,   45}; //   8
  needed_v_smax[x_a][  2] = {  12,   13,   18,   19,   30,   31,   36,   37,    2,    3,   34,   35}; //  12
  needed_v_smax[x_a][  3] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,    0,    1,    2,    3,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43}; //  32
  needed_v_smax[x_a][  4] = {  14,   15,   20,   21,   26,   27,   42,   43,   46,   47}; //  10
  needed_v_smax[x_a][  5] = {  14,   20}; //   2
  needed_v_smax[x_a][  6] = {  15,   21}; //   2
  needed_v_smax[x_a][  7] = {  16,   17,   22,   23,   28,   29,   38,   39,    0,    1,   32,   33}; //  12
  needed_v_smax[x_a][  8] = {  24,   25,   44,   45}; //   4
  needed_v_smax[x_a][  9] = {  26,   27,   46,   47}; //   4
  needed_v_smax[x_a][ 10] = {  26,   27,   46,   47}; //   4
  needed_v_smax[x_a][ 11] = {  40,   41}; //   2
  needed_v_smax[x_a][ 12] = {  42,   43}; //   2
  needed_v_smax[x_a][ 13] = {   0}; //   1
  needed_v_smax[x_a][ 14] = {   1}; //   1
  needed_v_smax[x_a][ 15] = {   2}; //   1
  needed_v_smax[x_a][ 16] = {   3}; //   1
  needed_v_smax[x_a][ 17] = {   4,    5}; //   2
  needed_v_smax[x_a][ 18] = {   4,    5,    8,    9}; //   4
  needed_v_smax[x_a][ 19] = {   6,    7}; //   2
  needed_v_smax[x_a][ 20] = {   6,    7,   10,   11}; //   4

  g_p[x_a].resize(21);
  needed_g_p[x_a].resize(21);
  needed_g_p[x_a][0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   16,   17,   18,   19,   22,   23,   24,   25,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   44,   45}; //  34
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   8,    9,   10,   11,   24,   25,   44,   45}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {  12,   13,   18,   19,   30,   31,   36,   37}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {  12,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {  13,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][5] = {  14,   15,   20,   21,   27,   43,   47}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax4");
  needed_g_p[x_a][6] = {  14,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][7] = {  14,   20}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin6_smax3");
  needed_g_p[x_a][8] = {  15,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {  15,   21}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax3");
  needed_g_p[x_a][10] = {  16,   17,   22,   23,   28,   29,   38,   39}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][11] = {  16,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax3");
  needed_g_p[x_a][12] = {  17,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax3");
  needed_g_p[x_a][13] = {  24,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax8");
  needed_g_p[x_a][14] = {  25,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax8");
  needed_g_p[x_a][15] = {  26,   42,   46}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][16] = {  26,   27,   46,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax9");
  needed_g_p[x_a][17] = {  26,   27,   46,   47}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax10");
  needed_g_p[x_a][18] = {  40}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax11");
  needed_g_p[x_a][19] = {  41}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax11");
  needed_g_p[x_a][20] = {  42,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax12");

  g_f[x_a].resize(19);
  needed_g_f[x_a].resize(19);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax13");
  needed_g_f[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax7");
  needed_g_f[x_a][2] = {   0,    1,   28,   29,   32,   33,   38,   39}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax3");
  needed_g_f[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax14");
  needed_g_f[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax7");
  needed_g_f[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax15");
  needed_g_f[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax2");
  needed_g_f[x_a][7] = {   2,    3,   30,   31,   34,   35,   36,   37}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax16");
  needed_g_f[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax2");
  needed_g_f[x_a][10] = {   4,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin20_smax17");
  needed_g_f[x_a][11] = {   4,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin21_smax18");
  needed_g_f[x_a][12] = {   6,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin22_smax19");
  needed_g_f[x_a][13] = {   6,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin23_smax20");
  needed_g_f[x_a][14] = {   8,    9}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin24_smax18");
  needed_g_f[x_a][15] = {  10,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin25_smax20");
  needed_g_f[x_a][16] = {  32,   33}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][17] = {  34,   35}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][18] = {  40,   41,   42,   43}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin26_smax3");

  g_t[x_a].resize(33);
  needed_g_t[x_a].resize(33);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,   29,   31,   33,   35,   37,   39}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__1_2__64_60");
  needed_g_t[x_a][1] = {   0,    1,   28,   29,   32,   33}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__8_52");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__16_36");
  needed_g_t[x_a][3] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_81__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_81__4_32");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__32_20");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_97__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_97__4_16");
  needed_g_t[x_a][6] = {   2,    3,   30,   31,   34,   35}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__4_56");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__16_40");
  needed_g_t[x_a][8] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_81__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_81__8_32");
  needed_g_t[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__32_24");
  needed_g_t[x_a][10] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_97__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_97__8_16");
  needed_g_t[x_a][11] = {   4,    5,    8,    9}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_116");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_116");
  needed_g_t[x_a][12] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_68");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_68");
  needed_g_t[x_a][13] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__10_49__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__10_49__4_64");
  needed_g_t[x_a][14] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__10_49__4_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__10_49__4_64");
  needed_g_t[x_a][15] = {   6,    7,   10,   11}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_120");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_120");
  needed_g_t[x_a][16] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_72");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_72");
  needed_g_t[x_a][17] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__6_49__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__6_49__8_64");
  needed_g_t[x_a][18] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_23__6_49__8_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_23__6_49__8_64");
  needed_g_t[x_a][19] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__10_1__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__10_1__4_112");
  needed_g_t[x_a][20] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__10_1__4_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__10_1__4_112");
  needed_g_t[x_a][21] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__6_1__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__6_1__8_112");
  needed_g_t[x_a][22] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_23__6_1__8_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_23__6_1__8_112");
  needed_g_t[x_a][23] = {  12,   13,   14,   15,   16,   17,   40,   41,   42,   43}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][24] = {  28,   30,   32,   34,   36,   38}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][25] = {  32,   33}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_10__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_10__4_48");
  needed_g_t[x_a][26] = {  34,   35}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_6__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_6__8_48");
  needed_g_t[x_a][27] = {  36,   37}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__4_56");
  needed_g_t[x_a][28] = {  38,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__8_52");
  needed_g_t[x_a][29] = {  40,   41}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][30] = {  42,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][31] = {  44,   45}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][32] = {  46,   47}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");

  g_d[x_a].resize(15);
  needed_g_d[x_a].resize(15);
  needed_g_d[x_a][0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   16,   17,   18,   19,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][1] = {   8,    9,   10,   11,   24,   25,   44,   45}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][2] = {  12,   13,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][3] = {  12,   13,   18,   19,   30,   31,   36,   37}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][4] = {  14,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][5] = {  14,   20}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {  14,   15,   20,   21,   24,   25,   26,   27,   40,   41,   42,   43,   44,   45,   46,   47}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][7] = {  15,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {  15,   21}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][9] = {  16,   17,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {  16,   17,   22,   23,   28,   29,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][11] = {  18,   19,   20,   21,   22,   23}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][12] = {  24,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__12_112");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__12_112");
  needed_g_d[x_a][13] = {  26,   27}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][14] = {  26,   27,   46,   47}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");

  c_p[x_a].resize(48);
  c_f[x_a].resize(48);
  c_t[x_a].resize(48);
  c_d[x_a].resize(48);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1,   2}; //   3
  c_t[x_a][0] = {  0,   1,   2,   3}; //   4
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  3,   4,   2}; //   3
  c_t[x_a][1] = {  0,   1,   4,   5}; //   4
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  5,   6,   7}; //   3
  c_t[x_a][2] = {  0,   6,   7,   8}; //   4
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  8,   9,   7}; //   3
  c_t[x_a][3] = {  0,   6,   9,  10}; //   4
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = { 10,  11}; //   2
  c_t[x_a][4] = { 11,  12,  13}; //   3
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = { 10,  11}; //   2
  c_t[x_a][5] = { 11,  12,  14}; //   3
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = { 12,  13}; //   2
  c_t[x_a][6] = { 15,  16,  17}; //   3
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = { 12,  13}; //   2
  c_t[x_a][7] = { 15,  16,  18}; //   3
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  0,   1}; //   2
  c_f[x_a][8] = { 14}; //   1
  c_t[x_a][8] = { 11,  19}; //   2
  c_d[x_a][8] = {  1,   0}; //   2

  c_p[x_a][9] = {  0,   1}; //   2
  c_f[x_a][9] = { 14}; //   1
  c_t[x_a][9] = { 11,  20}; //   2
  c_d[x_a][9] = {  1,   0}; //   2

  c_p[x_a][10] = {  0,   1}; //   2
  c_f[x_a][10] = { 15}; //   1
  c_t[x_a][10] = { 15,  21}; //   2
  c_d[x_a][10] = {  1,   0}; //   2

  c_p[x_a][11] = {  0,   1}; //   2
  c_f[x_a][11] = { 15}; //   1
  c_t[x_a][11] = { 15,  22}; //   2
  c_d[x_a][11] = {  1,   0}; //   2

  c_p[x_a][12] = {  0,   2,   3}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 23}; //   1
  c_d[x_a][12] = {  2,   3,   0}; //   3

  c_p[x_a][13] = {  0,   2,   4}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 23}; //   1
  c_d[x_a][13] = {  2,   3,   0}; //   3

  c_p[x_a][14] = {  5,   6,   7}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 23}; //   1
  c_d[x_a][14] = {  4,   5,   6}; //   3

  c_p[x_a][15] = {  5,   8,   9}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 23}; //   1
  c_d[x_a][15] = {  7,   8,   6}; //   3

  c_p[x_a][16] = {  0,  10,  11}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 23}; //   1
  c_d[x_a][16] = {  9,  10,   0}; //   3

  c_p[x_a][17] = {  0,  10,  12}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 23}; //   1
  c_d[x_a][17] = {  9,  10,   0}; //   3

  c_p[x_a][18] = {  0,   2,   3}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 11,   2,   3,   0}; //   4

  c_p[x_a][19] = {  0,   2,   4}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 11,   2,   3,   0}; //   4

  c_p[x_a][20] = {  5,   6,   7}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 11,   4,   5,   6}; //   4

  c_p[x_a][21] = {  5,   8,   9}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 11,   7,   8,   6}; //   4

  c_p[x_a][22] = {  0,  10,  11}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 11,   9,  10,   0}; //   4

  c_p[x_a][23] = {  0,  10,  12}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 11,   9,  10,   0}; //   4

  c_p[x_a][24] = {  0,   1,  13}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 12,   6,   1,   0}; //   4

  c_p[x_a][25] = {  0,   1,  14}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 12,   6,   1,   0}; //   4

  c_p[x_a][26] = { 15,  16,  17}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 13,   0,  14,   6}; //   4

  c_p[x_a][27] = {  5,  16,  17}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 13,   0,  14,   6}; //   4

  c_p[x_a][28] = {  0,  10}; //   2
  c_f[x_a][28] = {  2}; //   1
  c_t[x_a][28] = { 24,   1}; //   2
  c_d[x_a][28] = { 10,   0}; //   2

  c_p[x_a][29] = {  0,  10}; //   2
  c_f[x_a][29] = {  2}; //   1
  c_t[x_a][29] = {  0,   1}; //   2
  c_d[x_a][29] = { 10,   0}; //   2

  c_p[x_a][30] = {  0,   2}; //   2
  c_f[x_a][30] = {  7}; //   1
  c_t[x_a][30] = { 24,   6}; //   2
  c_d[x_a][30] = {  3,   0}; //   2

  c_p[x_a][31] = {  0,   2}; //   2
  c_f[x_a][31] = {  7}; //   1
  c_t[x_a][31] = {  0,   6}; //   2
  c_d[x_a][31] = {  3,   0}; //   2

  c_p[x_a][32] = {  0}; //   1
  c_f[x_a][32] = { 16,   2}; //   2
  c_t[x_a][32] = { 24,   1,  25}; //   3
  c_d[x_a][32] = {  0}; //   1

  c_p[x_a][33] = {  0}; //   1
  c_f[x_a][33] = { 16,   2}; //   2
  c_t[x_a][33] = {  0,   1,  25}; //   3
  c_d[x_a][33] = {  0}; //   1

  c_p[x_a][34] = {  0}; //   1
  c_f[x_a][34] = { 17,   7}; //   2
  c_t[x_a][34] = { 24,   6,  26}; //   3
  c_d[x_a][34] = {  0}; //   1

  c_p[x_a][35] = {  0}; //   1
  c_f[x_a][35] = { 17,   7}; //   2
  c_t[x_a][35] = {  0,   6,  26}; //   3
  c_d[x_a][35] = {  0}; //   1

  c_p[x_a][36] = {  0,   2}; //   2
  c_f[x_a][36] = {  7}; //   1
  c_t[x_a][36] = { 24,  27}; //   2
  c_d[x_a][36] = {  3,   0}; //   2

  c_p[x_a][37] = {  0,   2}; //   2
  c_f[x_a][37] = {  7}; //   1
  c_t[x_a][37] = {  0,  27}; //   2
  c_d[x_a][37] = {  3,   0}; //   2

  c_p[x_a][38] = {  0,  10}; //   2
  c_f[x_a][38] = {  2}; //   1
  c_t[x_a][38] = { 24,  28}; //   2
  c_d[x_a][38] = { 10,   0}; //   2

  c_p[x_a][39] = {  0,  10}; //   2
  c_f[x_a][39] = {  2}; //   1
  c_t[x_a][39] = {  0,  28}; //   2
  c_d[x_a][39] = { 10,   0}; //   2

  c_p[x_a][40] = {  0,  18}; //   2
  c_f[x_a][40] = { 18}; //   1
  c_t[x_a][40] = { 23,  29}; //   2
  c_d[x_a][40] = {  6,   0}; //   2

  c_p[x_a][41] = {  0,  19}; //   2
  c_f[x_a][41] = { 18}; //   1
  c_t[x_a][41] = { 23,  29}; //   2
  c_d[x_a][41] = {  6,   0}; //   2

  c_p[x_a][42] = { 15,  20}; //   2
  c_f[x_a][42] = { 18}; //   1
  c_t[x_a][42] = { 23,  30}; //   2
  c_d[x_a][42] = {  0,   6}; //   2

  c_p[x_a][43] = {  5,  20}; //   2
  c_f[x_a][43] = { 18}; //   1
  c_t[x_a][43] = { 23,  30}; //   2
  c_d[x_a][43] = {  0,   6}; //   2

  c_p[x_a][44] = {  0,   1,  13}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = { 31}; //   1
  c_d[x_a][44] = {  6,   1,   0}; //   3

  c_p[x_a][45] = {  0,   1,  14}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = { 31}; //   1
  c_d[x_a][45] = {  6,   1,   0}; //   3

  c_p[x_a][46] = { 15,  16,  17}; //   3
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 32}; //   1
  c_d[x_a][46] = {  0,  14,   6}; //   3

  c_p[x_a][47] = {  5,  16,  17}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = { 32}; //   1
  c_d[x_a][47] = {  0,  14,   6}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_050_uxa_emepvmvmxux
//  channel    0: 11111(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,  23)
//  channel    1: 11111(1, 2, 64, 32, 16, 4, 8;  23,   0,   0,  23)
//  channel    2: 11111(1, 2, 64, 16, 32, 8, 4;  23,   0,   0,  23)
//  channel    3: 11111(1, 2, 64, 32, 16, 8, 4;  23,   0,   0,  23)
//  channel    4: 2v111(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel    5: 2v111(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,  23)
//  channel    6: 2v111(1, 2, 16, 32, 64, 8, 4;  23,   0,   0,   0)
//  channel    7: 2v111(1, 2, 16, 32, 64, 8, 4;  23,   0,   0,  23)
//  channel    8: 3yv11(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel    9: 3yv11(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,  23)
//  channel   10: 3yv11(1, 2, 64, 16, 32, 8, 4;  23,   0,   0,   0)
//  channel   11: 3yv11(1, 2, 64, 16, 32, 8, 4;  23,   0,   0,  23)
//  channel   12: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel   13: 4yyv1(1, 2, 4, 8, 16, 32, 64;  23,   0,  23,   0)
//  channel   14: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,  23,   0)
//  channel   15: 4yyv1(1, 2, 32, 16, 4, 8, 64;  23,   0,  23,   0)
//  channel   16: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,   0,   0)
//  channel   17: 4yyv1(1, 2, 8, 4, 16, 32, 64;  23,   0,  23,   0)
//  channel   18: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel   19: 5yyyv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
//  channel   20: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,  23,   0)
//  channel   21: 5yyyv(1, 2, 64, 32, 16, 4, 8;  23,   0,  23,   0)
//  channel   22: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
//  channel   23: 5yyyv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
//  channel   24: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel   25: 52vyv(1, 2, 4, 8, 64, 16, 32;  23,   0,  23,   0)
//  channel   26: 52vyv(1, 2, 16, 32, 64, 4, 8;   0,   0,  23,   0)
//  channel   27: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   0,  23,   0)
//  channel   28: 13yv1(1, 2, 64, 4, 16, 32, 8;  23,   0,   0,   0)
//  channel   29: 13yv1(1, 2, 64, 4, 16, 32, 8;  23,   0,  23,   0)
//  channel   30: 13yv1(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,   0)
//  channel   31: 13yv1(1, 2, 64, 8, 16, 32, 4;  23,   0,  23,   0)
//  channel   32: 112v1(1, 2, 64, 4, 16, 32, 8;  23,   0,   0,   0)
//  channel   33: 112v1(1, 2, 64, 4, 16, 32, 8;  23,  23,   0,   0)
//  channel   34: 112v1(1, 2, 64, 8, 16, 32, 4;  23,   0,   0,   0)
//  channel   35: 112v1(1, 2, 64, 8, 16, 32, 4;  23,  23,   0,   0)
//  channel   36: 113yv(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel   37: 113yv(1, 2, 64, 4, 8, 16, 32;  23,   0,  23,   0)
//  channel   38: 113yv(1, 2, 64, 8, 4, 16, 32;  23,   0,   0,   0)
//  channel   39: 113yv(1, 2, 64, 8, 4, 16, 32;  23,   0,  23,   0)
//  channel   40: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel   41: 2v2v1(1, 2, 4, 8, 16, 32, 64;  23,  23,   0,   0)
//  channel   42: 2v2v1(1, 2, 16, 32, 4, 8, 64;   0,  23,   0,   0)
//  channel   43: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,  23,   0,   0)
//  channel   44: 2v3yv(1, 2, 4, 8, 64, 16, 32;  23,   0,   0,   0)
//  channel   45: 2v3yv(1, 2, 4, 8, 64, 16, 32;  23,   0,  23,   0)
//  channel   46: 2v3yv(1, 2, 16, 32, 64, 4, 8;   0,   0,  23,   0)
//  channel   47: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   0,  23,   0)
