#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_bbx_emmupvmvexbbx(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_bbx_emmupvmvexbbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(19);
  needed_v_smin[x_a].resize(19);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   46,   47,   48,   49,   50,   51,   52,   56,   57,   58,   59,   60,   61,   62,   63,   67,   68,   69,   70,   71,   72,   76,   77,   78,   79,   80,   81,   82,   83}; //  60
  needed_v_smin[x_a][  1] = {   0,    1,    9,   10,   19,   20,   21,   22,   40,   41,   50,   51,   61,   62,   70,   71}; //  16
  needed_v_smin[x_a][  2] = {   0,    1,    9,   10,   19,   20,   21,   22,   40,   41,   50,   51,   61,   62,   70,   71}; //  16
  needed_v_smin[x_a][  3] = {   2,   11,   23,   24,   42,   52,   63,   72}; //   8
  needed_v_smin[x_a][  4] = {   2,   11,   23,   24,   42,   52,   63,   72}; //   8
  needed_v_smin[x_a][  5] = {   3,    4,    5,    6,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   53,   54,   55,   56,   57,   58,   59,   60,   64,   65,   66,   67,   68,   69,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83}; //  60
  needed_v_smin[x_a][  6] = {   3,    4,   12,   13,   25,   26,   27,   28,   43,   44,   53,   54,   64,   65,   73,   74}; //  16
  needed_v_smin[x_a][  7] = {   3,    4,   12,   13,   25,   26,   27,   28,   43,   44,   53,   54,   64,   65,   73,   74}; //  16
  needed_v_smin[x_a][  8] = {   5,   14,   29,   30,   45,   55,   66,   75}; //   8
  needed_v_smin[x_a][  9] = {   5,   14,   29,   30,   45,   55,   66,   75}; //   8
  needed_v_smin[x_a][ 10] = {   6,    7,    8,   15,   16,   17,   31,   32,   33,   34,   35,   36,   46,   47,   48,   56,   57,   58,   67,   68,   69,   76,   77,   78,   83}; //  25
  needed_v_smin[x_a][ 11] = {   9,   10,   11,   12,   13,   14,   15,   16,   17,   21,   22,   24,   27,   28,   30,   34,   35,   36,    0,    1,    2,    3,    4,    5,    6,    7,    8}; //  27
  needed_v_smin[x_a][ 12] = {  18,   37,   39,   60,   59}; //   5
  needed_v_smin[x_a][ 13] = {  18,   37,   59,   60}; //   4
  needed_v_smin[x_a][ 14] = {  19,   20,   23,   25,   26,   29,   31,   32,   33,   40,   41,   42,   43,   44,   45,   46,   47,   48,   50,   51,   52,   53,   54,   55,   56,   57,   58}; //  27
  needed_v_smin[x_a][ 15] = {  38,   39,   49,   79,   80}; //   5
  needed_v_smin[x_a][ 16] = {  38,   49,   79,   80}; //   4
  needed_v_smin[x_a][ 17] = {  61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   81,   82,   83}; //  21
  needed_v_smin[x_a][ 18] = {  81,   82}; //   2

  v_smax[x_a].resize(31);
  needed_v_smax[x_a].resize(31);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   31,   32,   33,   34,   35,   36,   37,   40,   41,   42,   46,   47,   48,   50,   51,   52,   56,   57,   58,   59,   60,   61,   62,   63,   67,   68,   69,   79,   80,   82,   83}; //  50
  needed_v_smax[x_a][  1] = {   0,    1,    9,   10,   19,   20,   21,   22,   40,   41,   50,   51,   61,   62}; //  14
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   40,   41,   42,   43,   44,   45,   46,   47,   48,   50,   51,   52,   53,   54,   55,   56,   57,   58,   61,   62,   63,   64,   65,   66,   67,   68,   69}; //  63
  needed_v_smax[x_a][  3] = {   2,   11,   23,   24,   42,   52,   63}; //   7
  needed_v_smax[x_a][  4] = {   3,    4,    5,   12,   13,   14,   25,   26,   27,   28,   29,   30,   38,   39,   43,   44,   45,   49,   53,   54,   55,   64,   65,   66}; //  24
  needed_v_smax[x_a][  5] = {   3,    4,   12,   13,   25,   26,   27,   28,   43,   44,   53,   54,   64,   65}; //  14
  needed_v_smax[x_a][  6] = {   5,   14,   29,   30,   45,   55,   66}; //   7
  needed_v_smax[x_a][  7] = {   6,    7,    8,   15,   16,   17,   31,   32,   33,   34,   35,   36,   46,   47,   48,   56,   57,   58,   59,   67,   68,   69,   79,   80,   83}; //  25
  needed_v_smax[x_a][  8] = {   9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   21,   22,   24,   27,   28,   30,   34,   35,   36,   37,    0,    1,    2,    3,    4,    5,    6,    7,    8,   59,   60}; //  31
  needed_v_smax[x_a][  9] = {  18,   37,   60}; //   3
  needed_v_smax[x_a][ 10] = {  18,   37,   60}; //   3
  needed_v_smax[x_a][ 11] = {  19,   20,   23,   25,   26,   29,   31,   32,   33,   38,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   79,   80}; //  31
  needed_v_smax[x_a][ 12] = {  38,   49}; //   2
  needed_v_smax[x_a][ 13] = {  38,   49}; //   2
  needed_v_smax[x_a][ 14] = {  39}; //   1
  needed_v_smax[x_a][ 15] = {  39,   79,   80}; //   3
  needed_v_smax[x_a][ 16] = {  39}; //   1
  needed_v_smax[x_a][ 17] = {  61,   62,   63,   64,   65,   66,   67,   68,   69}; //   9
  needed_v_smax[x_a][ 18] = {  70,   71,   72,   73,   74,   75,   76,   77,   78,   81}; //  10
  needed_v_smax[x_a][ 19] = {  70,   71,   72,   76,   77,   78,   81}; //   7
  needed_v_smax[x_a][ 20] = {  70,   71}; //   2
  needed_v_smax[x_a][ 21] = {  70,   71,   72,   73,   74,   75,   76,   77,   78,   83}; //  10
  needed_v_smax[x_a][ 22] = {  72}; //   1
  needed_v_smax[x_a][ 23] = {  73,   74,   75}; //   3
  needed_v_smax[x_a][ 24] = {  73,   74}; //   2
  needed_v_smax[x_a][ 25] = {  75}; //   1
  needed_v_smax[x_a][ 26] = {  76,   77,   78,   81,   82}; //   5
  needed_v_smax[x_a][ 27] = {  82}; //   1
  needed_v_smax[x_a][ 28] = {  83}; //   1
  needed_v_smax[x_a][ 29] = {  59}; //   1
  needed_v_smax[x_a][ 30] = {  81,   82}; //   2

  g_p[x_a].resize(47);
  needed_g_p[x_a].resize(47);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   31,   32,   33,   34,   35,   36,   37,   40,   41,   42,   46,   47,   48,   50,   51,   52,   56,   57,   58,   59,   60,   61,   62,   63,   67,   68,   69,   79,   80,   82,   83}; //  50
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    9,   10,   19,   20,   21,   22,   40,   41,   50,   51,   61,   62}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    9,   19,   21,   40,   50,   61}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,   10,   20,   22,   41,   51,   62}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,   11,   23,   24,   42,   52,   63}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   2,   11,   23,   24,   42,   52,   63}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,   12,   13,   14,   25,   26,   27,   28,   29,   30,   38,   39,   43,   44,   45,   49,   53,   54,   55,   64,   65,   66}; //  24
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,    4,   12,   13,   25,   26,   27,   28,   43,   44,   53,   54,   64,   65}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   12,   25,   27,   43,   53,   64}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   13,   26,   28,   44,   54,   65}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {   5,   14,   29,   30,   45,   55,   66}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {   5,   14,   29,   30,   45,   55,   66}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7,    8,   15,   16,   17,   31,   32,   33,   34,   35,   36,   46,   47,   48,   56,   57,   58,   59,   67,   68,   69,   79,   80,   83}; //  25
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {   6,   15,   31,   34,   46,   56,   67}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {   7,   16,   32,   35,   47,   57,   68}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {   8,   17,   33,   36,   48,   58,   69}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax2");
  needed_g_p[x_a][16] = {   9,   10,   11,   12,   13,   14,   15,   16,   17,   21,   22,   24,   27,   28,   30,   34,   35,   36}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin11_smax8");
  needed_g_p[x_a][17] = {  18,   37,   60}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin12_smax9");
  needed_g_p[x_a][18] = {  18,   37,   60}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax10");
  needed_g_p[x_a][19] = {  18,   37}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin13_smax8");
  needed_g_p[x_a][20] = {  19,   20,   23,   25,   26,   29,   31,   32,   33,   40,   41,   42,   43,   44,   45,   46,   47,   48}; //  18
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin14_smax11");
  needed_g_p[x_a][21] = {  38,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin15_smax12");
  needed_g_p[x_a][22] = {  38,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax13");
  needed_g_p[x_a][23] = {  38,   49}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin16_smax11");
  needed_g_p[x_a][24] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][25] = {  39,   79}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin15_smax15");
  needed_g_p[x_a][26] = {  39}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin12_smax16");
  needed_g_p[x_a][27] = {  61,   62,   63,   64,   65,   66,   67,   68,   69}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax17");
  needed_g_p[x_a][28] = {  70,   71,   72,   73,   74,   75,   76,   77,   78,   81}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax18");
  needed_g_p[x_a][29] = {  70,   71,   72,   76,   77,   78,   81}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax19");
  needed_g_p[x_a][30] = {  70,   71}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax20");
  needed_g_p[x_a][31] = {  70}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax21");
  needed_g_p[x_a][32] = {  71}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax21");
  needed_g_p[x_a][33] = {  72}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax22");
  needed_g_p[x_a][34] = {  72}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax21");
  needed_g_p[x_a][35] = {  73,   74,   75}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax23");
  needed_g_p[x_a][36] = {  73,   74}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax24");
  needed_g_p[x_a][37] = {  73}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax21");
  needed_g_p[x_a][38] = {  74}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax21");
  needed_g_p[x_a][39] = {  75}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax25");
  needed_g_p[x_a][40] = {  75}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax21");
  needed_g_p[x_a][41] = {  76,   77,   78,   81,   82}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax26");
  needed_g_p[x_a][42] = {  76}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax21");
  needed_g_p[x_a][43] = {  77}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax21");
  needed_g_p[x_a][44] = {  78}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax21");
  needed_g_p[x_a][45] = {  82}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax27");
  needed_g_p[x_a][46] = {  83}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin17_smax28");

  g_f[x_a].resize(8);
  needed_g_f[x_a].resize(8);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8}; //   9
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][1] = {  50,   51,   52,   53,   54,   55,   56,   57,   58}; //   9
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax11");
  needed_g_f[x_a][2] = {  59}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax29");
  needed_g_f[x_a][3] = {  59,   60}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax8");
  needed_g_f[x_a][4] = {  79,   80}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax11");
  needed_g_f[x_a][5] = {  80}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax15");
  needed_g_f[x_a][6] = {  81,   82}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax30");
  needed_g_f[x_a][7] = {  83}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax21");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   59,   60}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7,    8}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__130_1__64_60");
  needed_g_t[x_a][2] = {  40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   79,   80}; //  21
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][3] = {  50,   51,   52,   53,   54,   55,   56,   57,   58}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__65_2__128_60");
  needed_g_t[x_a][4] = {  59,   60}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_130__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_130__36_88");
  needed_g_t[x_a][5] = {  59}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__130_37__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__130_37__64_24");
  needed_g_t[x_a][6] = {  61,   62,   63,   64,   65,   66,   67,   68,   69,   83}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__192_60");
  needed_g_t[x_a][7] = {  70,   71,   72,   73,   74,   75,   76,   77,   78}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__192_60");
  needed_g_t[x_a][8] = {  79,   80}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_65__24_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_65__24_164");
  needed_g_t[x_a][9] = {  80}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__65_26__128_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__65_26__128_36");
  needed_g_t[x_a][10] = {  81,   82}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__36_216");
  needed_g_t[x_a][11] = {  81}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_37__192_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_37__192_24");
  needed_g_t[x_a][12] = {  82}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_37__24_192");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_37__24_192");
  needed_g_t[x_a][13] = {  83}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_193__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_193__24_36");

  g_d[x_a].resize(21);
  needed_g_d[x_a].resize(21);
  needed_g_d[x_a][0] = {   0,    1,    9,   10,   19,   20,   21,   22,   40,   41,   50,   51,   61,   62,   70,   71}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    9,   10,   19,   20,   21,   22,   40,   41,   50,   51,   61,   62,   70,   71}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   46,   47,   48,   49,   50,   51,   52,   56,   57,   58,   59,   60,   61,   62,   63,   67,   68,   69,   70,   71,   72,   76,   77,   78,   79,   80,   81,   82,   83}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   2,   11,   23,   24,   42,   52,   63,   72}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2,   11,   23,   24,   42,   52,   63,   72}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3,    4,   12,   13,   25,   26,   27,   28,   43,   44,   53,   54,   64,   65,   73,   74}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    4,   12,   13,   25,   26,   27,   28,   43,   44,   53,   54,   64,   65,   73,   74}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   3,    4,    5,    6,    7,    8,   12,   13,   14,   15,   16,   17,   18,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   43,   44,   45,   46,   47,   48,   49,   53,   54,   55,   56,   57,   58,   59,   60,   64,   65,   66,   67,   68,   69,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83}; //  60
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {   5,   14,   29,   30,   45,   55,   66,   75}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   5,   14,   29,   30,   45,   55,   66,   75}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {   6,    7,    8,   15,   16,   17,   31,   32,   33,   34,   35,   36,   46,   47,   48,   56,   57,   58,   67,   68,   69,   76,   77,   78}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][11] = {   9,   10,   11,   12,   13,   14,   15,   16,   17,   21,   22,   24,   27,   28,   30,   34,   35,   36}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][12] = {  18,   37}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][13] = {  18,   37,   39,   60}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][14] = {  19,   20,   23,   25,   26,   29,   31,   32,   33,   38}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][15] = {  19,   20,   23,   25,   26,   29,   31,   32,   33,   40,   41,   42,   43,   44,   45,   46,   47,   48}; //  18
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][16] = {  21,   22,   24,   27,   28,   30,   34,   35,   36,   37}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__128_124");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__128_124");
  needed_g_d[x_a][17] = {  38,   49}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__24_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__24_164");
  needed_g_d[x_a][18] = {  38,   39,   49,   79}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_164__128_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_164__128_36");
  needed_g_d[x_a][19] = {  39}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__88_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__88_164");
  needed_g_d[x_a][20] = {  61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   81,   82,   83}; //  21
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");

  c_p[x_a].resize(84);
  c_f[x_a].resize(84);
  c_t[x_a].resize(84);
  c_d[x_a].resize(84);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  0,   1}; //   2
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  6,   7,   9}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  5,   6,   7}; //   3

  c_p[x_a][5] = {  6,  10,  11}; //   3
  c_f[x_a][5] = {  0}; //   1
  c_t[x_a][5] = {  0,   1}; //   2
  c_d[x_a][5] = {  8,   9,   7}; //   3

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = { 10,   7,   2}; //   3

  c_p[x_a][7] = {  0,  12,  14}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = { 10,   7,   2}; //   3

  c_p[x_a][8] = {  0,  12,  15}; //   3
  c_f[x_a][8] = {  0}; //   1
  c_t[x_a][8] = {  0,   1}; //   2
  c_d[x_a][8] = { 10,   7,   2}; //   3

  c_p[x_a][9] = {  0,   1,   2,  16}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 11,   0,   1,   2}; //   4

  c_p[x_a][10] = {  0,   1,   3,  16}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = { 11,   0,   1,   2}; //   4

  c_p[x_a][11] = {  0,   4,   5,  16}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = { 11,   3,   4,   2}; //   4

  c_p[x_a][12] = {  6,   7,   8,  16}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = { 11,   5,   6,   7}; //   4

  c_p[x_a][13] = {  6,   7,   9,  16}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  0}; //   1
  c_d[x_a][13] = { 11,   5,   6,   7}; //   4

  c_p[x_a][14] = {  6,  10,  11,  16}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  0}; //   1
  c_d[x_a][14] = { 11,   8,   9,   7}; //   4

  c_p[x_a][15] = {  0,  12,  13,  16}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  0}; //   1
  c_d[x_a][15] = { 11,  10,   7,   2}; //   4

  c_p[x_a][16] = {  0,  12,  14,  16}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  0}; //   1
  c_d[x_a][16] = { 11,  10,   7,   2}; //   4

  c_p[x_a][17] = {  0,  12,  15,  16}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  0}; //   1
  c_d[x_a][17] = { 11,  10,   7,   2}; //   4

  c_p[x_a][18] = {  0,  17,  18,  19}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 12,   7,  13,   2}; //   4

  c_p[x_a][19] = {  0,   1,   2,  20}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 14,  15,   0,   1,   2}; //   5

  c_p[x_a][20] = {  0,   1,   3,  20}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 14,  15,   0,   1,   2}; //   5

  c_p[x_a][21] = {  0,   1,   2,  16}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 16,  11,   0,   1,   2}; //   5

  c_p[x_a][22] = {  0,   1,   3,  16}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 16,  11,   0,   1,   2}; //   5

  c_p[x_a][23] = {  0,   4,   5,  20}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 14,  15,   3,   4,   2}; //   5

  c_p[x_a][24] = {  0,   4,   5,  16}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 16,  11,   3,   4,   2}; //   5

  c_p[x_a][25] = {  6,   7,   8,  20}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 14,  15,   5,   6,   7}; //   5

  c_p[x_a][26] = {  6,   7,   9,  20}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 14,  15,   5,   6,   7}; //   5

  c_p[x_a][27] = {  6,   7,   8,  16}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 16,  11,   5,   6,   7}; //   5

  c_p[x_a][28] = {  6,   7,   9,  16}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 16,  11,   5,   6,   7}; //   5

  c_p[x_a][29] = {  6,  10,  11,  20}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 14,  15,   8,   9,   7}; //   5

  c_p[x_a][30] = {  6,  10,  11,  16}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 16,  11,   8,   9,   7}; //   5

  c_p[x_a][31] = {  0,  12,  13,  20}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 14,  15,  10,   7,   2}; //   5

  c_p[x_a][32] = {  0,  12,  14,  20}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 14,  15,  10,   7,   2}; //   5

  c_p[x_a][33] = {  0,  12,  15,  20}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 14,  15,  10,   7,   2}; //   5

  c_p[x_a][34] = {  0,  12,  13,  16}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 16,  11,  10,   7,   2}; //   5

  c_p[x_a][35] = {  0,  12,  14,  16}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 16,  11,  10,   7,   2}; //   5

  c_p[x_a][36] = {  0,  12,  15,  16}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 16,  11,  10,   7,   2}; //   5

  c_p[x_a][37] = {  0,  17,  18,  19}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 16,  12,   7,  13,   2}; //   5

  c_p[x_a][38] = {  6,  21,  22,  23}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {}; //   0
  c_d[x_a][38] = { 14,  17,   2,  18,   7}; //   5

  c_p[x_a][39] = {  6,  24,  25,  26}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {}; //   0
  c_d[x_a][39] = { 19,  13,  18,   2,   7}; //   5

  c_p[x_a][40] = {  0,   1,   2,  20}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  2}; //   1
  c_d[x_a][40] = { 15,   0,   1,   2}; //   4

  c_p[x_a][41] = {  0,   1,   3,  20}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  2}; //   1
  c_d[x_a][41] = { 15,   0,   1,   2}; //   4

  c_p[x_a][42] = {  0,   4,   5,  20}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  2}; //   1
  c_d[x_a][42] = { 15,   3,   4,   2}; //   4

  c_p[x_a][43] = {  6,   7,   8,  20}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  2}; //   1
  c_d[x_a][43] = { 15,   5,   6,   7}; //   4

  c_p[x_a][44] = {  6,   7,   9,  20}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  2}; //   1
  c_d[x_a][44] = { 15,   5,   6,   7}; //   4

  c_p[x_a][45] = {  6,  10,  11,  20}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  2}; //   1
  c_d[x_a][45] = { 15,   8,   9,   7}; //   4

  c_p[x_a][46] = {  0,  12,  13,  20}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  2}; //   1
  c_d[x_a][46] = { 15,  10,   7,   2}; //   4

  c_p[x_a][47] = {  0,  12,  14,  20}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  2}; //   1
  c_d[x_a][47] = { 15,  10,   7,   2}; //   4

  c_p[x_a][48] = {  0,  12,  15,  20}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  2}; //   1
  c_d[x_a][48] = { 15,  10,   7,   2}; //   4

  c_p[x_a][49] = {  6,  21,  22,  23}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  2}; //   1
  c_d[x_a][49] = { 17,   2,  18,   7}; //   4

  c_p[x_a][50] = {  0,   1,   2}; //   3
  c_f[x_a][50] = {  1}; //   1
  c_t[x_a][50] = {  2,   3}; //   2
  c_d[x_a][50] = {  0,   1,   2}; //   3

  c_p[x_a][51] = {  0,   1,   3}; //   3
  c_f[x_a][51] = {  1}; //   1
  c_t[x_a][51] = {  2,   3}; //   2
  c_d[x_a][51] = {  0,   1,   2}; //   3

  c_p[x_a][52] = {  0,   4,   5}; //   3
  c_f[x_a][52] = {  1}; //   1
  c_t[x_a][52] = {  2,   3}; //   2
  c_d[x_a][52] = {  3,   4,   2}; //   3

  c_p[x_a][53] = {  6,   7,   8}; //   3
  c_f[x_a][53] = {  1}; //   1
  c_t[x_a][53] = {  2,   3}; //   2
  c_d[x_a][53] = {  5,   6,   7}; //   3

  c_p[x_a][54] = {  6,   7,   9}; //   3
  c_f[x_a][54] = {  1}; //   1
  c_t[x_a][54] = {  2,   3}; //   2
  c_d[x_a][54] = {  5,   6,   7}; //   3

  c_p[x_a][55] = {  6,  10,  11}; //   3
  c_f[x_a][55] = {  1}; //   1
  c_t[x_a][55] = {  2,   3}; //   2
  c_d[x_a][55] = {  8,   9,   7}; //   3

  c_p[x_a][56] = {  0,  12,  13}; //   3
  c_f[x_a][56] = {  1}; //   1
  c_t[x_a][56] = {  2,   3}; //   2
  c_d[x_a][56] = { 10,   7,   2}; //   3

  c_p[x_a][57] = {  0,  12,  14}; //   3
  c_f[x_a][57] = {  1}; //   1
  c_t[x_a][57] = {  2,   3}; //   2
  c_d[x_a][57] = { 10,   7,   2}; //   3

  c_p[x_a][58] = {  0,  12,  15}; //   3
  c_f[x_a][58] = {  1}; //   1
  c_t[x_a][58] = {  2,   3}; //   2
  c_d[x_a][58] = { 10,   7,   2}; //   3

  c_p[x_a][59] = {  0,  12}; //   2
  c_f[x_a][59] = {  2,   3}; //   2
  c_t[x_a][59] = {  0,   4,   5}; //   3
  c_d[x_a][59] = {  7,   2}; //   2

  c_p[x_a][60] = {  0,  17,  18}; //   3
  c_f[x_a][60] = {  3}; //   1
  c_t[x_a][60] = {  0,   4}; //   2
  c_d[x_a][60] = {  7,  13,   2}; //   3

  c_p[x_a][61] = {  0,   1,   2,  27}; //   4
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  6}; //   1
  c_d[x_a][61] = { 20,   0,   1,   2}; //   4

  c_p[x_a][62] = {  0,   1,   3,  27}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  6}; //   1
  c_d[x_a][62] = { 20,   0,   1,   2}; //   4

  c_p[x_a][63] = {  0,   4,   5,  27}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  6}; //   1
  c_d[x_a][63] = { 20,   3,   4,   2}; //   4

  c_p[x_a][64] = {  6,   7,   8,  27}; //   4
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  6}; //   1
  c_d[x_a][64] = { 20,   5,   6,   7}; //   4

  c_p[x_a][65] = {  6,   7,   9,  27}; //   4
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  6}; //   1
  c_d[x_a][65] = { 20,   5,   6,   7}; //   4

  c_p[x_a][66] = {  6,  10,  11,  27}; //   4
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  6}; //   1
  c_d[x_a][66] = { 20,   8,   9,   7}; //   4

  c_p[x_a][67] = {  0,  12,  13,  27}; //   4
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  6}; //   1
  c_d[x_a][67] = { 20,  10,   7,   2}; //   4

  c_p[x_a][68] = {  0,  12,  14,  27}; //   4
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  6}; //   1
  c_d[x_a][68] = { 20,  10,   7,   2}; //   4

  c_p[x_a][69] = {  0,  12,  15,  27}; //   4
  c_f[x_a][69] = {}; //   0
  c_t[x_a][69] = {  6}; //   1
  c_d[x_a][69] = { 20,  10,   7,   2}; //   4

  c_p[x_a][70] = { 28,  29,  30,  31}; //   4
  c_f[x_a][70] = {}; //   0
  c_t[x_a][70] = {  7}; //   1
  c_d[x_a][70] = {  0,   1,   2,  20}; //   4

  c_p[x_a][71] = { 28,  29,  30,  32}; //   4
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {  7}; //   1
  c_d[x_a][71] = {  0,   1,   2,  20}; //   4

  c_p[x_a][72] = { 28,  29,  33,  34}; //   4
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {  7}; //   1
  c_d[x_a][72] = {  3,   4,   2,  20}; //   4

  c_p[x_a][73] = { 28,  35,  36,  37}; //   4
  c_f[x_a][73] = {}; //   0
  c_t[x_a][73] = {  7}; //   1
  c_d[x_a][73] = {  5,   6,   7,  20}; //   4

  c_p[x_a][74] = { 28,  35,  36,  38}; //   4
  c_f[x_a][74] = {}; //   0
  c_t[x_a][74] = {  7}; //   1
  c_d[x_a][74] = {  5,   6,   7,  20}; //   4

  c_p[x_a][75] = { 28,  35,  39,  40}; //   4
  c_f[x_a][75] = {}; //   0
  c_t[x_a][75] = {  7}; //   1
  c_d[x_a][75] = {  8,   9,   7,  20}; //   4

  c_p[x_a][76] = { 28,  29,  41,  42}; //   4
  c_f[x_a][76] = {}; //   0
  c_t[x_a][76] = {  7}; //   1
  c_d[x_a][76] = { 10,   7,   2,  20}; //   4

  c_p[x_a][77] = { 28,  29,  41,  43}; //   4
  c_f[x_a][77] = {}; //   0
  c_t[x_a][77] = {  7}; //   1
  c_d[x_a][77] = { 10,   7,   2,  20}; //   4

  c_p[x_a][78] = { 28,  29,  41,  44}; //   4
  c_f[x_a][78] = {}; //   0
  c_t[x_a][78] = {  7}; //   1
  c_d[x_a][78] = { 10,   7,   2,  20}; //   4

  c_p[x_a][79] = {  0,  12,  25}; //   3
  c_f[x_a][79] = {  4}; //   1
  c_t[x_a][79] = {  2,   8}; //   2
  c_d[x_a][79] = { 18,   7,   2}; //   3

  c_p[x_a][80] = {  0,  12}; //   2
  c_f[x_a][80] = {  5,   4}; //   2
  c_t[x_a][80] = {  2,   8,   9}; //   3
  c_d[x_a][80] = {  7,   2}; //   2

  c_p[x_a][81] = { 28,  29,  41}; //   3
  c_f[x_a][81] = {  6}; //   1
  c_t[x_a][81] = { 10,  11}; //   2
  c_d[x_a][81] = {  7,   2,  20}; //   3

  c_p[x_a][82] = {  0,  45,  41}; //   3
  c_f[x_a][82] = {  6}; //   1
  c_t[x_a][82] = { 10,  12}; //   2
  c_d[x_a][82] = {  7,  20,   2}; //   3

  c_p[x_a][83] = {  0,  12,  46}; //   3
  c_f[x_a][83] = {  7}; //   1
  c_t[x_a][83] = {  6,  13}; //   2
  c_d[x_a][83] = { 20,   7,   2}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_bbx_emmupvmvexbbx
//  channel    0: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,   0,   0,   5)
//  channel    1: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,  23,   0,   5)
//  channel    2: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;  24,   0,  23,   0,   5)
//  channel    3: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,   0,   0,   5)
//  channel    4: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,  23,   0,   5)
//  channel    5: 4yyv11(1, 2, 16, 8, 4, 32, 64, 128;  24,   0,  23,   0,   5)
//  channel    6: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   5)
//  channel    7: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  23,   0,   5)
//  channel    8: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  25,   0,   5)
//  channel    9: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   5,   0)
//  channel   10: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   5,   0)
//  channel   11: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   5,   0)
//  channel   12: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   5,   0)
//  channel   13: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   5,   0)
//  channel   14: 5yyyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   5,   0)
//  channel   15: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   5,   0)
//  channel   16: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   5,   0)
//  channel   17: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  25,   5,   0)
//  channel   18: 52vyv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   6,  24,   5,   0)
//  channel   19: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   0)
//  channel   20: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   0)
//  channel   21: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   5,   0)
//  channel   22: 6yyyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   5,   0)
//  channel   23: 6yyyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   0)
//  channel   24: 6yyyyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   5,   0)
//  channel   25: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   0)
//  channel   26: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   0)
//  channel   27: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   5,   0)
//  channel   28: 6yyyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   5,   0)
//  channel   29: 6yyyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   0)
//  channel   30: 6yyyyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   5,   0)
//  channel   31: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   0)
//  channel   32: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   0)
//  channel   33: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   0)
//  channel   34: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   5,   0)
//  channel   35: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   5,   0)
//  channel   36: 6yy2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  25,   5,   0)
//  channel   37: 6y2vyv(1, 2, 128, 4, 32, 64, 8, 16;  24,   6,  24,   5,   0)
//  channel   38: 6y2vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   6,  24,   5,   0)
//  channel   39: 63yvyv(1, 2, 64, 8, 16, 128, 4, 32;  24,  24,   6,   6,   0)
//  channel   40: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   5,   0)
//  channel   41: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   5,   0)
//  channel   42: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   5,   0)
//  channel   43: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   5,   0)
//  channel   44: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   5,   0)
//  channel   45: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   5,   0)
//  channel   46: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   0)
//  channel   47: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   5,   0)
//  channel   48: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   5,   0)
//  channel   49: 152vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   6,  24,   5,   0)
//  channel   50: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   5)
//  channel   51: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   5)
//  channel   52: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   5)
//  channel   53: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   5)
//  channel   54: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   5)
//  channel   55: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   5)
//  channel   56: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   5)
//  channel   57: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   5)
//  channel   58: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   0,   5)
//  channel   59: 2v2v11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   6,   5)
//  channel   60: 2v3yv1(1, 2, 4, 32, 64, 8, 16, 128;  24,   6,  24,   0,   6)
//  channel   61: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   5)
//  channel   62: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   5)
//  channel   63: 2v4yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   5)
//  channel   64: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   5)
//  channel   65: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   5)
//  channel   66: 2v4yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   5)
//  channel   67: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   5)
//  channel   68: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   5)
//  channel   69: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  25,   0,   5)
//  channel   70: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,   0,   5)
//  channel   71: 4yyv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,  23,   5)
//  channel   72: 4yyv2v(1, 2, 32, 4, 8, 16, 64, 128;   0,  24,   0,  23,   5)
//  channel   73: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,   0,   5)
//  channel   74: 4yyv2v(1, 2, 8, 16, 4, 32, 64, 128;   0,  24,   0,  23,   5)
//  channel   75: 4yyv2v(1, 2, 16, 8, 4, 32, 64, 128;   0,  24,   0,  23,   5)
//  channel   76: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   0,   5)
//  channel   77: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,  23,   5)
//  channel   78: 42vv2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,  25,   5)
//  channel   79: 13yv2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   6,   0,   6)
//  channel   80: 112v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   6,   5)
//  channel   81: 2v2v2v(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,  24,   6,   5)
//  channel   82: 2v2v2v(1, 2, 4, 32, 64, 128, 8, 16;  24,   0,  24,   6,   6)
//  channel   83: 2v2v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   5,   6)
