#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_dxdx_emmupvmvexdxdx(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_dxdx_emmupvmvexdxdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(17);
  needed_v_smin[x_a].resize(17);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75}; //  52
  needed_v_smin[x_a][  1] = {   0,    1,    2,    3,   16,   17,   18,   19,   34,   35,   36,   37,   52,   53,   54,   55}; //  16
  needed_v_smin[x_a][  2] = {   0,    1,    2,    3,   16,   17,   18,   19,   34,   35,   36,   37,   52,   53,   54,   55}; //  16
  needed_v_smin[x_a][  3] = {   4,    5,   20,   21,   38,   39,   56,   57}; //   8
  needed_v_smin[x_a][  4] = {   4,    5,   20,   21,   38,   39,   56,   57}; //   8
  needed_v_smin[x_a][  5] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75}; //  52
  needed_v_smin[x_a][  6] = {   6,    7,    8,    9,   22,   23,   24,   25,   40,   41,   42,   43,   58,   59,   60,   61}; //  16
  needed_v_smin[x_a][  7] = {   6,    7,    8,    9,   22,   23,   24,   25,   40,   41,   42,   43,   58,   59,   60,   61}; //  16
  needed_v_smin[x_a][  8] = {  10,   11,   26,   27,   44,   45,   62,   63}; //   8
  needed_v_smin[x_a][  9] = {  10,   11,   26,   27,   44,   45,   62,   63}; //   8
  needed_v_smin[x_a][ 10] = {  12,   13,   14,   15,   28,   29,   30,   31,   46,   47,   48,   49,   64,   65,   66,   67}; //  16
  needed_v_smin[x_a][ 11] = {  16,   17,   20,   22,   23,   26,   28,   29,   34,   35,   38,   40,   41,   44,   46,   47,    2,    3,    5,    8,    9,   11,   14,   15,   52,   53,   56,   58,   59,   62,   64,   65}; //  32
  needed_v_smin[x_a][ 12] = {  18,   19,   21,   24,   25,   27,   30,   31,   36,   37,   39,   42,   43,   45,   48,   49,    0,    1,    4,    6,    7,   10,   12,   13,   54,   55,   57,   60,   61,   63,   66,   67}; //  32
  needed_v_smin[x_a][ 13] = {  32,   51,   70,   72,   69,   74}; //   6
  needed_v_smin[x_a][ 14] = {  32,   51,   69,   70,   72,   74}; //   6
  needed_v_smin[x_a][ 15] = {  33,   50,   71,   73,   68,   75}; //   6
  needed_v_smin[x_a][ 16] = {  33,   50,   68,   71,   73,   75}; //   6

  v_smax[x_a].resize(17);
  needed_v_smax[x_a].resize(17);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   34,   35,   36,   37,   38,   39,   46,   47,   48,   49,   52,   53,   54,   55,   56,   57,   64,   65,   66,   67,   72,   73,   74,   75}; //  44
  needed_v_smax[x_a][  1] = {   0,    1,    2,    3,   16,   17,   18,   19,   34,   35,   36,   37,   52,   53,   54,   55}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67}; //  64
  needed_v_smax[x_a][  3] = {   4,    5,   20,   21,   38,   39,   56,   57}; //   8
  needed_v_smax[x_a][  4] = {   6,    7,    8,    9,   10,   11,   22,   23,   24,   25,   26,   27,   32,   33,   40,   41,   42,   43,   44,   45,   50,   51,   58,   59,   60,   61,   62,   63,   68,   69,   70,   71}; //  32
  needed_v_smax[x_a][  5] = {   6,    7,    8,    9,   22,   23,   24,   25,   40,   41,   42,   43,   58,   59,   60,   61}; //  16
  needed_v_smax[x_a][  6] = {  10,   11,   26,   27,   44,   45,   62,   63}; //   8
  needed_v_smax[x_a][  7] = {  12,   13,   14,   15,   28,   29,   30,   31,   46,   47,   48,   49,   64,   65,   66,   67,   72,   73,   74,   75}; //  20
  needed_v_smax[x_a][  8] = {  16,   17,   20,   22,   23,   26,   28,   29,   32,   34,   35,   38,   40,   41,   44,   46,   47,   51,    2,    3,    5,    8,    9,   11,   14,   15,   52,   53,   56,   58,   59,   62,   64,   65,   69,   70,   72,   74}; //  38
  needed_v_smax[x_a][  9] = {  18,   19,   21,   24,   25,   27,   30,   31,   33,   36,   37,   39,   42,   43,   45,   48,   49,   50,    0,    1,    4,    6,    7,   10,   12,   13,   54,   55,   57,   60,   61,   63,   66,   67,   68,   71,   73,   75}; //  38
  needed_v_smax[x_a][ 10] = {  32,   51,   70}; //   3
  needed_v_smax[x_a][ 11] = {  32,   51,   70}; //   3
  needed_v_smax[x_a][ 12] = {  33,   50,   71}; //   3
  needed_v_smax[x_a][ 13] = {  33,   50,   71}; //   3
  needed_v_smax[x_a][ 14] = {  68,   69}; //   2
  needed_v_smax[x_a][ 15] = {  72,   69,   74}; //   3
  needed_v_smax[x_a][ 16] = {  73,   68,   75}; //   3

  g_p[x_a].resize(26);
  needed_g_p[x_a].resize(26);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   34,   35,   36,   37,   38,   39,   46,   47,   48,   49,   52,   53,   54,   55,   56,   57,   64,   65,   66,   67,   72,   73,   74,   75}; //  44
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    2,    3,   16,   17,   18,   19,   34,   35,   36,   37,   52,   53,   54,   55}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    2,   16,   18,   34,   36,   52,   54}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    3,   17,   19,   35,   37,   53,   55}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   4,    5,   20,   21,   38,   39,   56,   57}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   4,    5,   20,   21,   38,   39,   56,   57}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   6,    7,    8,    9,   10,   11,   22,   23,   24,   25,   26,   27,   32,   33,   40,   41,   42,   43,   44,   45,   50,   51,   58,   59,   60,   61,   62,   63,   68,   69,   70,   71}; //  32
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   6,    7,    8,    9,   22,   23,   24,   25,   40,   41,   42,   43,   58,   59,   60,   61}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   6,    8,   22,   24,   40,   42,   58,   60}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   7,    9,   23,   25,   41,   43,   59,   61}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {  10,   11,   26,   27,   44,   45,   62,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {  10,   11,   26,   27,   44,   45,   62,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {  12,   13,   14,   15,   28,   29,   30,   31,   46,   47,   48,   49,   64,   65,   66,   67,   72,   73,   74,   75}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {  12,   14,   28,   30,   46,   48,   64,   66}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {  13,   15,   29,   31,   47,   49,   65,   67}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {  16,   17,   20,   22,   23,   26,   28,   29,   34,   35,   38,   40,   41,   44,   46,   47}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][16] = {  18,   19,   21,   24,   25,   27,   30,   31,   36,   37,   39,   42,   43,   45,   48,   49}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][17] = {  32,   51,   70}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax10");
  needed_g_p[x_a][18] = {  32,   51,   70}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax11");
  needed_g_p[x_a][19] = {  32,   51}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax8");
  needed_g_p[x_a][20] = {  33,   50,   71}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax12");
  needed_g_p[x_a][21] = {  33,   50,   71}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax13");
  needed_g_p[x_a][22] = {  33,   50}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax9");
  needed_g_p[x_a][23] = {  68,   69}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax14");
  needed_g_p[x_a][24] = {  72}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax15");
  needed_g_p[x_a][25] = {  73}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax16");

  g_f[x_a].resize(6);
  needed_g_f[x_a].resize(6);
  needed_g_f[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   54,   55,   57,   60,   61,   63,   66,   67}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax9");
  needed_g_f[x_a][1] = {   2,    3,    5,    8,    9,   11,   14,   15,   52,   53,   56,   58,   59,   62,   64,   65}; //  16
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax8");
  needed_g_f[x_a][2] = {  68,   75}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax16");
  needed_g_f[x_a][3] = {  68,   71,   73,   75}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax9");
  needed_g_f[x_a][4] = {  69,   74}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax15");
  needed_g_f[x_a][5] = {  69,   70,   72,   74}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax8");

  g_t[x_a].resize(16);
  needed_g_t[x_a].resize(16);
  needed_g_t[x_a][0] = {   0,    1,    4,    6,    7,   10,   12,   13,   18,   19,   21,   24,   25,   27,   30,   31,   33,   68,   71}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__128_124");
  needed_g_t[x_a][1] = {   0,    1,    4,    6,    7,   10,   12,   13}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__130_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__130_1__64_60");
  needed_g_t[x_a][2] = {   2,    3,    5,    8,    9,   11,   14,   15,   16,   17,   20,   22,   23,   26,   28,   29,   32,   69,   70}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_188");
  needed_g_t[x_a][3] = {   2,    3,    5,    8,    9,   11,   14,   15}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__128_60");
  needed_g_t[x_a][4] = {  34,   35,   38,   40,   41,   44,   46,   47,   51,   52,   53,   56,   58,   59,   62,   64,   65,   72,   74}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][5] = {  36,   37,   39,   42,   43,   45,   48,   49,   50,   54,   55,   57,   60,   61,   63,   66,   67,   73,   75}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__128_124");
  needed_g_t[x_a][6] = {  52,   53,   56,   58,   59,   62,   64,   65}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][7] = {  54,   55,   57,   60,   61,   63,   66,   67}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__129_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__129_2__64_60");
  needed_g_t[x_a][8] = {  68,   71}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_130__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_130__24_100");
  needed_g_t[x_a][9] = {  68}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__130_25__64_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__130_25__64_36");
  needed_g_t[x_a][10] = {  69,   70}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__24_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__24_164");
  needed_g_t[x_a][11] = {  69}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_25__128_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_25__128_36");
  needed_g_t[x_a][12] = {  72,   74}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__24_164");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__24_164");
  needed_g_t[x_a][13] = {  73,   75}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__24_100");
  needed_g_t[x_a][14] = {  74}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_26__128_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_26__128_36");
  needed_g_t[x_a][15] = {  75}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_26__64_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_26__64_36");

  g_d[x_a].resize(17);
  needed_g_d[x_a].resize(17);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,   16,   17,   18,   19,   34,   35,   36,   37,   52,   53,   54,   55}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,   16,   17,   18,   19,   34,   35,   36,   37,   52,   53,   54,   55}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   4,    5,   20,   21,   38,   39,   56,   57}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   4,    5,   20,   21,   38,   39,   56,   57}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   6,    7,    8,    9,   22,   23,   24,   25,   40,   41,   42,   43,   58,   59,   60,   61}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   6,    7,    8,    9,   22,   23,   24,   25,   40,   41,   42,   43,   58,   59,   60,   61}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75}; //  52
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {  10,   11,   26,   27,   44,   45,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {  10,   11,   26,   27,   44,   45,   62,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {  12,   13,   14,   15,   28,   29,   30,   31,   46,   47,   48,   49,   64,   65,   66,   67}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][11] = {  16,   17,   20,   22,   23,   26,   28,   29,   34,   35,   38,   40,   41,   44,   46,   47}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][12] = {  18,   19,   21,   24,   25,   27,   30,   31,   36,   37,   39,   42,   43,   45,   48,   49}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][13] = {  32,   51}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__24_164");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__24_164");
  needed_g_d[x_a][14] = {  32,   51,   70,   72}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_164__128_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_164__128_36");
  needed_g_d[x_a][15] = {  33,   50}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");
  needed_g_d[x_a][16] = {  33,   50,   71,   73}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");

  c_p[x_a].resize(76);
  c_f[x_a].resize(76);
  c_t[x_a].resize(76);
  c_d[x_a].resize(76);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   1}; //   2
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   1,   2}; //   3
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  2,   3}; //   2
  c_d[x_a][2] = {  0,   1,   2}; //   3

  c_p[x_a][3] = {  0,   1,   3}; //   3
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  0,   1,   2}; //   3

  c_p[x_a][4] = {  0,   4,   5}; //   3
  c_f[x_a][4] = {  0}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  3,   4,   2}; //   3

  c_p[x_a][5] = {  0,   4,   5}; //   3
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  2,   3}; //   2
  c_d[x_a][5] = {  3,   4,   2}; //   3

  c_p[x_a][6] = {  6,   7,   8}; //   3
  c_f[x_a][6] = {  0}; //   1
  c_t[x_a][6] = {  0,   1}; //   2
  c_d[x_a][6] = {  5,   6,   7}; //   3

  c_p[x_a][7] = {  6,   7,   9}; //   3
  c_f[x_a][7] = {  0}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = {  5,   6,   7}; //   3

  c_p[x_a][8] = {  6,   7,   8}; //   3
  c_f[x_a][8] = {  1}; //   1
  c_t[x_a][8] = {  2,   3}; //   2
  c_d[x_a][8] = {  5,   6,   7}; //   3

  c_p[x_a][9] = {  6,   7,   9}; //   3
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  2,   3}; //   2
  c_d[x_a][9] = {  5,   6,   7}; //   3

  c_p[x_a][10] = {  6,  10,  11}; //   3
  c_f[x_a][10] = {  0}; //   1
  c_t[x_a][10] = {  0,   1}; //   2
  c_d[x_a][10] = {  8,   9,   7}; //   3

  c_p[x_a][11] = {  6,  10,  11}; //   3
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  2,   3}; //   2
  c_d[x_a][11] = {  8,   9,   7}; //   3

  c_p[x_a][12] = {  0,  12,  13}; //   3
  c_f[x_a][12] = {  0}; //   1
  c_t[x_a][12] = {  0,   1}; //   2
  c_d[x_a][12] = { 10,   7,   2}; //   3

  c_p[x_a][13] = {  0,  12,  14}; //   3
  c_f[x_a][13] = {  0}; //   1
  c_t[x_a][13] = {  0,   1}; //   2
  c_d[x_a][13] = { 10,   7,   2}; //   3

  c_p[x_a][14] = {  0,  12,  13}; //   3
  c_f[x_a][14] = {  1}; //   1
  c_t[x_a][14] = {  2,   3}; //   2
  c_d[x_a][14] = { 10,   7,   2}; //   3

  c_p[x_a][15] = {  0,  12,  14}; //   3
  c_f[x_a][15] = {  1}; //   1
  c_t[x_a][15] = {  2,   3}; //   2
  c_d[x_a][15] = { 10,   7,   2}; //   3

  c_p[x_a][16] = {  0,   1,   2,  15}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  2}; //   1
  c_d[x_a][16] = { 11,   0,   1,   2}; //   4

  c_p[x_a][17] = {  0,   1,   3,  15}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  2}; //   1
  c_d[x_a][17] = { 11,   0,   1,   2}; //   4

  c_p[x_a][18] = {  0,   1,   2,  16}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = { 12,   0,   1,   2}; //   4

  c_p[x_a][19] = {  0,   1,   3,  16}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = { 12,   0,   1,   2}; //   4

  c_p[x_a][20] = {  0,   4,   5,  15}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  2}; //   1
  c_d[x_a][20] = { 11,   3,   4,   2}; //   4

  c_p[x_a][21] = {  0,   4,   5,  16}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  0}; //   1
  c_d[x_a][21] = { 12,   3,   4,   2}; //   4

  c_p[x_a][22] = {  6,   7,   8,  15}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  2}; //   1
  c_d[x_a][22] = { 11,   5,   6,   7}; //   4

  c_p[x_a][23] = {  6,   7,   9,  15}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  2}; //   1
  c_d[x_a][23] = { 11,   5,   6,   7}; //   4

  c_p[x_a][24] = {  6,   7,   8,  16}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  0}; //   1
  c_d[x_a][24] = { 12,   5,   6,   7}; //   4

  c_p[x_a][25] = {  6,   7,   9,  16}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = { 12,   5,   6,   7}; //   4

  c_p[x_a][26] = {  6,  10,  11,  15}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  2}; //   1
  c_d[x_a][26] = { 11,   8,   9,   7}; //   4

  c_p[x_a][27] = {  6,  10,  11,  16}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  0}; //   1
  c_d[x_a][27] = { 12,   8,   9,   7}; //   4

  c_p[x_a][28] = {  0,  12,  13,  15}; //   4
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  2}; //   1
  c_d[x_a][28] = { 11,  10,   7,   2}; //   4

  c_p[x_a][29] = {  0,  12,  14,  15}; //   4
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  2}; //   1
  c_d[x_a][29] = { 11,  10,   7,   2}; //   4

  c_p[x_a][30] = {  0,  12,  13,  16}; //   4
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {  0}; //   1
  c_d[x_a][30] = { 12,  10,   7,   2}; //   4

  c_p[x_a][31] = {  0,  12,  14,  16}; //   4
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {  0}; //   1
  c_d[x_a][31] = { 12,  10,   7,   2}; //   4

  c_p[x_a][32] = {  6,  17,  18,  19}; //   4
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {  2}; //   1
  c_d[x_a][32] = { 13,   2,  14,   7}; //   4

  c_p[x_a][33] = {  6,  20,  21,  22}; //   4
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {  0}; //   1
  c_d[x_a][33] = { 15,   2,  16,   7}; //   4

  c_p[x_a][34] = {  0,   1,   2,  15}; //   4
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  4}; //   1
  c_d[x_a][34] = { 11,   0,   1,   2}; //   4

  c_p[x_a][35] = {  0,   1,   3,  15}; //   4
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  4}; //   1
  c_d[x_a][35] = { 11,   0,   1,   2}; //   4

  c_p[x_a][36] = {  0,   1,   2,  16}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  5}; //   1
  c_d[x_a][36] = { 12,   0,   1,   2}; //   4

  c_p[x_a][37] = {  0,   1,   3,  16}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  5}; //   1
  c_d[x_a][37] = { 12,   0,   1,   2}; //   4

  c_p[x_a][38] = {  0,   4,   5,  15}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  4}; //   1
  c_d[x_a][38] = { 11,   3,   4,   2}; //   4

  c_p[x_a][39] = {  0,   4,   5,  16}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  5}; //   1
  c_d[x_a][39] = { 12,   3,   4,   2}; //   4

  c_p[x_a][40] = {  6,   7,   8,  15}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  4}; //   1
  c_d[x_a][40] = { 11,   5,   6,   7}; //   4

  c_p[x_a][41] = {  6,   7,   9,  15}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  4}; //   1
  c_d[x_a][41] = { 11,   5,   6,   7}; //   4

  c_p[x_a][42] = {  6,   7,   8,  16}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  5}; //   1
  c_d[x_a][42] = { 12,   5,   6,   7}; //   4

  c_p[x_a][43] = {  6,   7,   9,  16}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  5}; //   1
  c_d[x_a][43] = { 12,   5,   6,   7}; //   4

  c_p[x_a][44] = {  6,  10,  11,  15}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  4}; //   1
  c_d[x_a][44] = { 11,   8,   9,   7}; //   4

  c_p[x_a][45] = {  6,  10,  11,  16}; //   4
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  5}; //   1
  c_d[x_a][45] = { 12,   8,   9,   7}; //   4

  c_p[x_a][46] = {  0,  12,  13,  15}; //   4
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = {  4}; //   1
  c_d[x_a][46] = { 11,  10,   7,   2}; //   4

  c_p[x_a][47] = {  0,  12,  14,  15}; //   4
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  4}; //   1
  c_d[x_a][47] = { 11,  10,   7,   2}; //   4

  c_p[x_a][48] = {  0,  12,  13,  16}; //   4
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  5}; //   1
  c_d[x_a][48] = { 12,  10,   7,   2}; //   4

  c_p[x_a][49] = {  0,  12,  14,  16}; //   4
  c_f[x_a][49] = {}; //   0
  c_t[x_a][49] = {  5}; //   1
  c_d[x_a][49] = { 12,  10,   7,   2}; //   4

  c_p[x_a][50] = {  6,  20,  21,  22}; //   4
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  5}; //   1
  c_d[x_a][50] = { 15,   2,  16,   7}; //   4

  c_p[x_a][51] = {  6,  17,  18,  19}; //   4
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  4}; //   1
  c_d[x_a][51] = { 13,   2,  14,   7}; //   4

  c_p[x_a][52] = {  0,   1,   2}; //   3
  c_f[x_a][52] = {  1}; //   1
  c_t[x_a][52] = {  4,   6}; //   2
  c_d[x_a][52] = {  0,   1,   2}; //   3

  c_p[x_a][53] = {  0,   1,   3}; //   3
  c_f[x_a][53] = {  1}; //   1
  c_t[x_a][53] = {  4,   6}; //   2
  c_d[x_a][53] = {  0,   1,   2}; //   3

  c_p[x_a][54] = {  0,   1,   2}; //   3
  c_f[x_a][54] = {  0}; //   1
  c_t[x_a][54] = {  5,   7}; //   2
  c_d[x_a][54] = {  0,   1,   2}; //   3

  c_p[x_a][55] = {  0,   1,   3}; //   3
  c_f[x_a][55] = {  0}; //   1
  c_t[x_a][55] = {  5,   7}; //   2
  c_d[x_a][55] = {  0,   1,   2}; //   3

  c_p[x_a][56] = {  0,   4,   5}; //   3
  c_f[x_a][56] = {  1}; //   1
  c_t[x_a][56] = {  4,   6}; //   2
  c_d[x_a][56] = {  3,   4,   2}; //   3

  c_p[x_a][57] = {  0,   4,   5}; //   3
  c_f[x_a][57] = {  0}; //   1
  c_t[x_a][57] = {  5,   7}; //   2
  c_d[x_a][57] = {  3,   4,   2}; //   3

  c_p[x_a][58] = {  6,   7,   8}; //   3
  c_f[x_a][58] = {  1}; //   1
  c_t[x_a][58] = {  4,   6}; //   2
  c_d[x_a][58] = {  5,   6,   7}; //   3

  c_p[x_a][59] = {  6,   7,   9}; //   3
  c_f[x_a][59] = {  1}; //   1
  c_t[x_a][59] = {  4,   6}; //   2
  c_d[x_a][59] = {  5,   6,   7}; //   3

  c_p[x_a][60] = {  6,   7,   8}; //   3
  c_f[x_a][60] = {  0}; //   1
  c_t[x_a][60] = {  5,   7}; //   2
  c_d[x_a][60] = {  5,   6,   7}; //   3

  c_p[x_a][61] = {  6,   7,   9}; //   3
  c_f[x_a][61] = {  0}; //   1
  c_t[x_a][61] = {  5,   7}; //   2
  c_d[x_a][61] = {  5,   6,   7}; //   3

  c_p[x_a][62] = {  6,  10,  11}; //   3
  c_f[x_a][62] = {  1}; //   1
  c_t[x_a][62] = {  4,   6}; //   2
  c_d[x_a][62] = {  8,   9,   7}; //   3

  c_p[x_a][63] = {  6,  10,  11}; //   3
  c_f[x_a][63] = {  0}; //   1
  c_t[x_a][63] = {  5,   7}; //   2
  c_d[x_a][63] = {  8,   9,   7}; //   3

  c_p[x_a][64] = {  0,  12,  13}; //   3
  c_f[x_a][64] = {  1}; //   1
  c_t[x_a][64] = {  4,   6}; //   2
  c_d[x_a][64] = { 10,   7,   2}; //   3

  c_p[x_a][65] = {  0,  12,  14}; //   3
  c_f[x_a][65] = {  1}; //   1
  c_t[x_a][65] = {  4,   6}; //   2
  c_d[x_a][65] = { 10,   7,   2}; //   3

  c_p[x_a][66] = {  0,  12,  13}; //   3
  c_f[x_a][66] = {  0}; //   1
  c_t[x_a][66] = {  5,   7}; //   2
  c_d[x_a][66] = { 10,   7,   2}; //   3

  c_p[x_a][67] = {  0,  12,  14}; //   3
  c_f[x_a][67] = {  0}; //   1
  c_t[x_a][67] = {  5,   7}; //   2
  c_d[x_a][67] = { 10,   7,   2}; //   3

  c_p[x_a][68] = {  6,  23}; //   2
  c_f[x_a][68] = {  2,   3}; //   2
  c_t[x_a][68] = {  0,   8,   9}; //   3
  c_d[x_a][68] = {  2,   7}; //   2

  c_p[x_a][69] = {  6,  23}; //   2
  c_f[x_a][69] = {  4,   5}; //   2
  c_t[x_a][69] = {  2,  10,  11}; //   3
  c_d[x_a][69] = {  2,   7}; //   2

  c_p[x_a][70] = {  6,  17,  18}; //   3
  c_f[x_a][70] = {  5}; //   1
  c_t[x_a][70] = {  2,  10}; //   2
  c_d[x_a][70] = {  2,  14,   7}; //   3

  c_p[x_a][71] = {  6,  20,  21}; //   3
  c_f[x_a][71] = {  3}; //   1
  c_t[x_a][71] = {  0,   8}; //   2
  c_d[x_a][71] = {  2,  16,   7}; //   3

  c_p[x_a][72] = {  0,  12,  24}; //   3
  c_f[x_a][72] = {  5}; //   1
  c_t[x_a][72] = {  4,  12}; //   2
  c_d[x_a][72] = { 14,   7,   2}; //   3

  c_p[x_a][73] = {  0,  12,  25}; //   3
  c_f[x_a][73] = {  3}; //   1
  c_t[x_a][73] = {  5,  13}; //   2
  c_d[x_a][73] = { 16,   7,   2}; //   3

  c_p[x_a][74] = {  0,  12}; //   2
  c_f[x_a][74] = {  4,   5}; //   2
  c_t[x_a][74] = {  4,  12,  14}; //   3
  c_d[x_a][74] = {  7,   2}; //   2

  c_p[x_a][75] = {  0,  12}; //   2
  c_f[x_a][75] = {  2,   3}; //   2
  c_t[x_a][75] = {  5,  13,  15}; //   3
  c_d[x_a][75] = {  7,   2}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_dxdx_emmupvmvexdxdx
//  channel    0: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,   0,   0,   0)
//  channel    1: 4yyv11(1, 2, 4, 32, 8, 16, 64, 128;  24,   0,  23,   0,   0)
//  channel    2: 4yyv11(1, 2, 4, 32, 8, 16, 128, 64;  24,   0,   0,   0,   0)
//  channel    3: 4yyv11(1, 2, 4, 32, 8, 16, 128, 64;  24,   0,  23,   0,   0)
//  channel    4: 4yyv11(1, 2, 32, 4, 8, 16, 64, 128;  24,   0,  23,   0,   0)
//  channel    5: 4yyv11(1, 2, 32, 4, 8, 16, 128, 64;  24,   0,  23,   0,   0)
//  channel    6: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,   0,   0,   0)
//  channel    7: 4yyv11(1, 2, 8, 16, 4, 32, 64, 128;  24,   0,  23,   0,   0)
//  channel    8: 4yyv11(1, 2, 8, 16, 4, 32, 128, 64;  24,   0,   0,   0,   0)
//  channel    9: 4yyv11(1, 2, 8, 16, 4, 32, 128, 64;  24,   0,  23,   0,   0)
//  channel   10: 4yyv11(1, 2, 16, 8, 4, 32, 64, 128;  24,   0,  23,   0,   0)
//  channel   11: 4yyv11(1, 2, 16, 8, 4, 32, 128, 64;  24,   0,  23,   0,   0)
//  channel   12: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,   0,   0,   0)
//  channel   13: 42vv11(1, 2, 4, 32, 8, 16, 64, 128;  24,  24,  23,   0,   0)
//  channel   14: 42vv11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,   0,   0,   0)
//  channel   15: 42vv11(1, 2, 4, 32, 8, 16, 128, 64;  24,  24,  23,   0,   0)
//  channel   16: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   0,   0)
//  channel   17: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   0,   0)
//  channel   18: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,   0,   0,   0)
//  channel   19: 5yyyv1(1, 2, 64, 4, 32, 8, 16, 128;  24,   0,  23,   0,   0)
//  channel   20: 5yyyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   0,   0)
//  channel   21: 5yyyv1(1, 2, 64, 32, 4, 8, 16, 128;  24,   0,  23,   0,   0)
//  channel   22: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   0,   0)
//  channel   23: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   0,   0)
//  channel   24: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,   0,   0,   0)
//  channel   25: 5yyyv1(1, 2, 64, 8, 16, 4, 32, 128;  24,   0,  23,   0,   0)
//  channel   26: 5yyyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   0,   0)
//  channel   27: 5yyyv1(1, 2, 64, 16, 8, 4, 32, 128;  24,   0,  23,   0,   0)
//  channel   28: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   0,   0)
//  channel   29: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   0,   0)
//  channel   30: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,   0,   0,   0)
//  channel   31: 5y2vv1(1, 2, 64, 4, 32, 8, 16, 128;  24,  24,  23,   0,   0)
//  channel   32: 52vyv1(1, 2, 8, 16, 128, 4, 32, 64;  24,   0,  24,   0,   0)
//  channel   33: 52vyv1(1, 2, 8, 16, 64, 4, 32, 128;  24,   0,  24,   0,   0)
//  channel   34: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   35: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   36: 15yyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   37: 15yyyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   38: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   39: 15yyyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   40: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   41: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   42: 15yyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   43: 15yyyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   44: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   45: 15yyyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   46: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   47: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   48: 15y2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   49: 15y2vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   50: 152vyv(1, 2, 128, 8, 16, 64, 4, 32;  24,   0,  24,   0,   0)
//  channel   51: 152vyv(1, 2, 64, 8, 16, 128, 4, 32;  24,   0,  24,   0,   0)
//  channel   52: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   53: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   54: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   55: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   56: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   57: 114yyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   58: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   59: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   60: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   61: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   62: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   63: 114yyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   64: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   65: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   66: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   67: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   68: 2v2v11(1, 2, 8, 16, 4, 32, 64, 128;  24,  24,   0,   0,   0)
//  channel   69: 2v2v11(1, 2, 8, 16, 4, 32, 128, 64;  24,  24,   0,   0,   0)
//  channel   70: 2v3yv1(1, 2, 8, 16, 128, 4, 32, 64;  24,   0,  24,   0,   0)
//  channel   71: 2v3yv1(1, 2, 8, 16, 64, 4, 32, 128;  24,   0,  24,   0,   0)
//  channel   72: 13yv2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   73: 13yv2v(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   74: 112v2v(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   75: 112v2v(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
