#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_240_gd_emmupvmvexgd(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_240_gd_emmupvmvexgd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(20);
  needed_v_smin[x_a].resize(20);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   42,   43,   44,   45,   46,   47,   48,   49,   50,   57,   58,   59,   60,   61,   62,   63,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  needed_v_smin[x_a][  1] = {   0,    1,    9,   10,   19,   20,   28,   29,   36,   37,   45,   46,   47,   48,   61,   62}; //  16
  needed_v_smin[x_a][  2] = {   0,    1,    9,   10,   19,   20,   28,   29,   36,   37,   45,   46,   47,   48,   61,   62}; //  16
  needed_v_smin[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    9,   10,   11,   12,   13,   14,   15,   16,   36,   37,   38,   39,   40,   41,   42,   43,   45,   46,   49,   51,   52,   55,   57,   58}; //  32
  needed_v_smin[x_a][  4] = {   2,   11,   21,   30,   38,   49,   50,   63}; //   8
  needed_v_smin[x_a][  5] = {   2,   11,   21,   30,   38,   49,   50,   63}; //   8
  needed_v_smin[x_a][  6] = {   3,    4,    5,    6,    7,    8,   12,   13,   14,   15,   16,   17,   18,   22,   23,   24,   25,   26,   27,   31,   32,   33,   34,   35,   39,   40,   41,   42,   43,   44,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  needed_v_smin[x_a][  7] = {   3,    4,   12,   13,   22,   23,   31,   32,   39,   40,   51,   52,   53,   54,   64,   65}; //  16
  needed_v_smin[x_a][  8] = {   3,    4,   12,   13,   22,   23,   31,   32,   39,   40,   51,   52,   53,   54,   64,   65}; //  16
  needed_v_smin[x_a][  9] = {   5,   14,   24,   33,   41,   55,   56,   66}; //   8
  needed_v_smin[x_a][ 10] = {   5,   14,   24,   33,   41,   55,   56,   66}; //   8
  needed_v_smin[x_a][ 11] = {   6,    7,   15,   16,   26,   27,   34,   35,   42,   43,   57,   58,   59,   60,   67,   68,   73,   78}; //  18
  needed_v_smin[x_a][ 12] = {   8,   17,   18,   44,   69,   70,   71,   75,   76}; //   9
  needed_v_smin[x_a][ 13] = {   8,   17,   44,   69,   75,   76}; //   6
  needed_v_smin[x_a][ 14] = {  18,   71,   70}; //   3
  needed_v_smin[x_a][ 15] = {  19,   20,   21,   22,   23,   24,   25,   26,   27,   61,   62,   63,   64,   65,   66,   67,   68,   72,   78}; //  19
  needed_v_smin[x_a][ 16] = {  25,   72}; //   2
  needed_v_smin[x_a][ 17] = {  28,   29,   30,   31,   32,   33,   34,   35,   47,   48,   50,   53,   54,   56,   59,   60,   73}; //  17
  needed_v_smin[x_a][ 18] = {  74,   77}; //   2
  needed_v_smin[x_a][ 19] = {  74,   77}; //   2

  v_smax[x_a].resize(25);
  needed_v_smax[x_a].resize(25);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   42,   43,   44,   45,   46,   47,   48,   49,   50,   57,   58,   59,   60,   61,   62,   63,   67,   68}; //  44
  needed_v_smax[x_a][  1] = {   0,    1,    9,   10,   19,   20,   28,   29,   36,   37,   45,   46,   47,   48,   61,   62}; //  16
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    9,   10,   11,   12,   13,   14,   15,   16,   19,   20,   21,   22,   23,   24,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   73}; //  65
  needed_v_smax[x_a][  3] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   49,   51,   52,   55,   57,   58,   69,   75,   76}; //  38
  needed_v_smax[x_a][  4] = {   2,   11,   21,   30,   38,   49,   50,   63}; //   8
  needed_v_smax[x_a][  5] = {   3,    4,    5,   12,   13,   14,   22,   23,   24,   31,   32,   33,   39,   40,   41,   51,   52,   53,   54,   55,   56,   64,   65,   66,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  34
  needed_v_smax[x_a][  6] = {   3,    4,   12,   13,   22,   23,   31,   32,   39,   40,   51,   52,   53,   54,   64,   65}; //  16
  needed_v_smax[x_a][  7] = {   5,   14,   24,   33,   41,   55,   56,   66}; //   8
  needed_v_smax[x_a][  8] = {   6,    7,   15,   16,   26,   27,   34,   35,   42,   43,   57,   58,   59,   60,   67,   68}; //  16
  needed_v_smax[x_a][  9] = {   8,   17,   18,   44}; //   4
  needed_v_smax[x_a][ 10] = {   8,   17,   44}; //   3
  needed_v_smax[x_a][ 11] = {  18,   25}; //   2
  needed_v_smax[x_a][ 12] = {  18,   25}; //   2
  needed_v_smax[x_a][ 13] = {  19,   20,   21,   22,   23,   24,   26,   27,   61,   62,   63,   64,   65,   66,   67,   68}; //  16
  needed_v_smax[x_a][ 14] = {  25}; //   1
  needed_v_smax[x_a][ 15] = {  25}; //   1
  needed_v_smax[x_a][ 16] = {  69,   70,   71,   73,   74,   75,   76,   77,   78}; //   9
  needed_v_smax[x_a][ 17] = {  69,   70,   71,   75,   76}; //   5
  needed_v_smax[x_a][ 18] = {  71,   72,   70}; //   3
  needed_v_smax[x_a][ 19] = {  72}; //   1
  needed_v_smax[x_a][ 20] = {  72}; //   1
  needed_v_smax[x_a][ 21] = {  78}; //   1
  needed_v_smax[x_a][ 22] = {  28,   29,   30,   31,   32,   33,   34,   35,   47,   48,   50,   53,   54,   56,   59,   60,   73,   74,   77}; //  19
  needed_v_smax[x_a][ 23] = {  74,   77}; //   2
  needed_v_smax[x_a][ 24] = {  78}; //   1

  g_p[x_a].resize(32);
  needed_g_p[x_a].resize(32);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   42,   43,   44,   45,   46,   47,   48,   49,   50,   57,   58,   59,   60,   61,   62,   63,   67,   68}; //  44
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    9,   10,   19,   20,   28,   29,   36,   37,   45,   46,   47,   48,   61,   62}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    9,   19,   28,   36,   45,   47,   61}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   0,    1,    2,    3,    4,    5,    6,    7,    9,   10,   11,   12,   13,   14,   15,   16,   36,   37,   38,   39,   40,   41,   42,   43}; //  24
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   1,   10,   20,   29,   37,   46,   48,   62}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][5] = {   2,   11,   21,   30,   38,   49,   50,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][6] = {   2,   11,   21,   30,   38,   49,   50,   63}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin5_smax2");
  needed_g_p[x_a][7] = {   3,    4,    5,   12,   13,   14,   22,   23,   24,   31,   32,   33,   39,   40,   41,   51,   52,   53,   54,   55,   56,   64,   65,   66,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  34
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax5");
  needed_g_p[x_a][8] = {   3,    4,   12,   13,   22,   23,   31,   32,   39,   40,   51,   52,   53,   54,   64,   65}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax6");
  needed_g_p[x_a][9] = {   3,   12,   22,   31,   39,   51,   53,   64}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax2");
  needed_g_p[x_a][10] = {   4,   13,   23,   32,   40,   52,   54,   65}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin8_smax2");
  needed_g_p[x_a][11] = {   5,   14,   24,   33,   41,   55,   56,   66}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax7");
  needed_g_p[x_a][12] = {   5,   14,   24,   33,   41,   55,   56,   66}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][13] = {   6,    7,   15,   16,   26,   27,   34,   35,   42,   43,   57,   58,   59,   60,   67,   68}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax8");
  needed_g_p[x_a][14] = {   6,   15,   26,   34,   42,   57,   59,   67}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax2");
  needed_g_p[x_a][15] = {   7,   16,   27,   35,   43,   58,   60,   68}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin11_smax2");
  needed_g_p[x_a][16] = {   8,   17,   18,   44}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][17] = {   8,   17,   44}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax10");
  needed_g_p[x_a][18] = {   8,   17,   44}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax3");
  needed_g_p[x_a][19] = {  18}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax11");
  needed_g_p[x_a][20] = {  18,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin6_smax12");
  needed_g_p[x_a][21] = {  19,   20,   21,   22,   23,   24,   26,   27,   61,   62,   63,   64,   65,   66,   67,   68}; //  16
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax13");
  needed_g_p[x_a][22] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax14");
  needed_g_p[x_a][23] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax15");
  needed_g_p[x_a][24] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax11");
  needed_g_p[x_a][25] = {  69,   70,   71,   73,   74,   75,   76,   77,   78}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax16");
  needed_g_p[x_a][26] = {  69,   70,   71,   75}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax17");
  needed_g_p[x_a][27] = {  71}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax18");
  needed_g_p[x_a][28] = {  72}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax19");
  needed_g_p[x_a][29] = {  72}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax20");
  needed_g_p[x_a][30] = {  72}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin16_smax18");
  needed_g_p[x_a][31] = {  78}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax21");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {  28,   29,   30,   31,   32,   33,   34,   35,   47,   48,   50,   53,   54,   56,   59,   60,   73}; //  17
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax22");
  needed_g_f[x_a][1] = {  45,   46,   49,   51,   52,   55,   57,   58}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][2] = {  69,   75,   76}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax3");
  needed_g_f[x_a][3] = {  70}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax18");
  needed_g_f[x_a][4] = {  73}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax2");
  needed_g_f[x_a][5] = {  74,   77}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin18_smax23");
  needed_g_f[x_a][6] = {  74,   77}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin19_smax22");
  needed_g_f[x_a][7] = {  76}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax17");
  needed_g_f[x_a][8] = {  78}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax24");

  g_t[x_a].resize(17);
  needed_g_t[x_a].resize(17);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,   69}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_188");
  needed_g_t[x_a][1] = {  28,   29,   30,   31,   32,   33,   34,   35,   47,   48,   50,   53,   54,   56,   59,   60,   73,   74,   77}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__128_124");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__128_124");
  needed_g_t[x_a][2] = {  28,   29,   30,   31,   32,   33,   34,   35,   73}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__64_60");
  needed_g_t[x_a][3] = {  36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   49,   51,   52,   55,   57,   58,   75,   76}; //  19
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_188");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_188");
  needed_g_t[x_a][4] = {  45,   46,   49,   51,   52,   55,   57,   58}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__128_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__128_60");
  needed_g_t[x_a][5] = {  47,   48,   50,   53,   54,   56,   59,   60}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__129_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__129_2__64_60");
  needed_g_t[x_a][6] = {  61,   62,   63,   64,   65,   66,   67,   68,   78}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__192_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__192_60");
  needed_g_t[x_a][7] = {  69}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__152_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__152_36");
  needed_g_t[x_a][8] = {  70,   71,   72}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__36_216");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__36_216");
  needed_g_t[x_a][9] = {  70}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_38__152_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_38__152_64");
  needed_g_t[x_a][10] = {  73}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_66__24_36");
  needed_g_t[x_a][11] = {  74,   77}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_129__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_129__36_88");
  needed_g_t[x_a][12] = {  74}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_38__24_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_38__24_64");
  needed_g_t[x_a][13] = {  75,   76}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_152");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_152");
  needed_g_t[x_a][14] = {  76}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_38__128_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_38__128_24");
  needed_g_t[x_a][15] = {  77}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__129_38__64_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__129_38__64_24");
  needed_g_t[x_a][16] = {  78}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_193__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_193__36_24");

  g_d[x_a].resize(20);
  needed_g_d[x_a].resize(20);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    9,   10,   11,   12,   13,   14,   15,   16,   36,   37,   38,   39,   40,   41,   42,   43}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__128_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__128_60");
  needed_g_d[x_a][1] = {   0,    1,    9,   10,   19,   20,   28,   29,   36,   37,   45,   46,   47,   48,   61,   62}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1,    9,   10,   19,   20,   28,   29,   36,   37,   45,   46,   47,   48,   61,   62}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][3] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   15,   16,   17,   18,   19,   20,   21,   25,   26,   27,   28,   29,   30,   34,   35,   36,   37,   38,   42,   43,   44,   45,   46,   47,   48,   49,   50,   57,   58,   59,   60,   61,   62,   63,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   2,   11,   21,   30,   38,   49,   50,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   2,   11,   21,   30,   38,   49,   50,   63}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][6] = {   3,    4,   12,   13,   22,   23,   31,   32,   39,   40,   51,   52,   53,   54,   64,   65}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][7] = {   3,    4,   12,   13,   22,   23,   31,   32,   39,   40,   51,   52,   53,   54,   64,   65}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][8] = {   3,    4,    5,    6,    7,    8,   12,   13,   14,   15,   16,   17,   18,   22,   23,   24,   25,   26,   27,   31,   32,   33,   34,   35,   39,   40,   41,   42,   43,   44,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   64,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][9] = {   5,   14,   24,   33,   41,   55,   56,   66}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][10] = {   5,   14,   24,   33,   41,   55,   56,   66}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][11] = {   6,    7,   15,   16,   26,   27,   34,   35,   42,   43,   57,   58,   59,   60,   67,   68}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][12] = {   8,   17,   44}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_188__36_152");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_188__36_152");
  needed_g_d[x_a][13] = {   8,   17,   18,   44,   69,   70,   71,   75}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_152__128_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_152__128_24");
  needed_g_d[x_a][14] = {   9,   10,   11,   12,   13,   14,   15,   16,   17}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__64_188");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__64_188");
  needed_g_d[x_a][15] = {  18,   25}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__36_216");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__36_216");
  needed_g_d[x_a][16] = {  18,   71}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_216__64_152");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_216__64_152");
  needed_g_d[x_a][17] = {  19,   20,   21,   22,   23,   24,   26,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_252__192_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_252__192_60");
  needed_g_d[x_a][18] = {  19,   20,   21,   22,   23,   24,   25,   26,   27,   61,   62,   63,   64,   65,   66,   67,   68,   72,   78}; //  19
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_192__64_128");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_192__64_128");
  needed_g_d[x_a][19] = {  25,   72}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_216__24_192");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_216__24_192");

  c_p[x_a].resize(79);
  c_f[x_a].resize(79);
  c_t[x_a].resize(79);
  c_d[x_a].resize(79);

  c_p[x_a][0] = {  0,   1,   2,   3}; //   4
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   4,   3}; //   4
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  0,   5,   6,   3}; //   4
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  0,   4,   5,   3}; //   4

  c_p[x_a][3] = {  7,   8,   9,   3}; //   4
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  0,   6,   7,   8}; //   4

  c_p[x_a][4] = {  7,   8,  10,   3}; //   4
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  0,   6,   7,   8}; //   4

  c_p[x_a][5] = {  7,  11,  12,   3}; //   4
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  0,   9,  10,   8}; //   4

  c_p[x_a][6] = {  0,  13,  14,   3}; //   4
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  0,  11,   8,   3}; //   4

  c_p[x_a][7] = {  0,  13,  15,   3}; //   4
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = {  0,  11,   8,   3}; //   4

  c_p[x_a][8] = {  0,  16,  17,  18}; //   4
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = { 12,   8,  13,   3}; //   4

  c_p[x_a][9] = {  0,   1,   2,   3}; //   4
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 14,   0,   1,   2,   3}; //   5

  c_p[x_a][10] = {  0,   1,   4,   3}; //   4
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 14,   0,   1,   2,   3}; //   5

  c_p[x_a][11] = {  0,   5,   6,   3}; //   4
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 14,   0,   4,   5,   3}; //   5

  c_p[x_a][12] = {  7,   8,   9,   3}; //   4
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 14,   0,   6,   7,   8}; //   5

  c_p[x_a][13] = {  7,   8,  10,   3}; //   4
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 14,   0,   6,   7,   8}; //   5

  c_p[x_a][14] = {  7,  11,  12,   3}; //   4
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 14,   0,   9,  10,   8}; //   5

  c_p[x_a][15] = {  0,  13,  14,   3}; //   4
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 14,   0,  11,   8,   3}; //   5

  c_p[x_a][16] = {  0,  13,  15,   3}; //   4
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 14,   0,  11,   8,   3}; //   5

  c_p[x_a][17] = {  0,  16,  17,  18}; //   4
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 14,  12,   8,  13,   3}; //   5

  c_p[x_a][18] = {  0,  16,  19,  20}; //   4
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 15,   8,  16,  13,   3}; //   5

  c_p[x_a][19] = {  0,   1,   2,  21}; //   4
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 17,  18,   1,   2,   3}; //   5

  c_p[x_a][20] = {  0,   1,   4,  21}; //   4
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 17,  18,   1,   2,   3}; //   5

  c_p[x_a][21] = {  0,   5,   6,  21}; //   4
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 17,  18,   4,   5,   3}; //   5

  c_p[x_a][22] = {  7,   8,   9,  21}; //   4
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 17,  18,   6,   7,   8}; //   5

  c_p[x_a][23] = {  7,   8,  10,  21}; //   4
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 17,  18,   6,   7,   8}; //   5

  c_p[x_a][24] = {  7,  11,  12,  21}; //   4
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 17,  18,   9,  10,   8}; //   5

  c_p[x_a][25] = { 22,  23,  24,  20}; //   4
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 15,   8,  19,   3,  18}; //   5

  c_p[x_a][26] = {  0,  13,  14,  21}; //   4
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 17,  18,  11,   8,   3}; //   5

  c_p[x_a][27] = {  0,  13,  15,  21}; //   4
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 17,  18,  11,   8,   3}; //   5

  c_p[x_a][28] = {  0,   1,   2}; //   3
  c_f[x_a][28] = {  0}; //   1
  c_t[x_a][28] = {  1,   2}; //   2
  c_d[x_a][28] = {  1,   2,   3}; //   3

  c_p[x_a][29] = {  0,   1,   4}; //   3
  c_f[x_a][29] = {  0}; //   1
  c_t[x_a][29] = {  1,   2}; //   2
  c_d[x_a][29] = {  1,   2,   3}; //   3

  c_p[x_a][30] = {  0,   5,   6}; //   3
  c_f[x_a][30] = {  0}; //   1
  c_t[x_a][30] = {  1,   2}; //   2
  c_d[x_a][30] = {  4,   5,   3}; //   3

  c_p[x_a][31] = {  7,   8,   9}; //   3
  c_f[x_a][31] = {  0}; //   1
  c_t[x_a][31] = {  1,   2}; //   2
  c_d[x_a][31] = {  6,   7,   8}; //   3

  c_p[x_a][32] = {  7,   8,  10}; //   3
  c_f[x_a][32] = {  0}; //   1
  c_t[x_a][32] = {  1,   2}; //   2
  c_d[x_a][32] = {  6,   7,   8}; //   3

  c_p[x_a][33] = {  7,  11,  12}; //   3
  c_f[x_a][33] = {  0}; //   1
  c_t[x_a][33] = {  1,   2}; //   2
  c_d[x_a][33] = {  9,  10,   8}; //   3

  c_p[x_a][34] = {  0,  13,  14}; //   3
  c_f[x_a][34] = {  0}; //   1
  c_t[x_a][34] = {  1,   2}; //   2
  c_d[x_a][34] = { 11,   8,   3}; //   3

  c_p[x_a][35] = {  0,  13,  15}; //   3
  c_f[x_a][35] = {  0}; //   1
  c_t[x_a][35] = {  1,   2}; //   2
  c_d[x_a][35] = { 11,   8,   3}; //   3

  c_p[x_a][36] = {  0,   1,   2,   3}; //   4
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  3}; //   1
  c_d[x_a][36] = {  0,   1,   2,   3}; //   4

  c_p[x_a][37] = {  0,   1,   4,   3}; //   4
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {  3}; //   1
  c_d[x_a][37] = {  0,   1,   2,   3}; //   4

  c_p[x_a][38] = {  0,   5,   6,   3}; //   4
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  3}; //   1
  c_d[x_a][38] = {  0,   4,   5,   3}; //   4

  c_p[x_a][39] = {  7,   8,   9,   3}; //   4
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  3}; //   1
  c_d[x_a][39] = {  0,   6,   7,   8}; //   4

  c_p[x_a][40] = {  7,   8,  10,   3}; //   4
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  3}; //   1
  c_d[x_a][40] = {  0,   6,   7,   8}; //   4

  c_p[x_a][41] = {  7,  11,  12,   3}; //   4
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  3}; //   1
  c_d[x_a][41] = {  0,   9,  10,   8}; //   4

  c_p[x_a][42] = {  0,  13,  14,   3}; //   4
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  3}; //   1
  c_d[x_a][42] = {  0,  11,   8,   3}; //   4

  c_p[x_a][43] = {  0,  13,  15,   3}; //   4
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  3}; //   1
  c_d[x_a][43] = {  0,  11,   8,   3}; //   4

  c_p[x_a][44] = {  0,  16,  17,  18}; //   4
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  3}; //   1
  c_d[x_a][44] = { 12,   8,  13,   3}; //   4

  c_p[x_a][45] = {  0,   1,   2}; //   3
  c_f[x_a][45] = {  1}; //   1
  c_t[x_a][45] = {  3,   4}; //   2
  c_d[x_a][45] = {  1,   2,   3}; //   3

  c_p[x_a][46] = {  0,   1,   4}; //   3
  c_f[x_a][46] = {  1}; //   1
  c_t[x_a][46] = {  3,   4}; //   2
  c_d[x_a][46] = {  1,   2,   3}; //   3

  c_p[x_a][47] = {  0,   1,   2}; //   3
  c_f[x_a][47] = {  0}; //   1
  c_t[x_a][47] = {  1,   5}; //   2
  c_d[x_a][47] = {  1,   2,   3}; //   3

  c_p[x_a][48] = {  0,   1,   4}; //   3
  c_f[x_a][48] = {  0}; //   1
  c_t[x_a][48] = {  1,   5}; //   2
  c_d[x_a][48] = {  1,   2,   3}; //   3

  c_p[x_a][49] = {  0,   5,   6}; //   3
  c_f[x_a][49] = {  1}; //   1
  c_t[x_a][49] = {  3,   4}; //   2
  c_d[x_a][49] = {  4,   5,   3}; //   3

  c_p[x_a][50] = {  0,   5,   6}; //   3
  c_f[x_a][50] = {  0}; //   1
  c_t[x_a][50] = {  1,   5}; //   2
  c_d[x_a][50] = {  4,   5,   3}; //   3

  c_p[x_a][51] = {  7,   8,   9}; //   3
  c_f[x_a][51] = {  1}; //   1
  c_t[x_a][51] = {  3,   4}; //   2
  c_d[x_a][51] = {  6,   7,   8}; //   3

  c_p[x_a][52] = {  7,   8,  10}; //   3
  c_f[x_a][52] = {  1}; //   1
  c_t[x_a][52] = {  3,   4}; //   2
  c_d[x_a][52] = {  6,   7,   8}; //   3

  c_p[x_a][53] = {  7,   8,   9}; //   3
  c_f[x_a][53] = {  0}; //   1
  c_t[x_a][53] = {  1,   5}; //   2
  c_d[x_a][53] = {  6,   7,   8}; //   3

  c_p[x_a][54] = {  7,   8,  10}; //   3
  c_f[x_a][54] = {  0}; //   1
  c_t[x_a][54] = {  1,   5}; //   2
  c_d[x_a][54] = {  6,   7,   8}; //   3

  c_p[x_a][55] = {  7,  11,  12}; //   3
  c_f[x_a][55] = {  1}; //   1
  c_t[x_a][55] = {  3,   4}; //   2
  c_d[x_a][55] = {  9,  10,   8}; //   3

  c_p[x_a][56] = {  7,  11,  12}; //   3
  c_f[x_a][56] = {  0}; //   1
  c_t[x_a][56] = {  1,   5}; //   2
  c_d[x_a][56] = {  9,  10,   8}; //   3

  c_p[x_a][57] = {  0,  13,  14}; //   3
  c_f[x_a][57] = {  1}; //   1
  c_t[x_a][57] = {  3,   4}; //   2
  c_d[x_a][57] = { 11,   8,   3}; //   3

  c_p[x_a][58] = {  0,  13,  15}; //   3
  c_f[x_a][58] = {  1}; //   1
  c_t[x_a][58] = {  3,   4}; //   2
  c_d[x_a][58] = { 11,   8,   3}; //   3

  c_p[x_a][59] = {  0,  13,  14}; //   3
  c_f[x_a][59] = {  0}; //   1
  c_t[x_a][59] = {  1,   5}; //   2
  c_d[x_a][59] = { 11,   8,   3}; //   3

  c_p[x_a][60] = {  0,  13,  15}; //   3
  c_f[x_a][60] = {  0}; //   1
  c_t[x_a][60] = {  1,   5}; //   2
  c_d[x_a][60] = { 11,   8,   3}; //   3

  c_p[x_a][61] = {  0,   1,   2,  21}; //   4
  c_f[x_a][61] = {}; //   0
  c_t[x_a][61] = {  6}; //   1
  c_d[x_a][61] = { 18,   1,   2,   3}; //   4

  c_p[x_a][62] = {  0,   1,   4,  21}; //   4
  c_f[x_a][62] = {}; //   0
  c_t[x_a][62] = {  6}; //   1
  c_d[x_a][62] = { 18,   1,   2,   3}; //   4

  c_p[x_a][63] = {  0,   5,   6,  21}; //   4
  c_f[x_a][63] = {}; //   0
  c_t[x_a][63] = {  6}; //   1
  c_d[x_a][63] = { 18,   4,   5,   3}; //   4

  c_p[x_a][64] = {  7,   8,   9,  21}; //   4
  c_f[x_a][64] = {}; //   0
  c_t[x_a][64] = {  6}; //   1
  c_d[x_a][64] = { 18,   6,   7,   8}; //   4

  c_p[x_a][65] = {  7,   8,  10,  21}; //   4
  c_f[x_a][65] = {}; //   0
  c_t[x_a][65] = {  6}; //   1
  c_d[x_a][65] = { 18,   6,   7,   8}; //   4

  c_p[x_a][66] = {  7,  11,  12,  21}; //   4
  c_f[x_a][66] = {}; //   0
  c_t[x_a][66] = {  6}; //   1
  c_d[x_a][66] = { 18,   9,  10,   8}; //   4

  c_p[x_a][67] = {  0,  13,  14,  21}; //   4
  c_f[x_a][67] = {}; //   0
  c_t[x_a][67] = {  6}; //   1
  c_d[x_a][67] = { 18,  11,   8,   3}; //   4

  c_p[x_a][68] = {  0,  13,  15,  21}; //   4
  c_f[x_a][68] = {}; //   0
  c_t[x_a][68] = {  6}; //   1
  c_d[x_a][68] = { 18,  11,   8,   3}; //   4

  c_p[x_a][69] = {  7,  25,  26}; //   3
  c_f[x_a][69] = {  2}; //   1
  c_t[x_a][69] = {  0,   7}; //   2
  c_d[x_a][69] = { 13,   3,   8}; //   3

  c_p[x_a][70] = {  7,  25,  26}; //   3
  c_f[x_a][70] = {  3}; //   1
  c_t[x_a][70] = {  8,   9}; //   2
  c_d[x_a][70] = { 13,   3,   8}; //   3

  c_p[x_a][71] = {  7,  25,  26,  27}; //   4
  c_f[x_a][71] = {}; //   0
  c_t[x_a][71] = {  8}; //   1
  c_d[x_a][71] = { 16,  13,   3,   8}; //   4

  c_p[x_a][72] = {  7,  28,  29,  30}; //   4
  c_f[x_a][72] = {}; //   0
  c_t[x_a][72] = {  8}; //   1
  c_d[x_a][72] = { 19,   3,  18,   8}; //   4

  c_p[x_a][73] = {  7,  25}; //   2
  c_f[x_a][73] = {  4,   0}; //   2
  c_t[x_a][73] = {  1,   2,  10}; //   3
  c_d[x_a][73] = {  3,   8}; //   2

  c_p[x_a][74] = {  7,  25}; //   2
  c_f[x_a][74] = {  5,   6}; //   2
  c_t[x_a][74] = {  1,  11,  12}; //   3
  c_d[x_a][74] = {  3,   8}; //   2

  c_p[x_a][75] = {  7,  25,  26}; //   3
  c_f[x_a][75] = {  2}; //   1
  c_t[x_a][75] = {  3,  13}; //   2
  c_d[x_a][75] = { 13,   3,   8}; //   3

  c_p[x_a][76] = {  7,  25}; //   2
  c_f[x_a][76] = {  7,   2}; //   2
  c_t[x_a][76] = {  3,  13,  14}; //   3
  c_d[x_a][76] = {  3,   8}; //   2

  c_p[x_a][77] = {  7,  25}; //   2
  c_f[x_a][77] = {  5,   6}; //   2
  c_t[x_a][77] = {  1,  11,  15}; //   3
  c_d[x_a][77] = {  3,   8}; //   2

  c_p[x_a][78] = {  7,  25,  31}; //   3
  c_f[x_a][78] = {  8}; //   1
  c_t[x_a][78] = {  6,  16}; //   2
  c_d[x_a][78] = { 18,   3,   8}; //   3

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_240_gd_emmupvmvexgd
//  channel    0: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   0,   0)
//  channel    1: 5yyyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   0,   0)
//  channel    2: 5yyyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   0,   0)
//  channel    3: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   0,   0)
//  channel    4: 5yyyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   0,   0)
//  channel    5: 5yyyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   0,   0)
//  channel    6: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   0,   0)
//  channel    7: 5y2vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   0,   0)
//  channel    8: 52vyv1(1, 2, 4, 32, 128, 8, 16, 64;  24,   0,  24,   0,   0)
//  channel    9: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   10: 6yyyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   11: 6yyyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   12: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   13: 6yyyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   14: 6yyyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   15: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   16: 6yy2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   17: 6y2vyv(1, 2, 64, 4, 32, 128, 8, 16;  24,   0,  24,   0,   0)
//  channel   18: 62vyyv(1, 2, 4, 32, 64, 128, 8, 16;  24,   0,   0,  24,   0)
//  channel   19: 62vyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   20: 62vyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   21: 62vyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   22: 62vyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   23: 62vyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   24: 62vyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   25: 62v2vv(1, 2, 4, 32, 8, 16, 64, 128;   0,  24,   0,  24,   0)
//  channel   26: 62v2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   27: 62v2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   28: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,   0,   0,   0)
//  channel   29: 14yyv1(1, 2, 128, 4, 32, 8, 16, 64;  24,   0,  23,   0,   0)
//  channel   30: 14yyv1(1, 2, 128, 32, 4, 8, 16, 64;  24,   0,  23,   0,   0)
//  channel   31: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,   0,   0,   0)
//  channel   32: 14yyv1(1, 2, 128, 8, 16, 4, 32, 64;  24,   0,  23,   0,   0)
//  channel   33: 14yyv1(1, 2, 128, 16, 8, 4, 32, 64;  24,   0,  23,   0,   0)
//  channel   34: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,   0,   0,   0)
//  channel   35: 142vv1(1, 2, 128, 4, 32, 8, 16, 64;  24,  24,  23,   0,   0)
//  channel   36: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   37: 15yyyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   38: 15yyyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   39: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   40: 15yyyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   41: 15yyyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   42: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   43: 15y2vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   44: 152vyv(1, 2, 64, 4, 32, 128, 8, 16;  24,   0,  24,   0,   0)
//  channel   45: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   46: 114yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   47: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   48: 114yyv(1, 2, 128, 64, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   49: 114yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   50: 114yyv(1, 2, 128, 64, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   51: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   52: 114yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   53: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   54: 114yyv(1, 2, 128, 64, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   55: 114yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   56: 114yyv(1, 2, 128, 64, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   57: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   58: 1142vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   59: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   60: 1142vv(1, 2, 128, 64, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   61: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,   0,   0,   0)
//  channel   62: 2v4yyv(1, 2, 64, 128, 4, 32, 8, 16;  24,   0,  23,   0,   0)
//  channel   63: 2v4yyv(1, 2, 64, 128, 32, 4, 8, 16;  24,   0,  23,   0,   0)
//  channel   64: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,   0,   0,   0)
//  channel   65: 2v4yyv(1, 2, 64, 128, 8, 16, 4, 32;  24,   0,  23,   0,   0)
//  channel   66: 2v4yyv(1, 2, 64, 128, 16, 8, 4, 32;  24,   0,  23,   0,   0)
//  channel   67: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,   0,   0,   0)
//  channel   68: 2v42vv(1, 2, 64, 128, 4, 32, 8, 16;  24,  24,  23,   0,   0)
//  channel   69: 3yv2v1(1, 2, 128, 8, 16, 4, 32, 64;  24,  24,   0,   0,   0)
//  channel   70: 3yv12v(1, 2, 128, 8, 16, 64, 4, 32;  24,  24,   0,   0,   0)
//  channel   71: 4yyv2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   0,   0)
//  channel   72: 42vv2v(1, 2, 8, 16, 64, 128, 4, 32;  24,   0,  24,   0,   0)
//  channel   73: 12v2v1(1, 2, 128, 8, 16, 4, 32, 64;  24,  24,   0,   0,   0)
//  channel   74: 12v12v(1, 2, 128, 8, 16, 64, 4, 32;  24,  24,   0,   0,   0)
//  channel   75: 13yv2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   0,   0)
//  channel   76: 112v2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   0,   0)
//  channel   77: 112v2v(1, 2, 128, 64, 8, 16, 4, 32;  24,  24,   0,   0,   0)
//  channel   78: 2v2v2v(1, 2, 64, 128, 8, 16, 4, 32;  24,  24,   0,   0,   0)
