#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_050_uux_emmupvmvexa(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_050_uux_emmupvmvexa");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(25);
  needed_v_smin[x_a].resize(25);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   24,   26,   27,   28,   29,   32,   33,   36,   37,   38,   39,   40,   44,   45,   46,   47,   48,   49,   50,   52}; //  30
  needed_v_smin[x_a][  1] = {   0,    1,   10,   11,   28,   29,   38,   39}; //   8
  needed_v_smin[x_a][  2] = {   0,    1,   38,   39}; //   4
  needed_v_smin[x_a][  3] = {   2,   40}; //   2
  needed_v_smin[x_a][  4] = {   2,   40}; //   2
  needed_v_smin[x_a][  5] = {   3,    4,    5,    6,    7,   16,   17,   18,   19,   22,   25,   26,   27,   30,   31,   32,   33,   34,   35,   41,   42,   43,   44,   45,   46,   47,   49,   50,   51,   52}; //  30
  needed_v_smin[x_a][  6] = {   3,    4,   18,   19,   34,   35,   41,   42}; //   8
  needed_v_smin[x_a][  7] = {   3,    4,   41,   42}; //   4
  needed_v_smin[x_a][  8] = {   5,   43}; //   2
  needed_v_smin[x_a][  9] = {   5,   43}; //   2
  needed_v_smin[x_a][ 10] = {   6,    7,   44,   45,   46,   52}; //   6
  needed_v_smin[x_a][ 11] = {   8,    9,   12,   26,   27,   50}; //   6
  needed_v_smin[x_a][ 12] = {   8,    9,   13,   14}; //   4
  needed_v_smin[x_a][ 13] = {  10,   11}; //   2
  needed_v_smin[x_a][ 14] = {  12,   15}; //   2
  needed_v_smin[x_a][ 15] = {  13,   14,   15,   25,   30,   31,   34,   35,   51}; //   9
  needed_v_smin[x_a][ 16] = {  13,   14,   15,   30,   31,   51}; //   6
  needed_v_smin[x_a][ 17] = {  16,   17,   22,   32,   33,   47,   49}; //   7
  needed_v_smin[x_a][ 18] = {  16,   17,   20,   21}; //   4
  needed_v_smin[x_a][ 19] = {  18,   19}; //   2
  needed_v_smin[x_a][ 20] = {  20,   21,   23,   24,   28,   29,   36,   37,   48}; //   9
  needed_v_smin[x_a][ 21] = {  20,   21,   23,   36,   37,   48}; //   6
  needed_v_smin[x_a][ 22] = {  22,   23}; //   2
  needed_v_smin[x_a][ 23] = {  24}; //   1
  needed_v_smin[x_a][ 24] = {  25}; //   1

  v_smax[x_a].resize(26);
  needed_v_smax[x_a].resize(26);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   24,   26,   27,   28,   29,   38,   39,   40,   44,   45}; //  20
  needed_v_smax[x_a][  1] = {   0,    1,   10,   11,   28,   29,   38,   39}; //   8
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,   38,   39,   40,   41,   42,   43,   44,   45,   46,   52}; //  18
  needed_v_smax[x_a][  3] = {   2,   40}; //   2
  needed_v_smax[x_a][  4] = {   3,    4,    5,   16,   17,   18,   19,   22,   32,   33,   34,   35,   41,   42,   43,   46,   47,   49,   50,   51,   52}; //  21
  needed_v_smax[x_a][  5] = {   3,    4,   18,   19,   34,   35,   41,   42}; //   8
  needed_v_smax[x_a][  6] = {   5,   43}; //   2
  needed_v_smax[x_a][  7] = {   6,    7,   44,   45}; //   4
  needed_v_smax[x_a][  8] = {   8,    9,   12,   13,   14,   15,   26,   27,   30,   31}; //  10
  needed_v_smax[x_a][  9] = {   8,    9,   10,   11,   13,   14}; //   6
  needed_v_smax[x_a][ 10] = {  12,   15,   24}; //   3
  needed_v_smax[x_a][ 11] = {  13,   14,   15,   25,   30,   31}; //   6
  needed_v_smax[x_a][ 12] = {  16,   17,   20,   21,   22,   23,   32,   33,   36,   37,   47,   48}; //  12
  needed_v_smax[x_a][ 13] = {  16,   17,   18,   19,   20,   21}; //   6
  needed_v_smax[x_a][ 14] = {  20,   21,   23,   36,   37,   48}; //   6
  needed_v_smax[x_a][ 15] = {  22,   23,   25}; //   3
  needed_v_smax[x_a][ 16] = {  24}; //   1
  needed_v_smax[x_a][ 17] = {  25}; //   1
  needed_v_smax[x_a][ 18] = {  26,   27,   30,   31}; //   4
  needed_v_smax[x_a][ 19] = {  28,   29}; //   2
  needed_v_smax[x_a][ 20] = {  32,   33,   36,   37,   47,   48}; //   6
  needed_v_smax[x_a][ 21] = {  34,   35}; //   2
  needed_v_smax[x_a][ 22] = {  46,   49,   50,   52}; //   4
  needed_v_smax[x_a][ 23] = {  50,   51}; //   2
  needed_v_smax[x_a][ 24] = {  51}; //   1
  needed_v_smax[x_a][ 25] = {  49}; //   1

  g_p[x_a].resize(39);
  needed_g_p[x_a].resize(39);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   24,   26,   27,   28,   29,   38,   39,   40,   44,   45}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,   10,   11,   28,   29,   38,   39}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,   38}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   2,   40}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,   16,   17,   18,   19,   22,   32,   33,   34,   35,   41,   42,   43,   46,   47,   49,   50,   51,   52}; //  21
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,    4,   18,   19,   34,   35,   41,   42}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   41}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   42}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {   5,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {   5,   43}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7,   44,   45}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {   6,   44}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {   7,   45}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {   8,    9,   12,   26,   27}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax8");
  needed_g_p[x_a][16] = {   8,    9,   13,   14}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][17] = {  10,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax9");
  needed_g_p[x_a][18] = {  12,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin14_smax10");
  needed_g_p[x_a][19] = {  13,   14,   15,   25,   30,   31}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax11");
  needed_g_p[x_a][20] = {  13,   14,   15,   30,   31}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin16_smax8");
  needed_g_p[x_a][21] = {  16,   17,   22,   32,   33,   47}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin17_smax12");
  needed_g_p[x_a][22] = {  16,   17,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin18_smax13");
  needed_g_p[x_a][23] = {  18,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin19_smax13");
  needed_g_p[x_a][24] = {  20,   21,   23,   36,   37,   48}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax14");
  needed_g_p[x_a][25] = {  20,   21,   23,   36,   37,   48}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin21_smax12");
  needed_g_p[x_a][26] = {  22,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin22_smax15");
  needed_g_p[x_a][27] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax16");
  needed_g_p[x_a][28] = {  24}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin23_smax10");
  needed_g_p[x_a][29] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax17");
  needed_g_p[x_a][30] = {  25}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin24_smax15");
  needed_g_p[x_a][31] = {  26,   27,   30,   31}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax18");
  needed_g_p[x_a][32] = {  28,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin20_smax19");
  needed_g_p[x_a][33] = {  32,   33,   36,   37,   47,   48}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax20");
  needed_g_p[x_a][34] = {  34,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax21");
  needed_g_p[x_a][35] = {  46,   49,   50,   52}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax22");
  needed_g_p[x_a][36] = {  50}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin11_smax23");
  needed_g_p[x_a][37] = {  51}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin15_smax24");
  needed_g_p[x_a][38] = {  51}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin16_smax23");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {  46,   52}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax2");
  needed_g_f[x_a][1] = {  49}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax25");

  g_t[x_a].resize(7);
  needed_g_t[x_a].resize(7);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,   46}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {  38,   39,   40,   41,   42,   43,   44,   45,   52}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  46}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__24_36");
  needed_g_t[x_a][3] = {  47,   48,   49}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_100");
  needed_g_t[x_a][4] = {  49}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__36_64");
  needed_g_t[x_a][5] = {  50,   51}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__36_88");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__36_88");
  needed_g_t[x_a][6] = {  52}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_24");

  g_d[x_a].resize(33);
  needed_g_d[x_a].resize(33);
  needed_g_d[x_a][0] = {   0,    1,   38,   39}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,   10,   11,   28,   29,   38,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   24,   26,   27,   28,   29,   32,   33,   36,   37,   38,   39,   40,   44,   45,   46,   47,   48,   49,   50,   52}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   2,   40}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2,   40}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3,    4,   41,   42}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    4,   18,   19,   34,   35,   41,   42}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   3,    4,    5,    6,    7,   16,   17,   18,   19,   22,   25,   26,   27,   30,   31,   32,   33,   34,   35,   41,   42,   43,   44,   45,   46,   47,   49,   50,   51,   52}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {   5,   43}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   5,   43}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {   6,    7,   44,   45}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][11] = {   8,    9,   10,   11,   13,   14}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__4_120");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__4_120");
  needed_g_d[x_a][12] = {   8,    9,   13,   14}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__32_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__32_88");
  needed_g_d[x_a][13] = {   8,    9,   12,   26,   27,   50}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][14] = {  10,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_120__64_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_120__64_56");
  needed_g_d[x_a][15] = {  12,   15,   24}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][16] = {  12,   15}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__4_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__4_88");
  needed_g_d[x_a][17] = {  13,   14,   15,   30,   31,   51}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__16_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__16_72");
  needed_g_d[x_a][18] = {  13,   14,   15,   25,   30,   31,   34,   35,   51}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_72__8_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_72__8_64");
  needed_g_d[x_a][19] = {  16,   17,   18,   19,   20,   21}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__8_116");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__8_116");
  needed_g_d[x_a][20] = {  16,   17,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__16_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__16_100");
  needed_g_d[x_a][21] = {  16,   17,   22,   32,   33,   47}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");
  needed_g_d[x_a][22] = {  18,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_116__64_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_116__64_52");
  needed_g_d[x_a][23] = {  20,   21,   23,   36,   37,   48}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__32_68");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__32_68");
  needed_g_d[x_a][24] = {  20,   21,   23,   24,   28,   29,   36,   37,   48}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_68__4_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_68__4_64");
  needed_g_d[x_a][25] = {  22,   23,   25}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__16_108");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__16_108");
  needed_g_d[x_a][26] = {  22,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__8_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__8_100");
  needed_g_d[x_a][27] = {  24}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__68_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__68_24");
  needed_g_d[x_a][28] = {  25}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__36_72");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__36_72");
  needed_g_d[x_a][29] = {  26,   27,   30,   31}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][30] = {  28,   29}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__68_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__68_56");
  needed_g_d[x_a][31] = {  32,   33,   36,   37}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");
  needed_g_d[x_a][32] = {  34,   35}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__72_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__72_52");

  c_p[x_a].resize(53);
  c_f[x_a].resize(53);
  c_t[x_a].resize(53);
  c_d[x_a].resize(53);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  6,   7,   9}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  5,   6,   7}; //   3

  c_p[x_a][5] = {  6,  10,  11}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  8,   9,   7}; //   3

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = { 10,   7,   2}; //   3

  c_p[x_a][7] = {  0,  12,  14}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 10,   7,   2}; //   3

  c_p[x_a][8] = {  0,  15,  16}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 11,  12,  13,   2}; //   4

  c_p[x_a][9] = {  0,  15,  16}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 11,  12,  13,   2}; //   4

  c_p[x_a][10] = {  0,   1,  17}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 11,  14,   1,   2}; //   4

  c_p[x_a][11] = {  0,   1,  17}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 11,  14,   1,   2}; //   4

  c_p[x_a][12] = {  0,  15,  18}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 15,  16,  13,   2}; //   4

  c_p[x_a][13] = { 19,  20,  16}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 11,  12,  17,  18}; //   4

  c_p[x_a][14] = { 19,  20,  16}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 11,  12,  17,  18}; //   4

  c_p[x_a][15] = { 19,  20,  18}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 15,  16,  17,  18}; //   4

  c_p[x_a][16] = {  6,  21,  22}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 19,  20,  21,   7}; //   4

  c_p[x_a][17] = {  6,  21,  22}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 19,  20,  21,   7}; //   4

  c_p[x_a][18] = {  6,   7,  23}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = { 19,  22,   6,   7}; //   4

  c_p[x_a][19] = {  6,   7,  23}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = { 19,  22,   6,   7}; //   4

  c_p[x_a][20] = { 24,  25,  22}; //   3
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 19,  20,  23,  24}; //   4

  c_p[x_a][21] = { 24,  25,  22}; //   3
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = { 19,  20,  23,  24}; //   4

  c_p[x_a][22] = {  6,  21,  26}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = { 25,  26,  21,   7}; //   4

  c_p[x_a][23] = { 24,  25,  26}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = { 25,  26,  23,  24}; //   4

  c_p[x_a][24] = {  0,  27,  28}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {}; //   0
  c_d[x_a][24] = { 15,  27,  24,   2}; //   4

  c_p[x_a][25] = { 19,  29,  30}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {}; //   0
  c_d[x_a][25] = { 25,  28,   7,  18}; //   4

  c_p[x_a][26] = {  0,  15,  31}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {}; //   0
  c_d[x_a][26] = { 29,   7,  13,   2}; //   4

  c_p[x_a][27] = {  0,  15,  31}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {}; //   0
  c_d[x_a][27] = { 29,   7,  13,   2}; //   4

  c_p[x_a][28] = {  0,   1,  32}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {}; //   0
  c_d[x_a][28] = { 30,  24,   1,   2}; //   4

  c_p[x_a][29] = {  0,   1,  32}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {}; //   0
  c_d[x_a][29] = { 30,  24,   1,   2}; //   4

  c_p[x_a][30] = { 19,  20,  31}; //   3
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = {}; //   0
  c_d[x_a][30] = { 29,   7,  17,  18}; //   4

  c_p[x_a][31] = { 19,  20,  31}; //   3
  c_f[x_a][31] = {}; //   0
  c_t[x_a][31] = {}; //   0
  c_d[x_a][31] = { 29,   7,  17,  18}; //   4

  c_p[x_a][32] = {  6,  21,  33}; //   3
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = {}; //   0
  c_d[x_a][32] = { 31,   2,  21,   7}; //   4

  c_p[x_a][33] = {  6,  21,  33}; //   3
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = {}; //   0
  c_d[x_a][33] = { 31,   2,  21,   7}; //   4

  c_p[x_a][34] = {  6,   7,  34}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {}; //   0
  c_d[x_a][34] = { 32,  18,   6,   7}; //   4

  c_p[x_a][35] = {  6,   7,  34}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {}; //   0
  c_d[x_a][35] = { 32,  18,   6,   7}; //   4

  c_p[x_a][36] = { 24,  25,  33}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {}; //   0
  c_d[x_a][36] = { 31,   2,  23,  24}; //   4

  c_p[x_a][37] = { 24,  25,  33}; //   3
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = {}; //   0
  c_d[x_a][37] = { 31,   2,  23,  24}; //   4

  c_p[x_a][38] = {  0,   1,   2}; //   3
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = {  1}; //   1
  c_d[x_a][38] = {  0,   1,   2}; //   3

  c_p[x_a][39] = {  0,   1,   3}; //   3
  c_f[x_a][39] = {}; //   0
  c_t[x_a][39] = {  1}; //   1
  c_d[x_a][39] = {  0,   1,   2}; //   3

  c_p[x_a][40] = {  0,   4,   5}; //   3
  c_f[x_a][40] = {}; //   0
  c_t[x_a][40] = {  1}; //   1
  c_d[x_a][40] = {  3,   4,   2}; //   3

  c_p[x_a][41] = {  6,   7,   8}; //   3
  c_f[x_a][41] = {}; //   0
  c_t[x_a][41] = {  1}; //   1
  c_d[x_a][41] = {  5,   6,   7}; //   3

  c_p[x_a][42] = {  6,   7,   9}; //   3
  c_f[x_a][42] = {}; //   0
  c_t[x_a][42] = {  1}; //   1
  c_d[x_a][42] = {  5,   6,   7}; //   3

  c_p[x_a][43] = {  6,  10,  11}; //   3
  c_f[x_a][43] = {}; //   0
  c_t[x_a][43] = {  1}; //   1
  c_d[x_a][43] = {  8,   9,   7}; //   3

  c_p[x_a][44] = {  0,  12,  13}; //   3
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = {  1}; //   1
  c_d[x_a][44] = { 10,   7,   2}; //   3

  c_p[x_a][45] = {  0,  12,  14}; //   3
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = {  1}; //   1
  c_d[x_a][45] = { 10,   7,   2}; //   3

  c_p[x_a][46] = {  6,  35}; //   2
  c_f[x_a][46] = {  0}; //   1
  c_t[x_a][46] = {  0,   2}; //   2
  c_d[x_a][46] = {  2,   7}; //   2

  c_p[x_a][47] = {  6,  21,  33}; //   3
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = {  3}; //   1
  c_d[x_a][47] = {  2,  21,   7}; //   3

  c_p[x_a][48] = { 24,  25,  33}; //   3
  c_f[x_a][48] = {}; //   0
  c_t[x_a][48] = {  3}; //   1
  c_d[x_a][48] = {  2,  23,  24}; //   3

  c_p[x_a][49] = {  6,  35}; //   2
  c_f[x_a][49] = {  1}; //   1
  c_t[x_a][49] = {  3,   4}; //   2
  c_d[x_a][49] = {  2,   7}; //   2

  c_p[x_a][50] = {  6,  35,  36}; //   3
  c_f[x_a][50] = {}; //   0
  c_t[x_a][50] = {  5}; //   1
  c_d[x_a][50] = { 13,   2,   7}; //   3

  c_p[x_a][51] = {  6,  37,  38}; //   3
  c_f[x_a][51] = {}; //   0
  c_t[x_a][51] = {  5}; //   1
  c_d[x_a][51] = { 17,  18,   7}; //   3

  c_p[x_a][52] = {  6,  35}; //   2
  c_f[x_a][52] = {  0}; //   1
  c_t[x_a][52] = {  1,   6}; //   2
  c_d[x_a][52] = {  2,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_050_uux_emmupvmvexa
//  channel    0: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,   0,   0)
//  channel    1: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,  23,   0)
//  channel    2: 4yyv1(1, 2, 32, 4, 8, 16, 64;  24,   0,  23,   0)
//  channel    3: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   0)
//  channel    4: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  23,   0)
//  channel    5: 4yyv1(1, 2, 16, 8, 4, 32, 64;  24,   0,  23,   0)
//  channel    6: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   0)
//  channel    7: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  23,   0)
//  channel    8: 5yyyv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,   0)
//  channel    9: 5yyyv(1, 2, 4, 32, 64, 8, 16;  24,  24,   0,  23)
//  channel   10: 5yyyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
//  channel   11: 5yyyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,  23)
//  channel   12: 5yyyv(1, 2, 32, 4, 64, 8, 16;  24,  24,   0,  23)
//  channel   13: 5yyyv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,   0)
//  channel   14: 5yyyv(1, 2, 4, 32, 16, 8, 64;   0,  24,   0,  23)
//  channel   15: 5yyyv(1, 2, 32, 4, 16, 8, 64;   0,  24,   0,  23)
//  channel   16: 5yyyv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,   0)
//  channel   17: 5yyyv(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,  23)
//  channel   18: 5yyyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
//  channel   19: 5yyyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,  23)
//  channel   20: 5yyyv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,   0)
//  channel   21: 5yyyv(1, 2, 8, 16, 32, 4, 64;   0,  24,   0,  23)
//  channel   22: 5yyyv(1, 2, 16, 8, 64, 4, 32;  24,  24,   0,  23)
//  channel   23: 5yyyv(1, 2, 16, 8, 32, 4, 64;   0,  24,   0,  23)
//  channel   24: 5y2vv(1, 2, 32, 4, 64, 8, 16;  24,   0,   0,  23)
//  channel   25: 5y2vv(1, 2, 16, 4, 32, 8, 64;   0,  24,   0,  23)
//  channel   26: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,   0)
//  channel   27: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  24,  24,  23)
//  channel   28: 52vyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,   0)
//  channel   29: 52vyv(1, 2, 4, 64, 32, 8, 16;  24,   0,   0,  23)
//  channel   30: 52vyv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,   0)
//  channel   31: 52vyv(1, 2, 4, 32, 16, 8, 64;   0,  24,  24,  23)
//  channel   32: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,   0)
//  channel   33: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,  23)
//  channel   34: 52vyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,   0)
//  channel   35: 52vyv(1, 2, 8, 64, 16, 4, 32;  24,   0,   0,  23)
//  channel   36: 52vyv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,   0)
//  channel   37: 52vyv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,  23)
//  channel   38: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
//  channel   39: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
//  channel   40: 14yyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   0)
//  channel   41: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
//  channel   42: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
//  channel   43: 14yyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   0)
//  channel   44: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   0)
//  channel   45: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   0)
//  channel   46: 2v2v1(1, 2, 8, 16, 4, 32, 64;  24,  24,   0,   0)
//  channel   47: 2v3yv(1, 2, 8, 16, 64, 4, 32;  24,  24,  24,   0)
//  channel   48: 2v3yv(1, 2, 8, 16, 32, 4, 64;   0,  24,  24,   0)
//  channel   49: 2v12v(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,   0)
//  channel   50: 3yv2v(1, 2, 64, 8, 16, 4, 32;  24,  24,  24,   0)
//  channel   51: 3yv2v(1, 2, 16, 8, 64, 4, 32;  24,   0,  24,   0)
//  channel   52: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,   0,   0)
