#include "header.hpp"

#include "ppemxnmnex04.phasespace.set.hpp"

void ppemxnmnex04_phasespace_set::ax_psp_140_uux_emmupvmvexg(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_140_uux_emmupvmvexg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(12);
  needed_v_smin[x_a].resize(12);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18}; //  13
  needed_v_smin[x_a][  1] = {   0,    1,    8,    9}; //   4
  needed_v_smin[x_a][  2] = {   0,    1,    8,    9}; //   4
  needed_v_smin[x_a][  3] = {   2,   10}; //   2
  needed_v_smin[x_a][  4] = {   2,   10}; //   2
  needed_v_smin[x_a][  5] = {   3,    4,    5,    6,    7,   11,   12,   13,   14,   15,   16,   17,   18}; //  13
  needed_v_smin[x_a][  6] = {   3,    4,   11,   12}; //   4
  needed_v_smin[x_a][  7] = {   3,    4,   11,   12}; //   4
  needed_v_smin[x_a][  8] = {   5,   13}; //   2
  needed_v_smin[x_a][  9] = {   5,   13}; //   2
  needed_v_smin[x_a][ 10] = {   6,    7,   14,   15,   16,   18}; //   6
  needed_v_smin[x_a][ 11] = {  17}; //   1

  v_smax[x_a].resize(10);
  needed_v_smax[x_a].resize(10);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15}; //  10
  needed_v_smax[x_a][  1] = {   0,    1,    8,    9}; //   4
  needed_v_smax[x_a][  2] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   18}; //  18
  needed_v_smax[x_a][  3] = {   2,   10}; //   2
  needed_v_smax[x_a][  4] = {   3,    4,    5,   11,   12,   13,   16,   17,   18}; //   9
  needed_v_smax[x_a][  5] = {   3,    4,   11,   12}; //   4
  needed_v_smax[x_a][  6] = {   5,   13}; //   2
  needed_v_smax[x_a][  7] = {   6,    7,   14,   15}; //   4
  needed_v_smax[x_a][  8] = {  16,   17,   18}; //   3
  needed_v_smax[x_a][  9] = {  17}; //   1

  g_p[x_a].resize(16);
  needed_g_p[x_a].resize(16);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1,    8,    9}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   2,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,   11,   12,   13,   16,   17,   18}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,    4,   11,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   4,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {   5,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {   5,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {   6,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {   7,   15}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {  16,   17,   18}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax8");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {  16,   18}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax2");
  needed_g_f[x_a][1] = {  17}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax9");

  g_t[x_a].resize(6);
  needed_g_t[x_a].resize(6);
  needed_g_t[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,   16}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   8,    9,   10,   11,   12,   13,   14,   15,   18}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][2] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__24_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__24_36");
  needed_g_t[x_a][3] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__24_100");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__24_100");
  needed_g_t[x_a][4] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_25__36_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_25__36_64");
  needed_g_t[x_a][5] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__36_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__36_24");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   0,    1,    8,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][1] = {   0,    1,    8,    9}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][2] = {   0,    1,    2,    6,    7,    8,    9,   10,   14,   15,   16,   17,   18}; //  13
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   2,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][4] = {   2,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][5] = {   3,    4,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][6] = {   3,    4,   11,   12}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][7] = {   3,    4,    5,    6,    7,   11,   12,   13,   14,   15,   16,   17,   18}; //  13
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][8] = {   5,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {   5,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][10] = {   6,    7,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");

  c_p[x_a].resize(19);
  c_f[x_a].resize(19);
  c_t[x_a].resize(19);
  c_d[x_a].resize(19);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {  0,   1,   2}; //   3

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  0}; //   1
  c_d[x_a][1] = {  0,   1,   2}; //   3

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   4,   2}; //   3

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  5,   6,   7}; //   3

  c_p[x_a][4] = {  6,   7,   9}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  5,   6,   7}; //   3

  c_p[x_a][5] = {  6,  10,  11}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  8,   9,   7}; //   3

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = { 10,   7,   2}; //   3

  c_p[x_a][7] = {  0,  12,  14}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  0}; //   1
  c_d[x_a][7] = { 10,   7,   2}; //   3

  c_p[x_a][8] = {  0,   1,   2}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  1}; //   1
  c_d[x_a][8] = {  0,   1,   2}; //   3

  c_p[x_a][9] = {  0,   1,   3}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  1}; //   1
  c_d[x_a][9] = {  0,   1,   2}; //   3

  c_p[x_a][10] = {  0,   4,   5}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  1}; //   1
  c_d[x_a][10] = {  3,   4,   2}; //   3

  c_p[x_a][11] = {  6,   7,   8}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  1}; //   1
  c_d[x_a][11] = {  5,   6,   7}; //   3

  c_p[x_a][12] = {  6,   7,   9}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  1}; //   1
  c_d[x_a][12] = {  5,   6,   7}; //   3

  c_p[x_a][13] = {  6,  10,  11}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  1}; //   1
  c_d[x_a][13] = {  8,   9,   7}; //   3

  c_p[x_a][14] = {  0,  12,  13}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  1}; //   1
  c_d[x_a][14] = { 10,   7,   2}; //   3

  c_p[x_a][15] = {  0,  12,  14}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  1}; //   1
  c_d[x_a][15] = { 10,   7,   2}; //   3

  c_p[x_a][16] = {  6,  15}; //   2
  c_f[x_a][16] = {  0}; //   1
  c_t[x_a][16] = {  0,   2}; //   2
  c_d[x_a][16] = {  2,   7}; //   2

  c_p[x_a][17] = {  6,  15}; //   2
  c_f[x_a][17] = {  1}; //   1
  c_t[x_a][17] = {  3,   4}; //   2
  c_d[x_a][17] = {  2,   7}; //   2

  c_p[x_a][18] = {  6,  15}; //   2
  c_f[x_a][18] = {  0}; //   1
  c_t[x_a][18] = {  1,   5}; //   2
  c_d[x_a][18] = {  2,   7}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_140_uux_emmupvmvexg
//  channel    0: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,   0,   0)
//  channel    1: 4yyv1(1, 2, 4, 32, 8, 16, 64;  24,   0,  23,   0)
//  channel    2: 4yyv1(1, 2, 32, 4, 8, 16, 64;  24,   0,  23,   0)
//  channel    3: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,   0,   0)
//  channel    4: 4yyv1(1, 2, 8, 16, 4, 32, 64;  24,   0,  23,   0)
//  channel    5: 4yyv1(1, 2, 16, 8, 4, 32, 64;  24,   0,  23,   0)
//  channel    6: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,   0,   0)
//  channel    7: 42vv1(1, 2, 4, 32, 8, 16, 64;  24,  24,  23,   0)
//  channel    8: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
//  channel    9: 14yyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
//  channel   10: 14yyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   0)
//  channel   11: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
//  channel   12: 14yyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
//  channel   13: 14yyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   0)
//  channel   14: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   0)
//  channel   15: 142vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   0)
//  channel   16: 2v2v1(1, 2, 8, 16, 4, 32, 64;  24,  24,   0,   0)
//  channel   17: 2v12v(1, 2, 8, 16, 64, 4, 32;  24,  24,   0,   0)
//  channel   18: 12v2v(1, 2, 64, 8, 16, 4, 32;  24,  24,   0,   0)

void ppemxnmnex04_phasespace_set::ax_psp_340_uux_emmupvmvexg(int x_a){
  static Logger logger("ppemxnmnex04_phasespace_set::ax_psp_340_uux_emmupvmvexg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(13);
  needed_v_smin[x_a].resize(13);
  int needed_v_smin_0[] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17}; //  15
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 15);
  int needed_v_smin_1[] = {   0,    1}; //   2
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 2);
  int needed_v_smin_2[] = {   0,    1}; //   2
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 2);
  int needed_v_smin_3[] = {   2}; //   1
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 1);
  int needed_v_smin_4[] = {   2}; //   1
  needed_v_smin[x_a][  4] = get_vector_from_array_int(needed_v_smin_4, 1);
  int needed_v_smin_5[] = {   3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17}; //  15
  needed_v_smin[x_a][  5] = get_vector_from_array_int(needed_v_smin_5, 15);
  int needed_v_smin_6[] = {   3,    4}; //   2
  needed_v_smin[x_a][  6] = get_vector_from_array_int(needed_v_smin_6, 2);
  int needed_v_smin_7[] = {   3,    4}; //   2
  needed_v_smin[x_a][  7] = get_vector_from_array_int(needed_v_smin_7, 2);
  int needed_v_smin_8[] = {   5}; //   1
  needed_v_smin[x_a][  8] = get_vector_from_array_int(needed_v_smin_8, 1);
  int needed_v_smin_9[] = {   5}; //   1
  needed_v_smin[x_a][  9] = get_vector_from_array_int(needed_v_smin_9, 1);
  int needed_v_smin_10[] = {   6,    7,    8,    9,   10,   11}; //   6
  needed_v_smin[x_a][ 10] = get_vector_from_array_int(needed_v_smin_10, 6);
  int needed_v_smin_11[] = {  12,   13,   14}; //   3
  needed_v_smin[x_a][ 11] = get_vector_from_array_int(needed_v_smin_11, 3);
  int needed_v_smin_12[] = {  15,   16,   17}; //   3
  needed_v_smin[x_a][ 12] = get_vector_from_array_int(needed_v_smin_12, 3);

  v_smax[x_a].resize(12);
  needed_v_smax[x_a].resize(12);
  int needed_v_smax_0[] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   14}; //  12
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 12);
  int needed_v_smax_1[] = {   0,    1}; //   2
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 12);
  int needed_v_smax_3[] = {   2}; //   1
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 1);
  int needed_v_smax_4[] = {   3,    4,    5,   15,   16,   17}; //   6
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 6);
  int needed_v_smax_5[] = {   3,    4}; //   2
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 2);
  int needed_v_smax_6[] = {   5}; //   1
  needed_v_smax[x_a][  6] = get_vector_from_array_int(needed_v_smax_6, 1);
  int needed_v_smax_7[] = {   6,    7,    8,    9,   10,   11}; //   6
  needed_v_smax[x_a][  7] = get_vector_from_array_int(needed_v_smax_7, 6);
  int needed_v_smax_8[] = {  12,   13,   14}; //   3
  needed_v_smax[x_a][  8] = get_vector_from_array_int(needed_v_smax_8, 3);
  int needed_v_smax_9[] = {  12,   13,   14}; //   3
  needed_v_smax[x_a][  9] = get_vector_from_array_int(needed_v_smax_9, 3);
  int needed_v_smax_10[] = {  15,   16,   17}; //   3
  needed_v_smax[x_a][ 10] = get_vector_from_array_int(needed_v_smax_10, 3);
  int needed_v_smax_11[] = {  15,   16,   17}; //   3
  needed_v_smax[x_a][ 11] = get_vector_from_array_int(needed_v_smax_11, 3);

  g_p[x_a].resize(26);
  needed_g_p[x_a].resize(26);
  needed_g_p[x_a][0] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   14}; //  12
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin2_smax2");
  needed_g_p[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin4_smax2");
  needed_g_p[x_a][6] = {   3,    4,    5,   15,   16,   17}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax4");
  needed_g_p[x_a][7] = {   3,    4}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax2");
  needed_g_p[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin7_smax2");
  needed_g_p[x_a][10] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin9_smax2");
  needed_g_p[x_a][12] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax7");
  needed_g_p[x_a][13] = {   6,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax2");
  needed_g_p[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin10_smax2");
  needed_g_p[x_a][15] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin10_smax2");
  needed_g_p[x_a][16] = {  10}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin10_smax2");
  needed_g_p[x_a][17] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin10_smax2");
  needed_g_p[x_a][18] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax8");
  needed_g_p[x_a][19] = {  12,   13,   14}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax9");
  needed_g_p[x_a][20] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin11_smax8");
  needed_g_p[x_a][21] = {  14}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin11_smax8");
  needed_g_p[x_a][22] = {  15}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax10");
  needed_g_p[x_a][23] = {  15,   16,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax11");
  needed_g_p[x_a][24] = {  16}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_35_smin12_smax10");
  needed_g_p[x_a][25] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin12_smax10");

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(0);
  needed_g_t[x_a].resize(0);

  g_d[x_a].resize(16);
  needed_g_d[x_a].resize(16);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][1] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][2] = {   0,    1}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__32_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__32_24");
  needed_g_d[x_a][3] = {   0,    1,    2,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][6] = {   3,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][7] = {   3,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__16_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__16_36");
  needed_g_d[x_a][8] = {   3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][10] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][11] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__36_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__36_24");
  needed_g_d[x_a][12] = {  12,   13,   14}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__36_88");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__36_88");
  needed_g_d[x_a][13] = {  12,   13,   14}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_88__64_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_88__64_24");
  needed_g_d[x_a][14] = {  15,   16,   17}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__24_100");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__24_100");
  needed_g_d[x_a][15] = {  15,   16,   17}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_100__64_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_100__64_36");

  c_p[x_a].resize(18);
  c_f[x_a].resize(18);
  c_t[x_a].resize(18);
  c_d[x_a].resize(18);

  c_p[x_a][0] = {  0,   1,   2}; //   3
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {}; //   0
  c_d[x_a][0] = {  0,   1,   2,   3}; //   4

  c_p[x_a][1] = {  0,   1,   3}; //   3
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1,   2,   3}; //   4

  c_p[x_a][2] = {  0,   4,   5}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  0,   4,   5,   3}; //   4

  c_p[x_a][3] = {  6,   7,   8}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {}; //   0
  c_d[x_a][3] = {  0,   6,   7,   8}; //   4

  c_p[x_a][4] = {  6,   7,   9}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  0,   6,   7,   8}; //   4

  c_p[x_a][5] = {  6,  10,  11}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  0,   9,  10,   8}; //   4

  c_p[x_a][6] = {  0,  12,  13}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0,  11,   8,   3}; //   4

  c_p[x_a][7] = {  0,  12,  14}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0,  11,   8,   3}; //   4

  c_p[x_a][8] = {  0,  12,  15}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0,  11,   8,   3}; //   4

  c_p[x_a][9] = {  0,  12,  13}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0,  11,   8,   3}; //   4

  c_p[x_a][10] = {  0,  12,  16}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0,  11,   8,   3}; //   4

  c_p[x_a][11] = {  0,  12,  17}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0,  11,   8,   3}; //   4

  c_p[x_a][12] = {  0,  18,  19}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 12,   8,  13,   3}; //   4

  c_p[x_a][13] = {  0,  20,  19}; //   3
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = { 12,   8,  13,   3}; //   4

  c_p[x_a][14] = {  0,  21,  19}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = { 12,   8,  13,   3}; //   4

  c_p[x_a][15] = {  6,  22,  23}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = { 14,   3,  15,   8}; //   4

  c_p[x_a][16] = {  6,  24,  23}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = { 14,   3,  15,   8}; //   4

  c_p[x_a][17] = {  6,  25,  23}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = { 14,   3,  15,   8}; //   4

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_140_uux_emmupvmvexg
//  channel    0: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,   0,   0)
//  channel    1: 5yyyv(1, 2, 64, 4, 32, 8, 16;  24,   0,  23,   0)
//  channel    2: 5yyyv(1, 2, 64, 32, 4, 8, 16;  24,   0,  23,   0)
//  channel    3: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,   0,   0)
//  channel    4: 5yyyv(1, 2, 64, 8, 16, 4, 32;  24,   0,  23,   0)
//  channel    5: 5yyyv(1, 2, 64, 16, 8, 4, 32;  24,   0,  23,   0)
//  channel    6: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   0)
//  channel    7: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  23,   0)
//  channel    8: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  25,   0)
//  channel    9: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,   0,   0)
//  channel   10: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  35,   0)
//  channel   11: 5y2vv(1, 2, 64, 4, 32, 8, 16;  24,  24,  36,   0)
//  channel   12: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,   0,  24,   0)
//  channel   13: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  36,  24,   0)
//  channel   14: 52vyv(1, 2, 4, 32, 64, 8, 16;  24,  35,  24,   0)
//  channel   15: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,   0,  24,   0)
//  channel   16: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  35,  24,   0)
//  channel   17: 52vyv(1, 2, 8, 16, 64, 4, 32;  24,  36,  24,   0)
