#include "header.hpp"

#include "ppexne02.phasespace.set.hpp"

void ppexne02_phasespace_set::ag_psp_220_csx_epvessx(int x_a, int zero){
  static Logger logger("ppexne02_phasespace_set::ag_psp_220_csx_epvessx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (xbp_all[x_a][12] == nullvector){xbp_all[x_a][12] = xbp_all[x_a][4] + xbp_all[x_a][8];}
  if (xbs_all[x_a][12] == 0.){xbs_all[x_a][12] = xbp_all[x_a][12].m2();}
  if (xbs_all[x_a][12] < 0.){xbs_all[x_a][12] = 0.;}
  if (xbsqrts_all[x_a][12] == 0.){xbsqrts_all[x_a][12] = sqrt(xbs_all[x_a][12]);}
  if (xbp_all[x_a][34] == nullvector){xbp_all[x_a][34] = xbp_all[x_a][2] - xbp_all[x_a][32];}
  if (xbs_all[x_a][34] == 0.){xbs_all[x_a][34] = xbp_all[x_a][34].m2();}
  if (xbs_all[x_a][34] > 0.){xbs_all[x_a][34] = 0.;}
  if (xbp_all[x_a][48] == nullvector){xbp_all[x_a][48] = xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][48] == 0.){xbs_all[x_a][48] = xbp_all[x_a][48].m2();}
  if (xbs_all[x_a][48] < 0.){xbs_all[x_a][48] = 0.;}
  if (xbsqrts_all[x_a][48] == 0.){xbsqrts_all[x_a][48] = sqrt(xbs_all[x_a][48]);}
  if (xbp_all[x_a][13] == nullvector){xbp_all[x_a][13] = xbp_all[x_a][1] - xbp_all[x_a][4] - xbp_all[x_a][8];}
  if (xbs_all[x_a][13] == 0.){xbs_all[x_a][13] = xbp_all[x_a][13].m2();}
  if (xbs_all[x_a][13] > 0.){xbs_all[x_a][13] = 0.;}
  if (xbp_all[x_a][28] == nullvector){xbp_all[x_a][28] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16];}
  if (xbs_all[x_a][28] == 0.){xbs_all[x_a][28] = xbp_all[x_a][28].m2();}
  if (xbs_all[x_a][28] < 0.){xbs_all[x_a][28] = 0.;}
  if (xbp_all[x_a][49] == nullvector){xbp_all[x_a][49] = xbp_all[x_a][1] - xbp_all[x_a][16] - xbp_all[x_a][32];}
  if (xbs_all[x_a][49] == 0.){xbs_all[x_a][49] = xbp_all[x_a][49].m2();}
  if (xbs_all[x_a][49] > 0.){xbs_all[x_a][49] = 0.;}
  if (xbp_all[x_a][60] == nullvector){xbp_all[x_a][60] = xbp_all[x_a][4] + xbp_all[x_a][8] + xbp_all[x_a][16] + xbp_all[x_a][32];}
  if (xbs_all[x_a][60] == 0.){xbs_all[x_a][60] = xbp_all[x_a][60].m2();}
  if (xbs_all[x_a][60] < 0.){xbs_all[x_a][60] = 0.;}

  v_smin[x_a][  0] = smin_opt[x_a][12]; // 4 times
  v_smin[x_a][  1] = GSL_MAX_DBL(pow(sqrtsmin_opt[x_a][16] + xbsqrts_all[x_a][12], 2), smin_opt[x_a][28]); // 2 times
  v_smin[x_a][  2] = smin_opt[x_a][48]; // 2 times

  v_smax[x_a][  0] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][48], 2); // 3 times
  v_smax[x_a][  1] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][32], 2); // 2 times
  v_smax[x_a][  2] = pow(xbsqrts_all[x_a][0] - sqrtsmin_opt[x_a][12], 2); // 1 times
  v_smax[x_a][  3] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][48], 2); // 1 times
  v_smax[x_a][  4] = pow(xbsqrts_all[x_a][0] - xbsqrts_all[x_a][12], 2); // 1 times

  //  vector<double> g_p(5);
  {g_p[x_a][  0] = g_propagator(x_a,  24,  12, v_smin[x_a][  0], v_smax[x_a][  0]); /* npp 2 */} // 3 times
  {g_p[x_a][  1] = g_propagator(x_a,   0,  28, v_smin[x_a][  1], v_smax[x_a][  1]); /* npp 3 */} // 1 times
  {g_p[x_a][  2] = g_propagator(x_a,   0,  48, v_smin[x_a][  2], v_smax[x_a][  2]); /* npp 2 */} // 1 times
  {g_p[x_a][  3] = g_propagator(x_a,  24,  12, v_smin[x_a][  0], v_smax[x_a][  3]); /* npp 2 */} // 1 times
  {g_p[x_a][  4] = g_propagator(x_a,   0,  48, v_smin[x_a][  2], v_smax[x_a][  4]); /* npp 2 */} // 1 times

  //  vector<double> g_f(1);
  {g_f[x_a][  0] = g_timelikeinvariant(v_smin[x_a][  1], v_smax[x_a][  1]); /* nfp 3 */} // 1 times

  //  vector<double> g_t(4);
  {g_t[x_a][  0] = g_tchannel_opt(x_a,   0,  60,   2,   1,  32,  28); /* ntp 0 */} // 2 times
  {g_t[x_a][  1] = g_tchannel_opt(x_a,   0,  28,   1,  34,  12,  16); /* ntp 1 */} // 1 times
  {g_t[x_a][  2] = g_tchannel_opt(x_a,   0,  60,   1,   2,  12,  48); /* ntp 0 */} // 1 times
  {g_t[x_a][  3] = g_tchannel_opt(x_a,   0,  60,   1,   2,  48,  12); /* ntp 0 */} // 1 times

  //  vector<double> g_d(3);
  {g_d[x_a][  0] = g_decay(x_a,  12,   4,   8); /* ndp 2 */} // 4 times
  {g_d[x_a][  1] = g_decay(x_a,  28,  16,  12); /* ndp 3 */} // 1 times
  {g_d[x_a][  2] = g_decay(x_a,  48,  16,  32); /* ndp 2 */} // 2 times

  if (switch_IS_mode_phasespace == 2 || switch_IS_mode_phasespace == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(6);
    inv_r[0].resize(5);
    inv_r[1].resize(1);
    inv_r[2].resize(4);
    inv_r[3].resize(4);
    inv_r[4].resize(3);
    inv_r[5].resize(3);

    {inv_propagator(x_a,  24,  12, v_smin[x_a][  0], v_smax[x_a][  0], inv_r[0][0]);} // 3 times
    {inv_propagator(x_a,   0,  28, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[0][1]);} // 1 times
    {inv_propagator(x_a,   0,  48, v_smin[x_a][  2], v_smax[x_a][  2], inv_r[0][2]);} // 1 times
    {inv_propagator(x_a,  24,  12, v_smin[x_a][  0], v_smax[x_a][  3], inv_r[0][3]);} // 1 times
    {inv_propagator(x_a,   0,  48, v_smin[x_a][  2], v_smax[x_a][  4], inv_r[0][4]);} // 1 times

    {inv_timelikeinvariant(x_a,  28, v_smin[x_a][  1], v_smax[x_a][  1], inv_r[1][0]);} // 1 times

    {inv_tchannel_opt(x_a,   0,  60,   2,   1,  32,  28, inv_r[2][0], inv_r[3][0]);} // 2 times
    {inv_tchannel_opt(x_a,   0,  28,   1,  34,  12,  16, inv_r[2][1], inv_r[3][1]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  60,   1,   2,  12,  48, inv_r[2][2], inv_r[3][2]);} // 1 times
    {inv_tchannel_opt(x_a,   0,  60,   1,   2,  48,  12, inv_r[2][3], inv_r[3][3]);} // 1 times

    {inv_decay(x_a,  12,   4,   8, inv_r[4][0], inv_r[5][0]);} // 4 times
    {inv_decay(x_a,  28,  16,  12, inv_r[4][1], inv_r[5][1]);} // 1 times
    {inv_decay(x_a,  48,  16,  32, inv_r[4][2], inv_r[5][2]);} // 2 times

    if (switch_IS_mode_phasespace == 2){
      vector<vector<double> > inv_channel_r(4, vector<double> (8));
      vector<double> g_IS(4, 1.);
      for (int i_c = 0; i_c < 4; i_c++){
        if (MC_phasespace.alpha[zero + i_c] == 0.){continue;}
        int ran = 0;
        for (int i_p = 0; i_p < c_p[x_a][i_c].size(); i_p++){
          inv_channel_r[i_c][ran++] = inv_r[0][c_p[x_a][i_c][i_p]];
        }
        for (int i_f = 0; i_f < c_f[x_a][i_c].size(); i_f++){
          inv_channel_r[i_c][ran++] = inv_r[1][c_f[x_a][i_c][i_f]];
        }
        for (int i_t = 0; i_t < c_t[x_a][i_c].size(); i_t++){
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t]];
          inv_channel_r[i_c][ran++] = inv_r[2][2 * c_t[x_a][i_c][i_t] + 1];
        }
        for (int i_d = 0; i_d < c_d[x_a][i_c].size(); i_d++){
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d]];
          inv_channel_r[i_c][ran++] = inv_r[3][2 * c_d[x_a][i_c][i_d] + 1];
        }
        for (int i_r = 0; i_r < 8; i_r++){
          random_psp[(zero + i_c) * no_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
          g_IS[i_c] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_IS[  0] * g_p[x_a][  0] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_IS[  1] * g_p[x_a][  0] * g_p[x_a][  1] * g_t[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  0];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_IS[  2] * g_p[x_a][  2] * g_p[x_a][  3] * g_t[x_a][  2] * g_d[x_a][  0] * g_d[x_a][  2];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_IS[  3] * g_p[x_a][  0] * g_p[x_a][  4] * g_t[x_a][  3] * g_d[x_a][  2] * g_d[x_a][  0];}
    }
    else if (switch_IS_mode_phasespace == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(5, 1.);
      g_IS[1].resize(1, 1.);
      g_IS[2].resize(4, 1.);
      g_IS[3].resize(3, 1.);

      for (int i_t = 0; i_t < 6; i_t++){
        for (int i_i = 0; i_i < inv_r[i_t].size(); i_i++){
          random_psp[map_type_to_list_MC_IS[vector<int> {x_a, i_t, i_i}]]->get_g_IS(inv_r[i_t][i_i], g_IS_temp);
          int i_g = i_t;
          if (i_t > 2){i_g = i_t / 2 + 1;}
          g_IS[i_g][i_i] *= g_IS_temp;
        }
      }
      if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_p[x_a][  0] * g_IS[0][  0] * g_f[x_a][  0] * g_IS[1][  0] * g_t[x_a][  0] * g_IS[2][  0] * g_t[x_a][  1] * g_IS[2][  1] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  1] * g_IS[0][  1] * g_t[x_a][  0] * g_IS[2][  0] * g_d[x_a][  1] * g_IS[3][  1] * g_d[x_a][  0] * g_IS[3][  0];}
      if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  2] * g_IS[0][  2] * g_p[x_a][  3] * g_IS[0][  3] * g_t[x_a][  2] * g_IS[2][  2] * g_d[x_a][  0] * g_IS[3][  0] * g_d[x_a][  2] * g_IS[3][  2];}
      if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  0] * g_IS[0][  0] * g_p[x_a][  4] * g_IS[0][  4] * g_t[x_a][  3] * g_IS[2][  3] * g_d[x_a][  2] * g_IS[3][  2] * g_d[x_a][  0] * g_IS[3][  0];}
    }
  }
  else {
    if (MC_phasespace.alpha[zero +   0] != 0.){MC_phasespace.g_channel[zero +   0] = g_p[x_a][  0] * g_f[x_a][  0] * g_t[x_a][  0] * g_t[x_a][  1] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +   1] != 0.){MC_phasespace.g_channel[zero +   1] = g_p[x_a][  0] * g_p[x_a][  1] * g_t[x_a][  0] * g_d[x_a][  1] * g_d[x_a][  0];}
    if (MC_phasespace.alpha[zero +   2] != 0.){MC_phasespace.g_channel[zero +   2] = g_p[x_a][  2] * g_p[x_a][  3] * g_t[x_a][  2] * g_d[x_a][  0] * g_d[x_a][  2];}
    if (MC_phasespace.alpha[zero +   3] != 0.){MC_phasespace.g_channel[zero +   3] = g_p[x_a][  0] * g_p[x_a][  4] * g_t[x_a][  3] * g_d[x_a][  2] * g_d[x_a][  0];}
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
