#include "header.hpp"

#include "ppexnea03.phasespace.set.hpp"

void ppexnea03_phasespace_set::ax_psp_230_du_epveadd(int x_a){
  static Logger logger("ppexnea03_phasespace_set::ax_psp_230_du_epveadd");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(18);
  needed_v_smin[x_a].resize(18);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  24
  needed_v_smin[x_a][  1] = {   0,    3,   12,   22,   10,   24}; //   6
  needed_v_smin[x_a][  2] = {   1,    2,   13,   23,   11,   25}; //   6
  needed_v_smin[x_a][  3] = {   2,    1,   11}; //   3
  needed_v_smin[x_a][  4] = {   3,    0,   10}; //   3
  needed_v_smin[x_a][  5] = {   4,    5,   14,   15}; //   4
  needed_v_smin[x_a][  6] = {   4,    6,   14,   16}; //   4
  needed_v_smin[x_a][  7] = {   5,    7,   15,   17}; //   4
  needed_v_smin[x_a][  8] = {   6,    7,   16,   17}; //   4
  needed_v_smin[x_a][  9] = {   6,    7,   16,   17}; //   4
  needed_v_smin[x_a][ 10] = {   8,   22,   24,   26,   21}; //   5
  needed_v_smin[x_a][ 11] = {   8,   21,   26}; //   3
  needed_v_smin[x_a][ 12] = {   9,   23,   25,   27,   20}; //   5
  needed_v_smin[x_a][ 13] = {   9,   20,   27}; //   3
  needed_v_smin[x_a][ 14] = {  12}; //   1
  needed_v_smin[x_a][ 15] = {  13}; //   1
  needed_v_smin[x_a][ 16] = {  18,   19}; //   2
  needed_v_smin[x_a][ 17] = {  18,   19}; //   2

  v_smax[x_a].resize(19);
  needed_v_smax[x_a].resize(19);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  22
  needed_v_smax[x_a][  1] = {   0,    3,   12,   22,   10}; //   5
  needed_v_smax[x_a][  2] = {   1,    2,   13,   23,   11}; //   5
  needed_v_smax[x_a][  3] = {   2,    5,    7,    8,    1,   11,   15,   17,   21,   26}; //  10
  needed_v_smax[x_a][  4] = {   3,    4,    6,    9,    0,   10,   14,   16,   20,   27}; //  10
  needed_v_smax[x_a][  5] = {   4,    5,    6,    7,   14,   15,   16,   17}; //   8
  needed_v_smax[x_a][  6] = {   6,    7,   16,   17}; //   4
  needed_v_smax[x_a][  7] = {   8}; //   1
  needed_v_smax[x_a][  8] = {   8}; //   1
  needed_v_smax[x_a][  9] = {   9}; //   1
  needed_v_smax[x_a][ 10] = {   9}; //   1
  needed_v_smax[x_a][ 11] = {  22}; //   1
  needed_v_smax[x_a][ 12] = {  23}; //   1
  needed_v_smax[x_a][ 13] = {  24,   26,   21}; //   3
  needed_v_smax[x_a][ 14] = {  25,   27,   20}; //   3
  needed_v_smax[x_a][ 15] = {  12,   13,   18,   19}; //   4
  needed_v_smax[x_a][ 16] = {  18,   19}; //   2
  needed_v_smax[x_a][ 17] = {  24}; //   1
  needed_v_smax[x_a][ 18] = {  25}; //   1

  g_p[x_a].resize(20);
  needed_g_p[x_a].resize(20);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,   10,   11,   12,   13,   14,   15,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  22
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    3,   12,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    2,   13,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   4,    5,   14,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin5_smax5");
  needed_g_p[x_a][6] = {   4,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][7] = {   5,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax3");
  needed_g_p[x_a][8] = {   6,    7,   16,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax6");
  needed_g_p[x_a][9] = {   6,    7,   16,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin9_smax5");
  needed_g_p[x_a][10] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][11] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax8");
  needed_g_p[x_a][12] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax3");
  needed_g_p[x_a][13] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax9");
  needed_g_p[x_a][14] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin0_smax10");
  needed_g_p[x_a][15] = {   9}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax4");
  needed_g_p[x_a][16] = {  22}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax11");
  needed_g_p[x_a][17] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax12");
  needed_g_p[x_a][18] = {  24,   26}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax13");
  needed_g_p[x_a][19] = {  25,   27}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax14");

  g_f[x_a].resize(16);
  needed_g_f[x_a].resize(16);
  needed_g_f[x_a][0] = {   0,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][1] = {   1,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][2] = {  10}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][3] = {  11}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][4] = {  12}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax15");
  needed_g_f[x_a][5] = {  13}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax15");
  needed_g_f[x_a][6] = {  14,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][7] = {  15,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax3");
  needed_g_f[x_a][8] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax16");
  needed_g_f[x_a][9] = {  18,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax15");
  needed_g_f[x_a][10] = {  20}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax14");
  needed_g_f[x_a][11] = {  20,   27}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax4");
  needed_g_f[x_a][12] = {  21}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax13");
  needed_g_f[x_a][13] = {  21,   26}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax3");
  needed_g_f[x_a][14] = {  24}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax17");
  needed_g_f[x_a][15] = {  25}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax18");

  g_t[x_a].resize(22);
  needed_g_t[x_a].resize(22);
  needed_g_t[x_a][0] = {   0,    3,    4,    6,    9,   10,   14,   16,   20,   27}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][1] = {   0,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][2] = {   1,    2,    5,    7,    8,   11,   15,   17,   21,   26}; //  10
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][3] = {   1,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__16_44");
  needed_g_t[x_a][4] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][5] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_18__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_18__32_12");
  needed_g_t[x_a][6] = {  12,   13,   18,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][7] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__32_76");
  needed_g_t[x_a][8] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__64_44");
  needed_g_t[x_a][9] = {  14,   16}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__64_28");
  needed_g_t[x_a][10] = {  15,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__32_28");
  needed_g_t[x_a][11] = {  18,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][12] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][13] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__64_32");
  needed_g_t[x_a][14] = {  20,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][15] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][16] = {  21,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__12_48");
  needed_g_t[x_a][17] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_14__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_14__32_16");
  needed_g_t[x_a][18] = {  22,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][19] = {  23,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__80_44");
  needed_g_t[x_a][20] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][21] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_81__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_81__12_32");

  g_d[x_a].resize(14);
  needed_g_d[x_a].resize(14);
  needed_g_d[x_a][0] = {   0,    3,   12,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    4,    5,    8,    9,   10,   11,   12,   13,   14,   15,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   1,    2,   13,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][5] = {   4,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__64_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__64_28");
  needed_g_d[x_a][6] = {   4,    5,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][7] = {   5,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {   6,    7,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][9] = {   6,    7,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][10] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][11] = {   8,   22,   24,   26}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][12] = {   9}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][13] = {   9,   23,   25,   27}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");

  c_p[x_a].resize(28);
  c_f[x_a].resize(28);
  c_t[x_a].resize(28);
  c_d[x_a].resize(28);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  0,   2}; //   2
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  2,   1}; //   2

  c_p[x_a][2] = {  0,   2,   3}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  2}; //   1
  c_d[x_a][2] = {  3,   2,   1}; //   3

  c_p[x_a][3] = {  0,   1,   4}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  0}; //   1
  c_d[x_a][3] = {  4,   0,   1}; //   3

  c_p[x_a][4] = {  0,   5,   6}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  0}; //   1
  c_d[x_a][4] = {  5,   6,   1}; //   3

  c_p[x_a][5] = {  0,   5,   7}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  2}; //   1
  c_d[x_a][5] = {  7,   6,   1}; //   3

  c_p[x_a][6] = {  8,   9,   6}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  5,   8,   9}; //   3

  c_p[x_a][7] = {  8,   9,   7}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  2}; //   1
  c_d[x_a][7] = {  7,   8,   9}; //   3

  c_p[x_a][8] = { 10,  11,  12}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  2}; //   1
  c_d[x_a][8] = { 10,   1,  11}; //   3

  c_p[x_a][9] = { 13,  14,  15}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = { 12,   1,  13}; //   3

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {  2,   0}; //   2
  c_t[x_a][10] = {  0,   1,   4}; //   3
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  0}; //   1
  c_f[x_a][11] = {  3,   1}; //   2
  c_t[x_a][11] = {  2,   3,   5}; //   3
  c_d[x_a][11] = {  1}; //   1

  c_p[x_a][12] = {  0,   1}; //   2
  c_f[x_a][12] = {  4}; //   1
  c_t[x_a][12] = {  6,   7}; //   2
  c_d[x_a][12] = {  0,   1}; //   2

  c_p[x_a][13] = {  0,   2}; //   2
  c_f[x_a][13] = {  5}; //   1
  c_t[x_a][13] = {  6,   8}; //   2
  c_d[x_a][13] = {  2,   1}; //   2

  c_p[x_a][14] = {  0,   5}; //   2
  c_f[x_a][14] = {  6}; //   1
  c_t[x_a][14] = {  0,   9}; //   2
  c_d[x_a][14] = {  6,   1}; //   2

  c_p[x_a][15] = {  0,   5}; //   2
  c_f[x_a][15] = {  7}; //   1
  c_t[x_a][15] = {  2,  10}; //   2
  c_d[x_a][15] = {  6,   1}; //   2

  c_p[x_a][16] = {  8,   9}; //   2
  c_f[x_a][16] = {  6}; //   1
  c_t[x_a][16] = {  0,   9}; //   2
  c_d[x_a][16] = {  8,   9}; //   2

  c_p[x_a][17] = {  8,   9}; //   2
  c_f[x_a][17] = {  7}; //   1
  c_t[x_a][17] = {  2,  10}; //   2
  c_d[x_a][17] = {  8,   9}; //   2

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = {  8,   9}; //   2
  c_t[x_a][18] = {  6,  11,  12}; //   3
  c_d[x_a][18] = {  1}; //   1

  c_p[x_a][19] = {  0}; //   1
  c_f[x_a][19] = {  8,   9}; //   2
  c_t[x_a][19] = {  6,  11,  13}; //   3
  c_d[x_a][19] = {  1}; //   1

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = { 10,  11}; //   2
  c_t[x_a][20] = {  0,  14,  15}; //   3
  c_d[x_a][20] = {  1}; //   1

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = { 12,  13}; //   2
  c_t[x_a][21] = {  2,  16,  17}; //   3
  c_d[x_a][21] = {  1}; //   1

  c_p[x_a][22] = {  0,   1,  16}; //   3
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = { 18}; //   1
  c_d[x_a][22] = { 11,   0,   1}; //   3

  c_p[x_a][23] = {  0,   2,  17}; //   3
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = { 19}; //   1
  c_d[x_a][23] = { 13,   2,   1}; //   3

  c_p[x_a][24] = {  0,  18}; //   2
  c_f[x_a][24] = { 14}; //   1
  c_t[x_a][24] = { 18,  20}; //   2
  c_d[x_a][24] = { 11,   1}; //   2

  c_p[x_a][25] = {  0,  19}; //   2
  c_f[x_a][25] = { 15}; //   1
  c_t[x_a][25] = { 19,  21}; //   2
  c_d[x_a][25] = { 13,   1}; //   2

  c_p[x_a][26] = {  0,  18}; //   2
  c_f[x_a][26] = { 13}; //   1
  c_t[x_a][26] = {  2,  16}; //   2
  c_d[x_a][26] = { 11,   1}; //   2

  c_p[x_a][27] = {  0,  19}; //   2
  c_f[x_a][27] = { 11}; //   1
  c_t[x_a][27] = {  0,  14}; //   2
  c_d[x_a][27] = { 13,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_du_epveadd
//  channel    0: 13yv1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel    1: 13yv1(1, 2, 64, 32, 4, 8, 16;  24,   0,   0,   0)
//  channel    2: 14yyv(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
//  channel    3: 14yyv(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
//  channel    4: 14yyv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel    5: 14yyv(1, 2, 64, 32, 16, 4, 8;  24,  24,   0,   0)
//  channel    6: 14yyv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel    7: 14yyv(1, 2, 64, 32, 8, 4, 16;   0,  24,   0,   0)
//  channel    8: 142vv(1, 2, 64, 4, 8, 16, 32;   0,  24,   0,   0)
//  channel    9: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  24,   0,   0)
//  channel   10: 112v1(1, 2, 32, 64, 4, 8, 16;  24,   0,   0,   0)
//  channel   11: 112v1(1, 2, 64, 32, 4, 8, 16;  24,   0,   0,   0)
//  channel   12: 113yv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   13: 113yv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
//  channel   14: 113yv(1, 2, 32, 64, 16, 4, 8;  24,  24,   0,   0)
//  channel   15: 113yv(1, 2, 64, 32, 16, 4, 8;  24,  24,   0,   0)
//  channel   16: 113yv(1, 2, 32, 64, 8, 4, 16;   0,  24,   0,   0)
//  channel   17: 113yv(1, 2, 64, 32, 8, 4, 16;   0,  24,   0,   0)
//  channel   18: 1112v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   19: 1112v(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
//  channel   20: 1112v(1, 2, 32, 64, 16, 4, 8;  24,   0,   0,   0)
//  channel   21: 1112v(1, 2, 64, 32, 16, 4, 8;  24,   0,   0,   0)
//  channel   22: 2v3yv(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   23: 2v3yv(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
//  channel   24: 2v12v(1, 2, 16, 32, 64, 4, 8;  24,   0,   0,   0)
//  channel   25: 2v12v(1, 2, 16, 64, 32, 4, 8;  24,   0,   0,   0)
//  channel   26: 12v2v(1, 2, 64, 16, 32, 4, 8;  24,   0,   0,   0)
//  channel   27: 12v2v(1, 2, 32, 16, 64, 4, 8;  24,   0,   0,   0)
