#include "header.hpp"

#include "pph21.phasespace.set.hpp"

void pph21_phasespace_set::ax_psp_410_ddx_hddx(int x_a){
  static Logger logger("pph21_phasespace_set::ax_psp_410_ddx_hddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(2);
  needed_v_smin[x_a].resize(2);
  needed_v_smin[x_a][  0] = {   1}; //   1
  needed_v_smin[x_a][  1] = {   0}; //   1

  v_smax[x_a].resize(2);
  needed_v_smax[x_a].resize(2);
  needed_v_smax[x_a][  0] = {   1}; //   1
  needed_v_smax[x_a][  1] = {   0}; //   1

  g_p[x_a].resize(1);
  needed_g_p[x_a].resize(1);
  needed_g_p[x_a][0] = {   1}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");

  g_f[x_a].resize(1);
  needed_g_f[x_a].resize(1);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(2);
  needed_g_t[x_a].resize(2);
  needed_g_t[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_20");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_4");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][1] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");

  c_p[x_a].resize(2);
  c_f[x_a].resize(2);
  c_t[x_a].resize(2);
  c_d[x_a].resize(2);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  0,   1}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_410_ddx_hddx
//  channel    0: 111(1, 2, 8, 4, 16;   0,   0)
//  channel    1: 3yv(1, 2, 4, 8, 16;   0,   0)
