#include "header.hpp"

#include "ppnenexa03.phasespace.set.hpp"

void ppnenexa03_phasespace_set::ax_psp_230_gg_vevexauux(int x_a){
  static Logger logger("ppnenexa03_phasespace_set::ax_psp_230_gg_vevexauux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(12);
  needed_v_smin[x_a].resize(12);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  30
  needed_v_smin[x_a][  1] = {   0,    2,    7,   10,   15,   21,   24,   26}; //   8
  needed_v_smin[x_a][  2] = {   1,    3,    6,   11,   14,   20,   25,   27}; //   8
  needed_v_smin[x_a][  3] = {   2,    7,   15,    0,   21}; //   5
  needed_v_smin[x_a][  4] = {   3,    6,   14,    1,   20}; //   5
  needed_v_smin[x_a][  5] = {   4,    8,   10,   16,   23,   24,   26,   28}; //   8
  needed_v_smin[x_a][  6] = {   4,    8,   16,   23,   28}; //   5
  needed_v_smin[x_a][  7] = {   5,    9,   11,   17,   22,   25,   27,   29}; //   8
  needed_v_smin[x_a][  8] = {   5,    9,   17,   22,   29}; //   5
  needed_v_smin[x_a][  9] = {  12,   13,   18,   19}; //   4
  needed_v_smin[x_a][ 10] = {  12,   18}; //   2
  needed_v_smin[x_a][ 11] = {  13,   19}; //   2

  v_smax[x_a].resize(16);
  needed_v_smax[x_a].resize(16);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    6,    7,   10,   11,   12,   13,   14,   15,   18,   19,   20,   21,   22,   23,   24,   25}; //  20
  needed_v_smax[x_a][  1] = {   0,    2,    7,   10,   15,   21,   24}; //   7
  needed_v_smax[x_a][  2] = {   1,    3,    6,   11,   14,   20,   25}; //   7
  needed_v_smax[x_a][  3] = {   2,    5,    7,    9,   15,   17,    0,   13,   19,   21,   22,   29}; //  12
  needed_v_smax[x_a][  4] = {   3,    4,    6,    8,   14,   16,    1,   12,   18,   20,   23,   28}; //  12
  needed_v_smax[x_a][  5] = {   4,    8,   16,   26,   28}; //   5
  needed_v_smax[x_a][  6] = {   4,    8,   16,   26,   28}; //   5
  needed_v_smax[x_a][  7] = {   5,    9,   17,   27,   29}; //   5
  needed_v_smax[x_a][  8] = {   5,    9,   17,   27,   29}; //   5
  needed_v_smax[x_a][  9] = {  10,   24}; //   2
  needed_v_smax[x_a][ 10] = {  11,   25}; //   2
  needed_v_smax[x_a][ 11] = {  22}; //   1
  needed_v_smax[x_a][ 12] = {  23}; //   1
  needed_v_smax[x_a][ 13] = {  26}; //   1
  needed_v_smax[x_a][ 14] = {  27}; //   1
  needed_v_smax[x_a][ 15] = {  12,   13,   18,   19}; //   4

  g_p[x_a].resize(17);
  needed_g_p[x_a].resize(17);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    6,    7,   10,   11,   12,   13,   14,   15,   18,   19,   20,   21,   22,   23,   24,   25}; //  20
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   0,    2,    7,   10,   15,   21,   24}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   1,    3,    6,   11,   14,   20,   25}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   2,    7,   15}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   3,    6,   14}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   4,    8,   16,   26,   28}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax5");
  needed_g_p[x_a][6] = {   4,    8,   16,   26,   28}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][7] = {   4,    8,   16}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][8] = {   5,    9,   17,   27,   29}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax7");
  needed_g_p[x_a][9] = {   5,    9,   17,   27,   29}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax8");
  needed_g_p[x_a][10] = {   5,    9,   17}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax3");
  needed_g_p[x_a][11] = {  10,   24}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax9");
  needed_g_p[x_a][12] = {  11,   25}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax10");
  needed_g_p[x_a][13] = {  22}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax11");
  needed_g_p[x_a][14] = {  23}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax12");
  needed_g_p[x_a][15] = {  26}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax13");
  needed_g_p[x_a][16] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax14");

  g_f[x_a].resize(7);
  needed_g_f[x_a].resize(7);
  needed_g_f[x_a][0] = {   0,   21}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {   1,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][2] = {  12,   13,   18,   19}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax15");
  needed_g_f[x_a][3] = {  12,   18}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax4");
  needed_g_f[x_a][4] = {  13,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax3");
  needed_g_f[x_a][5] = {  22,   29}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax3");
  needed_g_f[x_a][6] = {  23,   28}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");

  g_t[x_a].resize(22);
  needed_g_t[x_a].resize(22);
  needed_g_t[x_a][0] = {   0,    2,    5,   22}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_92");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__34_1__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__34_1__16_76");
  needed_g_t[x_a][2] = {   1,    3,    4,   23}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__66_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__66_1__16_44");
  needed_g_t[x_a][4] = {  12,   14,   16,   18,   20,   28}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__64_60");
  needed_g_t[x_a][5] = {  12,   18}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__32_28");
  needed_g_t[x_a][6] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__34_65__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__34_65__16_12");
  needed_g_t[x_a][7] = {  13,   15,   17,   19,   21,   29}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][8] = {  13,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__64_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__64_28");
  needed_g_t[x_a][9] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_33__16_12");
  needed_g_t[x_a][10] = {  18}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__65_34__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__65_34__16_12");
  needed_g_t[x_a][11] = {  19}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_66__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_66__16_12");
  needed_g_t[x_a][12] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__65_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__65_2__16_44");
  needed_g_t[x_a][13] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__33_2__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__33_2__16_76");
  needed_g_t[x_a][14] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__80_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__80_12");
  needed_g_t[x_a][15] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__48_12");
  needed_g_t[x_a][16] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][17] = {  25}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__80_44");
  needed_g_t[x_a][18] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__48_76");
  needed_g_t[x_a][19] = {  27}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");
  needed_g_t[x_a][20] = {  28}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_65__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_65__48_12");
  needed_g_t[x_a][21] = {  29}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__80_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__80_12");

  g_d[x_a].resize(13);
  needed_g_d[x_a].resize(13);
  needed_g_d[x_a][0] = {   0,    2,    7,   10,   15,   21,   24,   26}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][1] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29}; //  30
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][2] = {   1,    3,    6,   11,   14,   20,   25,   27}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   2,    7,   15}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][4] = {   3,    6,   14}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][5] = {   4,    8,   16}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][6] = {   4,    8,   10,   16,   23,   24,   26,   28}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][7] = {   5,    9,   17}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][8] = {   5,    9,   11,   17,   22,   25,   27,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][9] = {   6,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][10] = {   7,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][11] = {  10}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][12] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");

  c_p[x_a].resize(30);
  c_f[x_a].resize(30);
  c_t[x_a].resize(30);
  c_d[x_a].resize(30);

  c_p[x_a][0] = {  0,   1}; //   2
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0,   1}; //   2

  c_p[x_a][1] = {  0,   2}; //   2
  c_f[x_a][1] = {  1}; //   1
  c_t[x_a][1] = {  2,   3}; //   2
  c_d[x_a][1] = {  2,   1}; //   2

  c_p[x_a][2] = {  0,   1,   3}; //   3
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  0}; //   1
  c_d[x_a][2] = {  3,   0,   1}; //   3

  c_p[x_a][3] = {  0,   2,   4}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  2}; //   1
  c_d[x_a][3] = {  4,   2,   1}; //   3

  c_p[x_a][4] = {  5,   6,   7}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  2}; //   1
  c_d[x_a][4] = {  5,   1,   6}; //   3

  c_p[x_a][5] = {  8,   9,  10}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  7,   1,   8}; //   3

  c_p[x_a][6] = {  0,   2,   4}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  9,   4,   2,   1}; //   4

  c_p[x_a][7] = {  0,   1,   3}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = { 10,   3,   0,   1}; //   4

  c_p[x_a][8] = {  5,   6,   7}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  9,   5,   1,   6}; //   4

  c_p[x_a][9] = {  8,   9,  10}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = { 10,   7,   1,   8}; //   4

  c_p[x_a][10] = {  0,   1,  11}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = { 11,   6,   0,   1}; //   4

  c_p[x_a][11] = {  0,   2,  12}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 12,   8,   2,   1}; //   4

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  2,   3}; //   2
  c_t[x_a][12] = {  4,   5,   6}; //   3
  c_d[x_a][12] = {  1}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {  2,   4}; //   2
  c_t[x_a][13] = {  7,   8,   9}; //   3
  c_d[x_a][13] = {  1}; //   1

  c_p[x_a][14] = {  0,   2,   4}; //   3
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  4}; //   1
  c_d[x_a][14] = {  4,   2,   1}; //   3

  c_p[x_a][15] = {  0,   1,   3}; //   3
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {  7}; //   1
  c_d[x_a][15] = {  3,   0,   1}; //   3

  c_p[x_a][16] = {  5,   6,   7}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  4}; //   1
  c_d[x_a][16] = {  5,   1,   6}; //   3

  c_p[x_a][17] = {  8,   9,  10}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  7}; //   1
  c_d[x_a][17] = {  7,   1,   8}; //   3

  c_p[x_a][18] = {  0}; //   1
  c_f[x_a][18] = {  2,   3}; //   2
  c_t[x_a][18] = {  4,   5,  10}; //   3
  c_d[x_a][18] = {  1}; //   1

  c_p[x_a][19] = {  0}; //   1
  c_f[x_a][19] = {  2,   4}; //   2
  c_t[x_a][19] = {  7,   8,  11}; //   3
  c_d[x_a][19] = {  1}; //   1

  c_p[x_a][20] = {  0,   2}; //   2
  c_f[x_a][20] = {  1}; //   1
  c_t[x_a][20] = {  4,  12}; //   2
  c_d[x_a][20] = {  2,   1}; //   2

  c_p[x_a][21] = {  0,   1}; //   2
  c_f[x_a][21] = {  0}; //   1
  c_t[x_a][21] = {  7,  13}; //   2
  c_d[x_a][21] = {  0,   1}; //   2

  c_p[x_a][22] = {  0,  13}; //   2
  c_f[x_a][22] = {  5}; //   1
  c_t[x_a][22] = {  0,  14}; //   2
  c_d[x_a][22] = {  8,   1}; //   2

  c_p[x_a][23] = {  0,  14}; //   2
  c_f[x_a][23] = {  6}; //   1
  c_t[x_a][23] = {  2,  15}; //   2
  c_d[x_a][23] = {  6,   1}; //   2

  c_p[x_a][24] = {  0,   1,  11}; //   3
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = { 16}; //   1
  c_d[x_a][24] = {  6,   0,   1}; //   3

  c_p[x_a][25] = {  0,   2,  12}; //   3
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = { 17}; //   1
  c_d[x_a][25] = {  8,   2,   1}; //   3

  c_p[x_a][26] = {  5,   6,  15}; //   3
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = { 18}; //   1
  c_d[x_a][26] = {  0,   1,   6}; //   3

  c_p[x_a][27] = {  8,   9,  16}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 19}; //   1
  c_d[x_a][27] = {  2,   1,   8}; //   3

  c_p[x_a][28] = {  5,   6}; //   2
  c_f[x_a][28] = {  6}; //   1
  c_t[x_a][28] = {  4,  20}; //   2
  c_d[x_a][28] = {  1,   6}; //   2

  c_p[x_a][29] = {  8,   9}; //   2
  c_f[x_a][29] = {  5}; //   1
  c_t[x_a][29] = {  7,  21}; //   2
  c_d[x_a][29] = {  1,   8}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_gg_vevexauux
//  channel    0: 3yv11(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel    1: 3yv11(1, 2, 32, 4, 8, 16, 64;  23,   0,   0,   0)
//  channel    2: 4yyv1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
//  channel    3: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
//  channel    4: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel    5: 42vv1(1, 2, 4, 8, 16, 64, 32;   0,  23,   0,   0)
//  channel    6: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel    7: 5yyyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel    8: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
//  channel    9: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   10: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   11: 52vyv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   12: 12v11(1, 2, 64, 4, 8, 16, 32;  23,   0,   0,   0)
//  channel   13: 12v11(1, 2, 32, 4, 8, 16, 64;  23,   0,   0,   0)
//  channel   14: 14yyv(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel   15: 14yyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel   16: 142vv(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
//  channel   17: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   18: 112v1(1, 2, 64, 16, 4, 8, 32;  23,   0,   0,   0)
//  channel   19: 112v1(1, 2, 32, 16, 4, 8, 64;  23,   0,   0,   0)
//  channel   20: 113yv(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel   21: 113yv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel   22: 2v2v1(1, 2, 16, 64, 4, 8, 32;  23,   0,   0,   0)
//  channel   23: 2v2v1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
//  channel   24: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   25: 2v3yv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   26: 3yv2v(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
//  channel   27: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   28: 12v2v(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
//  channel   29: 12v2v(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
