#include "header.hpp"

#include "ppnenexa03.phasespace.set.hpp"

void ppnenexa03_phasespace_set::ax_psp_230_uux_vevexauux(int x_a){
  static Logger logger("ppnenexa03_phasespace_set::ax_psp_230_uux_vevexauux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(17);
  needed_v_smin[x_a].resize(17);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  40
  needed_v_smin[x_a][  1] = {   2,    4,    5,    7,   12,   15,   17,   34,   13}; //   9
  needed_v_smin[x_a][  2] = {   3,    8,   11,   14,   16,   18,   21,   29,   20,   32}; //  10
  needed_v_smin[x_a][  3] = {   3,   16,   21}; //   3
  needed_v_smin[x_a][  4] = {   4,   17,    2,   13,   15}; //   5
  needed_v_smin[x_a][  5] = {   5,    7}; //   2
  needed_v_smin[x_a][  6] = {   6,    9,   11,   24,   27,   29,   32,   35,    0}; //   9
  needed_v_smin[x_a][  7] = {   6,    9,    0,   24}; //   4
  needed_v_smin[x_a][  8] = {   8,   18,   14,   20}; //   4
  needed_v_smin[x_a][  9] = {  10,   12,   19,   28,   31,   34,   36,   39,   23}; //   9
  needed_v_smin[x_a][ 10] = {  10,   19,   23,   39}; //   4
  needed_v_smin[x_a][ 11] = {  25,   26,   30,   33,   37,   38,    1,   22}; //   8
  needed_v_smin[x_a][ 12] = {  27,   35}; //   2
  needed_v_smin[x_a][ 13] = {  28,   36,   31}; //   3
  needed_v_smin[x_a][ 14] = {   1,   22,   25,   26,   37,   38}; //   6
  needed_v_smin[x_a][ 15] = {  30}; //   1
  needed_v_smin[x_a][ 16] = {  33}; //   1

  v_smax[x_a].resize(23);
  needed_v_smax[x_a].resize(23);
  needed_v_smax[x_a][  0] = {   0,    1,    2,    3,    4,    5,    7,    8,   11,   12,   13,   14,   15,   16,   17,   18,   20,   21,   22,   23,   26,   29,   32,   33,   35,   36,   38,   39}; //  28
  needed_v_smax[x_a][  1] = {   2,    4,    5,    7,   12,   15,   17,   13}; //   8
  needed_v_smax[x_a][  2] = {   3,    8,   11,   14,   16,   18,   21,   29,   20}; //   9
  needed_v_smax[x_a][  3] = {   3,    4,   16,   17,    1,    2,   13,   15,   21,   22,   25,   26,   37,   38}; //  14
  needed_v_smax[x_a][  4] = {   5,    6,    7,    9,    0,   24}; //   6
  needed_v_smax[x_a][  5] = {   6,    9,   24,   27}; //   4
  needed_v_smax[x_a][  6] = {   6,    9,   24}; //   3
  needed_v_smax[x_a][  7] = {   8,   10,   18,   19,   14,   20,   23,   39}; //   8
  needed_v_smax[x_a][  8] = {  10,   19,   28,   31,   34}; //   5
  needed_v_smax[x_a][  9] = {  10,   19,   31,   34}; //   4
  needed_v_smax[x_a][ 10] = {  11,   29}; //   2
  needed_v_smax[x_a][ 11] = {  12}; //   1
  needed_v_smax[x_a][ 12] = {  25,   30,   37}; //   3
  needed_v_smax[x_a][ 13] = {  25,   30,   37}; //   3
  needed_v_smax[x_a][ 14] = {  26,   33,   38,    1,   22}; //   5
  needed_v_smax[x_a][ 15] = {  27,   28}; //   2
  needed_v_smax[x_a][ 16] = {  27,   28}; //   2
  needed_v_smax[x_a][ 17] = {  32,   35,    0}; //   3
  needed_v_smax[x_a][ 18] = {  34}; //   1
  needed_v_smax[x_a][ 19] = {  35,   36,   30,   31}; //   4
  needed_v_smax[x_a][ 20] = {  36,   39,   23}; //   3
  needed_v_smax[x_a][ 21] = {  32}; //   1
  needed_v_smax[x_a][ 22] = {  33}; //   1

  g_p[x_a].resize(26);
  needed_g_p[x_a].resize(26);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,    7,    8,   11,   12,   13,   14,   15,   16,   17,   18,   20,   21,   22,   23,   26,   29,   32,   33,   35,   36,   38,   39}; //  28
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   2,    4,    5,    7,   12,   15,   17}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   3,    8,   11,   14,   16,   18,   21,   29}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   3,   16}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   4,   17}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][5] = {   5,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][6] = {   6,    9,   24,   27}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax5");
  needed_g_p[x_a][7] = {   6,    9,   24}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax6");
  needed_g_p[x_a][8] = {   6,    9}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin7_smax4");
  needed_g_p[x_a][9] = {   8,   18}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin8_smax7");
  needed_g_p[x_a][10] = {  10,   19,   28,   31,   34}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax8");
  needed_g_p[x_a][11] = {  10,   19,   31,   34}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax9");
  needed_g_p[x_a][12] = {  10,   19}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin10_smax7");
  needed_g_p[x_a][13] = {  11,   29}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax10");
  needed_g_p[x_a][14] = {  12}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax11");
  needed_g_p[x_a][15] = {  25,   30,   37}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax12");
  needed_g_p[x_a][16] = {  25,   30,   37}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax13");
  needed_g_p[x_a][17] = {  26,   33,   38}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin11_smax14");
  needed_g_p[x_a][18] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax15");
  needed_g_p[x_a][19] = {  27,   28}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax16");
  needed_g_p[x_a][20] = {  28}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax15");
  needed_g_p[x_a][21] = {  32,   35}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax17");
  needed_g_p[x_a][22] = {  34}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax18");
  needed_g_p[x_a][23] = {  35}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin12_smax19");
  needed_g_p[x_a][24] = {  36,   39}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin9_smax20");
  needed_g_p[x_a][25] = {  36}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin13_smax19");

  g_f[x_a].resize(15);
  needed_g_f[x_a].resize(15);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax17");
  needed_g_f[x_a][1] = {   0,   24}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax4");
  needed_g_f[x_a][2] = {   1,   22}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax14");
  needed_g_f[x_a][3] = {   1,   22,   25,   26,   37,   38}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax3");
  needed_g_f[x_a][4] = {   2,   13,   15}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax3");
  needed_g_f[x_a][5] = {  13}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][6] = {  14,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax7");
  needed_g_f[x_a][7] = {  20}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][8] = {  21}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][9] = {  23}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax20");
  needed_g_f[x_a][10] = {  23,   39}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax7");
  needed_g_f[x_a][11] = {  30}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax19");
  needed_g_f[x_a][12] = {  31}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax19");
  needed_g_f[x_a][13] = {  32}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax21");
  needed_g_f[x_a][14] = {  33}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax22");

  g_t[x_a].resize(29);
  needed_g_t[x_a].resize(29);
  needed_g_t[x_a][0] = {   0,    5,    6,   24}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__64_60");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__64_60");
  needed_g_t[x_a][1] = {   0,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_66__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_66__12_48");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_13__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_13__32_16");
  needed_g_t[x_a][3] = {   1,    2,    3,    4,   25,   26}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_108");
  needed_g_t[x_a][4] = {   1,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_96");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__18_13__64_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__18_13__64_32");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__18_1__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__18_1__64_44");
  needed_g_t[x_a][7] = {  13,   15,   16,   17,   21,   22,   37,   38}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_108");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_108");
  needed_g_t[x_a][8] = {  13,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__64_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__64_44");
  needed_g_t[x_a][9] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__66_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__66_17__32_12");
  needed_g_t[x_a][10] = {  14,   18,   19,   20,   23,   39}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_92");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_92");
  needed_g_t[x_a][11] = {  14,   20}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_76");
  needed_g_t[x_a][12] = {  20}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__64_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__64_12");
  needed_g_t[x_a][13] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__17_2__32_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__17_2__32_76");
  needed_g_t[x_a][14] = {  22,   38}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_96");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_96");
  needed_g_t[x_a][15] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_14__32_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_14__32_64");
  needed_g_t[x_a][16] = {  23,   39}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_80");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_80");
  needed_g_t[x_a][17] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_14__64_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_14__64_16");
  needed_g_t[x_a][18] = {  26}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__96_12");
  needed_g_t[x_a][19] = {  27,   28,   30,   31}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_112");
  needed_g_t[x_a][20] = {  29,   32}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_76");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_76");
  needed_g_t[x_a][21] = {  30}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__96_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__96_16");
  needed_g_t[x_a][22] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_13__80_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_13__80_32");
  needed_g_t[x_a][23] = {  32}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_49__12_64");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_49__12_64");
  needed_g_t[x_a][24] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__96_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__96_28");
  needed_g_t[x_a][25] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_97__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_97__12_16");
  needed_g_t[x_a][26] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__80_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__80_44");
  needed_g_t[x_a][27] = {  35,   36}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__12_112");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__12_112");
  needed_g_t[x_a][28] = {  37}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__96_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__96_12");

  g_d[x_a].resize(18);
  needed_g_d[x_a].resize(18);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39}; //  40
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   2,    4,    5,    7,   12,   15,   17,   34}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   3,   16}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__32_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__32_76");
  needed_g_d[x_a][3] = {   3,    8,   11,   14,   16,   18,   21,   29}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_76__64_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_76__64_12");
  needed_g_d[x_a][4] = {   4,   17}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_108__64_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_108__64_44");
  needed_g_d[x_a][5] = {   5,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][6] = {   6,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][7] = {   6,    9,   11,   24,   27,   29,   32,   35}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][8] = {   7,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__64_60");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__64_60");
  needed_g_d[x_a][9] = {   8,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__32_92");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__32_92");
  needed_g_d[x_a][10] = {   8,   18}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__16_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__16_76");
  needed_g_d[x_a][11] = {  10,   19}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_92__12_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_92__12_80");
  needed_g_d[x_a][12] = {  10,   12,   19,   28,   31,   34,   36,   39}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_80__16_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_80__16_64");
  needed_g_d[x_a][13] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__48_76");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__48_76");
  needed_g_d[x_a][14] = {  12}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_124__80_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_124__80_44");
  needed_g_d[x_a][15] = {  25,   26,   30,   33,   37,   38}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_96__32_64");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_96__32_64");
  needed_g_d[x_a][16] = {  27,   35}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__64_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__64_48");
  needed_g_d[x_a][17] = {  28,   36}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_112__32_80");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_112__32_80");

  c_p[x_a].resize(40);
  c_f[x_a].resize(40);
  c_t[x_a].resize(40);
  c_d[x_a].resize(40);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0,   1}; //   2
  c_f[x_a][2] = {  4}; //   1
  c_t[x_a][2] = {  3,   6}; //   2
  c_d[x_a][2] = {  1,   0}; //   2

  c_p[x_a][3] = {  0,   2,   3}; //   3
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  3}; //   1
  c_d[x_a][3] = {  2,   3,   0}; //   3

  c_p[x_a][4] = {  0,   1,   4}; //   3
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  3}; //   1
  c_d[x_a][4] = {  4,   1,   0}; //   3

  c_p[x_a][5] = {  0,   1,   5}; //   3
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  5,   1,   0}; //   3

  c_p[x_a][6] = {  6,   7,   8}; //   3
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  0}; //   1
  c_d[x_a][6] = {  6,   0,   7}; //   3

  c_p[x_a][7] = {  0,   1,   5}; //   3
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  8,   5,   1,   0}; //   4

  c_p[x_a][8] = {  0,   2,   9}; //   3
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  9,  10,   3,   0}; //   4

  c_p[x_a][9] = {  6,   7,   8}; //   3
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  8,   6,   0,   7}; //   4

  c_p[x_a][10] = { 10,  11,  12}; //   3
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  9,  11,   0,  12}; //   4

  c_p[x_a][11] = {  0,   2,  13}; //   3
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = { 13,   7,   3,   0}; //   4

  c_p[x_a][12] = {  0,   1,  14}; //   3
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = { 14,  12,   1,   0}; //   4

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {  5,   4}; //   2
  c_t[x_a][13] = {  7,   8,   9}; //   3
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  0,   2}; //   2
  c_f[x_a][14] = {  6}; //   1
  c_t[x_a][14] = { 10,  11}; //   2
  c_d[x_a][14] = {  3,   0}; //   2

  c_p[x_a][15] = {  0,   1}; //   2
  c_f[x_a][15] = {  4}; //   1
  c_t[x_a][15] = {  7,   8}; //   2
  c_d[x_a][15] = {  1,   0}; //   2

  c_p[x_a][16] = {  0,   2,   3}; //   3
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {  7}; //   1
  c_d[x_a][16] = {  2,   3,   0}; //   3

  c_p[x_a][17] = {  0,   1,   4}; //   3
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {  7}; //   1
  c_d[x_a][17] = {  4,   1,   0}; //   3

  c_p[x_a][18] = {  0,   2,   9}; //   3
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = { 10}; //   1
  c_d[x_a][18] = { 10,   3,   0}; //   3

  c_p[x_a][19] = { 10,  11,  12}; //   3
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = { 10}; //   1
  c_d[x_a][19] = { 11,   0,  12}; //   3

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = {  7,   6}; //   2
  c_t[x_a][20] = { 10,  11,  12}; //   3
  c_d[x_a][20] = {  0}; //   1

  c_p[x_a][21] = {  0,   2}; //   2
  c_f[x_a][21] = {  8}; //   1
  c_t[x_a][21] = {  7,  13}; //   2
  c_d[x_a][21] = {  3,   0}; //   2

  c_p[x_a][22] = {  0}; //   1
  c_f[x_a][22] = {  2,   3}; //   2
  c_t[x_a][22] = {  7,  14,  15}; //   3
  c_d[x_a][22] = {  0}; //   1

  c_p[x_a][23] = {  0}; //   1
  c_f[x_a][23] = {  9,  10}; //   2
  c_t[x_a][23] = { 10,  16,  17}; //   3
  c_d[x_a][23] = {  0}; //   1

  c_p[x_a][24] = {  6,   7}; //   2
  c_f[x_a][24] = {  1}; //   1
  c_t[x_a][24] = {  0,   1}; //   2
  c_d[x_a][24] = {  0,   7}; //   2

  c_p[x_a][25] = { 15,  16}; //   2
  c_f[x_a][25] = {  3}; //   1
  c_t[x_a][25] = {  3,   4}; //   2
  c_d[x_a][25] = {  0,  15}; //   2

  c_p[x_a][26] = {  0,  17}; //   2
  c_f[x_a][26] = {  3}; //   1
  c_t[x_a][26] = {  3,  18}; //   2
  c_d[x_a][26] = { 15,   0}; //   2

  c_p[x_a][27] = {  6,  18,  19}; //   3
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 19}; //   1
  c_d[x_a][27] = {  0,  16,   7}; //   3

  c_p[x_a][28] = { 10,  20,  19}; //   3
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 19}; //   1
  c_d[x_a][28] = {  0,  17,  12}; //   3

  c_p[x_a][29] = {  0,   2,  13}; //   3
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = { 20}; //   1
  c_d[x_a][29] = {  7,   3,   0}; //   3

  c_p[x_a][30] = { 15,  16}; //   2
  c_f[x_a][30] = { 11}; //   1
  c_t[x_a][30] = { 19,  21}; //   2
  c_d[x_a][30] = {  0,  15}; //   2

  c_p[x_a][31] = { 10,  11}; //   2
  c_f[x_a][31] = { 12}; //   1
  c_t[x_a][31] = { 19,  22}; //   2
  c_d[x_a][31] = {  0,  12}; //   2

  c_p[x_a][32] = {  0,  21}; //   2
  c_f[x_a][32] = { 13}; //   1
  c_t[x_a][32] = { 20,  23}; //   2
  c_d[x_a][32] = {  7,   0}; //   2

  c_p[x_a][33] = {  0,  17}; //   2
  c_f[x_a][33] = { 14}; //   1
  c_t[x_a][33] = { 24,  25}; //   2
  c_d[x_a][33] = { 15,   0}; //   2

  c_p[x_a][34] = { 10,  11,  22}; //   3
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = { 26}; //   1
  c_d[x_a][34] = {  1,   0,  12}; //   3

  c_p[x_a][35] = {  0,  21,  23}; //   3
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = { 27}; //   1
  c_d[x_a][35] = { 16,   7,   0}; //   3

  c_p[x_a][36] = {  0,  24,  25}; //   3
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = { 27}; //   1
  c_d[x_a][36] = { 17,  12,   0}; //   3

  c_p[x_a][37] = { 15,  16}; //   2
  c_f[x_a][37] = {  3}; //   1
  c_t[x_a][37] = {  7,  28}; //   2
  c_d[x_a][37] = {  0,  15}; //   2

  c_p[x_a][38] = {  0,  17}; //   2
  c_f[x_a][38] = {  3}; //   1
  c_t[x_a][38] = {  7,  14}; //   2
  c_d[x_a][38] = { 15,   0}; //   2

  c_p[x_a][39] = {  0,  24}; //   2
  c_f[x_a][39] = { 10}; //   1
  c_t[x_a][39] = { 10,  16}; //   2
  c_d[x_a][39] = { 12,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_230_uux_vevexauux
//  channel    0: 2v111(1, 2, 4, 8, 16, 32, 64;  23,   0,   0,   0)
//  channel    1: 2v111(1, 2, 4, 8, 32, 64, 16;  23,   0,   0,   0)
//  channel    2: 3yv11(1, 2, 32, 4, 8, 64, 16;  23,   0,   0,   0)
//  channel    3: 4yyv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel    4: 4yyv1(1, 2, 64, 32, 4, 8, 16;  23,   0,   0,   0)
//  channel    5: 4yyv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
//  channel    6: 42vv1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel    7: 5yyyv(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel    8: 5yyyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel    9: 5y2vv(1, 2, 64, 4, 8, 16, 32;   0,  23,   0,   0)
//  channel   10: 5y2vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   11: 52vyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   12: 52vyv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   13: 12v11(1, 2, 16, 4, 8, 32, 64;  23,   0,   0,   0)
//  channel   14: 13yv1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   15: 13yv1(1, 2, 16, 32, 4, 8, 64;  23,   0,   0,   0)
//  channel   16: 14yyv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   17: 14yyv(1, 2, 16, 64, 32, 4, 8;  23,   0,   0,   0)
//  channel   18: 14yyv(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel   19: 142vv(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   20: 112v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   21: 113yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   22: 1112v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   23: 1112v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
//  channel   24: 2v2v1(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel   25: 2v2v1(1, 2, 4, 8, 32, 64, 16;   0,  23,   0,   0)
//  channel   26: 2v2v1(1, 2, 32, 64, 4, 8, 16;  23,   0,   0,   0)
//  channel   27: 2v3yv(1, 2, 4, 8, 64, 16, 32;   0,   0,  23,   0)
//  channel   28: 2v3yv(1, 2, 4, 8, 32, 16, 64;   0,   0,  23,   0)
//  channel   29: 2v3yv(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   30: 2v12v(1, 2, 4, 8, 16, 32, 64;   0,  23,   0,   0)
//  channel   31: 2v12v(1, 2, 4, 8, 32, 16, 64;   0,  23,   0,   0)
//  channel   32: 2v12v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   33: 2v12v(1, 2, 32, 64, 16, 4, 8;  23,   0,   0,   0)
//  channel   34: 3yv2v(1, 2, 32, 4, 8, 16, 64;   0,  23,   0,   0)
//  channel   35: 3yv2v(1, 2, 64, 16, 32, 4, 8;  23,   0,   0,   0)
//  channel   36: 3yv2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
//  channel   37: 12v2v(1, 2, 16, 4, 8, 32, 64;   0,  23,   0,   0)
//  channel   38: 12v2v(1, 2, 16, 32, 64, 4, 8;  23,   0,   0,   0)
//  channel   39: 12v2v(1, 2, 32, 16, 64, 4, 8;  23,   0,   0,   0)
