#include "header.hpp"

#include "ppnenexa03.phasespace.set.hpp"

void ppnenexa03_phasespace_set::ax_psp_040_da_vevexad(int x_a){
  static Logger logger("ppnenexa03_phasespace_set::ax_psp_040_da_vevexad");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(4);
  needed_v_smin[x_a].resize(4);
  needed_v_smin[x_a][  0] = {   0,    1,    2,    3,    4,    5}; //   6
  needed_v_smin[x_a][  1] = {   1,    4,    3}; //   3
  needed_v_smin[x_a][  2] = {   2,    5}; //   2
  needed_v_smin[x_a][  3] = {   0}; //   1

  v_smax[x_a].resize(5);
  needed_v_smax[x_a].resize(5);
  needed_v_smax[x_a][  0] = {   0,    1,    3,    4}; //   4
  needed_v_smax[x_a][  1] = {   1,    4,    3}; //   3
  needed_v_smax[x_a][  2] = {   2,    5}; //   2
  needed_v_smax[x_a][  3] = {   2,    5}; //   2
  needed_v_smax[x_a][  4] = {   0}; //   1

  g_p[x_a].resize(4);
  needed_g_p[x_a].resize(4);
  needed_g_p[x_a][0] = {   0,    1,    3,    4}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   1,    4}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   2,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   2,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax3");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax4");
  needed_g_f[x_a][1] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(5);
  needed_g_t[x_a].resize(5);
  needed_g_t[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][3] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][4] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");

  g_d[x_a].resize(5);
  needed_g_d[x_a].resize(5);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   1}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][2] = {   1,    4}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {   2}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][4] = {   2,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(6);
  c_f[x_a].resize(6);
  c_t[x_a].resize(6);
  c_d[x_a].resize(6);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0,   1}; //   2
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {}; //   0
  c_d[x_a][1] = {  1,   2,   0}; //   3

  c_p[x_a][2] = {  2,   3}; //   2
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {}; //   0
  c_d[x_a][2] = {  3,   0,   4}; //   3

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  1}; //   1
  c_t[x_a][3] = {  2,   3}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0,   1}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  2}; //   1
  c_d[x_a][4] = {  2,   0}; //   2

  c_p[x_a][5] = {  2,   3}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  4}; //   1
  c_d[x_a][5] = {  0,   4}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_040_da_vevexad
//  channel    0: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    1: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel    2: 42vv(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel    3: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel    4: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel    5: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
