#include "header.hpp"

#include "ppnenexa03.phasespace.set.hpp"

void ppnenexa03_phasespace_set::ax_psp_330_gg_vevexag(int x_a){
  static Logger logger("ppnenexa03_phasespace_set::ax_psp_330_gg_vevexag");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(4);
  needed_v_smin[x_a].resize(4);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  48
  needed_v_smin[x_a][  0] = get_vector_from_array_int(needed_v_smin_0, 48);
  int needed_v_smin_1[] = {   6,    7,   12,   13,   14,   15,   32,   33,    4,    5,   28,   29,   30,   31,   38,   39}; //  16
  needed_v_smin[x_a][  1] = get_vector_from_array_int(needed_v_smin_1, 16);
  int needed_v_smin_2[] = {   8,    9,   10,   11,   16,   17,   18,   19,   34,   35,   36,   37,    0,    1,    2,    3,   24,   25,   26,   27,   40,   41,   42,   43}; //  24
  needed_v_smin[x_a][  2] = get_vector_from_array_int(needed_v_smin_2, 24);
  int needed_v_smin_3[] = {  20,   21,   22,   23,   44,   45,   46,   47}; //   8
  needed_v_smin[x_a][  3] = get_vector_from_array_int(needed_v_smin_3, 8);

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   46,   47}; //  42
  needed_v_smax[x_a][  0] = get_vector_from_array_int(needed_v_smax_0, 42);
  int needed_v_smax_1[] = {   6,    7,   12,   13,   14,   15,   32,   33,    4,    5,   28,   29,   30,   31,   38,   39}; //  16
  needed_v_smax[x_a][  1] = get_vector_from_array_int(needed_v_smax_1, 16);
  int needed_v_smax_2[] = {   8,    9,   10,   11,   16,   17,   18,   19,   34,   35,   36,   37,    0,    1,    2,    3,   24,   25,   26,   27,   40,   41,   42,   43}; //  24
  needed_v_smax[x_a][  2] = get_vector_from_array_int(needed_v_smax_2, 24);
  int needed_v_smax_3[] = {  20,   21,   22,   23,   44,   45}; //   6
  needed_v_smax[x_a][  3] = get_vector_from_array_int(needed_v_smax_3, 6);
  int needed_v_smax_4[] = {  20,   21,   22,   23,   44,   45}; //   6
  needed_v_smax[x_a][  4] = get_vector_from_array_int(needed_v_smax_4, 6);
  int needed_v_smax_5[] = {  46,   47}; //   2
  needed_v_smax[x_a][  5] = get_vector_from_array_int(needed_v_smax_5, 2);

  g_p[x_a].resize(10);
  needed_g_p[x_a].resize(10);
  needed_g_p[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   46,   47}; //  42
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][1] = {   6,   12,   13,   32}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   7,   14,   15,   33}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin1_smax1");
  needed_g_p[x_a][3] = {   8,    9,   16,   17,   34,   35}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {  10,   11,   18,   19,   36,   37}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin2_smax2");
  needed_g_p[x_a][5] = {  20,   21,   44}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][6] = {  20,   21,   22,   23,   44,   45}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax4");
  needed_g_p[x_a][7] = {  22,   23,   45}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin3_smax3");
  needed_g_p[x_a][8] = {  46}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax5");
  needed_g_p[x_a][9] = {  47}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_36_smin3_smax5");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    1,    2,    3,   24,   25,   26,   27,   40,   41,   42,   43}; //  12
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   4,    5,   28,   29,   30,   31,   38,   39}; //   8
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(24);
  needed_g_t[x_a].resize(24);
  needed_g_t[x_a][0] = {   0,    1,    2,    8,    9,   10}; //   6
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][1] = {   0,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][2] = {   1,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_34__12_16");
  needed_g_t[x_a][3] = {   3,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__32_28");
  needed_g_t[x_a][4] = {   4,    6}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][5] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][6] = {   5,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_1__16_44");
  needed_g_t[x_a][7] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_18__12_32");
  needed_g_t[x_a][8] = {  24,   25,   26,   34,   35,   36,   40,   41,   42}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][9] = {  24,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][10] = {  25,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_33__16_12");
  needed_g_t[x_a][11] = {  27,   37,   43}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__32_28");
  needed_g_t[x_a][12] = {  28,   29,   32,   38}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][13] = {  28,   29,   30}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][14] = {  30,   31,   33,   39}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__16_44");
  needed_g_t[x_a][15] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_17__32_12");
  needed_g_t[x_a][16] = {  38}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][17] = {  39}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_17__12_32");
  needed_g_t[x_a][18] = {  40,   42}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");
  needed_g_t[x_a][19] = {  41,   43}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__2_33__12_16");
  needed_g_t[x_a][20] = {  44}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][21] = {  45}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__12_48");
  needed_g_t[x_a][22] = {  46}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");
  needed_g_t[x_a][23] = {  47}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__48_12");

  g_d[x_a].resize(7);
  needed_g_d[x_a].resize(7);
  needed_g_d[x_a][0] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  48
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   6,    7,   12,   13,   14,   15,   32,   33}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   8,    9,   10,   11,   16,   17,   18,   19,   34,   35,   36,   37}; //  12
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {  12,   13,   14,   15}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][4] = {  16,   17,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][5] = {  20,   21,   22,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");
  needed_g_d[x_a][6] = {  20,   21,   22,   23,   44,   45,   46,   47}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(48);
  c_f[x_a].resize(48);
  c_t[x_a].resize(48);
  c_d[x_a].resize(48);

  c_p[x_a][0] = {  0}; //   1
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {  0}; //   1

  c_p[x_a][1] = {  0}; //   1
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   2}; //   2
  c_d[x_a][1] = {  0}; //   1

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  0}; //   1
  c_t[x_a][2] = {  0,   1}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  0}; //   1
  c_t[x_a][3] = {  3,   2}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  1}; //   1
  c_t[x_a][4] = {  4,   5}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  6,   7}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0,   1}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  4}; //   1
  c_d[x_a][6] = {  1,   0}; //   2

  c_p[x_a][7] = {  0,   2}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  6}; //   1
  c_d[x_a][7] = {  1,   0}; //   2

  c_p[x_a][8] = {  0,   3}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  0}; //   1
  c_d[x_a][8] = {  2,   0}; //   2

  c_p[x_a][9] = {  0,   3}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  2,   0}; //   2

  c_p[x_a][10] = {  0,   4}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  2,   0}; //   2

  c_p[x_a][11] = {  0,   4}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  3}; //   1
  c_d[x_a][11] = {  2,   0}; //   2

  c_p[x_a][12] = {  0,   1}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {}; //   0
  c_d[x_a][12] = {  3,   1,   0}; //   3

  c_p[x_a][13] = {  0,   1}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  3,   1,   0}; //   3

  c_p[x_a][14] = {  0,   2}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  3,   1,   0}; //   3

  c_p[x_a][15] = {  0,   2}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  3,   1,   0}; //   3

  c_p[x_a][16] = {  0,   3}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  4,   2,   0}; //   3

  c_p[x_a][17] = {  0,   3}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  4,   2,   0}; //   3

  c_p[x_a][18] = {  0,   4}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  4,   2,   0}; //   3

  c_p[x_a][19] = {  0,   4}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  4,   2,   0}; //   3

  c_p[x_a][20] = {  5,   6}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  5,   0,   6}; //   3

  c_p[x_a][21] = {  5,   6}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  5,   0,   6}; //   3

  c_p[x_a][22] = {  7,   6}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {}; //   0
  c_d[x_a][22] = {  5,   0,   6}; //   3

  c_p[x_a][23] = {  7,   6}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {}; //   0
  c_d[x_a][23] = {  5,   0,   6}; //   3

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = {  0}; //   1
  c_t[x_a][24] = {  8,   9}; //   2
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  0}; //   1
  c_f[x_a][25] = {  0}; //   1
  c_t[x_a][25] = {  8,  10}; //   2
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  0}; //   1
  c_f[x_a][26] = {  0}; //   1
  c_t[x_a][26] = {  8,   9}; //   2
  c_d[x_a][26] = {  0}; //   1

  c_p[x_a][27] = {  0}; //   1
  c_f[x_a][27] = {  0}; //   1
  c_t[x_a][27] = { 11,  10}; //   2
  c_d[x_a][27] = {  0}; //   1

  c_p[x_a][28] = {  0}; //   1
  c_f[x_a][28] = {  1}; //   1
  c_t[x_a][28] = { 12,  13}; //   2
  c_d[x_a][28] = {  0}; //   1

  c_p[x_a][29] = {  0}; //   1
  c_f[x_a][29] = {  1}; //   1
  c_t[x_a][29] = { 12,  13}; //   2
  c_d[x_a][29] = {  0}; //   1

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = {  1}; //   1
  c_t[x_a][30] = { 14,  13}; //   2
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  0}; //   1
  c_f[x_a][31] = {  1}; //   1
  c_t[x_a][31] = { 14,  15}; //   2
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  0,   1}; //   2
  c_f[x_a][32] = {}; //   0
  c_t[x_a][32] = { 12}; //   1
  c_d[x_a][32] = {  1,   0}; //   2

  c_p[x_a][33] = {  0,   2}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = { 14}; //   1
  c_d[x_a][33] = {  1,   0}; //   2

  c_p[x_a][34] = {  0,   3}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = {  8}; //   1
  c_d[x_a][34] = {  2,   0}; //   2

  c_p[x_a][35] = {  0,   3}; //   2
  c_f[x_a][35] = {}; //   0
  c_t[x_a][35] = {  8}; //   1
  c_d[x_a][35] = {  2,   0}; //   2

  c_p[x_a][36] = {  0,   4}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = {  8}; //   1
  c_d[x_a][36] = {  2,   0}; //   2

  c_p[x_a][37] = {  0,   4}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = { 11}; //   1
  c_d[x_a][37] = {  2,   0}; //   2

  c_p[x_a][38] = {  0}; //   1
  c_f[x_a][38] = {  1}; //   1
  c_t[x_a][38] = { 12,  16}; //   2
  c_d[x_a][38] = {  0}; //   1

  c_p[x_a][39] = {  0}; //   1
  c_f[x_a][39] = {  1}; //   1
  c_t[x_a][39] = { 14,  17}; //   2
  c_d[x_a][39] = {  0}; //   1

  c_p[x_a][40] = {  0}; //   1
  c_f[x_a][40] = {  0}; //   1
  c_t[x_a][40] = {  8,  18}; //   2
  c_d[x_a][40] = {  0}; //   1

  c_p[x_a][41] = {  0}; //   1
  c_f[x_a][41] = {  0}; //   1
  c_t[x_a][41] = {  8,  19}; //   2
  c_d[x_a][41] = {  0}; //   1

  c_p[x_a][42] = {  0}; //   1
  c_f[x_a][42] = {  0}; //   1
  c_t[x_a][42] = {  8,  18}; //   2
  c_d[x_a][42] = {  0}; //   1

  c_p[x_a][43] = {  0}; //   1
  c_f[x_a][43] = {  0}; //   1
  c_t[x_a][43] = { 11,  19}; //   2
  c_d[x_a][43] = {  0}; //   1

  c_p[x_a][44] = {  5,   6}; //   2
  c_f[x_a][44] = {}; //   0
  c_t[x_a][44] = { 20}; //   1
  c_d[x_a][44] = {  0,   6}; //   2

  c_p[x_a][45] = {  7,   6}; //   2
  c_f[x_a][45] = {}; //   0
  c_t[x_a][45] = { 21}; //   1
  c_d[x_a][45] = {  0,   6}; //   2

  c_p[x_a][46] = {  0,   8}; //   2
  c_f[x_a][46] = {}; //   0
  c_t[x_a][46] = { 22}; //   1
  c_d[x_a][46] = {  6,   0}; //   2

  c_p[x_a][47] = {  0,   9}; //   2
  c_f[x_a][47] = {}; //   0
  c_t[x_a][47] = { 23}; //   1
  c_d[x_a][47] = {  6,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_130_gg_vevexag
//  channel    0: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    1: 2v11(1, 2, 4, 8, 16, 32;  23,   0,  36)
//  channel    2: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    3: 2v11(1, 2, 4, 8, 16, 32;  23,  36,  36)
//  channel    4: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel    5: 2v11(1, 2, 4, 8, 32, 16;  23,  36,  36)
//  channel    6: 3yv1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel    7: 3yv1(1, 2, 32, 4, 8, 16;  23,  36,  36)
//  channel    8: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel    9: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   10: 3yv1(1, 2, 16, 4, 8, 32;  23,  36,   0)
//  channel   11: 3yv1(1, 2, 16, 4, 8, 32;  23,  36,  36)
//  channel   12: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   13: 4yyv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   14: 4yyv(1, 2, 16, 32, 4, 8;  23,  36,   0)
//  channel   15: 4yyv(1, 2, 16, 32, 4, 8;  23,  36,  36)
//  channel   16: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   17: 4yyv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   18: 4yyv(1, 2, 32, 16, 4, 8;  23,  36,   0)
//  channel   19: 4yyv(1, 2, 32, 16, 4, 8;  23,  36,  36)
//  channel   20: 42vv(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   21: 42vv(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   22: 42vv(1, 2, 4, 8, 16, 32;  36,  23,   0)
//  channel   23: 42vv(1, 2, 4, 8, 16, 32;  36,  23,  36)
//  channel   24: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel   25: 12v1(1, 2, 32, 4, 8, 16;  23,   0,  36)
//  channel   26: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel   27: 12v1(1, 2, 32, 4, 8, 16;  23,  36,  36)
//  channel   28: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   29: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   30: 12v1(1, 2, 16, 4, 8, 32;  23,  36,   0)
//  channel   31: 12v1(1, 2, 16, 4, 8, 32;  23,  36,  36)
//  channel   32: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   33: 13yv(1, 2, 16, 32, 4, 8;  23,  36,  36)
//  channel   34: 13yv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   35: 13yv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   36: 13yv(1, 2, 32, 16, 4, 8;  23,  36,   0)
//  channel   37: 13yv(1, 2, 32, 16, 4, 8;  23,  36,  36)
//  channel   38: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   39: 112v(1, 2, 16, 32, 4, 8;  23,  36,  36)
//  channel   40: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   41: 112v(1, 2, 32, 16, 4, 8;  23,   0,  36)
//  channel   42: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   43: 112v(1, 2, 32, 16, 4, 8;  23,  36,  36)
//  channel   44: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   45: 2v2v(1, 2, 4, 8, 16, 32;  36,  23,  36)
//  channel   46: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   47: 2v2v(1, 2, 16, 32, 4, 8;  23,  36,  36)
