#include "header.hpp"

#include "ppttx20.phasespace.set.hpp"

void ppttx20_phasespace_set::ax_psp_400_ddx_ttxddx(int x_a){
  static Logger logger("ppttx20_phasespace_set::ax_psp_400_ddx_ttxddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(6);
  needed_v_smin[x_a].resize(6);
  needed_v_smin[x_a][  0] = {   2,    3,    5,    6,    8,    9,   10,   11,   12,   13,    0,    1}; //  12
  needed_v_smin[x_a][  1] = {   3,    6,    2}; //   3
  needed_v_smin[x_a][  2] = {   4,    7,    8,   12,   13}; //   5
  needed_v_smin[x_a][  3] = {   4}; //   1
  needed_v_smin[x_a][  4] = {   5,   10,    0,    1,    9,   11}; //   6
  needed_v_smin[x_a][  5] = {   7}; //   1

  v_smax[x_a].resize(8);
  needed_v_smax[x_a].resize(8);
  needed_v_smax[x_a][  0] = {   2,    3,    5,    6,    9,   10,   11,   13,    0,    1}; //  10
  needed_v_smax[x_a][  1] = {   3,    6,    2}; //   3
  needed_v_smax[x_a][  2] = {   4,    7,    8,   12}; //   4
  needed_v_smax[x_a][  3] = {   4}; //   1
  needed_v_smax[x_a][  4] = {   5,   10,    0,    1,    9,   11}; //   6
  needed_v_smax[x_a][  5] = {   7}; //   1
  needed_v_smax[x_a][  6] = {   8,   12}; //   2
  needed_v_smax[x_a][  7] = {  13}; //   1

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {   2,    3,    5,    6,    9,   10,   11,   13}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   3,    6}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   4,    7,    8,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {   4}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin3_smax3");
  needed_g_p[x_a][4] = {   5,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {   7}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin5_smax5");
  needed_g_p[x_a][6] = {   8,   12}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][7] = {  13}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax7");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][1] = {   0,    1,    9,   11}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][2] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(9);
  needed_g_t[x_a].resize(9);
  needed_g_t[x_a][0] = {   0,    1,    9,   10,   11}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][1] = {   0,    1,    9}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__4_8");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__8_4");
  needed_g_t[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][6] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][7] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][8] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   2,    3,    5,    6,    8,    9,   10,   11,   12,   13}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   3,    6}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][2] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][3] = {   4}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][4] = {   4,    7,    8,   12,   13}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][5] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][6] = {   5,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][7] = {   6}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][8] = {   7}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][9] = {   7}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][10] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");

  c_p[x_a].resize(14);
  c_f[x_a].resize(14);
  c_t[x_a].resize(14);
  c_d[x_a].resize(14);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1}; //   2
  c_t[x_a][1] = {  0,   1,   3}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  2}; //   1
  c_t[x_a][2] = {  4,   5}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  0,   1}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  4}; //   1
  c_d[x_a][3] = {  1,   0}; //   2

  c_p[x_a][4] = {  2,   3}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {}; //   0
  c_d[x_a][4] = {  2,   3,   4}; //   3

  c_p[x_a][5] = {  0,   4}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {}; //   0
  c_d[x_a][5] = {  5,   6,   0}; //   3

  c_p[x_a][6] = {  0,   1}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  7,   1,   0}; //   3

  c_p[x_a][7] = {  2,   5}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  8,   9,   4}; //   3

  c_p[x_a][8] = {  2,   6}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = { 10,   0,   4}; //   3

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  0,   1}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  0,   4}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  6,   0}; //   2

  c_p[x_a][11] = {  0}; //   1
  c_f[x_a][11] = {  1}; //   1
  c_t[x_a][11] = {  0,   6}; //   2
  c_d[x_a][11] = {  0}; //   1

  c_p[x_a][12] = {  2,   6}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  7}; //   1
  c_d[x_a][12] = {  0,   4}; //   2

  c_p[x_a][13] = {  0,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  8}; //   1
  c_d[x_a][13] = {  4,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_400_ddx_ttxddx
//  channel    0: 1111(1, 2, 16, 4, 8, 32;   0,   0,   6)
//  channel    1: 1111(1, 2, 16, 8, 4, 32;   0,   0,   6)
//  channel    2: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    3: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    4: 4yyv(1, 2, 4, 8, 16, 32;   0,   6,   0)
//  channel    5: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    6: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel    7: 4yyv(1, 2, 8, 4, 16, 32;   0,   6,   0)
//  channel    8: 42vv(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    9: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   10: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   11: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   12: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   13: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
