#include "header.hpp"

#include "ppttx20.phasespace.set.hpp"

void ppttx20_phasespace_set::ax_psp_400_gg_ttxddx(int x_a){
  static Logger logger("ppttx20_phasespace_set::ax_psp_400_gg_ttxddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(18);
  needed_v_smin[x_a].resize(18);
  needed_v_smin[x_a][  0] = {   8,    9,   12,   14,   17,   18,   20,   21,   23,   26,   27,   30,   31,   33,   34}; //  15
  needed_v_smin[x_a][  1] = {  10,   11,   13,   15,   16,   19,   20,   22,   24,   25,   28,   29,   32,   33,   34}; //  15
  needed_v_smin[x_a][  2] = {  12,   17,   26,    9,   23,   30}; //   6
  needed_v_smin[x_a][  3] = {  13,   19,   28,   10,   24,   32}; //   6
  needed_v_smin[x_a][  4] = {  14,   18,   27,    8,   21,   31}; //   6
  needed_v_smin[x_a][  5] = {  15,   16,   25,   11,   22,   29}; //   6
  needed_v_smin[x_a][  6] = {   0,    7}; //   2
  needed_v_smin[x_a][  7] = {   0}; //   1
  needed_v_smin[x_a][  8] = {   1,    6}; //   2
  needed_v_smin[x_a][  9] = {   1}; //   1
  needed_v_smin[x_a][ 10] = {   2,    5}; //   2
  needed_v_smin[x_a][ 11] = {   2}; //   1
  needed_v_smin[x_a][ 12] = {   3,    4}; //   2
  needed_v_smin[x_a][ 13] = {   3}; //   1
  needed_v_smin[x_a][ 14] = {   4}; //   1
  needed_v_smin[x_a][ 15] = {   5}; //   1
  needed_v_smin[x_a][ 16] = {   6}; //   1
  needed_v_smin[x_a][ 17] = {   7}; //   1

  v_smax[x_a].resize(12);
  needed_v_smax[x_a].resize(12);
  needed_v_smax[x_a][  0] = {   8,    9,   12,   14,   17,   18,   21,   23,   26,   27,   30,   31,   34}; //  13
  needed_v_smax[x_a][  1] = {  10,   11,   13,   15,   16,   19,   20,   22,   24,   25,   28,   29,   32,   33}; //  14
  needed_v_smax[x_a][  2] = {  12,   17,   26,    2,    6,    9,   23,   30}; //   8
  needed_v_smax[x_a][  3] = {  13,   19,   28,    4,    5,   10,   24,   32}; //   8
  needed_v_smax[x_a][  4] = {  14,   18,   27,    3,    7,    8,   21,   31}; //   8
  needed_v_smax[x_a][  5] = {  15,   16,   25,    0,    1,   11,   22,   29}; //   8
  needed_v_smax[x_a][  6] = {  20,   33}; //   2
  needed_v_smax[x_a][  7] = {  34}; //   1
  needed_v_smax[x_a][  8] = {   0,    7}; //   2
  needed_v_smax[x_a][  9] = {   1,    6}; //   2
  needed_v_smax[x_a][ 10] = {   2,    5}; //   2
  needed_v_smax[x_a][ 11] = {   3,    4}; //   2

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {   8,    9,   12,   14,   17,   18,   21,   23,   26,   27,   30,   31,   34}; //  13
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  10,   11,   13,   15,   16,   19,   20,   22,   24,   25,   28,   29,   32,   33}; //  14
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {  12,   17,   26}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][3] = {  13,   19,   28}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin3_smax3");
  needed_g_p[x_a][4] = {  14,   18,   27}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax4");
  needed_g_p[x_a][5] = {  15,   16,   25}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin5_smax5");
  needed_g_p[x_a][6] = {  20,   33}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax6");
  needed_g_p[x_a][7] = {  34}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax7");

  g_f[x_a].resize(16);
  needed_g_f[x_a].resize(16);
  needed_g_f[x_a][0] = {   0,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax8");
  needed_g_f[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][2] = {   1,    6}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax9");
  needed_g_f[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax5");
  needed_g_f[x_a][4] = {   2,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax10");
  needed_g_f[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax2");
  needed_g_f[x_a][6] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax11");
  needed_g_f[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax4");
  needed_g_f[x_a][8] = {   4}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin14_smax3");
  needed_g_f[x_a][9] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin15_smax3");
  needed_g_f[x_a][10] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin16_smax2");
  needed_g_f[x_a][11] = {   7}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin17_smax4");
  needed_g_f[x_a][12] = {   8,   21,   31}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][13] = {   9,   23,   30}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][14] = {  10,   24,   32}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][15] = {  11,   22,   29}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");

  g_t[x_a].resize(38);
  needed_g_t[x_a].resize(38);
  needed_g_t[x_a][0] = {   0,    1,   22,   25,   29}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__4_56");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_40");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__8_32");
  needed_g_t[x_a][5] = {   2,    6,   23,   26,   30}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__8_36");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][8] = {   3,    7,   21,   27,   31}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][9] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_33__8_20");
  needed_g_t[x_a][10] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__16_4");
  needed_g_t[x_a][11] = {   4,    5,   24,   28,   32}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__8_52");
  needed_g_t[x_a][12] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][13] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][14] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_36");
  needed_g_t[x_a][15] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__4_32");
  needed_g_t[x_a][16] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__4_40");
  needed_g_t[x_a][17] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_8");
  needed_g_t[x_a][18] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_33__4_24");
  needed_g_t[x_a][19] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_6__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_6__16_8");
  needed_g_t[x_a][20] = {   8,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][21] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][22] = {   9,   12}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][23] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][24] = {  10,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__8_52");
  needed_g_t[x_a][25] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_4");
  needed_g_t[x_a][26] = {  11,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__4_56");
  needed_g_t[x_a][27] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__48_8");
  needed_g_t[x_a][28] = {  21}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][29] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_5__8_48");
  needed_g_t[x_a][30] = {  23}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][31] = {  24}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_9__4_48");
  needed_g_t[x_a][32] = {  29}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__48_8");
  needed_g_t[x_a][33] = {  30}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][34] = {  31}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");
  needed_g_t[x_a][35] = {  32}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__48_4");
  needed_g_t[x_a][36] = {  33}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][37] = {  34}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(11);
  needed_g_d[x_a].resize(11);
  needed_g_d[x_a][0] = {   8,    9,   12,   14,   17,   18,   20,   21,   23,   26,   27,   30,   31,   33,   34}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  10,   11,   13,   15,   16,   19,   20,   22,   24,   25,   28,   29,   32,   33,   34}; //  15
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {  12,   17,   26}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][3] = {  13,   19,   28}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_52__4_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_52__4_48");
  needed_g_d[x_a][4] = {  14,   18,   27}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {  15,   16,   25}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][6] = {  16}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][7] = {  17}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][8] = {  18}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__32_28");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__32_28");
  needed_g_d[x_a][9] = {  19}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__8_52");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__8_52");
  needed_g_d[x_a][10] = {  20}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");

  c_p[x_a].resize(35);
  c_f[x_a].resize(35);
  c_t[x_a].resize(35);
  c_d[x_a].resize(35);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  4,   5}; //   2
  c_t[x_a][2] = {  5,   6,   7}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  6,   7}; //   2
  c_t[x_a][3] = {  8,   9,  10}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  6,   8}; //   2
  c_t[x_a][4] = { 11,  12,  13}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  4,   9}; //   2
  c_t[x_a][5] = { 11,  14,  15}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  2,  10}; //   2
  c_t[x_a][6] = {  5,  16,  17}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  0,  11}; //   2
  c_t[x_a][7] = {  8,  18,  19}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = { 12}; //   1
  c_t[x_a][8] = { 20,  21}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = { 13}; //   1
  c_t[x_a][9] = { 22,  23}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  1}; //   1
  c_f[x_a][10] = { 14}; //   1
  c_t[x_a][10] = { 24,  25}; //   2
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  1}; //   1
  c_f[x_a][11] = { 15}; //   1
  c_t[x_a][11] = { 26,  27}; //   2
  c_d[x_a][11] = {  1}; //   1

  c_p[x_a][12] = {  0,   2}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 22}; //   1
  c_d[x_a][12] = {  2,   0}; //   2

  c_p[x_a][13] = {  1,   3}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 24}; //   1
  c_d[x_a][13] = {  3,   1}; //   2

  c_p[x_a][14] = {  0,   4}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 20}; //   1
  c_d[x_a][14] = {  4,   0}; //   2

  c_p[x_a][15] = {  1,   5}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 26}; //   1
  c_d[x_a][15] = {  5,   1}; //   2

  c_p[x_a][16] = {  1,   5}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  6,   5,   1}; //   3

  c_p[x_a][17] = {  0,   2}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  7,   2,   0}; //   3

  c_p[x_a][18] = {  0,   4}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  8,   4,   0}; //   3

  c_p[x_a][19] = {  1,   3}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  9,   3,   1}; //   3

  c_p[x_a][20] = {  1,   6}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = { 10,   0,   1}; //   3

  c_p[x_a][21] = {  0}; //   1
  c_f[x_a][21] = { 12}; //   1
  c_t[x_a][21] = {  8,  28}; //   2
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = {  1}; //   1
  c_f[x_a][22] = { 15}; //   1
  c_t[x_a][22] = {  0,  29}; //   2
  c_d[x_a][22] = {  1}; //   1

  c_p[x_a][23] = {  0}; //   1
  c_f[x_a][23] = { 13}; //   1
  c_t[x_a][23] = {  5,  30}; //   2
  c_d[x_a][23] = {  0}; //   1

  c_p[x_a][24] = {  1}; //   1
  c_f[x_a][24] = { 14}; //   1
  c_t[x_a][24] = { 11,  31}; //   2
  c_d[x_a][24] = {  1}; //   1

  c_p[x_a][25] = {  1,   5}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  0}; //   1
  c_d[x_a][25] = {  5,   1}; //   2

  c_p[x_a][26] = {  0,   2}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  5}; //   1
  c_d[x_a][26] = {  2,   0}; //   2

  c_p[x_a][27] = {  0,   4}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  8}; //   1
  c_d[x_a][27] = {  4,   0}; //   2

  c_p[x_a][28] = {  1,   3}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 11}; //   1
  c_d[x_a][28] = {  3,   1}; //   2

  c_p[x_a][29] = {  1}; //   1
  c_f[x_a][29] = { 15}; //   1
  c_t[x_a][29] = {  0,  32}; //   2
  c_d[x_a][29] = {  1}; //   1

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = { 13}; //   1
  c_t[x_a][30] = {  5,  33}; //   2
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  0}; //   1
  c_f[x_a][31] = { 12}; //   1
  c_t[x_a][31] = {  8,  34}; //   2
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  1}; //   1
  c_f[x_a][32] = { 14}; //   1
  c_t[x_a][32] = { 11,  35}; //   2
  c_d[x_a][32] = {  1}; //   1

  c_p[x_a][33] = {  1,   6}; //   2
  c_f[x_a][33] = {}; //   0
  c_t[x_a][33] = { 36}; //   1
  c_d[x_a][33] = {  0,   1}; //   2

  c_p[x_a][34] = {  0,   7}; //   2
  c_f[x_a][34] = {}; //   0
  c_t[x_a][34] = { 37}; //   1
  c_d[x_a][34] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_400_gg_ttxddx
//  channel    0: 1111(1, 2, 4, 8, 16, 32;   6,   0,   0)
//  channel    1: 1111(1, 2, 4, 8, 32, 16;   6,   0,   0)
//  channel    2: 1111(1, 2, 16, 32, 4, 8;   0,   6,   0)
//  channel    3: 1111(1, 2, 32, 16, 4, 8;   0,   6,   0)
//  channel    4: 1111(1, 2, 8, 4, 16, 32;   6,   0,   0)
//  channel    5: 1111(1, 2, 8, 4, 32, 16;   6,   0,   0)
//  channel    6: 1111(1, 2, 16, 32, 8, 4;   0,   6,   0)
//  channel    7: 1111(1, 2, 32, 16, 8, 4;   0,   6,   0)
//  channel    8: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    9: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel   10: 2v11(1, 2, 16, 32, 4, 8;   0,   6,   0)
//  channel   11: 2v11(1, 2, 16, 32, 8, 4;   0,   6,   0)
//  channel   12: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   13: 3yv1(1, 2, 4, 16, 32, 8;   0,   6,   6)
//  channel   14: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   15: 3yv1(1, 2, 8, 16, 32, 4;   0,   6,   6)
//  channel   16: 4yyv(1, 2, 4, 8, 16, 32;   0,   6,   0)
//  channel   17: 4yyv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   18: 4yyv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   19: 4yyv(1, 2, 8, 4, 16, 32;   0,   6,   0)
//  channel   20: 42vv(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   21: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   22: 12v1(1, 2, 4, 16, 32, 8;   0,   6,   6)
//  channel   23: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   24: 12v1(1, 2, 8, 16, 32, 4;   0,   6,   6)
//  channel   25: 13yv(1, 2, 4, 8, 16, 32;   0,   6,   6)
//  channel   26: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   27: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   28: 13yv(1, 2, 8, 4, 16, 32;   0,   6,   6)
//  channel   29: 112v(1, 2, 4, 8, 16, 32;   0,   6,   0)
//  channel   30: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   31: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   32: 112v(1, 2, 8, 4, 16, 32;   0,   6,   0)
//  channel   33: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   34: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
