#include "header.hpp"

#include "ppttx20.phasespace.set.hpp"

void ppttx20_phasespace_set::ax_psp_400_ubx_ttxubx(int x_a){
  static Logger logger("ppttx20_phasespace_set::ax_psp_400_ubx_ttxubx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  needed_v_smin[x_a][  0] = {   2,    3,    4,    5,    6,    0,    1}; //   7
  needed_v_smin[x_a][  1] = {   3,    2}; //   2
  needed_v_smin[x_a][  2] = {   5,    0,    1,    4,    6}; //   5

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  needed_v_smax[x_a][  0] = {   2,    3,    4,    5,    6,    0,    1}; //   7
  needed_v_smax[x_a][  1] = {   3,    2}; //   2
  needed_v_smax[x_a][  2] = {   5,    0,    1,    4,    6}; //   5

  g_p[x_a].resize(3);
  needed_g_p[x_a].resize(3);
  needed_g_p[x_a][0] = {   2,    3,    4,    5,    6}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   3}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   5}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin2_smax2");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][1] = {   0,    1,    4,    6}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][2] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(7);
  needed_g_t[x_a].resize(7);
  needed_g_t[x_a][0] = {   0,    1,    4,    5,    6}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][1] = {   0,    1,    4}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__4_8");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__8_4");
  needed_g_t[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][6] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_17__12_32");

  g_d[x_a].resize(3);
  needed_g_d[x_a].resize(3);
  needed_g_d[x_a][0] = {   2,    3,    4,    5,    6}; //   5
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   3}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][2] = {   5}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");

  c_p[x_a].resize(7);
  c_f[x_a].resize(7);
  c_t[x_a].resize(7);
  c_d[x_a].resize(7);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   1}; //   2
  c_t[x_a][1] = {  0,   1,   3}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  2}; //   1
  c_t[x_a][2] = {  4,   5}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  0,   1}; //   2
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  4}; //   1
  c_d[x_a][3] = {  1,   0}; //   2

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  1}; //   1
  c_t[x_a][4] = {  0,   1}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0,   2}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  0}; //   1
  c_d[x_a][5] = {  2,   0}; //   2

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  1}; //   1
  c_t[x_a][6] = {  0,   6}; //   2
  c_d[x_a][6] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_400_ubx_ttxubx
//  channel    0: 1111(1, 2, 16, 4, 8, 32;   0,   0,   6)
//  channel    1: 1111(1, 2, 16, 8, 4, 32;   0,   0,   6)
//  channel    2: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    3: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    4: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    5: 13yv(1, 2, 16, 32, 4, 8;   0,   5,   0)
//  channel    6: 112v(1, 2, 16, 32, 4, 8;   0,   0,   5)
