#include "header.hpp"

#include "ppttx20.phasespace.set.hpp"

void ppttx20_phasespace_set::ax_psp_400_uu_ttxuu(int x_a){
  static Logger logger("ppttx20_phasespace_set::ax_psp_400_uu_ttxuu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  needed_v_smin[x_a][  0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,    0,    1,    2,    3}; //  14
  needed_v_smin[x_a][  1] = {   6,   10,    1,    3,    5,    9,   12}; //   7
  needed_v_smin[x_a][  2] = {   7,   11,    0,    2,    4,    8,   13}; //   7

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  needed_v_smax[x_a][  0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13,    0,    1,    2,    3}; //  14
  needed_v_smax[x_a][  1] = {   6,   10,    1,    3,    5,    9,   12}; //   7
  needed_v_smax[x_a][  2] = {   7,   11,    0,    2,    4,    8,   13}; //   7

  g_p[x_a].resize(3);
  needed_g_p[x_a].resize(3);
  needed_g_p[x_a][0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13}; //  10
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   6,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][2] = {   7,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {   0,    1,    2,    3}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][1] = {   0,    2,    4,    8,   13}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][2] = {   1,    3,    5,    9,   12}; //   5
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(14);
  needed_g_t[x_a].resize(14);
  needed_g_t[x_a][0] = {   0,    2,    8,   11,   13}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][1] = {   0,    2,    8}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__33_18__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__33_18__4_8");
  needed_g_t[x_a][3] = {   1,    3,    9,   10,   12}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][4] = {   1,    3,    9}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__4_8");
  needed_g_t[x_a][6] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__33_18__8_4");
  needed_g_t[x_a][7] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__17_34__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__17_34__8_4");
  needed_g_t[x_a][8] = {   4,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][10] = {   5,    6}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][12] = {  12}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][13] = {  13}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");

  g_d[x_a].resize(3);
  needed_g_d[x_a].resize(3);
  needed_g_d[x_a][0] = {   4,    5,    6,    7,    8,    9,   10,   11,   12,   13}; //  10
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   6,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {   7,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");

  c_p[x_a].resize(14);
  c_f[x_a].resize(14);
  c_t[x_a].resize(14);
  c_d[x_a].resize(14);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0,   2}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  0,   1}; //   2
  c_t[x_a][2] = {  0,   1,   6}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0,   2}; //   2
  c_t[x_a][3] = {  3,   4,   7}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  1}; //   1
  c_t[x_a][4] = {  8,   9}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  2}; //   1
  c_t[x_a][5] = { 10,  11}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0,   1}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = { 10}; //   1
  c_d[x_a][6] = {  1,   0}; //   2

  c_p[x_a][7] = {  0,   2}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  8}; //   1
  c_d[x_a][7] = {  2,   0}; //   2

  c_p[x_a][8] = {  0}; //   1
  c_f[x_a][8] = {  1}; //   1
  c_t[x_a][8] = {  0,   1}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  0}; //   1
  c_f[x_a][9] = {  2}; //   1
  c_t[x_a][9] = {  3,   4}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  0,   1}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  3}; //   1
  c_d[x_a][10] = {  1,   0}; //   2

  c_p[x_a][11] = {  0,   2}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  2,   0}; //   2

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  2}; //   1
  c_t[x_a][12] = {  3,  12}; //   2
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {  1}; //   1
  c_t[x_a][13] = {  0,  13}; //   2
  c_d[x_a][13] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_400_uu_ttxuu
//  channel    0: 1111(1, 2, 32, 4, 8, 16;   0,   0,   6)
//  channel    1: 1111(1, 2, 16, 4, 8, 32;   0,   0,   6)
//  channel    2: 1111(1, 2, 32, 8, 4, 16;   0,   0,   6)
//  channel    3: 1111(1, 2, 16, 8, 4, 32;   0,   0,   6)
//  channel    4: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    5: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel    6: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    7: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    8: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    9: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   10: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   11: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   12: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   13: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
