#include "header.hpp"

#include "ppttx20.phasespace.set.hpp"

void ppttx20_phasespace_set::ax_psp_300_gg_ttxg(int x_a){
  static Logger logger("ppttx20_phasespace_set::ax_psp_300_gg_ttxg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  needed_v_smin[x_a][  0] = {   6,   10,   13,    2,    5}; //   5
  needed_v_smin[x_a][  1] = {   7,   11,   14,    3,    4}; //   5
  needed_v_smin[x_a][  2] = {   8,    9,   12,    0,    1}; //   5

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  needed_v_smax[x_a][  0] = {   6,   10,   13,    2,    5}; //   5
  needed_v_smax[x_a][  1] = {   7,   11,   14,    3,    4}; //   5
  needed_v_smax[x_a][  2] = {   8,    9,   12,    0,    1}; //   5

  g_p[x_a].resize(3);
  needed_g_p[x_a].resize(3);
  needed_g_p[x_a][0] = {   6,   10,   13}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   7,   11,   14}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin1_smax1");
  needed_g_p[x_a][2] = {   8,    9,   12}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin2_smax2");

  g_f[x_a].resize(3);
  needed_g_f[x_a].resize(3);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   2,    5}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][2] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(12);
  needed_g_t[x_a].resize(12);
  needed_g_t[x_a][0] = {   0,    1,   12}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__4_24");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_8");
  needed_g_t[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_5__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_5__8_16");
  needed_g_t[x_a][3] = {   2,    5,   13}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_12");
  needed_g_t[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__8_4");
  needed_g_t[x_a][5] = {   3,    4,   14}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__8_20");
  needed_g_t[x_a][6] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_4");
  needed_g_t[x_a][7] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_9__4_16");
  needed_g_t[x_a][8] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__4_8");
  needed_g_t[x_a][9] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_12");
  needed_g_t[x_a][10] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__8_20");
  needed_g_t[x_a][11] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__4_24");

  g_d[x_a].resize(6);
  needed_g_d[x_a].resize(6);
  needed_g_d[x_a][0] = {   6,   10,   13}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   7,   11,   14}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][2] = {   8,    9,   12}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {   9}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][4] = {  10}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][5] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");

  c_p[x_a].resize(15);
  c_f[x_a].resize(15);
  c_t[x_a].resize(15);
  c_d[x_a].resize(15);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   2}; //   2
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  3,   4}; //   2
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  2}; //   1
  c_t[x_a][3] = {  5,   6}; //   2
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  2}; //   1
  c_t[x_a][4] = {  5,   7}; //   2
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  1}; //   1
  c_t[x_a][5] = {  3,   8}; //   2
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  9}; //   1
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  1}; //   1
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = { 10}; //   1
  c_d[x_a][7] = {  1}; //   1

  c_p[x_a][8] = {  2}; //   1
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = { 11}; //   1
  c_d[x_a][8] = {  2}; //   1

  c_p[x_a][9] = {  2}; //   1
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  3,   2}; //   2

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  4,   0}; //   2

  c_p[x_a][11] = {  1}; //   1
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  5,   1}; //   2

  c_p[x_a][12] = {  2}; //   1
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  2}; //   1

  c_p[x_a][13] = {  0}; //   1
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  3}; //   1
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  1}; //   1
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {  5}; //   1
  c_d[x_a][14] = {  1}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_300_gg_ttxg
//  channel    0: 111(1, 2, 4, 8, 16;   6,   0)
//  channel    1: 111(1, 2, 4, 16, 8;   6,   6)
//  channel    2: 111(1, 2, 16, 4, 8;   0,   6)
//  channel    3: 111(1, 2, 8, 4, 16;   6,   0)
//  channel    4: 111(1, 2, 8, 16, 4;   6,   6)
//  channel    5: 111(1, 2, 16, 8, 4;   0,   6)
//  channel    6: 2v1(1, 2, 4, 8, 16;   0,   0)
//  channel    7: 2v1(1, 2, 4, 16, 8;   6,   6)
//  channel    8: 2v1(1, 2, 8, 16, 4;   6,   6)
//  channel    9: 3yv(1, 2, 4, 8, 16;   6,   0)
//  channel   10: 3yv(1, 2, 16, 4, 8;   0,   0)
//  channel   11: 3yv(1, 2, 8, 4, 16;   6,   0)
//  channel   12: 12v(1, 2, 4, 8, 16;   6,   6)
//  channel   13: 12v(1, 2, 16, 4, 8;   0,   0)
//  channel   14: 12v(1, 2, 8, 4, 16;   6,   6)
