#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_gg_wpwm(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_gg_wpwm");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(0);
  needed_v_smin[x_a].resize(0);

  v_smax[x_a].resize(0);
  needed_v_smax[x_a].resize(0);

  g_p[x_a].resize(0);
  needed_g_p[x_a].resize(0);

  g_f[x_a].resize(0);
  needed_g_f[x_a].resize(0);

  g_t[x_a].resize(6);
  needed_g_t[x_a].resize(6);
  needed_g_t[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_8");
  needed_g_t[x_a][1] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__4_8");
  needed_g_t[x_a][2] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__4_8");
  needed_g_t[x_a][3] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_4");
  needed_g_t[x_a][4] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_36__1_2__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_36__1_2__8_4");
  needed_g_t[x_a][5] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_35__1_2__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_35__1_2__8_4");

  g_d[x_a].resize(1);
  needed_g_d[x_a].resize(1);
  needed_g_d[x_a][0] = {   6,    7,    8,    9,   10,   11}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");

  c_p[x_a].resize(12);
  c_f[x_a].resize(12);
  c_t[x_a].resize(12);
  c_d[x_a].resize(12);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {}; //   0
  c_t[x_a][0] = {  0}; //   1
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {}; //   0
  c_t[x_a][1] = {  1}; //   1
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {}; //   0
  c_t[x_a][2] = {  2}; //   1
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  3}; //   1
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  4}; //   1
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  5}; //   1
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {}; //   0
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {}; //   0
  c_d[x_a][11] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_020_gg_wpwm
//  channel    0: 11(1, 2, 4, 8;   0)
//  channel    1: 11(1, 2, 4, 8;  35)
//  channel    2: 11(1, 2, 4, 8;  36)
//  channel    3: 11(1, 2, 8, 4;   0)
//  channel    4: 11(1, 2, 8, 4;  36)
//  channel    5: 11(1, 2, 8, 4;  35)
//  channel    6: 2v(1, 2, 4, 8;   0)
//  channel    7: 2v(1, 2, 4, 8;  23)
//  channel    8: 2v(1, 2, 4, 8;  25)
//  channel    9: 2v(1, 2, 4, 8;   0)
//  channel   10: 2v(1, 2, 4, 8;  35)
//  channel   11: 2v(1, 2, 4, 8;  36)
