#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_bxbx_wpwmbxbx(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_bxbx_wpwmbxbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(9);
  needed_v_smin[x_a].resize(9);
  needed_v_smin[x_a][  0] = {   4,    5,    6,    7,    8,    9,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35}; //  24
  needed_v_smin[x_a][  1] = {  10,   18,   20,   22,    0,    3}; //   6
  needed_v_smin[x_a][  2] = {  10,   22,    3,   20}; //   4
  needed_v_smin[x_a][  3] = {  11,   19,   21,   23,    1,    2}; //   6
  needed_v_smin[x_a][  4] = {  11,   23,    2,   21}; //   4
  needed_v_smin[x_a][  5] = {  12,   13,   14,   24,   25,   26,    7,    8,    9,   30,   31,   32}; //  12
  needed_v_smin[x_a][  6] = {  15,   16,   17,   27,   28,   29,    4,    5,    6,   33,   34,   35}; //  12
  needed_v_smin[x_a][  7] = {   0,   18}; //   2
  needed_v_smin[x_a][  8] = {   1,   19}; //   2

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  needed_v_smax[x_a][  0] = {   4,    5,    6,    7,    8,    9,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35}; //  24
  needed_v_smax[x_a][  1] = {  10,   18,   20,   22,    0,    3}; //   6
  needed_v_smax[x_a][  2] = {  10,   15,   16,   17,   22,   27,   28,   29,    3,    4,    5,    6,   20,   33,   34,   35}; //  16
  needed_v_smax[x_a][  3] = {  11,   19,   21,   23,    1,    2}; //   6
  needed_v_smax[x_a][  4] = {  11,   12,   13,   14,   23,   24,   25,   26,    2,    7,    8,    9,   21,   30,   31,   32}; //  16
  needed_v_smax[x_a][  5] = {   0,    1,   18,   19}; //   4

  g_p[x_a].resize(9);
  needed_g_p[x_a].resize(9);
  needed_g_p[x_a][0] = {   4,    7,   12,   15,   24,   27,   30,   33}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   5,    8,   13,   16,   25,   28,   31,   34}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   6,    9,   14,   17,   26,   29,   32,   35}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin0_smax0");
  needed_g_p[x_a][3] = {  10,   18,   20,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin1_smax1");
  needed_g_p[x_a][4] = {  10,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin2_smax2");
  needed_g_p[x_a][5] = {  11,   19,   21,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin3_smax3");
  needed_g_p[x_a][6] = {  11,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin4_smax4");
  needed_g_p[x_a][7] = {  12,   13,   14,   24,   25,   26}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin5_smax4");
  needed_g_p[x_a][8] = {  15,   16,   17,   27,   28,   29}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin6_smax2");

  g_f[x_a].resize(8);
  needed_g_f[x_a].resize(8);
  needed_g_f[x_a][0] = {   0,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][1] = {   0,   18}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][2] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][3] = {   1,   19}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax5");
  needed_g_f[x_a][4] = {   2,   21}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax4");
  needed_g_f[x_a][5] = {   3,   20}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][6] = {   4,    5,    6,   33,   34,   35}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax2");
  needed_g_f[x_a][7] = {   7,    8,    9,   30,   31,   32}; //   6
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");

  g_t[x_a].resize(17);
  needed_g_t[x_a].resize(17);
  needed_g_t[x_a][0] = {   0,    1,   18,   19}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_2__4_56");
  needed_g_t[x_a][1] = {   0,   18}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__5_34__8_16");
  needed_g_t[x_a][3] = {   1,   19}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_40");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__5_18__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__5_18__8_32");
  needed_g_t[x_a][5] = {   2,   21,   23,   24,   25,   26,   30,   31,   32}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][6] = {   2,   21}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__4_40");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__17_6__32_8");
  needed_g_t[x_a][8] = {   3,   20,   22,   27,   28,   29,   33,   34,   35}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][9] = {   3,   20}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_33__4_24");
  needed_g_t[x_a][10] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__33_6__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__33_6__16_8");
  needed_g_t[x_a][11] = {   4,    5,    6,   10,   15,   16,   17}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][12] = {   4,    5,    6}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_34__12_16");
  needed_g_t[x_a][13] = {   7,    8,    9,   11,   12,   13,   14}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][14] = {   7,    8,    9}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_18__12_32");
  needed_g_t[x_a][15] = {  30,   31,   32}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_17__12_32");
  needed_g_t[x_a][16] = {  33,   34,   35}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_33__12_16");

  g_d[x_a].resize(7);
  needed_g_d[x_a].resize(7);
  needed_g_d[x_a][0] = {   4,    5,    6,    7,    8,    9,   12,   13,   14,   15,   16,   17,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  10,   22}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][2] = {  10,   18,   20,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][3] = {  11,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][4] = {  11,   19,   21,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][5] = {  12,   13,   14,   24,   25,   26}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {  15,   16,   17,   27,   28,   29}; //   6
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");

  c_p[x_a].resize(36);
  c_f[x_a].resize(36);
  c_t[x_a].resize(36);
  c_d[x_a].resize(36);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   4}; //   2
  c_t[x_a][2] = {  5,   6,   7}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0,   5}; //   2
  c_t[x_a][3] = {  8,   9,  10}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  6}; //   1
  c_t[x_a][4] = { 11,  12}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {  6}; //   1
  c_t[x_a][5] = { 11,  12}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  2}; //   1
  c_f[x_a][6] = {  6}; //   1
  c_t[x_a][6] = { 11,  12}; //   2
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  0}; //   1
  c_f[x_a][7] = {  7}; //   1
  c_t[x_a][7] = { 13,  14}; //   2
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  1}; //   1
  c_f[x_a][8] = {  7}; //   1
  c_t[x_a][8] = { 13,  14}; //   2
  c_d[x_a][8] = {  0}; //   1

  c_p[x_a][9] = {  2}; //   1
  c_f[x_a][9] = {  7}; //   1
  c_t[x_a][9] = { 13,  14}; //   2
  c_d[x_a][9] = {  0}; //   1

  c_p[x_a][10] = {  3,   4}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = { 11}; //   1
  c_d[x_a][10] = {  1,   2}; //   2

  c_p[x_a][11] = {  5,   6}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = { 13}; //   1
  c_d[x_a][11] = {  3,   4}; //   2

  c_p[x_a][12] = {  0,   7}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 13}; //   1
  c_d[x_a][12] = {  5,   0}; //   2

  c_p[x_a][13] = {  1,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 13}; //   1
  c_d[x_a][13] = {  5,   0}; //   2

  c_p[x_a][14] = {  2,   7}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = { 13}; //   1
  c_d[x_a][14] = {  5,   0}; //   2

  c_p[x_a][15] = {  0,   8}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = { 11}; //   1
  c_d[x_a][15] = {  6,   0}; //   2

  c_p[x_a][16] = {  1,   8}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = { 11}; //   1
  c_d[x_a][16] = {  6,   0}; //   2

  c_p[x_a][17] = {  2,   8}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 11}; //   1
  c_d[x_a][17] = {  6,   0}; //   2

  c_p[x_a][18] = {  3}; //   1
  c_f[x_a][18] = {  1}; //   1
  c_t[x_a][18] = {  0,   1}; //   2
  c_d[x_a][18] = {  2}; //   1

  c_p[x_a][19] = {  5}; //   1
  c_f[x_a][19] = {  3}; //   1
  c_t[x_a][19] = {  0,   3}; //   2
  c_d[x_a][19] = {  4}; //   1

  c_p[x_a][20] = {  3}; //   1
  c_f[x_a][20] = {  5}; //   1
  c_t[x_a][20] = {  8,   9}; //   2
  c_d[x_a][20] = {  2}; //   1

  c_p[x_a][21] = {  5}; //   1
  c_f[x_a][21] = {  4}; //   1
  c_t[x_a][21] = {  5,   6}; //   2
  c_d[x_a][21] = {  4}; //   1

  c_p[x_a][22] = {  3,   4}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  8}; //   1
  c_d[x_a][22] = {  1,   2}; //   2

  c_p[x_a][23] = {  5,   6}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  5}; //   1
  c_d[x_a][23] = {  3,   4}; //   2

  c_p[x_a][24] = {  0,   7}; //   2
  c_f[x_a][24] = {}; //   0
  c_t[x_a][24] = {  5}; //   1
  c_d[x_a][24] = {  5,   0}; //   2

  c_p[x_a][25] = {  1,   7}; //   2
  c_f[x_a][25] = {}; //   0
  c_t[x_a][25] = {  5}; //   1
  c_d[x_a][25] = {  5,   0}; //   2

  c_p[x_a][26] = {  2,   7}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  5}; //   1
  c_d[x_a][26] = {  5,   0}; //   2

  c_p[x_a][27] = {  0,   8}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  8}; //   1
  c_d[x_a][27] = {  6,   0}; //   2

  c_p[x_a][28] = {  1,   8}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  8}; //   1
  c_d[x_a][28] = {  6,   0}; //   2

  c_p[x_a][29] = {  2,   8}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  8}; //   1
  c_d[x_a][29] = {  6,   0}; //   2

  c_p[x_a][30] = {  0}; //   1
  c_f[x_a][30] = {  7}; //   1
  c_t[x_a][30] = {  5,  15}; //   2
  c_d[x_a][30] = {  0}; //   1

  c_p[x_a][31] = {  1}; //   1
  c_f[x_a][31] = {  7}; //   1
  c_t[x_a][31] = {  5,  15}; //   2
  c_d[x_a][31] = {  0}; //   1

  c_p[x_a][32] = {  2}; //   1
  c_f[x_a][32] = {  7}; //   1
  c_t[x_a][32] = {  5,  15}; //   2
  c_d[x_a][32] = {  0}; //   1

  c_p[x_a][33] = {  0}; //   1
  c_f[x_a][33] = {  6}; //   1
  c_t[x_a][33] = {  8,  16}; //   2
  c_d[x_a][33] = {  0}; //   1

  c_p[x_a][34] = {  1}; //   1
  c_f[x_a][34] = {  6}; //   1
  c_t[x_a][34] = {  8,  16}; //   2
  c_d[x_a][34] = {  0}; //   1

  c_p[x_a][35] = {  2}; //   1
  c_f[x_a][35] = {  6}; //   1
  c_t[x_a][35] = {  8,  16}; //   2
  c_d[x_a][35] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_bxbx_wpwmbxbx
//  channel    0: 1111(1, 2, 4, 8, 16, 32;   6,   0,   5)
//  channel    1: 1111(1, 2, 4, 8, 32, 16;   6,   0,   5)
//  channel    2: 1111(1, 2, 16, 32, 8, 4;   0,   6,   5)
//  channel    3: 1111(1, 2, 32, 16, 8, 4;   0,   6,   5)
//  channel    4: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   5)
//  channel    5: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   5)
//  channel    6: 2v11(1, 2, 4, 8, 16, 32;  25,   0,   5)
//  channel    7: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   5)
//  channel    8: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   5)
//  channel    9: 2v11(1, 2, 4, 8, 32, 16;  25,   0,   5)
//  channel   10: 3yv1(1, 2, 4, 8, 16, 32;   6,   5,   0)
//  channel   11: 3yv1(1, 2, 4, 8, 32, 16;   6,   5,   0)
//  channel   12: 3yv1(1, 2, 32, 4, 8, 16;   0,   5,   0)
//  channel   13: 3yv1(1, 2, 32, 4, 8, 16;  23,   5,   0)
//  channel   14: 3yv1(1, 2, 32, 4, 8, 16;  25,   5,   0)
//  channel   15: 3yv1(1, 2, 16, 4, 8, 32;   0,   5,   0)
//  channel   16: 3yv1(1, 2, 16, 4, 8, 32;  23,   5,   0)
//  channel   17: 3yv1(1, 2, 16, 4, 8, 32;  25,   5,   0)
//  channel   18: 12v1(1, 2, 4, 8, 16, 32;   6,   6,   0)
//  channel   19: 12v1(1, 2, 4, 8, 32, 16;   6,   6,   0)
//  channel   20: 12v1(1, 2, 32, 8, 16, 4;   6,   0,   6)
//  channel   21: 12v1(1, 2, 16, 8, 32, 4;   6,   0,   6)
//  channel   22: 13yv(1, 2, 32, 4, 8, 16;   6,   5,   0)
//  channel   23: 13yv(1, 2, 16, 4, 8, 32;   6,   5,   0)
//  channel   24: 13yv(1, 2, 16, 32, 4, 8;   0,   5,   0)
//  channel   25: 13yv(1, 2, 16, 32, 4, 8;  23,   5,   0)
//  channel   26: 13yv(1, 2, 16, 32, 4, 8;  25,   5,   0)
//  channel   27: 13yv(1, 2, 32, 16, 4, 8;   0,   5,   0)
//  channel   28: 13yv(1, 2, 32, 16, 4, 8;  23,   5,   0)
//  channel   29: 13yv(1, 2, 32, 16, 4, 8;  25,   5,   0)
//  channel   30: 112v(1, 2, 16, 32, 4, 8;   0,   0,   5)
//  channel   31: 112v(1, 2, 16, 32, 4, 8;  23,   0,   5)
//  channel   32: 112v(1, 2, 16, 32, 4, 8;  25,   0,   5)
//  channel   33: 112v(1, 2, 32, 16, 4, 8;   0,   0,   5)
//  channel   34: 112v(1, 2, 32, 16, 4, 8;  23,   0,   5)
//  channel   35: 112v(1, 2, 32, 16, 4, 8;  25,   0,   5)
