#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_ds_wpwmds(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_ds_wpwmds");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(8);
  needed_v_smin[x_a].resize(8);
  needed_v_smin[x_a][  0] = {   2,    3,    4,    5,    9,   10,   12,   13}; //   8
  needed_v_smin[x_a][  1] = {   4,    5,    2,    3}; //   4
  needed_v_smin[x_a][  2] = {   6,    8,    1}; //   3
  needed_v_smin[x_a][  3] = {   6}; //   1
  needed_v_smin[x_a][  4] = {   7,   11,    0}; //   3
  needed_v_smin[x_a][  5] = {   9,   10,   12,   13}; //   4
  needed_v_smin[x_a][  6] = {  11,    0,    7}; //   3
  needed_v_smin[x_a][  7] = {   1,    8}; //   2

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  needed_v_smax[x_a][  0] = {   2,    3,    4,    5,    9,   10,   12,   13}; //   8
  needed_v_smax[x_a][  1] = {   4,    5,    6,    2,    3}; //   5
  needed_v_smax[x_a][  2] = {   6,    8,    1}; //   3
  needed_v_smax[x_a][  3] = {   7,   11,    0}; //   3
  needed_v_smax[x_a][  4] = {   9,   10,   11,    0,    7,   12,   13}; //   7
  needed_v_smax[x_a][  5] = {   1,    8}; //   2

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {   2,    4,    9,   12}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   3,    5,   10,   13}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   4,    5}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {   6,    8}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   6}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax1");
  needed_g_p[x_a][5] = {   7,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax3");
  needed_g_p[x_a][6] = {   9,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");

  g_f[x_a].resize(6);
  needed_g_f[x_a].resize(6);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax3");
  needed_g_f[x_a][1] = {   0,    7}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][3] = {   1,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][4] = {   2,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][5] = {  12,   13}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");

  g_t[x_a].resize(9);
  needed_g_t[x_a].resize(9);
  needed_g_t[x_a][0] = {   0,    7,    9,   10,   11,   12,   13}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][1] = {   0,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][3] = {   1,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][4] = {   1,    8}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][6] = {   2,    3,    4,    5,    6}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][7] = {   2,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][8] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");

  g_d[x_a].resize(7);
  needed_g_d[x_a].resize(7);
  needed_g_d[x_a][0] = {   2,    3,    4,    5,    9,   10,   12,   13}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   4,    5}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][2] = {   6}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][3] = {   6,    8}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][4] = {   7,   11}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");
  needed_g_d[x_a][5] = {   9,   10}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][6] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");

  c_p[x_a].resize(14);
  c_f[x_a].resize(14);
  c_t[x_a].resize(14);
  c_d[x_a].resize(14);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {  0}; //   1
  c_f[x_a][2] = {  4}; //   1
  c_t[x_a][2] = {  6,   7}; //   2
  c_d[x_a][2] = {  0}; //   1

  c_p[x_a][3] = {  1}; //   1
  c_f[x_a][3] = {  4}; //   1
  c_t[x_a][3] = {  6,   7}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  0,   2}; //   2
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  6}; //   1
  c_d[x_a][4] = {  1,   0}; //   2

  c_p[x_a][5] = {  1,   2}; //   2
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  6}; //   1
  c_d[x_a][5] = {  1,   0}; //   2

  c_p[x_a][6] = {  3,   4}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  6}; //   1
  c_d[x_a][6] = {  2,   3}; //   2

  c_p[x_a][7] = {  5}; //   1
  c_f[x_a][7] = {  1}; //   1
  c_t[x_a][7] = {  0,   1}; //   2
  c_d[x_a][7] = {  4}; //   1

  c_p[x_a][8] = {  3}; //   1
  c_f[x_a][8] = {  3}; //   1
  c_t[x_a][8] = {  3,   4}; //   2
  c_d[x_a][8] = {  3}; //   1

  c_p[x_a][9] = {  0,   6}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  0}; //   1
  c_d[x_a][9] = {  5,   0}; //   2

  c_p[x_a][10] = {  1,   6}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  0}; //   1
  c_d[x_a][10] = {  5,   0}; //   2

  c_p[x_a][11] = {  5,   7}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  0}; //   1
  c_d[x_a][11] = {  6,   4}; //   2

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  5}; //   1
  c_t[x_a][12] = {  0,   8}; //   2
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  1}; //   1
  c_f[x_a][13] = {  5}; //   1
  c_t[x_a][13] = {  0,   8}; //   2
  c_d[x_a][13] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_ds_wpwmds
//  channel    0: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    1: 1111(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel    2: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    3: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    4: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    5: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel    6: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel    7: 12v1(1, 2, 16, 4, 32, 8;   0,   0,   0)
//  channel    8: 12v1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel    9: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   10: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   11: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   12: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   13: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
