#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_du_wpwmdu(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_du_wpwmdu");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(11);
  needed_v_smin[x_a].resize(11);
  needed_v_smin[x_a][  0] = {   3,    4,    6,    7,   12,   13,   14,   15}; //   8
  needed_v_smin[x_a][  1] = {   5,   10,   11,   17,    2}; //   5
  needed_v_smin[x_a][  2] = {   6,    7,    3,    4}; //   4
  needed_v_smin[x_a][  3] = {   8,    9,   16,   17,    0}; //   5
  needed_v_smin[x_a][  4] = {   8}; //   1
  needed_v_smin[x_a][  5] = {  11,    2,   10}; //   3
  needed_v_smin[x_a][  6] = {  12,   13,   14,   15}; //   4
  needed_v_smin[x_a][  7] = {   0,    9,   16}; //   3
  needed_v_smin[x_a][  8] = {   1}; //   1
  needed_v_smin[x_a][  9] = {   1}; //   1
  needed_v_smin[x_a][ 10] = {   5}; //   1

  v_smax[x_a].resize(9);
  needed_v_smax[x_a].resize(9);
  needed_v_smax[x_a][  0] = {   3,    4,    6,    7,   12,   13,   14,   15}; //   8
  needed_v_smax[x_a][  1] = {   5,   10,   11,    2}; //   4
  needed_v_smax[x_a][  2] = {   6,    7,    8,    3,    4}; //   5
  needed_v_smax[x_a][  3] = {   8,    9,   16,   17,    0}; //   5
  needed_v_smax[x_a][  4] = {  11,   12,   13,    2,   10,   14,   15}; //   7
  needed_v_smax[x_a][  5] = {  17}; //   1
  needed_v_smax[x_a][  6] = {   0,    1,    9,   16}; //   4
  needed_v_smax[x_a][  7] = {   1}; //   1
  needed_v_smax[x_a][  8] = {   5}; //   1

  g_p[x_a].resize(9);
  needed_g_p[x_a].resize(9);
  needed_g_p[x_a][0] = {   3,    6,   12,   14}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   4,    7,   13,   15}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   5,   10,   11}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {   6,    7}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {   8,    9,   16,   17}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {   8}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][6] = {  11}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {  12,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax4");
  needed_g_p[x_a][8] = {  17}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax5");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {   0,    9,   16}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax6");
  needed_g_f[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax7");
  needed_g_f[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax6");
  needed_g_f[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][5] = {   2,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][6] = {   3,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][7] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax8");
  needed_g_f[x_a][8] = {  14,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");

  g_t[x_a].resize(15);
  needed_g_t[x_a].resize(15);
  needed_g_t[x_a][0] = {   0,    1,    9,   16}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][1] = {   0,    9}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][3] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_48");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_6__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_6__32_16");
  needed_g_t[x_a][5] = {   2,   10,   11,   12,   13,   14,   15}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][6] = {   2,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_40");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_6__32_8");
  needed_g_t[x_a][8] = {   3,    4,    6,    7,    8}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][9] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][10] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_56");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_6__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_6__40_16");
  needed_g_t[x_a][12] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][13] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__20_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__20_32");
  needed_g_t[x_a][14] = {  17}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__40_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__40_20");

  g_d[x_a].resize(7);
  needed_g_d[x_a].resize(7);
  needed_g_d[x_a][0] = {   3,    4,    6,    7,   12,   13,   14,   15}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   5,   10,   11,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][2] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {   8}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {   8,    9,   16,   17}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][5] = {  11}; //   1
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][6] = {  12,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");

  c_p[x_a].resize(18);
  c_f[x_a].resize(18);
  c_t[x_a].resize(18);
  c_d[x_a].resize(18);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  4,   5}; //   2
  c_t[x_a][2] = {  5,   6,   7}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {  6}; //   1
  c_t[x_a][3] = {  8,   9}; //   2
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  1}; //   1
  c_f[x_a][4] = {  6}; //   1
  c_t[x_a][4] = {  8,   9}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  2}; //   1
  c_f[x_a][5] = {  7}; //   1
  c_t[x_a][5] = { 10,  11}; //   2
  c_d[x_a][5] = {  1}; //   1

  c_p[x_a][6] = {  0,   3}; //   2
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {  8}; //   1
  c_d[x_a][6] = {  2,   0}; //   2

  c_p[x_a][7] = {  1,   3}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  8}; //   1
  c_d[x_a][7] = {  2,   0}; //   2

  c_p[x_a][8] = {  4,   5}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  8}; //   1
  c_d[x_a][8] = {  3,   4}; //   2

  c_p[x_a][9] = {  4}; //   1
  c_f[x_a][9] = {  1}; //   1
  c_t[x_a][9] = {  0,   1}; //   2
  c_d[x_a][9] = {  4}; //   1

  c_p[x_a][10] = {  2}; //   1
  c_f[x_a][10] = {  5}; //   1
  c_t[x_a][10] = {  5,   6}; //   2
  c_d[x_a][10] = {  1}; //   1

  c_p[x_a][11] = {  2,   6}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  5}; //   1
  c_d[x_a][11] = {  5,   1}; //   2

  c_p[x_a][12] = {  0,   7}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  5}; //   1
  c_d[x_a][12] = {  6,   0}; //   2

  c_p[x_a][13] = {  1,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {  5}; //   1
  c_d[x_a][13] = {  6,   0}; //   2

  c_p[x_a][14] = {  0}; //   1
  c_f[x_a][14] = {  8}; //   1
  c_t[x_a][14] = {  5,  12}; //   2
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  1}; //   1
  c_f[x_a][15] = {  8}; //   1
  c_t[x_a][15] = {  5,  12}; //   2
  c_d[x_a][15] = {  0}; //   1

  c_p[x_a][16] = {  4}; //   1
  c_f[x_a][16] = {  1}; //   1
  c_t[x_a][16] = {  0,  13}; //   2
  c_d[x_a][16] = {  4}; //   1

  c_p[x_a][17] = {  4,   8}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = { 14}; //   1
  c_d[x_a][17] = {  1,   4}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_du_wpwmdu
//  channel    0: 1111(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel    1: 1111(1, 2, 8, 32, 16, 4;   0,   0,   0)
//  channel    2: 1111(1, 2, 16, 32, 8, 4;   0,   0,   0)
//  channel    3: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    4: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    5: 2v11(1, 2, 8, 32, 16, 4;   0,   0,   0)
//  channel    6: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    7: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel    8: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel    9: 12v1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   10: 12v1(1, 2, 16, 8, 32, 4;   0,   0,   0)
//  channel   11: 13yv(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   12: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   13: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   14: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   15: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   16: 112v(1, 2, 8, 32, 4, 16;   0,   0,   0)
//  channel   17: 2v2v(1, 2, 8, 32, 4, 16;   0,   0,   0)
