#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_gbx_wpwmgbx(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_gbx_wpwmgbx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(10);
  needed_v_smin[x_a].resize(10);
  needed_v_smin[x_a][  0] = {   4,    5,    7,   12,   14,   15,   25,   26,    2}; //   9
  needed_v_smin[x_a][  1] = {   6,   11,   13,   19,   20,   21,   36,   37,   38}; //   9
  needed_v_smin[x_a][  2] = {   7,   15,   26,    2,    4,   25}; //   6
  needed_v_smin[x_a][  3] = {   8,    9,   10,   16,   17,   18,   19,   20,   21,   22,   23,   24,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,    0}; //  25
  needed_v_smin[x_a][  4] = {   8,    9,   10,   16,   17,   18,   27,   28,   29,   30,   31,   32}; //  12
  needed_v_smin[x_a][  5] = {  11,   13,    6}; //   3
  needed_v_smin[x_a][  6] = {  12,   14,    5}; //   3
  needed_v_smin[x_a][  7] = {   0,   22,   23,   24,   33,   34,   35}; //   7
  needed_v_smin[x_a][  8] = {   1,    3}; //   2
  needed_v_smin[x_a][  9] = {   1,    3}; //   2

  v_smax[x_a].resize(9);
  needed_v_smax[x_a].resize(9);
  needed_v_smax[x_a][  0] = {   4,    5,    7,   12,   14,   15,   25,   26,    2}; //   9
  needed_v_smax[x_a][  1] = {   6,   11,   13,   19,   20,   21}; //   6
  needed_v_smax[x_a][  2] = {   7,    8,    9,   10,   15,   16,   17,   18,   26,   27,   28,   29,    2,    4,   25,   30,   31,   32}; //  18
  needed_v_smax[x_a][  3] = {   8,    9,   10,   16,   17,   18,   22,   23,   24,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,    0}; //  22
  needed_v_smax[x_a][  4] = {  11,   12,   13,   14,    5,    6}; //   6
  needed_v_smax[x_a][  5] = {  19,   20,   21}; //   3
  needed_v_smax[x_a][  6] = {  36,   37,   38}; //   3
  needed_v_smax[x_a][  7] = {   0,    1,    3,   22,   23,   24,   33,   34,   35}; //   9
  needed_v_smax[x_a][  8] = {   1,    3}; //   2

  g_p[x_a].resize(13);
  needed_g_p[x_a].resize(13);
  needed_g_p[x_a][0] = {   4,    5,    7,   12,   14,   15,   25,   26}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin0_smax0");
  needed_g_p[x_a][1] = {   6,   11,   13,   19,   20,   21}; //   6
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin1_smax1");
  needed_g_p[x_a][2] = {   7,   15,   26}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin2_smax2");
  needed_g_p[x_a][3] = {   8,   16,   22,   27,   30,   33,   36}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][4] = {   8,    9,   10,   16,   17,   18,   27,   28,   29}; //   9
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin4_smax2");
  needed_g_p[x_a][5] = {   9,   17,   23,   28,   31,   34,   37}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax3");
  needed_g_p[x_a][6] = {  10,   18,   24,   29,   32,   35,   38}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin3_smax3");
  needed_g_p[x_a][7] = {  11,   13}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin5_smax4");
  needed_g_p[x_a][8] = {  12,   14}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_6_smin6_smax4");
  needed_g_p[x_a][9] = {  19}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax5");
  needed_g_p[x_a][10] = {  20}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin3_smax5");
  needed_g_p[x_a][11] = {  21}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_25_smin3_smax5");
  needed_g_p[x_a][12] = {  36,   37,   38}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_5_smin1_smax6");

  g_f[x_a].resize(9);
  needed_g_f[x_a].resize(9);
  needed_g_f[x_a][0] = {   0}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][1] = {   0,   22,   23,   24,   33,   34,   35}; //   7
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax7");
  needed_g_f[x_a][2] = {   1,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax8");
  needed_g_f[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][5] = {   2,    4,   25}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][6] = {   5}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax4");
  needed_g_f[x_a][7] = {   6}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][8] = {  30,   31,   32}; //   3
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax2");

  g_t[x_a].resize(17);
  needed_g_t[x_a].resize(17);
  needed_g_t[x_a][0] = {   0,    1,    3,   22,   23,   24,   33,   34,   35}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__32_28");
  needed_g_t[x_a][1] = {   0,   22,   23,   24}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_33__16_12");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__33_18__8_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__33_18__8_4");
  needed_g_t[x_a][3] = {   1,    3}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_33__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_33__4_24");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_6__33_6__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_6__33_6__8_16");
  needed_g_t[x_a][5] = {   2,   25,   26,   27,   28,   29,   30,   31,   32}; //   9
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][6] = {   2,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_17__4_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_17__4_40");
  needed_g_t[x_a][7] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__17_6__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__17_6__32_8");
  needed_g_t[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_5__33_6__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_5__33_6__16_8");
  needed_g_t[x_a][9] = {   4,    7,    8,    9,   10}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_1__16_44");
  needed_g_t[x_a][10] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_18__40_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_18__40_4");
  needed_g_t[x_a][11] = {   5,    6,   11,   12}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__2_1__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__2_1__4_56");
  needed_g_t[x_a][12] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_6__1_6__40_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_6__1_6__40_16");
  needed_g_t[x_a][13] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_6__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_6__48_8");
  needed_g_t[x_a][14] = {  30,   31,   32}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_17__12_32");
  needed_g_t[x_a][15] = {  33,   34,   35}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__2_33__12_16");
  needed_g_t[x_a][16] = {  36,   37,   38}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_5__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_5__1_2__48_12");

  g_d[x_a].resize(10);
  needed_g_d[x_a].resize(10);
  needed_g_d[x_a][0] = {   4,    5,    7,   12,   14,   15,   25,   26}; //   8
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_40__8_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_40__8_32");
  needed_g_d[x_a][1] = {   6,   11,   13,   19,   20,   21,   36,   37,   38}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");
  needed_g_d[x_a][2] = {   7,   15,   26}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__4_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__4_40");
  needed_g_d[x_a][3] = {   8,    9,   10,   16,   17,   18,   27,   28,   29}; //   9
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][4] = {   8,    9,   10,   16,   17,   18,   19,   20,   21,   22,   23,   24,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38}; //  24
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][5] = {  11,   13}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__8_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__8_48");
  needed_g_d[x_a][6] = {  12,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_56__16_40");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_56__16_40");
  needed_g_d[x_a][7] = {  13,   14}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__4_56");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__4_56");
  needed_g_d[x_a][8] = {  15,   16,   17,   18}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__16_44");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__16_44");
  needed_g_d[x_a][9] = {  19,   20,   21}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_60__12_48");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_60__12_48");

  c_p[x_a].resize(39);
  c_f[x_a].resize(39);
  c_t[x_a].resize(39);
  c_d[x_a].resize(39);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  4,   5}; //   2
  c_t[x_a][2] = {  5,   6,   7}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  2,   3}; //   2
  c_t[x_a][3] = {  0,   3,   8}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  5}; //   1
  c_t[x_a][4] = {  9,  10}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  0}; //   1
  c_f[x_a][5] = {  6}; //   1
  c_t[x_a][5] = { 11,  12}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  1}; //   1
  c_f[x_a][6] = {  7}; //   1
  c_t[x_a][6] = { 11,  13}; //   2
  c_d[x_a][6] = {  1}; //   1

  c_p[x_a][7] = {  0,   2}; //   2
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {  9}; //   1
  c_d[x_a][7] = {  2,   0}; //   2

  c_p[x_a][8] = {  3,   4}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {  9}; //   1
  c_d[x_a][8] = {  3,   4}; //   2

  c_p[x_a][9] = {  5,   4}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {  9}; //   1
  c_d[x_a][9] = {  3,   4}; //   2

  c_p[x_a][10] = {  6,   4}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  9}; //   1
  c_d[x_a][10] = {  3,   4}; //   2

  c_p[x_a][11] = {  1,   7}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = { 11}; //   1
  c_d[x_a][11] = {  5,   1}; //   2

  c_p[x_a][12] = {  0,   8}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 11}; //   1
  c_d[x_a][12] = {  6,   0}; //   2

  c_p[x_a][13] = {  1,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = {}; //   0
  c_d[x_a][13] = {  7,   5,   1}; //   3

  c_p[x_a][14] = {  0,   8}; //   2
  c_f[x_a][14] = {}; //   0
  c_t[x_a][14] = {}; //   0
  c_d[x_a][14] = {  7,   6,   0}; //   3

  c_p[x_a][15] = {  0,   2}; //   2
  c_f[x_a][15] = {}; //   0
  c_t[x_a][15] = {}; //   0
  c_d[x_a][15] = {  8,   2,   0}; //   3

  c_p[x_a][16] = {  3,   4}; //   2
  c_f[x_a][16] = {}; //   0
  c_t[x_a][16] = {}; //   0
  c_d[x_a][16] = {  8,   3,   4}; //   3

  c_p[x_a][17] = {  5,   4}; //   2
  c_f[x_a][17] = {}; //   0
  c_t[x_a][17] = {}; //   0
  c_d[x_a][17] = {  8,   3,   4}; //   3

  c_p[x_a][18] = {  6,   4}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {}; //   0
  c_d[x_a][18] = {  8,   3,   4}; //   3

  c_p[x_a][19] = {  1,   9}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {}; //   0
  c_d[x_a][19] = {  9,   4,   1}; //   3

  c_p[x_a][20] = {  1,  10}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {}; //   0
  c_d[x_a][20] = {  9,   4,   1}; //   3

  c_p[x_a][21] = {  1,  11}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {}; //   0
  c_d[x_a][21] = {  9,   4,   1}; //   3

  c_p[x_a][22] = {  3}; //   1
  c_f[x_a][22] = {  1}; //   1
  c_t[x_a][22] = {  0,   1}; //   2
  c_d[x_a][22] = {  4}; //   1

  c_p[x_a][23] = {  5}; //   1
  c_f[x_a][23] = {  1}; //   1
  c_t[x_a][23] = {  0,   1}; //   2
  c_d[x_a][23] = {  4}; //   1

  c_p[x_a][24] = {  6}; //   1
  c_f[x_a][24] = {  1}; //   1
  c_t[x_a][24] = {  0,   1}; //   2
  c_d[x_a][24] = {  4}; //   1

  c_p[x_a][25] = {  0}; //   1
  c_f[x_a][25] = {  5}; //   1
  c_t[x_a][25] = {  5,   6}; //   2
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  0,   2}; //   2
  c_f[x_a][26] = {}; //   0
  c_t[x_a][26] = {  5}; //   1
  c_d[x_a][26] = {  2,   0}; //   2

  c_p[x_a][27] = {  3,   4}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = {  5}; //   1
  c_d[x_a][27] = {  3,   4}; //   2

  c_p[x_a][28] = {  5,   4}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = {  5}; //   1
  c_d[x_a][28] = {  3,   4}; //   2

  c_p[x_a][29] = {  6,   4}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = {  5}; //   1
  c_d[x_a][29] = {  3,   4}; //   2

  c_p[x_a][30] = {  3}; //   1
  c_f[x_a][30] = {  8}; //   1
  c_t[x_a][30] = {  5,  14}; //   2
  c_d[x_a][30] = {  4}; //   1

  c_p[x_a][31] = {  5}; //   1
  c_f[x_a][31] = {  8}; //   1
  c_t[x_a][31] = {  5,  14}; //   2
  c_d[x_a][31] = {  4}; //   1

  c_p[x_a][32] = {  6}; //   1
  c_f[x_a][32] = {  8}; //   1
  c_t[x_a][32] = {  5,  14}; //   2
  c_d[x_a][32] = {  4}; //   1

  c_p[x_a][33] = {  3}; //   1
  c_f[x_a][33] = {  1}; //   1
  c_t[x_a][33] = {  0,  15}; //   2
  c_d[x_a][33] = {  4}; //   1

  c_p[x_a][34] = {  5}; //   1
  c_f[x_a][34] = {  1}; //   1
  c_t[x_a][34] = {  0,  15}; //   2
  c_d[x_a][34] = {  4}; //   1

  c_p[x_a][35] = {  6}; //   1
  c_f[x_a][35] = {  1}; //   1
  c_t[x_a][35] = {  0,  15}; //   2
  c_d[x_a][35] = {  4}; //   1

  c_p[x_a][36] = {  3,  12}; //   2
  c_f[x_a][36] = {}; //   0
  c_t[x_a][36] = { 16}; //   1
  c_d[x_a][36] = {  1,   4}; //   2

  c_p[x_a][37] = {  5,  12}; //   2
  c_f[x_a][37] = {}; //   0
  c_t[x_a][37] = { 16}; //   1
  c_d[x_a][37] = {  1,   4}; //   2

  c_p[x_a][38] = {  6,  12}; //   2
  c_f[x_a][38] = {}; //   0
  c_t[x_a][38] = { 16}; //   1
  c_d[x_a][38] = {  1,   4}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_gbx_wpwmgbx
//  channel    0: 1111(1, 2, 32, 8, 4, 16;   5,   5,   6)
//  channel    1: 1111(1, 2, 32, 8, 16, 4;   5,   6,   6)
//  channel    2: 1111(1, 2, 16, 32, 8, 4;   0,   6,   5)
//  channel    3: 1111(1, 2, 32, 16, 8, 4;   5,   6,   5)
//  channel    4: 2v11(1, 2, 8, 32, 4, 16;   6,   5,   6)
//  channel    5: 2v11(1, 2, 8, 32, 16, 4;   6,   6,   6)
//  channel    6: 2v11(1, 2, 16, 32, 8, 4;   5,   6,   5)
//  channel    7: 3yv1(1, 2, 4, 8, 32, 16;   6,   5,   5)
//  channel    8: 3yv1(1, 2, 32, 4, 8, 16;   0,   5,   5)
//  channel    9: 3yv1(1, 2, 32, 4, 8, 16;  23,   5,   5)
//  channel   10: 3yv1(1, 2, 32, 4, 8, 16;  25,   5,   5)
//  channel   11: 3yv1(1, 2, 8, 16, 32, 4;   5,   6,   6)
//  channel   12: 3yv1(1, 2, 16, 8, 32, 4;   6,   6,   6)
//  channel   13: 4yyv(1, 2, 4, 8, 16, 32;   5,   6,   5)
//  channel   14: 4yyv(1, 2, 4, 16, 8, 32;   6,   6,   5)
//  channel   15: 4yyv(1, 2, 16, 4, 8, 32;   6,   5,   5)
//  channel   16: 4yyv(1, 2, 16, 32, 4, 8;   0,   5,   5)
//  channel   17: 4yyv(1, 2, 16, 32, 4, 8;  23,   5,   5)
//  channel   18: 4yyv(1, 2, 16, 32, 4, 8;  25,   5,   5)
//  channel   19: 42vv(1, 2, 4, 8, 16, 32;   5,   0,   5)
//  channel   20: 42vv(1, 2, 4, 8, 16, 32;   5,  23,   5)
//  channel   21: 42vv(1, 2, 4, 8, 16, 32;   5,  25,   5)
//  channel   22: 12v1(1, 2, 32, 4, 8, 16;   0,   5,   5)
//  channel   23: 12v1(1, 2, 32, 4, 8, 16;  23,   5,   5)
//  channel   24: 12v1(1, 2, 32, 4, 8, 16;  25,   5,   5)
//  channel   25: 12v1(1, 2, 16, 8, 32, 4;   6,   0,   6)
//  channel   26: 13yv(1, 2, 16, 4, 8, 32;   6,   5,   0)
//  channel   27: 13yv(1, 2, 16, 32, 4, 8;   0,   5,   0)
//  channel   28: 13yv(1, 2, 16, 32, 4, 8;  23,   5,   0)
//  channel   29: 13yv(1, 2, 16, 32, 4, 8;  25,   5,   0)
//  channel   30: 112v(1, 2, 16, 32, 4, 8;   0,   0,   5)
//  channel   31: 112v(1, 2, 16, 32, 4, 8;  23,   0,   5)
//  channel   32: 112v(1, 2, 16, 32, 4, 8;  25,   0,   5)
//  channel   33: 112v(1, 2, 32, 16, 4, 8;   0,   5,   5)
//  channel   34: 112v(1, 2, 32, 16, 4, 8;  23,   5,   5)
//  channel   35: 112v(1, 2, 32, 16, 4, 8;  25,   5,   5)
//  channel   36: 2v2v(1, 2, 16, 32, 4, 8;   0,   5,   5)
//  channel   37: 2v2v(1, 2, 16, 32, 4, 8;  23,   5,   5)
//  channel   38: 2v2v(1, 2, 16, 32, 4, 8;  25,   5,   5)
