#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_uux_wpwmgg(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_uux_wpwmgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(14);
  needed_v_smin[x_a].resize(14);
  needed_v_smin[x_a][  0] = {  12,   13,   14,   15,   17,   18,   20,   21,   23,   24,   25,   26,   27,   28,   29,   30,    3,    8}; //  18
  needed_v_smin[x_a][  1] = {  16,   19,   22,   27,   28,   29,   30,    5,    6}; //   9
  needed_v_smin[x_a][  2] = {   0,    4}; //   2
  needed_v_smin[x_a][  3] = {   0,    4}; //   2
  needed_v_smin[x_a][  4] = {   1,    2}; //   2
  needed_v_smin[x_a][  5] = {   1,    2}; //   2
  needed_v_smin[x_a][  6] = {   3,   12,   13,   17,   18,   25,   26}; //   7
  needed_v_smin[x_a][  7] = {   5,    6,   19,   22}; //   4
  needed_v_smin[x_a][  8] = {   7,   11}; //   2
  needed_v_smin[x_a][  9] = {   7,   11}; //   2
  needed_v_smin[x_a][ 10] = {   8,   14,   15,   20,   21,   23,   24}; //   7
  needed_v_smin[x_a][ 11] = {   9,   10}; //   2
  needed_v_smin[x_a][ 12] = {   9,   10}; //   2
  needed_v_smin[x_a][ 13] = {  16}; //   1

  v_smax[x_a].resize(12);
  needed_v_smax[x_a].resize(12);
  needed_v_smax[x_a][  0] = {  12,   13,   14,   15,   17,   18,   20,   21,   23,   24,   25,   26,   29,   30,    3,    8}; //  16
  needed_v_smax[x_a][  1] = {  16,   19,   22,   27,   28,    5,    6}; //   7
  needed_v_smax[x_a][  2] = {  27,   28}; //   2
  needed_v_smax[x_a][  3] = {  29,   30}; //   2
  needed_v_smax[x_a][  4] = {   0,    4}; //   2
  needed_v_smax[x_a][  5] = {   0,    1,    2,    4,    5,    6,   19,   22}; //   8
  needed_v_smax[x_a][  6] = {   1,    2}; //   2
  needed_v_smax[x_a][  7] = {   3,    7,   11,   12,   13,   17,   18,   25,   26}; //   9
  needed_v_smax[x_a][  8] = {   7,   11}; //   2
  needed_v_smax[x_a][  9] = {   8,    9,   10,   14,   15,   20,   21,   23,   24}; //   9
  needed_v_smax[x_a][ 10] = {   9,   10}; //   2
  needed_v_smax[x_a][ 11] = {  16}; //   1

  g_p[x_a].resize(6);
  needed_g_p[x_a].resize(6);
  needed_g_p[x_a][0] = {  12,   14,   17,   20,   23,   25,   29}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {  13,   15,   18,   21,   24,   26,   30}; //   7
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {  16,   19,   22,   27,   28}; //   5
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {  27}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax2");
  needed_g_p[x_a][4] = {  28}; //   1
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax2");
  needed_g_p[x_a][5] = {  29,   30}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax3");

  g_f[x_a].resize(14);
  needed_g_f[x_a].resize(14);
  needed_g_f[x_a][0] = {   0,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax4");
  needed_g_f[x_a][1] = {   0,    4}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax5");
  needed_g_f[x_a][2] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax6");
  needed_g_f[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax5");
  needed_g_f[x_a][4] = {   3,    8}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");
  needed_g_f[x_a][5] = {   3,   12,   13,   17,   18,   25,   26}; //   7
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax7");
  needed_g_f[x_a][6] = {   5,    6}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");
  needed_g_f[x_a][7] = {   5,    6,   19,   22}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][8] = {   7,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax8");
  needed_g_f[x_a][9] = {   7,   11}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin9_smax7");
  needed_g_f[x_a][10] = {   8,   14,   15,   20,   21,   23,   24}; //   7
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin10_smax9");
  needed_g_f[x_a][11] = {   9,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin11_smax10");
  needed_g_f[x_a][12] = {   9,   10}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin12_smax9");
  needed_g_f[x_a][13] = {  16}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin13_smax11");

  g_t[x_a].resize(33);
  needed_g_t[x_a].resize(33);
  needed_g_t[x_a][0] = {   0,    1,    2,    4,    5,    6,   19,   22}; //   8
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__4_56");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__4_56");
  needed_g_t[x_a][1] = {   0,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__32_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__32_24");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__8_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__8_16");
  needed_g_t[x_a][3] = {   1,    2}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__16_40");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__16_40");
  needed_g_t[x_a][4] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__8_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__8_32");
  needed_g_t[x_a][5] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_18__32_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_18__32_8");
  needed_g_t[x_a][6] = {   3,    7,   11,   17,   18,   25,   26}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][7] = {   3,   17,   18}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__16_12");
  needed_g_t[x_a][8] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_18__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_18__4_8");
  needed_g_t[x_a][9] = {   4}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_34__16_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_34__16_8");
  needed_g_t[x_a][10] = {   5,    6,   19}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__8_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__8_48");
  needed_g_t[x_a][11] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__16_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__16_32");
  needed_g_t[x_a][12] = {   6}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__5_10__32_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__5_10__32_16");
  needed_g_t[x_a][13] = {   7,   11}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_20");
  needed_g_t[x_a][14] = {   7}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__4_16");
  needed_g_t[x_a][15] = {   8,    9,   10,   20,   21,   23,   24}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][16] = {   8,   20,   21}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__32_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__32_12");
  needed_g_t[x_a][17] = {   8}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_34__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_34__4_8");
  needed_g_t[x_a][18] = {   9,   10}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][19] = {   9}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__4_32");
  needed_g_t[x_a][20] = {  10}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][21] = {  11}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__16_4");
  needed_g_t[x_a][22] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][23] = {  12,   13}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][24] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][25] = {  14,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][26] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__8_52");
  needed_g_t[x_a][27] = {  16}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_10__48_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_10__48_4");
  needed_g_t[x_a][28] = {  22}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_5__48_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_5__48_8");
  needed_g_t[x_a][29] = {  23,   24}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][30] = {  25,   26}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");
  needed_g_t[x_a][31] = {  27,   28}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__12_48");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__12_48");
  needed_g_t[x_a][32] = {  29,   30}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__48_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__48_12");

  g_d[x_a].resize(2);
  needed_g_d[x_a].resize(2);
  needed_g_d[x_a][0] = {  12,   13,   14,   15,   17,   18,   20,   21,   23,   24,   25,   26,   27,   28,   29,   30}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {  16,   19,   22,   27,   28,   29,   30}; //   7
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_48__16_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_48__16_32");

  c_p[x_a].resize(31);
  c_f[x_a].resize(31);
  c_t[x_a].resize(31);
  c_d[x_a].resize(31);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  0,   3,   4}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   3}; //   2
  c_t[x_a][2] = {  0,   3,   5}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  4,   5}; //   2
  c_t[x_a][3] = {  6,   7,   8}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {}; //   0
  c_f[x_a][4] = {  0,   1}; //   2
  c_t[x_a][4] = {  0,   1,   9}; //   3
  c_d[x_a][4] = {}; //   0

  c_p[x_a][5] = {}; //   0
  c_f[x_a][5] = {  6,   7}; //   2
  c_t[x_a][5] = {  0,  10,  11}; //   3
  c_d[x_a][5] = {}; //   0

  c_p[x_a][6] = {}; //   0
  c_f[x_a][6] = {  6,   7}; //   2
  c_t[x_a][6] = {  0,  10,  12}; //   3
  c_d[x_a][6] = {}; //   0

  c_p[x_a][7] = {}; //   0
  c_f[x_a][7] = {  8,   9}; //   2
  c_t[x_a][7] = {  6,  13,  14}; //   3
  c_d[x_a][7] = {}; //   0

  c_p[x_a][8] = {}; //   0
  c_f[x_a][8] = {  4,  10}; //   2
  c_t[x_a][8] = { 15,  16,  17}; //   3
  c_d[x_a][8] = {}; //   0

  c_p[x_a][9] = {}; //   0
  c_f[x_a][9] = { 11,  12}; //   2
  c_t[x_a][9] = { 15,  18,  19}; //   3
  c_d[x_a][9] = {}; //   0

  c_p[x_a][10] = {}; //   0
  c_f[x_a][10] = { 11,  12}; //   2
  c_t[x_a][10] = { 15,  18,  20}; //   3
  c_d[x_a][10] = {}; //   0

  c_p[x_a][11] = {}; //   0
  c_f[x_a][11] = {  8,   9}; //   2
  c_t[x_a][11] = {  6,  13,  21}; //   3
  c_d[x_a][11] = {}; //   0

  c_p[x_a][12] = {  0}; //   1
  c_f[x_a][12] = {  5}; //   1
  c_t[x_a][12] = { 22,  23}; //   2
  c_d[x_a][12] = {  0}; //   1

  c_p[x_a][13] = {  1}; //   1
  c_f[x_a][13] = {  5}; //   1
  c_t[x_a][13] = { 22,  23}; //   2
  c_d[x_a][13] = {  0}; //   1

  c_p[x_a][14] = {  0}; //   1
  c_f[x_a][14] = { 10}; //   1
  c_t[x_a][14] = { 24,  25}; //   2
  c_d[x_a][14] = {  0}; //   1

  c_p[x_a][15] = {  1}; //   1
  c_f[x_a][15] = { 10}; //   1
  c_t[x_a][15] = { 24,  25}; //   2
  c_d[x_a][15] = {  0}; //   1

  c_p[x_a][16] = {  2}; //   1
  c_f[x_a][16] = { 13}; //   1
  c_t[x_a][16] = { 26,  27}; //   2
  c_d[x_a][16] = {  1}; //   1

  c_p[x_a][17] = {  0}; //   1
  c_f[x_a][17] = {  5}; //   1
  c_t[x_a][17] = {  6,   7}; //   2
  c_d[x_a][17] = {  0}; //   1

  c_p[x_a][18] = {  1}; //   1
  c_f[x_a][18] = {  5}; //   1
  c_t[x_a][18] = {  6,   7}; //   2
  c_d[x_a][18] = {  0}; //   1

  c_p[x_a][19] = {  2}; //   1
  c_f[x_a][19] = {  7}; //   1
  c_t[x_a][19] = {  0,  10}; //   2
  c_d[x_a][19] = {  1}; //   1

  c_p[x_a][20] = {  0}; //   1
  c_f[x_a][20] = { 10}; //   1
  c_t[x_a][20] = { 15,  16}; //   2
  c_d[x_a][20] = {  0}; //   1

  c_p[x_a][21] = {  1}; //   1
  c_f[x_a][21] = { 10}; //   1
  c_t[x_a][21] = { 15,  16}; //   2
  c_d[x_a][21] = {  0}; //   1

  c_p[x_a][22] = {  2}; //   1
  c_f[x_a][22] = {  7}; //   1
  c_t[x_a][22] = {  0,  28}; //   2
  c_d[x_a][22] = {  1}; //   1

  c_p[x_a][23] = {  0}; //   1
  c_f[x_a][23] = { 10}; //   1
  c_t[x_a][23] = { 15,  29}; //   2
  c_d[x_a][23] = {  0}; //   1

  c_p[x_a][24] = {  1}; //   1
  c_f[x_a][24] = { 10}; //   1
  c_t[x_a][24] = { 15,  29}; //   2
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  0}; //   1
  c_f[x_a][25] = {  5}; //   1
  c_t[x_a][25] = {  6,  30}; //   2
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  1}; //   1
  c_f[x_a][26] = {  5}; //   1
  c_t[x_a][26] = {  6,  30}; //   2
  c_d[x_a][26] = {  0}; //   1

  c_p[x_a][27] = {  2,   3}; //   2
  c_f[x_a][27] = {}; //   0
  c_t[x_a][27] = { 31}; //   1
  c_d[x_a][27] = {  0,   1}; //   2

  c_p[x_a][28] = {  2,   4}; //   2
  c_f[x_a][28] = {}; //   0
  c_t[x_a][28] = { 31}; //   1
  c_d[x_a][28] = {  0,   1}; //   2

  c_p[x_a][29] = {  0,   5}; //   2
  c_f[x_a][29] = {}; //   0
  c_t[x_a][29] = { 32}; //   1
  c_d[x_a][29] = {  1,   0}; //   2

  c_p[x_a][30] = {  1,   5}; //   2
  c_f[x_a][30] = {}; //   0
  c_t[x_a][30] = { 32}; //   1
  c_d[x_a][30] = {  1,   0}; //   2

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_uux_wpwmgg
//  channel    0: 1111(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    1: 1111(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel    2: 1111(1, 2, 4, 32, 8, 16;   0,   0,   0)
//  channel    3: 1111(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    4: 1111(1, 2, 4, 16, 8, 32;   0,   0,   0)
//  channel    5: 1111(1, 2, 4, 16, 32, 8;   0,   0,   0)
//  channel    6: 1111(1, 2, 4, 32, 16, 8;   0,   0,   0)
//  channel    7: 1111(1, 2, 32, 4, 16, 8;   0,   0,   0)
//  channel    8: 1111(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel    9: 1111(1, 2, 16, 4, 32, 8;   0,   0,   0)
//  channel   10: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   11: 1111(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   12: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   13: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel   14: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel   15: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel   16: 2v11(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   17: 12v1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel   18: 12v1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel   19: 12v1(1, 2, 4, 16, 32, 8;   0,   0,   0)
//  channel   20: 12v1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   21: 12v1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   22: 112v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   23: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   24: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   25: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   26: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   27: 2v2v(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel   28: 2v2v(1, 2, 4, 8, 16, 32;   0,  23,   0)
//  channel   29: 2v2v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   30: 2v2v(1, 2, 16, 32, 4, 8;  23,   0,   0)
