#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_220_uxux_wpwmuxux(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_220_uxux_wpwmuxux");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(9);
  needed_v_smin[x_a].resize(9);
  needed_v_smin[x_a][  0] = {   4,    5,    6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   24,   25,   26,   27}; //  16
  needed_v_smin[x_a][  1] = {   8,    9,   18,   19,    6,    7,   24,   25}; //   8
  needed_v_smin[x_a][  2] = {  10,   11,   20,   21,    4,    5,   26,   27}; //   8
  needed_v_smin[x_a][  3] = {  12,   14,   16,   22,    1,    2}; //   6
  needed_v_smin[x_a][  4] = {  12,   22,    1,   14}; //   4
  needed_v_smin[x_a][  5] = {  13,   15,   17,   23,    0,    3}; //   6
  needed_v_smin[x_a][  6] = {  13,   23,    0,   15}; //   4
  needed_v_smin[x_a][  7] = {   2,   16}; //   2
  needed_v_smin[x_a][  8] = {   3,   17}; //   2

  v_smax[x_a].resize(6);
  needed_v_smax[x_a].resize(6);
  needed_v_smax[x_a][  0] = {   4,    5,    6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   24,   25,   26,   27}; //  16
  needed_v_smax[x_a][  1] = {   8,    9,   13,   18,   19,   23,    0,    6,    7,   15,   24,   25}; //  12
  needed_v_smax[x_a][  2] = {  10,   11,   12,   20,   21,   22,    1,    4,    5,   14,   26,   27}; //  12
  needed_v_smax[x_a][  3] = {  12,   14,   16,   22,    1,    2}; //   6
  needed_v_smax[x_a][  4] = {  13,   15,   17,   23,    0,    3}; //   6
  needed_v_smax[x_a][  5] = {   2,    3,   16,   17}; //   4

  g_p[x_a].resize(8);
  needed_g_p[x_a].resize(8);
  needed_g_p[x_a][0] = {   4,    6,    8,   10,   18,   20,   24,   26}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   5,    7,    9,   11,   19,   21,   25,   27}; //   8
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   8,    9,   18,   19}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin1_smax1");
  needed_g_p[x_a][3] = {  10,   11,   20,   21}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin2_smax2");
  needed_g_p[x_a][4] = {  12,   14,   16,   22}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin3_smax3");
  needed_g_p[x_a][5] = {  12,   22}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin4_smax2");
  needed_g_p[x_a][6] = {  13,   15,   17,   23}; //   4
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin5_smax4");
  needed_g_p[x_a][7] = {  13,   23}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin6_smax1");

  g_f[x_a].resize(8);
  needed_g_f[x_a].resize(8);
  needed_g_f[x_a][0] = {   0,    3}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin5_smax4");
  needed_g_f[x_a][1] = {   0,   15}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin6_smax1");
  needed_g_f[x_a][2] = {   1,    2}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin3_smax3");
  needed_g_f[x_a][3] = {   1,   14}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin4_smax2");
  needed_g_f[x_a][4] = {   2,   16}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin7_smax5");
  needed_g_f[x_a][5] = {   3,   17}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin8_smax5");
  needed_g_f[x_a][6] = {   4,    5,   26,   27}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][7] = {   6,    7,   24,   25}; //   4
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin1_smax1");

  g_t[x_a].resize(17);
  needed_g_t[x_a].resize(17);
  needed_g_t[x_a][0] = {   0,   15,   18,   19,   23,   24,   25}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_44");
  needed_g_t[x_a][1] = {   0,   15}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__8_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__8_36");
  needed_g_t[x_a][2] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__17_10__32_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__17_10__32_4");
  needed_g_t[x_a][3] = {   1,   14,   20,   21,   22,   26,   27}; //   7
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__32_28");
  needed_g_t[x_a][4] = {   1,   14}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__8_20");
  needed_g_t[x_a][5] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__33_10__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__33_10__16_4");
  needed_g_t[x_a][6] = {   2,    3,   16,   17}; //   4
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_52");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_52");
  needed_g_t[x_a][7] = {   2,   16}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__32_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__32_20");
  needed_g_t[x_a][8] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_34__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_34__4_16");
  needed_g_t[x_a][9] = {   3,   17}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_36");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_36");
  needed_g_t[x_a][10] = {   3}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_0__9_18__4_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_0__9_18__4_32");
  needed_g_t[x_a][11] = {   4,    5,   10,   11,   12}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__32_28");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__32_28");
  needed_g_t[x_a][12] = {   4,    5}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_34__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_34__12_16");
  needed_g_t[x_a][13] = {   6,    7,    8,    9,   13}; //   5
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_44");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_44");
  needed_g_t[x_a][14] = {   6,    7}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_18__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_18__12_32");
  needed_g_t[x_a][15] = {  24,   25}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__12_32");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__12_32");
  needed_g_t[x_a][16] = {  26,   27}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_33__12_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_33__12_16");

  g_d[x_a].resize(7);
  needed_g_d[x_a].resize(7);
  needed_g_d[x_a][0] = {   4,    5,    6,    7,    8,    9,   10,   11,   18,   19,   20,   21,   24,   25,   26,   27}; //  16
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   8,    9,   18,   19}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__32_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__32_12");
  needed_g_d[x_a][2] = {  10,   11,   20,   21}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__16_12");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__16_12");
  needed_g_d[x_a][3] = {  12,   22}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {  12,   14,   16,   22}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");
  needed_g_d[x_a][5] = {  13,   23}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_44__8_36");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_44__8_36");
  needed_g_d[x_a][6] = {  13,   15,   17,   23}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_36__4_32");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_36__4_32");

  c_p[x_a].resize(28);
  c_f[x_a].resize(28);
  c_t[x_a].resize(28);
  c_d[x_a].resize(28);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0,   1}; //   2
  c_t[x_a][0] = {  0,   1,   2}; //   3
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  2,   3}; //   2
  c_t[x_a][1] = {  3,   4,   5}; //   3
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  2,   4}; //   2
  c_t[x_a][2] = {  6,   7,   8}; //   3
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {}; //   0
  c_f[x_a][3] = {  0,   5}; //   2
  c_t[x_a][3] = {  6,   9,  10}; //   3
  c_d[x_a][3] = {}; //   0

  c_p[x_a][4] = {  0}; //   1
  c_f[x_a][4] = {  6}; //   1
  c_t[x_a][4] = { 11,  12}; //   2
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  1}; //   1
  c_f[x_a][5] = {  6}; //   1
  c_t[x_a][5] = { 11,  12}; //   2
  c_d[x_a][5] = {  0}; //   1

  c_p[x_a][6] = {  0}; //   1
  c_f[x_a][6] = {  7}; //   1
  c_t[x_a][6] = { 13,  14}; //   2
  c_d[x_a][6] = {  0}; //   1

  c_p[x_a][7] = {  1}; //   1
  c_f[x_a][7] = {  7}; //   1
  c_t[x_a][7] = { 13,  14}; //   2
  c_d[x_a][7] = {  0}; //   1

  c_p[x_a][8] = {  0,   2}; //   2
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = { 13}; //   1
  c_d[x_a][8] = {  1,   0}; //   2

  c_p[x_a][9] = {  1,   2}; //   2
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = { 13}; //   1
  c_d[x_a][9] = {  1,   0}; //   2

  c_p[x_a][10] = {  0,   3}; //   2
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = { 11}; //   1
  c_d[x_a][10] = {  2,   0}; //   2

  c_p[x_a][11] = {  1,   3}; //   2
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = { 11}; //   1
  c_d[x_a][11] = {  2,   0}; //   2

  c_p[x_a][12] = {  4,   5}; //   2
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = { 11}; //   1
  c_d[x_a][12] = {  3,   4}; //   2

  c_p[x_a][13] = {  6,   7}; //   2
  c_f[x_a][13] = {}; //   0
  c_t[x_a][13] = { 13}; //   1
  c_d[x_a][13] = {  5,   6}; //   2

  c_p[x_a][14] = {  4}; //   1
  c_f[x_a][14] = {  3}; //   1
  c_t[x_a][14] = {  3,   4}; //   2
  c_d[x_a][14] = {  4}; //   1

  c_p[x_a][15] = {  6}; //   1
  c_f[x_a][15] = {  1}; //   1
  c_t[x_a][15] = {  0,   1}; //   2
  c_d[x_a][15] = {  6}; //   1

  c_p[x_a][16] = {  4}; //   1
  c_f[x_a][16] = {  4}; //   1
  c_t[x_a][16] = {  6,   7}; //   2
  c_d[x_a][16] = {  4}; //   1

  c_p[x_a][17] = {  6}; //   1
  c_f[x_a][17] = {  5}; //   1
  c_t[x_a][17] = {  6,   9}; //   2
  c_d[x_a][17] = {  6}; //   1

  c_p[x_a][18] = {  0,   2}; //   2
  c_f[x_a][18] = {}; //   0
  c_t[x_a][18] = {  0}; //   1
  c_d[x_a][18] = {  1,   0}; //   2

  c_p[x_a][19] = {  1,   2}; //   2
  c_f[x_a][19] = {}; //   0
  c_t[x_a][19] = {  0}; //   1
  c_d[x_a][19] = {  1,   0}; //   2

  c_p[x_a][20] = {  0,   3}; //   2
  c_f[x_a][20] = {}; //   0
  c_t[x_a][20] = {  3}; //   1
  c_d[x_a][20] = {  2,   0}; //   2

  c_p[x_a][21] = {  1,   3}; //   2
  c_f[x_a][21] = {}; //   0
  c_t[x_a][21] = {  3}; //   1
  c_d[x_a][21] = {  2,   0}; //   2

  c_p[x_a][22] = {  4,   5}; //   2
  c_f[x_a][22] = {}; //   0
  c_t[x_a][22] = {  3}; //   1
  c_d[x_a][22] = {  3,   4}; //   2

  c_p[x_a][23] = {  6,   7}; //   2
  c_f[x_a][23] = {}; //   0
  c_t[x_a][23] = {  0}; //   1
  c_d[x_a][23] = {  5,   6}; //   2

  c_p[x_a][24] = {  0}; //   1
  c_f[x_a][24] = {  7}; //   1
  c_t[x_a][24] = {  0,  15}; //   2
  c_d[x_a][24] = {  0}; //   1

  c_p[x_a][25] = {  1}; //   1
  c_f[x_a][25] = {  7}; //   1
  c_t[x_a][25] = {  0,  15}; //   2
  c_d[x_a][25] = {  0}; //   1

  c_p[x_a][26] = {  0}; //   1
  c_f[x_a][26] = {  6}; //   1
  c_t[x_a][26] = {  3,  16}; //   2
  c_d[x_a][26] = {  0}; //   1

  c_p[x_a][27] = {  1}; //   1
  c_f[x_a][27] = {  6}; //   1
  c_t[x_a][27] = {  3,  16}; //   2
  c_d[x_a][27] = {  0}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_220_uxux_wpwmuxux
//  channel    0: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel    1: 1111(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel    2: 1111(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel    3: 1111(1, 2, 8, 4, 32, 16;   0,   0,   0)
//  channel    4: 2v11(1, 2, 4, 8, 16, 32;   0,   0,   0)
//  channel    5: 2v11(1, 2, 4, 8, 16, 32;  23,   0,   0)
//  channel    6: 2v11(1, 2, 4, 8, 32, 16;   0,   0,   0)
//  channel    7: 2v11(1, 2, 4, 8, 32, 16;  23,   0,   0)
//  channel    8: 3yv1(1, 2, 32, 4, 8, 16;   0,   0,   0)
//  channel    9: 3yv1(1, 2, 32, 4, 8, 16;  23,   0,   0)
//  channel   10: 3yv1(1, 2, 16, 4, 8, 32;   0,   0,   0)
//  channel   11: 3yv1(1, 2, 16, 4, 8, 32;  23,   0,   0)
//  channel   12: 3yv1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   13: 3yv1(1, 2, 8, 4, 32, 16;   0,   0,   0)
//  channel   14: 12v1(1, 2, 32, 4, 16, 8;   0,   0,   0)
//  channel   15: 12v1(1, 2, 16, 4, 32, 8;   0,   0,   0)
//  channel   16: 12v1(1, 2, 8, 4, 16, 32;   0,   0,   0)
//  channel   17: 12v1(1, 2, 8, 4, 32, 16;   0,   0,   0)
//  channel   18: 13yv(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   19: 13yv(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   20: 13yv(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   21: 13yv(1, 2, 32, 16, 4, 8;  23,   0,   0)
//  channel   22: 13yv(1, 2, 32, 8, 4, 16;   0,   0,   0)
//  channel   23: 13yv(1, 2, 16, 8, 4, 32;   0,   0,   0)
//  channel   24: 112v(1, 2, 16, 32, 4, 8;   0,   0,   0)
//  channel   25: 112v(1, 2, 16, 32, 4, 8;  23,   0,   0)
//  channel   26: 112v(1, 2, 32, 16, 4, 8;   0,   0,   0)
//  channel   27: 112v(1, 2, 32, 16, 4, 8;  23,   0,   0)
