#include "header.hpp"

#include "ppwxw02.phasespace.set.hpp"

void ppwxw02_phasespace_set::ax_psp_030_ddx_wpwma(int x_a){
  static Logger logger("ppwxw02_phasespace_set::ax_psp_030_ddx_wpwma");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  v_smin[x_a].resize(3);
  needed_v_smin[x_a].resize(3);
  needed_v_smin[x_a][  0] = {   3,    4,   10,   11,    2}; //   5
  needed_v_smin[x_a][  1] = {   5,    6,    7}; //   3
  needed_v_smin[x_a][  2] = {   8,    9,   12,    0,    1}; //   5

  v_smax[x_a].resize(3);
  needed_v_smax[x_a].resize(3);
  needed_v_smax[x_a][  0] = {   3,    4,   10,   11,    2}; //   5
  needed_v_smax[x_a][  1] = {   5,    6,    7}; //   3
  needed_v_smax[x_a][  2] = {   8,    9,   12,    0,    1}; //   5

  g_p[x_a].resize(4);
  needed_g_p[x_a].resize(4);
  needed_g_p[x_a][0] = {   3,   10}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_0_smin0_smax0");
  needed_g_p[x_a][1] = {   4,   11}; //   2
  MC_IS_name_type[x_a][0].push_back("propagator_23_smin0_smax0");
  needed_g_p[x_a][2] = {   5,    6,    7}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin1_smax1");
  needed_g_p[x_a][3] = {   8,    9,   12}; //   3
  MC_IS_name_type[x_a][0].push_back("propagator_24_smin2_smax2");

  g_f[x_a].resize(2);
  needed_g_f[x_a].resize(2);
  needed_g_f[x_a][0] = {   0,    1}; //   2
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin2_smax2");
  needed_g_f[x_a][1] = {   2}; //   1
  MC_IS_name_type[x_a][1].push_back("timelikeinvariant_smin0_smax0");

  g_t[x_a].resize(7);
  needed_g_t[x_a].resize(7);
  needed_g_t[x_a][0] = {   0,    1,   12}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__8_20");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__8_20");
  needed_g_t[x_a][1] = {   0}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__16_4");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__16_4");
  needed_g_t[x_a][2] = {   1}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_9__4_16");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_9__4_16");
  needed_g_t[x_a][3] = {   2,   10,   11}; //   3
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__1_2__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__1_2__16_12");
  needed_g_t[x_a][4] = {   2}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_17__4_8");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_17__4_8");
  needed_g_t[x_a][5] = {   3,    4}; //   2
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__16_12");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__16_12");
  needed_g_t[x_a][6] = {   5}; //   1
  MC_IS_name_type[x_a][2].push_back("t_of_tchannel_opt_0__2_1__4_24");
  MC_IS_name_type[x_a][3].push_back("phi_of_tchannel_opt_0__2_1__4_24");

  g_d[x_a].resize(5);
  needed_g_d[x_a].resize(5);
  needed_g_d[x_a][0] = {   3,    4,   10,   11}; //   4
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_12__4_8");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_12__4_8");
  needed_g_d[x_a][1] = {   5,    6,    7}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_24__8_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_24__8_16");
  needed_g_d[x_a][2] = {   6,    7}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__4_24");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__4_24");
  needed_g_d[x_a][3] = {   8,    9}; //   2
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_28__8_20");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_28__8_20");
  needed_g_d[x_a][4] = {   8,    9,   12}; //   3
  MC_IS_name_type[x_a][4].push_back("costheta_of_decay_20__4_16");
  MC_IS_name_type[x_a][5].push_back("phi_of_decay_20__4_16");

  c_p[x_a].resize(13);
  c_f[x_a].resize(13);
  c_t[x_a].resize(13);
  c_d[x_a].resize(13);

  c_p[x_a][0] = {}; //   0
  c_f[x_a][0] = {  0}; //   1
  c_t[x_a][0] = {  0,   1}; //   2
  c_d[x_a][0] = {}; //   0

  c_p[x_a][1] = {}; //   0
  c_f[x_a][1] = {  0}; //   1
  c_t[x_a][1] = {  0,   2}; //   2
  c_d[x_a][1] = {}; //   0

  c_p[x_a][2] = {}; //   0
  c_f[x_a][2] = {  1}; //   1
  c_t[x_a][2] = {  3,   4}; //   2
  c_d[x_a][2] = {}; //   0

  c_p[x_a][3] = {  0}; //   1
  c_f[x_a][3] = {}; //   0
  c_t[x_a][3] = {  5}; //   1
  c_d[x_a][3] = {  0}; //   1

  c_p[x_a][4] = {  1}; //   1
  c_f[x_a][4] = {}; //   0
  c_t[x_a][4] = {  5}; //   1
  c_d[x_a][4] = {  0}; //   1

  c_p[x_a][5] = {  2}; //   1
  c_f[x_a][5] = {}; //   0
  c_t[x_a][5] = {  6}; //   1
  c_d[x_a][5] = {  1}; //   1

  c_p[x_a][6] = {  2}; //   1
  c_f[x_a][6] = {}; //   0
  c_t[x_a][6] = {}; //   0
  c_d[x_a][6] = {  2,   1}; //   2

  c_p[x_a][7] = {  2}; //   1
  c_f[x_a][7] = {}; //   0
  c_t[x_a][7] = {}; //   0
  c_d[x_a][7] = {  2,   1}; //   2

  c_p[x_a][8] = {  3}; //   1
  c_f[x_a][8] = {}; //   0
  c_t[x_a][8] = {}; //   0
  c_d[x_a][8] = {  3,   4}; //   2

  c_p[x_a][9] = {  3}; //   1
  c_f[x_a][9] = {}; //   0
  c_t[x_a][9] = {}; //   0
  c_d[x_a][9] = {  3,   4}; //   2

  c_p[x_a][10] = {  0}; //   1
  c_f[x_a][10] = {}; //   0
  c_t[x_a][10] = {  3}; //   1
  c_d[x_a][10] = {  0}; //   1

  c_p[x_a][11] = {  1}; //   1
  c_f[x_a][11] = {}; //   0
  c_t[x_a][11] = {  3}; //   1
  c_d[x_a][11] = {  0}; //   1

  c_p[x_a][12] = {  3}; //   1
  c_f[x_a][12] = {}; //   0
  c_t[x_a][12] = {  0}; //   1
  c_d[x_a][12] = {  4}; //   1

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

//  psp_030_ddx_wpwma
//  channel    0: 111(1, 2, 8, 4, 16;   0,   0)
//  channel    1: 111(1, 2, 8, 16, 4;   0,   0)
//  channel    2: 111(1, 2, 16, 8, 4;   0,   0)
//  channel    3: 2v1(1, 2, 4, 8, 16;   0,   0)
//  channel    4: 2v1(1, 2, 4, 8, 16;  23,   0)
//  channel    5: 2v1(1, 2, 8, 16, 4;  24,   0)
//  channel    6: 3yv(1, 2, 4, 8, 16;  24,   0)
//  channel    7: 3yv(1, 2, 4, 8, 16;  24,  23)
//  channel    8: 3yv(1, 2, 8, 4, 16;  24,   0)
//  channel    9: 3yv(1, 2, 8, 4, 16;  24,  23)
//  channel   10: 12v(1, 2, 16, 4, 8;   0,   0)
//  channel   11: 12v(1, 2, 16, 4, 8;  23,   0)
//  channel   12: 12v(1, 2, 8, 4, 16;  24,   0)
