************************************************************************
*
* to be compiled as 
* g77 qqQQ_NLO.for -o qqQQ_NLO.exe 
* 
************************************************************************
**************************** 72 characters *****************************
*
*
      double precision function FinVirtqq(s,t)
      implicit none
      include 'scale.f'
      include 'masses.f'
      double precision en,w,tm,pi,hM,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,Nc,Nl,Nh,
     $                 stev,ttev,tmin,tmax,rnorm,
     $                 CSoneepm2qq,CSoneepm1qq,CSoneep0qq,
     $                 CSoneepm2Kqq,
     $                 CSoneepm1Kqq,CSoneep0Kqq,
     $                 PoleEPm2qq,PoleEPm1qq,PoleEP0qq
*
      Integer I
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
*
c      write(6,'('' '')')
c      write(6,'(''s (in TeV^2)              = '',$)')
c      read(5,*) stev
c      write(6,'(''mt (top mass in GeV)      = '',$)')
c      read(5,*) tm
c      write(6,'(''mu (renorm. scale in GeV) = '',$)')
c      read(5,*) w
      tm=mt
      w=scale
*
******* Allowed range for t: *****
*
c      tmin = - stev/2.d0 * ( 1.d0 - Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
c      tmax = - stev/2.d0 * ( 1.d0 + Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
*
**********************************
*
c      write(6,'('' '')')
c      write(6,'(''t (in TeV^2) belongs to the range '')')
c      write(6,'(1pe22.5,'' < t < '',1pe22.5)')
c     $         tmax, tmin
c      write(6,'(''t (in TeV^2)              = '',$)')
c      read(5,*) ttev
*
c       if (ttev.le.tmax.OR.ttev.ge.tmin) then
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'(''           t is outside the range '')')
c       write(6,'(''###############################################'')')
c        stop
c       endif
*
c      write(6,'('' '')')
c      write(6,'(''# Choose the normalization factor:'')')
c      write(6,'(''# 0  ->  Exp[-EulerGamma*ep]'')')
c      write(6,'(''# 1  ->  Gamma[1+ep]'')')
c      read(5,*) rnorm
*
c      write(6,'('' '')')
c      write(6,'(''# The results will be also written in qqQQN.res'')')
c       write(6,'(''#'')')
c       write(6,'(''#'')')
c       open(3,FILE='qqQQ_NLO.res')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
c       write(3,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(3,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(3,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(3,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(3,'(''#'')')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
*
************************************************************************
* 
c        s = 1.d+6*stev
c	t = 1.d+6*ttev
*
c       CSoneepm2 = PoleEPm2(s,t,tm,w)
c       CSoneepm1 = PoleEPm1(s,t,tm,w) 
c     $             - DLog(tm**2/w**2)*PoleEPm2(s,t,tm,w)
       FinVirtqq  = PoleEP0qq(s,t,tm,w) 
c     $             + 1.d0/2.d0*DLog(tm**2/w**2)**2*PoleEPm2(s,t,tm,w)
c     $             - DLog(tm**2/w**2)*PoleEPm1(s,t,tm,w) 

ch       write(*,*)PoleEPm2qq(s,t,tm,w)
ch       write(*,*)PoleEPm1qq(s,t,tm,w) 
ch     $             - DLog(tm**2/w**2)*PoleEPm2qq(s,t,tm,w)
*
* Normalization factor Exp[-EulerGamma*ep]:
*
c       CSoneepm2K = CSoneepm2
c       CSoneepm1K = CSoneepm1
c       CSoneep0K  = CSoneep0 + z2/2.d0*CSoneepm2
*
*
c       if (rnorm.eq.0) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
c       if (rnorm.eq.1) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
*
c15    continue
c       close(3)
      return
      end

      double precision function FinVirtgg(s,t)
      implicit none
      include 'scale.f'
      include 'masses.f'
      double precision en,w,tm,pi,hM,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,Nc,Nl,Nh,
     $                 stev,ttev,tmin,tmax,rnorm,ypzp2,ypzm2,sqrypzp2,
     $                 sqrypzm2,CSoneepm2gg,CSoneepm1gg,CSoneep0gg,
     $                 CSoneepm1Kgg,CSoneep0Kgg,CSoneepm2Kgg,
     $                 PoleEPm2gg,PoleEPm1gg,PoleEP0gg
*
      Integer I
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
*
c      write(6,'('' '')')
c      write(6,'(''s (in TeV^2)              = '',$)')
c      read(5,*) stev
c      write(6,'(''mt (top mass in GeV)      = '',$)')
c      read(5,*) tm
c      write(6,'(''mu (renorm. scale in GeV) = '',$)')
c      read(5,*) w

      tm=mt
      w=scale
*
******* Allowed range for t: *****
*
c      tmin = - stev/2.d0 * ( 1.d0 - Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
c      tmax = - stev/2.d0 * ( 1.d0 + Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
*
**********************************
*
c      write(6,'('' '')')
c      write(6,'(''t (in TeV^2) belongs to the range '')')
c      write(6,'(1pe22.5,'' < t < '',1pe22.5)')
c     $         tmax, tmin
c      write(6,'(''t (in TeV^2)              = '',$)')
c      read(5,*) ttev
*
c       if (ttev.le.tmax.OR.ttev.ge.tmin) then
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'(''           t is outside the range '')')
c       write(6,'(''###############################################'')')
c        stop
c       endif
*
c      write(6,'('' '')')
c      write(6,'(''# Choose the normalization factor:'')')
c      write(6,'(''# 0  ->  Exp[-EulerGamma*ep]'')')
c      write(6,'(''# 1  ->  Gamma[1+ep]'')')
c      read(5,*) rnorm
*
c      write(6,'('' '')')
c      write(6,'(''# The results will be also written in qqQQN.res'')')
c       write(6,'(''#'')')
c       write(6,'(''#'')')
c       open(3,FILE='ggQQ_NLO.res')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
c       write(3,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(3,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(3,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(3,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(3,'(''#'')')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
*
************************************************************************
* 
c       s = 1.d+6*stev
c	t = 1.d+6*ttev
*
c       CSoneepm2 = PoleEPm2(s,t,tm,w)
c       CSoneepm1 = PoleEPm1gg(s,t,tm,w) 
c     $             - DLog(tm**2/w**2)*PoleEPm2(s,t,tm,w)
       FinVirtgg  = PoleEP0gg(s,t,tm,w) 
c     $             + 1.d0/2.d0*DLog(tm**2/w**2)**2*PoleEPm2(s,t,tm,w)
c     $             - DLog(tm**2/w**2)*PoleEPm1gg(s,t,tm,w) 
*
* Normalization factor Exp[-EulerGamma*ep]:
*
c       CSoneepm2K = CSoneepm2
c       CSoneepm1K = CSoneepm1
c       CSoneep0K  = CSoneep0 + z2/2.d0*CSoneepm2
*
*
c       if (rnorm.eq.0) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
c       if (rnorm.eq.1) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
*
c15    continue
c       close(3)
      return
      end

      double precision function FinVirtT13qq(s,t)
      implicit none
      include 'scale.f'
      include 'masses.f'
      double precision en,w,tm,pi,hM,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,Nc,Nl,Nh,
     $                 stev,ttev,tmin,tmax,rnorm,
     $                 T13CSoneepm2qq,T13CSoneepm1qq,T13CSoneep0qq,
     $                 T13CSoneepm2Kqq,
     $                 T13CSoneepm1Kqq,T13CSoneep0Kqq,
     $                 T13PoleEPm2qq,T13PoleEPm1qq,T13PoleEP0qq
     $                 ,T13PoleEP0qqc
*
      Integer I
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
*
c      write(6,'('' '')')
c      write(6,'(''s (in TeV^2)              = '',$)')
c      read(5,*) stev
c      write(6,'(''mt (top mass in GeV)      = '',$)')
c      read(5,*) tm
c      write(6,'(''mu (renorm. scale in GeV) = '',$)')
c      read(5,*) w
      tm=mt
      w=scale
*
******* Allowed range for t: *****
*
c      tmin = - stev/2.d0 * ( 1.d0 - Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
c      tmax = - stev/2.d0 * ( 1.d0 + Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
*
**********************************
*
c      write(6,'('' '')')
c      write(6,'(''t (in TeV^2) belongs to the range '')')
c      write(6,'(1pe22.5,'' < t < '',1pe22.5)')
c     $         tmax, tmin
c      write(6,'(''t (in TeV^2)              = '',$)')
c      read(5,*) ttev
*
c       if (ttev.le.tmax.OR.ttev.ge.tmin) then
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'(''           t is outside the range '')')
c       write(6,'(''###############################################'')')
c        stop
c       endif
*
c      write(6,'('' '')')
c      write(6,'(''# Choose the normalization factor:'')')
c      write(6,'(''# 0  ->  Exp[-EulerGamma*ep]'')')
c      write(6,'(''# 1  ->  Gamma[1+ep]'')')
c      read(5,*) rnorm
*
c      write(6,'('' '')')
c      write(6,'(''# The results will be also written in qqQQN.res'')')
c       write(6,'(''#'')')
c       write(6,'(''#'')')
c       open(3,FILE='qqQQ_NLO.res')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
c       write(3,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(3,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(3,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(3,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(3,'(''#'')')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
*
************************************************************************
* 
c        s = 1.d+6*stev
c	t = 1.d+6*ttev
*
c       CSoneepm2 = PoleEPm2(s,t,tm,w)
c       CSoneepm1 = PoleEPm1(s,t,tm,w) 
c     $             - DLog(tm**2/w**2)*PoleEPm2(s,t,tm,w)
       FinVirtT13qq  = T13PoleEP0qq(s,t,tm,w) 
c     $             + 1.d0/2.d0*DLog(tm**2/w**2)**2*PoleEPm2(s,t,tm,w)
c     $             - DLog(tm**2/w**2)*PoleEPm1(s,t,tm,w) 
ch       write(*,*)T13PoleEP0qq(s,t,tm,w)/T13PoleEP0qqc(s,t,tm,w),'a'

ch       write(*,*)T13PoleEPm2qq(s,t,tm,w),
ch     $    T13PoleEPm1qq(s,t,tm,w),'ccc'
*
* Normalization factor Exp[-EulerGamma*ep]:
*
c       CSoneepm2K = CSoneepm2
c       CSoneepm1K = CSoneepm1
c       CSoneep0K  = CSoneep0 + z2/2.d0*CSoneepm2
*
*
c       if (rnorm.eq.0) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
c       if (rnorm.eq.1) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
*
c15    continue
c       close(3)
      return
      end

      double precision function FinVirtT23qq(s,t)
      implicit none
      include 'scale.f'
      include 'masses.f'
      double precision en,w,tm,pi,hM,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,Nc,Nl,Nh,
     $                 stev,ttev,tmin,tmax,rnorm,
     $                 T13CSoneepm2qq,T13CSoneepm1qq,T13CSoneep0qq,
     $                 T13CSoneepm2Kqq,
     $                 T13CSoneepm1Kqq,T13CSoneep0Kqq,
     $                 T23PoleEPm2qq,T23PoleEPm1qq,T23PoleEP0qq
     $                 ,T13PoleEP0qqc
*
      Integer I
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
*
c      write(6,'('' '')')
c      write(6,'(''s (in TeV^2)              = '',$)')
c      read(5,*) stev
c      write(6,'(''mt (top mass in GeV)      = '',$)')
c      read(5,*) tm
c      write(6,'(''mu (renorm. scale in GeV) = '',$)')
c      read(5,*) w
      tm=mt
      w=scale
*
******* Allowed range for t: *****
*
c      tmin = - stev/2.d0 * ( 1.d0 - Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
c      tmax = - stev/2.d0 * ( 1.d0 + Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
*
**********************************
*
c      write(6,'('' '')')
c      write(6,'(''t (in TeV^2) belongs to the range '')')
c      write(6,'(1pe22.5,'' < t < '',1pe22.5)')
c     $         tmax, tmin
c      write(6,'(''t (in TeV^2)              = '',$)')
c      read(5,*) ttev
*
c       if (ttev.le.tmax.OR.ttev.ge.tmin) then
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'(''           t is outside the range '')')
c       write(6,'(''###############################################'')')
c        stop
c       endif
*
c      write(6,'('' '')')
c      write(6,'(''# Choose the normalization factor:'')')
c      write(6,'(''# 0  ->  Exp[-EulerGamma*ep]'')')
c      write(6,'(''# 1  ->  Gamma[1+ep]'')')
c      read(5,*) rnorm
*
c      write(6,'('' '')')
c      write(6,'(''# The results will be also written in qqQQN.res'')')
c       write(6,'(''#'')')
c       write(6,'(''#'')')
c       open(3,FILE='qqQQ_NLO.res')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
c       write(3,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(3,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(3,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(3,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(3,'(''#'')')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
*
************************************************************************
* 
c        s = 1.d+6*stev
c	t = 1.d+6*ttev
*
c       CSoneepm2 = PoleEPm2(s,t,tm,w)
c       CSoneepm1 = PoleEPm1(s,t,tm,w) 
c     $             - DLog(tm**2/w**2)*PoleEPm2(s,t,tm,w)
       FinVirtT23qq  = T23PoleEP0qq(s,t,tm,w) 
c     $             + 1.d0/2.d0*DLog(tm**2/w**2)**2*PoleEPm2(s,t,tm,w)
c     $             - DLog(tm**2/w**2)*PoleEPm1(s,t,tm,w) 
ch       write(*,*)T13PoleEP0qq(s,t,tm,w)/T13PoleEP0qqc(s,t,tm,w),'a'

ch       write(*,*)T23PoleEPm2qq(s,t,tm,w),
ch     $    T23PoleEPm1qq(s,t,tm,w),'ccc'
*
* Normalization factor Exp[-EulerGamma*ep]:
*
c       CSoneepm2K = CSoneepm2
c       CSoneepm1K = CSoneepm1
c       CSoneep0K  = CSoneep0 + z2/2.d0*CSoneepm2
*
*
c       if (rnorm.eq.0) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
c       if (rnorm.eq.1) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
*
c15    continue
c       close(3)
      return
      end


      double precision function FinVirtT34qq(s,t)
      implicit none
      include 'scale.f'
      include 'masses.f'
      double precision en,w,tm,pi,hM,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,Nc,Nl,Nh,
     $                 stev,ttev,tmin,tmax,rnorm,
     $                 T34CSoneepm2qq,T34CSoneepm1qq,T34CSoneep0qq,
     $                 T34CSoneepm2Kqq,
     $                 T34CSoneepm1Kqq,T34CSoneep0Kqq,
     $                 T34PoleEPm2qq,T34PoleEPm1qq,T34PoleEP0qq
*
      Integer I
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
*
c      write(6,'('' '')')
c      write(6,'(''s (in TeV^2)              = '',$)')
c      read(5,*) stev
c      write(6,'(''mt (top mass in GeV)      = '',$)')
c      read(5,*) tm
c      write(6,'(''mu (renorm. scale in GeV) = '',$)')
c      read(5,*) w
      tm=mt
      w=scale
*
******* Allowed range for t: *****
*
c      tmin = - stev/2.d0 * ( 1.d0 - Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
c      tmax = - stev/2.d0 * ( 1.d0 + Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
*
**********************************
*
c      write(6,'('' '')')
c      write(6,'(''t (in TeV^2) belongs to the range '')')
c      write(6,'(1pe22.5,'' < t < '',1pe22.5)')
c     $         tmax, tmin
c      write(6,'(''t (in TeV^2)              = '',$)')
c      read(5,*) ttev
*
c       if (ttev.le.tmax.OR.ttev.ge.tmin) then
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'(''           t is outside the range '')')
c       write(6,'(''###############################################'')')
c        stop
c       endif
*
c      write(6,'('' '')')
c      write(6,'(''# Choose the normalization factor:'')')
c      write(6,'(''# 0  ->  Exp[-EulerGamma*ep]'')')
c      write(6,'(''# 1  ->  Gamma[1+ep]'')')
c      read(5,*) rnorm
*
c      write(6,'('' '')')
c      write(6,'(''# The results will be also written in qqQQN.res'')')
c       write(6,'(''#'')')
c       write(6,'(''#'')')
c       open(3,FILE='qqQQ_NLO.res')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
c       write(3,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(3,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(3,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(3,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(3,'(''#'')')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
*
************************************************************************
* 
c        s = 1.d+6*stev
c	t = 1.d+6*ttev
*
c       CSoneepm2 = PoleEPm2(s,t,tm,w)
c       CSoneepm1 = PoleEPm1(s,t,tm,w) 
c     $             - DLog(tm**2/w**2)*PoleEPm2(s,t,tm,w)
       FinVirtT34qq  = T34PoleEP0qq(s,t,tm,w) 
c     $             + 1.d0/2.d0*DLog(tm**2/w**2)**2*PoleEPm2(s,t,tm,w)
c     $             - DLog(tm**2/w**2)*PoleEPm1(s,t,tm,w)
ch       write(*,*)T34PoleEPm2qq(s,t,tm,w),
ch     $    T34PoleEPm1qq(s,t,tm,w),'aaa' 
*
* Normalization factor Exp[-EulerGamma*ep]:
*
c       CSoneepm2K = CSoneepm2
c       CSoneepm1K = CSoneepm1
c       CSoneep0K  = CSoneep0 + z2/2.d0*CSoneepm2
*
*
c       if (rnorm.eq.0) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
c       if (rnorm.eq.1) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
*
c15    continue
c       close(3)
      return
      end 

      double precision function FinVirtT34gg(s,t)
      implicit none
      include 'scale.f'
      include 'masses.f'
      double precision en,w,tm,pi,hM,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,Nc,Nl,Nh,
     $                 stev,ttev,tmin,tmax,rnorm,
     $                 T34CSoneepm2qq,T34CSoneepm1qq,T34CSoneep0qq,
     $                 T34CSoneepm2Kqq,
     $                 T34CSoneepm1Kqq,T34CSoneep0Kqq,
     $                 T34PoleEPm2qq,T34PoleEPm1qq,PoleEP0T34
*
      Integer I
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
*
c      write(6,'('' '')')
c      write(6,'(''s (in TeV^2)              = '',$)')
c      read(5,*) stev
c      write(6,'(''mt (top mass in GeV)      = '',$)')
c      read(5,*) tm
c      write(6,'(''mu (renorm. scale in GeV) = '',$)')
c      read(5,*) w
      tm=mt
      w=scale
*
******* Allowed range for t: *****
*
c      tmin = - stev/2.d0 * ( 1.d0 - Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
c      tmax = - stev/2.d0 * ( 1.d0 + Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
*
**********************************
*
c      write(6,'('' '')')
c      write(6,'(''t (in TeV^2) belongs to the range '')')
c      write(6,'(1pe22.5,'' < t < '',1pe22.5)')
c     $         tmax, tmin
c      write(6,'(''t (in TeV^2)              = '',$)')
c      read(5,*) ttev
*
c       if (ttev.le.tmax.OR.ttev.ge.tmin) then
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'(''           t is outside the range '')')
c       write(6,'(''###############################################'')')
c        stop
c       endif
*
c      write(6,'('' '')')
c      write(6,'(''# Choose the normalization factor:'')')
c      write(6,'(''# 0  ->  Exp[-EulerGamma*ep]'')')
c      write(6,'(''# 1  ->  Gamma[1+ep]'')')
c      read(5,*) rnorm
*
c      write(6,'('' '')')
c      write(6,'(''# The results will be also written in qqQQN.res'')')
c       write(6,'(''#'')')
c       write(6,'(''#'')')
c       open(3,FILE='qqQQ_NLO.res')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
c       write(3,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(3,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(3,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(3,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(3,'(''#'')')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
*
************************************************************************
* 
c        s = 1.d+6*stev
c	t = 1.d+6*ttev
*
c       CSoneepm2 = PoleEPm2(s,t,tm,w)
c       CSoneepm1 = PoleEPm1(s,t,tm,w) 
c     $             - DLog(tm**2/w**2)*PoleEPm2(s,t,tm,w)
       FinVirtT34gg  = PoleEP0T34(s,t,tm,w) 
c     $             + 1.d0/2.d0*DLog(tm**2/w**2)**2*PoleEPm2(s,t,tm,w)
c     $             - DLog(tm**2/w**2)*PoleEPm1(s,t,tm,w)
ch       write(*,*)T34PoleEPm2qq(s,t,tm,w),
ch     $    T34PoleEPm1qq(s,t,tm,w),'aaa' 
*
* Normalization factor Exp[-EulerGamma*ep]:
*
c       CSoneepm2K = CSoneepm2
c       CSoneepm1K = CSoneepm1
c       CSoneep0K  = CSoneep0 + z2/2.d0*CSoneepm2
*
*
c       if (rnorm.eq.0) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
c       if (rnorm.eq.1) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
*
c15    continue
c       close(3)
      return
      end

      double precision function FinVirtT13gg(s,t)
      implicit none
      include 'scale.f'
      include 'masses.f'
      double precision en,w,tm,pi,hM,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,Nc,Nl,Nh,
     $                 stev,ttev,tmin,tmax,rnorm,
     $                 T34CSoneepm2qq,T34CSoneepm1qq,T34CSoneep0qq,
     $                 T34CSoneepm2Kqq,
     $                 T34CSoneepm1Kqq,T34CSoneep0Kqq,
     $                 T34PoleEPm2qq,T34PoleEPm1qq,PoleEP0T13
*
      Integer I
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
*
c      write(6,'('' '')')
c      write(6,'(''s (in TeV^2)              = '',$)')
c      read(5,*) stev
c      write(6,'(''mt (top mass in GeV)      = '',$)')
c      read(5,*) tm
c      write(6,'(''mu (renorm. scale in GeV) = '',$)')
c      read(5,*) w
      tm=mt
      w=scale
*
******* Allowed range for t: *****
*
c      tmin = - stev/2.d0 * ( 1.d0 - Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
c      tmax = - stev/2.d0 * ( 1.d0 + Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
*
**********************************
*
c      write(6,'('' '')')
c      write(6,'(''t (in TeV^2) belongs to the range '')')
c      write(6,'(1pe22.5,'' < t < '',1pe22.5)')
c     $         tmax, tmin
c      write(6,'(''t (in TeV^2)              = '',$)')
c      read(5,*) ttev
*
c       if (ttev.le.tmax.OR.ttev.ge.tmin) then
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'(''           t is outside the range '')')
c       write(6,'(''###############################################'')')
c        stop
c       endif
*
c      write(6,'('' '')')
c      write(6,'(''# Choose the normalization factor:'')')
c      write(6,'(''# 0  ->  Exp[-EulerGamma*ep]'')')
c      write(6,'(''# 1  ->  Gamma[1+ep]'')')
c      read(5,*) rnorm
*
c      write(6,'('' '')')
c      write(6,'(''# The results will be also written in qqQQN.res'')')
c       write(6,'(''#'')')
c       write(6,'(''#'')')
c       open(3,FILE='qqQQ_NLO.res')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
c       write(3,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(3,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(3,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(3,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(3,'(''#'')')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
*
************************************************************************
* 
c        s = 1.d+6*stev
c	t = 1.d+6*ttev
*
c       CSoneepm2 = PoleEPm2(s,t,tm,w)
c       CSoneepm1 = PoleEPm1(s,t,tm,w) 
c     $             - DLog(tm**2/w**2)*PoleEPm2(s,t,tm,w)
       FinVirtT13gg  = PoleEP0T13(s,t,tm,w) 
c     $             + 1.d0/2.d0*DLog(tm**2/w**2)**2*PoleEPm2(s,t,tm,w)
c     $             - DLog(tm**2/w**2)*PoleEPm1(s,t,tm,w)
ch       write(*,*)T34PoleEPm2qq(s,t,tm,w),
ch     $    T34PoleEPm1qq(s,t,tm,w),'aaa' 
*
* Normalization factor Exp[-EulerGamma*ep]:
*
c       CSoneepm2K = CSoneepm2
c       CSoneepm1K = CSoneepm1
c       CSoneep0K  = CSoneep0 + z2/2.d0*CSoneepm2
*
*
c       if (rnorm.eq.0) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
c       if (rnorm.eq.1) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
*
c15    continue
c       close(3)
      return
      end

      double precision function FinVirtT14gg(s,t)
      implicit none
      include 'scale.f'
      include 'masses.f'
      double precision en,w,tm,pi,hM,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,Nc,Nl,Nh,
     $                 stev,ttev,tmin,tmax,rnorm,
     $                 T34CSoneepm2qq,T34CSoneepm1qq,T34CSoneep0qq,
     $                 T34CSoneepm2Kqq,
     $                 T34CSoneepm1Kqq,T34CSoneep0Kqq,
     $                 T34PoleEPm2qq,T34PoleEPm1qq,PoleEP0T14
*
      Integer I
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
*
c      write(6,'('' '')')
c      write(6,'(''s (in TeV^2)              = '',$)')
c      read(5,*) stev
c      write(6,'(''mt (top mass in GeV)      = '',$)')
c      read(5,*) tm
c      write(6,'(''mu (renorm. scale in GeV) = '',$)')
c      read(5,*) w
      tm=mt
      w=scale
*
******* Allowed range for t: *****
*
c      tmin = - stev/2.d0 * ( 1.d0 - Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
c      tmax = - stev/2.d0 * ( 1.d0 + Dsqrt(1.d0-4.d-6*tm**2/stev) ) 
c     $       + 1.d-6*tm**2
*
**********************************
*
c      write(6,'('' '')')
c      write(6,'(''t (in TeV^2) belongs to the range '')')
c      write(6,'(1pe22.5,'' < t < '',1pe22.5)')
c     $         tmax, tmin
c      write(6,'(''t (in TeV^2)              = '',$)')
c      read(5,*) ttev
*
c       if (ttev.le.tmax.OR.ttev.ge.tmin) then
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'(''           t is outside the range '')')
c       write(6,'(''###############################################'')')
c        stop
c       endif
*
c      write(6,'('' '')')
c      write(6,'(''# Choose the normalization factor:'')')
c      write(6,'(''# 0  ->  Exp[-EulerGamma*ep]'')')
c      write(6,'(''# 1  ->  Gamma[1+ep]'')')
c      read(5,*) rnorm
*
c      write(6,'('' '')')
c      write(6,'(''# The results will be also written in qqQQN.res'')')
c       write(6,'(''#'')')
c       write(6,'(''#'')')
c       open(3,FILE='qqQQ_NLO.res')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
c       write(3,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(3,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(3,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(3,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(3,'(''#'')')
c       write(3,'(''###############################################'')')
c       write(3,'(''#'')')
*
************************************************************************
* 
c        s = 1.d+6*stev
c	t = 1.d+6*ttev
*
c       CSoneepm2 = PoleEPm2(s,t,tm,w)
c       CSoneepm1 = PoleEPm1(s,t,tm,w) 
c     $             - DLog(tm**2/w**2)*PoleEPm2(s,t,tm,w)
       FinVirtT14gg  = PoleEP0T14(s,t,tm,w) 
c     $             + 1.d0/2.d0*DLog(tm**2/w**2)**2*PoleEPm2(s,t,tm,w)
c     $             - DLog(tm**2/w**2)*PoleEPm1(s,t,tm,w)
ch       write(*,*)T34PoleEPm2qq(s,t,tm,w),
ch     $    T34PoleEPm1qq(s,t,tm,w),'aaa' 
*
* Normalization factor Exp[-EulerGamma*ep]:
*
c       CSoneepm2K = CSoneepm2
c       CSoneepm1K = CSoneepm1
c       CSoneep0K  = CSoneep0 + z2/2.d0*CSoneepm2
*
*
c       if (rnorm.eq.0) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Exp[-EulerGamma*ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2K
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1K
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0K
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
c       if (rnorm.eq.1) then
c       write(6,'(''###############################################'')')
c       write(6,'(''#'')')
c       write(6,'(''# s (in TeV^2)              = '',F22.9)') stev
c       write(6,'(''# t (in TeV^2)              = '',F22.9)') ttev
c       write(6,'(''# mt (top mass in GeV)      = '',F22.9)') tm
c       write(6,'(''# mu (renorm. scale in GeV) = '',F22.9)') w
c       write(6,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(6,'(''#'')')
c       write(6,'(''###############################################'')')
c       write(6,'('' '')')
c       write(6,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(6,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(6,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(6,'('' '')')
c       write(6,'(''###############################################'')')
*
*
c       write(3,'(''# Normalization factor  Gamma[1+ep]'')') 
c       write(3,'(''#'')') 
c       write(3,'('' '')')
c       write(3,'(''  |M|^2 = 1/ep^2*('',1pe22.8,'')'')') CSoneepm2
c       write(3,'(''        + 1/ep  *('',1pe22.8,'')'')') CSoneepm1
c       write(3,'(''        +        ('',1pe22.8,'')'')') CSoneep0
c       write(3,'('' '')')
c       write(3,'(''###############################################'')')
c       endif
*
*
c15    continue
c       close(3)
      return
      end


*
*
*
************************************************************************
************************************************************************
*
*             SUBROUTINES for HPLs
*
************************************************************************
c     removed here to avoid issues about usage of hplog,
c     which is already included as a separate file !!!





      
************************************************************************
************************************************************************
*
*          FUNCTIONS for the Cross Section
*
*************************************************************************
**************************** 72 characters *****************************
*
*
      double precision function PoleEPm2qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEPm2qq =  + Nc**(-1) * (
     &     - 4.D0
     &     - 8.D0*upx**(-4)
     &     + 16.D0*upx**(-3)
     &     - 8.D0*upx**(-2)
     &     - 16.D0*y*upx**(-4)
     &     + 32.D0*y*upx**(-3)
     &     - 24.D0*y*upx**(-2)
     &     + 8.D0*y*upx**(-1)
     &     - 8.D0*y**2*upx**(-4)
     &     + 16.D0*y**2*upx**(-3)
     &     - 8.D0*y**2*upx**(-2)
     &     )
      PoleEPm2qq = PoleEPm2qq + Nc * (
     &     + 8.D0
     &     + 16.D0*upx**(-4)
     &     - 32.D0*upx**(-3)
     &     + 16.D0*upx**(-2)
     &     + 32.D0*y*upx**(-4)
     &     - 64.D0*y*upx**(-3)
     &     + 48.D0*y*upx**(-2)
     &     - 16.D0*y*upx**(-1)
     &     + 16.D0*y**2*upx**(-4)
     &     - 32.D0*y**2*upx**(-3)
     &     + 16.D0*y**2*upx**(-2)
     &     )
      PoleEPm2qq = PoleEPm2qq + Nc**3 * (
     &     - 4.D0
     &     - 8.D0*upx**(-4)
     &     + 16.D0*upx**(-3)
     &     - 8.D0*upx**(-2)
     &     - 16.D0*y*upx**(-4)
     &     + 32.D0*y*upx**(-3)
     &     - 24.D0*y*upx**(-2)
     &     + 8.D0*y*upx**(-1)
     &     - 8.D0*y**2*upx**(-4)
     &     + 16.D0*y**2*upx**(-3)
     &     - 8.D0*y**2*upx**(-2)
     &     )
      return
      end
*
*
*
      double precision function PoleEPm1qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEPm1qq =  + Nc**(-1) * (
     &     - 6.D0
     &     - 20.D0*upx**(-4)
     &     + 40.D0*upx**(-3)
     &     - 20.D0*upx**(-2)
     &     - 40.D0*y*upx**(-4)
     &     + 80.D0*y*upx**(-3)
     &     - 60.D0*y*upx**(-2)
     &     + 20.D0*y*upx**(-1)
     &     - 20.D0*y**2*upx**(-4)
     &     + 40.D0*y**2*upx**(-3)
     &     - 20.D0*y**2*upx**(-2)
     &     )
      PoleEPm1qq = PoleEPm1qq + Nc * (
     &     + 12.D0
     &     + 40.D0*upx**(-4)
     &     - 80.D0*upx**(-3)
     &     + 40.D0*upx**(-2)
     &     + 80.D0*y*upx**(-4)
     &     - 160.D0*y*upx**(-3)
     &     + 120.D0*y*upx**(-2)
     &     - 40.D0*y*upx**(-1)
     &     + 40.D0*y**2*upx**(-4)
     &     - 80.D0*y**2*upx**(-3)
     &     + 40.D0*y**2*upx**(-2)
     &     )
      PoleEPm1qq = PoleEPm1qq + Nc**3 * (
     &     - 6.D0
     &     - 20.D0*upx**(-4)
     &     + 40.D0*upx**(-3)
     &     - 20.D0*upx**(-2)
     &     - 40.D0*y*upx**(-4)
     &     + 80.D0*y*upx**(-3)
     &     - 60.D0*y*upx**(-2)
     &     + 20.D0*y*upx**(-1)
     &     - 20.D0*y**2*upx**(-4)
     &     + 40.D0*y**2*upx**(-3)
     &     - 20.D0*y**2*upx**(-2)
     &     )
      PoleEPm1qq = PoleEPm1qq + Hr1(-1)*Nc**(-1) * (
     &     + 8.D0
     &     + 16.D0*upx**(-4)
     &     - 32.D0*upx**(-3)
     &     + 16.D0*upx**(-2)
     &     + 32.D0*y*upx**(-4)
     &     - 64.D0*y*upx**(-3)
     &     + 48.D0*y*upx**(-2)
     &     - 16.D0*y*upx**(-1)
     &     + 16.D0*y**2*upx**(-4)
     &     - 32.D0*y**2*upx**(-3)
     &     + 16.D0*y**2*upx**(-2)
     &     )
      PoleEPm1qq = PoleEPm1qq + Hr1(-1)*Nc * (
     &     - 8.D0
     &     - 16.D0*upx**(-4)
     &     + 32.D0*upx**(-3)
     &     - 16.D0*upx**(-2)
     &     - 32.D0*y*upx**(-4)
     &     + 64.D0*y*upx**(-3)
     &     - 48.D0*y*upx**(-2)
     &     + 16.D0*y*upx**(-1)
     &     - 16.D0*y**2*upx**(-4)
     &     + 32.D0*y**2*upx**(-3)
     &     - 16.D0*y**2*upx**(-2)
     &     )
      PoleEPm1qq = PoleEPm1qq + Hr1(0)*Nc**(-1) * (
     &     - 8.D0*upx**(-5)
     &     + 12.D0*upx**(-4)
     &     - 2.D0*upx**(-3)
     &     - upx**(-2)
     &     - 9.D0/2.D0*upx**(-1)
     &     - 9.D0/2.D0*umx**(-1)
     &     - 16.D0*y*upx**(-5)
     &     + 24.D0*y*upx**(-4)
     &     - 12.D0*y*upx**(-3)
     &     + 2.D0*y*upx**(-2)
     &     + y*upx**(-1)
     &     + y*umx**(-1)
     &     - 8.D0*y**2*upx**(-5)
     &     + 12.D0*y**2*upx**(-4)
     &     )
      PoleEPm1qq = PoleEPm1qq + Hr1(0)*Nc**(-1) * (
     &     - 2.D0*y**2*upx**(-3)
     &     - y**2*upx**(-2)
     &     - 1.D0/2.D0*y**2*upx**(-1)
     &     - 1.D0/2.D0*y**2*umx**(-1)
     &     )
      PoleEPm1qq = PoleEPm1qq + Hr1(0)*Nc * (
     &     + 8.D0*upx**(-5)
     &     - 12.D0*upx**(-4)
     &     + 2.D0*upx**(-3)
     &     + upx**(-2)
     &     + 9.D0/2.D0*upx**(-1)
     &     + 9.D0/2.D0*umx**(-1)
     &     + 16.D0*y*upx**(-5)
     &     - 24.D0*y*upx**(-4)
     &     + 12.D0*y*upx**(-3)
     &     - 2.D0*y*upx**(-2)
     &     - y*upx**(-1)
     &     - y*umx**(-1)
     &     + 8.D0*y**2*upx**(-5)
     &     - 12.D0*y**2*upx**(-4)
     &     )
      PoleEPm1qq = PoleEPm1qq + Hr1(0)*Nc * (
     &     + 2.D0*y**2*upx**(-3)
     &     + y**2*upx**(-2)
     &     + 1.D0/2.D0*y**2*upx**(-1)
     &     + 1.D0/2.D0*y**2*umx**(-1)
     &     )
      PoleEPm1qq = PoleEPm1qq + HAr1(-1)*Nc**(-1) * (
     &     + 16.D0
     &     + 32.D0*upx**(-4)
     &     - 64.D0*upx**(-3)
     &     + 32.D0*upx**(-2)
     &     + 64.D0*y*upx**(-4)
     &     - 128.D0*y*upx**(-3)
     &     + 96.D0*y*upx**(-2)
     &     - 32.D0*y*upx**(-1)
     &     + 32.D0*y**2*upx**(-4)
     &     - 64.D0*y**2*upx**(-3)
     &     + 32.D0*y**2*upx**(-2)
     &     )
      PoleEPm1qq = PoleEPm1qq + HAr1(-1)*Nc * (
     &     - 24.D0
     &     - 48.D0*upx**(-4)
     &     + 96.D0*upx**(-3)
     &     - 48.D0*upx**(-2)
     &     - 96.D0*y*upx**(-4)
     &     + 192.D0*y*upx**(-3)
     &     - 144.D0*y*upx**(-2)
     &     + 48.D0*y*upx**(-1)
     &     - 48.D0*y**2*upx**(-4)
     &     + 96.D0*y**2*upx**(-3)
     &     - 48.D0*y**2*upx**(-2)
     &     )
      PoleEPm1qq = PoleEPm1qq + HAr1(-1)*Nc**3 * (
     &     + 8.D0
     &     + 16.D0*upx**(-4)
     &     - 32.D0*upx**(-3)
     &     + 16.D0*upx**(-2)
     &     + 32.D0*y*upx**(-4)
     &     - 64.D0*y*upx**(-3)
     &     + 48.D0*y*upx**(-2)
     &     - 16.D0*y*upx**(-1)
     &     + 16.D0*y**2*upx**(-4)
     &     - 32.D0*y**2*upx**(-3)
     &     + 16.D0*y**2*upx**(-2)
     &     )
      PoleEPm1qq = PoleEPm1qq + HBr1(-1)*Nc**(-1) * (
     &     - 16.D0
     &     - 32.D0*upx**(-4)
     &     + 64.D0*upx**(-3)
     &     - 32.D0*upx**(-2)
     &     - 64.D0*y*upx**(-4)
     &     + 128.D0*y*upx**(-3)
     &     - 96.D0*y*upx**(-2)
     &     + 32.D0*y*upx**(-1)
     &     - 32.D0*y**2*upx**(-4)
     &     + 64.D0*y**2*upx**(-3)
     &     - 32.D0*y**2*upx**(-2)
     &     )
      PoleEPm1qq = PoleEPm1qq + HBr1(-1)*Nc * (
     &     + 16.D0
     &     + 32.D0*upx**(-4)
     &     - 64.D0*upx**(-3)
     &     + 32.D0*upx**(-2)
     &     + 64.D0*y*upx**(-4)
     &     - 128.D0*y*upx**(-3)
     &     + 96.D0*y*upx**(-2)
     &     - 32.D0*y*upx**(-1)
     &     + 32.D0*y**2*upx**(-4)
     &     - 64.D0*y**2*upx**(-3)
     &     + 32.D0*y**2*upx**(-2)
     &     )
      return
      end
*
*
*
      double precision function PoleEP0qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1d0

* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEP0qq =  + Nc**(-1) * (
     &     - 14.D0
     &     - 48.D0*upx**(-4)
     &     + 96.D0*upx**(-3)
     &     - 48.D0*upx**(-2)
     &     + 32.D0*z2*upx**(-5)
     &     - 48.D0*z2*upx**(-4)
     &     - 8.D0*z2*upx**(-3)
     &     + 12.D0*z2*upx**(-2)
     &     + 10.D0*z2*upx**(-1)
     &     + 16.D0*z2*umx**(-3)
     &     - 24.D0*z2*umx**(-2)
     &     + 26.D0*z2*umx**(-1)
     &     - 96.D0*y*upx**(-4)
     &     + 192.D0*y*upx**(-3)
     &     )
      PoleEP0qq = PoleEP0qq + Nc**(-1) * (
     &     - 144.D0*y*upx**(-2)
     &     + 48.D0*y*upx**(-1)
     &     + 64.D0*y*z2*upx**(-5)
     &     - 96.D0*y*z2*upx**(-4)
     &     + 32.D0*y*z2*upx**(-3)
     &     - 4.D0*y*z2*upx**(-1)
     &     - 16.D0*y*z2*umx**(-3)
     &     + 24.D0*y*z2*umx**(-2)
     &     - 4.D0*y*z2*umx**(-1)
     &     - 48.D0*y**2*upx**(-4)
     &     + 96.D0*y**2*upx**(-3)
     &     - 48.D0*y**2*upx**(-2)
     &     + 32.D0*y**2*z2*upx**(-5)
     &     - 48.D0*y**2*z2*upx**(-4)
     &     )
      PoleEP0qq = PoleEP0qq + Nc**(-1) * (
     &     + 8.D0*y**2*z2*upx**(-3)
     &     + 4.D0*y**2*z2*upx**(-2)
     &     + 2.D0*y**2*z2*upx**(-1)
     &     + 2.D0*y**2*z2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Nl * (
     &     + 40.D0/9.D0
     &     + 80.D0/9.D0*upx**(-4)
     &     - 160.D0/9.D0*upx**(-3)
     &     + 80.D0/9.D0*upx**(-2)
     &     + 160.D0/9.D0*y*upx**(-4)
     &     - 320.D0/9.D0*y*upx**(-3)
     &     + 80.D0/3.D0*y*upx**(-2)
     &     - 80.D0/9.D0*y*upx**(-1)
     &     + 80.D0/9.D0*y**2*upx**(-4)
     &     - 160.D0/9.D0*y**2*upx**(-3)
     &     + 80.D0/9.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Nh * (
     &     + 40.D0/9.D0
     &     - 64.D0/3.D0*upx**(-6)
     &     + 64.D0*upx**(-5)
     &     - 496.D0/9.D0*upx**(-4)
     &     + 32.D0/9.D0*upx**(-3)
     &     - 16.D0/9.D0*upx**(-2)
     &     + 32.D0/3.D0*upx**(-1)
     &     - 128.D0/3.D0*y*upx**(-6)
     &     + 128.D0*y*upx**(-5)
     &     - 1184.D0/9.D0*y*upx**(-4)
     &     + 448.D0/9.D0*y*upx**(-3)
     &     + 16.D0/3.D0*y*upx**(-2)
     &     - 80.D0/9.D0*y*upx**(-1)
     &     - 64.D0/3.D0*y**2*upx**(-6)
     &     )
      PoleEP0qq = PoleEP0qq + Nh * (
     &     + 64.D0*y**2*upx**(-5)
     &     - 496.D0/9.D0*y**2*upx**(-4)
     &     + 32.D0/9.D0*y**2*upx**(-3)
     &     + 80.D0/9.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Nc * (
     &     - 88.D0/9.D0
     &     + 256.D0/9.D0*upx**(-4)
     &     - 512.D0/9.D0*upx**(-3)
     &     + 238.D0/9.D0*upx**(-2)
     &     + 2.D0*upx**(-1)
     &     - 2.D0*umx**(-2)
     &     + 2.D0*umx**(-1)
     &     - 32.D0*z2*upx**(-5)
     &     + 40.D0*z2*upx**(-4)
     &     + 22.D0*z2*upx**(-3)
     &     - 17.D0*z2*upx**(-2)
     &     - 33.D0/4.D0*z2*upx**(-1)
     &     - 12.D0*z2*umx**(-5)
     &     + 30.D0*z2*umx**(-4)
     &     )
      PoleEP0qq = PoleEP0qq + Nc * (
     &     - 47.D0*z2*umx**(-3)
     &     + 81.D0/2.D0*z2*umx**(-2)
     &     - 145.D0/4.D0*z2*umx**(-1)
     &     + 512.D0/9.D0*y*upx**(-4)
     &     - 1024.D0/9.D0*y*upx**(-3)
     &     + 244.D0/3.D0*y*upx**(-2)
     &     - 220.D0/9.D0*y*upx**(-1)
     &     + 4.D0*y*umx**(-2)
     &     - 4.D0*y*umx**(-1)
     &     - 64.D0*y*z2*upx**(-5)
     &     + 80.D0*y*z2*upx**(-4)
     &     - 8.D0*y*z2*upx**(-3)
     &     - 8.D0*y*z2*upx**(-2)
     &     + 11.D0/2.D0*y*z2*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Nc * (
     &     + 24.D0*y*z2*umx**(-5)
     &     - 60.D0*y*z2*umx**(-4)
     &     + 70.D0*y*z2*umx**(-3)
     &     - 45.D0*y*z2*umx**(-2)
     &     + 11.D0/2.D0*y*z2*umx**(-1)
     &     + 256.D0/9.D0*y**2*upx**(-4)
     &     - 512.D0/9.D0*y**2*upx**(-3)
     &     + 238.D0/9.D0*y**2*upx**(-2)
     &     + 2.D0*y**2*upx**(-1)
     &     - 2.D0*y**2*umx**(-2)
     &     + 2.D0*y**2*umx**(-1)
     &     - 32.D0*y**2*z2*upx**(-5)
     &     + 40.D0*y**2*z2*upx**(-4)
     &     + 2.D0*y**2*z2*upx**(-3)
     &     )
      PoleEP0qq = PoleEP0qq + Nc * (
     &     - 3.D0*y**2*z2*upx**(-2)
     &     - 9.D0/4.D0*y**2*z2*upx**(-1)
     &     - 12.D0*y**2*z2*umx**(-5)
     &     + 30.D0*y**2*z2*umx**(-4)
     &     - 19.D0*y**2*z2*umx**(-3)
     &     - 3.D0/2.D0*y**2*z2*umx**(-2)
     &     - 9.D0/4.D0*y**2*z2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Nc**2*Nl * (
     &     - 40.D0/9.D0
     &     - 80.D0/9.D0*upx**(-4)
     &     + 160.D0/9.D0*upx**(-3)
     &     - 80.D0/9.D0*upx**(-2)
     &     - 160.D0/9.D0*y*upx**(-4)
     &     + 320.D0/9.D0*y*upx**(-3)
     &     - 80.D0/3.D0*y*upx**(-2)
     &     + 80.D0/9.D0*y*upx**(-1)
     &     - 80.D0/9.D0*y**2*upx**(-4)
     &     + 160.D0/9.D0*y**2*upx**(-3)
     &     - 80.D0/9.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Nc**2*Nh * (
     &     - 40.D0/9.D0
     &     + 64.D0/3.D0*upx**(-6)
     &     - 64.D0*upx**(-5)
     &     + 496.D0/9.D0*upx**(-4)
     &     - 32.D0/9.D0*upx**(-3)
     &     + 16.D0/9.D0*upx**(-2)
     &     - 32.D0/3.D0*upx**(-1)
     &     + 128.D0/3.D0*y*upx**(-6)
     &     - 128.D0*y*upx**(-5)
     &     + 1184.D0/9.D0*y*upx**(-4)
     &     - 448.D0/9.D0*y*upx**(-3)
     &     - 16.D0/3.D0*y*upx**(-2)
     &     + 80.D0/9.D0*y*upx**(-1)
     &     + 64.D0/3.D0*y**2*upx**(-6)
     &     )
      PoleEP0qq = PoleEP0qq + Nc**2*Nh * (
     &     - 64.D0*y**2*upx**(-5)
     &     + 496.D0/9.D0*y**2*upx**(-4)
     &     - 32.D0/9.D0*y**2*upx**(-3)
     &     - 80.D0/9.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Nc**3 * (
     &     + 214.D0/9.D0
     &     + 176.D0/9.D0*upx**(-4)
     &     - 352.D0/9.D0*upx**(-3)
     &     + 194.D0/9.D0*upx**(-2)
     &     - 2.D0*upx**(-1)
     &     + 2.D0*umx**(-2)
     &     - 2.D0*umx**(-1)
     &     + 8.D0*z2*upx**(-4)
     &     - 14.D0*z2*upx**(-3)
     &     + 5.D0*z2*upx**(-2)
     &     - 7.D0/4.D0*z2*upx**(-1)
     &     + 12.D0*z2*umx**(-5)
     &     - 30.D0*z2*umx**(-4)
     &     + 31.D0*z2*umx**(-3)
     &     )
      PoleEP0qq = PoleEP0qq + Nc**3 * (
     &     - 33.D0/2.D0*z2*umx**(-2)
     &     + 41.D0/4.D0*z2*umx**(-1)
     &     + 352.D0/9.D0*y*upx**(-4)
     &     - 704.D0/9.D0*y*upx**(-3)
     &     + 188.D0/3.D0*y*upx**(-2)
     &     - 212.D0/9.D0*y*upx**(-1)
     &     - 4.D0*y*umx**(-2)
     &     + 4.D0*y*umx**(-1)
     &     + 16.D0*y*z2*upx**(-4)
     &     - 24.D0*y*z2*upx**(-3)
     &     + 8.D0*y*z2*upx**(-2)
     &     - 3.D0/2.D0*y*z2*upx**(-1)
     &     - 24.D0*y*z2*umx**(-5)
     &     + 60.D0*y*z2*umx**(-4)
     &     )
      PoleEP0qq = PoleEP0qq + Nc**3 * (
     &     - 54.D0*y*z2*umx**(-3)
     &     + 21.D0*y*z2*umx**(-2)
     &     - 3.D0/2.D0*y*z2*umx**(-1)
     &     + 176.D0/9.D0*y**2*upx**(-4)
     &     - 352.D0/9.D0*y**2*upx**(-3)
     &     + 194.D0/9.D0*y**2*upx**(-2)
     &     - 2.D0*y**2*upx**(-1)
     &     + 2.D0*y**2*umx**(-2)
     &     - 2.D0*y**2*umx**(-1)
     &     + 8.D0*y**2*z2*upx**(-4)
     &     - 10.D0*y**2*z2*upx**(-3)
     &     - y**2*z2*upx**(-2)
     &     + 1.D0/4.D0*y**2*z2*upx**(-1)
     &     + 12.D0*y**2*z2*umx**(-5)
     &     )
      PoleEP0qq = PoleEP0qq + Nc**3 * (
     &     - 30.D0*y**2*z2*umx**(-4)
     &     + 19.D0*y**2*z2*umx**(-3)
     &     + 3.D0/2.D0*y**2*z2*umx**(-2)
     &     + 1.D0/4.D0*y**2*z2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + DLog(tm**(-2)*w**2)*Nl * (
     &     + 8.D0/3.D0
     &     + 16.D0/3.D0*upx**(-4)
     &     - 32.D0/3.D0*upx**(-3)
     &     + 16.D0/3.D0*upx**(-2)
     &     + 32.D0/3.D0*y*upx**(-4)
     &     - 64.D0/3.D0*y*upx**(-3)
     &     + 16.D0*y*upx**(-2)
     &     - 16.D0/3.D0*y*upx**(-1)
     &     + 16.D0/3.D0*y**2*upx**(-4)
     &     - 32.D0/3.D0*y**2*upx**(-3)
     &     + 16.D0/3.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + DLog(tm**(-2)*w**2)*Nc * (
     &     - 44.D0/3.D0
     &     - 88.D0/3.D0*upx**(-4)
     &     + 176.D0/3.D0*upx**(-3)
     &     - 88.D0/3.D0*upx**(-2)
     &     - 176.D0/3.D0*y*upx**(-4)
     &     + 352.D0/3.D0*y*upx**(-3)
     &     - 88.D0*y*upx**(-2)
     &     + 88.D0/3.D0*y*upx**(-1)
     &     - 88.D0/3.D0*y**2*upx**(-4)
     &     + 176.D0/3.D0*y**2*upx**(-3)
     &     - 88.D0/3.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + DLog(tm**(-2)*w**2)*Nc**2*Nl * (
     &     - 8.D0/3.D0
     &     - 16.D0/3.D0*upx**(-4)
     &     + 32.D0/3.D0*upx**(-3)
     &     - 16.D0/3.D0*upx**(-2)
     &     - 32.D0/3.D0*y*upx**(-4)
     &     + 64.D0/3.D0*y*upx**(-3)
     &     - 16.D0*y*upx**(-2)
     &     + 16.D0/3.D0*y*upx**(-1)
     &     - 16.D0/3.D0*y**2*upx**(-4)
     &     + 32.D0/3.D0*y**2*upx**(-3)
     &     - 16.D0/3.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + DLog(tm**(-2)*w**2)*Nc**3 * (
     &     + 44.D0/3.D0
     &     + 88.D0/3.D0*upx**(-4)
     &     - 176.D0/3.D0*upx**(-3)
     &     + 88.D0/3.D0*upx**(-2)
     &     + 176.D0/3.D0*y*upx**(-4)
     &     - 352.D0/3.D0*y*upx**(-3)
     &     + 88.D0*y*upx**(-2)
     &     - 88.D0/3.D0*y*upx**(-1)
     &     + 88.D0/3.D0*y**2*upx**(-4)
     &     - 176.D0/3.D0*y**2*upx**(-3)
     &     + 88.D0/3.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*Nc**(-1) * (
     &     - 12.D0
     &     + 24.D0*upx**(-4)
     &     - 48.D0*upx**(-3)
     &     + 24.D0*upx**(-2)
     &     - 32.D0*umx**(-2)
     &     + 32.D0*umx**(-1)
     &     + 48.D0*y*upx**(-4)
     &     - 96.D0*y*upx**(-3)
     &     + 72.D0*y*upx**(-2)
     &     - 24.D0*y*upx**(-1)
     &     + 32.D0*y*umx**(-2)
     &     - 32.D0*y*umx**(-1)
     &     + 24.D0*y**2*upx**(-4)
     &     - 48.D0*y**2*upx**(-3)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*Nc**(-1) * (
     &     + 24.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*Nl * (
     &     - 16.D0/3.D0
     &     - 32.D0/3.D0*upx**(-4)
     &     + 64.D0/3.D0*upx**(-3)
     &     - 32.D0/3.D0*upx**(-2)
     &     - 64.D0/3.D0*y*upx**(-4)
     &     + 128.D0/3.D0*y*upx**(-3)
     &     - 32.D0*y*upx**(-2)
     &     + 32.D0/3.D0*y*upx**(-1)
     &     - 32.D0/3.D0*y**2*upx**(-4)
     &     + 64.D0/3.D0*y**2*upx**(-3)
     &     - 32.D0/3.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*Nc * (
     &     + 76.D0/3.D0
     &     - 16.D0/3.D0*upx**(-4)
     &     + 32.D0/3.D0*upx**(-3)
     &     - 40.D0/3.D0*upx**(-2)
     &     + 8.D0*upx**(-1)
     &     + 24.D0*umx**(-4)
     &     - 48.D0*umx**(-3)
     &     + 72.D0*umx**(-2)
     &     - 48.D0*umx**(-1)
     &     - 32.D0/3.D0*y*upx**(-4)
     &     + 64.D0/3.D0*y*upx**(-3)
     &     - 32.D0*y*upx**(-2)
     &     + 64.D0/3.D0*y*upx**(-1)
     &     - 48.D0*y*umx**(-4)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*Nc * (
     &     + 96.D0*y*umx**(-3)
     &     - 96.D0*y*umx**(-2)
     &     + 48.D0*y*umx**(-1)
     &     - 16.D0/3.D0*y**2*upx**(-4)
     &     + 32.D0/3.D0*y**2*upx**(-3)
     &     - 40.D0/3.D0*y**2*upx**(-2)
     &     + 8.D0*y**2*upx**(-1)
     &     + 24.D0*y**2*umx**(-4)
     &     - 48.D0*y**2*umx**(-3)
     &     + 16.D0*y**2*umx**(-2)
     &     + 8.D0*y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*Nc**2*Nl * (
     &     + 16.D0/3.D0
     &     + 32.D0/3.D0*upx**(-4)
     &     - 64.D0/3.D0*upx**(-3)
     &     + 32.D0/3.D0*upx**(-2)
     &     + 64.D0/3.D0*y*upx**(-4)
     &     - 128.D0/3.D0*y*upx**(-3)
     &     + 32.D0*y*upx**(-2)
     &     - 32.D0/3.D0*y*upx**(-1)
     &     + 32.D0/3.D0*y**2*upx**(-4)
     &     - 64.D0/3.D0*y**2*upx**(-3)
     &     + 32.D0/3.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*Nc**3 * (
     &     - 40.D0/3.D0
     &     - 56.D0/3.D0*upx**(-4)
     &     + 112.D0/3.D0*upx**(-3)
     &     - 32.D0/3.D0*upx**(-2)
     &     - 8.D0*upx**(-1)
     &     - 24.D0*umx**(-4)
     &     + 48.D0*umx**(-3)
     &     - 40.D0*umx**(-2)
     &     + 16.D0*umx**(-1)
     &     - 112.D0/3.D0*y*upx**(-4)
     &     + 224.D0/3.D0*y*upx**(-3)
     &     - 40.D0*y*upx**(-2)
     &     + 8.D0/3.D0*y*upx**(-1)
     &     + 48.D0*y*umx**(-4)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*Nc**3 * (
     &     - 96.D0*y*umx**(-3)
     &     + 64.D0*y*umx**(-2)
     &     - 16.D0*y*umx**(-1)
     &     - 56.D0/3.D0*y**2*upx**(-4)
     &     + 112.D0/3.D0*y**2*upx**(-3)
     &     - 32.D0/3.D0*y**2*upx**(-2)
     &     - 8.D0*y**2*upx**(-1)
     &     - 24.D0*y**2*umx**(-4)
     &     + 48.D0*y**2*umx**(-3)
     &     - 16.D0*y**2*umx**(-2)
     &     - 8.D0*y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*HAr1(-1)*Nc**(-1) * (
     &     - 16.D0
     &     - 64.D0*upx**(-4)
     &     + 128.D0*upx**(-3)
     &     - 64.D0*upx**(-2)
     &     - 128.D0*y*upx**(-4)
     &     + 256.D0*y*upx**(-3)
     &     - 160.D0*y*upx**(-2)
     &     + 32.D0*y*upx**(-1)
     &     - 64.D0*y**2*upx**(-4)
     &     + 128.D0*y**2*upx**(-3)
     &     - 64.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*HAr1(-1)*Nc * (
     &     + 24.D0
     &     + 96.D0*upx**(-4)
     &     - 192.D0*upx**(-3)
     &     + 96.D0*upx**(-2)
     &     + 192.D0*y*upx**(-4)
     &     - 384.D0*y*upx**(-3)
     &     + 240.D0*y*upx**(-2)
     &     - 48.D0*y*upx**(-1)
     &     + 96.D0*y**2*upx**(-4)
     &     - 192.D0*y**2*upx**(-3)
     &     + 96.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*HAr1(-1)*Nc**3 * (
     &     - 8.D0
     &     - 32.D0*upx**(-4)
     &     + 64.D0*upx**(-3)
     &     - 32.D0*upx**(-2)
     &     - 64.D0*y*upx**(-4)
     &     + 128.D0*y*upx**(-3)
     &     - 80.D0*y*upx**(-2)
     &     + 16.D0*y*upx**(-1)
     &     - 32.D0*y**2*upx**(-4)
     &     + 64.D0*y**2*upx**(-3)
     &     - 32.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*HBr1(-1)*Nc**(-1) * (
     &     + 48.D0
     &     + 64.D0*upx**(-4)
     &     - 128.D0*upx**(-3)
     &     + 128.D0*upx**(-2)
     &     - 64.D0*upx**(-1)
     &     + 128.D0*y*upx**(-4)
     &     - 256.D0*y*upx**(-3)
     &     + 224.D0*y*upx**(-2)
     &     - 96.D0*y*upx**(-1)
     &     + 64.D0*y**2*upx**(-4)
     &     - 128.D0*y**2*upx**(-3)
     &     + 64.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(-1)*HBr1(-1)*Nc * (
     &     - 48.D0
     &     - 64.D0*upx**(-4)
     &     + 128.D0*upx**(-3)
     &     - 128.D0*upx**(-2)
     &     + 64.D0*upx**(-1)
     &     - 128.D0*y*upx**(-4)
     &     + 256.D0*y*upx**(-3)
     &     - 224.D0*y*upx**(-2)
     &     + 96.D0*y*upx**(-1)
     &     - 64.D0*y**2*upx**(-4)
     &     + 128.D0*y**2*upx**(-3)
     &     - 64.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nc**(-1) * (
     &     + 8.D0
     &     - 16.D0*upx**(-5)
     &     + 28.D0*upx**(-4)
     &     - 10.D0*upx**(-3)
     &     - upx**(-2)
     &     - 17.D0/2.D0*upx**(-1)
     &     + 16.D0*umx**(-2)
     &     - 25.D0/2.D0*umx**(-1)
     &     - 32.D0*y*upx**(-5)
     &     + 56.D0*y*upx**(-4)
     &     - 36.D0*y*upx**(-3)
     &     + 10.D0*y*upx**(-2)
     &     + y*upx**(-1)
     &     - 16.D0*y*umx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nc**(-1) * (
     &     + 17.D0*y*umx**(-1)
     &     - 16.D0*y**2*upx**(-5)
     &     + 28.D0*y**2*upx**(-4)
     &     - 10.D0*y**2*upx**(-3)
     &     - y**2*upx**(-2)
     &     - 1.D0/2.D0*y**2*upx**(-1)
     &     - 1.D0/2.D0*y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nl * (
     &     + 8.D0/3.D0
     &     + 16.D0/3.D0*upx**(-4)
     &     - 32.D0/3.D0*upx**(-3)
     &     + 16.D0/3.D0*upx**(-2)
     &     + 32.D0/3.D0*y*upx**(-4)
     &     - 64.D0/3.D0*y*upx**(-3)
     &     + 16.D0*y*upx**(-2)
     &     - 16.D0/3.D0*y*upx**(-1)
     &     + 16.D0/3.D0*y**2*upx**(-4)
     &     - 32.D0/3.D0*y**2*upx**(-3)
     &     + 16.D0/3.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nh * (
     &     - 8.D0/3.D0
     &     - 64.D0/3.D0*upx**(-7)
     &     + 224.D0/3.D0*upx**(-6)
     &     - 256.D0/3.D0*upx**(-5)
     &     + 80.D0/3.D0*upx**(-4)
     &     + 32.D0/3.D0*upx**(-2)
     &     - 128.D0/3.D0*y*upx**(-7)
     &     + 448.D0/3.D0*y*upx**(-6)
     &     - 192.D0*y*upx**(-5)
     &     + 320.D0/3.D0*y*upx**(-4)
     &     - 32.D0/3.D0*y*upx**(-3)
     &     - 16.D0*y*upx**(-2)
     &     + 16.D0/3.D0*y*upx**(-1)
     &     - 64.D0/3.D0*y**2*upx**(-7)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nh * (
     &     + 224.D0/3.D0*y**2*upx**(-6)
     &     - 256.D0/3.D0*y**2*upx**(-5)
     &     + 80.D0/3.D0*y**2*upx**(-4)
     &     + 32.D0/3.D0*y**2*upx**(-3)
     &     - 16.D0/3.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nc * (
     &     - 44.D0/3.D0
     &     + 16.D0*upx**(-5)
     &     - 112.D0/3.D0*upx**(-4)
     &     + 86.D0/3.D0*upx**(-3)
     &     - 13.D0/3.D0*upx**(-2)
     &     + 9.D0/2.D0*upx**(-1)
     &     - 12.D0*umx**(-4)
     &     + 24.D0*umx**(-3)
     &     - 36.D0*umx**(-2)
     &     + 41.D0/2.D0*umx**(-1)
     &     + 32.D0*y*upx**(-5)
     &     - 224.D0/3.D0*y*upx**(-4)
     &     + 220.D0/3.D0*y*upx**(-3)
     &     - 30.D0*y*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nc * (
     &     + 1.D0/3.D0*y*upx**(-1)
     &     + 24.D0*y*umx**(-4)
     &     - 48.D0*y*umx**(-3)
     &     + 48.D0*y*umx**(-2)
     &     - 25.D0*y*umx**(-1)
     &     + 16.D0*y**2*upx**(-5)
     &     - 112.D0/3.D0*y**2*upx**(-4)
     &     + 86.D0/3.D0*y**2*upx**(-3)
     &     - 13.D0/3.D0*y**2*upx**(-2)
     &     - 7.D0/2.D0*y**2*upx**(-1)
     &     - 12.D0*y**2*umx**(-4)
     &     + 24.D0*y**2*umx**(-3)
     &     - 8.D0*y**2*umx**(-2)
     &     - 7.D0/2.D0*y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nc**2*Nl * (
     &     - 8.D0/3.D0
     &     - 16.D0/3.D0*upx**(-4)
     &     + 32.D0/3.D0*upx**(-3)
     &     - 16.D0/3.D0*upx**(-2)
     &     - 32.D0/3.D0*y*upx**(-4)
     &     + 64.D0/3.D0*y*upx**(-3)
     &     - 16.D0*y*upx**(-2)
     &     + 16.D0/3.D0*y*upx**(-1)
     &     - 16.D0/3.D0*y**2*upx**(-4)
     &     + 32.D0/3.D0*y**2*upx**(-3)
     &     - 16.D0/3.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nc**2*Nh * (
     &     + 8.D0/3.D0
     &     + 64.D0/3.D0*upx**(-7)
     &     - 224.D0/3.D0*upx**(-6)
     &     + 256.D0/3.D0*upx**(-5)
     &     - 80.D0/3.D0*upx**(-4)
     &     - 32.D0/3.D0*upx**(-2)
     &     + 128.D0/3.D0*y*upx**(-7)
     &     - 448.D0/3.D0*y*upx**(-6)
     &     + 192.D0*y*upx**(-5)
     &     - 320.D0/3.D0*y*upx**(-4)
     &     + 32.D0/3.D0*y*upx**(-3)
     &     + 16.D0*y*upx**(-2)
     &     - 16.D0/3.D0*y*upx**(-1)
     &     + 64.D0/3.D0*y**2*upx**(-7)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nc**2*Nh * (
     &     - 224.D0/3.D0*y**2*upx**(-6)
     &     + 256.D0/3.D0*y**2*upx**(-5)
     &     - 80.D0/3.D0*y**2*upx**(-4)
     &     - 32.D0/3.D0*y**2*upx**(-3)
     &     + 16.D0/3.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nc**3 * (
     &     + 20.D0/3.D0
     &     + 28.D0/3.D0*upx**(-4)
     &     - 56.D0/3.D0*upx**(-3)
     &     + 16.D0/3.D0*upx**(-2)
     &     + 4.D0*upx**(-1)
     &     + 12.D0*umx**(-4)
     &     - 24.D0*umx**(-3)
     &     + 20.D0*umx**(-2)
     &     - 8.D0*umx**(-1)
     &     + 56.D0/3.D0*y*upx**(-4)
     &     - 112.D0/3.D0*y*upx**(-3)
     &     + 20.D0*y*upx**(-2)
     &     - 4.D0/3.D0*y*upx**(-1)
     &     - 24.D0*y*umx**(-4)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*Nc**3 * (
     &     + 48.D0*y*umx**(-3)
     &     - 32.D0*y*umx**(-2)
     &     + 8.D0*y*umx**(-1)
     &     + 28.D0/3.D0*y**2*upx**(-4)
     &     - 56.D0/3.D0*y**2*upx**(-3)
     &     + 16.D0/3.D0*y**2*upx**(-2)
     &     + 4.D0*y**2*upx**(-1)
     &     + 12.D0*y**2*umx**(-4)
     &     - 24.D0*y**2*umx**(-3)
     &     + 8.D0*y**2*umx**(-2)
     &     + 4.D0*y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*HAr1(-1)*Nc**(-1) * (
     &     + 8.D0
     &     + 32.D0*upx**(-4)
     &     - 64.D0*upx**(-3)
     &     + 32.D0*upx**(-2)
     &     + 64.D0*y*upx**(-4)
     &     - 128.D0*y*upx**(-3)
     &     + 80.D0*y*upx**(-2)
     &     - 16.D0*y*upx**(-1)
     &     + 32.D0*y**2*upx**(-4)
     &     - 64.D0*y**2*upx**(-3)
     &     + 32.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*HAr1(-1)*Nc * (
     &     - 12.D0
     &     - 48.D0*upx**(-4)
     &     + 96.D0*upx**(-3)
     &     - 48.D0*upx**(-2)
     &     - 96.D0*y*upx**(-4)
     &     + 192.D0*y*upx**(-3)
     &     - 120.D0*y*upx**(-2)
     &     + 24.D0*y*upx**(-1)
     &     - 48.D0*y**2*upx**(-4)
     &     + 96.D0*y**2*upx**(-3)
     &     - 48.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*HAr1(-1)*Nc**3 * (
     &     + 4.D0
     &     + 16.D0*upx**(-4)
     &     - 32.D0*upx**(-3)
     &     + 16.D0*upx**(-2)
     &     + 32.D0*y*upx**(-4)
     &     - 64.D0*y*upx**(-3)
     &     + 40.D0*y*upx**(-2)
     &     - 8.D0*y*upx**(-1)
     &     + 16.D0*y**2*upx**(-4)
     &     - 32.D0*y**2*upx**(-3)
     &     + 16.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*HBr1(-1)*Nc**(-1) * (
     &     - 24.D0
     &     - 32.D0*upx**(-4)
     &     + 64.D0*upx**(-3)
     &     - 64.D0*upx**(-2)
     &     + 32.D0*upx**(-1)
     &     - 64.D0*y*upx**(-4)
     &     + 128.D0*y*upx**(-3)
     &     - 112.D0*y*upx**(-2)
     &     + 48.D0*y*upx**(-1)
     &     - 32.D0*y**2*upx**(-4)
     &     + 64.D0*y**2*upx**(-3)
     &     - 32.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr1(0)*HBr1(-1)*Nc * (
     &     + 24.D0
     &     + 32.D0*upx**(-4)
     &     - 64.D0*upx**(-3)
     &     + 64.D0*upx**(-2)
     &     - 32.D0*upx**(-1)
     &     + 64.D0*y*upx**(-4)
     &     - 128.D0*y*upx**(-3)
     &     + 112.D0*y*upx**(-2)
     &     - 48.D0*y*upx**(-1)
     &     + 32.D0*y**2*upx**(-4)
     &     - 64.D0*y**2*upx**(-3)
     &     + 32.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(-1,-1)*Nc**(-1) * (
     &     - 48.D0
     &     - 32.D0*upx**(-4)
     &     + 64.D0*upx**(-3)
     &     - 96.D0*upx**(-2)
     &     + 64.D0*upx**(-1)
     &     - 64.D0*y*upx**(-4)
     &     + 128.D0*y*upx**(-3)
     &     - 160.D0*y*upx**(-2)
     &     + 96.D0*y*upx**(-1)
     &     - 32.D0*y**2*upx**(-4)
     &     + 64.D0*y**2*upx**(-3)
     &     - 32.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(-1,-1)*Nc * (
     &     + 40.D0
     &     + 64.D0*upx**(-2)
     &     - 64.D0*upx**(-1)
     &     + 80.D0*y*upx**(-2)
     &     - 80.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(-1,-1)*Nc**3 * (
     &     + 8.D0
     &     + 32.D0*upx**(-4)
     &     - 64.D0*upx**(-3)
     &     + 32.D0*upx**(-2)
     &     + 64.D0*y*upx**(-4)
     &     - 128.D0*y*upx**(-3)
     &     + 80.D0*y*upx**(-2)
     &     - 16.D0*y*upx**(-1)
     &     + 32.D0*y**2*upx**(-4)
     &     - 64.D0*y**2*upx**(-3)
     &     + 32.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(-1,0)*Nc**(-1) * (
     &     + 24.D0
     &     + 16.D0*upx**(-4)
     &     - 32.D0*upx**(-3)
     &     + 48.D0*upx**(-2)
     &     - 32.D0*upx**(-1)
     &     + 32.D0*y*upx**(-4)
     &     - 64.D0*y*upx**(-3)
     &     + 80.D0*y*upx**(-2)
     &     - 48.D0*y*upx**(-1)
     &     + 16.D0*y**2*upx**(-4)
     &     - 32.D0*y**2*upx**(-3)
     &     + 16.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(-1,0)*Nc * (
     &     - 20.D0
     &     - 32.D0*upx**(-2)
     &     + 32.D0*upx**(-1)
     &     - 40.D0*y*upx**(-2)
     &     + 40.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(-1,0)*Nc**3 * (
     &     - 4.D0
     &     - 16.D0*upx**(-4)
     &     + 32.D0*upx**(-3)
     &     - 16.D0*upx**(-2)
     &     - 32.D0*y*upx**(-4)
     &     + 64.D0*y*upx**(-3)
     &     - 40.D0*y*upx**(-2)
     &     + 8.D0*y*upx**(-1)
     &     - 16.D0*y**2*upx**(-4)
     &     + 32.D0*y**2*upx**(-3)
     &     - 16.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,-1)*Nc**(-1) * (
     &     + 8.D0
     &     + 16.D0*upx**(-4)
     &     + 16.D0*upx**(-1)
     &     - 32.D0*umx**(-3)
     &     + 48.D0*umx**(-2)
     &     - 16.D0*umx**(-1)
     &     + 32.D0*y*upx**(-4)
     &     - 32.D0*y*upx**(-3)
     &     + 32.D0*y*upx**(-2)
     &     - 16.D0*y*upx**(-1)
     &     + 32.D0*y*umx**(-3)
     &     - 48.D0*y*umx**(-2)
     &     + 16.D0*y**2*upx**(-4)
     &     - 32.D0*y**2*upx**(-3)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,-1)*Nc**(-1) * (
     &     + 16.D0*y**2*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,-1)*Nc * (
     &     - 8.D0
     &     - 28.D0*upx**(-3)
     &     + 10.D0*upx**(-2)
     &     - 39.D0/2.D0*upx**(-1)
     &     + 24.D0*umx**(-5)
     &     - 60.D0*umx**(-4)
     &     + 94.D0*umx**(-3)
     &     - 81.D0*umx**(-2)
     &     + 73.D0/2.D0*umx**(-1)
     &     - 16.D0*y*upx**(-3)
     &     - 16.D0*y*upx**(-2)
     &     + 13.D0*y*upx**(-1)
     &     - 48.D0*y*umx**(-5)
     &     + 120.D0*y*umx**(-4)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,-1)*Nc * (
     &     - 140.D0*y*umx**(-3)
     &     + 90.D0*y*umx**(-2)
     &     - 3.D0*y*umx**(-1)
     &     + 12.D0*y**2*upx**(-3)
     &     - 18.D0*y**2*upx**(-2)
     &     + 1.D0/2.D0*y**2*upx**(-1)
     &     + 24.D0*y**2*umx**(-5)
     &     - 60.D0*y**2*umx**(-4)
     &     + 38.D0*y**2*umx**(-3)
     &     + 3.D0*y**2*umx**(-2)
     &     + 1.D0/2.D0*y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,-1)*Nc**3 * (
     &     - 16.D0*upx**(-4)
     &     + 28.D0*upx**(-3)
     &     - 10.D0*upx**(-2)
     &     + 7.D0/2.D0*upx**(-1)
     &     - 24.D0*umx**(-5)
     &     + 60.D0*umx**(-4)
     &     - 62.D0*umx**(-3)
     &     + 33.D0*umx**(-2)
     &     - 41.D0/2.D0*umx**(-1)
     &     - 32.D0*y*upx**(-4)
     &     + 48.D0*y*upx**(-3)
     &     - 16.D0*y*upx**(-2)
     &     + 3.D0*y*upx**(-1)
     &     + 48.D0*y*umx**(-5)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,-1)*Nc**3 * (
     &     - 120.D0*y*umx**(-4)
     &     + 108.D0*y*umx**(-3)
     &     - 42.D0*y*umx**(-2)
     &     + 3.D0*y*umx**(-1)
     &     - 16.D0*y**2*upx**(-4)
     &     + 20.D0*y**2*upx**(-3)
     &     + 2.D0*y**2*upx**(-2)
     &     - 1.D0/2.D0*y**2*upx**(-1)
     &     - 24.D0*y**2*umx**(-5)
     &     + 60.D0*y**2*umx**(-4)
     &     - 38.D0*y**2*umx**(-3)
     &     - 3.D0*y**2*umx**(-2)
     &     - 1.D0/2.D0*y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,0)*Nc**(-1) * (
     &     - 8.D0*upx**(-5)
     &     + 12.D0*upx**(-4)
     &     - 18.D0*upx**(-3)
     &     + 7.D0*upx**(-2)
     &     - 25.D0/2.D0*upx**(-1)
     &     + 16.D0*umx**(-3)
     &     - 24.D0*umx**(-2)
     &     + 7.D0/2.D0*umx**(-1)
     &     - 16.D0*y*upx**(-5)
     &     + 24.D0*y*upx**(-4)
     &     - 28.D0*y*upx**(-3)
     &     + 10.D0*y*upx**(-2)
     &     + y*upx**(-1)
     &     - 16.D0*y*umx**(-3)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,0)*Nc**(-1) * (
     &     + 24.D0*y*umx**(-2)
     &     + y*umx**(-1)
     &     - 8.D0*y**2*upx**(-5)
     &     + 12.D0*y**2*upx**(-4)
     &     - 2.D0*y**2*upx**(-3)
     &     - y**2*upx**(-2)
     &     - 1.D0/2.D0*y**2*upx**(-1)
     &     - 1.D0/2.D0*y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,0)*Nc * (
     &     + 8.D0*upx**(-5)
     &     - 20.D0*upx**(-4)
     &     + 32.D0*upx**(-3)
     &     - 12.D0*upx**(-2)
     &     + 57.D0/4.D0*upx**(-1)
     &     - 12.D0*umx**(-5)
     &     + 30.D0*umx**(-4)
     &     - 47.D0*umx**(-3)
     &     + 81.D0/2.D0*umx**(-2)
     &     - 55.D0/4.D0*umx**(-1)
     &     + 16.D0*y*upx**(-5)
     &     - 40.D0*y*upx**(-4)
     &     + 52.D0*y*upx**(-3)
     &     - 18.D0*y*upx**(-2)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,0)*Nc * (
     &     + 1.D0/2.D0*y*upx**(-1)
     &     + 24.D0*y*umx**(-5)
     &     - 60.D0*y*umx**(-4)
     &     + 70.D0*y*umx**(-3)
     &     - 45.D0*y*umx**(-2)
     &     + 1.D0/2.D0*y*umx**(-1)
     &     + 8.D0*y**2*upx**(-5)
     &     - 20.D0*y**2*upx**(-4)
     &     + 12.D0*y**2*upx**(-3)
     &     + 2.D0*y**2*upx**(-2)
     &     + 1.D0/4.D0*y**2*upx**(-1)
     &     - 12.D0*y**2*umx**(-5)
     &     + 30.D0*y**2*umx**(-4)
     &     - 19.D0*y**2*umx**(-3)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,0)*Nc * (
     &     - 3.D0/2.D0*y**2*umx**(-2)
     &     + 1.D0/4.D0*y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,0)*Nc**3 * (
     &     + 8.D0*upx**(-4)
     &     - 14.D0*upx**(-3)
     &     + 5.D0*upx**(-2)
     &     - 7.D0/4.D0*upx**(-1)
     &     + 12.D0*umx**(-5)
     &     - 30.D0*umx**(-4)
     &     + 31.D0*umx**(-3)
     &     - 33.D0/2.D0*umx**(-2)
     &     + 41.D0/4.D0*umx**(-1)
     &     + 16.D0*y*upx**(-4)
     &     - 24.D0*y*upx**(-3)
     &     + 8.D0*y*upx**(-2)
     &     - 3.D0/2.D0*y*upx**(-1)
     &     - 24.D0*y*umx**(-5)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(0,0)*Nc**3 * (
     &     + 60.D0*y*umx**(-4)
     &     - 54.D0*y*umx**(-3)
     &     + 21.D0*y*umx**(-2)
     &     - 3.D0/2.D0*y*umx**(-1)
     &     + 8.D0*y**2*upx**(-4)
     &     - 10.D0*y**2*upx**(-3)
     &     - y**2*upx**(-2)
     &     + 1.D0/4.D0*y**2*upx**(-1)
     &     + 12.D0*y**2*umx**(-5)
     &     - 30.D0*y**2*umx**(-4)
     &     + 19.D0*y**2*umx**(-3)
     &     + 3.D0/2.D0*y**2*umx**(-2)
     &     + 1.D0/4.D0*y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(1,0)*Nc**(-1) * (
     &     + 8.D0
     &     - 16.D0*upx**(-5)
     &     + 40.D0*upx**(-4)
     &     - 36.D0*upx**(-3)
     &     + 14.D0*upx**(-2)
     &     - 9.D0*upx**(-1)
     &     - 9.D0*umx**(-1)
     &     - 32.D0*y*upx**(-5)
     &     + 80.D0*y*upx**(-4)
     &     - 88.D0*y*upx**(-3)
     &     + 52.D0*y*upx**(-2)
     &     - 14.D0*y*upx**(-1)
     &     + 2.D0*y*umx**(-1)
     &     - 16.D0*y**2*upx**(-5)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(1,0)*Nc**(-1) * (
     &     + 40.D0*y**2*upx**(-4)
     &     - 36.D0*y**2*upx**(-3)
     &     + 14.D0*y**2*upx**(-2)
     &     - y**2*upx**(-1)
     &     - y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(1,0)*Nc * (
     &     - 8.D0
     &     + 16.D0*upx**(-5)
     &     - 40.D0*upx**(-4)
     &     + 36.D0*upx**(-3)
     &     - 14.D0*upx**(-2)
     &     + 9.D0*upx**(-1)
     &     + 9.D0*umx**(-1)
     &     + 32.D0*y*upx**(-5)
     &     - 80.D0*y*upx**(-4)
     &     + 88.D0*y*upx**(-3)
     &     - 52.D0*y*upx**(-2)
     &     + 14.D0*y*upx**(-1)
     &     - 2.D0*y*umx**(-1)
     &     + 16.D0*y**2*upx**(-5)
     &     )
      PoleEP0qq = PoleEP0qq + Hr2(1,0)*Nc * (
     &     - 40.D0*y**2*upx**(-4)
     &     + 36.D0*y**2*upx**(-3)
     &     - 14.D0*y**2*upx**(-2)
     &     + y**2*upx**(-1)
     &     + y**2*umx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HAr1(-1)*Nc**(-1) * (
     &     - 8.D0
     &     + 8.D0*y**(-1)*upx**(-2)
     &     - 8.D0*y**(-1)*upx**(-1)
     &     - 8.D0*y**(-1)
     &     + 16.D0*upx**(-2)
     &     - 16.D0*upx**(-1)
     &     + 8.D0*y*upx**(-2)
     &     - 8.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HAr1(-1)*Nc * (
     &     + 12.D0
     &     - 12.D0*y**(-1)*upx**(-2)
     &     + 12.D0*y**(-1)*upx**(-1)
     &     + 12.D0*y**(-1)
     &     - 24.D0*upx**(-2)
     &     + 24.D0*upx**(-1)
     &     - 12.D0*y*upx**(-2)
     &     + 12.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HAr1(-1)*Nc**3 * (
     &     - 4.D0
     &     + 4.D0*y**(-1)*upx**(-2)
     &     - 4.D0*y**(-1)*upx**(-1)
     &     - 4.D0*y**(-1)
     &     + 8.D0*upx**(-2)
     &     - 8.D0*upx**(-1)
     &     + 4.D0*y*upx**(-2)
     &     - 4.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HAr2(-1,-1)*Nc**(-1) * (
     &     - 16.D0
     &     - 32.D0*y*upx**(-2)
     &     + 32.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HAr2(-1,-1)*Nc * (
     &     + 24.D0
     &     + 48.D0*y*upx**(-2)
     &     - 48.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HAr2(-1,-1)*Nc**3 * (
     &     - 8.D0
     &     - 16.D0*y*upx**(-2)
     &     + 16.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HAr2(0,-1)*Nc**(-1) * (
     &     + 8.D0
     &     + 16.D0*y*upx**(-2)
     &     - 16.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HAr2(0,-1)*Nc * (
     &     - 12.D0
     &     - 24.D0*y*upx**(-2)
     &     + 24.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HAr2(0,-1)*Nc**3 * (
     &     + 4.D0
     &     + 8.D0*y*upx**(-2)
     &     - 8.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HBr1(-1)*Nc**(-1) * (
     &     + 16.D0
     &     - 8.D0*z**(-1)*upx**(-2)
     &     + 8.D0*z**(-1)*upx**(-1)
     &     + 8.D0*z**(-1)
     &     + 8.D0*y*upx**(-2)
     &     - 8.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HBr1(-1)*Nc * (
     &     - 16.D0
     &     + 8.D0*z**(-1)*upx**(-2)
     &     - 8.D0*z**(-1)*upx**(-1)
     &     - 8.D0*z**(-1)
     &     - 8.D0*y*upx**(-2)
     &     + 8.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HBr2(-1,-1)*Nc**(-1) * (
     &     - 16.D0
     &     - 64.D0*upx**(-2)
     &     + 64.D0*upx**(-1)
     &     - 32.D0*y*upx**(-2)
     &     + 32.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HBr2(-1,-1)*Nc * (
     &     + 16.D0
     &     + 64.D0*upx**(-2)
     &     - 64.D0*upx**(-1)
     &     + 32.D0*y*upx**(-2)
     &     - 32.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HBr2(0,-1)*Nc**(-1) * (
     &     + 8.D0
     &     + 32.D0*upx**(-2)
     &     - 32.D0*upx**(-1)
     &     + 16.D0*y*upx**(-2)
     &     - 16.D0*y*upx**(-1)
     &     )
      PoleEP0qq = PoleEP0qq + HBr2(0,-1)*Nc * (
     &     - 8.D0
     &     - 32.D0*upx**(-2)
     &     + 32.D0*upx**(-1)
     &     - 16.D0*y*upx**(-2)
     &     + 16.D0*y*upx**(-1)
     &     )
      return
      end

*
*******************************************************************************

************************************************************************
************************************************************************
*
*          FUNCTIONS for the Cross Section
*
*************************************************************************
**************************** 72 characters *****************************
*
*
      double precision function PoleEPm2gg(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl,ypzp2,ypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEPm2gg =  + Nc**2 * (
     &     - 16.D0
     &     - 64.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 80.D0*upy**(-1)
     &     - 64.D0*upz**(-2)
     &     + 80.D0*upz**(-1)
     &     - 32.D0*ypzp2**(-2)
     &     - 32.D0*ypzp2**(-1)
     &     + 16.D0*z*upy**(-1)
     &     - 64.D0*z*ypzp2**(-2)
     &     + 32.D0*z*ypzp2**(-1)
     &     - 32.D0*z**2*ypzp2**(-2)
     &     + 16.D0*y*upz**(-1)
     &     )
      PoleEPm2gg = PoleEPm2gg + Nc**4 * (
     &     + 16.D0
     &     + 32.D0*upy**(-2)
     &     - 40.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     + 32.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 64.D0*z*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-1)
     &     + 32.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEPm2gg = PoleEPm2gg + 32.D0*upy**(-2)
     &     + 64.D0*upy**(-1)*upz**(-1)
     &     - 40.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     - 8.D0*z*upy**(-1)
     &     - 8.D0*y*upz**(-1)
      return
      end
*
*
*
      double precision function PoleEPm1gg(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl,ypzp2,ypzm2,sqrypzp2,sqrypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
	sqrypzp2 = Dsqrt(y+z+2.d0)
	sqrypzm2 = Dsqrt(y+z-2.d0)
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEPm1gg =  + Nc**(-2) * (
     &     - 16.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Nc**(-1)*Nl * (
     &     - 32.D0/3.D0*upy**(-2)
     &     - 64.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 40.D0/3.D0*upy**(-1)
     &     - 32.D0/3.D0*upz**(-2)
     &     + 40.D0/3.D0*upz**(-1)
     &     + 8.D0/3.D0*z*upy**(-1)
     &     + 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Nc*Nl * (
     &     + 16.D0/3.D0
     &     + 64.D0/3.D0*upy**(-2)
     &     + 64.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 80.D0/3.D0*upy**(-1)
     &     + 64.D0/3.D0*upz**(-2)
     &     - 80.D0/3.D0*upz**(-1)
     &     + 32.D0/3.D0*ypzp2**(-2)
     &     + 32.D0/3.D0*ypzp2**(-1)
     &     - 16.D0/3.D0*z*upy**(-1)
     &     + 64.D0/3.D0*z*ypzp2**(-2)
     &     - 32.D0/3.D0*z*ypzp2**(-1)
     &     + 32.D0/3.D0*z**2*ypzp2**(-2)
     &     - 16.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Nc**2 * (
     &     - 136.D0/3.D0
     &     - 496.D0/3.D0*upy**(-2)
     &     - 448.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 524.D0/3.D0*upy**(-1)
     &     - 496.D0/3.D0*upz**(-2)
     &     + 524.D0/3.D0*upz**(-1)
     &     - 176.D0/3.D0*ypzp2**(-2)
     &     - 368.D0/3.D0*ypzp2**(-1)
     &     + 28.D0/3.D0*z*upy**(-1)
     &     - 352.D0/3.D0*z*ypzp2**(-2)
     &     + 176.D0/3.D0*z*ypzp2**(-1)
     &     - 176.D0/3.D0*z**2*ypzp2**(-2)
     &     + 28.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Nc**3*Nl * (
     &     - 16.D0/3.D0
     &     - 32.D0/3.D0*upy**(-2)
     &     + 40.D0/3.D0*upy**(-1)
     &     - 32.D0/3.D0*upz**(-2)
     &     + 40.D0/3.D0*upz**(-1)
     &     - 32.D0/3.D0*ypzp2**(-2)
     &     - 32.D0/3.D0*ypzp2**(-1)
     &     + 8.D0/3.D0*z*upy**(-1)
     &     - 64.D0/3.D0*z*ypzp2**(-2)
     &     + 32.D0/3.D0*z*ypzp2**(-1)
     &     - 32.D0/3.D0*z**2*ypzp2**(-2)
     &     + 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Nc**4 * (
     &     + 64.D0/3.D0
     &     + 224.D0/3.D0*upy**(-2)
     &     - 232.D0/3.D0*upy**(-1)
     &     + 224.D0/3.D0*upz**(-2)
     &     - 232.D0/3.D0*upz**(-1)
     &     + 128.D0/3.D0*ypzp2**(-2)
     &     + 320.D0/3.D0*ypzp2**(-1)
     &     - 8.D0/3.D0*z*upy**(-1)
     &     + 256.D0/3.D0*z*ypzp2**(-2)
     &     - 128.D0/3.D0*z*ypzp2**(-1)
     &     + 128.D0/3.D0*z**2*ypzp2**(-2)
     &     - 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Hr1(-1)*Nc**2 * (
     &     + 16.D0
     &     + 32.D0*upy**(-2)
     &     - 40.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     + 32.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 64.D0*z*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-1)
     &     + 32.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Hr1(-1)*Nc**4 * (
     &     - 16.D0
     &     - 32.D0*upy**(-2)
     &     + 40.D0*upy**(-1)
     &     - 32.D0*upz**(-2)
     &     + 40.D0*upz**(-1)
     &     - 32.D0*ypzp2**(-2)
     &     - 32.D0*ypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     - 64.D0*z*ypzp2**(-2)
     &     + 32.D0*z*ypzp2**(-1)
     &     - 32.D0*z**2*ypzp2**(-2)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Hr1(0)*Nc**(-2) * (
     &     + 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 68.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 68.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Hr1(0)*Nc**2 * (
     &     - 8.D0
     &     - 16.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 32.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*upz**(-1)
     &     + 32.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     - 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Hr1(0)*Nc**2 * (
     &     + 64.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     - 64.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     - 16.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     - 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Hr1(0)*Nc**4 * (
     &     + 8.D0
     &     + 16.D0*upy**(-2)
     &     - 20.D0*upy**(-1)
     &     + 16.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Hr1(0) * (
     &     - 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 36.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 36.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + Hr1(0) * (
     &     + 16.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + HAr1(-1)*Nc**2 * (
     &     + 64.D0*upy**(-2)
     &     + 64.D0*upy**(-1)*upz**(-1)
     &     - 80.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)
     &     - 16.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + HAr1(-1)*Nc**4 * (
     &     - 32.D0*upy**(-2)
     &     + 40.D0*upy**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 32.D0*ypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     )
      PoleEPm1gg = PoleEPm1gg + HAr1(-1) * (
     &     - 32.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 40.D0*upy**(-1)
     &     - 32.D0*upz**(-2)
     &     + 40.D0*upz**(-1)
     &     + 8.D0*z*upy**(-1)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + HBr1(-1)*Nc**2 * (
     &     + 16.D0
     &     + 32.D0*upy**(-2)
     &     + 64.D0*upy**(-1)*upz**(-1)
     &     - 40.D0*upy**(-1)
     &     + 64.D0*upz**(-2)
     &     - 80.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     - 8.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 16.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + HBr1(-1)*Nc**4 * (
     &     - 16.D0
     &     - 32.D0*upz**(-2)
     &     + 40.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 32.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + HBr1(-1) * (
     &     - 32.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 40.D0*upy**(-1)
     &     - 32.D0*upz**(-2)
     &     + 40.D0*upz**(-1)
     &     + 8.D0*z*upy**(-1)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEPm1gg = PoleEPm1gg + 24.D0
     &     + 320.D0/3.D0*upy**(-2)
     &     + 544.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 352.D0/3.D0*upy**(-1)
     &     + 320.D0/3.D0*upz**(-2)
     &     - 352.D0/3.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     - 32.D0/3.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 32.D0/3.D0*y*upz**(-1)
      return
      end
*
*
*
      double precision function PoleEP0gg(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,zp2,zm3,
     $                 Nc,Nh,Nl,ypzp2,ypzm2,sqrypzp2,sqrypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	zp2 = 2.d0+z
	zm3 = z-3.d0
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
	sqrypzp2 = Dsqrt(y+z+2.d0)
	sqrypzm2 = Dsqrt(y+z-2.d0)
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEP0gg =  + Nc**(-2) * (
     &     - 8.D0
     &     - 4.D0*y**(-1)*upz**(-1)
     &     - 2.D0*y**(-1)
     &     - 4.D0*z**(-1)*upy**(-1)
     &     - 2.D0*z**(-1)
     &     - 24.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 42.D0*upy**(-1)
     &     - 24.D0*upz**(-2)
     &     + 42.D0*upz**(-1)
     &     - 8.D0*z2*upy**(-3)
     &     - 48.D0*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z2*upy**(-2)
     &     - 192.D0*z2*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**(-2) * (
     &     + 186.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*z2*upy**(-1)
     &     - 8.D0*z2*upz**(-3)
     &     - 48.D0*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z2*upz**(-2)
     &     + 186.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*z2*upz**(-1)
     &     - 124.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z2
     &     + 8.D0*z*upy**(-2)
     &     - 2.D0*z*upy**(-1)
     &     - 8.D0*z*z2*upy**(-3)
     &     + 48.D0*z*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**(-2) * (
     &     + 6.D0*z*z2*upy**(-1)
     &     - 2.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-2)
     &     - 2.D0*y*upz**(-1)
     &     - 8.D0*y*z2*upz**(-3)
     &     + 48.D0*y*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*y*z2*upz**(-1)
     &     - 2.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**(-1)*Nl * (
     &     - 16.D0/3.D0
     &     - 16.D0/3.D0*upy**(-1)
     &     - 16.D0/3.D0*upz**(-1)
     &     - 16.D0/3.D0*z*upy**(-1)
     &     - 16.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc*Nl * (
     &     + 28.D0/3.D0*upy**(-1)
     &     + 28.D0/3.D0*upz**(-1)
     &     - 32.D0/3.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     + 32.D0/3.D0*z*upy**(-1)
     &     - 64.D0/3.D0*z*ypzp2**(-2)
     &     + 32.D0/3.D0*z*ypzp2**(-1)
     &     - 32.D0/3.D0*z**2*ypzp2**(-2)
     &     + 32.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc*Nh * (
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     - 4.D0/3.D0*upy**(-1)
     &     - 4.D0/3.D0*upz**(-1)
     &     + 128.D0*ypzp2**(-2)
     &     + 16.D0/3.D0*ypzp2**(-1)
     &     + 24.D0*z2*upy**(-1)*upz**(-1)
     &     - 96.D0*z2*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**2 * (
     &     - 4.D0*y**(-1)*upz**(-1)
     &     - 4.D0*y**(-1)*zp2**(-1)
     &     - 6.D0*y**(-1)
     &     - 4.D0*z**(-1)*upy**(-1)
     &     - 4.D0*z**(-1)*ypzp2**(-1)
     &     - 6.D0*z**(-1)
     &     - 88.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     - 16.D0*upy**(-1)*zm3**(-1)
     &     + 170.D0/3.D0*upy**(-1)
     &     - 88.D0*upz**(-2)
     &     - 16.D0*upz**(-1)*ypzm2**(-1)
     &     + 170.D0/3.D0*upz**(-1)
     &     + 4.D0*zp2**(-1)*ypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**2 * (
     &     + 16.D0*zm3**(-1)*ypzm2**(-1)
     &     + 20.D0*ypzm2**(-1)
     &     + 80.D0/3.D0*ypzp2**(-2)
     &     - 172.D0*ypzp2**(-1)
     &     - 8.D0*z2*upy**(-3)
     &     + 200.D0*z2*upy**(-2)
     &     + 192.D0*z2*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 120.D0*z2*upy**(-1)*upz**(-1)
     &     - 192.D0*z2*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 96.D0*z2*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 78.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 170.D0*z2*upy**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**2 * (
     &     - 8.D0*z2*upz**(-3)
     &     + 200.D0*z2*upz**(-2)
     &     - 192.D0*z2*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 96.D0*z2*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 78.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 170.D0*z2*upz**(-1)
     &     + 192.D0*z2*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 192.D0*z2*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 96.D0*z2*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**2 * (
     &     + 240.D0*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 88.D0*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 128.D0*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 80.D0*z2*ypzp2**(-2)
     &     - 72.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 80.D0*z2*ypzp2**(-1)
     &     + 52.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 38.D0*z2
     &     + 8.D0*z*upy**(-2)
     &     - 146.D0/3.D0*z*upy**(-1)
     &     - 8.D0*z*ypzm2**(-1)
     &     + 160.D0/3.D0*z*ypzp2**(-2)
     &     - 104.D0/3.D0*z*ypzp2**(-1)
     &     - 8.D0*z*z2*upy**(-3)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**2 * (
     &     - 16.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 46.D0*z*z2*upy**(-1)
     &     - 96.D0*z*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 256.D0*z*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 160.D0*z*z2*ypzp2**(-2)
     &     + 304.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 80.D0*z*z2*ypzp2**(-1)
     &     - 48.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*ypzm2**(-1)
     &     + 80.D0/3.D0*z**2*ypzp2**(-2)
     &     - 4.D0*z**2*ypzp2**(-1)
     &     - 6.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*z**2*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**2 * (
     &     - 8.D0*z**2*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 128.D0*z**2*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 80.D0*z**2*z2*ypzp2**(-2)
     &     + 88.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-2)
     &     - 146.D0/3.D0*y*upz**(-1)
     &     - 8.D0*y*z2*upz**(-3)
     &     - 16.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 46.D0*y*z2*upz**(-1)
     &     + 32.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**3*Nl * (
     &     + 16.D0/3.D0
     &     - 4.D0*upy**(-1)
     &     - 4.D0*upz**(-1)
     &     + 32.D0/3.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     - 16.D0/3.D0*z*upy**(-1)
     &     + 64.D0/3.D0*z*ypzp2**(-2)
     &     - 32.D0/3.D0*z*ypzp2**(-1)
     &     + 32.D0/3.D0*z**2*ypzp2**(-2)
     &     - 16.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**3*Nh * (
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 4.D0/3.D0*upy**(-1)
     &     + 4.D0/3.D0*upz**(-1)
     &     - 128.D0*ypzp2**(-2)
     &     - 16.D0/3.D0*ypzp2**(-1)
     &     - 24.D0*z2*upy**(-1)*upz**(-1)
     &     + 96.D0*z2*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**4 * (
     &     - 82.D0/3.D0
     &     + 2.D0*y**(-1)*zp2**(-1)
     &     + 2.D0*y**(-1)
     &     + 2.D0*z**(-1)*ypzp2**(-1)
     &     + 2.D0*z**(-1)
     &     + 32.D0*upy**(-2)
     &     + 16.D0*upy**(-1)*zm3**(-1)
     &     - 10.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     + 16.D0*upz**(-1)*ypzm2**(-1)
     &     - 10.D0*upz**(-1)
     &     - 2.D0*zp2**(-1)*ypzp2**(-1)
     &     - 16.D0*zm3**(-1)*ypzm2**(-1)
     &     - 20.D0*ypzm2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**4 * (
     &     - 128.D0/3.D0*ypzp2**(-2)
     &     + 120.D0*ypzp2**(-1)
     &     - 80.D0*z2*upy**(-2)
     &     + 192.D0*z2*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 96.D0*z2*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 90.D0*z2*upy**(-1)
     &     - 80.D0*z2*upz**(-2)
     &     + 192.D0*z2*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 96.D0*z2*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 10.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**4 * (
     &     + 90.D0*z2*upz**(-1)
     &     - 192.D0*z2*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 192.D0*z2*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 96.D0*z2*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 240.D0*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 88.D0*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 80.D0*z2*ypzp2**(-2)
     &     - 24.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*z2*ypzp2**(-1)
     &     - 8.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*z2
     &     )
      PoleEP0gg = PoleEP0gg + Nc**4 * (
     &     + 70.D0/3.D0*z*upy**(-1)
     &     + 8.D0*z*ypzm2**(-1)
     &     - 256.D0/3.D0*z*ypzp2**(-2)
     &     + 152.D0/3.D0*z*ypzp2**(-1)
     &     + 8.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*z*z2*upy**(-1)
     &     + 96.D0*z*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 160.D0*z*z2*ypzp2**(-2)
     &     - 48.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 80.D0*z*z2*ypzp2**(-1)
     &     + 10.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*ypzm2**(-1)
     &     - 128.D0/3.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + Nc**4 * (
     &     + 4.D0*z**2*ypzp2**(-1)
     &     + 2.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*z**2*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 80.D0*z**2*z2*ypzp2**(-2)
     &     - 24.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 70.D0/3.D0*y*upz**(-1)
     &     + 8.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*y*z2*upz**(-1)
     &     - 6.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Dlog(tm**(-2)*w**2)*Nc**(-1)*Nl * (
     &     + 32.D0/3.D0*upy**(-2)
     &     + 64.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 40.D0/3.D0*upy**(-1)
     &     + 32.D0/3.D0*upz**(-2)
     &     - 40.D0/3.D0*upz**(-1)
     &     - 8.D0/3.D0*z*upy**(-1)
     &     - 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Dlog(tm**(-2)*w**2)*Nc*Nl * (
     &     - 16.D0/3.D0
     &     - 64.D0/3.D0*upy**(-2)
     &     - 64.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 80.D0/3.D0*upy**(-1)
     &     - 64.D0/3.D0*upz**(-2)
     &     + 80.D0/3.D0*upz**(-1)
     &     - 32.D0/3.D0*ypzp2**(-2)
     &     - 32.D0/3.D0*ypzp2**(-1)
     &     + 16.D0/3.D0*z*upy**(-1)
     &     - 64.D0/3.D0*z*ypzp2**(-2)
     &     + 32.D0/3.D0*z*ypzp2**(-1)
     &     - 32.D0/3.D0*z**2*ypzp2**(-2)
     &     + 16.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Dlog(tm**(-2)*w**2)*Nc**2 * (
     &     + 88.D0/3.D0
     &     + 352.D0/3.D0*upy**(-2)
     &     + 352.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 440.D0/3.D0*upy**(-1)
     &     + 352.D0/3.D0*upz**(-2)
     &     - 440.D0/3.D0*upz**(-1)
     &     + 176.D0/3.D0*ypzp2**(-2)
     &     + 176.D0/3.D0*ypzp2**(-1)
     &     - 88.D0/3.D0*z*upy**(-1)
     &     + 352.D0/3.D0*z*ypzp2**(-2)
     &     - 176.D0/3.D0*z*ypzp2**(-1)
     &     + 176.D0/3.D0*z**2*ypzp2**(-2)
     &     - 88.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Dlog(tm**(-2)*w**2)*Nc**3*Nl * (
     &     + 16.D0/3.D0
     &     + 32.D0/3.D0*upy**(-2)
     &     - 40.D0/3.D0*upy**(-1)
     &     + 32.D0/3.D0*upz**(-2)
     &     - 40.D0/3.D0*upz**(-1)
     &     + 32.D0/3.D0*ypzp2**(-2)
     &     + 32.D0/3.D0*ypzp2**(-1)
     &     - 8.D0/3.D0*z*upy**(-1)
     &     + 64.D0/3.D0*z*ypzp2**(-2)
     &     - 32.D0/3.D0*z*ypzp2**(-1)
     &     + 32.D0/3.D0*z**2*ypzp2**(-2)
     &     - 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Dlog(tm**(-2)*w**2)*Nc**4 * (
     &     - 88.D0/3.D0
     &     - 176.D0/3.D0*upy**(-2)
     &     + 220.D0/3.D0*upy**(-1)
     &     - 176.D0/3.D0*upz**(-2)
     &     + 220.D0/3.D0*upz**(-1)
     &     - 176.D0/3.D0*ypzp2**(-2)
     &     - 176.D0/3.D0*ypzp2**(-1)
     &     + 44.D0/3.D0*z*upy**(-1)
     &     - 352.D0/3.D0*z*ypzp2**(-2)
     &     + 176.D0/3.D0*z*ypzp2**(-1)
     &     - 176.D0/3.D0*z**2*ypzp2**(-2)
     &     + 44.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Dlog(tm**(-2)*w**2) * (
     &     - 176.D0/3.D0*upy**(-2)
     &     - 352.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 220.D0/3.D0*upy**(-1)
     &     - 176.D0/3.D0*upz**(-2)
     &     + 220.D0/3.D0*upz**(-1)
     &     + 44.D0/3.D0*z*upy**(-1)
     &     + 44.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(-1)*Nc**2 * (
     &     - 12.D0
     &     + 192.D0*upy**(-1)*zm3**(-2)
     &     + 64.D0*upy**(-1)*zm3**(-1)
     &     + 12.D0*upy**(-1)
     &     + 192.D0*upz**(-1)*ypzm2**(-2)
     &     + 64.D0*upz**(-1)*ypzm2**(-1)
     &     + 12.D0*upz**(-1)
     &     - 192.D0*zm3**(-2)*ypzm2**(-1)
     &     - 192.D0*zm3**(-1)*ypzm2**(-2)
     &     - 64.D0*zm3**(-1)*ypzm2**(-1)
     &     - 240.D0*ypzm2**(-2)
     &     - 48.D0*ypzm2**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     + 16.D0*z*upy**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(-1)*Nc**2 * (
     &     + 96.D0*z*ypzm2**(-2)
     &     + 16.D0*z*ypzm2**(-1)
     &     - 32.D0*z*ypzp2**(-1)
     &     - 48.D0*z**2*ypzm2**(-2)
     &     + 16.D0*z**2*ypzm2**(-1)
     &     - 16.D0*z**2*ypzp2**(-1)
     &     + 16.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(-1)*Nc**4 * (
     &     + 12.D0
     &     - 192.D0*upy**(-1)*zm3**(-2)
     &     - 64.D0*upy**(-1)*zm3**(-1)
     &     - 12.D0*upy**(-1)
     &     - 192.D0*upz**(-1)*ypzm2**(-2)
     &     - 64.D0*upz**(-1)*ypzm2**(-1)
     &     - 12.D0*upz**(-1)
     &     + 192.D0*zm3**(-2)*ypzm2**(-1)
     &     + 192.D0*zm3**(-1)*ypzm2**(-2)
     &     + 64.D0*zm3**(-1)*ypzm2**(-1)
     &     + 240.D0*ypzm2**(-2)
     &     + 48.D0*ypzm2**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     - 16.D0*z*upy**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(-1)*Nc**4 * (
     &     - 96.D0*z*ypzm2**(-2)
     &     - 16.D0*z*ypzm2**(-1)
     &     + 32.D0*z*ypzp2**(-1)
     &     + 48.D0*z**2*ypzm2**(-2)
     &     - 16.D0*z**2*ypzm2**(-1)
     &     + 16.D0*z**2*ypzp2**(-1)
     &     - 16.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(-1)*HAr1(-1)*Nc**2 * (
     &     - 16.D0
     &     - 64.D0*upy**(-2)
     &     + 40.D0*upy**(-1)
     &     - 32.D0*ypzp2**(-2)
     &     + 8.D0*z*upy**(-1)
     &     - 64.D0*z*ypzp2**(-2)
     &     + 32.D0*z*ypzp2**(-1)
     &     - 32.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(-1)*HAr1(-1)*Nc**4 * (
     &     + 16.D0
     &     + 64.D0*upy**(-2)
     &     - 40.D0*upy**(-1)
     &     + 32.D0*ypzp2**(-2)
     &     - 8.D0*z*upy**(-1)
     &     + 64.D0*z*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-1)
     &     + 32.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(-1)*HBr1(-1)*Nc**2 * (
     &     - 16.D0
     &     - 64.D0*upz**(-2)
     &     + 40.D0*upz**(-1)
     &     - 32.D0*ypzp2**(-2)
     &     - 64.D0*z*ypzp2**(-2)
     &     + 32.D0*z*ypzp2**(-1)
     &     - 32.D0*z**2*ypzp2**(-2)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(-1)*HBr1(-1)*Nc**4 * (
     &     + 16.D0
     &     + 64.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     + 32.D0*ypzp2**(-2)
     &     + 64.D0*z*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-1)
     &     + 32.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*Nc**(-2) * (
     &     + 16.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*Nc*Nh * (
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 256.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*Nc**2 * (
     &     + 6.D0
     &     - 96.D0*upy**(-1)*zm3**(-2)
     &     - 32.D0*upy**(-1)*zm3**(-1)
     &     - 14.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*upy**(-1)
     &     - 96.D0*upz**(-1)*ypzm2**(-2)
     &     - 32.D0*upz**(-1)*ypzm2**(-1)
     &     - 14.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*upz**(-1)
     &     + 96.D0*zm3**(-2)*ypzm2**(-1)
     &     + 96.D0*zm3**(-1)*ypzm2**(-2)
     &     + 32.D0*zm3**(-1)*ypzm2**(-1)
     &     + 120.D0*ypzm2**(-2)
     &     + 24.D0*ypzm2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*Nc**2 * (
     &     + 32.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*ypzp2**(-1)
     &     + 2.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     - 48.D0*z*ypzm2**(-2)
     &     - 8.D0*z*ypzm2**(-1)
     &     + 64.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 22.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z**2*ypzm2**(-2)
     &     - 8.D0*z**2*ypzm2**(-1)
     &     + 32.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*Nc**2 * (
     &     - 8.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-1)
     &     + 2.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)
     &     + 14.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*Nc**3*Nh * (
     &     - 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 256.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*Nc**4 * (
     &     - 6.D0
     &     + 96.D0*upy**(-1)*zm3**(-2)
     &     + 32.D0*upy**(-1)*zm3**(-1)
     &     + 6.D0*upy**(-1)
     &     + 96.D0*upz**(-1)*ypzm2**(-2)
     &     + 32.D0*upz**(-1)*ypzm2**(-1)
     &     + 6.D0*upz**(-1)
     &     - 96.D0*zm3**(-2)*ypzm2**(-1)
     &     - 96.D0*zm3**(-1)*ypzm2**(-2)
     &     - 32.D0*zm3**(-1)*ypzm2**(-1)
     &     - 120.D0*ypzm2**(-2)
     &     - 24.D0*ypzm2**(-1)
     &     + 8.D0*ypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*Nc**4 * (
     &     + 48.D0*z*ypzm2**(-2)
     &     + 8.D0*z*ypzm2**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     - 24.D0*z**2*ypzm2**(-2)
     &     + 8.D0*z**2*ypzm2**(-1)
     &     - 8.D0*z**2*ypzp2**(-1)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*HAr1(-1)*Nc**(-2) * (
     &     - 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 84.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 88.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 36.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*HAr1(-1)*Nc**2 * (
     &     + 8.D0
     &     + 32.D0*upy**(-2)
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upy**(-1)
     &     - 88.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*HAr1(-1)*Nc**2 * (
     &     + 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*HAr1(-1)*Nc**4 * (
     &     - 8.D0
     &     - 32.D0*upy**(-2)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     + 4.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*HAr1(-1) * (
     &     + 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 52.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*HBr1(-1)*Nc**(-2) * (
     &     - 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 88.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 84.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 36.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*HBr1(-1)*Nc**2 * (
     &     + 8.D0
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 88.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upz**(-2)
     &     - 32.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*HBr1(-1)*Nc**2 * (
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     + 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*HBr1(-1)*Nc**4 * (
     &     - 8.D0
     &     - 32.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0)*HBr1(-1) * (
     &     + 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 52.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0) * (
     &     - 2.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr1(0) * (
     &     + 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(-1,-1)*Nc**2 * (
     &     + 40.D0*upy**(-1)
     &     + 40.D0*upz**(-1)
     &     - 64.D0*ypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(-1,-1)*Nc**4 * (
     &     - 40.D0*upy**(-1)
     &     - 40.D0*upz**(-1)
     &     + 64.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(-1,0)*Nc**(-2) * (
     &     + 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 128.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 172.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 172.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 72.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 28.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 28.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(-1,0)*Nc**2 * (
     &     - 128.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 120.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upy**(-1)
     &     + 120.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upz**(-1)
     &     - 64.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*ypzp2**(-1)
     &     - 40.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 12.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(-1,0)*Nc**2 * (
     &     - 12.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(-1,0)*Nc**4 * (
     &     + 20.D0*upy**(-1)
     &     + 20.D0*upz**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(-1,0) * (
     &     - 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 52.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 52.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,-1)*Nc**2 * (
     &     + 384.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 192.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upy**(-1)
     &     + 384.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 192.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upz**(-1)
     &     - 384.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 384.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 192.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 480.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 176.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,-1)*Nc**2 * (
     &     + 32.D0*ypzp2**(-1)
     &     - 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 192.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 96.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 96.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,-1)*Nc**2 * (
     &     - 12.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,-1)*Nc**4 * (
     &     - 384.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 192.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*upy**(-1)
     &     - 384.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 192.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*upz**(-1)
     &     + 384.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 384.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 192.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 480.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 176.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,-1)*Nc**4 * (
     &     - 32.D0*ypzp2**(-1)
     &     + 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 192.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,-1)*Nc**4 * (
     &     + 12.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,0)*Nc**(-2) * (
     &     - 8.D0
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     + 18.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*upy**(-1)
     &     + 18.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*upz**(-1)
     &     + 4.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*z*upy**(-1)
     &     - 10.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*y*upz**(-1)
     &     - 10.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,0)*Nc*Nh * (
     &     - 8.D0*upy**(-1)*upz**(-1)
     &     + 32.D0*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,0)*Nc**2 * (
     &     + 2.D0
     &     - 8.D0*upy**(-1)*upz**(-1)
     &     - 192.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 96.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 38.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*upy**(-1)
     &     - 192.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 96.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 38.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*upz**(-1)
     &     + 192.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 192.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 240.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,0)*Nc**2 * (
     &     + 88.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 72.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     + 12.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*z*upy**(-1)
     &     - 96.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,0)*Nc**2 * (
     &     + 32.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*y*upz**(-1)
     &     + 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,0)*Nc**3*Nh * (
     &     + 8.D0*upy**(-1)*upz**(-1)
     &     - 32.D0*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,0)*Nc**4 * (
     &     + 192.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*upy**(-1)
     &     + 192.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*upz**(-1)
     &     - 192.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 192.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 96.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 240.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 88.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,0)*Nc**4 * (
     &     + 16.D0*ypzp2**(-1)
     &     - 8.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z*upy**(-1)
     &     + 96.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,0)*Nc**4 * (
     &     - 6.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,0) * (
     &     + 6.D0
     &     - 8.D0*upy**(-1)*upz**(-1)
     &     + 10.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*upy**(-1)
     &     + 10.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*upz**(-1)
     &     - 32.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     - 8.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z*upy**(-1)
     &     - 64.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(0,0) * (
     &     - 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y*upz**(-1)
     &     + 12.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(1,0)*Nc**(-2) * (
     &     + 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 128.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 136.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 136.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 80.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(1,0)*Nc**2 * (
     &     - 128.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 128.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 128.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(1,0) * (
     &     - 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 72.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 72.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 128.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 128.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + Hr2(1,0) * (
     &     + 32.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr1(-1)*Nc**(-2) * (
     &     - 4.D0
     &     + 4.D0*y**(-2)*upz**(-1)
     &     + 2.D0*y**(-2)
     &     + 4.D0*y**(-1)*upz**(-1)
     &     + 4.D0*y**(-1)
     &     + 2.D0*y**(-1)*z
     &     + 24.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 40.D0*upy**(-1)
     &     - 8.D0*upz**(-1)
     &     - 8.D0*z*upy**(-2)
     &     - 8.D0*z*upy**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr1(-1)*Nc**2 * (
     &     + 20.D0
     &     + 4.D0*y**(-2)*upz**(-1)
     &     + 4.D0*y**(-2)*zp2**(-1)
     &     + 6.D0*y**(-2)
     &     - 12.D0*y**(-1)*upz**(-1)
     &     - 4.D0*y**(-1)*zp2**(-2)
     &     - 4.D0*y**(-1)*zp2**(-1)
     &     - 8.D0*y**(-1)
     &     + 6.D0*y**(-1)*z
     &     + 88.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 48.D0*upy**(-1)
     &     + 4.D0*zp2**(-2)*ypzp2**(-1)
     &     + 4.D0*zp2**(-1)*ypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr1(-1)*Nc**2 * (
     &     - 16.D0*ypzp2**(-2)
     &     + 36.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-2)
     &     + 8.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 12.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 16.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr1(-1)*Nc**4 * (
     &     - 2.D0*y**(-2)*zp2**(-1)
     &     - 2.D0*y**(-2)
     &     + 2.D0*y**(-1)*zp2**(-2)
     &     + 6.D0*y**(-1)*zp2**(-1)
     &     + 6.D0*y**(-1)
     &     - 2.D0*y**(-1)*z
     &     - 32.D0*upy**(-2)
     &     + 8.D0*upy**(-1)
     &     - 2.D0*zp2**(-2)*ypzp2**(-1)
     &     - 6.D0*zp2**(-1)*ypzp2**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     - 18.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + HAr1(-1)*Nc**4 * (
     &     - 10.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + HAr1(-1)*HBr1(-1)*Nc**2 * (
     &     - 64.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 40.D0*upy**(-1)
     &     - 64.D0*upz**(-2)
     &     + 40.D0*upz**(-1)
     &     + 8.D0*z*upy**(-1)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr1(-1)*HBr1(-1) * (
     &     + 64.D0*upy**(-2)
     &     + 64.D0*upy**(-1)*upz**(-1)
     &     - 40.D0*upy**(-1)
     &     + 64.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     - 8.D0*z*upy**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr1(-1) * (
     &     - 16.D0
     &     - 8.D0*y**(-2)*upz**(-1)
     &     - 2.D0*y**(-2)*zp2**(-1)
     &     - 6.D0*y**(-2)
     &     + 8.D0*y**(-1)*upz**(-1)
     &     + 2.D0*y**(-1)*zp2**(-2)
     &     - 2.D0*y**(-1)*zp2**(-1)
     &     - 2.D0*y**(-1)
     &     - 6.D0*y**(-1)*z
     &     - 80.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 80.D0*upy**(-1)
     &     + 8.D0*upz**(-1)
     &     - 2.D0*zp2**(-2)*ypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr1(-1) * (
     &     + 2.D0*zp2**(-1)*ypzp2**(-1)
     &     - 18.D0*ypzp2**(-1)
     &     + 16.D0*z*upy**(-2)
     &     + 8.D0*z*upy**(-1)
     &     - 2.D0*z*ypzp2**(-1)
     &     - 16.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr2(-1,-1)*Nc**2 * (
     &     + 16.D0
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 80.D0*upy**(-1)
     &     + 40.D0*upz**(-1)
     &     - 64.D0*ypzp2**(-1)
     &     + 16.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-1)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr2(-1,-1)*Nc**4 * (
     &     - 16.D0
     &     - 40.D0*upy**(-1)
     &     + 64.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr2(-1,-1) * (
     &     + 64.D0*upy**(-1)*upz**(-1)
     &     - 40.D0*upy**(-1)
     &     - 40.D0*upz**(-1)
     &     - 8.D0*z*upy**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr2(0,-1)*Nc**(-2) * (
     &     - 8.D0
     &     - 8.D0*upy**(-3)
     &     - 16.D0*upy**(-2)
     &     + 24.D0*upy**(-1)*upz**(-1)
     &     + 4.D0*upy**(-1)
     &     - 16.D0*upz**(-1)
     &     - 8.D0*z*upy**(-3)
     &     - 4.D0*z*upy**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr2(0,-1)*Nc**2 * (
     &     - 8.D0
     &     - 8.D0*upy**(-3)
     &     - 8.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 36.D0*upy**(-1)
     &     - 32.D0*upz**(-1)*ypzp2**(-1)
     &     + 20.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-3)
     &     - 12.D0*z*upy**(-1)
     &     + 20.D0*z*ypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr2(0,-1)*Nc**4 * (
     &     + 8.D0
     &     + 20.D0*upy**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HAr2(0,-1) * (
     &     + 8.D0
     &     + 16.D0*upy**(-3)
     &     + 24.D0*upy**(-2)
     &     - 56.D0*upy**(-1)*upz**(-1)
     &     + 12.D0*upy**(-1)
     &     + 32.D0*upz**(-1)*ypzp2**(-1)
     &     + 16.D0*upz**(-1)
     &     + 12.D0*ypzp2**(-1)
     &     + 16.D0*z*upy**(-3)
     &     + 12.D0*z*upy**(-1)
     &     - 4.D0*z*ypzp2**(-1)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr1(-1)*Nc**(-2) * (
     &     - 4.D0
     &     + 4.D0*z**(-2)*upy**(-1)
     &     + 2.D0*z**(-2)
     &     + 4.D0*z**(-1)*upy**(-1)
     &     + 4.D0*z**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 8.D0*upy**(-1)
     &     + 24.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     + 2.D0*y*z**(-1)
     &     - 8.D0*y*upz**(-2)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr1(-1)*Nc**2 * (
     &     + 16.D0
     &     + 4.D0*z**(-2)*upy**(-1)
     &     + 4.D0*z**(-2)*ypzp2**(-1)
     &     + 6.D0*z**(-2)
     &     - 12.D0*z**(-1)*upy**(-1)
     &     - 4.D0*z**(-1)*ypzp2**(-1)
     &     - 8.D0*z**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 88.D0*upz**(-2)
     &     - 48.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     + 44.D0*ypzp2**(-1)
     &     + 16.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     )
      PoleEP0gg = PoleEP0gg + HBr1(-1)*Nc**2 * (
     &     + 20.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 6.D0*y*z**(-1)
     &     - 8.D0*y*upz**(-2)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr1(-1)*Nc**4 * (
     &     + 6.D0
     &     - 2.D0*z**(-2)*ypzp2**(-1)
     &     - 2.D0*z**(-2)
     &     + 6.D0*z**(-1)*ypzp2**(-1)
     &     + 6.D0*z**(-1)
     &     - 32.D0*upz**(-2)
     &     + 8.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     - 30.D0*ypzp2**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 22.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 2.D0*y*z**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr1(-1) * (
     &     - 18.D0
     &     - 8.D0*z**(-2)*upy**(-1)
     &     - 2.D0*z**(-2)*ypzp2**(-1)
     &     - 6.D0*z**(-2)
     &     + 8.D0*z**(-1)*upy**(-1)
     &     - 2.D0*z**(-1)*ypzp2**(-1)
     &     - 2.D0*z**(-1)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 8.D0*upy**(-1)
     &     - 80.D0*upz**(-2)
     &     + 80.D0*upz**(-1)
     &     - 14.D0*ypzp2**(-1)
     &     - 16.D0*z*upy**(-1)
     &     + 2.D0*z*ypzp2**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr1(-1) * (
     &     - 6.D0*y*z**(-1)
     &     + 16.D0*y*upz**(-2)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr2(-1,-1)*Nc**2 * (
     &     - 16.D0
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 40.D0*upy**(-1)
     &     + 80.D0*upz**(-1)
     &     + 8.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-1)
     &     + 16.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr2(-1,-1)*Nc**4 * (
     &     + 16.D0
     &     - 40.D0*upz**(-1)
     &     - 32.D0*z*ypzp2**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr2(-1,-1) * (
     &     + 64.D0*upy**(-1)*upz**(-1)
     &     - 40.D0*upy**(-1)
     &     - 40.D0*upz**(-1)
     &     - 8.D0*z*upy**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr2(0,-1)*Nc**(-2) * (
     &     - 8.D0
     &     + 24.D0*upy**(-1)*upz**(-1)
     &     - 16.D0*upy**(-1)
     &     - 8.D0*upz**(-3)
     &     - 16.D0*upz**(-2)
     &     + 4.D0*upz**(-1)
     &     - 8.D0*z*upy**(-1)
     &     - 8.D0*y*upz**(-3)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr2(0,-1)*Nc**2 * (
     &     + 12.D0
     &     - 8.D0*upz**(-3)
     &     - 8.D0*upz**(-2)
     &     + 32.D0*upz**(-1)*ypzp2**(-1)
     &     - 36.D0*upz**(-1)
     &     - 20.D0*ypzp2**(-1)
     &     - 20.D0*z*ypzp2**(-1)
     &     - 8.D0*y*upz**(-3)
     &     - 12.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr2(0,-1)*Nc**4 * (
     &     - 8.D0
     &     + 20.D0*upz**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + HBr2(0,-1) * (
     &     + 4.D0
     &     - 24.D0*upy**(-1)*upz**(-1)
     &     + 16.D0*upy**(-1)
     &     + 16.D0*upz**(-3)
     &     + 24.D0*upz**(-2)
     &     - 32.D0*upz**(-1)*ypzp2**(-1)
     &     + 12.D0*upz**(-1)
     &     + 20.D0*ypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     + 4.D0*z*ypzp2**(-1)
     &     + 16.D0*y*upz**(-3)
     &     + 12.D0*y*upz**(-1)
     &     )
      PoleEP0gg = PoleEP0gg + 106.D0/3.D0
     &     + 8.D0*y**(-1)*upz**(-1)
     &     + 2.D0*y**(-1)*zp2**(-1)
     &     + 6.D0*y**(-1)
     &     + 8.D0*z**(-1)*upy**(-1)
     &     + 2.D0*z**(-1)*ypzp2**(-1)
     &     + 6.D0*z**(-1)
     &     + 80.D0*upy**(-2)
     &     + 128.D0*upy**(-1)*upz**(-1)
     &     - 266.D0/3.D0*upy**(-1)
     &     + 80.D0*upz**(-2)
     &     - 266.D0/3.D0*upz**(-1)
     &     - 2.D0*zp2**(-1)*ypzp2**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 52.D0*ypzp2**(-1)
     &
      PoleEP0gg = PoleEP0gg + 16.D0*z2*upy**(-3)
     &     + 48.D0*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 104.D0*z2*upy**(-2)
     &     - 120.D0*z2*upy**(-1)*upz**(-1)
     &     - 118.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 74.D0*z2*upy**(-1)
     &     + 16.D0*z2*upz**(-3)
     &     + 48.D0*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 104.D0*z2*upz**(-2)
     &     - 118.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 74.D0*z2*upz**(-1)
     &     + 128.D0*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z2*ypzp2**(-1)
     &     + 80.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &
      PoleEP0gg = PoleEP0gg - 6.D0*z2
     &     - 16.D0*z*upy**(-2)
     &     + 82.D0/3.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 16.D0*z*z2*upy**(-3)
     &     - 48.D0*z*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 56.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 22.D0*z*z2*upy**(-1)
     &     + 256.D0*z*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 256.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     + 14.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 128.D0*z**2*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &
      PoleEP0gg = PoleEP0gg - 64.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*
     & sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-2)
     &     + 82.D0/3.D0*y*upz**(-1)
     &     + 16.D0*y*z2*upz**(-3)
     &     - 48.D0*y*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 56.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 22.D0*y*z2*upz**(-1)
     &     - 24.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 14.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
      return
      end

*
*******************************************************************************
************************************************************************
************************************************************************
*
*          FUNCTIONS for the Cross Section
*
*************************************************************************
**************************** 72 characters *****************************
*
*
      double precision function T34PoleEPm2qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      T34PoleEPm2qq =  + Nc**(-2) * (
     &     - 8.D0
     &     - 16.D0*upx**(-4)
     &     - 32.D0*upx**(-4)*y
     &     - 16.D0*upx**(-4)*y**2
     &     + 32.D0*upx**(-3)
     &     + 64.D0*upx**(-3)*y
     &     + 32.D0*upx**(-3)*y**2
     &     - 16.D0*upx**(-2)
     &     - 48.D0*upx**(-2)*y
     &     - 16.D0*upx**(-2)*y**2
     &     + 16.D0*upx**(-1)*y
     &     )/4.D0
      T34PoleEPm2qq = T34PoleEPm2qq + (
     &     + 16.D0
     &     + 32.D0*upx**(-4)
     &     + 64.D0*upx**(-4)*y
     &     + 32.D0*upx**(-4)*y**2
     &     - 64.D0*upx**(-3)
     &     - 128.D0*upx**(-3)*y
     &     - 64.D0*upx**(-3)*y**2
     &     + 32.D0*upx**(-2)
     &     + 96.D0*upx**(-2)*y
     &     + 32.D0*upx**(-2)*y**2
     &     - 32.D0*upx**(-1)*y
     &     )/4.D0
      T34PoleEPm2qq = T34PoleEPm2qq + Nc**2 * (
     &     - 8.D0
     &     - 16.D0*upx**(-4)
     &     - 32.D0*upx**(-4)*y
     &     - 16.D0*upx**(-4)*y**2
     &     + 32.D0*upx**(-3)
     &     + 64.D0*upx**(-3)*y
     &     + 32.D0*upx**(-3)*y**2
     &     - 16.D0*upx**(-2)
     &     - 48.D0*upx**(-2)*y
     &     - 16.D0*upx**(-2)*y**2
     &     + 16.D0*upx**(-1)*y
     &     )/4.D0
      return
      end
*
*
*
      double precision function T34PoleEPm1qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      T34PoleEPm1qq =  + Nc**(-2) * (
     &     + 6.D0
     &     + 20.D0*upx**(-4)
     &     + 40.D0*upx**(-4)*y
     &     + 20.D0*upx**(-4)*y**2
     &     - 40.D0*upx**(-3)
     &     - 80.D0*upx**(-3)*y
     &     - 40.D0*upx**(-3)*y**2
     &     + 20.D0*upx**(-2)
     &     + 60.D0*upx**(-2)*y
     &     + 20.D0*upx**(-2)*y**2
     &     - 20.D0*upx**(-1)*y
     &     - 8.D0*Hr1(-1)
     &     - 16.D0*Hr1(-1)*upx**(-4)
     &     - 32.D0*Hr1(-1)*upx**(-4)*y
     &     - 16.D0*Hr1(-1)*upx**(-4)*y**2
     &     + 32.D0*Hr1(-1)*upx**(-3)
     &     + 64.D0*Hr1(-1)*upx**(-3)*y
     &     + 32.D0*Hr1(-1)*upx**(-3)*y**2
     &     - 16.D0*Hr1(-1)*upx**(-2)
     &     - 48.D0*Hr1(-1)*upx**(-2)*y
     &     - 16.D0*Hr1(-1)*upx**(-2)*y**2
     &     + 16.D0*Hr1(-1)*upx**(-1)*y
     &     - 16.D0*HAr1(-1)
     &     - 32.D0*HAr1(-1)*upx**(-4)
     &     - 64.D0*HAr1(-1)*upx**(-4)*y
     &     - 32.D0*HAr1(-1)*upx**(-4)*y**2
     &     + 64.D0*HAr1(-1)*upx**(-3)
     &     + 128.D0*HAr1(-1)*upx**(-3)*y
     &     + 64.D0*HAr1(-1)*upx**(-3)*y**2
     &     - 32.D0*HAr1(-1)*upx**(-2)
     &     - 96.D0*HAr1(-1)*upx**(-2)*y
     &     - 32.D0*HAr1(-1)*upx**(-2)*y**2
     &     + 32.D0*HAr1(-1)*upx**(-1)*y
     &     + 16.D0*HBr1(-1)
     &     + 32.D0*HBr1(-1)*upx**(-4)
     &     + 64.D0*HBr1(-1)*upx**(-4)*y
     &     + 32.D0*HBr1(-1)*upx**(-4)*y**2
     &     - 64.D0*HBr1(-1)*upx**(-3)
     &     - 128.D0*HBr1(-1)*upx**(-3)*y
     &     - 64.D0*HBr1(-1)*upx**(-3)*y**2
     &     + 32.D0*HBr1(-1)*upx**(-2)
     &     + 96.D0*HBr1(-1)*upx**(-2)*y
     &     + 32.D0*HBr1(-1)*upx**(-2)*y**2
     &     - 32.D0*HBr1(-1)*upx**(-1)*y
     &     + 9/2.D0*Hr1(0)*umx**(-1)
     &     - Hr1(0)*umx**(-1)*y
     &     + 1/2.D0*Hr1(0)*umx**(-1)*y**2
     &     + 8.D0*Hr1(0)*upx**(-5)
     &     + 16.D0*Hr1(0)*upx**(-5)*y
     &     + 8.D0*Hr1(0)*upx**(-5)*y**2
     &     - 12.D0*Hr1(0)*upx**(-4)
     &     - 24.D0*Hr1(0)*upx**(-4)*y
     &     - 12.D0*Hr1(0)*upx**(-4)*y**2
     &     + 2.D0*Hr1(0)*upx**(-3)
     &     + 12.D0*Hr1(0)*upx**(-3)*y
     &     + 2.D0*Hr1(0)*upx**(-3)*y**2
     &     + Hr1(0)*upx**(-2)
     &     - 2.D0*Hr1(0)*upx**(-2)*y
     &     + Hr1(0)*upx**(-2)*y**2
     &     + 9/2.D0*Hr1(0)*upx**(-1)
     &     - Hr1(0)*upx**(-1)*y
     &     + 1/2.D0*Hr1(0)*upx**(-1)*y**2
     &     )/(-2.D0)
      T34PoleEPm1qq = T34PoleEPm1qq + (
     &     - 12.D0
     &     - 40.D0*upx**(-4)
     &     - 80.D0*upx**(-4)*y
     &     - 40.D0*upx**(-4)*y**2
     &     + 80.D0*upx**(-3)
     &     + 160.D0*upx**(-3)*y
     &     + 80.D0*upx**(-3)*y**2
     &     - 40.D0*upx**(-2)
     &     - 120.D0*upx**(-2)*y
     &     - 40.D0*upx**(-2)*y**2
     &     + 40.D0*upx**(-1)*y
     &     + 8.D0*Hr1(-1)
     &     + 16.D0*Hr1(-1)*upx**(-4)
     &     + 32.D0*Hr1(-1)*upx**(-4)*y
     &     + 16.D0*Hr1(-1)*upx**(-4)*y**2
     &     - 32.D0*Hr1(-1)*upx**(-3)
     &     - 64.D0*Hr1(-1)*upx**(-3)*y
     &     - 32.D0*Hr1(-1)*upx**(-3)*y**2
     &     + 16.D0*Hr1(-1)*upx**(-2)
     &     + 48.D0*Hr1(-1)*upx**(-2)*y
     &     + 16.D0*Hr1(-1)*upx**(-2)*y**2
     &     - 16.D0*Hr1(-1)*upx**(-1)*y
     &     + 24.D0*HAr1(-1)
     &     + 48.D0*HAr1(-1)*upx**(-4)
     &     + 96.D0*HAr1(-1)*upx**(-4)*y
     &     + 48.D0*HAr1(-1)*upx**(-4)*y**2
     &     - 96.D0*HAr1(-1)*upx**(-3)
     &     - 192.D0*HAr1(-1)*upx**(-3)*y
     &     - 96.D0*HAr1(-1)*upx**(-3)*y**2
     &     + 48.D0*HAr1(-1)*upx**(-2)
     &     + 144.D0*HAr1(-1)*upx**(-2)*y
     &     + 48.D0*HAr1(-1)*upx**(-2)*y**2
     &     - 48.D0*HAr1(-1)*upx**(-1)*y
     &     - 16.D0*HBr1(-1)
     &     - 32.D0*HBr1(-1)*upx**(-4)
     &     - 64.D0*HBr1(-1)*upx**(-4)*y
     &     - 32.D0*HBr1(-1)*upx**(-4)*y**2
     &     + 64.D0*HBr1(-1)*upx**(-3)
     &     + 128.D0*HBr1(-1)*upx**(-3)*y
     &     + 64.D0*HBr1(-1)*upx**(-3)*y**2
     &     - 32.D0*HBr1(-1)*upx**(-2)
     &     - 96.D0*HBr1(-1)*upx**(-2)*y
     &     - 32.D0*HBr1(-1)*upx**(-2)*y**2
     &     + 32.D0*HBr1(-1)*upx**(-1)*y
     &     - 9/2.D0*Hr1(0)*umx**(-1)
     &     + Hr1(0)*umx**(-1)*y
     &     - 1/2.D0*Hr1(0)*umx**(-1)*y**2
     &     - 8.D0*Hr1(0)*upx**(-5)
     &     - 16.D0*Hr1(0)*upx**(-5)*y
     &     - 8.D0*Hr1(0)*upx**(-5)*y**2
     &     + 12.D0*Hr1(0)*upx**(-4)
     &     + 24.D0*Hr1(0)*upx**(-4)*y
     &     + 12.D0*Hr1(0)*upx**(-4)*y**2
     &     - 2.D0*Hr1(0)*upx**(-3)
     &     - 12.D0*Hr1(0)*upx**(-3)*y
     &     - 2.D0*Hr1(0)*upx**(-3)*y**2
     &     - Hr1(0)*upx**(-2)
     &     + 2.D0*Hr1(0)*upx**(-2)*y
     &     - Hr1(0)*upx**(-2)*y**2
     &     - 9/2.D0*Hr1(0)*upx**(-1)
     &     + Hr1(0)*upx**(-1)*y
     &     - 1/2.D0*Hr1(0)*upx**(-1)*y**2
     &     )/(-2.D0)
      T34PoleEPm1qq = T34PoleEPm1qq + Nc**2 * (
     &     + 6.D0
     &     + 20.D0*upx**(-4)
     &     + 40.D0*upx**(-4)*y
     &     + 20.D0*upx**(-4)*y**2
     &     - 40.D0*upx**(-3)
     &     - 80.D0*upx**(-3)*y
     &     - 40.D0*upx**(-3)*y**2
     &     + 20.D0*upx**(-2)
     &     + 60.D0*upx**(-2)*y
     &     + 20.D0*upx**(-2)*y**2
     &     - 20.D0*upx**(-1)*y
     &     - 8.D0*HAr1(-1)
     &     - 16.D0*HAr1(-1)*upx**(-4)
     &     - 32.D0*HAr1(-1)*upx**(-4)*y
     &     - 16.D0*HAr1(-1)*upx**(-4)*y**2
     &     + 32.D0*HAr1(-1)*upx**(-3)
     &     + 64.D0*HAr1(-1)*upx**(-3)*y
     &     + 32.D0*HAr1(-1)*upx**(-3)*y**2
     &     - 16.D0*HAr1(-1)*upx**(-2)
     &     - 48.D0*HAr1(-1)*upx**(-2)*y
     &     - 16.D0*HAr1(-1)*upx**(-2)*y**2
     &     + 16.D0*HAr1(-1)*upx**(-1)*y
     &     )/(-2.D0)
      
      return
      end
*
*
*
      double precision function T34PoleEP0qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1d0

* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      T34PoleEP0qq =  + Nc**(-2) * (
     &     - 7.D0
     &     + 8.D0*umx**(-3)*z2
     &     - 8.D0*umx**(-3)*y*z2
     &     - 12.D0*umx**(-2)*z2
     &     + 12.D0*umx**(-2)*y*z2
     &     + 13.D0*umx**(-1)*z2
     &     - 2.D0*umx**(-1)*y*z2
     &     + umx**(-1)*y**2*z2
     &     + 16.D0*upx**(-5)*z2
     &     + 32.D0*upx**(-5)*y*z2
     &     + 16.D0*upx**(-5)*y**2*z2
     &     - 24.D0*upx**(-4)
     &     - 24.D0*upx**(-4)*z2
     &     - 48.D0*upx**(-4)*y
     &     - 48.D0*upx**(-4)*y*z2
     &     - 24.D0*upx**(-4)*y**2
     &     - 24.D0*upx**(-4)*y**2*z2
     &     + 48.D0*upx**(-3)
     &     - 4.D0*upx**(-3)*z2
     &     + 96.D0*upx**(-3)*y
     &     + 16.D0*upx**(-3)*y*z2
     &     + 48.D0*upx**(-3)*y**2
     &     + 4.D0*upx**(-3)*y**2*z2
     &     - 24.D0*upx**(-2)
     &     + 6.D0*upx**(-2)*z2
     &     - 72.D0*upx**(-2)*y
     &     - 24.D0*upx**(-2)*y**2
     &     + 2.D0*upx**(-2)*y**2*z2
     &     + 5.D0*upx**(-1)*z2
     &     + 24.D0*upx**(-1)*y
     &     - 2.D0*upx**(-1)*y*z2
     &     + upx**(-1)*y**2*z2
     &     - 6.D0*Hr1(-1)
     &     - 16.D0*Hr1(-1)*umx**(-2)
     &     + 16.D0*Hr1(-1)*umx**(-2)*y
     &     + 16.D0*Hr1(-1)*umx**(-1)
     &     - 16.D0*Hr1(-1)*umx**(-1)*y
     &     + 12.D0*Hr1(-1)*upx**(-4)
     &     + 24.D0*Hr1(-1)*upx**(-4)*y
     &     + 12.D0*Hr1(-1)*upx**(-4)*y**2
     &     - 24.D0*Hr1(-1)*upx**(-3)
     &     - 48.D0*Hr1(-1)*upx**(-3)*y
     &     - 24.D0*Hr1(-1)*upx**(-3)*y**2
     &     + 12.D0*Hr1(-1)*upx**(-2)
     &     + 36.D0*Hr1(-1)*upx**(-2)*y
     &     + 12.D0*Hr1(-1)*upx**(-2)*y**2
     &     - 12.D0*Hr1(-1)*upx**(-1)*y
     &     - 8.D0*Hr1(-1)*HAr1(-1)
     &     - 32.D0*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     - 64.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     - 32.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     + 64.D0*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     + 128.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     + 64.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     - 32.D0*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     - 80.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     - 32.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     + 16.D0*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     + 24.D0*Hr1(-1)*HBr1(-1)
     &     + 32.D0*Hr1(-1)*HBr1(-1)*upx**(-4)
     &     + 64.D0*Hr1(-1)*HBr1(-1)*upx**(-4)*y
     &     + 32.D0*Hr1(-1)*HBr1(-1)*upx**(-4)*y**2
     &     - 64.D0*Hr1(-1)*HBr1(-1)*upx**(-3)
     &     - 128.D0*Hr1(-1)*HBr1(-1)*upx**(-3)*y
     &     - 64.D0*Hr1(-1)*HBr1(-1)*upx**(-3)*y**2
     &     + 64.D0*Hr1(-1)*HBr1(-1)*upx**(-2)
     &     + 112.D0*Hr1(-1)*HBr1(-1)*upx**(-2)*y
     &     + 32.D0*Hr1(-1)*HBr1(-1)*upx**(-2)*y**2
     &     - 32.D0*Hr1(-1)*HBr1(-1)*upx**(-1)
     &     - 48.D0*Hr1(-1)*HBr1(-1)*upx**(-1)*y
     &     - 4.D0*HAr1(-1)
     &     + 4.D0*HAr1(-1)*upx**(-2)*y**(-1)
     &     + 8.D0*HAr1(-1)*upx**(-2)
     &     + 4.D0*HAr1(-1)*upx**(-2)*y
     &     - 4.D0*HAr1(-1)*upx**(-1)*y**(-1)
     &     - 8.D0*HAr1(-1)*upx**(-1)
     &     - 4.D0*HAr1(-1)*upx**(-1)*y
     &     - 4.D0*HAr1(-1)*y**(-1)
     &     + 4.D0*HAr1(-1)*Hr1(0)
     &     + 16.D0*HAr1(-1)*Hr1(0)*upx**(-4)
     &     + 32.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     + 16.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     - 32.D0*HAr1(-1)*Hr1(0)*upx**(-3)
     &     - 64.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     - 32.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     + 16.D0*HAr1(-1)*Hr1(0)*upx**(-2)
     &     + 40.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     + 16.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     - 8.D0*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 8.D0*HBr1(-1)
     &     - 4.D0*HBr1(-1)*upx**(-2)*z**(-1)
     &     + 4.D0*HBr1(-1)*upx**(-2)*y
     &     + 4.D0*HBr1(-1)*upx**(-1)*z**(-1)
     &     - 4.D0*HBr1(-1)*upx**(-1)*y
     &     + 4.D0*HBr1(-1)*z**(-1)
     &     - 12.D0*HBr1(-1)*Hr1(0)
     &     - 16.D0*HBr1(-1)*Hr1(0)*upx**(-4)
     &     - 32.D0*HBr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 16.D0*HBr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 32.D0*HBr1(-1)*Hr1(0)*upx**(-3)
     &     + 64.D0*HBr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 32.D0*HBr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 32.D0*HBr1(-1)*Hr1(0)*upx**(-2)
     &     - 56.D0*HBr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 16.D0*HBr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 16.D0*HBr1(-1)*Hr1(0)*upx**(-1)
     &     + 24.D0*HBr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 24.D0*Hr2(-1,-1)
     &     - 16.D0*Hr2(-1,-1)*upx**(-4)
     &     - 32.D0*Hr2(-1,-1)*upx**(-4)*y
     &     - 16.D0*Hr2(-1,-1)*upx**(-4)*y**2
     &     + 32.D0*Hr2(-1,-1)*upx**(-3)
     &     + 64.D0*Hr2(-1,-1)*upx**(-3)*y
     &     + 32.D0*Hr2(-1,-1)*upx**(-3)*y**2
     &     - 48.D0*Hr2(-1,-1)*upx**(-2)
     &     - 80.D0*Hr2(-1,-1)*upx**(-2)*y
     &     - 16.D0*Hr2(-1,-1)*upx**(-2)*y**2
     &     + 32.D0*Hr2(-1,-1)*upx**(-1)
     &     + 48.D0*Hr2(-1,-1)*upx**(-1)*y
     &     - 8.D0*HAr2(-1,-1)
     &     - 16.D0*HAr2(-1,-1)*upx**(-2)*y
     &     + 16.D0*HAr2(-1,-1)*upx**(-1)*y
     &     - 8.D0*HBr2(-1,-1)
     &     - 32.D0*HBr2(-1,-1)*upx**(-2)
     &     - 16.D0*HBr2(-1,-1)*upx**(-2)*y
     &     + 32.D0*HBr2(-1,-1)*upx**(-1)
     &     + 16.D0*HBr2(-1,-1)*upx**(-1)*y
     &     + 12.D0*Hr2(-1,0)
     &     + 8.D0*Hr2(-1,0)*upx**(-4)
     &     + 16.D0*Hr2(-1,0)*upx**(-4)*y
     &     + 8.D0*Hr2(-1,0)*upx**(-4)*y**2
     &     - 16.D0*Hr2(-1,0)*upx**(-3)
     &     - 32.D0*Hr2(-1,0)*upx**(-3)*y
     &     - 16.D0*Hr2(-1,0)*upx**(-3)*y**2
     &     + 24.D0*Hr2(-1,0)*upx**(-2)
     &     + 40.D0*Hr2(-1,0)*upx**(-2)*y
     &     + 8.D0*Hr2(-1,0)*upx**(-2)*y**2
     &     - 16.D0*Hr2(-1,0)*upx**(-1)
     &     - 24.D0*Hr2(-1,0)*upx**(-1)*y
     &     + 4.D0*Hr1(0)
     &     + 8.D0*Hr1(0)*umx**(-2)
     &     - 8.D0*Hr1(0)*umx**(-2)*y
     &     - 25/4.D0*Hr1(0)*umx**(-1)
     &     + 17/2.D0*Hr1(0)*umx**(-1)*y
     &     - 1/4.D0*Hr1(0)*umx**(-1)*y**2
     &     - 8.D0*Hr1(0)*upx**(-5)
     &     - 16.D0*Hr1(0)*upx**(-5)*y
     &     - 8.D0*Hr1(0)*upx**(-5)*y**2
     &     + 14.D0*Hr1(0)*upx**(-4)
     &     + 28.D0*Hr1(0)*upx**(-4)*y
     &     + 14.D0*Hr1(0)*upx**(-4)*y**2
     &     - 5.D0*Hr1(0)*upx**(-3)
     &     - 18.D0*Hr1(0)*upx**(-3)*y
     &     - 5.D0*Hr1(0)*upx**(-3)*y**2
     &     - 1/2.D0*Hr1(0)*upx**(-2)
     &     + 5.D0*Hr1(0)*upx**(-2)*y
     &     - 1/2.D0*Hr1(0)*upx**(-2)*y**2
     &     - 17/4.D0*Hr1(0)*upx**(-1)
     &     + 1/2.D0*Hr1(0)*upx**(-1)*y
     &     - 1/4.D0*Hr1(0)*upx**(-1)*y**2
     &     + 4.D0*Hr2(0,-1)
     &     - 16.D0*Hr2(0,-1)*umx**(-3)
     &     + 16.D0*Hr2(0,-1)*umx**(-3)*y
     &     + 24.D0*Hr2(0,-1)*umx**(-2)
     &     - 24.D0*Hr2(0,-1)*umx**(-2)*y
     &     - 8.D0*Hr2(0,-1)*umx**(-1)
     &     + 8.D0*Hr2(0,-1)*upx**(-4)
     &     + 16.D0*Hr2(0,-1)*upx**(-4)*y
     &     + 8.D0*Hr2(0,-1)*upx**(-4)*y**2
     &     - 16.D0*Hr2(0,-1)*upx**(-3)*y
     &     - 16.D0*Hr2(0,-1)*upx**(-3)*y**2
     &     + 16.D0*Hr2(0,-1)*upx**(-2)*y
     &     + 8.D0*Hr2(0,-1)*upx**(-2)*y**2
     &     + 8.D0*Hr2(0,-1)*upx**(-1)
     &     - 8.D0*Hr2(0,-1)*upx**(-1)*y
     &     + 4.D0*HAr2(0,-1)
     &     + 8.D0*HAr2(0,-1)*upx**(-2)*y
     &     - 8.D0*HAr2(0,-1)*upx**(-1)*y
     &     + 4.D0*HBr2(0,-1)
     &     + 16.D0*HBr2(0,-1)*upx**(-2)
     &     + 8.D0*HBr2(0,-1)*upx**(-2)*y
     &     - 16.D0*HBr2(0,-1)*upx**(-1)
     &     - 8.D0*HBr2(0,-1)*upx**(-1)*y
     &     + 8.D0*Hr2(0,0)*umx**(-3)
     &     - 8.D0*Hr2(0,0)*umx**(-3)*y
     &     - 12.D0*Hr2(0,0)*umx**(-2)
     &     + 12.D0*Hr2(0,0)*umx**(-2)*y
     &     + 7/4.D0*Hr2(0,0)*umx**(-1)
     &     + 1/2.D0*Hr2(0,0)*umx**(-1)*y
     &     - 1/4.D0*Hr2(0,0)*umx**(-1)*y**2
     &     - 4.D0*Hr2(0,0)*upx**(-5)
     &     - 8.D0*Hr2(0,0)*upx**(-5)*y
     &     - 4.D0*Hr2(0,0)*upx**(-5)*y**2
     &     + 6.D0*Hr2(0,0)*upx**(-4)
     &     + 12.D0*Hr2(0,0)*upx**(-4)*y
     &     + 6.D0*Hr2(0,0)*upx**(-4)*y**2
     &     - 9.D0*Hr2(0,0)*upx**(-3)
     &     - 14.D0*Hr2(0,0)*upx**(-3)*y
     &     - Hr2(0,0)*upx**(-3)*y**2
     &     + 7/2.D0*Hr2(0,0)*upx**(-2)
     &     + 5.D0*Hr2(0,0)*upx**(-2)*y
     &     - 1/2.D0*Hr2(0,0)*upx**(-2)*y**2
     &     - 25/4.D0*Hr2(0,0)*upx**(-1)
     &     + 1/2.D0*Hr2(0,0)*upx**(-1)*y
     &     - 1/4.D0*Hr2(0,0)*upx**(-1)*y**2
     &     + 4.D0*Hr2(1,0)
     &     - 9/2.D0*Hr2(1,0)*umx**(-1)
     &     + Hr2(1,0)*umx**(-1)*y
     &     - 1/2.D0*Hr2(1,0)*umx**(-1)*y**2
     &     - 8.D0*Hr2(1,0)*upx**(-5)
     &     - 16.D0*Hr2(1,0)*upx**(-5)*y
     &     - 8.D0*Hr2(1,0)*upx**(-5)*y**2
     &     + 20.D0*Hr2(1,0)*upx**(-4)
     &     + 40.D0*Hr2(1,0)*upx**(-4)*y
     &     + 20.D0*Hr2(1,0)*upx**(-4)*y**2
     &     - 18.D0*Hr2(1,0)*upx**(-3)
     &     - 44.D0*Hr2(1,0)*upx**(-3)*y
     &     - 18.D0*Hr2(1,0)*upx**(-3)*y**2
     &     + 7.D0*Hr2(1,0)*upx**(-2)
     &     + 26.D0*Hr2(1,0)*upx**(-2)*y
     &     + 7.D0*Hr2(1,0)*upx**(-2)*y**2
     &     - 9/2.D0*Hr2(1,0)*upx**(-1)
     &     - 7.D0*Hr2(1,0)*upx**(-1)*y
     &     - 1/2.D0*Hr2(1,0)*upx**(-1)*y**2
     &     )
      T34PoleEP0qq = T34PoleEP0qq + Nc**(-1)*Nh * (
     &     + 20.D0/9.D0
     &     - 32/3.D0*upx**(-6)
     &     - 64/3.D0*upx**(-6)*y
     &     - 32/3.D0*upx**(-6)*y**2
     &     + 32.D0*upx**(-5)
     &     + 64.D0*upx**(-5)*y
     &     + 32.D0*upx**(-5)*y**2
     &     - 248/9.D0*upx**(-4)
     &     - 592/9.D0*upx**(-4)*y
     &     - 248/9.D0*upx**(-4)*y**2
     &     + 16/9.D0*upx**(-3)
     &     + 224/9.D0*upx**(-3)*y
     &     + 16/9.D0*upx**(-3)*y**2
     &     - 8/9.D0*upx**(-2)
     &     + 8/3.D0*upx**(-2)*y
     &     + 40/9.D0*upx**(-2)*y**2
     &     + 16/3.D0*upx**(-1)
     &     - 40/9.D0*upx**(-1)*y
     &     - 4/3.D0*Hr1(0)
     &     - 32/3.D0*Hr1(0)*upx**(-7)
     &     - 64/3.D0*Hr1(0)*upx**(-7)*y
     &     - 32/3.D0*Hr1(0)*upx**(-7)*y**2
     &     + 112/3.D0*Hr1(0)*upx**(-6)
     &     + 224/3.D0*Hr1(0)*upx**(-6)*y
     &     + 112/3.D0*Hr1(0)*upx**(-6)*y**2
     &     - 128/3.D0*Hr1(0)*upx**(-5)
     &     - 96.D0*Hr1(0)*upx**(-5)*y
     &     - 128/3.D0*Hr1(0)*upx**(-5)*y**2
     &     + 40/3.D0*Hr1(0)*upx**(-4)
     &     + 160/3.D0*Hr1(0)*upx**(-4)*y
     &     + 40/3.D0*Hr1(0)*upx**(-4)*y**2
     &     - 16/3.D0*Hr1(0)*upx**(-3)*y
     &     + 16/3.D0*Hr1(0)*upx**(-3)*y**2
     &     + 16/3.D0*Hr1(0)*upx**(-2)
     &     - 8.D0*Hr1(0)*upx**(-2)*y
     &     - 8/3.D0*Hr1(0)*upx**(-2)*y**2
     &     + 8/3.D0*Hr1(0)*upx**(-1)*y
     &     )
      T34PoleEP0qq = T34PoleEP0qq + Nc**(-1)*Nl * (
     &     + 20.D0/9.D0
     &     + 40/9.D0*upx**(-4)
     &     + 80/9.D0*upx**(-4)*y
     &     + 40/9.D0*upx**(-4)*y**2
     &     - 80/9.D0*upx**(-3)
     &     - 160/9.D0*upx**(-3)*y
     &     - 80/9.D0*upx**(-3)*y**2
     &     + 40/9.D0*upx**(-2)
     &     + 40/3.D0*upx**(-2)*y
     &     + 40/9.D0*upx**(-2)*y**2
     &     - 40/9.D0*upx**(-1)*y
     &     - 8/3.D0*Hr1(-1)
     &     - 16/3.D0*Hr1(-1)*upx**(-4)
     &     - 32/3.D0*Hr1(-1)*upx**(-4)*y
     &     - 16/3.D0*Hr1(-1)*upx**(-4)*y**2
     &     + 32/3.D0*Hr1(-1)*upx**(-3)
     &     + 64/3.D0*Hr1(-1)*upx**(-3)*y
     &     + 32/3.D0*Hr1(-1)*upx**(-3)*y**2
     &     - 16/3.D0*Hr1(-1)*upx**(-2)
     &     - 16.D0*Hr1(-1)*upx**(-2)*y
     &     - 16/3.D0*Hr1(-1)*upx**(-2)*y**2
     &     + 16/3.D0*Hr1(-1)*upx**(-1)*y
     &     + 4/3.D0*Hr1(0)
     &     + 8/3.D0*Hr1(0)*upx**(-4)
     &     + 16/3.D0*Hr1(0)*upx**(-4)*y
     &     + 8/3.D0*Hr1(0)*upx**(-4)*y**2
     &     - 16/3.D0*Hr1(0)*upx**(-3)
     &     - 32/3.D0*Hr1(0)*upx**(-3)*y
     &     - 16/3.D0*Hr1(0)*upx**(-3)*y**2
     &     + 8/3.D0*Hr1(0)*upx**(-2)
     &     + 8.D0*Hr1(0)*upx**(-2)*y
     &     + 8/3.D0*Hr1(0)*upx**(-2)*y**2
     &     - 8/3.D0*Hr1(0)*upx**(-1)*y
     &     + 4/3.D0*DLog(tm**(-2)*w**2)
     &     + 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)
     &     + 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     + 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     - 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)
     &     - 32/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     - 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     + 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)
     &     + 8.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     + 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     - 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T34PoleEP0qq = T34PoleEP0qq + (
     &     - 44.D0/9.D0
     &     - 6.D0*umx**(-5)*z2
     &     + 12.D0*umx**(-5)*y*z2
     &     - 6.D0*umx**(-5)*y**2*z2
     &     + 15.D0*umx**(-4)*z2
     &     - 30.D0*umx**(-4)*y*z2
     &     + 15.D0*umx**(-4)*y**2*z2
     &     - 47/2.D0*umx**(-3)*z2
     &     + 35.D0*umx**(-3)*y*z2
     &     - 19/2.D0*umx**(-3)*y**2*z2
     &     - umx**(-2)
     &     + 81/4.D0*umx**(-2)*z2
     &     + 2.D0*umx**(-2)*y
     &     - 45/2.D0*umx**(-2)*y*z2
     &     - umx**(-2)*y**2
     &     - 3/4.D0*umx**(-2)*y**2*z2
     &     + umx**(-1)
     &     - 145/8.D0*umx**(-1)*z2
     &     - 2.D0*umx**(-1)*y
     &     + 11/4.D0*umx**(-1)*y*z2
     &     + umx**(-1)*y**2
     &     - 9/8.D0*umx**(-1)*y**2*z2
     &     - 16.D0*upx**(-5)*z2
     &     - 32.D0*upx**(-5)*y*z2
     &     - 16.D0*upx**(-5)*y**2*z2
     &     + 128/9.D0*upx**(-4)
     &     + 20.D0*upx**(-4)*z2
     &     + 256/9.D0*upx**(-4)*y
     &     + 40.D0*upx**(-4)*y*z2
     &     + 128/9.D0*upx**(-4)*y**2
     &     + 20.D0*upx**(-4)*y**2*z2
     &     - 256/9.D0*upx**(-3)
     &     + 11.D0*upx**(-3)*z2
     &     - 512/9.D0*upx**(-3)*y
     &     - 4.D0*upx**(-3)*y*z2
     &     - 256/9.D0*upx**(-3)*y**2
     &     + upx**(-3)*y**2*z2
     &     + 119/9.D0*upx**(-2)
     &     - 17/2.D0*upx**(-2)*z2
     &     + 122/3.D0*upx**(-2)*y
     &     - 4.D0*upx**(-2)*y*z2
     &     + 119/9.D0*upx**(-2)*y**2
     &     - 3/2.D0*upx**(-2)*y**2*z2
     &     + upx**(-1)
     &     - 33/8.D0*upx**(-1)*z2
     &     - 110/9.D0*upx**(-1)*y
     &     + 11/4.D0*upx**(-1)*y*z2
     &     + upx**(-1)*y**2
     &     - 9/8.D0*upx**(-1)*y**2*z2
     &     + 38/3.D0*Hr1(-1)
     &     + 12.D0*Hr1(-1)*umx**(-4)
     &     - 24.D0*Hr1(-1)*umx**(-4)*y
     &     + 12.D0*Hr1(-1)*umx**(-4)*y**2
     &     - 24.D0*Hr1(-1)*umx**(-3)
     &     + 48.D0*Hr1(-1)*umx**(-3)*y
     &     - 24.D0*Hr1(-1)*umx**(-3)*y**2
     &     + 36.D0*Hr1(-1)*umx**(-2)
     &     - 48.D0*Hr1(-1)*umx**(-2)*y
     &     + 8.D0*Hr1(-1)*umx**(-2)*y**2
     &     - 24.D0*Hr1(-1)*umx**(-1)
     &     + 24.D0*Hr1(-1)*umx**(-1)*y
     &     + 4.D0*Hr1(-1)*umx**(-1)*y**2
     &     - 8/3.D0*Hr1(-1)*upx**(-4)
     &     - 16/3.D0*Hr1(-1)*upx**(-4)*y
     &     - 8/3.D0*Hr1(-1)*upx**(-4)*y**2
     &     + 16/3.D0*Hr1(-1)*upx**(-3)
     &     + 32/3.D0*Hr1(-1)*upx**(-3)*y
     &     + 16/3.D0*Hr1(-1)*upx**(-3)*y**2
     &     - 20/3.D0*Hr1(-1)*upx**(-2)
     &     - 16.D0*Hr1(-1)*upx**(-2)*y
     &     - 20/3.D0*Hr1(-1)*upx**(-2)*y**2
     &     + 4.D0*Hr1(-1)*upx**(-1)
     &     + 32/3.D0*Hr1(-1)*upx**(-1)*y
     &     + 4.D0*Hr1(-1)*upx**(-1)*y**2
     &     + 12.D0*Hr1(-1)*HAr1(-1)
     &     + 48.D0*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     + 96.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     + 48.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     - 96.D0*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     - 192.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     - 96.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     + 48.D0*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     + 120.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     + 48.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     - 24.D0*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     - 24.D0*Hr1(-1)*HBr1(-1)
     &     - 32.D0*Hr1(-1)*HBr1(-1)*upx**(-4)
     &     - 64.D0*Hr1(-1)*HBr1(-1)*upx**(-4)*y
     &     - 32.D0*Hr1(-1)*HBr1(-1)*upx**(-4)*y**2
     &     + 64.D0*Hr1(-1)*HBr1(-1)*upx**(-3)
     &     + 128.D0*Hr1(-1)*HBr1(-1)*upx**(-3)*y
     &     + 64.D0*Hr1(-1)*HBr1(-1)*upx**(-3)*y**2
     &     - 64.D0*Hr1(-1)*HBr1(-1)*upx**(-2)
     &     - 112.D0*Hr1(-1)*HBr1(-1)*upx**(-2)*y
     &     - 32.D0*Hr1(-1)*HBr1(-1)*upx**(-2)*y**2
     &     + 32.D0*Hr1(-1)*HBr1(-1)*upx**(-1)
     &     + 48.D0*Hr1(-1)*HBr1(-1)*upx**(-1)*y
     &     + 6.D0*HAr1(-1)
     &     - 6.D0*HAr1(-1)*upx**(-2)*y**(-1)
     &     - 12.D0*HAr1(-1)*upx**(-2)
     &     - 6.D0*HAr1(-1)*upx**(-2)*y
     &     + 6.D0*HAr1(-1)*upx**(-1)*y**(-1)
     &     + 12.D0*HAr1(-1)*upx**(-1)
     &     + 6.D0*HAr1(-1)*upx**(-1)*y
     &     + 6.D0*HAr1(-1)*y**(-1)
     &     - 6.D0*HAr1(-1)*Hr1(0)
     &     - 24.D0*HAr1(-1)*Hr1(0)*upx**(-4)
     &     - 48.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 24.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 48.D0*HAr1(-1)*Hr1(0)*upx**(-3)
     &     + 96.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 48.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 24.D0*HAr1(-1)*Hr1(0)*upx**(-2)
     &     - 60.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 24.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 12.D0*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 8.D0*HBr1(-1)
     &     + 4.D0*HBr1(-1)*upx**(-2)*z**(-1)
     &     - 4.D0*HBr1(-1)*upx**(-2)*y
     &     - 4.D0*HBr1(-1)*upx**(-1)*z**(-1)
     &     + 4.D0*HBr1(-1)*upx**(-1)*y
     &     - 4.D0*HBr1(-1)*z**(-1)
     &     + 12.D0*HBr1(-1)*Hr1(0)
     &     + 16.D0*HBr1(-1)*Hr1(0)*upx**(-4)
     &     + 32.D0*HBr1(-1)*Hr1(0)*upx**(-4)*y
     &     + 16.D0*HBr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     - 32.D0*HBr1(-1)*Hr1(0)*upx**(-3)
     &     - 64.D0*HBr1(-1)*Hr1(0)*upx**(-3)*y
     &     - 32.D0*HBr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     + 32.D0*HBr1(-1)*Hr1(0)*upx**(-2)
     &     + 56.D0*HBr1(-1)*Hr1(0)*upx**(-2)*y
     &     + 16.D0*HBr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     - 16.D0*HBr1(-1)*Hr1(0)*upx**(-1)
     &     - 24.D0*HBr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 20.D0*Hr2(-1,-1)
     &     + 32.D0*Hr2(-1,-1)*upx**(-2)
     &     + 40.D0*Hr2(-1,-1)*upx**(-2)*y
     &     - 32.D0*Hr2(-1,-1)*upx**(-1)
     &     - 40.D0*Hr2(-1,-1)*upx**(-1)*y
     &     + 12.D0*HAr2(-1,-1)
     &     + 24.D0*HAr2(-1,-1)*upx**(-2)*y
     &     - 24.D0*HAr2(-1,-1)*upx**(-1)*y
     &     + 8.D0*HBr2(-1,-1)
     &     + 32.D0*HBr2(-1,-1)*upx**(-2)
     &     + 16.D0*HBr2(-1,-1)*upx**(-2)*y
     &     - 32.D0*HBr2(-1,-1)*upx**(-1)
     &     - 16.D0*HBr2(-1,-1)*upx**(-1)*y
     &     - 10.D0*Hr2(-1,0)
     &     - 16.D0*Hr2(-1,0)*upx**(-2)
     &     - 20.D0*Hr2(-1,0)*upx**(-2)*y
     &     + 16.D0*Hr2(-1,0)*upx**(-1)
     &     + 20.D0*Hr2(-1,0)*upx**(-1)*y
     &     - 22/3.D0*Hr1(0)
     &     - 6.D0*Hr1(0)*umx**(-4)
     &     + 12.D0*Hr1(0)*umx**(-4)*y
     &     - 6.D0*Hr1(0)*umx**(-4)*y**2
     &     + 12.D0*Hr1(0)*umx**(-3)
     &     - 24.D0*Hr1(0)*umx**(-3)*y
     &     + 12.D0*Hr1(0)*umx**(-3)*y**2
     &     - 18.D0*Hr1(0)*umx**(-2)
     &     + 24.D0*Hr1(0)*umx**(-2)*y
     &     - 4.D0*Hr1(0)*umx**(-2)*y**2
     &     + 41/4.D0*Hr1(0)*umx**(-1)
     &     - 25/2.D0*Hr1(0)*umx**(-1)*y
     &     - 7/4.D0*Hr1(0)*umx**(-1)*y**2
     &     + 8.D0*Hr1(0)*upx**(-5)
     &     + 16.D0*Hr1(0)*upx**(-5)*y
     &     + 8.D0*Hr1(0)*upx**(-5)*y**2
     &     - 56/3.D0*Hr1(0)*upx**(-4)
     &     - 112/3.D0*Hr1(0)*upx**(-4)*y
     &     - 56/3.D0*Hr1(0)*upx**(-4)*y**2
     &     + 43/3.D0*Hr1(0)*upx**(-3)
     &     + 110/3.D0*Hr1(0)*upx**(-3)*y
     &     + 43/3.D0*Hr1(0)*upx**(-3)*y**2
     &     - 13/6.D0*Hr1(0)*upx**(-2)
     &     - 15.D0*Hr1(0)*upx**(-2)*y
     &     - 13/6.D0*Hr1(0)*upx**(-2)*y**2
     &     + 9/4.D0*Hr1(0)*upx**(-1)
     &     + 1/6.D0*Hr1(0)*upx**(-1)*y
     &     - 7/4.D0*Hr1(0)*upx**(-1)*y**2
     &     - 4.D0*Hr2(0,-1)
     &     + 12.D0*Hr2(0,-1)*umx**(-5)
     &     - 24.D0*Hr2(0,-1)*umx**(-5)*y
     &     + 12.D0*Hr2(0,-1)*umx**(-5)*y**2
     &     - 30.D0*Hr2(0,-1)*umx**(-4)
     &     + 60.D0*Hr2(0,-1)*umx**(-4)*y
     &     - 30.D0*Hr2(0,-1)*umx**(-4)*y**2
     &     + 47.D0*Hr2(0,-1)*umx**(-3)
     &     - 70.D0*Hr2(0,-1)*umx**(-3)*y
     &     + 19.D0*Hr2(0,-1)*umx**(-3)*y**2
     &     - 81/2.D0*Hr2(0,-1)*umx**(-2)
     &     + 45.D0*Hr2(0,-1)*umx**(-2)*y
     &     + 3/2.D0*Hr2(0,-1)*umx**(-2)*y**2
     &     + 73/4.D0*Hr2(0,-1)*umx**(-1)
     &     - 3/2.D0*Hr2(0,-1)*umx**(-1)*y
     &     + 1/4.D0*Hr2(0,-1)*umx**(-1)*y**2
     &     - 14.D0*Hr2(0,-1)*upx**(-3)
     &     - 8.D0*Hr2(0,-1)*upx**(-3)*y
     &     + 6.D0*Hr2(0,-1)*upx**(-3)*y**2
     &     + 5.D0*Hr2(0,-1)*upx**(-2)
     &     - 8.D0*Hr2(0,-1)*upx**(-2)*y
     &     - 9.D0*Hr2(0,-1)*upx**(-2)*y**2
     &     - 39/4.D0*Hr2(0,-1)*upx**(-1)
     &     + 13/2.D0*Hr2(0,-1)*upx**(-1)*y
     &     + 1/4.D0*Hr2(0,-1)*upx**(-1)*y**2
     &     - 6.D0*HAr2(0,-1)
     &     - 12.D0*HAr2(0,-1)*upx**(-2)*y
     &     + 12.D0*HAr2(0,-1)*upx**(-1)*y
     &     - 4.D0*HBr2(0,-1)
     &     - 16.D0*HBr2(0,-1)*upx**(-2)
     &     - 8.D0*HBr2(0,-1)*upx**(-2)*y
     &     + 16.D0*HBr2(0,-1)*upx**(-1)
     &     + 8.D0*HBr2(0,-1)*upx**(-1)*y
     &     - 6.D0*Hr2(0,0)*umx**(-5)
     &     + 12.D0*Hr2(0,0)*umx**(-5)*y
     &     - 6.D0*Hr2(0,0)*umx**(-5)*y**2
     &     + 15.D0*Hr2(0,0)*umx**(-4)
     &     - 30.D0*Hr2(0,0)*umx**(-4)*y
     &     + 15.D0*Hr2(0,0)*umx**(-4)*y**2
     &     - 47/2.D0*Hr2(0,0)*umx**(-3)
     &     + 35.D0*Hr2(0,0)*umx**(-3)*y
     &     - 19/2.D0*Hr2(0,0)*umx**(-3)*y**2
     &     + 81/4.D0*Hr2(0,0)*umx**(-2)
     &     - 45/2.D0*Hr2(0,0)*umx**(-2)*y
     &     - 3/4.D0*Hr2(0,0)*umx**(-2)*y**2
     &     - 55/8.D0*Hr2(0,0)*umx**(-1)
     &     + 1/4.D0*Hr2(0,0)*umx**(-1)*y
     &     + 1/8.D0*Hr2(0,0)*umx**(-1)*y**2
     &     + 4.D0*Hr2(0,0)*upx**(-5)
     &     + 8.D0*Hr2(0,0)*upx**(-5)*y
     &     + 4.D0*Hr2(0,0)*upx**(-5)*y**2
     &     - 10.D0*Hr2(0,0)*upx**(-4)
     &     - 20.D0*Hr2(0,0)*upx**(-4)*y
     &     - 10.D0*Hr2(0,0)*upx**(-4)*y**2
     &     + 16.D0*Hr2(0,0)*upx**(-3)
     &     + 26.D0*Hr2(0,0)*upx**(-3)*y
     &     + 6.D0*Hr2(0,0)*upx**(-3)*y**2
     &     - 6.D0*Hr2(0,0)*upx**(-2)
     &     - 9.D0*Hr2(0,0)*upx**(-2)*y
     &     + Hr2(0,0)*upx**(-2)*y**2
     &     + 57/8.D0*Hr2(0,0)*upx**(-1)
     &     + 1/4.D0*Hr2(0,0)*upx**(-1)*y
     &     + 1/8.D0*Hr2(0,0)*upx**(-1)*y**2
     &     - 4.D0*Hr2(1,0)
     &     + 9/2.D0*Hr2(1,0)*umx**(-1)
     &     - Hr2(1,0)*umx**(-1)*y
     &     + 1/2.D0*Hr2(1,0)*umx**(-1)*y**2
     &     + 8.D0*Hr2(1,0)*upx**(-5)
     &     + 16.D0*Hr2(1,0)*upx**(-5)*y
     &     + 8.D0*Hr2(1,0)*upx**(-5)*y**2
     &     - 20.D0*Hr2(1,0)*upx**(-4)
     &     - 40.D0*Hr2(1,0)*upx**(-4)*y
     &     - 20.D0*Hr2(1,0)*upx**(-4)*y**2
     &     + 18.D0*Hr2(1,0)*upx**(-3)
     &     + 44.D0*Hr2(1,0)*upx**(-3)*y
     &     + 18.D0*Hr2(1,0)*upx**(-3)*y**2
     &     - 7.D0*Hr2(1,0)*upx**(-2)
     &     - 26.D0*Hr2(1,0)*upx**(-2)*y
     &     - 7.D0*Hr2(1,0)*upx**(-2)*y**2
     &     + 9/2.D0*Hr2(1,0)*upx**(-1)
     &     + 7.D0*Hr2(1,0)*upx**(-1)*y
     &     + 1/2.D0*Hr2(1,0)*upx**(-1)*y**2
     &     - 22/3.D0*DLog(tm**(-2)*w**2)
     &     - 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)
     &     - 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     - 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     + 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)
     &     + 176/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     + 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     - 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)
     &     - 44.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     - 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     + 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T34PoleEP0qq = T34PoleEP0qq + Nc*Nh * (
     &     - 20.D0/9.D0
     &     + 32/3.D0*upx**(-6)
     &     + 64/3.D0*upx**(-6)*y
     &     + 32/3.D0*upx**(-6)*y**2
     &     - 32.D0*upx**(-5)
     &     - 64.D0*upx**(-5)*y
     &     - 32.D0*upx**(-5)*y**2
     &     + 248/9.D0*upx**(-4)
     &     + 592/9.D0*upx**(-4)*y
     &     + 248/9.D0*upx**(-4)*y**2
     &     - 16/9.D0*upx**(-3)
     &     - 224/9.D0*upx**(-3)*y
     &     - 16/9.D0*upx**(-3)*y**2
     &     + 8/9.D0*upx**(-2)
     &     - 8/3.D0*upx**(-2)*y
     &     - 40/9.D0*upx**(-2)*y**2
     &     - 16/3.D0*upx**(-1)
     &     + 40/9.D0*upx**(-1)*y
     &     + 4/3.D0*Hr1(0)
     &     + 32/3.D0*Hr1(0)*upx**(-7)
     &     + 64/3.D0*Hr1(0)*upx**(-7)*y
     &     + 32/3.D0*Hr1(0)*upx**(-7)*y**2
     &     - 112/3.D0*Hr1(0)*upx**(-6)
     &     - 224/3.D0*Hr1(0)*upx**(-6)*y
     &     - 112/3.D0*Hr1(0)*upx**(-6)*y**2
     &     + 128/3.D0*Hr1(0)*upx**(-5)
     &     + 96.D0*Hr1(0)*upx**(-5)*y
     &     + 128/3.D0*Hr1(0)*upx**(-5)*y**2
     &     - 40/3.D0*Hr1(0)*upx**(-4)
     &     - 160/3.D0*Hr1(0)*upx**(-4)*y
     &     - 40/3.D0*Hr1(0)*upx**(-4)*y**2
     &     + 16/3.D0*Hr1(0)*upx**(-3)*y
     &     - 16/3.D0*Hr1(0)*upx**(-3)*y**2
     &     - 16/3.D0*Hr1(0)*upx**(-2)
     &     + 8.D0*Hr1(0)*upx**(-2)*y
     &     + 8/3.D0*Hr1(0)*upx**(-2)*y**2
     &     - 8/3.D0*Hr1(0)*upx**(-1)*y
     &     )
      T34PoleEP0qq = T34PoleEP0qq + Nc*Nl * (
     &     - 20.D0/9.D0
     &     - 40/9.D0*upx**(-4)
     &     - 80/9.D0*upx**(-4)*y
     &     - 40/9.D0*upx**(-4)*y**2
     &     + 80/9.D0*upx**(-3)
     &     + 160/9.D0*upx**(-3)*y
     &     + 80/9.D0*upx**(-3)*y**2
     &     - 40/9.D0*upx**(-2)
     &     - 40/3.D0*upx**(-2)*y
     &     - 40/9.D0*upx**(-2)*y**2
     &     + 40/9.D0*upx**(-1)*y
     &     + 8/3.D0*Hr1(-1)
     &     + 16/3.D0*Hr1(-1)*upx**(-4)
     &     + 32/3.D0*Hr1(-1)*upx**(-4)*y
     &     + 16/3.D0*Hr1(-1)*upx**(-4)*y**2
     &     - 32/3.D0*Hr1(-1)*upx**(-3)
     &     - 64/3.D0*Hr1(-1)*upx**(-3)*y
     &     - 32/3.D0*Hr1(-1)*upx**(-3)*y**2
     &     + 16/3.D0*Hr1(-1)*upx**(-2)
     &     + 16.D0*Hr1(-1)*upx**(-2)*y
     &     + 16/3.D0*Hr1(-1)*upx**(-2)*y**2
     &     - 16/3.D0*Hr1(-1)*upx**(-1)*y
     &     - 4/3.D0*Hr1(0)
     &     - 8/3.D0*Hr1(0)*upx**(-4)
     &     - 16/3.D0*Hr1(0)*upx**(-4)*y
     &     - 8/3.D0*Hr1(0)*upx**(-4)*y**2
     &     + 16/3.D0*Hr1(0)*upx**(-3)
     &     + 32/3.D0*Hr1(0)*upx**(-3)*y
     &     + 16/3.D0*Hr1(0)*upx**(-3)*y**2
     &     - 8/3.D0*Hr1(0)*upx**(-2)
     &     - 8.D0*Hr1(0)*upx**(-2)*y
     &     - 8/3.D0*Hr1(0)*upx**(-2)*y**2
     &     + 8/3.D0*Hr1(0)*upx**(-1)*y
     &     - 4/3.D0*DLog(tm**(-2)*w**2)
     &     - 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)
     &     - 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     - 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     + 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)
     &     + 32/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     + 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     - 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)
     &     - 8.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     - 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     + 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T34PoleEP0qq = T34PoleEP0qq + Nc**2 * (
     &     + 107.D0/9.D0
     &     + 6.D0*umx**(-5)*z2
     &     - 12.D0*umx**(-5)*y*z2
     &     + 6.D0*umx**(-5)*y**2*z2
     &     - 15.D0*umx**(-4)*z2
     &     + 30.D0*umx**(-4)*y*z2
     &     - 15.D0*umx**(-4)*y**2*z2
     &     + 31/2.D0*umx**(-3)*z2
     &     - 27.D0*umx**(-3)*y*z2
     &     + 19/2.D0*umx**(-3)*y**2*z2
     &     + umx**(-2)
     &     - 33/4.D0*umx**(-2)*z2
     &     - 2.D0*umx**(-2)*y
     &     + 21/2.D0*umx**(-2)*y*z2
     &     + umx**(-2)*y**2
     &     + 3/4.D0*umx**(-2)*y**2*z2
     &     - umx**(-1)
     &     + 41/8.D0*umx**(-1)*z2
     &     + 2.D0*umx**(-1)*y
     &     - 3/4.D0*umx**(-1)*y*z2
     &     - umx**(-1)*y**2
     &     + 1/8.D0*umx**(-1)*y**2*z2
     &     + 88/9.D0*upx**(-4)
     &     + 4.D0*upx**(-4)*z2
     &     + 176/9.D0*upx**(-4)*y
     &     + 8.D0*upx**(-4)*y*z2
     &     + 88/9.D0*upx**(-4)*y**2
     &     + 4.D0*upx**(-4)*y**2*z2
     &     - 176/9.D0*upx**(-3)
     &     - 7.D0*upx**(-3)*z2
     &     - 352/9.D0*upx**(-3)*y
     &     - 12.D0*upx**(-3)*y*z2
     &     - 176/9.D0*upx**(-3)*y**2
     &     - 5.D0*upx**(-3)*y**2*z2
     &     + 97/9.D0*upx**(-2)
     &     + 5/2.D0*upx**(-2)*z2
     &     + 94/3.D0*upx**(-2)*y
     &     + 4.D0*upx**(-2)*y*z2
     &     + 97/9.D0*upx**(-2)*y**2
     &     - 1/2.D0*upx**(-2)*y**2*z2
     &     - upx**(-1)
     &     - 7/8.D0*upx**(-1)*z2
     &     - 106/9.D0*upx**(-1)*y
     &     - 3/4.D0*upx**(-1)*y*z2
     &     - upx**(-1)*y**2
     &     + 1/8.D0*upx**(-1)*y**2*z2
     &     - 20/3.D0*Hr1(-1)
     &     - 12.D0*Hr1(-1)*umx**(-4)
     &     + 24.D0*Hr1(-1)*umx**(-4)*y
     &     - 12.D0*Hr1(-1)*umx**(-4)*y**2
     &     + 24.D0*Hr1(-1)*umx**(-3)
     &     - 48.D0*Hr1(-1)*umx**(-3)*y
     &     + 24.D0*Hr1(-1)*umx**(-3)*y**2
     &     - 20.D0*Hr1(-1)*umx**(-2)
     &     + 32.D0*Hr1(-1)*umx**(-2)*y
     &     - 8.D0*Hr1(-1)*umx**(-2)*y**2
     &     + 8.D0*Hr1(-1)*umx**(-1)
     &     - 8.D0*Hr1(-1)*umx**(-1)*y
     &     - 4.D0*Hr1(-1)*umx**(-1)*y**2
     &     - 28/3.D0*Hr1(-1)*upx**(-4)
     &     - 56/3.D0*Hr1(-1)*upx**(-4)*y
     &     - 28/3.D0*Hr1(-1)*upx**(-4)*y**2
     &     + 56/3.D0*Hr1(-1)*upx**(-3)
     &     + 112/3.D0*Hr1(-1)*upx**(-3)*y
     &     + 56/3.D0*Hr1(-1)*upx**(-3)*y**2
     &     - 16/3.D0*Hr1(-1)*upx**(-2)
     &     - 20.D0*Hr1(-1)*upx**(-2)*y
     &     - 16/3.D0*Hr1(-1)*upx**(-2)*y**2
     &     - 4.D0*Hr1(-1)*upx**(-1)
     &     + 4/3.D0*Hr1(-1)*upx**(-1)*y
     &     - 4.D0*Hr1(-1)*upx**(-1)*y**2
     &     - 4.D0*Hr1(-1)*HAr1(-1)
     &     - 16.D0*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     - 32.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     - 16.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     + 32.D0*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     + 64.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     + 32.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     - 16.D0*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     - 40.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     - 16.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     + 8.D0*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     - 2.D0*HAr1(-1)
     &     + 2.D0*HAr1(-1)*upx**(-2)*y**(-1)
     &     + 4.D0*HAr1(-1)*upx**(-2)
     &     + 2.D0*HAr1(-1)*upx**(-2)*y
     &     - 2.D0*HAr1(-1)*upx**(-1)*y**(-1)
     &     - 4.D0*HAr1(-1)*upx**(-1)
     &     - 2.D0*HAr1(-1)*upx**(-1)*y
     &     - 2.D0*HAr1(-1)*y**(-1)
     &     + 2.D0*HAr1(-1)*Hr1(0)
     &     + 8.D0*HAr1(-1)*Hr1(0)*upx**(-4)
     &     + 16.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     + 8.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     - 16.D0*HAr1(-1)*Hr1(0)*upx**(-3)
     &     - 32.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     - 16.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     + 8.D0*HAr1(-1)*Hr1(0)*upx**(-2)
     &     + 20.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     + 8.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     - 4.D0*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 4.D0*Hr2(-1,-1)
     &     + 16.D0*Hr2(-1,-1)*upx**(-4)
     &     + 32.D0*Hr2(-1,-1)*upx**(-4)*y
     &     + 16.D0*Hr2(-1,-1)*upx**(-4)*y**2
     &     - 32.D0*Hr2(-1,-1)*upx**(-3)
     &     - 64.D0*Hr2(-1,-1)*upx**(-3)*y
     &     - 32.D0*Hr2(-1,-1)*upx**(-3)*y**2
     &     + 16.D0*Hr2(-1,-1)*upx**(-2)
     &     + 40.D0*Hr2(-1,-1)*upx**(-2)*y
     &     + 16.D0*Hr2(-1,-1)*upx**(-2)*y**2
     &     - 8.D0*Hr2(-1,-1)*upx**(-1)*y
     &     - 4.D0*HAr2(-1,-1)
     &     - 8.D0*HAr2(-1,-1)*upx**(-2)*y
     &     + 8.D0*HAr2(-1,-1)*upx**(-1)*y
     &     - 2.D0*Hr2(-1,0)
     &     - 8.D0*Hr2(-1,0)*upx**(-4)
     &     - 16.D0*Hr2(-1,0)*upx**(-4)*y
     &     - 8.D0*Hr2(-1,0)*upx**(-4)*y**2
     &     + 16.D0*Hr2(-1,0)*upx**(-3)
     &     + 32.D0*Hr2(-1,0)*upx**(-3)*y
     &     + 16.D0*Hr2(-1,0)*upx**(-3)*y**2
     &     - 8.D0*Hr2(-1,0)*upx**(-2)
     &     - 20.D0*Hr2(-1,0)*upx**(-2)*y
     &     - 8.D0*Hr2(-1,0)*upx**(-2)*y**2
     &     + 4.D0*Hr2(-1,0)*upx**(-1)*y
     &     + 10/3.D0*Hr1(0)
     &     + 6.D0*Hr1(0)*umx**(-4)
     &     - 12.D0*Hr1(0)*umx**(-4)*y
     &     + 6.D0*Hr1(0)*umx**(-4)*y**2
     &     - 12.D0*Hr1(0)*umx**(-3)
     &     + 24.D0*Hr1(0)*umx**(-3)*y
     &     - 12.D0*Hr1(0)*umx**(-3)*y**2
     &     + 10.D0*Hr1(0)*umx**(-2)
     &     - 16.D0*Hr1(0)*umx**(-2)*y
     &     + 4.D0*Hr1(0)*umx**(-2)*y**2
     &     - 4.D0*Hr1(0)*umx**(-1)
     &     + 4.D0*Hr1(0)*umx**(-1)*y
     &     + 2.D0*Hr1(0)*umx**(-1)*y**2
     &     + 14/3.D0*Hr1(0)*upx**(-4)
     &     + 28/3.D0*Hr1(0)*upx**(-4)*y
     &     + 14/3.D0*Hr1(0)*upx**(-4)*y**2
     &     - 28/3.D0*Hr1(0)*upx**(-3)
     &     - 56/3.D0*Hr1(0)*upx**(-3)*y
     &     - 28/3.D0*Hr1(0)*upx**(-3)*y**2
     &     + 8/3.D0*Hr1(0)*upx**(-2)
     &     + 10.D0*Hr1(0)*upx**(-2)*y
     &     + 8/3.D0*Hr1(0)*upx**(-2)*y**2
     &     + 2.D0*Hr1(0)*upx**(-1)
     &     - 2/3.D0*Hr1(0)*upx**(-1)*y
     &     + 2.D0*Hr1(0)*upx**(-1)*y**2
     &     - 12.D0*Hr2(0,-1)*umx**(-5)
     &     + 24.D0*Hr2(0,-1)*umx**(-5)*y
     &     - 12.D0*Hr2(0,-1)*umx**(-5)*y**2
     &     + 30.D0*Hr2(0,-1)*umx**(-4)
     &     - 60.D0*Hr2(0,-1)*umx**(-4)*y
     &     + 30.D0*Hr2(0,-1)*umx**(-4)*y**2
     &     - 31.D0*Hr2(0,-1)*umx**(-3)
     &     + 54.D0*Hr2(0,-1)*umx**(-3)*y
     &     - 19.D0*Hr2(0,-1)*umx**(-3)*y**2
     &     + 33/2.D0*Hr2(0,-1)*umx**(-2)
     &     - 21.D0*Hr2(0,-1)*umx**(-2)*y
     &     - 3/2.D0*Hr2(0,-1)*umx**(-2)*y**2
     &     - 41/4.D0*Hr2(0,-1)*umx**(-1)
     &     + 3/2.D0*Hr2(0,-1)*umx**(-1)*y
     &     - 1/4.D0*Hr2(0,-1)*umx**(-1)*y**2
     &     - 8.D0*Hr2(0,-1)*upx**(-4)
     &     - 16.D0*Hr2(0,-1)*upx**(-4)*y
     &     - 8.D0*Hr2(0,-1)*upx**(-4)*y**2
     &     + 14.D0*Hr2(0,-1)*upx**(-3)
     &     + 24.D0*Hr2(0,-1)*upx**(-3)*y
     &     + 10.D0*Hr2(0,-1)*upx**(-3)*y**2
     &     - 5.D0*Hr2(0,-1)*upx**(-2)
     &     - 8.D0*Hr2(0,-1)*upx**(-2)*y
     &     + Hr2(0,-1)*upx**(-2)*y**2
     &     + 7/4.D0*Hr2(0,-1)*upx**(-1)
     &     + 3/2.D0*Hr2(0,-1)*upx**(-1)*y
     &     - 1/4.D0*Hr2(0,-1)*upx**(-1)*y**2
     &     + 2.D0*HAr2(0,-1)
     &     + 4.D0*HAr2(0,-1)*upx**(-2)*y
     &     - 4.D0*HAr2(0,-1)*upx**(-1)*y
     &     + 6.D0*Hr2(0,0)*umx**(-5)
     &     - 12.D0*Hr2(0,0)*umx**(-5)*y
     &     + 6.D0*Hr2(0,0)*umx**(-5)*y**2
     &     - 15.D0*Hr2(0,0)*umx**(-4)
     &     + 30.D0*Hr2(0,0)*umx**(-4)*y
     &     - 15.D0*Hr2(0,0)*umx**(-4)*y**2
     &     + 31/2.D0*Hr2(0,0)*umx**(-3)
     &     - 27.D0*Hr2(0,0)*umx**(-3)*y
     &     + 19/2.D0*Hr2(0,0)*umx**(-3)*y**2
     &     - 33/4.D0*Hr2(0,0)*umx**(-2)
     &     + 21/2.D0*Hr2(0,0)*umx**(-2)*y
     &     + 3/4.D0*Hr2(0,0)*umx**(-2)*y**2
     &     + 41/8.D0*Hr2(0,0)*umx**(-1)
     &     - 3/4.D0*Hr2(0,0)*umx**(-1)*y
     &     + 1/8.D0*Hr2(0,0)*umx**(-1)*y**2
     &     + 4.D0*Hr2(0,0)*upx**(-4)
     &     + 8.D0*Hr2(0,0)*upx**(-4)*y
     &     + 4.D0*Hr2(0,0)*upx**(-4)*y**2
     &     - 7.D0*Hr2(0,0)*upx**(-3)
     &     - 12.D0*Hr2(0,0)*upx**(-3)*y
     &     - 5.D0*Hr2(0,0)*upx**(-3)*y**2
     &     + 5/2.D0*Hr2(0,0)*upx**(-2)
     &     + 4.D0*Hr2(0,0)*upx**(-2)*y
     &     - 1/2.D0*Hr2(0,0)*upx**(-2)*y**2
     &     - 7/8.D0*Hr2(0,0)*upx**(-1)
     &     - 3/4.D0*Hr2(0,0)*upx**(-1)*y
     &     + 1/8.D0*Hr2(0,0)*upx**(-1)*y**2
     &     + 22/3.D0*DLog(tm**(-2)*w**2)
     &     + 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)
     &     + 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     + 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     - 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)
     &     - 176/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     - 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     + 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)
     &     + 44.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     + 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     - 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      return
      end

*
*******************************************************************************
************************************************************************
************************************************************************
*
*          FUNCTIONS for the Cross Section
*
*************************************************************************
**************************** 72 characters *****************************
*
*
      double precision function T13PoleEPm2qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      T13PoleEPm2qq =  + Nc**(-2) * (
     &     - 16.D0
     &     - 32.D0*upx**(-4)
     &     - 64.D0*upx**(-4)*y
     &     - 32.D0*upx**(-4)*y**2
     &     + 64.D0*upx**(-3)
     &     + 128.D0*upx**(-3)*y
     &     + 64.D0*upx**(-3)*y**2
     &     - 32.D0*upx**(-2)
     &     - 96.D0*upx**(-2)*y
     &     - 32.D0*upx**(-2)*y**2
     &     + 32.D0*upx**(-1)*y
     &     )/4.D0
      T13PoleEPm2qq = T13PoleEPm2qq + (
     &     + 40.D0
     &     + 80.D0*upx**(-4)
     &     + 160.D0*upx**(-4)*y
     &     + 80.D0*upx**(-4)*y**2
     &     - 160.D0*upx**(-3)
     &     - 320.D0*upx**(-3)*y
     &     - 160.D0*upx**(-3)*y**2
     &     + 80.D0*upx**(-2)
     &     + 240.D0*upx**(-2)*y
     &     + 80.D0*upx**(-2)*y**2
     &     - 80.D0*upx**(-1)*y
     &     )/4.D0
      T13PoleEPm2qq = T13PoleEPm2qq + Nc**2 * (
     &     - 32.D0
     &     - 64.D0*upx**(-4)
     &     - 128.D0*upx**(-4)*y
     &     - 64.D0*upx**(-4)*y**2
     &     + 128.D0*upx**(-3)
     &     + 256.D0*upx**(-3)*y
     &     + 128.D0*upx**(-3)*y**2
     &     - 64.D0*upx**(-2)
     &     - 192.D0*upx**(-2)*y
     &     - 64.D0*upx**(-2)*y**2
     &     + 64.D0*upx**(-1)*y
     &     )/4.D0
      T13PoleEPm2qq = T13PoleEPm2qq + Nc**4 * (
     &     + 8.D0
     &     + 16.D0*upx**(-4)
     &     + 32.D0*upx**(-4)*y
     &     + 16.D0*upx**(-4)*y**2
     &     - 32.D0*upx**(-3)
     &     - 64.D0*upx**(-3)*y
     &     - 32.D0*upx**(-3)*y**2
     &     + 16.D0*upx**(-2)
     &     + 48.D0*upx**(-2)*y
     &     + 16.D0*upx**(-2)*y**2
     &     - 16.D0*upx**(-1)*y
     &     )/4.D0
      return
      end
*
*
*
      double precision function T13PoleEPm1qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      T13PoleEPm1qq =  + Nc**(-2) * (
     &     + 12.D0
     &     + 40.D0*upx**(-4)
     &     + 80.D0*upx**(-4)*y
     &     + 40.D0*upx**(-4)*y**2
     &     - 80.D0*upx**(-3)
     &     - 160.D0*upx**(-3)*y
     &     - 80.D0*upx**(-3)*y**2
     &     + 40.D0*upx**(-2)
     &     + 120.D0*upx**(-2)*y
     &     + 40.D0*upx**(-2)*y**2
     &     - 40.D0*upx**(-1)*y
     &     - 16.D0*Hr1(-1)
     &     - 32.D0*Hr1(-1)*upx**(-4)
     &     - 64.D0*Hr1(-1)*upx**(-4)*y
     &     - 32.D0*Hr1(-1)*upx**(-4)*y**2
     &     + 64.D0*Hr1(-1)*upx**(-3)
     &     + 128.D0*Hr1(-1)*upx**(-3)*y
     &     + 64.D0*Hr1(-1)*upx**(-3)*y**2
     &     - 32.D0*Hr1(-1)*upx**(-2)
     &     - 96.D0*Hr1(-1)*upx**(-2)*y
     &     - 32.D0*Hr1(-1)*upx**(-2)*y**2
     &     + 32.D0*Hr1(-1)*upx**(-1)*y
     &     - 24.D0*HAr1(-1)
     &     - 48.D0*HAr1(-1)*upx**(-4)
     &     - 96.D0*HAr1(-1)*upx**(-4)*y
     &     - 48.D0*HAr1(-1)*upx**(-4)*y**2
     &     + 96.D0*HAr1(-1)*upx**(-3)
     &     + 192.D0*HAr1(-1)*upx**(-3)*y
     &     + 96.D0*HAr1(-1)*upx**(-3)*y**2
     &     - 48.D0*HAr1(-1)*upx**(-2)
     &     - 144.D0*HAr1(-1)*upx**(-2)*y
     &     - 48.D0*HAr1(-1)*upx**(-2)*y**2
     &     + 48.D0*HAr1(-1)*upx**(-1)*y
     &     + 24.D0*HBr1(-1)
     &     + 48.D0*HBr1(-1)*upx**(-4)
     &     + 96.D0*HBr1(-1)*upx**(-4)*y
     &     + 48.D0*HBr1(-1)*upx**(-4)*y**2
     &     - 96.D0*HBr1(-1)*upx**(-3)
     &     - 192.D0*HBr1(-1)*upx**(-3)*y
     &     - 96.D0*HBr1(-1)*upx**(-3)*y**2
     &     + 48.D0*HBr1(-1)*upx**(-2)
     &     + 144.D0*HBr1(-1)*upx**(-2)*y
     &     + 48.D0*HBr1(-1)*upx**(-2)*y**2
     &     - 48.D0*HBr1(-1)*upx**(-1)*y
     &     + 9.D0*Hr1(0)*umx**(-1)
     &     - 2.D0*Hr1(0)*umx**(-1)*y
     &     + Hr1(0)*umx**(-1)*y**2
     &     + 16.D0*Hr1(0)*upx**(-5)
     &     + 32.D0*Hr1(0)*upx**(-5)*y
     &     + 16.D0*Hr1(0)*upx**(-5)*y**2
     &     - 24.D0*Hr1(0)*upx**(-4)
     &     - 48.D0*Hr1(0)*upx**(-4)*y
     &     - 24.D0*Hr1(0)*upx**(-4)*y**2
     &     + 4.D0*Hr1(0)*upx**(-3)
     &     + 24.D0*Hr1(0)*upx**(-3)*y
     &     + 4.D0*Hr1(0)*upx**(-3)*y**2
     &     + 2.D0*Hr1(0)*upx**(-2)
     &     - 4.D0*Hr1(0)*upx**(-2)*y
     &     + 2.D0*Hr1(0)*upx**(-2)*y**2
     &     + 9.D0*Hr1(0)*upx**(-1)
     &     - 2.D0*Hr1(0)*upx**(-1)*y
     &     + Hr1(0)*upx**(-1)*y**2
     &     )/(-2.D0)
      T13PoleEPm1qq = T13PoleEPm1qq + (
     &     - 30.D0
     &     - 100.D0*upx**(-4)
     &     - 200.D0*upx**(-4)*y
     &     - 100.D0*upx**(-4)*y**2
     &     + 200.D0*upx**(-3)
     &     + 400.D0*upx**(-3)*y
     &     + 200.D0*upx**(-3)*y**2
     &     - 100.D0*upx**(-2)
     &     - 300.D0*upx**(-2)*y
     &     - 100.D0*upx**(-2)*y**2
     &     + 100.D0*upx**(-1)*y
     &     + 24.D0*Hr1(-1)
     &     + 48.D0*Hr1(-1)*upx**(-4)
     &     + 96.D0*Hr1(-1)*upx**(-4)*y
     &     + 48.D0*Hr1(-1)*upx**(-4)*y**2
     &     - 96.D0*Hr1(-1)*upx**(-3)
     &     - 192.D0*Hr1(-1)*upx**(-3)*y
     &     - 96.D0*Hr1(-1)*upx**(-3)*y**2
     &     + 48.D0*Hr1(-1)*upx**(-2)
     &     + 144.D0*Hr1(-1)*upx**(-2)*y
     &     + 48.D0*Hr1(-1)*upx**(-2)*y**2
     &     - 48.D0*Hr1(-1)*upx**(-1)*y
     &     + 48.D0*HAr1(-1)
     &     + 96.D0*HAr1(-1)*upx**(-4)
     &     + 192.D0*HAr1(-1)*upx**(-4)*y
     &     + 96.D0*HAr1(-1)*upx**(-4)*y**2
     &     - 192.D0*HAr1(-1)*upx**(-3)
     &     - 384.D0*HAr1(-1)*upx**(-3)*y
     &     - 192.D0*HAr1(-1)*upx**(-3)*y**2
     &     + 96.D0*HAr1(-1)*upx**(-2)
     &     + 288.D0*HAr1(-1)*upx**(-2)*y
     &     + 96.D0*HAr1(-1)*upx**(-2)*y**2
     &     - 96.D0*HAr1(-1)*upx**(-1)*y
     &     - 32.D0*HBr1(-1)
     &     - 64.D0*HBr1(-1)*upx**(-4)
     &     - 128.D0*HBr1(-1)*upx**(-4)*y
     &     - 64.D0*HBr1(-1)*upx**(-4)*y**2
     &     + 128.D0*HBr1(-1)*upx**(-3)
     &     + 256.D0*HBr1(-1)*upx**(-3)*y
     &     + 128.D0*HBr1(-1)*upx**(-3)*y**2
     &     - 64.D0*HBr1(-1)*upx**(-2)
     &     - 192.D0*HBr1(-1)*upx**(-2)*y
     &     - 64.D0*HBr1(-1)*upx**(-2)*y**2
     &     + 64.D0*HBr1(-1)*upx**(-1)*y
     &     - 27/2.D0*Hr1(0)*umx**(-1)
     &     + 3.D0*Hr1(0)*umx**(-1)*y
     &     - 3/2.D0*Hr1(0)*umx**(-1)*y**2
     &     - 24.D0*Hr1(0)*upx**(-5)
     &     - 48.D0*Hr1(0)*upx**(-5)*y
     &     - 24.D0*Hr1(0)*upx**(-5)*y**2
     &     + 36.D0*Hr1(0)*upx**(-4)
     &     + 72.D0*Hr1(0)*upx**(-4)*y
     &     + 36.D0*Hr1(0)*upx**(-4)*y**2
     &     - 6.D0*Hr1(0)*upx**(-3)
     &     - 36.D0*Hr1(0)*upx**(-3)*y
     &     - 6.D0*Hr1(0)*upx**(-3)*y**2
     &     - 3.D0*Hr1(0)*upx**(-2)
     &     + 6.D0*Hr1(0)*upx**(-2)*y
     &     - 3.D0*Hr1(0)*upx**(-2)*y**2
     &     - 27/2.D0*Hr1(0)*upx**(-1)
     &     + 3.D0*Hr1(0)*upx**(-1)*y
     &     - 3/2.D0*Hr1(0)*upx**(-1)*y**2
     &     )/(-2.D0)
      T13PoleEPm1qq = T13PoleEPm1qq + Nc**2 * (
     &     + 24.D0
     &     + 80.D0*upx**(-4)
     &     + 160.D0*upx**(-4)*y
     &     + 80.D0*upx**(-4)*y**2
     &     - 160.D0*upx**(-3)
     &     - 320.D0*upx**(-3)*y
     &     - 160.D0*upx**(-3)*y**2
     &     + 80.D0*upx**(-2)
     &     + 240.D0*upx**(-2)*y
     &     + 80.D0*upx**(-2)*y**2
     &     - 80.D0*upx**(-1)*y
     &     - 8.D0*Hr1(-1)
     &     - 16.D0*Hr1(-1)*upx**(-4)
     &     - 32.D0*Hr1(-1)*upx**(-4)*y
     &     - 16.D0*Hr1(-1)*upx**(-4)*y**2
     &     + 32.D0*Hr1(-1)*upx**(-3)
     &     + 64.D0*Hr1(-1)*upx**(-3)*y
     &     + 32.D0*Hr1(-1)*upx**(-3)*y**2
     &     - 16.D0*Hr1(-1)*upx**(-2)
     &     - 48.D0*Hr1(-1)*upx**(-2)*y
     &     - 16.D0*Hr1(-1)*upx**(-2)*y**2
     &     + 16.D0*Hr1(-1)*upx**(-1)*y
     &     - 32.D0*HAr1(-1)
     &     - 64.D0*HAr1(-1)*upx**(-4)
     &     - 128.D0*HAr1(-1)*upx**(-4)*y
     &     - 64.D0*HAr1(-1)*upx**(-4)*y**2
     &     + 128.D0*HAr1(-1)*upx**(-3)
     &     + 256.D0*HAr1(-1)*upx**(-3)*y
     &     + 128.D0*HAr1(-1)*upx**(-3)*y**2
     &     - 64.D0*HAr1(-1)*upx**(-2)
     &     - 192.D0*HAr1(-1)*upx**(-2)*y
     &     - 64.D0*HAr1(-1)*upx**(-2)*y**2
     &     + 64.D0*HAr1(-1)*upx**(-1)*y
     &     + 8.D0*HBr1(-1)
     &     + 16.D0*HBr1(-1)*upx**(-4)
     &     + 32.D0*HBr1(-1)*upx**(-4)*y
     &     + 16.D0*HBr1(-1)*upx**(-4)*y**2
     &     - 32.D0*HBr1(-1)*upx**(-3)
     &     - 64.D0*HBr1(-1)*upx**(-3)*y
     &     - 32.D0*HBr1(-1)*upx**(-3)*y**2
     &     + 16.D0*HBr1(-1)*upx**(-2)
     &     + 48.D0*HBr1(-1)*upx**(-2)*y
     &     + 16.D0*HBr1(-1)*upx**(-2)*y**2
     &     - 16.D0*HBr1(-1)*upx**(-1)*y
     &     + 9/2.D0*Hr1(0)*umx**(-1)
     &     - Hr1(0)*umx**(-1)*y
     &     + 1/2.D0*Hr1(0)*umx**(-1)*y**2
     &     + 8.D0*Hr1(0)*upx**(-5)
     &     + 16.D0*Hr1(0)*upx**(-5)*y
     &     + 8.D0*Hr1(0)*upx**(-5)*y**2
     &     - 12.D0*Hr1(0)*upx**(-4)
     &     - 24.D0*Hr1(0)*upx**(-4)*y
     &     - 12.D0*Hr1(0)*upx**(-4)*y**2
     &     + 2.D0*Hr1(0)*upx**(-3)
     &     + 12.D0*Hr1(0)*upx**(-3)*y
     &     + 2.D0*Hr1(0)*upx**(-3)*y**2
     &     + Hr1(0)*upx**(-2)
     &     - 2.D0*Hr1(0)*upx**(-2)*y
     &     + Hr1(0)*upx**(-2)*y**2
     &     + 9/2.D0*Hr1(0)*upx**(-1)
     &     - Hr1(0)*upx**(-1)*y
     &     + 1/2.D0*Hr1(0)*upx**(-1)*y**2
     &     )/(-2.D0)
      T13PoleEPm1qq = T13PoleEPm1qq + Nc**4 * (
     &     - 6.D0
     &     - 20.D0*upx**(-4)
     &     - 40.D0*upx**(-4)*y
     &     - 20.D0*upx**(-4)*y**2
     &     + 40.D0*upx**(-3)
     &     + 80.D0*upx**(-3)*y
     &     + 40.D0*upx**(-3)*y**2
     &     - 20.D0*upx**(-2)
     &     - 60.D0*upx**(-2)*y
     &     - 20.D0*upx**(-2)*y**2
     &     + 20.D0*upx**(-1)*y
     &     + 8.D0*HAr1(-1)
     &     + 16.D0*HAr1(-1)*upx**(-4)
     &     + 32.D0*HAr1(-1)*upx**(-4)*y
     &     + 16.D0*HAr1(-1)*upx**(-4)*y**2
     &     - 32.D0*HAr1(-1)*upx**(-3)
     &     - 64.D0*HAr1(-1)*upx**(-3)*y
     &     - 32.D0*HAr1(-1)*upx**(-3)*y**2
     &     + 16.D0*HAr1(-1)*upx**(-2)
     &     + 48.D0*HAr1(-1)*upx**(-2)*y
     &     + 16.D0*HAr1(-1)*upx**(-2)*y**2
     &     - 16.D0*HAr1(-1)*upx**(-1)*y
     &     )/(-2.D0)
      
      return
      end
*
*
*
      double precision function T13PoleEP0qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1d0

* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      T13PoleEP0qq =  + Nc**(-2) * (
     &     - 14.D0
     &     + 12.D0*umx**(-3)*z2
     &     - 12.D0*umx**(-3)*y*z2
     &     - 18.D0*umx**(-2)*z2
     &     + 18.D0*umx**(-2)*y*z2
     &     + 24.D0*umx**(-1)*z2
     &     - 4.D0*umx**(-1)*y*z2
     &     + 2.D0*umx**(-1)*y**2*z2
     &     + 32.D0*upx**(-5)*z2
     &     + 64.D0*upx**(-5)*y*z2
     &     + 32.D0*upx**(-5)*y**2*z2
     &     - 48.D0*upx**(-4)
     &     - 48.D0*upx**(-4)*z2
     &     - 96.D0*upx**(-4)*y
     &     - 96.D0*upx**(-4)*y*z2
     &     - 48.D0*upx**(-4)*y**2
     &     - 48.D0*upx**(-4)*y**2*z2
     &     + 96.D0*upx**(-3)
     &     - 4.D0*upx**(-3)*z2
     &     + 192.D0*upx**(-3)*y
     &     + 36.D0*upx**(-3)*y*z2
     &     + 96.D0*upx**(-3)*y**2
     &     + 8.D0*upx**(-3)*y**2*z2
     &     - 48.D0*upx**(-2)
     &     + 10.D0*upx**(-2)*z2
     &     - 144.D0*upx**(-2)*y
     &     - 2.D0*upx**(-2)*y*z2
     &     - 48.D0*upx**(-2)*y**2
     &     + 4.D0*upx**(-2)*y**2*z2
     &     + 12.D0*upx**(-1)*z2
     &     + 48.D0*upx**(-1)*y
     &     - 4.D0*upx**(-1)*y*z2
     &     + 2.D0*upx**(-1)*y**2*z2
     &     - 8.D0*Hr1(-1)
     &     - 24.D0*Hr1(-1)*umx**(-2)
     &     + 24.D0*Hr1(-1)*umx**(-2)*y
     &     + 24.D0*Hr1(-1)*umx**(-1)
     &     - 24.D0*Hr1(-1)*umx**(-1)*y
     &     + 24.D0*Hr1(-1)*upx**(-4)
     &     + 48.D0*Hr1(-1)*upx**(-4)*y
     &     + 24.D0*Hr1(-1)*upx**(-4)*y**2
     &     - 48.D0*Hr1(-1)*upx**(-3)
     &     - 96.D0*Hr1(-1)*upx**(-3)*y
     &     - 48.D0*Hr1(-1)*upx**(-3)*y**2
     &     + 24.D0*Hr1(-1)*upx**(-2)
     &     + 72.D0*Hr1(-1)*upx**(-2)*y
     &     + 24.D0*Hr1(-1)*upx**(-2)*y**2
     &     - 24.D0*Hr1(-1)*upx**(-1)*y
     &     - 12.D0*Hr1(-1)*HAr1(-1)
     &     - 48.D0*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     - 96.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     - 48.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     + 96.D0*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     + 192.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     + 96.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     - 48.D0*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     - 120.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     - 48.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     + 24.D0*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     + 36.D0*Hr1(-1)*HBr1(-1)
     &     + 48.D0*Hr1(-1)*HBr1(-1)*upx**(-4)
     &     + 96.D0*Hr1(-1)*HBr1(-1)*upx**(-4)*y
     &     + 48.D0*Hr1(-1)*HBr1(-1)*upx**(-4)*y**2
     &     - 96.D0*Hr1(-1)*HBr1(-1)*upx**(-3)
     &     - 192.D0*Hr1(-1)*HBr1(-1)*upx**(-3)*y
     &     - 96.D0*Hr1(-1)*HBr1(-1)*upx**(-3)*y**2
     &     + 96.D0*Hr1(-1)*HBr1(-1)*upx**(-2)
     &     + 168.D0*Hr1(-1)*HBr1(-1)*upx**(-2)*y
     &     + 48.D0*Hr1(-1)*HBr1(-1)*upx**(-2)*y**2
     &     - 48.D0*Hr1(-1)*HBr1(-1)*upx**(-1)
     &     - 72.D0*Hr1(-1)*HBr1(-1)*upx**(-1)*y
     &     - 6.D0*HAr1(-1)
     &     + 6.D0*HAr1(-1)*upx**(-2)*y**(-1)
     &     + 12.D0*HAr1(-1)*upx**(-2)
     &     + 6.D0*HAr1(-1)*upx**(-2)*y
     &     - 6.D0*HAr1(-1)*upx**(-1)*y**(-1)
     &     - 12.D0*HAr1(-1)*upx**(-1)
     &     - 6.D0*HAr1(-1)*upx**(-1)*y
     &     - 6.D0*HAr1(-1)*y**(-1)
     &     + 6.D0*HAr1(-1)*Hr1(0)
     &     + 24.D0*HAr1(-1)*Hr1(0)*upx**(-4)
     &     + 48.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     + 24.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     - 48.D0*HAr1(-1)*Hr1(0)*upx**(-3)
     &     - 96.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     - 48.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     + 24.D0*HAr1(-1)*Hr1(0)*upx**(-2)
     &     + 60.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     + 24.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     - 12.D0*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 12.D0*HBr1(-1)
     &     - 6.D0*HBr1(-1)*upx**(-2)*z**(-1)
     &     + 6.D0*HBr1(-1)*upx**(-2)*y
     &     + 6.D0*HBr1(-1)*upx**(-1)*z**(-1)
     &     - 6.D0*HBr1(-1)*upx**(-1)*y
     &     + 6.D0*HBr1(-1)*z**(-1)
     &     - 18.D0*HBr1(-1)*Hr1(0)
     &     - 24.D0*HBr1(-1)*Hr1(0)*upx**(-4)
     &     - 48.D0*HBr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 24.D0*HBr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 48.D0*HBr1(-1)*Hr1(0)*upx**(-3)
     &     + 96.D0*HBr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 48.D0*HBr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 48.D0*HBr1(-1)*Hr1(0)*upx**(-2)
     &     - 84.D0*HBr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 24.D0*HBr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 24.D0*HBr1(-1)*Hr1(0)*upx**(-1)
     &     + 36.D0*HBr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 40.D0*Hr2(-1,-1)
     &     - 32.D0*Hr2(-1,-1)*upx**(-4)
     &     - 64.D0*Hr2(-1,-1)*upx**(-4)*y
     &     - 32.D0*Hr2(-1,-1)*upx**(-4)*y**2
     &     + 64.D0*Hr2(-1,-1)*upx**(-3)
     &     + 128.D0*Hr2(-1,-1)*upx**(-3)*y
     &     + 64.D0*Hr2(-1,-1)*upx**(-3)*y**2
     &     - 80.D0*Hr2(-1,-1)*upx**(-2)
     &     - 144.D0*Hr2(-1,-1)*upx**(-2)*y
     &     - 32.D0*Hr2(-1,-1)*upx**(-2)*y**2
     &     + 48.D0*Hr2(-1,-1)*upx**(-1)
     &     + 80.D0*Hr2(-1,-1)*upx**(-1)*y
     &     - 12.D0*HAr2(-1,-1)
     &     - 24.D0*HAr2(-1,-1)*upx**(-2)*y
     &     + 24.D0*HAr2(-1,-1)*upx**(-1)*y
     &     - 12.D0*HBr2(-1,-1)
     &     - 48.D0*HBr2(-1,-1)*upx**(-2)
     &     - 24.D0*HBr2(-1,-1)*upx**(-2)*y
     &     + 48.D0*HBr2(-1,-1)*upx**(-1)
     &     + 24.D0*HBr2(-1,-1)*upx**(-1)*y
     &     + 20.D0*Hr2(-1,0)
     &     + 16.D0*Hr2(-1,0)*upx**(-4)
     &     + 32.D0*Hr2(-1,0)*upx**(-4)*y
     &     + 16.D0*Hr2(-1,0)*upx**(-4)*y**2
     &     - 32.D0*Hr2(-1,0)*upx**(-3)
     &     - 64.D0*Hr2(-1,0)*upx**(-3)*y
     &     - 32.D0*Hr2(-1,0)*upx**(-3)*y**2
     &     + 40.D0*Hr2(-1,0)*upx**(-2)
     &     + 72.D0*Hr2(-1,0)*upx**(-2)*y
     &     + 16.D0*Hr2(-1,0)*upx**(-2)*y**2
     &     - 24.D0*Hr2(-1,0)*upx**(-1)
     &     - 40.D0*Hr2(-1,0)*upx**(-1)*y
     &     + 6.D0*Hr1(0)
     &     + 12.D0*Hr1(0)*umx**(-2)
     &     - 12.D0*Hr1(0)*umx**(-2)*y
     &     - 17/2.D0*Hr1(0)*umx**(-1)
     &     + 13.D0*Hr1(0)*umx**(-1)*y
     &     - 1/2.D0*Hr1(0)*umx**(-1)*y**2
     &     - 16.D0*Hr1(0)*upx**(-5)
     &     - 32.D0*Hr1(0)*upx**(-5)*y
     &     - 16.D0*Hr1(0)*upx**(-5)*y**2
     &     + 28.D0*Hr1(0)*upx**(-4)
     &     + 56.D0*Hr1(0)*upx**(-4)*y
     &     + 28.D0*Hr1(0)*upx**(-4)*y**2
     &     - 10.D0*Hr1(0)*upx**(-3)
     &     - 36.D0*Hr1(0)*upx**(-3)*y
     &     - 10.D0*Hr1(0)*upx**(-3)*y**2
     &     - Hr1(0)*upx**(-2)
     &     + 10.D0*Hr1(0)*upx**(-2)*y
     &     - Hr1(0)*upx**(-2)*y**2
     &     - 17/2.D0*Hr1(0)*upx**(-1)
     &     + Hr1(0)*upx**(-1)*y
     &     - 1/2.D0*Hr1(0)*upx**(-1)*y**2
     &     + 8.D0*Hr2(0,-1)
     &     - 24.D0*Hr2(0,-1)*umx**(-3)
     &     + 24.D0*Hr2(0,-1)*umx**(-3)*y
     &     + 36.D0*Hr2(0,-1)*umx**(-2)
     &     - 36.D0*Hr2(0,-1)*umx**(-2)*y
     &     - 12.D0*Hr2(0,-1)*umx**(-1)
     &     + 16.D0*Hr2(0,-1)*upx**(-4)
     &     + 32.D0*Hr2(0,-1)*upx**(-4)*y
     &     + 16.D0*Hr2(0,-1)*upx**(-4)*y**2
     &     - 8.D0*Hr2(0,-1)*upx**(-3)
     &     - 40.D0*Hr2(0,-1)*upx**(-3)*y
     &     - 32.D0*Hr2(0,-1)*upx**(-3)*y**2
     &     + 4.D0*Hr2(0,-1)*upx**(-2)
     &     + 36.D0*Hr2(0,-1)*upx**(-2)*y
     &     + 16.D0*Hr2(0,-1)*upx**(-2)*y**2
     &     + 12.D0*Hr2(0,-1)*upx**(-1)
     &     - 16.D0*Hr2(0,-1)*upx**(-1)*y
     &     + 6.D0*HAr2(0,-1)
     &     + 12.D0*HAr2(0,-1)*upx**(-2)*y
     &     - 12.D0*HAr2(0,-1)*upx**(-1)*y
     &     + 6.D0*HBr2(0,-1)
     &     + 24.D0*HBr2(0,-1)*upx**(-2)
     &     + 12.D0*HBr2(0,-1)*upx**(-2)*y
     &     - 24.D0*HBr2(0,-1)*upx**(-1)
     &     - 12.D0*HBr2(0,-1)*upx**(-1)*y
     &     + 12.D0*Hr2(0,0)*umx**(-3)
     &     - 12.D0*Hr2(0,0)*umx**(-3)*y
     &     - 18.D0*Hr2(0,0)*umx**(-2)
     &     + 18.D0*Hr2(0,0)*umx**(-2)*y
     &     + 3/2.D0*Hr2(0,0)*umx**(-1)
     &     + Hr2(0,0)*umx**(-1)*y
     &     - 1/2.D0*Hr2(0,0)*umx**(-1)*y**2
     &     - 8.D0*Hr2(0,0)*upx**(-5)
     &     - 16.D0*Hr2(0,0)*upx**(-5)*y
     &     - 8.D0*Hr2(0,0)*upx**(-5)*y**2
     &     + 12.D0*Hr2(0,0)*upx**(-4)
     &     + 24.D0*Hr2(0,0)*upx**(-4)*y
     &     + 12.D0*Hr2(0,0)*upx**(-4)*y**2
     &     - 14.D0*Hr2(0,0)*upx**(-3)
     &     - 24.D0*Hr2(0,0)*upx**(-3)*y
     &     - 2.D0*Hr2(0,0)*upx**(-3)*y**2
     &     + 5.D0*Hr2(0,0)*upx**(-2)
     &     + 8.D0*Hr2(0,0)*upx**(-2)*y
     &     - Hr2(0,0)*upx**(-2)*y**2
     &     - 21/2.D0*Hr2(0,0)*upx**(-1)
     &     + Hr2(0,0)*upx**(-1)*y
     &     - 1/2.D0*Hr2(0,0)*upx**(-1)*y**2
     &     + 8.D0*Hr2(1,0)
     &     - 9.D0*Hr2(1,0)*umx**(-1)
     &     + 2.D0*Hr2(1,0)*umx**(-1)*y
     &     - Hr2(1,0)*umx**(-1)*y**2
     &     - 16.D0*Hr2(1,0)*upx**(-5)
     &     - 32.D0*Hr2(1,0)*upx**(-5)*y
     &     - 16.D0*Hr2(1,0)*upx**(-5)*y**2
     &     + 40.D0*Hr2(1,0)*upx**(-4)
     &     + 80.D0*Hr2(1,0)*upx**(-4)*y
     &     + 40.D0*Hr2(1,0)*upx**(-4)*y**2
     &     - 36.D0*Hr2(1,0)*upx**(-3)
     &     - 88.D0*Hr2(1,0)*upx**(-3)*y
     &     - 36.D0*Hr2(1,0)*upx**(-3)*y**2
     &     + 14.D0*Hr2(1,0)*upx**(-2)
     &     + 52.D0*Hr2(1,0)*upx**(-2)*y
     &     + 14.D0*Hr2(1,0)*upx**(-2)*y**2
     &     - 9.D0*Hr2(1,0)*upx**(-1)
     &     - 14.D0*Hr2(1,0)*upx**(-1)*y
     &     - Hr2(1,0)*upx**(-1)*y**2
     &     )
      T13PoleEP0qq = T13PoleEP0qq + Nc**(-1)*Nh * (
     &     + 40.D0/9.D0
     &     - 64/3.D0*upx**(-6)
     &     - 128/3.D0*upx**(-6)*y
     &     - 64/3.D0*upx**(-6)*y**2
     &     + 64.D0*upx**(-5)
     &     + 128.D0*upx**(-5)*y
     &     + 64.D0*upx**(-5)*y**2
     &     - 496/9.D0*upx**(-4)
     &     - 1184/9.D0*upx**(-4)*y
     &     - 496/9.D0*upx**(-4)*y**2
     &     + 32/9.D0*upx**(-3)
     &     + 448/9.D0*upx**(-3)*y
     &     + 32/9.D0*upx**(-3)*y**2
     &     - 16/9.D0*upx**(-2)
     &     + 16/3.D0*upx**(-2)*y
     &     + 80/9.D0*upx**(-2)*y**2
     &     + 32/3.D0*upx**(-1)
     &     - 80/9.D0*upx**(-1)*y
     &     - 8/3.D0*Hr1(0)
     &     - 64/3.D0*Hr1(0)*upx**(-7)
     &     - 128/3.D0*Hr1(0)*upx**(-7)*y
     &     - 64/3.D0*Hr1(0)*upx**(-7)*y**2
     &     + 224/3.D0*Hr1(0)*upx**(-6)
     &     + 448/3.D0*Hr1(0)*upx**(-6)*y
     &     + 224/3.D0*Hr1(0)*upx**(-6)*y**2
     &     - 256/3.D0*Hr1(0)*upx**(-5)
     &     - 192.D0*Hr1(0)*upx**(-5)*y
     &     - 256/3.D0*Hr1(0)*upx**(-5)*y**2
     &     + 80/3.D0*Hr1(0)*upx**(-4)
     &     + 320/3.D0*Hr1(0)*upx**(-4)*y
     &     + 80/3.D0*Hr1(0)*upx**(-4)*y**2
     &     - 32/3.D0*Hr1(0)*upx**(-3)*y
     &     + 32/3.D0*Hr1(0)*upx**(-3)*y**2
     &     + 32/3.D0*Hr1(0)*upx**(-2)
     &     - 16.D0*Hr1(0)*upx**(-2)*y
     &     - 16/3.D0*Hr1(0)*upx**(-2)*y**2
     &     + 16/3.D0*Hr1(0)*upx**(-1)*y
     &     )
      T13PoleEP0qq = T13PoleEP0qq + Nc**(-1)*Nl * (
     &     + 40.D0/9.D0
     &     + 80/9.D0*upx**(-4)
     &     + 160/9.D0*upx**(-4)*y
     &     + 80/9.D0*upx**(-4)*y**2
     &     - 160/9.D0*upx**(-3)
     &     - 320/9.D0*upx**(-3)*y
     &     - 160/9.D0*upx**(-3)*y**2
     &     + 80/9.D0*upx**(-2)
     &     + 80/3.D0*upx**(-2)*y
     &     + 80/9.D0*upx**(-2)*y**2
     &     - 80/9.D0*upx**(-1)*y
     &     - 16/3.D0*Hr1(-1)
     &     - 32/3.D0*Hr1(-1)*upx**(-4)
     &     - 64/3.D0*Hr1(-1)*upx**(-4)*y
     &     - 32/3.D0*Hr1(-1)*upx**(-4)*y**2
     &     + 64/3.D0*Hr1(-1)*upx**(-3)
     &     + 128/3.D0*Hr1(-1)*upx**(-3)*y
     &     + 64/3.D0*Hr1(-1)*upx**(-3)*y**2
     &     - 32/3.D0*Hr1(-1)*upx**(-2)
     &     - 32.D0*Hr1(-1)*upx**(-2)*y
     &     - 32/3.D0*Hr1(-1)*upx**(-2)*y**2
     &     + 32/3.D0*Hr1(-1)*upx**(-1)*y
     &     + 8/3.D0*Hr1(0)
     &     + 16/3.D0*Hr1(0)*upx**(-4)
     &     + 32/3.D0*Hr1(0)*upx**(-4)*y
     &     + 16/3.D0*Hr1(0)*upx**(-4)*y**2
     &     - 32/3.D0*Hr1(0)*upx**(-3)
     &     - 64/3.D0*Hr1(0)*upx**(-3)*y
     &     - 32/3.D0*Hr1(0)*upx**(-3)*y**2
     &     + 16/3.D0*Hr1(0)*upx**(-2)
     &     + 16.D0*Hr1(0)*upx**(-2)*y
     &     + 16/3.D0*Hr1(0)*upx**(-2)*y**2
     &     - 16/3.D0*Hr1(0)*upx**(-1)*y
     &     + 8/3.D0*DLog(tm**(-2)*w**2)
     &     + 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)
     &     + 32/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     + 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     - 32/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)
     &     - 64/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     - 32/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     + 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)
     &     + 16.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     + 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     - 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T13PoleEP0qq = T13PoleEP0qq + (
     &     - 25.D0/9.D0
     &     - 12.D0*umx**(-5)*z2
     &     + 24.D0*umx**(-5)*y*z2
     &     - 12.D0*umx**(-5)*y**2*z2
     &     + 30.D0*umx**(-4)*z2
     &     - 60.D0*umx**(-4)*y*z2
     &     + 30.D0*umx**(-4)*y**2*z2
     &     - 47.D0*umx**(-3)*z2
     &     + 70.D0*umx**(-3)*y*z2
     &     - 19.D0*umx**(-3)*y**2*z2
     &     - 2.D0*umx**(-2)
     &     + 81/2.D0*umx**(-2)*z2
     &     + 4.D0*umx**(-2)*y
     &     - 45.D0*umx**(-2)*y*z2
     &     - 2.D0*umx**(-2)*y**2
     &     - 3/2.D0*umx**(-2)*y**2*z2
     &     + 2.D0*umx**(-1)
     &     - 181/4.D0*umx**(-1)*z2
     &     - 4.D0*umx**(-1)*y
     &     + 15/2.D0*umx**(-1)*y*z2
     &     + 2.D0*umx**(-1)*y**2
     &     - 13/4.D0*umx**(-1)*y**2*z2
     &     - 48.D0*upx**(-5)*z2
     &     - 96.D0*upx**(-5)*y*z2
     &     - 48.D0*upx**(-5)*y**2*z2
     &     + 472/9.D0*upx**(-4)
     &     + 64.D0*upx**(-4)*z2
     &     + 944/9.D0*upx**(-4)*y
     &     + 128.D0*upx**(-4)*y*z2
     &     + 472/9.D0*upx**(-4)*y**2
     &     + 64.D0*upx**(-4)*y**2*z2
     &     - 944/9.D0*upx**(-3)
     &     + 18.D0*upx**(-3)*z2
     &     - 1888/9.D0*upx**(-3)*y
     &     - 32.D0*upx**(-3)*y*z2
     &     - 944/9.D0*upx**(-3)*y**2
     &     - 2.D0*upx**(-3)*y**2*z2
     &     + 454/9.D0*upx**(-2)
     &     - 19.D0*upx**(-2)*z2
     &     + 460/3.D0*upx**(-2)*y
     &     - 4.D0*upx**(-2)*y*z2
     &     + 454/9.D0*upx**(-2)*y**2
     &     - 5.D0*upx**(-2)*y**2*z2
     &     + 2.D0*upx**(-1)
     &     - 69/4.D0*upx**(-1)*z2
     &     - 436/9.D0*upx**(-1)*y
     &     + 15/2.D0*upx**(-1)*y*z2
     &     + 2.D0*upx**(-1)*y**2
     &     - 13/4.D0*upx**(-1)*y**2*z2
     &     + 70/3.D0*Hr1(-1)
     &     + 24.D0*Hr1(-1)*umx**(-4)
     &     - 48.D0*Hr1(-1)*umx**(-4)*y
     &     + 24.D0*Hr1(-1)*umx**(-4)*y**2
     &     - 48.D0*Hr1(-1)*umx**(-3)
     &     + 96.D0*Hr1(-1)*umx**(-3)*y
     &     - 48.D0*Hr1(-1)*umx**(-3)*y**2
     &     + 72.D0*Hr1(-1)*umx**(-2)
     &     - 96.D0*Hr1(-1)*umx**(-2)*y
     &     + 16.D0*Hr1(-1)*umx**(-2)*y**2
     &     - 48.D0*Hr1(-1)*umx**(-1)
     &     + 48.D0*Hr1(-1)*umx**(-1)*y
     &     + 8.D0*Hr1(-1)*umx**(-1)*y**2
     &     - 52/3.D0*Hr1(-1)*upx**(-4)
     &     - 104/3.D0*Hr1(-1)*upx**(-4)*y
     &     - 52/3.D0*Hr1(-1)*upx**(-4)*y**2
     &     + 104/3.D0*Hr1(-1)*upx**(-3)
     &     + 208/3.D0*Hr1(-1)*upx**(-3)*y
     &     + 104/3.D0*Hr1(-1)*upx**(-3)*y**2
     &     - 76/3.D0*Hr1(-1)*upx**(-2)
     &     - 68.D0*Hr1(-1)*upx**(-2)*y
     &     - 76/3.D0*Hr1(-1)*upx**(-2)*y**2
     &     + 8.D0*Hr1(-1)*upx**(-1)
     &     + 100/3.D0*Hr1(-1)*upx**(-1)*y
     &     + 8.D0*Hr1(-1)*upx**(-1)*y**2
     &     + 24.D0*Hr1(-1)*HAr1(-1)
     &     + 96.D0*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     + 192.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     + 96.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     - 192.D0*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     - 384.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     - 192.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     + 96.D0*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     + 240.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     + 96.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     - 48.D0*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     - 48.D0*Hr1(-1)*HBr1(-1)
     &     - 64.D0*Hr1(-1)*HBr1(-1)*upx**(-4)
     &     - 128.D0*Hr1(-1)*HBr1(-1)*upx**(-4)*y
     &     - 64.D0*Hr1(-1)*HBr1(-1)*upx**(-4)*y**2
     &     + 128.D0*Hr1(-1)*HBr1(-1)*upx**(-3)
     &     + 256.D0*Hr1(-1)*HBr1(-1)*upx**(-3)*y
     &     + 128.D0*Hr1(-1)*HBr1(-1)*upx**(-3)*y**2
     &     - 128.D0*Hr1(-1)*HBr1(-1)*upx**(-2)
     &     - 224.D0*Hr1(-1)*HBr1(-1)*upx**(-2)*y
     &     - 64.D0*Hr1(-1)*HBr1(-1)*upx**(-2)*y**2
     &     + 64.D0*Hr1(-1)*HBr1(-1)*upx**(-1)
     &     + 96.D0*Hr1(-1)*HBr1(-1)*upx**(-1)*y
     &     + 12.D0*HAr1(-1)
     &     - 12.D0*HAr1(-1)*upx**(-2)*y**(-1)
     &     - 24.D0*HAr1(-1)*upx**(-2)
     &     - 12.D0*HAr1(-1)*upx**(-2)*y
     &     + 12.D0*HAr1(-1)*upx**(-1)*y**(-1)
     &     + 24.D0*HAr1(-1)*upx**(-1)
     &     + 12.D0*HAr1(-1)*upx**(-1)*y
     &     + 12.D0*HAr1(-1)*y**(-1)
     &     - 12.D0*HAr1(-1)*Hr1(0)
     &     - 48.D0*HAr1(-1)*Hr1(0)*upx**(-4)
     &     - 96.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 48.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 96.D0*HAr1(-1)*Hr1(0)*upx**(-3)
     &     + 192.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 96.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 48.D0*HAr1(-1)*Hr1(0)*upx**(-2)
     &     - 120.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 48.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 24.D0*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 16.D0*HBr1(-1)
     &     + 8.D0*HBr1(-1)*upx**(-2)*z**(-1)
     &     - 8.D0*HBr1(-1)*upx**(-2)*y
     &     - 8.D0*HBr1(-1)*upx**(-1)*z**(-1)
     &     + 8.D0*HBr1(-1)*upx**(-1)*y
     &     - 8.D0*HBr1(-1)*z**(-1)
     &     + 24.D0*HBr1(-1)*Hr1(0)
     &     + 32.D0*HBr1(-1)*Hr1(0)*upx**(-4)
     &     + 64.D0*HBr1(-1)*Hr1(0)*upx**(-4)*y
     &     + 32.D0*HBr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     - 64.D0*HBr1(-1)*Hr1(0)*upx**(-3)
     &     - 128.D0*HBr1(-1)*Hr1(0)*upx**(-3)*y
     &     - 64.D0*HBr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     + 64.D0*HBr1(-1)*Hr1(0)*upx**(-2)
     &     + 112.D0*HBr1(-1)*Hr1(0)*upx**(-2)*y
     &     + 32.D0*HBr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     - 32.D0*HBr1(-1)*Hr1(0)*upx**(-1)
     &     - 48.D0*HBr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 48.D0*Hr2(-1,-1)
     &     + 16.D0*Hr2(-1,-1)*upx**(-4)
     &     + 32.D0*Hr2(-1,-1)*upx**(-4)*y
     &     + 16.D0*Hr2(-1,-1)*upx**(-4)*y**2
     &     - 32.D0*Hr2(-1,-1)*upx**(-3)
     &     - 64.D0*Hr2(-1,-1)*upx**(-3)*y
     &     - 32.D0*Hr2(-1,-1)*upx**(-3)*y**2
     &     + 80.D0*Hr2(-1,-1)*upx**(-2)
     &     + 128.D0*Hr2(-1,-1)*upx**(-2)*y
     &     + 16.D0*Hr2(-1,-1)*upx**(-2)*y**2
     &     - 64.D0*Hr2(-1,-1)*upx**(-1)
     &     - 96.D0*Hr2(-1,-1)*upx**(-1)*y
     &     + 24.D0*HAr2(-1,-1)
     &     + 48.D0*HAr2(-1,-1)*upx**(-2)*y
     &     - 48.D0*HAr2(-1,-1)*upx**(-1)*y
     &     + 16.D0*HBr2(-1,-1)
     &     + 64.D0*HBr2(-1,-1)*upx**(-2)
     &     + 32.D0*HBr2(-1,-1)*upx**(-2)*y
     &     - 64.D0*HBr2(-1,-1)*upx**(-1)
     &     - 32.D0*HBr2(-1,-1)*upx**(-1)*y
     &     - 24.D0*Hr2(-1,0)
     &     - 8.D0*Hr2(-1,0)*upx**(-4)
     &     - 16.D0*Hr2(-1,0)*upx**(-4)*y
     &     - 8.D0*Hr2(-1,0)*upx**(-4)*y**2
     &     + 16.D0*Hr2(-1,0)*upx**(-3)
     &     + 32.D0*Hr2(-1,0)*upx**(-3)*y
     &     + 16.D0*Hr2(-1,0)*upx**(-3)*y**2
     &     - 40.D0*Hr2(-1,0)*upx**(-2)
     &     - 64.D0*Hr2(-1,0)*upx**(-2)*y
     &     - 8.D0*Hr2(-1,0)*upx**(-2)*y**2
     &     + 32.D0*Hr2(-1,0)*upx**(-1)
     &     + 48.D0*Hr2(-1,0)*upx**(-1)*y
     &     - 44/3.D0*Hr1(0)
     &     - 12.D0*Hr1(0)*umx**(-4)
     &     + 24.D0*Hr1(0)*umx**(-4)*y
     &     - 12.D0*Hr1(0)*umx**(-4)*y**2
     &     + 24.D0*Hr1(0)*umx**(-3)
     &     - 48.D0*Hr1(0)*umx**(-3)*y
     &     + 24.D0*Hr1(0)*umx**(-3)*y**2
     &     - 36.D0*Hr1(0)*umx**(-2)
     &     + 48.D0*Hr1(0)*umx**(-2)*y
     &     - 8.D0*Hr1(0)*umx**(-2)*y**2
     &     + 75/4.D0*Hr1(0)*umx**(-1)
     &     - 51/2.D0*Hr1(0)*umx**(-1)*y
     &     - 13/4.D0*Hr1(0)*umx**(-1)*y**2
     &     + 24.D0*Hr1(0)*upx**(-5)
     &     + 48.D0*Hr1(0)*upx**(-5)*y
     &     + 24.D0*Hr1(0)*upx**(-5)*y**2
     &     - 154/3.D0*Hr1(0)*upx**(-4)
     &     - 308/3.D0*Hr1(0)*upx**(-4)*y
     &     - 154/3.D0*Hr1(0)*upx**(-4)*y**2
     &     + 101/3.D0*Hr1(0)*upx**(-3)
     &     + 274/3.D0*Hr1(0)*upx**(-3)*y
     &     + 101/3.D0*Hr1(0)*upx**(-3)*y**2
     &     - 23/6.D0*Hr1(0)*upx**(-2)
     &     - 35.D0*Hr1(0)*upx**(-2)*y
     &     - 23/6.D0*Hr1(0)*upx**(-2)*y**2
     &     + 35/4.D0*Hr1(0)*upx**(-1)
     &     - 1/6.D0*Hr1(0)*upx**(-1)*y
     &     - 13/4.D0*Hr1(0)*upx**(-1)*y**2
     &     - 12.D0*Hr2(0,-1)
     &     + 24.D0*Hr2(0,-1)*umx**(-5)
     &     - 48.D0*Hr2(0,-1)*umx**(-5)*y
     &     + 24.D0*Hr2(0,-1)*umx**(-5)*y**2
     &     - 60.D0*Hr2(0,-1)*umx**(-4)
     &     + 120.D0*Hr2(0,-1)*umx**(-4)*y
     &     - 60.D0*Hr2(0,-1)*umx**(-4)*y**2
     &     + 94.D0*Hr2(0,-1)*umx**(-3)
     &     - 140.D0*Hr2(0,-1)*umx**(-3)*y
     &     + 38.D0*Hr2(0,-1)*umx**(-3)*y**2
     &     - 81.D0*Hr2(0,-1)*umx**(-2)
     &     + 90.D0*Hr2(0,-1)*umx**(-2)*y
     &     + 3.D0*Hr2(0,-1)*umx**(-2)*y**2
     &     + 73/2.D0*Hr2(0,-1)*umx**(-1)
     &     - 3.D0*Hr2(0,-1)*umx**(-1)*y
     &     + 1/2.D0*Hr2(0,-1)*umx**(-1)*y**2
     &     - 8.D0*Hr2(0,-1)*upx**(-4)
     &     - 16.D0*Hr2(0,-1)*upx**(-4)*y
     &     - 8.D0*Hr2(0,-1)*upx**(-4)*y**2
     &     - 12.D0*Hr2(0,-1)*upx**(-3)
     &     + 16.D0*Hr2(0,-1)*upx**(-3)*y
     &     + 28.D0*Hr2(0,-1)*upx**(-3)*y**2
     &     + 2.D0*Hr2(0,-1)*upx**(-2)
     &     - 40.D0*Hr2(0,-1)*upx**(-2)*y
     &     - 26.D0*Hr2(0,-1)*upx**(-2)*y**2
     &     - 39/2.D0*Hr2(0,-1)*upx**(-1)
     &     + 21.D0*Hr2(0,-1)*upx**(-1)*y
     &     + 1/2.D0*Hr2(0,-1)*upx**(-1)*y**2
     &     - 12.D0*HAr2(0,-1)
     &     - 24.D0*HAr2(0,-1)*upx**(-2)*y
     &     + 24.D0*HAr2(0,-1)*upx**(-1)*y
     &     - 8.D0*HBr2(0,-1)
     &     - 32.D0*HBr2(0,-1)*upx**(-2)
     &     - 16.D0*HBr2(0,-1)*upx**(-2)*y
     &     + 32.D0*HBr2(0,-1)*upx**(-1)
     &     + 16.D0*HBr2(0,-1)*upx**(-1)*y
     &     - 12.D0*Hr2(0,0)*umx**(-5)
     &     + 24.D0*Hr2(0,0)*umx**(-5)*y
     &     - 12.D0*Hr2(0,0)*umx**(-5)*y**2
     &     + 30.D0*Hr2(0,0)*umx**(-4)
     &     - 60.D0*Hr2(0,0)*umx**(-4)*y
     &     + 30.D0*Hr2(0,0)*umx**(-4)*y**2
     &     - 47.D0*Hr2(0,0)*umx**(-3)
     &     + 70.D0*Hr2(0,0)*umx**(-3)*y
     &     - 19.D0*Hr2(0,0)*umx**(-3)*y**2
     &     + 81/2.D0*Hr2(0,0)*umx**(-2)
     &     - 45.D0*Hr2(0,0)*umx**(-2)*y
     &     - 3/2.D0*Hr2(0,0)*umx**(-2)*y**2
     &     - 23/2.D0*Hr2(0,0)*umx**(-1)
     &     + 1/2.D0*Hr2(0,0)*umx**(-1)*y**2
     &     + 12.D0*Hr2(0,0)*upx**(-5)
     &     + 24.D0*Hr2(0,0)*upx**(-5)*y
     &     + 12.D0*Hr2(0,0)*upx**(-5)*y**2
     &     - 26.D0*Hr2(0,0)*upx**(-4)
     &     - 52.D0*Hr2(0,0)*upx**(-4)*y
     &     - 26.D0*Hr2(0,0)*upx**(-4)*y**2
     &     + 33.D0*Hr2(0,0)*upx**(-3)
     &     + 58.D0*Hr2(0,0)*upx**(-3)*y
     &     + 13.D0*Hr2(0,0)*upx**(-3)*y**2
     &     - 23/2.D0*Hr2(0,0)*upx**(-2)
     &     - 19.D0*Hr2(0,0)*upx**(-2)*y
     &     + 5/2.D0*Hr2(0,0)*upx**(-2)*y**2
     &     + 33/2.D0*Hr2(0,0)*upx**(-1)
     &     + 1/2.D0*Hr2(0,0)*upx**(-1)*y**2
     &     - 12.D0*Hr2(1,0)
     &     + 27/2.D0*Hr2(1,0)*umx**(-1)
     &     - 3.D0*Hr2(1,0)*umx**(-1)*y
     &     + 3/2.D0*Hr2(1,0)*umx**(-1)*y**2
     &     + 24.D0*Hr2(1,0)*upx**(-5)
     &     + 48.D0*Hr2(1,0)*upx**(-5)*y
     &     + 24.D0*Hr2(1,0)*upx**(-5)*y**2
     &     - 60.D0*Hr2(1,0)*upx**(-4)
     &     - 120.D0*Hr2(1,0)*upx**(-4)*y
     &     - 60.D0*Hr2(1,0)*upx**(-4)*y**2
     &     + 54.D0*Hr2(1,0)*upx**(-3)
     &     + 132.D0*Hr2(1,0)*upx**(-3)*y
     &     + 54.D0*Hr2(1,0)*upx**(-3)*y**2
     &     - 21.D0*Hr2(1,0)*upx**(-2)
     &     - 78.D0*Hr2(1,0)*upx**(-2)*y
     &     - 21.D0*Hr2(1,0)*upx**(-2)*y**2
     &     + 27/2.D0*Hr2(1,0)*upx**(-1)
     &     + 21.D0*Hr2(1,0)*upx**(-1)*y
     &     + 3/2.D0*Hr2(1,0)*upx**(-1)*y**2
     &     - 44/3.D0*DLog(tm**(-2)*w**2)
     &     - 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)
     &     - 176/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     - 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     + 176/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)
     &     + 352/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     + 176/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     - 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)
     &     - 88.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     - 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     + 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T13PoleEP0qq = T13PoleEP0qq + Nc*Nh * (
     &     - 20.D0/3.D0
     &     + 32.D0*upx**(-6)
     &     + 64.D0*upx**(-6)*y
     &     + 32.D0*upx**(-6)*y**2
     &     - 96.D0*upx**(-5)
     &     - 192.D0*upx**(-5)*y
     &     - 96.D0*upx**(-5)*y**2
     &     + 248/3.D0*upx**(-4)
     &     + 592/3.D0*upx**(-4)*y
     &     + 248/3.D0*upx**(-4)*y**2
     &     - 16/3.D0*upx**(-3)
     &     - 224/3.D0*upx**(-3)*y
     &     - 16/3.D0*upx**(-3)*y**2
     &     + 8/3.D0*upx**(-2)
     &     - 8.D0*upx**(-2)*y
     &     - 40/3.D0*upx**(-2)*y**2
     &     - 16.D0*upx**(-1)
     &     + 40/3.D0*upx**(-1)*y
     &     + 4.D0*Hr1(0)
     &     + 32.D0*Hr1(0)*upx**(-7)
     &     + 64.D0*Hr1(0)*upx**(-7)*y
     &     + 32.D0*Hr1(0)*upx**(-7)*y**2
     &     - 112.D0*Hr1(0)*upx**(-6)
     &     - 224.D0*Hr1(0)*upx**(-6)*y
     &     - 112.D0*Hr1(0)*upx**(-6)*y**2
     &     + 128.D0*Hr1(0)*upx**(-5)
     &     + 288.D0*Hr1(0)*upx**(-5)*y
     &     + 128.D0*Hr1(0)*upx**(-5)*y**2
     &     - 40.D0*Hr1(0)*upx**(-4)
     &     - 160.D0*Hr1(0)*upx**(-4)*y
     &     - 40.D0*Hr1(0)*upx**(-4)*y**2
     &     + 16.D0*Hr1(0)*upx**(-3)*y
     &     - 16.D0*Hr1(0)*upx**(-3)*y**2
     &     - 16.D0*Hr1(0)*upx**(-2)
     &     + 24.D0*Hr1(0)*upx**(-2)*y
     &     + 8.D0*Hr1(0)*upx**(-2)*y**2
     &     - 8.D0*Hr1(0)*upx**(-1)*y
     &     )
      T13PoleEP0qq = T13PoleEP0qq + Nc*Nl * (
     &     - 20.D0/3.D0
     &     - 40/3.D0*upx**(-4)
     &     - 80/3.D0*upx**(-4)*y
     &     - 40/3.D0*upx**(-4)*y**2
     &     + 80/3.D0*upx**(-3)
     &     + 160/3.D0*upx**(-3)*y
     &     + 80/3.D0*upx**(-3)*y**2
     &     - 40/3.D0*upx**(-2)
     &     - 40.D0*upx**(-2)*y
     &     - 40/3.D0*upx**(-2)*y**2
     &     + 40/3.D0*upx**(-1)*y
     &     + 8.D0*Hr1(-1)
     &     + 16.D0*Hr1(-1)*upx**(-4)
     &     + 32.D0*Hr1(-1)*upx**(-4)*y
     &     + 16.D0*Hr1(-1)*upx**(-4)*y**2
     &     - 32.D0*Hr1(-1)*upx**(-3)
     &     - 64.D0*Hr1(-1)*upx**(-3)*y
     &     - 32.D0*Hr1(-1)*upx**(-3)*y**2
     &     + 16.D0*Hr1(-1)*upx**(-2)
     &     + 48.D0*Hr1(-1)*upx**(-2)*y
     &     + 16.D0*Hr1(-1)*upx**(-2)*y**2
     &     - 16.D0*Hr1(-1)*upx**(-1)*y
     &     - 4.D0*Hr1(0)
     &     - 8.D0*Hr1(0)*upx**(-4)
     &     - 16.D0*Hr1(0)*upx**(-4)*y
     &     - 8.D0*Hr1(0)*upx**(-4)*y**2
     &     + 16.D0*Hr1(0)*upx**(-3)
     &     + 32.D0*Hr1(0)*upx**(-3)*y
     &     + 16.D0*Hr1(0)*upx**(-3)*y**2
     &     - 8.D0*Hr1(0)*upx**(-2)
     &     - 24.D0*Hr1(0)*upx**(-2)*y
     &     - 8.D0*Hr1(0)*upx**(-2)*y**2
     &     + 8.D0*Hr1(0)*upx**(-1)*y
     &     - 4.D0*DLog(tm**(-2)*w**2)
     &     - 8.D0*DLog(tm**(-2)*w**2)*upx**(-4)
     &     - 16.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     - 8.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     + 16.D0*DLog(tm**(-2)*w**2)*upx**(-3)
     &     + 32.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     + 16.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     - 8.D0*DLog(tm**(-2)*w**2)*upx**(-2)
     &     - 24.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     - 8.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     + 8.D0*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T13PoleEP0qq = T13PoleEP0qq + Nc**2 * (
     &     + 86.D0/3.D0
     &     + 18.D0*umx**(-5)*z2
     &     - 36.D0*umx**(-5)*y*z2
     &     + 18.D0*umx**(-5)*y**2*z2
     &     - 45.D0*umx**(-4)*z2
     &     + 90.D0*umx**(-4)*y*z2
     &     - 45.D0*umx**(-4)*y**2*z2
     &     + 101/2.D0*umx**(-3)*z2
     &     - 85.D0*umx**(-3)*y*z2
     &     + 57/2.D0*umx**(-3)*y**2*z2
     &     + 3.D0*umx**(-2)
     &     - 123/4.D0*umx**(-2)*z2
     &     - 6.D0*umx**(-2)*y
     &     + 75/2.D0*umx**(-2)*y*z2
     &     + 3.D0*umx**(-2)*y**2
     &     + 9/4.D0*umx**(-2)*y**2*z2
     &     - 3.D0*umx**(-1)
     &     + 211/8.D0*umx**(-1)*z2
     &     + 6.D0*umx**(-1)*y
     &     - 17/4.D0*umx**(-1)*y*z2
     &     - 3.D0*umx**(-1)*y**2
     &     + 11/8.D0*umx**(-1)*y**2*z2
     &     + 16.D0*upx**(-5)*z2
     &     + 32.D0*upx**(-5)*y*z2
     &     + 16.D0*upx**(-5)*y**2*z2
     &     + 16/3.D0*upx**(-4)
     &     - 12.D0*upx**(-4)*z2
     &     + 32/3.D0*upx**(-4)*y
     &     - 24.D0*upx**(-4)*y*z2
     &     + 16/3.D0*upx**(-4)*y**2
     &     - 12.D0*upx**(-4)*y**2*z2
     &     - 32/3.D0*upx**(-3)
     &     - 21.D0*upx**(-3)*z2
     &     - 64/3.D0*upx**(-3)*y
     &     - 16.D0*upx**(-3)*y*z2
     &     - 32/3.D0*upx**(-3)*y**2
     &     - 11.D0*upx**(-3)*y**2*z2
     &     + 25/3.D0*upx**(-2)
     &     + 23/2.D0*upx**(-2)*z2
     &     + 22.D0*upx**(-2)*y
     &     + 10.D0*upx**(-2)*y*z2
     &     + 25/3.D0*upx**(-2)*y**2
     &     + 1/2.D0*upx**(-2)*y**2*z2
     &     - 3.D0*upx**(-1)
     &     + 35/8.D0*upx**(-1)*z2
     &     - 34/3.D0*upx**(-1)*y
     &     - 17/4.D0*upx**(-1)*y*z2
     &     - 3.D0*upx**(-1)*y**2
     &     + 11/8.D0*upx**(-1)*y**2*z2
     &     - 22.D0*Hr1(-1)
     &     - 36.D0*Hr1(-1)*umx**(-4)
     &     + 72.D0*Hr1(-1)*umx**(-4)*y
     &     - 36.D0*Hr1(-1)*umx**(-4)*y**2
     &     + 72.D0*Hr1(-1)*umx**(-3)
     &     - 144.D0*Hr1(-1)*umx**(-3)*y
     &     + 72.D0*Hr1(-1)*umx**(-3)*y**2
     &     - 68.D0*Hr1(-1)*umx**(-2)
     &     + 104.D0*Hr1(-1)*umx**(-2)*y
     &     - 24.D0*Hr1(-1)*umx**(-2)*y**2
     &     + 32.D0*Hr1(-1)*umx**(-1)
     &     - 32.D0*Hr1(-1)*umx**(-1)*y
     &     - 12.D0*Hr1(-1)*umx**(-1)*y**2
     &     - 16.D0*Hr1(-1)*upx**(-4)
     &     - 32.D0*Hr1(-1)*upx**(-4)*y
     &     - 16.D0*Hr1(-1)*upx**(-4)*y**2
     &     + 32.D0*Hr1(-1)*upx**(-3)
     &     + 64.D0*Hr1(-1)*upx**(-3)*y
     &     + 32.D0*Hr1(-1)*upx**(-3)*y**2
     &     - 4.D0*Hr1(-1)*upx**(-2)
     &     - 24.D0*Hr1(-1)*upx**(-2)*y
     &     - 4.D0*Hr1(-1)*upx**(-2)*y**2
     &     - 12.D0*Hr1(-1)*upx**(-1)
     &     - 8.D0*Hr1(-1)*upx**(-1)*y
     &     - 12.D0*Hr1(-1)*upx**(-1)*y**2
     &     - 16.D0*Hr1(-1)*HAr1(-1)
     &     - 64.D0*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     - 128.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     - 64.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     + 128.D0*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     + 256.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     + 128.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     - 64.D0*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     - 160.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     - 64.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     + 32.D0*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     + 12.D0*Hr1(-1)*HBr1(-1)
     &     + 16.D0*Hr1(-1)*HBr1(-1)*upx**(-4)
     &     + 32.D0*Hr1(-1)*HBr1(-1)*upx**(-4)*y
     &     + 16.D0*Hr1(-1)*HBr1(-1)*upx**(-4)*y**2
     &     - 32.D0*Hr1(-1)*HBr1(-1)*upx**(-3)
     &     - 64.D0*Hr1(-1)*HBr1(-1)*upx**(-3)*y
     &     - 32.D0*Hr1(-1)*HBr1(-1)*upx**(-3)*y**2
     &     + 32.D0*Hr1(-1)*HBr1(-1)*upx**(-2)
     &     + 56.D0*Hr1(-1)*HBr1(-1)*upx**(-2)*y
     &     + 16.D0*Hr1(-1)*HBr1(-1)*upx**(-2)*y**2
     &     - 16.D0*Hr1(-1)*HBr1(-1)*upx**(-1)
     &     - 24.D0*Hr1(-1)*HBr1(-1)*upx**(-1)*y
     &     - 8.D0*HAr1(-1)
     &     + 8.D0*HAr1(-1)*upx**(-2)*y**(-1)
     &     + 16.D0*HAr1(-1)*upx**(-2)
     &     + 8.D0*HAr1(-1)*upx**(-2)*y
     &     - 8.D0*HAr1(-1)*upx**(-1)*y**(-1)
     &     - 16.D0*HAr1(-1)*upx**(-1)
     &     - 8.D0*HAr1(-1)*upx**(-1)*y
     &     - 8.D0*HAr1(-1)*y**(-1)
     &     + 8.D0*HAr1(-1)*Hr1(0)
     &     + 32.D0*HAr1(-1)*Hr1(0)*upx**(-4)
     &     + 64.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     + 32.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     - 64.D0*HAr1(-1)*Hr1(0)*upx**(-3)
     &     - 128.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     - 64.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     + 32.D0*HAr1(-1)*Hr1(0)*upx**(-2)
     &     + 80.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     + 32.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     - 16.D0*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 4.D0*HBr1(-1)
     &     - 2.D0*HBr1(-1)*upx**(-2)*z**(-1)
     &     + 2.D0*HBr1(-1)*upx**(-2)*y
     &     + 2.D0*HBr1(-1)*upx**(-1)*z**(-1)
     &     - 2.D0*HBr1(-1)*upx**(-1)*y
     &     + 2.D0*HBr1(-1)*z**(-1)
     &     - 6.D0*HBr1(-1)*Hr1(0)
     &     - 8.D0*HBr1(-1)*Hr1(0)*upx**(-4)
     &     - 16.D0*HBr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 8.D0*HBr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 16.D0*HBr1(-1)*Hr1(0)*upx**(-3)
     &     + 32.D0*HBr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 16.D0*HBr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 16.D0*HBr1(-1)*Hr1(0)*upx**(-2)
     &     - 28.D0*HBr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 8.D0*HBr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 8.D0*HBr1(-1)*Hr1(0)*upx**(-1)
     &     + 12.D0*HBr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 4.D0*Hr2(-1,-1)
     &     + 32.D0*Hr2(-1,-1)*upx**(-4)
     &     + 64.D0*Hr2(-1,-1)*upx**(-4)*y
     &     + 32.D0*Hr2(-1,-1)*upx**(-4)*y**2
     &     - 64.D0*Hr2(-1,-1)*upx**(-3)
     &     - 128.D0*Hr2(-1,-1)*upx**(-3)*y
     &     - 64.D0*Hr2(-1,-1)*upx**(-3)*y**2
     &     + 16.D0*Hr2(-1,-1)*upx**(-2)
     &     + 56.D0*Hr2(-1,-1)*upx**(-2)*y
     &     + 32.D0*Hr2(-1,-1)*upx**(-2)*y**2
     &     + 16.D0*Hr2(-1,-1)*upx**(-1)
     &     + 8.D0*Hr2(-1,-1)*upx**(-1)*y
     &     - 16.D0*HAr2(-1,-1)
     &     - 32.D0*HAr2(-1,-1)*upx**(-2)*y
     &     + 32.D0*HAr2(-1,-1)*upx**(-1)*y
     &     - 4.D0*HBr2(-1,-1)
     &     - 16.D0*HBr2(-1,-1)*upx**(-2)
     &     - 8.D0*HBr2(-1,-1)*upx**(-2)*y
     &     + 16.D0*HBr2(-1,-1)*upx**(-1)
     &     + 8.D0*HBr2(-1,-1)*upx**(-1)*y
     &     + 2.D0*Hr2(-1,0)
     &     - 16.D0*Hr2(-1,0)*upx**(-4)
     &     - 32.D0*Hr2(-1,0)*upx**(-4)*y
     &     - 16.D0*Hr2(-1,0)*upx**(-4)*y**2
     &     + 32.D0*Hr2(-1,0)*upx**(-3)
     &     + 64.D0*Hr2(-1,0)*upx**(-3)*y
     &     + 32.D0*Hr2(-1,0)*upx**(-3)*y**2
     &     - 8.D0*Hr2(-1,0)*upx**(-2)
     &     - 28.D0*Hr2(-1,0)*upx**(-2)*y
     &     - 16.D0*Hr2(-1,0)*upx**(-2)*y**2
     &     - 8.D0*Hr2(-1,0)*upx**(-1)
     &     - 4.D0*Hr2(-1,0)*upx**(-1)*y
     &     + 12.D0*Hr1(0)
     &     + 18.D0*Hr1(0)*umx**(-4)
     &     - 36.D0*Hr1(0)*umx**(-4)*y
     &     + 18.D0*Hr1(0)*umx**(-4)*y**2
     &     - 36.D0*Hr1(0)*umx**(-3)
     &     + 72.D0*Hr1(0)*umx**(-3)*y
     &     - 36.D0*Hr1(0)*umx**(-3)*y**2
     &     + 34.D0*Hr1(0)*umx**(-2)
     &     - 52.D0*Hr1(0)*umx**(-2)*y
     &     + 12.D0*Hr1(0)*umx**(-2)*y**2
     &     - 57/4.D0*Hr1(0)*umx**(-1)
     &     + 33/2.D0*Hr1(0)*umx**(-1)*y
     &     + 23/4.D0*Hr1(0)*umx**(-1)*y**2
     &     - 8.D0*Hr1(0)*upx**(-5)
     &     - 16.D0*Hr1(0)*upx**(-5)*y
     &     - 8.D0*Hr1(0)*upx**(-5)*y**2
     &     + 28.D0*Hr1(0)*upx**(-4)
     &     + 56.D0*Hr1(0)*upx**(-4)*y
     &     + 28.D0*Hr1(0)*upx**(-4)*y**2
     &     - 33.D0*Hr1(0)*upx**(-3)
     &     - 74.D0*Hr1(0)*upx**(-3)*y
     &     - 33.D0*Hr1(0)*upx**(-3)*y**2
     &     + 15/2.D0*Hr1(0)*upx**(-2)
     &     + 35.D0*Hr1(0)*upx**(-2)*y
     &     + 15/2.D0*Hr1(0)*upx**(-2)*y**2
     &     + 7/4.D0*Hr1(0)*upx**(-1)
     &     - 3/2.D0*Hr1(0)*upx**(-1)*y
     &     + 23/4.D0*Hr1(0)*upx**(-1)*y**2
     &     + 4.D0*Hr2(0,-1)
     &     - 36.D0*Hr2(0,-1)*umx**(-5)
     &     + 72.D0*Hr2(0,-1)*umx**(-5)*y
     &     - 36.D0*Hr2(0,-1)*umx**(-5)*y**2
     &     + 90.D0*Hr2(0,-1)*umx**(-4)
     &     - 180.D0*Hr2(0,-1)*umx**(-4)*y
     &     + 90.D0*Hr2(0,-1)*umx**(-4)*y**2
     &     - 101.D0*Hr2(0,-1)*umx**(-3)
     &     + 170.D0*Hr2(0,-1)*umx**(-3)*y
     &     - 57.D0*Hr2(0,-1)*umx**(-3)*y**2
     &     + 123/2.D0*Hr2(0,-1)*umx**(-2)
     &     - 75.D0*Hr2(0,-1)*umx**(-2)*y
     &     - 9/2.D0*Hr2(0,-1)*umx**(-2)*y**2
     &     - 139/4.D0*Hr2(0,-1)*umx**(-1)
     &     + 9/2.D0*Hr2(0,-1)*umx**(-1)*y
     &     - 3/4.D0*Hr2(0,-1)*umx**(-1)*y**2
     &     - 16.D0*Hr2(0,-1)*upx**(-4)
     &     - 32.D0*Hr2(0,-1)*upx**(-4)*y
     &     - 16.D0*Hr2(0,-1)*upx**(-4)*y**2
     &     + 34.D0*Hr2(0,-1)*upx**(-3)
     &     + 48.D0*Hr2(0,-1)*upx**(-3)*y
     &     + 14.D0*Hr2(0,-1)*upx**(-3)*y**2
     &     - 11.D0*Hr2(0,-1)*upx**(-2)
     &     - 4.D0*Hr2(0,-1)*upx**(-2)*y
     &     + 11.D0*Hr2(0,-1)*upx**(-2)*y**2
     &     + 37/4.D0*Hr2(0,-1)*upx**(-1)
     &     - 7/2.D0*Hr2(0,-1)*upx**(-1)*y
     &     - 3/4.D0*Hr2(0,-1)*upx**(-1)*y**2
     &     + 8.D0*HAr2(0,-1)
     &     + 16.D0*HAr2(0,-1)*upx**(-2)*y
     &     - 16.D0*HAr2(0,-1)*upx**(-1)*y
     &     + 2.D0*HBr2(0,-1)
     &     + 8.D0*HBr2(0,-1)*upx**(-2)
     &     + 4.D0*HBr2(0,-1)*upx**(-2)*y
     &     - 8.D0*HBr2(0,-1)*upx**(-1)
     &     - 4.D0*HBr2(0,-1)*upx**(-1)*y
     &     + 18.D0*Hr2(0,0)*umx**(-5)
     &     - 36.D0*Hr2(0,0)*umx**(-5)*y
     &     + 18.D0*Hr2(0,0)*umx**(-5)*y**2
     &     - 45.D0*Hr2(0,0)*umx**(-4)
     &     + 90.D0*Hr2(0,0)*umx**(-4)*y
     &     - 45.D0*Hr2(0,0)*umx**(-4)*y**2
     &     + 101/2.D0*Hr2(0,0)*umx**(-3)
     &     - 85.D0*Hr2(0,0)*umx**(-3)*y
     &     + 57/2.D0*Hr2(0,0)*umx**(-3)*y**2
     &     - 123/4.D0*Hr2(0,0)*umx**(-2)
     &     + 75/2.D0*Hr2(0,0)*umx**(-2)*y
     &     + 9/4.D0*Hr2(0,0)*umx**(-2)*y**2
     &     + 121/8.D0*Hr2(0,0)*umx**(-1)
     &     - 7/4.D0*Hr2(0,0)*umx**(-1)*y
     &     + 1/8.D0*Hr2(0,0)*umx**(-1)*y**2
     &     - 4.D0*Hr2(0,0)*upx**(-5)
     &     - 8.D0*Hr2(0,0)*upx**(-5)*y
     &     - 4.D0*Hr2(0,0)*upx**(-5)*y**2
     &     + 18.D0*Hr2(0,0)*upx**(-4)
     &     + 36.D0*Hr2(0,0)*upx**(-4)*y
     &     + 18.D0*Hr2(0,0)*upx**(-4)*y**2
     &     - 26.D0*Hr2(0,0)*upx**(-3)
     &     - 46.D0*Hr2(0,0)*upx**(-3)*y
     &     - 16.D0*Hr2(0,0)*upx**(-3)*y**2
     &     + 9.D0*Hr2(0,0)*upx**(-2)
     &     + 15.D0*Hr2(0,0)*upx**(-2)*y
     &     - 2.D0*Hr2(0,0)*upx**(-2)*y**2
     &     - 55/8.D0*Hr2(0,0)*upx**(-1)
     &     - 7/4.D0*Hr2(0,0)*upx**(-1)*y
     &     + 1/8.D0*Hr2(0,0)*upx**(-1)*y**2
     &     + 4.D0*Hr2(1,0)
     &     - 9/2.D0*Hr2(1,0)*umx**(-1)
     &     + Hr2(1,0)*umx**(-1)*y
     &     - 1/2.D0*Hr2(1,0)*umx**(-1)*y**2
     &     - 8.D0*Hr2(1,0)*upx**(-5)
     &     - 16.D0*Hr2(1,0)*upx**(-5)*y
     &     - 8.D0*Hr2(1,0)*upx**(-5)*y**2
     &     + 20.D0*Hr2(1,0)*upx**(-4)
     &     + 40.D0*Hr2(1,0)*upx**(-4)*y
     &     + 20.D0*Hr2(1,0)*upx**(-4)*y**2
     &     - 18.D0*Hr2(1,0)*upx**(-3)
     &     - 44.D0*Hr2(1,0)*upx**(-3)*y
     &     - 18.D0*Hr2(1,0)*upx**(-3)*y**2
     &     + 7.D0*Hr2(1,0)*upx**(-2)
     &     + 26.D0*Hr2(1,0)*upx**(-2)*y
     &     + 7.D0*Hr2(1,0)*upx**(-2)*y**2
     &     - 9/2.D0*Hr2(1,0)*upx**(-1)
     &     - 7.D0*Hr2(1,0)*upx**(-1)*y
     &     - 1/2.D0*Hr2(1,0)*upx**(-1)*y**2
     &     + 22.D0*DLog(tm**(-2)*w**2)
     &     + 44.D0*DLog(tm**(-2)*w**2)*upx**(-4)
     &     + 88.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     + 44.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     - 88.D0*DLog(tm**(-2)*w**2)*upx**(-3)
     &     - 176.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     - 88.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     + 44.D0*DLog(tm**(-2)*w**2)*upx**(-2)
     &     + 132.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     + 44.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     - 44.D0*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T13PoleEP0qq = T13PoleEP0qq + Nc**3*Nh * (
     &     + 20.D0/9.D0
     &     - 32/3.D0*upx**(-6)
     &     - 64/3.D0*upx**(-6)*y
     &     - 32/3.D0*upx**(-6)*y**2
     &     + 32.D0*upx**(-5)
     &     + 64.D0*upx**(-5)*y
     &     + 32.D0*upx**(-5)*y**2
     &     - 248/9.D0*upx**(-4)
     &     - 592/9.D0*upx**(-4)*y
     &     - 248/9.D0*upx**(-4)*y**2
     &     + 16/9.D0*upx**(-3)
     &     + 224/9.D0*upx**(-3)*y
     &     + 16/9.D0*upx**(-3)*y**2
     &     - 8/9.D0*upx**(-2)
     &     + 8/3.D0*upx**(-2)*y
     &     + 40/9.D0*upx**(-2)*y**2
     &     + 16/3.D0*upx**(-1)
     &     - 40/9.D0*upx**(-1)*y
     &     - 4/3.D0*Hr1(0)
     &     - 32/3.D0*Hr1(0)*upx**(-7)
     &     - 64/3.D0*Hr1(0)*upx**(-7)*y
     &     - 32/3.D0*Hr1(0)*upx**(-7)*y**2
     &     + 112/3.D0*Hr1(0)*upx**(-6)
     &     + 224/3.D0*Hr1(0)*upx**(-6)*y
     &     + 112/3.D0*Hr1(0)*upx**(-6)*y**2
     &     - 128/3.D0*Hr1(0)*upx**(-5)
     &     - 96.D0*Hr1(0)*upx**(-5)*y
     &     - 128/3.D0*Hr1(0)*upx**(-5)*y**2
     &     + 40/3.D0*Hr1(0)*upx**(-4)
     &     + 160/3.D0*Hr1(0)*upx**(-4)*y
     &     + 40/3.D0*Hr1(0)*upx**(-4)*y**2
     &     - 16/3.D0*Hr1(0)*upx**(-3)*y
     &     + 16/3.D0*Hr1(0)*upx**(-3)*y**2
     &     + 16/3.D0*Hr1(0)*upx**(-2)
     &     - 8.D0*Hr1(0)*upx**(-2)*y
     &     - 8/3.D0*Hr1(0)*upx**(-2)*y**2
     &     + 8/3.D0*Hr1(0)*upx**(-1)*y
     &     )
      T13PoleEP0qq = T13PoleEP0qq + Nc**3*Nl * (
     &     + 20.D0/9.D0
     &     + 40/9.D0*upx**(-4)
     &     + 80/9.D0*upx**(-4)*y
     &     + 40/9.D0*upx**(-4)*y**2
     &     - 80/9.D0*upx**(-3)
     &     - 160/9.D0*upx**(-3)*y
     &     - 80/9.D0*upx**(-3)*y**2
     &     + 40/9.D0*upx**(-2)
     &     + 40/3.D0*upx**(-2)*y
     &     + 40/9.D0*upx**(-2)*y**2
     &     - 40/9.D0*upx**(-1)*y
     &     - 8/3.D0*Hr1(-1)
     &     - 16/3.D0*Hr1(-1)*upx**(-4)
     &     - 32/3.D0*Hr1(-1)*upx**(-4)*y
     &     - 16/3.D0*Hr1(-1)*upx**(-4)*y**2
     &     + 32/3.D0*Hr1(-1)*upx**(-3)
     &     + 64/3.D0*Hr1(-1)*upx**(-3)*y
     &     + 32/3.D0*Hr1(-1)*upx**(-3)*y**2
     &     - 16/3.D0*Hr1(-1)*upx**(-2)
     &     - 16.D0*Hr1(-1)*upx**(-2)*y
     &     - 16/3.D0*Hr1(-1)*upx**(-2)*y**2
     &     + 16/3.D0*Hr1(-1)*upx**(-1)*y
     &     + 4/3.D0*Hr1(0)
     &     + 8/3.D0*Hr1(0)*upx**(-4)
     &     + 16/3.D0*Hr1(0)*upx**(-4)*y
     &     + 8/3.D0*Hr1(0)*upx**(-4)*y**2
     &     - 16/3.D0*Hr1(0)*upx**(-3)
     &     - 32/3.D0*Hr1(0)*upx**(-3)*y
     &     - 16/3.D0*Hr1(0)*upx**(-3)*y**2
     &     + 8/3.D0*Hr1(0)*upx**(-2)
     &     + 8.D0*Hr1(0)*upx**(-2)*y
     &     + 8/3.D0*Hr1(0)*upx**(-2)*y**2
     &     - 8/3.D0*Hr1(0)*upx**(-1)*y
     &     + 4/3.D0*DLog(tm**(-2)*w**2)
     &     + 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)
     &     + 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     + 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     - 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)
     &     - 32/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     - 16/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     + 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)
     &     + 8.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     + 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     - 8/3.D0*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T13PoleEP0qq = T13PoleEP0qq + Nc**4 * (
     &     - 107.D0/9.D0
     &     - 6.D0*umx**(-5)*z2
     &     + 12.D0*umx**(-5)*y*z2
     &     - 6.D0*umx**(-5)*y**2*z2
     &     + 15.D0*umx**(-4)*z2
     &     - 30.D0*umx**(-4)*y*z2
     &     + 15.D0*umx**(-4)*y**2*z2
     &     - 31/2.D0*umx**(-3)*z2
     &     + 27.D0*umx**(-3)*y*z2
     &     - 19/2.D0*umx**(-3)*y**2*z2
     &     - umx**(-2)
     &     + 33/4.D0*umx**(-2)*z2
     &     + 2.D0*umx**(-2)*y
     &     - 21/2.D0*umx**(-2)*y*z2
     &     - umx**(-2)*y**2
     &     - 3/4.D0*umx**(-2)*y**2*z2
     &     + umx**(-1)
     &     - 41/8.D0*umx**(-1)*z2
     &     - 2.D0*umx**(-1)*y
     &     + 3/4.D0*umx**(-1)*y*z2
     &     + umx**(-1)*y**2
     &     - 1/8.D0*umx**(-1)*y**2*z2
     &     - 88/9.D0*upx**(-4)
     &     - 4.D0*upx**(-4)*z2
     &     - 176/9.D0*upx**(-4)*y
     &     - 8.D0*upx**(-4)*y*z2
     &     - 88/9.D0*upx**(-4)*y**2
     &     - 4.D0*upx**(-4)*y**2*z2
     &     + 176/9.D0*upx**(-3)
     &     + 7.D0*upx**(-3)*z2
     &     + 352/9.D0*upx**(-3)*y
     &     + 12.D0*upx**(-3)*y*z2
     &     + 176/9.D0*upx**(-3)*y**2
     &     + 5.D0*upx**(-3)*y**2*z2
     &     - 97/9.D0*upx**(-2)
     &     - 5/2.D0*upx**(-2)*z2
     &     - 94/3.D0*upx**(-2)*y
     &     - 4.D0*upx**(-2)*y*z2
     &     - 97/9.D0*upx**(-2)*y**2
     &     + 1/2.D0*upx**(-2)*y**2*z2
     &     + upx**(-1)
     &     + 7/8.D0*upx**(-1)*z2
     &     + 106/9.D0*upx**(-1)*y
     &     + 3/4.D0*upx**(-1)*y*z2
     &     + upx**(-1)*y**2
     &     - 1/8.D0*upx**(-1)*y**2*z2
     &     + 20/3.D0*Hr1(-1)
     &     + 12.D0*Hr1(-1)*umx**(-4)
     &     - 24.D0*Hr1(-1)*umx**(-4)*y
     &     + 12.D0*Hr1(-1)*umx**(-4)*y**2
     &     - 24.D0*Hr1(-1)*umx**(-3)
     &     + 48.D0*Hr1(-1)*umx**(-3)*y
     &     - 24.D0*Hr1(-1)*umx**(-3)*y**2
     &     + 20.D0*Hr1(-1)*umx**(-2)
     &     - 32.D0*Hr1(-1)*umx**(-2)*y
     &     + 8.D0*Hr1(-1)*umx**(-2)*y**2
     &     - 8.D0*Hr1(-1)*umx**(-1)
     &     + 8.D0*Hr1(-1)*umx**(-1)*y
     &     + 4.D0*Hr1(-1)*umx**(-1)*y**2
     &     + 28/3.D0*Hr1(-1)*upx**(-4)
     &     + 56/3.D0*Hr1(-1)*upx**(-4)*y
     &     + 28/3.D0*Hr1(-1)*upx**(-4)*y**2
     &     - 56/3.D0*Hr1(-1)*upx**(-3)
     &     - 112/3.D0*Hr1(-1)*upx**(-3)*y
     &     - 56/3.D0*Hr1(-1)*upx**(-3)*y**2
     &     + 16/3.D0*Hr1(-1)*upx**(-2)
     &     + 20.D0*Hr1(-1)*upx**(-2)*y
     &     + 16/3.D0*Hr1(-1)*upx**(-2)*y**2
     &     + 4.D0*Hr1(-1)*upx**(-1)
     &     - 4/3.D0*Hr1(-1)*upx**(-1)*y
     &     + 4.D0*Hr1(-1)*upx**(-1)*y**2
     &     + 4.D0*Hr1(-1)*HAr1(-1)
     &     + 16.D0*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     + 32.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     + 16.D0*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     - 32.D0*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     - 64.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     - 32.D0*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     + 16.D0*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     + 40.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     + 16.D0*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     - 8.D0*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     + 2.D0*HAr1(-1)
     &     - 2.D0*HAr1(-1)*upx**(-2)*y**(-1)
     &     - 4.D0*HAr1(-1)*upx**(-2)
     &     - 2.D0*HAr1(-1)*upx**(-2)*y
     &     + 2.D0*HAr1(-1)*upx**(-1)*y**(-1)
     &     + 4.D0*HAr1(-1)*upx**(-1)
     &     + 2.D0*HAr1(-1)*upx**(-1)*y
     &     + 2.D0*HAr1(-1)*y**(-1)
     &     - 2.D0*HAr1(-1)*Hr1(0)
     &     - 8.D0*HAr1(-1)*Hr1(0)*upx**(-4)
     &     - 16.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 8.D0*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 16.D0*HAr1(-1)*Hr1(0)*upx**(-3)
     &     + 32.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 16.D0*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 8.D0*HAr1(-1)*Hr1(0)*upx**(-2)
     &     - 20.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 8.D0*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 4.D0*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 4.D0*Hr2(-1,-1)
     &     - 16.D0*Hr2(-1,-1)*upx**(-4)
     &     - 32.D0*Hr2(-1,-1)*upx**(-4)*y
     &     - 16.D0*Hr2(-1,-1)*upx**(-4)*y**2
     &     + 32.D0*Hr2(-1,-1)*upx**(-3)
     &     + 64.D0*Hr2(-1,-1)*upx**(-3)*y
     &     + 32.D0*Hr2(-1,-1)*upx**(-3)*y**2
     &     - 16.D0*Hr2(-1,-1)*upx**(-2)
     &     - 40.D0*Hr2(-1,-1)*upx**(-2)*y
     &     - 16.D0*Hr2(-1,-1)*upx**(-2)*y**2
     &     + 8.D0*Hr2(-1,-1)*upx**(-1)*y
     &     + 4.D0*HAr2(-1,-1)
     &     + 8.D0*HAr2(-1,-1)*upx**(-2)*y
     &     - 8.D0*HAr2(-1,-1)*upx**(-1)*y
     &     + 2.D0*Hr2(-1,0)
     &     + 8.D0*Hr2(-1,0)*upx**(-4)
     &     + 16.D0*Hr2(-1,0)*upx**(-4)*y
     &     + 8.D0*Hr2(-1,0)*upx**(-4)*y**2
     &     - 16.D0*Hr2(-1,0)*upx**(-3)
     &     - 32.D0*Hr2(-1,0)*upx**(-3)*y
     &     - 16.D0*Hr2(-1,0)*upx**(-3)*y**2
     &     + 8.D0*Hr2(-1,0)*upx**(-2)
     &     + 20.D0*Hr2(-1,0)*upx**(-2)*y
     &     + 8.D0*Hr2(-1,0)*upx**(-2)*y**2
     &     - 4.D0*Hr2(-1,0)*upx**(-1)*y
     &     - 10/3.D0*Hr1(0)
     &     - 6.D0*Hr1(0)*umx**(-4)
     &     + 12.D0*Hr1(0)*umx**(-4)*y
     &     - 6.D0*Hr1(0)*umx**(-4)*y**2
     &     + 12.D0*Hr1(0)*umx**(-3)
     &     - 24.D0*Hr1(0)*umx**(-3)*y
     &     + 12.D0*Hr1(0)*umx**(-3)*y**2
     &     - 10.D0*Hr1(0)*umx**(-2)
     &     + 16.D0*Hr1(0)*umx**(-2)*y
     &     - 4.D0*Hr1(0)*umx**(-2)*y**2
     &     + 4.D0*Hr1(0)*umx**(-1)
     &     - 4.D0*Hr1(0)*umx**(-1)*y
     &     - 2.D0*Hr1(0)*umx**(-1)*y**2
     &     - 14/3.D0*Hr1(0)*upx**(-4)
     &     - 28/3.D0*Hr1(0)*upx**(-4)*y
     &     - 14/3.D0*Hr1(0)*upx**(-4)*y**2
     &     + 28/3.D0*Hr1(0)*upx**(-3)
     &     + 56/3.D0*Hr1(0)*upx**(-3)*y
     &     + 28/3.D0*Hr1(0)*upx**(-3)*y**2
     &     - 8/3.D0*Hr1(0)*upx**(-2)
     &     - 10.D0*Hr1(0)*upx**(-2)*y
     &     - 8/3.D0*Hr1(0)*upx**(-2)*y**2
     &     - 2.D0*Hr1(0)*upx**(-1)
     &     + 2/3.D0*Hr1(0)*upx**(-1)*y
     &     - 2.D0*Hr1(0)*upx**(-1)*y**2
     &     + 12.D0*Hr2(0,-1)*umx**(-5)
     &     - 24.D0*Hr2(0,-1)*umx**(-5)*y
     &     + 12.D0*Hr2(0,-1)*umx**(-5)*y**2
     &     - 30.D0*Hr2(0,-1)*umx**(-4)
     &     + 60.D0*Hr2(0,-1)*umx**(-4)*y
     &     - 30.D0*Hr2(0,-1)*umx**(-4)*y**2
     &     + 31.D0*Hr2(0,-1)*umx**(-3)
     &     - 54.D0*Hr2(0,-1)*umx**(-3)*y
     &     + 19.D0*Hr2(0,-1)*umx**(-3)*y**2
     &     - 33/2.D0*Hr2(0,-1)*umx**(-2)
     &     + 21.D0*Hr2(0,-1)*umx**(-2)*y
     &     + 3/2.D0*Hr2(0,-1)*umx**(-2)*y**2
     &     + 41/4.D0*Hr2(0,-1)*umx**(-1)
     &     - 3/2.D0*Hr2(0,-1)*umx**(-1)*y
     &     + 1/4.D0*Hr2(0,-1)*umx**(-1)*y**2
     &     + 8.D0*Hr2(0,-1)*upx**(-4)
     &     + 16.D0*Hr2(0,-1)*upx**(-4)*y
     &     + 8.D0*Hr2(0,-1)*upx**(-4)*y**2
     &     - 14.D0*Hr2(0,-1)*upx**(-3)
     &     - 24.D0*Hr2(0,-1)*upx**(-3)*y
     &     - 10.D0*Hr2(0,-1)*upx**(-3)*y**2
     &     + 5.D0*Hr2(0,-1)*upx**(-2)
     &     + 8.D0*Hr2(0,-1)*upx**(-2)*y
     &     - Hr2(0,-1)*upx**(-2)*y**2
     &     - 7/4.D0*Hr2(0,-1)*upx**(-1)
     &     - 3/2.D0*Hr2(0,-1)*upx**(-1)*y
     &     + 1/4.D0*Hr2(0,-1)*upx**(-1)*y**2
     &     - 2.D0*HAr2(0,-1)
     &     - 4.D0*HAr2(0,-1)*upx**(-2)*y
     &     + 4.D0*HAr2(0,-1)*upx**(-1)*y
     &     - 6.D0*Hr2(0,0)*umx**(-5)
     &     + 12.D0*Hr2(0,0)*umx**(-5)*y
     &     - 6.D0*Hr2(0,0)*umx**(-5)*y**2
     &     + 15.D0*Hr2(0,0)*umx**(-4)
     &     - 30.D0*Hr2(0,0)*umx**(-4)*y
     &     + 15.D0*Hr2(0,0)*umx**(-4)*y**2
     &     - 31/2.D0*Hr2(0,0)*umx**(-3)
     &     + 27.D0*Hr2(0,0)*umx**(-3)*y
     &     - 19/2.D0*Hr2(0,0)*umx**(-3)*y**2
     &     + 33/4.D0*Hr2(0,0)*umx**(-2)
     &     - 21/2.D0*Hr2(0,0)*umx**(-2)*y
     &     - 3/4.D0*Hr2(0,0)*umx**(-2)*y**2
     &     - 41/8.D0*Hr2(0,0)*umx**(-1)
     &     + 3/4.D0*Hr2(0,0)*umx**(-1)*y
     &     - 1/8.D0*Hr2(0,0)*umx**(-1)*y**2
     &     - 4.D0*Hr2(0,0)*upx**(-4)
     &     - 8.D0*Hr2(0,0)*upx**(-4)*y
     &     - 4.D0*Hr2(0,0)*upx**(-4)*y**2
     &     + 7.D0*Hr2(0,0)*upx**(-3)
     &     + 12.D0*Hr2(0,0)*upx**(-3)*y
     &     + 5.D0*Hr2(0,0)*upx**(-3)*y**2
     &     - 5/2.D0*Hr2(0,0)*upx**(-2)
     &     - 4.D0*Hr2(0,0)*upx**(-2)*y
     &     + 1/2.D0*Hr2(0,0)*upx**(-2)*y**2
     &     + 7/8.D0*Hr2(0,0)*upx**(-1)
     &     + 3/4.D0*Hr2(0,0)*upx**(-1)*y
     &     - 1/8.D0*Hr2(0,0)*upx**(-1)*y**2
     &     - 22/3.D0*DLog(tm**(-2)*w**2)
     &     - 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)
     &     - 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     - 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     + 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)
     &     + 176/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     + 88/3.D0*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     - 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)
     &     - 44.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     - 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     + 44/3.D0*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      return
      end

      double precision function T13PoleEP0qqc(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1d0

* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      T13PoleEP0qqc =  + Nc**(-2) * (
     &     - 14
     &     + 12*umx**(-3)*z2
     &     - 12*umx**(-3)*y*z2
     &     - 18*umx**(-2)*z2
     &     + 18*umx**(-2)*y*z2
     &     + 24*umx**(-1)*z2
     &     - 4*umx**(-1)*y*z2
     &     + 2*umx**(-1)*y**2*z2
     &     + 32*upx**(-5)*z2
     &     + 64*upx**(-5)*y*z2
     &     + 32*upx**(-5)*y**2*z2
     &     - 48*upx**(-4)
     &     - 48*upx**(-4)*z2
     &     - 96*upx**(-4)*y
     &     - 96*upx**(-4)*y*z2
     &     - 48*upx**(-4)*y**2
     &     - 48*upx**(-4)*y**2*z2
     &     + 96*upx**(-3)
     &     - 4*upx**(-3)*z2
     &     + 192*upx**(-3)*y
     &     + 36*upx**(-3)*y*z2
     &     + 96*upx**(-3)*y**2
     &     + 8*upx**(-3)*y**2*z2
     &     - 48*upx**(-2)
     &     + 10*upx**(-2)*z2
     &     - 144*upx**(-2)*y
     &     - 2*upx**(-2)*y*z2
     &     - 48*upx**(-2)*y**2
     &     + 4*upx**(-2)*y**2*z2
     &     + 12*upx**(-1)*z2
     &     + 48*upx**(-1)*y
     &     - 4*upx**(-1)*y*z2
     &     + 2*upx**(-1)*y**2*z2
     &     - 8*Hr1(-1)
     &     - 24*Hr1(-1)*umx**(-2)
     &     + 24*Hr1(-1)*umx**(-2)*y
     &     + 24*Hr1(-1)*umx**(-1)
     &     - 24*Hr1(-1)*umx**(-1)*y
     &     + 24*Hr1(-1)*upx**(-4)
     &     + 48*Hr1(-1)*upx**(-4)*y
     &     + 24*Hr1(-1)*upx**(-4)*y**2
     &     - 48*Hr1(-1)*upx**(-3)
     &     - 96*Hr1(-1)*upx**(-3)*y
     &     - 48*Hr1(-1)*upx**(-3)*y**2
     &     + 24*Hr1(-1)*upx**(-2)
     &     + 72*Hr1(-1)*upx**(-2)*y
     &     + 24*Hr1(-1)*upx**(-2)*y**2
     &     - 24*Hr1(-1)*upx**(-1)*y
     &     - 12*Hr1(-1)*HAr1(-1)
     &     - 48*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     - 96*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     - 48*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     + 96*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     + 192*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     + 96*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     - 48*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     - 120*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     - 48*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     + 24*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     + 36*Hr1(-1)*HBr1(-1)
     &     + 48*Hr1(-1)*HBr1(-1)*upx**(-4)
     &     + 96*Hr1(-1)*HBr1(-1)*upx**(-4)*y
     &     + 48*Hr1(-1)*HBr1(-1)*upx**(-4)*y**2
     &     - 96*Hr1(-1)*HBr1(-1)*upx**(-3)
     &     - 192*Hr1(-1)*HBr1(-1)*upx**(-3)*y
     &     - 96*Hr1(-1)*HBr1(-1)*upx**(-3)*y**2
     &     + 96*Hr1(-1)*HBr1(-1)*upx**(-2)
     &     + 168*Hr1(-1)*HBr1(-1)*upx**(-2)*y
     &     + 48*Hr1(-1)*HBr1(-1)*upx**(-2)*y**2
     &     - 48*Hr1(-1)*HBr1(-1)*upx**(-1)
     &     - 72*Hr1(-1)*HBr1(-1)*upx**(-1)*y
     &     - 6*HAr1(-1)
     &     + 6*HAr1(-1)*upx**(-2)*y**(-1)
     &     + 12*HAr1(-1)*upx**(-2)
     &     + 6*HAr1(-1)*upx**(-2)*y
     &     - 6*HAr1(-1)*upx**(-1)*y**(-1)
     &     - 12*HAr1(-1)*upx**(-1)
     &     - 6*HAr1(-1)*upx**(-1)*y
     &     - 6*HAr1(-1)*y**(-1)
     &     + 6*HAr1(-1)*Hr1(0)
     &     + 24*HAr1(-1)*Hr1(0)*upx**(-4)
     &     + 48*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     + 24*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     - 48*HAr1(-1)*Hr1(0)*upx**(-3)
     &     - 96*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     - 48*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     + 24*HAr1(-1)*Hr1(0)*upx**(-2)
     &     + 60*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     + 24*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     - 12*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 12*HBr1(-1)
     &     - 6*HBr1(-1)*upx**(-2)*z**(-1)
     &     + 6*HBr1(-1)*upx**(-2)*y
     &     + 6*HBr1(-1)*upx**(-1)*z**(-1)
     &     - 6*HBr1(-1)*upx**(-1)*y
     &     + 6*HBr1(-1)*z**(-1)
     &     - 18*HBr1(-1)*Hr1(0)
     &     - 24*HBr1(-1)*Hr1(0)*upx**(-4)
     &     - 48*HBr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 24*HBr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 48*HBr1(-1)*Hr1(0)*upx**(-3)
     &     + 96*HBr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 48*HBr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 48*HBr1(-1)*Hr1(0)*upx**(-2)
     &     - 84*HBr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 24*HBr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 24*HBr1(-1)*Hr1(0)*upx**(-1)
     &     + 36*HBr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 40*Hr2(-1,-1)
     &     - 32*Hr2(-1,-1)*upx**(-4)
     &     - 64*Hr2(-1,-1)*upx**(-4)*y
     &     - 32*Hr2(-1,-1)*upx**(-4)*y**2
     &     + 64*Hr2(-1,-1)*upx**(-3)
     &     + 128*Hr2(-1,-1)*upx**(-3)*y
     &     + 64*Hr2(-1,-1)*upx**(-3)*y**2
     &     - 80*Hr2(-1,-1)*upx**(-2)
     &     - 144*Hr2(-1,-1)*upx**(-2)*y
     &     - 32*Hr2(-1,-1)*upx**(-2)*y**2
     &     + 48*Hr2(-1,-1)*upx**(-1)
     &     + 80*Hr2(-1,-1)*upx**(-1)*y
     &     - 12*HAr2(-1,-1)
     &     - 24*HAr2(-1,-1)*upx**(-2)*y
     &     + 24*HAr2(-1,-1)*upx**(-1)*y
     &     - 12*HBr2(-1,-1)
     &     - 48*HBr2(-1,-1)*upx**(-2)
     &     - 24*HBr2(-1,-1)*upx**(-2)*y
     &     + 48*HBr2(-1,-1)*upx**(-1)
     &     + 24*HBr2(-1,-1)*upx**(-1)*y
     &     + 20*Hr2(-1,0)
     &     + 16*Hr2(-1,0)*upx**(-4)
     &     + 32*Hr2(-1,0)*upx**(-4)*y
     &     + 16*Hr2(-1,0)*upx**(-4)*y**2
     &     - 32*Hr2(-1,0)*upx**(-3)
     &     - 64*Hr2(-1,0)*upx**(-3)*y
     &     - 32*Hr2(-1,0)*upx**(-3)*y**2
     &     + 40*Hr2(-1,0)*upx**(-2)
     &     + 72*Hr2(-1,0)*upx**(-2)*y
     &     + 16*Hr2(-1,0)*upx**(-2)*y**2
     &     - 24*Hr2(-1,0)*upx**(-1)
     &     - 40*Hr2(-1,0)*upx**(-1)*y
     &     + 6*Hr1(0)
     &     + 12*Hr1(0)*umx**(-2)
     &     - 12*Hr1(0)*umx**(-2)*y
     &     - 17.D0/2*Hr1(0)*umx**(-1)
     &     + 13*Hr1(0)*umx**(-1)*y
     &     - 1.D0/2*Hr1(0)*umx**(-1)*y**2
     &     - 16*Hr1(0)*upx**(-5)
     &     - 32*Hr1(0)*upx**(-5)*y
     &     - 16*Hr1(0)*upx**(-5)*y**2
     &     + 28*Hr1(0)*upx**(-4)
     &     + 56*Hr1(0)*upx**(-4)*y
     &     + 28*Hr1(0)*upx**(-4)*y**2
     &     - 10*Hr1(0)*upx**(-3)
     &     - 36*Hr1(0)*upx**(-3)*y
     &     - 10*Hr1(0)*upx**(-3)*y**2
     &     - Hr1(0)*upx**(-2)
     &     + 10*Hr1(0)*upx**(-2)*y
     &     - Hr1(0)*upx**(-2)*y**2
     &     - 17.D0/2*Hr1(0)*upx**(-1)
     &     + Hr1(0)*upx**(-1)*y
     &     - 1.D0/2*Hr1(0)*upx**(-1)*y**2
     &     + 8*Hr2(0,-1)
     &     - 24*Hr2(0,-1)*umx**(-3)
     &     + 24*Hr2(0,-1)*umx**(-3)*y
     &     + 36*Hr2(0,-1)*umx**(-2)
     &     - 36*Hr2(0,-1)*umx**(-2)*y
     &     - 12*Hr2(0,-1)*umx**(-1)
     &     + 16*Hr2(0,-1)*upx**(-4)
     &     + 32*Hr2(0,-1)*upx**(-4)*y
     &     + 16*Hr2(0,-1)*upx**(-4)*y**2
     &     - 8*Hr2(0,-1)*upx**(-3)
     &     - 40*Hr2(0,-1)*upx**(-3)*y
     &     - 32*Hr2(0,-1)*upx**(-3)*y**2
     &     + 4*Hr2(0,-1)*upx**(-2)
     &     + 36*Hr2(0,-1)*upx**(-2)*y
     &     + 16*Hr2(0,-1)*upx**(-2)*y**2
     &     + 12*Hr2(0,-1)*upx**(-1)
     &     - 16*Hr2(0,-1)*upx**(-1)*y
     &     + 6*HAr2(0,-1)
     &     + 12*HAr2(0,-1)*upx**(-2)*y
     &     - 12*HAr2(0,-1)*upx**(-1)*y
     &     + 6*HBr2(0,-1)
     &     + 24*HBr2(0,-1)*upx**(-2)
     &     + 12*HBr2(0,-1)*upx**(-2)*y
     &     - 24*HBr2(0,-1)*upx**(-1)
     &     - 12*HBr2(0,-1)*upx**(-1)*y
     &     + 12*Hr2(0,0)*umx**(-3)
     &     - 12*Hr2(0,0)*umx**(-3)*y
     &     - 18*Hr2(0,0)*umx**(-2)
     &     + 18*Hr2(0,0)*umx**(-2)*y
     &     + 3.D0/2*Hr2(0,0)*umx**(-1)
     &     + Hr2(0,0)*umx**(-1)*y
     &     - 1.D0/2*Hr2(0,0)*umx**(-1)*y**2
     &     - 8*Hr2(0,0)*upx**(-5)
     &     - 16*Hr2(0,0)*upx**(-5)*y
     &     - 8*Hr2(0,0)*upx**(-5)*y**2
     &     + 12*Hr2(0,0)*upx**(-4)
     &     + 24*Hr2(0,0)*upx**(-4)*y
     &     + 12*Hr2(0,0)*upx**(-4)*y**2
     &     - 14*Hr2(0,0)*upx**(-3)
     &     - 24*Hr2(0,0)*upx**(-3)*y
     &     - 2*Hr2(0,0)*upx**(-3)*y**2
     &     + 5*Hr2(0,0)*upx**(-2)
     &     + 8*Hr2(0,0)*upx**(-2)*y
     &     - Hr2(0,0)*upx**(-2)*y**2
     &     - 21.D0/2*Hr2(0,0)*upx**(-1)
     &     + Hr2(0,0)*upx**(-1)*y
     &     - 1.D0/2*Hr2(0,0)*upx**(-1)*y**2
     &     + 8*Hr2(1,0)
     &     - 9*Hr2(1,0)*umx**(-1)
     &     + 2*Hr2(1,0)*umx**(-1)*y
     &     - Hr2(1,0)*umx**(-1)*y**2
     &     - 16*Hr2(1,0)*upx**(-5)
     &     - 32*Hr2(1,0)*upx**(-5)*y
     &     - 16*Hr2(1,0)*upx**(-5)*y**2
     &     + 40*Hr2(1,0)*upx**(-4)
     &     + 80*Hr2(1,0)*upx**(-4)*y
     &     + 40*Hr2(1,0)*upx**(-4)*y**2
     &     - 36*Hr2(1,0)*upx**(-3)
     &     - 88*Hr2(1,0)*upx**(-3)*y
     &     - 36*Hr2(1,0)*upx**(-3)*y**2
     &     + 14*Hr2(1,0)*upx**(-2)
     &     + 52*Hr2(1,0)*upx**(-2)*y
     &     + 14*Hr2(1,0)*upx**(-2)*y**2
     &     - 9*Hr2(1,0)*upx**(-1)
     &     - 14*Hr2(1,0)*upx**(-1)*y
     &     - Hr2(1,0)*upx**(-1)*y**2
     &     )
      T13PoleEP0qqc = T13PoleEP0qqc + Nc**(-1)*Nh * (
     &     + 40.D0/9
     &     - 64.D0/3*upx**(-6)
     &     - 128.D0/3*upx**(-6)*y
     &     - 64.D0/3*upx**(-6)*y**2
     &     + 64*upx**(-5)
     &     + 128*upx**(-5)*y
     &     + 64*upx**(-5)*y**2
     &     - 496.D0/9*upx**(-4)
     &     - 1184.D0/9*upx**(-4)*y
     &     - 496.D0/9*upx**(-4)*y**2
     &     + 32.D0/9*upx**(-3)
     &     + 448.D0/9*upx**(-3)*y
     &     + 32.D0/9*upx**(-3)*y**2
     &     - 16.D0/9*upx**(-2)
     &     + 16.D0/3*upx**(-2)*y
     &     + 80.D0/9*upx**(-2)*y**2
     &     + 32.D0/3*upx**(-1)
     &     - 80.D0/9*upx**(-1)*y
     &     - 8.D0/3*Hr1(0)
     &     - 64.D0/3*Hr1(0)*upx**(-7)
     &     - 128.D0/3*Hr1(0)*upx**(-7)*y
     &     - 64.D0/3*Hr1(0)*upx**(-7)*y**2
     &     + 224.D0/3*Hr1(0)*upx**(-6)
     &     + 448.D0/3*Hr1(0)*upx**(-6)*y
     &     + 224.D0/3*Hr1(0)*upx**(-6)*y**2
     &     - 256.D0/3*Hr1(0)*upx**(-5)
     &     - 192*Hr1(0)*upx**(-5)*y
     &     - 256.D0/3*Hr1(0)*upx**(-5)*y**2
     &     + 80.D0/3*Hr1(0)*upx**(-4)
     &     + 320.D0/3*Hr1(0)*upx**(-4)*y
     &     + 80.D0/3*Hr1(0)*upx**(-4)*y**2
     &     - 32.D0/3*Hr1(0)*upx**(-3)*y
     &     + 32.D0/3*Hr1(0)*upx**(-3)*y**2
     &     + 32.D0/3*Hr1(0)*upx**(-2)
     &     - 16*Hr1(0)*upx**(-2)*y
     &     - 16.D0/3*Hr1(0)*upx**(-2)*y**2
     &     + 16.D0/3*Hr1(0)*upx**(-1)*y
     &     )
      T13PoleEP0qqc = T13PoleEP0qqc + Nc**(-1)*Nl * (
     &     + 40.D0/9
     &     + 80.D0/9*upx**(-4)
     &     + 160.D0/9*upx**(-4)*y
     &     + 80.D0/9*upx**(-4)*y**2
     &     - 160.D0/9*upx**(-3)
     &     - 320.D0/9*upx**(-3)*y
     &     - 160.D0/9*upx**(-3)*y**2
     &     + 80.D0/9*upx**(-2)
     &     + 80.D0/3*upx**(-2)*y
     &     + 80.D0/9*upx**(-2)*y**2
     &     - 80.D0/9*upx**(-1)*y
     &     - 16.D0/3*Hr1(-1)
     &     - 32.D0/3*Hr1(-1)*upx**(-4)
     &     - 64.D0/3*Hr1(-1)*upx**(-4)*y
     &     - 32.D0/3*Hr1(-1)*upx**(-4)*y**2
     &     + 64.D0/3*Hr1(-1)*upx**(-3)
     &     + 128.D0/3*Hr1(-1)*upx**(-3)*y
     &     + 64.D0/3*Hr1(-1)*upx**(-3)*y**2
     &     - 32.D0/3*Hr1(-1)*upx**(-2)
     &     - 32*Hr1(-1)*upx**(-2)*y
     &     - 32.D0/3*Hr1(-1)*upx**(-2)*y**2
     &     + 32.D0/3*Hr1(-1)*upx**(-1)*y
     &     + 8.D0/3*Hr1(0)
     &     + 16.D0/3*Hr1(0)*upx**(-4)
     &     + 32.D0/3*Hr1(0)*upx**(-4)*y
     &     + 16.D0/3*Hr1(0)*upx**(-4)*y**2
     &     - 32.D0/3*Hr1(0)*upx**(-3)
     &     - 64.D0/3*Hr1(0)*upx**(-3)*y
     &     - 32.D0/3*Hr1(0)*upx**(-3)*y**2
     &     + 16.D0/3*Hr1(0)*upx**(-2)
     &     + 16*Hr1(0)*upx**(-2)*y
     &     + 16.D0/3*Hr1(0)*upx**(-2)*y**2
     &     - 16.D0/3*Hr1(0)*upx**(-1)*y
     &     + 8.D0/3*DLog(tm**(-2)*w**2)
     &     + 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)
     &     + 32.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     + 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     - 32.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)
     &     - 64.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     - 32.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     + 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)
     &     + 16*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     + 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     - 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T13PoleEP0qqc = T13PoleEP0qqc + (
     &     - 25.D0/9
     &     - 12*umx**(-5)*z2
     &     + 24*umx**(-5)*y*z2
     &     - 12*umx**(-5)*y**2*z2
     &     + 30*umx**(-4)*z2
     &     - 60*umx**(-4)*y*z2
     &     + 30*umx**(-4)*y**2*z2
     &     - 47*umx**(-3)*z2
     &     + 70*umx**(-3)*y*z2
     &     - 19*umx**(-3)*y**2*z2
     &     - 2*umx**(-2)
     &     + 81.D0/2*umx**(-2)*z2
     &     + 4*umx**(-2)*y
     &     - 45*umx**(-2)*y*z2
     &     - 2*umx**(-2)*y**2
     &     - 3.D0/2*umx**(-2)*y**2*z2
     &     + 2*umx**(-1)
     &     - 181.D0/4*umx**(-1)*z2
     &     - 4*umx**(-1)*y
     &     + 15.D0/2*umx**(-1)*y*z2
     &     + 2*umx**(-1)*y**2
     &     - 13.D0/4*umx**(-1)*y**2*z2
     &     - 48*upx**(-5)*z2
     &     - 96*upx**(-5)*y*z2
     &     - 48*upx**(-5)*y**2*z2
     &     + 472.D0/9*upx**(-4)
     &     + 64*upx**(-4)*z2
     &     + 944.D0/9*upx**(-4)*y
     &     + 128*upx**(-4)*y*z2
     &     + 472.D0/9*upx**(-4)*y**2
     &     + 64*upx**(-4)*y**2*z2
     &     - 944.D0/9*upx**(-3)
     &     + 18*upx**(-3)*z2
     &     - 1888.D0/9*upx**(-3)*y
     &     - 32*upx**(-3)*y*z2
     &     - 944.D0/9*upx**(-3)*y**2
     &     - 2*upx**(-3)*y**2*z2
     &     + 454.D0/9*upx**(-2)
     &     - 19*upx**(-2)*z2
     &     + 460.D0/3*upx**(-2)*y
     &     - 4*upx**(-2)*y*z2
     &     + 454.D0/9*upx**(-2)*y**2
     &     - 5*upx**(-2)*y**2*z2
     &     + 2*upx**(-1)
     &     - 69.D0/4*upx**(-1)*z2
     &     - 436.D0/9*upx**(-1)*y
     &     + 15.D0/2*upx**(-1)*y*z2
     &     + 2*upx**(-1)*y**2
     &     - 13.D0/4*upx**(-1)*y**2*z2
     &     + 70.D0/3*Hr1(-1)
     &     + 24*Hr1(-1)*umx**(-4)
     &     - 48*Hr1(-1)*umx**(-4)*y
     &     + 24*Hr1(-1)*umx**(-4)*y**2
     &     - 48*Hr1(-1)*umx**(-3)
     &     + 96*Hr1(-1)*umx**(-3)*y
     &     - 48*Hr1(-1)*umx**(-3)*y**2
     &     + 72*Hr1(-1)*umx**(-2)
     &     - 96*Hr1(-1)*umx**(-2)*y
     &     + 16*Hr1(-1)*umx**(-2)*y**2
     &     - 48*Hr1(-1)*umx**(-1)
     &     + 48*Hr1(-1)*umx**(-1)*y
     &     + 8*Hr1(-1)*umx**(-1)*y**2
     &     - 52.D0/3*Hr1(-1)*upx**(-4)
     &     - 104.D0/3*Hr1(-1)*upx**(-4)*y
     &     - 52.D0/3*Hr1(-1)*upx**(-4)*y**2
     &     + 104.D0/3*Hr1(-1)*upx**(-3)
     &     + 208.D0/3*Hr1(-1)*upx**(-3)*y
     &     + 104.D0/3*Hr1(-1)*upx**(-3)*y**2
     &     - 76.D0/3*Hr1(-1)*upx**(-2)
     &     - 68*Hr1(-1)*upx**(-2)*y
     &     - 76.D0/3*Hr1(-1)*upx**(-2)*y**2
     &     + 8*Hr1(-1)*upx**(-1)
     &     + 100.D0/3*Hr1(-1)*upx**(-1)*y
     &     + 8*Hr1(-1)*upx**(-1)*y**2
     &     + 24*Hr1(-1)*HAr1(-1)
     &     + 96*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     + 192*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     + 96*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     - 192*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     - 384*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     - 192*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     + 96*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     + 240*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     + 96*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     - 48*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     - 48*Hr1(-1)*HBr1(-1)
     &     - 64*Hr1(-1)*HBr1(-1)*upx**(-4)
     &     - 128*Hr1(-1)*HBr1(-1)*upx**(-4)*y
     &     - 64*Hr1(-1)*HBr1(-1)*upx**(-4)*y**2
     &     + 128*Hr1(-1)*HBr1(-1)*upx**(-3)
     &     + 256*Hr1(-1)*HBr1(-1)*upx**(-3)*y
     &     + 128*Hr1(-1)*HBr1(-1)*upx**(-3)*y**2
     &     - 128*Hr1(-1)*HBr1(-1)*upx**(-2)
     &     - 224*Hr1(-1)*HBr1(-1)*upx**(-2)*y
     &     - 64*Hr1(-1)*HBr1(-1)*upx**(-2)*y**2
     &     + 64*Hr1(-1)*HBr1(-1)*upx**(-1)
     &     + 96*Hr1(-1)*HBr1(-1)*upx**(-1)*y
     &     + 12*HAr1(-1)
     &     - 12*HAr1(-1)*upx**(-2)*y**(-1)
     &     - 24*HAr1(-1)*upx**(-2)
     &     - 12*HAr1(-1)*upx**(-2)*y
     &     + 12*HAr1(-1)*upx**(-1)*y**(-1)
     &     + 24*HAr1(-1)*upx**(-1)
     &     + 12*HAr1(-1)*upx**(-1)*y
     &     + 12*HAr1(-1)*y**(-1)
     &     - 12*HAr1(-1)*Hr1(0)
     &     - 48*HAr1(-1)*Hr1(0)*upx**(-4)
     &     - 96*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 48*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 96*HAr1(-1)*Hr1(0)*upx**(-3)
     &     + 192*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 96*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 48*HAr1(-1)*Hr1(0)*upx**(-2)
     &     - 120*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 48*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 24*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 16*HBr1(-1)
     &     + 8*HBr1(-1)*upx**(-2)*z**(-1)
     &     - 8*HBr1(-1)*upx**(-2)*y
     &     - 8*HBr1(-1)*upx**(-1)*z**(-1)
     &     + 8*HBr1(-1)*upx**(-1)*y
     &     - 8*HBr1(-1)*z**(-1)
     &     + 24*HBr1(-1)*Hr1(0)
     &     + 32*HBr1(-1)*Hr1(0)*upx**(-4)
     &     + 64*HBr1(-1)*Hr1(0)*upx**(-4)*y
     &     + 32*HBr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     - 64*HBr1(-1)*Hr1(0)*upx**(-3)
     &     - 128*HBr1(-1)*Hr1(0)*upx**(-3)*y
     &     - 64*HBr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     + 64*HBr1(-1)*Hr1(0)*upx**(-2)
     &     + 112*HBr1(-1)*Hr1(0)*upx**(-2)*y
     &     + 32*HBr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     - 32*HBr1(-1)*Hr1(0)*upx**(-1)
     &     - 48*HBr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 48*Hr2(-1,-1)
     &     + 16*Hr2(-1,-1)*upx**(-4)
     &     + 32*Hr2(-1,-1)*upx**(-4)*y
     &     + 16*Hr2(-1,-1)*upx**(-4)*y**2
     &     - 32*Hr2(-1,-1)*upx**(-3)
     &     - 64*Hr2(-1,-1)*upx**(-3)*y
     &     - 32*Hr2(-1,-1)*upx**(-3)*y**2
     &     + 80*Hr2(-1,-1)*upx**(-2)
     &     + 128*Hr2(-1,-1)*upx**(-2)*y
     &     + 16*Hr2(-1,-1)*upx**(-2)*y**2
     &     - 64*Hr2(-1,-1)*upx**(-1)
     &     - 96*Hr2(-1,-1)*upx**(-1)*y
     &     + 24*HAr2(-1,-1)
     &     + 48*HAr2(-1,-1)*upx**(-2)*y
     &     - 48*HAr2(-1,-1)*upx**(-1)*y
     &     + 16*HBr2(-1,-1)
     &     + 64*HBr2(-1,-1)*upx**(-2)
     &     + 32*HBr2(-1,-1)*upx**(-2)*y
     &     - 64*HBr2(-1,-1)*upx**(-1)
     &     - 32*HBr2(-1,-1)*upx**(-1)*y
     &     - 24*Hr2(-1,0)
     &     - 8*Hr2(-1,0)*upx**(-4)
     &     - 16*Hr2(-1,0)*upx**(-4)*y
     &     - 8*Hr2(-1,0)*upx**(-4)*y**2
     &     + 16*Hr2(-1,0)*upx**(-3)
     &     + 32*Hr2(-1,0)*upx**(-3)*y
     &     + 16*Hr2(-1,0)*upx**(-3)*y**2
     &     - 40*Hr2(-1,0)*upx**(-2)
     &     - 64*Hr2(-1,0)*upx**(-2)*y
     &     - 8*Hr2(-1,0)*upx**(-2)*y**2
     &     + 32*Hr2(-1,0)*upx**(-1)
     &     + 48*Hr2(-1,0)*upx**(-1)*y
     &     - 44.D0/3*Hr1(0)
     &     - 12*Hr1(0)*umx**(-4)
     &     + 24*Hr1(0)*umx**(-4)*y
     &     - 12*Hr1(0)*umx**(-4)*y**2
     &     + 24*Hr1(0)*umx**(-3)
     &     - 48*Hr1(0)*umx**(-3)*y
     &     + 24*Hr1(0)*umx**(-3)*y**2
     &     - 36*Hr1(0)*umx**(-2)
     &     + 48*Hr1(0)*umx**(-2)*y
     &     - 8*Hr1(0)*umx**(-2)*y**2
     &     + 75.D0/4*Hr1(0)*umx**(-1)
     &     - 51.D0/2*Hr1(0)*umx**(-1)*y
     &     - 13.D0/4*Hr1(0)*umx**(-1)*y**2
     &     + 24*Hr1(0)*upx**(-5)
     &     + 48*Hr1(0)*upx**(-5)*y
     &     + 24*Hr1(0)*upx**(-5)*y**2
     &     - 154.D0/3*Hr1(0)*upx**(-4)
     &     - 308.D0/3*Hr1(0)*upx**(-4)*y
     &     - 154.D0/3*Hr1(0)*upx**(-4)*y**2
     &     + 101.D0/3*Hr1(0)*upx**(-3)
     &     + 274.D0/3*Hr1(0)*upx**(-3)*y
     &     + 101.D0/3*Hr1(0)*upx**(-3)*y**2
     &     - 23.D0/6*Hr1(0)*upx**(-2)
     &     - 35*Hr1(0)*upx**(-2)*y
     &     - 23.D0/6*Hr1(0)*upx**(-2)*y**2
     &     + 35.D0/4*Hr1(0)*upx**(-1)
     &     - 1.D0/6*Hr1(0)*upx**(-1)*y
     &     - 13.D0/4*Hr1(0)*upx**(-1)*y**2
     &     - 12*Hr2(0,-1)
     &     + 24*Hr2(0,-1)*umx**(-5)
     &     - 48*Hr2(0,-1)*umx**(-5)*y
     &     + 24*Hr2(0,-1)*umx**(-5)*y**2
     &     - 60*Hr2(0,-1)*umx**(-4)
     &     + 120*Hr2(0,-1)*umx**(-4)*y
     &     - 60*Hr2(0,-1)*umx**(-4)*y**2
     &     + 94*Hr2(0,-1)*umx**(-3)
     &     - 140*Hr2(0,-1)*umx**(-3)*y
     &     + 38*Hr2(0,-1)*umx**(-3)*y**2
     &     - 81*Hr2(0,-1)*umx**(-2)
     &     + 90*Hr2(0,-1)*umx**(-2)*y
     &     + 3*Hr2(0,-1)*umx**(-2)*y**2
     &     + 73.D0/2*Hr2(0,-1)*umx**(-1)
     &     - 3*Hr2(0,-1)*umx**(-1)*y
     &     + 1.D0/2*Hr2(0,-1)*umx**(-1)*y**2
     &     - 8*Hr2(0,-1)*upx**(-4)
     &     - 16*Hr2(0,-1)*upx**(-4)*y
     &     - 8*Hr2(0,-1)*upx**(-4)*y**2
     &     - 12*Hr2(0,-1)*upx**(-3)
     &     + 16*Hr2(0,-1)*upx**(-3)*y
     &     + 28*Hr2(0,-1)*upx**(-3)*y**2
     &     + 2*Hr2(0,-1)*upx**(-2)
     &     - 40*Hr2(0,-1)*upx**(-2)*y
     &     - 26*Hr2(0,-1)*upx**(-2)*y**2
     &     - 39.D0/2*Hr2(0,-1)*upx**(-1)
     &     + 21*Hr2(0,-1)*upx**(-1)*y
     &     + 1.D0/2*Hr2(0,-1)*upx**(-1)*y**2
     &     - 12*HAr2(0,-1)
     &     - 24*HAr2(0,-1)*upx**(-2)*y
     &     + 24*HAr2(0,-1)*upx**(-1)*y
     &     - 8*HBr2(0,-1)
     &     - 32*HBr2(0,-1)*upx**(-2)
     &     - 16*HBr2(0,-1)*upx**(-2)*y
     &     + 32*HBr2(0,-1)*upx**(-1)
     &     + 16*HBr2(0,-1)*upx**(-1)*y
     &     - 12*Hr2(0,0)*umx**(-5)
     &     + 24*Hr2(0,0)*umx**(-5)*y
     &     - 12*Hr2(0,0)*umx**(-5)*y**2
     &     + 30*Hr2(0,0)*umx**(-4)
     &     - 60*Hr2(0,0)*umx**(-4)*y
     &     + 30*Hr2(0,0)*umx**(-4)*y**2
     &     - 47*Hr2(0,0)*umx**(-3)
     &     + 70*Hr2(0,0)*umx**(-3)*y
     &     - 19*Hr2(0,0)*umx**(-3)*y**2
     &     + 81.D0/2*Hr2(0,0)*umx**(-2)
     &     - 45*Hr2(0,0)*umx**(-2)*y
     &     - 3.D0/2*Hr2(0,0)*umx**(-2)*y**2
     &     - 23.D0/2*Hr2(0,0)*umx**(-1)
     &     + 1.D0/2*Hr2(0,0)*umx**(-1)*y**2
     &     + 12*Hr2(0,0)*upx**(-5)
     &     + 24*Hr2(0,0)*upx**(-5)*y
     &     + 12*Hr2(0,0)*upx**(-5)*y**2
     &     - 26*Hr2(0,0)*upx**(-4)
     &     - 52*Hr2(0,0)*upx**(-4)*y
     &     - 26*Hr2(0,0)*upx**(-4)*y**2
     &     + 33*Hr2(0,0)*upx**(-3)
     &     + 58*Hr2(0,0)*upx**(-3)*y
     &     + 13*Hr2(0,0)*upx**(-3)*y**2
     &     - 23.D0/2*Hr2(0,0)*upx**(-2)
     &     - 19*Hr2(0,0)*upx**(-2)*y
     &     + 5.D0/2*Hr2(0,0)*upx**(-2)*y**2
     &     + 33.D0/2*Hr2(0,0)*upx**(-1)
     &     + 1.D0/2*Hr2(0,0)*upx**(-1)*y**2
     &     - 12*Hr2(1,0)
     &     + 27.D0/2*Hr2(1,0)*umx**(-1)
     &     - 3*Hr2(1,0)*umx**(-1)*y
     &     + 3.D0/2*Hr2(1,0)*umx**(-1)*y**2
     &     + 24*Hr2(1,0)*upx**(-5)
     &     + 48*Hr2(1,0)*upx**(-5)*y
     &     + 24*Hr2(1,0)*upx**(-5)*y**2
     &     - 60*Hr2(1,0)*upx**(-4)
     &     - 120*Hr2(1,0)*upx**(-4)*y
     &     - 60*Hr2(1,0)*upx**(-4)*y**2
     &     + 54*Hr2(1,0)*upx**(-3)
     &     + 132*Hr2(1,0)*upx**(-3)*y
     &     + 54*Hr2(1,0)*upx**(-3)*y**2
     &     - 21*Hr2(1,0)*upx**(-2)
     &     - 78*Hr2(1,0)*upx**(-2)*y
     &     - 21*Hr2(1,0)*upx**(-2)*y**2
     &     + 27.D0/2*Hr2(1,0)*upx**(-1)
     &     + 21*Hr2(1,0)*upx**(-1)*y
     &     + 3.D0/2*Hr2(1,0)*upx**(-1)*y**2
     &     - 44.D0/3*DLog(tm**(-2)*w**2)
     &     - 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)
     &     - 176.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     - 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     + 176.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)
     &     + 352.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     + 176.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     - 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)
     &     - 88*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     - 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     + 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T13PoleEP0qqc = T13PoleEP0qqc + Nc*Nh * (
     &     - 20.D0/3
     &     + 32*upx**(-6)
     &     + 64*upx**(-6)*y
     &     + 32*upx**(-6)*y**2
     &     - 96*upx**(-5)
     &     - 192*upx**(-5)*y
     &     - 96*upx**(-5)*y**2
     &     + 248.D0/3*upx**(-4)
     &     + 592.D0/3*upx**(-4)*y
     &     + 248.D0/3*upx**(-4)*y**2
     &     - 16.D0/3*upx**(-3)
     &     - 224.D0/3*upx**(-3)*y
     &     - 16.D0/3*upx**(-3)*y**2
     &     + 8.D0/3*upx**(-2)
     &     - 8*upx**(-2)*y
     &     - 40.D0/3*upx**(-2)*y**2
     &     - 16*upx**(-1)
     &     + 40.D0/3*upx**(-1)*y
     &     + 4*Hr1(0)
     &     + 32*Hr1(0)*upx**(-7)
     &     + 64*Hr1(0)*upx**(-7)*y
     &     + 32*Hr1(0)*upx**(-7)*y**2
     &     - 112*Hr1(0)*upx**(-6)
     &     - 224*Hr1(0)*upx**(-6)*y
     &     - 112*Hr1(0)*upx**(-6)*y**2
     &     + 128*Hr1(0)*upx**(-5)
     &     + 288*Hr1(0)*upx**(-5)*y
     &     + 128*Hr1(0)*upx**(-5)*y**2
     &     - 40*Hr1(0)*upx**(-4)
     &     - 160*Hr1(0)*upx**(-4)*y
     &     - 40*Hr1(0)*upx**(-4)*y**2
     &     + 16*Hr1(0)*upx**(-3)*y
     &     - 16*Hr1(0)*upx**(-3)*y**2
     &     - 16*Hr1(0)*upx**(-2)
     &     + 24*Hr1(0)*upx**(-2)*y
     &     + 8*Hr1(0)*upx**(-2)*y**2
     &     - 8*Hr1(0)*upx**(-1)*y
     &     )
      T13PoleEP0qqc = T13PoleEP0qqc + Nc*Nl * (
     &     - 20.D0/3
     &     - 40.D0/3*upx**(-4)
     &     - 80.D0/3*upx**(-4)*y
     &     - 40.D0/3*upx**(-4)*y**2
     &     + 80.D0/3*upx**(-3)
     &     + 160.D0/3*upx**(-3)*y
     &     + 80.D0/3*upx**(-3)*y**2
     &     - 40.D0/3*upx**(-2)
     &     - 40*upx**(-2)*y
     &     - 40.D0/3*upx**(-2)*y**2
     &     + 40.D0/3*upx**(-1)*y
     &     + 8*Hr1(-1)
     &     + 16*Hr1(-1)*upx**(-4)
     &     + 32*Hr1(-1)*upx**(-4)*y
     &     + 16*Hr1(-1)*upx**(-4)*y**2
     &     - 32*Hr1(-1)*upx**(-3)
     &     - 64*Hr1(-1)*upx**(-3)*y
     &     - 32*Hr1(-1)*upx**(-3)*y**2
     &     + 16*Hr1(-1)*upx**(-2)
     &     + 48*Hr1(-1)*upx**(-2)*y
     &     + 16*Hr1(-1)*upx**(-2)*y**2
     &     - 16*Hr1(-1)*upx**(-1)*y
     &     - 4*Hr1(0)
     &     - 8*Hr1(0)*upx**(-4)
     &     - 16*Hr1(0)*upx**(-4)*y
     &     - 8*Hr1(0)*upx**(-4)*y**2
     &     + 16*Hr1(0)*upx**(-3)
     &     + 32*Hr1(0)*upx**(-3)*y
     &     + 16*Hr1(0)*upx**(-3)*y**2
     &     - 8*Hr1(0)*upx**(-2)
     &     - 24*Hr1(0)*upx**(-2)*y
     &     - 8*Hr1(0)*upx**(-2)*y**2
     &     + 8*Hr1(0)*upx**(-1)*y
     &     - 4*DLog(tm**(-2)*w**2)
     &     - 8*DLog(tm**(-2)*w**2)*upx**(-4)
     &     - 16*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     - 8*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     + 16*DLog(tm**(-2)*w**2)*upx**(-3)
     &     + 32*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     + 16*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     - 8*DLog(tm**(-2)*w**2)*upx**(-2)
     &     - 24*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     - 8*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     + 8*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T13PoleEP0qqc = T13PoleEP0qqc + Nc**2 * (
     &     + 86.D0/3
     &     + 18*umx**(-5)*z2
     &     - 36*umx**(-5)*y*z2
     &     + 18*umx**(-5)*y**2*z2
     &     - 45*umx**(-4)*z2
     &     + 90*umx**(-4)*y*z2
     &     - 45*umx**(-4)*y**2*z2
     &     + 101.D0/2*umx**(-3)*z2
     &     - 85*umx**(-3)*y*z2
     &     + 57.D0/2*umx**(-3)*y**2*z2
     &     + 3*umx**(-2)
     &     - 123.D0/4*umx**(-2)*z2
     &     - 6*umx**(-2)*y
     &     + 75.D0/2*umx**(-2)*y*z2
     &     + 3*umx**(-2)*y**2
     &     + 9.D0/4*umx**(-2)*y**2*z2
     &     - 3*umx**(-1)
     &     + 211.D0/8*umx**(-1)*z2
     &     + 6*umx**(-1)*y
     &     - 17.D0/4*umx**(-1)*y*z2
     &     - 3*umx**(-1)*y**2
     &     + 11.D0/8*umx**(-1)*y**2*z2
     &     + 16*upx**(-5)*z2
     &     + 32*upx**(-5)*y*z2
     &     + 16*upx**(-5)*y**2*z2
     &     + 16.D0/3*upx**(-4)
     &     - 12*upx**(-4)*z2
     &     + 32.D0/3*upx**(-4)*y
     &     - 24*upx**(-4)*y*z2
     &     + 16.D0/3*upx**(-4)*y**2
     &     - 12*upx**(-4)*y**2*z2
     &     - 32.D0/3*upx**(-3)
     &     - 21*upx**(-3)*z2
     &     - 64.D0/3*upx**(-3)*y
     &     - 16*upx**(-3)*y*z2
     &     - 32.D0/3*upx**(-3)*y**2
     &     - 11*upx**(-3)*y**2*z2
     &     + 25.D0/3*upx**(-2)
     &     + 23.D0/2*upx**(-2)*z2
     &     + 22*upx**(-2)*y
     &     + 10*upx**(-2)*y*z2
     &     + 25.D0/3*upx**(-2)*y**2
     &     + 1.D0/2*upx**(-2)*y**2*z2
     &     - 3*upx**(-1)
     &     + 35.D0/8*upx**(-1)*z2
     &     - 34.D0/3*upx**(-1)*y
     &     - 17.D0/4*upx**(-1)*y*z2
     &     - 3*upx**(-1)*y**2
     &     + 11.D0/8*upx**(-1)*y**2*z2
     &     - 22*Hr1(-1)
     &     - 36*Hr1(-1)*umx**(-4)
     &     + 72*Hr1(-1)*umx**(-4)*y
     &     - 36*Hr1(-1)*umx**(-4)*y**2
     &     + 72*Hr1(-1)*umx**(-3)
     &     - 144*Hr1(-1)*umx**(-3)*y
     &     + 72*Hr1(-1)*umx**(-3)*y**2
     &     - 68*Hr1(-1)*umx**(-2)
     &     + 104*Hr1(-1)*umx**(-2)*y
     &     - 24*Hr1(-1)*umx**(-2)*y**2
     &     + 32*Hr1(-1)*umx**(-1)
     &     - 32*Hr1(-1)*umx**(-1)*y
     &     - 12*Hr1(-1)*umx**(-1)*y**2
     &     - 16*Hr1(-1)*upx**(-4)
     &     - 32*Hr1(-1)*upx**(-4)*y
     &     - 16*Hr1(-1)*upx**(-4)*y**2
     &     + 32*Hr1(-1)*upx**(-3)
     &     + 64*Hr1(-1)*upx**(-3)*y
     &     + 32*Hr1(-1)*upx**(-3)*y**2
     &     - 4*Hr1(-1)*upx**(-2)
     &     - 24*Hr1(-1)*upx**(-2)*y
     &     - 4*Hr1(-1)*upx**(-2)*y**2
     &     - 12*Hr1(-1)*upx**(-1)
     &     - 8*Hr1(-1)*upx**(-1)*y
     &     - 12*Hr1(-1)*upx**(-1)*y**2
     &     - 16*Hr1(-1)*HAr1(-1)
     &     - 64*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     - 128*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     - 64*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     + 128*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     + 256*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     + 128*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     - 64*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     - 160*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     - 64*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     + 32*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     + 12*Hr1(-1)*HBr1(-1)
     &     + 16*Hr1(-1)*HBr1(-1)*upx**(-4)
     &     + 32*Hr1(-1)*HBr1(-1)*upx**(-4)*y
     &     + 16*Hr1(-1)*HBr1(-1)*upx**(-4)*y**2
     &     - 32*Hr1(-1)*HBr1(-1)*upx**(-3)
     &     - 64*Hr1(-1)*HBr1(-1)*upx**(-3)*y
     &     - 32*Hr1(-1)*HBr1(-1)*upx**(-3)*y**2
     &     + 32*Hr1(-1)*HBr1(-1)*upx**(-2)
     &     + 56*Hr1(-1)*HBr1(-1)*upx**(-2)*y
     &     + 16*Hr1(-1)*HBr1(-1)*upx**(-2)*y**2
     &     - 16*Hr1(-1)*HBr1(-1)*upx**(-1)
     &     - 24*Hr1(-1)*HBr1(-1)*upx**(-1)*y
     &     - 8*HAr1(-1)
     &     + 8*HAr1(-1)*upx**(-2)*y**(-1)
     &     + 16*HAr1(-1)*upx**(-2)
     &     + 8*HAr1(-1)*upx**(-2)*y
     &     - 8*HAr1(-1)*upx**(-1)*y**(-1)
     &     - 16*HAr1(-1)*upx**(-1)
     &     - 8*HAr1(-1)*upx**(-1)*y
     &     - 8*HAr1(-1)*y**(-1)
     &     + 8*HAr1(-1)*Hr1(0)
     &     + 32*HAr1(-1)*Hr1(0)*upx**(-4)
     &     + 64*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     + 32*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     - 64*HAr1(-1)*Hr1(0)*upx**(-3)
     &     - 128*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     - 64*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     + 32*HAr1(-1)*Hr1(0)*upx**(-2)
     &     + 80*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     + 32*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     - 16*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 4*HBr1(-1)
     &     - 2*HBr1(-1)*upx**(-2)*z**(-1)
     &     + 2*HBr1(-1)*upx**(-2)*y
     &     + 2*HBr1(-1)*upx**(-1)*z**(-1)
     &     - 2*HBr1(-1)*upx**(-1)*y
     &     + 2*HBr1(-1)*z**(-1)
     &     - 6*HBr1(-1)*Hr1(0)
     &     - 8*HBr1(-1)*Hr1(0)*upx**(-4)
     &     - 16*HBr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 8*HBr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 16*HBr1(-1)*Hr1(0)*upx**(-3)
     &     + 32*HBr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 16*HBr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 16*HBr1(-1)*Hr1(0)*upx**(-2)
     &     - 28*HBr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 8*HBr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 8*HBr1(-1)*Hr1(0)*upx**(-1)
     &     + 12*HBr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 4*Hr2(-1,-1)
     &     + 32*Hr2(-1,-1)*upx**(-4)
     &     + 64*Hr2(-1,-1)*upx**(-4)*y
     &     + 32*Hr2(-1,-1)*upx**(-4)*y**2
     &     - 64*Hr2(-1,-1)*upx**(-3)
     &     - 128*Hr2(-1,-1)*upx**(-3)*y
     &     - 64*Hr2(-1,-1)*upx**(-3)*y**2
     &     + 16*Hr2(-1,-1)*upx**(-2)
     &     + 56*Hr2(-1,-1)*upx**(-2)*y
     &     + 32*Hr2(-1,-1)*upx**(-2)*y**2
     &     + 16*Hr2(-1,-1)*upx**(-1)
     &     + 8*Hr2(-1,-1)*upx**(-1)*y
     &     - 16*HAr2(-1,-1)
     &     - 32*HAr2(-1,-1)*upx**(-2)*y
     &     + 32*HAr2(-1,-1)*upx**(-1)*y
     &     - 4*HBr2(-1,-1)
     &     - 16*HBr2(-1,-1)*upx**(-2)
     &     - 8*HBr2(-1,-1)*upx**(-2)*y
     &     + 16*HBr2(-1,-1)*upx**(-1)
     &     + 8*HBr2(-1,-1)*upx**(-1)*y
     &     + 2*Hr2(-1,0)
     &     - 16*Hr2(-1,0)*upx**(-4)
     &     - 32*Hr2(-1,0)*upx**(-4)*y
     &     - 16*Hr2(-1,0)*upx**(-4)*y**2
     &     + 32*Hr2(-1,0)*upx**(-3)
     &     + 64*Hr2(-1,0)*upx**(-3)*y
     &     + 32*Hr2(-1,0)*upx**(-3)*y**2
     &     - 8*Hr2(-1,0)*upx**(-2)
     &     - 28*Hr2(-1,0)*upx**(-2)*y
     &     - 16*Hr2(-1,0)*upx**(-2)*y**2
     &     - 8*Hr2(-1,0)*upx**(-1)
     &     - 4*Hr2(-1,0)*upx**(-1)*y
     &     + 12*Hr1(0)
     &     + 18*Hr1(0)*umx**(-4)
     &     - 36*Hr1(0)*umx**(-4)*y
     &     + 18*Hr1(0)*umx**(-4)*y**2
     &     - 36*Hr1(0)*umx**(-3)
     &     + 72*Hr1(0)*umx**(-3)*y
     &     - 36*Hr1(0)*umx**(-3)*y**2
     &     + 34*Hr1(0)*umx**(-2)
     &     - 52*Hr1(0)*umx**(-2)*y
     &     + 12*Hr1(0)*umx**(-2)*y**2
     &     - 57.D0/4*Hr1(0)*umx**(-1)
     &     + 33.D0/2*Hr1(0)*umx**(-1)*y
     &     + 23.D0/4*Hr1(0)*umx**(-1)*y**2
     &     - 8*Hr1(0)*upx**(-5)
     &     - 16*Hr1(0)*upx**(-5)*y
     &     - 8*Hr1(0)*upx**(-5)*y**2
     &     + 28*Hr1(0)*upx**(-4)
     &     + 56*Hr1(0)*upx**(-4)*y
     &     + 28*Hr1(0)*upx**(-4)*y**2
     &     - 33*Hr1(0)*upx**(-3)
     &     - 74*Hr1(0)*upx**(-3)*y
     &     - 33*Hr1(0)*upx**(-3)*y**2
     &     + 15.D0/2*Hr1(0)*upx**(-2)
     &     + 35*Hr1(0)*upx**(-2)*y
     &     + 15.D0/2*Hr1(0)*upx**(-2)*y**2
     &     + 7.D0/4*Hr1(0)*upx**(-1)
     &     - 3.D0/2*Hr1(0)*upx**(-1)*y
     &     + 23.D0/4*Hr1(0)*upx**(-1)*y**2
     &     + 4*Hr2(0,-1)
     &     - 36*Hr2(0,-1)*umx**(-5)
     &     + 72*Hr2(0,-1)*umx**(-5)*y
     &     - 36*Hr2(0,-1)*umx**(-5)*y**2
     &     + 90*Hr2(0,-1)*umx**(-4)
     &     - 180*Hr2(0,-1)*umx**(-4)*y
     &     + 90*Hr2(0,-1)*umx**(-4)*y**2
     &     - 101*Hr2(0,-1)*umx**(-3)
     &     + 170*Hr2(0,-1)*umx**(-3)*y
     &     - 57*Hr2(0,-1)*umx**(-3)*y**2
     &     + 123.D0/2*Hr2(0,-1)*umx**(-2)
     &     - 75*Hr2(0,-1)*umx**(-2)*y
     &     - 9.D0/2*Hr2(0,-1)*umx**(-2)*y**2
     &     - 139.D0/4*Hr2(0,-1)*umx**(-1)
     &     + 9.D0/2*Hr2(0,-1)*umx**(-1)*y
     &     - 3.D0/4*Hr2(0,-1)*umx**(-1)*y**2
     &     - 16*Hr2(0,-1)*upx**(-4)
     &     - 32*Hr2(0,-1)*upx**(-4)*y
     &     - 16*Hr2(0,-1)*upx**(-4)*y**2
     &     + 34*Hr2(0,-1)*upx**(-3)
     &     + 48*Hr2(0,-1)*upx**(-3)*y
     &     + 14*Hr2(0,-1)*upx**(-3)*y**2
     &     - 11*Hr2(0,-1)*upx**(-2)
     &     - 4*Hr2(0,-1)*upx**(-2)*y
     &     + 11*Hr2(0,-1)*upx**(-2)*y**2
     &     + 37.D0/4*Hr2(0,-1)*upx**(-1)
     &     - 7.D0/2*Hr2(0,-1)*upx**(-1)*y
     &     - 3.D0/4*Hr2(0,-1)*upx**(-1)*y**2
     &     + 8*HAr2(0,-1)
     &     + 16*HAr2(0,-1)*upx**(-2)*y
     &     - 16*HAr2(0,-1)*upx**(-1)*y
     &     + 2*HBr2(0,-1)
     &     + 8*HBr2(0,-1)*upx**(-2)
     &     + 4*HBr2(0,-1)*upx**(-2)*y
     &     - 8*HBr2(0,-1)*upx**(-1)
     &     - 4*HBr2(0,-1)*upx**(-1)*y
     &     + 18*Hr2(0,0)*umx**(-5)
     &     - 36*Hr2(0,0)*umx**(-5)*y
     &     + 18*Hr2(0,0)*umx**(-5)*y**2
     &     - 45*Hr2(0,0)*umx**(-4)
     &     + 90*Hr2(0,0)*umx**(-4)*y
     &     - 45*Hr2(0,0)*umx**(-4)*y**2
     &     + 101.D0/2*Hr2(0,0)*umx**(-3)
     &     - 85*Hr2(0,0)*umx**(-3)*y
     &     + 57.D0/2*Hr2(0,0)*umx**(-3)*y**2
     &     - 123.D0/4*Hr2(0,0)*umx**(-2)
     &     + 75.D0/2*Hr2(0,0)*umx**(-2)*y
     &     + 9.D0/4*Hr2(0,0)*umx**(-2)*y**2
     &     + 121.D0/8*Hr2(0,0)*umx**(-1)
     &     - 7.D0/4*Hr2(0,0)*umx**(-1)*y
     &     + 1.D0/8*Hr2(0,0)*umx**(-1)*y**2
     &     - 4*Hr2(0,0)*upx**(-5)
     &     - 8*Hr2(0,0)*upx**(-5)*y
     &     - 4*Hr2(0,0)*upx**(-5)*y**2
     &     + 18*Hr2(0,0)*upx**(-4)
     &     + 36*Hr2(0,0)*upx**(-4)*y
     &     + 18*Hr2(0,0)*upx**(-4)*y**2
     &     - 26*Hr2(0,0)*upx**(-3)
     &     - 46*Hr2(0,0)*upx**(-3)*y
     &     - 16*Hr2(0,0)*upx**(-3)*y**2
     &     + 9*Hr2(0,0)*upx**(-2)
     &     + 15*Hr2(0,0)*upx**(-2)*y
     &     - 2*Hr2(0,0)*upx**(-2)*y**2
     &     - 55.D0/8*Hr2(0,0)*upx**(-1)
     &     - 7.D0/4*Hr2(0,0)*upx**(-1)*y
     &     + 1.D0/8*Hr2(0,0)*upx**(-1)*y**2
     &     + 4*Hr2(1,0)
     &     - 9.D0/2*Hr2(1,0)*umx**(-1)
     &     + Hr2(1,0)*umx**(-1)*y
     &     - 1.D0/2*Hr2(1,0)*umx**(-1)*y**2
     &     - 8*Hr2(1,0)*upx**(-5)
     &     - 16*Hr2(1,0)*upx**(-5)*y
     &     - 8*Hr2(1,0)*upx**(-5)*y**2
     &     + 20*Hr2(1,0)*upx**(-4)
     &     + 40*Hr2(1,0)*upx**(-4)*y
     &     + 20*Hr2(1,0)*upx**(-4)*y**2
     &     - 18*Hr2(1,0)*upx**(-3)
     &     - 44*Hr2(1,0)*upx**(-3)*y
     &     - 18*Hr2(1,0)*upx**(-3)*y**2
     &     + 7*Hr2(1,0)*upx**(-2)
     &     + 26*Hr2(1,0)*upx**(-2)*y
     &     + 7*Hr2(1,0)*upx**(-2)*y**2
     &     - 9.D0/2*Hr2(1,0)*upx**(-1)
     &     - 7*Hr2(1,0)*upx**(-1)*y
     &     - 1.D0/2*Hr2(1,0)*upx**(-1)*y**2
     &     + 22*DLog(tm**(-2)*w**2)
     &     + 44*DLog(tm**(-2)*w**2)*upx**(-4)
     &     + 88*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     + 44*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     - 88*DLog(tm**(-2)*w**2)*upx**(-3)
     &     - 176*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     - 88*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     + 44*DLog(tm**(-2)*w**2)*upx**(-2)
     &     + 132*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     + 44*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     - 44*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T13PoleEP0qqc = T13PoleEP0qqc + Nc**3*Nh * (
     &     + 20.D0/9
     &     - 32.D0/3*upx**(-6)
     &     - 64.D0/3*upx**(-6)*y
     &     - 32.D0/3*upx**(-6)*y**2
     &     + 32*upx**(-5)
     &     + 64*upx**(-5)*y
     &     + 32*upx**(-5)*y**2
     &     - 248.D0/9*upx**(-4)
     &     - 592.D0/9*upx**(-4)*y
     &     - 248.D0/9*upx**(-4)*y**2
     &     + 16.D0/9*upx**(-3)
     &     + 224.D0/9*upx**(-3)*y
     &     + 16.D0/9*upx**(-3)*y**2
     &     - 8.D0/9*upx**(-2)
     &     + 8.D0/3*upx**(-2)*y
     &     + 40.D0/9*upx**(-2)*y**2
     &     + 16.D0/3*upx**(-1)
     &     - 40.D0/9*upx**(-1)*y
     &     - 4.D0/3*Hr1(0)
     &     - 32.D0/3*Hr1(0)*upx**(-7)
     &     - 64.D0/3*Hr1(0)*upx**(-7)*y
     &     - 32.D0/3*Hr1(0)*upx**(-7)*y**2
     &     + 112.D0/3*Hr1(0)*upx**(-6)
     &     + 224.D0/3*Hr1(0)*upx**(-6)*y
     &     + 112.D0/3*Hr1(0)*upx**(-6)*y**2
     &     - 128.D0/3*Hr1(0)*upx**(-5)
     &     - 96*Hr1(0)*upx**(-5)*y
     &     - 128.D0/3*Hr1(0)*upx**(-5)*y**2
     &     + 40.D0/3*Hr1(0)*upx**(-4)
     &     + 160.D0/3*Hr1(0)*upx**(-4)*y
     &     + 40.D0/3*Hr1(0)*upx**(-4)*y**2
     &     - 16.D0/3*Hr1(0)*upx**(-3)*y
     &     + 16.D0/3*Hr1(0)*upx**(-3)*y**2
     &     + 16.D0/3*Hr1(0)*upx**(-2)
     &     - 8*Hr1(0)*upx**(-2)*y
     &     - 8.D0/3*Hr1(0)*upx**(-2)*y**2
     &     + 8.D0/3*Hr1(0)*upx**(-1)*y
     &     )
      T13PoleEP0qqc = T13PoleEP0qqc + Nc**3*Nl * (
     &     + 20.D0/9
     &     + 40.D0/9*upx**(-4)
     &     + 80.D0/9*upx**(-4)*y
     &     + 40.D0/9*upx**(-4)*y**2
     &     - 80.D0/9*upx**(-3)
     &     - 160.D0/9*upx**(-3)*y
     &     - 80.D0/9*upx**(-3)*y**2
     &     + 40.D0/9*upx**(-2)
     &     + 40.D0/3*upx**(-2)*y
     &     + 40.D0/9*upx**(-2)*y**2
     &     - 40.D0/9*upx**(-1)*y
     &     - 8.D0/3*Hr1(-1)
     &     - 16.D0/3*Hr1(-1)*upx**(-4)
     &     - 32.D0/3*Hr1(-1)*upx**(-4)*y
     &     - 16.D0/3*Hr1(-1)*upx**(-4)*y**2
     &     + 32.D0/3*Hr1(-1)*upx**(-3)
     &     + 64.D0/3*Hr1(-1)*upx**(-3)*y
     &     + 32.D0/3*Hr1(-1)*upx**(-3)*y**2
     &     - 16.D0/3*Hr1(-1)*upx**(-2)
     &     - 16*Hr1(-1)*upx**(-2)*y
     &     - 16.D0/3*Hr1(-1)*upx**(-2)*y**2
     &     + 16.D0/3*Hr1(-1)*upx**(-1)*y
     &     + 4.D0/3*Hr1(0)
     &     + 8.D0/3*Hr1(0)*upx**(-4)
     &     + 16.D0/3*Hr1(0)*upx**(-4)*y
     &     + 8.D0/3*Hr1(0)*upx**(-4)*y**2
     &     - 16.D0/3*Hr1(0)*upx**(-3)
     &     - 32.D0/3*Hr1(0)*upx**(-3)*y
     &     - 16.D0/3*Hr1(0)*upx**(-3)*y**2
     &     + 8.D0/3*Hr1(0)*upx**(-2)
     &     + 8*Hr1(0)*upx**(-2)*y
     &     + 8.D0/3*Hr1(0)*upx**(-2)*y**2
     &     - 8.D0/3*Hr1(0)*upx**(-1)*y
     &     + 4.D0/3*DLog(tm**(-2)*w**2)
     &     + 8.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)
     &     + 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     + 8.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     - 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)
     &     - 32.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     - 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     + 8.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)
     &     + 8*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     + 8.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     - 8.D0/3*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T13PoleEP0qqc = T13PoleEP0qqc + Nc**4 * (
     &     - 107.D0/9
     &     - 6*umx**(-5)*z2
     &     + 12*umx**(-5)*y*z2
     &     - 6*umx**(-5)*y**2*z2
     &     + 15*umx**(-4)*z2
     &     - 30*umx**(-4)*y*z2
     &     + 15*umx**(-4)*y**2*z2
     &     - 31.D0/2*umx**(-3)*z2
     &     + 27*umx**(-3)*y*z2
     &     - 19.D0/2*umx**(-3)*y**2*z2
     &     - umx**(-2)
     &     + 33.D0/4*umx**(-2)*z2
     &     + 2*umx**(-2)*y
     &     - 21.D0/2*umx**(-2)*y*z2
     &     - umx**(-2)*y**2
     &     - 3.D0/4*umx**(-2)*y**2*z2
     &     + umx**(-1)
     &     - 41.D0/8*umx**(-1)*z2
     &     - 2*umx**(-1)*y
     &     + 3.D0/4*umx**(-1)*y*z2
     &     + umx**(-1)*y**2
     &     - 1.D0/8*umx**(-1)*y**2*z2
     &     - 88.D0/9*upx**(-4)
     &     - 4*upx**(-4)*z2
     &     - 176.D0/9*upx**(-4)*y
     &     - 8*upx**(-4)*y*z2
     &     - 88.D0/9*upx**(-4)*y**2
     &     - 4*upx**(-4)*y**2*z2
     &     + 176.D0/9*upx**(-3)
     &     + 7*upx**(-3)*z2
     &     + 352.D0/9*upx**(-3)*y
     &     + 12*upx**(-3)*y*z2
     &     + 176.D0/9*upx**(-3)*y**2
     &     + 5*upx**(-3)*y**2*z2
     &     - 97.D0/9*upx**(-2)
     &     - 5.D0/2*upx**(-2)*z2
     &     - 94.D0/3*upx**(-2)*y
     &     - 4*upx**(-2)*y*z2
     &     - 97.D0/9*upx**(-2)*y**2
     &     + 1.D0/2*upx**(-2)*y**2*z2
     &     + upx**(-1)
     &     + 7.D0/8*upx**(-1)*z2
     &     + 106.D0/9*upx**(-1)*y
     &     + 3.D0/4*upx**(-1)*y*z2
     &     + upx**(-1)*y**2
     &     - 1.D0/8*upx**(-1)*y**2*z2
     &     + 20.D0/3*Hr1(-1)
     &     + 12*Hr1(-1)*umx**(-4)
     &     - 24*Hr1(-1)*umx**(-4)*y
     &     + 12*Hr1(-1)*umx**(-4)*y**2
     &     - 24*Hr1(-1)*umx**(-3)
     &     + 48*Hr1(-1)*umx**(-3)*y
     &     - 24*Hr1(-1)*umx**(-3)*y**2
     &     + 20*Hr1(-1)*umx**(-2)
     &     - 32*Hr1(-1)*umx**(-2)*y
     &     + 8*Hr1(-1)*umx**(-2)*y**2
     &     - 8*Hr1(-1)*umx**(-1)
     &     + 8*Hr1(-1)*umx**(-1)*y
     &     + 4*Hr1(-1)*umx**(-1)*y**2
     &     + 28.D0/3*Hr1(-1)*upx**(-4)
     &     + 56.D0/3*Hr1(-1)*upx**(-4)*y
     &     + 28.D0/3*Hr1(-1)*upx**(-4)*y**2
     &     - 56.D0/3*Hr1(-1)*upx**(-3)
     &     - 112.D0/3*Hr1(-1)*upx**(-3)*y
     &     - 56.D0/3*Hr1(-1)*upx**(-3)*y**2
     &     + 16.D0/3*Hr1(-1)*upx**(-2)
     &     + 20*Hr1(-1)*upx**(-2)*y
     &     + 16.D0/3*Hr1(-1)*upx**(-2)*y**2
     &     + 4*Hr1(-1)*upx**(-1)
     &     - 4.D0/3*Hr1(-1)*upx**(-1)*y
     &     + 4*Hr1(-1)*upx**(-1)*y**2
     &     + 4*Hr1(-1)*HAr1(-1)
     &     + 16*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     + 32*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     + 16*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     - 32*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     - 64*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     - 32*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     + 16*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     + 40*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     + 16*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     - 8*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     + 2*HAr1(-1)
     &     - 2*HAr1(-1)*upx**(-2)*y**(-1)
     &     - 4*HAr1(-1)*upx**(-2)
     &     - 2*HAr1(-1)*upx**(-2)*y
     &     + 2*HAr1(-1)*upx**(-1)*y**(-1)
     &     + 4*HAr1(-1)*upx**(-1)
     &     + 2*HAr1(-1)*upx**(-1)*y
     &     + 2*HAr1(-1)*y**(-1)
     &     - 2*HAr1(-1)*Hr1(0)
     &     - 8*HAr1(-1)*Hr1(0)*upx**(-4)
     &     - 16*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 8*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 16*HAr1(-1)*Hr1(0)*upx**(-3)
     &     + 32*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 16*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 8*HAr1(-1)*Hr1(0)*upx**(-2)
     &     - 20*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 8*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 4*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 4*Hr2(-1,-1)
     &     - 16*Hr2(-1,-1)*upx**(-4)
     &     - 32*Hr2(-1,-1)*upx**(-4)*y
     &     - 16*Hr2(-1,-1)*upx**(-4)*y**2
     &     + 32*Hr2(-1,-1)*upx**(-3)
     &     + 64*Hr2(-1,-1)*upx**(-3)*y
     &     + 32*Hr2(-1,-1)*upx**(-3)*y**2
     &     - 16*Hr2(-1,-1)*upx**(-2)
     &     - 40*Hr2(-1,-1)*upx**(-2)*y
     &     - 16*Hr2(-1,-1)*upx**(-2)*y**2
     &     + 8*Hr2(-1,-1)*upx**(-1)*y
     &     + 4*HAr2(-1,-1)
     &     + 8*HAr2(-1,-1)*upx**(-2)*y
     &     - 8*HAr2(-1,-1)*upx**(-1)*y
     &     + 2*Hr2(-1,0)
     &     + 8*Hr2(-1,0)*upx**(-4)
     &     + 16*Hr2(-1,0)*upx**(-4)*y
     &     + 8*Hr2(-1,0)*upx**(-4)*y**2
     &     - 16*Hr2(-1,0)*upx**(-3)
     &     - 32*Hr2(-1,0)*upx**(-3)*y
     &     - 16*Hr2(-1,0)*upx**(-3)*y**2
     &     + 8*Hr2(-1,0)*upx**(-2)
     &     + 20*Hr2(-1,0)*upx**(-2)*y
     &     + 8*Hr2(-1,0)*upx**(-2)*y**2
     &     - 4*Hr2(-1,0)*upx**(-1)*y
     &     - 10.D0/3*Hr1(0)
     &     - 6*Hr1(0)*umx**(-4)
     &     + 12*Hr1(0)*umx**(-4)*y
     &     - 6*Hr1(0)*umx**(-4)*y**2
     &     + 12*Hr1(0)*umx**(-3)
     &     - 24*Hr1(0)*umx**(-3)*y
     &     + 12*Hr1(0)*umx**(-3)*y**2
     &     - 10*Hr1(0)*umx**(-2)
     &     + 16*Hr1(0)*umx**(-2)*y
     &     - 4*Hr1(0)*umx**(-2)*y**2
     &     + 4*Hr1(0)*umx**(-1)
     &     - 4*Hr1(0)*umx**(-1)*y
     &     - 2*Hr1(0)*umx**(-1)*y**2
     &     - 14.D0/3*Hr1(0)*upx**(-4)
     &     - 28.D0/3*Hr1(0)*upx**(-4)*y
     &     - 14.D0/3*Hr1(0)*upx**(-4)*y**2
     &     + 28.D0/3*Hr1(0)*upx**(-3)
     &     + 56.D0/3*Hr1(0)*upx**(-3)*y
     &     + 28.D0/3*Hr1(0)*upx**(-3)*y**2
     &     - 8.D0/3*Hr1(0)*upx**(-2)
     &     - 10*Hr1(0)*upx**(-2)*y
     &     - 8.D0/3*Hr1(0)*upx**(-2)*y**2
     &     - 2*Hr1(0)*upx**(-1)
     &     + 2.D0/3*Hr1(0)*upx**(-1)*y
     &     - 2*Hr1(0)*upx**(-1)*y**2
     &     + 12*Hr2(0,-1)*umx**(-5)
     &     - 24*Hr2(0,-1)*umx**(-5)*y
     &     + 12*Hr2(0,-1)*umx**(-5)*y**2
     &     - 30*Hr2(0,-1)*umx**(-4)
     &     + 60*Hr2(0,-1)*umx**(-4)*y
     &     - 30*Hr2(0,-1)*umx**(-4)*y**2
     &     + 31*Hr2(0,-1)*umx**(-3)
     &     - 54*Hr2(0,-1)*umx**(-3)*y
     &     + 19*Hr2(0,-1)*umx**(-3)*y**2
     &     - 33.D0/2*Hr2(0,-1)*umx**(-2)
     &     + 21*Hr2(0,-1)*umx**(-2)*y
     &     + 3.D0/2*Hr2(0,-1)*umx**(-2)*y**2
     &     + 41.D0/4*Hr2(0,-1)*umx**(-1)
     &     - 3.D0/2*Hr2(0,-1)*umx**(-1)*y
     &     + 1.D0/4*Hr2(0,-1)*umx**(-1)*y**2
     &     + 8*Hr2(0,-1)*upx**(-4)
     &     + 16*Hr2(0,-1)*upx**(-4)*y
     &     + 8*Hr2(0,-1)*upx**(-4)*y**2
     &     - 14*Hr2(0,-1)*upx**(-3)
     &     - 24*Hr2(0,-1)*upx**(-3)*y
     &     - 10*Hr2(0,-1)*upx**(-3)*y**2
     &     + 5*Hr2(0,-1)*upx**(-2)
     &     + 8*Hr2(0,-1)*upx**(-2)*y
     &     - Hr2(0,-1)*upx**(-2)*y**2
     &     - 7.D0/4*Hr2(0,-1)*upx**(-1)
     &     - 3.D0/2*Hr2(0,-1)*upx**(-1)*y
     &     + 1.D0/4*Hr2(0,-1)*upx**(-1)*y**2
     &     - 2*HAr2(0,-1)
     &     - 4*HAr2(0,-1)*upx**(-2)*y
     &     + 4*HAr2(0,-1)*upx**(-1)*y
     &     - 6*Hr2(0,0)*umx**(-5)
     &     + 12*Hr2(0,0)*umx**(-5)*y
     &     - 6*Hr2(0,0)*umx**(-5)*y**2
     &     + 15*Hr2(0,0)*umx**(-4)
     &     - 30*Hr2(0,0)*umx**(-4)*y
     &     + 15*Hr2(0,0)*umx**(-4)*y**2
     &     - 31.D0/2*Hr2(0,0)*umx**(-3)
     &     + 27*Hr2(0,0)*umx**(-3)*y
     &     - 19.D0/2*Hr2(0,0)*umx**(-3)*y**2
     &     + 33.D0/4*Hr2(0,0)*umx**(-2)
     &     - 21.D0/2*Hr2(0,0)*umx**(-2)*y
     &     - 3.D0/4*Hr2(0,0)*umx**(-2)*y**2
     &     - 41.D0/8*Hr2(0,0)*umx**(-1)
     &     + 3.D0/4*Hr2(0,0)*umx**(-1)*y
     &     - 1.D0/8*Hr2(0,0)*umx**(-1)*y**2
     &     - 4*Hr2(0,0)*upx**(-4)
     &     - 8*Hr2(0,0)*upx**(-4)*y
     &     - 4*Hr2(0,0)*upx**(-4)*y**2
     &     + 7*Hr2(0,0)*upx**(-3)
     &     + 12*Hr2(0,0)*upx**(-3)*y
     &     + 5*Hr2(0,0)*upx**(-3)*y**2
     &     - 5.D0/2*Hr2(0,0)*upx**(-2)
     &     - 4*Hr2(0,0)*upx**(-2)*y
     &     + 1.D0/2*Hr2(0,0)*upx**(-2)*y**2
     &     + 7.D0/8*Hr2(0,0)*upx**(-1)
     &     + 3.D0/4*Hr2(0,0)*upx**(-1)*y
     &     - 1.D0/8*Hr2(0,0)*upx**(-1)*y**2
     &     - 22.D0/3*DLog(tm**(-2)*w**2)
     &     - 44.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)
     &     - 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     - 44.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     + 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)
     &     + 176.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     + 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     - 44.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)
     &     - 44*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     - 44.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     + 44.D0/3*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      return
      end

*
*******************************************************************************
************************************************************************
************************************************************************
*
*          FUNCTIONS for the Cross Section
*
*************************************************************************
**************************** 72 characters *****************************
*
*
      double precision function T23PoleEPm2qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      T23PoleEPm2qq =  + Nc**(-2) * (
     &     + 16
     &     + 32*upx**(-4)
     &     + 64*upx**(-4)*y
     &     + 32*upx**(-4)*y**2
     &     - 64*upx**(-3)
     &     - 128*upx**(-3)*y
     &     - 64*upx**(-3)*y**2
     &     + 32*upx**(-2)
     &     + 96*upx**(-2)*y
     &     + 32*upx**(-2)*y**2
     &     - 32*upx**(-1)*y
     &     )/4.D0
      T23PoleEPm2qq = T23PoleEPm2qq + (
     &     - 32
     &     - 64*upx**(-4)
     &     - 128*upx**(-4)*y
     &     - 64*upx**(-4)*y**2
     &     + 128*upx**(-3)
     &     + 256*upx**(-3)*y
     &     + 128*upx**(-3)*y**2
     &     - 64*upx**(-2)
     &     - 192*upx**(-2)*y
     &     - 64*upx**(-2)*y**2
     &     + 64*upx**(-1)*y
     &     )/4.D0
      T23PoleEPm2qq = T23PoleEPm2qq + Nc**2 * (
     &     + 16
     &     + 32*upx**(-4)
     &     + 64*upx**(-4)*y
     &     + 32*upx**(-4)*y**2
     &     - 64*upx**(-3)
     &     - 128*upx**(-3)*y
     &     - 64*upx**(-3)*y**2
     &     + 32*upx**(-2)
     &     + 96*upx**(-2)*y
     &     + 32*upx**(-2)*y**2
     &     - 32*upx**(-1)*y
     &     )/4.D0
      return
      end
*
*
*
      double precision function T23PoleEPm1qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      T23PoleEPm1qq =  + Nc**(-2) * (
     &     - 12
     &     - 40*upx**(-4)
     &     - 80*upx**(-4)*y
     &     - 40*upx**(-4)*y**2
     &     + 80*upx**(-3)
     &     + 160*upx**(-3)*y
     &     + 80*upx**(-3)*y**2
     &     - 40*upx**(-2)
     &     - 120*upx**(-2)*y
     &     - 40*upx**(-2)*y**2
     &     + 40*upx**(-1)*y
     &     + 16*Hr1(-1)
     &     + 32*Hr1(-1)*upx**(-4)
     &     + 64*Hr1(-1)*upx**(-4)*y
     &     + 32*Hr1(-1)*upx**(-4)*y**2
     &     - 64*Hr1(-1)*upx**(-3)
     &     - 128*Hr1(-1)*upx**(-3)*y
     &     - 64*Hr1(-1)*upx**(-3)*y**2
     &     + 32*Hr1(-1)*upx**(-2)
     &     + 96*Hr1(-1)*upx**(-2)*y
     &     + 32*Hr1(-1)*upx**(-2)*y**2
     &     - 32*Hr1(-1)*upx**(-1)*y
     &     + 24*HAr1(-1)
     &     + 48*HAr1(-1)*upx**(-4)
     &     + 96*HAr1(-1)*upx**(-4)*y
     &     + 48*HAr1(-1)*upx**(-4)*y**2
     &     - 96*HAr1(-1)*upx**(-3)
     &     - 192*HAr1(-1)*upx**(-3)*y
     &     - 96*HAr1(-1)*upx**(-3)*y**2
     &     + 48*HAr1(-1)*upx**(-2)
     &     + 144*HAr1(-1)*upx**(-2)*y
     &     + 48*HAr1(-1)*upx**(-2)*y**2
     &     - 48*HAr1(-1)*upx**(-1)*y
     &     - 24*HBr1(-1)
     &     - 48*HBr1(-1)*upx**(-4)
     &     - 96*HBr1(-1)*upx**(-4)*y
     &     - 48*HBr1(-1)*upx**(-4)*y**2
     &     + 96*HBr1(-1)*upx**(-3)
     &     + 192*HBr1(-1)*upx**(-3)*y
     &     + 96*HBr1(-1)*upx**(-3)*y**2
     &     - 48*HBr1(-1)*upx**(-2)
     &     - 144*HBr1(-1)*upx**(-2)*y
     &     - 48*HBr1(-1)*upx**(-2)*y**2
     &     + 48*HBr1(-1)*upx**(-1)*y
     &     - 9*Hr1(0)*umx**(-1)
     &     + 2*Hr1(0)*umx**(-1)*y
     &     - Hr1(0)*umx**(-1)*y**2
     &     - 16*Hr1(0)*upx**(-5)
     &     - 32*Hr1(0)*upx**(-5)*y
     &     - 16*Hr1(0)*upx**(-5)*y**2
     &     + 24*Hr1(0)*upx**(-4)
     &     + 48*Hr1(0)*upx**(-4)*y
     &     + 24*Hr1(0)*upx**(-4)*y**2
     &     - 4*Hr1(0)*upx**(-3)
     &     - 24*Hr1(0)*upx**(-3)*y
     &     - 4*Hr1(0)*upx**(-3)*y**2
     &     - 2*Hr1(0)*upx**(-2)
     &     + 4*Hr1(0)*upx**(-2)*y
     &     - 2*Hr1(0)*upx**(-2)*y**2
     &     - 9*Hr1(0)*upx**(-1)
     &     + 2*Hr1(0)*upx**(-1)*y
     &     - Hr1(0)*upx**(-1)*y**2
     &     )/(-2.D0)
      T23PoleEPm1qq = T23PoleEPm1qq + (
     &     + 24
     &     + 80*upx**(-4)
     &     + 160*upx**(-4)*y
     &     + 80*upx**(-4)*y**2
     &     - 160*upx**(-3)
     &     - 320*upx**(-3)*y
     &     - 160*upx**(-3)*y**2
     &     + 80*upx**(-2)
     &     + 240*upx**(-2)*y
     &     + 80*upx**(-2)*y**2
     &     - 80*upx**(-1)*y
     &     - 16*Hr1(-1)
     &     - 32*Hr1(-1)*upx**(-4)
     &     - 64*Hr1(-1)*upx**(-4)*y
     &     - 32*Hr1(-1)*upx**(-4)*y**2
     &     + 64*Hr1(-1)*upx**(-3)
     &     + 128*Hr1(-1)*upx**(-3)*y
     &     + 64*Hr1(-1)*upx**(-3)*y**2
     &     - 32*Hr1(-1)*upx**(-2)
     &     - 96*Hr1(-1)*upx**(-2)*y
     &     - 32*Hr1(-1)*upx**(-2)*y**2
     &     + 32*Hr1(-1)*upx**(-1)*y
     &     - 32*HAr1(-1)
     &     - 64*HAr1(-1)*upx**(-4)
     &     - 128*HAr1(-1)*upx**(-4)*y
     &     - 64*HAr1(-1)*upx**(-4)*y**2
     &     + 128*HAr1(-1)*upx**(-3)
     &     + 256*HAr1(-1)*upx**(-3)*y
     &     + 128*HAr1(-1)*upx**(-3)*y**2
     &     - 64*HAr1(-1)*upx**(-2)
     &     - 192*HAr1(-1)*upx**(-2)*y
     &     - 64*HAr1(-1)*upx**(-2)*y**2
     &     + 64*HAr1(-1)*upx**(-1)*y
     &     + 16*HBr1(-1)
     &     + 32*HBr1(-1)*upx**(-4)
     &     + 64*HBr1(-1)*upx**(-4)*y
     &     + 32*HBr1(-1)*upx**(-4)*y**2
     &     - 64*HBr1(-1)*upx**(-3)
     &     - 128*HBr1(-1)*upx**(-3)*y
     &     - 64*HBr1(-1)*upx**(-3)*y**2
     &     + 32*HBr1(-1)*upx**(-2)
     &     + 96*HBr1(-1)*upx**(-2)*y
     &     + 32*HBr1(-1)*upx**(-2)*y**2
     &     - 32*HBr1(-1)*upx**(-1)*y
     &     + 9*Hr1(0)*umx**(-1)
     &     - 2*Hr1(0)*umx**(-1)*y
     &     + Hr1(0)*umx**(-1)*y**2
     &     + 16*Hr1(0)*upx**(-5)
     &     + 32*Hr1(0)*upx**(-5)*y
     &     + 16*Hr1(0)*upx**(-5)*y**2
     &     - 24*Hr1(0)*upx**(-4)
     &     - 48*Hr1(0)*upx**(-4)*y
     &     - 24*Hr1(0)*upx**(-4)*y**2
     &     + 4*Hr1(0)*upx**(-3)
     &     + 24*Hr1(0)*upx**(-3)*y
     &     + 4*Hr1(0)*upx**(-3)*y**2
     &     + 2*Hr1(0)*upx**(-2)
     &     - 4*Hr1(0)*upx**(-2)*y
     &     + 2*Hr1(0)*upx**(-2)*y**2
     &     + 9*Hr1(0)*upx**(-1)
     &     - 2*Hr1(0)*upx**(-1)*y
     &     + Hr1(0)*upx**(-1)*y**2
     &     )/(-2.D0)
      T23PoleEPm1qq = T23PoleEPm1qq + Nc**2 * (
     &     - 12
     &     - 40*upx**(-4)
     &     - 80*upx**(-4)*y
     &     - 40*upx**(-4)*y**2
     &     + 80*upx**(-3)
     &     + 160*upx**(-3)*y
     &     + 80*upx**(-3)*y**2
     &     - 40*upx**(-2)
     &     - 120*upx**(-2)*y
     &     - 40*upx**(-2)*y**2
     &     + 40*upx**(-1)*y
     &     + 8*HAr1(-1)
     &     + 16*HAr1(-1)*upx**(-4)
     &     + 32*HAr1(-1)*upx**(-4)*y
     &     + 16*HAr1(-1)*upx**(-4)*y**2
     &     - 32*HAr1(-1)*upx**(-3)
     &     - 64*HAr1(-1)*upx**(-3)*y
     &     - 32*HAr1(-1)*upx**(-3)*y**2
     &     + 16*HAr1(-1)*upx**(-2)
     &     + 48*HAr1(-1)*upx**(-2)*y
     &     + 16*HAr1(-1)*upx**(-2)*y**2
     &     - 16*HAr1(-1)*upx**(-1)*y
     &     + 8*HBr1(-1)
     &     + 16*HBr1(-1)*upx**(-4)
     &     + 32*HBr1(-1)*upx**(-4)*y
     &     + 16*HBr1(-1)*upx**(-4)*y**2
     &     - 32*HBr1(-1)*upx**(-3)
     &     - 64*HBr1(-1)*upx**(-3)*y
     &     - 32*HBr1(-1)*upx**(-3)*y**2
     &     + 16*HBr1(-1)*upx**(-2)
     &     + 48*HBr1(-1)*upx**(-2)*y
     &     + 16*HBr1(-1)*upx**(-2)*y**2
     &     - 16*HBr1(-1)*upx**(-1)*y
     &     )/(-2.D0)
      return
      end
*
*
*
      double precision function T23PoleEP0qq(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1d0

* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      T23PoleEP0qq =  + Nc**(-2) * (
     &     + 14
     &     - 12*umx**(-3)*z2
     &     + 12*umx**(-3)*y*z2
     &     + 18*umx**(-2)*z2
     &     - 18*umx**(-2)*y*z2
     &     - 24*umx**(-1)*z2
     &     + 4*umx**(-1)*y*z2
     &     - 2*umx**(-1)*y**2*z2
     &     - 32*upx**(-5)*z2
     &     - 64*upx**(-5)*y*z2
     &     - 32*upx**(-5)*y**2*z2
     &     + 48*upx**(-4)
     &     + 48*upx**(-4)*z2
     &     + 96*upx**(-4)*y
     &     + 96*upx**(-4)*y*z2
     &     + 48*upx**(-4)*y**2
     &     + 48*upx**(-4)*y**2*z2
     &     - 96*upx**(-3)
     &     + 4*upx**(-3)*z2
     &     - 192*upx**(-3)*y
     &     - 36*upx**(-3)*y*z2
     &     - 96*upx**(-3)*y**2
     &     - 8*upx**(-3)*y**2*z2
     &     + 48*upx**(-2)
     &     - 10*upx**(-2)*z2
     &     + 144*upx**(-2)*y
     &     + 2*upx**(-2)*y*z2
     &     + 48*upx**(-2)*y**2
     &     - 4*upx**(-2)*y**2*z2
     &     - 12*upx**(-1)*z2
     &     - 48*upx**(-1)*y
     &     + 4*upx**(-1)*y*z2
     &     - 2*upx**(-1)*y**2*z2
     &     + 8*Hr1(-1)
     &     + 24*Hr1(-1)*umx**(-2)
     &     - 24*Hr1(-1)*umx**(-2)*y
     &     - 24*Hr1(-1)*umx**(-1)
     &     + 24*Hr1(-1)*umx**(-1)*y
     &     - 24*Hr1(-1)*upx**(-4)
     &     - 48*Hr1(-1)*upx**(-4)*y
     &     - 24*Hr1(-1)*upx**(-4)*y**2
     &     + 48*Hr1(-1)*upx**(-3)
     &     + 96*Hr1(-1)*upx**(-3)*y
     &     + 48*Hr1(-1)*upx**(-3)*y**2
     &     - 24*Hr1(-1)*upx**(-2)
     &     - 72*Hr1(-1)*upx**(-2)*y
     &     - 24*Hr1(-1)*upx**(-2)*y**2
     &     + 24*Hr1(-1)*upx**(-1)*y
     &     + 12*Hr1(-1)*HAr1(-1)
     &     + 48*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     + 96*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     + 48*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     - 96*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     - 192*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     - 96*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     + 48*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     + 120*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     + 48*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     - 24*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     - 36*Hr1(-1)*HBr1(-1)
     &     - 48*Hr1(-1)*HBr1(-1)*upx**(-4)
     &     - 96*Hr1(-1)*HBr1(-1)*upx**(-4)*y
     &     - 48*Hr1(-1)*HBr1(-1)*upx**(-4)*y**2
     &     + 96*Hr1(-1)*HBr1(-1)*upx**(-3)
     &     + 192*Hr1(-1)*HBr1(-1)*upx**(-3)*y
     &     + 96*Hr1(-1)*HBr1(-1)*upx**(-3)*y**2
     &     - 96*Hr1(-1)*HBr1(-1)*upx**(-2)
     &     - 168*Hr1(-1)*HBr1(-1)*upx**(-2)*y
     &     - 48*Hr1(-1)*HBr1(-1)*upx**(-2)*y**2
     &     + 48*Hr1(-1)*HBr1(-1)*upx**(-1)
     &     + 72*Hr1(-1)*HBr1(-1)*upx**(-1)*y
     &     + 6*HAr1(-1)
     &     - 6*HAr1(-1)*upx**(-2)*y**(-1)
     &     - 12*HAr1(-1)*upx**(-2)
     &     - 6*HAr1(-1)*upx**(-2)*y
     &     + 6*HAr1(-1)*upx**(-1)*y**(-1)
     &     + 12*HAr1(-1)*upx**(-1)
     &     + 6*HAr1(-1)*upx**(-1)*y
     &     + 6*HAr1(-1)*y**(-1)
     &     - 6*HAr1(-1)*Hr1(0)
     &     - 24*HAr1(-1)*Hr1(0)*upx**(-4)
     &     - 48*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 24*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 48*HAr1(-1)*Hr1(0)*upx**(-3)
     &     + 96*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 48*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 24*HAr1(-1)*Hr1(0)*upx**(-2)
     &     - 60*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 24*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 12*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 12*HBr1(-1)
     &     + 6*HBr1(-1)*upx**(-2)*z**(-1)
     &     - 6*HBr1(-1)*upx**(-2)*y
     &     - 6*HBr1(-1)*upx**(-1)*z**(-1)
     &     + 6*HBr1(-1)*upx**(-1)*y
     &     - 6*HBr1(-1)*z**(-1)
     &     + 18*HBr1(-1)*Hr1(0)
     &     + 24*HBr1(-1)*Hr1(0)*upx**(-4)
     &     + 48*HBr1(-1)*Hr1(0)*upx**(-4)*y
     &     + 24*HBr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     - 48*HBr1(-1)*Hr1(0)*upx**(-3)
     &     - 96*HBr1(-1)*Hr1(0)*upx**(-3)*y
     &     - 48*HBr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     + 48*HBr1(-1)*Hr1(0)*upx**(-2)
     &     + 84*HBr1(-1)*Hr1(0)*upx**(-2)*y
     &     + 24*HBr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     - 24*HBr1(-1)*Hr1(0)*upx**(-1)
     &     - 36*HBr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 40*Hr2(-1,-1)
     &     + 32*Hr2(-1,-1)*upx**(-4)
     &     + 64*Hr2(-1,-1)*upx**(-4)*y
     &     + 32*Hr2(-1,-1)*upx**(-4)*y**2
     &     - 64*Hr2(-1,-1)*upx**(-3)
     &     - 128*Hr2(-1,-1)*upx**(-3)*y
     &     - 64*Hr2(-1,-1)*upx**(-3)*y**2
     &     + 80*Hr2(-1,-1)*upx**(-2)
     &     + 144*Hr2(-1,-1)*upx**(-2)*y
     &     + 32*Hr2(-1,-1)*upx**(-2)*y**2
     &     - 48*Hr2(-1,-1)*upx**(-1)
     &     - 80*Hr2(-1,-1)*upx**(-1)*y
     &     + 12*HAr2(-1,-1)
     &     + 24*HAr2(-1,-1)*upx**(-2)*y
     &     - 24*HAr2(-1,-1)*upx**(-1)*y
     &     + 12*HBr2(-1,-1)
     &     + 48*HBr2(-1,-1)*upx**(-2)
     &     + 24*HBr2(-1,-1)*upx**(-2)*y
     &     - 48*HBr2(-1,-1)*upx**(-1)
     &     - 24*HBr2(-1,-1)*upx**(-1)*y
     &     - 20*Hr2(-1,0)
     &     - 16*Hr2(-1,0)*upx**(-4)
     &     - 32*Hr2(-1,0)*upx**(-4)*y
     &     - 16*Hr2(-1,0)*upx**(-4)*y**2
     &     + 32*Hr2(-1,0)*upx**(-3)
     &     + 64*Hr2(-1,0)*upx**(-3)*y
     &     + 32*Hr2(-1,0)*upx**(-3)*y**2
     &     - 40*Hr2(-1,0)*upx**(-2)
     &     - 72*Hr2(-1,0)*upx**(-2)*y
     &     - 16*Hr2(-1,0)*upx**(-2)*y**2
     &     + 24*Hr2(-1,0)*upx**(-1)
     &     + 40*Hr2(-1,0)*upx**(-1)*y
     &     - 6*Hr1(0)
     &     - 12*Hr1(0)*umx**(-2)
     &     + 12*Hr1(0)*umx**(-2)*y
     &     + 17.D0/2*Hr1(0)*umx**(-1)
     &     - 13*Hr1(0)*umx**(-1)*y
     &     + 1.D0/2*Hr1(0)*umx**(-1)*y**2
     &     + 16*Hr1(0)*upx**(-5)
     &     + 32*Hr1(0)*upx**(-5)*y
     &     + 16*Hr1(0)*upx**(-5)*y**2
     &     - 28*Hr1(0)*upx**(-4)
     &     - 56*Hr1(0)*upx**(-4)*y
     &     - 28*Hr1(0)*upx**(-4)*y**2
     &     + 10*Hr1(0)*upx**(-3)
     &     + 36*Hr1(0)*upx**(-3)*y
     &     + 10*Hr1(0)*upx**(-3)*y**2
     &     + Hr1(0)*upx**(-2)
     &     - 10*Hr1(0)*upx**(-2)*y
     &     + Hr1(0)*upx**(-2)*y**2
     &     + 17.D0/2*Hr1(0)*upx**(-1)
     &     - Hr1(0)*upx**(-1)*y
     &     + 1.D0/2*Hr1(0)*upx**(-1)*y**2
     &     - 8*Hr2(0,-1)
     &     + 24*Hr2(0,-1)*umx**(-3)
     &     - 24*Hr2(0,-1)*umx**(-3)*y
     &     - 36*Hr2(0,-1)*umx**(-2)
     &     + 36*Hr2(0,-1)*umx**(-2)*y
     &     + 12*Hr2(0,-1)*umx**(-1)
     &     - 16*Hr2(0,-1)*upx**(-4)
     &     - 32*Hr2(0,-1)*upx**(-4)*y
     &     - 16*Hr2(0,-1)*upx**(-4)*y**2
     &     + 8*Hr2(0,-1)*upx**(-3)
     &     + 40*Hr2(0,-1)*upx**(-3)*y
     &     + 32*Hr2(0,-1)*upx**(-3)*y**2
     &     - 4*Hr2(0,-1)*upx**(-2)
     &     - 36*Hr2(0,-1)*upx**(-2)*y
     &     - 16*Hr2(0,-1)*upx**(-2)*y**2
     &     - 12*Hr2(0,-1)*upx**(-1)
     &     + 16*Hr2(0,-1)*upx**(-1)*y
     &     - 6*HAr2(0,-1)
     &     - 12*HAr2(0,-1)*upx**(-2)*y
     &     + 12*HAr2(0,-1)*upx**(-1)*y
     &     - 6*HBr2(0,-1)
     &     - 24*HBr2(0,-1)*upx**(-2)
     &     - 12*HBr2(0,-1)*upx**(-2)*y
     &     + 24*HBr2(0,-1)*upx**(-1)
     &     + 12*HBr2(0,-1)*upx**(-1)*y
     &     - 12*Hr2(0,0)*umx**(-3)
     &     + 12*Hr2(0,0)*umx**(-3)*y
     &     + 18*Hr2(0,0)*umx**(-2)
     &     - 18*Hr2(0,0)*umx**(-2)*y
     &     - 3.D0/2*Hr2(0,0)*umx**(-1)
     &     - Hr2(0,0)*umx**(-1)*y
     &     + 1.D0/2*Hr2(0,0)*umx**(-1)*y**2
     &     + 8*Hr2(0,0)*upx**(-5)
     &     + 16*Hr2(0,0)*upx**(-5)*y
     &     + 8*Hr2(0,0)*upx**(-5)*y**2
     &     - 12*Hr2(0,0)*upx**(-4)
     &     - 24*Hr2(0,0)*upx**(-4)*y
     &     - 12*Hr2(0,0)*upx**(-4)*y**2
     &     + 14*Hr2(0,0)*upx**(-3)
     &     + 24*Hr2(0,0)*upx**(-3)*y
     &     + 2*Hr2(0,0)*upx**(-3)*y**2
     &     - 5*Hr2(0,0)*upx**(-2)
     &     - 8*Hr2(0,0)*upx**(-2)*y
     &     + Hr2(0,0)*upx**(-2)*y**2
     &     + 21.D0/2*Hr2(0,0)*upx**(-1)
     &     - Hr2(0,0)*upx**(-1)*y
     &     + 1.D0/2*Hr2(0,0)*upx**(-1)*y**2
     &     - 8*Hr2(1,0)
     &     + 9*Hr2(1,0)*umx**(-1)
     &     - 2*Hr2(1,0)*umx**(-1)*y
     &     + Hr2(1,0)*umx**(-1)*y**2
     &     + 16*Hr2(1,0)*upx**(-5)
     &     + 32*Hr2(1,0)*upx**(-5)*y
     &     + 16*Hr2(1,0)*upx**(-5)*y**2
     &     - 40*Hr2(1,0)*upx**(-4)
     &     - 80*Hr2(1,0)*upx**(-4)*y
     &     - 40*Hr2(1,0)*upx**(-4)*y**2
     &     + 36*Hr2(1,0)*upx**(-3)
     &     + 88*Hr2(1,0)*upx**(-3)*y
     &     + 36*Hr2(1,0)*upx**(-3)*y**2
     &     - 14*Hr2(1,0)*upx**(-2)
     &     - 52*Hr2(1,0)*upx**(-2)*y
     &     - 14*Hr2(1,0)*upx**(-2)*y**2
     &     + 9*Hr2(1,0)*upx**(-1)
     &     + 14*Hr2(1,0)*upx**(-1)*y
     &     + Hr2(1,0)*upx**(-1)*y**2
     &     )
      T23PoleEP0qq = T23PoleEP0qq + Nc**(-1)*Nh * (
     &     - 40.D0/9
     &     + 64.D0/3*upx**(-6)
     &     + 128.D0/3*upx**(-6)*y
     &     + 64.D0/3*upx**(-6)*y**2
     &     - 64*upx**(-5)
     &     - 128*upx**(-5)*y
     &     - 64*upx**(-5)*y**2
     &     + 496.D0/9*upx**(-4)
     &     + 1184.D0/9*upx**(-4)*y
     &     + 496.D0/9*upx**(-4)*y**2
     &     - 32.D0/9*upx**(-3)
     &     - 448.D0/9*upx**(-3)*y
     &     - 32.D0/9*upx**(-3)*y**2
     &     + 16.D0/9*upx**(-2)
     &     - 16.D0/3*upx**(-2)*y
     &     - 80.D0/9*upx**(-2)*y**2
     &     - 32.D0/3*upx**(-1)
     &     + 80.D0/9*upx**(-1)*y
     &     + 8.D0/3*Hr1(0)
     &     + 64.D0/3*Hr1(0)*upx**(-7)
     &     + 128.D0/3*Hr1(0)*upx**(-7)*y
     &     + 64.D0/3*Hr1(0)*upx**(-7)*y**2
     &     - 224.D0/3*Hr1(0)*upx**(-6)
     &     - 448.D0/3*Hr1(0)*upx**(-6)*y
     &     - 224.D0/3*Hr1(0)*upx**(-6)*y**2
     &     + 256.D0/3*Hr1(0)*upx**(-5)
     &     + 192*Hr1(0)*upx**(-5)*y
     &     + 256.D0/3*Hr1(0)*upx**(-5)*y**2
     &     - 80.D0/3*Hr1(0)*upx**(-4)
     &     - 320.D0/3*Hr1(0)*upx**(-4)*y
     &     - 80.D0/3*Hr1(0)*upx**(-4)*y**2
     &     + 32.D0/3*Hr1(0)*upx**(-3)*y
     &     - 32.D0/3*Hr1(0)*upx**(-3)*y**2
     &     - 32.D0/3*Hr1(0)*upx**(-2)
     &     + 16*Hr1(0)*upx**(-2)*y
     &     + 16.D0/3*Hr1(0)*upx**(-2)*y**2
     &     - 16.D0/3*Hr1(0)*upx**(-1)*y
     &     )
      T23PoleEP0qq = T23PoleEP0qq + Nc**(-1)*Nl * (
     &     - 40.D0/9
     &     - 80.D0/9*upx**(-4)
     &     - 160.D0/9*upx**(-4)*y
     &     - 80.D0/9*upx**(-4)*y**2
     &     + 160.D0/9*upx**(-3)
     &     + 320.D0/9*upx**(-3)*y
     &     + 160.D0/9*upx**(-3)*y**2
     &     - 80.D0/9*upx**(-2)
     &     - 80.D0/3*upx**(-2)*y
     &     - 80.D0/9*upx**(-2)*y**2
     &     + 80.D0/9*upx**(-1)*y
     &     + 16.D0/3*Hr1(-1)
     &     + 32.D0/3*Hr1(-1)*upx**(-4)
     &     + 64.D0/3*Hr1(-1)*upx**(-4)*y
     &     + 32.D0/3*Hr1(-1)*upx**(-4)*y**2
     &     - 64.D0/3*Hr1(-1)*upx**(-3)
     &     - 128.D0/3*Hr1(-1)*upx**(-3)*y
     &     - 64.D0/3*Hr1(-1)*upx**(-3)*y**2
     &     + 32.D0/3*Hr1(-1)*upx**(-2)
     &     + 32*Hr1(-1)*upx**(-2)*y
     &     + 32.D0/3*Hr1(-1)*upx**(-2)*y**2
     &     - 32.D0/3*Hr1(-1)*upx**(-1)*y
     &     - 8.D0/3*Hr1(0)
     &     - 16.D0/3*Hr1(0)*upx**(-4)
     &     - 32.D0/3*Hr1(0)*upx**(-4)*y
     &     - 16.D0/3*Hr1(0)*upx**(-4)*y**2
     &     + 32.D0/3*Hr1(0)*upx**(-3)
     &     + 64.D0/3*Hr1(0)*upx**(-3)*y
     &     + 32.D0/3*Hr1(0)*upx**(-3)*y**2
     &     - 16.D0/3*Hr1(0)*upx**(-2)
     &     - 16*Hr1(0)*upx**(-2)*y
     &     - 16.D0/3*Hr1(0)*upx**(-2)*y**2
     &     + 16.D0/3*Hr1(0)*upx**(-1)*y
     &     - 8.D0/3*DLog(tm**(-2)*w**2)
     &     - 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)
     &     - 32.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     - 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     + 32.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)
     &     + 64.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     + 32.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     - 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)
     &     - 16*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     - 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     + 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T23PoleEP0qq = T23PoleEP0qq + (
     &     + 88.D0/9
     &     + 12*umx**(-5)*z2
     &     - 24*umx**(-5)*y*z2
     &     + 12*umx**(-5)*y**2*z2
     &     - 30*umx**(-4)*z2
     &     + 60*umx**(-4)*y*z2
     &     - 30*umx**(-4)*y**2*z2
     &     + 39*umx**(-3)*z2
     &     - 62*umx**(-3)*y*z2
     &     + 19*umx**(-3)*y**2*z2
     &     + 2*umx**(-2)
     &     - 57.D0/2*umx**(-2)*z2
     &     - 4*umx**(-2)*y
     &     + 33*umx**(-2)*y*z2
     &     + 2*umx**(-2)*y**2
     &     + 3.D0/2*umx**(-2)*y**2*z2
     &     - 2*umx**(-1)
     &     + 129.D0/4*umx**(-1)*z2
     &     + 4*umx**(-1)*y
     &     - 11.D0/2*umx**(-1)*y*z2
     &     - 2*umx**(-1)*y**2
     &     + 9.D0/4*umx**(-1)*y**2*z2
     &     + 32*upx**(-5)*z2
     &     + 64*upx**(-5)*y*z2
     &     + 32*upx**(-5)*y**2*z2
     &     - 256.D0/9*upx**(-4)
     &     - 40*upx**(-4)*z2
     &     - 512.D0/9*upx**(-4)*y
     &     - 80*upx**(-4)*y*z2
     &     - 256.D0/9*upx**(-4)*y**2
     &     - 40*upx**(-4)*y**2*z2
     &     + 512.D0/9*upx**(-3)
     &     - 14*upx**(-3)*z2
     &     + 1024.D0/9*upx**(-3)*y
     &     + 16*upx**(-3)*y*z2
     &     + 512.D0/9*upx**(-3)*y**2
     &     - 2*upx**(-3)*y**2*z2
     &     - 238.D0/9*upx**(-2)
     &     + 13*upx**(-2)*z2
     &     - 244.D0/3*upx**(-2)*y
     &     + 4*upx**(-2)*y*z2
     &     - 238.D0/9*upx**(-2)*y**2
     &     + 3*upx**(-2)*y**2*z2
     &     - 2*upx**(-1)
     &     + 49.D0/4*upx**(-1)*z2
     &     + 220.D0/9*upx**(-1)*y
     &     - 11.D0/2*upx**(-1)*y*z2
     &     - 2*upx**(-1)*y**2
     &     + 9.D0/4*upx**(-1)*y**2*z2
     &     - 52.D0/3*Hr1(-1)
     &     - 24*Hr1(-1)*umx**(-4)
     &     + 48*Hr1(-1)*umx**(-4)*y
     &     - 24*Hr1(-1)*umx**(-4)*y**2
     &     + 48*Hr1(-1)*umx**(-3)
     &     - 96*Hr1(-1)*umx**(-3)*y
     &     + 48*Hr1(-1)*umx**(-3)*y**2
     &     - 56*Hr1(-1)*umx**(-2)
     &     + 80*Hr1(-1)*umx**(-2)*y
     &     - 16*Hr1(-1)*umx**(-2)*y**2
     &     + 32*Hr1(-1)*umx**(-1)
     &     - 32*Hr1(-1)*umx**(-1)*y
     &     - 8*Hr1(-1)*umx**(-1)*y**2
     &     + 16.D0/3*Hr1(-1)*upx**(-4)
     &     + 32.D0/3*Hr1(-1)*upx**(-4)*y
     &     + 16.D0/3*Hr1(-1)*upx**(-4)*y**2
     &     - 32.D0/3*Hr1(-1)*upx**(-3)
     &     - 64.D0/3*Hr1(-1)*upx**(-3)*y
     &     - 32.D0/3*Hr1(-1)*upx**(-3)*y**2
     &     + 40.D0/3*Hr1(-1)*upx**(-2)
     &     + 32*Hr1(-1)*upx**(-2)*y
     &     + 40.D0/3*Hr1(-1)*upx**(-2)*y**2
     &     - 8*Hr1(-1)*upx**(-1)
     &     - 64.D0/3*Hr1(-1)*upx**(-1)*y
     &     - 8*Hr1(-1)*upx**(-1)*y**2
     &     - 16*Hr1(-1)*HAr1(-1)
     &     - 64*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     - 128*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     - 64*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     + 128*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     + 256*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     + 128*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     - 64*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     - 160*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     - 64*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     + 32*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     + 24*Hr1(-1)*HBr1(-1)
     &     + 32*Hr1(-1)*HBr1(-1)*upx**(-4)
     &     + 64*Hr1(-1)*HBr1(-1)*upx**(-4)*y
     &     + 32*Hr1(-1)*HBr1(-1)*upx**(-4)*y**2
     &     - 64*Hr1(-1)*HBr1(-1)*upx**(-3)
     &     - 128*Hr1(-1)*HBr1(-1)*upx**(-3)*y
     &     - 64*Hr1(-1)*HBr1(-1)*upx**(-3)*y**2
     &     + 64*Hr1(-1)*HBr1(-1)*upx**(-2)
     &     + 112*Hr1(-1)*HBr1(-1)*upx**(-2)*y
     &     + 32*Hr1(-1)*HBr1(-1)*upx**(-2)*y**2
     &     - 32*Hr1(-1)*HBr1(-1)*upx**(-1)
     &     - 48*Hr1(-1)*HBr1(-1)*upx**(-1)*y
     &     - 8*HAr1(-1)
     &     + 8*HAr1(-1)*upx**(-2)*y**(-1)
     &     + 16*HAr1(-1)*upx**(-2)
     &     + 8*HAr1(-1)*upx**(-2)*y
     &     - 8*HAr1(-1)*upx**(-1)*y**(-1)
     &     - 16*HAr1(-1)*upx**(-1)
     &     - 8*HAr1(-1)*upx**(-1)*y
     &     - 8*HAr1(-1)*y**(-1)
     &     + 8*HAr1(-1)*Hr1(0)
     &     + 32*HAr1(-1)*Hr1(0)*upx**(-4)
     &     + 64*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     + 32*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     - 64*HAr1(-1)*Hr1(0)*upx**(-3)
     &     - 128*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     - 64*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     + 32*HAr1(-1)*Hr1(0)*upx**(-2)
     &     + 80*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     + 32*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     - 16*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 8*HBr1(-1)
     &     - 4*HBr1(-1)*upx**(-2)*z**(-1)
     &     + 4*HBr1(-1)*upx**(-2)*y
     &     + 4*HBr1(-1)*upx**(-1)*z**(-1)
     &     - 4*HBr1(-1)*upx**(-1)*y
     &     + 4*HBr1(-1)*z**(-1)
     &     - 12*HBr1(-1)*Hr1(0)
     &     - 16*HBr1(-1)*Hr1(0)*upx**(-4)
     &     - 32*HBr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 16*HBr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 32*HBr1(-1)*Hr1(0)*upx**(-3)
     &     + 64*HBr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 32*HBr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 32*HBr1(-1)*Hr1(0)*upx**(-2)
     &     - 56*HBr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 16*HBr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 16*HBr1(-1)*Hr1(0)*upx**(-1)
     &     + 24*HBr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 24*Hr2(-1,-1)
     &     - 32*Hr2(-1,-1)*upx**(-2)
     &     - 48*Hr2(-1,-1)*upx**(-2)*y
     &     + 32*Hr2(-1,-1)*upx**(-1)
     &     + 48*Hr2(-1,-1)*upx**(-1)*y
     &     - 16*HAr2(-1,-1)
     &     - 32*HAr2(-1,-1)*upx**(-2)*y
     &     + 32*HAr2(-1,-1)*upx**(-1)*y
     &     - 8*HBr2(-1,-1)
     &     - 32*HBr2(-1,-1)*upx**(-2)
     &     - 16*HBr2(-1,-1)*upx**(-2)*y
     &     + 32*HBr2(-1,-1)*upx**(-1)
     &     + 16*HBr2(-1,-1)*upx**(-1)*y
     &     + 12*Hr2(-1,0)
     &     + 16*Hr2(-1,0)*upx**(-2)
     &     + 24*Hr2(-1,0)*upx**(-2)*y
     &     - 16*Hr2(-1,0)*upx**(-1)
     &     - 24*Hr2(-1,0)*upx**(-1)*y
     &     + 32.D0/3*Hr1(0)
     &     + 12*Hr1(0)*umx**(-4)
     &     - 24*Hr1(0)*umx**(-4)*y
     &     + 12*Hr1(0)*umx**(-4)*y**2
     &     - 24*Hr1(0)*umx**(-3)
     &     + 48*Hr1(0)*umx**(-3)*y
     &     - 24*Hr1(0)*umx**(-3)*y**2
     &     + 28*Hr1(0)*umx**(-2)
     &     - 40*Hr1(0)*umx**(-2)*y
     &     + 8*Hr1(0)*umx**(-2)*y**2
     &     - 25.D0/2*Hr1(0)*umx**(-1)
     &     + 17*Hr1(0)*umx**(-1)*y
     &     + 7.D0/2*Hr1(0)*umx**(-1)*y**2
     &     - 16*Hr1(0)*upx**(-5)
     &     - 32*Hr1(0)*upx**(-5)*y
     &     - 16*Hr1(0)*upx**(-5)*y**2
     &     + 112.D0/3*Hr1(0)*upx**(-4)
     &     + 224.D0/3*Hr1(0)*upx**(-4)*y
     &     + 112.D0/3*Hr1(0)*upx**(-4)*y**2
     &     - 86.D0/3*Hr1(0)*upx**(-3)
     &     - 220.D0/3*Hr1(0)*upx**(-3)*y
     &     - 86.D0/3*Hr1(0)*upx**(-3)*y**2
     &     + 13.D0/3*Hr1(0)*upx**(-2)
     &     + 30*Hr1(0)*upx**(-2)*y
     &     + 13.D0/3*Hr1(0)*upx**(-2)*y**2
     &     - 9.D0/2*Hr1(0)*upx**(-1)
     &     - 1.D0/3*Hr1(0)*upx**(-1)*y
     &     + 7.D0/2*Hr1(0)*upx**(-1)*y**2
     &     + 8*Hr2(0,-1)
     &     - 24*Hr2(0,-1)*umx**(-5)
     &     + 48*Hr2(0,-1)*umx**(-5)*y
     &     - 24*Hr2(0,-1)*umx**(-5)*y**2
     &     + 60*Hr2(0,-1)*umx**(-4)
     &     - 120*Hr2(0,-1)*umx**(-4)*y
     &     + 60*Hr2(0,-1)*umx**(-4)*y**2
     &     - 78*Hr2(0,-1)*umx**(-3)
     &     + 124*Hr2(0,-1)*umx**(-3)*y
     &     - 38*Hr2(0,-1)*umx**(-3)*y**2
     &     + 57*Hr2(0,-1)*umx**(-2)
     &     - 66*Hr2(0,-1)*umx**(-2)*y
     &     - 3*Hr2(0,-1)*umx**(-2)*y**2
     &     - 57.D0/2*Hr2(0,-1)*umx**(-1)
     &     + 3*Hr2(0,-1)*umx**(-1)*y
     &     - 1.D0/2*Hr2(0,-1)*umx**(-1)*y**2
     &     + 12*Hr2(0,-1)*upx**(-3)
     &     - 12*Hr2(0,-1)*upx**(-3)*y**2
     &     - 2*Hr2(0,-1)*upx**(-2)
     &     + 24*Hr2(0,-1)*upx**(-2)*y
     &     + 18*Hr2(0,-1)*upx**(-2)*y**2
     &     + 23.D0/2*Hr2(0,-1)*upx**(-1)
     &     - 13*Hr2(0,-1)*upx**(-1)*y
     &     - 1.D0/2*Hr2(0,-1)*upx**(-1)*y**2
     &     + 8*HAr2(0,-1)
     &     + 16*HAr2(0,-1)*upx**(-2)*y
     &     - 16*HAr2(0,-1)*upx**(-1)*y
     &     + 4*HBr2(0,-1)
     &     + 16*HBr2(0,-1)*upx**(-2)
     &     + 8*HBr2(0,-1)*upx**(-2)*y
     &     - 16*HBr2(0,-1)*upx**(-1)
     &     - 8*HBr2(0,-1)*upx**(-1)*y
     &     + 12*Hr2(0,0)*umx**(-5)
     &     - 24*Hr2(0,0)*umx**(-5)*y
     &     + 12*Hr2(0,0)*umx**(-5)*y**2
     &     - 30*Hr2(0,0)*umx**(-4)
     &     + 60*Hr2(0,0)*umx**(-4)*y
     &     - 30*Hr2(0,0)*umx**(-4)*y**2
     &     + 39*Hr2(0,0)*umx**(-3)
     &     - 62*Hr2(0,0)*umx**(-3)*y
     &     + 19*Hr2(0,0)*umx**(-3)*y**2
     &     - 57.D0/2*Hr2(0,0)*umx**(-2)
     &     + 33*Hr2(0,0)*umx**(-2)*y
     &     + 3.D0/2*Hr2(0,0)*umx**(-2)*y**2
     &     + 39.D0/4*Hr2(0,0)*umx**(-1)
     &     - 1.D0/2*Hr2(0,0)*umx**(-1)*y
     &     - 1.D0/4*Hr2(0,0)*umx**(-1)*y**2
     &     - 8*Hr2(0,0)*upx**(-5)
     &     - 16*Hr2(0,0)*upx**(-5)*y
     &     - 8*Hr2(0,0)*upx**(-5)*y**2
     &     + 20*Hr2(0,0)*upx**(-4)
     &     + 40*Hr2(0,0)*upx**(-4)*y
     &     + 20*Hr2(0,0)*upx**(-4)*y**2
     &     - 24*Hr2(0,0)*upx**(-3)
     &     - 44*Hr2(0,0)*upx**(-3)*y
     &     - 12*Hr2(0,0)*upx**(-3)*y**2
     &     + 8*Hr2(0,0)*upx**(-2)
     &     + 14*Hr2(0,0)*upx**(-2)*y
     &     - 2*Hr2(0,0)*upx**(-2)*y**2
     &     - 41.D0/4*Hr2(0,0)*upx**(-1)
     &     - 1.D0/2*Hr2(0,0)*upx**(-1)*y
     &     - 1.D0/4*Hr2(0,0)*upx**(-1)*y**2
     &     + 8*Hr2(1,0)
     &     - 9*Hr2(1,0)*umx**(-1)
     &     + 2*Hr2(1,0)*umx**(-1)*y
     &     - Hr2(1,0)*umx**(-1)*y**2
     &     - 16*Hr2(1,0)*upx**(-5)
     &     - 32*Hr2(1,0)*upx**(-5)*y
     &     - 16*Hr2(1,0)*upx**(-5)*y**2
     &     + 40*Hr2(1,0)*upx**(-4)
     &     + 80*Hr2(1,0)*upx**(-4)*y
     &     + 40*Hr2(1,0)*upx**(-4)*y**2
     &     - 36*Hr2(1,0)*upx**(-3)
     &     - 88*Hr2(1,0)*upx**(-3)*y
     &     - 36*Hr2(1,0)*upx**(-3)*y**2
     &     + 14*Hr2(1,0)*upx**(-2)
     &     + 52*Hr2(1,0)*upx**(-2)*y
     &     + 14*Hr2(1,0)*upx**(-2)*y**2
     &     - 9*Hr2(1,0)*upx**(-1)
     &     - 14*Hr2(1,0)*upx**(-1)*y
     &     - Hr2(1,0)*upx**(-1)*y**2
     &     + 44.D0/3*DLog(tm**(-2)*w**2)
     &     + 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)
     &     + 176.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     + 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     - 176.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)
     &     - 352.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     - 176.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     + 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)
     &     + 88*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     + 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     - 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T23PoleEP0qq = T23PoleEP0qq + Nc*Nh * (
     &     + 40.D0/9
     &     - 64.D0/3*upx**(-6)
     &     - 128.D0/3*upx**(-6)*y
     &     - 64.D0/3*upx**(-6)*y**2
     &     + 64*upx**(-5)
     &     + 128*upx**(-5)*y
     &     + 64*upx**(-5)*y**2
     &     - 496.D0/9*upx**(-4)
     &     - 1184.D0/9*upx**(-4)*y
     &     - 496.D0/9*upx**(-4)*y**2
     &     + 32.D0/9*upx**(-3)
     &     + 448.D0/9*upx**(-3)*y
     &     + 32.D0/9*upx**(-3)*y**2
     &     - 16.D0/9*upx**(-2)
     &     + 16.D0/3*upx**(-2)*y
     &     + 80.D0/9*upx**(-2)*y**2
     &     + 32.D0/3*upx**(-1)
     &     - 80.D0/9*upx**(-1)*y
     &     - 8.D0/3*Hr1(0)
     &     - 64.D0/3*Hr1(0)*upx**(-7)
     &     - 128.D0/3*Hr1(0)*upx**(-7)*y
     &     - 64.D0/3*Hr1(0)*upx**(-7)*y**2
     &     + 224.D0/3*Hr1(0)*upx**(-6)
     &     + 448.D0/3*Hr1(0)*upx**(-6)*y
     &     + 224.D0/3*Hr1(0)*upx**(-6)*y**2
     &     - 256.D0/3*Hr1(0)*upx**(-5)
     &     - 192*Hr1(0)*upx**(-5)*y
     &     - 256.D0/3*Hr1(0)*upx**(-5)*y**2
     &     + 80.D0/3*Hr1(0)*upx**(-4)
     &     + 320.D0/3*Hr1(0)*upx**(-4)*y
     &     + 80.D0/3*Hr1(0)*upx**(-4)*y**2
     &     - 32.D0/3*Hr1(0)*upx**(-3)*y
     &     + 32.D0/3*Hr1(0)*upx**(-3)*y**2
     &     + 32.D0/3*Hr1(0)*upx**(-2)
     &     - 16*Hr1(0)*upx**(-2)*y
     &     - 16.D0/3*Hr1(0)*upx**(-2)*y**2
     &     + 16.D0/3*Hr1(0)*upx**(-1)*y
     &     )
      T23PoleEP0qq = T23PoleEP0qq + Nc*Nl * (
     &     + 40.D0/9
     &     + 80.D0/9*upx**(-4)
     &     + 160.D0/9*upx**(-4)*y
     &     + 80.D0/9*upx**(-4)*y**2
     &     - 160.D0/9*upx**(-3)
     &     - 320.D0/9*upx**(-3)*y
     &     - 160.D0/9*upx**(-3)*y**2
     &     + 80.D0/9*upx**(-2)
     &     + 80.D0/3*upx**(-2)*y
     &     + 80.D0/9*upx**(-2)*y**2
     &     - 80.D0/9*upx**(-1)*y
     &     - 16.D0/3*Hr1(-1)
     &     - 32.D0/3*Hr1(-1)*upx**(-4)
     &     - 64.D0/3*Hr1(-1)*upx**(-4)*y
     &     - 32.D0/3*Hr1(-1)*upx**(-4)*y**2
     &     + 64.D0/3*Hr1(-1)*upx**(-3)
     &     + 128.D0/3*Hr1(-1)*upx**(-3)*y
     &     + 64.D0/3*Hr1(-1)*upx**(-3)*y**2
     &     - 32.D0/3*Hr1(-1)*upx**(-2)
     &     - 32*Hr1(-1)*upx**(-2)*y
     &     - 32.D0/3*Hr1(-1)*upx**(-2)*y**2
     &     + 32.D0/3*Hr1(-1)*upx**(-1)*y
     &     + 8.D0/3*Hr1(0)
     &     + 16.D0/3*Hr1(0)*upx**(-4)
     &     + 32.D0/3*Hr1(0)*upx**(-4)*y
     &     + 16.D0/3*Hr1(0)*upx**(-4)*y**2
     &     - 32.D0/3*Hr1(0)*upx**(-3)
     &     - 64.D0/3*Hr1(0)*upx**(-3)*y
     &     - 32.D0/3*Hr1(0)*upx**(-3)*y**2
     &     + 16.D0/3*Hr1(0)*upx**(-2)
     &     + 16*Hr1(0)*upx**(-2)*y
     &     + 16.D0/3*Hr1(0)*upx**(-2)*y**2
     &     - 16.D0/3*Hr1(0)*upx**(-1)*y
     &     + 8.D0/3*DLog(tm**(-2)*w**2)
     &     + 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)
     &     + 32.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     + 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     - 32.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)
     &     - 64.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     - 32.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     + 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)
     &     + 16*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     + 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     - 16.D0/3*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      T23PoleEP0qq = T23PoleEP0qq + Nc**2 * (
     &     - 214.D0/9
     &     - 12*umx**(-5)*z2
     &     + 24*umx**(-5)*y*z2
     &     - 12*umx**(-5)*y**2*z2
     &     + 30*umx**(-4)*z2
     &     - 60*umx**(-4)*y*z2
     &     + 30*umx**(-4)*y**2*z2
     &     - 27*umx**(-3)*z2
     &     + 50*umx**(-3)*y*z2
     &     - 19*umx**(-3)*y**2*z2
     &     - 2*umx**(-2)
     &     + 21.D0/2*umx**(-2)*z2
     &     + 4*umx**(-2)*y
     &     - 15*umx**(-2)*y*z2
     &     - 2*umx**(-2)*y**2
     &     - 3.D0/2*umx**(-2)*y**2*z2
     &     + 2*umx**(-1)
     &     - 33.D0/4*umx**(-1)*z2
     &     - 4*umx**(-1)*y
     &     + 3.D0/2*umx**(-1)*y*z2
     &     + 2*umx**(-1)*y**2
     &     - 1.D0/4*umx**(-1)*y**2*z2
     &     - 176.D0/9*upx**(-4)
     &     - 8*upx**(-4)*z2
     &     - 352.D0/9*upx**(-4)*y
     &     - 16*upx**(-4)*y*z2
     &     - 176.D0/9*upx**(-4)*y**2
     &     - 8*upx**(-4)*y**2*z2
     &     + 352.D0/9*upx**(-3)
     &     + 10*upx**(-3)*z2
     &     + 704.D0/9*upx**(-3)*y
     &     + 20*upx**(-3)*y*z2
     &     + 352.D0/9*upx**(-3)*y**2
     &     + 10*upx**(-3)*y**2*z2
     &     - 194.D0/9*upx**(-2)
     &     - 3*upx**(-2)*z2
     &     - 188.D0/3*upx**(-2)*y
     &     - 6*upx**(-2)*y*z2
     &     - 194.D0/9*upx**(-2)*y**2
     &     + upx**(-2)*y**2*z2
     &     + 2*upx**(-1)
     &     - 1.D0/4*upx**(-1)*z2
     &     + 212.D0/9*upx**(-1)*y
     &     + 3.D0/2*upx**(-1)*y*z2
     &     + 2*upx**(-1)*y**2
     &     - 1.D0/4*upx**(-1)*y**2*z2
     &     + 28.D0/3*Hr1(-1)
     &     + 24*Hr1(-1)*umx**(-4)
     &     - 48*Hr1(-1)*umx**(-4)*y
     &     + 24*Hr1(-1)*umx**(-4)*y**2
     &     - 48*Hr1(-1)*umx**(-3)
     &     + 96*Hr1(-1)*umx**(-3)*y
     &     - 48*Hr1(-1)*umx**(-3)*y**2
     &     + 32*Hr1(-1)*umx**(-2)
     &     - 56*Hr1(-1)*umx**(-2)*y
     &     + 16*Hr1(-1)*umx**(-2)*y**2
     &     - 8*Hr1(-1)*umx**(-1)
     &     + 8*Hr1(-1)*umx**(-1)*y
     &     + 8*Hr1(-1)*umx**(-1)*y**2
     &     + 56.D0/3*Hr1(-1)*upx**(-4)
     &     + 112.D0/3*Hr1(-1)*upx**(-4)*y
     &     + 56.D0/3*Hr1(-1)*upx**(-4)*y**2
     &     - 112.D0/3*Hr1(-1)*upx**(-3)
     &     - 224.D0/3*Hr1(-1)*upx**(-3)*y
     &     - 112.D0/3*Hr1(-1)*upx**(-3)*y**2
     &     + 32.D0/3*Hr1(-1)*upx**(-2)
     &     + 40*Hr1(-1)*upx**(-2)*y
     &     + 32.D0/3*Hr1(-1)*upx**(-2)*y**2
     &     + 8*Hr1(-1)*upx**(-1)
     &     - 8.D0/3*Hr1(-1)*upx**(-1)*y
     &     + 8*Hr1(-1)*upx**(-1)*y**2
     &     + 4*Hr1(-1)*HAr1(-1)
     &     + 16*Hr1(-1)*HAr1(-1)*upx**(-4)
     &     + 32*Hr1(-1)*HAr1(-1)*upx**(-4)*y
     &     + 16*Hr1(-1)*HAr1(-1)*upx**(-4)*y**2
     &     - 32*Hr1(-1)*HAr1(-1)*upx**(-3)
     &     - 64*Hr1(-1)*HAr1(-1)*upx**(-3)*y
     &     - 32*Hr1(-1)*HAr1(-1)*upx**(-3)*y**2
     &     + 16*Hr1(-1)*HAr1(-1)*upx**(-2)
     &     + 40*Hr1(-1)*HAr1(-1)*upx**(-2)*y
     &     + 16*Hr1(-1)*HAr1(-1)*upx**(-2)*y**2
     &     - 8*Hr1(-1)*HAr1(-1)*upx**(-1)*y
     &     + 12*Hr1(-1)*HBr1(-1)
     &     + 16*Hr1(-1)*HBr1(-1)*upx**(-4)
     &     + 32*Hr1(-1)*HBr1(-1)*upx**(-4)*y
     &     + 16*Hr1(-1)*HBr1(-1)*upx**(-4)*y**2
     &     - 32*Hr1(-1)*HBr1(-1)*upx**(-3)
     &     - 64*Hr1(-1)*HBr1(-1)*upx**(-3)*y
     &     - 32*Hr1(-1)*HBr1(-1)*upx**(-3)*y**2
     &     + 32*Hr1(-1)*HBr1(-1)*upx**(-2)
     &     + 56*Hr1(-1)*HBr1(-1)*upx**(-2)*y
     &     + 16*Hr1(-1)*HBr1(-1)*upx**(-2)*y**2
     &     - 16*Hr1(-1)*HBr1(-1)*upx**(-1)
     &     - 24*Hr1(-1)*HBr1(-1)*upx**(-1)*y
     &     + 2*HAr1(-1)
     &     - 2*HAr1(-1)*upx**(-2)*y**(-1)
     &     - 4*HAr1(-1)*upx**(-2)
     &     - 2*HAr1(-1)*upx**(-2)*y
     &     + 2*HAr1(-1)*upx**(-1)*y**(-1)
     &     + 4*HAr1(-1)*upx**(-1)
     &     + 2*HAr1(-1)*upx**(-1)*y
     &     + 2*HAr1(-1)*y**(-1)
     &     - 2*HAr1(-1)*Hr1(0)
     &     - 8*HAr1(-1)*Hr1(0)*upx**(-4)
     &     - 16*HAr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 8*HAr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 16*HAr1(-1)*Hr1(0)*upx**(-3)
     &     + 32*HAr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 16*HAr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 8*HAr1(-1)*Hr1(0)*upx**(-2)
     &     - 20*HAr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 8*HAr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 4*HAr1(-1)*Hr1(0)*upx**(-1)*y
     &     + 4*HBr1(-1)
     &     - 2*HBr1(-1)*upx**(-2)*z**(-1)
     &     + 2*HBr1(-1)*upx**(-2)*y
     &     + 2*HBr1(-1)*upx**(-1)*z**(-1)
     &     - 2*HBr1(-1)*upx**(-1)*y
     &     + 2*HBr1(-1)*z**(-1)
     &     - 6*HBr1(-1)*Hr1(0)
     &     - 8*HBr1(-1)*Hr1(0)*upx**(-4)
     &     - 16*HBr1(-1)*Hr1(0)*upx**(-4)*y
     &     - 8*HBr1(-1)*Hr1(0)*upx**(-4)*y**2
     &     + 16*HBr1(-1)*Hr1(0)*upx**(-3)
     &     + 32*HBr1(-1)*Hr1(0)*upx**(-3)*y
     &     + 16*HBr1(-1)*Hr1(0)*upx**(-3)*y**2
     &     - 16*HBr1(-1)*Hr1(0)*upx**(-2)
     &     - 28*HBr1(-1)*Hr1(0)*upx**(-2)*y
     &     - 8*HBr1(-1)*Hr1(0)*upx**(-2)*y**2
     &     + 8*HBr1(-1)*Hr1(0)*upx**(-1)
     &     + 12*HBr1(-1)*Hr1(0)*upx**(-1)*y
     &     - 16*Hr2(-1,-1)
     &     - 32*Hr2(-1,-1)*upx**(-4)
     &     - 64*Hr2(-1,-1)*upx**(-4)*y
     &     - 32*Hr2(-1,-1)*upx**(-4)*y**2
     &     + 64*Hr2(-1,-1)*upx**(-3)
     &     + 128*Hr2(-1,-1)*upx**(-3)*y
     &     + 64*Hr2(-1,-1)*upx**(-3)*y**2
     &     - 48*Hr2(-1,-1)*upx**(-2)
     &     - 96*Hr2(-1,-1)*upx**(-2)*y
     &     - 32*Hr2(-1,-1)*upx**(-2)*y**2
     &     + 16*Hr2(-1,-1)*upx**(-1)
     &     + 32*Hr2(-1,-1)*upx**(-1)*y
     &     + 4*HAr2(-1,-1)
     &     + 8*HAr2(-1,-1)*upx**(-2)*y
     &     - 8*HAr2(-1,-1)*upx**(-1)*y
     &     - 4*HBr2(-1,-1)
     &     - 16*HBr2(-1,-1)*upx**(-2)
     &     - 8*HBr2(-1,-1)*upx**(-2)*y
     &     + 16*HBr2(-1,-1)*upx**(-1)
     &     + 8*HBr2(-1,-1)*upx**(-1)*y
     &     + 8*Hr2(-1,0)
     &     + 16*Hr2(-1,0)*upx**(-4)
     &     + 32*Hr2(-1,0)*upx**(-4)*y
     &     + 16*Hr2(-1,0)*upx**(-4)*y**2
     &     - 32*Hr2(-1,0)*upx**(-3)
     &     - 64*Hr2(-1,0)*upx**(-3)*y
     &     - 32*Hr2(-1,0)*upx**(-3)*y**2
     &     + 24*Hr2(-1,0)*upx**(-2)
     &     + 48*Hr2(-1,0)*upx**(-2)*y
     &     + 16*Hr2(-1,0)*upx**(-2)*y**2
     &     - 8*Hr2(-1,0)*upx**(-1)
     &     - 16*Hr2(-1,0)*upx**(-1)*y
     &     - 14.D0/3*Hr1(0)
     &     - 12*Hr1(0)*umx**(-4)
     &     + 24*Hr1(0)*umx**(-4)*y
     &     - 12*Hr1(0)*umx**(-4)*y**2
     &     + 24*Hr1(0)*umx**(-3)
     &     - 48*Hr1(0)*umx**(-3)*y
     &     + 24*Hr1(0)*umx**(-3)*y**2
     &     - 16*Hr1(0)*umx**(-2)
     &     + 28*Hr1(0)*umx**(-2)*y
     &     - 8*Hr1(0)*umx**(-2)*y**2
     &     + 4*Hr1(0)*umx**(-1)
     &     - 4*Hr1(0)*umx**(-1)*y
     &     - 4*Hr1(0)*umx**(-1)*y**2
     &     - 28.D0/3*Hr1(0)*upx**(-4)
     &     - 56.D0/3*Hr1(0)*upx**(-4)*y
     &     - 28.D0/3*Hr1(0)*upx**(-4)*y**2
     &     + 56.D0/3*Hr1(0)*upx**(-3)
     &     + 112.D0/3*Hr1(0)*upx**(-3)*y
     &     + 56.D0/3*Hr1(0)*upx**(-3)*y**2
     &     - 16.D0/3*Hr1(0)*upx**(-2)
     &     - 20*Hr1(0)*upx**(-2)*y
     &     - 16.D0/3*Hr1(0)*upx**(-2)*y**2
     &     - 4*Hr1(0)*upx**(-1)
     &     + 4.D0/3*Hr1(0)*upx**(-1)*y
     &     - 4*Hr1(0)*upx**(-1)*y**2
     &     + 24*Hr2(0,-1)*umx**(-5)
     &     - 48*Hr2(0,-1)*umx**(-5)*y
     &     + 24*Hr2(0,-1)*umx**(-5)*y**2
     &     - 60*Hr2(0,-1)*umx**(-4)
     &     + 120*Hr2(0,-1)*umx**(-4)*y
     &     - 60*Hr2(0,-1)*umx**(-4)*y**2
     &     + 54*Hr2(0,-1)*umx**(-3)
     &     - 100*Hr2(0,-1)*umx**(-3)*y
     &     + 38*Hr2(0,-1)*umx**(-3)*y**2
     &     - 21*Hr2(0,-1)*umx**(-2)
     &     + 30*Hr2(0,-1)*umx**(-2)*y
     &     + 3*Hr2(0,-1)*umx**(-2)*y**2
     &     + 33.D0/2*Hr2(0,-1)*umx**(-1)
     &     - 3*Hr2(0,-1)*umx**(-1)*y
     &     + 1.D0/2*Hr2(0,-1)*umx**(-1)*y**2
     &     + 16*Hr2(0,-1)*upx**(-4)
     &     + 32*Hr2(0,-1)*upx**(-4)*y
     &     + 16*Hr2(0,-1)*upx**(-4)*y**2
     &     - 20*Hr2(0,-1)*upx**(-3)
     &     - 40*Hr2(0,-1)*upx**(-3)*y
     &     - 20*Hr2(0,-1)*upx**(-3)*y**2
     &     + 6*Hr2(0,-1)*upx**(-2)
     &     + 12*Hr2(0,-1)*upx**(-2)*y
     &     - 2*Hr2(0,-1)*upx**(-2)*y**2
     &     + 1.D0/2*Hr2(0,-1)*upx**(-1)
     &     - 3*Hr2(0,-1)*upx**(-1)*y
     &     + 1.D0/2*Hr2(0,-1)*upx**(-1)*y**2
     &     - 2*HAr2(0,-1)
     &     - 4*HAr2(0,-1)*upx**(-2)*y
     &     + 4*HAr2(0,-1)*upx**(-1)*y
     &     + 2*HBr2(0,-1)
     &     + 8*HBr2(0,-1)*upx**(-2)
     &     + 4*HBr2(0,-1)*upx**(-2)*y
     &     - 8*HBr2(0,-1)*upx**(-1)
     &     - 4*HBr2(0,-1)*upx**(-1)*y
     &     - 12*Hr2(0,0)*umx**(-5)
     &     + 24*Hr2(0,0)*umx**(-5)*y
     &     - 12*Hr2(0,0)*umx**(-5)*y**2
     &     + 30*Hr2(0,0)*umx**(-4)
     &     - 60*Hr2(0,0)*umx**(-4)*y
     &     + 30*Hr2(0,0)*umx**(-4)*y**2
     &     - 27*Hr2(0,0)*umx**(-3)
     &     + 50*Hr2(0,0)*umx**(-3)*y
     &     - 19*Hr2(0,0)*umx**(-3)*y**2
     &     + 21.D0/2*Hr2(0,0)*umx**(-2)
     &     - 15*Hr2(0,0)*umx**(-2)*y
     &     - 3.D0/2*Hr2(0,0)*umx**(-2)*y**2
     &     - 33.D0/4*Hr2(0,0)*umx**(-1)
     &     + 3.D0/2*Hr2(0,0)*umx**(-1)*y
     &     - 1.D0/4*Hr2(0,0)*umx**(-1)*y**2
     &     - 8*Hr2(0,0)*upx**(-4)
     &     - 16*Hr2(0,0)*upx**(-4)*y
     &     - 8*Hr2(0,0)*upx**(-4)*y**2
     &     + 10*Hr2(0,0)*upx**(-3)
     &     + 20*Hr2(0,0)*upx**(-3)*y
     &     + 10*Hr2(0,0)*upx**(-3)*y**2
     &     - 3*Hr2(0,0)*upx**(-2)
     &     - 6*Hr2(0,0)*upx**(-2)*y
     &     + Hr2(0,0)*upx**(-2)*y**2
     &     - 1.D0/4*Hr2(0,0)*upx**(-1)
     &     + 3.D0/2*Hr2(0,0)*upx**(-1)*y
     &     - 1.D0/4*Hr2(0,0)*upx**(-1)*y**2
     &     - 44.D0/3*DLog(tm**(-2)*w**2)
     &     - 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)
     &     - 176.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y
     &     - 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-4)*y**2
     &     + 176.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)
     &     + 352.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y
     &     + 176.D0/3*DLog(tm**(-2)*w**2)*upx**(-3)*y**2
     &     - 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)
     &     - 88*DLog(tm**(-2)*w**2)*upx**(-2)*y
     &     - 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-2)*y**2
     &     + 88.D0/3*DLog(tm**(-2)*w**2)*upx**(-1)*y
     &     )
      end

*
**************************** 72 characters *****************************
*
*
      double precision function PoleEPm2T13(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl,ypzp2,ypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEPm2T13 =  + Nc * (
     &     - 16.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEPm2T13 = PoleEPm2T13 + Nc**3 * (
     &     + 32.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 40.D0*upy**(-1)
     &     + 16.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEPm2T13 = PoleEPm2T13 + Nc**5 * (
     &     - 16.D0*upy**(-2)
     &     + 20.D0*upy**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     )
      return
      end
*
*
*
      double precision function PoleEPm1T13(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl,ypzp2,ypzm2,sqrypzp2,sqrypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
	sqrypzp2 = Dsqrt(y+z+2.d0)
	sqrypzm2 = Dsqrt(y+z-2.d0)
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEPm1T13 =  + Nc**(-1) * (
     &     + 8.D0*upy**(-2)
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     - 10.D0*upy**(-1)
     &     + 8.D0*upz**(-2)
     &     - 10.D0*upz**(-1)
     &     - 2.D0*z*upy**(-1)
     &     - 2.D0*y*upz**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Nl * (
     &     + 16.D0/3.D0*upy**(-2)
     &     + 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 20.D0/3.D0*upy**(-1)
     &     + 16.D0/3.D0*upz**(-2)
     &     - 20.D0/3.D0*upz**(-1)
     &     - 4.D0/3.D0*z*upy**(-1)
     &     - 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Nc * (
     &     - 8.D0
     &     - 160.D0/3.D0*upy**(-2)
     &     - 272.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 176.D0/3.D0*upy**(-1)
     &     - 136.D0/3.D0*upz**(-2)
     &     + 146.D0/3.D0*upz**(-1)
     &     - 4.D0*ypzp2**(-2)
     &     - 8.D0*ypzp2**(-1)
     &     + 16.D0/3.D0*z*upy**(-1)
     &     - 8.D0*z*ypzp2**(-2)
     &     - 4.D0*z**2*ypzp2**(-2)
     &     + 10.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Nc**2*Nl * (
     &     - 32.D0/3.D0*upy**(-2)
     &     - 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 40.D0/3.D0*upy**(-1)
     &     - 16.D0/3.D0*upz**(-2)
     &     + 20.D0/3.D0*upz**(-1)
     &     - 8.D0/3.D0*ypzp2**(-2)
     &     - 16.D0/3.D0*ypzp2**(-1)
     &     + 8.D0/3.D0*z*upy**(-1)
     &     - 16.D0/3.D0*z*ypzp2**(-2)
     &     - 8.D0/3.D0*z**2*ypzp2**(-2)
     &     + 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Nc**3 * (
     &     + 8.D0
     &     + 248.D0/3.D0*upy**(-2)
     &     + 224.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 262.D0/3.D0*upy**(-1)
     &     + 112.D0/3.D0*upz**(-2)
     &     - 116.D0/3.D0*upz**(-1)
     &     + 44.D0/3.D0*ypzp2**(-2)
     &     + 136.D0/3.D0*ypzp2**(-1)
     &     - 14.D0/3.D0*z*upy**(-1)
     &     + 88.D0/3.D0*z*ypzp2**(-2)
     &     + 44.D0/3.D0*z**2*ypzp2**(-2)
     &     - 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Nc**4*Nl * (
     &     + 16.D0/3.D0*upy**(-2)
     &     - 20.D0/3.D0*upy**(-1)
     &     + 8.D0/3.D0*ypzp2**(-2)
     &     + 16.D0/3.D0*ypzp2**(-1)
     &     - 4.D0/3.D0*z*upy**(-1)
     &     + 16.D0/3.D0*z*ypzp2**(-2)
     &     + 8.D0/3.D0*z**2*ypzp2**(-2)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Nc**5 * (
     &     - 112.D0/3.D0*upy**(-2)
     &     + 116.D0/3.D0*upy**(-1)
     &     - 32.D0/3.D0*ypzp2**(-2)
     &     - 112.D0/3.D0*ypzp2**(-1)
     &     + 4.D0/3.D0*z*upy**(-1)
     &     - 64.D0/3.D0*z*ypzp2**(-2)
     &     - 32.D0/3.D0*z**2*ypzp2**(-2)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Hr1(-1)*Nc * (
     &     + 8.D0
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 32.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Hr1(-1)*Nc**3 * (
     &     - 8.D0
     &     - 16.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     - 32.D0*upz**(-2)
     &     + 40.D0*upz**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Hr1(-1)*Nc**5 * (
     &     + 16.D0*upy**(-2)
     &     - 20.D0*upy**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Hr1(0)*Nc**(-1) * (
     &     - 8.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 34.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 34.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Hr1(0)*Nc * (
     &     - 4.D0
     &     + 8.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     - 34.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-2)
     &     - 52.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*ypzp2**(-1)
     &     + 30.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Hr1(0)*Nc * (
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*ypzp2**(-1)
     &     + 6.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Hr1(0)*Nc**3 * (
     &     + 4.D0
     &     + 8.D0*upy**(-2)
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     - 10.D0*upy**(-1)
     &     - 8.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-2)
     &     + 18.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upz**(-1)
     &     - 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*ypzp2**(-2)
     &     + 4.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Hr1(0)*Nc**3 * (
     &     + 8.D0*z*ypzp2**(-2)
     &     + 24.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*ypzp2**(-1)
     &     - 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*ypzp2**(-2)
     &     + 4.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-1)
     &     + 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + Hr1(0)*Nc**5 * (
     &     - 8.D0*upy**(-2)
     &     + 10.D0*upy**(-1)
     &     - 4.D0*ypzp2**(-2)
     &     - 8.D0*ypzp2**(-1)
     &     + 2.D0*z*upy**(-1)
     &     - 8.D0*z*ypzp2**(-2)
     &     - 4.D0*z**2*ypzp2**(-2)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + HAr1(-1)*Nc * (
     &     - 16.D0
     &     + 16.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 4.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 32.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + HAr1(-1)*Nc**3 * (
     &     + 16.D0
     &     - 32.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 40.D0*upy**(-1)
     &     + 16.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + HAr1(-1)*Nc**5 * (
     &     + 16.D0*upy**(-2)
     &     - 20.D0*upy**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + HBr1(-1)*Nc * (
     &     + 8.D0
     &     + 16.D0*upy**(-2)
     &     - 20.D0*upy**(-1)
     &     + 16.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T13 = PoleEPm1T13 + HBr1(-1)*Nc**3 * (
     &     - 8.D0
     &     - 16.D0*upy**(-2)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      return
      end
*
*
*
      double precision function PoleEP0T13(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,zp2,zm3,
     $                 Nc,Nh,Nl,ypzp2,ypzm2,sqrypzp2,sqrypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	zp2 = 2.d0+z
	zm3 = z-3.d0
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
	sqrypzp2 = Dsqrt(y+z+2.d0)
	sqrypzm2 = Dsqrt(y+z-2.d0)
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEP0T13 =  + Nc**(-1) * (
     &     + 4.D0
     &     + 2.D0*y**(-1)*upz**(-1)
     &     + y**(-1)
     &     + 2.D0*z**(-1)*upy**(-1)
     &     + z**(-1)
     &     + 12.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 21.D0*upy**(-1)
     &     + 12.D0*upz**(-2)
     &     - 21.D0*upz**(-1)
     &     + 4.D0*z2*upy**(-3)
     &     + 24.D0*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z2*upy**(-2)
     &     + 96.D0*z2*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**(-1) * (
     &     - 93.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*z2*upy**(-1)
     &     + 4.D0*z2*upz**(-3)
     &     + 24.D0*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z2*upz**(-2)
     &     - 93.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*z2*upz**(-1)
     &     + 62.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z2
     &     - 4.D0*z*upy**(-2)
     &     + z*upy**(-1)
     &     + 4.D0*z*z2*upy**(-3)
     &     - 24.D0*z*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**(-1) * (
     &     - 3.D0*z*z2*upy**(-1)
     &     + z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 5.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-2)
     &     + y*upz**(-1)
     &     + 4.D0*y*z2*upz**(-3)
     &     - 24.D0*y*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*y*z2*upz**(-1)
     &     + y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 5.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nl * (
     &     + 8.D0/3.D0
     &     + 8.D0/3.D0*upy**(-1)
     &     + 8.D0/3.D0*upz**(-1)
     &     + 8.D0/3.D0*z*upy**(-1)
     &     + 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc * (
     &     - 44.D0/3.D0
     &     - 4.D0*y**(-1)*upz**(-1)
     &     - y**(-1)*zp2**(-1)
     &     - 3.D0*y**(-1)
     &     - 4.D0*z**(-1)*upy**(-1)
     &     - 2.D0*z**(-1)
     &     - 40.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 133.D0/3.D0*upy**(-1)
     &     - 28.D0*upz**(-2)
     &     + 82.D0/3.D0*upz**(-1)
     &     + zp2**(-1)*ypzp2**(-1)
     &     - 4.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc * (
     &     - 8.D0*z2*upy**(-3)
     &     - 24.D0*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 52.D0*z2*upy**(-2)
     &     - 96.D0*z2*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z2*upy**(-1)*upz**(-1)
     &     + 107.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 37.D0*z2*upy**(-1)
     &     - 4.D0*z2*upz**(-3)
     &     - 48.D0*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z2*upz**(-2)
     &     - 64.D0*z2*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 140.D0*z2*upz**(-1)*ypzp2**(-1)
     &     + 132.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc * (
     &     - 44.D0*z2*upz**(-1)
     &     + 48.D0*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 31.D0*z2*ypzp2**(-1)
     &     - 76.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*z2
     &     + 8.D0*z*upy**(-2)
     &     - 41.D0/3.D0*z*upy**(-1)
     &     - 8.D0*z*ypzp2**(-2)
     &     + z*ypzp2**(-1)
     &     - 8.D0*z*z2*upy**(-3)
     &     + 24.D0*z*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 28.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc * (
     &     - 11.D0*z*z2*upy**(-1)
     &     - 16.D0*z*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*z*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 80.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 27.D0*z*z2*ypzp2**(-1)
     &     - 14.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*ypzp2**(-2)
     &     - 7.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z**2*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-2)
     &     - 38.D0/3.D0*y*upz**(-1)
     &     - 4.D0*y*z2*upz**(-3)
     &     + 48.D0*y*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc * (
     &     - 52.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*z2*upz**(-1)
     &     + 6.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**2*Nl * (
     &     - 8.D0/3.D0
     &     - 14.D0/3.D0*upy**(-1)
     &     - 8.D0/3.D0*upz**(-1)
     &     + 8.D0/3.D0*ypzp2**(-2)
     &     - 4.D0/3.D0*ypzp2**(-1)
     &     - 16.D0/3.D0*z*upy**(-1)
     &     + 16.D0/3.D0*z*ypzp2**(-2)
     &     + 8.D0/3.D0*z**2*ypzp2**(-2)
     &     - 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**2*Nh * (
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     + 2.D0/3.D0*upy**(-1)
     &     - 16.D0*upz**(-1)*ypzp2**(-1)
     &     - 32.D0*ypzp2**(-2)
     &     - 4.D0/3.D0*ypzp2**(-1)
     &     - 12.D0*z2*upy**(-1)*upz**(-1)
     &     + 12.D0*z2*upz**(-1)*ypzp2**(-1)
     &     + 24.D0*z2*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**3 * (
     &     + 32.D0/3.D0
     &     + 2.D0*y**(-1)*upz**(-1)
     &     + 2.D0*y**(-1)*zp2**(-1)
     &     + 3.D0*y**(-1)
     &     + 2.D0*z**(-1)*upy**(-1)
     &     + z**(-1)
     &     + 44.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 8.D0*upy**(-1)*zm3**(-1)
     &     - 85.D0/3.D0*upy**(-1)
     &     + 16.D0*upz**(-2)
     &     - 19.D0/3.D0*upz**(-1)
     &     - 2.D0*zp2**(-1)*ypzp2**(-1)
     &     - 8.D0*zm3**(-1)*ypzm2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**3 * (
     &     - 3.D0*ypzm2**(-1)
     &     - 20.D0/3.D0*ypzp2**(-2)
     &     + 103.D0/3.D0*ypzp2**(-1)
     &     + 4.D0*z2*upy**(-3)
     &     - 100.D0*z2*upy**(-2)
     &     - 12.D0*z2*upy**(-1)*upz**(-1)
     &     + 96.D0*z2*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*z2*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 9.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 85.D0*z2*upy**(-1)
     &     + 24.D0*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z2*upz**(-2)
     &     + 64.D0*z2*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**3 * (
     &     - 140.D0*z2*upz**(-1)*ypzp2**(-1)
     &     - 39.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 47.D0*z2*upz**(-1)
     &     - 96.D0*z2*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 96.D0*z2*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 48.D0*z2*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 36.D0*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 52.D0*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*z2*ypzp2**(-2)
     &     - 2.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**3 * (
     &     - 63.D0*z2*ypzp2**(-1)
     &     + 17.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z2
     &     - 4.D0*z*upy**(-2)
     &     + 73.D0/3.D0*z*upy**(-1)
     &     - 40.D0/3.D0*z*ypzp2**(-2)
     &     + 4.D0*z*z2*upy**(-3)
     &     + 8.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 23.D0*z*z2*upy**(-1)
     &     + 18.D0*z*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*z*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*z*z2*ypzp2**(-2)
     &     - 96.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 23.D0*z*z2*ypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**3 * (
     &     + 16.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - z**2*ypzm2**(-1)
     &     - 20.D0/3.D0*z**2*ypzp2**(-2)
     &     + z**2*ypzp2**(-1)
     &     + 3.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z**2*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z**2*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*z**2*z2*ypzp2**(-2)
     &     - 22.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 35.D0/3.D0*y*upz**(-1)
     &     - 24.D0*y*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 28.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - y*z2*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**3 * (
     &     - 9.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**4*Nl * (
     &     + 2.D0*upy**(-1)
     &     - 8.D0/3.D0*ypzp2**(-2)
     &     + 4.D0/3.D0*ypzp2**(-1)
     &     + 8.D0/3.D0*z*upy**(-1)
     &     - 16.D0/3.D0*z*ypzp2**(-2)
     &     - 8.D0/3.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**4*Nh * (
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     - 2.D0/3.D0*upy**(-1)
     &     + 16.D0*upz**(-1)*ypzp2**(-1)
     &     + 32.D0*ypzp2**(-2)
     &     + 4.D0/3.D0*ypzp2**(-1)
     &     + 12.D0*z2*upy**(-1)*upz**(-1)
     &     - 12.D0*z2*upz**(-1)*ypzp2**(-1)
     &     - 24.D0*z2*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**5 * (
     &     - y**(-1)*zp2**(-1)
     &     - y**(-1)
     &     - 16.D0*upy**(-2)
     &     - 8.D0*upy**(-1)*zm3**(-1)
     &     + 5.D0*upy**(-1)
     &     + zp2**(-1)*ypzp2**(-1)
     &     + 8.D0*zm3**(-1)*ypzm2**(-1)
     &     + 3.D0*ypzm2**(-1)
     &     + 32.D0/3.D0*ypzp2**(-2)
     &     - 55.D0/3.D0*ypzp2**(-1)
     &     + 40.D0*z2*upy**(-2)
     &     - 96.D0*z2*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*z2*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 5.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**5 * (
     &     - 45.D0*z2*upy**(-1)
     &     + 96.D0*z2*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 96.D0*z2*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 48.D0*z2*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 36.D0*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*z2*ypzp2**(-2)
     &     + 10.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z2*ypzp2**(-1)
     &     - 3.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z2
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**5 * (
     &     - 35.D0/3.D0*z*upy**(-1)
     &     + 64.D0/3.D0*z*ypzp2**(-2)
     &     - z*ypzp2**(-1)
     &     - 4.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 9.D0*z*z2*upy**(-1)
     &     - 2.D0*z*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*z*z2*ypzp2**(-2)
     &     + 16.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*z2*ypzp2**(-1)
     &     - 3.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + z**2*ypzm2**(-1)
     &     + 32.D0/3.D0*z**2*ypzp2**(-2)
     &     - z**2*ypzp2**(-1)
     &     - z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Nc**5 * (
     &     + 12.D0*z**2*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*z**2*z2*ypzp2**(-2)
     &     + 6.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Dlog(tm**(-2)*w**2)*Nl * (
     &     - 16.D0/3.D0*upy**(-2)
     &     - 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 20.D0/3.D0*upy**(-1)
     &     - 16.D0/3.D0*upz**(-2)
     &     + 20.D0/3.D0*upz**(-1)
     &     + 4.D0/3.D0*z*upy**(-1)
     &     + 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Dlog(tm**(-2)*w**2)*Nc * (
     &     + 88.D0/3.D0*upy**(-2)
     &     + 176.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 110.D0/3.D0*upy**(-1)
     &     + 88.D0/3.D0*upz**(-2)
     &     - 110.D0/3.D0*upz**(-1)
     &     - 22.D0/3.D0*z*upy**(-1)
     &     - 22.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Dlog(tm**(-2)*w**2)*Nc**2*Nl * (
     &     + 32.D0/3.D0*upy**(-2)
     &     + 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 40.D0/3.D0*upy**(-1)
     &     + 16.D0/3.D0*upz**(-2)
     &     - 20.D0/3.D0*upz**(-1)
     &     + 8.D0/3.D0*ypzp2**(-2)
     &     + 16.D0/3.D0*ypzp2**(-1)
     &     - 8.D0/3.D0*z*upy**(-1)
     &     + 16.D0/3.D0*z*ypzp2**(-2)
     &     + 8.D0/3.D0*z**2*ypzp2**(-2)
     &     - 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Dlog(tm**(-2)*w**2)*Nc**3 * (
     &     - 176.D0/3.D0*upy**(-2)
     &     - 176.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 220.D0/3.D0*upy**(-1)
     &     - 88.D0/3.D0*upz**(-2)
     &     + 110.D0/3.D0*upz**(-1)
     &     - 44.D0/3.D0*ypzp2**(-2)
     &     - 88.D0/3.D0*ypzp2**(-1)
     &     + 44.D0/3.D0*z*upy**(-1)
     &     - 88.D0/3.D0*z*ypzp2**(-2)
     &     - 44.D0/3.D0*z**2*ypzp2**(-2)
     &     + 22.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Dlog(tm**(-2)*w**2)*Nc**4*Nl * (
     &     - 16.D0/3.D0*upy**(-2)
     &     + 20.D0/3.D0*upy**(-1)
     &     - 8.D0/3.D0*ypzp2**(-2)
     &     - 16.D0/3.D0*ypzp2**(-1)
     &     + 4.D0/3.D0*z*upy**(-1)
     &     - 16.D0/3.D0*z*ypzp2**(-2)
     &     - 8.D0/3.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + Dlog(tm**(-2)*w**2)*Nc**5 * (
     &     + 88.D0/3.D0*upy**(-2)
     &     - 110.D0/3.D0*upy**(-1)
     &     + 44.D0/3.D0*ypzp2**(-2)
     &     + 88.D0/3.D0*ypzp2**(-1)
     &     - 22.D0/3.D0*z*upy**(-1)
     &     + 88.D0/3.D0*z*ypzp2**(-2)
     &     + 44.D0/3.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(-1)*Nc * (
     &     - 16.D0
     &     + 64.D0*upz**(-1)*ypzm2**(-1)
     &     + 32.D0*upz**(-1)
     &     - 48.D0*ypzm2**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     + 16.D0*z*ypzm2**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 16.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(-1)*Nc**3 * (
     &     + 16.D0
     &     - 96.D0*upy**(-1)*zm3**(-2)
     &     - 32.D0*upy**(-1)*zm3**(-1)
     &     - 6.D0*upy**(-1)
     &     - 64.D0*upz**(-1)*ypzm2**(-1)
     &     - 32.D0*upz**(-1)
     &     + 96.D0*zm3**(-2)*ypzm2**(-1)
     &     + 96.D0*zm3**(-1)*ypzm2**(-2)
     &     + 32.D0*zm3**(-1)*ypzm2**(-1)
     &     + 36.D0*ypzm2**(-2)
     &     + 46.D0*ypzm2**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     - 18.D0*z*ypzm2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(-1)*Nc**3 * (
     &     - 4.D0*z*ypzp2**(-1)
     &     + 12.D0*z**2*ypzm2**(-2)
     &     - 4.D0*z**2*ypzm2**(-1)
     &     + 4.D0*z**2*ypzp2**(-1)
     &     - 16.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(-1)*Nc**5 * (
     &     + 96.D0*upy**(-1)*zm3**(-2)
     &     + 32.D0*upy**(-1)*zm3**(-1)
     &     + 6.D0*upy**(-1)
     &     - 96.D0*zm3**(-2)*ypzm2**(-1)
     &     - 96.D0*zm3**(-1)*ypzm2**(-2)
     &     - 32.D0*zm3**(-1)*ypzm2**(-1)
     &     - 36.D0*ypzm2**(-2)
     &     + 2.D0*ypzm2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     + 2.D0*z*ypzm2**(-1)
     &     - 12.D0*z*ypzp2**(-1)
     &     - 12.D0*z**2*ypzm2**(-2)
     &     + 4.D0*z**2*ypzm2**(-1)
     &     - 4.D0*z**2*ypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(-1)*HAr1(-1)*Nc * (
     &     + 40.D0
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     - 16.D0*upz**(-1)
     &     + 32.D0*ypzp2**(-2)
     &     - 32.D0*ypzp2**(-1)
     &     + 64.D0*z*ypzp2**(-2)
     &     - 64.D0*z*ypzp2**(-1)
     &     + 32.D0*z**2*ypzp2**(-2)
     &     - 16.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(-1)*HAr1(-1)*Nc**3 * (
     &     - 32.D0
     &     + 32.D0*upy**(-2)
     &     + 64.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     + 16.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 48.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 16.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(-1)*HAr1(-1)*Nc**5 * (
     &     - 8.D0
     &     - 32.D0*upy**(-2)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     + 4.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(-1)*HBr1(-1)*Nc * (
     &     - 16.D0
     &     - 64.D0*upz**(-2)
     &     + 40.D0*upz**(-1)
     &     - 32.D0*ypzp2**(-2)
     &     - 64.D0*z*ypzp2**(-2)
     &     + 32.D0*z*ypzp2**(-1)
     &     - 32.D0*z**2*ypzp2**(-2)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(-1)*HBr1(-1)*Nc**3 * (
     &     + 16.D0
     &     + 64.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     + 32.D0*ypzp2**(-2)
     &     + 64.D0*z*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-1)
     &     + 32.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*Nc**(-1) * (
     &     - 8.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*Nc * (
     &     + 8.D0
     &     + upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upz**(-1)*ypzm2**(-1)
     &     + 16.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-1)
     &     + 24.D0*ypzm2**(-1)
     &     + 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 22.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*ypzp2**(-1)
     &     - 20.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 5.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*ypzm2**(-1)
     &     + 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*Nc * (
     &     - 8.D0*z*ypzp2**(-1)
     &     - 11.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)
     &     - 16.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*Nc**2*Nh * (
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upz**(-1)*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*Nc**3 * (
     &     - 8.D0
     &     + 48.D0*upy**(-1)*zm3**(-2)
     &     + 16.D0*upy**(-1)*zm3**(-1)
     &     + 7.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*upy**(-1)
     &     + 32.D0*upz**(-1)*ypzm2**(-1)
     &     - 8.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-1)
     &     - 48.D0*zm3**(-2)*ypzm2**(-1)
     &     - 48.D0*zm3**(-1)*ypzm2**(-2)
     &     - 16.D0*zm3**(-1)*ypzm2**(-1)
     &     - 18.D0*ypzm2**(-2)
     &     - 23.D0*ypzm2**(-1)
     &     - 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*Nc**3 * (
     &     - 22.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*ypzp2**(-1)
     &     + 12.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 9.D0*z*ypzm2**(-1)
     &     - 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z*ypzp2**(-1)
     &     - z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*z**2*ypzm2**(-2)
     &     + 2.D0*z**2*ypzm2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*Nc**3 * (
     &     - 2.D0*z**2*ypzp2**(-1)
     &     - 4.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)
     &     + 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*Nc**4*Nh * (
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upz**(-1)*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*Nc**5 * (
     &     - 48.D0*upy**(-1)*zm3**(-2)
     &     - 16.D0*upy**(-1)*zm3**(-1)
     &     - 3.D0*upy**(-1)
     &     + 48.D0*zm3**(-2)*ypzm2**(-1)
     &     + 48.D0*zm3**(-1)*ypzm2**(-2)
     &     + 16.D0*zm3**(-1)*ypzm2**(-1)
     &     + 18.D0*ypzm2**(-2)
     &     - ypzm2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - z*ypzm2**(-1)
     &     + 6.D0*z*ypzp2**(-1)
     &     + 6.D0*z**2*ypzm2**(-2)
     &     - 2.D0*z**2*ypzm2**(-1)
     &     + 2.D0*z**2*ypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*HAr1(-1)*Nc**(-1) * (
     &     + 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 42.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 44.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*HAr1(-1)*Nc * (
     &     - 20.D0
     &     - 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 58.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 88.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     - 28.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*HAr1(-1)*Nc * (
     &     + 32.D0*z*ypzp2**(-1)
     &     - 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)
     &     - 12.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*HAr1(-1)*Nc**3 * (
     &     + 16.D0
     &     - 16.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     - 16.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upy**(-1)
     &     - 44.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     + 10.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*HAr1(-1)*Nc**3 * (
     &     - 24.D0*z*ypzp2**(-1)
     &     + 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)
     &     + 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*HAr1(-1)*Nc**5 * (
     &     + 4.D0
     &     + 16.D0*upy**(-2)
     &     - 10.D0*upy**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     - 2.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     - 8.D0*z*ypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*HBr1(-1)*Nc**(-1) * (
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 44.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 42.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*HBr1(-1)*Nc * (
     &     + 8.D0
     &     - 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upz**(-2)
     &     + 52.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     - 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     + 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*HBr1(-1)*Nc * (
     &     - 4.D0*y*upz**(-1)
     &     - 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*HBr1(-1)*Nc**3 * (
     &     - 8.D0
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 44.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upz**(-2)
     &     - 10.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr1(0)*HBr1(-1)*Nc**3 * (
     &     - 16.D0*z**2*ypzp2**(-2)
     &     - 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     + 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(-1,-1)*Nc * (
     &     - 40.D0
     &     + 56.D0*upz**(-1)
     &     + 64.D0*ypzp2**(-1)
     &     + 64.D0*z*ypzp2**(-1)
     &     + 24.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(-1,-1)*Nc**3 * (
     &     + 32.D0
     &     - 20.D0*upy**(-1)
     &     - 56.D0*upz**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 48.D0*z*ypzp2**(-1)
     &     - 24.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(-1,-1)*Nc**5 * (
     &     + 8.D0
     &     + 20.D0*upy**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(-1,0)*Nc**(-1) * (
     &     - 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 86.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 86.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 36.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 14.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 14.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(-1,0)*Nc * (
     &     + 20.D0
     &     + 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 58.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 140.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 28.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     + 44.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzp2**(-1)
     &     + 16.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(-1,0)*Nc * (
     &     + 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*y*upz**(-1)
     &     + 20.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(-1,0)*Nc**3 * (
     &     - 16.D0
     &     - 28.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upy**(-1)
     &     - 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 54.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 28.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     - 8.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z*upy**(-1)
     &     + 24.D0*z*ypzp2**(-1)
     &     - 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(-1,0)*Nc**3 * (
     &     + 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*y*upz**(-1)
     &     - 6.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(-1,0)*Nc**5 * (
     &     - 4.D0
     &     - 10.D0*upy**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     - 2.D0*z*upy**(-1)
     &     + 8.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,-1)*Nc * (
     &     + 20.D0
     &     + 128.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 28.D0*upz**(-1)
     &     - 96.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     - 44.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzp2**(-1)
     &     - 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,-1)*Nc * (
     &     + 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,-1)*Nc**3 * (
     &     - 16.D0
     &     - 192.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 96.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upy**(-1)
     &     - 128.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 28.D0*upz**(-1)
     &     + 192.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 192.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 72.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 104.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,-1)*Nc**3 * (
     &     + 16.D0*ypzp2**(-1)
     &     + 38.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z*upy**(-1)
     &     - 36.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z*ypzp2**(-1)
     &     - 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*y*upz**(-1)
     &     - 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,-1)*Nc**3 * (
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,-1)*Nc**5 * (
     &     - 4.D0
     &     + 192.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*upy**(-1)
     &     - 192.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 192.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 96.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 72.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     + 6.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,-1)*Nc**5 * (
     &     - 2.D0*z*upy**(-1)
     &     + 4.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*ypzp2**(-1)
     &     + 6.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,0)*Nc**(-1) * (
     &     + 4.D0
     &     - 8.D0*upy**(-1)*upz**(-1)
     &     - 9.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*upy**(-1)
     &     - 9.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*upz**(-1)
     &     - 2.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*z*upy**(-1)
     &     + 5.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*y*upz**(-1)
     &     + 5.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,0)*Nc * (
     &     - 14.D0
     &     + 4.D0*upy**(-1)*upz**(-1)
     &     - 5.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + upy**(-1)
     &     - 64.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*upz**(-1)*ypzp2**(-1)
     &     + 12.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upz**(-1)
     &     + 48.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 9.D0*ypzp2**(-1)
     &     + 30.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,0)*Nc * (
     &     - z*upy**(-1)
     &     - 16.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 13.D0*z*ypzp2**(-1)
     &     + z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 14.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,0)*Nc**2*Nh * (
     &     + 4.D0*upy**(-1)*upz**(-1)
     &     - 4.D0*upz**(-1)*ypzp2**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,0)*Nc**3 * (
     &     + 8.D0
     &     + 4.D0*upy**(-1)*upz**(-1)
     &     + 96.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 19.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 9.D0*upy**(-1)
     &     + 64.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*upz**(-1)*ypzp2**(-1)
     &     - 3.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 11.D0*upz**(-1)
     &     - 96.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 96.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 36.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,0)*Nc**3 * (
     &     - 52.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - ypzp2**(-1)
     &     - 25.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*z*upy**(-1)
     &     + 18.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 9.D0*z*ypzp2**(-1)
     &     - 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,0)*Nc**3 * (
     &     - 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*y*upz**(-1)
     &     + 7.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,0)*Nc**4*Nh * (
     &     - 4.D0*upy**(-1)*upz**(-1)
     &     + 4.D0*upz**(-1)*ypzp2**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,0)*Nc**5 * (
     &     + 2.D0
     &     - 96.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 5.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 5.D0*upy**(-1)
     &     + 96.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 36.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*ypzp2**(-1)
     &     - 3.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(0,0)*Nc**5 * (
     &     + z*upy**(-1)
     &     - 2.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*ypzp2**(-1)
     &     - 3.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(1,0)*Nc**(-1) * (
     &     - 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 68.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 68.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(1,0)*Nc * (
     &     + 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 68.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 104.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 60.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(1,0)*Nc * (
     &     + 16.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + Hr2(1,0)*Nc**3 * (
     &     - 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 36.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr1(-1)*Nc**(-1) * (
     &     + 2.D0
     &     - 2.D0*y**(-2)*upz**(-1)
     &     - y**(-2)
     &     - 2.D0*y**(-1)*upz**(-1)
     &     - 2.D0*y**(-1)
     &     - y**(-1)*z
     &     - 12.D0*upy**(-2)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     + 4.D0*upz**(-1)
     &     + 4.D0*z*upy**(-2)
     &     + 4.D0*z*upy**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr1(-1)*Nc * (
     &     + 24.D0
     &     + 4.D0*y**(-2)*upz**(-1)
     &     + y**(-2)*zp2**(-1)
     &     + 3.D0*y**(-2)
     &     - 4.D0*y**(-1)*upz**(-1)
     &     - y**(-1)*zp2**(-2)
     &     + y**(-1)*zp2**(-1)
     &     + y**(-1)
     &     + 3.D0*y**(-1)*z
     &     + 40.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 40.D0*upy**(-1)
     &     - 20.D0*upz**(-1)
     &     + zp2**(-2)*ypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr1(-1)*Nc * (
     &     - zp2**(-1)*ypzp2**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     - 23.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-2)
     &     - 4.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 31.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr1(-1)*Nc**3 * (
     &     - 26.D0
     &     - 2.D0*y**(-2)*upz**(-1)
     &     - 2.D0*y**(-2)*zp2**(-1)
     &     - 3.D0*y**(-2)
     &     + 6.D0*y**(-1)*upz**(-1)
     &     + 2.D0*y**(-1)*zp2**(-2)
     &     + 2.D0*y**(-1)*zp2**(-1)
     &     + 4.D0*y**(-1)
     &     - 3.D0*y**(-1)*z
     &     - 44.D0*upy**(-2)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 24.D0*upy**(-1)
     &     + 16.D0*upz**(-1)
     &     - 2.D0*zp2**(-2)*ypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr1(-1)*Nc**3 * (
     &     - 2.D0*zp2**(-1)*ypzp2**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     + 14.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-2)
     &     - 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     + 26.D0*z*ypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr1(-1)*Nc**5 * (
     &     + y**(-2)*zp2**(-1)
     &     + y**(-2)
     &     - y**(-1)*zp2**(-2)
     &     - 3.D0*y**(-1)*zp2**(-1)
     &     - 3.D0*y**(-1)
     &     + y**(-1)*z
     &     + 16.D0*upy**(-2)
     &     - 4.D0*upy**(-1)
     &     + zp2**(-2)*ypzp2**(-1)
     &     + 3.D0*zp2**(-1)*ypzp2**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     + 9.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr1(-1)*Nc**5 * (
     &     + 5.D0*z*ypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr1(-1)*HBr1(-1)*Nc * (
     &     + 8.D0
     &     - 32.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 64.D0*upz**(-1)*ypzp2**(-1)
     &     - 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr1(-1)*HBr1(-1)*Nc**3 * (
     &     - 8.D0
     &     + 32.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     - 32.D0*upz**(-2)
     &     + 64.D0*upz**(-1)*ypzp2**(-1)
     &     + 20.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr2(-1,-1)*Nc * (
     &     - 16.D0
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     + 64.D0*upz**(-1)*ypzp2**(-1)
     &     - 4.D0*upz**(-1)
     &     + 48.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 12.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr2(-1,-1)*Nc**3 * (
     &     + 8.D0
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 40.D0*upy**(-1)
     &     - 64.D0*upz**(-1)*ypzp2**(-1)
     &     + 4.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     - 12.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr2(-1,-1)*Nc**5 * (
     &     + 8.D0
     &     + 20.D0*upy**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr2(0,-1)*Nc**(-1) * (
     &     + 4.D0
     &     + 4.D0*upy**(-3)
     &     + 8.D0*upy**(-2)
     &     - 12.D0*upy**(-1)*upz**(-1)
     &     - 2.D0*upy**(-1)
     &     + 8.D0*upz**(-1)
     &     + 4.D0*z*upy**(-3)
     &     + 2.D0*z*upy**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr2(0,-1)*Nc * (
     &     - 8.D0*upy**(-3)
     &     - 12.D0*upy**(-2)
     &     + 28.D0*upy**(-1)*upz**(-1)
     &     - 6.D0*upy**(-1)
     &     - 16.D0*upz**(-1)*ypzp2**(-1)
     &     - 16.D0*upz**(-1)
     &     - 10.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-3)
     &     - 6.D0*z*upy**(-1)
     &     - 2.D0*z*ypzp2**(-1)
     &     - 12.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr2(0,-1)*Nc**3 * (
     &     + 4.D0*upy**(-3)
     &     + 4.D0*upy**(-2)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 18.D0*upy**(-1)
     &     + 16.D0*upz**(-1)*ypzp2**(-1)
     &     + 8.D0*upz**(-1)
     &     - 6.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-3)
     &     + 6.D0*z*upy**(-1)
     &     - 6.D0*z*ypzp2**(-1)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HAr2(0,-1)*Nc**5 * (
     &     - 4.D0
     &     - 10.D0*upy**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     - 2.D0*z*upy**(-1)
     &     + 8.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HBr1(-1)*Nc**(-1) * (
     &     + 2.D0
     &     - 2.D0*z**(-2)*upy**(-1)
     &     - z**(-2)
     &     - 2.D0*z**(-1)*upy**(-1)
     &     - 2.D0*z**(-1)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 4.D0*upy**(-1)
     &     - 12.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - y*z**(-1)
     &     + 4.D0*y*upz**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HBr1(-1)*Nc * (
     &     - 8.D0
     &     + 4.D0*z**(-2)*upy**(-1)
     &     + 2.D0*z**(-2)
     &     - 4.D0*z**(-1)*upy**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 4.D0*upy**(-1)
     &     + 28.D0*upz**(-2)
     &     - 24.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + HBr1(-1)*Nc * (
     &     + 2.D0*y*z**(-1)
     &     - 4.D0*y*upz**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + HBr1(-1)*Nc**3 * (
     &     + 6.D0
     &     - 2.D0*z**(-2)*upy**(-1)
     &     - z**(-2)
     &     + 6.D0*z**(-1)*upy**(-1)
     &     + 2.D0*z**(-1)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     - 16.D0*upz**(-2)
     &     + 4.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T13 = PoleEP0T13 + HBr1(-1)*Nc**3 * (
     &     - y*z**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HBr2(-1,-1)*Nc * (
     &     - 8.D0
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     + 64.D0*upz**(-1)*ypzp2**(-1)
     &     + 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HBr2(-1,-1)*Nc**3 * (
     &     + 8.D0
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     - 64.D0*upz**(-1)*ypzp2**(-1)
     &     - 20.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HBr2(0,-1)*Nc**(-1) * (
     &     + 4.D0
     &     - 12.D0*upy**(-1)*upz**(-1)
     &     + 8.D0*upy**(-1)
     &     + 4.D0*upz**(-3)
     &     + 8.D0*upz**(-2)
     &     - 2.D0*upz**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 4.D0*y*upz**(-3)
     &     + 2.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HBr2(0,-1)*Nc * (
     &     - 4.D0
     &     + 12.D0*upy**(-1)*upz**(-1)
     &     - 8.D0*upy**(-1)
     &     - 4.D0*upz**(-3)
     &     - 8.D0*upz**(-2)
     &     - 8.D0*upz**(-1)
     &     - 4.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 4.D0*z*ypzp2**(-1)
     &     - 4.D0*y*upz**(-3)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T13 = PoleEP0T13 + HBr2(0,-1)*Nc**3 * (
     &     + 10.D0*upz**(-1)
     &     + 4.D0*ypzp2**(-1)
     &     + 4.D0*z*ypzp2**(-1)
     &     + 2.D0*y*upz**(-1)
     &     )
      return
      end

*
**************************** 72 characters *****************************
*
*
      double precision function PoleEPm2T34(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl,ypzp2,ypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEPm2T34 =  + Nc**(-1) * (
     &     + 16.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     + 16.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEPm2T34 = PoleEPm2T34 + Nc * (
     &     - 8.D0
     &     - 16.D0*upy**(-2)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEPm2T34 = PoleEPm2T34 + Nc**3 * (
     &     + 8.D0
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     )
      return
      end
*
*
*
      double precision function PoleEPm1T34(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl,ypzp2,ypzm2,sqrypzp2,sqrypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
	sqrypzp2 = Dsqrt(y+z+2.d0)
	sqrypzm2 = Dsqrt(y+z-2.d0)
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEPm1T34 =  + Nc**(-3) * (
     &     - 8.D0*upy**(-2)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 10.D0*upy**(-1)
     &     - 8.D0*upz**(-2)
     &     + 10.D0*upz**(-1)
     &     + 2.D0*z*upy**(-1)
     &     + 2.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Nc**(-2)*Nl * (
     &     - 16.D0/3.D0*upy**(-2)
     &     - 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 20.D0/3.D0*upy**(-1)
     &     - 16.D0/3.D0*upz**(-2)
     &     + 20.D0/3.D0*upz**(-1)
     &     + 4.D0/3.D0*z*upy**(-1)
     &     + 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Nc**(-1) * (
     &     + 12.D0
     &     + 136.D0/3.D0*upy**(-2)
     &     + 224.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 146.D0/3.D0*upy**(-1)
     &     + 136.D0/3.D0*upz**(-2)
     &     - 146.D0/3.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 8.D0*ypzp2**(-1)
     &     - 10.D0/3.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     - 8.D0*z*ypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 10.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Nl * (
     &     + 8.D0/3.D0
     &     + 16.D0/3.D0*upy**(-2)
     &     - 20.D0/3.D0*upy**(-1)
     &     + 16.D0/3.D0*upz**(-2)
     &     - 20.D0/3.D0*upz**(-1)
     &     + 16.D0/3.D0*ypzp2**(-2)
     &     + 16.D0/3.D0*ypzp2**(-1)
     &     - 4.D0/3.D0*z*upy**(-1)
     &     + 32.D0/3.D0*z*ypzp2**(-2)
     &     - 16.D0/3.D0*z*ypzp2**(-1)
     &     + 16.D0/3.D0*z**2*ypzp2**(-2)
     &     - 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Nc * (
     &     - 44.D0/3.D0
     &     - 112.D0/3.D0*upy**(-2)
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     + 116.D0/3.D0*upy**(-1)
     &     - 112.D0/3.D0*upz**(-2)
     &     + 116.D0/3.D0*upz**(-1)
     &     - 88.D0/3.D0*ypzp2**(-2)
     &     - 184.D0/3.D0*ypzp2**(-1)
     &     + 4.D0/3.D0*z*upy**(-1)
     &     - 176.D0/3.D0*z*ypzp2**(-2)
     &     + 88.D0/3.D0*z*ypzp2**(-1)
     &     - 88.D0/3.D0*z**2*ypzp2**(-2)
     &     + 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Nc**2*Nl * (
     &     - 8.D0/3.D0
     &     + 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 16.D0/3.D0*ypzp2**(-2)
     &     - 16.D0/3.D0*ypzp2**(-1)
     &     - 32.D0/3.D0*z*ypzp2**(-2)
     &     + 16.D0/3.D0*z*ypzp2**(-1)
     &     - 16.D0/3.D0*z**2*ypzp2**(-2)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Nc**3 * (
     &     + 8.D0/3.D0
     &     - 224.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 64.D0/3.D0*ypzp2**(-2)
     &     + 160.D0/3.D0*ypzp2**(-1)
     &     + 128.D0/3.D0*z*ypzp2**(-2)
     &     - 64.D0/3.D0*z*ypzp2**(-1)
     &     + 64.D0/3.D0*z**2*ypzp2**(-2)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Hr1(-1)*Nc * (
     &     + 8.D0
     &     - 16.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Hr1(-1)*Nc**3 * (
     &     - 8.D0
     &     + 16.D0*upy**(-2)
     &     + 64.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     + 16.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Hr1(0)*Nc**(-3) * (
     &     + 8.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 34.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 34.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Hr1(0)*Nc**(-1) * (
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Hr1(0)*Nc * (
     &     - 4.D0
     &     - 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upy**(-2)
     &     - 96.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 84.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*upy**(-1)
     &     - 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upz**(-2)
     &     + 84.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     + 8.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Hr1(0)*Nc * (
     &     - 8.D0*ypzp2**(-1)
     &     - 48.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*ypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     - 8.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Hr1(0)*Nc * (
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y*upz**(-1)
     &     - 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Hr1(0)*Nc**3 * (
     &     + 4.D0
     &     + 8.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     - 34.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upy**(-1)
     &     + 8.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upz**(-2)
     &     - 34.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 8.D0*ypzp2**(-1)
     &     + 20.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + Hr1(0)*Nc**3 * (
     &     - 8.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     - 8.D0*z*ypzp2**(-1)
     &     + 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y*upz**(-1)
     &     + 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + HAr1(-1)*Nc**(-1) * (
     &     - 16.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + HAr1(-1)*Nc * (
     &     + 8.D0
     &     + 16.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     - 4.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + HAr1(-1)*Nc**3 * (
     &     - 8.D0
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + HBr1(-1)*Nc**(-1) * (
     &     - 16.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + HBr1(-1)*Nc * (
     &     + 32.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 40.D0*upy**(-1)
     &     + 16.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T34 = PoleEPm1T34 + HBr1(-1)*Nc**3 * (
     &     - 16.D0*upy**(-2)
     &     + 20.D0*upy**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     )
      return
      end
*
*
*
      double precision function PoleEP0T34(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,zp2,zm3,
     $                 Nc,Nh,Nl,ypzp2,ypzm2,sqrypzp2,sqrypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	zp2 = 2.d0+z
	zm3 = z-3.d0
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
	sqrypzp2 = Dsqrt(y+z+2.d0)
	sqrypzm2 = Dsqrt(y+z-2.d0)
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEP0T34 =  + Nc**(-3) * (
     &     - 4.D0
     &     - 2.D0*y**(-1)*upz**(-1)
     &     - y**(-1)
     &     - 2.D0*z**(-1)*upy**(-1)
     &     - z**(-1)
     &     - 12.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 21.D0*upy**(-1)
     &     - 12.D0*upz**(-2)
     &     + 21.D0*upz**(-1)
     &     - 4.D0*z2*upy**(-3)
     &     - 24.D0*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z2*upy**(-2)
     &     - 96.D0*z2*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**(-3) * (
     &     + 93.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*z2*upy**(-1)
     &     - 4.D0*z2*upz**(-3)
     &     - 24.D0*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z2*upz**(-2)
     &     + 93.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*z2*upz**(-1)
     &     - 62.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z2
     &     + 4.D0*z*upy**(-2)
     &     - z*upy**(-1)
     &     - 4.D0*z*z2*upy**(-3)
     &     + 24.D0*z*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**(-3) * (
     &     + 3.D0*z*z2*upy**(-1)
     &     - z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 5.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-2)
     &     - y*upz**(-1)
     &     - 4.D0*y*z2*upz**(-3)
     &     + 24.D0*y*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*y*z2*upz**(-1)
     &     - y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 5.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**(-2)*Nl * (
     &     - 8.D0/3.D0
     &     - 8.D0/3.D0*upy**(-1)
     &     - 8.D0/3.D0*upz**(-1)
     &     - 8.D0/3.D0*z*upy**(-1)
     &     - 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**(-1) * (
     &     + 41.D0/3.D0
     &     + 2.D0*y**(-1)*upz**(-1)
     &     + y**(-1)*zp2**(-1)
     &     + 2.D0*y**(-1)
     &     + 2.D0*z**(-1)*upy**(-1)
     &     + z**(-1)*ypzp2**(-1)
     &     + 2.D0*z**(-1)
     &     + 28.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 70.D0/3.D0*upy**(-1)
     &     + 28.D0*upz**(-2)
     &     - 70.D0/3.D0*upz**(-1)
     &     - zp2**(-1)*ypzp2**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**(-1) * (
     &     + 26.D0*ypzp2**(-1)
     &     + 4.D0*z2*upy**(-3)
     &     - 60.D0*z2*upy**(-2)
     &     - 96.D0*z2*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 60.D0*z2*upy**(-1)*upz**(-1)
     &     + 34.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*z2*upy**(-1)
     &     + 4.D0*z2*upz**(-3)
     &     - 60.D0*z2*upz**(-2)
     &     + 34.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*z2*upz**(-1)
     &     + 64.D0*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z2*ypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**(-1) * (
     &     - 22.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + z2
     &     - 4.D0*z*upy**(-2)
     &     + 38.D0/3.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     - 8.D0*z*ypzp2**(-1)
     &     + 4.D0*z*z2*upy**(-3)
     &     + 4.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 14.D0*z*z2*upy**(-1)
     &     + 128.D0*z*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 128.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 19.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     + 2.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**(-1) * (
     &     + 64.D0*z**2*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-2)
     &     + 38.D0/3.D0*y*upz**(-1)
     &     + 4.D0*y*z2*upz**(-3)
     &     + 4.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 14.D0*y*z2*upz**(-1)
     &     - 13.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nl * (
     &     - 8.D0/3.D0
     &     + 2.D0*upy**(-1)
     &     + 2.D0*upz**(-1)
     &     - 16.D0/3.D0*ypzp2**(-2)
     &     + 8.D0*ypzp2**(-1)
     &     + 8.D0/3.D0*z*upy**(-1)
     &     - 32.D0/3.D0*z*ypzp2**(-2)
     &     + 16.D0/3.D0*z*ypzp2**(-1)
     &     - 16.D0/3.D0*z**2*ypzp2**(-2)
     &     + 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nh * (
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     - 2.D0/3.D0*upy**(-1)
     &     - 2.D0/3.D0*upz**(-1)
     &     + 64.D0*ypzp2**(-2)
     &     + 8.D0/3.D0*ypzp2**(-1)
     &     + 12.D0*z2*upy**(-1)*upz**(-1)
     &     - 48.D0*z2*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc * (
     &     + 44.D0/3.D0
     &     + 2.D0*y**(-1)*upz**(-1)
     &     - 2.D0*y**(-1)*zp2**(-1)
     &     - y**(-1)
     &     + 2.D0*z**(-1)*upy**(-1)
     &     - 2.D0*z**(-1)*ypzp2**(-1)
     &     - z**(-1)
     &     - 16.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 8.D0*upy**(-1)*zm3**(-1)
     &     + upy**(-1)
     &     - 16.D0*upz**(-2)
     &     - 8.D0*upz**(-1)*ypzm2**(-1)
     &     + upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc * (
     &     + 2.D0*zp2**(-1)*ypzp2**(-1)
     &     + 8.D0*zm3**(-1)*ypzm2**(-1)
     &     + 10.D0*ypzm2**(-1)
     &     + 40.D0/3.D0*ypzp2**(-2)
     &     - 86.D0*ypzp2**(-1)
     &     + 48.D0*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 92.D0*z2*upy**(-2)
     &     + 288.D0*z2*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 44.D0*z2*upy**(-1)*upz**(-1)
     &     - 96.D0*z2*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z2*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 219.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 41.D0*z2*upy**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc * (
     &     + 48.D0*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 92.D0*z2*upz**(-2)
     &     - 96.D0*z2*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 16.D0*z2*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 219.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 41.D0*z2*upz**(-1)
     &     + 96.D0*z2*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 96.D0*z2*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 16.D0*z2*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc * (
     &     + 120.D0*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*z2*ypzp2**(-2)
     &     - 36.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*z2*ypzp2**(-1)
     &     + 138.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 15.D0*z2
     &     - 35.D0/3.D0*z*upy**(-1)
     &     - 4.D0*z*ypzm2**(-1)
     &     + 80.D0/3.D0*z*ypzp2**(-2)
     &     - 52.D0/3.D0*z*ypzp2**(-1)
     &     - 48.D0*z*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 44.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc * (
     &     - 27.D0*z*z2*upy**(-1)
     &     - 48.D0*z*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 128.D0*z*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 80.D0*z*z2*ypzp2**(-2)
     &     + 152.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*z*z2*ypzp2**(-1)
     &     - 20.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*ypzm2**(-1)
     &     + 40.D0/3.D0*z**2*ypzp2**(-2)
     &     - 2.D0*z**2*ypzp2**(-1)
     &     + 5.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z**2*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc * (
     &     - 64.D0*z**2*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*z**2*z2*ypzp2**(-2)
     &     + 44.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 35.D0/3.D0*y*upz**(-1)
     &     - 48.D0*y*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 44.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 27.D0*y*z2*upz**(-1)
     &     + 20.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 5.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**2*Nl * (
     &     + 16.D0/3.D0
     &     + 2.D0/3.D0*upy**(-1)
     &     + 2.D0/3.D0*upz**(-1)
     &     + 16.D0/3.D0*ypzp2**(-2)
     &     - 8.D0*ypzp2**(-1)
     &     + 32.D0/3.D0*z*ypzp2**(-2)
     &     - 16.D0/3.D0*z*ypzp2**(-1)
     &     + 16.D0/3.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**2*Nh * (
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     + 2.D0/3.D0*upy**(-1)
     &     + 2.D0/3.D0*upz**(-1)
     &     - 64.D0*ypzp2**(-2)
     &     - 8.D0/3.D0*ypzp2**(-1)
     &     - 12.D0*z2*upy**(-1)*upz**(-1)
     &     + 48.D0*z2*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**3 * (
     &     - 73.D0/3.D0
     &     - 2.D0*y**(-1)*upz**(-1)
     &     + y**(-1)*zp2**(-1)
     &     - 2.D0*z**(-1)*upy**(-1)
     &     + z**(-1)*ypzp2**(-1)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 8.D0*upy**(-1)*zm3**(-1)
     &     + 4.D0/3.D0*upy**(-1)
     &     + 8.D0*upz**(-1)*ypzm2**(-1)
     &     + 4.D0/3.D0*upz**(-1)
     &     - zp2**(-1)*ypzp2**(-1)
     &     - 8.D0*zm3**(-1)*ypzm2**(-1)
     &     - 10.D0*ypzm2**(-1)
     &     - 64.D0/3.D0*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**3 * (
     &     + 60.D0*ypzp2**(-1)
     &     - 24.D0*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z2*upy**(-2)
     &     - 96.D0*z2*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 104.D0*z2*upy**(-1)*upz**(-1)
     &     + 96.D0*z2*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z2*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 92.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z2*upy**(-1)
     &     - 24.D0*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z2*upz**(-2)
     &     + 96.D0*z2*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 16.D0*z2*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**3 * (
     &     + 92.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z2*upz**(-1)
     &     - 96.D0*z2*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 96.D0*z2*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 16.D0*z2*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 120.D0*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*z2*ypzp2**(-2)
     &     - 12.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z2*ypzp2**(-1)
     &     - 54.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**3 * (
     &     - 20.D0*z2
     &     + 4.D0*z*ypzm2**(-1)
     &     - 128.D0/3.D0*z*ypzp2**(-2)
     &     + 76.D0/3.D0*z*ypzp2**(-1)
     &     + 24.D0*z*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*z*z2*upy**(-1)
     &     + 48.D0*z*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 80.D0*z*z2*ypzp2**(-2)
     &     - 24.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*z*z2*ypzp2**(-1)
     &     + 2.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*ypzm2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Nc**3 * (
     &     - 64.D0/3.D0*z**2*ypzp2**(-2)
     &     + 2.D0*z**2*ypzp2**(-1)
     &     - 2.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z**2*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*z**2*z2*ypzp2**(-2)
     &     - 12.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*y*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*y*z2*upz**(-1)
     &     - 6.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Dlog(tm**(-2)*w**2)*Nc**(-2)*Nl * (
     &     + 16.D0/3.D0*upy**(-2)
     &     + 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 20.D0/3.D0*upy**(-1)
     &     + 16.D0/3.D0*upz**(-2)
     &     - 20.D0/3.D0*upz**(-1)
     &     - 4.D0/3.D0*z*upy**(-1)
     &     - 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Dlog(tm**(-2)*w**2)*Nc**(-1) * (
     &     - 88.D0/3.D0*upy**(-2)
     &     - 176.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 110.D0/3.D0*upy**(-1)
     &     - 88.D0/3.D0*upz**(-2)
     &     + 110.D0/3.D0*upz**(-1)
     &     + 22.D0/3.D0*z*upy**(-1)
     &     + 22.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Dlog(tm**(-2)*w**2)*Nl * (
     &     - 8.D0/3.D0
     &     - 16.D0/3.D0*upy**(-2)
     &     + 20.D0/3.D0*upy**(-1)
     &     - 16.D0/3.D0*upz**(-2)
     &     + 20.D0/3.D0*upz**(-1)
     &     - 16.D0/3.D0*ypzp2**(-2)
     &     - 16.D0/3.D0*ypzp2**(-1)
     &     + 4.D0/3.D0*z*upy**(-1)
     &     - 32.D0/3.D0*z*ypzp2**(-2)
     &     + 16.D0/3.D0*z*ypzp2**(-1)
     &     - 16.D0/3.D0*z**2*ypzp2**(-2)
     &     + 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Dlog(tm**(-2)*w**2)*Nc * (
     &     + 44.D0/3.D0
     &     + 88.D0/3.D0*upy**(-2)
     &     - 110.D0/3.D0*upy**(-1)
     &     + 88.D0/3.D0*upz**(-2)
     &     - 110.D0/3.D0*upz**(-1)
     &     + 88.D0/3.D0*ypzp2**(-2)
     &     + 88.D0/3.D0*ypzp2**(-1)
     &     - 22.D0/3.D0*z*upy**(-1)
     &     + 176.D0/3.D0*z*ypzp2**(-2)
     &     - 88.D0/3.D0*z*ypzp2**(-1)
     &     + 88.D0/3.D0*z**2*ypzp2**(-2)
     &     - 22.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Dlog(tm**(-2)*w**2)*Nc**2*Nl * (
     &     + 8.D0/3.D0
     &     - 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 16.D0/3.D0*ypzp2**(-2)
     &     + 16.D0/3.D0*ypzp2**(-1)
     &     + 32.D0/3.D0*z*ypzp2**(-2)
     &     - 16.D0/3.D0*z*ypzp2**(-1)
     &     + 16.D0/3.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + Dlog(tm**(-2)*w**2)*Nc**3 * (
     &     - 44.D0/3.D0
     &     + 176.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 88.D0/3.D0*ypzp2**(-2)
     &     - 88.D0/3.D0*ypzp2**(-1)
     &     - 176.D0/3.D0*z*ypzp2**(-2)
     &     + 88.D0/3.D0*z*ypzp2**(-1)
     &     - 88.D0/3.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(-1)*Nc * (
     &     - 6.D0
     &     + 96.D0*upy**(-1)*zm3**(-2)
     &     - 32.D0*upy**(-1)*zm3**(-1)
     &     - 26.D0*upy**(-1)
     &     + 96.D0*upz**(-1)*ypzm2**(-2)
     &     - 32.D0*upz**(-1)*ypzm2**(-1)
     &     - 26.D0*upz**(-1)
     &     - 96.D0*zm3**(-2)*ypzm2**(-1)
     &     - 96.D0*zm3**(-1)*ypzm2**(-2)
     &     + 32.D0*zm3**(-1)*ypzm2**(-1)
     &     - 120.D0*ypzm2**(-2)
     &     + 40.D0*ypzm2**(-1)
     &     + 8.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(-1)*Nc * (
     &     + 48.D0*z*ypzm2**(-2)
     &     + 8.D0*z*ypzm2**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     - 24.D0*z**2*ypzm2**(-2)
     &     + 8.D0*z**2*ypzm2**(-1)
     &     - 8.D0*z**2*ypzp2**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(-1)*Nc**3 * (
     &     + 6.D0
     &     - 96.D0*upy**(-1)*zm3**(-2)
     &     + 32.D0*upy**(-1)*zm3**(-1)
     &     + 26.D0*upy**(-1)
     &     - 96.D0*upz**(-1)*ypzm2**(-2)
     &     + 32.D0*upz**(-1)*ypzm2**(-1)
     &     + 26.D0*upz**(-1)
     &     + 96.D0*zm3**(-2)*ypzm2**(-1)
     &     + 96.D0*zm3**(-1)*ypzm2**(-2)
     &     - 32.D0*zm3**(-1)*ypzm2**(-1)
     &     + 120.D0*ypzm2**(-2)
     &     - 40.D0*ypzm2**(-1)
     &     - 8.D0*ypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(-1)*Nc**3 * (
     &     - 48.D0*z*ypzm2**(-2)
     &     - 8.D0*z*ypzm2**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 24.D0*z**2*ypzm2**(-2)
     &     - 8.D0*z**2*ypzm2**(-1)
     &     + 8.D0*z**2*ypzp2**(-1)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(-1)*HAr1(-1)*Nc * (
     &     - 32.D0
     &     + 32.D0*upy**(-2)
     &     + 64.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     + 16.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 48.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 16.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(-1)*HAr1(-1)*Nc**3 * (
     &     + 32.D0
     &     - 32.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     - 32.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 48.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 16.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(-1)*HBr1(-1)*Nc * (
     &     + 64.D0*upy**(-1)*upz**(-1)
     &     + 16.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 32.D0*ypzp2**(-1)
     &     + 16.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(-1)*HBr1(-1)*Nc**3 * (
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     - 16.D0*upy**(-1)
     &     - 32.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)
     &     - 16.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*Nc**(-3) * (
     &     + 8.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*Nc**(-1) * (
     &     + 7.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 7.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 11.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 7.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*Nh * (
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 128.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*Nc * (
     &     + 3.D0
     &     - 48.D0*upy**(-1)*zm3**(-2)
     &     + 16.D0*upy**(-1)*zm3**(-1)
     &     - 23.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 13.D0*upy**(-1)
     &     - 48.D0*upz**(-1)*ypzm2**(-2)
     &     + 16.D0*upz**(-1)*ypzm2**(-1)
     &     - 23.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 13.D0*upz**(-1)
     &     + 48.D0*zm3**(-2)*ypzm2**(-1)
     &     + 48.D0*zm3**(-1)*ypzm2**(-2)
     &     - 16.D0*zm3**(-1)*ypzm2**(-1)
     &     + 60.D0*ypzm2**(-2)
     &     - 20.D0*ypzm2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*Nc * (
     &     + 16.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*ypzp2**(-1)
     &     + 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 7.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 24.D0*z*ypzm2**(-2)
     &     - 4.D0*z*ypzm2**(-1)
     &     + 32.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*ypzp2**(-1)
     &     + 35.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z**2*ypzm2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*Nc * (
     &     - 4.D0*z**2*ypzm2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*ypzp2**(-1)
     &     - 7.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     + 31.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*Nc**2*Nh * (
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 128.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*Nc**3 * (
     &     - 3.D0
     &     + 48.D0*upy**(-1)*zm3**(-2)
     &     - 16.D0*upy**(-1)*zm3**(-1)
     &     + 8.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 13.D0*upy**(-1)
     &     + 48.D0*upz**(-1)*ypzm2**(-2)
     &     - 16.D0*upz**(-1)*ypzm2**(-1)
     &     + 8.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 13.D0*upz**(-1)
     &     - 48.D0*zm3**(-2)*ypzm2**(-1)
     &     - 48.D0*zm3**(-1)*ypzm2**(-2)
     &     + 16.D0*zm3**(-1)*ypzm2**(-1)
     &     - 60.D0*ypzm2**(-2)
     &     + 20.D0*ypzm2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*Nc**3 * (
     &     + 4.D0*ypzp2**(-1)
     &     - 8.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 24.D0*z*ypzm2**(-2)
     &     + 4.D0*z*ypzm2**(-1)
     &     - 8.D0*z*ypzp2**(-1)
     &     - 12.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z**2*ypzm2**(-2)
     &     + 4.D0*z**2*ypzm2**(-1)
     &     - 4.D0*z**2*ypzp2**(-1)
     &     + 4.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*Nc**3 * (
     &     - 12.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HAr1(-1)*Nc**(-3) * (
     &     - 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 42.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 44.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 18.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HAr1(-1)*Nc**(-1) * (
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 44.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HAr1(-1)*Nc * (
     &     + 16.D0
     &     + 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upy**(-2)
     &     + 96.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     - 100.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upy**(-1)
     &     - 132.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     + 46.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HAr1(-1)*Nc * (
     &     + 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     - 24.D0*z*ypzp2**(-1)
     &     + 14.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     + 24.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)
     &     + 20.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HAr1(-1)*Nc**3 * (
     &     - 16.D0
     &     - 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 42.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*upy**(-1)
     &     + 44.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upz**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     - 18.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HAr1(-1)*Nc**3 * (
     &     - 2.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     + 24.D0*z*ypzp2**(-1)
     &     - 6.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)
     &     - 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HBr1(-1)*Nc**(-3) * (
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 44.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 42.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 18.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HBr1(-1)*Nc**(-1) * (
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 44.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HBr1(-1)*Nc * (
     &     + 96.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     - 132.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upy**(-1)
     &     + 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-2)
     &     - 100.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     + 46.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HBr1(-1)*Nc * (
     &     + 16.D0*z*ypzp2**(-2)
     &     + 8.D0*z*ypzp2**(-1)
     &     + 20.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y*upz**(-1)
     &     + 14.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HBr1(-1)*Nc**3 * (
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 44.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upy**(-1)
     &     - 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-2)
     &     + 42.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*upz**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     - 18.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr1(0)*HBr1(-1)*Nc**3 * (
     &     - 8.D0*z*ypzp2**(-1)
     &     - 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     + 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y*upz**(-1)
     &     - 6.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(-1,-1)*Nc * (
     &     + 16.D0
     &     - 36.D0*upy**(-1)
     &     - 36.D0*upz**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     - 20.D0*z*upy**(-1)
     &     - 20.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(-1,-1)*Nc**3 * (
     &     - 16.D0
     &     + 36.D0*upy**(-1)
     &     + 36.D0*upz**(-1)
     &     + 32.D0*ypzp2**(-1)
     &     + 20.D0*z*upy**(-1)
     &     + 20.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(-1,0)*Nc**(-3) * (
     &     + 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 86.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 86.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 36.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 14.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 14.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(-1,0)*Nc**(-1) * (
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 60.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 60.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(-1,0)*Nc * (
     &     - 8.D0
     &     - 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 192.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 232.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*upy**(-1)
     &     - 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 232.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*upz**(-1)
     &     - 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     - 92.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*z*upy**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(-1,0)*Nc * (
     &     - 34.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*y*upz**(-1)
     &     - 34.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(-1,0)*Nc**3 * (
     &     + 8.D0
     &     + 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 86.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 18.D0*upy**(-1)
     &     + 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 86.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 18.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     + 36.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*z*upy**(-1)
     &     + 14.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(-1,0)*Nc**3 * (
     &     + 6.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*y*upz**(-1)
     &     + 14.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,-1)*Nc * (
     &     - 8.D0
     &     + 192.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*upy**(-1)
     &     + 192.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*upz**(-1)
     &     - 192.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 192.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 240.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,-1)*Nc * (
     &     - 24.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     + 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*z*upy**(-1)
     &     + 96.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*y*upz**(-1)
     &     - 10.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,-1)*Nc * (
     &     + 6.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,-1)*Nc**3 * (
     &     + 8.D0
     &     - 192.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 18.D0*upy**(-1)
     &     - 192.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 18.D0*upz**(-1)
     &     + 192.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 192.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 240.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,-1)*Nc**3 * (
     &     + 24.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     - 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*z*upy**(-1)
     &     - 96.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*y*upz**(-1)
     &     + 10.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,-1)*Nc**3 * (
     &     - 6.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,0)*Nc**(-3) * (
     &     - 4.D0
     &     + 8.D0*upy**(-1)*upz**(-1)
     &     + 9.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*upy**(-1)
     &     + 9.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*upz**(-1)
     &     + 2.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*z*upy**(-1)
     &     - 5.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*y*upz**(-1)
     &     - 5.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,0)*Nc**(-1) * (
     &     - 1.D0
     &     + 4.D0*upy**(-1)*upz**(-1)
     &     + 14.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*upy**(-1)
     &     + 14.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*ypzp2**(-1)
     &     - 2.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,0)*Nc**(-1) * (
     &     - 7.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y*upz**(-1)
     &     + y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,0)*Nh * (
     &     - 4.D0*upy**(-1)*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,0)*Nc * (
     &     + 13.D0
     &     - 20.D0*upy**(-1)*upz**(-1)
     &     - 96.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 31.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + upy**(-1)
     &     - 96.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 31.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + upz**(-1)
     &     + 96.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 120.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,0)*Nc * (
     &     - 20.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 36.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     - 10.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*z*upy**(-1)
     &     - 48.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 14.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,0)*Nc * (
     &     - 4.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*y*upz**(-1)
     &     + 14.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,0)*Nc**2*Nh * (
     &     + 4.D0*upy**(-1)*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,0)*Nc**3 * (
     &     - 8.D0
     &     + 8.D0*upy**(-1)*upz**(-1)
     &     + 96.D0*upy**(-1)*zm3**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*upy**(-1)
     &     + 96.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*upz**(-1)
     &     - 96.D0*zm3**(-2)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 96.D0*zm3**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 120.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,0)*Nc**3 * (
     &     + 20.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*ypzp2**(-1)
     &     + 10.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z*upy**(-1)
     &     + 48.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(0,0)*Nc**3 * (
     &     - 10.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(1,0)*Nc**(-3) * (
     &     + 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 68.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 68.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(1,0)*Nc**(-1) * (
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(1,0)*Nc * (
     &     - 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 192.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 168.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 168.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 96.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(1,0)*Nc * (
     &     - 16.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + Hr2(1,0)*Nc**3 * (
     &     + 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 68.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 68.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr1(-1)*Nc**(-3) * (
     &     - 2.D0
     &     + 2.D0*y**(-2)*upz**(-1)
     &     + y**(-2)
     &     + 2.D0*y**(-1)*upz**(-1)
     &     + 2.D0*y**(-1)
     &     + y**(-1)*z
     &     + 12.D0*upy**(-2)
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     - 4.D0*upz**(-1)
     &     - 4.D0*z*upy**(-2)
     &     - 4.D0*z*upy**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr1(-1)*Nc**(-1) * (
     &     - 10.D0
     &     - 2.D0*y**(-2)*upz**(-1)
     &     - y**(-2)*zp2**(-1)
     &     - 2.D0*y**(-2)
     &     + 6.D0*y**(-1)*upz**(-1)
     &     + y**(-1)*zp2**(-2)
     &     - y**(-1)*zp2**(-1)
     &     + y**(-1)
     &     - 2.D0*y**(-1)*z
     &     - 28.D0*upy**(-2)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     - zp2**(-2)*ypzp2**(-1)
     &     + zp2**(-1)*ypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr1(-1)*Nc**(-1) * (
     &     - 9.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-2)
     &     - z*ypzp2**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr1(-1)*Nc * (
     &     + 2.D0
     &     - 2.D0*y**(-2)*upz**(-1)
     &     + 2.D0*y**(-2)*zp2**(-1)
     &     + y**(-2)
     &     - 2.D0*y**(-1)*upz**(-1)
     &     - 2.D0*y**(-1)*zp2**(-2)
     &     - 2.D0*y**(-1)*zp2**(-1)
     &     - 4.D0*y**(-1)
     &     + y**(-1)*z
     &     + 16.D0*upy**(-2)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upz**(-1)
     &     + 2.D0*zp2**(-2)*ypzp2**(-1)
     &     + 2.D0*zp2**(-1)*ypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr1(-1)*Nc * (
     &     - 8.D0*ypzp2**(-2)
     &     + 34.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     + 22.D0*z*ypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     + 16.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr1(-1)*Nc**3 * (
     &     + 10.D0
     &     + 2.D0*y**(-2)*upz**(-1)
     &     - y**(-2)*zp2**(-1)
     &     - 6.D0*y**(-1)*upz**(-1)
     &     + y**(-1)*zp2**(-2)
     &     + 3.D0*y**(-1)*zp2**(-1)
     &     + y**(-1)
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     - 16.D0*upz**(-1)
     &     - zp2**(-2)*ypzp2**(-1)
     &     - 3.D0*zp2**(-1)*ypzp2**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     - 25.D0*ypzp2**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr1(-1)*Nc**3 * (
     &     - 21.D0*z*ypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr1(-1)*HBr1(-1)*Nc**(-1) * (
     &     + 32.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr1(-1)*HBr1(-1)*Nc * (
     &     - 64.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 40.D0*upy**(-1)
     &     - 64.D0*upz**(-2)
     &     + 40.D0*upz**(-1)
     &     + 8.D0*z*upy**(-1)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr1(-1)*HBr1(-1)*Nc**3 * (
     &     + 32.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr2(-1,-1)*Nc**(-1) * (
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     - 20.D0*upz**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr2(-1,-1)*Nc * (
     &     + 16.D0
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     + 24.D0*upz**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr2(-1,-1)*Nc**3 * (
     &     - 16.D0
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 4.D0*upz**(-1)
     &     + 32.D0*ypzp2**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 12.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr2(0,-1)*Nc**(-3) * (
     &     - 4.D0
     &     - 4.D0*upy**(-3)
     &     - 8.D0*upy**(-2)
     &     + 12.D0*upy**(-1)*upz**(-1)
     &     + 2.D0*upy**(-1)
     &     - 8.D0*upz**(-1)
     &     - 4.D0*z*upy**(-3)
     &     - 2.D0*z*upy**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr2(0,-1)*Nc**(-1) * (
     &     + 4.D0*upy**(-3)
     &     + 4.D0*upy**(-2)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 8.D0*upy**(-1)
     &     + 16.D0*upz**(-1)*ypzp2**(-1)
     &     + 6.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-3)
     &     + 4.D0*z*upy**(-1)
     &     - 2.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr2(0,-1)*Nc * (
     &     + 4.D0*upy**(-2)
     &     + 4.D0*upy**(-1)*upz**(-1)
     &     - 10.D0*upy**(-1)
     &     - 16.D0*upz**(-1)*ypzp2**(-1)
     &     + 16.D0*upz**(-1)
     &     + 10.D0*ypzp2**(-1)
     &     - 2.D0*z*upy**(-1)
     &     + 10.D0*z*ypzp2**(-1)
     &     + 12.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HAr2(0,-1)*Nc**3 * (
     &     + 4.D0
     &     - 8.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     - 8.D0*z*ypzp2**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr1(-1)*Nc**(-3) * (
     &     - 2.D0
     &     + 2.D0*z**(-2)*upy**(-1)
     &     + z**(-2)
     &     + 2.D0*z**(-1)*upy**(-1)
     &     + 2.D0*z**(-1)
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     - 4.D0*upy**(-1)
     &     + 12.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     + y*z**(-1)
     &     - 4.D0*y*upz**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr1(-1)*Nc**(-1) * (
     &     - 11.D0
     &     - 2.D0*z**(-2)*upy**(-1)
     &     - z**(-2)*ypzp2**(-1)
     &     - 2.D0*z**(-2)
     &     + 6.D0*z**(-1)*upy**(-1)
     &     - z**(-1)*ypzp2**(-1)
     &     + z**(-1)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     - 28.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - 7.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + z*ypzp2**(-1)
     &     - 2.D0*y*z**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr1(-1)*Nc**(-1) * (
     &     + 4.D0*y*upz**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr1(-1)*Nc * (
     &     + 16.D0
     &     - 2.D0*z**(-2)*upy**(-1)
     &     + 2.D0*z**(-2)*ypzp2**(-1)
     &     + z**(-2)
     &     - 2.D0*z**(-1)*upy**(-1)
     &     - 2.D0*z**(-1)*ypzp2**(-1)
     &     - 4.D0*z**(-1)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     + 16.D0*upz**(-2)
     &     - 8.D0*ypzp2**(-2)
     &     + 6.D0*ypzp2**(-1)
     &     + 16.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr1(-1)*Nc * (
     &     - 6.D0*z*ypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     + y*z**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr1(-1)*Nc**3 * (
     &     - 3.D0
     &     + 2.D0*z**(-2)*upy**(-1)
     &     - z**(-2)*ypzp2**(-1)
     &     - 6.D0*z**(-1)*upy**(-1)
     &     + 3.D0*z**(-1)*ypzp2**(-1)
     &     + z**(-1)
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     - 16.D0*upy**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     + 5.D0*z*ypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr2(-1,-1)*Nc**(-1) * (
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     - 20.D0*upz**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr2(-1,-1)*Nc * (
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 24.D0*upy**(-1)
     &     + 20.D0*upz**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr2(-1,-1)*Nc**3 * (
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 4.D0*upy**(-1)
     &     + 12.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr2(0,-1)*Nc**(-3) * (
     &     - 4.D0
     &     + 12.D0*upy**(-1)*upz**(-1)
     &     - 8.D0*upy**(-1)
     &     - 4.D0*upz**(-3)
     &     - 8.D0*upz**(-2)
     &     + 2.D0*upz**(-1)
     &     - 4.D0*z*upy**(-1)
     &     - 4.D0*y*upz**(-3)
     &     - 2.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr2(0,-1)*Nc**(-1) * (
     &     - 2.D0
     &     + 4.D0*upz**(-3)
     &     + 4.D0*upz**(-2)
     &     - 16.D0*upz**(-1)*ypzp2**(-1)
     &     + 8.D0*upz**(-1)
     &     + 10.D0*ypzp2**(-1)
     &     + 2.D0*z*ypzp2**(-1)
     &     + 4.D0*y*upz**(-3)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr2(0,-1)*Nc * (
     &     + 10.D0
     &     - 12.D0*upy**(-1)*upz**(-1)
     &     + 16.D0*upy**(-1)
     &     + 4.D0*upz**(-2)
     &     + 16.D0*upz**(-1)*ypzp2**(-1)
     &     - 10.D0*upz**(-1)
     &     - 10.D0*ypzp2**(-1)
     &     + 12.D0*z*upy**(-1)
     &     - 10.D0*z*ypzp2**(-1)
     &     - 2.D0*y*upz**(-1)
     &     )
      PoleEP0T34 = PoleEP0T34 + HBr2(0,-1)*Nc**3 * (
     &     - 4.D0
     &     - 8.D0*upy**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 8.D0*z*ypzp2**(-1)
     &     )
      return
      end

*
**************************** 72 characters *****************************
*
*

*
**************************** 72 characters *****************************
*
*
      double precision function PoleEPm2T14(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl,ypzp2,ypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEPm2T14 = + Nc * (
     &     - 16.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEPm2T14 = PoleEPm2T14 + Nc**3 * (
     &     + 8.D0
     &     + 16.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     - 4.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEPm2T14 = PoleEPm2T14 + Nc**5 * (
     &     - 8.D0
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     + 4.D0*y*upz**(-1)
     &     ) 
      return
      end
*
*
*
      double precision function PoleEPm1T14(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,
     $                 Nc,Nh,Nl,ypzp2,ypzm2,sqrypzp2,sqrypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
	sqrypzp2 = Dsqrt(y+z+2.d0)
	sqrypzm2 = Dsqrt(y+z-2.d0)
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEPm1T14 =  + Nc**(-1) * (
     &     + 8.D0*upy**(-2)
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     - 10.D0*upy**(-1)
     &     + 8.D0*upz**(-2)
     &     - 10.D0*upz**(-1)
     &     - 2.D0*z*upy**(-1)
     &     - 2.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Nl * (
     &     + 16.D0/3.D0*upy**(-2)
     &     + 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 20.D0/3.D0*upy**(-1)
     &     + 16.D0/3.D0*upz**(-2)
     &     - 20.D0/3.D0*upz**(-1)
     &     - 4.D0/3.D0*z*upy**(-1)
     &     - 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Nc * (
     &     - 12.D0
     &     - 136.D0/3.D0*upy**(-2)
     &     - 272.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 146.D0/3.D0*upy**(-1)
     &     - 160.D0/3.D0*upz**(-2)
     &     + 176.D0/3.D0*upz**(-1)
     &     - 4.D0*ypzp2**(-2)
     &     + 10.D0/3.D0*z*upy**(-1)
     &     - 8.D0*z*ypzp2**(-2)
     &     + 8.D0*z*ypzp2**(-1)
     &     - 4.D0*z**2*ypzp2**(-2)
     &     + 16.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Nc**2*Nl * (
     &     - 8.D0/3.D0
     &     - 16.D0/3.D0*upy**(-2)
     &     - 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 20.D0/3.D0*upy**(-1)
     &     - 32.D0/3.D0*upz**(-2)
     &     + 40.D0/3.D0*upz**(-1)
     &     - 8.D0/3.D0*ypzp2**(-2)
     &     + 4.D0/3.D0*z*upy**(-1)
     &     - 16.D0/3.D0*z*ypzp2**(-2)
     &     + 16.D0/3.D0*z*ypzp2**(-1)
     &     - 8.D0/3.D0*z**2*ypzp2**(-2)
     &     + 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Nc**3 * (
     &     + 68.D0/3.D0
     &     + 112.D0/3.D0*upy**(-2)
     &     + 224.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 116.D0/3.D0*upy**(-1)
     &     + 248.D0/3.D0*upz**(-2)
     &     - 262.D0/3.D0*upz**(-1)
     &     + 44.D0/3.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     - 4.D0/3.D0*z*upy**(-1)
     &     + 88.D0/3.D0*z*ypzp2**(-2)
     &     - 88.D0/3.D0*z*ypzp2**(-1)
     &     + 44.D0/3.D0*z**2*ypzp2**(-2)
     &     - 14.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Nc**4*Nl * (
     &     + 8.D0/3.D0
     &     + 16.D0/3.D0*upz**(-2)
     &     - 20.D0/3.D0*upz**(-1)
     &     + 8.D0/3.D0*ypzp2**(-2)
     &     + 16.D0/3.D0*z*ypzp2**(-2)
     &     - 16.D0/3.D0*z*ypzp2**(-1)
     &     + 8.D0/3.D0*z**2*ypzp2**(-2)
     &     - 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Nc**5 * (
     &     - 32.D0/3.D0
     &     - 112.D0/3.D0*upz**(-2)
     &     + 116.D0/3.D0*upz**(-1)
     &     - 32.D0/3.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     - 64.D0/3.D0*z*ypzp2**(-2)
     &     + 64.D0/3.D0*z*ypzp2**(-1)
     &     - 32.D0/3.D0*z**2*ypzp2**(-2)
     &     + 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Hr1(-1)*Nc * (
     &     - 8.D0
     &     + 32.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 40.D0*upy**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Hr1(-1)*Nc**3 * (
     &     - 32.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 40.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Hr1(-1)*Nc**5 * (
     &     + 8.D0
     &     + 16.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Hr1(0)*Nc**(-1) * (
     &     - 8.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 34.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 34.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Hr1(0)*Nc * (
     &     + 4.D0
     &     + 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     - 52.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*upy**(-1)
     &     + 8.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 34.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*ypzp2**(-1)
     &     + 22.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Hr1(0)*Nc * (
     &     + 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*ypzp2**(-1)
     &     + 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Hr1(0)*Nc**3 * (
     &     - 8.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upy**(-2)
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     + 18.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upy**(-1)
     &     + 8.D0*upz**(-2)
     &     - 10.D0*upz**(-1)
     &     - 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*ypzp2**(-2)
     &     - 12.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*ypzp2**(-1)
     &     - 2.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Hr1(0)*Nc**3 * (
     &     - 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*ypzp2**(-2)
     &     + 8.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*ypzp2**(-2)
     &     + 4.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + Hr1(0)*Nc**5 * (
     &     - 4.D0
     &     - 8.D0*upz**(-2)
     &     + 10.D0*upz**(-1)
     &     - 4.D0*ypzp2**(-2)
     &     - 8.D0*z*ypzp2**(-2)
     &     + 8.D0*z*ypzp2**(-1)
     &     - 4.D0*z**2*ypzp2**(-2)
     &     + 2.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + HAr1(-1)*Nc * (
     &     + 8.D0
     &     + 16.D0*upy**(-2)
     &     - 20.D0*upy**(-1)
     &     + 16.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + HAr1(-1)*Nc**3 * (
     &     - 8.D0
     &     - 16.D0*upy**(-2)
     &     + 20.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + HBr1(-1)*Nc * (
     &     - 16.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     + 16.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 32.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + HBr1(-1)*Nc**3 * (
     &     - 8.D0
     &     + 16.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     - 32.D0*upz**(-2)
     &     + 40.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEPm1T14 = PoleEPm1T14 + HBr1(-1)*Nc**5 * (
     &     + 8.D0
     &     + 16.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      return
      end
*
*
*
      double precision function PoleEP0T14(s,t,tm,w) 
      implicit none
      double precision Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,
     $                 HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,
     $                 HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,
     $                 en,w,tm,pi,the,s,t,u,x,xp,y,z,z2,z3,aln2,
     $                 upx,umx,upxp,umxp,upy,umy,upz,umz,zp2,zm3,
     $                 Nc,Nh,Nl,ypzp2,ypzm2,sqrypzp2,sqrypzm2
*
      complex*16 Hc1,Hc2,Hc3,Hc4
      dimension Hc1(-1:1),Hc2(-1:1,-1:1),Hc3(-1:1,-1:1,-1:1), 
     $          Hc4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hr1(-1:1),Hr2(-1:1,-1:1),Hr3(-1:1,-1:1,-1:1), 
     $          Hr4(-1:1,-1:1,-1:1,-1:1) 
      dimension Hi1(-1:1),Hi2(-1:1,-1:1),Hi3(-1:1,-1:1,-1:1), 
     $          Hi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HAc1,HAc2,HAc3,HAc4
      dimension HAc1(-1:1),HAc2(-1:1,-1:1),HAc3(-1:1,-1:1,-1:1), 
     $          HAc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAr1(-1:1),HAr2(-1:1,-1:1),HAr3(-1:1,-1:1,-1:1), 
     $          HAr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HAi1(-1:1),HAi2(-1:1,-1:1),HAi3(-1:1,-1:1,-1:1), 
     $          HAi4(-1:1,-1:1,-1:1,-1:1) 
*
      complex*16 HBc1,HBc2,HBc3,HBc4
      dimension HBc1(-1:1),HBc2(-1:1,-1:1),HBc3(-1:1,-1:1,-1:1), 
     $          HBc4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBr1(-1:1),HBr2(-1:1,-1:1),HBr3(-1:1,-1:1,-1:1), 
     $          HBr4(-1:1,-1:1,-1:1,-1:1) 
      dimension HBi1(-1:1),HBi2(-1:1,-1:1),HBi3(-1:1,-1:1,-1:1), 
     $          HBi4(-1:1,-1:1,-1:1,-1:1) 
*
*
      parameter ( pi   = 3.1415926535897932385d0 )
      parameter ( z2   = 1.6449340668482264365d0 )
      parameter ( z3   = 1.2020569031595942854d0 ) 
      parameter ( aln2 = 0.6931471805599453094d0 )
*
	u = 2.d0*tm**2 - s - t
*
        x  = 4.d0*tm**2/(Dsqrt(s-4.d0*tm**2)+Dsqrt(s))**2 
        y  = - t/tm**2
        z  = - u/tm**2
*
        upx = 1.d0+x
	umx = 1.d0-x
	upxp = 1.d0+xp
	umxp = 1.d0-xp
	upy = 1.d0+y
	umy = 1.d0-y
	upz = 1.d0+z
	umz = 1.d0-z
	zp2 = 2.d0+z
	zm3 = z-3.d0
	ypzp2 = y+z+2.d0
	ypzm2 = y+z-2.d0
	sqrypzp2 = Dsqrt(y+z+2.d0)
	sqrypzm2 = Dsqrt(y+z-2.d0)
*
        Nc = 3.d0
	Nl = 5.d0
	Nh = 1.d0
* 
       call hplog(x,4,Hc1,Hc2,Hc3,Hc4, 
     $                  Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,-1,1) 
*
       call hplog(y,4,HAc1,HAc2,HAc3,HAc4, 
     $                  HAr1,HAr2,HAr3,HAr4,HAi1,HAi2,HAi3,HAi4,-1,1) 
*
       call hplog(z,4,HBc1,HBc2,HBc3,HBc4, 
     $                  HBr1,HBr2,HBr3,HBr4,HBi1,HBi2,HBi3,HBi4,-1,1) 
*
*
      PoleEP0T14 =  + Nc**(-1) * (
     &     + 4.D0
     &     + 2.D0*y**(-1)*upz**(-1)
     &     + y**(-1)
     &     + 2.D0*z**(-1)*upy**(-1)
     &     + z**(-1)
     &     + 12.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 21.D0*upy**(-1)
     &     + 12.D0*upz**(-2)
     &     - 21.D0*upz**(-1)
     &     + 4.D0*z2*upy**(-3)
     &     + 24.D0*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z2*upy**(-2)
     &     + 96.D0*z2*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**(-1) * (
     &     - 93.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*z2*upy**(-1)
     &     + 4.D0*z2*upz**(-3)
     &     + 24.D0*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z2*upz**(-2)
     &     - 93.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*z2*upz**(-1)
     &     + 62.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z2
     &     - 4.D0*z*upy**(-2)
     &     + z*upy**(-1)
     &     + 4.D0*z*z2*upy**(-3)
     &     - 24.D0*z*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**(-1) * (
     &     - 3.D0*z*z2*upy**(-1)
     &     + z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 5.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-2)
     &     + y*upz**(-1)
     &     + 4.D0*y*z2*upz**(-3)
     &     - 24.D0*y*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*y*z2*upz**(-1)
     &     + y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 5.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nl * (
     &     + 8.D0/3.D0
     &     + 8.D0/3.D0*upy**(-1)
     &     + 8.D0/3.D0*upz**(-1)
     &     + 8.D0/3.D0*z*upy**(-1)
     &     + 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc * (
     &     - 53.D0/3.D0
     &     - 4.D0*y**(-1)*upz**(-1)
     &     - 2.D0*y**(-1)
     &     - 4.D0*z**(-1)*upy**(-1)
     &     - z**(-1)*ypzp2**(-1)
     &     - 3.D0*z**(-1)
     &     - 28.D0*upy**(-2)
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     + 82.D0/3.D0*upy**(-1)
     &     - 40.D0*upz**(-2)
     &     + 133.D0/3.D0*upz**(-1)
     &     - 4.D0*ypzp2**(-2)
     &     - 10.D0*ypzp2**(-1)
     &     - 4.D0*z2*upy**(-3)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc * (
     &     - 48.D0*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z2*upy**(-2)
     &     - 96.D0*z2*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 152.D0*z2*upy**(-1)*upz**(-1)
     &     - 64.D0*z2*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 132.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 44.D0*z2*upy**(-1)
     &     - 8.D0*z2*upz**(-3)
     &     - 24.D0*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 52.D0*z2*upz**(-2)
     &     - 140.D0*z2*upz**(-1)*ypzp2**(-1)
     &     + 107.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 37.D0*z2*upz**(-1)
     &     + 64.D0*z2*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc * (
     &     + 16.D0*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 23.D0*z2*ypzp2**(-1)
     &     - 76.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 17.D0*z2
     &     + 4.D0*z*upy**(-2)
     &     - 38.D0/3.D0*z*upy**(-1)
     &     - 8.D0*z*ypzp2**(-2)
     &     + 7.D0*z*ypzp2**(-1)
     &     - 4.D0*z*z2*upy**(-3)
     &     + 48.D0*z*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 52.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*z2*upy**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc * (
     &     + 16.D0*z*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*z*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 27.D0*z*z2*ypzp2**(-1)
     &     - 10.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*ypzp2**(-2)
     &     - 8.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z**2*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-2)
     &     - 41.D0/3.D0*y*upz**(-1)
     &     - 8.D0*y*z2*upz**(-3)
     &     + 24.D0*y*z2*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 28.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc * (
     &     - 11.D0*y*z2*upz**(-1)
     &     + 2.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 7.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**2*Nl * (
     &     - 8.D0/3.D0*upy**(-1)
     &     - 14.D0/3.D0*upz**(-1)
     &     + 8.D0/3.D0*ypzp2**(-2)
     &     - 20.D0/3.D0*ypzp2**(-1)
     &     - 8.D0/3.D0*z*upy**(-1)
     &     + 16.D0/3.D0*z*ypzp2**(-2)
     &     - 16.D0/3.D0*z*ypzp2**(-1)
     &     + 8.D0/3.D0*z**2*ypzp2**(-2)
     &     - 16.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**2*Nh * (
     &     + 16.D0*upz**(-1)*ypzp2**(-1)
     &     + 2.D0/3.D0*upz**(-1)
     &     - 32.D0*ypzp2**(-2)
     &     - 4.D0/3.D0*ypzp2**(-1)
     &     - 12.D0*z2*upz**(-1)*ypzp2**(-1)
     &     + 24.D0*z2*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**3 * (
     &     + 2.D0*y**(-1)*upz**(-1)
     &     + y**(-1)
     &     + 2.D0*z**(-1)*upy**(-1)
     &     + 2.D0*z**(-1)*ypzp2**(-1)
     &     + 3.D0*z**(-1)
     &     + 16.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 19.D0/3.D0*upy**(-1)
     &     + 44.D0*upz**(-2)
     &     + 8.D0*upz**(-1)*ypzm2**(-1)
     &     - 85.D0/3.D0*upz**(-1)
     &     - 7.D0*ypzm2**(-1)
     &     - 20.D0/3.D0*ypzp2**(-2)
     &     + 155.D0/3.D0*ypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**3 * (
     &     + 24.D0*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z2*upy**(-2)
     &     - 152.D0*z2*upy**(-1)*upz**(-1)
     &     + 64.D0*z2*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 39.D0*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 47.D0*z2*upy**(-1)
     &     + 4.D0*z2*upz**(-3)
     &     - 100.D0*z2*upz**(-2)
     &     + 96.D0*z2*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 48.D0*z2*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     + 140.D0*z2*upz**(-1)*ypzp2**(-1)
     &     - 9.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**3 * (
     &     + 85.D0*z2*upz**(-1)
     &     - 64.D0*z2*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 84.D0*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 56.D0*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*z2*ypzp2**(-2)
     &     + 38.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 23.D0*z2*ypzp2**(-1)
     &     + 7.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 31.D0*z2
     &     + 35.D0/3.D0*z*upy**(-1)
     &     + 4.D0*z*ypzm2**(-1)
     &     - 40.D0/3.D0*z*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**3 * (
     &     + 52.D0/3.D0*z*ypzp2**(-1)
     &     - 24.D0*z*z2*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 28.D0*z*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - z*z2*upy**(-1)
     &     + 48.D0*z*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*z*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*z*z2*ypzp2**(-2)
     &     - 56.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 63.D0*z*z2*ypzp2**(-1)
     &     + 11.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - z**2*ypzm2**(-1)
     &     - 20.D0/3.D0*z**2*ypzp2**(-2)
     &     + z**2*ypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**3 * (
     &     + 3.D0*z**2*z2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z**2*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z**2*z2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*z**2*z2*ypzp2**(-2)
     &     - 22.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-2)
     &     + 73.D0/3.D0*y*upz**(-1)
     &     + 4.D0*y*z2*upz**(-3)
     &     + 8.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 23.D0*y*z2*upz**(-1)
     &     - 4.D0*y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**4*Nl * (
     &     - 8.D0/3.D0
     &     + 2.D0*upz**(-1)
     &     - 8.D0/3.D0*ypzp2**(-2)
     &     + 20.D0/3.D0*ypzp2**(-1)
     &     - 16.D0/3.D0*z*ypzp2**(-2)
     &     + 16.D0/3.D0*z*ypzp2**(-1)
     &     - 8.D0/3.D0*z**2*ypzp2**(-2)
     &     + 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**4*Nh * (
     &     - 16.D0*upz**(-1)*ypzp2**(-1)
     &     - 2.D0/3.D0*upz**(-1)
     &     + 32.D0*ypzp2**(-2)
     &     + 4.D0/3.D0*ypzp2**(-1)
     &     + 12.D0*z2*upz**(-1)*ypzp2**(-1)
     &     - 24.D0*z2*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**5 * (
     &     + 41.D0/3.D0
     &     - z**(-1)*ypzp2**(-1)
     &     - z**(-1)
     &     - 16.D0*upz**(-2)
     &     - 8.D0*upz**(-1)*ypzm2**(-1)
     &     + 5.D0*upz**(-1)
     &     + 7.D0*ypzm2**(-1)
     &     + 32.D0/3.D0*ypzp2**(-2)
     &     - 125.D0/3.D0*ypzp2**(-1)
     &     + 40.D0*z2*upz**(-2)
     &     - 96.D0*z2*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     - 48.D0*z2*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*
     &    sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**5 * (
     &     - 5.D0*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 45.D0*z2*upz**(-1)
     &     + 84.D0*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*z2*ypzp2**(-2)
     &     + 2.D0*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 7.D0*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*z2
     &     - 4.D0*z*ypzm2**(-1)
     &     + 64.D0/3.D0*z*ypzp2**(-2)
     &     - 73.D0/3.D0*z*ypzp2**(-1)
     &     - 48.D0*z*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 14.D0*z*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*z*z2*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**5 * (
     &     + 8.D0*z*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 36.D0*z*z2*ypzp2**(-1)
     &     - 2.D0*z*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + z**2*ypzm2**(-1)
     &     + 32.D0/3.D0*z**2*ypzp2**(-2)
     &     - z**2*ypzp2**(-1)
     &     + 12.D0*z**2*z2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*z2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*z**2*z2*ypzp2**(-2)
     &     + 6.D0*z**2*z2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 35.D0/3.D0*y*upz**(-1)
     &     - 4.D0*y*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 9.D0*y*z2*upz**(-1)
     &     + y*z2*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Nc**5 * (
     &     - y**2*z2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Dlog(tm**(-2)*w**2)*Nl * (
     &     - 16.D0/3.D0*upy**(-2)
     &     - 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 20.D0/3.D0*upy**(-1)
     &     - 16.D0/3.D0*upz**(-2)
     &     + 20.D0/3.D0*upz**(-1)
     &     + 4.D0/3.D0*z*upy**(-1)
     &     + 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Dlog(tm**(-2)*w**2)*Nc * (
     &     + 88.D0/3.D0*upy**(-2)
     &     + 176.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 110.D0/3.D0*upy**(-1)
     &     + 88.D0/3.D0*upz**(-2)
     &     - 110.D0/3.D0*upz**(-1)
     &     - 22.D0/3.D0*z*upy**(-1)
     &     - 22.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Dlog(tm**(-2)*w**2)*Nc**2*Nl * (
     &     + 8.D0/3.D0
     &     + 16.D0/3.D0*upy**(-2)
     &     + 32.D0/3.D0*upy**(-1)*upz**(-1)
     &     - 20.D0/3.D0*upy**(-1)
     &     + 32.D0/3.D0*upz**(-2)
     &     - 40.D0/3.D0*upz**(-1)
     &     + 8.D0/3.D0*ypzp2**(-2)
     &     - 4.D0/3.D0*z*upy**(-1)
     &     + 16.D0/3.D0*z*ypzp2**(-2)
     &     - 16.D0/3.D0*z*ypzp2**(-1)
     &     + 8.D0/3.D0*z**2*ypzp2**(-2)
     &     - 8.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Dlog(tm**(-2)*w**2)*Nc**3 * (
     &     - 44.D0/3.D0
     &     - 88.D0/3.D0*upy**(-2)
     &     - 176.D0/3.D0*upy**(-1)*upz**(-1)
     &     + 110.D0/3.D0*upy**(-1)
     &     - 176.D0/3.D0*upz**(-2)
     &     + 220.D0/3.D0*upz**(-1)
     &     - 44.D0/3.D0*ypzp2**(-2)
     &     + 22.D0/3.D0*z*upy**(-1)
     &     - 88.D0/3.D0*z*ypzp2**(-2)
     &     + 88.D0/3.D0*z*ypzp2**(-1)
     &     - 44.D0/3.D0*z**2*ypzp2**(-2)
     &     + 44.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Dlog(tm**(-2)*w**2)*Nc**4*Nl * (
     &     - 8.D0/3.D0
     &     - 16.D0/3.D0*upz**(-2)
     &     + 20.D0/3.D0*upz**(-1)
     &     - 8.D0/3.D0*ypzp2**(-2)
     &     - 16.D0/3.D0*z*ypzp2**(-2)
     &     + 16.D0/3.D0*z*ypzp2**(-1)
     &     - 8.D0/3.D0*z**2*ypzp2**(-2)
     &     + 4.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Dlog(tm**(-2)*w**2)*Nc**5 * (
     &     + 44.D0/3.D0
     &     + 88.D0/3.D0*upz**(-2)
     &     - 110.D0/3.D0*upz**(-1)
     &     + 44.D0/3.D0*ypzp2**(-2)
     &     + 88.D0/3.D0*z*ypzp2**(-2)
     &     - 88.D0/3.D0*z*ypzp2**(-1)
     &     + 44.D0/3.D0*z**2*ypzp2**(-2)
     &     - 22.D0/3.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(-1)*Nc * (
     &     + 16.D0
     &     + 64.D0*upy**(-1)*zm3**(-1)
     &     + 32.D0*upy**(-1)
     &     - 64.D0*zm3**(-1)*ypzm2**(-1)
     &     - 16.D0*ypzm2**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     + 16.D0*z*upy**(-1)
     &     - 16.D0*z*ypzm2**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(-1)*Nc**3 * (
     &     - 10.D0
     &     - 64.D0*upy**(-1)*zm3**(-1)
     &     - 32.D0*upy**(-1)
     &     - 96.D0*upz**(-1)*ypzm2**(-2)
     &     - 32.D0*upz**(-1)*ypzm2**(-1)
     &     - 6.D0*upz**(-1)
     &     + 64.D0*zm3**(-1)*ypzm2**(-1)
     &     + 84.D0*ypzm2**(-2)
     &     + 42.D0*ypzm2**(-1)
     &     + 8.D0*ypzp2**(-1)
     &     - 16.D0*z*upy**(-1)
     &     - 48.D0*z*ypzm2**(-2)
     &     + 10.D0*z*ypzm2**(-1)
     &     + 20.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(-1)*Nc**3 * (
     &     + 12.D0*z**2*ypzm2**(-2)
     &     - 4.D0*z**2*ypzm2**(-1)
     &     + 4.D0*z**2*ypzp2**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(-1)*Nc**5 * (
     &     - 6.D0
     &     + 96.D0*upz**(-1)*ypzm2**(-2)
     &     + 32.D0*upz**(-1)*ypzm2**(-1)
     &     + 6.D0*upz**(-1)
     &     - 84.D0*ypzm2**(-2)
     &     - 26.D0*ypzm2**(-1)
     &     + 8.D0*ypzp2**(-1)
     &     + 48.D0*z*ypzm2**(-2)
     &     + 6.D0*z*ypzm2**(-1)
     &     - 4.D0*z*ypzp2**(-1)
     &     - 12.D0*z**2*ypzm2**(-2)
     &     + 4.D0*z**2*ypzm2**(-1)
     &     - 4.D0*z**2*ypzp2**(-1)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(-1)*HAr1(-1)*Nc * (
     &     - 16.D0
     &     - 64.D0*upy**(-2)
     &     + 40.D0*upy**(-1)
     &     - 32.D0*ypzp2**(-2)
     &     + 8.D0*z*upy**(-1)
     &     - 64.D0*z*ypzp2**(-2)
     &     + 32.D0*z*ypzp2**(-1)
     &     - 32.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(-1)*HAr1(-1)*Nc**3 * (
     &     + 16.D0
     &     + 64.D0*upy**(-2)
     &     - 40.D0*upy**(-1)
     &     + 32.D0*ypzp2**(-2)
     &     - 8.D0*z*upy**(-1)
     &     + 64.D0*z*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-1)
     &     + 32.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(-1)*HBr1(-1)*Nc * (
     &     + 8.D0
     &     - 64.D0*upy**(-1)*upz**(-1)
     &     - 16.D0*upy**(-1)
     &     + 32.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)
     &     - 16.D0*z*upy**(-1)
     &     + 64.D0*z*ypzp2**(-2)
     &     + 32.D0*z**2*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(-1)*HBr1(-1)*Nc**3 * (
     &     + 64.D0*upy**(-1)*upz**(-1)
     &     + 16.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 32.D0*ypzp2**(-1)
     &     + 16.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(-1)*HBr1(-1)*Nc**5 * (
     &     - 8.D0
     &     - 32.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*Nc**(-1) * (
     &     - 8.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*Nc * (
     &     - 8.D0
     &     - 32.D0*upy**(-1)*zm3**(-1)
     &     + 16.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upy**(-1)
     &     + upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*zm3**(-1)*ypzm2**(-1)
     &     + 8.D0*ypzm2**(-1)
     &     + 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*ypzp2**(-1)
     &     - 4.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 8.D0*z*ypzm2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*Nc * (
     &     + 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 28.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*ypzp2**(-1)
     &     - 14.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 5.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 13.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*Nc**2*Nh * (
     &     - 32.D0*upz**(-1)*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*Nc**3 * (
     &     + 5.D0
     &     + 32.D0*upy**(-1)*zm3**(-1)
     &     - 8.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upy**(-1)
     &     + 48.D0*upz**(-1)*ypzm2**(-2)
     &     + 16.D0*upz**(-1)*ypzm2**(-1)
     &     + 7.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*upz**(-1)
     &     - 32.D0*zm3**(-1)*ypzm2**(-1)
     &     - 42.D0*ypzm2**(-2)
     &     - 21.D0*ypzm2**(-1)
     &     - 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*ypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*Nc**3 * (
     &     - 4.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     + 24.D0*z*ypzm2**(-2)
     &     - 5.D0*z*ypzm2**(-1)
     &     - 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 28.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*z*ypzp2**(-1)
     &     + 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*z**2*ypzm2**(-2)
     &     + 2.D0*z**2*ypzm2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*Nc**3 * (
     &     - 2.D0*z**2*ypzp2**(-1)
     &     - y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     + y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*Nc**4*Nh * (
     &     + 32.D0*upz**(-1)*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*Nc**5 * (
     &     + 3.D0
     &     - 48.D0*upz**(-1)*ypzm2**(-2)
     &     - 16.D0*upz**(-1)*ypzm2**(-1)
     &     - 3.D0*upz**(-1)
     &     + 42.D0*ypzm2**(-2)
     &     + 13.D0*ypzm2**(-1)
     &     - 4.D0*ypzp2**(-1)
     &     - 24.D0*z*ypzm2**(-2)
     &     - 3.D0*z*ypzm2**(-1)
     &     + 2.D0*z*ypzp2**(-1)
     &     + 6.D0*z**2*ypzm2**(-2)
     &     - 2.D0*z**2*ypzm2**(-1)
     &     + 2.D0*z**2*ypzp2**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*HAr1(-1)*Nc**(-1) * (
     &     + 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 42.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 44.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*HAr1(-1)*Nc * (
     &     + 8.D0
     &     - 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-2)
     &     + 52.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 20.D0*upy**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     - 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*HAr1(-1)*Nc * (
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*HAr1(-1)*Nc**3 * (
     &     - 8.D0
     &     + 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 20.D0*upy**(-1)
     &     + 44.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*HAr1(-1)*Nc**3 * (
     &     + 16.D0*z*ypzp2**(-1)
     &     + 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*HBr1(-1)*Nc**(-1) * (
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 44.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 42.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 18.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*HBr1(-1)*Nc * (
     &     - 4.D0
     &     - 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 88.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upy**(-1)
     &     - 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 58.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     - 28.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     - 32.D0*z*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*HBr1(-1)*Nc * (
     &     - 12.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*HBr1(-1)*Nc**3 * (
     &     + 32.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     - 44.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*upy**(-1)
     &     - 16.D0*upz**(-2)
     &     - 16.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     + 10.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*HBr1(-1)*Nc**3 * (
     &     + 8.D0*z*ypzp2**(-1)
     &     + 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     + 2.D0*y*upz**(-1)
     &     + 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr1(0)*HBr1(-1)*Nc**5 * (
     &     + 4.D0
     &     + 16.D0*upz**(-2)
     &     - 10.D0*upz**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-2)
     &     - 8.D0*z*ypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)
     &     - 2.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(-1,-1)*Nc * (
     &     + 24.D0
     &     + 56.D0*upy**(-1)
     &     - 64.D0*ypzp2**(-1)
     &     + 24.D0*z*upy**(-1)
     &     - 64.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(-1,-1)*Nc**3 * (
     &     - 16.D0
     &     - 56.D0*upy**(-1)
     &     - 20.D0*upz**(-1)
     &     + 64.D0*ypzp2**(-1)
     &     - 24.D0*z*upy**(-1)
     &     + 48.D0*z*ypzp2**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(-1,-1)*Nc**5 * (
     &     - 8.D0
     &     + 20.D0*upz**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(-1,0)*Nc**(-1) * (
     &     - 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 86.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 86.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 36.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 14.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 14.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 6.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(-1,0)*Nc * (
     &     - 12.D0
     &     + 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 140.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 28.D0*upy**(-1)
     &     + 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 58.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*ypzp2**(-1)
     &     + 44.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(-1,0)*Nc * (
     &     + 20.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(-1,0)*Nc**3 * (
     &     + 8.D0
     &     - 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 54.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 28.D0*upy**(-1)
     &     - 28.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     - 8.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z*upy**(-1)
     &     - 24.D0*z*ypzp2**(-1)
     &     - 6.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(-1,0)*Nc**3 * (
     &     - 6.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y*upz**(-1)
     &     - 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(-1,0)*Nc**5 * (
     &     + 4.D0
     &     - 10.D0*upz**(-1)
     &     - 8.D0*z*ypzp2**(-1)
     &     - 2.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,-1)*Nc * (
     &     - 12.D0
     &     + 128.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 28.D0*upy**(-1)
     &     - 128.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*ypzp2**(-1)
     &     + 20.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z*upy**(-1)
     &     - 32.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,-1)*Nc * (
     &     + 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,-1)*Nc**3 * (
     &     + 8.D0
     &     - 128.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 28.D0*upy**(-1)
     &     - 192.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 96.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upz**(-1)
     &     + 128.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 168.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 112.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 36.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*ypzp2**(-1)
     &     - 6.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,-1)*Nc**3 * (
     &     - 8.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z*upy**(-1)
     &     - 96.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*z*ypzp2**(-1)
     &     - 12.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y*upz**(-1)
     &     + 6.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,-1)*Nc**3 * (
     &     - 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,-1)*Nc**5 * (
     &     + 4.D0
     &     + 192.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 10.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 10.D0*upz**(-1)
     &     - 168.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 80.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 14.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 96.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 28.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z*ypzp2**(-1)
     &     + 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,-1)*Nc**5 * (
     &     - 24.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*y*upz**(-1)
     &     - 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,0)*Nc**(-1) * (
     &     + 4.D0
     &     - 8.D0*upy**(-1)*upz**(-1)
     &     - 9.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*upy**(-1)
     &     - 9.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*upz**(-1)
     &     - 2.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*z*upy**(-1)
     &     + 5.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 3.D0*y*upz**(-1)
     &     + 5.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,0)*Nc * (
     &     - 1.D0
     &     + 16.D0*upy**(-1)*upz**(-1)
     &     - 64.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*upy**(-1)
     &     - 12.D0*upz**(-1)*ypzp2**(-1)
     &     - 5.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + upz**(-1)
     &     + 64.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 36.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 17.D0*ypzp2**(-1)
     &     - 10.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,0)*Nc * (
     &     - 4.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 13.D0*z*ypzp2**(-1)
     &     - 10.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - y*upz**(-1)
     &     - 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,0)*Nc**2*Nh * (
     &     + 4.D0*upz**(-1)*ypzp2**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,0)*Nc**3 * (
     &     - 1.D0
     &     - 8.D0*upy**(-1)*upz**(-1)
     &     + 64.D0*upy**(-1)*zm3**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 11.D0*upy**(-1)
     &     + 96.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 48.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 12.D0*upz**(-1)*ypzp2**(-1)
     &     + 19.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 9.D0*upz**(-1)
     &     - 64.D0*zm3**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 84.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 56.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,0)*Nc**3 * (
     &     - 38.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 17.D0*ypzp2**(-1)
     &     + 5.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*z*upy**(-1)
     &     + 48.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 9.D0*z*ypzp2**(-1)
     &     + 7.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 12.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,0)*Nc**3 * (
     &     - 8.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 3.D0*y*upz**(-1)
     &     - 2.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,0)*Nc**4*Nh * (
     &     - 4.D0*upz**(-1)*ypzp2**(-1)
     &     + 8.D0*ypzp2**(-2)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,0)*Nc**5 * (
     &     - 2.D0
     &     - 96.D0*upz**(-1)*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*upz**(-1)*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 5.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 5.D0*upz**(-1)
     &     + 84.D0*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 40.D0*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 2.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 7.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 48.D0*z*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 14.D0*z*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*z*ypzp2**(-1)
     &     - 2.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(0,0)*Nc**5 * (
     &     + 12.D0*z**2*ypzm2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 2.D0*z**2*ypzm2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 6.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + y*upz**(-1)
     &     + y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(1,0)*Nc**(-1) * (
     &     - 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 68.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 68.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 40.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(1,0)*Nc * (
     &     + 32.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 64.D0*upy**(-1)*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 104.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 68.D0*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 24.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 44.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 32.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(1,0)*Nc * (
     &     + 16.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*y*upz**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*y*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 4.D0*y**2*upz**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + Hr2(1,0)*Nc**3 * (
     &     - 16.D0*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 36.D0*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 24.D0*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*upy**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 32.D0*z*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 16.D0*z*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 4.D0*z**2*upy**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     - 16.D0*z**2*ypzp2**(-2)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     + 8.D0*z**2*ypzp2**(-1)*sqrypzm2**(-1)*sqrypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr1(-1)*Nc**(-1) * (
     &     + 2.D0
     &     - 2.D0*y**(-2)*upz**(-1)
     &     - y**(-2)
     &     - 2.D0*y**(-1)*upz**(-1)
     &     - 2.D0*y**(-1)
     &     - y**(-1)*z
     &     - 12.D0*upy**(-2)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     + 4.D0*upz**(-1)
     &     + 4.D0*z*upy**(-2)
     &     + 4.D0*z*upy**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr1(-1)*Nc * (
     &     - 8.D0
     &     + 4.D0*y**(-2)*upz**(-1)
     &     + 2.D0*y**(-2)
     &     - 4.D0*y**(-1)*upz**(-1)
     &     + 2.D0*y**(-1)*z
     &     + 28.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 24.D0*upy**(-1)
     &     - 4.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-2)
     &     + 16.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-2)
     &     - 32.D0*z*ypzp2**(-2)
     &     + 16.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr1(-1)*Nc * (
     &     - 16.D0*z**2*ypzp2**(-2)
     &     + 8.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr1(-1)*Nc**3 * (
     &     + 6.D0
     &     - 2.D0*y**(-2)*upz**(-1)
     &     - y**(-2)
     &     + 6.D0*y**(-1)*upz**(-1)
     &     + 2.D0*y**(-1)
     &     - y**(-1)*z
     &     - 16.D0*upy**(-2)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 4.D0*upy**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     - 16.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 32.D0*z*ypzp2**(-2)
     &     - 16.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr1(-1)*Nc**3 * (
     &     + 16.D0*z**2*ypzp2**(-2)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr1(-1)*HBr1(-1)*Nc * (
     &     - 8.D0
     &     + 32.D0*upy**(-2)
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     - 32.D0*upz**(-2)
     &     + 64.D0*upz**(-1)*ypzp2**(-1)
     &     + 20.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr1(-1)*HBr1(-1)*Nc**3 * (
     &     + 8.D0
     &     - 32.D0*upy**(-2)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     + 32.D0*upz**(-2)
     &     - 64.D0*upz**(-1)*ypzp2**(-1)
     &     - 20.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr2(-1,-1)*Nc * (
     &     + 8.D0
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     + 20.D0*upy**(-1)
     &     - 64.D0*upz**(-1)*ypzp2**(-1)
     &     + 20.D0*upz**(-1)
     &     - 48.D0*ypzp2**(-1)
     &     + 4.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr2(-1,-1)*Nc**3 * (
     &     - 8.D0
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     + 64.D0*upz**(-1)*ypzp2**(-1)
     &     - 20.D0*upz**(-1)
     &     + 48.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr2(0,-1)*Nc**(-1) * (
     &     + 4.D0
     &     + 4.D0*upy**(-3)
     &     + 8.D0*upy**(-2)
     &     - 12.D0*upy**(-1)*upz**(-1)
     &     - 2.D0*upy**(-1)
     &     + 8.D0*upz**(-1)
     &     + 4.D0*z*upy**(-3)
     &     + 2.D0*z*upy**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr2(0,-1)*Nc * (
     &     - 8.D0
     &     - 4.D0*upy**(-3)
     &     - 8.D0*upy**(-2)
     &     + 12.D0*upy**(-1)*upz**(-1)
     &     - 8.D0*upy**(-1)
     &     - 8.D0*upz**(-1)
     &     + 4.D0*ypzp2**(-1)
     &     - 4.D0*z*upy**(-3)
     &     - 4.D0*z*upy**(-1)
     &     + 4.D0*z*ypzp2**(-1)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HAr2(0,-1)*Nc**3 * (
     &     + 4.D0
     &     + 10.D0*upy**(-1)
     &     - 4.D0*ypzp2**(-1)
     &     + 2.D0*z*upy**(-1)
     &     - 4.D0*z*ypzp2**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr1(-1)*Nc**(-1) * (
     &     + 2.D0
     &     - 2.D0*z**(-2)*upy**(-1)
     &     - z**(-2)
     &     - 2.D0*z**(-1)*upy**(-1)
     &     - 2.D0*z**(-1)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 4.D0*upy**(-1)
     &     - 12.D0*upz**(-2)
     &     + 20.D0*upz**(-1)
     &     - y*z**(-1)
     &     + 4.D0*y*upz**(-2)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr1(-1)*Nc * (
     &     + 9.D0
     &     + 4.D0*z**(-2)*upy**(-1)
     &     + z**(-2)*ypzp2**(-1)
     &     + 3.D0*z**(-2)
     &     - 4.D0*z**(-1)*upy**(-1)
     &     + z**(-1)*ypzp2**(-1)
     &     + z**(-1)
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 20.D0*upy**(-1)
     &     + 40.D0*upz**(-2)
     &     - 40.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-2)
     &     + 7.D0*ypzp2**(-1)
     &     - 8.D0*z*upy**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr1(-1)*Nc * (
     &     + 32.D0*z*ypzp2**(-2)
     &     - z*ypzp2**(-1)
     &     + 16.D0*z**2*ypzp2**(-2)
     &     + 3.D0*y*z**(-1)
     &     - 8.D0*y*upz**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr1(-1)*Nc**3 * (
     &     - 8.D0
     &     - 2.D0*z**(-2)*upy**(-1)
     &     - 2.D0*z**(-2)*ypzp2**(-1)
     &     - 3.D0*z**(-2)
     &     + 6.D0*z**(-1)*upy**(-1)
     &     + 2.D0*z**(-1)*ypzp2**(-1)
     &     + 4.D0*z**(-1)
     &     - 16.D0*upy**(-1)*upz**(-1)
     &     + 16.D0*upy**(-1)
     &     - 44.D0*upz**(-2)
     &     + 24.D0*upz**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     - 22.D0*ypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr1(-1)*Nc**3 * (
     &     - 16.D0*z*ypzp2**(-2)
     &     - 10.D0*z*ypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     - 3.D0*y*z**(-1)
     &     + 4.D0*y*upz**(-2)
     &     - 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr1(-1)*Nc**5 * (
     &     - 3.D0
     &     + z**(-2)*ypzp2**(-1)
     &     + z**(-2)
     &     - 3.D0*z**(-1)*ypzp2**(-1)
     &     - 3.D0*z**(-1)
     &     + 16.D0*upz**(-2)
     &     - 4.D0*upz**(-1)
     &     - 8.D0*ypzp2**(-2)
     &     + 15.D0*ypzp2**(-1)
     &     - 16.D0*z*ypzp2**(-2)
     &     + 11.D0*z*ypzp2**(-1)
     &     - 8.D0*z**2*ypzp2**(-2)
     &     + y*z**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr2(-1,-1)*Nc * (
     &     + 32.D0*upy**(-1)*upz**(-1)
     &     - 4.D0*upy**(-1)
     &     - 64.D0*upz**(-1)*ypzp2**(-1)
     &     + 20.D0*upz**(-1)
     &     + 16.D0*ypzp2**(-1)
     &     + 12.D0*z*upy**(-1)
     &     - 16.D0*z*ypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr2(-1,-1)*Nc**3 * (
     &     + 8.D0
     &     - 32.D0*upy**(-1)*upz**(-1)
     &     + 4.D0*upy**(-1)
     &     + 64.D0*upz**(-1)*ypzp2**(-1)
     &     - 40.D0*upz**(-1)
     &     - 16.D0*ypzp2**(-1)
     &     - 12.D0*z*upy**(-1)
     &     - 8.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr2(-1,-1)*Nc**5 * (
     &     - 8.D0
     &     + 20.D0*upz**(-1)
     &     + 16.D0*z*ypzp2**(-1)
     &     + 4.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr2(0,-1)*Nc**(-1) * (
     &     + 4.D0
     &     - 12.D0*upy**(-1)*upz**(-1)
     &     + 8.D0*upy**(-1)
     &     + 4.D0*upz**(-3)
     &     + 8.D0*upz**(-2)
     &     - 2.D0*upz**(-1)
     &     + 4.D0*z*upy**(-1)
     &     + 4.D0*y*upz**(-3)
     &     + 2.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr2(0,-1)*Nc * (
     &     - 2.D0
     &     + 12.D0*upy**(-1)*upz**(-1)
     &     - 16.D0*upy**(-1)
     &     - 8.D0*upz**(-3)
     &     - 12.D0*upz**(-2)
     &     + 16.D0*upz**(-1)*ypzp2**(-1)
     &     - 6.D0*upz**(-1)
     &     - 6.D0*ypzp2**(-1)
     &     - 12.D0*z*upy**(-1)
     &     + 2.D0*z*ypzp2**(-1)
     &     - 8.D0*y*upz**(-3)
     &     - 6.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr2(0,-1)*Nc**3 * (
     &     - 6.D0
     &     + 8.D0*upy**(-1)
     &     + 4.D0*upz**(-3)
     &     + 4.D0*upz**(-2)
     &     - 16.D0*upz**(-1)*ypzp2**(-1)
     &     + 18.D0*upz**(-1)
     &     + 6.D0*ypzp2**(-1)
     &     + 8.D0*z*upy**(-1)
     &     + 6.D0*z*ypzp2**(-1)
     &     + 4.D0*y*upz**(-3)
     &     + 6.D0*y*upz**(-1)
     &     )
      PoleEP0T14 = PoleEP0T14 + HBr2(0,-1)*Nc**5 * (
     &     + 4.D0
     &     - 10.D0*upz**(-1)
     &     - 8.D0*z*ypzp2**(-1)
     &     - 2.D0*y*upz**(-1)
     &     )
      return
      end
